(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[9],{

/***/ 5775:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var _util__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(784);
let

SyncIssueHelper = class SyncIssueHelper {
  sanitizedChangeSet(reason, changeset) {
    var dataSize = _util__WEBPACK_IMPORTED_MODULE_0__["default"].lengthInUtf8Bytes(changeset.data),
    res = _.get(changeset, 'res', {});

    if (reason === 'timeout') {
      res.error = { name: 'timeout' };
    } else
    if (!_.get(res, 'error')) {
      res.error = { name: reason };
    }

    return _.assign({}, changeset, {
      dataSize: _util__WEBPACK_IMPORTED_MODULE_0__["default"].formatSize(dataSize),
      res: res });

  }

  constructLogToAnalytics(changeset) {
    let log = {
      entity: changeset.entity,
      entity_id: _.get(changeset, 'res.model_id') || _.get(changeset, 'res.data.id'),
      timestamp: new Date().toISOString(),
      action: changeset.verb,
      error: changeset.res.error,
      requestSize: changeset.dataSize };


    // special handling for unnamed errors
    if (_.get(log, 'error.name') === 'error') {
      log.response = changeset.res;
    }

    return log;
  }};


/* harmony default export */ __webpack_exports__["default"] = (new SyncIssueHelper());
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5837:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return Console; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var react_notification_system__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5838);
/* harmony import */ var react_notification_system__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react_notification_system__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(749);
/* harmony import */ var _ConsoleFooter_ConsoleFooter__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5847);
/* harmony import */ var _ConsoleHeader_ConsoleHeader__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(5849);
/* harmony import */ var _ConsoleList_ConsoleList__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(5851);
/* harmony import */ var _js_components_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(2974);
/* harmony import */ var _ConsoleBlobViewer_ConsoleBlobViewer__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(6006);
/* harmony import */ var _js_constants_AppNotificationStyles__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(6007);
var _class;










let


Console = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class Console extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isBlobViewerOpen: false };


    this.themeChangeHandler = this.themeChangeHandler.bind(this);
    this.handleBlobViewerOpen = this.handleBlobViewerOpen.bind(this);
    this.handleBlobViewerClose = this.handleBlobViewerClose.bind(this);
    this.handleViewLargeBody = this.handleViewLargeBody.bind(this);

    // Setup store references
    this.store = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('ConsoleStore');
    this.eventStore = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('ConsoleEventStore');
  }

  componentDidMount() {
    pm.mediator.on('themeChange', this.themeChangeHandler);
    pm.toasts.setNotificationComponent(this.refs.notificationSystem);
  }

  componentWillUnmount() {
    pm.mediator.off('themeChange', this.themeChangeHandler);
  }

  themeChangeHandler() {
    // Force re-render the child components
    this.forceUpdate();
  }

  handleBlobViewerOpen() {
    this.setState({ isBlobViewerOpen: true });
  }

  handleBlobViewerClose() {
    this.setState({ isBlobViewerOpen: false }, () => {
      this.eventStore.updateBlob({}); // Reset the blob to empty object
    });
  }

  handleViewLargeBody(eventId, bodyType) {
    this.eventStore.loadBlob(eventId, bodyType);
    this.handleBlobViewerOpen();
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-container' },
        this.props.withDropdownRoot &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { id: 'dropdown-root', style: { width: 0, height: 0 } }),
        this.props.showHeader &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleHeader_ConsoleHeader__WEBPACK_IMPORTED_MODULE_5__["default"], {
          store: this.store,
          eventStore: this.eventStore }),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleList_ConsoleList__WEBPACK_IMPORTED_MODULE_6__["default"], {
          store: this.store,
          viewLargeBody: this.handleViewLargeBody }),

        this.props.showFooter &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleFooter_ConsoleFooter__WEBPACK_IMPORTED_MODULE_4__["default"], {
          store: this.store,
          eventStore: this.eventStore }),


        this.store.isLoading &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_7__["default"], { className: 'console-list__loading' }),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleBlobViewer_ConsoleBlobViewer__WEBPACK_IMPORTED_MODULE_8__["default"], {
          isOpen: this.state.isBlobViewerOpen,
          onClose: this.handleBlobViewerClose,
          isLoading: this.eventStore.isBlobLoading,
          data: this.eventStore.blob && this.eventStore.blob.data,
          bodyType: this.eventStore.blob && this.eventStore.blob.bodyType,
          type: this.eventStore.blob && this.eventStore.blob.type,
          isTruncated: this.eventStore.blob && this.eventStore.blob.isTruncated

          // This will be removed when we remove console window
          , showInModal: this.props.showBlobInModal }),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react_notification_system__WEBPACK_IMPORTED_MODULE_2___default.a, {
          allowHTML: true,
          ref: 'notificationSystem',
          style: _js_constants_AppNotificationStyles__WEBPACK_IMPORTED_MODULE_9__["default"] })));



  }}) || _class;

/***/ }),

/***/ 5838:
/***/ (function(module, exports, __webpack_require__) {

var React = __webpack_require__(2);
var createReactClass = __webpack_require__(5839);
var PropTypes = __webpack_require__(2815);
var merge = __webpack_require__(4);
var NotificationContainer = __webpack_require__(5842);
var Constants = __webpack_require__(5844);
var Styles = __webpack_require__(5846);

var NotificationSystem = createReactClass({

  uid: 3400,

  _isMounted: false,

  _getStyles: {
    overrideStyle: {},

    overrideWidth: null,

    setOverrideStyle: function(style) {
      this.overrideStyle = style;
    },

    wrapper: function() {
      if (!this.overrideStyle) return {};
      return merge({}, Styles.Wrapper, this.overrideStyle.Wrapper);
    },

    container: function(position) {
      var override = this.overrideStyle.Containers || {};
      if (!this.overrideStyle) return {};

      this.overrideWidth = Styles.Containers.DefaultStyle.width;

      if (override.DefaultStyle && override.DefaultStyle.width) {
        this.overrideWidth = override.DefaultStyle.width;
      }

      if (override[position] && override[position].width) {
        this.overrideWidth = override[position].width;
      }

      return merge({}, Styles.Containers.DefaultStyle, Styles.Containers[position], override.DefaultStyle, override[position]);
    },

    elements: {
      notification: 'NotificationItem',
      title: 'Title',
      messageWrapper: 'MessageWrapper',
      dismiss: 'Dismiss',
      action: 'Action',
      actionWrapper: 'ActionWrapper'
    },

    byElement: function(element) {
      var self = this;
      return function(level) {
        var _element = self.elements[element];
        var override = self.overrideStyle[_element] || {};
        if (!self.overrideStyle) return {};
        return merge({}, Styles[_element].DefaultStyle, Styles[_element][level], override.DefaultStyle, override[level]);
      };
    }
  },

  _didNotificationRemoved: function(uid) {
    var notification;
    var notifications = this.state.notifications.filter(function(toCheck) {
      if (toCheck.uid === uid) {
        notification = toCheck;
        return false;
      }
      return true;
    });

    if (this._isMounted) {
      this.setState({ notifications: notifications });
    }

    if (notification && notification.onRemove) {
      notification.onRemove(notification);
    }
  },

  getInitialState: function() {
    return {
      notifications: []
    };
  },

  propTypes: {
    style: PropTypes.oneOfType([
      PropTypes.bool,
      PropTypes.object
    ]),
    noAnimation: PropTypes.bool,
    allowHTML: PropTypes.bool
  },

  getDefaultProps: function() {
    return {
      style: {},
      noAnimation: false,
      allowHTML: false
    };
  },

  addNotification: function(notification) {
    var _notification = merge({}, Constants.notification, notification);
    var notifications = this.state.notifications;
    var i;

    if (!_notification.level) {
      throw new Error('notification level is required.');
    }

    if (Object.keys(Constants.levels).indexOf(_notification.level) === -1) {
      throw new Error('\'' + _notification.level + '\' is not a valid level.');
    }

    // eslint-disable-next-line
    if (isNaN(_notification.autoDismiss)) {
      throw new Error('\'autoDismiss\' must be a number.');
    }

    if (Object.keys(Constants.positions).indexOf(_notification.position) === -1) {
      throw new Error('\'' + _notification.position + '\' is not a valid position.');
    }

    // Some preparations
    _notification.position = _notification.position.toLowerCase();
    _notification.level = _notification.level.toLowerCase();
    _notification.autoDismiss = parseInt(_notification.autoDismiss, 10);

    _notification.uid = _notification.uid || this.uid;
    _notification.ref = 'notification-' + _notification.uid;
    this.uid += 1;

    // do not add if the notification already exists based on supplied uid
    for (i = 0; i < notifications.length; i += 1) {
      if (notifications[i].uid === _notification.uid) {
        return false;
      }
    }

    notifications.push(_notification);

    if (typeof _notification.onAdd === 'function') {
      notification.onAdd(_notification);
    }

    this.setState({
      notifications: notifications
    });

    return _notification;
  },

  getNotificationRef: function(notification) {
    var self = this;
    var foundNotification = null;

    Object.keys(this.refs).forEach(function(container) {
      if (container.indexOf('container') > -1) {
        Object.keys(self.refs[container].refs).forEach(function(_notification) {
          var uid = notification.uid ? notification.uid : notification;
          if (_notification === 'notification-' + uid) {
            // NOTE: Stop iterating further and return the found notification.
            // Since UIDs are uniques and there won't be another notification found.
            foundNotification = self.refs[container].refs[_notification];
          }
        });
      }
    });

    return foundNotification;
  },

  removeNotification: function(notification) {
    var foundNotification = this.getNotificationRef(notification);
    return foundNotification && foundNotification._hideNotification();
  },

  editNotification: function(notification, newNotification) {
    var foundNotification = null;
    // NOTE: Find state notification to update by using
    // `setState` and forcing React to re-render the component.
    var uid = notification.uid ? notification.uid : notification;

    var newNotifications = this.state.notifications.filter(function(stateNotification) {
      if (uid === stateNotification.uid) {
        foundNotification = stateNotification;
        return false;
      }

      return true;
    });


    if (!foundNotification) {
      return;
    }

    newNotifications.push(merge(
      {},
      foundNotification,
      newNotification
    ));

    this.setState({
      notifications: newNotifications
    });
  },

  clearNotifications: function() {
    var self = this;
    Object.keys(this.refs).forEach(function(container) {
      if (container.indexOf('container') > -1) {
        Object.keys(self.refs[container].refs).forEach(function(_notification) {
          self.refs[container].refs[_notification]._hideNotification();
        });
      }
    });
  },

  componentDidMount: function() {
    this._getStyles.setOverrideStyle(this.props.style);
    this._isMounted = true;
  },

  componentWillUnmount: function() {
    this._isMounted = false;
  },

  render: function() {
    var self = this;
    var containers = null;
    var notifications = this.state.notifications;

    if (notifications.length) {
      containers = Object.keys(Constants.positions).map(function(position) {
        var _notifications = notifications.filter(function(notification) {
          return position === notification.position;
        });

        if (!_notifications.length) {
          return null;
        }

        return (
          React.createElement(NotificationContainer, {
            ref:  'container-' + position, 
            key:  position, 
            position:  position, 
            notifications:  _notifications, 
            getStyles:  self._getStyles, 
            onRemove:  self._didNotificationRemoved, 
            noAnimation:  self.props.noAnimation, 
            allowHTML:  self.props.allowHTML}
          )
        );
      });
    }


    return (
      React.createElement("div", {className: "notifications-wrapper", style:  this._getStyles.wrapper() }, 
         containers 
      )
    );
  }
});

module.exports = NotificationSystem;


/***/ }),

/***/ 5839:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */



var React = __webpack_require__(2);
var factory = __webpack_require__(5840);

if (typeof React === 'undefined') {
  throw Error(
    'create-react-class could not find the React object. If you are using script tags, ' +
      'make sure that React is being loaded before create-react-class.'
  );
}

// Hack to grab NoopUpdateQueue from isomorphic React
var ReactNoopUpdateQueue = new React.Component().updater;

module.exports = factory(
  React.Component,
  React.isValidElement,
  ReactNoopUpdateQueue
);


/***/ }),

/***/ 5840:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */



var _assign = __webpack_require__(4);

var emptyObject = __webpack_require__(5841);
var _invariant = __webpack_require__(2818);

if (false) { var warning; }

var MIXINS_KEY = 'mixins';

// Helper function to allow the creation of anonymous functions which do not
// have .name set to the name of the variable being assigned to.
function identity(fn) {
  return fn;
}

var ReactPropTypeLocationNames;
if (false) {} else {
  ReactPropTypeLocationNames = {};
}

function factory(ReactComponent, isValidElement, ReactNoopUpdateQueue) {
  /**
   * Policies that describe methods in `ReactClassInterface`.
   */

  var injectedMixins = [];

  /**
   * Composite components are higher-level components that compose other composite
   * or host components.
   *
   * To create a new type of `ReactClass`, pass a specification of
   * your new class to `React.createClass`. The only requirement of your class
   * specification is that you implement a `render` method.
   *
   *   var MyComponent = React.createClass({
   *     render: function() {
   *       return <div>Hello World</div>;
   *     }
   *   });
   *
   * The class specification supports a specific protocol of methods that have
   * special meaning (e.g. `render`). See `ReactClassInterface` for
   * more the comprehensive protocol. Any other properties and methods in the
   * class specification will be available on the prototype.
   *
   * @interface ReactClassInterface
   * @internal
   */
  var ReactClassInterface = {
    /**
     * An array of Mixin objects to include when defining your component.
     *
     * @type {array}
     * @optional
     */
    mixins: 'DEFINE_MANY',

    /**
     * An object containing properties and methods that should be defined on
     * the component's constructor instead of its prototype (static methods).
     *
     * @type {object}
     * @optional
     */
    statics: 'DEFINE_MANY',

    /**
     * Definition of prop types for this component.
     *
     * @type {object}
     * @optional
     */
    propTypes: 'DEFINE_MANY',

    /**
     * Definition of context types for this component.
     *
     * @type {object}
     * @optional
     */
    contextTypes: 'DEFINE_MANY',

    /**
     * Definition of context types this component sets for its children.
     *
     * @type {object}
     * @optional
     */
    childContextTypes: 'DEFINE_MANY',

    // ==== Definition methods ====

    /**
     * Invoked when the component is mounted. Values in the mapping will be set on
     * `this.props` if that prop is not specified (i.e. using an `in` check).
     *
     * This method is invoked before `getInitialState` and therefore cannot rely
     * on `this.state` or use `this.setState`.
     *
     * @return {object}
     * @optional
     */
    getDefaultProps: 'DEFINE_MANY_MERGED',

    /**
     * Invoked once before the component is mounted. The return value will be used
     * as the initial value of `this.state`.
     *
     *   getInitialState: function() {
     *     return {
     *       isOn: false,
     *       fooBaz: new BazFoo()
     *     }
     *   }
     *
     * @return {object}
     * @optional
     */
    getInitialState: 'DEFINE_MANY_MERGED',

    /**
     * @return {object}
     * @optional
     */
    getChildContext: 'DEFINE_MANY_MERGED',

    /**
     * Uses props from `this.props` and state from `this.state` to render the
     * structure of the component.
     *
     * No guarantees are made about when or how often this method is invoked, so
     * it must not have side effects.
     *
     *   render: function() {
     *     var name = this.props.name;
     *     return <div>Hello, {name}!</div>;
     *   }
     *
     * @return {ReactComponent}
     * @required
     */
    render: 'DEFINE_ONCE',

    // ==== Delegate methods ====

    /**
     * Invoked when the component is initially created and about to be mounted.
     * This may have side effects, but any external subscriptions or data created
     * by this method must be cleaned up in `componentWillUnmount`.
     *
     * @optional
     */
    componentWillMount: 'DEFINE_MANY',

    /**
     * Invoked when the component has been mounted and has a DOM representation.
     * However, there is no guarantee that the DOM node is in the document.
     *
     * Use this as an opportunity to operate on the DOM when the component has
     * been mounted (initialized and rendered) for the first time.
     *
     * @param {DOMElement} rootNode DOM element representing the component.
     * @optional
     */
    componentDidMount: 'DEFINE_MANY',

    /**
     * Invoked before the component receives new props.
     *
     * Use this as an opportunity to react to a prop transition by updating the
     * state using `this.setState`. Current props are accessed via `this.props`.
     *
     *   componentWillReceiveProps: function(nextProps, nextContext) {
     *     this.setState({
     *       likesIncreasing: nextProps.likeCount > this.props.likeCount
     *     });
     *   }
     *
     * NOTE: There is no equivalent `componentWillReceiveState`. An incoming prop
     * transition may cause a state change, but the opposite is not true. If you
     * need it, you are probably looking for `componentWillUpdate`.
     *
     * @param {object} nextProps
     * @optional
     */
    componentWillReceiveProps: 'DEFINE_MANY',

    /**
     * Invoked while deciding if the component should be updated as a result of
     * receiving new props, state and/or context.
     *
     * Use this as an opportunity to `return false` when you're certain that the
     * transition to the new props/state/context will not require a component
     * update.
     *
     *   shouldComponentUpdate: function(nextProps, nextState, nextContext) {
     *     return !equal(nextProps, this.props) ||
     *       !equal(nextState, this.state) ||
     *       !equal(nextContext, this.context);
     *   }
     *
     * @param {object} nextProps
     * @param {?object} nextState
     * @param {?object} nextContext
     * @return {boolean} True if the component should update.
     * @optional
     */
    shouldComponentUpdate: 'DEFINE_ONCE',

    /**
     * Invoked when the component is about to update due to a transition from
     * `this.props`, `this.state` and `this.context` to `nextProps`, `nextState`
     * and `nextContext`.
     *
     * Use this as an opportunity to perform preparation before an update occurs.
     *
     * NOTE: You **cannot** use `this.setState()` in this method.
     *
     * @param {object} nextProps
     * @param {?object} nextState
     * @param {?object} nextContext
     * @param {ReactReconcileTransaction} transaction
     * @optional
     */
    componentWillUpdate: 'DEFINE_MANY',

    /**
     * Invoked when the component's DOM representation has been updated.
     *
     * Use this as an opportunity to operate on the DOM when the component has
     * been updated.
     *
     * @param {object} prevProps
     * @param {?object} prevState
     * @param {?object} prevContext
     * @param {DOMElement} rootNode DOM element representing the component.
     * @optional
     */
    componentDidUpdate: 'DEFINE_MANY',

    /**
     * Invoked when the component is about to be removed from its parent and have
     * its DOM representation destroyed.
     *
     * Use this as an opportunity to deallocate any external resources.
     *
     * NOTE: There is no `componentDidUnmount` since your component will have been
     * destroyed by that point.
     *
     * @optional
     */
    componentWillUnmount: 'DEFINE_MANY',

    /**
     * Replacement for (deprecated) `componentWillMount`.
     *
     * @optional
     */
    UNSAFE_componentWillMount: 'DEFINE_MANY',

    /**
     * Replacement for (deprecated) `componentWillReceiveProps`.
     *
     * @optional
     */
    UNSAFE_componentWillReceiveProps: 'DEFINE_MANY',

    /**
     * Replacement for (deprecated) `componentWillUpdate`.
     *
     * @optional
     */
    UNSAFE_componentWillUpdate: 'DEFINE_MANY',

    // ==== Advanced methods ====

    /**
     * Updates the component's currently mounted DOM representation.
     *
     * By default, this implements React's rendering and reconciliation algorithm.
     * Sophisticated clients may wish to override this.
     *
     * @param {ReactReconcileTransaction} transaction
     * @internal
     * @overridable
     */
    updateComponent: 'OVERRIDE_BASE'
  };

  /**
   * Similar to ReactClassInterface but for static methods.
   */
  var ReactClassStaticInterface = {
    /**
     * This method is invoked after a component is instantiated and when it
     * receives new props. Return an object to update state in response to
     * prop changes. Return null to indicate no change to state.
     *
     * If an object is returned, its keys will be merged into the existing state.
     *
     * @return {object || null}
     * @optional
     */
    getDerivedStateFromProps: 'DEFINE_MANY_MERGED'
  };

  /**
   * Mapping from class specification keys to special processing functions.
   *
   * Although these are declared like instance properties in the specification
   * when defining classes using `React.createClass`, they are actually static
   * and are accessible on the constructor instead of the prototype. Despite
   * being static, they must be defined outside of the "statics" key under
   * which all other static methods are defined.
   */
  var RESERVED_SPEC_KEYS = {
    displayName: function(Constructor, displayName) {
      Constructor.displayName = displayName;
    },
    mixins: function(Constructor, mixins) {
      if (mixins) {
        for (var i = 0; i < mixins.length; i++) {
          mixSpecIntoComponent(Constructor, mixins[i]);
        }
      }
    },
    childContextTypes: function(Constructor, childContextTypes) {
      if (false) {}
      Constructor.childContextTypes = _assign(
        {},
        Constructor.childContextTypes,
        childContextTypes
      );
    },
    contextTypes: function(Constructor, contextTypes) {
      if (false) {}
      Constructor.contextTypes = _assign(
        {},
        Constructor.contextTypes,
        contextTypes
      );
    },
    /**
     * Special case getDefaultProps which should move into statics but requires
     * automatic merging.
     */
    getDefaultProps: function(Constructor, getDefaultProps) {
      if (Constructor.getDefaultProps) {
        Constructor.getDefaultProps = createMergedResultFunction(
          Constructor.getDefaultProps,
          getDefaultProps
        );
      } else {
        Constructor.getDefaultProps = getDefaultProps;
      }
    },
    propTypes: function(Constructor, propTypes) {
      if (false) {}
      Constructor.propTypes = _assign({}, Constructor.propTypes, propTypes);
    },
    statics: function(Constructor, statics) {
      mixStaticSpecIntoComponent(Constructor, statics);
    },
    autobind: function() {}
  };

  function validateTypeDef(Constructor, typeDef, location) {
    for (var propName in typeDef) {
      if (typeDef.hasOwnProperty(propName)) {
        // use a warning instead of an _invariant so components
        // don't show up in prod but only in __DEV__
        if (false) {}
      }
    }
  }

  function validateMethodOverride(isAlreadyDefined, name) {
    var specPolicy = ReactClassInterface.hasOwnProperty(name)
      ? ReactClassInterface[name]
      : null;

    // Disallow overriding of base class methods unless explicitly allowed.
    if (ReactClassMixin.hasOwnProperty(name)) {
      _invariant(
        specPolicy === 'OVERRIDE_BASE',
        'ReactClassInterface: You are attempting to override ' +
          '`%s` from your class specification. Ensure that your method names ' +
          'do not overlap with React methods.',
        name
      );
    }

    // Disallow defining methods more than once unless explicitly allowed.
    if (isAlreadyDefined) {
      _invariant(
        specPolicy === 'DEFINE_MANY' || specPolicy === 'DEFINE_MANY_MERGED',
        'ReactClassInterface: You are attempting to define ' +
          '`%s` on your component more than once. This conflict may be due ' +
          'to a mixin.',
        name
      );
    }
  }

  /**
   * Mixin helper which handles policy validation and reserved
   * specification keys when building React classes.
   */
  function mixSpecIntoComponent(Constructor, spec) {
    if (!spec) {
      if (false) { var isMixinValid, typeofSpec; }

      return;
    }

    _invariant(
      typeof spec !== 'function',
      "ReactClass: You're attempting to " +
        'use a component class or function as a mixin. Instead, just use a ' +
        'regular object.'
    );
    _invariant(
      !isValidElement(spec),
      "ReactClass: You're attempting to " +
        'use a component as a mixin. Instead, just use a regular object.'
    );

    var proto = Constructor.prototype;
    var autoBindPairs = proto.__reactAutoBindPairs;

    // By handling mixins before any other properties, we ensure the same
    // chaining order is applied to methods with DEFINE_MANY policy, whether
    // mixins are listed before or after these methods in the spec.
    if (spec.hasOwnProperty(MIXINS_KEY)) {
      RESERVED_SPEC_KEYS.mixins(Constructor, spec.mixins);
    }

    for (var name in spec) {
      if (!spec.hasOwnProperty(name)) {
        continue;
      }

      if (name === MIXINS_KEY) {
        // We have already handled mixins in a special case above.
        continue;
      }

      var property = spec[name];
      var isAlreadyDefined = proto.hasOwnProperty(name);
      validateMethodOverride(isAlreadyDefined, name);

      if (RESERVED_SPEC_KEYS.hasOwnProperty(name)) {
        RESERVED_SPEC_KEYS[name](Constructor, property);
      } else {
        // Setup methods on prototype:
        // The following member methods should not be automatically bound:
        // 1. Expected ReactClass methods (in the "interface").
        // 2. Overridden methods (that were mixed in).
        var isReactClassMethod = ReactClassInterface.hasOwnProperty(name);
        var isFunction = typeof property === 'function';
        var shouldAutoBind =
          isFunction &&
          !isReactClassMethod &&
          !isAlreadyDefined &&
          spec.autobind !== false;

        if (shouldAutoBind) {
          autoBindPairs.push(name, property);
          proto[name] = property;
        } else {
          if (isAlreadyDefined) {
            var specPolicy = ReactClassInterface[name];

            // These cases should already be caught by validateMethodOverride.
            _invariant(
              isReactClassMethod &&
                (specPolicy === 'DEFINE_MANY_MERGED' ||
                  specPolicy === 'DEFINE_MANY'),
              'ReactClass: Unexpected spec policy %s for key %s ' +
                'when mixing in component specs.',
              specPolicy,
              name
            );

            // For methods which are defined more than once, call the existing
            // methods before calling the new property, merging if appropriate.
            if (specPolicy === 'DEFINE_MANY_MERGED') {
              proto[name] = createMergedResultFunction(proto[name], property);
            } else if (specPolicy === 'DEFINE_MANY') {
              proto[name] = createChainedFunction(proto[name], property);
            }
          } else {
            proto[name] = property;
            if (false) {}
          }
        }
      }
    }
  }

  function mixStaticSpecIntoComponent(Constructor, statics) {
    if (!statics) {
      return;
    }

    for (var name in statics) {
      var property = statics[name];
      if (!statics.hasOwnProperty(name)) {
        continue;
      }

      var isReserved = name in RESERVED_SPEC_KEYS;
      _invariant(
        !isReserved,
        'ReactClass: You are attempting to define a reserved ' +
          'property, `%s`, that shouldn\'t be on the "statics" key. Define it ' +
          'as an instance property instead; it will still be accessible on the ' +
          'constructor.',
        name
      );

      var isAlreadyDefined = name in Constructor;
      if (isAlreadyDefined) {
        var specPolicy = ReactClassStaticInterface.hasOwnProperty(name)
          ? ReactClassStaticInterface[name]
          : null;

        _invariant(
          specPolicy === 'DEFINE_MANY_MERGED',
          'ReactClass: You are attempting to define ' +
            '`%s` on your component more than once. This conflict may be ' +
            'due to a mixin.',
          name
        );

        Constructor[name] = createMergedResultFunction(Constructor[name], property);

        return;
      }

      Constructor[name] = property;
    }
  }

  /**
   * Merge two objects, but throw if both contain the same key.
   *
   * @param {object} one The first object, which is mutated.
   * @param {object} two The second object
   * @return {object} one after it has been mutated to contain everything in two.
   */
  function mergeIntoWithNoDuplicateKeys(one, two) {
    _invariant(
      one && two && typeof one === 'object' && typeof two === 'object',
      'mergeIntoWithNoDuplicateKeys(): Cannot merge non-objects.'
    );

    for (var key in two) {
      if (two.hasOwnProperty(key)) {
        _invariant(
          one[key] === undefined,
          'mergeIntoWithNoDuplicateKeys(): ' +
            'Tried to merge two objects with the same key: `%s`. This conflict ' +
            'may be due to a mixin; in particular, this may be caused by two ' +
            'getInitialState() or getDefaultProps() methods returning objects ' +
            'with clashing keys.',
          key
        );
        one[key] = two[key];
      }
    }
    return one;
  }

  /**
   * Creates a function that invokes two functions and merges their return values.
   *
   * @param {function} one Function to invoke first.
   * @param {function} two Function to invoke second.
   * @return {function} Function that invokes the two argument functions.
   * @private
   */
  function createMergedResultFunction(one, two) {
    return function mergedResult() {
      var a = one.apply(this, arguments);
      var b = two.apply(this, arguments);
      if (a == null) {
        return b;
      } else if (b == null) {
        return a;
      }
      var c = {};
      mergeIntoWithNoDuplicateKeys(c, a);
      mergeIntoWithNoDuplicateKeys(c, b);
      return c;
    };
  }

  /**
   * Creates a function that invokes two functions and ignores their return vales.
   *
   * @param {function} one Function to invoke first.
   * @param {function} two Function to invoke second.
   * @return {function} Function that invokes the two argument functions.
   * @private
   */
  function createChainedFunction(one, two) {
    return function chainedFunction() {
      one.apply(this, arguments);
      two.apply(this, arguments);
    };
  }

  /**
   * Binds a method to the component.
   *
   * @param {object} component Component whose method is going to be bound.
   * @param {function} method Method to be bound.
   * @return {function} The bound method.
   */
  function bindAutoBindMethod(component, method) {
    var boundMethod = method.bind(component);
    if (false) { var _bind, componentName; }
    return boundMethod;
  }

  /**
   * Binds all auto-bound methods in a component.
   *
   * @param {object} component Component whose method is going to be bound.
   */
  function bindAutoBindMethods(component) {
    var pairs = component.__reactAutoBindPairs;
    for (var i = 0; i < pairs.length; i += 2) {
      var autoBindKey = pairs[i];
      var method = pairs[i + 1];
      component[autoBindKey] = bindAutoBindMethod(component, method);
    }
  }

  var IsMountedPreMixin = {
    componentDidMount: function() {
      this.__isMounted = true;
    }
  };

  var IsMountedPostMixin = {
    componentWillUnmount: function() {
      this.__isMounted = false;
    }
  };

  /**
   * Add more to the ReactClass base class. These are all legacy features and
   * therefore not already part of the modern ReactComponent.
   */
  var ReactClassMixin = {
    /**
     * TODO: This will be deprecated because state should always keep a consistent
     * type signature and the only use case for this, is to avoid that.
     */
    replaceState: function(newState, callback) {
      this.updater.enqueueReplaceState(this, newState, callback);
    },

    /**
     * Checks whether or not this composite component is mounted.
     * @return {boolean} True if mounted, false otherwise.
     * @protected
     * @final
     */
    isMounted: function() {
      if (false) {}
      return !!this.__isMounted;
    }
  };

  var ReactClassComponent = function() {};
  _assign(
    ReactClassComponent.prototype,
    ReactComponent.prototype,
    ReactClassMixin
  );

  /**
   * Creates a composite component class given a class specification.
   * See https://facebook.github.io/react/docs/top-level-api.html#react.createclass
   *
   * @param {object} spec Class specification (which must define `render`).
   * @return {function} Component constructor function.
   * @public
   */
  function createClass(spec) {
    // To keep our warnings more understandable, we'll use a little hack here to
    // ensure that Constructor.name !== 'Constructor'. This makes sure we don't
    // unnecessarily identify a class without displayName as 'Constructor'.
    var Constructor = identity(function(props, context, updater) {
      // This constructor gets overridden by mocks. The argument is used
      // by mocks to assert on what gets mounted.

      if (false) {}

      // Wire up auto-binding
      if (this.__reactAutoBindPairs.length) {
        bindAutoBindMethods(this);
      }

      this.props = props;
      this.context = context;
      this.refs = emptyObject;
      this.updater = updater || ReactNoopUpdateQueue;

      this.state = null;

      // ReactClasses doesn't have constructors. Instead, they use the
      // getInitialState and componentWillMount methods for initialization.

      var initialState = this.getInitialState ? this.getInitialState() : null;
      if (false) {}
      _invariant(
        typeof initialState === 'object' && !Array.isArray(initialState),
        '%s.getInitialState(): must return an object or null',
        Constructor.displayName || 'ReactCompositeComponent'
      );

      this.state = initialState;
    });
    Constructor.prototype = new ReactClassComponent();
    Constructor.prototype.constructor = Constructor;
    Constructor.prototype.__reactAutoBindPairs = [];

    injectedMixins.forEach(mixSpecIntoComponent.bind(null, Constructor));

    mixSpecIntoComponent(Constructor, IsMountedPreMixin);
    mixSpecIntoComponent(Constructor, spec);
    mixSpecIntoComponent(Constructor, IsMountedPostMixin);

    // Initialize the defaultProps property after all mixins have been merged.
    if (Constructor.getDefaultProps) {
      Constructor.defaultProps = Constructor.getDefaultProps();
    }

    if (false) {}

    _invariant(
      Constructor.prototype.render,
      'createClass(...): Class specification must implement a `render` method.'
    );

    if (false) {}

    // Reduce time spent doing lookups by setting these on the prototype.
    for (var methodName in ReactClassInterface) {
      if (!Constructor.prototype[methodName]) {
        Constructor.prototype[methodName] = null;
      }
    }

    return Constructor;
  }

  return createClass;
}

module.exports = factory;


/***/ }),

/***/ 5841:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */



var emptyObject = {};

if (false) {}

module.exports = emptyObject;

/***/ }),

/***/ 5842:
/***/ (function(module, exports, __webpack_require__) {

var React = __webpack_require__(2);
var createReactClass = __webpack_require__(5839);
var PropTypes = __webpack_require__(2815);
var NotificationItem = __webpack_require__(5843);
var Constants = __webpack_require__(5844);

var NotificationContainer = createReactClass({

  propTypes: {
    position: PropTypes.string.isRequired,
    notifications: PropTypes.array.isRequired,
    getStyles: PropTypes.object
  },

  _style: {},

  componentWillMount: function() {
    // Fix position if width is overrided
    this._style = this.props.getStyles.container(this.props.position);

    if (this.props.getStyles.overrideWidth && (this.props.position === Constants.positions.tc || this.props.position === Constants.positions.bc)) {
      this._style.marginLeft = -(this.props.getStyles.overrideWidth / 2);
    }
  },

  render: function() {
    var self = this;
    var notifications;

    if ([Constants.positions.bl, Constants.positions.br, Constants.positions.bc].indexOf(this.props.position) > -1) {
      this.props.notifications.reverse();
    }

    notifications = this.props.notifications.map(function(notification) {
      return (
        React.createElement(NotificationItem, {
          ref:  'notification-' + notification.uid, 
          key:  notification.uid, 
          notification:  notification, 
          getStyles:  self.props.getStyles, 
          onRemove:  self.props.onRemove, 
          noAnimation:  self.props.noAnimation, 
          allowHTML:  self.props.allowHTML, 
          children:  self.props.children}
        )
      );
    });

    return (
      React.createElement("div", {className:  'notifications-' + this.props.position, style:  this._style}, 
         notifications 
      )
    );
  }
});


module.exports = NotificationContainer;


/***/ }),

/***/ 5843:
/***/ (function(module, exports, __webpack_require__) {

var React = __webpack_require__(2);
var createReactClass = __webpack_require__(5839);
var PropTypes = __webpack_require__(2815);
var ReactDOM = __webpack_require__(5);
var Constants = __webpack_require__(5844);
var Helpers = __webpack_require__(5845);
var merge = __webpack_require__(4);

/* From Modernizr */
var whichTransitionEvent = function() {
  var el = document.createElement('fakeelement');
  var transition;
  var transitions = {
    transition: 'transitionend',
    OTransition: 'oTransitionEnd',
    MozTransition: 'transitionend',
    WebkitTransition: 'webkitTransitionEnd'
  };

  Object.keys(transitions).forEach(function(transitionKey) {
    if (el.style[transitionKey] !== undefined) {
      transition = transitions[transitionKey];
    }
  });

  return transition;
};

var NotificationItem = createReactClass({
  propTypes: {
    notification: PropTypes.object,
    getStyles: PropTypes.object,
    onRemove: PropTypes.func,
    allowHTML: PropTypes.bool,
    noAnimation: PropTypes.bool,
    children: PropTypes.oneOfType([
      PropTypes.string,
      PropTypes.element
    ])
  },

  getDefaultProps: function() {
    return {
      noAnimation: false,
      onRemove: function() {},
      allowHTML: false
    };
  },

  getInitialState: function() {
    return {
      visible: undefined,
      removed: false
    };
  },

  componentWillMount: function() {
    var getStyles = this.props.getStyles;
    var level = this.props.notification.level;
    var dismissible = this.props.notification.dismissible;

    this._noAnimation = this.props.noAnimation;

    this._styles = {
      notification: getStyles.byElement('notification')(level),
      title: getStyles.byElement('title')(level),
      dismiss: getStyles.byElement('dismiss')(level),
      messageWrapper: getStyles.byElement('messageWrapper')(level),
      actionWrapper: getStyles.byElement('actionWrapper')(level),
      action: getStyles.byElement('action')(level)
    };

    if (!dismissible || dismissible === 'none' || dismissible === 'button') {
      this._styles.notification.cursor = 'default';
    }
  },

  _styles: {},

  _notificationTimer: null,

  _height: 0,

  _noAnimation: null,

  _isMounted: false,

  _removeCount: 0,

  _getCssPropertyByPosition: function() {
    var position = this.props.notification.position;
    var css = {};

    switch (position) {
    case Constants.positions.tl:
    case Constants.positions.bl:
      css = {
        property: 'left',
        value: -200
      };
      break;

    case Constants.positions.tr:
    case Constants.positions.br:
      css = {
        property: 'right',
        value: -200
      };
      break;

    case Constants.positions.tc:
      css = {
        property: 'top',
        value: -100
      };
      break;

    case Constants.positions.bc:
      css = {
        property: 'bottom',
        value: -100
      };
      break;

    default:
    }

    return css;
  },

  _defaultAction: function(event) {
    var notification = this.props.notification;

    event.preventDefault();
    this._hideNotification();
    if (typeof notification.action.callback === 'function') {
      notification.action.callback();
    }
  },

  _hideNotification: function() {
    if (this._notificationTimer) {
      this._notificationTimer.clear();
    }

    if (this._isMounted) {
      this.setState({
        visible: false,
        removed: true
      });
    }

    if (this._noAnimation) {
      this._removeNotification();
    }
  },

  _removeNotification: function() {
    this.props.onRemove(this.props.notification.uid);
  },

  _dismiss: function() {
    if (!this.props.notification.dismissible) {
      return;
    }

    this._hideNotification();
  },

  _showNotification: function() {
    var self = this;
    setTimeout(function() {
      if (self._isMounted) {
        self.setState({
          visible: true
        });
      }
    }, 50);
  },

  _onTransitionEnd: function() {
    if (this._removeCount > 0) return;
    if (this.state.removed) {
      this._removeCount += 1;
      this._removeNotification();
    }
  },

  componentDidMount: function() {
    var self = this;
    var transitionEvent = whichTransitionEvent();
    var notification = this.props.notification;
    var element = ReactDOM.findDOMNode(this);

    this._height = element.offsetHeight;

    this._isMounted = true;

    // Watch for transition end
    if (!this._noAnimation) {
      if (transitionEvent) {
        element.addEventListener(transitionEvent, this._onTransitionEnd);
      } else {
        this._noAnimation = true;
      }
    }


    if (notification.autoDismiss) {
      this._notificationTimer = new Helpers.Timer(function() {
        self._hideNotification();
      }, notification.autoDismiss * 1000);
    }

    this._showNotification();
  },

  _handleMouseEnter: function() {
    var notification = this.props.notification;
    if (notification.autoDismiss) {
      this._notificationTimer.pause();
    }
  },

  _handleMouseLeave: function() {
    var notification = this.props.notification;
    if (notification.autoDismiss) {
      this._notificationTimer.resume();
    }
  },

  _handleNotificationClick: function() {
    var dismissible = this.props.notification.dismissible;
    if (dismissible === 'both' || dismissible === 'click' || dismissible === true) {
      this._dismiss();
    }
  },

  componentWillUnmount: function() {
    var element = ReactDOM.findDOMNode(this);
    var transitionEvent = whichTransitionEvent();
    element.removeEventListener(transitionEvent, this._onTransitionEnd);
    this._isMounted = false;
  },

  _allowHTML: function(string) {
    return { __html: string };
  },

  render: function() {
    var notification = this.props.notification;
    var className = 'notification notification-' + notification.level;
    var notificationStyle = merge({}, this._styles.notification);
    var cssByPos = this._getCssPropertyByPosition();
    var dismiss = null;
    var actionButton = null;
    var title = null;
    var message = null;

    if (this.state.visible) {
      className += ' notification-visible';
    } else if (this.state.visible === false) {
      className += ' notification-hidden';
    }

    if (notification.dismissible === 'none') {
      className += ' notification-not-dismissible';
    }

    if (this.props.getStyles.overrideStyle) {
      if (!this.state.visible && !this.state.removed) {
        notificationStyle[cssByPos.property] = cssByPos.value;
      }

      if (this.state.visible && !this.state.removed) {
        notificationStyle.height = this._height;
        notificationStyle[cssByPos.property] = 0;
      }

      if (this.state.removed) {
        notificationStyle.overlay = 'hidden';
        notificationStyle.height = 0;
        notificationStyle.marginTop = 0;
        notificationStyle.paddingTop = 0;
        notificationStyle.paddingBottom = 0;
      }
      notificationStyle.opacity = this.state.visible ? this._styles.notification.isVisible.opacity : this._styles.notification.isHidden.opacity;
    }

    if (notification.title) {
      title = React.createElement("h4", {className: "notification-title", style:  this._styles.title},  notification.title);
    }

    if (notification.message) {
      if (this.props.allowHTML) {
        message = (
          React.createElement("div", {className: "notification-message", style:  this._styles.messageWrapper, dangerouslySetInnerHTML:  this._allowHTML(notification.message) })
        );
      } else {
        message = (
          React.createElement("div", {className: "notification-message", style:  this._styles.messageWrapper},  notification.message)
        );
      }
    }
    if (notification.dismissible === 'both' || notification.dismissible === 'button' || notification.dismissible === true) {
      dismiss = React.createElement("span", {className: "notification-dismiss", onClick:  this._dismiss, style:  this._styles.dismiss}, "×");
    }

    if (notification.action) {
      actionButton = (
        React.createElement("div", {className: "notification-action-wrapper", style:  this._styles.actionWrapper}, 
          React.createElement("button", {className: "notification-action-button", 
            onClick:  this._defaultAction, 
            style:  this._styles.action}, 
             notification.action.label
          )
        )
      );
    }

    if (notification.children) {
      actionButton = notification.children;
    }

    return (
      React.createElement("div", {className:  className, onClick:  this._handleNotificationClick, onMouseEnter:  this._handleMouseEnter, onMouseLeave:  this._handleMouseLeave, style:  notificationStyle }, 
         title, 
         message, 
         dismiss, 
         actionButton 
      )
    );
  }

});

module.exports = NotificationItem;


/***/ }),

/***/ 5844:
/***/ (function(module, exports) {

var CONSTANTS = {

  // Positions
  positions: {
    tl: 'tl',
    tr: 'tr',
    tc: 'tc',
    bl: 'bl',
    br: 'br',
    bc: 'bc'
  },

  // Levels
  levels: {
    success: 'success',
    error: 'error',
    warning: 'warning',
    info: 'info'
  },

  // Notification defaults
  notification: {
    title: null,
    message: null,
    level: null,
    position: 'tr',
    autoDismiss: 5,
    dismissible: 'both',
    action: null
  }
};


module.exports = CONSTANTS;


/***/ }),

/***/ 5845:
/***/ (function(module, exports) {

var Helpers = {
  Timer: function(callback, delay) {
    var timerId;
    var start;
    var remaining = delay;

    this.pause = function() {
      clearTimeout(timerId);
      remaining -= new Date() - start;
    };

    this.resume = function() {
      start = new Date();
      clearTimeout(timerId);
      timerId = setTimeout(callback, remaining);
    };

    this.clear = function() {
      clearTimeout(timerId);
    };

    this.resume();
  }
};

module.exports = Helpers;


/***/ }),

/***/ 5846:
/***/ (function(module, exports) {

// Used for calculations
var defaultWidth = 320;
var defaultColors = {
  success: {
    rgb: '94, 164, 0',
    hex: '#5ea400'
  },
  error: {
    rgb: '236, 61, 61',
    hex: '#ec3d3d'
  },
  warning: {
    rgb: '235, 173, 23',
    hex: '#ebad1a'
  },
  info: {
    rgb: '54, 156, 199',
    hex: '#369cc7'
  }
};
var defaultShadowOpacity = '0.9';

var STYLES = {

  Wrapper: {},
  Containers: {
    DefaultStyle: {
      fontFamily: 'inherit',
      position: 'fixed',
      width: defaultWidth,
      padding: '0 10px 10px 10px',
      zIndex: 9998,
      WebkitBoxSizing: 'border-box',
      MozBoxSizing: 'border-box',
      boxSizing: 'border-box',
      height: 'auto'
    },

    tl: {
      top: '0px',
      bottom: 'auto',
      left: '0px',
      right: 'auto'
    },

    tr: {
      top: '0px',
      bottom: 'auto',
      left: 'auto',
      right: '0px'
    },

    tc: {
      top: '0px',
      bottom: 'auto',
      margin: '0 auto',
      left: '50%',
      marginLeft: -(defaultWidth / 2)
    },

    bl: {
      top: 'auto',
      bottom: '0px',
      left: '0px',
      right: 'auto'
    },

    br: {
      top: 'auto',
      bottom: '0px',
      left: 'auto',
      right: '0px'
    },

    bc: {
      top: 'auto',
      bottom: '0px',
      margin: '0 auto',
      left: '50%',
      marginLeft: -(defaultWidth / 2)
    }

  },

  NotificationItem: {
    DefaultStyle: {
      position: 'relative',
      width: '100%',
      cursor: 'pointer',
      borderRadius: '2px',
      fontSize: '13px',
      margin: '10px 0 0',
      padding: '10px',
      display: 'block',
      WebkitBoxSizing: 'border-box',
      MozBoxSizing: 'border-box',
      boxSizing: 'border-box',
      opacity: 0,
      transition: '0.3s ease-in-out',
      WebkitTransform: 'translate3d(0, 0, 0)',
      transform: 'translate3d(0, 0, 0)',
      willChange: 'transform, opacity',

      isHidden: {
        opacity: 0
      },

      isVisible: {
        opacity: 1
      }
    },

    success: {
      borderTop: '2px solid ' + defaultColors.success.hex,
      backgroundColor: '#f0f5ea',
      color: '#4b583a',
      WebkitBoxShadow: '0 0 1px rgba(' + defaultColors.success.rgb + ',' + defaultShadowOpacity + ')',
      MozBoxShadow: '0 0 1px rgba(' + defaultColors.success.rgb + ',' + defaultShadowOpacity + ')',
      boxShadow: '0 0 1px rgba(' + defaultColors.success.rgb + ',' + defaultShadowOpacity + ')'
    },

    error: {
      borderTop: '2px solid ' + defaultColors.error.hex,
      backgroundColor: '#f4e9e9',
      color: '#412f2f',
      WebkitBoxShadow: '0 0 1px rgba(' + defaultColors.error.rgb + ',' + defaultShadowOpacity + ')',
      MozBoxShadow: '0 0 1px rgba(' + defaultColors.error.rgb + ',' + defaultShadowOpacity + ')',
      boxShadow: '0 0 1px rgba(' + defaultColors.error.rgb + ',' + defaultShadowOpacity + ')'
    },

    warning: {
      borderTop: '2px solid ' + defaultColors.warning.hex,
      backgroundColor: '#f9f6f0',
      color: '#5a5343',
      WebkitBoxShadow: '0 0 1px rgba(' + defaultColors.warning.rgb + ',' + defaultShadowOpacity + ')',
      MozBoxShadow: '0 0 1px rgba(' + defaultColors.warning.rgb + ',' + defaultShadowOpacity + ')',
      boxShadow: '0 0 1px rgba(' + defaultColors.warning.rgb + ',' + defaultShadowOpacity + ')'
    },

    info: {
      borderTop: '2px solid ' + defaultColors.info.hex,
      backgroundColor: '#e8f0f4',
      color: '#41555d',
      WebkitBoxShadow: '0 0 1px rgba(' + defaultColors.info.rgb + ',' + defaultShadowOpacity + ')',
      MozBoxShadow: '0 0 1px rgba(' + defaultColors.info.rgb + ',' + defaultShadowOpacity + ')',
      boxShadow: '0 0 1px rgba(' + defaultColors.info.rgb + ',' + defaultShadowOpacity + ')'
    }
  },

  Title: {
    DefaultStyle: {
      fontSize: '14px',
      margin: '0 0 5px 0',
      padding: 0,
      fontWeight: 'bold'
    },

    success: {
      color: defaultColors.success.hex
    },

    error: {
      color: defaultColors.error.hex
    },

    warning: {
      color: defaultColors.warning.hex
    },

    info: {
      color: defaultColors.info.hex
    }

  },

  MessageWrapper: {
    DefaultStyle: {
      margin: 0,
      padding: 0
    }
  },

  Dismiss: {
    DefaultStyle: {
      cursor: 'pointer',
      fontFamily: 'Arial',
      fontSize: '17px',
      position: 'absolute',
      top: '4px',
      right: '5px',
      lineHeight: '15px',
      backgroundColor: '#dededf',
      color: '#ffffff',
      borderRadius: '50%',
      width: '14px',
      height: '14px',
      fontWeight: 'bold',
      textAlign: 'center'
    },

    success: {
      color: '#f0f5ea',
      backgroundColor: '#b0ca92'
    },

    error: {
      color: '#f4e9e9',
      backgroundColor: '#e4bebe'
    },

    warning: {
      color: '#f9f6f0',
      backgroundColor: '#e1cfac'
    },

    info: {
      color: '#e8f0f4',
      backgroundColor: '#a4becb'
    }
  },

  Action: {
    DefaultStyle: {
      background: '#ffffff',
      borderRadius: '2px',
      padding: '6px 20px',
      fontWeight: 'bold',
      margin: '10px 0 0 0',
      border: 0
    },

    success: {
      backgroundColor: defaultColors.success.hex,
      color: '#ffffff'
    },

    error: {
      backgroundColor: defaultColors.error.hex,
      color: '#ffffff'
    },

    warning: {
      backgroundColor: defaultColors.warning.hex,
      color: '#ffffff'
    },

    info: {
      backgroundColor: defaultColors.info.hex,
      color: '#ffffff'
    }
  },

  ActionWrapper: {
    DefaultStyle: {
      margin: 0,
      padding: 0
    }
  }
};

module.exports = STYLES;


/***/ }),

/***/ 5847:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleFooter; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _js_utils_PluralizeHelper__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3224);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(3048);
/* harmony import */ var _js_components_base_Icons_ErrorIcon__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(3232);
/* harmony import */ var _js_components_base_Icons_SettingsIcon__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(5848);
/* harmony import */ var _js_components_base_Icons_WarningIcon__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(3225);
var _class;










const NARROW_WIDTH_THRESHOLD = 550;let


ConsoleFooter = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class ConsoleFooter extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isExpanded: false,
      isNarrow: false };


    this.toggleSettings = this.toggleSettings.bind(this);
    this.handleResize = this.handleResize.bind(this);
    this.getSettingToggles = this.getSettingToggles.bind(this);
  }

  componentDidMount() {
    window.addEventListener('resize', this.handleResize);
    this.handleResize();
  }

  componentWillUnmount() {
    window.removeEventListener('resize', this.handleResize);
  }

  getSettingToggles() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-footer__settings' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: 'settings__item',
            onClick: () => this.props.store.toggleTimestamp() },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__["Checkbox"], {
            checked: this.props.store.showTimestamp,
            className: 'settings__checkbox' }),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'settings__label' }, 'Show timestamps')),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: 'settings__item',
            onClick: () => this.props.store.toggleNetworkLogs() },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__["Checkbox"], {
            className: 'settings__checkbox',
            checked: this.props.store.hideNetworkLogs }),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'settings__label' }, 'Hide network'))));



  }

  handleResize() {
    if (window.innerWidth < NARROW_WIDTH_THRESHOLD) {
      !this.state.isNarrow && this.setState({ isNarrow: true });
    } else {
      this.state.isNarrow && this.setState({ isNarrow: false });
    }
  }

  toggleSettings() {
    this.setState(prevState => ({ isExpanded: !prevState.isExpanded }));
  }

  render() {
    const errorCount = _.get(this, 'props.eventStore.errorCount', 0),
    warnCount = _.get(this, 'props.eventStore.warnCount', 0);

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-footer' },

        this.state.isExpanded && this.state.isNarrow && this.getSettingToggles(),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-footer__meta-settings' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'meta-settings__left' },

            !!errorCount &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'meta console-footer__error' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_ErrorIcon__WEBPACK_IMPORTED_MODULE_5__["default"], {
                size: 'xs',
                className: 'meta__error-icon' }),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'meta__label' },
                errorCount,

                _js_utils_PluralizeHelper__WEBPACK_IMPORTED_MODULE_2__["default"].pluralize({
                  count: errorCount,
                  singular: ' error',
                  plural: ' errors' }))),







            !!warnCount &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'meta console-footer__warning' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_WarningIcon__WEBPACK_IMPORTED_MODULE_7__["default"], {
                size: 'xs',
                className: 'meta__warning-icon' }),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'meta__label' },
                warnCount,

                _js_utils_PluralizeHelper__WEBPACK_IMPORTED_MODULE_2__["default"].pluralize({
                  count: warnCount,
                  singular: ' warning',
                  plural: ' warnings' })))),







          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'meta-settings__right' },

            this.state.isNarrow ?
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], {
                type: 'icon',
                className: 'settings-icon',
                onClick: this.toggleSettings,
                tooltip: 'Console settings' },

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_SettingsIcon__WEBPACK_IMPORTED_MODULE_6__["default"], {
                size: 'xs',
                className: this.state.isExpanded && 'settings-icon--active' })) :



            this.getSettingToggles()))));





  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5848:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return SettingsIcon; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2813);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('svg', { width: '16', height: '16', viewBox: '0 0 16 16' },
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('defs', null,
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { id: 'settings', d: 'M16 9.62c-.162.507-.316 1.009-.49 1.502a.292.292 0 0 1-.24.074 40.124 40.124 0 0 1-1.51-.217.35.35 0 0 0-.409.16c-.178.275-.371.54-.579.795a.389.389 0 0 0-.046.502c.275.488.518.981.776 1.506l-1.378 1c-.423-.405-.848-.798-1.257-1.206a.354.354 0 0 0-.425-.091c-.348.125-.707.225-1.054.354a.318.318 0 0 0-.176.205c-.11.584-.206 1.174-.313 1.796H7.304a.21.21 0 0 1-.133-.145c-.105-.53-.201-1.063-.29-1.597a.26.26 0 0 0-.211-.245c-.37-.106-.738-.225-1.106-.348a.266.266 0 0 0-.318.074c-.412.428-.831.855-1.263 1.283l-1.421-1c.252-.508.486-1.013.753-1.5a.403.403 0 0 0-.04-.53c-.224-.263-.424-.545-.623-.825a.236.236 0 0 0-.29-.116c-.524.09-1.054.162-1.58.248a.235.235 0 0 1-.2-.023.228.228 0 0 1-.107-.168A19.382 19.382 0 0 0 .08 9.93a.205.205 0 0 1-.019-.188.21.21 0 0 1 .144-.125c.471-.229.926-.485 1.395-.719a.285.285 0 0 0 .188-.314c-.013-.35-.013-.699 0-1.049a.333.333 0 0 0-.22-.365C1.045 6.925.536 6.654 0 6.38c.162-.507.316-1.009.49-1.499a.292.292 0 0 1 .24-.074c.506.063 1.01.131 1.51.214a.347.347 0 0 0 .406-.157c.182-.283.381-.554.596-.813a.37.37 0 0 0 .03-.484 43.456 43.456 0 0 1-.77-1.509l1.377-1c.426.407.848.798 1.26 1.206a.35.35 0 0 0 .425.091c.347-.125.706-.225 1.054-.354a.315.315 0 0 0 .176-.205C6.904 1.212 7 .622 7.107 0h1.595a.212.212 0 0 1 .133.145c.104.53.203 1.061.29 1.597a.26.26 0 0 0 .211.248c.37.106.738.225 1.106.348.11.05.24.02.315-.074.411-.428.831-.856 1.26-1.283l1.421 1c-.252.51-.492 1.013-.75 1.503a.39.39 0 0 0 .026.525c.235.285.58.407.657.855.058.064.142.1.23.097a50.556 50.556 0 0 0 1.603-.243.235.235 0 0 1 .206.008.228.228 0 0 1 .118.166c.116.405.255.804.4 1.198.035.05.043.113.022.17a.187.187 0 0 1-.13.115c-.474.237-.94.493-1.415.73a.285.285 0 0 0-.185.313c0 .351.014.702 0 1.05a.333.333 0 0 0 .22.365c.51.242 1.027.516 1.56.786zM10.708 8a2.665 2.665 0 0 0-1.667-2.467 2.737 2.737 0 0 0-2.951.574 2.636 2.636 0 0 0-.59 2.906 2.707 2.707 0 0 0 2.501 1.647c1.49-.008 2.696-1.193 2.707-2.66z' })),

  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('use', { fill: '#A9A9A9', fillRule: 'evenodd', xlinkHref: '#settings' }));



function SettingsIcon(props) {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_Icon__WEBPACK_IMPORTED_MODULE_1__["default"], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 5849:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleHeader; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(3048);
/* harmony import */ var _ConsoleFilter_ConsoleFilter__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(5850);
var _class;





let


ConsoleHeader = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class ConsoleHeader extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    // Set a local state for searchQuery to debounce the search selection
    this.state = {
      searchQuery: '' };


    this.handleSearchChange = this.handleSearchChange.bind(this);
    this.handleSearchCancel = this.handleSearchCancel.bind(this);
    this.handleClear = this.handleClear.bind(this);
  }

  handleSearchChange(query) {
    this.setState({ searchQuery: query });

    this.props.store.setIsSearching(true);
    this.props.store.setSearchQueryDebounced(query);
  }

  handleSearchCancel() {
    this.props.store.setSearchQuery('');
  }

  handleClear() {
    this.props.store.clearEvents();
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-header' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-header__left' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'search-input' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__["Input"], {
              inputStyle: 'search',
              type: 'text',
              placeholder: 'Search messages',
              onChange: this.handleSearchChange,
              onCancel: this.handleSearchCancel,
              query: this.state.searchQuery,
              className: classnames__WEBPACK_IMPORTED_MODULE_2___default()({ 'is-highlighted': this.state.searchQuery }) })),



          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleFilter_ConsoleFilter__WEBPACK_IMPORTED_MODULE_5__["default"], null)),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-header__right' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], {
              type: 'secondary',
              className: 'clear-btn',
              size: 'small',
              onClick: this.handleClear,
              disabled: !_.get(this.props, 'eventStore.hasLogs') }, 'Clear'))));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5850:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleFilter; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2959);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(3048);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(749);
var _class;





let


ConsoleFilter = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class ConsoleFilter extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {
  constructor(props) {
    super(props);

    this.store = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('ConsoleStore');
    this.eventStore = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('ConsoleEventStore');

    this.handleToggleFilterLevel = this.handleToggleFilterLevel.bind(this);
  }

  handleToggleFilterLevel(level, e) {
    e && e.stopPropagation();
    this.eventStore.toggleFilterLevel(level);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-filter' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["Dropdown"], { disableCloseOnPageScroll: true },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["DropdownButton"], null,
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], { type: 'text', className: 'filter-btn' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, this.store && this.store.allFilterLevelsSelected ? 'All Logs' : 'Custom'))),


          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["DropdownMenu"], null,
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
                key: 'log',
                refKey: 'log',
                className: 'filter__menu-item' },

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  onClick: this.handleToggleFilterLevel.bind(null, 'log'),
                  className: 'menu-item__wrapper' },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__["Checkbox"], {
                  checked: _.includes(this.eventStore.filterLevels, 'log'),
                  className: 'menu-item__checkbox' }),

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'menu-item__label' }, 'Log'))),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
                key: 'info',
                refKey: 'info',
                className: 'filter__menu-item' },

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  onClick: this.handleToggleFilterLevel.bind(null, 'info'),
                  className: 'menu-item__wrapper' },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__["Checkbox"], {
                  checked: _.includes(this.eventStore.filterLevels, 'info'),
                  className: 'menu-item__checkbox' }),

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'menu-item__label' }, 'Info'))),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
                key: 'warn',
                refKey: 'warn',
                className: 'filter__menu-item' },

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  onClick: this.handleToggleFilterLevel.bind(null, 'warn'),
                  className: 'menu-item__wrapper' },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__["Checkbox"], {
                  checked: _.includes(this.eventStore.filterLevels, 'warn'),
                  className: 'menu-item__checkbox' }),

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'menu-item__label' }, 'Warning'))),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
                key: 'error',
                refKey: 'error',
                className: 'filter__menu-item' },

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  onClick: this.handleToggleFilterLevel.bind(null, 'error'),
                  className: 'menu-item__wrapper' },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__["Checkbox"], {
                  checked: _.includes(this.eventStore.filterLevels, 'error'),
                  className: 'menu-item__checkbox' }),

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'menu-item__label' }, 'Error')))))));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5851:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleList; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_window__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3616);
/* harmony import */ var react_virtualized_auto_sizer__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5852);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2929);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var mobx__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(751);
/* harmony import */ var _ConsoleListItem_ConsoleListItem__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(5853);
/* harmony import */ var _js_components_base_Text__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(3285);
var _class;










const MIN_ROW_HEIGHT = 24;let


ConsoleList = Object(mobx_react__WEBPACK_IMPORTED_MODULE_4__["observer"])(_class = class ConsoleList extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.getListItem = this.getListItem.bind(this);
    this.getItemSize = this.getItemSize.bind(this);
    this.handleClearCachedHeight = this.handleClearCachedHeight.bind(this);
    this.autoScrollToBottom = this.autoScrollToBottom.bind(this);
    this.onItemsRendered = this.onItemsRendered.bind(this);
    this.callOnScroll = this.callOnScroll.bind(this);
    this.observeSizeChange = this.observeSizeChange.bind(this);
    this.unobserveSizeChange = this.unobserveSizeChange.bind(this);
    this.renderEmptyState = this.renderEmptyState.bind(this);

    this.listRefs = {};
    this.autoScroll = true;

    // Listen to changes in number of Console events
    //
    // fireImmediately is used for the first scroll to bottom when Console is opened.
    //
    // requestIdleCallback is used because mounting and rendering of new Console events is of
    // higher priority and must be done before scrolling.
    // Also, this helps in waiting for the initial loading and mounting, when Console is booted,
    // before the initial scroll to bottom.
    this.reactionDisposer = Object(mobx__WEBPACK_IMPORTED_MODULE_6__["reaction"])(() => this.props.store.visibleEvents, () => {
      requestIdleCallback(this.autoScrollToBottom.bind(this));
    },
    {
      fireImmediately: true });

  }

  componentDidMount() {
    this.resizeObserver = new ResizeObserver(entries => {
      for (const entry of entries) {// eslint-disable-line no-unused-vars
        if (entry.target.offsetHeight === 0) {
          return;
        }

        this.handleClearCachedHeight(_.get(entry, 'target.dataset.index'));
      }
    });
  }

  componentWillUnmount() {
    this.reactionDisposer && this.reactionDisposer();
  }

  // Listen to user scroll for enabling autoscroll in Console.
  onItemsRendered({ visibleStopIndex }) {
    // Visible stop index is the last list item visible in the virtualized list
    //
    // if the last list item is visible, then autoscroll gets enabled
    if (visibleStopIndex >= this.props.store.eventCount - 2) {
      this.autoScroll = true;
    }
  }

  getItemSize(index) {
    const currentEvent = _.get(this.props, ['store', 'visibleEvents', index]),
    currentEventId = currentEvent && currentEvent.id,
    currentNode = currentEventId && Object(react_dom__WEBPACK_IMPORTED_MODULE_1__["findDOMNode"])(this.listRefs[currentEventId]);

    return currentNode && currentNode.offsetHeight || MIN_ROW_HEIGHT;
  }

  getListItem(data) {
    const consoleEvent = _.get(this.props, ['store', 'visibleEvents', data.index]),
    expandSet = _.get(this.props, 'store.expandSet'),
    toggleExpanded = () => {
      this.props.store.toggleExpanded(consoleEvent.id);
    };

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: this.getClassnames(), style: data.style },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleListItem_ConsoleListItem__WEBPACK_IMPORTED_MODULE_7__["default"], {
          key: consoleEvent.id,
          index: data.index,
          event: consoleEvent,
          showTimestamp: this.props.store.showTimestamp,
          onHeightChange: this.handleClearCachedHeight,
          ref: ref => {this.listRefs[consoleEvent.id] = ref;},
          isExpanded: expandSet.has(consoleEvent.id),
          toggleExpanded: toggleExpanded,
          observeSizeChange: this.observeSizeChange,
          unobserveSizeChange: this.unobserveSizeChange,
          viewLargeBody: this.props.viewLargeBody })));



  }

  getClassnames() {
    let isOverflown = false;

    if (this.listRef) {
      const node = Object(react_dom__WEBPACK_IMPORTED_MODULE_1__["findDOMNode"])(this.listRef);

      isOverflown = node.clientHeight < node.scrollHeight;
    }

    return classnames__WEBPACK_IMPORTED_MODULE_5___default()(
    'console-list-item',
    {
      'is-overflown': isOverflown });


  }

  handleClearCachedHeight(index) {
    this.listRef.resetAfterIndex(index);
  }

  // Listen to backward user scroll for disabling autoscroll in Console.
  callOnScroll({ scrollDirection }) {
    // If the user scrolls in upward direction, which is 'backward' in react-window
    // then autoscroll should be disabled
    if (scrollDirection === 'backward') {
      this.autoScroll = false;
    }
  }

  autoScrollToBottom() {
    if (!this.autoScroll) {
      return;
    }

    !_.isEmpty(this.listRef) && this.listRef.scrollToItem(this.props.store.eventCount);
  }

  observeSizeChange(node) {
    this.resizeObserver && this.resizeObserver.observe(node);
  }

  unobserveSizeChange(node) {
    this.resizeObserver && this.resizeObserver.unobserve(node);
  }

  renderEmptyState() {
    const { store } = this.props;

    if (store.searchQuery) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-list__empty' },
          ` No results found for "${this.props.store.searchQuery}"`));


    }

    // @todo the empty state might be wrong if some logs are hidden by user
    // preference.
    // i.e. (!store.allFilterLevelsSelected || store.hideNetworkLogs)

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-list__empty__container' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-list__empty' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-list__empty--title' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Text__WEBPACK_IMPORTED_MODULE_8__["default"], { type: 'heading-h4', value: 'No logs yet' })),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-list__empty--description' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Text__WEBPACK_IMPORTED_MODULE_8__["default"], { type: 'body-medium', value: 'Send a request to view its details in the console.' })))));




  }

  render() {
    const lister = data =>
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(mobx_react__WEBPACK_IMPORTED_MODULE_4__["Observer"], null,
      this.getListItem.bind(this, data)),


    sizer = ({ height, width }) =>
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(mobx_react__WEBPACK_IMPORTED_MODULE_4__["Observer"], null,
      () =>
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react_window__WEBPACK_IMPORTED_MODULE_2__["VariableSizeList"], {
          height: height,
          itemCount: this.props.store.eventCount,
          itemSize: this.getItemSize,
          width: width,
          ref: ref => {this.listRef = ref;},
          onItemsRendered: this.onItemsRendered,
          onScroll: this.callOnScroll },

        lister));





    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: classnames__WEBPACK_IMPORTED_MODULE_5___default()('console-list', { 'is-disabled': this.props.store.isLoading }) },

        !this.props.store.hasLogs ?
        this.renderEmptyState() :
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react_virtualized_auto_sizer__WEBPACK_IMPORTED_MODULE_3__["default"], null, sizer)));



  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5852:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(global) {/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);


/**
 * Detect Element Resize.
 * https://github.com/sdecima/javascript-detect-element-resize
 * Sebastian Decima
 *
 * Forked from version 0.5.3; includes the following modifications:
 * 1) Guard against unsafe 'window' and 'document' references (to support SSR).
 * 2) Defer initialization code via a top-level function wrapper (to support SSR).
 * 3) Avoid unnecessary reflows by not measuring size for scroll events bubbling from children.
 * 4) Add nonce for style element.
 **/

function createDetectElementResize(nonce) {
  // Check `document` and `window` in case of server-side rendering
  var _window;
  if (typeof window !== 'undefined') {
    _window = window;
  } else if (typeof self !== 'undefined') {
    _window = self;
  } else {
    _window = global;
  }

  var attachEvent = typeof document !== 'undefined' && document.attachEvent;

  if (!attachEvent) {
    var requestFrame = function () {
      var raf = _window.requestAnimationFrame || _window.mozRequestAnimationFrame || _window.webkitRequestAnimationFrame || function (fn) {
        return _window.setTimeout(fn, 20);
      };
      return function (fn) {
        return raf(fn);
      };
    }();

    var cancelFrame = function () {
      var cancel = _window.cancelAnimationFrame || _window.mozCancelAnimationFrame || _window.webkitCancelAnimationFrame || _window.clearTimeout;
      return function (id) {
        return cancel(id);
      };
    }();

    var resetTriggers = function resetTriggers(element) {
      var triggers = element.__resizeTriggers__,
          expand = triggers.firstElementChild,
          contract = triggers.lastElementChild,
          expandChild = expand.firstElementChild;
      contract.scrollLeft = contract.scrollWidth;
      contract.scrollTop = contract.scrollHeight;
      expandChild.style.width = expand.offsetWidth + 1 + 'px';
      expandChild.style.height = expand.offsetHeight + 1 + 'px';
      expand.scrollLeft = expand.scrollWidth;
      expand.scrollTop = expand.scrollHeight;
    };

    var checkTriggers = function checkTriggers(element) {
      return element.offsetWidth != element.__resizeLast__.width || element.offsetHeight != element.__resizeLast__.height;
    };

    var scrollListener = function scrollListener(e) {
      // Don't measure (which forces) reflow for scrolls that happen inside of children!
      if (e.target.className.indexOf('contract-trigger') < 0 && e.target.className.indexOf('expand-trigger') < 0) {
        return;
      }

      var element = this;
      resetTriggers(this);
      if (this.__resizeRAF__) {
        cancelFrame(this.__resizeRAF__);
      }
      this.__resizeRAF__ = requestFrame(function () {
        if (checkTriggers(element)) {
          element.__resizeLast__.width = element.offsetWidth;
          element.__resizeLast__.height = element.offsetHeight;
          element.__resizeListeners__.forEach(function (fn) {
            fn.call(element, e);
          });
        }
      });
    };

    /* Detect CSS Animations support to detect element display/re-attach */
    var animation = false,
        keyframeprefix = '',
        animationstartevent = 'animationstart',
        domPrefixes = 'Webkit Moz O ms'.split(' '),
        startEvents = 'webkitAnimationStart animationstart oAnimationStart MSAnimationStart'.split(' '),
        pfx = '';
    {
      var elm = document.createElement('fakeelement');
      if (elm.style.animationName !== undefined) {
        animation = true;
      }

      if (animation === false) {
        for (var i = 0; i < domPrefixes.length; i++) {
          if (elm.style[domPrefixes[i] + 'AnimationName'] !== undefined) {
            pfx = domPrefixes[i];
            keyframeprefix = '-' + pfx.toLowerCase() + '-';
            animationstartevent = startEvents[i];
            animation = true;
            break;
          }
        }
      }
    }

    var animationName = 'resizeanim';
    var animationKeyframes = '@' + keyframeprefix + 'keyframes ' + animationName + ' { from { opacity: 0; } to { opacity: 0; } } ';
    var animationStyle = keyframeprefix + 'animation: 1ms ' + animationName + '; ';
  }

  var createStyles = function createStyles(doc) {
    if (!doc.getElementById('detectElementResize')) {
      //opacity:0 works around a chrome bug https://code.google.com/p/chromium/issues/detail?id=286360
      var css = (animationKeyframes ? animationKeyframes : '') + '.resize-triggers { ' + (animationStyle ? animationStyle : '') + 'visibility: hidden; opacity: 0; } ' + '.resize-triggers, .resize-triggers > div, .contract-trigger:before { content: " "; display: block; position: absolute; top: 0; left: 0; height: 100%; width: 100%; overflow: hidden; z-index: -1; } .resize-triggers > div { background: #eee; overflow: auto; } .contract-trigger:before { width: 200%; height: 200%; }',
          head = doc.head || doc.getElementsByTagName('head')[0],
          style = doc.createElement('style');

      style.id = 'detectElementResize';
      style.type = 'text/css';

      if (nonce != null) {
        style.setAttribute('nonce', nonce);
      }

      if (style.styleSheet) {
        style.styleSheet.cssText = css;
      } else {
        style.appendChild(doc.createTextNode(css));
      }

      head.appendChild(style);
    }
  };

  var addResizeListener = function addResizeListener(element, fn) {
    if (attachEvent) {
      element.attachEvent('onresize', fn);
    } else {
      if (!element.__resizeTriggers__) {
        var doc = element.ownerDocument;
        var elementStyle = _window.getComputedStyle(element);
        if (elementStyle && elementStyle.position == 'static') {
          element.style.position = 'relative';
        }
        createStyles(doc);
        element.__resizeLast__ = {};
        element.__resizeListeners__ = [];
        (element.__resizeTriggers__ = doc.createElement('div')).className = 'resize-triggers';
        element.__resizeTriggers__.innerHTML = '<div class="expand-trigger"><div></div></div>' + '<div class="contract-trigger"></div>';
        element.appendChild(element.__resizeTriggers__);
        resetTriggers(element);
        element.addEventListener('scroll', scrollListener, true);

        /* Listen for a css animation to detect element display/re-attach */
        if (animationstartevent) {
          element.__resizeTriggers__.__animationListener__ = function animationListener(e) {
            if (e.animationName == animationName) {
              resetTriggers(element);
            }
          };
          element.__resizeTriggers__.addEventListener(animationstartevent, element.__resizeTriggers__.__animationListener__);
        }
      }
      element.__resizeListeners__.push(fn);
    }
  };

  var removeResizeListener = function removeResizeListener(element, fn) {
    if (attachEvent) {
      element.detachEvent('onresize', fn);
    } else {
      element.__resizeListeners__.splice(element.__resizeListeners__.indexOf(fn), 1);
      if (!element.__resizeListeners__.length) {
        element.removeEventListener('scroll', scrollListener, true);
        if (element.__resizeTriggers__.__animationListener__) {
          element.__resizeTriggers__.removeEventListener(animationstartevent, element.__resizeTriggers__.__animationListener__);
          element.__resizeTriggers__.__animationListener__ = null;
        }
        try {
          element.__resizeTriggers__ = !element.removeChild(element.__resizeTriggers__);
        } catch (e) {
          // Preact compat; see developit/preact-compat/issues/228
        }
      }
    }
  };

  return {
    addResizeListener: addResizeListener,
    removeResizeListener: removeResizeListener
  };
}

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var AutoSizer = function (_React$PureComponent) {
  inherits(AutoSizer, _React$PureComponent);

  function AutoSizer() {
    var _ref;

    var _temp, _this, _ret;

    classCallCheck(this, AutoSizer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = AutoSizer.__proto__ || Object.getPrototypeOf(AutoSizer)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      height: _this.props.defaultHeight || 0,
      width: _this.props.defaultWidth || 0
    }, _this._onResize = function () {
      var _this$props = _this.props,
          disableHeight = _this$props.disableHeight,
          disableWidth = _this$props.disableWidth,
          onResize = _this$props.onResize;


      if (_this._parentNode) {
        // Guard against AutoSizer component being removed from the DOM immediately after being added.
        // This can result in invalid style values which can result in NaN values if we don't handle them.
        // See issue #150 for more context.

        var _height = _this._parentNode.offsetHeight || 0;
        var _width = _this._parentNode.offsetWidth || 0;

        var _style = window.getComputedStyle(_this._parentNode) || {};
        var paddingLeft = parseInt(_style.paddingLeft, 10) || 0;
        var paddingRight = parseInt(_style.paddingRight, 10) || 0;
        var paddingTop = parseInt(_style.paddingTop, 10) || 0;
        var paddingBottom = parseInt(_style.paddingBottom, 10) || 0;

        var newHeight = _height - paddingTop - paddingBottom;
        var newWidth = _width - paddingLeft - paddingRight;

        if (!disableHeight && _this.state.height !== newHeight || !disableWidth && _this.state.width !== newWidth) {
          _this.setState({
            height: _height - paddingTop - paddingBottom,
            width: _width - paddingLeft - paddingRight
          });

          onResize({ height: _height, width: _width });
        }
      }
    }, _this._setRef = function (autoSizer) {
      _this._autoSizer = autoSizer;
    }, _temp), possibleConstructorReturn(_this, _ret);
  }

  createClass(AutoSizer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var nonce = this.props.nonce;

      if (this._autoSizer && this._autoSizer.parentNode && this._autoSizer.parentNode.ownerDocument && this._autoSizer.parentNode.ownerDocument.defaultView && this._autoSizer.parentNode instanceof this._autoSizer.parentNode.ownerDocument.defaultView.HTMLElement) {
        // Delay access of parentNode until mount.
        // This handles edge-cases where the component has already been unmounted before its ref has been set,
        // As well as libraries like react-lite which have a slightly different lifecycle.
        this._parentNode = this._autoSizer.parentNode;

        // Defer requiring resize handler in order to support server-side rendering.
        // See issue #41
        this._detectElementResize = createDetectElementResize(nonce);
        this._detectElementResize.addResizeListener(this._parentNode, this._onResize);

        this._onResize();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this._detectElementResize && this._parentNode) {
        this._detectElementResize.removeResizeListener(this._parentNode, this._onResize);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          className = _props.className,
          disableHeight = _props.disableHeight,
          disableWidth = _props.disableWidth,
          style = _props.style;
      var _state = this.state,
          height = _state.height,
          width = _state.width;

      // Outer div should not force width/height since that may prevent containers from shrinking.
      // Inner component should overflow and use calculated width/height.
      // See issue #68 for more information.

      var outerStyle = { overflow: 'visible' };
      var childParams = {};

      // Avoid rendering children before the initial measurements have been collected.
      // At best this would just be wasting cycles.
      var bailoutOnChildren = false;

      if (!disableHeight) {
        if (height === 0) {
          bailoutOnChildren = true;
        }
        outerStyle.height = 0;
        childParams.height = height;
      }

      if (!disableWidth) {
        if (width === 0) {
          bailoutOnChildren = true;
        }
        outerStyle.width = 0;
        childParams.width = width;
      }

      return Object(react__WEBPACK_IMPORTED_MODULE_0__["createElement"])(
        'div',
        {
          className: className,
          ref: this._setRef,
          style: _extends({}, outerStyle, style) },
        !bailoutOnChildren && children(childParams)
      );
    }
  }]);
  return AutoSizer;
}(react__WEBPACK_IMPORTED_MODULE_0__["PureComponent"]);

AutoSizer.defaultProps = {
  onResize: function onResize() {},
  disableHeight: false,
  disableWidth: false,
  style: {}
};

/* harmony default export */ __webpack_exports__["default"] = (AutoSizer);

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(19)))

/***/ }),

/***/ 5853:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleListItem; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2929);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var moment__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2703);
/* harmony import */ var moment__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(moment__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _ConsoleMessageItem__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(5854);
/* harmony import */ var _ConsoleNetworkItem_ConsoleNetworkItem__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(5998);
/* harmony import */ var _js_components_base_Icons_LockedIcon__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(6003);
/* harmony import */ var _js_components_base_Icons_ErrorIcon__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(3232);
/* harmony import */ var _js_components_base_Icons_WarningIcon__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(3225);
/* harmony import */ var _js_components_base_Icons_InformationIcon__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(3231);
/* harmony import */ var _js_components_base_Icons_RedirectIcon__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(6004);
/* harmony import */ var _js_components_base_Icons_CodeIcon__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(6005);
/* harmony import */ var _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(731);
var _class;
















let



ConsoleListItem = Object(mobx_react__WEBPACK_IMPORTED_MODULE_2__["observer"])(_class = class ConsoleListItem extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  componentDidMount() {
    this.selfNode = Object(react_dom__WEBPACK_IMPORTED_MODULE_1__["findDOMNode"])(this);

    // Starts observing element
    this.props.observeSizeChange && this.props.observeSizeChange(this.selfNode);
  }

  shouldComponentUpdate(nextProps) {
    // If showTimestamp modifier has changed then update the component
    if (this.props.showTimestamp !== nextProps.showTimestamp) {
      return true;
    }

    // If expanded state has not changed do not update
    if (this.props.isExpanded !== nextProps.isExpanded) {
      return true;
    }

    return false;
  }

  componentWillUnmount() {
    this.props.observeSizeChange && this.props.unobserveSizeChange(this.selfNode);
  }

  getLeftIcon(severity) {
    if (severity === _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_13__["CONSOLE_LEVEL_ERROR"]) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_ErrorIcon__WEBPACK_IMPORTED_MODULE_8__["default"], {
          size: 'xs',
          title: 'Error',
          className: 'c-li__icon c-li__icon--error' }));


    }

    if (severity === _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_13__["CONSOLE_LEVEL_WARN"]) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_WarningIcon__WEBPACK_IMPORTED_MODULE_9__["default"], {
          size: 'xs',
          title: 'Warning',
          className: 'c-li__icon c-li__icon--warning' }));


    }

    if (severity === _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_13__["CONSOLE_LEVEL_INFO"]) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_InformationIcon__WEBPACK_IMPORTED_MODULE_10__["default"], {
          size: 'xs',
          title: 'Info',
          className: 'c-li__icon c-li__icon--info' }));


    }

    return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { title: 'Log', className: 'c-li__icon empty' }, '\xA0');
  }

  getRightIcon(details) {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,

        details.redirect &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_RedirectIcon__WEBPACK_IMPORTED_MODULE_11__["default"], {
          size: 'xs',
          title: 'This request was triggered on redirect',
          className: 'c-li__icon c-li__redirect-icon' }),




        details.indirect === 'request' &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_CodeIcon__WEBPACK_IMPORTED_MODULE_12__["default"], {
          size: 'xs',
          title: 'This request was triggered by a function in your script',
          className: 'c-li__icon c-li__code-icon' }),




        details.indirect === 'auth' &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_LockedIcon__WEBPACK_IMPORTED_MODULE_7__["default"], {
          size: 'xs',
          title: 'This request was triggered by an authorization helper',
          className: 'c-li__icon c-li__lock-icon' })));





  }

  getDetails(event) {
    if (event.type === 'log') {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__msg-wrap' },

          _.map(event.details, (message, index) =>
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleMessageItem__WEBPACK_IMPORTED_MODULE_5__["default"], {
            message: message,
            key: index }))));





    }

    if (event.type === 'network') {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleNetworkItem_ConsoleNetworkItem__WEBPACK_IMPORTED_MODULE_6__["default"], {
          data: event.details,
          severity: event.severity,
          isExpanded: this.props.isExpanded,
          toggleExpanded: this.props.toggleExpanded,
          viewLargeBody: this.props.viewLargeBody,
          id: event.id // So that the NetworkItem knows which Blob to load
        }));

    }

    if (event.type === 'exception') {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleMessageItem__WEBPACK_IMPORTED_MODULE_5__["default"], {
          message: `${_.get(event, 'details.name', 'Error')}: ${_.get(event, 'details.message', '')}` }));


    }
  }

  render() {
    const severity = _.get(this.props, 'event.severity'),
    listItemClass = classnames__WEBPACK_IMPORTED_MODULE_3___default()('c-flex', {
      'is-error': severity === _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_13__["CONSOLE_LEVEL_ERROR"],
      'is-warning': severity === _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_13__["CONSOLE_LEVEL_WARN"],
      'is-log': severity === _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_13__["CONSOLE_LEVEL_LOG"],
      'is-info': severity === _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_13__["CONSOLE_LEVEL_INFO"],
      'is-indirect': !!(_.get(this.props, 'event.details.redirect') || _.get(this.props, 'event.details.indirect')) });


    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: listItemClass, 'data-index': this.props.index },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'c-flex__left' },

          this.getLeftIcon(severity),


          this.props.showTimestamp &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'c-li__timestamp' },
            moment__WEBPACK_IMPORTED_MODULE_4___default()(this.props.event.timestamp).format('HH:mm:ss.SSS')),




          this.getDetails(this.props.event)),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'c-flex__right' },

          this.getRightIcon(_.get(this.props, 'event.details', {})))));




  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5854:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleMessageItem; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_inspector__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5855);
/* harmony import */ var react_inspector__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_inspector__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _provider_ObjectInspector_styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5991);
/* harmony import */ var _provider_ObjectInspector_object_ObjectRootLabel__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5992);
/* harmony import */ var _provider_ObjectInspector_ObjectLabel__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5997);
/* harmony import */ var _provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(5996);







let

ConsoleMessageItem = class ConsoleMessageItem extends react__WEBPACK_IMPORTED_MODULE_0__["PureComponent"] {
  getMessage(message) {
    if (message === '') {
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: 0, className: 'c-li__empty', title: 'Empty String' });
    }

    const isStr = typeof message === 'string',
    splitMessage = String(message).split('\n'),
    isOnlyNewlines = isStr && splitMessage.length > message.length,
    isSingularString = isStr && splitMessage.length === 1;

    splitMessage[0] =
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: 'spch-0', className: 'c-li__msg-str' },
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_5__["default"], {
        quoteStart: isStr,
        quoteEnd: isSingularString,
        key: 'wf-0',
        sentence: splitMessage[0] }));




    for (let i = 1; i < splitMessage.length; i++) {
      splitMessage[i] =
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, { key: i },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: `spfl-${i}`, className: 'c-li__r-fill' }),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: `spch-${i}`, className: 'c-li__msg-str' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_5__["default"], {
            key: `wf-${i}`,
            sentence: splitMessage[i],
            quoteEnd: isStr && i === splitMessage.length - 1 })));




    }

    if (isOnlyNewlines) {
      splitMessage[splitMessage.length - 1] =
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
        isStr && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_5__["default"], { quoteEnd: true }),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: 'spfl__last', className: 'c-li__r-fill' }));


    }

    return splitMessage;
  }

  getTheme() {
    return _.defaults({ TREENODE_PADDING_LEFT: 15 }, _provider_ObjectInspector_styles__WEBPACK_IMPORTED_MODULE_2__["baseStyles"]);
  }

  nodeRenderer({
    depth, name, data, isNonenumerable, shouldShowArrow })
  {
    let styles;

    if (shouldShowArrow) {
      styles = { cursor: 'pointer' };
    }

    if (depth === 0) {
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: styles }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_ObjectInspector_object_ObjectRootLabel__WEBPACK_IMPORTED_MODULE_3__["default"], { name: name, data: data }));
    }

    return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_ObjectInspector_ObjectLabel__WEBPACK_IMPORTED_MODULE_4__["default"], { name: name, data: data, isNonenumerable: isNonenumerable, styles: styles });
  }

  render() {
    if (_.isObject(this.props.message)) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'c-li__msg-obj' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react_inspector__WEBPACK_IMPORTED_MODULE_1___default.a, {
            data: this.props.message,
            theme: this.getTheme(),
            nodeRenderer: this.nodeRenderer,
            sortObjectKeys: false })));



    }

    return this.getMessage(this.props.message);
  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5855:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Inspector = exports.ObjectName = exports.ObjectValue = exports.ObjectRootLabel = exports.ObjectLabel = exports.DOMInspector = exports.TableInspector = exports.ObjectInspector = exports.chromeDark = exports.chromeLight = undefined;

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = __webpack_require__(5895);

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _themes = __webpack_require__(5896);

Object.defineProperty(exports, 'chromeLight', {
  enumerable: true,
  get: function get() {
    return _themes.chromeLight;
  }
});
Object.defineProperty(exports, 'chromeDark', {
  enumerable: true,
  get: function get() {
    return _themes.chromeDark;
  }
});

var _ObjectInspector2 = __webpack_require__(5899);

var _ObjectInspector3 = _interopRequireDefault(_ObjectInspector2);

var _TableInspector2 = __webpack_require__(5972);

var _TableInspector3 = _interopRequireDefault(_TableInspector2);

var _DOMInspector2 = __webpack_require__(5985);

var _DOMInspector3 = _interopRequireDefault(_DOMInspector2);

var _ObjectLabel2 = __webpack_require__(5970);

var _ObjectLabel3 = _interopRequireDefault(_ObjectLabel2);

var _ObjectRootLabel2 = __webpack_require__(5966);

var _ObjectRootLabel3 = _interopRequireDefault(_ObjectRootLabel2);

var _ObjectValue2 = __webpack_require__(5969);

var _ObjectValue3 = _interopRequireDefault(_ObjectValue2);

var _ObjectName2 = __webpack_require__(5967);

var _ObjectName3 = _interopRequireDefault(_ObjectName2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isDom = __webpack_require__(5988);

var _isDom2 = _interopRequireDefault(_isDom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.ObjectInspector = _ObjectInspector3.default;
exports.TableInspector = _TableInspector3.default;
exports.DOMInspector = _DOMInspector3.default;
exports.ObjectLabel = _ObjectLabel3.default;
exports.ObjectRootLabel = _ObjectRootLabel3.default;
exports.ObjectValue = _ObjectValue3.default;
exports.ObjectName = _ObjectName3.default;

// Wrapping the inspectors

var Inspector = function Inspector(_ref) {
  var _ref$table = _ref.table,
      table = _ref$table === undefined ? false : _ref$table,
      data = _ref.data,
      rest = (0, _objectWithoutProperties3.default)(_ref, ['table', 'data']);

  if (table) {
    return _react2.default.createElement(_TableInspector3.default, (0, _extends3.default)({ data: data }, rest));
  }

  if ((0, _isDom2.default)(data)) return _react2.default.createElement(_DOMInspector3.default, (0, _extends3.default)({ data: data }, rest));

  return _react2.default.createElement(_ObjectInspector3.default, (0, _extends3.default)({ data: data }, rest));
};

Inspector.propTypes = {
  data: _propTypes2.default.any,
  name: _propTypes2.default.string,
  table: _propTypes2.default.bool
};

exports.Inspector = Inspector;
exports.default = Inspector;

/***/ }),

/***/ 5856:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _assign = __webpack_require__(5857);

var _assign2 = _interopRequireDefault(_assign);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = _assign2.default || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

/***/ }),

/***/ 5857:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5858), __esModule: true };

/***/ }),

/***/ 5858:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5859);
module.exports = __webpack_require__(5862).Object.assign;


/***/ }),

/***/ 5859:
/***/ (function(module, exports, __webpack_require__) {

// 19.1.3.1 Object.assign(target, source)
var $export = __webpack_require__(5860);

$export($export.S + $export.F, 'Object', { assign: __webpack_require__(5876) });


/***/ }),

/***/ 5860:
/***/ (function(module, exports, __webpack_require__) {

var global = __webpack_require__(5861);
var core = __webpack_require__(5862);
var ctx = __webpack_require__(5863);
var hide = __webpack_require__(5865);
var has = __webpack_require__(5875);
var PROTOTYPE = 'prototype';

var $export = function (type, name, source) {
  var IS_FORCED = type & $export.F;
  var IS_GLOBAL = type & $export.G;
  var IS_STATIC = type & $export.S;
  var IS_PROTO = type & $export.P;
  var IS_BIND = type & $export.B;
  var IS_WRAP = type & $export.W;
  var exports = IS_GLOBAL ? core : core[name] || (core[name] = {});
  var expProto = exports[PROTOTYPE];
  var target = IS_GLOBAL ? global : IS_STATIC ? global[name] : (global[name] || {})[PROTOTYPE];
  var key, own, out;
  if (IS_GLOBAL) source = name;
  for (key in source) {
    // contains in native
    own = !IS_FORCED && target && target[key] !== undefined;
    if (own && has(exports, key)) continue;
    // export native or passed
    out = own ? target[key] : source[key];
    // prevent global pollution for namespaces
    exports[key] = IS_GLOBAL && typeof target[key] != 'function' ? source[key]
    // bind timers to global for call from export context
    : IS_BIND && own ? ctx(out, global)
    // wrap global constructors for prevent change them in library
    : IS_WRAP && target[key] == out ? (function (C) {
      var F = function (a, b, c) {
        if (this instanceof C) {
          switch (arguments.length) {
            case 0: return new C();
            case 1: return new C(a);
            case 2: return new C(a, b);
          } return new C(a, b, c);
        } return C.apply(this, arguments);
      };
      F[PROTOTYPE] = C[PROTOTYPE];
      return F;
    // make static versions for prototype methods
    })(out) : IS_PROTO && typeof out == 'function' ? ctx(Function.call, out) : out;
    // export proto methods to core.%CONSTRUCTOR%.methods.%NAME%
    if (IS_PROTO) {
      (exports.virtual || (exports.virtual = {}))[key] = out;
      // export proto methods to core.%CONSTRUCTOR%.prototype.%NAME%
      if (type & $export.R && expProto && !expProto[key]) hide(expProto, key, out);
    }
  }
};
// type bitmap
$export.F = 1;   // forced
$export.G = 2;   // global
$export.S = 4;   // static
$export.P = 8;   // proto
$export.B = 16;  // bind
$export.W = 32;  // wrap
$export.U = 64;  // safe
$export.R = 128; // real proto method for `library`
module.exports = $export;


/***/ }),

/***/ 5861:
/***/ (function(module, exports) {

// https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
var global = module.exports = typeof window != 'undefined' && window.Math == Math
  ? window : typeof self != 'undefined' && self.Math == Math ? self
  // eslint-disable-next-line no-new-func
  : Function('return this')();
if (typeof __g == 'number') __g = global; // eslint-disable-line no-undef


/***/ }),

/***/ 5862:
/***/ (function(module, exports) {

var core = module.exports = { version: '2.6.11' };
if (typeof __e == 'number') __e = core; // eslint-disable-line no-undef


/***/ }),

/***/ 5863:
/***/ (function(module, exports, __webpack_require__) {

// optional / simple context binding
var aFunction = __webpack_require__(5864);
module.exports = function (fn, that, length) {
  aFunction(fn);
  if (that === undefined) return fn;
  switch (length) {
    case 1: return function (a) {
      return fn.call(that, a);
    };
    case 2: return function (a, b) {
      return fn.call(that, a, b);
    };
    case 3: return function (a, b, c) {
      return fn.call(that, a, b, c);
    };
  }
  return function (/* ...args */) {
    return fn.apply(that, arguments);
  };
};


/***/ }),

/***/ 5864:
/***/ (function(module, exports) {

module.exports = function (it) {
  if (typeof it != 'function') throw TypeError(it + ' is not a function!');
  return it;
};


/***/ }),

/***/ 5865:
/***/ (function(module, exports, __webpack_require__) {

var dP = __webpack_require__(5866);
var createDesc = __webpack_require__(5874);
module.exports = __webpack_require__(5870) ? function (object, key, value) {
  return dP.f(object, key, createDesc(1, value));
} : function (object, key, value) {
  object[key] = value;
  return object;
};


/***/ }),

/***/ 5866:
/***/ (function(module, exports, __webpack_require__) {

var anObject = __webpack_require__(5867);
var IE8_DOM_DEFINE = __webpack_require__(5869);
var toPrimitive = __webpack_require__(5873);
var dP = Object.defineProperty;

exports.f = __webpack_require__(5870) ? Object.defineProperty : function defineProperty(O, P, Attributes) {
  anObject(O);
  P = toPrimitive(P, true);
  anObject(Attributes);
  if (IE8_DOM_DEFINE) try {
    return dP(O, P, Attributes);
  } catch (e) { /* empty */ }
  if ('get' in Attributes || 'set' in Attributes) throw TypeError('Accessors not supported!');
  if ('value' in Attributes) O[P] = Attributes.value;
  return O;
};


/***/ }),

/***/ 5867:
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(5868);
module.exports = function (it) {
  if (!isObject(it)) throw TypeError(it + ' is not an object!');
  return it;
};


/***/ }),

/***/ 5868:
/***/ (function(module, exports) {

module.exports = function (it) {
  return typeof it === 'object' ? it !== null : typeof it === 'function';
};


/***/ }),

/***/ 5869:
/***/ (function(module, exports, __webpack_require__) {

module.exports = !__webpack_require__(5870) && !__webpack_require__(5871)(function () {
  return Object.defineProperty(__webpack_require__(5872)('div'), 'a', { get: function () { return 7; } }).a != 7;
});


/***/ }),

/***/ 5870:
/***/ (function(module, exports, __webpack_require__) {

// Thank's IE8 for his funny defineProperty
module.exports = !__webpack_require__(5871)(function () {
  return Object.defineProperty({}, 'a', { get: function () { return 7; } }).a != 7;
});


/***/ }),

/***/ 5871:
/***/ (function(module, exports) {

module.exports = function (exec) {
  try {
    return !!exec();
  } catch (e) {
    return true;
  }
};


/***/ }),

/***/ 5872:
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(5868);
var document = __webpack_require__(5861).document;
// typeof document.createElement is 'object' in old IE
var is = isObject(document) && isObject(document.createElement);
module.exports = function (it) {
  return is ? document.createElement(it) : {};
};


/***/ }),

/***/ 5873:
/***/ (function(module, exports, __webpack_require__) {

// 7.1.1 ToPrimitive(input [, PreferredType])
var isObject = __webpack_require__(5868);
// instead of the ES6 spec version, we didn't implement @@toPrimitive case
// and the second argument - flag - preferred type is a string
module.exports = function (it, S) {
  if (!isObject(it)) return it;
  var fn, val;
  if (S && typeof (fn = it.toString) == 'function' && !isObject(val = fn.call(it))) return val;
  if (typeof (fn = it.valueOf) == 'function' && !isObject(val = fn.call(it))) return val;
  if (!S && typeof (fn = it.toString) == 'function' && !isObject(val = fn.call(it))) return val;
  throw TypeError("Can't convert object to primitive value");
};


/***/ }),

/***/ 5874:
/***/ (function(module, exports) {

module.exports = function (bitmap, value) {
  return {
    enumerable: !(bitmap & 1),
    configurable: !(bitmap & 2),
    writable: !(bitmap & 4),
    value: value
  };
};


/***/ }),

/***/ 5875:
/***/ (function(module, exports) {

var hasOwnProperty = {}.hasOwnProperty;
module.exports = function (it, key) {
  return hasOwnProperty.call(it, key);
};


/***/ }),

/***/ 5876:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

// 19.1.2.1 Object.assign(target, source, ...)
var DESCRIPTORS = __webpack_require__(5870);
var getKeys = __webpack_require__(5877);
var gOPS = __webpack_require__(5892);
var pIE = __webpack_require__(5893);
var toObject = __webpack_require__(5894);
var IObject = __webpack_require__(5880);
var $assign = Object.assign;

// should work with symbols and should have deterministic property order (V8 bug)
module.exports = !$assign || __webpack_require__(5871)(function () {
  var A = {};
  var B = {};
  // eslint-disable-next-line no-undef
  var S = Symbol();
  var K = 'abcdefghijklmnopqrst';
  A[S] = 7;
  K.split('').forEach(function (k) { B[k] = k; });
  return $assign({}, A)[S] != 7 || Object.keys($assign({}, B)).join('') != K;
}) ? function assign(target, source) { // eslint-disable-line no-unused-vars
  var T = toObject(target);
  var aLen = arguments.length;
  var index = 1;
  var getSymbols = gOPS.f;
  var isEnum = pIE.f;
  while (aLen > index) {
    var S = IObject(arguments[index++]);
    var keys = getSymbols ? getKeys(S).concat(getSymbols(S)) : getKeys(S);
    var length = keys.length;
    var j = 0;
    var key;
    while (length > j) {
      key = keys[j++];
      if (!DESCRIPTORS || isEnum.call(S, key)) T[key] = S[key];
    }
  } return T;
} : $assign;


/***/ }),

/***/ 5877:
/***/ (function(module, exports, __webpack_require__) {

// 19.1.2.14 / 15.2.3.14 Object.keys(O)
var $keys = __webpack_require__(5878);
var enumBugKeys = __webpack_require__(5891);

module.exports = Object.keys || function keys(O) {
  return $keys(O, enumBugKeys);
};


/***/ }),

/***/ 5878:
/***/ (function(module, exports, __webpack_require__) {

var has = __webpack_require__(5875);
var toIObject = __webpack_require__(5879);
var arrayIndexOf = __webpack_require__(5883)(false);
var IE_PROTO = __webpack_require__(5887)('IE_PROTO');

module.exports = function (object, names) {
  var O = toIObject(object);
  var i = 0;
  var result = [];
  var key;
  for (key in O) if (key != IE_PROTO) has(O, key) && result.push(key);
  // Don't enum bug & hidden keys
  while (names.length > i) if (has(O, key = names[i++])) {
    ~arrayIndexOf(result, key) || result.push(key);
  }
  return result;
};


/***/ }),

/***/ 5879:
/***/ (function(module, exports, __webpack_require__) {

// to indexed object, toObject with fallback for non-array-like ES3 strings
var IObject = __webpack_require__(5880);
var defined = __webpack_require__(5882);
module.exports = function (it) {
  return IObject(defined(it));
};


/***/ }),

/***/ 5880:
/***/ (function(module, exports, __webpack_require__) {

// fallback for non-array-like ES3 and non-enumerable old V8 strings
var cof = __webpack_require__(5881);
// eslint-disable-next-line no-prototype-builtins
module.exports = Object('z').propertyIsEnumerable(0) ? Object : function (it) {
  return cof(it) == 'String' ? it.split('') : Object(it);
};


/***/ }),

/***/ 5881:
/***/ (function(module, exports) {

var toString = {}.toString;

module.exports = function (it) {
  return toString.call(it).slice(8, -1);
};


/***/ }),

/***/ 5882:
/***/ (function(module, exports) {

// 7.2.1 RequireObjectCoercible(argument)
module.exports = function (it) {
  if (it == undefined) throw TypeError("Can't call method on  " + it);
  return it;
};


/***/ }),

/***/ 5883:
/***/ (function(module, exports, __webpack_require__) {

// false -> Array#indexOf
// true  -> Array#includes
var toIObject = __webpack_require__(5879);
var toLength = __webpack_require__(5884);
var toAbsoluteIndex = __webpack_require__(5886);
module.exports = function (IS_INCLUDES) {
  return function ($this, el, fromIndex) {
    var O = toIObject($this);
    var length = toLength(O.length);
    var index = toAbsoluteIndex(fromIndex, length);
    var value;
    // Array#includes uses SameValueZero equality algorithm
    // eslint-disable-next-line no-self-compare
    if (IS_INCLUDES && el != el) while (length > index) {
      value = O[index++];
      // eslint-disable-next-line no-self-compare
      if (value != value) return true;
    // Array#indexOf ignores holes, Array#includes - not
    } else for (;length > index; index++) if (IS_INCLUDES || index in O) {
      if (O[index] === el) return IS_INCLUDES || index || 0;
    } return !IS_INCLUDES && -1;
  };
};


/***/ }),

/***/ 5884:
/***/ (function(module, exports, __webpack_require__) {

// 7.1.15 ToLength
var toInteger = __webpack_require__(5885);
var min = Math.min;
module.exports = function (it) {
  return it > 0 ? min(toInteger(it), 0x1fffffffffffff) : 0; // pow(2, 53) - 1 == 9007199254740991
};


/***/ }),

/***/ 5885:
/***/ (function(module, exports) {

// 7.1.4 ToInteger
var ceil = Math.ceil;
var floor = Math.floor;
module.exports = function (it) {
  return isNaN(it = +it) ? 0 : (it > 0 ? floor : ceil)(it);
};


/***/ }),

/***/ 5886:
/***/ (function(module, exports, __webpack_require__) {

var toInteger = __webpack_require__(5885);
var max = Math.max;
var min = Math.min;
module.exports = function (index, length) {
  index = toInteger(index);
  return index < 0 ? max(index + length, 0) : min(index, length);
};


/***/ }),

/***/ 5887:
/***/ (function(module, exports, __webpack_require__) {

var shared = __webpack_require__(5888)('keys');
var uid = __webpack_require__(5890);
module.exports = function (key) {
  return shared[key] || (shared[key] = uid(key));
};


/***/ }),

/***/ 5888:
/***/ (function(module, exports, __webpack_require__) {

var core = __webpack_require__(5862);
var global = __webpack_require__(5861);
var SHARED = '__core-js_shared__';
var store = global[SHARED] || (global[SHARED] = {});

(module.exports = function (key, value) {
  return store[key] || (store[key] = value !== undefined ? value : {});
})('versions', []).push({
  version: core.version,
  mode: __webpack_require__(5889) ? 'pure' : 'global',
  copyright: '© 2019 Denis Pushkarev (zloirock.ru)'
});


/***/ }),

/***/ 5889:
/***/ (function(module, exports) {

module.exports = true;


/***/ }),

/***/ 5890:
/***/ (function(module, exports) {

var id = 0;
var px = Math.random();
module.exports = function (key) {
  return 'Symbol('.concat(key === undefined ? '' : key, ')_', (++id + px).toString(36));
};


/***/ }),

/***/ 5891:
/***/ (function(module, exports) {

// IE 8- don't enum bug keys
module.exports = (
  'constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf'
).split(',');


/***/ }),

/***/ 5892:
/***/ (function(module, exports) {

exports.f = Object.getOwnPropertySymbols;


/***/ }),

/***/ 5893:
/***/ (function(module, exports) {

exports.f = {}.propertyIsEnumerable;


/***/ }),

/***/ 5894:
/***/ (function(module, exports, __webpack_require__) {

// 7.1.13 ToObject(argument)
var defined = __webpack_require__(5882);
module.exports = function (it) {
  return Object(defined(it));
};


/***/ }),

/***/ 5895:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

exports.default = function (obj, keys) {
  var target = {};

  for (var i in obj) {
    if (keys.indexOf(i) >= 0) continue;
    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
    target[i] = obj[i];
  }

  return target;
};

/***/ }),

/***/ 5896:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.chromeLight = exports.chromeDark = undefined;

var _chromeDark2 = __webpack_require__(5897);

var _chromeDark3 = _interopRequireDefault(_chromeDark2);

var _chromeLight2 = __webpack_require__(5898);

var _chromeLight3 = _interopRequireDefault(_chromeLight2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.chromeDark = _chromeDark3.default;
exports.chromeLight = _chromeLight3.default;

/***/ }),

/***/ 5897:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var theme = {
  BASE_FONT_FAMILY: 'Menlo, monospace',
  BASE_FONT_SIZE: '11px',
  BASE_LINE_HEIGHT: '14px',

  BASE_BACKGROUND_COLOR: 'rgb(36, 36, 36)',
  BASE_COLOR: 'rgb(213, 213, 213)',

  OBJECT_NAME_COLOR: 'rgb(227, 110, 236)',
  OBJECT_VALUE_NULL_COLOR: 'rgb(127, 127, 127)',
  OBJECT_VALUE_UNDEFINED_COLOR: 'rgb(127, 127, 127)',
  OBJECT_VALUE_REGEXP_COLOR: 'rgb(233, 63, 59)',
  OBJECT_VALUE_STRING_COLOR: 'rgb(233, 63, 59)',
  OBJECT_VALUE_SYMBOL_COLOR: 'rgb(233, 63, 59)',
  OBJECT_VALUE_NUMBER_COLOR: 'hsl(252, 100%, 75%)',
  OBJECT_VALUE_BOOLEAN_COLOR: 'hsl(252, 100%, 75%)',
  OBJECT_VALUE_FUNCTION_KEYWORD_COLOR: 'rgb(242, 85, 217)',

  HTML_TAG_COLOR: 'rgb(93, 176, 215)',
  HTML_TAGNAME_COLOR: 'rgb(93, 176, 215)',
  HTML_TAGNAME_TEXT_TRANSFORM: 'lowercase',
  HTML_ATTRIBUTE_NAME_COLOR: 'rgb(155, 187, 220)',
  HTML_ATTRIBUTE_VALUE_COLOR: 'rgb(242, 151, 102)',
  HTML_COMMENT_COLOR: 'rgb(137, 137, 137)',
  HTML_DOCTYPE_COLOR: 'rgb(192, 192, 192)',

  ARROW_COLOR: 'rgb(145, 145, 145)',
  ARROW_MARGIN_RIGHT: 3,
  ARROW_FONT_SIZE: 12,

  TREENODE_FONT_FAMILY: 'Menlo, monospace',
  TREENODE_FONT_SIZE: '11px',
  TREENODE_LINE_HEIGHT: '14px',
  TREENODE_PADDING_LEFT: 12,

  TABLE_BORDER_COLOR: 'rgb(85, 85, 85)',
  TABLE_TH_BACKGROUND_COLOR: 'rgb(44, 44, 44)',
  TABLE_TH_HOVER_COLOR: 'rgb(48, 48, 48)',
  TABLE_SORT_ICON_COLOR: 'black', //'rgb(48, 57, 66)',
  TABLE_DATA_BACKGROUND_IMAGE: 'linear-gradient(rgba(255, 255, 255, 0), rgba(255, 255, 255, 0) 50%, rgba(51, 139, 255, 0.0980392) 50%, rgba(51, 139, 255, 0.0980392))',
  TABLE_DATA_BACKGROUND_SIZE: '128px 32px'
};

exports.default = theme;

/***/ }),

/***/ 5898:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var theme = {
  BASE_FONT_FAMILY: 'Menlo, monospace',
  BASE_FONT_SIZE: '11px',
  BASE_LINE_HEIGHT: '14px',

  BASE_BACKGROUND_COLOR: 'white',
  BASE_COLOR: 'black',

  OBJECT_NAME_COLOR: 'rgb(136, 19, 145)',
  OBJECT_VALUE_NULL_COLOR: 'rgb(128, 128, 128)',
  OBJECT_VALUE_UNDEFINED_COLOR: 'rgb(128, 128, 128)',
  OBJECT_VALUE_REGEXP_COLOR: 'rgb(196, 26, 22)',
  OBJECT_VALUE_STRING_COLOR: 'rgb(196, 26, 22)',
  OBJECT_VALUE_SYMBOL_COLOR: 'rgb(196, 26, 22)',
  OBJECT_VALUE_NUMBER_COLOR: 'rgb(28, 0, 207)',
  OBJECT_VALUE_BOOLEAN_COLOR: 'rgb(28, 0, 207)',
  OBJECT_VALUE_FUNCTION_KEYWORD_COLOR: 'rgb(170, 13, 145)',

  HTML_TAG_COLOR: 'rgb(168, 148, 166)',
  HTML_TAGNAME_COLOR: 'rgb(136, 18, 128)',
  HTML_TAGNAME_TEXT_TRANSFORM: 'lowercase',
  HTML_ATTRIBUTE_NAME_COLOR: 'rgb(153, 69, 0)',
  HTML_ATTRIBUTE_VALUE_COLOR: 'rgb(26, 26, 166)',
  HTML_COMMENT_COLOR: 'rgb(35, 110, 37)',
  HTML_DOCTYPE_COLOR: 'rgb(192, 192, 192)',

  ARROW_COLOR: '#6e6e6e',
  ARROW_MARGIN_RIGHT: 3,
  ARROW_FONT_SIZE: 12,

  TREENODE_FONT_FAMILY: 'Menlo, monospace',
  TREENODE_FONT_SIZE: '11px',
  TREENODE_LINE_HEIGHT: '14px',
  TREENODE_PADDING_LEFT: 12,

  TABLE_BORDER_COLOR: '#aaa',
  TABLE_TH_BACKGROUND_COLOR: '#eee',
  TABLE_TH_HOVER_COLOR: 'hsla(0, 0%, 90%, 1)',
  TABLE_SORT_ICON_COLOR: '#6e6e6e',
  TABLE_DATA_BACKGROUND_IMAGE: 'linear-gradient(to bottom, white, white 50%, rgb(234, 243, 255) 50%, rgb(234, 243, 255))',
  TABLE_DATA_BACKGROUND_SIZE: '128px 32px'
};

exports.default = theme;

/***/ }),

/***/ 5899:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = __webpack_require__(5895);

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = __webpack_require__(5900);

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = __webpack_require__(5901);

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = __webpack_require__(5905);

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = __webpack_require__(5939);

var _inherits3 = _interopRequireDefault(_inherits2);

var _regenerator = __webpack_require__(5947);

var _regenerator2 = _interopRequireDefault(_regenerator);

var _slicedToArray2 = __webpack_require__(5950);

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TreeView = __webpack_require__(5959);

var _TreeView2 = _interopRequireDefault(_TreeView);

var _ObjectRootLabel = __webpack_require__(5966);

var _ObjectRootLabel2 = _interopRequireDefault(_ObjectRootLabel);

var _ObjectLabel = __webpack_require__(5970);

var _ObjectLabel2 = _interopRequireDefault(_ObjectLabel);

var _ThemeProvider = __webpack_require__(5971);

var _ThemeProvider2 = _interopRequireDefault(_ThemeProvider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createIterator = function createIterator(showNonenumerable, sortObjectKeys) {
  var objectIterator = /*#__PURE__*/_regenerator2.default.mark(function objectIterator(data) {
    var shouldIterate, dataIsArray, i, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, entry, _entry, k, v, keys, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, propertyName, propertyValue, _propertyValue;

    return _regenerator2.default.wrap(function objectIterator$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            shouldIterate = (typeof data === 'undefined' ? 'undefined' : (0, _typeof3.default)(data)) === 'object' && data !== null || typeof data === 'function';

            if (shouldIterate) {
              _context.next = 3;
              break;
            }

            return _context.abrupt('return');

          case 3:
            dataIsArray = Array.isArray(data);

            // iterable objects (except arrays)

            if (!(!dataIsArray && data[Symbol.iterator])) {
              _context.next = 41;
              break;
            }

            i = 0;
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context.prev = 9;
            _iterator = data[Symbol.iterator]();

          case 11:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context.next = 25;
              break;
            }

            entry = _step.value;

            if (!(Array.isArray(entry) && entry.length === 2)) {
              _context.next = 19;
              break;
            }

            _entry = (0, _slicedToArray3.default)(entry, 2), k = _entry[0], v = _entry[1];
            _context.next = 17;
            return {
              name: k,
              data: v
            };

          case 17:
            _context.next = 21;
            break;

          case 19:
            _context.next = 21;
            return {
              name: i.toString(),
              data: entry
            };

          case 21:
            i++;

          case 22:
            _iteratorNormalCompletion = true;
            _context.next = 11;
            break;

          case 25:
            _context.next = 31;
            break;

          case 27:
            _context.prev = 27;
            _context.t0 = _context['catch'](9);
            _didIteratorError = true;
            _iteratorError = _context.t0;

          case 31:
            _context.prev = 31;
            _context.prev = 32;

            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }

          case 34:
            _context.prev = 34;

            if (!_didIteratorError) {
              _context.next = 37;
              break;
            }

            throw _iteratorError;

          case 37:
            return _context.finish(34);

          case 38:
            return _context.finish(31);

          case 39:
            _context.next = 82;
            break;

          case 41:
            keys = Object.getOwnPropertyNames(data);

            if (sortObjectKeys === true && !dataIsArray) {
              // Array keys should not be sorted in alphabetical order
              keys.sort();
            } else if (typeof sortObjectKeys === 'function') {
              keys.sort(sortObjectKeys);
            }

            _iteratorNormalCompletion2 = true;
            _didIteratorError2 = false;
            _iteratorError2 = undefined;
            _context.prev = 46;
            _iterator2 = keys[Symbol.iterator]();

          case 48:
            if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
              _context.next = 65;
              break;
            }

            propertyName = _step2.value;

            if (!data.propertyIsEnumerable(propertyName)) {
              _context.next = 56;
              break;
            }

            propertyValue = data[propertyName];
            _context.next = 54;
            return {
              name: propertyName || '""',
              data: propertyValue
            };

          case 54:
            _context.next = 62;
            break;

          case 56:
            if (!showNonenumerable) {
              _context.next = 62;
              break;
            }

            // To work around the error (happens some time when propertyName === 'caller' || propertyName === 'arguments')
            // 'caller' and 'arguments' are restricted function properties and cannot be accessed in this context
            // http://stackoverflow.com/questions/31921189/caller-and-arguments-are-restricted-function-properties-and-cannot-be-access
            _propertyValue = void 0;

            try {
              _propertyValue = data[propertyName];
            } catch (e) {
              // console.warn(e)
            }

            if (!(_propertyValue !== undefined)) {
              _context.next = 62;
              break;
            }

            _context.next = 62;
            return {
              name: propertyName,
              data: _propertyValue,
              isNonenumerable: true
            };

          case 62:
            _iteratorNormalCompletion2 = true;
            _context.next = 48;
            break;

          case 65:
            _context.next = 71;
            break;

          case 67:
            _context.prev = 67;
            _context.t1 = _context['catch'](46);
            _didIteratorError2 = true;
            _iteratorError2 = _context.t1;

          case 71:
            _context.prev = 71;
            _context.prev = 72;

            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }

          case 74:
            _context.prev = 74;

            if (!_didIteratorError2) {
              _context.next = 77;
              break;
            }

            throw _iteratorError2;

          case 77:
            return _context.finish(74);

          case 78:
            return _context.finish(71);

          case 79:
            if (!(showNonenumerable && data !== Object.prototype /* already added */)) {
              _context.next = 82;
              break;
            }

            _context.next = 82;
            return {
              name: '__proto__',
              data: Object.getPrototypeOf(data),
              isNonenumerable: true
            };

          case 82:
          case 'end':
            return _context.stop();
        }
      }
    }, objectIterator, this, [[9, 27, 31, 39], [32,, 34, 38], [46, 67, 71, 79], [72,, 74, 78]]);
  });

  return objectIterator;
};

var defaultNodeRenderer = function defaultNodeRenderer(_ref) {
  var depth = _ref.depth,
      name = _ref.name,
      data = _ref.data,
      isNonenumerable = _ref.isNonenumerable;
  return depth === 0 ? _react2.default.createElement(_ObjectRootLabel2.default, { name: name, data: data }) : _react2.default.createElement(_ObjectLabel2.default, { name: name, data: data, isNonenumerable: isNonenumerable });
};

/**
 * Tree-view for objects
 */

var ObjectInspector = function (_Component) {
  (0, _inherits3.default)(ObjectInspector, _Component);

  function ObjectInspector() {
    (0, _classCallCheck3.default)(this, ObjectInspector);
    return (0, _possibleConstructorReturn3.default)(this, (ObjectInspector.__proto__ || Object.getPrototypeOf(ObjectInspector)).apply(this, arguments));
  }

  (0, _createClass3.default)(ObjectInspector, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          showNonenumerable = _props.showNonenumerable,
          sortObjectKeys = _props.sortObjectKeys,
          nodeRenderer = _props.nodeRenderer,
          rest = (0, _objectWithoutProperties3.default)(_props, ['showNonenumerable', 'sortObjectKeys', 'nodeRenderer']);

      var dataIterator = createIterator(showNonenumerable, sortObjectKeys);

      var renderer = nodeRenderer ? nodeRenderer : defaultNodeRenderer;

      return _react2.default.createElement(
        _ThemeProvider2.default,
        { theme: this.props.theme },
        _react2.default.createElement(_TreeView2.default, (0, _extends3.default)({ nodeRenderer: renderer, dataIterator: dataIterator }, rest))
      );
    }
  }]);
  return ObjectInspector;
}(_react.Component);

ObjectInspector.defaultProps = {
  showNonenumerable: false,

  theme: 'chromeLight'
};
ObjectInspector.propTypes = {
  /** An integer specifying to which level the tree should be initially expanded. */
  expandLevel: _propTypes2.default.number,
  /** An array containing all the paths that should be expanded when the component is initialized, or a string of just one path */
  expandPaths: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.array]),

  name: _propTypes2.default.string,
  /** Not required prop because we also allow undefined value */
  data: _propTypes2.default.any,

  /** A known theme or theme object */
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]),

  /** Show non-enumerable properties */
  showNonenumerable: _propTypes2.default.bool,
  /** Sort object keys with optional compare function. */
  sortObjectKeys: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.func]),

  /** Provide a custom nodeRenderer */
  nodeRenderer: _propTypes2.default.func
};
exports.default = ObjectInspector;

/***/ }),

/***/ 5900:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

exports.default = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

/***/ }),

/***/ 5901:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _defineProperty = __webpack_require__(5902);

var _defineProperty2 = _interopRequireDefault(_defineProperty);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      (0, _defineProperty2.default)(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

/***/ }),

/***/ 5902:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5903), __esModule: true };

/***/ }),

/***/ 5903:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5904);
var $Object = __webpack_require__(5862).Object;
module.exports = function defineProperty(it, key, desc) {
  return $Object.defineProperty(it, key, desc);
};


/***/ }),

/***/ 5904:
/***/ (function(module, exports, __webpack_require__) {

var $export = __webpack_require__(5860);
// 19.1.2.4 / 15.2.3.6 Object.defineProperty(O, P, Attributes)
$export($export.S + $export.F * !__webpack_require__(5870), 'Object', { defineProperty: __webpack_require__(5866).f });


/***/ }),

/***/ 5905:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && ((typeof call === "undefined" ? "undefined" : (0, _typeof3.default)(call)) === "object" || typeof call === "function") ? call : self;
};

/***/ }),

/***/ 5906:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _iterator = __webpack_require__(5907);

var _iterator2 = _interopRequireDefault(_iterator);

var _symbol = __webpack_require__(5926);

var _symbol2 = _interopRequireDefault(_symbol);

var _typeof = typeof _symbol2.default === "function" && typeof _iterator2.default === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof _symbol2.default === "function" && obj.constructor === _symbol2.default && obj !== _symbol2.default.prototype ? "symbol" : typeof obj; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = typeof _symbol2.default === "function" && _typeof(_iterator2.default) === "symbol" ? function (obj) {
  return typeof obj === "undefined" ? "undefined" : _typeof(obj);
} : function (obj) {
  return obj && typeof _symbol2.default === "function" && obj.constructor === _symbol2.default && obj !== _symbol2.default.prototype ? "symbol" : typeof obj === "undefined" ? "undefined" : _typeof(obj);
};

/***/ }),

/***/ 5907:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5908), __esModule: true };

/***/ }),

/***/ 5908:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5909);
__webpack_require__(5921);
module.exports = __webpack_require__(5925).f('iterator');


/***/ }),

/***/ 5909:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var $at = __webpack_require__(5910)(true);

// 21.1.3.27 String.prototype[@@iterator]()
__webpack_require__(5911)(String, 'String', function (iterated) {
  this._t = String(iterated); // target
  this._i = 0;                // next index
// 21.1.5.2.1 %StringIteratorPrototype%.next()
}, function () {
  var O = this._t;
  var index = this._i;
  var point;
  if (index >= O.length) return { value: undefined, done: true };
  point = $at(O, index);
  this._i += point.length;
  return { value: point, done: false };
});


/***/ }),

/***/ 5910:
/***/ (function(module, exports, __webpack_require__) {

var toInteger = __webpack_require__(5885);
var defined = __webpack_require__(5882);
// true  -> String#at
// false -> String#codePointAt
module.exports = function (TO_STRING) {
  return function (that, pos) {
    var s = String(defined(that));
    var i = toInteger(pos);
    var l = s.length;
    var a, b;
    if (i < 0 || i >= l) return TO_STRING ? '' : undefined;
    a = s.charCodeAt(i);
    return a < 0xd800 || a > 0xdbff || i + 1 === l || (b = s.charCodeAt(i + 1)) < 0xdc00 || b > 0xdfff
      ? TO_STRING ? s.charAt(i) : a
      : TO_STRING ? s.slice(i, i + 2) : (a - 0xd800 << 10) + (b - 0xdc00) + 0x10000;
  };
};


/***/ }),

/***/ 5911:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var LIBRARY = __webpack_require__(5889);
var $export = __webpack_require__(5860);
var redefine = __webpack_require__(5912);
var hide = __webpack_require__(5865);
var Iterators = __webpack_require__(5913);
var $iterCreate = __webpack_require__(5914);
var setToStringTag = __webpack_require__(5918);
var getPrototypeOf = __webpack_require__(5920);
var ITERATOR = __webpack_require__(5919)('iterator');
var BUGGY = !([].keys && 'next' in [].keys()); // Safari has buggy iterators w/o `next`
var FF_ITERATOR = '@@iterator';
var KEYS = 'keys';
var VALUES = 'values';

var returnThis = function () { return this; };

module.exports = function (Base, NAME, Constructor, next, DEFAULT, IS_SET, FORCED) {
  $iterCreate(Constructor, NAME, next);
  var getMethod = function (kind) {
    if (!BUGGY && kind in proto) return proto[kind];
    switch (kind) {
      case KEYS: return function keys() { return new Constructor(this, kind); };
      case VALUES: return function values() { return new Constructor(this, kind); };
    } return function entries() { return new Constructor(this, kind); };
  };
  var TAG = NAME + ' Iterator';
  var DEF_VALUES = DEFAULT == VALUES;
  var VALUES_BUG = false;
  var proto = Base.prototype;
  var $native = proto[ITERATOR] || proto[FF_ITERATOR] || DEFAULT && proto[DEFAULT];
  var $default = $native || getMethod(DEFAULT);
  var $entries = DEFAULT ? !DEF_VALUES ? $default : getMethod('entries') : undefined;
  var $anyNative = NAME == 'Array' ? proto.entries || $native : $native;
  var methods, key, IteratorPrototype;
  // Fix native
  if ($anyNative) {
    IteratorPrototype = getPrototypeOf($anyNative.call(new Base()));
    if (IteratorPrototype !== Object.prototype && IteratorPrototype.next) {
      // Set @@toStringTag to native iterators
      setToStringTag(IteratorPrototype, TAG, true);
      // fix for some old engines
      if (!LIBRARY && typeof IteratorPrototype[ITERATOR] != 'function') hide(IteratorPrototype, ITERATOR, returnThis);
    }
  }
  // fix Array#{values, @@iterator}.name in V8 / FF
  if (DEF_VALUES && $native && $native.name !== VALUES) {
    VALUES_BUG = true;
    $default = function values() { return $native.call(this); };
  }
  // Define iterator
  if ((!LIBRARY || FORCED) && (BUGGY || VALUES_BUG || !proto[ITERATOR])) {
    hide(proto, ITERATOR, $default);
  }
  // Plug for library
  Iterators[NAME] = $default;
  Iterators[TAG] = returnThis;
  if (DEFAULT) {
    methods = {
      values: DEF_VALUES ? $default : getMethod(VALUES),
      keys: IS_SET ? $default : getMethod(KEYS),
      entries: $entries
    };
    if (FORCED) for (key in methods) {
      if (!(key in proto)) redefine(proto, key, methods[key]);
    } else $export($export.P + $export.F * (BUGGY || VALUES_BUG), NAME, methods);
  }
  return methods;
};


/***/ }),

/***/ 5912:
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(5865);


/***/ }),

/***/ 5913:
/***/ (function(module, exports) {

module.exports = {};


/***/ }),

/***/ 5914:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var create = __webpack_require__(5915);
var descriptor = __webpack_require__(5874);
var setToStringTag = __webpack_require__(5918);
var IteratorPrototype = {};

// 25.1.2.1.1 %IteratorPrototype%[@@iterator]()
__webpack_require__(5865)(IteratorPrototype, __webpack_require__(5919)('iterator'), function () { return this; });

module.exports = function (Constructor, NAME, next) {
  Constructor.prototype = create(IteratorPrototype, { next: descriptor(1, next) });
  setToStringTag(Constructor, NAME + ' Iterator');
};


/***/ }),

/***/ 5915:
/***/ (function(module, exports, __webpack_require__) {

// 19.1.2.2 / 15.2.3.5 Object.create(O [, Properties])
var anObject = __webpack_require__(5867);
var dPs = __webpack_require__(5916);
var enumBugKeys = __webpack_require__(5891);
var IE_PROTO = __webpack_require__(5887)('IE_PROTO');
var Empty = function () { /* empty */ };
var PROTOTYPE = 'prototype';

// Create object with fake `null` prototype: use iframe Object with cleared prototype
var createDict = function () {
  // Thrash, waste and sodomy: IE GC bug
  var iframe = __webpack_require__(5872)('iframe');
  var i = enumBugKeys.length;
  var lt = '<';
  var gt = '>';
  var iframeDocument;
  iframe.style.display = 'none';
  __webpack_require__(5917).appendChild(iframe);
  iframe.src = 'javascript:'; // eslint-disable-line no-script-url
  // createDict = iframe.contentWindow.Object;
  // html.removeChild(iframe);
  iframeDocument = iframe.contentWindow.document;
  iframeDocument.open();
  iframeDocument.write(lt + 'script' + gt + 'document.F=Object' + lt + '/script' + gt);
  iframeDocument.close();
  createDict = iframeDocument.F;
  while (i--) delete createDict[PROTOTYPE][enumBugKeys[i]];
  return createDict();
};

module.exports = Object.create || function create(O, Properties) {
  var result;
  if (O !== null) {
    Empty[PROTOTYPE] = anObject(O);
    result = new Empty();
    Empty[PROTOTYPE] = null;
    // add "__proto__" for Object.getPrototypeOf polyfill
    result[IE_PROTO] = O;
  } else result = createDict();
  return Properties === undefined ? result : dPs(result, Properties);
};


/***/ }),

/***/ 5916:
/***/ (function(module, exports, __webpack_require__) {

var dP = __webpack_require__(5866);
var anObject = __webpack_require__(5867);
var getKeys = __webpack_require__(5877);

module.exports = __webpack_require__(5870) ? Object.defineProperties : function defineProperties(O, Properties) {
  anObject(O);
  var keys = getKeys(Properties);
  var length = keys.length;
  var i = 0;
  var P;
  while (length > i) dP.f(O, P = keys[i++], Properties[P]);
  return O;
};


/***/ }),

/***/ 5917:
/***/ (function(module, exports, __webpack_require__) {

var document = __webpack_require__(5861).document;
module.exports = document && document.documentElement;


/***/ }),

/***/ 5918:
/***/ (function(module, exports, __webpack_require__) {

var def = __webpack_require__(5866).f;
var has = __webpack_require__(5875);
var TAG = __webpack_require__(5919)('toStringTag');

module.exports = function (it, tag, stat) {
  if (it && !has(it = stat ? it : it.prototype, TAG)) def(it, TAG, { configurable: true, value: tag });
};


/***/ }),

/***/ 5919:
/***/ (function(module, exports, __webpack_require__) {

var store = __webpack_require__(5888)('wks');
var uid = __webpack_require__(5890);
var Symbol = __webpack_require__(5861).Symbol;
var USE_SYMBOL = typeof Symbol == 'function';

var $exports = module.exports = function (name) {
  return store[name] || (store[name] =
    USE_SYMBOL && Symbol[name] || (USE_SYMBOL ? Symbol : uid)('Symbol.' + name));
};

$exports.store = store;


/***/ }),

/***/ 5920:
/***/ (function(module, exports, __webpack_require__) {

// 19.1.2.9 / 15.2.3.2 Object.getPrototypeOf(O)
var has = __webpack_require__(5875);
var toObject = __webpack_require__(5894);
var IE_PROTO = __webpack_require__(5887)('IE_PROTO');
var ObjectProto = Object.prototype;

module.exports = Object.getPrototypeOf || function (O) {
  O = toObject(O);
  if (has(O, IE_PROTO)) return O[IE_PROTO];
  if (typeof O.constructor == 'function' && O instanceof O.constructor) {
    return O.constructor.prototype;
  } return O instanceof Object ? ObjectProto : null;
};


/***/ }),

/***/ 5921:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5922);
var global = __webpack_require__(5861);
var hide = __webpack_require__(5865);
var Iterators = __webpack_require__(5913);
var TO_STRING_TAG = __webpack_require__(5919)('toStringTag');

var DOMIterables = ('CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,' +
  'DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,' +
  'MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,' +
  'SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,' +
  'TextTrackList,TouchList').split(',');

for (var i = 0; i < DOMIterables.length; i++) {
  var NAME = DOMIterables[i];
  var Collection = global[NAME];
  var proto = Collection && Collection.prototype;
  if (proto && !proto[TO_STRING_TAG]) hide(proto, TO_STRING_TAG, NAME);
  Iterators[NAME] = Iterators.Array;
}


/***/ }),

/***/ 5922:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var addToUnscopables = __webpack_require__(5923);
var step = __webpack_require__(5924);
var Iterators = __webpack_require__(5913);
var toIObject = __webpack_require__(5879);

// 22.1.3.4 Array.prototype.entries()
// 22.1.3.13 Array.prototype.keys()
// 22.1.3.29 Array.prototype.values()
// 22.1.3.30 Array.prototype[@@iterator]()
module.exports = __webpack_require__(5911)(Array, 'Array', function (iterated, kind) {
  this._t = toIObject(iterated); // target
  this._i = 0;                   // next index
  this._k = kind;                // kind
// 22.1.5.2.1 %ArrayIteratorPrototype%.next()
}, function () {
  var O = this._t;
  var kind = this._k;
  var index = this._i++;
  if (!O || index >= O.length) {
    this._t = undefined;
    return step(1);
  }
  if (kind == 'keys') return step(0, index);
  if (kind == 'values') return step(0, O[index]);
  return step(0, [index, O[index]]);
}, 'values');

// argumentsList[@@iterator] is %ArrayProto_values% (9.4.4.6, 9.4.4.7)
Iterators.Arguments = Iterators.Array;

addToUnscopables('keys');
addToUnscopables('values');
addToUnscopables('entries');


/***/ }),

/***/ 5923:
/***/ (function(module, exports) {

module.exports = function () { /* empty */ };


/***/ }),

/***/ 5924:
/***/ (function(module, exports) {

module.exports = function (done, value) {
  return { value: value, done: !!done };
};


/***/ }),

/***/ 5925:
/***/ (function(module, exports, __webpack_require__) {

exports.f = __webpack_require__(5919);


/***/ }),

/***/ 5926:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5927), __esModule: true };

/***/ }),

/***/ 5927:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5928);
__webpack_require__(5936);
__webpack_require__(5937);
__webpack_require__(5938);
module.exports = __webpack_require__(5862).Symbol;


/***/ }),

/***/ 5928:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

// ECMAScript 6 symbols shim
var global = __webpack_require__(5861);
var has = __webpack_require__(5875);
var DESCRIPTORS = __webpack_require__(5870);
var $export = __webpack_require__(5860);
var redefine = __webpack_require__(5912);
var META = __webpack_require__(5929).KEY;
var $fails = __webpack_require__(5871);
var shared = __webpack_require__(5888);
var setToStringTag = __webpack_require__(5918);
var uid = __webpack_require__(5890);
var wks = __webpack_require__(5919);
var wksExt = __webpack_require__(5925);
var wksDefine = __webpack_require__(5930);
var enumKeys = __webpack_require__(5931);
var isArray = __webpack_require__(5932);
var anObject = __webpack_require__(5867);
var isObject = __webpack_require__(5868);
var toObject = __webpack_require__(5894);
var toIObject = __webpack_require__(5879);
var toPrimitive = __webpack_require__(5873);
var createDesc = __webpack_require__(5874);
var _create = __webpack_require__(5915);
var gOPNExt = __webpack_require__(5933);
var $GOPD = __webpack_require__(5935);
var $GOPS = __webpack_require__(5892);
var $DP = __webpack_require__(5866);
var $keys = __webpack_require__(5877);
var gOPD = $GOPD.f;
var dP = $DP.f;
var gOPN = gOPNExt.f;
var $Symbol = global.Symbol;
var $JSON = global.JSON;
var _stringify = $JSON && $JSON.stringify;
var PROTOTYPE = 'prototype';
var HIDDEN = wks('_hidden');
var TO_PRIMITIVE = wks('toPrimitive');
var isEnum = {}.propertyIsEnumerable;
var SymbolRegistry = shared('symbol-registry');
var AllSymbols = shared('symbols');
var OPSymbols = shared('op-symbols');
var ObjectProto = Object[PROTOTYPE];
var USE_NATIVE = typeof $Symbol == 'function' && !!$GOPS.f;
var QObject = global.QObject;
// Don't use setters in Qt Script, https://github.com/zloirock/core-js/issues/173
var setter = !QObject || !QObject[PROTOTYPE] || !QObject[PROTOTYPE].findChild;

// fallback for old Android, https://code.google.com/p/v8/issues/detail?id=687
var setSymbolDesc = DESCRIPTORS && $fails(function () {
  return _create(dP({}, 'a', {
    get: function () { return dP(this, 'a', { value: 7 }).a; }
  })).a != 7;
}) ? function (it, key, D) {
  var protoDesc = gOPD(ObjectProto, key);
  if (protoDesc) delete ObjectProto[key];
  dP(it, key, D);
  if (protoDesc && it !== ObjectProto) dP(ObjectProto, key, protoDesc);
} : dP;

var wrap = function (tag) {
  var sym = AllSymbols[tag] = _create($Symbol[PROTOTYPE]);
  sym._k = tag;
  return sym;
};

var isSymbol = USE_NATIVE && typeof $Symbol.iterator == 'symbol' ? function (it) {
  return typeof it == 'symbol';
} : function (it) {
  return it instanceof $Symbol;
};

var $defineProperty = function defineProperty(it, key, D) {
  if (it === ObjectProto) $defineProperty(OPSymbols, key, D);
  anObject(it);
  key = toPrimitive(key, true);
  anObject(D);
  if (has(AllSymbols, key)) {
    if (!D.enumerable) {
      if (!has(it, HIDDEN)) dP(it, HIDDEN, createDesc(1, {}));
      it[HIDDEN][key] = true;
    } else {
      if (has(it, HIDDEN) && it[HIDDEN][key]) it[HIDDEN][key] = false;
      D = _create(D, { enumerable: createDesc(0, false) });
    } return setSymbolDesc(it, key, D);
  } return dP(it, key, D);
};
var $defineProperties = function defineProperties(it, P) {
  anObject(it);
  var keys = enumKeys(P = toIObject(P));
  var i = 0;
  var l = keys.length;
  var key;
  while (l > i) $defineProperty(it, key = keys[i++], P[key]);
  return it;
};
var $create = function create(it, P) {
  return P === undefined ? _create(it) : $defineProperties(_create(it), P);
};
var $propertyIsEnumerable = function propertyIsEnumerable(key) {
  var E = isEnum.call(this, key = toPrimitive(key, true));
  if (this === ObjectProto && has(AllSymbols, key) && !has(OPSymbols, key)) return false;
  return E || !has(this, key) || !has(AllSymbols, key) || has(this, HIDDEN) && this[HIDDEN][key] ? E : true;
};
var $getOwnPropertyDescriptor = function getOwnPropertyDescriptor(it, key) {
  it = toIObject(it);
  key = toPrimitive(key, true);
  if (it === ObjectProto && has(AllSymbols, key) && !has(OPSymbols, key)) return;
  var D = gOPD(it, key);
  if (D && has(AllSymbols, key) && !(has(it, HIDDEN) && it[HIDDEN][key])) D.enumerable = true;
  return D;
};
var $getOwnPropertyNames = function getOwnPropertyNames(it) {
  var names = gOPN(toIObject(it));
  var result = [];
  var i = 0;
  var key;
  while (names.length > i) {
    if (!has(AllSymbols, key = names[i++]) && key != HIDDEN && key != META) result.push(key);
  } return result;
};
var $getOwnPropertySymbols = function getOwnPropertySymbols(it) {
  var IS_OP = it === ObjectProto;
  var names = gOPN(IS_OP ? OPSymbols : toIObject(it));
  var result = [];
  var i = 0;
  var key;
  while (names.length > i) {
    if (has(AllSymbols, key = names[i++]) && (IS_OP ? has(ObjectProto, key) : true)) result.push(AllSymbols[key]);
  } return result;
};

// 19.4.1.1 Symbol([description])
if (!USE_NATIVE) {
  $Symbol = function Symbol() {
    if (this instanceof $Symbol) throw TypeError('Symbol is not a constructor!');
    var tag = uid(arguments.length > 0 ? arguments[0] : undefined);
    var $set = function (value) {
      if (this === ObjectProto) $set.call(OPSymbols, value);
      if (has(this, HIDDEN) && has(this[HIDDEN], tag)) this[HIDDEN][tag] = false;
      setSymbolDesc(this, tag, createDesc(1, value));
    };
    if (DESCRIPTORS && setter) setSymbolDesc(ObjectProto, tag, { configurable: true, set: $set });
    return wrap(tag);
  };
  redefine($Symbol[PROTOTYPE], 'toString', function toString() {
    return this._k;
  });

  $GOPD.f = $getOwnPropertyDescriptor;
  $DP.f = $defineProperty;
  __webpack_require__(5934).f = gOPNExt.f = $getOwnPropertyNames;
  __webpack_require__(5893).f = $propertyIsEnumerable;
  $GOPS.f = $getOwnPropertySymbols;

  if (DESCRIPTORS && !__webpack_require__(5889)) {
    redefine(ObjectProto, 'propertyIsEnumerable', $propertyIsEnumerable, true);
  }

  wksExt.f = function (name) {
    return wrap(wks(name));
  };
}

$export($export.G + $export.W + $export.F * !USE_NATIVE, { Symbol: $Symbol });

for (var es6Symbols = (
  // 19.4.2.2, 19.4.2.3, 19.4.2.4, 19.4.2.6, 19.4.2.8, 19.4.2.9, 19.4.2.10, 19.4.2.11, 19.4.2.12, 19.4.2.13, 19.4.2.14
  'hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables'
).split(','), j = 0; es6Symbols.length > j;)wks(es6Symbols[j++]);

for (var wellKnownSymbols = $keys(wks.store), k = 0; wellKnownSymbols.length > k;) wksDefine(wellKnownSymbols[k++]);

$export($export.S + $export.F * !USE_NATIVE, 'Symbol', {
  // 19.4.2.1 Symbol.for(key)
  'for': function (key) {
    return has(SymbolRegistry, key += '')
      ? SymbolRegistry[key]
      : SymbolRegistry[key] = $Symbol(key);
  },
  // 19.4.2.5 Symbol.keyFor(sym)
  keyFor: function keyFor(sym) {
    if (!isSymbol(sym)) throw TypeError(sym + ' is not a symbol!');
    for (var key in SymbolRegistry) if (SymbolRegistry[key] === sym) return key;
  },
  useSetter: function () { setter = true; },
  useSimple: function () { setter = false; }
});

$export($export.S + $export.F * !USE_NATIVE, 'Object', {
  // 19.1.2.2 Object.create(O [, Properties])
  create: $create,
  // 19.1.2.4 Object.defineProperty(O, P, Attributes)
  defineProperty: $defineProperty,
  // 19.1.2.3 Object.defineProperties(O, Properties)
  defineProperties: $defineProperties,
  // 19.1.2.6 Object.getOwnPropertyDescriptor(O, P)
  getOwnPropertyDescriptor: $getOwnPropertyDescriptor,
  // 19.1.2.7 Object.getOwnPropertyNames(O)
  getOwnPropertyNames: $getOwnPropertyNames,
  // 19.1.2.8 Object.getOwnPropertySymbols(O)
  getOwnPropertySymbols: $getOwnPropertySymbols
});

// Chrome 38 and 39 `Object.getOwnPropertySymbols` fails on primitives
// https://bugs.chromium.org/p/v8/issues/detail?id=3443
var FAILS_ON_PRIMITIVES = $fails(function () { $GOPS.f(1); });

$export($export.S + $export.F * FAILS_ON_PRIMITIVES, 'Object', {
  getOwnPropertySymbols: function getOwnPropertySymbols(it) {
    return $GOPS.f(toObject(it));
  }
});

// 24.3.2 JSON.stringify(value [, replacer [, space]])
$JSON && $export($export.S + $export.F * (!USE_NATIVE || $fails(function () {
  var S = $Symbol();
  // MS Edge converts symbol values to JSON as {}
  // WebKit converts symbol values to JSON as null
  // V8 throws on boxed symbols
  return _stringify([S]) != '[null]' || _stringify({ a: S }) != '{}' || _stringify(Object(S)) != '{}';
})), 'JSON', {
  stringify: function stringify(it) {
    var args = [it];
    var i = 1;
    var replacer, $replacer;
    while (arguments.length > i) args.push(arguments[i++]);
    $replacer = replacer = args[1];
    if (!isObject(replacer) && it === undefined || isSymbol(it)) return; // IE8 returns string on undefined
    if (!isArray(replacer)) replacer = function (key, value) {
      if (typeof $replacer == 'function') value = $replacer.call(this, key, value);
      if (!isSymbol(value)) return value;
    };
    args[1] = replacer;
    return _stringify.apply($JSON, args);
  }
});

// 19.4.3.4 Symbol.prototype[@@toPrimitive](hint)
$Symbol[PROTOTYPE][TO_PRIMITIVE] || __webpack_require__(5865)($Symbol[PROTOTYPE], TO_PRIMITIVE, $Symbol[PROTOTYPE].valueOf);
// 19.4.3.5 Symbol.prototype[@@toStringTag]
setToStringTag($Symbol, 'Symbol');
// 20.2.1.9 Math[@@toStringTag]
setToStringTag(Math, 'Math', true);
// 24.3.3 JSON[@@toStringTag]
setToStringTag(global.JSON, 'JSON', true);


/***/ }),

/***/ 5929:
/***/ (function(module, exports, __webpack_require__) {

var META = __webpack_require__(5890)('meta');
var isObject = __webpack_require__(5868);
var has = __webpack_require__(5875);
var setDesc = __webpack_require__(5866).f;
var id = 0;
var isExtensible = Object.isExtensible || function () {
  return true;
};
var FREEZE = !__webpack_require__(5871)(function () {
  return isExtensible(Object.preventExtensions({}));
});
var setMeta = function (it) {
  setDesc(it, META, { value: {
    i: 'O' + ++id, // object ID
    w: {}          // weak collections IDs
  } });
};
var fastKey = function (it, create) {
  // return primitive with prefix
  if (!isObject(it)) return typeof it == 'symbol' ? it : (typeof it == 'string' ? 'S' : 'P') + it;
  if (!has(it, META)) {
    // can't set metadata to uncaught frozen object
    if (!isExtensible(it)) return 'F';
    // not necessary to add metadata
    if (!create) return 'E';
    // add missing metadata
    setMeta(it);
  // return object ID
  } return it[META].i;
};
var getWeak = function (it, create) {
  if (!has(it, META)) {
    // can't set metadata to uncaught frozen object
    if (!isExtensible(it)) return true;
    // not necessary to add metadata
    if (!create) return false;
    // add missing metadata
    setMeta(it);
  // return hash weak collections IDs
  } return it[META].w;
};
// add metadata on freeze-family methods calling
var onFreeze = function (it) {
  if (FREEZE && meta.NEED && isExtensible(it) && !has(it, META)) setMeta(it);
  return it;
};
var meta = module.exports = {
  KEY: META,
  NEED: false,
  fastKey: fastKey,
  getWeak: getWeak,
  onFreeze: onFreeze
};


/***/ }),

/***/ 5930:
/***/ (function(module, exports, __webpack_require__) {

var global = __webpack_require__(5861);
var core = __webpack_require__(5862);
var LIBRARY = __webpack_require__(5889);
var wksExt = __webpack_require__(5925);
var defineProperty = __webpack_require__(5866).f;
module.exports = function (name) {
  var $Symbol = core.Symbol || (core.Symbol = LIBRARY ? {} : global.Symbol || {});
  if (name.charAt(0) != '_' && !(name in $Symbol)) defineProperty($Symbol, name, { value: wksExt.f(name) });
};


/***/ }),

/***/ 5931:
/***/ (function(module, exports, __webpack_require__) {

// all enumerable object keys, includes symbols
var getKeys = __webpack_require__(5877);
var gOPS = __webpack_require__(5892);
var pIE = __webpack_require__(5893);
module.exports = function (it) {
  var result = getKeys(it);
  var getSymbols = gOPS.f;
  if (getSymbols) {
    var symbols = getSymbols(it);
    var isEnum = pIE.f;
    var i = 0;
    var key;
    while (symbols.length > i) if (isEnum.call(it, key = symbols[i++])) result.push(key);
  } return result;
};


/***/ }),

/***/ 5932:
/***/ (function(module, exports, __webpack_require__) {

// 7.2.2 IsArray(argument)
var cof = __webpack_require__(5881);
module.exports = Array.isArray || function isArray(arg) {
  return cof(arg) == 'Array';
};


/***/ }),

/***/ 5933:
/***/ (function(module, exports, __webpack_require__) {

// fallback for IE11 buggy Object.getOwnPropertyNames with iframe and window
var toIObject = __webpack_require__(5879);
var gOPN = __webpack_require__(5934).f;
var toString = {}.toString;

var windowNames = typeof window == 'object' && window && Object.getOwnPropertyNames
  ? Object.getOwnPropertyNames(window) : [];

var getWindowNames = function (it) {
  try {
    return gOPN(it);
  } catch (e) {
    return windowNames.slice();
  }
};

module.exports.f = function getOwnPropertyNames(it) {
  return windowNames && toString.call(it) == '[object Window]' ? getWindowNames(it) : gOPN(toIObject(it));
};


/***/ }),

/***/ 5934:
/***/ (function(module, exports, __webpack_require__) {

// 19.1.2.7 / 15.2.3.4 Object.getOwnPropertyNames(O)
var $keys = __webpack_require__(5878);
var hiddenKeys = __webpack_require__(5891).concat('length', 'prototype');

exports.f = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
  return $keys(O, hiddenKeys);
};


/***/ }),

/***/ 5935:
/***/ (function(module, exports, __webpack_require__) {

var pIE = __webpack_require__(5893);
var createDesc = __webpack_require__(5874);
var toIObject = __webpack_require__(5879);
var toPrimitive = __webpack_require__(5873);
var has = __webpack_require__(5875);
var IE8_DOM_DEFINE = __webpack_require__(5869);
var gOPD = Object.getOwnPropertyDescriptor;

exports.f = __webpack_require__(5870) ? gOPD : function getOwnPropertyDescriptor(O, P) {
  O = toIObject(O);
  P = toPrimitive(P, true);
  if (IE8_DOM_DEFINE) try {
    return gOPD(O, P);
  } catch (e) { /* empty */ }
  if (has(O, P)) return createDesc(!pIE.f.call(O, P), O[P]);
};


/***/ }),

/***/ 5936:
/***/ (function(module, exports) {



/***/ }),

/***/ 5937:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5930)('asyncIterator');


/***/ }),

/***/ 5938:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5930)('observable');


/***/ }),

/***/ 5939:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _setPrototypeOf = __webpack_require__(5940);

var _setPrototypeOf2 = _interopRequireDefault(_setPrototypeOf);

var _create = __webpack_require__(5944);

var _create2 = _interopRequireDefault(_create);

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + (typeof superClass === "undefined" ? "undefined" : (0, _typeof3.default)(superClass)));
  }

  subClass.prototype = (0, _create2.default)(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf2.default ? (0, _setPrototypeOf2.default)(subClass, superClass) : subClass.__proto__ = superClass;
};

/***/ }),

/***/ 5940:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5941), __esModule: true };

/***/ }),

/***/ 5941:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5942);
module.exports = __webpack_require__(5862).Object.setPrototypeOf;


/***/ }),

/***/ 5942:
/***/ (function(module, exports, __webpack_require__) {

// 19.1.3.19 Object.setPrototypeOf(O, proto)
var $export = __webpack_require__(5860);
$export($export.S, 'Object', { setPrototypeOf: __webpack_require__(5943).set });


/***/ }),

/***/ 5943:
/***/ (function(module, exports, __webpack_require__) {

// Works with __proto__ only. Old v8 can't work with null proto objects.
/* eslint-disable no-proto */
var isObject = __webpack_require__(5868);
var anObject = __webpack_require__(5867);
var check = function (O, proto) {
  anObject(O);
  if (!isObject(proto) && proto !== null) throw TypeError(proto + ": can't set as prototype!");
};
module.exports = {
  set: Object.setPrototypeOf || ('__proto__' in {} ? // eslint-disable-line
    function (test, buggy, set) {
      try {
        set = __webpack_require__(5863)(Function.call, __webpack_require__(5935).f(Object.prototype, '__proto__').set, 2);
        set(test, []);
        buggy = !(test instanceof Array);
      } catch (e) { buggy = true; }
      return function setPrototypeOf(O, proto) {
        check(O, proto);
        if (buggy) O.__proto__ = proto;
        else set(O, proto);
        return O;
      };
    }({}, false) : undefined),
  check: check
};


/***/ }),

/***/ 5944:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5945), __esModule: true };

/***/ }),

/***/ 5945:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5946);
var $Object = __webpack_require__(5862).Object;
module.exports = function create(P, D) {
  return $Object.create(P, D);
};


/***/ }),

/***/ 5946:
/***/ (function(module, exports, __webpack_require__) {

var $export = __webpack_require__(5860);
// 19.1.2.2 / 15.2.3.5 Object.create(O [, Properties])
$export($export.S, 'Object', { create: __webpack_require__(5915) });


/***/ }),

/***/ 5947:
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(5948);


/***/ }),

/***/ 5948:
/***/ (function(module, exports, __webpack_require__) {

/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

// This method of obtaining a reference to the global object needs to be
// kept identical to the way it is obtained in runtime.js
var g = (function() { return this })() || Function("return this")();

// Use `getOwnPropertyNames` because not all browsers support calling
// `hasOwnProperty` on the global `self` object in a worker. See #183.
var hadRuntime = g.regeneratorRuntime &&
  Object.getOwnPropertyNames(g).indexOf("regeneratorRuntime") >= 0;

// Save the old regeneratorRuntime in case it needs to be restored later.
var oldRuntime = hadRuntime && g.regeneratorRuntime;

// Force reevalutation of runtime.js.
g.regeneratorRuntime = undefined;

module.exports = __webpack_require__(5949);

if (hadRuntime) {
  // Restore the original runtime.
  g.regeneratorRuntime = oldRuntime;
} else {
  // Remove the global property added by runtime.js.
  try {
    delete g.regeneratorRuntime;
  } catch(e) {
    g.regeneratorRuntime = undefined;
  }
}


/***/ }),

/***/ 5949:
/***/ (function(module, exports) {

/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

!(function(global) {
  "use strict";

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  var inModule = typeof module === "object";
  var runtime = global.regeneratorRuntime;
  if (runtime) {
    if (inModule) {
      // If regeneratorRuntime is defined globally and we're in a module,
      // make the exports object identical to regeneratorRuntime.
      module.exports = runtime;
    }
    // Don't bother evaluating the rest of this file if the runtime was
    // already defined globally.
    return;
  }

  // Define the runtime globally (as expected by generated code) as either
  // module.exports (if we're in a module) or a new, empty object.
  runtime = global.regeneratorRuntime = inModule ? module.exports : {};

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  runtime.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunctionPrototype[toStringTagSymbol] =
    GeneratorFunction.displayName = "GeneratorFunction";

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      prototype[method] = function(arg) {
        return this._invoke(method, arg);
      };
    });
  }

  runtime.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  runtime.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      if (!(toStringTagSymbol in genFun)) {
        genFun[toStringTagSymbol] = "GeneratorFunction";
      }
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  runtime.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return Promise.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return Promise.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration. If the Promise is rejected, however, the
          // result for this iteration will be rejected with the same
          // reason. Note that rejections of yielded Promises are not
          // thrown back into the generator function, as is the case
          // when an awaited Promise is rejected. This difference in
          // behavior between yield and await is important, because it
          // allows the consumer to decide what to do with the yielded
          // rejection (swallow it and continue, manually .throw it back
          // into the generator, abandon iteration, whatever). With
          // await, by contrast, there is no opportunity to examine the
          // rejection reason outside the generator function, so the
          // only option is to throw it from the await expression, and
          // let the generator function handle the exception.
          result.value = unwrapped;
          resolve(result);
        }, reject);
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new Promise(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };
  runtime.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  runtime.async = function(innerFn, outerFn, self, tryLocsList) {
    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList)
    );

    return runtime.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        if (delegate.iterator.return) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  Gp[toStringTagSymbol] = "Generator";

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  Gp[iteratorSymbol] = function() {
    return this;
  };

  Gp.toString = function() {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  runtime.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  runtime.values = values;

  function doneResult() {
    return { value: undefined, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined;
      }

      return ContinueSentinel;
    }
  };
})(
  // In sloppy mode, unbound `this` refers to the global object, fallback to
  // Function constructor if we're in global strict mode. That is sadly a form
  // of indirect eval which violates Content Security Policy.
  (function() { return this })() || Function("return this")()
);


/***/ }),

/***/ 5950:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _isIterable2 = __webpack_require__(5951);

var _isIterable3 = _interopRequireDefault(_isIterable2);

var _getIterator2 = __webpack_require__(5955);

var _getIterator3 = _interopRequireDefault(_getIterator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = (0, _getIterator3.default)(arr), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if ((0, _isIterable3.default)(Object(arr))) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

/***/ }),

/***/ 5951:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5952), __esModule: true };

/***/ }),

/***/ 5952:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5921);
__webpack_require__(5909);
module.exports = __webpack_require__(5953);


/***/ }),

/***/ 5953:
/***/ (function(module, exports, __webpack_require__) {

var classof = __webpack_require__(5954);
var ITERATOR = __webpack_require__(5919)('iterator');
var Iterators = __webpack_require__(5913);
module.exports = __webpack_require__(5862).isIterable = function (it) {
  var O = Object(it);
  return O[ITERATOR] !== undefined
    || '@@iterator' in O
    // eslint-disable-next-line no-prototype-builtins
    || Iterators.hasOwnProperty(classof(O));
};


/***/ }),

/***/ 5954:
/***/ (function(module, exports, __webpack_require__) {

// getting tag from 19.1.3.6 Object.prototype.toString()
var cof = __webpack_require__(5881);
var TAG = __webpack_require__(5919)('toStringTag');
// ES3 wrong here
var ARG = cof(function () { return arguments; }()) == 'Arguments';

// fallback for IE11 Script Access Denied error
var tryGet = function (it, key) {
  try {
    return it[key];
  } catch (e) { /* empty */ }
};

module.exports = function (it) {
  var O, T, B;
  return it === undefined ? 'Undefined' : it === null ? 'Null'
    // @@toStringTag case
    : typeof (T = tryGet(O = Object(it), TAG)) == 'string' ? T
    // builtinTag case
    : ARG ? cof(O)
    // ES3 arguments fallback
    : (B = cof(O)) == 'Object' && typeof O.callee == 'function' ? 'Arguments' : B;
};


/***/ }),

/***/ 5955:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5956), __esModule: true };

/***/ }),

/***/ 5956:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5921);
__webpack_require__(5909);
module.exports = __webpack_require__(5957);


/***/ }),

/***/ 5957:
/***/ (function(module, exports, __webpack_require__) {

var anObject = __webpack_require__(5867);
var get = __webpack_require__(5958);
module.exports = __webpack_require__(5862).getIterator = function (it) {
  var iterFn = get(it);
  if (typeof iterFn != 'function') throw TypeError(it + ' is not iterable!');
  return anObject(iterFn.call(it));
};


/***/ }),

/***/ 5958:
/***/ (function(module, exports, __webpack_require__) {

var classof = __webpack_require__(5954);
var ITERATOR = __webpack_require__(5919)('iterator');
var Iterators = __webpack_require__(5913);
module.exports = __webpack_require__(5862).getIteratorMethod = function (it) {
  if (it != undefined) return it[ITERATOR]
    || it['@@iterator']
    || Iterators[classof(it)];
};


/***/ }),

/***/ 5959:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = __webpack_require__(5895);

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = __webpack_require__(5900);

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = __webpack_require__(5901);

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = __webpack_require__(5905);

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = __webpack_require__(5939);

var _inherits3 = _interopRequireDefault(_inherits2);

var _defineProperty2 = __webpack_require__(5960);

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TreeNode = __webpack_require__(5961);

var _TreeNode2 = _interopRequireDefault(_TreeNode);

var _pathUtils = __webpack_require__(5965);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var reducer = function reducer(state, action) {
  switch (action.type) {
    case 'TOGGLE_EXPAND':
      {
        var path = action.path;
        var expandedPaths = state.expandedPaths;
        var expanded = !!expandedPaths[path];

        return Object.assign({}, state, {
          expandedPaths: Object.assign({}, state.expandedPaths, (0, _defineProperty3.default)({}, path, !expanded))
        });
      }
    default:
      return state;
  }
};

var ConnectedTreeNode = function (_Component) {
  (0, _inherits3.default)(ConnectedTreeNode, _Component);

  function ConnectedTreeNode(props, context) {
    (0, _classCallCheck3.default)(this, ConnectedTreeNode);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ConnectedTreeNode.__proto__ || Object.getPrototypeOf(ConnectedTreeNode)).call(this, props));

    _this.state = context.store.storeState;
    return _this;
  }

  (0, _createClass3.default)(ConnectedTreeNode, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !!nextState.expandedPaths[nextProps.path] !== !!this.state.expandedPaths[this.props.path] || nextProps.data !== this.props.data || nextProps.name !== this.props.name;
    }
  }, {
    key: 'handleClick',
    value: function handleClick(path) {
      this.context.store.storeState = reducer(this.context.store.storeState, {
        type: 'TOGGLE_EXPAND',
        path: path
      });
      this.setState(this.context.store.storeState);
    }
  }, {
    key: 'renderChildNodes',
    value: function renderChildNodes(parentData, parentPath) {
      var dataIterator = this.props.dataIterator;
      var depth = this.props.depth;
      var nodeRenderer = this.props.nodeRenderer;


      var childNodes = [];
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = dataIterator(parentData)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _ref2 = _step.value;
          var name = _ref2.name,
              data = _ref2.data,
              props = (0, _objectWithoutProperties3.default)(_ref2, ['name', 'data']);

          var key = name;
          var path = parentPath + '.' + key;
          childNodes.push(_react2.default.createElement(ConnectedTreeNode, (0, _extends3.default)({
            name: name,
            data: data,
            depth: depth + 1,
            path: path,
            key: key,
            dataIterator: dataIterator,
            nodeRenderer: nodeRenderer
          }, props)) // props for nodeRenderer
          );
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return childNodes;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          data = _props.data,
          dataIterator = _props.dataIterator,
          path = _props.path,
          depth = _props.depth;


      var nodeHasChildNodes = (0, _pathUtils.hasChildNodes)(data, dataIterator);
      var expandedPaths = this.state.expandedPaths;

      var expanded = !!expandedPaths[path];

      var nodeRenderer = this.props.nodeRenderer;


      return _react2.default.createElement(
        _TreeNode2.default,
        (0, _extends3.default)({
          expanded: expanded,
          onClick: nodeHasChildNodes ? this.handleClick.bind(this, path) : function () {}
          // show arrow anyway even if not expanded and not rendering children
          , shouldShowArrow: nodeHasChildNodes
          // show placeholder only for non root nodes
          , shouldShowPlaceholder: depth > 0
          // Render a node from name and data (or possibly other props like isNonenumerable)
          , nodeRenderer: nodeRenderer
        }, this.props),
        // only render if the node is expanded
        expanded ? this.renderChildNodes(data, path) : undefined
      );
    }
  }]);
  return ConnectedTreeNode;
}(_react.Component);

ConnectedTreeNode.propTypes = {
  name: _propTypes2.default.string,
  data: _propTypes2.default.any,
  dataIterator: _propTypes2.default.func,

  depth: _propTypes2.default.number,
  expanded: _propTypes2.default.bool,

  nodeRenderer: _propTypes2.default.func
};

ConnectedTreeNode.contextTypes = {
  store: _propTypes2.default.any
};

var TreeView = function (_Component2) {
  (0, _inherits3.default)(TreeView, _Component2);

  function TreeView(props) {
    (0, _classCallCheck3.default)(this, TreeView);

    var _this2 = (0, _possibleConstructorReturn3.default)(this, (TreeView.__proto__ || Object.getPrototypeOf(TreeView)).call(this, props));

    _this2.store = {
      storeState: {
        expandedPaths: (0, _pathUtils.getExpandedPaths)(props.data, props.dataIterator, props.expandPaths, props.expandLevel)
      }
    };
    return _this2;
  }

  (0, _createClass3.default)(TreeView, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.store = {
        storeState: {
          expandedPaths: (0, _pathUtils.getExpandedPaths)(nextProps.data, nextProps.dataIterator, nextProps.expandPaths, nextProps.expandLevel, this.store.storeState.expandedPaths)
        }
      };
    }
  }, {
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        store: this.store
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          name = _props2.name,
          data = _props2.data,
          dataIterator = _props2.dataIterator;
      var nodeRenderer = this.props.nodeRenderer;


      var rootPath = _pathUtils.DEFAULT_ROOT_PATH;

      return _react2.default.createElement(ConnectedTreeNode, {
        name: name,
        data: data,
        dataIterator: dataIterator,
        depth: 0,
        path: rootPath,
        nodeRenderer: nodeRenderer
      });
    }
  }]);
  return TreeView;
}(_react.Component);

TreeView.defaultProps = {
  expandLevel: 0,
  expandPaths: []
};
TreeView.childContextTypes = {
  store: _propTypes2.default.any
};


TreeView.propTypes = {
  name: _propTypes2.default.string,
  data: _propTypes2.default.any,
  dataIterator: _propTypes2.default.func,

  nodeRenderer: _propTypes2.default.func
};

TreeView.defaultProps = {
  name: undefined
};

exports.default = TreeView;

/***/ }),

/***/ 5960:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _defineProperty = __webpack_require__(5902);

var _defineProperty2 = _interopRequireDefault(_defineProperty);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (obj, key, value) {
  if (key in obj) {
    (0, _defineProperty2.default)(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

/***/ }),

/***/ 5961:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = __webpack_require__(5900);

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = __webpack_require__(5901);

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = __webpack_require__(5905);

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = __webpack_require__(5939);

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createStyles = __webpack_require__(5962);

var _createStyles2 = _interopRequireDefault(_createStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Arrow = function Arrow(_ref) {
  var expanded = _ref.expanded,
      styles = _ref.styles;
  return _react2.default.createElement(
    'span',
    { style: (0, _extends3.default)({}, styles.base, expanded ? styles.expanded : styles.collapsed) },
    '\u25B6'
  );
};

var TreeNode = function (_Component) {
  (0, _inherits3.default)(TreeNode, _Component);

  function TreeNode() {
    (0, _classCallCheck3.default)(this, TreeNode);
    return (0, _possibleConstructorReturn3.default)(this, (TreeNode.__proto__ || Object.getPrototypeOf(TreeNode)).apply(this, arguments));
  }

  (0, _createClass3.default)(TreeNode, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          expanded = _props.expanded,
          onClick = _props.onClick,
          children = _props.children,
          nodeRenderer = _props.nodeRenderer,
          title = _props.title,
          shouldShowArrow = _props.shouldShowArrow,
          shouldShowPlaceholder = _props.shouldShowPlaceholder;
      var theme = this.context.theme;

      var styles = (0, _createStyles2.default)('TreeNode', theme);

      var renderedNode = (0, _react.createElement)(nodeRenderer, this.props);
      var childNodes = expanded ? children : undefined;

      return _react2.default.createElement(
        'li',
        { 'aria-expanded': expanded, role: 'treeitem', style: styles.treeNodeBase, title: title },
        _react2.default.createElement(
          'div',
          { style: styles.treeNodePreviewContainer, onClick: onClick },
          shouldShowArrow || _react.Children.count(children) > 0 ? _react2.default.createElement(Arrow, { expanded: expanded, styles: styles.treeNodeArrow }) : shouldShowPlaceholder && _react2.default.createElement(
            'span',
            { style: styles.treeNodePlaceholder },
            '\xA0'
          ),
          renderedNode
        ),
        _react2.default.createElement(
          'ol',
          { role: 'group', style: styles.treeNodeChildNodesContainer },
          childNodes
        )
      );
    }
  }]);
  return TreeNode;
}(_react.Component);

TreeNode.propTypes = {
  name: _propTypes2.default.string,
  data: _propTypes2.default.any,

  expanded: _propTypes2.default.bool,
  shouldShowArrow: _propTypes2.default.bool,
  shouldShowPlaceholder: _propTypes2.default.bool,

  nodeRenderer: _propTypes2.default.func,

  onClick: _propTypes2.default.func
};

TreeNode.defaultProps = {
  name: undefined,
  data: undefined,
  expanded: true,

  nodeRenderer: function nodeRenderer(_ref2) {
    var name = _ref2.name;
    return _react2.default.createElement(
      'span',
      null,
      name
    );
  },

  onClick: function onClick() {},

  shouldShowArrow: false,
  shouldShowPlaceholder: true
};

TreeNode.contextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]).isRequired
};

exports.default = TreeNode;

/***/ }),

/***/ 5962:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

var _themes = __webpack_require__(5896);

var themes = _interopRequireWildcard(_themes);

var _base = __webpack_require__(5963);

var _base2 = _interopRequireDefault(_base);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = Object.keys(themes).reduce(function (styles, themeName) {
  styles[themeName] = (0, _base2.default)(themes[themeName]);
  return styles;
}, {});

var createStyles = function createStyles(key, theme) {
  // console.debug(styles, theme, styles[theme])
  if (typeof theme === 'string') {
    return styles[theme][key];
  } else if ((typeof theme === 'undefined' ? 'undefined' : (0, _typeof3.default)(theme)) === 'object') {
    return (0, _base2.default)(theme)[key];
  }
  // Default styles
  return styles['chromeLight'][key];
};

exports.default = createStyles;

/***/ }),

/***/ 5963:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _unselectable = __webpack_require__(5964);

var _unselectable2 = _interopRequireDefault(_unselectable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (theme) {
  return {
    DOMNodePreview: {
      htmlOpenTag: {
        base: {
          color: theme.HTML_TAG_COLOR
        },
        tagName: {
          color: theme.HTML_TAGNAME_COLOR,
          textTransform: theme.HTML_TAGNAME_TEXT_TRANSFORM
        },
        htmlAttributeName: {
          color: theme.HTML_ATTRIBUTE_NAME_COLOR
        },
        htmlAttributeValue: {
          color: theme.HTML_ATTRIBUTE_VALUE_COLOR
        }
      },
      htmlCloseTag: {
        base: {
          color: theme.HTML_TAG_COLOR
        },
        offsetLeft: {
          /* hack: offset placeholder */
          marginLeft: -theme.TREENODE_PADDING_LEFT
        },
        tagName: {
          color: theme.HTML_TAGNAME_COLOR,
          textTransform: theme.HTML_TAGNAME_TEXT_TRANSFORM
        }
      },
      htmlComment: {
        color: theme.HTML_COMMENT_COLOR
      },
      htmlDoctype: {
        color: theme.HTML_DOCTYPE_COLOR
      }
    },

    ObjectName: {
      base: {
        color: theme.OBJECT_NAME_COLOR
      },
      dimmed: {
        opacity: 0.6
      }
    },

    ObjectValue: {
      objectValueNull: {
        color: theme.OBJECT_VALUE_NULL_COLOR
      },
      objectValueUndefined: {
        color: theme.OBJECT_VALUE_UNDEFINED_COLOR
      },
      objectValueRegExp: {
        color: theme.OBJECT_VALUE_REGEXP_COLOR
      },
      objectValueString: {
        color: theme.OBJECT_VALUE_STRING_COLOR
      },
      objectValueSymbol: {
        color: theme.OBJECT_VALUE_SYMBOL_COLOR
      },
      objectValueNumber: {
        color: theme.OBJECT_VALUE_NUMBER_COLOR
      },
      objectValueBoolean: {
        color: theme.OBJECT_VALUE_BOOLEAN_COLOR
      },
      objectValueFunctionKeyword: {
        color: theme.OBJECT_VALUE_FUNCTION_KEYWORD_COLOR,
        fontStyle: 'italic'
      },
      objectValueFunctionName: {
        fontStyle: 'italic'
      }
    },

    TreeNode: {
      treeNodeBase: {
        color: theme.BASE_COLOR,
        backgroundColor: theme.BASE_BACKGROUND_COLOR,

        lineHeight: theme.TREENODE_LINE_HEIGHT,
        cursor: 'default',

        boxSizing: 'border-box',
        listStyle: 'none',

        fontFamily: theme.TREENODE_FONT_FAMILY,
        fontSize: theme.TREENODE_FONT_SIZE
      },
      treeNodePreviewContainer: {},
      treeNodePlaceholder: (0, _extends3.default)({
        whiteSpace: 'pre',

        fontSize: theme.ARROW_FONT_SIZE,
        marginRight: theme.ARROW_MARGIN_RIGHT
      }, _unselectable2.default),
      treeNodeArrow: {
        base: (0, _extends3.default)({
          color: theme.ARROW_COLOR,
          display: 'inline-block',
          // lineHeight: '14px',
          fontSize: theme.ARROW_FONT_SIZE,
          marginRight: theme.ARROW_MARGIN_RIGHT
        }, _unselectable2.default),
        expanded: {
          WebkitTransform: 'rotateZ(90deg)',
          MozTransform: 'rotateZ(90deg)',
          transform: 'rotateZ(90deg)'
        },
        collapsed: {
          WebkitTransform: 'rotateZ(0deg)',
          MozTransform: 'rotateZ(0deg)',
          transform: 'rotateZ(0deg)'
        }
      },
      treeNodeChildNodesContainer: {
        margin: 0, // reset user-agent style
        paddingLeft: theme.TREENODE_PADDING_LEFT
      }
    },

    TableInspector: {
      base: {
        color: theme.BASE_COLOR,

        position: 'relative',
        border: '1px solid ' + theme.TABLE_BORDER_COLOR,
        fontFamily: theme.BASE_FONT_FAMILY,
        fontSize: theme.BASE_FONT_SIZE,
        lineHeight: '120%',
        boxSizing: 'border-box',
        cursor: 'default'
      }
    },

    TableInspectorHeaderContainer: {
      base: {
        top: 0,
        height: '17px',
        left: 0,
        right: 0,
        overflowX: 'hidden'
      },
      table: {
        tableLayout: 'fixed',
        borderSpacing: 0,
        borderCollapse: 'separate',
        height: '100%',
        width: '100%',
        margin: 0
      }
    },

    TableInspectorDataContainer: {
      tr: {
        display: 'table-row'
      },
      td: {
        boxSizing: 'border-box',
        border: 'none', // prevent overrides
        height: '16px', // /* 0.5 * table.background-size height */
        verticalAlign: 'top',
        padding: '1px 4px',
        WebkitUserSelect: 'text',

        whiteSpace: 'nowrap',
        textOverflow: 'ellipsis',
        overflow: 'hidden',
        lineHeight: '14px'
      },
      div: {
        position: 'static',
        top: '17px',
        bottom: 0,
        overflowY: 'overlay',
        transform: 'translateZ(0)',

        left: 0,
        right: 0,
        overflowX: 'hidden'
      },
      table: {
        positon: 'static',
        left: 0,
        top: 0,
        right: 0,
        bottom: 0,
        borderTop: '0 none transparent',
        margin: 0, // prevent user agent stylesheet overrides

        backgroundImage: theme.TABLE_DATA_BACKGROUND_IMAGE,
        backgroundSize: theme.TABLE_DATA_BACKGROUND_SIZE,
        tableLayout: 'fixed',

        // table
        borderSpacing: 0,
        borderCollapse: 'separate',
        // height: '100%',
        width: '100%',

        fontSize: theme.BASE_FONT_SIZE,
        lineHeight: '120%'
      }
    },

    TableInspectorTH: {
      base: {
        position: 'relative', // anchor for sort icon container
        height: 'auto',
        textAlign: 'left',
        backgroundColor: theme.TABLE_TH_BACKGROUND_COLOR,
        borderBottom: '1px solid ' + theme.TABLE_BORDER_COLOR,
        fontWeight: 'normal',
        verticalAlign: 'middle',
        padding: '0 4px',

        whiteSpace: 'nowrap',
        textOverflow: 'ellipsis',
        overflow: 'hidden',
        lineHeight: '14px',

        ':hover': {
          backgroundColor: theme.TABLE_TH_HOVER_COLOR
        }
      },
      div: {
        whiteSpace: 'nowrap',
        textOverflow: 'ellipsis',
        overflow: 'hidden',

        // prevent user agent stylesheet overrides
        fontSize: theme.BASE_FONT_SIZE,
        lineHeight: '120%'
      }
    },

    TableInspectorLeftBorder: {
      none: {
        borderLeft: 'none'
      },
      solid: {
        borderLeft: '1px solid ' + theme.TABLE_BORDER_COLOR
      }
    },

    TableInspectorSortIcon: (0, _extends3.default)({
      display: 'block',
      marginRight: 3, // 4,
      width: 8,
      height: 7,

      marginTop: -7,
      color: theme.TABLE_SORT_ICON_COLOR,
      fontSize: 12
    }, _unselectable2.default)
  };
};

/***/ }),

/***/ 5964:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = {
  WebkitTouchCallout: 'none',
  WebkitUserSelect: 'none',
  KhtmlUserSelect: 'none',
  MozUserSelect: 'none',
  msUserSelect: 'none',
  OUserSelect: 'none',
  userSelect: 'none'
};

/***/ }),

/***/ 5965:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hasChildNodes = hasChildNodes;
var DEFAULT_ROOT_PATH = exports.DEFAULT_ROOT_PATH = '$';

var WILDCARD = '*';

function hasChildNodes(data, dataIterator) {
  return !dataIterator(data).next().done;
}

var wildcardPathsFromLevel = exports.wildcardPathsFromLevel = function wildcardPathsFromLevel(level) {
  // i is depth
  return Array.from({ length: level }, function (_, i) {
    return [DEFAULT_ROOT_PATH].concat(Array.from({ length: i }, function () {
      return '*';
    })).join('.');
  });
};

var getExpandedPaths = exports.getExpandedPaths = function getExpandedPaths(data, dataIterator, expandPaths, expandLevel) {
  var initialState = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};

  var wildcardPaths = [].concat(wildcardPathsFromLevel(expandLevel)).concat(expandPaths).filter(function (path) {
    return typeof path === 'string';
  }); // could be undefined

  var expandedPaths = [];
  wildcardPaths.forEach(function (wildcardPath) {
    var keyPaths = wildcardPath.split('.');
    var populatePaths = function populatePaths(curData, curPath, depth) {
      if (depth === keyPaths.length) {
        expandedPaths.push(curPath);
        return;
      }
      var key = keyPaths[depth];
      if (depth === 0) {
        if (hasChildNodes(curData, dataIterator) && (key === DEFAULT_ROOT_PATH || key === WILDCARD)) {
          populatePaths(curData, DEFAULT_ROOT_PATH, depth + 1);
        }
      } else {
        if (key === WILDCARD) {
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = dataIterator(curData)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var _ref2 = _step.value;
              var name = _ref2.name,
                  _data = _ref2.data;

              if (hasChildNodes(_data, dataIterator)) {
                populatePaths(_data, curPath + '.' + name, depth + 1);
              }
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }
        } else {
          var value = curData[key];
          if (hasChildNodes(value, dataIterator)) {
            populatePaths(value, curPath + '.' + key, depth + 1);
          }
        }
      }
    };

    populatePaths(data, '', 0);
  });

  return expandedPaths.reduce(function (obj, path) {
    obj[path] = true;
    return obj;
  }, initialState);
};

/***/ }),

/***/ 5966:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _ObjectName = __webpack_require__(5967);

var _ObjectName2 = _interopRequireDefault(_ObjectName);

var _ObjectPreview = __webpack_require__(5968);

var _ObjectPreview2 = _interopRequireDefault(_ObjectPreview);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ObjectRootLabel = function ObjectRootLabel(_ref) {
  var name = _ref.name,
      data = _ref.data;

  if (typeof name === 'string') {
    return _react2.default.createElement(
      'span',
      null,
      _react2.default.createElement(_ObjectName2.default, { name: name }),
      _react2.default.createElement(
        'span',
        null,
        ': '
      ),
      _react2.default.createElement(_ObjectPreview2.default, { data: data })
    );
  } else {
    return _react2.default.createElement(_ObjectPreview2.default, { data: data });
  }
};

exports.default = ObjectRootLabel;

/***/ }),

/***/ 5967:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createStyles = __webpack_require__(5962);

var _createStyles2 = _interopRequireDefault(_createStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A view for object property names.
 *
 * If the property name is enumerable (in Object.keys(object)),
 * the property name will be rendered normally.
 *
 * If the property name is not enumerable (`Object.prototype.propertyIsEnumerable()`),
 * the property name will be dimmed to show the difference.
 */
var ObjectName = function ObjectName(_ref, _ref2) {
  var name = _ref.name,
      dimmed = _ref.dimmed,
      styles = _ref.styles;
  var theme = _ref2.theme;

  var themeStyles = (0, _createStyles2.default)('ObjectName', theme);
  var appliedStyles = (0, _extends3.default)({}, themeStyles.base, dimmed ? themeStyles['dimmed'] : {}, styles);

  return _react2.default.createElement(
    'span',
    { style: appliedStyles },
    name
  );
};

ObjectName.propTypes = {
  /** Property name */
  name: _propTypes2.default.string,
  /** Should property name be dimmed */
  dimmed: _propTypes2.default.bool
};

ObjectName.defaultProps = {
  dimmed: false
};

ObjectName.contextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object])
};

exports.default = ObjectName;

/***/ }),

/***/ 5968:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ObjectValue = __webpack_require__(5969);

var _ObjectValue2 = _interopRequireDefault(_ObjectValue);

var _ObjectName = __webpack_require__(5967);

var _ObjectName2 = _interopRequireDefault(_ObjectName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* NOTE: Chrome console.log is italic */
var styles = {
  preview: {
    fontStyle: 'italic'
  }
};

/* intersperse arr with separator */
function intersperse(arr, sep) {
  if (arr.length === 0) {
    return [];
  }

  return arr.slice(1).reduce(function (xs, x) {
    return xs.concat([sep, x]);
  }, [arr[0]]);
}

/**
 * A preview of the object
 */
var ObjectPreview = function ObjectPreview(_ref) {
  var data = _ref.data,
      maxProperties = _ref.maxProperties;

  var object = data;

  if ((typeof object === 'undefined' ? 'undefined' : (0, _typeof3.default)(object)) !== 'object' || object === null || object instanceof Date || object instanceof RegExp) {
    return _react2.default.createElement(_ObjectValue2.default, { object: object });
  }

  if (Array.isArray(object)) {
    return _react2.default.createElement(
      'span',
      { style: styles.preview },
      '[',
      intersperse(object.map(function (element, index) {
        return _react2.default.createElement(_ObjectValue2.default, { key: index, object: element });
      }), ', '),
      ']'
    );
  } else {
    var propertyNodes = [];
    for (var propertyName in object) {
      var propertyValue = object[propertyName];
      if (object.hasOwnProperty(propertyName)) {
        var ellipsis = void 0;
        if (propertyNodes.length === maxProperties - 1 && Object.keys(object).length > maxProperties) {
          ellipsis = _react2.default.createElement(
            'span',
            { key: 'ellipsis' },
            '\u2026'
          );
        }
        propertyNodes.push(_react2.default.createElement(
          'span',
          { key: propertyName },
          _react2.default.createElement(_ObjectName2.default, { name: propertyName || '""' }),
          ':\xA0',
          _react2.default.createElement(_ObjectValue2.default, { object: propertyValue }),
          ellipsis
        ));
        if (ellipsis) break;
      }
    }

    return _react2.default.createElement(
      'span',
      { style: styles.preview },
      object.constructor.name + ' {',
      intersperse(propertyNodes, ', '),
      '}'
    );
  }
};

ObjectPreview.propTypes = {
  /**
   * max number of properties shown in the property view
   */
  maxProperties: _propTypes2.default.number
};
ObjectPreview.defaultProps = {
  maxProperties: 5
};

exports.default = ObjectPreview;

/***/ }),

/***/ 5969:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createStyles = __webpack_require__(5962);

var _createStyles2 = _interopRequireDefault(_createStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A short description of the object values.
 * Can be used to render tree node in ObjectInspector
 * or render objects in TableInspector.
 */
var ObjectValue = function ObjectValue(_ref, _ref2) {
  var object = _ref.object,
      styles = _ref.styles;
  var theme = _ref2.theme;

  var themeStyles = (0, _createStyles2.default)('ObjectValue', theme);

  var mkStyle = function mkStyle(key) {
    return (0, _extends3.default)({}, themeStyles[key], styles);
  };

  switch (typeof object === 'undefined' ? 'undefined' : (0, _typeof3.default)(object)) {
    case 'number':
      return _react2.default.createElement(
        'span',
        { style: mkStyle('objectValueNumber') },
        String(object)
      );
    case 'string':
      return _react2.default.createElement(
        'span',
        { style: mkStyle('objectValueString') },
        '"',
        object,
        '"'
      );
    case 'boolean':
      return _react2.default.createElement(
        'span',
        { style: mkStyle('objectValueBoolean') },
        String(object)
      );
    case 'undefined':
      return _react2.default.createElement(
        'span',
        { style: mkStyle('objectValueUndefined') },
        'undefined'
      );
    case 'object':
      if (object === null) {
        return _react2.default.createElement(
          'span',
          { style: mkStyle('objectValueNull') },
          'null'
        );
      }
      if (object instanceof Date) {
        return _react2.default.createElement(
          'span',
          null,
          object.toString()
        );
      }
      if (object instanceof RegExp) {
        return _react2.default.createElement(
          'span',
          { style: mkStyle('objectValueRegExp') },
          object.toString()
        );
      }
      if (Array.isArray(object)) {
        return _react2.default.createElement(
          'span',
          null,
          'Array[' + object.length + ']'
        );
      }
      if (!object.constructor) {
        return _react2.default.createElement(
          'span',
          null,
          'Object'
        );
      }
      if (typeof object.constructor.isBuffer === 'function' && object.constructor.isBuffer(object)) {
        return _react2.default.createElement(
          'span',
          null,
          'Buffer[' + object.length + ']'
        );
      }

      return _react2.default.createElement(
        'span',
        null,
        object.constructor.name
      );
    case 'function':
      return _react2.default.createElement(
        'span',
        null,
        _react2.default.createElement(
          'span',
          { style: mkStyle('objectValueFunctionKeyword') },
          'function'
        ),
        _react2.default.createElement(
          'span',
          { style: mkStyle('objectValueFunctionName') },
          '\xA0',
          object.name,
          '()'
        )
      );
    case 'symbol':
      return _react2.default.createElement(
        'span',
        { style: mkStyle('objectValueSymbol') },
        object.toString()
      );
    default:
      return _react2.default.createElement('span', null);
  }
};

ObjectValue.propTypes = {
  /** the object to describe */
  object: _propTypes2.default.any
};

ObjectValue.contextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object])
};

exports.default = ObjectValue;

/***/ }),

/***/ 5970:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ObjectName = __webpack_require__(5967);

var _ObjectName2 = _interopRequireDefault(_ObjectName);

var _ObjectValue = __webpack_require__(5969);

var _ObjectValue2 = _interopRequireDefault(_ObjectValue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * if isNonenumerable is specified, render the name dimmed
 */
var ObjectLabel = function ObjectLabel(_ref) {
  var name = _ref.name,
      data = _ref.data,
      isNonenumerable = _ref.isNonenumerable;

  var object = data;

  return _react2.default.createElement(
    'span',
    null,
    _react2.default.createElement(_ObjectName2.default, { name: name, dimmed: isNonenumerable }),
    _react2.default.createElement(
      'span',
      null,
      ': '
    ),
    _react2.default.createElement(_ObjectValue2.default, { object: object })
  );
};

ObjectLabel.propTypes = {
  /** Non enumerable object property will be dimmed */
  isNonenumerable: _propTypes2.default.bool
};

ObjectLabel.defaultProps = {
  isNonenumerable: false
};

exports.default = ObjectLabel;

/***/ }),

/***/ 5971:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = __webpack_require__(5900);

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = __webpack_require__(5901);

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = __webpack_require__(5905);

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = __webpack_require__(5939);

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = __webpack_require__(2);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ThemeProvider = function (_Component) {
  (0, _inherits3.default)(ThemeProvider, _Component);

  function ThemeProvider() {
    (0, _classCallCheck3.default)(this, ThemeProvider);
    return (0, _possibleConstructorReturn3.default)(this, (ThemeProvider.__proto__ || Object.getPrototypeOf(ThemeProvider)).apply(this, arguments));
  }

  (0, _createClass3.default)(ThemeProvider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      var theme = this.props.theme;

      return {
        // createStyles: createStyles
        theme: theme
      };
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children;
    }
  }]);
  return ThemeProvider;
}(_react.Component);

ThemeProvider.childContextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object])
};

exports.default = ThemeProvider;

/***/ }),

/***/ 5972:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

var _classCallCheck2 = __webpack_require__(5900);

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = __webpack_require__(5901);

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = __webpack_require__(5905);

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = __webpack_require__(5939);

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ThemeProvider = __webpack_require__(5971);

var _ThemeProvider2 = _interopRequireDefault(_ThemeProvider);

var _createStyles = __webpack_require__(5962);

var _createStyles2 = _interopRequireDefault(_createStyles);

var _getHeaders2 = __webpack_require__(5973);

var _getHeaders3 = _interopRequireDefault(_getHeaders2);

var _DataContainer = __webpack_require__(5982);

var _DataContainer2 = _interopRequireDefault(_DataContainer);

var _HeaderContainer = __webpack_require__(5983);

var _HeaderContainer2 = _interopRequireDefault(_HeaderContainer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TableInspector = function (_Component) {
  (0, _inherits3.default)(TableInspector, _Component);

  function TableInspector(props) {
    (0, _classCallCheck3.default)(this, TableInspector);

    var _this = (0, _possibleConstructorReturn3.default)(this, (TableInspector.__proto__ || Object.getPrototypeOf(TableInspector)).call(this, props));

    _this.state = {
      sorted: false, // has user ever clicked the <th> tag to sort?
      sortIndexColumn: false, // is index column sorted?
      sortColumn: undefined, // which column is sorted?
      sortAscending: false // is sorting ascending or descending?
    };
    return _this;
  }

  (0, _createClass3.default)(TableInspector, [{
    key: 'handleIndexTHClick',
    value: function handleIndexTHClick() {
      this.setState(function (_ref) {
        var sortIndexColumn = _ref.sortIndexColumn,
            sortAscending = _ref.sortAscending;
        return {
          sorted: true,
          sortIndexColumn: true,
          sortColumn: undefined,
          // when changed to a new column, default to asending
          sortAscending: sortIndexColumn ? !sortAscending : true
        };
      });
    }
  }, {
    key: 'handleTHClick',
    value: function handleTHClick(col) {
      this.setState(function (_ref2) {
        var sortColumn = _ref2.sortColumn,
            sortAscending = _ref2.sortAscending;
        return {
          sorted: true,
          sortIndexColumn: false,
          // update sort column
          sortColumn: col,
          // when changed to a new column, default to asending
          sortAscending: col === sortColumn ? !sortAscending : true
        };
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var data = this.props.data;
      var columns = this.props.columns;

      var theme = this.props.theme;

      var styles = (0, _createStyles2.default)('TableInspector', theme);

      if ((typeof data === 'undefined' ? 'undefined' : (0, _typeof3.default)(data)) !== 'object' || data === null) {
        return _react2.default.createElement('div', null);
      }

      var _getHeaders = (0, _getHeaders3.default)(data),
          rowHeaders = _getHeaders.rowHeaders,
          colHeaders = _getHeaders.colHeaders;

      // columns to be displayed are specified
      // NOTE: there's some space for optimization here


      if (columns !== undefined) {
        colHeaders = columns;
      }

      var rowsData = rowHeaders.map(function (rowHeader) {
        return data[rowHeader];
      });

      var sortIndexColumn = this.state.sortIndexColumn,
          sortColumn = this.state.sortColumn,
          sortAscending = this.state.sortAscending;

      var columnDataWithRowIndexes = void 0; /* row indexes are [0..nRows-1] */
      // TODO: refactor
      if (sortColumn !== undefined) {
        // the column to be sorted (rowsData, column) => [[columnData, rowIndex]]
        columnDataWithRowIndexes = rowsData.map(function (rowData, index) {
          // normalize rowData
          if ((typeof rowData === 'undefined' ? 'undefined' : (0, _typeof3.default)(rowData)) === 'object' && rowData !== null /*&& rowData.hasOwnProperty(sortColumn)*/
          ) {
              var columnData = rowData[sortColumn];
              return [columnData, index];
            }
          return [undefined, index];
        });
      } else {
        if (sortIndexColumn) {
          columnDataWithRowIndexes = rowHeaders.map(function (rowData, index) {
            var columnData = rowHeaders[index];
            return [columnData, index];
          });
        }
      }
      if (columnDataWithRowIndexes !== undefined) {
        // apply a mapper before sorting (because we need to access inside a container)
        var comparator = function comparator(mapper, ascending) {
          return function (a, b) {
            var v1 = mapper(a); // the datum
            var v2 = mapper(b);
            var type1 = typeof v1 === 'undefined' ? 'undefined' : (0, _typeof3.default)(v1);
            var type2 = typeof v2 === 'undefined' ? 'undefined' : (0, _typeof3.default)(v2);
            // use '<' operator to compare same type of values or compare type precedence order #
            var lt = function lt(v1, v2) {
              if (v1 < v2) {
                return -1;
              } else if (v1 > v2) {
                return 1;
              } else {
                return 0;
              }
            };
            var result = void 0;
            if (type1 === type2) {
              result = lt(v1, v2);
            } else {
              // order of different types
              var order = {
                string: 0,
                number: 1,
                object: 2,
                symbol: 3,
                boolean: 4,
                undefined: 5,
                function: 6
              };
              result = lt(order[type1], order[type2]);
            }
            // reverse result if descending
            if (!ascending) result = -result;
            return result;
          };
        };
        var sortedRowIndexes = columnDataWithRowIndexes.sort(comparator(function (item) {
          return item[0];
        }, sortAscending)).map(function (item) {
          return item[1];
        }); // sorted row indexes
        rowHeaders = sortedRowIndexes.map(function (i) {
          return rowHeaders[i];
        });
        rowsData = sortedRowIndexes.map(function (i) {
          return rowsData[i];
        });
      }

      return _react2.default.createElement(
        _ThemeProvider2.default,
        { theme: this.props.theme },
        _react2.default.createElement(
          'div',
          { style: styles.base },
          _react2.default.createElement(_HeaderContainer2.default, {
            columns: colHeaders
            /* for sorting */
            , sorted: this.state.sorted,
            sortIndexColumn: this.state.sortIndexColumn,
            sortColumn: this.state.sortColumn,
            sortAscending: this.state.sortAscending,
            onTHClick: this.handleTHClick.bind(this),
            onIndexTHClick: this.handleIndexTHClick.bind(this)
          }),
          _react2.default.createElement(_DataContainer2.default, { rows: rowHeaders, columns: colHeaders, rowsData: rowsData })
        )
      );
    }
  }]);
  return TableInspector;
}(_react.Component); /**
                      * Specs:
                      * https://developer.chrome.com/devtools/docs/commandline-api#tabledata-columns
                      * https://developer.mozilla.org/en-US/docs/Web/API/Console/table
                      */

exports.default = TableInspector;


TableInspector.propTypes = {
  /**
   * the Javascript object you would like to inspect, either an array or an object
   */
  data: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.object]),
  /**
   * An array of the names of the columns you'd like to display in the table
   */
  columns: _propTypes2.default.array
};

TableInspector.defaultProps = {
  data: undefined,
  columns: undefined,
  theme: 'chromeLight'
};

/***/ }),

/***/ 5973:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = __webpack_require__(5974);

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

exports.default = getHeaders;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Polyfill for running tests
 * `includes` is an ES2016 feature
 */
if (!Array.prototype.includes) {
  Array.prototype.includes = function (searchElement /*, fromIndex*/) {
    var O = Object(this);
    var len = parseInt(O.length) || 0;
    if (len === 0) {
      return false;
    }
    var n = parseInt(arguments[1]) || 0;
    var k;
    if (n >= 0) {
      k = n;
    } else {
      k = len + n;
      if (k < 0) {
        k = 0;
      }
    }
    var currentElement;
    while (k < len) {
      currentElement = O[k];
      if (searchElement === currentElement || searchElement !== searchElement && currentElement !== currentElement) {
        // NaN !== NaN
        return true;
      }
      k++;
    }
    return false;
  };
}

function getHeaders(data) {
  if ((typeof data === 'undefined' ? 'undefined' : (0, _typeof3.default)(data)) === 'object') {
    var rowHeaders = void 0;
    // is an array
    if (Array.isArray(data)) {
      var nRows = data.length;
      rowHeaders = [].concat((0, _toConsumableArray3.default)(Array(nRows).keys()));
    } else if (data !== null) {
      // is an object
      // keys are row indexes
      rowHeaders = Object.keys(data);
    }

    // Time: O(nRows * nCols)
    var colHeaders = rowHeaders.reduce(function (colHeaders, rowHeader) {
      var row = data[rowHeader];
      if ((typeof row === 'undefined' ? 'undefined' : (0, _typeof3.default)(row)) === 'object' && row !== null) {
        /* O(nCols) Could optimize `includes` here */
        var cols = Object.keys(row);
        cols.reduce(function (xs, x) {
          if (!xs.includes(x)) {
            /* xs is the colHeaders to be filled by searching the row's indexes */
            xs.push(x);
          }
          return xs;
        }, colHeaders);
      }
      return colHeaders;
    }, []);
    return {
      rowHeaders: rowHeaders,
      colHeaders: colHeaders
    };
  }
  return undefined;
}

/***/ }),

/***/ 5974:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _from = __webpack_require__(5975);

var _from2 = _interopRequireDefault(_from);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {
      arr2[i] = arr[i];
    }

    return arr2;
  } else {
    return (0, _from2.default)(arr);
  }
};

/***/ }),

/***/ 5975:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5976), __esModule: true };

/***/ }),

/***/ 5976:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5909);
__webpack_require__(5977);
module.exports = __webpack_require__(5862).Array.from;


/***/ }),

/***/ 5977:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var ctx = __webpack_require__(5863);
var $export = __webpack_require__(5860);
var toObject = __webpack_require__(5894);
var call = __webpack_require__(5978);
var isArrayIter = __webpack_require__(5979);
var toLength = __webpack_require__(5884);
var createProperty = __webpack_require__(5980);
var getIterFn = __webpack_require__(5958);

$export($export.S + $export.F * !__webpack_require__(5981)(function (iter) { Array.from(iter); }), 'Array', {
  // 22.1.2.1 Array.from(arrayLike, mapfn = undefined, thisArg = undefined)
  from: function from(arrayLike /* , mapfn = undefined, thisArg = undefined */) {
    var O = toObject(arrayLike);
    var C = typeof this == 'function' ? this : Array;
    var aLen = arguments.length;
    var mapfn = aLen > 1 ? arguments[1] : undefined;
    var mapping = mapfn !== undefined;
    var index = 0;
    var iterFn = getIterFn(O);
    var length, result, step, iterator;
    if (mapping) mapfn = ctx(mapfn, aLen > 2 ? arguments[2] : undefined, 2);
    // if object isn't iterable or it's array with default iterator - use simple case
    if (iterFn != undefined && !(C == Array && isArrayIter(iterFn))) {
      for (iterator = iterFn.call(O), result = new C(); !(step = iterator.next()).done; index++) {
        createProperty(result, index, mapping ? call(iterator, mapfn, [step.value, index], true) : step.value);
      }
    } else {
      length = toLength(O.length);
      for (result = new C(length); length > index; index++) {
        createProperty(result, index, mapping ? mapfn(O[index], index) : O[index]);
      }
    }
    result.length = index;
    return result;
  }
});


/***/ }),

/***/ 5978:
/***/ (function(module, exports, __webpack_require__) {

// call something on iterator step with safe closing on error
var anObject = __webpack_require__(5867);
module.exports = function (iterator, fn, value, entries) {
  try {
    return entries ? fn(anObject(value)[0], value[1]) : fn(value);
  // 7.4.6 IteratorClose(iterator, completion)
  } catch (e) {
    var ret = iterator['return'];
    if (ret !== undefined) anObject(ret.call(iterator));
    throw e;
  }
};


/***/ }),

/***/ 5979:
/***/ (function(module, exports, __webpack_require__) {

// check on default Array iterator
var Iterators = __webpack_require__(5913);
var ITERATOR = __webpack_require__(5919)('iterator');
var ArrayProto = Array.prototype;

module.exports = function (it) {
  return it !== undefined && (Iterators.Array === it || ArrayProto[ITERATOR] === it);
};


/***/ }),

/***/ 5980:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var $defineProperty = __webpack_require__(5866);
var createDesc = __webpack_require__(5874);

module.exports = function (object, index, value) {
  if (index in object) $defineProperty.f(object, index, createDesc(0, value));
  else object[index] = value;
};


/***/ }),

/***/ 5981:
/***/ (function(module, exports, __webpack_require__) {

var ITERATOR = __webpack_require__(5919)('iterator');
var SAFE_CLOSING = false;

try {
  var riter = [7][ITERATOR]();
  riter['return'] = function () { SAFE_CLOSING = true; };
  // eslint-disable-next-line no-throw-literal
  Array.from(riter, function () { throw 2; });
} catch (e) { /* empty */ }

module.exports = function (exec, skipClosing) {
  if (!skipClosing && !SAFE_CLOSING) return false;
  var safe = false;
  try {
    var arr = [7];
    var iter = arr[ITERATOR]();
    iter.next = function () { return { done: safe = true }; };
    arr[ITERATOR] = function () { return iter; };
    exec(arr);
  } catch (e) { /* empty */ }
  return safe;
};


/***/ }),

/***/ 5982:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createStyles = __webpack_require__(5962);

var _createStyles2 = _interopRequireDefault(_createStyles);

var _ObjectValue = __webpack_require__(5969);

var _ObjectValue2 = _interopRequireDefault(_ObjectValue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DataContainer = function DataContainer(_ref, _ref2) {
  var rows = _ref.rows,
      columns = _ref.columns,
      rowsData = _ref.rowsData;
  var theme = _ref2.theme;

  var styles = (0, _createStyles2.default)('TableInspectorDataContainer', theme);
  var borderStyles = (0, _createStyles2.default)('TableInspectorLeftBorder', theme);

  return _react2.default.createElement(
    'div',
    { style: styles.div },
    _react2.default.createElement(
      'table',
      { style: styles.table },
      _react2.default.createElement('colgroup', null),
      _react2.default.createElement(
        'tbody',
        null,
        rows.map(function (row, i) {
          return _react2.default.createElement(
            'tr',
            { key: row, style: styles.tr },
            _react2.default.createElement(
              'td',
              { style: (0, _extends3.default)({}, styles.td, borderStyles.none) },
              row
            ),
            columns.map(function (column) {
              var rowData = rowsData[i];
              // rowData could be
              //  object -> index by key
              //    array -> index by array index
              //    null -> pass
              //  boolean -> pass
              //  string -> pass (hasOwnProperty returns true for [0..len-1])
              //  number -> pass
              //  function -> pass
              //  symbol
              //  undefined -> pass
              if ((typeof rowData === 'undefined' ? 'undefined' : (0, _typeof3.default)(rowData)) === 'object' && rowData !== null && rowData.hasOwnProperty(column)) {
                return _react2.default.createElement(
                  'td',
                  { key: column, style: (0, _extends3.default)({}, styles.td, borderStyles.solid) },
                  _react2.default.createElement(_ObjectValue2.default, { object: rowData[column] })
                );
              } else {
                return _react2.default.createElement('td', { key: column, style: (0, _extends3.default)({}, styles.td, borderStyles.solid) });
              }
            })
          );
        })
      )
    )
  );
};

DataContainer.contextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]).isRequired
};

exports.default = DataContainer;

/***/ }),

/***/ 5983:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createStyles = __webpack_require__(5962);

var _createStyles2 = _interopRequireDefault(_createStyles);

var _TH = __webpack_require__(5984);

var _TH2 = _interopRequireDefault(_TH);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HeaderContainer = function HeaderContainer(_ref, _ref2) {
  var indexColumnText = _ref.indexColumnText,
      columns = _ref.columns,
      sorted = _ref.sorted,
      sortIndexColumn = _ref.sortIndexColumn,
      sortColumn = _ref.sortColumn,
      sortAscending = _ref.sortAscending,
      onTHClick = _ref.onTHClick,
      onIndexTHClick = _ref.onIndexTHClick;
  var theme = _ref2.theme;

  var styles = (0, _createStyles2.default)('TableInspectorHeaderContainer', theme);
  var borderStyles = (0, _createStyles2.default)('TableInspectorLeftBorder', theme);
  return _react2.default.createElement(
    'div',
    { style: styles.base },
    _react2.default.createElement(
      'table',
      { style: styles.table },
      _react2.default.createElement(
        'tbody',
        null,
        _react2.default.createElement(
          'tr',
          null,
          _react2.default.createElement(
            _TH2.default,
            {
              borderStyle: borderStyles.none,
              sorted: sorted && sortIndexColumn,
              sortAscending: sortAscending,
              onClick: onIndexTHClick
            },
            indexColumnText
          ),
          columns.map(function (column) {
            return _react2.default.createElement(
              _TH2.default,
              {
                borderStyle: borderStyles.solid,
                key: column,
                sorted: sorted && sortColumn === column,
                sortAscending: sortAscending,
                onClick: onTHClick.bind(undefined, column)
              },
              column
            );
          })
        )
      )
    )
  );
};

HeaderContainer.defaultProps = {
  indexColumnText: '(index)',
  columns: []
};

HeaderContainer.contextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]).isRequired
};

exports.default = HeaderContainer;

/***/ }),

/***/ 5984:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = __webpack_require__(5895);

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = __webpack_require__(5900);

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = __webpack_require__(5901);

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = __webpack_require__(5905);

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = __webpack_require__(5939);

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createStyles = __webpack_require__(5962);

var _createStyles2 = _interopRequireDefault(_createStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SortIconContainer = function SortIconContainer(props) {
  return _react2.default.createElement(
    'div',
    {
      style: {
        position: 'absolute',
        top: 1,
        right: 0,
        bottom: 1,
        display: 'flex',
        alignItems: 'center'
      }
    },
    props.children
  );
};

var SortIcon = function SortIcon(_ref, _ref2) {
  var sortAscending = _ref.sortAscending;
  var theme = _ref2.theme;

  var glyph = sortAscending ? '▲' : '▼';
  var styles = (0, _createStyles2.default)('TableInspectorSortIcon', theme);
  return _react2.default.createElement(
    'div',
    { style: styles },
    glyph
  );
};

SortIcon.contextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]).isRequired
};

var TH = function (_Component) {
  (0, _inherits3.default)(TH, _Component);

  function TH() {
    var _ref3;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, TH);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref3 = TH.__proto__ || Object.getPrototypeOf(TH)).call.apply(_ref3, [this].concat(args))), _this), _this.state = { hovered: false }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(TH, [{
    key: 'toggleHovered',
    value: function toggleHovered(hovered) {
      this.setState({ hovered: hovered });
    }
  }, {
    key: 'render',
    value: function render() {
      // either not sorted, sort ascending or sort descending
      var _props = this.props,
          borderStyle = _props.borderStyle,
          children = _props.children,
          onClick = _props.onClick,
          sortAscending = _props.sortAscending,
          sorted = _props.sorted,
          props = (0, _objectWithoutProperties3.default)(_props, ['borderStyle', 'children', 'onClick', 'sortAscending', 'sorted']);
      var theme = this.context.theme;

      var styles = (0, _createStyles2.default)('TableInspectorTH', theme);

      return _react2.default.createElement(
        'th',
        (0, _extends3.default)({}, props, {
          style: (0, _extends3.default)({}, styles.base, borderStyle, this.state.hovered ? styles.base[':hover'] : {}),
          onMouseEnter: this.toggleHovered.bind(this, true),
          onMouseLeave: this.toggleHovered.bind(this, false),
          onClick: onClick
        }),
        _react2.default.createElement(
          'div',
          { style: styles.div },
          children
        ),
        sorted && _react2.default.createElement(
          SortIconContainer,
          null,
          _react2.default.createElement(SortIcon, { sortAscending: sortAscending })
        )
      );
    }
  }]);
  return TH;
}(_react.Component);

TH.contextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]).isRequired
};

TH.defaultProps = {
  sortAscending: false,
  sorted: false,
  onClick: undefined
};

exports.default = TH;

/***/ }),

/***/ 5985:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = __webpack_require__(5900);

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = __webpack_require__(5901);

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = __webpack_require__(5905);

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = __webpack_require__(5939);

var _inherits3 = _interopRequireDefault(_inherits2);

var _regenerator = __webpack_require__(5947);

var _regenerator2 = _interopRequireDefault(_regenerator);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DOMNodePreview = __webpack_require__(5986);

var _DOMNodePreview2 = _interopRequireDefault(_DOMNodePreview);

var _TreeView = __webpack_require__(5959);

var _TreeView2 = _interopRequireDefault(_TreeView);

var _shouldInline = __webpack_require__(5987);

var _shouldInline2 = _interopRequireDefault(_shouldInline);

var _ThemeProvider = __webpack_require__(5971);

var _ThemeProvider2 = _interopRequireDefault(_ThemeProvider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var domIterator = /*#__PURE__*/_regenerator2.default.mark(function domIterator(data) {
  var textInlined, i, node;
  return _regenerator2.default.wrap(function domIterator$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          if (!(data && data.childNodes)) {
            _context.next = 17;
            break;
          }

          textInlined = (0, _shouldInline2.default)(data);

          if (!textInlined) {
            _context.next = 4;
            break;
          }

          return _context.abrupt('return');

        case 4:
          i = 0;

        case 5:
          if (!(i < data.childNodes.length)) {
            _context.next = 14;
            break;
          }

          node = data.childNodes[i];

          if (!(node.nodeType === Node.TEXT_NODE && node.textContent.trim().length === 0)) {
            _context.next = 9;
            break;
          }

          return _context.abrupt('continue', 11);

        case 9:
          _context.next = 11;
          return {
            name: node.tagName + '[' + i + ']',
            data: node
          };

        case 11:
          i++;
          _context.next = 5;
          break;

        case 14:
          if (!data.tagName) {
            _context.next = 17;
            break;
          }

          _context.next = 17;
          return {
            name: 'CLOSE_TAG',
            data: {
              tagName: data.tagName
            },
            isCloseTag: true
          };

        case 17:
        case 'end':
          return _context.stop();
      }
    }
  }, domIterator, this);
});

var DOMInspector = function (_Component) {
  (0, _inherits3.default)(DOMInspector, _Component);

  function DOMInspector() {
    (0, _classCallCheck3.default)(this, DOMInspector);
    return (0, _possibleConstructorReturn3.default)(this, (DOMInspector.__proto__ || Object.getPrototypeOf(DOMInspector)).apply(this, arguments));
  }

  (0, _createClass3.default)(DOMInspector, [{
    key: 'render',
    value: function render() {
      var nodeRenderer = _DOMNodePreview2.default;

      return _react2.default.createElement(
        _ThemeProvider2.default,
        { theme: this.props.theme },
        _react2.default.createElement(_TreeView2.default, (0, _extends3.default)({ nodeRenderer: nodeRenderer, dataIterator: domIterator }, this.props))
      );
    }
  }]);
  return DOMInspector;
}(_react.Component);

DOMInspector.propTypes = {
  /** The DOM Node to inspect */
  data: _propTypes2.default.object.isRequired
};
DOMInspector.defaultProps = {
  theme: 'chromeLight'
};
exports.default = DOMInspector;

/***/ }),

/***/ 5986:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createStyles = __webpack_require__(5962);

var _createStyles2 = _interopRequireDefault(_createStyles);

var _shouldInline = __webpack_require__(5987);

var _shouldInline2 = _interopRequireDefault(_shouldInline);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var OpenTag = function OpenTag(_ref) {
  var tagName = _ref.tagName,
      attributes = _ref.attributes,
      styles = _ref.styles;

  return _react2.default.createElement(
    'span',
    { style: styles.base },
    '<',
    _react2.default.createElement(
      'span',
      { style: styles.tagName },
      tagName
    ),
    function () {
      if (attributes) {
        var attributeNodes = [];
        for (var i = 0; i < attributes.length; i++) {
          var attribute = attributes[i];
          attributeNodes.push(_react2.default.createElement(
            'span',
            { key: i },
            ' ',
            _react2.default.createElement(
              'span',
              { style: styles.htmlAttributeName },
              attribute.name
            ),
            '="',
            _react2.default.createElement(
              'span',
              { style: styles.htmlAttributeValue },
              attribute.value
            ),
            '"'
          ));
        }
        return attributeNodes;
      }
    }(),
    '>'
  );
};

// isChildNode style={{ marginLeft: -12 /* hack: offset placeholder */ }}
var CloseTag = function CloseTag(_ref2) {
  var tagName = _ref2.tagName,
      _ref2$isChildNode = _ref2.isChildNode,
      isChildNode = _ref2$isChildNode === undefined ? false : _ref2$isChildNode,
      styles = _ref2.styles;
  return _react2.default.createElement(
    'span',
    { style: Object.assign({}, styles.base, isChildNode && styles.offsetLeft) },
    '</',
    _react2.default.createElement(
      'span',
      { style: styles.tagName },
      tagName
    ),
    '>'
  );
};

var nameByNodeType = {
  1: 'ELEMENT_NODE',
  3: 'TEXT_NODE',
  7: 'PROCESSING_INSTRUCTION_NODE',
  8: 'COMMENT_NODE',
  9: 'DOCUMENT_NODE',
  10: 'DOCUMENT_TYPE_NODE', // http://stackoverflow.com/questions/6088972/get-doctype-of-an-html-as-string-with-javascript
  11: 'DOCUMENT_FRAGMENT_NODE'
};

var DOMNodePreview = function DOMNodePreview(_ref3, _ref4) {
  var isCloseTag = _ref3.isCloseTag,
      data = _ref3.data,
      expanded = _ref3.expanded;
  var theme = _ref4.theme;

  var styles = (0, _createStyles2.default)('DOMNodePreview', theme);

  if (isCloseTag) {
    return _react2.default.createElement(CloseTag, { styles: styles.htmlCloseTag, isChildNode: true, tagName: data.tagName });
  }

  switch (data.nodeType) {
    case Node.ELEMENT_NODE:
      return _react2.default.createElement(
        'span',
        null,
        _react2.default.createElement(OpenTag, {
          tagName: data.tagName,
          attributes: data.attributes,
          styles: styles.htmlOpenTag
        }),
        (0, _shouldInline2.default)(data) ? data.textContent : !expanded && '…',
        !expanded && _react2.default.createElement(CloseTag, { tagName: data.tagName, styles: styles.htmlCloseTag })
      );
    case Node.TEXT_NODE:
      return _react2.default.createElement(
        'span',
        null,
        data.textContent
      );
    case Node.CDATA_SECTION_NODE:
      return _react2.default.createElement(
        'span',
        null,
        '<![CDATA[' + data.textContent + ']]>'
      );
    case Node.COMMENT_NODE:
      return _react2.default.createElement(
        'span',
        { style: styles.htmlComment },
        '<!--',
        data.textContent,
        '-->'
      );
    case Node.PROCESSING_INSTRUCTION_NODE:
      return _react2.default.createElement(
        'span',
        null,
        data.nodeName
      );
    case Node.DOCUMENT_TYPE_NODE:
      return _react2.default.createElement(
        'span',
        { style: styles.htmlDoctype },
        '<!DOCTYPE ',
        data.name,
        data.publicId ? ' PUBLIC "' + data.publicId + '"' : '',
        !data.publicId && data.systemId ? ' SYSTEM' : '',
        data.systemId ? ' "' + data.systemId + '"' : '',
        '>'
      );
    case Node.DOCUMENT_NODE:
      return _react2.default.createElement(
        'span',
        null,
        data.nodeName
      );
    case Node.DOCUMENT_FRAGMENT_NODE:
      return _react2.default.createElement(
        'span',
        null,
        data.nodeName
      );
    default:
      return _react2.default.createElement(
        'span',
        null,
        nameByNodeType[data.nodeType]
      );
  }
};

DOMNodePreview.propTypes = {
  /** If true, just render a close tag */
  isCloseTag: _propTypes2.default.bool,
  /**  */
  name: _propTypes2.default.string,
  /** The DOM Node */
  data: _propTypes2.default.object.isRequired,
  /** Whether the DOM node has been expanded. */
  expanded: _propTypes2.default.bool.isRequired
};

DOMNodePreview.contextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]).isRequired
};

exports.default = DOMNodePreview;

/***/ }),

/***/ 5987:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var TEXT_NODE_MAX_INLINE_CHARS = 80;

var shouldInline = function shouldInline(data) {
  return data.childNodes.length === 0 || data.childNodes.length === 1 && data.childNodes[0].nodeType === Node.TEXT_NODE && data.textContent.length < TEXT_NODE_MAX_INLINE_CHARS;
};

exports.default = shouldInline;

/***/ }),

/***/ 5988:
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(5989)
var isWindow = __webpack_require__(5990)

function isNode (val) {
  if (!isObject(val) || !isWindow(window) || typeof window.Node !== 'function') {
    return false
  }

  return typeof val.nodeType === 'number' &&
    typeof val.nodeName === 'string'
}

module.exports = isNode


/***/ }),

/***/ 5989:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = function isObject(x) {
	return typeof x === "object" && x !== null;
};


/***/ }),

/***/ 5990:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = function (obj) {

  if (obj == null) {
    return false;
  }

  var o = Object(obj);

  return o === o.window;
};


/***/ }),

/***/ 5991:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "useStyles", function() { return useStyles; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "baseStyles", function() { return baseStyles; });
const base = {
  ObjectPreview: {
    objectDescription: {
      fontStyle: 'italic' },

    preview: {
      fontStyle: 'italic' },

    arrayMaxProperties: 5,
    objectMaxProperties: 3 },


  ObjectName: {
    base: {},
    dimmed: {
      opacity: 0.6 } },



  ObjectValue: {
    objectValueNull: {
      color: 'var(--color-accent-success)' },

    objectValueUndefined: {
      color: 'var(--color-accent-success)' },

    objectValueRegExp: {
      color: 'var(--color-accent-success)' },

    objectValueString: {
      color: 'var(--color-accent-success)',
      wordBreak: 'break-all' },

    objectValueSymbol: {
      color: 'var(--color-accent-success)' },

    objectValueNumber: {
      color: 'var(--color-accent-success)' },

    objectValueBoolean: {
      color: 'var(--color-accent-success)' },

    objectValueFunctionPrefix: {
      color: 'var(--color-accent-success)',
      fontStyle: 'italic' },

    objectValueFunctionName: {
      fontStyle: 'italic' } } };




/**
                                  * Hook to get the component styles for the current theme.
                                  * @param {string} baseStylesKey - Name of the component to be styled
                                  */
const useStyles = baseStylesKey => base[baseStylesKey];

const baseStyles = {
  BASE_BACKGROUND_COLOR: 'transparent',
  ARROW_MARGIN_RIGHT: 4,
  ARROW_FONT_SIZE: 8,
  ARROW_COLOR: 'var(--content-tertiary)' };

/***/ }),

/***/ 5992:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ObjectName__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5993);
/* harmony import */ var _ObjectPreview__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5994);




const ObjectRootLabel = ({ name, data }) => {
  if (typeof name === 'string') {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null,
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ObjectName__WEBPACK_IMPORTED_MODULE_1__["default"], { name: name }),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, ': '),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ObjectPreview__WEBPACK_IMPORTED_MODULE_2__["default"], { data: data })));


  }

  return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ObjectPreview__WEBPACK_IMPORTED_MODULE_2__["default"], { data: data });
};

/* harmony default export */ __webpack_exports__["default"] = (ObjectRootLabel);

/***/ }),

/***/ 5993:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5991);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};



/**
                                        * A view for object property names.
                                        *
                                        * If the property name is enumerable (in Object.keys(object)),
                                        * the property name will be rendered normally.
                                        *
                                        * If the property name is not enumerable (`Object.prototype.propertyIsEnumerable()`),
                                        * the property name will be dimmed to show the difference.
                                        */
const ObjectName = ({ name, dimmed = false, styles = {} }) => {
  const themeStyles = Object(_styles__WEBPACK_IMPORTED_MODULE_2__["useStyles"])('ObjectName'),
  appliedStyles = _extends({},
  themeStyles.base,
  dimmed ? themeStyles.dimmed : {},
  styles);


  return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: appliedStyles }, name);
};

ObjectName.propTypes = {
  /** Property name */
  name: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.string,

  /** Should property name be dimmed */
  dimmed: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.bool };


ObjectName.defaultProps = {
  name: '',
  dimmed: false };


/* harmony default export */ __webpack_exports__["default"] = (ObjectName);

/***/ }),

/***/ 5994:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ObjectValue__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5995);
/* harmony import */ var _ObjectName__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5993);
/* harmony import */ var _styles__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5991);







/* Intersperse arr with separator */
// eslint-disable-next-line require-jsdoc
function intersperse(arr, sep) {
  if (arr.length === 0) {
    return [];
  }

  return arr.slice(1).reduce((xs, x) => xs.concat([sep, x]), [arr[0]]);
}

/**
   * A preview of the object
   */
const ObjectPreview = ({ data }) => {
  const styles = Object(_styles__WEBPACK_IMPORTED_MODULE_3__["useStyles"])('ObjectPreview'),
  object = data;

  if (
  typeof object !== 'object' ||
  object === null ||
  object instanceof Date ||
  object instanceof RegExp)
  {
    return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ObjectValue__WEBPACK_IMPORTED_MODULE_1__["default"], { object: object });
  }

  if (Array.isArray(object)) {
    const maxProperties = styles.arrayMaxProperties,
    previewArray = object.
    slice(0, maxProperties).
    map((element, index) => react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ObjectValue__WEBPACK_IMPORTED_MODULE_1__["default"], { key: index, object: element }));

    if (object.length > maxProperties) {
      previewArray.push(react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: 'ellipsis' }, '\u2026'));
    }

    const arrayLength = object.length;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: styles.objectDescription },
          arrayLength === 0 ? '' : `(${arrayLength})\xa0`),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: styles.preview }, '[',

          intersperse(previewArray, ', '), ']')));




  }

  const maxProperties = styles.objectMaxProperties,

  propertyNodes = [];

  // eslint-disable-next-line
  for (const propertyName in object) {
    const propertyValue = object[propertyName];

    if (Object.prototype.hasOwnProperty.call(object, propertyName)) {
      let ellipsis;

      if (
      propertyNodes.length === maxProperties - 1 &&
      Object.keys(object).length > maxProperties)
      {
        ellipsis = react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: 'ellipsis' }, '\u2026');
      }

      propertyNodes.push(
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: propertyName },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ObjectName__WEBPACK_IMPORTED_MODULE_2__["default"], { name: propertyName || '""' }), ':\xA0',

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ObjectValue__WEBPACK_IMPORTED_MODULE_1__["default"], { object: propertyValue }),
        ellipsis));


      if (ellipsis) break;
    }
  }

  const objectConstructorName = object.constructor ? object.constructor.name : 'Object';

  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: styles.objectDescription },
        objectConstructorName === 'Object' ? '' : `${objectConstructorName} `),

      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: styles.preview },
        '{',
        intersperse(propertyNodes, ', '),
        '}')));



};

/* harmony default export */ __webpack_exports__["default"] = (ObjectPreview);

/***/ }),

/***/ 5995:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5991);
/* harmony import */ var _WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5996);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};






/**
                                             * A short description of the object values.
                                             * Can be used to render tree node in ObjectInspector
                                             * or render objects in TableInspector.
                                             */
const ObjectValue = ({ object, styles }) => {
  const themeStyles = Object(_styles__WEBPACK_IMPORTED_MODULE_2__["useStyles"])('ObjectValue'),

  mkStyle = key => _extends({}, themeStyles[key], styles);

  switch (typeof object) {
    case 'number':
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueNumber') }, String(object));

    case 'string':
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueString') }, '"',

          !_.isEmpty(object) && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_3__["default"], { sentence: object }), '"'));




    case 'boolean':
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueBoolean') }, String(object)));


    case 'undefined':
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueUndefined') }, 'undefined');

    case 'object':
      if (object === null) {
        return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueNull') }, 'null');
      }

      if (object instanceof Date) {
        return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, object.toString());
      }

      if (object instanceof RegExp) {
        return (
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueRegExp') }, object.toString()));

      }

      if (Array.isArray(object)) {
        return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, `[${object.length}]`);
      }

      if (!object.constructor) {
        return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, String('{…}'));
      }

      if (typeof object.constructor.isBuffer === 'function' && object.constructor.isBuffer(object)) {
        return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, `Buffer[${object.length}]`);
      }

      if (object.constructor.name === 'Object') {
        const isEmpty = !Object.getOwnPropertyNames(object).length,
        style = { fontStyle: 'italic' };

        return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: style }, isEmpty ? String('{}') : String('{…}'));
      }

      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, object.constructor.name);

    case 'function':
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueFunctionPrefix') }, '\u0192\xA0'),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueFunctionName') },
            `${object.name}()`)));




    case 'symbol':
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueSymbol') }, object.toString()));


    default:
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null);}

};

ObjectValue.propTypes = {
  // The object to describe
  object: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.any // eslint-disable-line react/forbid-prop-types
};

ObjectValue.defaultProps = {
  object: undefined };


/* harmony default export */ __webpack_exports__["default"] = (ObjectValue);
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5996:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return WhitespaceFormatter; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);


const NULL = '\u20E0',
SPACE = '\u00B7',
TAB = '\u2192',
CARRIAGE_RETURN = '\u21B5',
CharMap = {
  0: NULL,
  9: TAB,
  10: CARRIAGE_RETURN,
  13: CARRIAGE_RETURN,
  32: SPACE };let


WhitespaceFormatter = class WhitespaceFormatter extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  getMessage(message) {
    if (message === null) {
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'wf__nl', title: 'New line' }, '\n');
    }

    return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'wf__tk' }, message);
  }

  getParsedMessage(sentence) {
    if (_.isEmpty(sentence)) {
      return [null, null, null];
    }

    // Figure out the start boundary characters
    let startBoundary = '',
    endBoundary = '',

    i = 0,
    isEmpty = false;

    // Find empty starting boundary character
    while (sentence.charCodeAt(i) in CharMap) {
      startBoundary += CharMap[sentence.charCodeAt(i)];

      // If we could reach the end then the complete string is empty
      if (++i === sentence.length) {
        isEmpty = true;
        break;
      }
    }

    if (isEmpty) {
      return [startBoundary];
    }

    i = sentence.length - 1;

    // Find empty starting boundary character
    while (sentence.charCodeAt(i) in CharMap) {
      endBoundary = CharMap[sentence.charCodeAt(i)] + endBoundary;

      // This should not happen, but just in case it happened
      if (--i === -1) {
        break;
      }
    }

    return [startBoundary, sentence.trim(), endBoundary];
  }

  getWhitespaces(whitespaces) {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,

        _.map(whitespaces, (whitespace, index) => {
          if (whitespace === SPACE) {
            return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: index, className: 'wf__sp', title: 'Single space' }, ' ');
          }

          if (whitespace === TAB) {
            return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: index, className: 'wf__tb', title: 'Tab' }, '\t');
          }

          return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: index, className: 'wf__ch' }, whitespace);
        })));



  }

  render() {
    const line = _.isNil(this.props.sentence) ? [null, '', null] : this.getParsedMessage(String(this.props.sentence));

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'wf__item' },
        this.props.quoteStart && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'wf__qt' }),
        line[0] !== null && this.getWhitespaces(line[0]),

        this.getMessage(line[1]),

        line[2] !== null && this.getWhitespaces(line[2]),

        this.props.quoteEnd && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'wf__qt' })));


  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5997:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _object_ObjectName__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5993);
/* harmony import */ var _object_ObjectValue__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5995);






/**
                                                 * If isNonenumerable is specified, render the name dimmed
                                                 */
const ObjectLabel = ({
  name, data, isNonenumerable = false, styles = {} }) =>

react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: styles },
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_object_ObjectName__WEBPACK_IMPORTED_MODULE_2__["default"], { name: name, dimmed: isNonenumerable }),
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, ': '),
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_object_ObjectValue__WEBPACK_IMPORTED_MODULE_3__["default"], { object: data }));



ObjectLabel.propTypes = {
  /** Non enumerable object property will be dimmed */
  isNonenumerable: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.bool };


ObjectLabel.defaultProps = {
  isNonenumerable: false };


/* harmony default export */ __webpack_exports__["default"] = (ObjectLabel);

/***/ }),

/***/ 5998:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleNetworkItem; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _postman_pretty_ms__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3286);
/* harmony import */ var _postman_pretty_ms__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_postman_pretty_ms__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _ConsoleListItemPretty_ConsoleListItemPretty__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5999);
/* harmony import */ var _ConsoleListItemRaw_ConsoleListItemRaw__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6002);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(2934);









/**
                                                                        * Data should be of the following format
                                                                        * data:
                                                                        *  request:
                                                                        *  response:
                                                                        *  session:
                                                                        *  timings:
                                                                        */let

ConsoleNetworkItem = class ConsoleNetworkItem extends react__WEBPACK_IMPORTED_MODULE_0__["PureComponent"] {
  constructor(props) {
    super(props);

    this.state = { activeTab: 'pretty' };

    this.toggleView = this.toggleView.bind(this);
    this.handleToggle = this.handleToggle.bind(this);
    this.getButtonText = this.getButtonText.bind(this);
    this.viewLargeBody = this.viewLargeBody.bind(this);
  }

  componentDidUpdate() {
    Object(react_dom__WEBPACK_IMPORTED_MODULE_1__["findDOMNode"])(this).scrollIntoViewIfNeeded();
  }

  getRequestHead(data) {
    // Use the href property and then fallback to url
    return `${data.request.method} ${data.request.href || data.request.url}`;
  }

  getNetworkErrorOrWarning(data) {
    if (data.error) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__network-error' },
          `Error: ${data.error.message || data.error}`));


    }

    if (data.warning) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__network-warning' },
          `Warning: ${data.warning.message || data.warning}`));


    }
  }

  getStatusCode(data) {
    if (data.redirect === true) {
      return _.get(this.props, 'data.response.statusCode');
    }

    return _.get(this.props, 'data.response.code');
  }

  getButtonText() {
    if (this.state.activeTab === 'pretty') {
      return 'Show raw log';
    }

    return 'Show pretty log';
  }

  toggleView() {
    if (this.state.activeTab === 'pretty') {
      return this.setState({ activeTab: 'raw' });
    }

    return this.setState({ activeTab: 'pretty' });
  }

  handleToggle() {
    this.props.toggleExpanded();
  }

  /**
    * A utility helper method that prettifies raw millisecond counts and returns it.
    *
    * @param {Number} ms - The raw millisecond count, usually from response times.
    * @returns {String} - The prettified time, scaled to units of time, depending on the input value.
    */
  formatTime(ms) {
    return ms < 1998 ? `${_.ceil(ms, 2)} ms` :
    _postman_pretty_ms__WEBPACK_IMPORTED_MODULE_3___default()(ms || 0, {
      secondsDecimalDigits: 2,
      keepDecimalsOnWholeSeconds: true,
      padUnits: true });

  }

  viewLargeBody(bodyType) {
    this.props.viewLargeBody(this.props.id, bodyType);
  }

  render() {
    const responseTime = _.get(this.props, 'data.response.responseTime');

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__network-wrap' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__network-msg', onClick: this.handleToggle },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: classnames__WEBPACK_IMPORTED_MODULE_2___default()('network-expand__caret', { down: this.props.isExpanded }) }, '\u25B6'),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'network__message' },

            this.getRequestHead(this.props.data)),


          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'network__response-meta' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'network__response-code' }, this.getStatusCode(this.props.data)),

            Boolean(responseTime) &&

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'separator' }),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'network__response-time' }, this.formatTime(responseTime))))),






        this.props.isExpanded &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__network-wrap--expanded' },
          this.getNetworkErrorOrWarning(this.props.data),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__network-expanded' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'network-expanded__left' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: classnames__WEBPACK_IMPORTED_MODULE_2___default()({ 'is-hidden': this.state.activeTab !== 'pretty' }) },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleListItemPretty_ConsoleListItemPretty__WEBPACK_IMPORTED_MODULE_4__["default"], {
                  data: this.props.data,
                  viewLargeBody: this.viewLargeBody })),


              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: classnames__WEBPACK_IMPORTED_MODULE_2___default()({ 'is-hidden': this.state.activeTab !== 'raw' }) },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleListItemRaw_ConsoleListItemRaw__WEBPACK_IMPORTED_MODULE_5__["default"], {
                  data: this.props.data,
                  viewLargeBody: this.viewLargeBody }))),




            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'network-expanded__right' },

              !(this.props.data.browserRequest || this.props.data.redirect || this.props.data.error) &&
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_6__["Button"], {
                  className: 'network__switch-view',
                  type: 'text',
                  onClick: this.toggleView },

                this.getButtonText()))))));










  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5999:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleListItemPretty; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_inspector__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5855);
/* harmony import */ var react_inspector__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_inspector__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _provider_ObjectInspector_ObjectLabel__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5997);
/* harmony import */ var _provider_ObjectInspector_styles__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5991);
/* harmony import */ var _ConsoleNetworkFormatter__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6000);
/* harmony import */ var _js_constants_RequestDataModeConstants__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2662);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(3229);
/* harmony import */ var _ConsoleBodyViewer_ConsoleBodyViewer__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(6001);
/* harmony import */ var _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(3269);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};













const REQUEST_HEADER_WARNING = 'This request did not get sent completely and might not have all the required system headers.',
REQUEST_HEADER_XHR_AGENT_WARNING = 'Some headers may be missing. Send this request with the Postman Desktop Agent to view accurate request headers.',
RESPONSE_HEADER_XHR_AGENT_WARNING = 'Some headers may be missing. Send this request with the Postman Desktop Agent to view accurate response headers.';let

ConsoleListItemPretty = class ConsoleListItemPretty extends react__WEBPACK_IMPORTED_MODULE_0__["PureComponent"] {
  constructor(props) {
    super(props);

    this.getBodyView = this.getBodyView.bind(this);
  }

  getRequestBody(request) {
    // Check for an ignored body and bail
    if (_.get(request, 'body.___ignored___')) {
      return { ___ignored___: true };
    }


    const mode = _.get(request, 'body.mode', _js_constants_RequestDataModeConstants__WEBPACK_IMPORTED_MODULE_5__["REQUEST_DATA_MODE_RAW"]),
    body = _.get(request, ['body', mode]);

    // Return empty or raw body as it is
    if (!body || body === '""' || mode === _js_constants_RequestDataModeConstants__WEBPACK_IMPORTED_MODULE_5__["REQUEST_DATA_MODE_RAW"]) {
      return body;
    }

    // At this moment the datamode could be any of form-data, url-encoded or graphql
    if (Array.isArray(body)) {
      return body.reduce((acc, b) => {
        if (b.disabled) {
          return acc;
        }

        // Check if the key already exists then
        if (acc[b.key]) {
          if (Array.isArray(acc[b.key])) {
            acc[b.key].push(b.value);
          } else {
            acc[b.key] = [acc[b.key], b.value];
          }
        } else {
          acc[b.key] = b.value;
        }

        return acc;
      }, {});
    }

    return body;
  }

  getResponseBody(response) {
    // Check for unsupported body and bail
    if (_.get(response, 'body.___unsupported___')) {
      return { ___unsupported___: true };
    }

    // Check for an ignored body and bail
    if (_.get(response, 'body.___ignored___')) {
      return { ___ignored___: true };
    }

    // Return the response body
    return _.get(response, 'body');
  }

  getHeaders(data) {
    if (!(data && data.headers)) {
      return;
    }

    return _.filter(data.headers, header => !header.disabled);
  }

  getTheme() {
    return _extends({ TREENODE_PADDING_LEFT: 8 }, _provider_ObjectInspector_styles__WEBPACK_IMPORTED_MODULE_3__["baseStyles"]);
  }

  getView(name, data, isExpanded, info) {
    if (_.isArray(data) || !_.isObject(data)) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleNetworkFormatter__WEBPACK_IMPORTED_MODULE_4__["default"], {
          isExpanded: isExpanded,
          name: name,
          data: data,
          info: info }));


    }

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react_inspector__WEBPACK_IMPORTED_MODULE_1___default.a, {
        data: data,
        theme: this.getTheme(),
        name: name,
        nodeRenderer: this.nodeRenderer,
        expandLevel: isExpanded ? 1 : 0 }));


  }

  getBodyView(name, data, bodyType, canViewInEditor) {
    const canPreviewInline = !(_.get(data, '___ignored___') || _.get(data, '___unsupported___'));

    if (!(canPreviewInline && _.isObject(data))) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleBodyViewer_ConsoleBodyViewer__WEBPACK_IMPORTED_MODULE_8__["default"], {
          name: name,
          data: data,
          viewLargeBody: this.props.viewLargeBody,
          bodyType: bodyType,
          isExpanded: !canPreviewInline,
          canViewInEditor: canViewInEditor }));


    }

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react_inspector__WEBPACK_IMPORTED_MODULE_1___default.a, {
        data: data,
        theme: this.getTheme(),
        name: name,
        nodeRenderer: this.nodeRendererBody.bind(this, bodyType, canViewInEditor) }));


  }

  getRequestHeadersError(data, responseStarted) {
    if (!_.get(this.props, 'data.request.headers.length')) {
      return;
    }

    if (!responseStarted && this.props.data.error) {
      return REQUEST_HEADER_WARNING;
    }

    if (data && data.agentUsed === _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_9__["TYPES"].XHR) {
      return REQUEST_HEADER_XHR_AGENT_WARNING;
    }
  }

  viewLargeBody(bodyType, e) {
    e && e.stopPropagation();
    this.props.viewLargeBody(bodyType);
  }

  nodeRenderer({
    depth, name, data, isNonenumerable, shouldShowArrow })
  {
    if (depth === 0) {
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'node-renderer__root-node' }, name);
    }

    let styles;

    if (shouldShowArrow) {
      styles = { cursor: 'pointer' };
    }

    return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_ObjectInspector_ObjectLabel__WEBPACK_IMPORTED_MODULE_2__["default"], { name: name, data: data, isNonenumerable: isNonenumerable, styles: styles });
  }

  nodeRendererBody(bodyType, canViewInEditor, {
    depth, name, data, isNonenumerable, shouldShowArrow })
  {
    if (depth === 0) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'node-renderer__root-node' },
          name,

          canViewInEditor &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_6__["Button"], {
              type: 'icon',
              onClick: this.viewLargeBody.bind(this, bodyType),
              className: 'console__large-body__btn',
              tooltip: 'Open in Editor' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_7__["default"], { size: 'xs', className: 'console__body-viewer__open-icon' }))));





    }

    let styles;

    if (shouldShowArrow) {
      styles = { cursor: 'pointer' };
    }

    return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_ObjectInspector_ObjectLabel__WEBPACK_IMPORTED_MODULE_2__["default"], { name: name, data: data, isNonenumerable: isNonenumerable, styles: styles });
  }

  render() {
    const requestBody = this.getRequestBody(this.props.data.request),
    requestBodyMode = _.get(this.props, 'data.request.body.mode'),
    responseBody = this.getResponseBody(this.props.data.response),
    requestHeader = this.getHeaders(this.props.data.request),
    responseHeaders = this.getHeaders(this.props.data.response),
    certificate = _.get(this.props, 'data.request.certificate'),
    proxy = _.get(this.props, 'data.request.proxy'),
    session = _.get(this.props, 'data.session'),
    sessions = _.get(this.props, 'data.history.execution.sessions', {}),
    sessionKeys = _.keys(sessions),
    lastSessionKey = sessionKeys[sessionKeys.length - 1],
    responseStarted = !_.isEmpty(sessions[lastSessionKey]);

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-list__pretty' },

        !_.isEmpty(certificate) && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'pretty__certificate' }, this.getView('Client Certificate', certificate)),


        !_.isEmpty(proxy) &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'pretty__proxy' },

          this.getView('Proxy', proxy, true) // Expanded by default
        ),




        !_.isEmpty(session) && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'pretty__network' }, this.getView('Network', session)),


        !_.isEmpty(requestHeader) &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'pretty__request-headers' },

          this.getView('Request Headers', requestHeader, true, this.getRequestHeadersError(this.props.data, responseStarted)) // Expanded by default
        ),




        !_.isUndefined(requestBody) &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'pretty__request-body' }, this.getBodyView('Request Body', requestBody, 'request', requestBodyMode === 'raw')) // Can only open in editor if requestBodyMode is raw
        ,

        !_.isEmpty(responseHeaders) &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'pretty__response-headers' },

          this.getView('Response Headers', responseHeaders, true, _.get(this.props.data, 'agentUsed') === _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_9__["TYPES"].XHR && RESPONSE_HEADER_XHR_AGENT_WARNING) // Expanded by default
        ),




        !_.isUndefined(responseBody) && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'pretty__response-body' }, this.getBodyView('Response Body', responseBody, 'response', true))));



  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6000:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleNetworkFormatter; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5996);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Icons_InformationIconNew__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(3624);




let

ConsoleNetworkFormatter = class ConsoleNetworkFormatter extends react__WEBPACK_IMPORTED_MODULE_0__["PureComponent"] {
  constructor(props) {
    super(props);

    this.state = { isExpanded: props.isExpanded };

    this.handleToggle = this.handleToggle.bind(this);
  }

  getText(value) {
    if (typeof value === 'string') {
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_2__["default"], { quoteStart: true, sentence: value, quoteEnd: true });
    }

    return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_2__["default"], { sentence: value });
  }

  handleToggle() {
    this.setState(prevState => ({ isExpanded: !prevState.isExpanded }));
  }

  render() {
    const { data, name } = this.props;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__network-string' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: 'network-string__name',
            onClick: this.handleToggle },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: classnames__WEBPACK_IMPORTED_MODULE_1___default()('network-expand__caret', { down: this.state.isExpanded }) }, '\u25B6'),
          name,

          this.props.info &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], {
              type: 'icon',
              className: 'network-string__info',
              tooltip: this.props.info },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_InformationIconNew__WEBPACK_IMPORTED_MODULE_4__["default"], { size: 'xs', className: 'network-string__info-icon' }))),





        this.state.isExpanded && (
        _.isArray(data) ?
        _.map(data, (row, index) =>
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { key: index, className: 'network-formatter__item' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_2__["default"], { sentence: row.key })),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, ': '),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'network__value' }, this.getText(row.value)))) :


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'network-string__value' }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_2__["default"], { sentence: data })))));





  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6001:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleBodyViewer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3229);
/* harmony import */ var _provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5996);




let

ConsoleBodyViewer = class ConsoleBodyViewer extends react__WEBPACK_IMPORTED_MODULE_0__["PureComponent"] {
  constructor(props) {
    super(props);

    this.state = { isExpanded: props.isExpanded };

    this.handleToggle = this.handleToggle.bind(this);
    this.viewLargeBody = this.viewLargeBody.bind(this);
    this.getBody = this.getBody.bind(this);
    this.getIgnoredBodyText = this.getIgnoredBodyText.bind(this);
  }


  getText(value) {
    if (typeof value === 'string') {
      return `"${value}"`;
    }

    return value;
  }

  getIgnoredBodyText() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'console__ignored-body' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'The console only shows bodies smaller than 10 KB inline. To view the complete body, inspect it by clicking'),



        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'console__open__link', onClick: this.viewLargeBody },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_3__["default"], { size: 'xs', className: 'console__inline__open-icon' })),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, ' Open.'))));



  }

  getBody(data) {
    if (_.isNil(data)) {
      return String(data);
    }

    if (data.___unsupported___) {
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'console__unsupported-body' }, 'The console does not support viewing bodies with media files.');
    }

    if (data.___ignored___) {
      return this.getIgnoredBodyText();
    }

    if (data === '') {
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'c-li__empty' });
    }

    return (

      // Changing this from `span` to `div` as body is now a container with background color.
      // This wouldn't be possible with `span` as each line would get background color separately.
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'network-string__value body' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_4__["default"], { sentence: data })));


  }

  handleToggle() {
    this.setState(prevState => ({ isExpanded: !prevState.isExpanded }));
  }


  viewLargeBody(e) {
    e && e.stopPropagation();
    this.props.viewLargeBody(this.props.bodyType);
  }

  render() {
    const { data, name, canViewInEditor } = this.props,
    isSupported = !_.get(data, '___unsupported___');

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__network-string' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: 'network-string__name',
            onClick: this.handleToggle },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: classnames__WEBPACK_IMPORTED_MODULE_1___default()('network-expand__caret', { down: this.state.isExpanded }) }, '\u25B6'),
          name,

          canViewInEditor && isSupported &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_2__["Button"], {
              type: 'icon',
              onClick: this.viewLargeBody,
              className: 'console__large-body__btn',
              tooltip: 'Open in Editor' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_3__["default"], { size: 'xs', className: 'console__body-viewer__open-icon' }))),





        this.state.isExpanded && this.getBody(data)));




  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6002:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleListItemRaw; });
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(64);
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(path__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3229);




const querystring = __webpack_require__(178),
{ Url } = __webpack_require__(790);let

ConsoleListItemRaw = class ConsoleListItemRaw extends react__WEBPACK_IMPORTED_MODULE_1__["PureComponent"] {
  getRawText() {
    const { data } = this.props,
    requestHeaders = this.getRequestHeaders(data.request),
    requestBody = this.getRequestBody(data.request),
    responseHeaders = this.getResponseHeaders(data.response),
    responseBody = this.getResponseBody(data.response);

    return {
      requestHeaders,
      requestBody,
      responseHeaders,
      responseBody };

  }

  getRequestHeaders(request) {
    const requestHeaders = _.
    chain(_.get(request, 'headers', [])).
    compact().
    reject('disabled').
    map(header => `${header.key || header.name}: ${header.value}`).
    value(),
    url = new Url(request.url),
    httpVersion = request.httpVersion ? request.httpVersion : '1.1';

    let queryString = url.getQueryString({ encode: true, ignoreDisabled: true });

    queryString = queryString ? `?${queryString}` : '';

    return _.concat(
    [`${request.method} ${url.getPath()}${queryString} HTTP/${httpVersion}`],
    requestHeaders);

  }

  getRequestBody(request) {
    let requestBody;

    const requestBodyMode = _.get(request, 'body.mode', '');

    if (requestBodyMode === 'formdata') {
      // Extract boundary from content-type header, which is of the form:
      //  Content-Type: multipart/form-data; boundary=--------------------------648758041545280124149783
      const contentType = _.find(request.headers, header => String(header.key).toLowerCase() === 'content-type');

      let boundary = contentType && contentType.value.
      split(';').
      map(x => x.trim()).
      find(x => x.startsWith('boundary='));

      boundary = boundary && boundary.substr(9);

      // Boundary might not be present in the header if user sends a custom header.
      // just add a custom boundary in that case
      if (!boundary) {
        boundary = '--------------------------postman';
      }

      boundary = `--${boundary}`;

      // Convert form data params into a fake of the request body that was actually sent:
      //
      // --------------------------648758041545280124149783
      // Content-Disposition: form-data; name="text1"
      //
      // value1
      // --------------------------648758041545280124149783
      // Content-Disposition: form-data; name="file1"; filename="some-file-name.txt"
      // Content-Type: application/octet-stream
      //
      // FILE CONTENT HERE
      // --------------------------648758041545280124149783--
      //
      const formData = _.
      chain(_.get(request, 'body.formdata', [])).
      filter(param => !param.disabled).
      map(param => {
        const NON_ASCII_REGEX = /[^\t\x20-\x7e\x80-\xff]/;

        let filename,
        formEntry = `Content-Disposition: form-data; name="${param.key}"`;

        // Try to get filename from "src" param
        if (typeof param.src === 'string') {
          filename = path__WEBPACK_IMPORTED_MODULE_0___default.a.basename(param.src);
        }

        // If param.type is "file", we should always show the "filename" param (it can be empty string)
        if (!filename && param.type === 'file') {
          filename = '';
        }

        // Filename can be empty string, make sure we handle it
        if (typeof filename === 'string') {
          formEntry += `; filename="${filename}"`;
        }

        // If filename is a UTF string, encode it as per RFC 6266
        if (NON_ASCII_REGEX.test(filename)) {
          formEntry += `; filename*="UTF-8''${

          // @note see RFC 8187
          // @todo use postman-urlencoder instead of encodeURIComponent for consistency
          encodeURIComponent(filename)

          // Note that although RFC3986 reserves "!", RFC8187 does not,
          // so we do not need to escape it
          .replace(/['()*]/g, c => `%${c.charCodeAt(0).toString(16)}`)

          // The following are not required for percent-encoding per RFC8187,
          // so we can allow for a little better readability over the wire: |`^
          .replace(/%(?:7C|60|5E)/g, unescape)
          }"`;
        }

        formEntry += '\r\n';

        // Only add content-type if it was user specified
        // @note this misses the content-type which was actually sent because
        // we have no way to knowing what it was
        if (param.contentType) {
          formEntry += `Content-Type: ${param.contentType}\r\n`;
        }

        formEntry += '\r\n';

        // If we have a filename, we print it; if not, we try to print the
        // value param
        if (param.type === 'file' && filename) {
          formEntry += `<${filename}>`;
        } else if (typeof param.value === 'string') {
          formEntry += param.value;
        }

        formEntry += '\r\n';

        return formEntry;
      }).
      join(`${boundary}\r\n`).
      value();

      if (formData) {
        requestBody = `${boundary}\r\n${formData}${boundary}--`;
      } else {
        requestBody = '';
      }
    } else if (requestBodyMode === 'urlencoded') {
      requestBody = _.
      chain(_.get(request.body, 'urlencoded', [])).
      reject('disabled').
      map(parameter => querystring.stringify({ [parameter.key]: parameter.value })).
      join('&').
      value();
    } else if (requestBodyMode === 'raw') {
      requestBody = _.get(request, 'body.raw');
    } else if (requestBodyMode === 'graphql') {
      const body = [],
      content = _.get(request, 'body.graphql');

      if (Object.hasOwnProperty.call(content, 'query') && typeof content.query === 'string') {
        body.push(`"query":${JSON.stringify(content.query)}`);
      }

      if (Object.hasOwnProperty.call(content, 'operationName') && typeof content.operationName === 'string') {
        body.push(`"operationName":${JSON.stringify(content.operationName)}`);
      }

      if (Object.hasOwnProperty.call(content, 'variables') && typeof content.variables === 'string' && content.variables !== '') {
        body.push(`"variables":${content.variables}`); // Already a stringified JSON
      }

      requestBody = `{${body.join(',')}}`;
    }

    return requestBody;
  }

  getResponseHeaders(response) {
    if (!response) {
      return [];
    }

    const responseHeaders = _.
    chain(_.get(response, 'headers', [])).
    map(header => `${header.key || header.name}: ${header.value}`).
    value(),
    httpVersion = response.httpVersion ? response.httpVersion : '1.1';

    return _.concat(
    [`HTTP/${httpVersion} ${response.code}${response.status ? ` ${response.status}` : ''}`],
    responseHeaders);

  }

  getResponseBody(response) {
    return response ? response.body : '';
  }

  getIgnoredBodyText(bodyType) {
    return (
      react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('span', { className: 'console__ignored-body' },
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('span', null, 'The console only shows',

          bodyType,
          ' bodies smaller than 10 KB inline. To view the complete body, inspect it by clicking '),

        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('span', { className: 'console__open__link', onClick: this.props.viewLargeBody.bind(null, bodyType) },
          react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('span', null, react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(_js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_2__["default"], { size: 'xs', className: 'console__inline__open-icon' })),
          react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('span', null, ' Open.'))));



  }

  render() {
    const raw = this.getRawText(),
    isResponseBodyUnsupported = _.get(this.props, 'data.response.body.___unsupported___'),
    isRequestBodyLarge = _.get(this.props, 'data.request.body.___ignored___'),
    isResponseBodyLarge = _.get(this.props, 'data.response.body.___ignored___');

    return (
      react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { className: 'console-net-item' },
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { className: 'console-net-item__body console-net-item__body--raw console-list__raw' },

          !_.isEmpty(raw.requestHeaders) &&
          react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { className: 'console-net-item__body-left__request' },
            _.map(raw.requestHeaders, (line, index) => line && react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { key: `request-line-${index}` }, line))),




          isRequestBodyLarge ?
          this.getIgnoredBodyText('request') :

          !_.isEmpty(raw.requestBody) &&
          react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { className: 'console-net-item__body-left__request-body' },
            _.map(_.split(raw.requestBody, '\n'), (line, index) => line && react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { key: `request-body-line-${index}` }, line))),




          !_.isEmpty(raw.responseHeaders) &&
          react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { className: 'console-net-item__body-left__response' },
            _.map(raw.responseHeaders, (line, index) => line && react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { key: `response-line-${index}` }, line))),




          isResponseBodyUnsupported &&
          react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('span', { className: 'console__unsupported-body' }, 'The console does not support viewing response bodies with media files.') || (

          isResponseBodyLarge ?
          this.getIgnoredBodyText('response') :
          !_.isEmpty(raw.responseBody) &&
          react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { className: 'console-net-item__body-left__response-body' },
            _.map(_.split(raw.responseBody, '\n'), (line, index) => line && react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { key: `response-body-line-${index}` }, line)))))));






  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6003:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return LockedIcon; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2813);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('svg', { width: '12', height: '14', viewBox: '0 0 16 16' },
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('defs', null,
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { id: 'locked', d: 'M8 1C5.79 1 4 2.79 4 5v2H2v8h12V7h-2V5c0-2.21-1.79-4-4-4zm0 2c1.19 0 2 .81 2 2v2H6V5c0-1.19.81-2 2-2z' })),

  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('use', { fill: '#282828', fillRule: 'evenodd', xlinkHref: '#locked' }));



function LockedIcon(props) {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_Icon__WEBPACK_IMPORTED_MODULE_1__["default"], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 6004:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RedirectIcon; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2813);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('svg', { width: '16', height: '16', viewBox: '0 0 16 16', fill: 'none', xmlns: 'http://www.w3.org/2000/svg' },
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { d: 'M11 2H16V7H15V3.70713L8.41424 10.2929C7.63319 11.0739 6.36686 11.0739 5.58581 10.2929L0.146469 4.85355L0.853577 4.14645L6.29292 9.58579C6.68344 9.97631 7.31661 9.97631 7.70713 9.58579L14.2929 3H11V2Z', fill: '#7E7E7E' }),
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { d: 'M0 13H16V14H0V13Z', fill: '#7E7E7E' }));



function RedirectIcon(props) {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_Icon__WEBPACK_IMPORTED_MODULE_1__["default"], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 6005:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return CodeIcon; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2813);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('svg', { width: '16', height: '14', viewBox: '0 0 16 14', fill: 'none', xmlns: 'http://www.w3.org/2000/svg' },
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { d: 'M6.47431 13.1581L10.4743 1.15812L9.52563 0.841888L5.52563 12.8419L6.47431 13.1581Z', fill: '#A9A9A9' }),
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { d: 'M4.6464 2.64645L0.292847 7L4.6464 11.3536L5.35351 10.6465L1.70706 7L5.35351 3.35356L4.6464 2.64645Z', fill: '#A9A9A9' }),
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { d: 'M11.3536 2.64645L15.7071 7L11.3536 11.3536L10.6465 10.6465L14.2929 7L10.6465 3.35356L11.3536 2.64645Z', fill: '#A9A9A9' }));



function CodeIcon(props) {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_Icon__WEBPACK_IMPORTED_MODULE_1__["default"], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 6006:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleBlobViewer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2929);
/* harmony import */ var _js_components_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2974);
/* harmony import */ var _js_components_base_Modals__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(3250);
/* harmony import */ var _appsdk_components_editors_texteditor_TextEditor__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2952);
/* harmony import */ var _js_components_base_Icons_InformationIcon__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(3231);
/* harmony import */ var _js_components_base_Tooltips__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(2935);
/* harmony import */ var _js_components_base_Icons_CloseIcon__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(3049);
var _class;









const TRUNCATED_TOOLTIP_COPY = 'The console truncates bodies larger than 5 MB',
responseLanguages = [
{ key: 'json', label: 'JSON' },
{ key: 'xml', label: 'XML' },
{ key: 'html', label: 'HTML' },
{ key: 'text', label: 'Text' },
{ key: 'auto', label: 'Auto' }];let



ConsoleBlobViewer = Object(mobx_react__WEBPACK_IMPORTED_MODULE_2__["observer"])(_class = class ConsoleBlobViewer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      activeLanguage: props.type,
      languageIntent: 'auto',
      wordWrap: true,
      isTooltipVisible: false };


    this.handleLanguageSelect = this.handleLanguageSelect.bind(this);
    this.handleLineWrapToggle = this.handleLineWrapToggle.bind(this);
    this.showTooltip = this.showTooltip.bind(this);
    this.handleTooltipClose = this.handleTooltipClose.bind(this);
    this.renderInModal = this.renderInModal.bind(this);
    this.renderInContainer = this.renderInContainer.bind(this);
  }

  getCustomStyles() {
    return {
      margin: 'auto' };

  }

  handleLanguageSelect(language) {
    let languageToBeUpdated = language,
    languageIntent = 'manual';

    if (languageToBeUpdated === 'auto') {
      languageToBeUpdated = this.props.type || 'text';
      languageIntent = 'auto';
    }

    this.setState({ activeLanguage: languageToBeUpdated, languageIntent });
  }

  handleLineWrapToggle() {
    this.setState(prevState => ({ wordWrap: !prevState.wordWrap }));
  }

  showTooltip() {
    this.setState({ isTooltipVisible: true });
  }

  handleTooltipClose() {
    this.state.isTooltipVisible && this.setState({ isTooltipVisible: false });
  }

  renderInModal(data, activeLanguage) {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Modals__WEBPACK_IMPORTED_MODULE_4__["Modal"], {
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onClose,
          customStyles: this.getCustomStyles(),
          fullscreen: true },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Modals__WEBPACK_IMPORTED_MODULE_4__["ModalHeader"], null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console__text-editor__header' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null,
              `${this.props.bodyType} Body`),



            this.props.isTruncated &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'console__text-editor__truncated-label' }, '(truncated)'),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  ref: 'tooltipTarget',
                  onClick: this.showTooltip,
                  className: 'truncated-info__button' },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_InformationIcon__WEBPACK_IMPORTED_MODULE_6__["default"], { className: 'truncated-info__icon', size: 'xs' })),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Tooltips__WEBPACK_IMPORTED_MODULE_7__["Tooltip"], {
                  show: this.state.isTooltipVisible,
                  target: this.refs.tooltipTarget,
                  onClose: this.handleTooltipClose,
                  closeOnClickOutside: true,
                  immediate: true },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Tooltips__WEBPACK_IMPORTED_MODULE_7__["TooltipBody"], null,
                  TRUNCATED_TOOLTIP_COPY))))),







        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Modals__WEBPACK_IMPORTED_MODULE_4__["ModalContent"], { className: 'console__text-editor__container' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console__text-editor' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_appsdk_components_editors_texteditor_TextEditor__WEBPACK_IMPORTED_MODULE_5__["default"], {
              showActionBar: true,
              autoFormat: true,
              readOnly: true,
              enableLinks: true,
              language: _.toLower(activeLanguage),
              languages: responseLanguages,
              onLanguageSelect: this.handleLanguageSelect,
              wordWrap: this.state.wordWrap,
              onWordWrapClick: this.handleLineWrapToggle,
              value: data }),


            this.props.isLoading && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_3__["default"], { className: 'console-list__loading' })))));





  }

  renderInContainer(data, activeLanguage) {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: classnames__WEBPACK_IMPORTED_MODULE_1___default()('console__blob-viewer', { 'is-hidden': !this.props.isOpen }) },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console__text-editor__header' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'header__section-left' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null,
              `${this.props.bodyType} Body`),



            this.props.isTruncated &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'console__text-editor__truncated-label' }, '(truncated)'),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  ref: 'tooltipTarget',
                  onClick: this.showTooltip,
                  className: 'truncated-info__button' },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_InformationIcon__WEBPACK_IMPORTED_MODULE_6__["default"], { className: 'truncated-info__icon', size: 'xs' })),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Tooltips__WEBPACK_IMPORTED_MODULE_7__["Tooltip"], {
                  show: this.state.isTooltipVisible,
                  target: this.refs.tooltipTarget,
                  onClose: this.handleTooltipClose,
                  closeOnClickOutside: true,
                  immediate: true },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Tooltips__WEBPACK_IMPORTED_MODULE_7__["TooltipBody"], null,
                  TRUNCATED_TOOLTIP_COPY)))),






          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'header__section-right' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_CloseIcon__WEBPACK_IMPORTED_MODULE_8__["default"], { className: 'header__section-right__close-icon', onClick: this.props.onClose }))),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console__text-editor__container' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_appsdk_components_editors_texteditor_TextEditor__WEBPACK_IMPORTED_MODULE_5__["default"], {
            showActionBar: true,
            readOnly: true,
            enableLinks: true,
            language: _.toLower(activeLanguage),
            languages: responseLanguages,
            onLanguageSelect: this.handleLanguageSelect,
            wordWrap: this.state.wordWrap,
            onWordWrapClick: this.handleLineWrapToggle,
            value: data }),


          this.props.isLoading && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_3__["default"], { className: 'console-list__loading' }))));




  }

  render() {
    const activeLanguage = (this.state.languageIntent === 'auto' ? this.props.type : this.state.activeLanguage) || '';

    let { data } = this.props;

    if (_.isEmpty(data)) {
      data = '';
    }

    return this.props.showInModal ?
    this.renderInModal(data, activeLanguage) :
    this.renderInContainer(data, activeLanguage);
  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6007:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
const AppNotificationStyles = {
  Containers: {
    DefaultStyle: {
      zIndex: 210,
      width: 360 },

    tr: { bottom: '30px', top: 'unset' } },

  MessageWrapper: {
    DefaultStyle: {
      display: 'inline-block',
      paddingRight: '10px' } },


  NotificationItem: {
    DefaultStyle: {
      textAlign: 'inherit',
      wordBreak: 'break-word',
      margin: '0',
      overflowY: 'hidden',
      transition: 'all 0.3s ease-in-out',
      cursor: 'default' },


    success: {
      borderTop: 'none',
      backgroundColor: 'none',
      boxShadow: 'none' },


    error: {
      borderTop: 'none',
      backgroundColor: 'none',
      boxShadow: 'none' },


    warning: {
      borderTop: 'none',
      backgroundColor: 'none',
      boxShadow: 'none' },


    info: {
      borderTop: 'none',
      backgroundColor: 'none',
      boxShadow: 'none' } },


  ActionWrapper: { DefaultStyle: { display: 'inline-block' } },
  Action: {
    DefaultStyle: {
      backgroundColor: 'transparent',
      borderRadius: '0',
      padding: '0',
      fontWeight: 'bold',
      margin: '0 0 0 5px',
      border: 0,
      textDecoration: 'underline' },


    success: {
      backgroundColor: 'transparent',
      color: '#468847' },


    error: {
      backgroundColor: 'transparent',
      color: '#B94A48' },


    warning: {
      backgroundColor: 'transparent',
      color: '#C09853' },


    info: {
      backgroundColor: 'transparent',
      color: '#3A87AD' } },


  Dismiss: { DefaultStyle: { display: 'none' } } };


/* harmony default export */ __webpack_exports__["default"] = (AppNotificationStyles);

/***/ }),

/***/ 6012:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return XPathProvider; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _XPathManager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2920);
/* harmony import */ var mobx__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(751);






/**
                                    * XPathProvider is the root context provider for XPath Components.
                                    *
                                    * XPath component create new xPath by using xPath of its ancestor.
                                    * Also consumers can control when to make an xPath visible by passing boolean value
                                    * to isVisible.
                                    *
                                    * That is why it becomes important to make the xPath context as observable so that any change
                                    * (in xPath or visibility) in an xPath can cause all its descendents to re-register (unregister)
                                    * themselves.
                                    *
                                    *
                                    */let


XPathProvider = class XPathProvider extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);
    this.xPathManager = Object(mobx__WEBPACK_IMPORTED_MODULE_3__["observable"])({
      register: _XPathManager__WEBPACK_IMPORTED_MODULE_2__["default"].register,
      unregister: _XPathManager__WEBPACK_IMPORTED_MODULE_2__["default"].unregister,
      path: props.identifier,
      isVisible: this.props.isVisible });

  }

  getChildContext() {
    return { xPathManager: this.xPathManager };
  }

  render() {
    return this.props.children;
  }};


XPathProvider.childContextTypes = { xPathManager: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.object };

XPathProvider.propTypes = { identifier: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.string };

XPathProvider.defaultProps = {
  isVisible: true };

/***/ }),

/***/ 6014:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return WorkspaceSwitcherContainer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(751);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2929);
/* harmony import */ var _external_navigation_ExternalNavigationService__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2388);
/* harmony import */ var _components_workspaces_WorkspaceSwitcher__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6015);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(749);
/* harmony import */ var _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(748);
/* harmony import */ var _modules_services_AuthHandlerService__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(3854);
/* harmony import */ var _modules_controllers_SyncWorkspaceController__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(779);
/* harmony import */ var _modules_controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(756);
/* harmony import */ var _modules_model_event__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(742);
/* harmony import */ var _modules_pipelines_user_action__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(2435);
/* harmony import */ var _constants_RequesterTabConstants__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(774);
/* harmony import */ var _models_services_DashboardService__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(3243);
/* harmony import */ var _constants_AppUrlConstants_js__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(3041);
/* harmony import */ var _components_base_XPaths_XPath__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(2955);
/* harmony import */ var _services_WorkspaceSwitchService__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(2696);
/* harmony import */ var _collaboration_services_DashboardService__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(6023);
/* harmony import */ var _modules_services_PermissionsService__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(6024);
var _class;




















const REFETCH_WORKSPACE_WAIT_TIME = 1000, // 1 sec
WINDOW_TYPE = {
  RUNNER: 'runner',
  REQUESTER: 'requester' };let



WorkspaceSwitcherContainer = Object(mobx_react__WEBPACK_IMPORTED_MODULE_2__["observer"])(_class = class WorkspaceSwitcherContainer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      activeTab: 'personal',
      isLoading: false,
      dataFetchedFirstTime: false, // will be set to true the first time API returns the data
      canViewTeamWorkspaces: false,
      personalWorkspaces: [],
      teamWorkspaces: [], // team workspaces that the user belongs to
      joinableWorkspaces: [], // team workspaces that the user can join
      joiningWorkspaceId: '' };


    this.handleToggle = this.handleToggle.bind(this);
    this.handleTabChange = this.handleTabChange.bind(this);
    this.handleSwitchWorkspace = this.handleSwitchWorkspace.bind(this);
    this.handleWorkspaceAction = this.handleWorkspaceAction.bind(this);
    this.handleSignIn = this.handleSignIn.bind(this);
    this.handleLearnMore = this.handleLearnMore.bind(this);
    this.handleProUpgradeClick = this.handleProUpgradeClick.bind(this);
    this.showWorkspacesFromLocalData = this.showWorkspacesFromLocalData.bind(this);
    this.refetchWorkspaces = _.debounce(this.refetchWorkspaces.bind(this), REFETCH_WORKSPACE_WAIT_TIME, { leading: true, trailing: false });
    this.handleWorkspaceJoin = this.handleWorkspaceJoin.bind(this);
  }

  componentDidMount() {
    // InitialHydration, read from db and assign the personal and joined workspaces
    _modules_controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_9__["default"].getAll().
    then((workspaces = []) => {
      let {
        personal,
        joined,
        joinable } =
      this.segregateWorkspaces(workspaces);

      this.setState({
        personalWorkspaces: personal || [],
        teamWorkspaces: joined || [], // team workspaces that the user belongs to
        joinableWorkspaces: joinable || [] // team workspaces that the user can join
      });
    }).
    catch(err => {
      pm.logger.error('WorkspaceSwitcherContainer~componentDidMount: Could not get data from db', err);
    });

    // This autorun is responsible for fetching the permission 'viewVisibleWorkspaceTeam'
    // An autorun is used instead of a reaction here as there could be a race condition where the socket is connected by teamID has not been hydrated yet
    this.fetchPermissionsAutorun = Object(mobx__WEBPACK_IMPORTED_MODULE_1__["autorun"])(() => {
      const isSocketConnected = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('SyncStatusStore').isSocketConnected,
      teamId = _.get(Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('CurrentUserStore'), 'team.id');

      if (!teamId) {
        return this.setState({ canViewTeamWorkspaces: false });
      }

      if (isSocketConnected) {
        Object(_modules_services_PermissionsService__WEBPACK_IMPORTED_MODULE_18__["fetchPermissions"])(['viewVisibleWorkspaceTeam']).
        then(({ viewVisibleWorkspaceTeam }) => {
          this.setState({ canViewTeamWorkspaces: viewVisibleWorkspaceTeam });
        });
      }
    });
  }

  componentWillUnmount() {
    // Dispose Reaction
    this.fetchPermissionsAutorun && this.fetchPermissionsAutorun();
  }

  getActiveStore() {
    let viewMode = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('ActiveWorkspaceSessionStore').viewMode;

    if (viewMode === _constants_RequesterTabConstants__WEBPACK_IMPORTED_MODULE_12__["WORKSPACE_BUILDER_VIEW"]) {
      return Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('ActiveWorkspaceStore');
    } else
    if (viewMode === _constants_RequesterTabConstants__WEBPACK_IMPORTED_MODULE_12__["WORKSPACE_BROWSER_VIEW"]) {
      return Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('ActiveBrowseWorkspaceStore');
    }
  }

  handleToggle(isOpen) {
    // do nothing if requested to close an already closed switcher
    if (!this.state.isOpen && !isOpen) {
      return;
    }

    let activeTab = this.getActiveStore().type || 'personal';
    this.setState({
      isOpen,
      activeTab },
    () => {
      // switcher was closed, bail
      if (!isOpen) {
        return;
      }

      _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_6__["default"].addEvent('workspace', 'view_workspace_list', 'workspace_switcher', null, activeTab);

      // otherwise try to re-fetch it from sync
      this.refetchWorkspaces();
    });
  }

  /**
     * Returns a list of workspaces into 3 category: personal, joined, joinable
     * @param {Array<Object>} workspaces
     * @returns {Object} having keys 'personal', 'joined', 'joinable' and value as array of workspace list
     */
  segregateWorkspaces(workspaces = []) {
    let currentUserId = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('CurrentUserStore').id,
    wsMemberPropertyPath = `members.users.${currentUserId}`,
    personal = [],
    joined = [],
    joinable = [];

    _.forEach(workspaces, ws => {
      if (!ws) {
        return;
      }

      switch (ws.type) {
        case 'personal':
          personal.push(ws);
          break;

        case 'team':
          _.get(ws, wsMemberPropertyPath) ?
          joined.push(ws) : joinable.push(ws);
          break;}

    });

    return {
      personal: _.sortBy(personal, [w => _.toLower(w.name)]),
      joined: _.sortBy(joined, [w => _.toLower(w.name)]),
      joinable: _.sortBy(joinable, [w => _.toLower(w.name)]) };

  }

  async showWorkspacesFromLocalData() {
    let allWorkspaces = await _modules_controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_9__["default"].getAll(),
    wsMap = this.segregateWorkspaces(allWorkspaces);

    this.setState({
      isLoading: false,
      personalWorkspaces: wsMap.personal,
      teamWorkspaces: wsMap.joined,
      joinableWorkspaces: [] });

  }

  refetchWorkspaces() {
    if (!this.state.isOpen) {
      return;
    }

    this.setState({
      isLoading: true });


    _modules_controllers_SyncWorkspaceController__WEBPACK_IMPORTED_MODULE_8__["default"].getAll().
    then(workspaces => {
      let wsMap = this.segregateWorkspaces(workspaces);

      this.setState({
        isLoading: false,
        dataFetchedFirstTime: true,
        personalWorkspaces: wsMap.personal,
        teamWorkspaces: wsMap.joined,
        joinableWorkspaces: wsMap.joinable });


      _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_6__["default"].addEvent('sync', 'get_workspaces', { source: 'workspace_switcher' });
    })

    // Could not get the data from sync, fallback to showing only the joined workspaces from local data
    .catch(() => {
      this.showWorkspacesFromLocalData();
    });
  }

  handleTabChange(activeTab) {
    this.setState({ activeTab });
    _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_6__["default"].addEvent('workspace', 'view_workspace_list', 'workspace_switcher', null, activeTab);
  }

  handleSwitchWorkspace(id) {
    let toBeSwitchedToWorkspaceInstance = pm.stores.WorkspaceStore.find(id),

    // workspace will only be not there in the store when it is an unjoined workspace,
    // and unjoined workspace is also a case of a team workspace
    analyticsLabel = toBeSwitchedToWorkspaceInstance && toBeSwitchedToWorkspaceInstance.type === 'personal' ? 'workspace_switcher_personal' : 'workspace_switcher_team';

    // On artemis unjoined workspace needs to be opened in dashboard and on App it needs to be opened in Browse mode
    if (window.SDK_PLATFORM === 'browser' && _.find(this.state.joinableWorkspaces, { id: id })) {
      Object(_collaboration_services_DashboardService__WEBPACK_IMPORTED_MODULE_17__["openWorkspace"])(id);
    } else
    {
      _services_WorkspaceSwitchService__WEBPACK_IMPORTED_MODULE_16__["default"].switchWorkspace(id).
      catch(e => {
        console.log('Error in switching workspace', e);
      });
    }


    this.handleToggle(false);
    _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_6__["default"].addEvent('workspace', 'switch_workspace', analyticsLabel, 1);
  }

  handleWorkspaceAction(workspace, action) {
    this.handleToggle(false);
    switch (action) {
      case 'create':
        pm.mediator.trigger('openCreateNewWorkspaceModal');
        break;
      case 'manage-all':
        Object(_models_services_DashboardService__WEBPACK_IMPORTED_MODULE_13__["manageWorkspaces"])();
        break;}

  }

  handleSignIn() {
    this.handleToggle(false);
    _modules_services_AuthHandlerService__WEBPACK_IMPORTED_MODULE_7__["default"].login();
  }

  handleProUpgradeClick() {
    let currentUser = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('CurrentUserStore'),
    quantity;

    if (currentUser.team) {
      quantity = _.get(currentUser, 'organizations[0].team_users').length;
    }

    quantity = quantity || 1;

    Object(_models_services_DashboardService__WEBPACK_IMPORTED_MODULE_13__["upgradeToPro"])({ quantity });

    this.handleToggle(false);
  }

  handleLearnMore() {
    this.handleToggle(false);

    Object(_external_navigation_ExternalNavigationService__WEBPACK_IMPORTED_MODULE_3__["openExternalLink"])(_constants_AppUrlConstants_js__WEBPACK_IMPORTED_MODULE_14__["WORKSPACE_DOCS"]);
  }

  handleWorkspaceJoin(workspaceId) {
    if (!workspaceId) {
      return;
    }

    let joinWorkspaceEvent = Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_10__["createEvent"])('join', 'workspace', { model: 'workspace', workspace: { id: workspaceId } });

    this.setState({
      joiningWorkspaceId: workspaceId });


    Object(_modules_pipelines_user_action__WEBPACK_IMPORTED_MODULE_11__["default"])(joinWorkspaceEvent).
    then(() => {
      // This is done because after join it takes time for workspace to be hydrated in local DB
      this.workspaceStoreReaction = Object(mobx__WEBPACK_IMPORTED_MODULE_1__["reaction"])(() => {
        return Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('WorkspaceStore').find(workspaceId);
      }, workspace => {
        // If user has closed the switcher, do not switch the workspace and set joiningWorkspaceId as empty string
        if (_.isEmpty(workspace) || !this.state.isOpen) {
          this.setState({ joiningWorkspaceId: '' });
          return this.workspaceStoreReaction && this.workspaceStoreReaction();
        }

        // Close the tab and set joiningWorkspaceId as empty string once workspace is present in DB
        this.setState({
          isOpen: false,
          joiningWorkspaceId: '' },
        () => {
          _services_WorkspaceSwitchService__WEBPACK_IMPORTED_MODULE_16__["default"].switchWorkspace(workspace.id);
          return this.workspaceStoreReaction && this.workspaceStoreReaction();
        });
      });
    }).
    catch(e => {
      this.setState({
        joiningWorkspaceId: '' });

    });
  }

  render() {
    let activeWorkspaceStore = this.getActiveStore();
    if (!activeWorkspaceStore) {
      return false;
    }

    let initialWorkspaces = {
      personalWorkspaces: this.state.personalWorkspaces,
      teamWorkspaces: this.state.teamWorkspaces,
      joinableWorkspaces: this.state.joinableWorkspaces },

    isOffline = !Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('SyncStatusStore').isSocketConnected,
    activeWindow = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('ActiveWindowStore').type;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_components_base_XPaths_XPath__WEBPACK_IMPORTED_MODULE_15__["default"], { identifier: 'workspaceDropdown' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_components_workspaces_WorkspaceSwitcher__WEBPACK_IMPORTED_MODULE_4__["default"], {
          isLoading: this.state.isLoading && !this.state.dataFetchedFirstTime,
          activeTab: this.state.activeTab,
          activeWorkspace: activeWorkspaceStore,
          isLoggedIn: Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('CurrentUserStore').isLoggedIn,
          canViewTeamWorkspaces: this.state.canViewTeamWorkspaces,
          isOpen: this.state.isOpen,
          initialWorkspaces: initialWorkspaces,
          onToggle: this.handleToggle,
          onSignIn: this.handleSignIn,
          onLearnMore: this.handleLearnMore,
          onTabChange: this.handleTabChange,
          onSwitchWorkspace: this.handleSwitchWorkspace,
          onWorkspaceAction: this.handleWorkspaceAction,
          onProUpgradeClick: this.handleProUpgradeClick,
          isOffline: isOffline,
          teamSyncEnabled: Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('CurrentUserStore').teamSyncEnabled,
          disableActions: activeWindow === WINDOW_TYPE.RUNNER,
          disableJoinableWorkspaces: activeWindow === WINDOW_TYPE.RUNNER,
          onJoin: this.handleWorkspaceJoin,
          joiningWorkspaceId: this.state.joiningWorkspaceId })));



  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6015:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return WorkspaceSwitcher; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _postman_react_click_outside__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2936);
/* harmony import */ var _postman_react_click_outside__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_postman_react_click_outside__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _base_Tabs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2957);
/* harmony import */ var _base_Buttons__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2934);
/* harmony import */ var _base_FuzzySearchInput__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(3658);
/* harmony import */ var _WorkspaceSwitcherList__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(6016);
/* harmony import */ var _containers_sync_SyncOfflineStatusContainer__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(6019);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_9___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_9__);
/* harmony import */ var _base_XPaths_XPath__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(2955);
/* harmony import */ var _base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(2974);
/* harmony import */ var _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(748);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(749);
/* harmony import */ var _collaboration_utils_util__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(6021);
/* harmony import */ var _collaboration_containers_PermissionDenied__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(6022);
/* harmony import */ var _postman_design_system__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(3051);
/* harmony import */ var _postman_design_system__WEBPACK_IMPORTED_MODULE_16___default = /*#__PURE__*/__webpack_require__.n(_postman_design_system__WEBPACK_IMPORTED_MODULE_16__);
var _dec, _class;
















let



WorkspaceSwitcher = (_dec = _postman_react_click_outside__WEBPACK_IMPORTED_MODULE_2___default()({ eventCapturingPhase: false }), _dec(_class = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class WorkspaceSwitcher extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      searchQuery: '',
      focusedWorkspace: '',
      filteredPersonalWorkspaces: [],
      filteredTeamWorkspaces: [],
      filteredJoinableWorkspaces: [] };


    this.handleSwitchWorkspace = this.handleSwitchWorkspace.bind(this);
    this.setFocusedWorkspace = this.setFocusedWorkspace.bind(this);
    this.handleSignIn = this.handleSignIn.bind(this);
    this.handleTabChange = this.handleTabChange.bind(this);
    this.handleLearnMore = this.handleLearnMore.bind(this);
    this.handleProUpgrade = this.handleProUpgrade.bind(this);
    this.handleFuzzySearch = this.handleFuzzySearch.bind(this);
    this.handleSearchClick = this.handleSearchClick.bind(this);
    this.handleKeyDown = this.handleKeyDown.bind(this);
    this.getToggle = this.getToggle.bind(this);
  }

  handleProUpgrade() {
    this.props.onProUpgradeClick && this.props.onProUpgradeClick();
  }

  handleClickOutside(e) {
    this.props.onToggle && this.props.onToggle(false) || _.noop;
  }

  handleAction(action) {
    this.props.onWorkspaceAction && this.props.onWorkspaceAction(null, action);
  }

  handleSwitchWorkspace(id) {
    this.props.onSwitchWorkspace && this.props.onSwitchWorkspace(id);
  }

  handleTabChange(activeTab) {
    this.setState({
      focusedWorkspace: '' },
    () => {
      _.isFunction(this.props.onTabChange) && this.props.onTabChange(activeTab);
    });
  }

  handleSignIn() {
    this.props.onSignIn && this.props.onSignIn();
  }

  handleLearnMore() {
    this.props.onLearnMore && this.props.onLearnMore();
  }

  handleFuzzySearch(searchQuery, searchResults) {
    this.setState({
      focusedWorkspace: '',
      searchQuery: searchQuery,
      filteredPersonalWorkspaces: _.intersection(_.get(this.props.initialWorkspaces, 'personalWorkspaces', []), searchResults),
      filteredTeamWorkspaces: _.intersection(_.get(this.props.initialWorkspaces, 'teamWorkspaces', []), searchResults),
      filteredJoinableWorkspaces: _.intersection(_.get(this.props.initialWorkspaces, 'joinableWorkspaces', []), searchResults) });

  }

  isButtonDisabled() {
    if (this.props.isOffline) {
      return true;
    }
    return false;
  }

  getToggle() {
    if (this.props.disable) {
      return _.noop;
    }

    this.setState({
      searchQuery: '',
      focusedWorkspace: '' });


    this.props.onToggle(!this.props.isOpen);
  }

  getSwitcherClasses() {
    return classnames__WEBPACK_IMPORTED_MODULE_9___default()({
      'workspace-switcher__active': !this.props.disable,
      'workspace-switcher__disabled': this.props.disable });

  }

  handleSearchClick() {
    _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_12__["default"].addEvent('workspace', 'filter_workspace', 'workspace_switcher', 1);
  }

  setFocusedWorkspace(id) {
    this.setState({ focusedWorkspace: id });
  }

  handleKeyDown(event) {
    let nextIndex,
    currentIndex,
    workspaces = [],
    workspacesLength;

    if (_.isEmpty(this.props.initialWorkspaces)) {
      return;
    }

    if (this.props.activeTab === 'personal') {
      if (!_.isEmpty(this.props.initialWorkspaces.personalWorkspaces)) {
        workspaces = this.state.searchQuery ? this.state.filteredPersonalWorkspaces : this.props.initialWorkspaces.personalWorkspaces;
      }
    } else
    if (this.props.activeTab === 'team') {
      if (!_.isEmpty(this.props.initialWorkspaces.teamWorkspaces) || !_.isEmpty(this.props.initialWorkspaces.joinableWorkspaces)) {
        let joinableWorkspaces = [],
        teamWorkspaces = this.state.searchQuery ? this.state.filteredTeamWorkspaces : this.props.initialWorkspaces.teamWorkspaces;

        if (!this.props.disableJoinableWorkspaces) {
          joinableWorkspaces = this.state.searchQuery ? this.state.filteredJoinableWorkspaces : this.props.initialWorkspaces.joinableWorkspaces;
        }

        workspaces = [...teamWorkspaces, ...joinableWorkspaces];
      }
    }

    workspacesLength = workspaces.length;

    if (!workspacesLength) {
      return;
    }

    currentIndex = workspaces.findIndex(x => x.id === this.state.focusedWorkspace);

    if (_collaboration_utils_util__WEBPACK_IMPORTED_MODULE_14__["default"].isArrowUpEvent(event.key)) {
      nextIndex = currentIndex === 0 ? workspacesLength - 1 : (currentIndex - 1) % workspacesLength;
      this.setFocusedWorkspace(workspaces[nextIndex].id);
    } else
    if (_collaboration_utils_util__WEBPACK_IMPORTED_MODULE_14__["default"].isArrowDownEvent(event.key)) {
      nextIndex = (currentIndex + 1) % workspacesLength;
      this.setFocusedWorkspace(workspaces[nextIndex].id);
    } else
    if (_collaboration_utils_util__WEBPACK_IMPORTED_MODULE_14__["default"].isEnterEvent(event.key) && this.state.focusedWorkspace) {
      this.handleSwitchWorkspace(this.state.focusedWorkspace);
    }
  }

  render() {
    let isLoggedIn = this.props.isLoggedIn,
    canViewTeamWorkspaces = this.props.canViewTeamWorkspaces,
    searchQuery = this.state.searchQuery,
    initialWorkspaces = this.props.initialWorkspaces,
    filteredWorkspacesBySearch = {
      personalWorkspaces: this.state.filteredPersonalWorkspaces,
      teamWorkspaces: this.state.filteredTeamWorkspaces,
      joinableWorkspaces: this.state.filteredJoinableWorkspaces },

    isLoading = this.props.isLoading,
    items = _.concat(initialWorkspaces.personalWorkspaces, initialWorkspaces.teamWorkspaces, initialWorkspaces.joinableWorkspaces),
    disableButton = this.isButtonDisabled();

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: this.getSwitcherClasses(),
            onClick: this.getToggle },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_postman_design_system__WEBPACK_IMPORTED_MODULE_16__["Icon"], {
            name: 'icon-entity-workspaces-stroke',
            className: 'workspace-switcher__icon pm-icon pm-icon-primary',
            color: 'content-color-constant' }),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
              className: 'workspace-switcher__name',
              title: this.props.activeWorkspace.name },

            _.truncate(this.props.activeWorkspace.name, { length: 40 }) || 'Loading..'),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_postman_design_system__WEBPACK_IMPORTED_MODULE_16__["Icon"], { name: 'icon-direction-down', size: 'large', className: 'workspace-switcher__icon pm-icon pm-icon-primary' })),


        this.props.isOpen &&
        !isLoggedIn &&

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__selector' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state__title' }, 'Sign in to create workspaces'),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state__description' }, 'Workspaces help you organize your collections and environments.'),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state__learn-more' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], {
                  type: 'text',
                  onClick: this.handleLearnMore }, 'Learn more about workspaces')),




            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state__primary-btn' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], {
                  type: 'primary',
                  size: 'large',
                  onClick: this.handleSignIn }, 'Sign in to create workspaces')))),









        this.props.isOpen &&
        isLoggedIn &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            tabIndex: '0',
            className: 'workspace-switcher__selector',
            onKeyDown: this.handleKeyDown },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__header' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Tabs__WEBPACK_IMPORTED_MODULE_4__["Tabs"], {
                activeRef: this.props.activeTab,
                className: 'workspace-switcher__tabs',
                defaultActive: 'personal',
                type: 'primary',
                onChange: this.handleTabChange },

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_XPaths_XPath__WEBPACK_IMPORTED_MODULE_10__["default"], { identifier: 'personal' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Tabs__WEBPACK_IMPORTED_MODULE_4__["Tab"], { className: 'workspace-switcher__tab', refKey: 'personal' },
                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'workspace-switcher__tab__title' }, 'Personal'))),


              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_XPaths_XPath__WEBPACK_IMPORTED_MODULE_10__["default"], { identifier: 'team' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Tabs__WEBPACK_IMPORTED_MODULE_4__["Tab"], { className: 'workspace-switcher__tab', refKey: 'team' },
                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'workspace-switcher__tab__title' }, 'Team')))),




            !this.props.disableActions &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__actions' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_XPaths_XPath__WEBPACK_IMPORTED_MODULE_10__["default"], { identifier: 'createNew' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], {
                    className:
                    classnames__WEBPACK_IMPORTED_MODULE_9___default()({
                      'workspace-switcher__action workspace-switcher__action--create': true,
                      'disable-component': disableButton }),


                    type: 'text',
                    onClick: this.handleAction.bind(this, 'create') }, 'Create New')),




              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_XPaths_XPath__WEBPACK_IMPORTED_MODULE_10__["default"], { identifier: 'allWorkspaces' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], {
                    className:
                    classnames__WEBPACK_IMPORTED_MODULE_9___default()({
                      'workspace-switcher__action workspace-switcher__action--manage': true,
                      'disable-component': disableButton }),


                    type: 'text',
                    onClick: this.handleAction.bind(this, 'manage-all') }, 'All workspaces')))),








          !isLoading && !(this.props.activeTab === 'team' && !this.props.isOffline &&
          this.props.teamSyncEnabled && !canViewTeamWorkspaces) &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__search' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_FuzzySearchInput__WEBPACK_IMPORTED_MODULE_6__["default"], {
              ref: 'fuzzySearch',
              searchQuery: searchQuery,
              placeholder: 'Search for a workspace',
              onChange: this.handleFuzzySearch,
              onClick: this.handleSearchClick,
              onKeyDown: this.handleKeyDown,
              items: items,
              searchFields: ['name'] })),




          this.props.activeTab === 'personal' &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list' },

            isLoading &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_11__["default"], null),


            !_.isEmpty(initialWorkspaces.personalWorkspaces) &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list__group' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_WorkspaceSwitcherList__WEBPACK_IMPORTED_MODULE_7__["default"], {
                focusedWorkspace: this.state.focusedWorkspace,
                setFocusedWorkspace: this.setFocusedWorkspace,
                onSwitchWorkspace: this.handleSwitchWorkspace,
                workspaces: searchQuery ? filteredWorkspacesBySearch.personalWorkspaces : initialWorkspaces.personalWorkspaces,
                activeWorkspace: this.props.activeWorkspace,
                onToggle: this.props.onToggle,
                disableActions: this.props.disableActions }))),






          this.props.activeTab === 'team' && !this.props.isOffline &&
          this.props.teamSyncEnabled && !canViewTeamWorkspaces &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_collaboration_containers_PermissionDenied__WEBPACK_IMPORTED_MODULE_15__["default"], null),


          this.props.activeTab === 'team' && !this.props.teamSyncEnabled &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state workspace-switcher__upgrade_to_pro' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state__title' }, 'Start collaborating in team workspaces'),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state__description' }, 'Team workspaces allow you to share and work together on your API collections with your colleagues.'),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state__primary-btn' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_XPaths_XPath__WEBPACK_IMPORTED_MODULE_10__["default"], { identifier: 'createNewTeam' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], {
                    type: 'primary',
                    size: 'large',
                    onClick: this.handleAction.bind(this, 'create') }, 'Create a team workspace')))),








          this.props.activeTab === 'team' && this.props.teamSyncEnabled &&
          canViewTeamWorkspaces &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_containers_sync_SyncOfflineStatusContainer__WEBPACK_IMPORTED_MODULE_8__["default"], { position: 'switcher' }),


            isLoading &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_11__["default"], null),


            !_.isEmpty(initialWorkspaces.teamWorkspaces) &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list__group' + (this.props.isOffline ? ' disable-component' : '') },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list__group__header' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'workspace-switcher__list__group__title' }, 'Workspaces you belong to')),



              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_WorkspaceSwitcherList__WEBPACK_IMPORTED_MODULE_7__["default"], {
                focusedWorkspace: this.state.focusedWorkspace,
                setFocusedWorkspace: this.setFocusedWorkspace,
                onSwitchWorkspace: this.handleSwitchWorkspace,
                workspaces: searchQuery ? filteredWorkspacesBySearch.teamWorkspaces : initialWorkspaces.teamWorkspaces,
                activeWorkspace: this.props.activeWorkspace,
                onToggle: this.props.onToggle,
                disableActions: this.props.disableActions })),




            !this.props.disableJoinableWorkspaces && !_.isEmpty(initialWorkspaces.joinableWorkspaces) &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list__group' + (this.props.isOffline ? ' disable-component' : '') },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list__group__header' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'workspace-switcher__list__group__title' }, 'Workspaces you can join')),



              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_WorkspaceSwitcherList__WEBPACK_IMPORTED_MODULE_7__["default"], {
                focusedWorkspace: this.state.focusedWorkspace,
                setFocusedWorkspace: this.setFocusedWorkspace,
                onSwitchWorkspace: this.handleSwitchWorkspace,
                workspaces: searchQuery ? filteredWorkspacesBySearch.joinableWorkspaces : initialWorkspaces.joinableWorkspaces,
                activeWorkspace: this.props.activeWorkspace,
                onToggle: this.props.onToggle,
                onJoin: this.props.onJoin,
                joiningWorkspaceId: this.props.joiningWorkspaceId,
                disableActions: this.props.disableActions }))))));









  }}) || _class) || _class);


WorkspaceSwitcher.propTypes = {
  onToggle: prop_types__WEBPACK_IMPORTED_MODULE_3___default.a.func.isRequired,
  initialWorkspaces: prop_types__WEBPACK_IMPORTED_MODULE_3___default.a.object.isRequired };
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6016:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return WorkspaceSwitcherList; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _WorkspaceSwitcherListItem__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6017);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2929);
var _class;


let


WorkspaceSwitcherList = Object(mobx_react__WEBPACK_IMPORTED_MODULE_2__["observer"])(_class = class WorkspaceSwitcherList extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.switcherRef;
    this.handleSwitchWorkspace = this.handleSwitchWorkspace.bind(this);
  }

  handleSwitchWorkspace(id) {
    this.props.onSwitchWorkspace && this.props.onSwitchWorkspace(id);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list__group__list' },

        _.isEmpty(this.props.workspaces) ?

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__no-result' }, 'No workspaces found') :





        _.map(this.props.workspaces, workspace => {
          return (
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_WorkspaceSwitcherListItem__WEBPACK_IMPORTED_MODULE_1__["default"], {
              isFocused: workspace.id === this.props.focusedWorkspace,
              setFocus: this.props.setFocusedWorkspace,
              onToggle: this.props.onToggle,
              onSelect: this.handleSwitchWorkspace,
              workspace: workspace,
              active: workspace.id === this.props.activeWorkspace.id,
              key: workspace.id,
              onJoin: this.props.onJoin,
              joiningWorkspaceId: this.props.joiningWorkspaceId,
              disableActions: this.props.disableActions }));


        })));




  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6017:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return WorkspaceSwitcherListItem; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _base_Buttons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2934);
/* harmony import */ var _WorkspaceActionDropdown__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6018);
/* harmony import */ var _base_Dropdowns__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2959);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(749);
/* harmony import */ var _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(748);
/* harmony import */ var _base_Icons_SuccessIcon__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(3220);
/* harmony import */ var _base_Tooltips__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(2935);
/* harmony import */ var _base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(2974);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;











let


WorkspaceSwitcherListItem = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class WorkspaceSwitcherListItem extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isActionsDropdownOpen: false,
      showTooltip: false };


    this.itemRef = null;
    this.userPreferenceForWorkspace = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_6__["getStore"])('UserPreferenceStore').find(`workspace:${this.props.workspace.id}:isHistoryAndRunsPulled`);
    this.isWorkspaceVisitedOnce = this.userPreferenceForWorkspace ? this.userPreferenceForWorkspace.value : true;
    this.syncStatusStore = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_6__["getStore"])('SyncStatusStore');

    this.handleSelect = this.handleSelect.bind(this);
    this.handleMouseEnter = this.handleMouseEnter.bind(this);
    this.handleDropdownToggle = this.handleDropdownToggle.bind(this);
    this.handleDropdownAction = this.handleDropdownAction.bind(this);
    this.toggleTooltip = this.toggleTooltip.bind(this);
    this.handleJoin = this.handleJoin.bind(this);
  }

  isSwitchingDisabled() {
    return !this.syncStatusStore.isSocketConnected && !this.isWorkspaceVisitedOnce;
  }

  handleJoin(e) {
    e && e.preventDefault();
    e && e.stopPropagation();

    !this.props.joiningWorkspaceId && this.props.onJoin && this.props.onJoin(_.get(this.props.workspace, 'id'));
  }

  getClasses() {
    return classnames__WEBPACK_IMPORTED_MODULE_2___default()({
      'workspace-switcher__list__group__list-item': true,
      'is-active': this.props.active,
      'is-hovered': this.state.isActionsDropdownOpen,
      'is-focused': this.props.isFocused,
      'is-disabled': this.isSwitchingDisabled() });

  }

  componentWillReceiveProps(newProps) {
    if (newProps.isFocused !== this.props.isFocused && newProps.isFocused) {
      this.scrollIntoView();
    }
  }

  handleSelect() {
    this.props.onSelect && !this.isSwitchingDisabled() && this.props.onSelect(this.props.workspace.id);
  }

  handleDropdownToggle(isOpen, e) {
    e && e.stopPropagation();
    e && e.preventDefault();

    this.setState({ isActionsDropdownOpen: isOpen });
  }

  handleDropdownAction() {
    this.props.onToggle && this.props.onToggle(false);
  }

  scrollIntoView() {
    this.itemRef &&
    _.isFunction(this.itemRef.scrollIntoView) &&
    this.itemRef.scrollIntoView({ block: 'nearest', inline: 'center' });
  }

  toggleTooltip() {
    this.setState(prevState => {
      return { showTooltip: !prevState.showTooltip };
    });
  }

  handleMouseEnter() {
    const id = _.get(this.props.workspace, 'id');

    _.isFunction(this.props.setFocus) && this.props.setFocus(id);
  }

  render() {
    const isSwitchingDisabled = this.isSwitchingDisabled();
    const tooltipProps = isSwitchingDisabled ? {
      ref: ref => this.workspaceItem = ref,
      onMouseEnter: this.toggleTooltip,
      onMouseLeave: this.toggleTooltip } :
    {},
    workspaceId = _.get(this.props.workspace, 'id');

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', _extends({
          ref: ref => this.itemRef = ref,
          className: this.getClasses(),
          onClick: this.handleSelect,
          onMouseEnter: this.handleMouseEnter },
        tooltipProps),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list__group__list-item__enabled' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Icons_SuccessIcon__WEBPACK_IMPORTED_MODULE_8__["default"], {
            className: 'workspace-switcher__list__group__list-item__enabled__icon',
            size: 'xs' })),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list__group__list-item__name' },
          this.props.workspace.name),


        !this.props.disableActions && !isSwitchingDisabled && this.props.onJoin &&

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], {
            className: 'workspace-switcher__join',
            type: 'text',
            size: 'large',
            disabled: this.props.joiningWorkspaceId,
            onClick: this.handleJoin },

          this.props.joiningWorkspaceId === workspaceId ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_10__["default"], null) : 'Join'),




        !this.props.disableActions && !isSwitchingDisabled && !(this.props.joiningWorkspaceId === workspaceId) &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_WorkspaceActionDropdown__WEBPACK_IMPORTED_MODULE_4__["default"], {
          workspaceId: this.props.workspace.id,
          onAction: this.handleDropdownAction,
          onToggle: this.handleDropdownToggle }),


        isSwitchingDisabled &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Tooltips__WEBPACK_IMPORTED_MODULE_9__["Tooltip"], {
            show: this.state.showTooltip,
            target: this.workspaceItem,
            placement: 'right',
            immediate: true },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Tooltips__WEBPACK_IMPORTED_MODULE_9__["TooltipBody"], null, 'You need to be online to switch to this workspace.'))));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6018:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return WorkspaceActionDropdown; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _base_Buttons__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2934);
/* harmony import */ var _base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2959);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(749);
/* harmony import */ var _base_Icons_MoreIcon__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(3290);
/* harmony import */ var _utils_uuid_helper__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2401);
/* harmony import */ var _modules_controllers_SyncWorkspaceController__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(779);
/* harmony import */ var _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(748);
/* harmony import */ var _services_UIEventService__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(2921);
/* harmony import */ var _constants_UIEventConstants__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(2922);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(2929);
/* harmony import */ var _constants_MoreButtonTooltipConstant__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(3632);
var _class;











let


WorkspaceActionDropdown = Object(mobx_react__WEBPACK_IMPORTED_MODULE_10__["observer"])(_class = class WorkspaceActionDropdown extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = { isDefaultWorkspace: false };

    this.handleItemSelect = this.handleItemSelect.bind(this);
    this.handleShareWorkspace = this.handleShareWorkspace.bind(this);
  }

  UNSAFE_componentWillMount() {
    this.setDefaultWorkspace();
  }

  setDefaultWorkspace() {
    let currentUser = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('CurrentUserStore'),
    workspace = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('WorkspaceStore').find(this.props.workspaceId),
    defaultUserWorkspaceId = Object(_utils_uuid_helper__WEBPACK_IMPORTED_MODULE_5__["deterministicUUID"])(`user:${currentUser.id}`),
    defaultTeamWorkspaceId = null;

    if (workspace && workspace.id === defaultUserWorkspaceId) {
      this.setState({ isDefaultWorkspace: true });
      return;
    }

    let teamId = _.get(currentUser, 'team.id', null);
    if (teamId) {
      defaultTeamWorkspaceId = Object(_utils_uuid_helper__WEBPACK_IMPORTED_MODULE_5__["deterministicUUID"])(`team:${teamId}`);

      if (this.props.workspaceId === defaultTeamWorkspaceId) {
        this.setState({ isDefaultWorkspace: true });
      }
    }
  }

  handleShareWorkspace() {
    let workspaceId = this.props.workspaceId,
    workspace = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('WorkspaceStore').find(workspaceId),
    currentUser = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('CurrentUserStore');

    if (workspace.type === 'personal' && (this.state.isDefaultWorkspace || currentUser.isFreeUser)) {
      _services_UIEventService__WEBPACK_IMPORTED_MODULE_8__["default"].publish(_constants_UIEventConstants__WEBPACK_IMPORTED_MODULE_9__["OPEN_INVITE_MODAL"], { workspaceId, source: 'share_ws' });
      return;
    }

    pm.mediator.trigger('openShareWorkspaceModal', workspaceId);
  }

  handleItemSelect(item) {
    let { workspaceId } = this.props,
    workspace = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('WorkspaceStore').find(workspaceId);
    if (!workspace && item !== 'details') {
      pm.mediator.trigger('joinWorkspace', workspaceId);
      return;
    }
    switch (item) {
      case 'details':
        _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEvent('workspace', 'view_details');

        pm.mediator.trigger('openWorkspaceDetailsModal', workspaceId);
        break;

      case 'manageMembers':
      case 'share':
        this.handleShareWorkspace(item);
        break;

      case 'rename':
      case 'addMembers':
      case 'description':
        pm.mediator.trigger('openEditWorkspaceModal', workspaceId);
        break;

      case 'delete':
        pm.mediator.trigger('showWorkspaceDeleteModal', workspaceId);
        break;
      case 'leave':
        pm.mediator.trigger('showWorkspaceLeaveModal', workspaceId);
        break;
      default:
        break;}

    this.props.onAction && this.props.onAction(item);
  }

  getDisabledState() {
    let isOffline = !Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('SyncStatusStore').isSocketConnected;
    if (isOffline) {
      return {
        active: true,
        text: 'You need to be online to perform these actions on the workspace.' };

    }

    return { active: false };
  }

  getShareDisabledStatus() {
    let disabledState = this.getDisabledState();
    if (disabledState.active) {
      return {
        isShareDisabled: true,
        shareDisableText: disabledState.text };

    }

    return { isShareDisabled: false, shareDisableText: '' };
  }

  getDeleteDisabledStatus() {
    let disabledState = this.getDisabledState();

    if (disabledState.active) {
      return {
        isDeleteDisabled: true,
        deleteDisableText: disabledState.text };

    }

    // Bootstrapped workspace cannot be deleted
    if (this.state.isDefaultWorkspace) {
      return {
        isDeleteDisabled: true,
        deleteDisableText: 'You cannot delete this workspace.' };

    }

    return { isDeleteDisabled: false, deleteDisableText: '' };
  }

  render() {
    let isOffline = !Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('SyncStatusStore').isSocketConnected,
    disabledState = this.getDisabledState(isOffline),
    workspace = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('WorkspaceStore').find(this.props.workspaceId),
    { isShareDisabled, shareDisableText } = this.getShareDisabledStatus(),
    { isDeleteDisabled, deleteDisableText } = this.getDeleteDisabledStatus();

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["Dropdown"], {
          className: 'workspace-actions-dropdown',
          onSelect: this.handleItemSelect,
          onToggle: this.props.onToggle },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["DropdownButton"], {
            dropdownStyle: 'nocaret',
            type: 'custom' },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_1__["Button"], {
              type: 'icon',
              className: 'workspace-actions-dropdown-button',
              tooltip: _constants_MoreButtonTooltipConstant__WEBPACK_IMPORTED_MODULE_11__["ACTION_TYPE_VIEW_MORE_ACTIONS_TOOLTIP"] },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Icons_MoreIcon__WEBPACK_IMPORTED_MODULE_4__["default"], null))),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["DropdownMenu"], { 'align-right': true },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], { refKey: 'details' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'View Details')),


          workspace && workspace.type === 'personal' &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
              disabled: isShareDisabled,
              disabledText: shareDisableText,
              tooltipPlacement: this.props.tooltipPlacement,
              refKey: 'share' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'Invite to Workspace')),


          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
              disabled: disabledState.active,
              disabledText: disabledState.text,
              refKey: 'rename' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'Rename')),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
              disabled: disabledState.active,
              disabledText: disabledState.text,
              refKey: 'description' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'Edit Workspace')),


          workspace && workspace.type === 'team' &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
              disabled: disabledState.active,
              disabledText: disabledState.text,
              refKey: 'addMembers' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'Add Members')),



          workspace && workspace.type !== 'personal' &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
              disabled: disabledState.active,
              disabledText: disabledState.text,
              refKey: 'manageMembers' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'Invite to Workspace')),



          workspace && workspace.type !== 'personal' &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
              disabled: disabledState.active,
              disabledText: disabledState.text,
              refKey: 'leave' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'Leave')),


          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
              disabled: isDeleteDisabled,
              disabledText: deleteDisableText,
              tooltipPlacement: this.props.tooltipPlacement,
              refKey: 'delete' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'Delete')))));




  }}) || _class;


WorkspaceActionDropdown.defaultProps = { tooltipPlacement: 'right' };
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6019:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return SyncOfflineStatusBarContainer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _components_sync_SyncOfflineStatusBar__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6020);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(749);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2929);
/* harmony import */ var _constants_RequesterTabConstants__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(774);
var _class;





const config = {
  switcher: {
    default: {
      offline: 'You need to have an active internet connection to be able to switch to or create a workspace.',
      connecting: 'Trying to reconnect to sync.' } },


  builder: {
    default: {
      offline: 'You seem to be offline. Any changes made while offline might not sync properly with other members of this workspace.',
      connecting: 'Trying to reconnect to sync... Any changes made while offline will sync once you are back online..' },

    personal: {
      offline: 'You seem to be offline. Data in this workspace might not be up to date.' } } };let





SyncOfflineStatusBarContainer = Object(mobx_react__WEBPACK_IMPORTED_MODULE_3__["observer"])(_class = class SyncOfflineStatusBarContainer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);
  }

  getMessage(position, status, workspaceType) {
    const data = config[position];
    const defaultMessages = data.default;

    return _.get(data, [workspaceType, status]) || defaultMessages[status];
  }

  render() {
    let currentSyncStatus = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_2__["getStore"])('SyncStatusStore').currentSyncStatus,
    notInSync = !Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_2__["getStore"])('SyncStatusStore').isSocketConnected,
    status;

    if (currentSyncStatus === 'connecting') {
      status = 'connecting';
    } else if (!_.includes('insync', 'syncing', 'idle'), currentSyncStatus) {
      status = 'offline';
    }

    let isOpen = notInSync &&
    !(Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_2__["getStore"])('ActiveWorkspaceSessionStore').viewMode === _constants_RequesterTabConstants__WEBPACK_IMPORTED_MODULE_4__["WORKSPACE_BROWSER_VIEW"] && status === 'offline' && this.props.position === 'builder');

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_components_sync_SyncOfflineStatusBar__WEBPACK_IMPORTED_MODULE_1__["default"], {
        isOpen: isOpen,
        status: status,
        message: this.getMessage(this.props.position, status, Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_2__["getStore"])('ActiveWorkspaceStore').type) }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6020:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _base_Infobar__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(3716);
/* harmony import */ var _constants_InfobarConstants__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2424);




const infoBarType = {
  'connecting': _constants_InfobarConstants__WEBPACK_IMPORTED_MODULE_2__["WARN"],
  'offline': _constants_InfobarConstants__WEBPACK_IMPORTED_MODULE_2__["ERROR"] };let


SyncOfflineStatusBar = class SyncOfflineStatusBar extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  render() {
    return (
      this.props.isOpen &&
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Infobar__WEBPACK_IMPORTED_MODULE_1__["default"], {
        type: infoBarType[this.props.status],
        message: this.props.message,
        isDismissable: false,
        className: 'sync-offline-status-bar' }));


  }};


/* harmony default export */ __webpack_exports__["default"] = (SyncOfflineStatusBar);

/***/ }),

/***/ 6021:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony default export */ __webpack_exports__["default"] = ({
  /**
                  * Check if the keyboard event key name
                  * is ArrowUp, or Up in older versions of IE/Edge
                  *
                  * @param {String} key - KeyboardEvent.key
                  * @returns {boolean} - true if key is ArrowUp/Up
                  */
  isArrowUpEvent(key) {
    return key === 'ArrowUp' || key === 'Up';
  },

  /**
      * Check if the keyboard event key name
      * is ArrowDown, or Down in older versions of IE/Edge
      *
      * @param {String} key - KeyboardEvent.key
      * @returns {boolean} - true if key is ArrowDown/Down
      */
  isArrowDownEvent(key) {
    return key === 'ArrowDown' || key === 'Down';
  },

  /**
      * Check if the keyboard event key name is Enter
      * also labelled as Return in few keyboards
      *
      * @param {String} key - KeyboardEvent.key
      * @returns {boolean} - true if key is Enter
      */
  isEnterEvent(key) {
    return key === 'Enter';
  } });

/***/ }),

/***/ 6022:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);


const PermissionDenied = ({ title, subtitle }) => {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'permission-denied' },
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'permission-denied--img' }),
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'permission-denied--title' },
        title || 'You don\'t have permissions to view this page'),

      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'permission-denied--subtitle' },
        subtitle || 'Only users with a developer role can view or join team workspaces. Contact your team admin to make sure you have the proper roles.')));



};

/* harmony default export */ __webpack_exports__["default"] = (PermissionDenied);

/***/ }),

/***/ 6023:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "openWorkspace", function() { return openWorkspace; });
/* harmony import */ var _js_modules_services_APIService__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2386);


/**
                                                                                * Open workspace
                                                                                *
                                                                                * @param {String} id - workspace ID
                                                                                */
function openWorkspace(id) {
  Object(_js_modules_services_APIService__WEBPACK_IMPORTED_MODULE_0__["openAuthenticatedRoute"])(`${pm.dashboardUrl}/workspaces/${id}`);
}



/***/ }),

/***/ 6024:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchPermissions", function() { return fetchPermissions; });
/* harmony import */ var _PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6025);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(749);
/* harmony import */ var _utils_util__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(784);
/* harmony import */ var _controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(756);





const PERMISSION_HANDLER_MAP = {

  /**
                                  * Checks if user has permission to add member to the workspace
                                  *
                                  * @param { String } workspaceId
                                  *
                                  * @returns { Boolean }
                                  */
  addMemberToWorkspace: async workspaceId => {
    let { type } = await _controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_3__["default"].get({ id: workspaceId });

    if (!Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore').team || type === 'personal') {
      return true;
    }

    try {
      return _.get((await Object(_PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__["fetchAddMemberToWorkspaces"])([workspaceId])), `${workspaceId}.allowed`, true);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to remove member to the workspace
      *
      * @param { String } workspaceId
      *
      * @returns { Boolean }
      */
  removeMemberFromWorkspace: async workspaceId => {
    let { type } = await _controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_3__["default"].get({ id: workspaceId });

    if (!Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore').team || type === 'personal') {
      return true;
    }

    try {
      return _.get((await Object(_PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__["fetchRemoveMemberFromWorkspaces"])([workspaceId])), `${workspaceId}.allowed`, true);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to update roles in the workspace
      *
      * @param { String } workspaceId
      *
      * @returns { Boolean }
      */
  updateWorkspaceRoles: async workspaceId => {
    let { type } = await _controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_3__["default"].get({ id: workspaceId });

    if (!Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore').team || type === 'personal') {
      return true;
    }

    try {
      return _.get((await Object(_PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__["fetchUpdateWorkspacesRoles"])([workspaceId])), `${workspaceId}.allowed`, true);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to update workspace meta
      *
      * @param { String } workspaceId
      *
      * @returns { Boolean }
      */
  updateWorkspaceMeta: async workspaceId => {
    let { type } = await _controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_3__["default"].get({ id: workspaceId });

    if (!Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore').team || type === 'personal') {
      return true;
    }

    try {
      return _.get((await Object(_PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__["fetchUpdateWorkspacesMeta"])([workspaceId])), `${workspaceId}.allowed`, true);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to send preapproved invites in a team
      *
      * @returns { Boolean }
      */
  manageTeamInvites: async () => {
    const user = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore'),
    teamId = _.get(user, 'team.id');

    // A free user or the one for which the trial has been activated
    // can invite users outside the team.
    if (_utils_util__WEBPACK_IMPORTED_MODULE_2__["default"].isFreeUser(user) || _utils_util__WEBPACK_IMPORTED_MODULE_2__["default"].isTrialActive(user)) {
      return true;
    }

    try {
      return _.get((await Object(_PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__["fetchManageTeamInvites"])(teamId)), `${teamId}.allowed`, true);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to send unapproved invites in a team
      *
      * @returns { Boolean }
      */
  sendUnapprovedInvites: async () => {
    const user = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore'),
    teamId = _.get(user, 'team.id');

    try {
      return _.get((await Object(_PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__["fetchSendUnapprovedInvites"])(teamId)), `${teamId}.allowed`, false);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to manage payments in a team
      *
      * @returns { Boolean }
      */
  managePayment: async () => {
    const user = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore'),
    teamId = _.get(user, 'team.id');

    if (!Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore').isUserDelinquent) {
      return true;
    }

    try {
      return _.get((await Object(_PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__["fetchManagePayment"])(teamId)), `${teamId}.allowed`, false);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to view team workspaces
      *
      * @returns { Boolean }
      */
  viewVisibleWorkspaceTeam: async () => {
    const user = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore'),
    teamId = _.get(user, 'team.id');

    try {
      return _.get((await Object(_PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__["fetchViewVisibleWorkspaceTeam"])(teamId)), `${teamId}.allowed`, false);
    }
    catch (e) {
      console.warn(e);

      return false;
    }
  } };


/**
        * Fetches permission status for an array of permissions
        * Check individual handlers for function definition
        *
        * @param { String[] } permissions
        * @param { String } entityId
        */
async function fetchPermissions(permissions = [], entityId) {
  let permissionStatus = {};

  permissionStatus = await Promise.all(
  _.map(permissions, async permission => {
    if (!PERMISSION_HANDLER_MAP[permission]) {
      console.warn(`${permission} permission does not exist`);

      return {
        name: permission,
        allowed: false };

    }

    return {
      name: permission,
      allowed: await PERMISSION_HANDLER_MAP[permission](entityId) };

  }));


  return _.reduce(permissionStatus, (acc, permission) => {
    acc[permission.name] = permission.allowed;

    return acc;
  }, {});
}
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6025:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchAddCollectionToWorkspaces", function() { return fetchAddCollectionToWorkspaces; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchAddMemberToWorkspaces", function() { return fetchAddMemberToWorkspaces; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchRemoveMemberFromWorkspaces", function() { return fetchRemoveMemberFromWorkspaces; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchUpdateWorkspacesMeta", function() { return fetchUpdateWorkspacesMeta; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchUpdateWorkspacesRoles", function() { return fetchUpdateWorkspacesRoles; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchCollectionManageRole", function() { return fetchCollectionManageRole; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchCollectionShare", function() { return fetchCollectionShare; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchAddEnvironmentToWorkspaces", function() { return fetchAddEnvironmentToWorkspaces; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchEnvironmentShare", function() { return fetchEnvironmentShare; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchEnvironmentManageRole", function() { return fetchEnvironmentManageRole; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchAddAPIToWorkspaces", function() { return fetchAddAPIToWorkspaces; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchAPIManageRole", function() { return fetchAPIManageRole; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchAPIShare", function() { return fetchAPIShare; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchSendUnapprovedInvites", function() { return fetchSendUnapprovedInvites; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchManageTeamInvites", function() { return fetchManageTeamInvites; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchManagePayment", function() { return fetchManagePayment; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchViewVisibleWorkspaceTeam", function() { return fetchViewVisibleWorkspaceTeam; });
/* harmony import */ var _constants_ACConstants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2443);
/* harmony import */ var _controllers_UserController__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2383);
/* harmony import */ var _SyncRemoteFetcherService__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(762);




const {
  ADD_COLLECTION_TO_WORKSPACE,
  ADD_ENVIRONMENT_TO_WORKSPACE,
  ADD_MEMBER_TO_WORKSPACE,
  REMOVE_MEMBER_FROM_WORKSPACE,
  UPDATE_WORKSPACE_META,
  UPDATE_WORKSPACE_ROLES,
  UPDATE_COLLECTION_ROLES,
  UPDATE_ENVIRONMENT_ROLES,
  SHARE_COLLECTION,
  SHARE_ENVIRONMENT } =
_constants_ACConstants__WEBPACK_IMPORTED_MODULE_0__["default"],

// @todo: Move these permissions as imports from ACConstants once the file is updated
// by @product-core
ADD_API_TO_WORKSPACE = 'ADD_API_TO_WORKSPACE',
SHARE_API = 'SHARE_API',
UPDATE_API_ROLES = 'UPDATE_API_ROLES',
WORKSPACE = 'workspace',
COLLECTION = 'collection',
ENVIRONMENT = 'environment',
API = 'api',
USER = 'user',
TEAM = 'team',
MANAGE_TEAM_INVITES = 'MANAGE_TEAM_INVITES',
SEND_UNAPPROVED_INVITES = 'SEND_UNAPPROVED_INVITES',
MANAGE_PAYMENTS = 'MANAGE_PAYMENTS',
VIEW_VISIBLE_WORKSPACE_TEAM = 'VIEW_VISIBLE_WORKSPACE_TEAM';

/**
                                                              * Fetches the permission for a list of models
                                                              *
                                                              * @private
                                                              * @param {String} permission
                                                              * @param {Object} options
                                                              * @param {Array<Object>} options.modelIds
                                                              * @param {String} options.modelType
                                                              * @returns Promise<{ permissions: object[] }>
                                                              */
async function _fetchPerObject(permission, options) {
  let { modelIds, modelType } = options,
  { id: userId } = await _controllers_UserController__WEBPACK_IMPORTED_MODULE_1__["default"].get(),
  criteria = _.transform(modelIds, (acc, modelId) => {
    acc[modelId] = {
      entityType: USER,
      entityId: userId,
      permission,
      objectType: modelType,
      objectId: modelId };

  }, {});

  return _SyncRemoteFetcherService__WEBPACK_IMPORTED_MODULE_2__["default"].
  remoteFetch('permission', 'fetchPerObject', criteria);
}

/**
   * Fetches the permission status for adding a collection to a workspaces
   * for a given list of workspaces
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchAddCollectionToWorkspaces(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchAddCollectionToWorkspace: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(ADD_COLLECTION_TO_WORKSPACE, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for adding a member to the workspace
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchAddMemberToWorkspaces(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchAddMemberToWorkspaces: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(ADD_MEMBER_TO_WORKSPACE, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for removing a member from the workspace
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchRemoveMemberFromWorkspaces(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchRemoveMemberFromWorkspaces: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(REMOVE_MEMBER_FROM_WORKSPACE, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for updating workspace meta
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchUpdateWorkspacesMeta(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchUpdateWorkspacesMeta: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(UPDATE_WORKSPACE_META, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for updating workspace roles
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchUpdateWorkspacesRoles(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchUpdateWorkspacesRoles: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(UPDATE_WORKSPACE_ROLES, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}


/**
   * Fetches the permission status for managing roles on a collection
   *
   * @param {String} collectionUID
   * @returns Promise<{ results: object[] }>
   */
function fetchCollectionManageRole(collectionUID) {
  if (!collectionUID) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchUpdateWorkspacesRoles: No collection UID provided'));
  }

  let options = { modelIds: [collectionUID], modelType: COLLECTION };

  return _fetchPerObject(UPDATE_COLLECTION_ROLES, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for sharing a collection
   *
   * @param {String} collectionUID
   * @returns Promise<{ results: object[] }>
   */
function fetchCollectionShare(collectionUID) {
  if (!collectionUID) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchUpdateWorkspacesRoles: No collection UID provided'));
  }

  let options = { modelIds: [collectionUID], modelType: COLLECTION };

  return _fetchPerObject(SHARE_COLLECTION, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for adding a environment to a workspaces
   * for a given list of workspaces
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchAddEnvironmentToWorkspaces(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchAddEnvironmentToWorkspaces: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(ADD_ENVIRONMENT_TO_WORKSPACE, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for sharing a environment
   *
   * @param {String} environmentUID
   * @returns Promise<{ results: object[] }>
   */
function fetchEnvironmentShare(environmentUID) {
  if (!environmentUID) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchEnvironmentShare: No environment UID provided'));
  }

  let options = { modelIds: [environmentUID], modelType: ENVIRONMENT };

  return _fetchPerObject(SHARE_ENVIRONMENT, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for managing roles on a environment
   *
   * @param {String} environmentUID
   * @returns Promise<{ results: object[] }>
   */
function fetchEnvironmentManageRole(environmentUID) {
  if (!environmentUID) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchEnvironmentManageRole: No environment UID provided'));
  }

  let options = { modelIds: [environmentUID], modelType: ENVIRONMENT };

  return _fetchPerObject(UPDATE_ENVIRONMENT_ROLES, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for adding an API to a workspaces
   * for a given list of workspaces
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchAddAPIToWorkspaces(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchAddAPIToWorkspaces: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(ADD_API_TO_WORKSPACE, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}


/**
   * Fetches the permission status for managing roles on an API
   *
   * @param {String} apiId
   * @returns Promise<{ results: object[] }>
   */
function fetchAPIManageRole(apiId) {
  if (!apiId) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchAPIManageRole: No API ID provided'));
  }

  let options = { modelIds: [apiId], modelType: API };

  return _fetchPerObject(UPDATE_API_ROLES, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for sharing an API
   *
   * @param {String} apiId
   * @returns Promise<{ results: object[] }>
   */
function fetchAPIShare(apiId) {
  if (!apiId) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchAPIShare: No API ID provided'));
  }

  let options = { modelIds: [apiId], modelType: API };

  return _fetchPerObject(SHARE_API, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
  * Fetches permission status for send unapproved invites
  * @param { String } teamId
  * @returns Promise<{ results: object[] }>
  */
function fetchSendUnapprovedInvites(teamId) {
  if (!teamId) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchSendUnapprovedInvites: No team id provided'));
  }

  let options = { modelIds: [teamId], modelType: TEAM };

  return _fetchPerObject(SEND_UNAPPROVED_INVITES, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
  * Fetches permission status for send preapproved invites
  * @param { String } teamId
  * @returns Promise<{ results: object[] }>
  */
function fetchManageTeamInvites(teamId) {
  if (!teamId) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchManageTeamInvites: No team id provided'));
  }

  let options = { modelIds: [teamId], modelType: TEAM };

  return _fetchPerObject(MANAGE_TEAM_INVITES, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
  * Fetches permission status for managing payment
  * @param { String } teamId
  * @returns Promise<{ results: object[] }>
  */
function fetchManagePayment(teamId) {
  if (!teamId) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchManagePayment: No team id provided'));
  }

  let options = { modelIds: [teamId], modelType: TEAM };

  return _fetchPerObject(MANAGE_PAYMENTS, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
  * Fetches permission status for viewing team workspaces
  * @param { String } teamId
  * @returns Promise<{ results: object[] }>
  */
function fetchViewVisibleWorkspaceTeam(teamId) {
  if (!teamId) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchViewVisibleWorkspaceTeam: No team id provided'));
  }

  let options = { modelIds: [teamId], modelType: TEAM };

  return _fetchPerObject(VIEW_VISIBLE_WORKSPACE_TEAM, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6029:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return Explorer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ExplorerRow__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6030);
/* harmony import */ var _ExplorerSearch__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6032);
/* harmony import */ var _ExplorerResults__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6033);
/* harmony import */ var _ExplorerCreateRow__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6035);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2929);
/* harmony import */ var _base_Icons_LeftSolidIcon__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(2971);
/* harmony import */ var _collections_CollectionForkLabel__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(5239);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_8___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_8__);
/* harmony import */ var _base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(2974);
var _class;










let defaultSelection = {
  id: null,
  depth: -1 };let



Explorer = Object(mobx_react__WEBPACK_IMPORTED_MODULE_5__["observer"])(_class = class Explorer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      targets: [],
      selected: defaultSelection,
      filter: '',
      isCreating: false };


    this.setTargets = this.setTargets.bind(this);
    this.setTargetsDebounced = _.debounce(this.setTargets, 300);
    this.isLeaf = this.isLeaf.bind(this);
    this.getNextTargets = this.getNextTargets.bind(this);
    this.setNextTargets = this.setNextTargets.bind(this);
    this.handleSelect = this.handleSelect.bind(this);
    this.handleBack = this.handleBack.bind(this);
    this.handleSearch = this.handleSearch.bind(this);
    this.handleCreate = this.handleCreate.bind(this);
    this.handleStartCreate = this.handleStartCreate.bind(this);
    this.handleCancelCreate = this.handleCancelCreate.bind(this);
  }

  UNSAFE_componentWillMount() {
    this.setTargets();
  }

  UNSAFE_componentWillReceiveProps(nextProps) {
    if (_.isEqual(this.props.targets, nextProps.targets)) {
      return;
    }

    // hackk implementation for new collection/folder added
    if (nextProps.newTargetId && this.props.newTargetId === undefined) {
      let selected = _.find(nextProps.targets, target => {
        return _.isEqual(target.id, nextProps.newTargetId);
      });

      this.props.onSelect && this.props.onSelect(selected);
      this.setState({ selected: selected }, () => {
        this.setNextTargets(nextProps.targets, selected);
      });

      return;
    }

    this.setNextTargets(nextProps.targets, this.state.selected);
  }

  /**
     * find parent of the currently selected parent when going back
     */
  getSelectionParent() {
    let selected = this.state.selected,
    targets = this.props.targets,
    selectedIndex = _.findIndex(targets, ['id', selected.id]);

    if (selectedIndex === -1) {
      return this.state.selected;
    }

    let parentIndex = _.chain(targets).
    slice(0, selectedIndex).
    findLastIndex(['depth', selected.depth - 1]).
    value();

    if (parentIndex === -1) {
      return defaultSelection;
    }

    return this.props.targets[parentIndex];
  }

  setTargets(targets = this.props.targets) {
    this.setNextTargets(targets);
  }

  isLeaf(targets, node) {
    if (this.props.isLeaf) {
      return this.props.isLeaf(node);
    } else
    {
      let nextTargets = this.getNextTargets(targets, node);
      return !_.size(nextTargets);
    }
  }

  /**
     * get the next list of collections/folders as per the selected collection/folder
     * @param {Array} currentTargets - list of flattened collections and folders
     * @param {Object} selectedTarget - selected collection/folder
     */
  getNextTargets(currentTargets, selectedTarget) {
    // find index of the selected target from the array of currentTargets
    let selectedTargetIndex = _.findIndex(currentTargets, ['id', selectedTarget.id]);

    // handle in case there is no selected collection(when we initially open the modal to save request)
    if (selectedTargetIndex === -1) {
      this.setState({ selected: defaultSelection });
      return currentTargets;
    }

    // find index of the next collection/folder at same depth as the selectedTarget
    let endIndex = _.findIndex(currentTargets, n => {return n.depth <= currentTargets[selectedTargetIndex].depth;}, selectedTargetIndex + 1);

    // handle in case there is no next collection/folder having same depth in the currentTargets
    if (endIndex === -1) {
      endIndex = _.size(currentTargets);
    }

    // return the list of selected target tree
    return _.slice(currentTargets, selectedTargetIndex + 1, endIndex);
  }

  /**
     * set the next list of collections/folders as per the selected collection/folder
     * @param {Array} currentTargets - list of flattened collections and folders
     * @param {Object} selectedTarget - selected collection/folder
     */
  setNextTargets(currentTargets, selectedTarget = defaultSelection) {
    let nextTargets = this.getNextTargets(currentTargets, selectedTarget);

    this.setState({ targets: nextTargets });
  }

  /**
     * get the next targets on select of any collection/folder
     * @param {Object} target
     * @param {*} isLeaf
     */

  handleSelect(target, isLeaf = false) {
    if (this.props.disableLeaves && isLeaf) {
      return;
    }
    let nextTargets = this.getNextTargets(this.props.targets, target);

    this.setState({
      selected: target,
      filter: '',
      targets: nextTargets },
    () => {
      this.handleCancelCreate && this.handleCancelCreate();
      this.props.onSelect && this.props.onSelect(target);
    });
  }

  /**
     * go back one level up in the directory tree,fetch the parent of the selected target along with the next targets
     */
  handleBack() {
    let selected = this.getSelectionParent(),
    nextTargets = this.getNextTargets(this.props.targets, selected);

    this.setState({
      selected,
      targets: nextTargets },
    () => {
      this.handleCancelCreate && this.handleCancelCreate();

      _.invoke(this, 'props.onBack', selected);
    });
  }

  /**
     * search results based on the filter value
     * @param  {string} filter - collection/folder searched
     */
  handleSearch(filter) {
    this.setState({ filter }, () => {
      this.props.onFilter && this.props.onFilter(filter);
    });
  }

  /**
     * start creating collection/folder
     */
  handleStartCreate() {
    // create new collection/folder if the searched filter named collection/folder does not exist
    if (!_.isEmpty(this.state.filter)) {
      this.handleCreate(this.state.filter);
      return;
    }
    this.setState({ isCreating: true });
  }

  handleCancelCreate() {
    this.setState({ isCreating: false });
  }

  /**
     * to create new collection/folder
     * @param {string} name - name of collection or folder created
     */
  handleCreate(name) {
    if (!_.isEmpty(name)) {
      this.setState({ isCreating: false, filter: '' }, () => {
        _.invoke(this.props, 'onCreate', name, this.state.selected);
      });
    }
  }

  render() {
    const showLoadingIndicator = this.props.loading,
    showRows = !this.props.loading && _.isEmpty(this.state.filter);

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer__header-wrapper' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ExplorerSearch__WEBPACK_IMPORTED_MODULE_2__["default"], {
            disabled: this.props.loading,
            filter: this.state.filter,
            onSearch: this.handleSearch }),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer__header__create-wrapper' },

            _.isEqual(this.state.selected, defaultSelection) ?
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer__header-title' },
              _.isEmpty(this.state.filter) ? 'All Collections' : 'Search Results') :

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                className: 'explorer-pop-btn',
                onClick: this.handleBack },

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Icons_LeftSolidIcon__WEBPACK_IMPORTED_MODULE_6__["default"], { className: 'explorer-pop-btn__icon' }),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-pop-btn__text' },
                this.state.selected.name),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-pop-btn__meta' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_collections_CollectionForkLabel__WEBPACK_IMPORTED_MODULE_7__["default"], { forkInfo: _.get(this.state.selected, 'forkInfo') }))),




            !this.props.disableCreate &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                className: 'explorer__header-create-btn',
                onClick: this.handleStartCreate },

              this.props.createText && this.props.createText(this.state.selected)))),





        this.state.isCreating &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ExplorerCreateRow__WEBPACK_IMPORTED_MODULE_4__["default"], {
          placeholder: _.invoke(this.props, 'createPlaceholder', this.state.selected),
          onCancel: this.handleCancelCreate,
          onCreate: this.handleCreate }),



        showLoadingIndicator &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_9__["default"], null),


        showRows &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-rows' },

          _.map(this.state.targets, (target, index) => {
            let isLeaf = this.isLeaf(this.state.targets, target);

            return target.depth === this.state.selected.depth + 1 && (
            !this.props.hideLeaves || !isLeaf) &&
            !(this.props.hideNodes && this.props.hideNodes(target)) &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ExplorerRow__WEBPACK_IMPORTED_MODULE_1__["default"], {
              disableLeaves: this.props.disableLeaves,
              filter: this.state.filter,
              isLeaf: isLeaf,
              key: index,
              leafIcon: this.props.leafIcon,
              target: target,
              onSelect: this.handleSelect });


          })),




        !_.isEmpty(this.state.filter) &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ExplorerResults__WEBPACK_IMPORTED_MODULE_3__["default"], {
          filter: this.state.filter,
          allTargets: this.props.targets,
          isLeaf: this.props.isLeaf,
          onSelect: this.handleSelect })));




  }}) || _class;


Explorer.propTypes = {
  createPlaceholder: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func,
  createText: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func, // The callback function that will be called to render the first row in every view
  disableCreate: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.bool,
  disableLeaves: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.bool, // Indicates if leaves will be shown
  hideLeaves: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.bool,
  hideNodes: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func, // The callback function that will be called so you can hide specific nodes if needed
  isLeaf: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func, // The callback function that will be called to check if a node is a leaf
  leafIcon: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func, // The callback called to render the leaf icon
  onBack: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func,
  onCreate: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func,
  onFilter: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func,
  onSelect: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func,
  targets: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.array,
  loading: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.bool };


Explorer.defaultProps = {
  disableLeaves: false,
  loading: false };
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6030:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ExplorerRow; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _base_Icons_CollectionIcon__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2812);
/* harmony import */ var _base_Icons_RightSolidIcon__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2970);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _collections_CollectionMetaIcons__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6031);
/* harmony import */ var _collections_CollectionForkLabel__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(5239);






let

ExplorerRow = class ExplorerRow extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.getClasses = this.getClasses.bind(this);
    this.handleSelect = this.handleSelect.bind(this);
  }

  getClasses(target) {
    return classnames__WEBPACK_IMPORTED_MODULE_1___default()({
      'explorer-row': true,
      'is-selected': target.id === _.get(this, 'props.selected.id'),
      'is-disabled': this.props.leafIcon && this.props.isLeaf },
    this.props.className);
  }

  /**
     * select a collection/folder
     * @param {Object} target
     */
  handleSelect(target, e) {
    e && e.stopPropagation();
    e && e.preventDefault();

    !this.props.isLeaf && _.invoke(this, 'props.onSelect', target, this.props.isLeaf);
  }

  render() {
    let { target } = this.props;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
          className: this.getClasses(target),
          onClick: this.handleSelect.bind(this, target) },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__icon' },

          this.props.isLeaf && _.isFunction(this.props.leafIcon) ?
          this.props.leafIcon(target) :
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Icons_CollectionIcon__WEBPACK_IMPORTED_MODULE_2__["default"], { className: 'explorer-row__icon-icon' })),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__name' },
          target.name),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__icons' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_collections_CollectionMetaIcons__WEBPACK_IMPORTED_MODULE_5__["default"], { collection: target })),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__meta' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_collections_CollectionForkLabel__WEBPACK_IMPORTED_MODULE_6__["default"], { forkInfo: _.get(target, 'forkInfo') })),


        !this.props.isLeaf &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Icons_RightSolidIcon__WEBPACK_IMPORTED_MODULE_3__["default"], { className: 'explorer-row__forward' })));



  }};


ExplorerRow.propTypes = {
  depth: prop_types__WEBPACK_IMPORTED_MODULE_4___default.a.number,
  filter: prop_types__WEBPACK_IMPORTED_MODULE_4___default.a.string,
  isLeaf: prop_types__WEBPACK_IMPORTED_MODULE_4___default.a.bool,
  onSelect: prop_types__WEBPACK_IMPORTED_MODULE_4___default.a.func,
  selected: prop_types__WEBPACK_IMPORTED_MODULE_4___default.a.object,
  target: prop_types__WEBPACK_IMPORTED_MODULE_4___default.a.object };
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6031:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _stores_CollectionStore__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(780);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(749);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2929);
/* harmony import */ var _postman_design_system__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(3051);
/* harmony import */ var _postman_design_system__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(_postman_design_system__WEBPACK_IMPORTED_MODULE_5__);
var _class;





let

CollectionMetaIcons = Object(mobx_react__WEBPACK_IMPORTED_MODULE_4__["observer"])(_class = class CollectionMetaIcons extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    const isCollectionEditable = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('PermissionStore').can('edit', 'collection', this.props.collection.id);

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'collection-meta-icons' },
        this.props.collection.isShared && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_postman_design_system__WEBPACK_IMPORTED_MODULE_5__["Icon"], { name: 'icon-descriptive-team-stroke', className: 'collection-meta-icon pm-icon pm-icon-normal', size: 'small', title: 'Shared with team' }),
        !isCollectionEditable && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_postman_design_system__WEBPACK_IMPORTED_MODULE_5__["Icon"], { name: 'icon-state-locked-stroke', className: 'collection-meta-icon pm-icon pm-icon-normal', size: 'small', title: 'Read only' })));


  }}) || _class;


CollectionMetaIcons.propTypes = {
  collection: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.oneOfType([
  prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.instanceOf(_stores_CollectionStore__WEBPACK_IMPORTED_MODULE_2__["CollectionItemStore"]),
  prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.object]) };



/* harmony default export */ __webpack_exports__["default"] = (CollectionMetaIcons);

/***/ }),

/***/ 6032:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ExplorerSearch; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _base_Inputs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(3048);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_2__);


let

ExplorerSearch = class ExplorerSearch extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-search' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Inputs__WEBPACK_IMPORTED_MODULE_1__["Input"], {
          disabled: this.props.disabled,
          inputStyle: 'search',
          placeholder: 'Search for a collection or folder',
          query: this.props.filter,
          onChange: this.props.onSearch })));



  }};


ExplorerSearch.defaultProps = {
  disabled: false };


ExplorerSearch.propTypes = {
  filter: prop_types__WEBPACK_IMPORTED_MODULE_2___default.a.string.isRequired,
  onSearch: prop_types__WEBPACK_IMPORTED_MODULE_2___default.a.func.isRequired,
  disabled: prop_types__WEBPACK_IMPORTED_MODULE_2___default.a.bool };

/***/ }),

/***/ 6033:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ExplorerResults; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _base_SearchHighlighter__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3671);
/* harmony import */ var _utils_CollectionTreeUtil__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6034);




let

ExplorerResults = class ExplorerResults extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = { filteredItems: this.filterTargets(props.allTargets, props.filter) };

    this.filterTargets = this.filterTargets.bind(this);
    this.getPath = this.getPath.bind(this);
    this.handleSelect = this.handleSelect.bind(this);
    this.setFilteredItems = this.setFilteredItems.bind(this);
    this.setFilteredItemsDebounced = _.debounce(this.setFilteredItems, 300, {
      leading: false,
      trailing: true });

  }

  UNSAFE_componentWillReceiveProps(nextProps) {
    this.setFilteredItemsDebounced(nextProps);
  }

  getHighlightClasses(text) {
    return classnames__WEBPACK_IMPORTED_MODULE_2___default()({ 'highlight': text.isHighlight });
  }

  filterTargets(targets = this.props.allTargets, filter = this.props.filter) {
    return _.filter(targets, target => {
      if (_.isFunction(this.props.isLeaf)) {
        return !this.props.isLeaf(target) && _.includes(_.toLower(target.name), _.toLower(filter));
      }
      return _.includes(_.toLower(target.name), _.toLower(filter));
    });
  }

  setFilteredItems(nextProps) {
    this.setState({ filteredItems: this.filterTargets(nextProps.allTargets, nextProps.filter) });
  }

  getPath(target, itemToFind) {
    return Object(_utils_CollectionTreeUtil__WEBPACK_IMPORTED_MODULE_4__["getNodePath"])(target, itemToFind);
  }

  handleSelect(item) {
    _.invoke(this, 'props.onSelect', item);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-results' },

        _.map(this.state.filteredItems, (target, index) => {
          return (
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                className: 'explorer-row explorer-result',
                key: index,
                onClick: this.handleSelect.bind(this, target) },

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__icon' }),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__content' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__name' },
                  target.name),

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-result__path' },
                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_SearchHighlighter__WEBPACK_IMPORTED_MODULE_3__["default"], {
                    source: this.getPath(this.props.allTargets, target),
                    query: this.props.filter })))));





        })));



  }};



ExplorerResults.propTypes = {
  filter: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.string,
  onSelect: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.func,
  targets: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.array };
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6034:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "flattenCollection", function() { return flattenCollection; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "flattenCollections", function() { return flattenCollections; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "computeVisibility", function() { return computeVisibility; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getParents", function() { return getParents; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getNodePath", function() { return getNodePath; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getAllToggleableNodes", function() { return getAllToggleableNodes; });
/**
 * Denormalize folder children
 * @param  {string} folderId          folder id
 * @param  {Array} options.requests   all requests in collection
 * @param  {Array} options.folders    all folders in collection
 * @return {Object}                   denormalized folder object
 */

/**
     * Denormalize request children
     * @param  {string} requestId         request id
     * @param  {Array} options.requests   all requests in collection
     * @return {Object}                   denormalized folder object
     */

/**
         * Denormalize node children
         * @param  {string} folderId          folder id
         * @param  {Array} options.requests   all requests in collection
         * @param  {Array} options.folders    all folders in collection
         * @return {Object}                   denormalized folder object
         */

/**
             * Denormalize collection children
             * @param  {object} collection collection in v1 format
             * @return {object}            denormalized collection
             */

/** =========================================================================**/
/*
                                                                                   FLATTENING UTILS
                                                                                  */

/**
                                                                                      * Deep flatten a node in denormalized collection
                                                                                      * @param  {Object} node node in denormalized collection tree
                                                                                      * @param  {number} depth depth of node (default: 0)
                                                                                      * @return {Array}       deep flattened node
                                                                                      */
// function flattenNode (node, depth) {
function flattenNode(flattened, node, depth, map) {
  // let flattenedNode = _.omit(node, ['children']),
  //     nodeDepth = depth || 0,
  //     flattenedChildren = _.flatMap(node.children, (childNode) => {
  //       return flattenNode(childNode, nodeDepth + 1);
  //     });

  // flattenedNode.endOffset = _.size(flattenedChildren);
  // flattenedNode.depth = nodeDepth;

  // // TODO: add parent and child offsets

  // return _.concat(flattenedNode, flattenedChildren);

  // console.log('flattening', node)

  if (!node) {
    return flattened;
  }

  // node.endOffset = _.size(node.folders_order) + _.size(node.order)
  flattened.push(node);

  _.each(node.folders_order, folderId => {
    let folder = _.find(map.folders, ['id', folderId]);
    if (folder) {
      folder.type = 'folder';
      folder.depth = depth + 1;
      flattenNode(flattened, folder, depth + 1, map);
    }
  });

  _.each(node.order, requestId => {
    let request = _.find(map.requests, ['id', requestId]);
    if (request) {
      request.type = 'request';
      request.depth = depth + 1;
      flattened.push(request);
    }
  });

  return flattened;
}

/**
   * marks all children as (in)visible
   * @param  {Array}  visibilityMap visibilityMap
   * @param  {Array}  flatTree      flattened tree
   * @param  {Array}  openNodes     ids of open items
   * @param  {number}  nodeIdx      index of node in flattened tree
   * @param  {Boolean} isVisible    boolean for flagging (in)visible
   * @param  {Boolean} deep         deep
   * @return {undefined}            no return value. visibilityMap is mutated
   */
function _markChildrenVisibility(visibilityMap, flatTree, openNodes, nodeIdx, isVisible, deep) {
  let node = flatTree[nodeIdx],
  idx = nodeIdx + 1,
  endIdx = _.findIndex(flatTree, n => {return n.depth <= node.depth;}, idx + 1); // nodeIdx + node.endOffset + 1;

  if (endIdx === -1) {
    endIdx = _.size(flatTree);
  }

  // if deep, mark the whole subtree
  if (deep) {
    while (idx < endIdx) {
      let itemNode = flatTree[idx];

      visibilityMap[idx] = isVisible;

      // fast forward to next subtree
      if (_isNodeToggleable(itemNode) && !_isNodeOpen(itemNode, openNodes)) {
        let endOffset = _.findIndex(flatTree, n => {return n.depth <= itemNode.depth;}, idx + 1);
        if (endOffset === -1) {
          endOffset = _.size(flatTree) - idx;
        }
        idx += endOffset; // itemNode.endOffset;
      }

      ++idx;
    }

    return;
  }

  let nodeDepth = node.depth,
  immediateChildDepth = nodeDepth + 1;

  // loop from immediate child to start of next subtree
  while (idx < endIdx) {
    let itemNode = flatTree[idx],
    itemNodeDepth = itemNode.depth;

    if (itemNodeDepth <= nodeDepth) {
      break;
    }

    if (itemNodeDepth === immediateChildDepth) {
      visibilityMap[idx] = isVisible;
    }

    ++idx;
  }

  return;
}

/**
  * marks all parents as (in)visible
  * @param  {Array}  visibilityMap visibilityMap
  * @param  {Array}  flatTree      flattened tree
  * @param  {number}  nodeIdx      index of node in flattened tree
  * @param  {Boolean} isVisible    boolean for flagging (in)visible
  * @return {undefined}            no return value. visibilityMap is mutated
   */
function _markParentVisibility(visibilityMap, flatTree, nodeIdx, isVisible) {
  let node = flatTree[nodeIdx],
  nodeDepth = node.depth,
  idx = nodeIdx - 1,
  parentDepth = nodeDepth - 1;

  while (idx > -1) {
    let tmpNode = flatTree[idx],
    tmpNodeDepth = tmpNode.depth;
    if (tmpNodeDepth <= parentDepth) {
      visibilityMap[idx] = isVisible;
      --parentDepth;
    }
    --idx;
  }
}

/**
   * get parent items
   * @param  {Array} flatTree flattened tree
   * @param  {Object} nodeIdx index in flattened tree
   * @return {Array}          array of parent nodes
   */
function getParents(flatTree, nodeIdx) {
  let node = flatTree[nodeIdx],
  nodeDepth = node.depth,
  parents = [],
  idx = nodeIdx - 1,
  parentDepth = nodeDepth - 1;

  while (idx > -1) {
    let tmpNode = flatTree[idx],
    tmpNodeDepth = tmpNode.depth;
    if (tmpNodeDepth <= parentDepth) {
      parents.push(flatTree[idx]);
      --parentDepth;
    }
    --idx;
  }

  return parents;
}

/**
   * Get path for the item
   * @param  {Array} flatTree flattened tree
   * @param  {Object} node    node
   * @return {string}         path
   */
function getNodePath(flatTree, node) {

  let nodeIdx = _.findIndex(flatTree, ['id', node.id]);

  if (nodeIdx === -1) {
    return '';
  }

  let parents = getParents(flatTree, nodeIdx),
  pathItems = _.concat([node], parents);


  return _.chain(pathItems).
  reverse().
  map('name').
  join(' / ').
  value();
}

/**
   * check if the node is open
   * @param  {Object}  node      node in flattened tree
   * @param  {Array}  openNodes  ids of open nodes
   * @return {Boolean}           whether node is open
   */
function _isNodeOpen(node, openNodes) {
  return openNodes.get(node.id);

  // return _.includes(openNodes, node.id);
}

/**
   * check if node is toggled
   * @param  {Object}  node node in flattened tree
   * @return {Boolean}      whether node is toggleable
   */
function _isNodeToggleable(node) {
  return _.includes(['collection', 'folder'], node.type);
}

/**
   * returns id of all toggleable nodes
   * @param  {Array} flatTree flattened tree
   * @return {Array}          ids of toggleable nodes
   */
function getAllToggleableNodes(flatTree) {
  return _.chain(flatTree).
  filter(_isNodeToggleable).
  map('id').
  value();
}

/**
   * computes visibility map
   * @param  {Array} flatCollection flattened collection
   * @param  {Array} openNodes      array of open node ids
   * @param  {string} filterQuery    search filter
   * @return {Array}                visibility map
   */
function computeVisibility(flatCollection, openNodes, filterQuery) {
  let visibilityMap = new Array(_.size(flatCollection));
  _.fill(visibilityMap, false);
  visibilityMap[0] = true;

  _.each(flatCollection, (node, index) => {
    if (_isNodeToggleable(node) && _isNodeOpen(node, openNodes)) {
      // find the next sibling
      let endIndex = _.findIndex(flatCollection, n => n.depth <= node.depth, index + 1);
      if (endIndex === -1) {
        endIndex = _.size(flatCollection);
      }

      visibilityMap[index] = true;
      _.each(new Array(endIndex - index), (n, i) => {
        if (flatCollection[index + i].depth === node.depth + 1) {
          visibilityMap[index + i] = true;
        }
      });
    }
  });

  return visibilityMap;
}

/**
   * computes visibility map
   * @param  {Array} flatCollection flattened collection
   * @param  {Array} openNodes      array of open node ids
   * @param  {string} filterQuery    search filter
   * @return {Array}                visibility map
   */
function _computeVisibilityQuery(flatCollection, openNodes, filterQuery) {
  let lowerFilterQuery = _.toLower(filterQuery),
  matchingNodes = new Array(_.size(flatCollection)),
  visibilityMap = new Array(_.size(flatCollection));

  _.fill(matchingNodes, false);
  _.fill(visibilityMap, false);

  _.forEach(flatCollection, (flatNode, itemIdx) => {
    let lowerItemName = _.toLower(flatNode.name);

    // if not matching, flag as not visible
    if (!_.includes(lowerItemName, lowerFilterQuery)) {
      return;
    }

    matchingNodes[itemIdx] = true;
  });

  let matchIdx = 0,
  endMatchIdx = matchingNodes.length;

  while (matchIdx < endMatchIdx) {
    if (!matchingNodes[matchIdx]) {
      ++matchIdx;
      continue; // eslint-disable-line no-continue
    }

    let matchNode = flatCollection[matchIdx];

    // mark node as visible
    visibilityMap[matchIdx] = true;

    // if toggleable node, deep mark subtree and fast forward
    if (_isNodeToggleable(matchNode) && _isNodeOpen(matchNode, openNodes)) {
      _markChildrenVisibility(visibilityMap, flatCollection, openNodes, matchIdx, true, true);
      matchIdx += matchNode.endOffset;
    }

    // mark parent chain
    _markParentVisibility(visibilityMap, flatCollection, matchIdx, true);

    ++matchIdx;
  }

  let idx = 0,
  length = flatCollection.length;

  while (idx < length) {
    let node = flatCollection[idx];

    if (_isNodeToggleable(node)) {
      // if toggleable node, and is not open, deep mark subtree and fast forward
      if (visibilityMap[idx] && !_isNodeOpen(node, openNodes)) {
        _markChildrenVisibility(visibilityMap, flatCollection, openNodes, idx, false, true);
        let endIdx = _.findIndex(flatCollection, n => {return n.depth <= node.depth;}, idx + 1);
        if (endIdx === -1) {
          endIdx = _.size(flatCollection) - idx;
        }
        idx += endIdx;
      }
    }

    ++idx;
  }

  return visibilityMap;
}

/**
   * Deep flattens a collection
   * @param  {Object} collection collection in v1 format
   * @return {Array}             flattened collection
   */
function flattenCollection(collection, folders = [], requests = []) {
  // let denormalized = denormalizeCollection(collection);
  // return flattenNode(denormalized);
  collection.type = 'collection';
  collection.depth = 0;
  return flattenNode([], collection, 0, { folders, requests });
}

/**
   * Flattens list of collections
   * @param  {Array} collections              Array of v1 collections
   * @param  {Array} options.openCollections  Array of ids of open collections
   * @param  {Array} options.openFolders      Array of ids of open folders
   * @return {Array}                          Flattened collections
   */
function flattenCollections(collections) {
  return _.chain(collections).
  sortBy(collection => {
    return collection.get('name');
  }).
  map(collection => {
    return flattenCollection(collection.toJSON());
  }).
  value();
}


/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6035:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ExplorerCreateRow; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _base_Inputs__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3048);
/* harmony import */ var _base_Icons_SuccessIcon__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3220);



let

ExplorerCreateRow = class ExplorerCreateRow extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = { name: '' };

    this.handleCreate = this.handleCreate.bind(this);
    this.handleCancel = this.handleCancel.bind(this);
    this.handleChange = this.handleChange.bind(this);
  }

  componentDidMount() {
    this.refs.input && this.refs.input.focus();
  }

  handleCreate(e) {
    e && e.preventDefault();
    e && e.stopPropagation();
    this.props.onCreate(this.state.name);
  }

  handleCancel(e) {
    this.setState({ name: '' });
    this.props.onCancel && this.props.onCancel();
  }

  handleChange(value) {
    this.setState({ name: value });
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
          className: 'explorer-create-row' },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__icon' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__icon-icon' })),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Inputs__WEBPACK_IMPORTED_MODULE_2__["Input"], {
          className: 'explorer-row__create',
          inputStyle: 'search',
          hideSearchGlass: true,
          placeholder: this.props.placeholder,
          ref: 'input',
          query: this.state.name,
          onCancel: this.handleCancel,
          onChange: this.handleChange,
          onSubmit: this.handleCreate,
          onEnter: this.handleCreate }),

        !_.isEmpty(_.isString(this.state.name) && this.state.name.trim()) &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: 'explorer-row__save',
            onClick: this.handleCreate },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Icons_SuccessIcon__WEBPACK_IMPORTED_MODULE_3__["default"], {
            className: 'explorer-row__save-icon',
            style: 'primary' }))));





  }};


ExplorerCreateRow.propTypes = {
  onCancel: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.func,
  onCreate: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.func.isRequired,
  placeholder: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.string.isRequired };
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6036:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return EnvironmentMetaIcons; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2929);
/* harmony import */ var _js_components_base_Icons_LockedIcon__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6003);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(749);
var _class;



let


EnvironmentMetaIcons = Object(mobx_react__WEBPACK_IMPORTED_MODULE_2__["observer"])(_class = class EnvironmentMetaIcons extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  render() {
    const canEditEnvironment = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_4__["getStore"])('PermissionStore').can('edit', 'environment', this.props.environmentId);

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'environment-meta-icons' },
        !canEditEnvironment && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_LockedIcon__WEBPACK_IMPORTED_MODULE_3__["default"], { className: 'environment-meta-icon', size: this.props.iconSize, title: 'Read only' })));


  }}) || _class;


EnvironmentMetaIcons.propTypes = {
  environmentId: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.string.isRequired,
  iconSize: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.string };


EnvironmentMetaIcons.defaultProps = {
  iconSize: 'xs' };

/***/ }),

/***/ 6047:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
const MAX_METHOD_LENGTH = 5;let

RequestMethodHelper = class RequestMethodHelper {
  getMethodAbbreviation(method) {
    let abbrvHash = {
      'PROPFIND': 'PROP',
      'DELETE': 'DEL',
      'OPTIONS': 'OPT',
      'UNLINK': 'UNLNK',
      'UNLOCK': 'UNLCK' };


    if (method) {
      return abbrvHash[method.toUpperCase()] || method.toUpperCase().slice(0, MAX_METHOD_LENGTH);
    }
  }};


/* harmony default export */ __webpack_exports__["default"] = (new RequestMethodHelper());

/***/ }),

/***/ 6064:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleActions; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(749);
/* harmony import */ var _js_utils_PluralizeHelper__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3224);
/* harmony import */ var _js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2959);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(3048);
/* harmony import */ var _js_components_base_Icons_MoreIcon__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(3290);
/* harmony import */ var _js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(3229);
/* harmony import */ var _js_modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(748);
var _class;










let


ConsoleActions = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class ConsoleActions extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {
  constructor(props) {
    super(props);

    this.consoleStore = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_2__["getStore"])('ConsoleStore');
    this.consoleEventStore = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_2__["getStore"])('ConsoleEventStore');
  }

  handleClear() {
    this.consoleStore.clearEvents();
  }

  handleConsoleOptionsToggle(option, e) {
    e && e.stopPropagation();

    switch (option) {
      case 'timestamps':
        return this.consoleStore.toggleTimestamp();

      case 'network':
        return this.consoleStore.toggleNetworkLogs();

      default:}

  }

  handleConsoleWindowOpen() {
    _js_modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_9__["default"].addEventV2({
      category: 'console',
      action: 'open_window',
      label: 'expand' });


    pm.mediator.trigger('newConsoleWindow');
  }

  render() {
    const { errorCount, warnCount } = this.consoleEventStore,
    isBrowser = window.SDK_PLATFORM === 'browser';

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-actions' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-actions__meta' },
          !!errorCount &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'meta__item meta__error' },
            errorCount,

            _js_utils_PluralizeHelper__WEBPACK_IMPORTED_MODULE_3__["default"].pluralize({
              count: errorCount,
              singular: ' ERROR',
              plural: ' ERRORS' })),




          !!warnCount &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'meta__item meta__warning' },
            warnCount,

            _js_utils_PluralizeHelper__WEBPACK_IMPORTED_MODULE_3__["default"].pluralize({
              count: warnCount,
              singular: ' WARNING',
              plural: ' WARNINGS' }))),





        this.props.showOptions &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
          !!(errorCount || warnCount) &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-actions__separator' }),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-actions__clear-button' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], {
                type: 'secondary',
                className: 'clear-btn',
                size: 'small',
                onClick: this.handleClear.bind(this),
                disabled: !this.consoleEventStore.hasLogs }, 'Clear')),





          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_4__["Dropdown"], { className: 'console-actions__settings', disableCloseOnPageScroll: true },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_4__["DropdownButton"], { type: 'text', size: 'small', dropdownStyle: 'nocaret' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], { type: 'text' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_MoreIcon__WEBPACK_IMPORTED_MODULE_7__["default"], { style: 'header' }))),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_4__["DropdownMenu"], { 'align-right': true },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_4__["MenuItem"], {
                  className: 'filter__menu-item' },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                    onClick: this.handleConsoleOptionsToggle.bind(this, 'timestamps'),
                    className: 'menu-item__wrapper' },

                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_6__["Checkbox"], {
                    className: 'menu-item__checkbox',
                    checked: this.consoleStore.showTimestamp }),

                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'menu-item__label' }, 'Show timestamps'))),


              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_4__["MenuItem"], {
                  className: 'filter__menu-item' },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                    onClick: this.handleConsoleOptionsToggle.bind(this, 'network'),
                    className: 'menu-item__wrapper' },

                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_6__["Checkbox"], {
                    className: 'menu-item__checkbox',
                    checked: this.consoleStore.hideNetworkLogs }),

                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'menu-item__label' }, 'Hide Network'))))),





          !isBrowser &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-actions__open-window-button' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_8__["default"], { style: 'header', onClick: this.handleConsoleWindowOpen })))));






  }}) || _class;

/***/ }),

/***/ 6067:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return MissingCurrentWorkspaceModalContainer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _components_workspaces_MissingCurrentWorkspaceModal__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6068);



const defaultState = { isOpen: false };let

MissingCurrentWorkspaceModalContainer = class MissingCurrentWorkspaceModalContainer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = defaultState;

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }

  UNSAFE_componentWillMount() {
    pm.mediator.on('missingCurrentWorkspace', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('missingCurrentWorkspace', this.handleOpen);
  }

  handleOpen(workspace) {
    this.setState({
      isOpen: true,
      workspaceName: workspace.name });

  }

  handleClose() {
    this.setState(defaultState);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_components_workspaces_MissingCurrentWorkspaceModal__WEBPACK_IMPORTED_MODULE_1__["default"], {
        isOpen: this.state.isOpen,
        workspaceName: this.state.workspaceName,
        onRequestClose: this.handleClose }));


  }};

/***/ }),

/***/ 6068:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _base_Modals__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(3250);
/* harmony import */ var _base_Buttons__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2934);


let

MissingCurrentWorkspaceModal = class MissingCurrentWorkspaceModal extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_1__["Modal"], {
          className: 'missing-current-workspace-modal',
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onRequestClose },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_1__["ModalContent"], null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'missing-current-workspace-modal__wrapper' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'modal-header-close-button', onClick: this.props.onRequestClose }),
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'missing-current-workspace-thumbnail__container' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'missing-current-workspace-thumbnail' })),

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'missing-current-workspace-modal__content' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'missing-current-workspace-modal__header' }, 'We can\'t seem to find the ',
                this.props.workspaceName, ' workspace'),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'missing-current-workspace-modal__subtext' }, 'The workspace might have been deleted by another user in your team. You have been switched to one of your personal workspaces.'),


              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'missing-current-workspace-modal__action' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_2__["Button"], {
                    type: 'primary',
                    onClick: this.props.onRequestClose }, 'Okay')))))));









  }};


/* harmony default export */ __webpack_exports__["default"] = (MissingCurrentWorkspaceModal);

/***/ }),

/***/ 6069:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return UserInvalidSessionModalContainer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _components_user_UserInvalidSessionModal__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6070);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(749);
/* harmony import */ var _modules_pipelines_app_action__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2406);
/* harmony import */ var _modules_model_event__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(742);
/* harmony import */ var pure_render_decorator__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2965);
/* harmony import */ var pure_render_decorator__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(pure_render_decorator__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _modules_services_AuthHandlerService__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(3854);
/* harmony import */ var _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(748);
/* harmony import */ var _utils_HttpService__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(2387);
var _class;









const COOLDOWN_MIN_MS = 15 * 1000, // Wait at least this much time before contacting Identity again
COOLDOWN_MAX_MS = 60 * 1000, // Wait at most this much time before contacting Identity again
COOLDOWN_WINDOW_MS = COOLDOWN_MAX_MS - COOLDOWN_MIN_MS;let


UserInvalidSessionModalContainer = pure_render_decorator__WEBPACK_IMPORTED_MODULE_5___default()(_class = class UserInvalidSessionModalContainer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,

      // Are we waiting on a response from Identity?
      validationInProgress: false,

      // Are we holding off from sending unnecessary calls to prevent loading the backend services? The
      // actual cooldown period is tracked separately from the throttle because while we know that we only
      // need to check once per MIN cooldown period, the actual period can vary and checks between MIN
      // and MAX will be short-circuited by other states which are being tracked.
      cooldown: false,

      // Have we already verified the invalidation once?
      invalidated: false };


    this.cooldown = this.cooldown.bind(this);
    this.validateSession = this.validateSession.bind(this);
    this.handleOpen = this.handleOpen.bind(this);
    this.handleOpenIntent = this.handleOpenIntent.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleSignIn = this.handleSignIn.bind(this);
    this.handleSignOut = this.handleSignOut.bind(this);

    /**
                                                         * every time whenever there is a successful log in, then close
                                                         * the session expired modal if its already open.
                                                         *
                                                         * There may be pending requests which have got executed later and
                                                         * might have triggered this modal when the requester window was hidden
                                                         */
    pm.eventBus.channel('auth-handler-events').subscribe(event => {
      if (event && event.name === 'authenticated' && event.namespace === 'authentication') {
        this.handleClose && this.handleClose();
      }
    });
  }

  UNSAFE_componentWillMount() {
    pm.logger.info('SessionValidation - Registering listener');
    pm.mediator.on('startReenterPassword', this.handleOpenIntent);

    // check if the current session is already locked
    // if the session is locked, the same event for showing this modal
    // (pm.mediator.trigger('startReenterPassword')) will be triggered
    pm.eventBus.channel('user-session-management').publish(Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_4__["createEvent"])('isSessionLocked', 'sessionManagement'));
  }

  componentWillUnmount() {
    pm.logger.info('SessionValidation - De-registering listener');
    pm.mediator.off('startReenterPassword', this.handleOpenIntent);
  }

  /**
     * Handle the intent to open this modal. Having this step in between, and treating this invocation as
     * an intent rather than an action allows us to take control of when this modal is displayed rather
     * than completely delegating that control to the caller.
     */
  handleOpenIntent() {
    pm.logger.info('SessionValidation - Intent received');
    _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
      category: 'identity',
      action: 'lock_session',
      label: 'intent' });


    if (this.state.isOpen) {
      // The modal is already open. There's nothing meaningful we can do here.
      pm.logger.info('SessionValidation - Modal already open');
      _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
        category: 'identity',
        action: 'lock_session',
        label: 'bail_modal_open' });


      return;
    }

    if (this.state.validationInProgress) {
      // We're already waiting on a response from Identity verifying the validity of this session,
      // there's no need to send another request.
      pm.logger.info('SessionValidation - Validation already in progress');
      _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
        category: 'identity',
        action: 'lock_session',
        label: 'bail_in_progress' });


      return;
    }

    if (this.state.cooldown) {
      // We're already offline because we've disconnected the socket already and are on cooldown. If this
      // intent is expressed at this point, it's because of a request coming in from a non-sync flow. Since
      // we're already in cooldown, we don't need to send out another request unnecessarily to check again.
      pm.logger.info('SessionValidation~cooldown - Application is already offline');
      _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
        category: 'identity',
        action: 'lock_session',
        label: 'bail_offline' });


      return;
    }

    if (this.state.invalidated) {
      // We've already verified that the session is invalid, we don't need to check again and the user should
      // definitely sign in again.
      pm.logger.info('SessionValidation - Session has already been verified as invalid');
      _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
        category: 'identity',
        action: 'lock_session',
        label: 'already_invalid' });


      return this.handleOpen();
    }

    // If we've reached this point, then we need to load the session validity from Identity.
    this.validateSession();
  }

  /**
     * To avoid cases where we show this modal as a false alarm, this component will take steps to verify
     * that the user session has indeed expired before actually displaying this blocking modal.
     */
  validateSession() {
    pm.logger.info(`SessionValidation - Validation starting (${pm.identityApiUrl})`);
    _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
      category: 'identity',
      action: 'lock_session',
      label: 'start_validation' });

    this.setState({ validationInProgress: true });

    // Send request to Identity directly using XHR, using the access token to fetch the current session
    // If the session was fetched and is valid, then we disconnect the socket for some time to avoid a
    // barrage of requests hitting Identity. The syncing logic at the time of writing drops a changeset if
    // the request to Sync fails (with some retry built in). If we don't disconnect the socket, we'll end
    // with a string of failed requests and a string of dropped changesets. To avoid this, we'll disconnect
    // the socket for some time and reconnect the socket when it's likely that load issues on Identity/Sync
    // have subsided. But we log it in case that helps with debugging later. If the session actually turns
    // out to be invalid, then we throw the modal.
    let headers = { 'x-access-token': _.get(Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_2__["getStore"])('CurrentUserStore'), 'auth.access_token') },
    options = { headers };

    _utils_HttpService__WEBPACK_IMPORTED_MODULE_8__["default"].request(`${pm.identityApiUrl}/api/sessions/current`, options).
    then(({ body, status }) => {
      pm.logger.info(`SessionValidation - Response received (${status})`);
    }).
    catch(error => {
      let status = _.get(error, 'status');

      pm.logger.info(`SessionValidation - Request error (${status})`);

      if (status === 401) {
        // This is the only case where we know for a fact that the session is invalid, so we can go ahead
        // and show the modal.
        pm.logger.info('SessionValidation - Session invalidity confirmed. Opening modal.');
        _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
          category: 'identity',
          action: 'lock_session',
          label: 'session_invalidated' });


        this.setState({ invalidated: true });

        return this.handleOpen();
      }
    }).
    finally(() => {
      this.setState({ validationInProgress: false });

      if (!this.state.isOpen) {
        // If the modal hasn't been opened by the time we reach here, something has gone wrong and we need to
        // disconnect the socket to prevent data loss. If we don't disconnect the socket, the current changeset
        // sync which triggered this change will get dropped and the next changeset will attempt to sync. That
        // will also fail for the same reason, causing that to be dropped as well. This will continue until all
        // changesets are dropped. To prevent this, we'll keep the socket disconnected for some time so that
        // the system can recover (hopefully?) by the next time the socket reconnects.
        let cooldown = this.cooldown(),
        cooldownSeconds = Math.floor(cooldown / 1000);

        pm.logger.error('SessionValidation - Session expiry hint validated as incorrect, ' +
        `disconnecting socket for ~${cooldownSeconds} seconds`);
        pm.mediator.trigger('appOffline');
        _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
          category: 'identity',
          action: 'lock_session',
          label: 'socket_disconnected' });

        this.setState({ cooldown: true });

        // Reconnect after some time to check again. The time we wait before reconnecting is spread out over
        // some period to avoid concurrent reconnects from all the apps in the wild.
        setTimeout(() => {
          pm.logger.info(`SessionValidation - Waited ~${cooldownSeconds} seconds. Reconnecting socket.`);
          pm.mediator.trigger('appOnline');
          _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
            category: 'identity',
            action: 'lock_session',
            label: 'socket_reconnected' });

          this.setState({ cooldown: false });
        }, cooldown);
      }
    });
  }

  handleOpen() {
    this.setState({ isOpen: true });
  }

  handleClose() {
    this.setState({ isOpen: false });
  }

  handleSignIn() {
    _modules_services_AuthHandlerService__WEBPACK_IMPORTED_MODULE_6__["default"].reAuthenticate();
    this.handleClose();
  }

  handleSignOut() {
    pm.mediator.trigger('showUserSignoutModal', { isSessionExpired: true });
    this.handleClose();
  }

  /**
     * Rather than having a backoff logic, which would complicate this flow further and probably cause bugs,
     * we can spread out the removal of the cooldown in a pseudo-random manner using the configured cooldown
     * MIN & MAX times. We're okay with using Math.random here since our intent here is not to generate
     * a cooldown time that's cryptographically secure, rather simply spread out over the MIN & MAX times.
     *
     * @return {Number} The cooldown time in milliseconds
     */
  cooldown() {
    return Math.round(Math.random() * COOLDOWN_WINDOW_MS + COOLDOWN_MIN_MS);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_components_user_UserInvalidSessionModal__WEBPACK_IMPORTED_MODULE_1__["default"], {
        isOpen: this.state.isOpen,
        onSignIn: this.handleSignIn,
        onSignOut: this.handleSignOut }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6070:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return UserInvalidSessionModal; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _base_Buttons__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2934);
/* harmony import */ var _base_Modals__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3250);
/* harmony import */ var _base_keymaps_KeyMaps__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2960);



let

UserInvalidSessionModal = class UserInvalidSessionModal extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);
  }

  getKeymapHandlers() {
    return { 'submit': pm.shortcuts.handle('submit', this.props.onSignOut) };
  }

  getCustomStyles() {
    return { marginTop: '35vh' };
  }

  render() {
    // This modal should not be close-able

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_2__["Modal"], {
          customStyles: this.getCustomStyles(),
          isOpen: this.props.isOpen },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_2__["ModalHeader"], null, 'Session Expired'),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_2__["ModalContent"], null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_keymaps_KeyMaps__WEBPACK_IMPORTED_MODULE_3__["default"], { keyMap: pm.shortcuts.getShortcuts(), handlers: this.getKeymapHandlers() },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', null, 'Your session has expired. Please sign in again.'))),




        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_2__["ModalFooter"], null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_1__["Button"], {
              type: 'secondary',
              onClick: this.props.onSignOut }, 'Sign Out'),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_1__["Button"], {
              type: 'primary',
              onClick: this.props.onSignIn }, 'Sign In'))));




  }};

/***/ }),

/***/ 6071:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return UserSignOutModalContainer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var pure_render_decorator__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2965);
/* harmony import */ var pure_render_decorator__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(pure_render_decorator__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _components_user_UserSignOutModal__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6072);
/* harmony import */ var _modules_model_event__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(742);
/* harmony import */ var _modules_pipelines_app_action__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2406);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(749);
/* harmony import */ var _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(748);
/* harmony import */ var _modules_controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(756);
var _class;






let


UserSignOutModalContainer = pure_render_decorator__WEBPACK_IMPORTED_MODULE_1___default()(_class = class UserSignOutModalContainer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      isSessionExpired: false,
      acceptForceSignout: false };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.toggleSignoutCheck = this.toggleSignoutCheck.bind(this);
    this.handleSocketConnectedCase = this.handleSocketConnectedCase.bind(this);
    this.handleSocketDisconnectedCase = this.handleSocketDisconnectedCase.bind(this);
  }

  UNSAFE_componentWillMount() {
    pm.mediator.on('showUserSignoutModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showUserSignoutModal', this.handleOpen);
  }

  handleSocketConnectedCase() {
    this.syncManagerInternalChannelDisposer = pm.eventBus.channel('sync-manager-internal').subscribe(event => {
      // bail out and return do not do anything
      if (!this.state.isOpen) {
        return;
      }

      // bail out if any other event other than verification of sync data integrity
      if (event.name === 'verified' && event.namespace === 'sync-data-integrity') {
        let data = Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_3__["getEventData"])(event),
        hasUnsyncedData = data && data.hasUnsyncedData,
        didFinishVerification = data && data.didFinishVerification;

        if (!didFinishVerification || hasUnsyncedData) {
          // if has unsynced data or we did not finish verification then show the warning
          this.setState({
            isLoading: false,
            showWarning: true,
            acceptForceSignout: false });

        } else {
          // this is the case where we have successfully verified that user data is in sync
          this.setState({
            isLoading: false,
            showWarning: false,
            acceptForceSignout: true });

        }
      }
    });

    pm.eventBus.channel('sync-manager-internal').publish(Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_3__["createEvent"])('verify', 'sync-data-integrity'));
  }

  handleSocketDisconnectedCase() {
    this.setState({
      isLoading: false,
      showWarning: true,
      acceptForceSignout: false });

  }

  handleOpen({ isSessionExpired } = {}) {
    // clean up if existing listeners are already there
    this.syncManagerInternalChannelDisposer && this.syncManagerInternalChannelDisposer();

    // if session expired dont show any warning or anything and show the state where user can directly log out
    if (isSessionExpired) {
      this.setState({
        isLoading: false,
        showWarning: false,
        acceptForceSignout: true,
        isOpen: true,
        isSessionExpired: isSessionExpired || false });


      return;
    }

    this.setState({
      isOpen: true,
      isLoading: true,
      acceptForceSignout: false,
      showWarning: false,
      isSessionExpired: isSessionExpired || false });


    _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_6__["default"].addEvent('account', 'initiate_sign_out');

    if (Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('SyncStatusStore').isSocketConnected) {
      this.handleSocketConnectedCase();
    } else {
      this.handleSocketDisconnectedCase();
    }
  }

  handleClose() {
    this.syncManagerInternalChannelDisposer && this.syncManagerInternalChannelDisposer();

    this.setState({
      isOpen: false,
      isSigningOut: false,
      acceptForceSignout: true });


    /**
                                    * If the user's auth session is expired, then go back to the `session expired modal`
                                    * https://github.com/postmanlabs/postman-app-support/issues/4859
                                    */
    if (this.state.isSessionExpired) {
      pm.mediator.trigger('startReenterPassword');
    }
  }

  handleConfirm() {
    let currentUser = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('CurrentUserStore'),
    logoutEvent = Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_3__["createEvent"])('logout', 'user', { id: currentUser.id });

    this.setState({ isSigningOut: true });

    Object(_modules_pipelines_app_action__WEBPACK_IMPORTED_MODULE_4__["default"])(logoutEvent).
    then(() => {
      this.handleClose();
    }).
    catch(e => {
      pm.logger.warn('UserSignOutModalContainer~Error in logging out user ', e);

      this.setState({
        signInLoading: false,
        signInError: e, // @todo copy from vineeth
        isSigningOut: false,
        disableSignout: false,
        acceptForceSignout: true });

      this.handleClose();
    });

  }

  toggleSignoutCheck() {
    this.setState({
      acceptForceSignout: !this.state.acceptForceSignout });

  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_components_user_UserSignOutModal__WEBPACK_IMPORTED_MODULE_2__["default"], {
        isSigningOut: this.state.isSigningOut,
        showWarning: this.state.showWarning,
        toggleSignoutCheck: this.toggleSignoutCheck,
        isLoading: this.state.isLoading,
        isOpen: this.state.isOpen,
        onClose: this.handleClose,
        onConfirm: this.handleConfirm,
        acceptForceSignout: this.state.acceptForceSignout }));


  }}) || _class;

/***/ }),

/***/ 6072:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return UserSignOutModal; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _base_Buttons__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2934);
/* harmony import */ var _base_Modals__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3250);
/* harmony import */ var _base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2974);
/* harmony import */ var _base_Inputs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(3048);
/* harmony import */ var _base_Icons_WarningIcon__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(3225);
/* harmony import */ var _base_Icons_SpannerIcon__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(6073);






let

UserSignOutModal = class UserSignOutModal extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
    this.toggleSignoutCheck = this.toggleSignoutCheck.bind(this);
    this.renderModalContent = this.renderModalContent.bind(this);
  }

  handleClose() {
    this.props.onClose && this.props.onClose();
  }

  handleConfirm() {
    this.props.onConfirm && this.props.onConfirm();
  }

  toggleSignoutCheck() {
    this.props.toggleSignoutCheck && this.props.toggleSignoutCheck();
  }

  getCustomStyles() {
    return { marginTop: '35vh' };
  }

  renderModalContent() {
    let isLoading = this.props.isLoading,
    isSomethingWrong = !isLoading && this.props.showWarning;

    if (isLoading) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'sign-out-loading--container--text' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'sign-out-loading--text' }, 'Checking for unsaved changes...'),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_3__["default"], { className: 'sign-out-loading-wrapper' })));


    } else

    if (isSomethingWrong) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'sign-out-warning-container-wrapper' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'sign-out-warning-container' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'sign-out-warning--header' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Icons_WarningIcon__WEBPACK_IMPORTED_MODULE_5__["default"], { className: 'sign-out-warning--warning-icon' }), 'You have unsaved changes'),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('br', null),
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'sign-out-warning--text' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'You will lose your unsaved changes if you sign out now. To save your changes, follow these steps:'),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('ul', { className: 'sign-out-warning--list' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('li', null, 'Export your data from ', react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Icons_SpannerIcon__WEBPACK_IMPORTED_MODULE_6__["default"], { className: 'sign-out-settings-icon', size: 'xs' }), ' > Settings > Data to create a backup'),
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('li', null, 'Ensure you have a working internet connection'),
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('li', null, 'Quit the app (be sure to stay signed in)'),
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('li', null, 'Re-open the app again')),

              ' ')),


          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null,
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Inputs__WEBPACK_IMPORTED_MODULE_4__["Checkbox"], {
              className: 'sign-out-warning--checkbox',
              checked: this.props.acceptForceSignout,
              onChange: this.toggleSignoutCheck,
              disabled: this.props.isSigningOut }),

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'sign-out-warning--checkbox-text' }, ' Sign out without saving my changes'))));



    }

    // nothing is wrong with data, allow signout
    else {
        return 'Signing out removes your synced history, collections and environments from local storage. You can access them again by signing back in anytime';
      }
  }

  render() {
    let disableSignout = this.props.isSigningOut || this.props.isLoading || this.props.showWarning && !this.props.acceptForceSignout;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_2__["Modal"], {
          isOpen: this.props.isOpen,
          className: 'user-signout-modal',
          customStyles: this.getCustomStyles() },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_2__["ModalHeader"], null, 'SIGN OUT OF POSTMAN'),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_2__["ModalContent"], null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'user-signout-modal-message' },
            this.renderModalContent())),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_2__["ModalFooter"], null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_1__["Button"], {
              type: 'secondary',
              onClick: this.handleClose,
              disabled: this.props.isSigningOut }, 'Cancel'),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_1__["Button"], {
              type: 'primary',
              onClick: this.handleConfirm,
              disabled: disableSignout },

            this.props.isSigningOut ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_3__["default"], null) : 'Sign out and remove local data'))));




  }};


UserSignOutModal.defaultProps = { isLoading: false, isSigningOut: false };

/***/ }),

/***/ 6073:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return SortIcon; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2813);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('svg', { width: '16', height: '16', viewBox: '0 0 16 16' },
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('defs', null,
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { id: 'spanner', d: 'M8.9 13.304c-1.192-.385-2.018.096-3.486 1.444L4.129 16A10.665 10.665 0 0 1 0 11.956l1.468-1.444C2.844 9.356 3.12 8.779 2.844 7.238c-.367-1.733-.367-3.755 1.744-5.68l1.01-.771c3.21-1.926 6.973.289 6.973.289S9.634 3 9.267 3.29c-.458.29-1.743 1.733-.183 3.948 1.468 2.31 3.12 1.54 3.578 1.155.367-.192 3.304-2.118 3.304-2.118s.55 4.333-2.753 6.451c-1.56.963-3.212.963-4.313.578z' })),

  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('use', { fill: '#FFF', fillRule: 'nonzero', xlinkHref: '#spanner' }));




function SortIcon(props) {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_Icon__WEBPACK_IMPORTED_MODULE_1__["default"], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 6205:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "determineDataFormats", function() { return determineDataFormats; });
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(61);
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(lodash__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _controllers_Importer__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2831);
/* harmony import */ var _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(748);
/* harmony import */ var async__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(664);
/* harmony import */ var async__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(async__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _formats__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(4101);






/**
                                  * Imports a file system folder.
                                  *
                                  * @param {File[]} allFiles   - The files that need to be imported
                                  * @param {String} rootPath   - The root path of uploaded data, e.g: /Uber or /my-folder. The slash at the beginning is important
                                  * @param {Function} callback - The function that will be called after the imported resources are written to IndexedDB
                                  *
                                  * @fires Mediator#failedCollectionImport
                                  */
/* harmony default export */ __webpack_exports__["default"] = (async function importFolder(allFiles, rootPath, callback, options) {
  var uploadedData = lodash__WEBPACK_IMPORTED_MODULE_0___default.a.zipObject(lodash__WEBPACK_IMPORTED_MODULE_0___default.a.map(allFiles, 'fileName'), lodash__WEBPACK_IMPORTED_MODULE_0___default.a.map(allFiles, 'content')),
  allFileNames = lodash__WEBPACK_IMPORTED_MODULE_0___default.a.map(allFiles, file => {return lodash__WEBPACK_IMPORTED_MODULE_0___default.a.pick(file, 'fileName');}),
  successfulConversions = {},
  unsuccessfulConversions = [],
  format = await determineDataFormats(allFileNames);

  if (format) {
    try {
      // Convert the data to native Postman objects (Collections, Environments, Globals, etc)
      let result = await format.convertFolder(allFileNames, options);

      // Add relevant analytics event
      _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_2__["default"].addEventV2({
        category: 'collection',
        action: 'create',
        label: format.id });


      async__WEBPACK_IMPORTED_MODULE_3___default.a.each(result, (conversionOutput, next) => {
        _controllers_Importer__WEBPACK_IMPORTED_MODULE_1__["default"].importData(conversionOutput.data, { origin: 'import/folder' }, next);
      });
    }
    catch (error) {
      pm.toasts.error(`Error while importing ${format.name}: ${error.message}`);
      pm.mediator.trigger('failedCollectionImport', `Error importing ${format.name} API: ${error.message}`);
    }
  } else
  {
    // Try importing all files as individual format.
    async__WEBPACK_IMPORTED_MODULE_3___default.a.eachOfSeries(uploadedData, (content, fileName, next) => {
      _controllers_Importer__WEBPACK_IMPORTED_MODULE_1__["default"].importData(content, { origin: 'import/folder' }, (err, result) => {
        lodash__WEBPACK_IMPORTED_MODULE_0___default.a.isEmpty(lodash__WEBPACK_IMPORTED_MODULE_0___default.a.get(result, 'format.id')) ?
        unsuccessfulConversions.push(fileName) :
        successfulConversions[fileName] = result;
        return next();
      });
    }, () => {
      if (lodash__WEBPACK_IMPORTED_MODULE_0___default.a.isEmpty(successfulConversions)) {
        pm.toasts.error('Error while importing: Could not determine format');
      } else
      if (unsuccessfulConversions.length > 0) {
        pm.toasts.warn('Warning while importing: Some of files could not be imported. Check Developer Tools to get more info.');
        console.log('failedImport: Here are the files that were not imported ', unsuccessfulConversions);
      }
    });
  }
});

/**
     * Returns the appropriate formats for the given data
     *
     * @param {array} data - Array of all non-hidden file paths in imported folder
     * @returns {object} - A format object with a `convertFolder` method
     */
async function determineDataFormats(data, cb) {
  // filter formats with support for folder import
  var allFormats = lodash__WEBPACK_IMPORTED_MODULE_0___default.a.chain(_formats__WEBPACK_IMPORTED_MODULE_4__["default"]).
  filter(['multiFileSupport', true]).
  value();

  for (let format of allFormats) {
    try {
      var result = await format.validateFolder(data);
      if (result) {
        return format;
      }
    }
    catch (error) {
      // The data is not supported by this format, so just try the next one
    }
  }
}

/***/ }),

/***/ 6207:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _export_single__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2689);


/* harmony default export */ __webpack_exports__["default"] = ({ exportSingle: _export_single__WEBPACK_IMPORTED_MODULE_0__["default"] });

/***/ }),

/***/ 6210:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "localize", function() { return localize; });
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
function _format(message, args) {
    var result;
    if (args.length === 0) {
        result = message;
    } else
    {
        result = message.replace(/\{(\d+)\}/g, function (match, rest) {
            var index = rest[0];
            return typeof args[index] !== 'undefined' ? args[index] : match;
        });
    }
    return result;
}
function localize(data, message) {
    var args = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        args[_i - 2] = arguments[_i];
    }
    return _format(message, args);
}

/***/ }),

/***/ 6211:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isThenable", function() { return isThenable; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "createCancelablePromise", function() { return createCancelablePromise; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "raceCancellation", function() { return raceCancellation; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Delayer", function() { return Delayer; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "timeout", function() { return timeout; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "disposableTimeout", function() { return disposableTimeout; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "first", function() { return first; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "TimeoutTimer", function() { return TimeoutTimer; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "IntervalTimer", function() { return IntervalTimer; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "RunOnceScheduler", function() { return RunOnceScheduler; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "runWhenIdle", function() { return runWhenIdle; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "IdleValue", function() { return IdleValue; });
/* harmony import */ var _cancellation_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6212);
/* harmony import */ var _errors_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6214);
/* harmony import */ var _lifecycle_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6216);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/



function isThenable(obj) {
    return obj && typeof obj.then === 'function';
}
function createCancelablePromise(callback) {
    var source = new _cancellation_js__WEBPACK_IMPORTED_MODULE_0__["CancellationTokenSource"]();
    var thenable = callback(source.token);
    var promise = new Promise(function (resolve, reject) {
        source.token.onCancellationRequested(function () {
            reject(_errors_js__WEBPACK_IMPORTED_MODULE_1__["canceled"]());
        });
        Promise.resolve(thenable).then(function (value) {
            source.dispose();
            resolve(value);
        }, function (err) {
            source.dispose();
            reject(err);
        });
    });
    return new ( /** @class */function () {
        function class_1() {
        }
        class_1.prototype.cancel = function () {
            source.cancel();
        };
        class_1.prototype.then = function (resolve, reject) {
            return promise.then(resolve, reject);
        };
        class_1.prototype.catch = function (reject) {
            return this.then(undefined, reject);
        };
        class_1.prototype.finally = function (onfinally) {
            return promise.finally(onfinally);
        };
        return class_1;
    }())();
}
function raceCancellation(promise, token, defaultValue) {
    return Promise.race([promise, new Promise(function (resolve) {return token.onCancellationRequested(function () {return resolve(defaultValue);});})]);
}
/**
   * A helper to delay execution of a task that is being requested often.
   *
   * Following the throttler, now imagine the mail man wants to optimize the number of
   * trips proactively. The trip itself can be long, so he decides not to make the trip
   * as soon as a letter is submitted. Instead he waits a while, in case more
   * letters are submitted. After said waiting period, if no letters were submitted, he
   * decides to make the trip. Imagine that N more letters were submitted after the first
   * one, all within a short period of time between each other. Even though N+1
   * submissions occurred, only 1 delivery was made.
   *
   * The delayer offers this behavior via the trigger() method, into which both the task
   * to be executed and the waiting period (delay) must be passed in as arguments. Following
   * the example:
   *
   * 		const delayer = new Delayer(WAITING_PERIOD);
   * 		const letters = [];
   *
   * 		function letterReceived(l) {
   * 			letters.push(l);
   * 			delayer.trigger(() => { return makeTheTrip(); });
   * 		}
   */
var Delayer = /** @class */function () {
    function Delayer(defaultDelay) {
        this.defaultDelay = defaultDelay;
        this.timeout = null;
        this.completionPromise = null;
        this.doResolve = null;
        this.doReject = null;
        this.task = null;
    }
    Delayer.prototype.trigger = function (task, delay) {
        var _this = this;
        if (delay === void 0) {delay = this.defaultDelay;}
        this.task = task;
        this.cancelTimeout();
        if (!this.completionPromise) {
            this.completionPromise = new Promise(function (c, e) {
                _this.doResolve = c;
                _this.doReject = e;
            }).then(function () {
                _this.completionPromise = null;
                _this.doResolve = null;
                if (_this.task) {
                    var task_1 = _this.task;
                    _this.task = null;
                    return task_1();
                }
                return undefined;
            });
        }
        this.timeout = setTimeout(function () {
            _this.timeout = null;
            if (_this.doResolve) {
                _this.doResolve(null);
            }
        }, delay);
        return this.completionPromise;
    };
    Delayer.prototype.isTriggered = function () {
        return this.timeout !== null;
    };
    Delayer.prototype.cancel = function () {
        this.cancelTimeout();
        if (this.completionPromise) {
            if (this.doReject) {
                this.doReject(_errors_js__WEBPACK_IMPORTED_MODULE_1__["canceled"]());
            }
            this.completionPromise = null;
        }
    };
    Delayer.prototype.cancelTimeout = function () {
        if (this.timeout !== null) {
            clearTimeout(this.timeout);
            this.timeout = null;
        }
    };
    Delayer.prototype.dispose = function () {
        this.cancelTimeout();
    };
    return Delayer;
}();

function timeout(millis, token) {
    if (!token) {
        return createCancelablePromise(function (token) {return timeout(millis, token);});
    }
    return new Promise(function (resolve, reject) {
        var handle = setTimeout(resolve, millis);
        token.onCancellationRequested(function () {
            clearTimeout(handle);
            reject(_errors_js__WEBPACK_IMPORTED_MODULE_1__["canceled"]());
        });
    });
}
function disposableTimeout(handler, timeout) {
    if (timeout === void 0) {timeout = 0;}
    var timer = setTimeout(handler, timeout);
    return Object(_lifecycle_js__WEBPACK_IMPORTED_MODULE_2__["toDisposable"])(function () {return clearTimeout(timer);});
}
function first(promiseFactories, shouldStop, defaultValue) {
    if (shouldStop === void 0) {shouldStop = function (t) {return !!t;};}
    if (defaultValue === void 0) {defaultValue = null;}
    var index = 0;
    var len = promiseFactories.length;
    var loop = function () {
        if (index >= len) {
            return Promise.resolve(defaultValue);
        }
        var factory = promiseFactories[index++];
        var promise = Promise.resolve(factory());
        return promise.then(function (result) {
            if (shouldStop(result)) {
                return Promise.resolve(result);
            }
            return loop();
        });
    };
    return loop();
}
var TimeoutTimer = /** @class */function () {
    function TimeoutTimer(runner, timeout) {
        this._token = -1;
        if (typeof runner === 'function' && typeof timeout === 'number') {
            this.setIfNotSet(runner, timeout);
        }
    }
    TimeoutTimer.prototype.dispose = function () {
        this.cancel();
    };
    TimeoutTimer.prototype.cancel = function () {
        if (this._token !== -1) {
            clearTimeout(this._token);
            this._token = -1;
        }
    };
    TimeoutTimer.prototype.cancelAndSet = function (runner, timeout) {
        var _this = this;
        this.cancel();
        this._token = setTimeout(function () {
            _this._token = -1;
            runner();
        }, timeout);
    };
    TimeoutTimer.prototype.setIfNotSet = function (runner, timeout) {
        var _this = this;
        if (this._token !== -1) {
            // timer is already set
            return;
        }
        this._token = setTimeout(function () {
            _this._token = -1;
            runner();
        }, timeout);
    };
    return TimeoutTimer;
}();

var IntervalTimer = /** @class */function () {
    function IntervalTimer() {
        this._token = -1;
    }
    IntervalTimer.prototype.dispose = function () {
        this.cancel();
    };
    IntervalTimer.prototype.cancel = function () {
        if (this._token !== -1) {
            clearInterval(this._token);
            this._token = -1;
        }
    };
    IntervalTimer.prototype.cancelAndSet = function (runner, interval) {
        this.cancel();
        this._token = setInterval(function () {
            runner();
        }, interval);
    };
    return IntervalTimer;
}();

var RunOnceScheduler = /** @class */function () {
    function RunOnceScheduler(runner, timeout) {
        this.timeoutToken = -1;
        this.runner = runner;
        this.timeout = timeout;
        this.timeoutHandler = this.onTimeout.bind(this);
    }
    /**
       * Dispose RunOnceScheduler
       */
    RunOnceScheduler.prototype.dispose = function () {
        this.cancel();
        this.runner = null;
    };
    /**
        * Cancel current scheduled runner (if any).
        */
    RunOnceScheduler.prototype.cancel = function () {
        if (this.isScheduled()) {
            clearTimeout(this.timeoutToken);
            this.timeoutToken = -1;
        }
    };
    /**
        * Cancel previous runner (if any) & schedule a new runner.
        */
    RunOnceScheduler.prototype.schedule = function (delay) {
        if (delay === void 0) {delay = this.timeout;}
        this.cancel();
        this.timeoutToken = setTimeout(this.timeoutHandler, delay);
    };
    /**
        * Returns true if scheduled.
        */
    RunOnceScheduler.prototype.isScheduled = function () {
        return this.timeoutToken !== -1;
    };
    RunOnceScheduler.prototype.onTimeout = function () {
        this.timeoutToken = -1;
        if (this.runner) {
            this.doRun();
        }
    };
    RunOnceScheduler.prototype.doRun = function () {
        if (this.runner) {
            this.runner();
        }
    };
    return RunOnceScheduler;
}();

/**
                              * Execute the callback the next time the browser is idle
                              */
var runWhenIdle;
(function () {
    if (typeof requestIdleCallback !== 'function' || typeof cancelIdleCallback !== 'function') {
        var dummyIdle_1 = Object.freeze({
            didTimeout: true,
            timeRemaining: function () {return 15;} });

        runWhenIdle = function (runner) {
            var handle = setTimeout(function () {return runner(dummyIdle_1);});
            var disposed = false;
            return {
                dispose: function () {
                    if (disposed) {
                        return;
                    }
                    disposed = true;
                    clearTimeout(handle);
                } };

        };
    } else
    {
        runWhenIdle = function (runner, timeout) {
            var handle = requestIdleCallback(runner, typeof timeout === 'number' ? { timeout: timeout } : undefined);
            var disposed = false;
            return {
                dispose: function () {
                    if (disposed) {
                        return;
                    }
                    disposed = true;
                    cancelIdleCallback(handle);
                } };

        };
    }
})();
/**
       * An implementation of the "idle-until-urgent"-strategy as introduced
       * here: https://philipwalton.com/articles/idle-until-urgent/
       */
var IdleValue = /** @class */function () {
    function IdleValue(executor) {
        var _this = this;
        this._didRun = false;
        this._executor = function () {
            try {
                _this._value = executor();
            }
            catch (err) {
                _this._error = err;
            } finally
            {
                _this._didRun = true;
            }
        };
        this._handle = runWhenIdle(function () {return _this._executor();});
    }
    IdleValue.prototype.dispose = function () {
        this._handle.dispose();
    };
    IdleValue.prototype.getValue = function () {
        if (!this._didRun) {
            this._handle.dispose();
            this._executor();
        }
        if (this._error) {
            throw this._error;
        }
        return this._value;
    };
    return IdleValue;
}();


/***/ }),

/***/ 6212:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "CancellationToken", function() { return CancellationToken; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "CancellationTokenSource", function() { return CancellationTokenSource; });
/* harmony import */ var _event_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6213);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/

var shortcutEvent = Object.freeze(function (callback, context) {
    var handle = setTimeout(callback.bind(context), 0);
    return { dispose: function () {clearTimeout(handle);} };
});
var CancellationToken;
(function (CancellationToken) {
    function isCancellationToken(thing) {
        if (thing === CancellationToken.None || thing === CancellationToken.Cancelled) {
            return true;
        }
        if (thing instanceof MutableToken) {
            return true;
        }
        if (!thing || typeof thing !== 'object') {
            return false;
        }
        return typeof thing.isCancellationRequested === 'boolean' &&
        typeof thing.onCancellationRequested === 'function';
    }
    CancellationToken.isCancellationToken = isCancellationToken;
    CancellationToken.None = Object.freeze({
        isCancellationRequested: false,
        onCancellationRequested: _event_js__WEBPACK_IMPORTED_MODULE_0__["Event"].None });

    CancellationToken.Cancelled = Object.freeze({
        isCancellationRequested: true,
        onCancellationRequested: shortcutEvent });

})(CancellationToken || (CancellationToken = {}));
var MutableToken = /** @class */function () {
    function MutableToken() {
        this._isCancelled = false;
        this._emitter = null;
    }
    MutableToken.prototype.cancel = function () {
        if (!this._isCancelled) {
            this._isCancelled = true;
            if (this._emitter) {
                this._emitter.fire(undefined);
                this.dispose();
            }
        }
    };
    Object.defineProperty(MutableToken.prototype, "isCancellationRequested", {
        get: function () {
            return this._isCancelled;
        },
        enumerable: true,
        configurable: true });

    Object.defineProperty(MutableToken.prototype, "onCancellationRequested", {
        get: function () {
            if (this._isCancelled) {
                return shortcutEvent;
            }
            if (!this._emitter) {
                this._emitter = new _event_js__WEBPACK_IMPORTED_MODULE_0__["Emitter"]();
            }
            return this._emitter.event;
        },
        enumerable: true,
        configurable: true });

    MutableToken.prototype.dispose = function () {
        if (this._emitter) {
            this._emitter.dispose();
            this._emitter = null;
        }
    };
    return MutableToken;
}();
var CancellationTokenSource = /** @class */function () {
    function CancellationTokenSource(parent) {
        this._token = undefined;
        this._parentListener = undefined;
        this._parentListener = parent && parent.onCancellationRequested(this.cancel, this);
    }
    Object.defineProperty(CancellationTokenSource.prototype, "token", {
        get: function () {
            if (!this._token) {
                // be lazy and create the token only when
                // actually needed
                this._token = new MutableToken();
            }
            return this._token;
        },
        enumerable: true,
        configurable: true });

    CancellationTokenSource.prototype.cancel = function () {
        if (!this._token) {
            // save an object by returning the default
            // cancelled token when cancellation happens
            // before someone asks for the token
            this._token = CancellationToken.Cancelled;
        } else
        if (this._token instanceof MutableToken) {
            // actually cancel
            this._token.cancel();
        }
    };
    CancellationTokenSource.prototype.dispose = function (cancel) {
        if (cancel === void 0) {cancel = false;}
        if (cancel) {
            this.cancel();
        }
        if (this._parentListener) {
            this._parentListener.dispose();
        }
        if (!this._token) {
            // ensure to initialize with an empty token if we had none
            this._token = CancellationToken.None;
        } else
        if (this._token instanceof MutableToken) {
            // actually dispose
            this._token.dispose();
        }
    };
    return CancellationTokenSource;
}();


/***/ }),

/***/ 6213:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Event", function() { return Event; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Emitter", function() { return Emitter; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "PauseableEmitter", function() { return PauseableEmitter; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "EventMultiplexer", function() { return EventMultiplexer; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "EventBufferer", function() { return EventBufferer; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Relay", function() { return Relay; });
/* harmony import */ var _errors_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6214);
/* harmony import */ var _functional_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6215);
/* harmony import */ var _lifecycle_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6216);
/* harmony import */ var _linkedList_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6217);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __extends = undefined && undefined.__extends || function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
        { __proto__: [] } instanceof Array && function (d, b) {d.__proto__ = b;} ||
        function (d, b) {for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];};
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {this.constructor = d;}
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();




var Event;
(function (Event) {
    Event.None = function () {return _lifecycle_js__WEBPACK_IMPORTED_MODULE_2__["Disposable"].None;};
    /**
                                                         * Given an event, returns another event which only fires once.
                                                         */
    function once(event) {
        return function (listener, thisArgs, disposables) {
            if (thisArgs === void 0) {thisArgs = null;}
            // we need this, in case the event fires during the listener call
            var didFire = false;
            var result;
            result = event(function (e) {
                if (didFire) {
                    return;
                } else
                if (result) {
                    result.dispose();
                } else
                {
                    didFire = true;
                }
                return listener.call(thisArgs, e);
            }, null, disposables);
            if (didFire) {
                result.dispose();
            }
            return result;
        };
    }
    Event.once = once;
    /**
                        * Given an event and a `map` function, returns another event which maps each element
                        * through the mapping function.
                        */
    function map(event, map) {
        return snapshot(function (listener, thisArgs, disposables) {
            if (thisArgs === void 0) {thisArgs = null;}
            return event(function (i) {return listener.call(thisArgs, map(i));}, null, disposables);
        });
    }
    Event.map = map;
    /**
                      * Given an event and an `each` function, returns another identical event and calls
                      * the `each` function per each element.
                      */
    function forEach(event, each) {
        return snapshot(function (listener, thisArgs, disposables) {
            if (thisArgs === void 0) {thisArgs = null;}
            return event(function (i) {each(i);listener.call(thisArgs, i);}, null, disposables);
        });
    }
    Event.forEach = forEach;
    function filter(event, filter) {
        return snapshot(function (listener, thisArgs, disposables) {
            if (thisArgs === void 0) {thisArgs = null;}
            return event(function (e) {return filter(e) && listener.call(thisArgs, e);}, null, disposables);
        });
    }
    Event.filter = filter;
    /**
                            * Given an event, returns the same event but typed as `Event<void>`.
                            */
    function signal(event) {
        return event;
    }
    Event.signal = signal;
    /**
                            * Given a collection of events, returns a single event which emits
                            * whenever any of the provided events emit.
                            */
    function any() {
        var events = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            events[_i] = arguments[_i];
        }
        return function (listener, thisArgs, disposables) {
            if (thisArgs === void 0) {thisArgs = null;}
            return _lifecycle_js__WEBPACK_IMPORTED_MODULE_2__["combinedDisposable"].apply(void 0, events.map(function (event) {return event(function (e) {return listener.call(thisArgs, e);}, null, disposables);}));
        };
    }
    Event.any = any;
    /**
                      * Given an event and a `merge` function, returns another event which maps each element
                      * and the cumulative result through the `merge` function. Similar to `map`, but with memory.
                      */
    function reduce(event, merge, initial) {
        var output = initial;
        return map(event, function (e) {
            output = merge(output, e);
            return output;
        });
    }
    Event.reduce = reduce;
    /**
                            * Given a chain of event processing functions (filter, map, etc), each
                            * function will be invoked per event & per listener. Snapshotting an event
                            * chain allows each function to be invoked just once per event.
                            */
    function snapshot(event) {
        var listener;
        var emitter = new Emitter({
            onFirstListenerAdd: function () {
                listener = event(emitter.fire, emitter);
            },
            onLastListenerRemove: function () {
                listener.dispose();
            } });

        return emitter.event;
    }
    Event.snapshot = snapshot;
    function debounce(event, merge, delay, leading, leakWarningThreshold) {
        if (delay === void 0) {delay = 100;}
        if (leading === void 0) {leading = false;}
        var subscription;
        var output = undefined;
        var handle = undefined;
        var numDebouncedCalls = 0;
        var emitter = new Emitter({
            leakWarningThreshold: leakWarningThreshold,
            onFirstListenerAdd: function () {
                subscription = event(function (cur) {
                    numDebouncedCalls++;
                    output = merge(output, cur);
                    if (leading && !handle) {
                        emitter.fire(output);
                        output = undefined;
                    }
                    clearTimeout(handle);
                    handle = setTimeout(function () {
                        var _output = output;
                        output = undefined;
                        handle = undefined;
                        if (!leading || numDebouncedCalls > 1) {
                            emitter.fire(_output);
                        }
                        numDebouncedCalls = 0;
                    }, delay);
                });
            },
            onLastListenerRemove: function () {
                subscription.dispose();
            } });

        return emitter.event;
    }
    Event.debounce = debounce;
    /**
                                * Given an event, it returns another event which fires only once and as soon as
                                * the input event emits. The event data is the number of millis it took for the
                                * event to fire.
                                */
    function stopwatch(event) {
        var start = new Date().getTime();
        return map(once(event), function (_) {return new Date().getTime() - start;});
    }
    Event.stopwatch = stopwatch;
    /**
                                  * Given an event, it returns another event which fires only when the event
                                  * element changes.
                                  */
    function latch(event) {
        var firstCall = true;
        var cache;
        return filter(event, function (value) {
            var shouldEmit = firstCall || value !== cache;
            firstCall = false;
            cache = value;
            return shouldEmit;
        });
    }
    Event.latch = latch;
    /**
                          * Buffers the provided event until a first listener comes
                          * along, at which point fire all the events at once and
                          * pipe the event from then on.
                          *
                          * ```typescript
                          * const emitter = new Emitter<number>();
                          * const event = emitter.event;
                          * const bufferedEvent = buffer(event);
                          *
                          * emitter.fire(1);
                          * emitter.fire(2);
                          * emitter.fire(3);
                          * // nothing...
                          *
                          * const listener = bufferedEvent(num => console.log(num));
                          * // 1, 2, 3
                          *
                          * emitter.fire(4);
                          * // 4
                          * ```
                          */
    function buffer(event, nextTick, _buffer) {
        if (nextTick === void 0) {nextTick = false;}
        if (_buffer === void 0) {_buffer = [];}
        var buffer = _buffer.slice();
        var listener = event(function (e) {
            if (buffer) {
                buffer.push(e);
            } else
            {
                emitter.fire(e);
            }
        });
        var flush = function () {
            if (buffer) {
                buffer.forEach(function (e) {return emitter.fire(e);});
            }
            buffer = null;
        };
        var emitter = new Emitter({
            onFirstListenerAdd: function () {
                if (!listener) {
                    listener = event(function (e) {return emitter.fire(e);});
                }
            },
            onFirstListenerDidAdd: function () {
                if (buffer) {
                    if (nextTick) {
                        setTimeout(flush);
                    } else
                    {
                        flush();
                    }
                }
            },
            onLastListenerRemove: function () {
                if (listener) {
                    listener.dispose();
                }
                listener = null;
            } });

        return emitter.event;
    }
    Event.buffer = buffer;
    var ChainableEvent = /** @class */function () {
        function ChainableEvent(event) {
            this.event = event;
        }
        ChainableEvent.prototype.map = function (fn) {
            return new ChainableEvent(map(this.event, fn));
        };
        ChainableEvent.prototype.forEach = function (fn) {
            return new ChainableEvent(forEach(this.event, fn));
        };
        ChainableEvent.prototype.filter = function (fn) {
            return new ChainableEvent(filter(this.event, fn));
        };
        ChainableEvent.prototype.reduce = function (merge, initial) {
            return new ChainableEvent(reduce(this.event, merge, initial));
        };
        ChainableEvent.prototype.latch = function () {
            return new ChainableEvent(latch(this.event));
        };
        ChainableEvent.prototype.debounce = function (merge, delay, leading, leakWarningThreshold) {
            if (delay === void 0) {delay = 100;}
            if (leading === void 0) {leading = false;}
            return new ChainableEvent(debounce(this.event, merge, delay, leading, leakWarningThreshold));
        };
        ChainableEvent.prototype.on = function (listener, thisArgs, disposables) {
            return this.event(listener, thisArgs, disposables);
        };
        ChainableEvent.prototype.once = function (listener, thisArgs, disposables) {
            return once(this.event)(listener, thisArgs, disposables);
        };
        return ChainableEvent;
    }();
    function chain(event) {
        return new ChainableEvent(event);
    }
    Event.chain = chain;
    function fromNodeEventEmitter(emitter, eventName, map) {
        if (map === void 0) {map = function (id) {return id;};}
        var fn = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return result.fire(map.apply(void 0, args));
        };
        var onFirstListenerAdd = function () {return emitter.on(eventName, fn);};
        var onLastListenerRemove = function () {return emitter.removeListener(eventName, fn);};
        var result = new Emitter({ onFirstListenerAdd: onFirstListenerAdd, onLastListenerRemove: onLastListenerRemove });
        return result.event;
    }
    Event.fromNodeEventEmitter = fromNodeEventEmitter;
    function fromDOMEventEmitter(emitter, eventName, map) {
        if (map === void 0) {map = function (id) {return id;};}
        var fn = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return result.fire(map.apply(void 0, args));
        };
        var onFirstListenerAdd = function () {return emitter.addEventListener(eventName, fn);};
        var onLastListenerRemove = function () {return emitter.removeEventListener(eventName, fn);};
        var result = new Emitter({ onFirstListenerAdd: onFirstListenerAdd, onLastListenerRemove: onLastListenerRemove });
        return result.event;
    }
    Event.fromDOMEventEmitter = fromDOMEventEmitter;
    function fromPromise(promise) {
        var emitter = new Emitter();
        var shouldEmit = false;
        promise.
        then(undefined, function () {return null;}).
        then(function () {
            if (!shouldEmit) {
                setTimeout(function () {return emitter.fire(undefined);}, 0);
            } else
            {
                emitter.fire(undefined);
            }
        });
        shouldEmit = true;
        return emitter.event;
    }
    Event.fromPromise = fromPromise;
    function toPromise(event) {
        return new Promise(function (c) {return once(event)(c);});
    }
    Event.toPromise = toPromise;
})(Event || (Event = {}));
var _globalLeakWarningThreshold = -1;
var LeakageMonitor = /** @class */function () {
    function LeakageMonitor(customThreshold, name) {
        if (name === void 0) {name = Math.random().toString(18).slice(2, 5);}
        this.customThreshold = customThreshold;
        this.name = name;
        this._warnCountdown = 0;
    }
    LeakageMonitor.prototype.dispose = function () {
        if (this._stacks) {
            this._stacks.clear();
        }
    };
    LeakageMonitor.prototype.check = function (listenerCount) {
        var _this = this;
        var threshold = _globalLeakWarningThreshold;
        if (typeof this.customThreshold === 'number') {
            threshold = this.customThreshold;
        }
        if (threshold <= 0 || listenerCount < threshold) {
            return undefined;
        }
        if (!this._stacks) {
            this._stacks = new Map();
        }
        var stack = new Error().stack.split('\n').slice(3).join('\n');
        var count = this._stacks.get(stack) || 0;
        this._stacks.set(stack, count + 1);
        this._warnCountdown -= 1;
        if (this._warnCountdown <= 0) {
            // only warn on first exceed and then every time the limit
            // is exceeded by 50% again
            this._warnCountdown = threshold * 0.5;
            // find most frequent listener and print warning
            var topStack_1;
            var topCount_1 = 0;
            this._stacks.forEach(function (count, stack) {
                if (!topStack_1 || topCount_1 < count) {
                    topStack_1 = stack;
                    topCount_1 = count;
                }
            });
            console.warn("[" + this.name + "] potential listener LEAK detected, having " + listenerCount + " listeners already. MOST frequent listener (" + topCount_1 + "):");
            console.warn(topStack_1);
        }
        return function () {
            var count = _this._stacks.get(stack) || 0;
            _this._stacks.set(stack, count - 1);
        };
    };
    return LeakageMonitor;
}();
/**
      * The Emitter can be used to expose an Event to the public
      * to fire it from the insides.
      * Sample:
         class Document {
     
             private readonly _onDidChange = new Emitter<(value:string)=>any>();
     
             public onDidChange = this._onDidChange.event;
     
             // getter-style
             // get onDidChange(): Event<(value:string)=>any> {
             // 	return this._onDidChange.event;
             // }
     
             private _doIt() {
                 //...
                 this._onDidChange.fire(value);
             }
         }
      */
var Emitter = /** @class */function () {
    function Emitter(options) {
        this._disposed = false;
        this._options = options;
        this._leakageMon = _globalLeakWarningThreshold > 0 ?
        new LeakageMonitor(this._options && this._options.leakWarningThreshold) :
        undefined;
    }
    Object.defineProperty(Emitter.prototype, "event", {
        /**
                                                         * For the public to allow to subscribe
                                                         * to events from this Emitter
                                                         */
        get: function () {
            var _this = this;
            if (!this._event) {
                this._event = function (listener, thisArgs, disposables) {
                    if (!_this._listeners) {
                        _this._listeners = new _linkedList_js__WEBPACK_IMPORTED_MODULE_3__["LinkedList"]();
                    }
                    var firstListener = _this._listeners.isEmpty();
                    if (firstListener && _this._options && _this._options.onFirstListenerAdd) {
                        _this._options.onFirstListenerAdd(_this);
                    }
                    var remove = _this._listeners.push(!thisArgs ? listener : [listener, thisArgs]);
                    if (firstListener && _this._options && _this._options.onFirstListenerDidAdd) {
                        _this._options.onFirstListenerDidAdd(_this);
                    }
                    if (_this._options && _this._options.onListenerDidAdd) {
                        _this._options.onListenerDidAdd(_this, listener, thisArgs);
                    }
                    // check and record this emitter for potential leakage
                    var removeMonitor;
                    if (_this._leakageMon) {
                        removeMonitor = _this._leakageMon.check(_this._listeners.size);
                    }
                    var result;
                    result = {
                        dispose: function () {
                            if (removeMonitor) {
                                removeMonitor();
                            }
                            result.dispose = Emitter._noop;
                            if (!_this._disposed) {
                                remove();
                                if (_this._options && _this._options.onLastListenerRemove) {
                                    var hasListeners = _this._listeners && !_this._listeners.isEmpty();
                                    if (!hasListeners) {
                                        _this._options.onLastListenerRemove(_this);
                                    }
                                }
                            }
                        } };

                    if (disposables instanceof _lifecycle_js__WEBPACK_IMPORTED_MODULE_2__["DisposableStore"]) {
                        disposables.add(result);
                    } else
                    if (Array.isArray(disposables)) {
                        disposables.push(result);
                    }
                    return result;
                };
            }
            return this._event;
        },
        enumerable: true,
        configurable: true });

    /**
                                * To be kept private to fire an event to
                                * subscribers
                                */
    Emitter.prototype.fire = function (event) {
        if (this._listeners) {
            // put all [listener,event]-pairs into delivery queue
            // then emit all event. an inner/nested event might be
            // the driver of this
            if (!this._deliveryQueue) {
                this._deliveryQueue = new _linkedList_js__WEBPACK_IMPORTED_MODULE_3__["LinkedList"]();
            }
            for (var iter = this._listeners.iterator(), e = iter.next(); !e.done; e = iter.next()) {
                this._deliveryQueue.push([e.value, event]);
            }
            while (this._deliveryQueue.size > 0) {
                var _a = this._deliveryQueue.shift(),listener = _a[0],event_1 = _a[1];
                try {
                    if (typeof listener === 'function') {
                        listener.call(undefined, event_1);
                    } else
                    {
                        listener[0].call(listener[1], event_1);
                    }
                }
                catch (e) {
                    Object(_errors_js__WEBPACK_IMPORTED_MODULE_0__["onUnexpectedError"])(e);
                }
            }
        }
    };
    Emitter.prototype.dispose = function () {
        if (this._listeners) {
            this._listeners.clear();
        }
        if (this._deliveryQueue) {
            this._deliveryQueue.clear();
        }
        if (this._leakageMon) {
            this._leakageMon.dispose();
        }
        this._disposed = true;
    };
    Emitter._noop = function () {};
    return Emitter;
}();

var PauseableEmitter = /** @class */function (_super) {
    __extends(PauseableEmitter, _super);
    function PauseableEmitter(options) {
        var _this = _super.call(this, options) || this;
        _this._isPaused = 0;
        _this._eventQueue = new _linkedList_js__WEBPACK_IMPORTED_MODULE_3__["LinkedList"]();
        _this._mergeFn = options && options.merge;
        return _this;
    }
    PauseableEmitter.prototype.pause = function () {
        this._isPaused++;
    };
    PauseableEmitter.prototype.resume = function () {
        if (this._isPaused !== 0 && --this._isPaused === 0) {
            if (this._mergeFn) {
                // use the merge function to create a single composite
                // event. make a copy in case firing pauses this emitter
                var events = this._eventQueue.toArray();
                this._eventQueue.clear();
                _super.prototype.fire.call(this, this._mergeFn(events));
            } else
            {
                // no merging, fire each event individually and test
                // that this emitter isn't paused halfway through
                while (!this._isPaused && this._eventQueue.size !== 0) {
                    _super.prototype.fire.call(this, this._eventQueue.shift());
                }
            }
        }
    };
    PauseableEmitter.prototype.fire = function (event) {
        if (this._listeners) {
            if (this._isPaused !== 0) {
                this._eventQueue.push(event);
            } else
            {
                _super.prototype.fire.call(this, event);
            }
        }
    };
    return PauseableEmitter;
}(Emitter);

var EventMultiplexer = /** @class */function () {
    function EventMultiplexer() {
        var _this = this;
        this.hasListeners = false;
        this.events = [];
        this.emitter = new Emitter({
            onFirstListenerAdd: function () {return _this.onFirstListenerAdd();},
            onLastListenerRemove: function () {return _this.onLastListenerRemove();} });

    }
    Object.defineProperty(EventMultiplexer.prototype, "event", {
        get: function () {
            return this.emitter.event;
        },
        enumerable: true,
        configurable: true });

    EventMultiplexer.prototype.add = function (event) {
        var _this = this;
        var e = { event: event, listener: null };
        this.events.push(e);
        if (this.hasListeners) {
            this.hook(e);
        }
        var dispose = function () {
            if (_this.hasListeners) {
                _this.unhook(e);
            }
            var idx = _this.events.indexOf(e);
            _this.events.splice(idx, 1);
        };
        return Object(_lifecycle_js__WEBPACK_IMPORTED_MODULE_2__["toDisposable"])(Object(_functional_js__WEBPACK_IMPORTED_MODULE_1__["once"])(dispose));
    };
    EventMultiplexer.prototype.onFirstListenerAdd = function () {
        var _this = this;
        this.hasListeners = true;
        this.events.forEach(function (e) {return _this.hook(e);});
    };
    EventMultiplexer.prototype.onLastListenerRemove = function () {
        var _this = this;
        this.hasListeners = false;
        this.events.forEach(function (e) {return _this.unhook(e);});
    };
    EventMultiplexer.prototype.hook = function (e) {
        var _this = this;
        e.listener = e.event(function (r) {return _this.emitter.fire(r);});
    };
    EventMultiplexer.prototype.unhook = function (e) {
        if (e.listener) {
            e.listener.dispose();
        }
        e.listener = null;
    };
    EventMultiplexer.prototype.dispose = function () {
        this.emitter.dispose();
    };
    return EventMultiplexer;
}();

/**
                              * The EventBufferer is useful in situations in which you want
                              * to delay firing your events during some code.
                              * You can wrap that code and be sure that the event will not
                              * be fired during that wrap.
                              *
                              * ```
                              * const emitter: Emitter;
                              * const delayer = new EventDelayer();
                              * const delayedEvent = delayer.wrapEvent(emitter.event);
                              *
                              * delayedEvent(console.log);
                              *
                              * delayer.bufferEvents(() => {
                              *   emitter.fire(); // event will not be fired yet
                              * });
                              *
                              * // event will only be fired at this point
                              * ```
                              */
var EventBufferer = /** @class */function () {
    function EventBufferer() {
        this.buffers = [];
    }
    EventBufferer.prototype.wrapEvent = function (event) {
        var _this = this;
        return function (listener, thisArgs, disposables) {
            return event(function (i) {
                var buffer = _this.buffers[_this.buffers.length - 1];
                if (buffer) {
                    buffer.push(function () {return listener.call(thisArgs, i);});
                } else
                {
                    listener.call(thisArgs, i);
                }
            }, undefined, disposables);
        };
    };
    EventBufferer.prototype.bufferEvents = function (fn) {
        var buffer = [];
        this.buffers.push(buffer);
        var r = fn();
        this.buffers.pop();
        buffer.forEach(function (flush) {return flush();});
        return r;
    };
    return EventBufferer;
}();

/**
                           * A Relay is an event forwarder which functions as a replugabble event pipe.
                           * Once created, you can connect an input event to it and it will simply forward
                           * events from that input event through its own `event` property. The `input`
                           * can be changed at any point in time.
                           */
var Relay = /** @class */function () {
    function Relay() {
        var _this = this;
        this.listening = false;
        this.inputEvent = Event.None;
        this.inputEventListener = _lifecycle_js__WEBPACK_IMPORTED_MODULE_2__["Disposable"].None;
        this.emitter = new Emitter({
            onFirstListenerDidAdd: function () {
                _this.listening = true;
                _this.inputEventListener = _this.inputEvent(_this.emitter.fire, _this.emitter);
            },
            onLastListenerRemove: function () {
                _this.listening = false;
                _this.inputEventListener.dispose();
            } });

        this.event = this.emitter.event;
    }
    Object.defineProperty(Relay.prototype, "input", {
        set: function (event) {
            this.inputEvent = event;
            if (this.listening) {
                this.inputEventListener.dispose();
                this.inputEventListener = event(this.emitter.fire, this.emitter);
            }
        },
        enumerable: true,
        configurable: true });

    Relay.prototype.dispose = function () {
        this.inputEventListener.dispose();
        this.emitter.dispose();
    };
    return Relay;
}();


/***/ }),

/***/ 6214:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ErrorHandler", function() { return ErrorHandler; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "errorHandler", function() { return errorHandler; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "onUnexpectedError", function() { return onUnexpectedError; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "onUnexpectedExternalError", function() { return onUnexpectedExternalError; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "transformErrorForSerialization", function() { return transformErrorForSerialization; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isPromiseCanceledError", function() { return isPromiseCanceledError; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "canceled", function() { return canceled; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "illegalArgument", function() { return illegalArgument; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "illegalState", function() { return illegalState; });
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
// Avoid circular dependency on EventEmitter by implementing a subset of the interface.
var ErrorHandler = /** @class */function () {
    function ErrorHandler() {
        this.listeners = [];
        this.unexpectedErrorHandler = function (e) {
            setTimeout(function () {
                if (e.stack) {
                    throw new Error(e.message + '\n\n' + e.stack);
                }
                throw e;
            }, 0);
        };
    }
    ErrorHandler.prototype.emit = function (e) {
        this.listeners.forEach(function (listener) {
            listener(e);
        });
    };
    ErrorHandler.prototype.onUnexpectedError = function (e) {
        this.unexpectedErrorHandler(e);
        this.emit(e);
    };
    // For external errors, we don't want the listeners to be called
    ErrorHandler.prototype.onUnexpectedExternalError = function (e) {
        this.unexpectedErrorHandler(e);
    };
    return ErrorHandler;
}();

var errorHandler = new ErrorHandler();
function onUnexpectedError(e) {
    // ignore errors from cancelled promises
    if (!isPromiseCanceledError(e)) {
        errorHandler.onUnexpectedError(e);
    }
    return undefined;
}
function onUnexpectedExternalError(e) {
    // ignore errors from cancelled promises
    if (!isPromiseCanceledError(e)) {
        errorHandler.onUnexpectedExternalError(e);
    }
    return undefined;
}
function transformErrorForSerialization(error) {
    if (error instanceof Error) {
        var name_1 = error.name,message = error.message;
        var stack = error.stacktrace || error.stack;
        return {
            $isError: true,
            name: name_1,
            message: message,
            stack: stack };

    }
    // return as is
    return error;
}
var canceledName = 'Canceled';
/**
                                * Checks if the given error is a promise in canceled state
                                */
function isPromiseCanceledError(error) {
    return error instanceof Error && error.name === canceledName && error.message === canceledName;
}
/**
   * Returns an error that signals cancellation.
   */
function canceled() {
    var error = new Error(canceledName);
    error.name = error.message;
    return error;
}
function illegalArgument(name) {
    if (name) {
        return new Error("Illegal argument: " + name);
    } else
    {
        return new Error('Illegal argument');
    }
}
function illegalState(name) {
    if (name) {
        return new Error("Illegal state: " + name);
    } else
    {
        return new Error('Illegal state');
    }
}

/***/ }),

/***/ 6215:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "once", function() { return once; });
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
function once(fn) {
    var _this = this;
    var didCall = false;
    var result;
    return function () {
        if (didCall) {
            return result;
        }
        didCall = true;
        result = fn.apply(_this, arguments);
        return result;
    };
}

/***/ }),

/***/ 6216:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isDisposable", function() { return isDisposable; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "dispose", function() { return dispose; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "combinedDisposable", function() { return combinedDisposable; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "toDisposable", function() { return toDisposable; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DisposableStore", function() { return DisposableStore; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Disposable", function() { return Disposable; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "MutableDisposable", function() { return MutableDisposable; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ImmortalReference", function() { return ImmortalReference; });
/**
 * Enables logging of potentially leaked disposables.
 *
 * A disposable is considered leaked if it is not disposed or not registered as the child of
 * another disposable. This tracking is very simple an only works for classes that either
 * extend Disposable or use a DisposableStore. This means there are a lot of false positives.
 */
var TRACK_DISPOSABLES = false;
var __is_disposable_tracked__ = '__is_disposable_tracked__';
function markTracked(x) {
    if (!TRACK_DISPOSABLES) {
        return;
    }
    if (x && x !== Disposable.None) {
        try {
            x[__is_disposable_tracked__] = true;
        }
        catch (_a) {
            // noop
        }
    }
}
function trackDisposable(x) {
    if (!TRACK_DISPOSABLES) {
        return x;
    }
    var stack = new Error('Potentially leaked disposable').stack;
    setTimeout(function () {
        if (!x[__is_disposable_tracked__]) {
            console.log(stack);
        }
    }, 3000);
    return x;
}
function isDisposable(thing) {
    return typeof thing.dispose === 'function' &&
    thing.dispose.length === 0;
}
function dispose(disposables) {
    if (Array.isArray(disposables)) {
        disposables.forEach(function (d) {
            if (d) {
                markTracked(d);
                d.dispose();
            }
        });
        return [];
    } else
    if (disposables) {
        markTracked(disposables);
        disposables.dispose();
        return disposables;
    } else
    {
        return undefined;
    }
}
function combinedDisposable() {
    var disposables = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        disposables[_i] = arguments[_i];
    }
    disposables.forEach(markTracked);
    return trackDisposable({ dispose: function () {return dispose(disposables);} });
}
function toDisposable(fn) {
    var self = trackDisposable({
        dispose: function () {
            markTracked(self);
            fn();
        } });

    return self;
}
var DisposableStore = /** @class */function () {
    function DisposableStore() {
        this._toDispose = new Set();
        this._isDisposed = false;
    }
    /**
       * Dispose of all registered disposables and mark this object as disposed.
       *
       * Any future disposables added to this object will be disposed of on `add`.
       */
    DisposableStore.prototype.dispose = function () {
        if (this._isDisposed) {
            return;
        }
        markTracked(this);
        this._isDisposed = true;
        this.clear();
    };
    /**
        * Dispose of all registered disposables but do not mark this object as disposed.
        */
    DisposableStore.prototype.clear = function () {
        this._toDispose.forEach(function (item) {return item.dispose();});
        this._toDispose.clear();
    };
    DisposableStore.prototype.add = function (t) {
        if (!t) {
            return t;
        }
        if (t === this) {
            throw new Error('Cannot register a disposable on itself!');
        }
        markTracked(t);
        if (this._isDisposed) {
            console.warn(new Error('Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!').stack);
        } else
        {
            this._toDispose.add(t);
        }
        return t;
    };
    return DisposableStore;
}();

var Disposable = /** @class */function () {
    function Disposable() {
        this._store = new DisposableStore();
        trackDisposable(this);
    }
    Disposable.prototype.dispose = function () {
        markTracked(this);
        this._store.dispose();
    };
    Disposable.prototype._register = function (t) {
        if (t === this) {
            throw new Error('Cannot register a disposable on itself!');
        }
        return this._store.add(t);
    };
    Disposable.None = Object.freeze({ dispose: function () {} });
    return Disposable;
}();

/**
                        * Manages the lifecycle of a disposable value that may be changed.
                        *
                        * This ensures that when the disposable value is changed, the previously held disposable is disposed of. You can
                        * also register a `MutableDisposable` on a `Disposable` to ensure it is automatically cleaned up.
                        */
var MutableDisposable = /** @class */function () {
    function MutableDisposable() {
        this._isDisposed = false;
        trackDisposable(this);
    }
    Object.defineProperty(MutableDisposable.prototype, "value", {
        get: function () {
            return this._isDisposed ? undefined : this._value;
        },
        set: function (value) {
            if (this._isDisposed || value === this._value) {
                return;
            }
            if (this._value) {
                this._value.dispose();
            }
            if (value) {
                markTracked(value);
            }
            this._value = value;
        },
        enumerable: true,
        configurable: true });

    MutableDisposable.prototype.clear = function () {
        this.value = undefined;
    };
    MutableDisposable.prototype.dispose = function () {
        this._isDisposed = true;
        markTracked(this);
        if (this._value) {
            this._value.dispose();
        }
        this._value = undefined;
    };
    return MutableDisposable;
}();

var ImmortalReference = /** @class */function () {
    function ImmortalReference(object) {
        this.object = object;
    }
    ImmortalReference.prototype.dispose = function () {};
    return ImmortalReference;
}();


/***/ }),

/***/ 6217:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LinkedList", function() { return LinkedList; });
/* harmony import */ var _iterator_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6218);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/

var Node = /** @class */function () {
    function Node(element) {
        this.element = element;
        this.next = Node.Undefined;
        this.prev = Node.Undefined;
    }
    Node.Undefined = new Node(undefined);
    return Node;
}();
var LinkedList = /** @class */function () {
    function LinkedList() {
        this._first = Node.Undefined;
        this._last = Node.Undefined;
        this._size = 0;
    }
    Object.defineProperty(LinkedList.prototype, "size", {
        get: function () {
            return this._size;
        },
        enumerable: true,
        configurable: true });

    LinkedList.prototype.isEmpty = function () {
        return this._first === Node.Undefined;
    };
    LinkedList.prototype.clear = function () {
        this._first = Node.Undefined;
        this._last = Node.Undefined;
        this._size = 0;
    };
    LinkedList.prototype.unshift = function (element) {
        return this._insert(element, false);
    };
    LinkedList.prototype.push = function (element) {
        return this._insert(element, true);
    };
    LinkedList.prototype._insert = function (element, atTheEnd) {
        var _this = this;
        var newNode = new Node(element);
        if (this._first === Node.Undefined) {
            this._first = newNode;
            this._last = newNode;
        } else
        if (atTheEnd) {
            // push
            var oldLast = this._last;
            this._last = newNode;
            newNode.prev = oldLast;
            oldLast.next = newNode;
        } else
        {
            // unshift
            var oldFirst = this._first;
            this._first = newNode;
            newNode.next = oldFirst;
            oldFirst.prev = newNode;
        }
        this._size += 1;
        var didRemove = false;
        return function () {
            if (!didRemove) {
                didRemove = true;
                _this._remove(newNode);
            }
        };
    };
    LinkedList.prototype.shift = function () {
        if (this._first === Node.Undefined) {
            return undefined;
        } else
        {
            var res = this._first.element;
            this._remove(this._first);
            return res;
        }
    };
    LinkedList.prototype.pop = function () {
        if (this._last === Node.Undefined) {
            return undefined;
        } else
        {
            var res = this._last.element;
            this._remove(this._last);
            return res;
        }
    };
    LinkedList.prototype._remove = function (node) {
        if (node.prev !== Node.Undefined && node.next !== Node.Undefined) {
            // middle
            var anchor = node.prev;
            anchor.next = node.next;
            node.next.prev = anchor;
        } else
        if (node.prev === Node.Undefined && node.next === Node.Undefined) {
            // only node
            this._first = Node.Undefined;
            this._last = Node.Undefined;
        } else
        if (node.next === Node.Undefined) {
            // last
            this._last = this._last.prev;
            this._last.next = Node.Undefined;
        } else
        if (node.prev === Node.Undefined) {
            // first
            this._first = this._first.next;
            this._first.prev = Node.Undefined;
        }
        // done
        this._size -= 1;
    };
    LinkedList.prototype.iterator = function () {
        var element;
        var node = this._first;
        return {
            next: function () {
                if (node === Node.Undefined) {
                    return _iterator_js__WEBPACK_IMPORTED_MODULE_0__["FIN"];
                }
                if (!element) {
                    element = { done: false, value: node.element };
                } else
                {
                    element.value = node.element;
                }
                node = node.next;
                return element;
            } };

    };
    LinkedList.prototype.toArray = function () {
        var result = [];
        for (var node = this._first; node !== Node.Undefined; node = node.next) {
            result.push(node.element);
        }
        return result;
    };
    return LinkedList;
}();


/***/ }),

/***/ 6218:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FIN", function() { return FIN; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Iterator", function() { return Iterator; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ChainableIterator", function() { return ChainableIterator; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getSequenceIterator", function() { return getSequenceIterator; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ArrayIterator", function() { return ArrayIterator; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ArrayNavigator", function() { return ArrayNavigator; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "MappedIterator", function() { return MappedIterator; });
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __extends = undefined && undefined.__extends || function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
        { __proto__: [] } instanceof Array && function (d, b) {d.__proto__ = b;} ||
        function (d, b) {for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];};
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {this.constructor = d;}
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();
var FIN = { done: true, value: undefined };
var Iterator;
(function (Iterator) {
    var _empty = {
        next: function () {
            return FIN;
        } };

    function empty() {
        return _empty;
    }
    Iterator.empty = empty;
    function single(value) {
        var done = false;
        return {
            next: function () {
                if (done) {
                    return FIN;
                }
                done = true;
                return { done: false, value: value };
            } };

    }
    Iterator.single = single;
    function fromArray(array, index, length) {
        if (index === void 0) {index = 0;}
        if (length === void 0) {length = array.length;}
        return {
            next: function () {
                if (index >= length) {
                    return FIN;
                }
                return { done: false, value: array[index++] };
            } };

    }
    Iterator.fromArray = fromArray;
    function fromNativeIterator(it) {
        return {
            next: function () {
                var result = it.next();
                if (result.done) {
                    return FIN;
                }
                return { done: false, value: result.value };
            } };

    }
    Iterator.fromNativeIterator = fromNativeIterator;
    function from(elements) {
        if (!elements) {
            return Iterator.empty();
        } else
        if (Array.isArray(elements)) {
            return Iterator.fromArray(elements);
        } else
        {
            return elements;
        }
    }
    Iterator.from = from;
    function map(iterator, fn) {
        return {
            next: function () {
                var element = iterator.next();
                if (element.done) {
                    return FIN;
                } else
                {
                    return { done: false, value: fn(element.value) };
                }
            } };

    }
    Iterator.map = map;
    function filter(iterator, fn) {
        return {
            next: function () {
                while (true) {
                    var element = iterator.next();
                    if (element.done) {
                        return FIN;
                    }
                    if (fn(element.value)) {
                        return { done: false, value: element.value };
                    }
                }
            } };

    }
    Iterator.filter = filter;
    function forEach(iterator, fn) {
        for (var next = iterator.next(); !next.done; next = iterator.next()) {
            fn(next.value);
        }
    }
    Iterator.forEach = forEach;
    function collect(iterator, atMost) {
        if (atMost === void 0) {atMost = Number.POSITIVE_INFINITY;}
        var result = [];
        if (atMost === 0) {
            return result;
        }
        var i = 0;
        for (var next = iterator.next(); !next.done; next = iterator.next()) {
            result.push(next.value);
            if (++i >= atMost) {
                break;
            }
        }
        return result;
    }
    Iterator.collect = collect;
    function concat() {
        var iterators = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            iterators[_i] = arguments[_i];
        }
        var i = 0;
        return {
            next: function () {
                if (i >= iterators.length) {
                    return FIN;
                }
                var iterator = iterators[i];
                var result = iterator.next();
                if (result.done) {
                    i++;
                    return this.next();
                }
                return result;
            } };

    }
    Iterator.concat = concat;
    function chain(iterator) {
        return new ChainableIterator(iterator);
    }
    Iterator.chain = chain;
})(Iterator || (Iterator = {}));
var ChainableIterator = /** @class */function () {
    function ChainableIterator(it) {
        this.it = it;
    }
    ChainableIterator.prototype.next = function () {return this.it.next();};
    return ChainableIterator;
}();

function getSequenceIterator(arg) {
    if (Array.isArray(arg)) {
        return Iterator.fromArray(arg);
    } else
    if (!arg) {
        return Iterator.empty();
    } else
    {
        return arg;
    }
}
var ArrayIterator = /** @class */function () {
    function ArrayIterator(items, start, end, index) {
        if (start === void 0) {start = 0;}
        if (end === void 0) {end = items.length;}
        if (index === void 0) {index = start - 1;}
        this.items = items;
        this.start = start;
        this.end = end;
        this.index = index;
    }
    ArrayIterator.prototype.first = function () {
        this.index = this.start;
        return this.current();
    };
    ArrayIterator.prototype.next = function () {
        this.index = Math.min(this.index + 1, this.end);
        return this.current();
    };
    ArrayIterator.prototype.current = function () {
        if (this.index === this.start - 1 || this.index === this.end) {
            return null;
        }
        return this.items[this.index];
    };
    return ArrayIterator;
}();

var ArrayNavigator = /** @class */function (_super) {
    __extends(ArrayNavigator, _super);
    function ArrayNavigator(items, start, end, index) {
        if (start === void 0) {start = 0;}
        if (end === void 0) {end = items.length;}
        if (index === void 0) {index = start - 1;}
        return _super.call(this, items, start, end, index) || this;
    }
    ArrayNavigator.prototype.current = function () {
        return _super.prototype.current.call(this);
    };
    ArrayNavigator.prototype.previous = function () {
        this.index = Math.max(this.index - 1, this.start - 1);
        return this.current();
    };
    ArrayNavigator.prototype.first = function () {
        this.index = this.start;
        return this.current();
    };
    ArrayNavigator.prototype.last = function () {
        this.index = this.end - 1;
        return this.current();
    };
    ArrayNavigator.prototype.parent = function () {
        return null;
    };
    return ArrayNavigator;
}(ArrayIterator);

var MappedIterator = /** @class */function () {
    function MappedIterator(iterator, fn) {
        this.iterator = iterator;
        this.fn = fn;
        // noop
    }
    MappedIterator.prototype.next = function () {return this.fn(this.iterator.next());};
    return MappedIterator;
}();


/***/ }),

/***/ 6219:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isFalsyOrWhitespace", function() { return isFalsyOrWhitespace; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "pad", function() { return pad; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "format", function() { return format; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "escape", function() { return escape; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "escapeRegExpCharacters", function() { return escapeRegExpCharacters; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "trim", function() { return trim; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ltrim", function() { return ltrim; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "rtrim", function() { return rtrim; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "convertSimple2RegExpPattern", function() { return convertSimple2RegExpPattern; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "startsWith", function() { return startsWith; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "endsWith", function() { return endsWith; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "createRegExp", function() { return createRegExp; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "regExpLeadsToEndlessLoop", function() { return regExpLeadsToEndlessLoop; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "regExpFlags", function() { return regExpFlags; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "firstNonWhitespaceIndex", function() { return firstNonWhitespaceIndex; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getLeadingWhitespace", function() { return getLeadingWhitespace; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "lastNonWhitespaceIndex", function() { return lastNonWhitespaceIndex; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "compare", function() { return compare; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "compareIgnoreCase", function() { return compareIgnoreCase; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isLowerAsciiLetter", function() { return isLowerAsciiLetter; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isUpperAsciiLetter", function() { return isUpperAsciiLetter; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "equalsIgnoreCase", function() { return equalsIgnoreCase; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "startsWithIgnoreCase", function() { return startsWithIgnoreCase; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "commonPrefixLength", function() { return commonPrefixLength; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "commonSuffixLength", function() { return commonSuffixLength; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isHighSurrogate", function() { return isHighSurrogate; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isLowSurrogate", function() { return isLowSurrogate; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getNextCodePoint", function() { return getNextCodePoint; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "nextCharLength", function() { return nextCharLength; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "prevCharLength", function() { return prevCharLength; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "containsRTL", function() { return containsRTL; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "containsEmoji", function() { return containsEmoji; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isBasicASCII", function() { return isBasicASCII; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "containsFullWidthCharacter", function() { return containsFullWidthCharacter; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isFullWidthCharacter", function() { return isFullWidthCharacter; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isEmojiImprecise", function() { return isEmojiImprecise; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "UTF8_BOM_CHARACTER", function() { return UTF8_BOM_CHARACTER; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "startsWithUTF8BOM", function() { return startsWithUTF8BOM; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "safeBtoa", function() { return safeBtoa; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "repeat", function() { return repeat; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "containsUppercaseCharacter", function() { return containsUppercaseCharacter; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "singleLetterHash", function() { return singleLetterHash; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getGraphemeBreakType", function() { return getGraphemeBreakType; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "breakBetweenGraphemeBreakType", function() { return breakBetweenGraphemeBreakType; });
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
function isFalsyOrWhitespace(str) {
    if (!str || typeof str !== 'string') {
        return true;
    }
    return str.trim().length === 0;
}
/**
   * @returns the provided number with the given number of preceding zeros.
   */
function pad(n, l, char) {
    if (char === void 0) {char = '0';}
    var str = '' + n;
    var r = [str];
    for (var i = str.length; i < l; i++) {
        r.push(char);
    }
    return r.reverse().join('');
}
var _formatRegexp = /{(\d+)}/g;
/**
                                 * Helper to produce a string with a variable number of arguments. Insert variable segments
                                 * into the string using the {n} notation where N is the index of the argument following the string.
                                 * @param value string to which formatting is applied
                                 * @param args replacements for {n}-entries
                                 */
function format(value) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    if (args.length === 0) {
        return value;
    }
    return value.replace(_formatRegexp, function (match, group) {
        var idx = parseInt(group, 10);
        return isNaN(idx) || idx < 0 || idx >= args.length ?
        match :
        args[idx];
    });
}
/**
   * Converts HTML characters inside the string to use entities instead. Makes the string safe from
   * being used e.g. in HTMLElement.innerHTML.
   */
function escape(html) {
    return html.replace(/[<>&]/g, function (match) {
        switch (match) {
            case '<':return '&lt;';
            case '>':return '&gt;';
            case '&':return '&amp;';
            default:return match;}

    });
}
/**
   * Escapes regular expression characters in a given string
   */
function escapeRegExpCharacters(value) {
    return value.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g, '\\$&');
}
/**
   * Removes all occurrences of needle from the beginning and end of haystack.
   * @param haystack string to trim
   * @param needle the thing to trim (default is a blank)
   */
function trim(haystack, needle) {
    if (needle === void 0) {needle = ' ';}
    var trimmed = ltrim(haystack, needle);
    return rtrim(trimmed, needle);
}
/**
   * Removes all occurrences of needle from the beginning of haystack.
   * @param haystack string to trim
   * @param needle the thing to trim
   */
function ltrim(haystack, needle) {
    if (!haystack || !needle) {
        return haystack;
    }
    var needleLen = needle.length;
    if (needleLen === 0 || haystack.length === 0) {
        return haystack;
    }
    var offset = 0;
    while (haystack.indexOf(needle, offset) === offset) {
        offset = offset + needleLen;
    }
    return haystack.substring(offset);
}
/**
   * Removes all occurrences of needle from the end of haystack.
   * @param haystack string to trim
   * @param needle the thing to trim
   */
function rtrim(haystack, needle) {
    if (!haystack || !needle) {
        return haystack;
    }
    var needleLen = needle.length,haystackLen = haystack.length;
    if (needleLen === 0 || haystackLen === 0) {
        return haystack;
    }
    var offset = haystackLen,idx = -1;
    while (true) {
        idx = haystack.lastIndexOf(needle, offset - 1);
        if (idx === -1 || idx + needleLen !== offset) {
            break;
        }
        if (idx === 0) {
            return '';
        }
        offset = idx;
    }
    return haystack.substring(0, offset);
}
function convertSimple2RegExpPattern(pattern) {
    return pattern.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g, '\\$&').replace(/[\*]/g, '.*');
}
/**
   * Determines if haystack starts with needle.
   */
function startsWith(haystack, needle) {
    if (haystack.length < needle.length) {
        return false;
    }
    if (haystack === needle) {
        return true;
    }
    for (var i = 0; i < needle.length; i++) {
        if (haystack[i] !== needle[i]) {
            return false;
        }
    }
    return true;
}
/**
   * Determines if haystack ends with needle.
   */
function endsWith(haystack, needle) {
    var diff = haystack.length - needle.length;
    if (diff > 0) {
        return haystack.indexOf(needle, diff) === diff;
    } else
    if (diff === 0) {
        return haystack === needle;
    } else
    {
        return false;
    }
}
function createRegExp(searchString, isRegex, options) {
    if (options === void 0) {options = {};}
    if (!searchString) {
        throw new Error('Cannot create regex from empty string');
    }
    if (!isRegex) {
        searchString = escapeRegExpCharacters(searchString);
    }
    if (options.wholeWord) {
        if (!/\B/.test(searchString.charAt(0))) {
            searchString = '\\b' + searchString;
        }
        if (!/\B/.test(searchString.charAt(searchString.length - 1))) {
            searchString = searchString + '\\b';
        }
    }
    var modifiers = '';
    if (options.global) {
        modifiers += 'g';
    }
    if (!options.matchCase) {
        modifiers += 'i';
    }
    if (options.multiline) {
        modifiers += 'm';
    }
    if (options.unicode) {
        modifiers += 'u';
    }
    return new RegExp(searchString, modifiers);
}
function regExpLeadsToEndlessLoop(regexp) {
    // Exit early if it's one of these special cases which are meant to match
    // against an empty string
    if (regexp.source === '^' || regexp.source === '^$' || regexp.source === '$' || regexp.source === '^\\s*$') {
        return false;
    }
    // We check against an empty string. If the regular expression doesn't advance
    // (e.g. ends in an endless loop) it will match an empty string.
    var match = regexp.exec('');
    return !!(match && regexp.lastIndex === 0);
}
function regExpFlags(regexp) {
    return (regexp.global ? 'g' : '') + (
    regexp.ignoreCase ? 'i' : '') + (
    regexp.multiline ? 'm' : '') + (
    regexp.unicode ? 'u' : '');
}
/**
   * Returns first index of the string that is not whitespace.
   * If string is empty or contains only whitespaces, returns -1
   */
function firstNonWhitespaceIndex(str) {
    for (var i = 0, len = str.length; i < len; i++) {
        var chCode = str.charCodeAt(i);
        if (chCode !== 32 /* Space */ && chCode !== 9 /* Tab */) {
                return i;
            }
    }
    return -1;
}
/**
   * Returns the leading whitespace of the string.
   * If the string contains only whitespaces, returns entire string
   */
function getLeadingWhitespace(str, start, end) {
    if (start === void 0) {start = 0;}
    if (end === void 0) {end = str.length;}
    for (var i = start; i < end; i++) {
        var chCode = str.charCodeAt(i);
        if (chCode !== 32 /* Space */ && chCode !== 9 /* Tab */) {
                return str.substring(start, i);
            }
    }
    return str.substring(start, end);
}
/**
   * Returns last index of the string that is not whitespace.
   * If string is empty or contains only whitespaces, returns -1
   */
function lastNonWhitespaceIndex(str, startIndex) {
    if (startIndex === void 0) {startIndex = str.length - 1;}
    for (var i = startIndex; i >= 0; i--) {
        var chCode = str.charCodeAt(i);
        if (chCode !== 32 /* Space */ && chCode !== 9 /* Tab */) {
                return i;
            }
    }
    return -1;
}
function compare(a, b) {
    if (a < b) {
        return -1;
    } else
    if (a > b) {
        return 1;
    } else
    {
        return 0;
    }
}
function compareIgnoreCase(a, b) {
    var len = Math.min(a.length, b.length);
    for (var i = 0; i < len; i++) {
        var codeA = a.charCodeAt(i);
        var codeB = b.charCodeAt(i);
        if (codeA === codeB) {
            // equal
            continue;
        }
        if (isUpperAsciiLetter(codeA)) {
            codeA += 32;
        }
        if (isUpperAsciiLetter(codeB)) {
            codeB += 32;
        }
        var diff = codeA - codeB;
        if (diff === 0) {
            // equal -> ignoreCase
            continue;
        } else
        if (isLowerAsciiLetter(codeA) && isLowerAsciiLetter(codeB)) {
            //
            return diff;
        } else
        {
            return compare(a.toLowerCase(), b.toLowerCase());
        }
    }
    if (a.length < b.length) {
        return -1;
    } else
    if (a.length > b.length) {
        return 1;
    } else
    {
        return 0;
    }
}
function isLowerAsciiLetter(code) {
    return code >= 97 /* a */ && code <= 122 /* z */;
}
function isUpperAsciiLetter(code) {
    return code >= 65 /* A */ && code <= 90 /* Z */;
}
function isAsciiLetter(code) {
    return isLowerAsciiLetter(code) || isUpperAsciiLetter(code);
}
function equalsIgnoreCase(a, b) {
    return a.length === b.length && doEqualsIgnoreCase(a, b);
}
function doEqualsIgnoreCase(a, b, stopAt) {
    if (stopAt === void 0) {stopAt = a.length;}
    for (var i = 0; i < stopAt; i++) {
        var codeA = a.charCodeAt(i);
        var codeB = b.charCodeAt(i);
        if (codeA === codeB) {
            continue;
        }
        // a-z A-Z
        if (isAsciiLetter(codeA) && isAsciiLetter(codeB)) {
            var diff = Math.abs(codeA - codeB);
            if (diff !== 0 && diff !== 32) {
                return false;
            }
        }
        // Any other charcode
        else {
                if (String.fromCharCode(codeA).toLowerCase() !== String.fromCharCode(codeB).toLowerCase()) {
                    return false;
                }
            }
    }
    return true;
}
function startsWithIgnoreCase(str, candidate) {
    var candidateLength = candidate.length;
    if (candidate.length > str.length) {
        return false;
    }
    return doEqualsIgnoreCase(str, candidate, candidateLength);
}
/**
   * @returns the length of the common prefix of the two strings.
   */
function commonPrefixLength(a, b) {
    var i,len = Math.min(a.length, b.length);
    for (i = 0; i < len; i++) {
        if (a.charCodeAt(i) !== b.charCodeAt(i)) {
            return i;
        }
    }
    return len;
}
/**
   * @returns the length of the common suffix of the two strings.
   */
function commonSuffixLength(a, b) {
    var i,len = Math.min(a.length, b.length);
    var aLastIndex = a.length - 1;
    var bLastIndex = b.length - 1;
    for (i = 0; i < len; i++) {
        if (a.charCodeAt(aLastIndex - i) !== b.charCodeAt(bLastIndex - i)) {
            return i;
        }
    }
    return len;
}
// --- unicode
// http://en.wikipedia.org/wiki/Surrogate_pair
// Returns the code point starting at a specified index in a string
// Code points U+0000 to U+D7FF and U+E000 to U+FFFF are represented on a single character
// Code points U+10000 to U+10FFFF are represented on two consecutive characters
//export function getUnicodePoint(str:string, index:number, len:number):number {
//	const chrCode = str.charCodeAt(index);
//	if (0xD800 <= chrCode && chrCode <= 0xDBFF && index + 1 < len) {
//		const nextChrCode = str.charCodeAt(index + 1);
//		if (0xDC00 <= nextChrCode && nextChrCode <= 0xDFFF) {
//			return (chrCode - 0xD800) << 10 + (nextChrCode - 0xDC00) + 0x10000;
//		}
//	}
//	return chrCode;
//}
function isHighSurrogate(charCode) {
    return 0xD800 <= charCode && charCode <= 0xDBFF;
}
function isLowSurrogate(charCode) {
    return 0xDC00 <= charCode && charCode <= 0xDFFF;
}
/**
   * get the code point that begins at offset `offset`
   */
function getNextCodePoint(str, len, offset) {
    var charCode = str.charCodeAt(offset);
    if (isHighSurrogate(charCode) && offset + 1 < len) {
        var nextCharCode = str.charCodeAt(offset + 1);
        if (isLowSurrogate(nextCharCode)) {
            return (charCode - 0xD800 << 10) + (nextCharCode - 0xDC00) + 0x10000;
        }
    }
    return charCode;
}
/**
   * get the code point that ends right before offset `offset`
   */
function getPrevCodePoint(str, offset) {
    var charCode = str.charCodeAt(offset - 1);
    if (isLowSurrogate(charCode) && offset > 1) {
        var prevCharCode = str.charCodeAt(offset - 2);
        if (isHighSurrogate(prevCharCode)) {
            return (prevCharCode - 0xD800 << 10) + (charCode - 0xDC00) + 0x10000;
        }
    }
    return charCode;
}
function nextCharLength(str, offset) {
    var graphemeBreakTree = GraphemeBreakTree.getInstance();
    var initialOffset = offset;
    var len = str.length;
    var initialCodePoint = getNextCodePoint(str, len, offset);
    offset += initialCodePoint >= 65536 /* UNICODE_SUPPLEMENTARY_PLANE_BEGIN */ ? 2 : 1;
    var graphemeBreakType = graphemeBreakTree.getGraphemeBreakType(initialCodePoint);
    while (offset < len) {
        var nextCodePoint = getNextCodePoint(str, len, offset);
        var nextGraphemeBreakType = graphemeBreakTree.getGraphemeBreakType(nextCodePoint);
        if (breakBetweenGraphemeBreakType(graphemeBreakType, nextGraphemeBreakType)) {
            break;
        }
        offset += nextCodePoint >= 65536 /* UNICODE_SUPPLEMENTARY_PLANE_BEGIN */ ? 2 : 1;
        graphemeBreakType = nextGraphemeBreakType;
    }
    return offset - initialOffset;
}
function prevCharLength(str, offset) {
    var graphemeBreakTree = GraphemeBreakTree.getInstance();
    var initialOffset = offset;
    var initialCodePoint = getPrevCodePoint(str, offset);
    offset -= initialCodePoint >= 65536 /* UNICODE_SUPPLEMENTARY_PLANE_BEGIN */ ? 2 : 1;
    var graphemeBreakType = graphemeBreakTree.getGraphemeBreakType(initialCodePoint);
    while (offset > 0) {
        var prevCodePoint = getPrevCodePoint(str, offset);
        var prevGraphemeBreakType = graphemeBreakTree.getGraphemeBreakType(prevCodePoint);
        if (breakBetweenGraphemeBreakType(prevGraphemeBreakType, graphemeBreakType)) {
            break;
        }
        offset -= prevCodePoint >= 65536 /* UNICODE_SUPPLEMENTARY_PLANE_BEGIN */ ? 2 : 1;
        graphemeBreakType = prevGraphemeBreakType;
    }
    return initialOffset - offset;
}
/**
   * Generated using https://github.com/alexandrudima/unicode-utils/blob/master/generate-rtl-test.js
   */
var CONTAINS_RTL = /(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;
/**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Returns true if `str` contains any Unicode character that is classified as "R" or "AL".
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */
function containsRTL(str) {
    return CONTAINS_RTL.test(str);
}
/**
   * Generated using https://github.com/alexandrudima/unicode-utils/blob/master/generate-emoji-test.js
   */
var CONTAINS_EMOJI = /(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDE73\uDE78-\uDE82\uDE90-\uDE95])/;
function containsEmoji(str) {
    return CONTAINS_EMOJI.test(str);
}
var IS_BASIC_ASCII = /^[\t\n\r\x20-\x7E]*$/;
/**
                                              * Returns true if `str` contains only basic ASCII characters in the range 32 - 126 (including 32 and 126) or \n, \r, \t
                                              */
function isBasicASCII(str) {
    return IS_BASIC_ASCII.test(str);
}
function containsFullWidthCharacter(str) {
    for (var i = 0, len = str.length; i < len; i++) {
        if (isFullWidthCharacter(str.charCodeAt(i))) {
            return true;
        }
    }
    return false;
}
function isFullWidthCharacter(charCode) {
    // Do a cheap trick to better support wrapping of wide characters, treat them as 2 columns
    // http://jrgraphix.net/research/unicode_blocks.php
    //          2E80 — 2EFF   CJK Radicals Supplement
    //          2F00 — 2FDF   Kangxi Radicals
    //          2FF0 — 2FFF   Ideographic Description Characters
    //          3000 — 303F   CJK Symbols and Punctuation
    //          3040 — 309F   Hiragana
    //          30A0 — 30FF   Katakana
    //          3100 — 312F   Bopomofo
    //          3130 — 318F   Hangul Compatibility Jamo
    //          3190 — 319F   Kanbun
    //          31A0 — 31BF   Bopomofo Extended
    //          31F0 — 31FF   Katakana Phonetic Extensions
    //          3200 — 32FF   Enclosed CJK Letters and Months
    //          3300 — 33FF   CJK Compatibility
    //          3400 — 4DBF   CJK Unified Ideographs Extension A
    //          4DC0 — 4DFF   Yijing Hexagram Symbols
    //          4E00 — 9FFF   CJK Unified Ideographs
    //          A000 — A48F   Yi Syllables
    //          A490 — A4CF   Yi Radicals
    //          AC00 — D7AF   Hangul Syllables
    // [IGNORE] D800 — DB7F   High Surrogates
    // [IGNORE] DB80 — DBFF   High Private Use Surrogates
    // [IGNORE] DC00 — DFFF   Low Surrogates
    // [IGNORE] E000 — F8FF   Private Use Area
    //          F900 — FAFF   CJK Compatibility Ideographs
    // [IGNORE] FB00 — FB4F   Alphabetic Presentation Forms
    // [IGNORE] FB50 — FDFF   Arabic Presentation Forms-A
    // [IGNORE] FE00 — FE0F   Variation Selectors
    // [IGNORE] FE20 — FE2F   Combining Half Marks
    // [IGNORE] FE30 — FE4F   CJK Compatibility Forms
    // [IGNORE] FE50 — FE6F   Small Form Variants
    // [IGNORE] FE70 — FEFF   Arabic Presentation Forms-B
    //          FF00 — FFEF   Halfwidth and Fullwidth Forms
    //               [https://en.wikipedia.org/wiki/Halfwidth_and_fullwidth_forms]
    //               of which FF01 - FF5E fullwidth ASCII of 21 to 7E
    // [IGNORE]    and FF65 - FFDC halfwidth of Katakana and Hangul
    // [IGNORE] FFF0 — FFFF   Specials
    charCode = +charCode; // @perf
    return charCode >= 0x2E80 && charCode <= 0xD7AF ||
    charCode >= 0xF900 && charCode <= 0xFAFF ||
    charCode >= 0xFF01 && charCode <= 0xFF5E;
}
/**
   * A fast function (therefore imprecise) to check if code points are emojis.
   * Generated using https://github.com/alexandrudima/unicode-utils/blob/master/generate-emoji-test.js
   */
function isEmojiImprecise(x) {
    return x >= 0x1F1E6 && x <= 0x1F1FF || x >= 9728 && x <= 10175 || x >= 127744 && x <= 128591 ||
    x >= 128640 && x <= 128764 || x >= 128992 && x <= 129003 || x >= 129280 && x <= 129535 ||
    x >= 129648 && x <= 129651 || x >= 129656 && x <= 129666 || x >= 129680 && x <= 129685;
}
// -- UTF-8 BOM
var UTF8_BOM_CHARACTER = String.fromCharCode(65279 /* UTF8_BOM */);
function startsWithUTF8BOM(str) {
    return !!(str && str.length > 0 && str.charCodeAt(0) === 65279 /* UTF8_BOM */);
}
function safeBtoa(str) {
    return btoa(encodeURIComponent(str)); // we use encodeURIComponent because btoa fails for non Latin 1 values
}
function repeat(s, count) {
    var result = '';
    for (var i = 0; i < count; i++) {
        result += s;
    }
    return result;
}
function containsUppercaseCharacter(target, ignoreEscapedChars) {
    if (ignoreEscapedChars === void 0) {ignoreEscapedChars = false;}
    if (!target) {
        return false;
    }
    if (ignoreEscapedChars) {
        target = target.replace(/\\./g, '');
    }
    return target.toLowerCase() !== target;
}
/**
   * Produces 'a'-'z', followed by 'A'-'Z'... followed by 'a'-'z', etc.
   */
function singleLetterHash(n) {
    var LETTERS_CNT = 90 /* Z */ - 65 /* A */ + 1;
    n = n % (2 * LETTERS_CNT);
    if (n < LETTERS_CNT) {
        return String.fromCharCode(97 /* a */ + n);
    }
    return String.fromCharCode(65 /* A */ + n - LETTERS_CNT);
}
//#region Unicode Grapheme Break
function getGraphemeBreakType(codePoint) {
    var graphemeBreakTree = GraphemeBreakTree.getInstance();
    return graphemeBreakTree.getGraphemeBreakType(codePoint);
}
function breakBetweenGraphemeBreakType(breakTypeA, breakTypeB) {
    // http://www.unicode.org/reports/tr29/#Grapheme_Cluster_Boundary_Rules
    // !!! Let's make the common case a bit faster
    if (breakTypeA === 0 /* Other */) {
            // see https://www.unicode.org/Public/13.0.0/ucd/auxiliary/GraphemeBreakTest-13.0.0d10.html#table
            return breakTypeB !== 5 /* Extend */ && breakTypeB !== 7 /* SpacingMark */;
        }
    // Do not break between a CR and LF. Otherwise, break before and after controls.
    // GB3                                        CR × LF
    // GB4                       (Control | CR | LF) ÷
    // GB5                                           ÷ (Control | CR | LF)
    if (breakTypeA === 2 /* CR */) {
            if (breakTypeB === 3 /* LF */) {
                    return false; // GB3
                }
        }
    if (breakTypeA === 4 /* Control */ || breakTypeA === 2 /* CR */ || breakTypeA === 3 /* LF */) {
            return true; // GB4
        }
    if (breakTypeB === 4 /* Control */ || breakTypeB === 2 /* CR */ || breakTypeB === 3 /* LF */) {
            return true; // GB5
        }
    // Do not break Hangul syllable sequences.
    // GB6                                         L × (L | V | LV | LVT)
    // GB7                                  (LV | V) × (V | T)
    // GB8                                 (LVT | T) × T
    if (breakTypeA === 8 /* L */) {
            if (breakTypeB === 8 /* L */ || breakTypeB === 9 /* V */ || breakTypeB === 11 /* LV */ || breakTypeB === 12 /* LVT */) {
                    return false; // GB6
                }
        }
    if (breakTypeA === 11 /* LV */ || breakTypeA === 9 /* V */) {
            if (breakTypeB === 9 /* V */ || breakTypeB === 10 /* T */) {
                    return false; // GB7
                }
        }
    if (breakTypeA === 12 /* LVT */ || breakTypeA === 10 /* T */) {
            if (breakTypeB === 10 /* T */) {
                    return false; // GB8
                }
        }
    // Do not break before extending characters or ZWJ.
    // GB9                                           × (Extend | ZWJ)
    if (breakTypeB === 5 /* Extend */ || breakTypeB === 13 /* ZWJ */) {
            return false; // GB9
        }
    // The GB9a and GB9b rules only apply to extended grapheme clusters:
    // Do not break before SpacingMarks, or after Prepend characters.
    // GB9a                                          × SpacingMark
    // GB9b                                  Prepend ×
    if (breakTypeB === 7 /* SpacingMark */) {
            return false; // GB9a
        }
    if (breakTypeA === 1 /* Prepend */) {
            return false; // GB9b
        }
    // Do not break within emoji modifier sequences or emoji zwj sequences.
    // GB11    \p{Extended_Pictographic} Extend* ZWJ × \p{Extended_Pictographic}
    if (breakTypeA === 13 /* ZWJ */ && breakTypeB === 14 /* Extended_Pictographic */) {
            // Note: we are not implementing the rule entirely here to avoid introducing states
            return false; // GB11
        }
    // GB12                          sot (RI RI)* RI × RI
    // GB13                        [^RI] (RI RI)* RI × RI
    if (breakTypeA === 6 /* Regional_Indicator */ && breakTypeB === 6 /* Regional_Indicator */) {
            // Note: we are not implementing the rule entirely here to avoid introducing states
            return false; // GB12 & GB13
        }
    // GB999                                     Any ÷ Any
    return true;
}
var GraphemeBreakTree = /** @class */function () {
    function GraphemeBreakTree() {
        this._data = getGraphemeBreakRawData();
    }
    GraphemeBreakTree.getInstance = function () {
        if (!GraphemeBreakTree._INSTANCE) {
            GraphemeBreakTree._INSTANCE = new GraphemeBreakTree();
        }
        return GraphemeBreakTree._INSTANCE;
    };
    GraphemeBreakTree.prototype.getGraphemeBreakType = function (codePoint) {
        // !!! Let's make 7bit ASCII a bit faster: 0..31
        if (codePoint < 32) {
            if (codePoint === 10 /* LineFeed */) {
                    return 3 /* LF */;
                }
            if (codePoint === 13 /* CarriageReturn */) {
                    return 2 /* CR */;
                }
            return 4 /* Control */;
        }
        // !!! Let's make 7bit ASCII a bit faster: 32..126
        if (codePoint < 127) {
            return 0 /* Other */;
        }
        var data = this._data;
        var nodeCount = data.length / 3;
        var nodeIndex = 1;
        while (nodeIndex <= nodeCount) {
            if (codePoint < data[3 * nodeIndex]) {
                // go left
                nodeIndex = 2 * nodeIndex;
            } else
            if (codePoint > data[3 * nodeIndex + 1]) {
                // go right
                nodeIndex = 2 * nodeIndex + 1;
            } else
            {
                // hit
                return data[3 * nodeIndex + 2];
            }
        }
        return 0 /* Other */;
    };
    GraphemeBreakTree._INSTANCE = null;
    return GraphemeBreakTree;
}();
function getGraphemeBreakRawData() {
    // generated using https://github.com/alexandrudima/unicode-utils/blob/master/generate-grapheme-break.js
    return JSON.parse('[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]');
}
//#endregion

/***/ }),

/***/ 6220:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Command", function() { return Command; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "EditorCommand", function() { return EditorCommand; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "EditorAction", function() { return EditorAction; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "registerLanguageCommand", function() { return registerLanguageCommand; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "registerDefaultLanguageCommand", function() { return registerDefaultLanguageCommand; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "registerModelAndPositionCommand", function() { return registerModelAndPositionCommand; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "registerModelCommand", function() { return registerModelCommand; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "registerEditorCommand", function() { return registerEditorCommand; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "registerEditorAction", function() { return registerEditorAction; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "registerInstantiatedEditorAction", function() { return registerInstantiatedEditorAction; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "registerEditorContribution", function() { return registerEditorContribution; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "EditorExtensionsRegistry", function() { return EditorExtensionsRegistry; });
/* harmony import */ var _base_common_errors_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6214);
/* harmony import */ var _base_common_uri_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6221);
/* harmony import */ var _services_codeEditorService_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6223);
/* harmony import */ var _common_core_position_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6225);
/* harmony import */ var _common_services_modelService_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6226);
/* harmony import */ var _common_services_resolverService_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6227);
/* harmony import */ var _platform_actions_common_actions_js__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(6228);
/* harmony import */ var _platform_commands_common_commands_js__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(6231);
/* harmony import */ var _platform_contextkey_common_contextkey_js__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(6230);
/* harmony import */ var _platform_keybinding_common_keybindingsRegistry_js__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(6234);
/* harmony import */ var _platform_registry_common_platform_js__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(6236);
/* harmony import */ var _platform_telemetry_common_telemetry_js__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(6238);
/* harmony import */ var _base_common_types_js__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(6232);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __extends = undefined && undefined.__extends || function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
        { __proto__: [] } instanceof Array && function (d, b) {d.__proto__ = b;} ||
        function (d, b) {for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];};
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {this.constructor = d;}
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();













var Command = /** @class */function () {
    function Command(opts) {
        this.id = opts.id;
        this.precondition = opts.precondition;
        this._kbOpts = opts.kbOpts;
        this._menuOpts = opts.menuOpts;
        this._description = opts.description;
    }
    Command.prototype.register = function () {
        var _this = this;
        if (Array.isArray(this._menuOpts)) {
            this._menuOpts.forEach(this._registerMenuItem, this);
        } else
        if (this._menuOpts) {
            this._registerMenuItem(this._menuOpts);
        }
        if (this._kbOpts) {
            var kbWhen = this._kbOpts.kbExpr;
            if (this.precondition) {
                if (kbWhen) {
                    kbWhen = _platform_contextkey_common_contextkey_js__WEBPACK_IMPORTED_MODULE_8__["ContextKeyExpr"].and(kbWhen, this.precondition);
                } else
                {
                    kbWhen = this.precondition;
                }
            }
            _platform_keybinding_common_keybindingsRegistry_js__WEBPACK_IMPORTED_MODULE_9__["KeybindingsRegistry"].registerCommandAndKeybindingRule({
                id: this.id,
                handler: function (accessor, args) {return _this.runCommand(accessor, args);},
                weight: this._kbOpts.weight,
                when: kbWhen,
                primary: this._kbOpts.primary,
                secondary: this._kbOpts.secondary,
                win: this._kbOpts.win,
                linux: this._kbOpts.linux,
                mac: this._kbOpts.mac,
                description: this._description });

        } else
        {
            _platform_commands_common_commands_js__WEBPACK_IMPORTED_MODULE_7__["CommandsRegistry"].registerCommand({
                id: this.id,
                handler: function (accessor, args) {return _this.runCommand(accessor, args);},
                description: this._description });

        }
    };
    Command.prototype._registerMenuItem = function (item) {
        _platform_actions_common_actions_js__WEBPACK_IMPORTED_MODULE_6__["MenuRegistry"].appendMenuItem(item.menuId, {
            group: item.group,
            command: {
                id: this.id,
                title: item.title },

            when: item.when,
            order: item.order });

    };
    return Command;
}();

var EditorCommand = /** @class */function (_super) {
    __extends(EditorCommand, _super);
    function EditorCommand() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
       * Create a command class that is bound to a certain editor contribution.
       */
    EditorCommand.bindToContribution = function (controllerGetter) {
        return (/** @class */function (_super) {
                __extends(EditorControllerCommandImpl, _super);
                function EditorControllerCommandImpl(opts) {
                    var _this = _super.call(this, opts) || this;
                    _this._callback = opts.handler;
                    return _this;
                }
                EditorControllerCommandImpl.prototype.runEditorCommand = function (accessor, editor, args) {
                    var controller = controllerGetter(editor);
                    if (controller) {
                        this._callback(controllerGetter(editor), args);
                    }
                };
                return EditorControllerCommandImpl;
            }(EditorCommand));
    };
    EditorCommand.prototype.runCommand = function (accessor, args) {
        var _this = this;
        var codeEditorService = accessor.get(_services_codeEditorService_js__WEBPACK_IMPORTED_MODULE_2__["ICodeEditorService"]);
        // Find the editor with text focus or active
        var editor = codeEditorService.getFocusedCodeEditor() || codeEditorService.getActiveCodeEditor();
        if (!editor) {
            // well, at least we tried...
            return;
        }
        return editor.invokeWithinContext(function (editorAccessor) {
            var kbService = editorAccessor.get(_platform_contextkey_common_contextkey_js__WEBPACK_IMPORTED_MODULE_8__["IContextKeyService"]);
            if (!kbService.contextMatchesRules(Object(_base_common_types_js__WEBPACK_IMPORTED_MODULE_12__["withNullAsUndefined"])(_this.precondition))) {
                // precondition does not hold
                return;
            }
            return _this.runEditorCommand(editorAccessor, editor, args);
        });
    };
    return EditorCommand;
}(Command);

var EditorAction = /** @class */function (_super) {
    __extends(EditorAction, _super);
    function EditorAction(opts) {
        var _this = _super.call(this, EditorAction.convertOptions(opts)) || this;
        _this.label = opts.label;
        _this.alias = opts.alias;
        return _this;
    }
    EditorAction.convertOptions = function (opts) {
        var menuOpts;
        if (Array.isArray(opts.menuOpts)) {
            menuOpts = opts.menuOpts;
        } else
        if (opts.menuOpts) {
            menuOpts = [opts.menuOpts];
        } else
        {
            menuOpts = [];
        }
        function withDefaults(item) {
            if (!item.menuId) {
                item.menuId = 7 /* EditorContext */;
            }
            if (!item.title) {
                item.title = opts.label;
            }
            item.when = _platform_contextkey_common_contextkey_js__WEBPACK_IMPORTED_MODULE_8__["ContextKeyExpr"].and(opts.precondition, item.when);
            return item;
        }
        if (Array.isArray(opts.contextMenuOpts)) {
            menuOpts.push.apply(menuOpts, opts.contextMenuOpts.map(withDefaults));
        } else
        if (opts.contextMenuOpts) {
            menuOpts.push(withDefaults(opts.contextMenuOpts));
        }
        opts.menuOpts = menuOpts;
        return opts;
    };
    EditorAction.prototype.runEditorCommand = function (accessor, editor, args) {
        this.reportTelemetry(accessor, editor);
        return this.run(accessor, editor, args || {});
    };
    EditorAction.prototype.reportTelemetry = function (accessor, editor) {
        accessor.get(_platform_telemetry_common_telemetry_js__WEBPACK_IMPORTED_MODULE_11__["ITelemetryService"]).publicLog2('editorActionInvoked', { name: this.label, id: this.id });
    };
    return EditorAction;
}(EditorCommand);

//#endregion EditorAction
// --- Registration of commands and actions
function registerLanguageCommand(id, handler) {
    _platform_commands_common_commands_js__WEBPACK_IMPORTED_MODULE_7__["CommandsRegistry"].registerCommand(id, function (accessor, args) {return handler(accessor, args || {});});
}
function registerDefaultLanguageCommand(id, handler) {
    registerLanguageCommand(id, function (accessor, args) {
        var resource = args.resource,position = args.position;
        if (!(resource instanceof _base_common_uri_js__WEBPACK_IMPORTED_MODULE_1__["URI"])) {
            throw Object(_base_common_errors_js__WEBPACK_IMPORTED_MODULE_0__["illegalArgument"])('resource');
        }
        if (!_common_core_position_js__WEBPACK_IMPORTED_MODULE_3__["Position"].isIPosition(position)) {
            throw Object(_base_common_errors_js__WEBPACK_IMPORTED_MODULE_0__["illegalArgument"])('position');
        }
        var model = accessor.get(_common_services_modelService_js__WEBPACK_IMPORTED_MODULE_4__["IModelService"]).getModel(resource);
        if (model) {
            var editorPosition = _common_core_position_js__WEBPACK_IMPORTED_MODULE_3__["Position"].lift(position);
            return handler(model, editorPosition, args);
        }
        return accessor.get(_common_services_resolverService_js__WEBPACK_IMPORTED_MODULE_5__["ITextModelService"]).createModelReference(resource).then(function (reference) {
            return new Promise(function (resolve, reject) {
                try {
                    var result = handler(reference.object.textEditorModel, _common_core_position_js__WEBPACK_IMPORTED_MODULE_3__["Position"].lift(position), args);
                    resolve(result);
                }
                catch (err) {
                    reject(err);
                }
            }).finally(function () {
                reference.dispose();
            });
        });
    });
}
function registerModelAndPositionCommand(id, handler) {
    _platform_commands_common_commands_js__WEBPACK_IMPORTED_MODULE_7__["CommandsRegistry"].registerCommand(id, function (accessor) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var resource = args[0],position = args[1];
        Object(_base_common_types_js__WEBPACK_IMPORTED_MODULE_12__["assertType"])(_base_common_uri_js__WEBPACK_IMPORTED_MODULE_1__["URI"].isUri(resource));
        Object(_base_common_types_js__WEBPACK_IMPORTED_MODULE_12__["assertType"])(_common_core_position_js__WEBPACK_IMPORTED_MODULE_3__["Position"].isIPosition(position));
        var model = accessor.get(_common_services_modelService_js__WEBPACK_IMPORTED_MODULE_4__["IModelService"]).getModel(resource);
        if (model) {
            var editorPosition = _common_core_position_js__WEBPACK_IMPORTED_MODULE_3__["Position"].lift(position);
            return handler(model, editorPosition, args.slice(2));
        }
        return accessor.get(_common_services_resolverService_js__WEBPACK_IMPORTED_MODULE_5__["ITextModelService"]).createModelReference(resource).then(function (reference) {
            return new Promise(function (resolve, reject) {
                try {
                    var result = handler(reference.object.textEditorModel, _common_core_position_js__WEBPACK_IMPORTED_MODULE_3__["Position"].lift(position), args.slice(2));
                    resolve(result);
                }
                catch (err) {
                    reject(err);
                }
            }).finally(function () {
                reference.dispose();
            });
        });
    });
}
function registerModelCommand(id, handler) {
    _platform_commands_common_commands_js__WEBPACK_IMPORTED_MODULE_7__["CommandsRegistry"].registerCommand(id, function (accessor) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var resource = args[0];
        Object(_base_common_types_js__WEBPACK_IMPORTED_MODULE_12__["assertType"])(_base_common_uri_js__WEBPACK_IMPORTED_MODULE_1__["URI"].isUri(resource));
        var model = accessor.get(_common_services_modelService_js__WEBPACK_IMPORTED_MODULE_4__["IModelService"]).getModel(resource);
        if (model) {
            return handler(model, args.slice(1));
        }
        return accessor.get(_common_services_resolverService_js__WEBPACK_IMPORTED_MODULE_5__["ITextModelService"]).createModelReference(resource).then(function (reference) {
            return new Promise(function (resolve, reject) {
                try {
                    var result = handler(reference.object.textEditorModel, args.slice(1));
                    resolve(result);
                }
                catch (err) {
                    reject(err);
                }
            }).finally(function () {
                reference.dispose();
            });
        });
    });
}
function registerEditorCommand(editorCommand) {
    EditorContributionRegistry.INSTANCE.registerEditorCommand(editorCommand);
    return editorCommand;
}
function registerEditorAction(ctor) {
    EditorContributionRegistry.INSTANCE.registerEditorAction(new ctor());
}
function registerInstantiatedEditorAction(editorAction) {
    EditorContributionRegistry.INSTANCE.registerEditorAction(editorAction);
}
function registerEditorContribution(id, ctor) {
    EditorContributionRegistry.INSTANCE.registerEditorContribution(id, ctor);
}
var EditorExtensionsRegistry;
(function (EditorExtensionsRegistry) {
    function getEditorCommand(commandId) {
        return EditorContributionRegistry.INSTANCE.getEditorCommand(commandId);
    }
    EditorExtensionsRegistry.getEditorCommand = getEditorCommand;
    function getEditorActions() {
        return EditorContributionRegistry.INSTANCE.getEditorActions();
    }
    EditorExtensionsRegistry.getEditorActions = getEditorActions;
    function getEditorContributions() {
        return EditorContributionRegistry.INSTANCE.getEditorContributions();
    }
    EditorExtensionsRegistry.getEditorContributions = getEditorContributions;
    function getSomeEditorContributions(ids) {
        return EditorContributionRegistry.INSTANCE.getEditorContributions().filter(function (c) {return ids.indexOf(c.id) >= 0;});
    }
    EditorExtensionsRegistry.getSomeEditorContributions = getSomeEditorContributions;
    function getDiffEditorContributions() {
        return EditorContributionRegistry.INSTANCE.getDiffEditorContributions();
    }
    EditorExtensionsRegistry.getDiffEditorContributions = getDiffEditorContributions;
})(EditorExtensionsRegistry || (EditorExtensionsRegistry = {}));
// Editor extension points
var Extensions = {
    EditorCommonContributions: 'editor.contributions' };

var EditorContributionRegistry = /** @class */function () {
    function EditorContributionRegistry() {
        this.editorContributions = [];
        this.diffEditorContributions = [];
        this.editorActions = [];
        this.editorCommands = Object.create(null);
    }
    EditorContributionRegistry.prototype.registerEditorContribution = function (id, ctor) {
        this.editorContributions.push({ id: id, ctor: ctor });
    };
    EditorContributionRegistry.prototype.getEditorContributions = function () {
        return this.editorContributions.slice(0);
    };
    EditorContributionRegistry.prototype.getDiffEditorContributions = function () {
        return this.diffEditorContributions.slice(0);
    };
    EditorContributionRegistry.prototype.registerEditorAction = function (action) {
        action.register();
        this.editorActions.push(action);
    };
    EditorContributionRegistry.prototype.getEditorActions = function () {
        return this.editorActions.slice(0);
    };
    EditorContributionRegistry.prototype.registerEditorCommand = function (editorCommand) {
        editorCommand.register();
        this.editorCommands[editorCommand.id] = editorCommand;
    };
    EditorContributionRegistry.prototype.getEditorCommand = function (commandId) {
        return this.editorCommands[commandId] || null;
    };
    EditorContributionRegistry.INSTANCE = new EditorContributionRegistry();
    return EditorContributionRegistry;
}();
_platform_registry_common_platform_js__WEBPACK_IMPORTED_MODULE_10__["Registry"].add(Extensions.EditorCommonContributions, EditorContributionRegistry.INSTANCE);

/***/ }),

/***/ 6221:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "URI", function() { return URI; });
/* harmony import */ var _platform_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6222);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __extends = undefined && undefined.__extends || function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
        { __proto__: [] } instanceof Array && function (d, b) {d.__proto__ = b;} ||
        function (d, b) {for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];};
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {this.constructor = d;}
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();
var _a;

var _schemePattern = /^\w[\w\d+.-]*$/;
var _singleSlashStart = /^\//;
var _doubleSlashStart = /^\/\//;
function _validateUri(ret, _strict) {
    // scheme, must be set
    if (!ret.scheme && _strict) {
        throw new Error("[UriError]: Scheme is missing: {scheme: \"\", authority: \"" + ret.authority + "\", path: \"" + ret.path + "\", query: \"" + ret.query + "\", fragment: \"" + ret.fragment + "\"}");
    }
    // scheme, https://tools.ietf.org/html/rfc3986#section-3.1
    // ALPHA *( ALPHA / DIGIT / "+" / "-" / "." )
    if (ret.scheme && !_schemePattern.test(ret.scheme)) {
        throw new Error('[UriError]: Scheme contains illegal characters.');
    }
    // path, http://tools.ietf.org/html/rfc3986#section-3.3
    // If a URI contains an authority component, then the path component
    // must either be empty or begin with a slash ("/") character.  If a URI
    // does not contain an authority component, then the path cannot begin
    // with two slash characters ("//").
    if (ret.path) {
        if (ret.authority) {
            if (!_singleSlashStart.test(ret.path)) {
                throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character');
            }
        } else
        {
            if (_doubleSlashStart.test(ret.path)) {
                throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")');
            }
        }
    }
}
// for a while we allowed uris *without* schemes and this is the migration
// for them, e.g. an uri without scheme and without strict-mode warns and falls
// back to the file-scheme. that should cause the least carnage and still be a
// clear warning
function _schemeFix(scheme, _strict) {
    if (!scheme && !_strict) {
        return 'file';
    }
    return scheme;
}
// implements a bit of https://tools.ietf.org/html/rfc3986#section-5
function _referenceResolution(scheme, path) {
    // the slash-character is our 'default base' as we don't
    // support constructing URIs relative to other URIs. This
    // also means that we alter and potentially break paths.
    // see https://tools.ietf.org/html/rfc3986#section-5.1.4
    switch (scheme) {
        case 'https':
        case 'http':
        case 'file':
            if (!path) {
                path = _slash;
            } else
            if (path[0] !== _slash) {
                path = _slash + path;
            }
            break;}

    return path;
}
var _empty = '';
var _slash = '/';
var _regexp = /^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;
/**
                                                                               * Uniform Resource Identifier (URI) http://tools.ietf.org/html/rfc3986.
                                                                               * This class is a simple parser which creates the basic component parts
                                                                               * (http://tools.ietf.org/html/rfc3986#section-3) with minimal validation
                                                                               * and encoding.
                                                                               *
                                                                               *       foo://example.com:8042/over/there?name=ferret#nose
                                                                               *       \_/   \______________/\_________/ \_________/ \__/
                                                                               *        |           |            |            |        |
                                                                               *     scheme     authority       path        query   fragment
                                                                               *        |   _____________________|__
                                                                               *       / \ /                        \
                                                                               *       urn:example:animal:ferret:nose
                                                                               */
var URI = /** @class */function () {
    /**
                                     * @internal
                                     */
    function URI(schemeOrData, authority, path, query, fragment, _strict) {
        if (_strict === void 0) {_strict = false;}
        if (typeof schemeOrData === 'object') {
            this.scheme = schemeOrData.scheme || _empty;
            this.authority = schemeOrData.authority || _empty;
            this.path = schemeOrData.path || _empty;
            this.query = schemeOrData.query || _empty;
            this.fragment = schemeOrData.fragment || _empty;
            // no validation because it's this URI
            // that creates uri components.
            // _validateUri(this);
        } else
        {
            this.scheme = _schemeFix(schemeOrData, _strict);
            this.authority = authority || _empty;
            this.path = _referenceResolution(this.scheme, path || _empty);
            this.query = query || _empty;
            this.fragment = fragment || _empty;
            _validateUri(this, _strict);
        }
    }
    URI.isUri = function (thing) {
        if (thing instanceof URI) {
            return true;
        }
        if (!thing) {
            return false;
        }
        return typeof thing.authority === 'string' &&
        typeof thing.fragment === 'string' &&
        typeof thing.path === 'string' &&
        typeof thing.query === 'string' &&
        typeof thing.scheme === 'string' &&
        typeof thing.fsPath === 'function' &&
        typeof thing.with === 'function' &&
        typeof thing.toString === 'function';
    };
    Object.defineProperty(URI.prototype, "fsPath", {
        // ---- filesystem path -----------------------
        /**
         * Returns a string representing the corresponding file system path of this URI.
         * Will handle UNC paths, normalizes windows drive letters to lower-case, and uses the
         * platform specific path separator.
         *
         * * Will *not* validate the path for invalid characters and semantics.
         * * Will *not* look at the scheme of this URI.
         * * The result shall *not* be used for display purposes but for accessing a file on disk.
         *
         *
         * The *difference* to `URI#path` is the use of the platform specific separator and the handling
         * of UNC paths. See the below sample of a file-uri with an authority (UNC path).
         *
         * ```ts
            const u = URI.parse('file://server/c$/folder/file.txt')
            u.authority === 'server'
            u.path === '/shares/c$/file.txt'
            u.fsPath === '\\server\c$\folder\file.txt'
        ```
         *
         * Using `URI#path` to read a file (using fs-apis) would not be enough because parts of the path,
         * namely the server name, would be missing. Therefore `URI#fsPath` exists - it's sugar to ease working
         * with URIs that represent files on disk (`file` scheme).
         */
        get: function () {
            // if (this.scheme !== 'file') {
            // 	console.warn(`[UriError] calling fsPath with scheme ${this.scheme}`);
            // }
            return _makeFsPath(this);
        },
        enumerable: true,
        configurable: true });

    // ---- modify to new -------------------------
    URI.prototype.with = function (change) {
        if (!change) {
            return this;
        }
        var scheme = change.scheme,authority = change.authority,path = change.path,query = change.query,fragment = change.fragment;
        if (scheme === undefined) {
            scheme = this.scheme;
        } else
        if (scheme === null) {
            scheme = _empty;
        }
        if (authority === undefined) {
            authority = this.authority;
        } else
        if (authority === null) {
            authority = _empty;
        }
        if (path === undefined) {
            path = this.path;
        } else
        if (path === null) {
            path = _empty;
        }
        if (query === undefined) {
            query = this.query;
        } else
        if (query === null) {
            query = _empty;
        }
        if (fragment === undefined) {
            fragment = this.fragment;
        } else
        if (fragment === null) {
            fragment = _empty;
        }
        if (scheme === this.scheme &&
        authority === this.authority &&
        path === this.path &&
        query === this.query &&
        fragment === this.fragment) {
            return this;
        }
        return new _URI(scheme, authority, path, query, fragment);
    };
    // ---- parse & validate ------------------------
    /**
     * Creates a new URI from a string, e.g. `http://www.msft.com/some/path`,
     * `file:///usr/home`, or `scheme:with/path`.
     *
     * @param value A string which represents an URI (see `URI#toString`).
     */
    URI.parse = function (value, _strict) {
        if (_strict === void 0) {_strict = false;}
        var match = _regexp.exec(value);
        if (!match) {
            return new _URI(_empty, _empty, _empty, _empty, _empty);
        }
        return new _URI(match[2] || _empty, percentDecode(match[4] || _empty), percentDecode(match[5] || _empty), percentDecode(match[7] || _empty), percentDecode(match[9] || _empty), _strict);
    };
    /**
        * Creates a new URI from a file system path, e.g. `c:\my\files`,
        * `/usr/home`, or `\\server\share\some\path`.
        *
        * The *difference* between `URI#parse` and `URI#file` is that the latter treats the argument
        * as path, not as stringified-uri. E.g. `URI.file(path)` is **not the same as**
        * `URI.parse('file://' + path)` because the path might contain characters that are
        * interpreted (# and ?). See the following sample:
        * ```ts
       const good = URI.file('/coding/c#/project1');
       good.scheme === 'file';
       good.path === '/coding/c#/project1';
       good.fragment === '';
       const bad = URI.parse('file://' + '/coding/c#/project1');
       bad.scheme === 'file';
       bad.path === '/coding/c'; // path is now broken
       bad.fragment === '/project1';
       ```
        *
        * @param path A file system path (see `URI#fsPath`)
        */
    URI.file = function (path) {
        var authority = _empty;
        // normalize to fwd-slashes on windows,
        // on other systems bwd-slashes are valid
        // filename character, eg /f\oo/ba\r.txt
        if (_platform_js__WEBPACK_IMPORTED_MODULE_0__["isWindows"]) {
            path = path.replace(/\\/g, _slash);
        }
        // check for authority as used in UNC shares
        // or use the path as given
        if (path[0] === _slash && path[1] === _slash) {
            var idx = path.indexOf(_slash, 2);
            if (idx === -1) {
                authority = path.substring(2);
                path = _slash;
            } else
            {
                authority = path.substring(2, idx);
                path = path.substring(idx) || _slash;
            }
        }
        return new _URI('file', authority, path, _empty, _empty);
    };
    URI.from = function (components) {
        return new _URI(components.scheme, components.authority, components.path, components.query, components.fragment);
    };
    // ---- printing/externalize ---------------------------
    /**
     * Creates a string representation for this URI. It's guaranteed that calling
     * `URI.parse` with the result of this function creates an URI which is equal
     * to this URI.
     *
     * * The result shall *not* be used for display purposes but for externalization or transport.
     * * The result will be encoded using the percentage encoding and encoding happens mostly
     * ignore the scheme-specific encoding rules.
     *
     * @param skipEncoding Do not encode the result, default is `false`
     */
    URI.prototype.toString = function (skipEncoding) {
        if (skipEncoding === void 0) {skipEncoding = false;}
        return _asFormatted(this, skipEncoding);
    };
    URI.prototype.toJSON = function () {
        return this;
    };
    URI.revive = function (data) {
        if (!data) {
            return data;
        } else
        if (data instanceof URI) {
            return data;
        } else
        {
            var result = new _URI(data);
            result._formatted = data.external;
            result._fsPath = data._sep === _pathSepMarker ? data.fsPath : null;
            return result;
        }
    };
    return URI;
}();

var _pathSepMarker = _platform_js__WEBPACK_IMPORTED_MODULE_0__["isWindows"] ? 1 : undefined;
// eslint-disable-next-line @typescript-eslint/class-name-casing
var _URI = /** @class */function (_super) {
    __extends(_URI, _super);
    function _URI() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._formatted = null;
        _this._fsPath = null;
        return _this;
    }
    Object.defineProperty(_URI.prototype, "fsPath", {
        get: function () {
            if (!this._fsPath) {
                this._fsPath = _makeFsPath(this);
            }
            return this._fsPath;
        },
        enumerable: true,
        configurable: true });

    _URI.prototype.toString = function (skipEncoding) {
        if (skipEncoding === void 0) {skipEncoding = false;}
        if (!skipEncoding) {
            if (!this._formatted) {
                this._formatted = _asFormatted(this, false);
            }
            return this._formatted;
        } else
        {
            // we don't cache that
            return _asFormatted(this, true);
        }
    };
    _URI.prototype.toJSON = function () {
        var res = {
            $mid: 1 };

        // cached state
        if (this._fsPath) {
            res.fsPath = this._fsPath;
            res._sep = _pathSepMarker;
        }
        if (this._formatted) {
            res.external = this._formatted;
        }
        // uri components
        if (this.path) {
            res.path = this.path;
        }
        if (this.scheme) {
            res.scheme = this.scheme;
        }
        if (this.authority) {
            res.authority = this.authority;
        }
        if (this.query) {
            res.query = this.query;
        }
        if (this.fragment) {
            res.fragment = this.fragment;
        }
        return res;
    };
    return _URI;
}(URI);
// reserved characters: https://tools.ietf.org/html/rfc3986#section-2.2
var encodeTable = (_a = {},
_a[58 /* Colon */] = '%3A',
_a[47 /* Slash */] = '%2F',
_a[63 /* QuestionMark */] = '%3F',
_a[35 /* Hash */] = '%23',
_a[91 /* OpenSquareBracket */] = '%5B',
_a[93 /* CloseSquareBracket */] = '%5D',
_a[64 /* AtSign */] = '%40',
_a[33 /* ExclamationMark */] = '%21',
_a[36 /* DollarSign */] = '%24',
_a[38 /* Ampersand */] = '%26',
_a[39 /* SingleQuote */] = '%27',
_a[40 /* OpenParen */] = '%28',
_a[41 /* CloseParen */] = '%29',
_a[42 /* Asterisk */] = '%2A',
_a[43 /* Plus */] = '%2B',
_a[44 /* Comma */] = '%2C',
_a[59 /* Semicolon */] = '%3B',
_a[61 /* Equals */] = '%3D',
_a[32 /* Space */] = '%20',
_a);
function encodeURIComponentFast(uriComponent, allowSlash) {
    var res = undefined;
    var nativeEncodePos = -1;
    for (var pos = 0; pos < uriComponent.length; pos++) {
        var code = uriComponent.charCodeAt(pos);
        // unreserved characters: https://tools.ietf.org/html/rfc3986#section-2.3
        if (code >= 97 /* a */ && code <= 122 /* z */ ||
        code >= 65 /* A */ && code <= 90 /* Z */ ||
        code >= 48 /* Digit0 */ && code <= 57 /* Digit9 */ ||
        code === 45 /* Dash */ ||
        code === 46 /* Period */ ||
        code === 95 /* Underline */ ||
        code === 126 /* Tilde */ ||
        allowSlash && code === 47 /* Slash */) {
            // check if we are delaying native encode
            if (nativeEncodePos !== -1) {
                res += encodeURIComponent(uriComponent.substring(nativeEncodePos, pos));
                nativeEncodePos = -1;
            }
            // check if we write into a new string (by default we try to return the param)
            if (res !== undefined) {
                res += uriComponent.charAt(pos);
            }
        } else
        {
            // encoding needed, we need to allocate a new string
            if (res === undefined) {
                res = uriComponent.substr(0, pos);
            }
            // check with default table first
            var escaped = encodeTable[code];
            if (escaped !== undefined) {
                // check if we are delaying native encode
                if (nativeEncodePos !== -1) {
                    res += encodeURIComponent(uriComponent.substring(nativeEncodePos, pos));
                    nativeEncodePos = -1;
                }
                // append escaped variant to result
                res += escaped;
            } else
            if (nativeEncodePos === -1) {
                // use native encode only when needed
                nativeEncodePos = pos;
            }
        }
    }
    if (nativeEncodePos !== -1) {
        res += encodeURIComponent(uriComponent.substring(nativeEncodePos));
    }
    return res !== undefined ? res : uriComponent;
}
function encodeURIComponentMinimal(path) {
    var res = undefined;
    for (var pos = 0; pos < path.length; pos++) {
        var code = path.charCodeAt(pos);
        if (code === 35 /* Hash */ || code === 63 /* QuestionMark */) {
                if (res === undefined) {
                    res = path.substr(0, pos);
                }
                res += encodeTable[code];
            } else
        {
            if (res !== undefined) {
                res += path[pos];
            }
        }
    }
    return res !== undefined ? res : path;
}
/**
   * Compute `fsPath` for the given uri
   */
function _makeFsPath(uri) {
    var value;
    if (uri.authority && uri.path.length > 1 && uri.scheme === 'file') {
        // unc path: file://shares/c$/far/boo
        value = "//" + uri.authority + uri.path;
    } else
    if (uri.path.charCodeAt(0) === 47 /* Slash */ && (
    uri.path.charCodeAt(1) >= 65 /* A */ && uri.path.charCodeAt(1) <= 90 /* Z */ || uri.path.charCodeAt(1) >= 97 /* a */ && uri.path.charCodeAt(1) <= 122 /* z */) &&
    uri.path.charCodeAt(2) === 58 /* Colon */) {
            // windows drive letter: file:///c:/far/boo
            value = uri.path[1].toLowerCase() + uri.path.substr(2);
        } else
    {
        // other path
        value = uri.path;
    }
    if (_platform_js__WEBPACK_IMPORTED_MODULE_0__["isWindows"]) {
        value = value.replace(/\//g, '\\');
    }
    return value;
}
/**
   * Create the external version of a uri
   */
function _asFormatted(uri, skipEncoding) {
    var encoder = !skipEncoding ?
    encodeURIComponentFast :
    encodeURIComponentMinimal;
    var res = '';
    var scheme = uri.scheme,authority = uri.authority,path = uri.path,query = uri.query,fragment = uri.fragment;
    if (scheme) {
        res += scheme;
        res += ':';
    }
    if (authority || scheme === 'file') {
        res += _slash;
        res += _slash;
    }
    if (authority) {
        var idx = authority.indexOf('@');
        if (idx !== -1) {
            // <user>@<auth>
            var userinfo = authority.substr(0, idx);
            authority = authority.substr(idx + 1);
            idx = userinfo.indexOf(':');
            if (idx === -1) {
                res += encoder(userinfo, false);
            } else
            {
                // <user>:<pass>@<auth>
                res += encoder(userinfo.substr(0, idx), false);
                res += ':';
                res += encoder(userinfo.substr(idx + 1), false);
            }
            res += '@';
        }
        authority = authority.toLowerCase();
        idx = authority.indexOf(':');
        if (idx === -1) {
            res += encoder(authority, false);
        } else
        {
            // <auth>:<port>
            res += encoder(authority.substr(0, idx), false);
            res += authority.substr(idx);
        }
    }
    if (path) {
        // lower-case windows drive letters in /C:/fff or C:/fff
        if (path.length >= 3 && path.charCodeAt(0) === 47 /* Slash */ && path.charCodeAt(2) === 58 /* Colon */) {
                var code = path.charCodeAt(1);
                if (code >= 65 /* A */ && code <= 90 /* Z */) {
                        path = "/" + String.fromCharCode(code + 32) + ":" + path.substr(3); // "/c:".length === 3
                    }
            } else
        if (path.length >= 2 && path.charCodeAt(1) === 58 /* Colon */) {
                var code = path.charCodeAt(0);
                if (code >= 65 /* A */ && code <= 90 /* Z */) {
                        path = String.fromCharCode(code + 32) + ":" + path.substr(2); // "/c:".length === 3
                    }
            }
        // encode the rest of the path
        res += encoder(path, true);
    }
    if (query) {
        res += '?';
        res += encoder(query, false);
    }
    if (fragment) {
        res += '#';
        res += !skipEncoding ? encodeURIComponentFast(fragment, false) : fragment;
    }
    return res;
}
// --- decode
function decodeURIComponentGraceful(str) {
    try {
        return decodeURIComponent(str);
    }
    catch (_a) {
        if (str.length > 3) {
            return str.substr(0, 3) + decodeURIComponentGraceful(str.substr(3));
        } else
        {
            return str;
        }
    }
}
var _rEncodedAsHex = /(%[0-9A-Za-z][0-9A-Za-z])+/g;
function percentDecode(str) {
    if (!str.match(_rEncodedAsHex)) {
        return str;
    }
    return str.replace(_rEncodedAsHex, function (match) {return decodeURIComponentGraceful(match);});
}

/***/ }),

/***/ 6222:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(process, global) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isWindows", function() { return isWindows; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isMacintosh", function() { return isMacintosh; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isLinux", function() { return isLinux; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isNative", function() { return isNative; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isWeb", function() { return isWeb; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isIOS", function() { return isIOS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "globals", function() { return globals; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "setImmediate", function() { return setImmediate; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "OS", function() { return OS; });
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var LANGUAGE_DEFAULT = 'en';
var _isWindows = false;
var _isMacintosh = false;
var _isLinux = false;
var _isNative = false;
var _isWeb = false;
var _isIOS = false;
var _locale = undefined;
var _language = LANGUAGE_DEFAULT;
var _translationsConfigFile = undefined;
var _userAgent = undefined;
var isElectronRenderer = typeof process !== 'undefined' && typeof process.versions !== 'undefined' && typeof process.versions.electron !== 'undefined' && process.type === 'renderer';
// OS detection
if (typeof navigator === 'object' && !isElectronRenderer) {
    _userAgent = navigator.userAgent;
    _isWindows = _userAgent.indexOf('Windows') >= 0;
    _isMacintosh = _userAgent.indexOf('Macintosh') >= 0;
    _isIOS = _userAgent.indexOf('Macintosh') >= 0 && !!navigator.maxTouchPoints && navigator.maxTouchPoints > 0;
    _isLinux = _userAgent.indexOf('Linux') >= 0;
    _isWeb = true;
    _locale = navigator.language;
    _language = _locale;
} else
if (typeof process === 'object') {
    _isWindows = process.platform === 'win32';
    _isMacintosh = process.platform === 'darwin';
    _isLinux = process.platform === 'linux';
    _locale = LANGUAGE_DEFAULT;
    _language = LANGUAGE_DEFAULT;
    var rawNlsConfig = process.env['VSCODE_NLS_CONFIG'];
    if (rawNlsConfig) {
        try {
            var nlsConfig = JSON.parse(rawNlsConfig);
            var resolved = nlsConfig.availableLanguages['*'];
            _locale = nlsConfig.locale;
            // VSCode's default language is 'en'
            _language = resolved ? resolved : LANGUAGE_DEFAULT;
            _translationsConfigFile = nlsConfig._translationsConfigFile;
        }
        catch (e) {
        }
    }
    _isNative = true;
}
var _platform = 0 /* Web */;
if (_isMacintosh) {
    _platform = 1 /* Mac */;
} else
if (_isWindows) {
    _platform = 3 /* Windows */;
} else
if (_isLinux) {
    _platform = 2 /* Linux */;
}
var isWindows = _isWindows;
var isMacintosh = _isMacintosh;
var isLinux = _isLinux;
var isNative = _isNative;
var isWeb = _isWeb;
var isIOS = _isIOS;
var _globals = typeof self === 'object' ? self : typeof global === 'object' ? global : {};
var globals = _globals;
var setImmediate = function defineSetImmediate() {
    if (globals.setImmediate) {
        return globals.setImmediate.bind(globals);
    }
    if (typeof globals.postMessage === 'function' && !globals.importScripts) {
        var pending_1 = [];
        globals.addEventListener('message', function (e) {
            if (e.data && e.data.vscodeSetImmediateId) {
                for (var i = 0, len = pending_1.length; i < len; i++) {
                    var candidate = pending_1[i];
                    if (candidate.id === e.data.vscodeSetImmediateId) {
                        pending_1.splice(i, 1);
                        candidate.callback();
                        return;
                    }
                }
            }
        });
        var lastId_1 = 0;
        return function (callback) {
            var myId = ++lastId_1;
            pending_1.push({
                id: myId,
                callback: callback });

            globals.postMessage({ vscodeSetImmediateId: myId }, '*');
        };
    }
    if (typeof process !== 'undefined' && typeof process.nextTick === 'function') {
        return process.nextTick.bind(process);
    }
    var _promise = Promise.resolve();
    return function (callback) {return _promise.then(callback);};
}();
var OS = _isMacintosh ? 2 /* Macintosh */ : _isWindows ? 1 /* Windows */ : 3 /* Linux */;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(31), __webpack_require__(19)))

/***/ }),

/***/ 6223:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ICodeEditorService", function() { return ICodeEditorService; });
/* harmony import */ var _platform_instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6224);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/

var ICodeEditorService = Object(_platform_instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_0__["createDecorator"])('codeEditorService');

/***/ }),

/***/ 6224:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "_util", function() { return _util; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "IInstantiationService", function() { return IInstantiationService; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "createDecorator", function() { return createDecorator; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "optional", function() { return optional; });
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
// ------ internal util
var _util;
(function (_util) {
    _util.serviceIds = new Map();
    _util.DI_TARGET = '$di$target';
    _util.DI_DEPENDENCIES = '$di$dependencies';
    function getServiceDependencies(ctor) {
        return ctor[_util.DI_DEPENDENCIES] || [];
    }
    _util.getServiceDependencies = getServiceDependencies;
})(_util || (_util = {}));
var IInstantiationService = createDecorator('instantiationService');
function storeServiceDependency(id, target, index, optional) {
    if (target[_util.DI_TARGET] === target) {
        target[_util.DI_DEPENDENCIES].push({ id: id, index: index, optional: optional });
    } else
    {
        target[_util.DI_DEPENDENCIES] = [{ id: id, index: index, optional: optional }];
        target[_util.DI_TARGET] = target;
    }
}
/**
   * A *only* valid way to create a {{ServiceIdentifier}}.
   */
function createDecorator(serviceId) {
    if (_util.serviceIds.has(serviceId)) {
        return _util.serviceIds.get(serviceId);
    }
    var id = function (target, key, index) {
        if (arguments.length !== 3) {
            throw new Error('@IServiceName-decorator can only be used to decorate a parameter');
        }
        storeServiceDependency(id, target, index, false);
    };
    id.toString = function () {return serviceId;};
    _util.serviceIds.set(serviceId, id);
    return id;
}
/**
   * Mark a service dependency as optional.
   */
function optional(serviceIdentifier) {
    return function (target, key, index) {
        if (arguments.length !== 3) {
            throw new Error('@optional-decorator can only be used to decorate a parameter');
        }
        storeServiceDependency(serviceIdentifier, target, index, true);
    };
}

/***/ }),

/***/ 6225:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Position", function() { return Position; });
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
/**
                                                                                                  * A position in the editor.
                                                                                                  */
var Position = /** @class */function () {
    function Position(lineNumber, column) {
        this.lineNumber = lineNumber;
        this.column = column;
    }
    /**
       * Create a new position from this position.
       *
       * @param newLineNumber new line number
       * @param newColumn new column
       */
    Position.prototype.with = function (newLineNumber, newColumn) {
        if (newLineNumber === void 0) {newLineNumber = this.lineNumber;}
        if (newColumn === void 0) {newColumn = this.column;}
        if (newLineNumber === this.lineNumber && newColumn === this.column) {
            return this;
        } else
        {
            return new Position(newLineNumber, newColumn);
        }
    };
    /**
        * Derive a new position from this position.
        *
        * @param deltaLineNumber line number delta
        * @param deltaColumn column delta
        */
    Position.prototype.delta = function (deltaLineNumber, deltaColumn) {
        if (deltaLineNumber === void 0) {deltaLineNumber = 0;}
        if (deltaColumn === void 0) {deltaColumn = 0;}
        return this.with(this.lineNumber + deltaLineNumber, this.column + deltaColumn);
    };
    /**
        * Test if this position equals other position
        */
    Position.prototype.equals = function (other) {
        return Position.equals(this, other);
    };
    /**
        * Test if position `a` equals position `b`
        */
    Position.equals = function (a, b) {
        if (!a && !b) {
            return true;
        }
        return !!a &&
        !!b &&
        a.lineNumber === b.lineNumber &&
        a.column === b.column;
    };
    /**
        * Test if this position is before other position.
        * If the two positions are equal, the result will be false.
        */
    Position.prototype.isBefore = function (other) {
        return Position.isBefore(this, other);
    };
    /**
        * Test if position `a` is before position `b`.
        * If the two positions are equal, the result will be false.
        */
    Position.isBefore = function (a, b) {
        if (a.lineNumber < b.lineNumber) {
            return true;
        }
        if (b.lineNumber < a.lineNumber) {
            return false;
        }
        return a.column < b.column;
    };
    /**
        * Test if this position is before other position.
        * If the two positions are equal, the result will be true.
        */
    Position.prototype.isBeforeOrEqual = function (other) {
        return Position.isBeforeOrEqual(this, other);
    };
    /**
        * Test if position `a` is before position `b`.
        * If the two positions are equal, the result will be true.
        */
    Position.isBeforeOrEqual = function (a, b) {
        if (a.lineNumber < b.lineNumber) {
            return true;
        }
        if (b.lineNumber < a.lineNumber) {
            return false;
        }
        return a.column <= b.column;
    };
    /**
        * A function that compares positions, useful for sorting
        */
    Position.compare = function (a, b) {
        var aLineNumber = a.lineNumber | 0;
        var bLineNumber = b.lineNumber | 0;
        if (aLineNumber === bLineNumber) {
            var aColumn = a.column | 0;
            var bColumn = b.column | 0;
            return aColumn - bColumn;
        }
        return aLineNumber - bLineNumber;
    };
    /**
        * Clone this position.
        */
    Position.prototype.clone = function () {
        return new Position(this.lineNumber, this.column);
    };
    /**
        * Convert to a human-readable representation.
        */
    Position.prototype.toString = function () {
        return '(' + this.lineNumber + ',' + this.column + ')';
    };
    // ---
    /**
     * Create a `Position` from an `IPosition`.
     */
    Position.lift = function (pos) {
        return new Position(pos.lineNumber, pos.column);
    };
    /**
        * Test if `obj` is an `IPosition`.
        */
    Position.isIPosition = function (obj) {
        return obj &&
        typeof obj.lineNumber === 'number' &&
        typeof obj.column === 'number';
    };
    return Position;
}();


/***/ }),

/***/ 6226:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "IModelService", function() { return IModelService; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "shouldSynchronizeModel", function() { return shouldSynchronizeModel; });
/* harmony import */ var _platform_instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6224);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/

var IModelService = Object(_platform_instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_0__["createDecorator"])('modelService');
function shouldSynchronizeModel(model) {
  return !model.isTooLargeForSyncing() && !model.isForSimpleWidget;
}

/***/ }),

/***/ 6227:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ITextModelService", function() { return ITextModelService; });
/* harmony import */ var _platform_instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6224);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/

var ITextModelService = Object(_platform_instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_0__["createDecorator"])('textModelService');

/***/ }),

/***/ 6228:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isIMenuItem", function() { return isIMenuItem; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "IMenuService", function() { return IMenuService; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "MenuRegistry", function() { return MenuRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ExecuteCommandAction", function() { return ExecuteCommandAction; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SubmenuItemAction", function() { return SubmenuItemAction; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "MenuItemAction", function() { return MenuItemAction; });
/* harmony import */ var _base_common_actions_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6229);
/* harmony import */ var _instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6224);
/* harmony import */ var _contextkey_common_contextkey_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6230);
/* harmony import */ var _commands_common_commands_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6231);
/* harmony import */ var _base_common_event_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6213);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __extends = undefined && undefined.__extends || function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
        { __proto__: [] } instanceof Array && function (d, b) {d.__proto__ = b;} ||
        function (d, b) {for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];};
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {this.constructor = d;}
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();
var __decorate = undefined && undefined.__decorate || function (decorators, target, key, desc) {
    var c = arguments.length,r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else
    for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __param = undefined && undefined.__param || function (paramIndex, decorator) {
    return function (target, key) {decorator(target, key, paramIndex);};
};
var __spreadArrays = undefined && undefined.__spreadArrays || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
    for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
    r[k] = a[j];
    return r;
};





function isIMenuItem(item) {
    return item.command !== undefined;
}
var IMenuService = Object(_instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_1__["createDecorator"])('menuService');
var MenuRegistry = new ( /** @class */function () {
    function class_1() {
        this._commands = new Map();
        this._menuItems = new Map();
        this._onDidChangeMenu = new _base_common_event_js__WEBPACK_IMPORTED_MODULE_4__["Emitter"]();
        this.onDidChangeMenu = this._onDidChangeMenu.event;
    }
    class_1.prototype.addCommand = function (command) {
        var _this = this;
        this._commands.set(command.id, command);
        this._onDidChangeMenu.fire(0 /* CommandPalette */);
        return {
            dispose: function () {
                if (_this._commands.delete(command.id)) {
                    _this._onDidChangeMenu.fire(0 /* CommandPalette */);
                }
            } };

    };
    class_1.prototype.getCommand = function (id) {
        return this._commands.get(id);
    };
    class_1.prototype.getCommands = function () {
        var map = new Map();
        this._commands.forEach(function (value, key) {return map.set(key, value);});
        return map;
    };
    class_1.prototype.appendMenuItem = function (id, item) {
        var _this = this;
        var array = this._menuItems.get(id);
        if (!array) {
            array = [item];
            this._menuItems.set(id, array);
        } else
        {
            array.push(item);
        }
        this._onDidChangeMenu.fire(id);
        return {
            dispose: function () {
                var idx = array.indexOf(item);
                if (idx >= 0) {
                    array.splice(idx, 1);
                    _this._onDidChangeMenu.fire(id);
                }
            } };

    };
    class_1.prototype.getMenuItems = function (id) {
        var result = (this._menuItems.get(id) || []).slice(0);
        if (id === 0 /* CommandPalette */) {
                // CommandPalette is special because it shows
                // all commands by default
                this._appendImplicitItems(result);
            }
        return result;
    };
    class_1.prototype._appendImplicitItems = function (result) {
        var set = new Set();
        var temp = result.filter(function (item) {return isIMenuItem(item);});
        for (var _i = 0, temp_1 = temp; _i < temp_1.length; _i++) {
            var _a = temp_1[_i],command = _a.command,alt = _a.alt;
            set.add(command.id);
            if (alt) {
                set.add(alt.id);
            }
        }
        this._commands.forEach(function (command, id) {
            if (!set.has(id)) {
                result.push({ command: command });
            }
        });
    };
    return class_1;
}())();
var ExecuteCommandAction = /** @class */function (_super) {
    __extends(ExecuteCommandAction, _super);
    function ExecuteCommandAction(id, label, _commandService) {
        var _this = _super.call(this, id, label) || this;
        _this._commandService = _commandService;
        return _this;
    }
    ExecuteCommandAction.prototype.run = function () {
        var _a;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return (_a = this._commandService).executeCommand.apply(_a, __spreadArrays([this.id], args));
    };
    ExecuteCommandAction = __decorate([
    __param(2, _commands_common_commands_js__WEBPACK_IMPORTED_MODULE_3__["ICommandService"])],
    ExecuteCommandAction);
    return ExecuteCommandAction;
}(_base_common_actions_js__WEBPACK_IMPORTED_MODULE_0__["Action"]);

var SubmenuItemAction = /** @class */function (_super) {
    __extends(SubmenuItemAction, _super);
    function SubmenuItemAction(item) {
        var _this = this;
        typeof item.title === 'string' ? _this = _super.call(this, '', item.title, 'submenu') || this : _this = _super.call(this, '', item.title.value, 'submenu') || this;
        _this.item = item;
        return _this;
    }
    return SubmenuItemAction;
}(_base_common_actions_js__WEBPACK_IMPORTED_MODULE_0__["Action"]);

var MenuItemAction = /** @class */function (_super) {
    __extends(MenuItemAction, _super);
    function MenuItemAction(item, alt, options, contextKeyService, commandService) {
        var _this = this;
        typeof item.title === 'string' ? _this = _super.call(this, item.id, item.title, commandService) || this : _this = _super.call(this, item.id, item.title.value, commandService) || this;
        _this._cssClass = undefined;
        _this._enabled = !item.precondition || contextKeyService.contextMatchesRules(item.precondition);
        _this._checked = Boolean(item.toggled && contextKeyService.contextMatchesRules(item.toggled));
        _this._options = options || {};
        _this.item = item;
        _this.alt = alt ? new MenuItemAction(alt, undefined, _this._options, contextKeyService, commandService) : undefined;
        return _this;
    }
    MenuItemAction.prototype.dispose = function () {
        if (this.alt) {
            this.alt.dispose();
        }
        _super.prototype.dispose.call(this);
    };
    MenuItemAction.prototype.run = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var runArgs = [];
        if (this._options.arg) {
            runArgs = __spreadArrays(runArgs, [this._options.arg]);
        }
        if (this._options.shouldForwardArgs) {
            runArgs = __spreadArrays(runArgs, args);
        }
        return _super.prototype.run.apply(this, runArgs);
    };
    MenuItemAction = __decorate([
    __param(3, _contextkey_common_contextkey_js__WEBPACK_IMPORTED_MODULE_2__["IContextKeyService"]),
    __param(4, _commands_common_commands_js__WEBPACK_IMPORTED_MODULE_3__["ICommandService"])],
    MenuItemAction);
    return MenuItemAction;
}(ExecuteCommandAction);

//#endregion

/***/ }),

/***/ 6229:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Action", function() { return Action; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ActionRunner", function() { return ActionRunner; });
/* harmony import */ var _lifecycle_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6216);
/* harmony import */ var _event_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6213);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __extends = undefined && undefined.__extends || function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
        { __proto__: [] } instanceof Array && function (d, b) {d.__proto__ = b;} ||
        function (d, b) {for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];};
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {this.constructor = d;}
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();
var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
    function adopt(value) {return value instanceof P ? value : new P(function (resolve) {resolve(value);});}
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {try {step(generator.next(value));} catch (e) {reject(e);}}
        function rejected(value) {try {step(generator["throw"](value));} catch (e) {reject(e);}}
        function step(result) {result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);}
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = undefined && undefined.__generator || function (thisArg, body) {
    var _ = { label: 0, sent: function () {if (t[0] & 1) throw t[1];return t[1];}, trys: [], ops: [] },f,y,t,g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {return this;}), g;
    function verb(n) {return function (v) {return step([n, v]);};}
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0:case 1:t = op;break;
                case 4:_.label++;return { value: op[1], done: false };
                case 5:_.label++;y = op[1];op = [0];continue;
                case 7:op = _.ops.pop();_.trys.pop();continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {_ = 0;continue;}
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {_.label = op[1];break;}
                    if (op[0] === 6 && _.label < t[1]) {_.label = t[1];t = op;break;}
                    if (t && _.label < t[2]) {_.label = t[2];_.ops.push(op);break;}
                    if (t[2]) _.ops.pop();
                    _.trys.pop();continue;}

            op = body.call(thisArg, _);
        } catch (e) {op = [6, e];y = 0;} finally {f = t = 0;}
        if (op[0] & 5) throw op[1];return { value: op[0] ? op[1] : void 0, done: true };
    }
};


var Action = /** @class */function (_super) {
    __extends(Action, _super);
    function Action(id, label, cssClass, enabled, actionCallback) {
        if (label === void 0) {label = '';}
        if (cssClass === void 0) {cssClass = '';}
        if (enabled === void 0) {enabled = true;}
        var _this = _super.call(this) || this;
        _this._onDidChange = _this._register(new _event_js__WEBPACK_IMPORTED_MODULE_1__["Emitter"]());
        _this.onDidChange = _this._onDidChange.event;
        _this._enabled = true;
        _this._checked = false;
        _this._id = id;
        _this._label = label;
        _this._cssClass = cssClass;
        _this._enabled = enabled;
        _this._actionCallback = actionCallback;
        return _this;
    }
    Object.defineProperty(Action.prototype, "id", {
        get: function () {
            return this._id;
        },
        enumerable: true,
        configurable: true });

    Object.defineProperty(Action.prototype, "label", {
        get: function () {
            return this._label;
        },
        set: function (value) {
            this._setLabel(value);
        },
        enumerable: true,
        configurable: true });

    Action.prototype._setLabel = function (value) {
        if (this._label !== value) {
            this._label = value;
            this._onDidChange.fire({ label: value });
        }
    };
    Object.defineProperty(Action.prototype, "tooltip", {
        get: function () {
            return this._tooltip || '';
        },
        set: function (value) {
            this._setTooltip(value);
        },
        enumerable: true,
        configurable: true });

    Action.prototype._setTooltip = function (value) {
        if (this._tooltip !== value) {
            this._tooltip = value;
            this._onDidChange.fire({ tooltip: value });
        }
    };
    Object.defineProperty(Action.prototype, "class", {
        get: function () {
            return this._cssClass;
        },
        set: function (value) {
            this._setClass(value);
        },
        enumerable: true,
        configurable: true });

    Action.prototype._setClass = function (value) {
        if (this._cssClass !== value) {
            this._cssClass = value;
            this._onDidChange.fire({ class: value });
        }
    };
    Object.defineProperty(Action.prototype, "enabled", {
        get: function () {
            return this._enabled;
        },
        set: function (value) {
            this._setEnabled(value);
        },
        enumerable: true,
        configurable: true });

    Action.prototype._setEnabled = function (value) {
        if (this._enabled !== value) {
            this._enabled = value;
            this._onDidChange.fire({ enabled: value });
        }
    };
    Object.defineProperty(Action.prototype, "checked", {
        get: function () {
            return this._checked;
        },
        set: function (value) {
            this._setChecked(value);
        },
        enumerable: true,
        configurable: true });

    Action.prototype._setChecked = function (value) {
        if (this._checked !== value) {
            this._checked = value;
            this._onDidChange.fire({ checked: value });
        }
    };
    Action.prototype.run = function (event, _data) {
        if (this._actionCallback) {
            return this._actionCallback(event);
        }
        return Promise.resolve(true);
    };
    return Action;
}(_lifecycle_js__WEBPACK_IMPORTED_MODULE_0__["Disposable"]);

var ActionRunner = /** @class */function (_super) {
    __extends(ActionRunner, _super);
    function ActionRunner() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._onDidBeforeRun = _this._register(new _event_js__WEBPACK_IMPORTED_MODULE_1__["Emitter"]());
        _this.onDidBeforeRun = _this._onDidBeforeRun.event;
        _this._onDidRun = _this._register(new _event_js__WEBPACK_IMPORTED_MODULE_1__["Emitter"]());
        _this.onDidRun = _this._onDidRun.event;
        return _this;
    }
    ActionRunner.prototype.run = function (action, context) {
        return __awaiter(this, void 0, void 0, function () {
            var result, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!action.enabled) {
                            return [2 /*return*/, Promise.resolve(null)];
                        }
                        this._onDidBeforeRun.fire({ action: action });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3,, 4]);
                        return [4 /*yield*/, this.runAction(action, context)];
                    case 2:
                        result = _a.sent();
                        this._onDidRun.fire({ action: action, result: result });
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _a.sent();
                        this._onDidRun.fire({ action: action, error: error_1 });
                        return [3 /*break*/, 4];
                    case 4:return [2 /*return*/];}

            });
        });
    };
    ActionRunner.prototype.runAction = function (action, context) {
        var res = context ? action.run(context) : action.run();
        return Promise.resolve(res);
    };
    return ActionRunner;
}(_lifecycle_js__WEBPACK_IMPORTED_MODULE_0__["Disposable"]);


/***/ }),

/***/ 6230:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ContextKeyExpr", function() { return ContextKeyExpr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ContextKeyDefinedExpr", function() { return ContextKeyDefinedExpr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ContextKeyEqualsExpr", function() { return ContextKeyEqualsExpr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ContextKeyNotEqualsExpr", function() { return ContextKeyNotEqualsExpr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ContextKeyNotExpr", function() { return ContextKeyNotExpr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ContextKeyRegexExpr", function() { return ContextKeyRegexExpr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ContextKeyNotRegexExpr", function() { return ContextKeyNotRegexExpr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ContextKeyAndExpr", function() { return ContextKeyAndExpr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ContextKeyOrExpr", function() { return ContextKeyOrExpr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "RawContextKey", function() { return RawContextKey; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "IContextKeyService", function() { return IContextKeyService; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SET_CONTEXT_COMMAND_ID", function() { return SET_CONTEXT_COMMAND_ID; });
/* harmony import */ var _base_common_strings_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6219);
/* harmony import */ var _instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6224);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __extends = undefined && undefined.__extends || function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
        { __proto__: [] } instanceof Array && function (d, b) {d.__proto__ = b;} ||
        function (d, b) {for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];};
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {this.constructor = d;}
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();


var ContextKeyExpr = /** @class */function () {
    function ContextKeyExpr() {
    }
    ContextKeyExpr.has = function (key) {
        return ContextKeyDefinedExpr.create(key);
    };
    ContextKeyExpr.equals = function (key, value) {
        return ContextKeyEqualsExpr.create(key, value);
    };
    ContextKeyExpr.regex = function (key, value) {
        return ContextKeyRegexExpr.create(key, value);
    };
    ContextKeyExpr.not = function (key) {
        return ContextKeyNotExpr.create(key);
    };
    ContextKeyExpr.and = function () {
        var expr = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            expr[_i] = arguments[_i];
        }
        return ContextKeyAndExpr.create(expr);
    };
    ContextKeyExpr.or = function () {
        var expr = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            expr[_i] = arguments[_i];
        }
        return ContextKeyOrExpr.create(expr);
    };
    ContextKeyExpr.deserialize = function (serialized, strict) {
        if (strict === void 0) {strict = false;}
        if (!serialized) {
            return undefined;
        }
        return this._deserializeOrExpression(serialized, strict);
    };
    ContextKeyExpr._deserializeOrExpression = function (serialized, strict) {
        var _this = this;
        var pieces = serialized.split('||');
        return ContextKeyOrExpr.create(pieces.map(function (p) {return _this._deserializeAndExpression(p, strict);}));
    };
    ContextKeyExpr._deserializeAndExpression = function (serialized, strict) {
        var _this = this;
        var pieces = serialized.split('&&');
        return ContextKeyAndExpr.create(pieces.map(function (p) {return _this._deserializeOne(p, strict);}));
    };
    ContextKeyExpr._deserializeOne = function (serializedOne, strict) {
        serializedOne = serializedOne.trim();
        if (serializedOne.indexOf('!=') >= 0) {
            var pieces = serializedOne.split('!=');
            return ContextKeyNotEqualsExpr.create(pieces[0].trim(), this._deserializeValue(pieces[1], strict));
        }
        if (serializedOne.indexOf('==') >= 0) {
            var pieces = serializedOne.split('==');
            return ContextKeyEqualsExpr.create(pieces[0].trim(), this._deserializeValue(pieces[1], strict));
        }
        if (serializedOne.indexOf('=~') >= 0) {
            var pieces = serializedOne.split('=~');
            return ContextKeyRegexExpr.create(pieces[0].trim(), this._deserializeRegexValue(pieces[1], strict));
        }
        if (/^\!\s*/.test(serializedOne)) {
            return ContextKeyNotExpr.create(serializedOne.substr(1).trim());
        }
        return ContextKeyDefinedExpr.create(serializedOne);
    };
    ContextKeyExpr._deserializeValue = function (serializedValue, strict) {
        serializedValue = serializedValue.trim();
        if (serializedValue === 'true') {
            return true;
        }
        if (serializedValue === 'false') {
            return false;
        }
        var m = /^'([^']*)'$/.exec(serializedValue);
        if (m) {
            return m[1].trim();
        }
        return serializedValue;
    };
    ContextKeyExpr._deserializeRegexValue = function (serializedValue, strict) {
        if (Object(_base_common_strings_js__WEBPACK_IMPORTED_MODULE_0__["isFalsyOrWhitespace"])(serializedValue)) {
            if (strict) {
                throw new Error('missing regexp-value for =~-expression');
            } else
            {
                console.warn('missing regexp-value for =~-expression');
            }
            return null;
        }
        var start = serializedValue.indexOf('/');
        var end = serializedValue.lastIndexOf('/');
        if (start === end || start < 0 /* || to < 0 */) {
                if (strict) {
                    throw new Error("bad regexp-value '" + serializedValue + "', missing /-enclosure");
                } else
                {
                    console.warn("bad regexp-value '" + serializedValue + "', missing /-enclosure");
                }
                return null;
            }
        var value = serializedValue.slice(start + 1, end);
        var caseIgnoreFlag = serializedValue[end + 1] === 'i' ? 'i' : '';
        try {
            return new RegExp(value, caseIgnoreFlag);
        }
        catch (e) {
            if (strict) {
                throw new Error("bad regexp-value '" + serializedValue + "', parse error: " + e);
            } else
            {
                console.warn("bad regexp-value '" + serializedValue + "', parse error: " + e);
            }
            return null;
        }
    };
    return ContextKeyExpr;
}();

function cmp(a, b) {
    var aType = a.getType();
    var bType = b.getType();
    if (aType !== bType) {
        return aType - bType;
    }
    switch (aType) {
        case 1 /* Defined */:
            return a.cmp(b);
        case 2 /* Not */:
            return a.cmp(b);
        case 3 /* Equals */:
            return a.cmp(b);
        case 4 /* NotEquals */:
            return a.cmp(b);
        case 6 /* Regex */:
            return a.cmp(b);
        case 7 /* NotRegex */:
            return a.cmp(b);
        case 5 /* And */:
            return a.cmp(b);
        default:
            throw new Error('Unknown ContextKeyExpr!');}

}
var ContextKeyDefinedExpr = /** @class */function () {
    function ContextKeyDefinedExpr(key) {
        this.key = key;
    }
    ContextKeyDefinedExpr.create = function (key) {
        return new ContextKeyDefinedExpr(key);
    };
    ContextKeyDefinedExpr.prototype.getType = function () {
        return 1 /* Defined */;
    };
    ContextKeyDefinedExpr.prototype.cmp = function (other) {
        if (this.key < other.key) {
            return -1;
        }
        if (this.key > other.key) {
            return 1;
        }
        return 0;
    };
    ContextKeyDefinedExpr.prototype.equals = function (other) {
        if (other instanceof ContextKeyDefinedExpr) {
            return this.key === other.key;
        }
        return false;
    };
    ContextKeyDefinedExpr.prototype.evaluate = function (context) {
        return !!context.getValue(this.key);
    };
    ContextKeyDefinedExpr.prototype.keys = function () {
        return [this.key];
    };
    ContextKeyDefinedExpr.prototype.negate = function () {
        return ContextKeyNotExpr.create(this.key);
    };
    return ContextKeyDefinedExpr;
}();

var ContextKeyEqualsExpr = /** @class */function () {
    function ContextKeyEqualsExpr(key, value) {
        this.key = key;
        this.value = value;
    }
    ContextKeyEqualsExpr.create = function (key, value) {
        if (typeof value === 'boolean') {
            if (value) {
                return ContextKeyDefinedExpr.create(key);
            }
            return ContextKeyNotExpr.create(key);
        }
        return new ContextKeyEqualsExpr(key, value);
    };
    ContextKeyEqualsExpr.prototype.getType = function () {
        return 3 /* Equals */;
    };
    ContextKeyEqualsExpr.prototype.cmp = function (other) {
        if (this.key < other.key) {
            return -1;
        }
        if (this.key > other.key) {
            return 1;
        }
        if (this.value < other.value) {
            return -1;
        }
        if (this.value > other.value) {
            return 1;
        }
        return 0;
    };
    ContextKeyEqualsExpr.prototype.equals = function (other) {
        if (other instanceof ContextKeyEqualsExpr) {
            return this.key === other.key && this.value === other.value;
        }
        return false;
    };
    ContextKeyEqualsExpr.prototype.evaluate = function (context) {
        // Intentional ==
        // eslint-disable-next-line eqeqeq
        return context.getValue(this.key) == this.value;
    };
    ContextKeyEqualsExpr.prototype.keys = function () {
        return [this.key];
    };
    ContextKeyEqualsExpr.prototype.negate = function () {
        return ContextKeyNotEqualsExpr.create(this.key, this.value);
    };
    return ContextKeyEqualsExpr;
}();

var ContextKeyNotEqualsExpr = /** @class */function () {
    function ContextKeyNotEqualsExpr(key, value) {
        this.key = key;
        this.value = value;
    }
    ContextKeyNotEqualsExpr.create = function (key, value) {
        if (typeof value === 'boolean') {
            if (value) {
                return ContextKeyNotExpr.create(key);
            }
            return ContextKeyDefinedExpr.create(key);
        }
        return new ContextKeyNotEqualsExpr(key, value);
    };
    ContextKeyNotEqualsExpr.prototype.getType = function () {
        return 4 /* NotEquals */;
    };
    ContextKeyNotEqualsExpr.prototype.cmp = function (other) {
        if (this.key < other.key) {
            return -1;
        }
        if (this.key > other.key) {
            return 1;
        }
        if (this.value < other.value) {
            return -1;
        }
        if (this.value > other.value) {
            return 1;
        }
        return 0;
    };
    ContextKeyNotEqualsExpr.prototype.equals = function (other) {
        if (other instanceof ContextKeyNotEqualsExpr) {
            return this.key === other.key && this.value === other.value;
        }
        return false;
    };
    ContextKeyNotEqualsExpr.prototype.evaluate = function (context) {
        // Intentional !=
        // eslint-disable-next-line eqeqeq
        return context.getValue(this.key) != this.value;
    };
    ContextKeyNotEqualsExpr.prototype.keys = function () {
        return [this.key];
    };
    ContextKeyNotEqualsExpr.prototype.negate = function () {
        return ContextKeyEqualsExpr.create(this.key, this.value);
    };
    return ContextKeyNotEqualsExpr;
}();

var ContextKeyNotExpr = /** @class */function () {
    function ContextKeyNotExpr(key) {
        this.key = key;
    }
    ContextKeyNotExpr.create = function (key) {
        return new ContextKeyNotExpr(key);
    };
    ContextKeyNotExpr.prototype.getType = function () {
        return 2 /* Not */;
    };
    ContextKeyNotExpr.prototype.cmp = function (other) {
        if (this.key < other.key) {
            return -1;
        }
        if (this.key > other.key) {
            return 1;
        }
        return 0;
    };
    ContextKeyNotExpr.prototype.equals = function (other) {
        if (other instanceof ContextKeyNotExpr) {
            return this.key === other.key;
        }
        return false;
    };
    ContextKeyNotExpr.prototype.evaluate = function (context) {
        return !context.getValue(this.key);
    };
    ContextKeyNotExpr.prototype.keys = function () {
        return [this.key];
    };
    ContextKeyNotExpr.prototype.negate = function () {
        return ContextKeyDefinedExpr.create(this.key);
    };
    return ContextKeyNotExpr;
}();

var ContextKeyRegexExpr = /** @class */function () {
    function ContextKeyRegexExpr(key, regexp) {
        this.key = key;
        this.regexp = regexp;
        //
    }
    ContextKeyRegexExpr.create = function (key, regexp) {
        return new ContextKeyRegexExpr(key, regexp);
    };
    ContextKeyRegexExpr.prototype.getType = function () {
        return 6 /* Regex */;
    };
    ContextKeyRegexExpr.prototype.cmp = function (other) {
        if (this.key < other.key) {
            return -1;
        }
        if (this.key > other.key) {
            return 1;
        }
        var thisSource = this.regexp ? this.regexp.source : '';
        var otherSource = other.regexp ? other.regexp.source : '';
        if (thisSource < otherSource) {
            return -1;
        }
        if (thisSource > otherSource) {
            return 1;
        }
        return 0;
    };
    ContextKeyRegexExpr.prototype.equals = function (other) {
        if (other instanceof ContextKeyRegexExpr) {
            var thisSource = this.regexp ? this.regexp.source : '';
            var otherSource = other.regexp ? other.regexp.source : '';
            return this.key === other.key && thisSource === otherSource;
        }
        return false;
    };
    ContextKeyRegexExpr.prototype.evaluate = function (context) {
        var value = context.getValue(this.key);
        return this.regexp ? this.regexp.test(value) : false;
    };
    ContextKeyRegexExpr.prototype.keys = function () {
        return [this.key];
    };
    ContextKeyRegexExpr.prototype.negate = function () {
        return ContextKeyNotRegexExpr.create(this);
    };
    return ContextKeyRegexExpr;
}();

var ContextKeyNotRegexExpr = /** @class */function () {
    function ContextKeyNotRegexExpr(_actual) {
        this._actual = _actual;
        //
    }
    ContextKeyNotRegexExpr.create = function (actual) {
        return new ContextKeyNotRegexExpr(actual);
    };
    ContextKeyNotRegexExpr.prototype.getType = function () {
        return 7 /* NotRegex */;
    };
    ContextKeyNotRegexExpr.prototype.cmp = function (other) {
        return this._actual.cmp(other._actual);
    };
    ContextKeyNotRegexExpr.prototype.equals = function (other) {
        if (other instanceof ContextKeyNotRegexExpr) {
            return this._actual.equals(other._actual);
        }
        return false;
    };
    ContextKeyNotRegexExpr.prototype.evaluate = function (context) {
        return !this._actual.evaluate(context);
    };
    ContextKeyNotRegexExpr.prototype.keys = function () {
        return this._actual.keys();
    };
    ContextKeyNotRegexExpr.prototype.negate = function () {
        return this._actual;
    };
    return ContextKeyNotRegexExpr;
}();

var ContextKeyAndExpr = /** @class */function () {
    function ContextKeyAndExpr(expr) {
        this.expr = expr;
    }
    ContextKeyAndExpr.create = function (_expr) {
        var expr = ContextKeyAndExpr._normalizeArr(_expr);
        if (expr.length === 0) {
            return undefined;
        }
        if (expr.length === 1) {
            return expr[0];
        }
        return new ContextKeyAndExpr(expr);
    };
    ContextKeyAndExpr.prototype.getType = function () {
        return 5 /* And */;
    };
    ContextKeyAndExpr.prototype.cmp = function (other) {
        if (this.expr.length < other.expr.length) {
            return -1;
        }
        if (this.expr.length > other.expr.length) {
            return 1;
        }
        for (var i = 0, len = this.expr.length; i < len; i++) {
            var r = cmp(this.expr[i], other.expr[i]);
            if (r !== 0) {
                return r;
            }
        }
        return 0;
    };
    ContextKeyAndExpr.prototype.equals = function (other) {
        if (other instanceof ContextKeyAndExpr) {
            if (this.expr.length !== other.expr.length) {
                return false;
            }
            for (var i = 0, len = this.expr.length; i < len; i++) {
                if (!this.expr[i].equals(other.expr[i])) {
                    return false;
                }
            }
            return true;
        }
        return false;
    };
    ContextKeyAndExpr.prototype.evaluate = function (context) {
        for (var i = 0, len = this.expr.length; i < len; i++) {
            if (!this.expr[i].evaluate(context)) {
                return false;
            }
        }
        return true;
    };
    ContextKeyAndExpr._normalizeArr = function (arr) {
        var expr = [];
        if (arr) {
            for (var i = 0, len = arr.length; i < len; i++) {
                var e = arr[i];
                if (!e) {
                    continue;
                }
                if (e instanceof ContextKeyAndExpr) {
                    expr = expr.concat(e.expr);
                    continue;
                }
                if (e instanceof ContextKeyOrExpr) {
                    // Not allowed, because we don't have parens!
                    throw new Error("It is not allowed to have an or expression here due to lack of parens! For example \"a && (b||c)\" is not supported, use \"(a&&b) || (a&&c)\" instead.");
                }
                expr.push(e);
            }
            expr.sort(cmp);
        }
        return expr;
    };
    ContextKeyAndExpr.prototype.keys = function () {
        var result = [];
        for (var _i = 0, _a = this.expr; _i < _a.length; _i++) {
            var expr = _a[_i];
            result.push.apply(result, expr.keys());
        }
        return result;
    };
    ContextKeyAndExpr.prototype.negate = function () {
        var result = [];
        for (var _i = 0, _a = this.expr; _i < _a.length; _i++) {
            var expr = _a[_i];
            result.push(expr.negate());
        }
        return ContextKeyOrExpr.create(result);
    };
    return ContextKeyAndExpr;
}();

var ContextKeyOrExpr = /** @class */function () {
    function ContextKeyOrExpr(expr) {
        this.expr = expr;
    }
    ContextKeyOrExpr.create = function (_expr) {
        var expr = ContextKeyOrExpr._normalizeArr(_expr);
        if (expr.length === 0) {
            return undefined;
        }
        if (expr.length === 1) {
            return expr[0];
        }
        return new ContextKeyOrExpr(expr);
    };
    ContextKeyOrExpr.prototype.getType = function () {
        return 8 /* Or */;
    };
    ContextKeyOrExpr.prototype.equals = function (other) {
        if (other instanceof ContextKeyOrExpr) {
            if (this.expr.length !== other.expr.length) {
                return false;
            }
            for (var i = 0, len = this.expr.length; i < len; i++) {
                if (!this.expr[i].equals(other.expr[i])) {
                    return false;
                }
            }
            return true;
        }
        return false;
    };
    ContextKeyOrExpr.prototype.evaluate = function (context) {
        for (var i = 0, len = this.expr.length; i < len; i++) {
            if (this.expr[i].evaluate(context)) {
                return true;
            }
        }
        return false;
    };
    ContextKeyOrExpr._normalizeArr = function (arr) {
        var expr = [];
        if (arr) {
            for (var i = 0, len = arr.length; i < len; i++) {
                var e = arr[i];
                if (!e) {
                    continue;
                }
                if (e instanceof ContextKeyOrExpr) {
                    expr = expr.concat(e.expr);
                    continue;
                }
                expr.push(e);
            }
            expr.sort(cmp);
        }
        return expr;
    };
    ContextKeyOrExpr.prototype.keys = function () {
        var result = [];
        for (var _i = 0, _a = this.expr; _i < _a.length; _i++) {
            var expr = _a[_i];
            result.push.apply(result, expr.keys());
        }
        return result;
    };
    ContextKeyOrExpr.prototype.negate = function () {
        var result = [];
        for (var _i = 0, _a = this.expr; _i < _a.length; _i++) {
            var expr = _a[_i];
            result.push(expr.negate());
        }
        var terminals = function (node) {
            if (node instanceof ContextKeyOrExpr) {
                return node.expr;
            }
            return [node];
        };
        // We don't support parens, so here we distribute the AND over the OR terminals
        // We always take the first 2 AND pairs and distribute them
        while (result.length > 1) {
            var LEFT = result.shift();
            var RIGHT = result.shift();
            var all = [];
            for (var _b = 0, _c = terminals(LEFT); _b < _c.length; _b++) {
                var left = _c[_b];
                for (var _d = 0, _e = terminals(RIGHT); _d < _e.length; _d++) {
                    var right = _e[_d];
                    all.push(ContextKeyExpr.and(left, right));
                }
            }
            result.unshift(ContextKeyExpr.or.apply(ContextKeyExpr, all));
        }
        return result[0];
    };
    return ContextKeyOrExpr;
}();

var RawContextKey = /** @class */function (_super) {
    __extends(RawContextKey, _super);
    function RawContextKey(key, defaultValue) {
        var _this = _super.call(this, key) || this;
        _this._defaultValue = defaultValue;
        return _this;
    }
    RawContextKey.prototype.bindTo = function (target) {
        return target.createKey(this.key, this._defaultValue);
    };
    RawContextKey.prototype.getValue = function (target) {
        return target.getContextKeyValue(this.key);
    };
    RawContextKey.prototype.toNegated = function () {
        return ContextKeyExpr.not(this.key);
    };
    return RawContextKey;
}(ContextKeyDefinedExpr);

var IContextKeyService = Object(_instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_1__["createDecorator"])('contextKeyService');
var SET_CONTEXT_COMMAND_ID = 'setContext';

/***/ }),

/***/ 6231:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ICommandService", function() { return ICommandService; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "CommandsRegistry", function() { return CommandsRegistry; });
/* harmony import */ var _base_common_lifecycle_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6216);
/* harmony import */ var _base_common_types_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6232);
/* harmony import */ var _instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6224);
/* harmony import */ var _base_common_event_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6213);
/* harmony import */ var _base_common_linkedList_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6217);
/* harmony import */ var _base_common_map_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6233);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __spreadArrays = undefined && undefined.__spreadArrays || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
    for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
    r[k] = a[j];
    return r;
};






var ICommandService = Object(_instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_2__["createDecorator"])('commandService');
var CommandsRegistry = new ( /** @class */function () {
    function class_1() {
        this._commands = new Map();
        this._onDidRegisterCommand = new _base_common_event_js__WEBPACK_IMPORTED_MODULE_3__["Emitter"]();
        this.onDidRegisterCommand = this._onDidRegisterCommand.event;
    }
    class_1.prototype.registerCommand = function (idOrCommand, handler) {
        var _this = this;
        if (!idOrCommand) {
            throw new Error("invalid command");
        }
        if (typeof idOrCommand === 'string') {
            if (!handler) {
                throw new Error("invalid command");
            }
            return this.registerCommand({ id: idOrCommand, handler: handler });
        }
        // add argument validation if rich command metadata is provided
        if (idOrCommand.description) {
            var constraints_1 = [];
            for (var _i = 0, _a = idOrCommand.description.args; _i < _a.length; _i++) {
                var arg = _a[_i];
                constraints_1.push(arg.constraint);
            }
            var actualHandler_1 = idOrCommand.handler;
            idOrCommand.handler = function (accessor) {
                var args = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    args[_i - 1] = arguments[_i];
                }
                Object(_base_common_types_js__WEBPACK_IMPORTED_MODULE_1__["validateConstraints"])(args, constraints_1);
                return actualHandler_1.apply(void 0, __spreadArrays([accessor], args));
            };
        }
        // find a place to store the command
        var id = idOrCommand.id;
        var commands = this._commands.get(id);
        if (!commands) {
            commands = new _base_common_linkedList_js__WEBPACK_IMPORTED_MODULE_4__["LinkedList"]();
            this._commands.set(id, commands);
        }
        var removeFn = commands.unshift(idOrCommand);
        var ret = Object(_base_common_lifecycle_js__WEBPACK_IMPORTED_MODULE_0__["toDisposable"])(function () {
            removeFn();
            var command = _this._commands.get(id);
            if (command === null || command === void 0 ? void 0 : command.isEmpty()) {
                _this._commands.delete(id);
            }
        });
        // tell the world about this command
        this._onDidRegisterCommand.fire(id);
        return ret;
    };
    class_1.prototype.registerCommandAlias = function (oldId, newId) {
        return CommandsRegistry.registerCommand(oldId, function (accessor) {
            var _a;
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            return (_a = accessor.get(ICommandService)).executeCommand.apply(_a, __spreadArrays([newId], args));
        });
    };
    class_1.prototype.getCommand = function (id) {
        var list = this._commands.get(id);
        if (!list || list.isEmpty()) {
            return undefined;
        }
        return list.iterator().next().value;
    };
    class_1.prototype.getCommands = function () {
        var result = new Map();
        for (var _i = 0, _a = Object(_base_common_map_js__WEBPACK_IMPORTED_MODULE_5__["keys"])(this._commands); _i < _a.length; _i++) {
            var key = _a[_i];
            var command = this.getCommand(key);
            if (command) {
                result.set(key, command);
            }
        }
        return result;
    };
    return class_1;
}())();

/***/ }),

/***/ 6232:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isArray", function() { return isArray; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isString", function() { return isString; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isObject", function() { return isObject; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isNumber", function() { return isNumber; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isBoolean", function() { return isBoolean; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isUndefined", function() { return isUndefined; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isUndefinedOrNull", function() { return isUndefinedOrNull; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "assertType", function() { return assertType; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isEmptyObject", function() { return isEmptyObject; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isFunction", function() { return isFunction; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "validateConstraints", function() { return validateConstraints; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "validateConstraint", function() { return validateConstraint; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getAllPropertyNames", function() { return getAllPropertyNames; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getAllMethodNames", function() { return getAllMethodNames; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "createProxyObject", function() { return createProxyObject; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "withNullAsUndefined", function() { return withNullAsUndefined; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "withUndefinedAsNull", function() { return withUndefinedAsNull; });
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var _typeof = {
    number: 'number',
    string: 'string',
    undefined: 'undefined',
    object: 'object',
    function: 'function' };

/**
                             * @returns whether the provided parameter is a JavaScript Array or not.
                             */
function isArray(array) {
    if (Array.isArray) {
        return Array.isArray(array);
    }
    if (array && typeof array.length === _typeof.number && array.constructor === Array) {
        return true;
    }
    return false;
}
/**
   * @returns whether the provided parameter is a JavaScript String or not.
   */
function isString(str) {
    if (typeof str === _typeof.string || str instanceof String) {
        return true;
    }
    return false;
}
/**
   *
   * @returns whether the provided parameter is of type `object` but **not**
   *	`null`, an `array`, a `regexp`, nor a `date`.
   */
function isObject(obj) {
    // The method can't do a type cast since there are type (like strings) which
    // are subclasses of any put not positvely matched by the function. Hence type
    // narrowing results in wrong results.
    return typeof obj === _typeof.object &&
    obj !== null &&
    !Array.isArray(obj) &&
    !(obj instanceof RegExp) &&
    !(obj instanceof Date);
}
/**
   * In **contrast** to just checking `typeof` this will return `false` for `NaN`.
   * @returns whether the provided parameter is a JavaScript Number or not.
   */
function isNumber(obj) {
    if ((typeof obj === _typeof.number || obj instanceof Number) && !isNaN(obj)) {
        return true;
    }
    return false;
}
/**
   * @returns whether the provided parameter is a JavaScript Boolean or not.
   */
function isBoolean(obj) {
    return obj === true || obj === false;
}
/**
   * @returns whether the provided parameter is undefined.
   */
function isUndefined(obj) {
    return typeof obj === _typeof.undefined;
}
/**
   * @returns whether the provided parameter is undefined or null.
   */
function isUndefinedOrNull(obj) {
    return isUndefined(obj) || obj === null;
}
function assertType(condition, type) {
    if (!condition) {
        throw new Error(type ? "Unexpected type, expected '" + type + "'" : 'Unexpected type');
    }
}
var hasOwnProperty = Object.prototype.hasOwnProperty;
/**
                                                       * @returns whether the provided parameter is an empty JavaScript Object or not.
                                                       */
function isEmptyObject(obj) {
    if (!isObject(obj)) {
        return false;
    }
    for (var key in obj) {
        if (hasOwnProperty.call(obj, key)) {
            return false;
        }
    }
    return true;
}
/**
   * @returns whether the provided parameter is a JavaScript Function or not.
   */
function isFunction(obj) {
    return typeof obj === _typeof.function;
}
function validateConstraints(args, constraints) {
    var len = Math.min(args.length, constraints.length);
    for (var i = 0; i < len; i++) {
        validateConstraint(args[i], constraints[i]);
    }
}
function validateConstraint(arg, constraint) {
    if (isString(constraint)) {
        if (typeof arg !== constraint) {
            throw new Error("argument does not match constraint: typeof " + constraint);
        }
    } else
    if (isFunction(constraint)) {
        try {
            if (arg instanceof constraint) {
                return;
            }
        }
        catch (_a) {
            // ignore
        }
        if (!isUndefinedOrNull(arg) && arg.constructor === constraint) {
            return;
        }
        if (constraint.length === 1 && constraint.call(undefined, arg) === true) {
            return;
        }
        throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true");
    }
}
function getAllPropertyNames(obj) {
    var res = [];
    var proto = Object.getPrototypeOf(obj);
    while (Object.prototype !== proto) {
        res = res.concat(Object.getOwnPropertyNames(proto));
        proto = Object.getPrototypeOf(proto);
    }
    return res;
}
function getAllMethodNames(obj) {
    var methods = [];
    for (var _i = 0, _a = getAllPropertyNames(obj); _i < _a.length; _i++) {
        var prop = _a[_i];
        if (typeof obj[prop] === 'function') {
            methods.push(prop);
        }
    }
    return methods;
}
function createProxyObject(methodNames, invoke) {
    var createProxyMethod = function (method) {
        return function () {
            var args = Array.prototype.slice.call(arguments, 0);
            return invoke(method, args);
        };
    };
    var result = {};
    for (var _i = 0, methodNames_1 = methodNames; _i < methodNames_1.length; _i++) {
        var methodName = methodNames_1[_i];
        result[methodName] = createProxyMethod(methodName);
    }
    return result;
}
/**
   * Converts null to undefined, passes all other values through.
   */
function withNullAsUndefined(x) {
    return x === null ? undefined : x;
}
/**
   * Converts undefined to null, passes all other values through.
   */
function withUndefinedAsNull(x) {
    return typeof x === 'undefined' ? null : x;
}

/***/ }),

/***/ 6233:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "values", function() { return values; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "keys", function() { return keys; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "StringIterator", function() { return StringIterator; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "PathIterator", function() { return PathIterator; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "TernarySearchTree", function() { return TernarySearchTree; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ResourceMap", function() { return ResourceMap; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LinkedMap", function() { return LinkedMap; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LRUCache", function() { return LRUCache; });
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __extends = undefined && undefined.__extends || function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
        { __proto__: [] } instanceof Array && function (d, b) {d.__proto__ = b;} ||
        function (d, b) {for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];};
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {this.constructor = d;}
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();
function values(forEachable) {
    var result = [];
    forEachable.forEach(function (value) {return result.push(value);});
    return result;
}
function keys(map) {
    var result = [];
    map.forEach(function (_value, key) {return result.push(key);});
    return result;
}
var StringIterator = /** @class */function () {
    function StringIterator() {
        this._value = '';
        this._pos = 0;
    }
    StringIterator.prototype.reset = function (key) {
        this._value = key;
        this._pos = 0;
        return this;
    };
    StringIterator.prototype.next = function () {
        this._pos += 1;
        return this;
    };
    StringIterator.prototype.hasNext = function () {
        return this._pos < this._value.length - 1;
    };
    StringIterator.prototype.cmp = function (a) {
        var aCode = a.charCodeAt(0);
        var thisCode = this._value.charCodeAt(this._pos);
        return aCode - thisCode;
    };
    StringIterator.prototype.value = function () {
        return this._value[this._pos];
    };
    return StringIterator;
}();

var PathIterator = /** @class */function () {
    function PathIterator(_splitOnBackslash) {
        if (_splitOnBackslash === void 0) {_splitOnBackslash = true;}
        this._splitOnBackslash = _splitOnBackslash;
    }
    PathIterator.prototype.reset = function (key) {
        this._value = key.replace(/\\$|\/$/, '');
        this._from = 0;
        this._to = 0;
        return this.next();
    };
    PathIterator.prototype.hasNext = function () {
        return this._to < this._value.length;
    };
    PathIterator.prototype.next = function () {
        // this._data = key.split(/[\\/]/).filter(s => !!s);
        this._from = this._to;
        var justSeps = true;
        for (; this._to < this._value.length; this._to++) {
            var ch = this._value.charCodeAt(this._to);
            if (ch === 47 /* Slash */ || this._splitOnBackslash && ch === 92 /* Backslash */) {
                    if (justSeps) {
                        this._from++;
                    } else
                    {
                        break;
                    }
                } else
            {
                justSeps = false;
            }
        }
        return this;
    };
    PathIterator.prototype.cmp = function (a) {
        var aPos = 0;
        var aLen = a.length;
        var thisPos = this._from;
        while (aPos < aLen && thisPos < this._to) {
            var cmp = a.charCodeAt(aPos) - this._value.charCodeAt(thisPos);
            if (cmp !== 0) {
                return cmp;
            }
            aPos += 1;
            thisPos += 1;
        }
        if (aLen === this._to - this._from) {
            return 0;
        } else
        if (aPos < aLen) {
            return -1;
        } else
        {
            return 1;
        }
    };
    PathIterator.prototype.value = function () {
        return this._value.substring(this._from, this._to);
    };
    return PathIterator;
}();

var TernarySearchTreeNode = /** @class */function () {
    function TernarySearchTreeNode() {
    }
    return TernarySearchTreeNode;
}();
var TernarySearchTree = /** @class */function () {
    function TernarySearchTree(segments) {
        this._iter = segments;
    }
    TernarySearchTree.forPaths = function () {
        return new TernarySearchTree(new PathIterator());
    };
    TernarySearchTree.forStrings = function () {
        return new TernarySearchTree(new StringIterator());
    };
    TernarySearchTree.prototype.clear = function () {
        this._root = undefined;
    };
    TernarySearchTree.prototype.set = function (key, element) {
        var iter = this._iter.reset(key);
        var node;
        if (!this._root) {
            this._root = new TernarySearchTreeNode();
            this._root.segment = iter.value();
        }
        node = this._root;
        while (true) {
            var val = iter.cmp(node.segment);
            if (val > 0) {
                // left
                if (!node.left) {
                    node.left = new TernarySearchTreeNode();
                    node.left.segment = iter.value();
                }
                node = node.left;
            } else
            if (val < 0) {
                // right
                if (!node.right) {
                    node.right = new TernarySearchTreeNode();
                    node.right.segment = iter.value();
                }
                node = node.right;
            } else
            if (iter.hasNext()) {
                // mid
                iter.next();
                if (!node.mid) {
                    node.mid = new TernarySearchTreeNode();
                    node.mid.segment = iter.value();
                }
                node = node.mid;
            } else
            {
                break;
            }
        }
        var oldElement = node.value;
        node.value = element;
        node.key = key;
        return oldElement;
    };
    TernarySearchTree.prototype.get = function (key) {
        var iter = this._iter.reset(key);
        var node = this._root;
        while (node) {
            var val = iter.cmp(node.segment);
            if (val > 0) {
                // left
                node = node.left;
            } else
            if (val < 0) {
                // right
                node = node.right;
            } else
            if (iter.hasNext()) {
                // mid
                iter.next();
                node = node.mid;
            } else
            {
                break;
            }
        }
        return node ? node.value : undefined;
    };
    TernarySearchTree.prototype.findSubstr = function (key) {
        var iter = this._iter.reset(key);
        var node = this._root;
        var candidate = undefined;
        while (node) {
            var val = iter.cmp(node.segment);
            if (val > 0) {
                // left
                node = node.left;
            } else
            if (val < 0) {
                // right
                node = node.right;
            } else
            if (iter.hasNext()) {
                // mid
                iter.next();
                candidate = node.value || candidate;
                node = node.mid;
            } else
            {
                break;
            }
        }
        return node && node.value || candidate;
    };
    TernarySearchTree.prototype.forEach = function (callback) {
        this._forEach(this._root, callback);
    };
    TernarySearchTree.prototype._forEach = function (node, callback) {
        if (node) {
            // left
            this._forEach(node.left, callback);
            // node
            if (node.value) {
                // callback(node.value, this._iter.join(parts));
                callback(node.value, node.key);
            }
            // mid
            this._forEach(node.mid, callback);
            // right
            this._forEach(node.right, callback);
        }
    };
    return TernarySearchTree;
}();

var ResourceMap = /** @class */function () {
    function ResourceMap() {
        this.map = new Map();
        this.ignoreCase = false; // in the future this should be an uri-comparator
    }
    ResourceMap.prototype.set = function (resource, value) {
        this.map.set(this.toKey(resource), value);
    };
    ResourceMap.prototype.get = function (resource) {
        return this.map.get(this.toKey(resource));
    };
    ResourceMap.prototype.toKey = function (resource) {
        var key = resource.toString();
        if (this.ignoreCase) {
            key = key.toLowerCase();
        }
        return key;
    };
    return ResourceMap;
}();

var LinkedMap = /** @class */function () {
    function LinkedMap() {
        this._map = new Map();
        this._head = undefined;
        this._tail = undefined;
        this._size = 0;
    }
    LinkedMap.prototype.clear = function () {
        this._map.clear();
        this._head = undefined;
        this._tail = undefined;
        this._size = 0;
    };
    Object.defineProperty(LinkedMap.prototype, "size", {
        get: function () {
            return this._size;
        },
        enumerable: true,
        configurable: true });

    LinkedMap.prototype.get = function (key, touch) {
        if (touch === void 0) {touch = 0 /* None */;}
        var item = this._map.get(key);
        if (!item) {
            return undefined;
        }
        if (touch !== 0 /* None */) {
                this.touch(item, touch);
            }
        return item.value;
    };
    LinkedMap.prototype.set = function (key, value, touch) {
        if (touch === void 0) {touch = 0 /* None */;}
        var item = this._map.get(key);
        if (item) {
            item.value = value;
            if (touch !== 0 /* None */) {
                    this.touch(item, touch);
                }
        } else
        {
            item = { key: key, value: value, next: undefined, previous: undefined };
            switch (touch) {
                case 0 /* None */:
                    this.addItemLast(item);
                    break;
                case 1 /* AsOld */:
                    this.addItemFirst(item);
                    break;
                case 2 /* AsNew */:
                    this.addItemLast(item);
                    break;
                default:
                    this.addItemLast(item);
                    break;}

            this._map.set(key, item);
            this._size++;
        }
    };
    LinkedMap.prototype.delete = function (key) {
        return !!this.remove(key);
    };
    LinkedMap.prototype.remove = function (key) {
        var item = this._map.get(key);
        if (!item) {
            return undefined;
        }
        this._map.delete(key);
        this.removeItem(item);
        this._size--;
        return item.value;
    };
    LinkedMap.prototype.forEach = function (callbackfn, thisArg) {
        var current = this._head;
        while (current) {
            if (thisArg) {
                callbackfn.bind(thisArg)(current.value, current.key, this);
            } else
            {
                callbackfn(current.value, current.key, this);
            }
            current = current.next;
        }
    };
    /* VS Code / Monaco editor runs on es5 which has no Symbol.iterator
       keys(): IterableIterator<K> {
           const current = this._head;
           const iterator: IterableIterator<K> = {
               [Symbol.iterator]() {
                   return iterator;
               },
               next():IteratorResult<K> {
                   if (current) {
                       const result = { value: current.key, done: false };
                       current = current.next;
                       return result;
                   } else {
                       return { value: undefined, done: true };
                   }
               }
           };
           return iterator;
       }
         values(): IterableIterator<V> {
           const current = this._head;
           const iterator: IterableIterator<V> = {
               [Symbol.iterator]() {
                   return iterator;
               },
               next():IteratorResult<V> {
                   if (current) {
                       const result = { value: current.value, done: false };
                       current = current.next;
                       return result;
                   } else {
                       return { value: undefined, done: true };
                   }
               }
           };
           return iterator;
       }
       */

    LinkedMap.prototype.trimOld = function (newSize) {
        if (newSize >= this.size) {
            return;
        }
        if (newSize === 0) {
            this.clear();
            return;
        }
        var current = this._head;
        var currentSize = this.size;
        while (current && currentSize > newSize) {
            this._map.delete(current.key);
            current = current.next;
            currentSize--;
        }
        this._head = current;
        this._size = currentSize;
        if (current) {
            current.previous = undefined;
        }
    };
    LinkedMap.prototype.addItemFirst = function (item) {
        // First time Insert
        if (!this._head && !this._tail) {
            this._tail = item;
        } else
        if (!this._head) {
            throw new Error('Invalid list');
        } else
        {
            item.next = this._head;
            this._head.previous = item;
        }
        this._head = item;
    };
    LinkedMap.prototype.addItemLast = function (item) {
        // First time Insert
        if (!this._head && !this._tail) {
            this._head = item;
        } else
        if (!this._tail) {
            throw new Error('Invalid list');
        } else
        {
            item.previous = this._tail;
            this._tail.next = item;
        }
        this._tail = item;
    };
    LinkedMap.prototype.removeItem = function (item) {
        if (item === this._head && item === this._tail) {
            this._head = undefined;
            this._tail = undefined;
        } else
        if (item === this._head) {
            // This can only happend if size === 1 which is handle
            // by the case above.
            if (!item.next) {
                throw new Error('Invalid list');
            }
            item.next.previous = undefined;
            this._head = item.next;
        } else
        if (item === this._tail) {
            // This can only happend if size === 1 which is handle
            // by the case above.
            if (!item.previous) {
                throw new Error('Invalid list');
            }
            item.previous.next = undefined;
            this._tail = item.previous;
        } else
        {
            var next = item.next;
            var previous = item.previous;
            if (!next || !previous) {
                throw new Error('Invalid list');
            }
            next.previous = previous;
            previous.next = next;
        }
        item.next = undefined;
        item.previous = undefined;
    };
    LinkedMap.prototype.touch = function (item, touch) {
        if (!this._head || !this._tail) {
            throw new Error('Invalid list');
        }
        if (touch !== 1 /* AsOld */ && touch !== 2 /* AsNew */) {
                return;
            }
        if (touch === 1 /* AsOld */) {
                if (item === this._head) {
                    return;
                }
                var next = item.next;
                var previous = item.previous;
                // Unlink the item
                if (item === this._tail) {
                    // previous must be defined since item was not head but is tail
                    // So there are more than on item in the map
                    previous.next = undefined;
                    this._tail = previous;
                } else
                {
                    // Both next and previous are not undefined since item was neither head nor tail.
                    next.previous = previous;
                    previous.next = next;
                }
                // Insert the node at head
                item.previous = undefined;
                item.next = this._head;
                this._head.previous = item;
                this._head = item;
            } else
        if (touch === 2 /* AsNew */) {
                if (item === this._tail) {
                    return;
                }
                var next = item.next;
                var previous = item.previous;
                // Unlink the item.
                if (item === this._head) {
                    // next must be defined since item was not tail but is head
                    // So there are more than on item in the map
                    next.previous = undefined;
                    this._head = next;
                } else
                {
                    // Both next and previous are not undefined since item was neither head nor tail.
                    next.previous = previous;
                    previous.next = next;
                }
                item.next = undefined;
                item.previous = this._tail;
                this._tail.next = item;
                this._tail = item;
            }
    };
    LinkedMap.prototype.toJSON = function () {
        var data = [];
        this.forEach(function (value, key) {
            data.push([key, value]);
        });
        return data;
    };
    return LinkedMap;
}();

var LRUCache = /** @class */function (_super) {
    __extends(LRUCache, _super);
    function LRUCache(limit, ratio) {
        if (ratio === void 0) {ratio = 1;}
        var _this = _super.call(this) || this;
        _this._limit = limit;
        _this._ratio = Math.min(Math.max(0, ratio), 1);
        return _this;
    }
    LRUCache.prototype.get = function (key) {
        return _super.prototype.get.call(this, key, 2 /* AsNew */);
    };
    LRUCache.prototype.peek = function (key) {
        return _super.prototype.get.call(this, key, 0 /* None */);
    };
    LRUCache.prototype.set = function (key, value) {
        _super.prototype.set.call(this, key, value, 2 /* AsNew */);
        this.checkTrim();
    };
    LRUCache.prototype.checkTrim = function () {
        if (this.size > this._limit) {
            this.trimOld(Math.round(this._limit * this._ratio));
        }
    };
    return LRUCache;
}(LinkedMap);


/***/ }),

/***/ 6234:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "KeybindingsRegistry", function() { return KeybindingsRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Extensions", function() { return Extensions; });
/* harmony import */ var _base_common_keyCodes_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6235);
/* harmony import */ var _base_common_platform_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6222);
/* harmony import */ var _commands_common_commands_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6231);
/* harmony import */ var _registry_common_platform_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6236);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/




var KeybindingsRegistryImpl = /** @class */function () {
    function KeybindingsRegistryImpl() {
        this._coreKeybindings = [];
        this._extensionKeybindings = [];
        this._cachedMergedKeybindings = null;
    }
    /**
       * Take current platform into account and reduce to primary & secondary.
       */
    KeybindingsRegistryImpl.bindToCurrentPlatform = function (kb) {
        if (_base_common_platform_js__WEBPACK_IMPORTED_MODULE_1__["OS"] === 1 /* Windows */) {
                if (kb && kb.win) {
                    return kb.win;
                }
            } else
        if (_base_common_platform_js__WEBPACK_IMPORTED_MODULE_1__["OS"] === 2 /* Macintosh */) {
                if (kb && kb.mac) {
                    return kb.mac;
                }
            } else
        {
            if (kb && kb.linux) {
                return kb.linux;
            }
        }
        return kb;
    };
    KeybindingsRegistryImpl.prototype.registerKeybindingRule = function (rule) {
        var actualKb = KeybindingsRegistryImpl.bindToCurrentPlatform(rule);
        if (actualKb && actualKb.primary) {
            var kk = Object(_base_common_keyCodes_js__WEBPACK_IMPORTED_MODULE_0__["createKeybinding"])(actualKb.primary, _base_common_platform_js__WEBPACK_IMPORTED_MODULE_1__["OS"]);
            if (kk) {
                this._registerDefaultKeybinding(kk, rule.id, rule.args, rule.weight, 0, rule.when);
            }
        }
        if (actualKb && Array.isArray(actualKb.secondary)) {
            for (var i = 0, len = actualKb.secondary.length; i < len; i++) {
                var k = actualKb.secondary[i];
                var kk = Object(_base_common_keyCodes_js__WEBPACK_IMPORTED_MODULE_0__["createKeybinding"])(k, _base_common_platform_js__WEBPACK_IMPORTED_MODULE_1__["OS"]);
                if (kk) {
                    this._registerDefaultKeybinding(kk, rule.id, rule.args, rule.weight, -i - 1, rule.when);
                }
            }
        }
    };
    KeybindingsRegistryImpl.prototype.registerCommandAndKeybindingRule = function (desc) {
        this.registerKeybindingRule(desc);
        _commands_common_commands_js__WEBPACK_IMPORTED_MODULE_2__["CommandsRegistry"].registerCommand(desc);
    };
    KeybindingsRegistryImpl._mightProduceChar = function (keyCode) {
        if (keyCode >= 21 /* KEY_0 */ && keyCode <= 30 /* KEY_9 */) {
                return true;
            }
        if (keyCode >= 31 /* KEY_A */ && keyCode <= 56 /* KEY_Z */) {
                return true;
            }
        return keyCode === 80 /* US_SEMICOLON */ ||
        keyCode === 81 /* US_EQUAL */ ||
        keyCode === 82 /* US_COMMA */ ||
        keyCode === 83 /* US_MINUS */ ||
        keyCode === 84 /* US_DOT */ ||
        keyCode === 85 /* US_SLASH */ ||
        keyCode === 86 /* US_BACKTICK */ ||
        keyCode === 110 /* ABNT_C1 */ ||
        keyCode === 111 /* ABNT_C2 */ ||
        keyCode === 87 /* US_OPEN_SQUARE_BRACKET */ ||
        keyCode === 88 /* US_BACKSLASH */ ||
        keyCode === 89 /* US_CLOSE_SQUARE_BRACKET */ ||
        keyCode === 90 /* US_QUOTE */ ||
        keyCode === 91 /* OEM_8 */ ||
        keyCode === 92 /* OEM_102 */;
    };
    KeybindingsRegistryImpl.prototype._assertNoCtrlAlt = function (keybinding, commandId) {
        if (keybinding.ctrlKey && keybinding.altKey && !keybinding.metaKey) {
            if (KeybindingsRegistryImpl._mightProduceChar(keybinding.keyCode)) {
                console.warn('Ctrl+Alt+ keybindings should not be used by default under Windows. Offender: ', keybinding, ' for ', commandId);
            }
        }
    };
    KeybindingsRegistryImpl.prototype._registerDefaultKeybinding = function (keybinding, commandId, commandArgs, weight1, weight2, when) {
        if (_base_common_platform_js__WEBPACK_IMPORTED_MODULE_1__["OS"] === 1 /* Windows */) {
                this._assertNoCtrlAlt(keybinding.parts[0], commandId);
            }
        this._coreKeybindings.push({
            keybinding: keybinding,
            command: commandId,
            commandArgs: commandArgs,
            when: when,
            weight1: weight1,
            weight2: weight2 });

        this._cachedMergedKeybindings = null;
    };
    KeybindingsRegistryImpl.prototype.getDefaultKeybindings = function () {
        if (!this._cachedMergedKeybindings) {
            this._cachedMergedKeybindings = [].concat(this._coreKeybindings).concat(this._extensionKeybindings);
            this._cachedMergedKeybindings.sort(sorter);
        }
        return this._cachedMergedKeybindings.slice(0);
    };
    return KeybindingsRegistryImpl;
}();
var KeybindingsRegistry = new KeybindingsRegistryImpl();
// Define extension point ids
var Extensions = {
    EditorModes: 'platform.keybindingsRegistry' };

_registry_common_platform_js__WEBPACK_IMPORTED_MODULE_3__["Registry"].add(Extensions.EditorModes, KeybindingsRegistry);
function sorter(a, b) {
    if (a.weight1 !== b.weight1) {
        return a.weight1 - b.weight1;
    }
    if (a.command < b.command) {
        return -1;
    }
    if (a.command > b.command) {
        return 1;
    }
    return a.weight2 - b.weight2;
}

/***/ }),

/***/ 6235:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "KeyCodeUtils", function() { return KeyCodeUtils; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "KeyChord", function() { return KeyChord; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "createKeybinding", function() { return createKeybinding; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "createSimpleKeybinding", function() { return createSimpleKeybinding; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SimpleKeybinding", function() { return SimpleKeybinding; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ChordKeybinding", function() { return ChordKeybinding; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ResolvedKeybindingPart", function() { return ResolvedKeybindingPart; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ResolvedKeybinding", function() { return ResolvedKeybinding; });
/* harmony import */ var _errors_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6214);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/

var KeyCodeStrMap = /** @class */function () {
    function KeyCodeStrMap() {
        this._keyCodeToStr = [];
        this._strToKeyCode = Object.create(null);
    }
    KeyCodeStrMap.prototype.define = function (keyCode, str) {
        this._keyCodeToStr[keyCode] = str;
        this._strToKeyCode[str.toLowerCase()] = keyCode;
    };
    KeyCodeStrMap.prototype.keyCodeToStr = function (keyCode) {
        return this._keyCodeToStr[keyCode];
    };
    KeyCodeStrMap.prototype.strToKeyCode = function (str) {
        return this._strToKeyCode[str.toLowerCase()] || 0 /* Unknown */;
    };
    return KeyCodeStrMap;
}();
var uiMap = new KeyCodeStrMap();
var userSettingsUSMap = new KeyCodeStrMap();
var userSettingsGeneralMap = new KeyCodeStrMap();
(function () {
    function define(keyCode, uiLabel, usUserSettingsLabel, generalUserSettingsLabel) {
        if (usUserSettingsLabel === void 0) {usUserSettingsLabel = uiLabel;}
        if (generalUserSettingsLabel === void 0) {generalUserSettingsLabel = usUserSettingsLabel;}
        uiMap.define(keyCode, uiLabel);
        userSettingsUSMap.define(keyCode, usUserSettingsLabel);
        userSettingsGeneralMap.define(keyCode, generalUserSettingsLabel);
    }
    define(0 /* Unknown */, 'unknown');
    define(1 /* Backspace */, 'Backspace');
    define(2 /* Tab */, 'Tab');
    define(3 /* Enter */, 'Enter');
    define(4 /* Shift */, 'Shift');
    define(5 /* Ctrl */, 'Ctrl');
    define(6 /* Alt */, 'Alt');
    define(7 /* PauseBreak */, 'PauseBreak');
    define(8 /* CapsLock */, 'CapsLock');
    define(9 /* Escape */, 'Escape');
    define(10 /* Space */, 'Space');
    define(11 /* PageUp */, 'PageUp');
    define(12 /* PageDown */, 'PageDown');
    define(13 /* End */, 'End');
    define(14 /* Home */, 'Home');
    define(15 /* LeftArrow */, 'LeftArrow', 'Left');
    define(16 /* UpArrow */, 'UpArrow', 'Up');
    define(17 /* RightArrow */, 'RightArrow', 'Right');
    define(18 /* DownArrow */, 'DownArrow', 'Down');
    define(19 /* Insert */, 'Insert');
    define(20 /* Delete */, 'Delete');
    define(21 /* KEY_0 */, '0');
    define(22 /* KEY_1 */, '1');
    define(23 /* KEY_2 */, '2');
    define(24 /* KEY_3 */, '3');
    define(25 /* KEY_4 */, '4');
    define(26 /* KEY_5 */, '5');
    define(27 /* KEY_6 */, '6');
    define(28 /* KEY_7 */, '7');
    define(29 /* KEY_8 */, '8');
    define(30 /* KEY_9 */, '9');
    define(31 /* KEY_A */, 'A');
    define(32 /* KEY_B */, 'B');
    define(33 /* KEY_C */, 'C');
    define(34 /* KEY_D */, 'D');
    define(35 /* KEY_E */, 'E');
    define(36 /* KEY_F */, 'F');
    define(37 /* KEY_G */, 'G');
    define(38 /* KEY_H */, 'H');
    define(39 /* KEY_I */, 'I');
    define(40 /* KEY_J */, 'J');
    define(41 /* KEY_K */, 'K');
    define(42 /* KEY_L */, 'L');
    define(43 /* KEY_M */, 'M');
    define(44 /* KEY_N */, 'N');
    define(45 /* KEY_O */, 'O');
    define(46 /* KEY_P */, 'P');
    define(47 /* KEY_Q */, 'Q');
    define(48 /* KEY_R */, 'R');
    define(49 /* KEY_S */, 'S');
    define(50 /* KEY_T */, 'T');
    define(51 /* KEY_U */, 'U');
    define(52 /* KEY_V */, 'V');
    define(53 /* KEY_W */, 'W');
    define(54 /* KEY_X */, 'X');
    define(55 /* KEY_Y */, 'Y');
    define(56 /* KEY_Z */, 'Z');
    define(57 /* Meta */, 'Meta');
    define(58 /* ContextMenu */, 'ContextMenu');
    define(59 /* F1 */, 'F1');
    define(60 /* F2 */, 'F2');
    define(61 /* F3 */, 'F3');
    define(62 /* F4 */, 'F4');
    define(63 /* F5 */, 'F5');
    define(64 /* F6 */, 'F6');
    define(65 /* F7 */, 'F7');
    define(66 /* F8 */, 'F8');
    define(67 /* F9 */, 'F9');
    define(68 /* F10 */, 'F10');
    define(69 /* F11 */, 'F11');
    define(70 /* F12 */, 'F12');
    define(71 /* F13 */, 'F13');
    define(72 /* F14 */, 'F14');
    define(73 /* F15 */, 'F15');
    define(74 /* F16 */, 'F16');
    define(75 /* F17 */, 'F17');
    define(76 /* F18 */, 'F18');
    define(77 /* F19 */, 'F19');
    define(78 /* NumLock */, 'NumLock');
    define(79 /* ScrollLock */, 'ScrollLock');
    define(80 /* US_SEMICOLON */, ';', ';', 'OEM_1');
    define(81 /* US_EQUAL */, '=', '=', 'OEM_PLUS');
    define(82 /* US_COMMA */, ',', ',', 'OEM_COMMA');
    define(83 /* US_MINUS */, '-', '-', 'OEM_MINUS');
    define(84 /* US_DOT */, '.', '.', 'OEM_PERIOD');
    define(85 /* US_SLASH */, '/', '/', 'OEM_2');
    define(86 /* US_BACKTICK */, '`', '`', 'OEM_3');
    define(110 /* ABNT_C1 */, 'ABNT_C1');
    define(111 /* ABNT_C2 */, 'ABNT_C2');
    define(87 /* US_OPEN_SQUARE_BRACKET */, '[', '[', 'OEM_4');
    define(88 /* US_BACKSLASH */, '\\', '\\', 'OEM_5');
    define(89 /* US_CLOSE_SQUARE_BRACKET */, ']', ']', 'OEM_6');
    define(90 /* US_QUOTE */, '\'', '\'', 'OEM_7');
    define(91 /* OEM_8 */, 'OEM_8');
    define(92 /* OEM_102 */, 'OEM_102');
    define(93 /* NUMPAD_0 */, 'NumPad0');
    define(94 /* NUMPAD_1 */, 'NumPad1');
    define(95 /* NUMPAD_2 */, 'NumPad2');
    define(96 /* NUMPAD_3 */, 'NumPad3');
    define(97 /* NUMPAD_4 */, 'NumPad4');
    define(98 /* NUMPAD_5 */, 'NumPad5');
    define(99 /* NUMPAD_6 */, 'NumPad6');
    define(100 /* NUMPAD_7 */, 'NumPad7');
    define(101 /* NUMPAD_8 */, 'NumPad8');
    define(102 /* NUMPAD_9 */, 'NumPad9');
    define(103 /* NUMPAD_MULTIPLY */, 'NumPad_Multiply');
    define(104 /* NUMPAD_ADD */, 'NumPad_Add');
    define(105 /* NUMPAD_SEPARATOR */, 'NumPad_Separator');
    define(106 /* NUMPAD_SUBTRACT */, 'NumPad_Subtract');
    define(107 /* NUMPAD_DECIMAL */, 'NumPad_Decimal');
    define(108 /* NUMPAD_DIVIDE */, 'NumPad_Divide');
})();
var KeyCodeUtils;
(function (KeyCodeUtils) {
    function toString(keyCode) {
        return uiMap.keyCodeToStr(keyCode);
    }
    KeyCodeUtils.toString = toString;
    function fromString(key) {
        return uiMap.strToKeyCode(key);
    }
    KeyCodeUtils.fromString = fromString;
    function toUserSettingsUS(keyCode) {
        return userSettingsUSMap.keyCodeToStr(keyCode);
    }
    KeyCodeUtils.toUserSettingsUS = toUserSettingsUS;
    function toUserSettingsGeneral(keyCode) {
        return userSettingsGeneralMap.keyCodeToStr(keyCode);
    }
    KeyCodeUtils.toUserSettingsGeneral = toUserSettingsGeneral;
    function fromUserSettings(key) {
        return userSettingsUSMap.strToKeyCode(key) || userSettingsGeneralMap.strToKeyCode(key);
    }
    KeyCodeUtils.fromUserSettings = fromUserSettings;
})(KeyCodeUtils || (KeyCodeUtils = {}));
function KeyChord(firstPart, secondPart) {
    var chordPart = (secondPart & 0x0000FFFF) << 16 >>> 0;
    return (firstPart | chordPart) >>> 0;
}
function createKeybinding(keybinding, OS) {
    if (keybinding === 0) {
        return null;
    }
    var firstPart = (keybinding & 0x0000FFFF) >>> 0;
    var chordPart = (keybinding & 0xFFFF0000) >>> 16;
    if (chordPart !== 0) {
        return new ChordKeybinding([
        createSimpleKeybinding(firstPart, OS),
        createSimpleKeybinding(chordPart, OS)]);

    }
    return new ChordKeybinding([createSimpleKeybinding(firstPart, OS)]);
}
function createSimpleKeybinding(keybinding, OS) {
    var ctrlCmd = keybinding & 2048 /* CtrlCmd */ ? true : false;
    var winCtrl = keybinding & 256 /* WinCtrl */ ? true : false;
    var ctrlKey = OS === 2 /* Macintosh */ ? winCtrl : ctrlCmd;
    var shiftKey = keybinding & 1024 /* Shift */ ? true : false;
    var altKey = keybinding & 512 /* Alt */ ? true : false;
    var metaKey = OS === 2 /* Macintosh */ ? ctrlCmd : winCtrl;
    var keyCode = keybinding & 255 /* KeyCode */;
    return new SimpleKeybinding(ctrlKey, shiftKey, altKey, metaKey, keyCode);
}
var SimpleKeybinding = /** @class */function () {
    function SimpleKeybinding(ctrlKey, shiftKey, altKey, metaKey, keyCode) {
        this.ctrlKey = ctrlKey;
        this.shiftKey = shiftKey;
        this.altKey = altKey;
        this.metaKey = metaKey;
        this.keyCode = keyCode;
    }
    SimpleKeybinding.prototype.equals = function (other) {
        return this.ctrlKey === other.ctrlKey &&
        this.shiftKey === other.shiftKey &&
        this.altKey === other.altKey &&
        this.metaKey === other.metaKey &&
        this.keyCode === other.keyCode;
    };
    SimpleKeybinding.prototype.isModifierKey = function () {
        return this.keyCode === 0 /* Unknown */ ||
        this.keyCode === 5 /* Ctrl */ ||
        this.keyCode === 57 /* Meta */ ||
        this.keyCode === 6 /* Alt */ ||
        this.keyCode === 4 /* Shift */;
    };
    SimpleKeybinding.prototype.toChord = function () {
        return new ChordKeybinding([this]);
    };
    /**
        * Does this keybinding refer to the key code of a modifier and it also has the modifier flag?
        */
    SimpleKeybinding.prototype.isDuplicateModifierCase = function () {
        return this.ctrlKey && this.keyCode === 5 /* Ctrl */ ||
        this.shiftKey && this.keyCode === 4 /* Shift */ ||
        this.altKey && this.keyCode === 6 /* Alt */ ||
        this.metaKey && this.keyCode === 57 /* Meta */;
    };
    return SimpleKeybinding;
}();

var ChordKeybinding = /** @class */function () {
    function ChordKeybinding(parts) {
        if (parts.length === 0) {
            throw Object(_errors_js__WEBPACK_IMPORTED_MODULE_0__["illegalArgument"])("parts");
        }
        this.parts = parts;
    }
    ChordKeybinding.prototype.equals = function (other) {
        if (other === null) {
            return false;
        }
        if (this.parts.length !== other.parts.length) {
            return false;
        }
        for (var i = 0; i < this.parts.length; i++) {
            if (!this.parts[i].equals(other.parts[i])) {
                return false;
            }
        }
        return true;
    };
    return ChordKeybinding;
}();

var ResolvedKeybindingPart = /** @class */function () {
    function ResolvedKeybindingPart(ctrlKey, shiftKey, altKey, metaKey, kbLabel, kbAriaLabel) {
        this.ctrlKey = ctrlKey;
        this.shiftKey = shiftKey;
        this.altKey = altKey;
        this.metaKey = metaKey;
        this.keyLabel = kbLabel;
        this.keyAriaLabel = kbAriaLabel;
    }
    return ResolvedKeybindingPart;
}();

/**
                                    * A resolved keybinding. Can be a simple keybinding or a chord keybinding.
                                    */
var ResolvedKeybinding = /** @class */function () {
    function ResolvedKeybinding() {
    }
    return ResolvedKeybinding;
}();


/***/ }),

/***/ 6236:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Registry", function() { return Registry; });
/* harmony import */ var _base_common_types_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6232);
/* harmony import */ var _base_common_assert_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6237);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/


var RegistryImpl = /** @class */function () {
    function RegistryImpl() {
        this.data = new Map();
    }
    RegistryImpl.prototype.add = function (id, data) {
        _base_common_assert_js__WEBPACK_IMPORTED_MODULE_1__["ok"](_base_common_types_js__WEBPACK_IMPORTED_MODULE_0__["isString"](id));
        _base_common_assert_js__WEBPACK_IMPORTED_MODULE_1__["ok"](_base_common_types_js__WEBPACK_IMPORTED_MODULE_0__["isObject"](data));
        _base_common_assert_js__WEBPACK_IMPORTED_MODULE_1__["ok"](!this.data.has(id), 'There is already an extension with this id');
        this.data.set(id, data);
    };
    RegistryImpl.prototype.as = function (id) {
        return this.data.get(id) || null;
    };
    return RegistryImpl;
}();
var Registry = new RegistryImpl();

/***/ }),

/***/ 6237:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ok", function() { return ok; });
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
/**
                                                                                                  * Throws an error with the provided message if the provided value does not evaluate to a true Javascript value.
                                                                                                  */
function ok(value, message) {
  if (!value) {
    throw new Error(message ? 'Assertion failed (' + message + ')' : 'Assertion Failed');
  }
}

/***/ }),

/***/ 6238:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ITelemetryService", function() { return ITelemetryService; });
/* harmony import */ var _instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6224);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/

var ITelemetryService = Object(_instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_0__["createDecorator"])('telemetryService');

/***/ }),

/***/ 6242:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Selection", function() { return Selection; });
/* harmony import */ var _position_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6225);
/* harmony import */ var _range_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6243);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __extends = undefined && undefined.__extends || function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
        { __proto__: [] } instanceof Array && function (d, b) {d.__proto__ = b;} ||
        function (d, b) {for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];};
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {this.constructor = d;}
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();


/**
                                     * A selection in the editor.
                                     * The selection is a range that has an orientation.
                                     */
var Selection = /** @class */function (_super) {
    __extends(Selection, _super);
    function Selection(selectionStartLineNumber, selectionStartColumn, positionLineNumber, positionColumn) {
        var _this = _super.call(this, selectionStartLineNumber, selectionStartColumn, positionLineNumber, positionColumn) || this;
        _this.selectionStartLineNumber = selectionStartLineNumber;
        _this.selectionStartColumn = selectionStartColumn;
        _this.positionLineNumber = positionLineNumber;
        _this.positionColumn = positionColumn;
        return _this;
    }
    /**
       * Transform to a human-readable representation.
       */
    Selection.prototype.toString = function () {
        return '[' + this.selectionStartLineNumber + ',' + this.selectionStartColumn + ' -> ' + this.positionLineNumber + ',' + this.positionColumn + ']';
    };
    /**
        * Test if equals other selection.
        */
    Selection.prototype.equalsSelection = function (other) {
        return Selection.selectionsEqual(this, other);
    };
    /**
        * Test if the two selections are equal.
        */
    Selection.selectionsEqual = function (a, b) {
        return a.selectionStartLineNumber === b.selectionStartLineNumber &&
        a.selectionStartColumn === b.selectionStartColumn &&
        a.positionLineNumber === b.positionLineNumber &&
        a.positionColumn === b.positionColumn;
    };
    /**
        * Get directions (LTR or RTL).
        */
    Selection.prototype.getDirection = function () {
        if (this.selectionStartLineNumber === this.startLineNumber && this.selectionStartColumn === this.startColumn) {
            return 0 /* LTR */;
        }
        return 1 /* RTL */;
    };
    /**
        * Create a new selection with a different `positionLineNumber` and `positionColumn`.
        */
    Selection.prototype.setEndPosition = function (endLineNumber, endColumn) {
        if (this.getDirection() === 0 /* LTR */) {
                return new Selection(this.startLineNumber, this.startColumn, endLineNumber, endColumn);
            }
        return new Selection(endLineNumber, endColumn, this.startLineNumber, this.startColumn);
    };
    /**
        * Get the position at `positionLineNumber` and `positionColumn`.
        */
    Selection.prototype.getPosition = function () {
        return new _position_js__WEBPACK_IMPORTED_MODULE_0__["Position"](this.positionLineNumber, this.positionColumn);
    };
    /**
        * Create a new selection with a different `selectionStartLineNumber` and `selectionStartColumn`.
        */
    Selection.prototype.setStartPosition = function (startLineNumber, startColumn) {
        if (this.getDirection() === 0 /* LTR */) {
                return new Selection(startLineNumber, startColumn, this.endLineNumber, this.endColumn);
            }
        return new Selection(this.endLineNumber, this.endColumn, startLineNumber, startColumn);
    };
    // ----
    /**
     * Create a `Selection` from one or two positions
     */
    Selection.fromPositions = function (start, end) {
        if (end === void 0) {end = start;}
        return new Selection(start.lineNumber, start.column, end.lineNumber, end.column);
    };
    /**
        * Create a `Selection` from an `ISelection`.
        */
    Selection.liftSelection = function (sel) {
        return new Selection(sel.selectionStartLineNumber, sel.selectionStartColumn, sel.positionLineNumber, sel.positionColumn);
    };
    /**
        * `a` equals `b`.
        */
    Selection.selectionsArrEqual = function (a, b) {
        if (a && !b || !a && b) {
            return false;
        }
        if (!a && !b) {
            return true;
        }
        if (a.length !== b.length) {
            return false;
        }
        for (var i = 0, len = a.length; i < len; i++) {
            if (!this.selectionsEqual(a[i], b[i])) {
                return false;
            }
        }
        return true;
    };
    /**
        * Test if `obj` is an `ISelection`.
        */
    Selection.isISelection = function (obj) {
        return obj &&
        typeof obj.selectionStartLineNumber === 'number' &&
        typeof obj.selectionStartColumn === 'number' &&
        typeof obj.positionLineNumber === 'number' &&
        typeof obj.positionColumn === 'number';
    };
    /**
        * Create with a direction.
        */
    Selection.createWithDirection = function (startLineNumber, startColumn, endLineNumber, endColumn, direction) {
        if (direction === 0 /* LTR */) {
                return new Selection(startLineNumber, startColumn, endLineNumber, endColumn);
            }
        return new Selection(endLineNumber, endColumn, startLineNumber, startColumn);
    };
    return Selection;
}(_range_js__WEBPACK_IMPORTED_MODULE_1__["Range"]);


/***/ }),

/***/ 6243:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Range", function() { return Range; });
/* harmony import */ var _position_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6225);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/

/**
                                           * A range in the editor. (startLineNumber,startColumn) is <= (endLineNumber,endColumn)
                                           */
var Range = /** @class */function () {
    function Range(startLineNumber, startColumn, endLineNumber, endColumn) {
        if (startLineNumber > endLineNumber || startLineNumber === endLineNumber && startColumn > endColumn) {
            this.startLineNumber = endLineNumber;
            this.startColumn = endColumn;
            this.endLineNumber = startLineNumber;
            this.endColumn = startColumn;
        } else
        {
            this.startLineNumber = startLineNumber;
            this.startColumn = startColumn;
            this.endLineNumber = endLineNumber;
            this.endColumn = endColumn;
        }
    }
    /**
       * Test if this range is empty.
       */
    Range.prototype.isEmpty = function () {
        return Range.isEmpty(this);
    };
    /**
        * Test if `range` is empty.
        */
    Range.isEmpty = function (range) {
        return range.startLineNumber === range.endLineNumber && range.startColumn === range.endColumn;
    };
    /**
        * Test if position is in this range. If the position is at the edges, will return true.
        */
    Range.prototype.containsPosition = function (position) {
        return Range.containsPosition(this, position);
    };
    /**
        * Test if `position` is in `range`. If the position is at the edges, will return true.
        */
    Range.containsPosition = function (range, position) {
        if (position.lineNumber < range.startLineNumber || position.lineNumber > range.endLineNumber) {
            return false;
        }
        if (position.lineNumber === range.startLineNumber && position.column < range.startColumn) {
            return false;
        }
        if (position.lineNumber === range.endLineNumber && position.column > range.endColumn) {
            return false;
        }
        return true;
    };
    /**
        * Test if range is in this range. If the range is equal to this range, will return true.
        */
    Range.prototype.containsRange = function (range) {
        return Range.containsRange(this, range);
    };
    /**
        * Test if `otherRange` is in `range`. If the ranges are equal, will return true.
        */
    Range.containsRange = function (range, otherRange) {
        if (otherRange.startLineNumber < range.startLineNumber || otherRange.endLineNumber < range.startLineNumber) {
            return false;
        }
        if (otherRange.startLineNumber > range.endLineNumber || otherRange.endLineNumber > range.endLineNumber) {
            return false;
        }
        if (otherRange.startLineNumber === range.startLineNumber && otherRange.startColumn < range.startColumn) {
            return false;
        }
        if (otherRange.endLineNumber === range.endLineNumber && otherRange.endColumn > range.endColumn) {
            return false;
        }
        return true;
    };
    /**
        * Test if `range` is strictly in this range. `range` must start after and end before this range for the result to be true.
        */
    Range.prototype.strictContainsRange = function (range) {
        return Range.strictContainsRange(this, range);
    };
    /**
        * Test if `otherRange` is strinctly in `range` (must start after, and end before). If the ranges are equal, will return false.
        */
    Range.strictContainsRange = function (range, otherRange) {
        if (otherRange.startLineNumber < range.startLineNumber || otherRange.endLineNumber < range.startLineNumber) {
            return false;
        }
        if (otherRange.startLineNumber > range.endLineNumber || otherRange.endLineNumber > range.endLineNumber) {
            return false;
        }
        if (otherRange.startLineNumber === range.startLineNumber && otherRange.startColumn <= range.startColumn) {
            return false;
        }
        if (otherRange.endLineNumber === range.endLineNumber && otherRange.endColumn >= range.endColumn) {
            return false;
        }
        return true;
    };
    /**
        * A reunion of the two ranges.
        * The smallest position will be used as the start point, and the largest one as the end point.
        */
    Range.prototype.plusRange = function (range) {
        return Range.plusRange(this, range);
    };
    /**
        * A reunion of the two ranges.
        * The smallest position will be used as the start point, and the largest one as the end point.
        */
    Range.plusRange = function (a, b) {
        var startLineNumber;
        var startColumn;
        var endLineNumber;
        var endColumn;
        if (b.startLineNumber < a.startLineNumber) {
            startLineNumber = b.startLineNumber;
            startColumn = b.startColumn;
        } else
        if (b.startLineNumber === a.startLineNumber) {
            startLineNumber = b.startLineNumber;
            startColumn = Math.min(b.startColumn, a.startColumn);
        } else
        {
            startLineNumber = a.startLineNumber;
            startColumn = a.startColumn;
        }
        if (b.endLineNumber > a.endLineNumber) {
            endLineNumber = b.endLineNumber;
            endColumn = b.endColumn;
        } else
        if (b.endLineNumber === a.endLineNumber) {
            endLineNumber = b.endLineNumber;
            endColumn = Math.max(b.endColumn, a.endColumn);
        } else
        {
            endLineNumber = a.endLineNumber;
            endColumn = a.endColumn;
        }
        return new Range(startLineNumber, startColumn, endLineNumber, endColumn);
    };
    /**
        * A intersection of the two ranges.
        */
    Range.prototype.intersectRanges = function (range) {
        return Range.intersectRanges(this, range);
    };
    /**
        * A intersection of the two ranges.
        */
    Range.intersectRanges = function (a, b) {
        var resultStartLineNumber = a.startLineNumber;
        var resultStartColumn = a.startColumn;
        var resultEndLineNumber = a.endLineNumber;
        var resultEndColumn = a.endColumn;
        var otherStartLineNumber = b.startLineNumber;
        var otherStartColumn = b.startColumn;
        var otherEndLineNumber = b.endLineNumber;
        var otherEndColumn = b.endColumn;
        if (resultStartLineNumber < otherStartLineNumber) {
            resultStartLineNumber = otherStartLineNumber;
            resultStartColumn = otherStartColumn;
        } else
        if (resultStartLineNumber === otherStartLineNumber) {
            resultStartColumn = Math.max(resultStartColumn, otherStartColumn);
        }
        if (resultEndLineNumber > otherEndLineNumber) {
            resultEndLineNumber = otherEndLineNumber;
            resultEndColumn = otherEndColumn;
        } else
        if (resultEndLineNumber === otherEndLineNumber) {
            resultEndColumn = Math.min(resultEndColumn, otherEndColumn);
        }
        // Check if selection is now empty
        if (resultStartLineNumber > resultEndLineNumber) {
            return null;
        }
        if (resultStartLineNumber === resultEndLineNumber && resultStartColumn > resultEndColumn) {
            return null;
        }
        return new Range(resultStartLineNumber, resultStartColumn, resultEndLineNumber, resultEndColumn);
    };
    /**
        * Test if this range equals other.
        */
    Range.prototype.equalsRange = function (other) {
        return Range.equalsRange(this, other);
    };
    /**
        * Test if range `a` equals `b`.
        */
    Range.equalsRange = function (a, b) {
        return !!a &&
        !!b &&
        a.startLineNumber === b.startLineNumber &&
        a.startColumn === b.startColumn &&
        a.endLineNumber === b.endLineNumber &&
        a.endColumn === b.endColumn;
    };
    /**
        * Return the end position (which will be after or equal to the start position)
        */
    Range.prototype.getEndPosition = function () {
        return new _position_js__WEBPACK_IMPORTED_MODULE_0__["Position"](this.endLineNumber, this.endColumn);
    };
    /**
        * Return the start position (which will be before or equal to the end position)
        */
    Range.prototype.getStartPosition = function () {
        return new _position_js__WEBPACK_IMPORTED_MODULE_0__["Position"](this.startLineNumber, this.startColumn);
    };
    /**
        * Transform to a user presentable string representation.
        */
    Range.prototype.toString = function () {
        return '[' + this.startLineNumber + ',' + this.startColumn + ' -> ' + this.endLineNumber + ',' + this.endColumn + ']';
    };
    /**
        * Create a new range using this range's start position, and using endLineNumber and endColumn as the end position.
        */
    Range.prototype.setEndPosition = function (endLineNumber, endColumn) {
        return new Range(this.startLineNumber, this.startColumn, endLineNumber, endColumn);
    };
    /**
        * Create a new range using this range's end position, and using startLineNumber and startColumn as the start position.
        */
    Range.prototype.setStartPosition = function (startLineNumber, startColumn) {
        return new Range(startLineNumber, startColumn, this.endLineNumber, this.endColumn);
    };
    /**
        * Create a new empty range using this range's start position.
        */
    Range.prototype.collapseToStart = function () {
        return Range.collapseToStart(this);
    };
    /**
        * Create a new empty range using this range's start position.
        */
    Range.collapseToStart = function (range) {
        return new Range(range.startLineNumber, range.startColumn, range.startLineNumber, range.startColumn);
    };
    // ---
    Range.fromPositions = function (start, end) {
        if (end === void 0) {end = start;}
        return new Range(start.lineNumber, start.column, end.lineNumber, end.column);
    };
    Range.lift = function (range) {
        if (!range) {
            return null;
        }
        return new Range(range.startLineNumber, range.startColumn, range.endLineNumber, range.endColumn);
    };
    /**
        * Test if `obj` is an `IRange`.
        */
    Range.isIRange = function (obj) {
        return obj &&
        typeof obj.startLineNumber === 'number' &&
        typeof obj.startColumn === 'number' &&
        typeof obj.endLineNumber === 'number' &&
        typeof obj.endColumn === 'number';
    };
    /**
        * Test if the two ranges are touching in any way.
        */
    Range.areIntersectingOrTouching = function (a, b) {
        // Check if `a` is before `b`
        if (a.endLineNumber < b.startLineNumber || a.endLineNumber === b.startLineNumber && a.endColumn < b.startColumn) {
            return false;
        }
        // Check if `b` is before `a`
        if (b.endLineNumber < a.startLineNumber || b.endLineNumber === a.startLineNumber && b.endColumn < a.startColumn) {
            return false;
        }
        // These ranges must intersect
        return true;
    };
    /**
        * Test if the two ranges are intersecting. If the ranges are touching it returns true.
        */
    Range.areIntersecting = function (a, b) {
        // Check if `a` is before `b`
        if (a.endLineNumber < b.startLineNumber || a.endLineNumber === b.startLineNumber && a.endColumn <= b.startColumn) {
            return false;
        }
        // Check if `b` is before `a`
        if (b.endLineNumber < a.startLineNumber || b.endLineNumber === a.startLineNumber && b.endColumn <= a.startColumn) {
            return false;
        }
        // These ranges must intersect
        return true;
    };
    /**
        * A function that compares ranges, useful for sorting ranges
        * It will first compare ranges on the startPosition and then on the endPosition
        */
    Range.compareRangesUsingStarts = function (a, b) {
        if (a && b) {
            var aStartLineNumber = a.startLineNumber | 0;
            var bStartLineNumber = b.startLineNumber | 0;
            if (aStartLineNumber === bStartLineNumber) {
                var aStartColumn = a.startColumn | 0;
                var bStartColumn = b.startColumn | 0;
                if (aStartColumn === bStartColumn) {
                    var aEndLineNumber = a.endLineNumber | 0;
                    var bEndLineNumber = b.endLineNumber | 0;
                    if (aEndLineNumber === bEndLineNumber) {
                        var aEndColumn = a.endColumn | 0;
                        var bEndColumn = b.endColumn | 0;
                        return aEndColumn - bEndColumn;
                    }
                    return aEndLineNumber - bEndLineNumber;
                }
                return aStartColumn - bStartColumn;
            }
            return aStartLineNumber - bStartLineNumber;
        }
        var aExists = a ? 1 : 0;
        var bExists = b ? 1 : 0;
        return aExists - bExists;
    };
    /**
        * A function that compares ranges, useful for sorting ranges
        * It will first compare ranges on the endPosition and then on the startPosition
        */
    Range.compareRangesUsingEnds = function (a, b) {
        if (a.endLineNumber === b.endLineNumber) {
            if (a.endColumn === b.endColumn) {
                if (a.startLineNumber === b.startLineNumber) {
                    return a.startColumn - b.startColumn;
                }
                return a.startLineNumber - b.startLineNumber;
            }
            return a.endColumn - b.endColumn;
        }
        return a.endLineNumber - b.endLineNumber;
    };
    /**
        * Test if the range spans multiple lines.
        */
    Range.spansMultipleLines = function (range) {
        return range.endLineNumber > range.startLineNumber;
    };
    return Range;
}();


/***/ }),

/***/ 6262:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "tail", function() { return tail; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "tail2", function() { return tail2; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "equals", function() { return equals; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "binarySearch", function() { return binarySearch; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "findFirstInSorted", function() { return findFirstInSorted; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "mergeSort", function() { return mergeSort; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "groupBy", function() { return groupBy; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "coalesce", function() { return coalesce; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isFalsyOrEmpty", function() { return isFalsyOrEmpty; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isNonEmptyArray", function() { return isNonEmptyArray; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "distinct", function() { return distinct; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "distinctES6", function() { return distinctES6; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fromSet", function() { return fromSet; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "firstIndex", function() { return firstIndex; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "first", function() { return first; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "firstOrDefault", function() { return firstOrDefault; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "flatten", function() { return flatten; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "range", function() { return range; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "arrayInsert", function() { return arrayInsert; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "pushToStart", function() { return pushToStart; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "pushToEnd", function() { return pushToEnd; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "find", function() { return find; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "asArray", function() { return asArray; });
/**
 * Returns the last element of an array.
 * @param array The array.
 * @param n Which element from the end (default is zero).
 */
function tail(array, n) {
    if (n === void 0) {n = 0;}
    return array[array.length - (1 + n)];
}
function tail2(arr) {
    if (arr.length === 0) {
        throw new Error('Invalid tail call');
    }
    return [arr.slice(0, arr.length - 1), arr[arr.length - 1]];
}
function equals(one, other, itemEquals) {
    if (itemEquals === void 0) {itemEquals = function (a, b) {return a === b;};}
    if (one === other) {
        return true;
    }
    if (!one || !other) {
        return false;
    }
    if (one.length !== other.length) {
        return false;
    }
    for (var i = 0, len = one.length; i < len; i++) {
        if (!itemEquals(one[i], other[i])) {
            return false;
        }
    }
    return true;
}
function binarySearch(array, key, comparator) {
    var low = 0,high = array.length - 1;
    while (low <= high) {
        var mid = (low + high) / 2 | 0;
        var comp = comparator(array[mid], key);
        if (comp < 0) {
            low = mid + 1;
        } else
        if (comp > 0) {
            high = mid - 1;
        } else
        {
            return mid;
        }
    }
    return -(low + 1);
}
/**
   * Takes a sorted array and a function p. The array is sorted in such a way that all elements where p(x) is false
   * are located before all elements where p(x) is true.
   * @returns the least x for which p(x) is true or array.length if no element fullfills the given function.
   */
function findFirstInSorted(array, p) {
    var low = 0,high = array.length;
    if (high === 0) {
        return 0; // no children
    }
    while (low < high) {
        var mid = Math.floor((low + high) / 2);
        if (p(array[mid])) {
            high = mid;
        } else
        {
            low = mid + 1;
        }
    }
    return low;
}
/**
   * Like `Array#sort` but always stable. Usually runs a little slower `than Array#sort`
   * so only use this when actually needing stable sort.
   */
function mergeSort(data, compare) {
    _sort(data, compare, 0, data.length - 1, []);
    return data;
}
function _merge(a, compare, lo, mid, hi, aux) {
    var leftIdx = lo,rightIdx = mid + 1;
    for (var i = lo; i <= hi; i++) {
        aux[i] = a[i];
    }
    for (var i = lo; i <= hi; i++) {
        if (leftIdx > mid) {
            // left side consumed
            a[i] = aux[rightIdx++];
        } else
        if (rightIdx > hi) {
            // right side consumed
            a[i] = aux[leftIdx++];
        } else
        if (compare(aux[rightIdx], aux[leftIdx]) < 0) {
            // right element is less -> comes first
            a[i] = aux[rightIdx++];
        } else
        {
            // left element comes first (less or equal)
            a[i] = aux[leftIdx++];
        }
    }
}
function _sort(a, compare, lo, hi, aux) {
    if (hi <= lo) {
        return;
    }
    var mid = lo + (hi - lo) / 2 | 0;
    _sort(a, compare, lo, mid, aux);
    _sort(a, compare, mid + 1, hi, aux);
    if (compare(a[mid], a[mid + 1]) <= 0) {
        // left and right are sorted and if the last-left element is less
        // or equals than the first-right element there is nothing else
        // to do
        return;
    }
    _merge(a, compare, lo, mid, hi, aux);
}
function groupBy(data, compare) {
    var result = [];
    var currentGroup = undefined;
    for (var _i = 0, _a = mergeSort(data.slice(0), compare); _i < _a.length; _i++) {
        var element = _a[_i];
        if (!currentGroup || compare(currentGroup[0], element) !== 0) {
            currentGroup = [element];
            result.push(currentGroup);
        } else
        {
            currentGroup.push(element);
        }
    }
    return result;
}
/**
   * @returns New array with all falsy values removed. The original array IS NOT modified.
   */
function coalesce(array) {
    return array.filter(function (e) {return !!e;});
}
/**
   * @returns false if the provided object is an array and not empty.
   */
function isFalsyOrEmpty(obj) {
    return !Array.isArray(obj) || obj.length === 0;
}
function isNonEmptyArray(obj) {
    return Array.isArray(obj) && obj.length > 0;
}
/**
   * Removes duplicates from the given array. The optional keyFn allows to specify
   * how elements are checked for equalness by returning a unique string for each.
   */
function distinct(array, keyFn) {
    if (!keyFn) {
        return array.filter(function (element, position) {
            return array.indexOf(element) === position;
        });
    }
    var seen = Object.create(null);
    return array.filter(function (elem) {
        var key = keyFn(elem);
        if (seen[key]) {
            return false;
        }
        seen[key] = true;
        return true;
    });
}
function distinctES6(array) {
    var seen = new Set();
    return array.filter(function (element) {
        if (seen.has(element)) {
            return false;
        }
        seen.add(element);
        return true;
    });
}
function fromSet(set) {
    var result = [];
    set.forEach(function (o) {return result.push(o);});
    return result;
}
function firstIndex(array, fn) {
    for (var i = 0; i < array.length; i++) {
        var element = array[i];
        if (fn(element)) {
            return i;
        }
    }
    return -1;
}
function first(array, fn, notFoundValue) {
    if (notFoundValue === void 0) {notFoundValue = undefined;}
    var index = firstIndex(array, fn);
    return index < 0 ? notFoundValue : array[index];
}
function firstOrDefault(array, notFoundValue) {
    return array.length > 0 ? array[0] : notFoundValue;
}
function flatten(arr) {
    var _a;
    return (_a = []).concat.apply(_a, arr);
}
function range(arg, to) {
    var from = typeof to === 'number' ? arg : 0;
    if (typeof to === 'number') {
        from = arg;
    } else
    {
        from = 0;
        to = arg;
    }
    var result = [];
    if (from <= to) {
        for (var i = from; i < to; i++) {
            result.push(i);
        }
    } else
    {
        for (var i = from; i > to; i--) {
            result.push(i);
        }
    }
    return result;
}
/**
   * Insert `insertArr` inside `target` at `insertIndex`.
   * Please don't touch unless you understand https://jsperf.com/inserting-an-array-within-an-array
   */
function arrayInsert(target, insertIndex, insertArr) {
    var before = target.slice(0, insertIndex);
    var after = target.slice(insertIndex);
    return before.concat(insertArr, after);
}
/**
   * Pushes an element to the start of the array, if found.
   */
function pushToStart(arr, value) {
    var index = arr.indexOf(value);
    if (index > -1) {
        arr.splice(index, 1);
        arr.unshift(value);
    }
}
/**
   * Pushes an element to the end of the array, if found.
   */
function pushToEnd(arr, value) {
    var index = arr.indexOf(value);
    if (index > -1) {
        arr.splice(index, 1);
        arr.push(value);
    }
}
function find(arr, predicate) {
    for (var i = 0; i < arr.length; i++) {
        var element = arr[i];
        if (predicate(element, i, arr)) {
            return element;
        }
    }
    return undefined;
}
function asArray(x) {
    return Array.isArray(x) ? x : [x];
}

/***/ }),

/***/ 6264:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LanguageIdentifier", function() { return LanguageIdentifier; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "TokenMetadata", function() { return TokenMetadata; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "completionKindToCssClass", function() { return completionKindToCssClass; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "completionKindFromString", function() { return completionKindFromString; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SignatureHelpTriggerKind", function() { return SignatureHelpTriggerKind; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DocumentHighlightKind", function() { return DocumentHighlightKind; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isLocationLink", function() { return isLocationLink; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SymbolKinds", function() { return SymbolKinds; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FoldingRangeKind", function() { return FoldingRangeKind; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "WorkspaceFileEdit", function() { return WorkspaceFileEdit; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "WorkspaceTextEdit", function() { return WorkspaceTextEdit; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ReferenceProviderRegistry", function() { return ReferenceProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "RenameProviderRegistry", function() { return RenameProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "CompletionProviderRegistry", function() { return CompletionProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SignatureHelpProviderRegistry", function() { return SignatureHelpProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "HoverProviderRegistry", function() { return HoverProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DocumentSymbolProviderRegistry", function() { return DocumentSymbolProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DocumentHighlightProviderRegistry", function() { return DocumentHighlightProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DefinitionProviderRegistry", function() { return DefinitionProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DeclarationProviderRegistry", function() { return DeclarationProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ImplementationProviderRegistry", function() { return ImplementationProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "TypeDefinitionProviderRegistry", function() { return TypeDefinitionProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "CodeLensProviderRegistry", function() { return CodeLensProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "CodeActionProviderRegistry", function() { return CodeActionProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DocumentFormattingEditProviderRegistry", function() { return DocumentFormattingEditProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DocumentRangeFormattingEditProviderRegistry", function() { return DocumentRangeFormattingEditProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "OnTypeFormattingEditProviderRegistry", function() { return OnTypeFormattingEditProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LinkProviderRegistry", function() { return LinkProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ColorProviderRegistry", function() { return ColorProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SelectionRangeRegistry", function() { return SelectionRangeRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FoldingRangeProviderRegistry", function() { return FoldingRangeProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DocumentSemanticTokensProviderRegistry", function() { return DocumentSemanticTokensProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DocumentRangeSemanticTokensProviderRegistry", function() { return DocumentRangeSemanticTokensProviderRegistry; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "TokenizationRegistry", function() { return TokenizationRegistry; });
/* harmony import */ var _base_common_types_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6232);
/* harmony import */ var _base_common_uri_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6221);
/* harmony import */ var _core_range_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6243);
/* harmony import */ var _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6265);
/* harmony import */ var _modes_tokenizationRegistry_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6271);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/





/**
                                                                             * @internal
                                                                             */
var LanguageIdentifier = /** @class */function () {
  function LanguageIdentifier(language, id) {
    this.language = language;
    this.id = id;
  }
  return LanguageIdentifier;
}();

/**
                                * @internal
                                */
var TokenMetadata = /** @class */function () {
  function TokenMetadata() {
  }
  TokenMetadata.getLanguageId = function (metadata) {
    return (metadata & 255 /* LANGUAGEID_MASK */) >>> 0 /* LANGUAGEID_OFFSET */;
  };
  TokenMetadata.getTokenType = function (metadata) {
    return (metadata & 1792 /* TOKEN_TYPE_MASK */) >>> 8 /* TOKEN_TYPE_OFFSET */;
  };
  TokenMetadata.getFontStyle = function (metadata) {
    return (metadata & 14336 /* FONT_STYLE_MASK */) >>> 11 /* FONT_STYLE_OFFSET */;
  };
  TokenMetadata.getForeground = function (metadata) {
    return (metadata & 8372224 /* FOREGROUND_MASK */) >>> 14 /* FOREGROUND_OFFSET */;
  };
  TokenMetadata.getBackground = function (metadata) {
    return (metadata & 4286578688 /* BACKGROUND_MASK */) >>> 23 /* BACKGROUND_OFFSET */;
  };
  TokenMetadata.getClassNameFromMetadata = function (metadata) {
    var foreground = this.getForeground(metadata);
    var className = 'mtk' + foreground;
    var fontStyle = this.getFontStyle(metadata);
    if (fontStyle & 1 /* Italic */) {
        className += ' mtki';
      }
    if (fontStyle & 2 /* Bold */) {
        className += ' mtkb';
      }
    if (fontStyle & 4 /* Underline */) {
        className += ' mtku';
      }
    return className;
  };
  TokenMetadata.getInlineStyleFromMetadata = function (metadata, colorMap) {
    var foreground = this.getForeground(metadata);
    var fontStyle = this.getFontStyle(metadata);
    var result = "color: " + colorMap[foreground] + ";";
    if (fontStyle & 1 /* Italic */) {
        result += 'font-style: italic;';
      }
    if (fontStyle & 2 /* Bold */) {
        result += 'font-weight: bold;';
      }
    if (fontStyle & 4 /* Underline */) {
        result += 'text-decoration: underline;';
      }
    return result;
  };
  return TokenMetadata;
}();

/**
                           * @internal
                           */
var completionKindToCssClass = function () {
  var data = Object.create(null);
  data[0 /* Method */] = 'method';
  data[1 /* Function */] = 'function';
  data[2 /* Constructor */] = 'constructor';
  data[3 /* Field */] = 'field';
  data[4 /* Variable */] = 'variable';
  data[5 /* Class */] = 'class';
  data[6 /* Struct */] = 'struct';
  data[7 /* Interface */] = 'interface';
  data[8 /* Module */] = 'module';
  data[9 /* Property */] = 'property';
  data[10 /* Event */] = 'event';
  data[11 /* Operator */] = 'operator';
  data[12 /* Unit */] = 'unit';
  data[13 /* Value */] = 'value';
  data[14 /* Constant */] = 'constant';
  data[15 /* Enum */] = 'enum';
  data[16 /* EnumMember */] = 'enum-member';
  data[17 /* Keyword */] = 'keyword';
  data[25 /* Snippet */] = 'snippet';
  data[18 /* Text */] = 'text';
  data[19 /* Color */] = 'color';
  data[20 /* File */] = 'file';
  data[21 /* Reference */] = 'reference';
  data[22 /* Customcolor */] = 'customcolor';
  data[23 /* Folder */] = 'folder';
  data[24 /* TypeParameter */] = 'type-parameter';
  return function (kind) {
    return data[kind] || 'property';
  };
}();
/**
      * @internal
      */
var completionKindFromString = function () {
  var data = Object.create(null);
  data['method'] = 0 /* Method */;
  data['function'] = 1 /* Function */;
  data['constructor'] = 2 /* Constructor */;
  data['field'] = 3 /* Field */;
  data['variable'] = 4 /* Variable */;
  data['class'] = 5 /* Class */;
  data['struct'] = 6 /* Struct */;
  data['interface'] = 7 /* Interface */;
  data['module'] = 8 /* Module */;
  data['property'] = 9 /* Property */;
  data['event'] = 10 /* Event */;
  data['operator'] = 11 /* Operator */;
  data['unit'] = 12 /* Unit */;
  data['value'] = 13 /* Value */;
  data['constant'] = 14 /* Constant */;
  data['enum'] = 15 /* Enum */;
  data['enum-member'] = 16 /* EnumMember */;
  data['enumMember'] = 16 /* EnumMember */;
  data['keyword'] = 17 /* Keyword */;
  data['snippet'] = 25 /* Snippet */;
  data['text'] = 18 /* Text */;
  data['color'] = 19 /* Color */;
  data['file'] = 20 /* File */;
  data['reference'] = 21 /* Reference */;
  data['customcolor'] = 22 /* Customcolor */;
  data['folder'] = 23 /* Folder */;
  data['type-parameter'] = 24 /* TypeParameter */;
  data['typeParameter'] = 24 /* TypeParameter */;
  return function (value, strict) {
    var res = data[value];
    if (typeof res === 'undefined' && !strict) {
      res = 9 /* Property */;
    }
    return res;
  };
}();
var SignatureHelpTriggerKind;
(function (SignatureHelpTriggerKind) {
  SignatureHelpTriggerKind[SignatureHelpTriggerKind["Invoke"] = 1] = "Invoke";
  SignatureHelpTriggerKind[SignatureHelpTriggerKind["TriggerCharacter"] = 2] = "TriggerCharacter";
  SignatureHelpTriggerKind[SignatureHelpTriggerKind["ContentChange"] = 3] = "ContentChange";
})(SignatureHelpTriggerKind || (SignatureHelpTriggerKind = {}));
/**
                                                                  * A document highlight kind.
                                                                  */
var DocumentHighlightKind;
(function (DocumentHighlightKind) {
  /**
                                    * A textual occurrence.
                                    */
  DocumentHighlightKind[DocumentHighlightKind["Text"] = 0] = "Text";
  /**
                                                                      * Read-access of a symbol, like reading a variable.
                                                                      */
  DocumentHighlightKind[DocumentHighlightKind["Read"] = 1] = "Read";
  /**
                                                                      * Write-access of a symbol, like writing to a variable.
                                                                      */
  DocumentHighlightKind[DocumentHighlightKind["Write"] = 2] = "Write";
})(DocumentHighlightKind || (DocumentHighlightKind = {}));
/**
                                                            * @internal
                                                            */
function isLocationLink(thing) {
  return thing &&
  _base_common_uri_js__WEBPACK_IMPORTED_MODULE_1__["URI"].isUri(thing.uri) &&
  _core_range_js__WEBPACK_IMPORTED_MODULE_2__["Range"].isIRange(thing.range) && (
  _core_range_js__WEBPACK_IMPORTED_MODULE_2__["Range"].isIRange(thing.originSelectionRange) || _core_range_js__WEBPACK_IMPORTED_MODULE_2__["Range"].isIRange(thing.targetSelectionRange));
}
/**
   * @internal
   */
var SymbolKinds;
(function (SymbolKinds) {
  var byName = new Map();
  byName.set('file', 0 /* File */);
  byName.set('module', 1 /* Module */);
  byName.set('namespace', 2 /* Namespace */);
  byName.set('package', 3 /* Package */);
  byName.set('class', 4 /* Class */);
  byName.set('method', 5 /* Method */);
  byName.set('property', 6 /* Property */);
  byName.set('field', 7 /* Field */);
  byName.set('constructor', 8 /* Constructor */);
  byName.set('enum', 9 /* Enum */);
  byName.set('interface', 10 /* Interface */);
  byName.set('function', 11 /* Function */);
  byName.set('variable', 12 /* Variable */);
  byName.set('constant', 13 /* Constant */);
  byName.set('string', 14 /* String */);
  byName.set('number', 15 /* Number */);
  byName.set('boolean', 16 /* Boolean */);
  byName.set('array', 17 /* Array */);
  byName.set('object', 18 /* Object */);
  byName.set('key', 19 /* Key */);
  byName.set('null', 20 /* Null */);
  byName.set('enum-member', 21 /* EnumMember */);
  byName.set('struct', 22 /* Struct */);
  byName.set('event', 23 /* Event */);
  byName.set('operator', 24 /* Operator */);
  byName.set('type-parameter', 25 /* TypeParameter */);
  var byKind = new Map();
  byKind.set(0 /* File */, 'file');
  byKind.set(1 /* Module */, 'module');
  byKind.set(2 /* Namespace */, 'namespace');
  byKind.set(3 /* Package */, 'package');
  byKind.set(4 /* Class */, 'class');
  byKind.set(5 /* Method */, 'method');
  byKind.set(6 /* Property */, 'property');
  byKind.set(7 /* Field */, 'field');
  byKind.set(8 /* Constructor */, 'constructor');
  byKind.set(9 /* Enum */, 'enum');
  byKind.set(10 /* Interface */, 'interface');
  byKind.set(11 /* Function */, 'function');
  byKind.set(12 /* Variable */, 'variable');
  byKind.set(13 /* Constant */, 'constant');
  byKind.set(14 /* String */, 'string');
  byKind.set(15 /* Number */, 'number');
  byKind.set(16 /* Boolean */, 'boolean');
  byKind.set(17 /* Array */, 'array');
  byKind.set(18 /* Object */, 'object');
  byKind.set(19 /* Key */, 'key');
  byKind.set(20 /* Null */, 'null');
  byKind.set(21 /* EnumMember */, 'enum-member');
  byKind.set(22 /* Struct */, 'struct');
  byKind.set(23 /* Event */, 'event');
  byKind.set(24 /* Operator */, 'operator');
  byKind.set(25 /* TypeParameter */, 'type-parameter');
  /**
                                                         * @internal
                                                         */
  function fromString(value) {
    return byName.get(value);
  }
  SymbolKinds.fromString = fromString;
  /**
                                        * @internal
                                        */
  function toString(kind) {
    return byKind.get(kind);
  }
  SymbolKinds.toString = toString;
  /**
                                    * @internal
                                    */
  function toCssClassName(kind, inline) {
    return "codicon " + (inline ? 'inline' : 'block') + " codicon-symbol-" + (byKind.get(kind) || 'property');
  }
  SymbolKinds.toCssClassName = toCssClassName;
})(SymbolKinds || (SymbolKinds = {}));
var FoldingRangeKind = /** @class */function () {
  /**
                                                  * Creates a new [FoldingRangeKind](#FoldingRangeKind).
                                                  *
                                                  * @param value of the kind.
                                                  */
  function FoldingRangeKind(value) {
    this.value = value;
  }
  /**
     * Kind for folding range representing a comment. The value of the kind is 'comment'.
     */
  FoldingRangeKind.Comment = new FoldingRangeKind('comment');
  /**
                                                               * Kind for folding range representing a import. The value of the kind is 'imports'.
                                                               */
  FoldingRangeKind.Imports = new FoldingRangeKind('imports');
  /**
                                                               * Kind for folding range representing regions (for example marked by `#region`, `#endregion`).
                                                               * The value of the kind is 'region'.
                                                               */
  FoldingRangeKind.Region = new FoldingRangeKind('region');
  return FoldingRangeKind;
}();

/**
                              * @internal
                              */
var WorkspaceFileEdit;
(function (WorkspaceFileEdit) {
  /**
                                * @internal
                                */
  function is(thing) {
    return Object(_base_common_types_js__WEBPACK_IMPORTED_MODULE_0__["isObject"])(thing) && (Boolean(thing.newUri) || Boolean(thing.oldUri));
  }
  WorkspaceFileEdit.is = is;
})(WorkspaceFileEdit || (WorkspaceFileEdit = {}));
/**
                                                    * @internal
                                                    */
var WorkspaceTextEdit;
(function (WorkspaceTextEdit) {
  /**
                                * @internal
                                */
  function is(thing) {
    return Object(_base_common_types_js__WEBPACK_IMPORTED_MODULE_0__["isObject"])(thing) && _base_common_uri_js__WEBPACK_IMPORTED_MODULE_1__["URI"].isUri(thing.resource) && Object(_base_common_types_js__WEBPACK_IMPORTED_MODULE_0__["isObject"])(thing.edit);
  }
  WorkspaceTextEdit.is = is;
})(WorkspaceTextEdit || (WorkspaceTextEdit = {}));
// --- feature registries ------
/**
 * @internal
 */
var ReferenceProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                       * @internal
                                                                       */
var RenameProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                    * @internal
                                                                    */
var CompletionProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                        * @internal
                                                                        */
var SignatureHelpProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                           * @internal
                                                                           */
var HoverProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                   * @internal
                                                                   */
var DocumentSymbolProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                            * @internal
                                                                            */
var DocumentHighlightProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                               * @internal
                                                                               */
var DefinitionProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                        * @internal
                                                                        */
var DeclarationProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                         * @internal
                                                                         */
var ImplementationProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                            * @internal
                                                                            */
var TypeDefinitionProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                            * @internal
                                                                            */
var CodeLensProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                      * @internal
                                                                      */
var CodeActionProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                        * @internal
                                                                        */
var DocumentFormattingEditProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                                    * @internal
                                                                                    */
var DocumentRangeFormattingEditProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                                         * @internal
                                                                                         */
var OnTypeFormattingEditProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                                  * @internal
                                                                                  */
var LinkProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                  * @internal
                                                                  */
var ColorProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                   * @internal
                                                                   */
var SelectionRangeRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                    * @internal
                                                                    */
var FoldingRangeProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                          * @internal
                                                                          */
var DocumentSemanticTokensProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                                    * @internal
                                                                                    */
var DocumentRangeSemanticTokensProviderRegistry = new _modes_languageFeatureRegistry_js__WEBPACK_IMPORTED_MODULE_3__["LanguageFeatureRegistry"]();
/**
                                                                                         * @internal
                                                                                         */
var TokenizationRegistry = new _modes_tokenizationRegistry_js__WEBPACK_IMPORTED_MODULE_4__["TokenizationRegistryImpl"]();

/***/ }),

/***/ 6265:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LanguageFeatureRegistry", function() { return LanguageFeatureRegistry; });
/* harmony import */ var _base_common_event_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6213);
/* harmony import */ var _base_common_lifecycle_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6216);
/* harmony import */ var _languageSelector_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6266);
/* harmony import */ var _services_modelService_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6226);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/




function isExclusive(selector) {
    if (typeof selector === 'string') {
        return false;
    } else
    if (Array.isArray(selector)) {
        return selector.every(isExclusive);
    } else
    {
        return !!selector.exclusive;
    }
}
var LanguageFeatureRegistry = /** @class */function () {
    function LanguageFeatureRegistry() {
        this._clock = 0;
        this._entries = [];
        this._onDidChange = new _base_common_event_js__WEBPACK_IMPORTED_MODULE_0__["Emitter"]();
    }
    Object.defineProperty(LanguageFeatureRegistry.prototype, "onDidChange", {
        get: function () {
            return this._onDidChange.event;
        },
        enumerable: true,
        configurable: true });

    LanguageFeatureRegistry.prototype.register = function (selector, provider) {
        var _this = this;
        var entry = {
            selector: selector,
            provider: provider,
            _score: -1,
            _time: this._clock++ };

        this._entries.push(entry);
        this._lastCandidate = undefined;
        this._onDidChange.fire(this._entries.length);
        return Object(_base_common_lifecycle_js__WEBPACK_IMPORTED_MODULE_1__["toDisposable"])(function () {
            if (entry) {
                var idx = _this._entries.indexOf(entry);
                if (idx >= 0) {
                    _this._entries.splice(idx, 1);
                    _this._lastCandidate = undefined;
                    _this._onDidChange.fire(_this._entries.length);
                    entry = undefined;
                }
            }
        });
    };
    LanguageFeatureRegistry.prototype.has = function (model) {
        return this.all(model).length > 0;
    };
    LanguageFeatureRegistry.prototype.all = function (model) {
        if (!model) {
            return [];
        }
        this._updateScores(model);
        var result = [];
        // from registry
        for (var _i = 0, _a = this._entries; _i < _a.length; _i++) {
            var entry = _a[_i];
            if (entry._score > 0) {
                result.push(entry.provider);
            }
        }
        return result;
    };
    LanguageFeatureRegistry.prototype.ordered = function (model) {
        var result = [];
        this._orderedForEach(model, function (entry) {return result.push(entry.provider);});
        return result;
    };
    LanguageFeatureRegistry.prototype.orderedGroups = function (model) {
        var result = [];
        var lastBucket;
        var lastBucketScore;
        this._orderedForEach(model, function (entry) {
            if (lastBucket && lastBucketScore === entry._score) {
                lastBucket.push(entry.provider);
            } else
            {
                lastBucketScore = entry._score;
                lastBucket = [entry.provider];
                result.push(lastBucket);
            }
        });
        return result;
    };
    LanguageFeatureRegistry.prototype._orderedForEach = function (model, callback) {
        if (!model) {
            return;
        }
        this._updateScores(model);
        for (var _i = 0, _a = this._entries; _i < _a.length; _i++) {
            var entry = _a[_i];
            if (entry._score > 0) {
                callback(entry);
            }
        }
    };
    LanguageFeatureRegistry.prototype._updateScores = function (model) {
        var candidate = {
            uri: model.uri.toString(),
            language: model.getLanguageIdentifier().language };

        if (this._lastCandidate &&
        this._lastCandidate.language === candidate.language &&
        this._lastCandidate.uri === candidate.uri) {
            // nothing has changed
            return;
        }
        this._lastCandidate = candidate;
        for (var _i = 0, _a = this._entries; _i < _a.length; _i++) {
            var entry = _a[_i];
            entry._score = Object(_languageSelector_js__WEBPACK_IMPORTED_MODULE_2__["score"])(entry.selector, model.uri, model.getLanguageIdentifier().language, Object(_services_modelService_js__WEBPACK_IMPORTED_MODULE_3__["shouldSynchronizeModel"])(model));
            if (isExclusive(entry.selector) && entry._score > 0) {
                // support for one exclusive selector that overwrites
                // any other selector
                for (var _b = 0, _c = this._entries; _b < _c.length; _b++) {
                    var entry_1 = _c[_b];
                    entry_1._score = 0;
                }
                entry._score = 1000;
                break;
            }
        }
        // needs sorting
        this._entries.sort(LanguageFeatureRegistry._compareByScoreAndTime);
    };
    LanguageFeatureRegistry._compareByScoreAndTime = function (a, b) {
        if (a._score < b._score) {
            return 1;
        } else
        if (a._score > b._score) {
            return -1;
        } else
        if (a._time < b._time) {
            return 1;
        } else
        if (a._time > b._time) {
            return -1;
        } else
        {
            return 0;
        }
    };
    return LanguageFeatureRegistry;
}();


/***/ }),

/***/ 6266:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "score", function() { return score; });
/* harmony import */ var _base_common_glob_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6267);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/

function score(selector, candidateUri, candidateLanguage, candidateIsSynchronized) {
    if (Array.isArray(selector)) {
        // array -> take max individual value
        var ret = 0;
        for (var _i = 0, selector_1 = selector; _i < selector_1.length; _i++) {
            var filter = selector_1[_i];
            var value = score(filter, candidateUri, candidateLanguage, candidateIsSynchronized);
            if (value === 10) {
                return value; // already at the highest
            }
            if (value > ret) {
                ret = value;
            }
        }
        return ret;
    } else
    if (typeof selector === 'string') {
        if (!candidateIsSynchronized) {
            return 0;
        }
        // short-hand notion, desugars to
        // 'fooLang' -> { language: 'fooLang'}
        // '*' -> { language: '*' }
        if (selector === '*') {
            return 5;
        } else
        if (selector === candidateLanguage) {
            return 10;
        } else
        {
            return 0;
        }
    } else
    if (selector) {
        // filter -> select accordingly, use defaults for scheme
        var language = selector.language,pattern = selector.pattern,scheme = selector.scheme,hasAccessToAllModels = selector.hasAccessToAllModels;
        if (!candidateIsSynchronized && !hasAccessToAllModels) {
            return 0;
        }
        var ret = 0;
        if (scheme) {
            if (scheme === candidateUri.scheme) {
                ret = 10;
            } else
            if (scheme === '*') {
                ret = 5;
            } else
            {
                return 0;
            }
        }
        if (language) {
            if (language === candidateLanguage) {
                ret = 10;
            } else
            if (language === '*') {
                ret = Math.max(ret, 5);
            } else
            {
                return 0;
            }
        }
        if (pattern) {
            if (pattern === candidateUri.fsPath || Object(_base_common_glob_js__WEBPACK_IMPORTED_MODULE_0__["match"])(pattern, candidateUri.fsPath)) {
                ret = 10;
            } else
            {
                return 0;
            }
        }
        return ret;
    } else
    {
        return 0;
    }
}

/***/ }),

/***/ 6267:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "splitGlobAware", function() { return splitGlobAware; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "match", function() { return match; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "parse", function() { return parse; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isRelativePattern", function() { return isRelativePattern; });
/* harmony import */ var _arrays_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6262);
/* harmony import */ var _strings_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6219);
/* harmony import */ var _extpath_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6268);
/* harmony import */ var _path_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6269);
/* harmony import */ var _map_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6233);
/* harmony import */ var _async_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6211);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/






var GLOBSTAR = '**';
var GLOB_SPLIT = '/';
var PATH_REGEX = '[/\\\\]'; // any slash or backslash
var NO_PATH_REGEX = '[^/\\\\]'; // any non-slash and non-backslash
var ALL_FORWARD_SLASHES = /\//g;
function starsToRegExp(starCount) {
    switch (starCount) {
        case 0:
            return '';
        case 1:
            return NO_PATH_REGEX + "*?"; // 1 star matches any number of characters except path separator (/ and \) - non greedy (?)
        default:
            // Matches:  (Path Sep OR Path Val followed by Path Sep OR Path Sep followed by Path Val) 0-many times
            // Group is non capturing because we don't need to capture at all (?:...)
            // Overall we use non-greedy matching because it could be that we match too much
            return "(?:" + PATH_REGEX + "|" + NO_PATH_REGEX + "+" + PATH_REGEX + "|" + PATH_REGEX + NO_PATH_REGEX + "+)*?";}

}
function splitGlobAware(pattern, splitChar) {
    if (!pattern) {
        return [];
    }
    var segments = [];
    var inBraces = false;
    var inBrackets = false;
    var curVal = '';
    for (var _i = 0, pattern_1 = pattern; _i < pattern_1.length; _i++) {
        var char = pattern_1[_i];
        switch (char) {
            case splitChar:
                if (!inBraces && !inBrackets) {
                    segments.push(curVal);
                    curVal = '';
                    continue;
                }
                break;
            case '{':
                inBraces = true;
                break;
            case '}':
                inBraces = false;
                break;
            case '[':
                inBrackets = true;
                break;
            case ']':
                inBrackets = false;
                break;}

        curVal += char;
    }
    // Tail
    if (curVal) {
        segments.push(curVal);
    }
    return segments;
}
function parseRegExp(pattern) {
    if (!pattern) {
        return '';
    }
    var regEx = '';
    // Split up into segments for each slash found
    var segments = splitGlobAware(pattern, GLOB_SPLIT);
    // Special case where we only have globstars
    if (segments.every(function (s) {return s === GLOBSTAR;})) {
        regEx = '.*';
    }
    // Build regex over segments
    else {
            var previousSegmentWasGlobStar_1 = false;
            segments.forEach(function (segment, index) {
                // Globstar is special
                if (segment === GLOBSTAR) {
                    // if we have more than one globstar after another, just ignore it
                    if (!previousSegmentWasGlobStar_1) {
                        regEx += starsToRegExp(2);
                        previousSegmentWasGlobStar_1 = true;
                    }
                    return;
                }
                // States
                var inBraces = false;
                var braceVal = '';
                var inBrackets = false;
                var bracketVal = '';
                for (var _i = 0, segment_1 = segment; _i < segment_1.length; _i++) {
                    var char = segment_1[_i];
                    // Support brace expansion
                    if (char !== '}' && inBraces) {
                        braceVal += char;
                        continue;
                    }
                    // Support brackets
                    if (inBrackets && (char !== ']' || !bracketVal) /* ] is literally only allowed as first character in brackets to match it */) {
                            var res = void 0;
                            // range operator
                            if (char === '-') {
                                res = char;
                            }
                            // negation operator (only valid on first index in bracket)
                            else if ((char === '^' || char === '!') && !bracketVal) {
                                    res = '^';
                                }
                                // glob split matching is not allowed within character ranges
                                // see http://man7.org/linux/man-pages/man7/glob.7.html
                                else if (char === GLOB_SPLIT) {
                                        res = '';
                                    }
                                    // anything else gets escaped
                                    else {
                                            res = _strings_js__WEBPACK_IMPORTED_MODULE_1__["escapeRegExpCharacters"](char);
                                        }
                            bracketVal += res;
                            continue;
                        }
                    switch (char) {
                        case '{':
                            inBraces = true;
                            continue;
                        case '[':
                            inBrackets = true;
                            continue;
                        case '}':
                            var choices = splitGlobAware(braceVal, ',');
                            // Converts {foo,bar} => [foo|bar]
                            var braceRegExp = "(?:" + choices.map(function (c) {return parseRegExp(c);}).join('|') + ")";
                            regEx += braceRegExp;
                            inBraces = false;
                            braceVal = '';
                            break;
                        case ']':
                            regEx += '[' + bracketVal + ']';
                            inBrackets = false;
                            bracketVal = '';
                            break;
                        case '?':
                            regEx += NO_PATH_REGEX; // 1 ? matches any single character except path separator (/ and \)
                            continue;
                        case '*':
                            regEx += starsToRegExp(1);
                            continue;
                        default:
                            regEx += _strings_js__WEBPACK_IMPORTED_MODULE_1__["escapeRegExpCharacters"](char);}

                }
                // Tail: Add the slash we had split on if there is more to come and the remaining pattern is not a globstar
                // For example if pattern: some/**/*.js we want the "/" after some to be included in the RegEx to prevent
                // a folder called "something" to match as well.
                // However, if pattern: some/**, we tolerate that we also match on "something" because our globstar behaviour
                // is to match 0-N segments.
                if (index < segments.length - 1 && (segments[index + 1] !== GLOBSTAR || index + 2 < segments.length)) {
                    regEx += PATH_REGEX;
                }
                // reset state
                previousSegmentWasGlobStar_1 = false;
            });
        }
    return regEx;
}
// regexes to check for trival glob patterns that just check for String#endsWith
var T1 = /^\*\*\/\*\.[\w\.-]+$/; // **/*.something
var T2 = /^\*\*\/([\w\.-]+)\/?$/; // **/something
var T3 = /^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/; // {**/*.something,**/*.else} or {**/package.json,**/project.json}
var T3_2 = /^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/; // Like T3, with optional trailing /**
var T4 = /^\*\*((\/[\w\.-]+)+)\/?$/; // **/something/else
var T5 = /^([\w\.-]+(\/[\w\.-]+)*)\/?$/; // something/else
var CACHE = new _map_js__WEBPACK_IMPORTED_MODULE_4__["LRUCache"](10000); // bounded to 10000 elements
var FALSE = function () {
    return false;
};
var NULL = function () {
    return null;
};
function parsePattern(arg1, options) {
    if (!arg1) {
        return NULL;
    }
    // Handle IRelativePattern
    var pattern;
    if (typeof arg1 !== 'string') {
        pattern = arg1.pattern;
    } else
    {
        pattern = arg1;
    }
    // Whitespace trimming
    pattern = pattern.trim();
    // Check cache
    var patternKey = pattern + "_" + !!options.trimForExclusions;
    var parsedPattern = CACHE.get(patternKey);
    if (parsedPattern) {
        return wrapRelativePattern(parsedPattern, arg1);
    }
    // Check for Trivias
    var match;
    if (T1.test(pattern)) {// common pattern: **/*.txt just need endsWith check
        var base_1 = pattern.substr(4); // '**/*'.length === 4
        parsedPattern = function (path, basename) {
            return typeof path === 'string' && _strings_js__WEBPACK_IMPORTED_MODULE_1__["endsWith"](path, base_1) ? pattern : null;
        };
    } else
    if (match = T2.exec(trimForExclusions(pattern, options))) {// common pattern: **/some.txt just need basename check
        parsedPattern = trivia2(match[1], pattern);
    } else
    if ((options.trimForExclusions ? T3_2 : T3).test(pattern)) {// repetition of common patterns (see above) {**/*.txt,**/*.png}
        parsedPattern = trivia3(pattern, options);
    } else
    if (match = T4.exec(trimForExclusions(pattern, options))) {// common pattern: **/something/else just need endsWith check
        parsedPattern = trivia4and5(match[1].substr(1), pattern, true);
    } else
    if (match = T5.exec(trimForExclusions(pattern, options))) {// common pattern: something/else just need equals check
        parsedPattern = trivia4and5(match[1], pattern, false);
    }
    // Otherwise convert to pattern
    else {
            parsedPattern = toRegExp(pattern);
        }
    // Cache
    CACHE.set(patternKey, parsedPattern);
    return wrapRelativePattern(parsedPattern, arg1);
}
function wrapRelativePattern(parsedPattern, arg2) {
    if (typeof arg2 === 'string') {
        return parsedPattern;
    }
    return function (path, basename) {
        if (!_extpath_js__WEBPACK_IMPORTED_MODULE_2__["isEqualOrParent"](path, arg2.base)) {
            return null;
        }
        return parsedPattern(_path_js__WEBPACK_IMPORTED_MODULE_3__["relative"](arg2.base, path), basename);
    };
}
function trimForExclusions(pattern, options) {
    return options.trimForExclusions && _strings_js__WEBPACK_IMPORTED_MODULE_1__["endsWith"](pattern, '/**') ? pattern.substr(0, pattern.length - 2) : pattern; // dropping **, tailing / is dropped later
}
// common pattern: **/some.txt just need basename check
function trivia2(base, originalPattern) {
    var slashBase = "/" + base;
    var backslashBase = "\\" + base;
    var parsedPattern = function (path, basename) {
        if (typeof path !== 'string') {
            return null;
        }
        if (basename) {
            return basename === base ? originalPattern : null;
        }
        return path === base || _strings_js__WEBPACK_IMPORTED_MODULE_1__["endsWith"](path, slashBase) || _strings_js__WEBPACK_IMPORTED_MODULE_1__["endsWith"](path, backslashBase) ? originalPattern : null;
    };
    var basenames = [base];
    parsedPattern.basenames = basenames;
    parsedPattern.patterns = [originalPattern];
    parsedPattern.allBasenames = basenames;
    return parsedPattern;
}
// repetition of common patterns (see above) {**/*.txt,**/*.png}
function trivia3(pattern, options) {
    var parsedPatterns = aggregateBasenameMatches(pattern.slice(1, -1).split(',').
    map(function (pattern) {return parsePattern(pattern, options);}).
    filter(function (pattern) {return pattern !== NULL;}), pattern);
    var n = parsedPatterns.length;
    if (!n) {
        return NULL;
    }
    if (n === 1) {
        return parsedPatterns[0];
    }
    var parsedPattern = function (path, basename) {
        for (var i = 0, n_1 = parsedPatterns.length; i < n_1; i++) {
            if (parsedPatterns[i](path, basename)) {
                return pattern;
            }
        }
        return null;
    };
    var withBasenames = _arrays_js__WEBPACK_IMPORTED_MODULE_0__["first"](parsedPatterns, function (pattern) {return !!pattern.allBasenames;});
    if (withBasenames) {
        parsedPattern.allBasenames = withBasenames.allBasenames;
    }
    var allPaths = parsedPatterns.reduce(function (all, current) {return current.allPaths ? all.concat(current.allPaths) : all;}, []);
    if (allPaths.length) {
        parsedPattern.allPaths = allPaths;
    }
    return parsedPattern;
}
// common patterns: **/something/else just need endsWith check, something/else just needs and equals check
function trivia4and5(path, pattern, matchPathEnds) {
    var nativePath = _path_js__WEBPACK_IMPORTED_MODULE_3__["sep"] !== _path_js__WEBPACK_IMPORTED_MODULE_3__["posix"].sep ? path.replace(ALL_FORWARD_SLASHES, _path_js__WEBPACK_IMPORTED_MODULE_3__["sep"]) : path;
    var nativePathEnd = _path_js__WEBPACK_IMPORTED_MODULE_3__["sep"] + nativePath;
    var parsedPattern = matchPathEnds ? function (path, basename) {
        return typeof path === 'string' && (path === nativePath || _strings_js__WEBPACK_IMPORTED_MODULE_1__["endsWith"](path, nativePathEnd)) ? pattern : null;
    } : function (path, basename) {
        return typeof path === 'string' && path === nativePath ? pattern : null;
    };
    parsedPattern.allPaths = [(matchPathEnds ? '*/' : './') + path];
    return parsedPattern;
}
function toRegExp(pattern) {
    try {
        var regExp_1 = new RegExp("^" + parseRegExp(pattern) + "$");
        return function (path, basename) {
            regExp_1.lastIndex = 0; // reset RegExp to its initial state to reuse it!
            return typeof path === 'string' && regExp_1.test(path) ? pattern : null;
        };
    }
    catch (error) {
        return NULL;
    }
}
function match(arg1, path, hasSibling) {
    if (!arg1 || typeof path !== 'string') {
        return false;
    }
    return parse(arg1)(path, undefined, hasSibling);
}
function parse(arg1, options) {
    if (options === void 0) {options = {};}
    if (!arg1) {
        return FALSE;
    }
    // Glob with String
    if (typeof arg1 === 'string' || isRelativePattern(arg1)) {
        var parsedPattern_1 = parsePattern(arg1, options);
        if (parsedPattern_1 === NULL) {
            return FALSE;
        }
        var resultPattern = function (path, basename) {
            return !!parsedPattern_1(path, basename);
        };
        if (parsedPattern_1.allBasenames) {
            resultPattern.allBasenames = parsedPattern_1.allBasenames;
        }
        if (parsedPattern_1.allPaths) {
            resultPattern.allPaths = parsedPattern_1.allPaths;
        }
        return resultPattern;
    }
    // Glob with Expression
    return parsedExpression(arg1, options);
}
function isRelativePattern(obj) {
    var rp = obj;
    return rp && typeof rp.base === 'string' && typeof rp.pattern === 'string';
}
function parsedExpression(expression, options) {
    var parsedPatterns = aggregateBasenameMatches(Object.getOwnPropertyNames(expression).
    map(function (pattern) {return parseExpressionPattern(pattern, expression[pattern], options);}).
    filter(function (pattern) {return pattern !== NULL;}));
    var n = parsedPatterns.length;
    if (!n) {
        return NULL;
    }
    if (!parsedPatterns.some(function (parsedPattern) {return !!parsedPattern.requiresSiblings;})) {
        if (n === 1) {
            return parsedPatterns[0];
        }
        var resultExpression_1 = function (path, basename) {
            for (var i = 0, n_2 = parsedPatterns.length; i < n_2; i++) {
                // Pattern matches path
                var result = parsedPatterns[i](path, basename);
                if (result) {
                    return result;
                }
            }
            return null;
        };
        var withBasenames_1 = _arrays_js__WEBPACK_IMPORTED_MODULE_0__["first"](parsedPatterns, function (pattern) {return !!pattern.allBasenames;});
        if (withBasenames_1) {
            resultExpression_1.allBasenames = withBasenames_1.allBasenames;
        }
        var allPaths_1 = parsedPatterns.reduce(function (all, current) {return current.allPaths ? all.concat(current.allPaths) : all;}, []);
        if (allPaths_1.length) {
            resultExpression_1.allPaths = allPaths_1;
        }
        return resultExpression_1;
    }
    var resultExpression = function (path, basename, hasSibling) {
        var name = undefined;
        for (var i = 0, n_3 = parsedPatterns.length; i < n_3; i++) {
            // Pattern matches path
            var parsedPattern = parsedPatterns[i];
            if (parsedPattern.requiresSiblings && hasSibling) {
                if (!basename) {
                    basename = _path_js__WEBPACK_IMPORTED_MODULE_3__["basename"](path);
                }
                if (!name) {
                    name = basename.substr(0, basename.length - _path_js__WEBPACK_IMPORTED_MODULE_3__["extname"](path).length);
                }
            }
            var result = parsedPattern(path, basename, name, hasSibling);
            if (result) {
                return result;
            }
        }
        return null;
    };
    var withBasenames = _arrays_js__WEBPACK_IMPORTED_MODULE_0__["first"](parsedPatterns, function (pattern) {return !!pattern.allBasenames;});
    if (withBasenames) {
        resultExpression.allBasenames = withBasenames.allBasenames;
    }
    var allPaths = parsedPatterns.reduce(function (all, current) {return current.allPaths ? all.concat(current.allPaths) : all;}, []);
    if (allPaths.length) {
        resultExpression.allPaths = allPaths;
    }
    return resultExpression;
}
function parseExpressionPattern(pattern, value, options) {
    if (value === false) {
        return NULL; // pattern is disabled
    }
    var parsedPattern = parsePattern(pattern, options);
    if (parsedPattern === NULL) {
        return NULL;
    }
    // Expression Pattern is <boolean>
    if (typeof value === 'boolean') {
        return parsedPattern;
    }
    // Expression Pattern is <SiblingClause>
    if (value) {
        var when_1 = value.when;
        if (typeof when_1 === 'string') {
            var result = function (path, basename, name, hasSibling) {
                if (!hasSibling || !parsedPattern(path, basename)) {
                    return null;
                }
                var clausePattern = when_1.replace('$(basename)', name);
                var matched = hasSibling(clausePattern);
                return Object(_async_js__WEBPACK_IMPORTED_MODULE_5__["isThenable"])(matched) ?
                matched.then(function (m) {return m ? pattern : null;}) :
                matched ? pattern : null;
            };
            result.requiresSiblings = true;
            return result;
        }
    }
    // Expression is Anything
    return parsedPattern;
}
function aggregateBasenameMatches(parsedPatterns, result) {
    var basenamePatterns = parsedPatterns.filter(function (parsedPattern) {return !!parsedPattern.basenames;});
    if (basenamePatterns.length < 2) {
        return parsedPatterns;
    }
    var basenames = basenamePatterns.reduce(function (all, current) {
        var basenames = current.basenames;
        return basenames ? all.concat(basenames) : all;
    }, []);
    var patterns;
    if (result) {
        patterns = [];
        for (var i = 0, n = basenames.length; i < n; i++) {
            patterns.push(result);
        }
    } else
    {
        patterns = basenamePatterns.reduce(function (all, current) {
            var patterns = current.patterns;
            return patterns ? all.concat(patterns) : all;
        }, []);
    }
    var aggregate = function (path, basename) {
        if (typeof path !== 'string') {
            return null;
        }
        if (!basename) {
            var i = void 0;
            for (i = path.length; i > 0; i--) {
                var ch = path.charCodeAt(i - 1);
                if (ch === 47 /* Slash */ || ch === 92 /* Backslash */) {
                        break;
                    }
            }
            basename = path.substr(i);
        }
        var index = basenames.indexOf(basename);
        return index !== -1 ? patterns[index] : null;
    };
    aggregate.basenames = basenames;
    aggregate.patterns = patterns;
    aggregate.allBasenames = basenames;
    var aggregatedPatterns = parsedPatterns.filter(function (parsedPattern) {return !parsedPattern.basenames;});
    aggregatedPatterns.push(aggregate);
    return aggregatedPatterns;
}

/***/ }),

/***/ 6268:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "toSlashes", function() { return toSlashes; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isEqualOrParent", function() { return isEqualOrParent; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isWindowsDriveLetter", function() { return isWindowsDriveLetter; });
/* harmony import */ var _strings_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6219);
/* harmony import */ var _path_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6269);


/**
                                         * Takes a Windows OS path and changes backward slashes to forward slashes.
                                         * This should only be done for OS paths from Windows (or user provided paths potentially from Windows).
                                         * Using it on a Linux or MaxOS path might change it.
                                         */
function toSlashes(osPath) {
    return osPath.replace(/[\\/]/g, _path_js__WEBPACK_IMPORTED_MODULE_1__["posix"].sep);
}
function isEqualOrParent(path, candidate, ignoreCase, separator) {
    if (separator === void 0) {separator = _path_js__WEBPACK_IMPORTED_MODULE_1__["sep"];}
    if (path === candidate) {
        return true;
    }
    if (!path || !candidate) {
        return false;
    }
    if (candidate.length > path.length) {
        return false;
    }
    if (ignoreCase) {
        var beginsWith = Object(_strings_js__WEBPACK_IMPORTED_MODULE_0__["startsWithIgnoreCase"])(path, candidate);
        if (!beginsWith) {
            return false;
        }
        if (candidate.length === path.length) {
            return true; // same path, different casing
        }
        var sepOffset = candidate.length;
        if (candidate.charAt(candidate.length - 1) === separator) {
            sepOffset--; // adjust the expected sep offset in case our candidate already ends in separator character
        }
        return path.charAt(sepOffset) === separator;
    }
    if (candidate.charAt(candidate.length - 1) !== separator) {
        candidate += separator;
    }
    return path.indexOf(candidate) === 0;
}
function isWindowsDriveLetter(char0) {
    return char0 >= 65 /* A */ && char0 <= 90 /* Z */ || char0 >= 97 /* a */ && char0 <= 122 /* z */;
}

/***/ }),

/***/ 6269:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "win32", function() { return win32; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "posix", function() { return posix; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "normalize", function() { return normalize; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "join", function() { return join; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "relative", function() { return relative; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "dirname", function() { return dirname; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "basename", function() { return basename; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "extname", function() { return extname; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sep", function() { return sep; });
/* harmony import */ var _process_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6270);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __extends = undefined && undefined.__extends || function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
        { __proto__: [] } instanceof Array && function (d, b) {d.__proto__ = b;} ||
        function (d, b) {for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];};
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {this.constructor = d;}
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();
// NOTE: VSCode's copy of nodejs path library to be usable in common (non-node) namespace
// Copied from: https://github.com/nodejs/node/tree/43dd49c9782848c25e5b03448c8a0f923f13c158
/**
 * Copyright Joyent, Inc. and other Node contributors.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to permit
 * persons to whom the Software is furnished to do so, subject to the
 * following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
 * NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
 * USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

var CHAR_UPPERCASE_A = 65; /* A */
var CHAR_LOWERCASE_A = 97; /* a */
var CHAR_UPPERCASE_Z = 90; /* Z */
var CHAR_LOWERCASE_Z = 122; /* z */
var CHAR_DOT = 46; /* . */
var CHAR_FORWARD_SLASH = 47; /* / */
var CHAR_BACKWARD_SLASH = 92; /* \ */
var CHAR_COLON = 58; /* : */
var CHAR_QUESTION_MARK = 63; /* ? */
var ErrorInvalidArgType = /** @class */function (_super) {
    __extends(ErrorInvalidArgType, _super);
    function ErrorInvalidArgType(name, expected, actual) {
        var _this = this;
        // determiner: 'must be' or 'must not be'
        var determiner;
        if (typeof expected === 'string' && expected.indexOf('not ') === 0) {
            determiner = 'must not be';
            expected = expected.replace(/^not /, '');
        } else
        {
            determiner = 'must be';
        }
        var type = name.indexOf('.') !== -1 ? 'property' : 'argument';
        var msg = "The \"" + name + "\" " + type + " " + determiner + " of type " + expected;
        msg += ". Received type " + typeof actual;
        _this = _super.call(this, msg) || this;
        _this.code = 'ERR_INVALID_ARG_TYPE';
        return _this;
    }
    return ErrorInvalidArgType;
}(Error);
function validateString(value, name) {
    if (typeof value !== 'string') {
        throw new ErrorInvalidArgType(name, 'string', value);
    }
}
function isPathSeparator(code) {
    return code === CHAR_FORWARD_SLASH || code === CHAR_BACKWARD_SLASH;
}
function isPosixPathSeparator(code) {
    return code === CHAR_FORWARD_SLASH;
}
function isWindowsDeviceRoot(code) {
    return code >= CHAR_UPPERCASE_A && code <= CHAR_UPPERCASE_Z ||
    code >= CHAR_LOWERCASE_A && code <= CHAR_LOWERCASE_Z;
}
// Resolves . and .. elements in a path with directory names
function normalizeString(path, allowAboveRoot, separator, isPathSeparator) {
    var res = '';
    var lastSegmentLength = 0;
    var lastSlash = -1;
    var dots = 0;
    var code;
    for (var i = 0; i <= path.length; ++i) {
        if (i < path.length) {
            code = path.charCodeAt(i);
        } else
        if (isPathSeparator(code)) {
            break;
        } else
        {
            code = CHAR_FORWARD_SLASH;
        }
        if (isPathSeparator(code)) {
            if (lastSlash === i - 1 || dots === 1) {
                // NOOP
            } else
            if (lastSlash !== i - 1 && dots === 2) {
                if (res.length < 2 || lastSegmentLength !== 2 ||
                res.charCodeAt(res.length - 1) !== CHAR_DOT ||
                res.charCodeAt(res.length - 2) !== CHAR_DOT) {
                    if (res.length > 2) {
                        var lastSlashIndex = res.lastIndexOf(separator);
                        if (lastSlashIndex === -1) {
                            res = '';
                            lastSegmentLength = 0;
                        } else
                        {
                            res = res.slice(0, lastSlashIndex);
                            lastSegmentLength = res.length - 1 - res.lastIndexOf(separator);
                        }
                        lastSlash = i;
                        dots = 0;
                        continue;
                    } else
                    if (res.length === 2 || res.length === 1) {
                        res = '';
                        lastSegmentLength = 0;
                        lastSlash = i;
                        dots = 0;
                        continue;
                    }
                }
                if (allowAboveRoot) {
                    if (res.length > 0) {
                        res += separator + "..";
                    } else
                    {
                        res = '..';
                    }
                    lastSegmentLength = 2;
                }
            } else
            {
                if (res.length > 0) {
                    res += separator + path.slice(lastSlash + 1, i);
                } else
                {
                    res = path.slice(lastSlash + 1, i);
                }
                lastSegmentLength = i - lastSlash - 1;
            }
            lastSlash = i;
            dots = 0;
        } else
        if (code === CHAR_DOT && dots !== -1) {
            ++dots;
        } else
        {
            dots = -1;
        }
    }
    return res;
}
function _format(sep, pathObject) {
    var dir = pathObject.dir || pathObject.root;
    var base = pathObject.base ||
    (pathObject.name || '') + (pathObject.ext || '');
    if (!dir) {
        return base;
    }
    if (dir === pathObject.root) {
        return dir + base;
    }
    return dir + sep + base;
}
var win32 = {
    // path.resolve([from ...], to)
    resolve: function () {
        var pathSegments = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            pathSegments[_i] = arguments[_i];
        }
        var resolvedDevice = '';
        var resolvedTail = '';
        var resolvedAbsolute = false;
        for (var i = pathSegments.length - 1; i >= -1; i--) {
            var path = void 0;
            if (i >= 0) {
                path = pathSegments[i];
            } else
            if (!resolvedDevice) {
                path = _process_js__WEBPACK_IMPORTED_MODULE_0__["cwd"]();
            } else
            {
                // Windows has the concept of drive-specific current working
                // directories. If we've resolved a drive letter but not yet an
                // absolute path, get cwd for that drive, or the process cwd if
                // the drive cwd is not available. We're sure the device is not
                // a UNC path at this points, because UNC paths are always absolute.
                path = _process_js__WEBPACK_IMPORTED_MODULE_0__["env"]['=' + resolvedDevice] || _process_js__WEBPACK_IMPORTED_MODULE_0__["cwd"]();
                // Verify that a cwd was found and that it actually points
                // to our drive. If not, default to the drive's root.
                if (path === undefined ||
                path.slice(0, 3).toLowerCase() !==
                resolvedDevice.toLowerCase() + '\\') {
                    path = resolvedDevice + '\\';
                }
            }
            validateString(path, 'path');
            // Skip empty entries
            if (path.length === 0) {
                continue;
            }
            var len = path.length;
            var rootEnd = 0;
            var device = '';
            var isAbsolute = false;
            var code = path.charCodeAt(0);
            // Try to match a root
            if (len > 1) {
                if (isPathSeparator(code)) {
                    // Possible UNC root
                    // If we started with a separator, we know we at least have an
                    // absolute path of some kind (UNC or otherwise)
                    isAbsolute = true;
                    if (isPathSeparator(path.charCodeAt(1))) {
                        // Matched double path separator at beginning
                        var j = 2;
                        var last = j;
                        // Match 1 or more non-path separators
                        for (; j < len; ++j) {
                            if (isPathSeparator(path.charCodeAt(j))) {
                                break;
                            }
                        }
                        if (j < len && j !== last) {
                            var firstPart = path.slice(last, j);
                            // Matched!
                            last = j;
                            // Match 1 or more path separators
                            for (; j < len; ++j) {
                                if (!isPathSeparator(path.charCodeAt(j))) {
                                    break;
                                }
                            }
                            if (j < len && j !== last) {
                                // Matched!
                                last = j;
                                // Match 1 or more non-path separators
                                for (; j < len; ++j) {
                                    if (isPathSeparator(path.charCodeAt(j))) {
                                        break;
                                    }
                                }
                                if (j === len) {
                                    // We matched a UNC root only
                                    device = '\\\\' + firstPart + '\\' + path.slice(last);
                                    rootEnd = j;
                                } else
                                if (j !== last) {
                                    // We matched a UNC root with leftovers
                                    device = '\\\\' + firstPart + '\\' + path.slice(last, j);
                                    rootEnd = j;
                                }
                            }
                        }
                    } else
                    {
                        rootEnd = 1;
                    }
                } else
                if (isWindowsDeviceRoot(code)) {
                    // Possible device root
                    if (path.charCodeAt(1) === CHAR_COLON) {
                        device = path.slice(0, 2);
                        rootEnd = 2;
                        if (len > 2) {
                            if (isPathSeparator(path.charCodeAt(2))) {
                                // Treat separator following drive name as an absolute path
                                // indicator
                                isAbsolute = true;
                                rootEnd = 3;
                            }
                        }
                    }
                }
            } else
            if (isPathSeparator(code)) {
                // `path` contains just a path separator
                rootEnd = 1;
                isAbsolute = true;
            }
            if (device.length > 0 &&
            resolvedDevice.length > 0 &&
            device.toLowerCase() !== resolvedDevice.toLowerCase()) {
                // This path points to another device so it is not applicable
                continue;
            }
            if (resolvedDevice.length === 0 && device.length > 0) {
                resolvedDevice = device;
            }
            if (!resolvedAbsolute) {
                resolvedTail = path.slice(rootEnd) + '\\' + resolvedTail;
                resolvedAbsolute = isAbsolute;
            }
            if (resolvedDevice.length > 0 && resolvedAbsolute) {
                break;
            }
        }
        // At this point the path should be resolved to a full absolute path,
        // but handle relative paths to be safe (might happen when process.cwd()
        // fails)
        // Normalize the tail path
        resolvedTail = normalizeString(resolvedTail, !resolvedAbsolute, '\\', isPathSeparator);
        return resolvedDevice + (resolvedAbsolute ? '\\' : '') + resolvedTail ||
        '.';
    },
    normalize: function (path) {
        validateString(path, 'path');
        var len = path.length;
        if (len === 0) {
            return '.';
        }
        var rootEnd = 0;
        var device;
        var isAbsolute = false;
        var code = path.charCodeAt(0);
        // Try to match a root
        if (len > 1) {
            if (isPathSeparator(code)) {
                // Possible UNC root
                // If we started with a separator, we know we at least have an absolute
                // path of some kind (UNC or otherwise)
                isAbsolute = true;
                if (isPathSeparator(path.charCodeAt(1))) {
                    // Matched double path separator at beginning
                    var j = 2;
                    var last = j;
                    // Match 1 or more non-path separators
                    for (; j < len; ++j) {
                        if (isPathSeparator(path.charCodeAt(j))) {
                            break;
                        }
                    }
                    if (j < len && j !== last) {
                        var firstPart = path.slice(last, j);
                        // Matched!
                        last = j;
                        // Match 1 or more path separators
                        for (; j < len; ++j) {
                            if (!isPathSeparator(path.charCodeAt(j))) {
                                break;
                            }
                        }
                        if (j < len && j !== last) {
                            // Matched!
                            last = j;
                            // Match 1 or more non-path separators
                            for (; j < len; ++j) {
                                if (isPathSeparator(path.charCodeAt(j))) {
                                    break;
                                }
                            }
                            if (j === len) {
                                // We matched a UNC root only
                                // Return the normalized version of the UNC root since there
                                // is nothing left to process
                                return '\\\\' + firstPart + '\\' + path.slice(last) + '\\';
                            } else
                            if (j !== last) {
                                // We matched a UNC root with leftovers
                                device = '\\\\' + firstPart + '\\' + path.slice(last, j);
                                rootEnd = j;
                            }
                        }
                    }
                } else
                {
                    rootEnd = 1;
                }
            } else
            if (isWindowsDeviceRoot(code)) {
                // Possible device root
                if (path.charCodeAt(1) === CHAR_COLON) {
                    device = path.slice(0, 2);
                    rootEnd = 2;
                    if (len > 2) {
                        if (isPathSeparator(path.charCodeAt(2))) {
                            // Treat separator following drive name as an absolute path
                            // indicator
                            isAbsolute = true;
                            rootEnd = 3;
                        }
                    }
                }
            }
        } else
        if (isPathSeparator(code)) {
            // `path` contains just a path separator, exit early to avoid unnecessary
            // work
            return '\\';
        }
        var tail;
        if (rootEnd < len) {
            tail = normalizeString(path.slice(rootEnd), !isAbsolute, '\\', isPathSeparator);
        } else
        {
            tail = '';
        }
        if (tail.length === 0 && !isAbsolute) {
            tail = '.';
        }
        if (tail.length > 0 && isPathSeparator(path.charCodeAt(len - 1))) {
            tail += '\\';
        }
        if (device === undefined) {
            if (isAbsolute) {
                if (tail.length > 0) {
                    return '\\' + tail;
                } else
                {
                    return '\\';
                }
            } else
            if (tail.length > 0) {
                return tail;
            } else
            {
                return '';
            }
        } else
        if (isAbsolute) {
            if (tail.length > 0) {
                return device + '\\' + tail;
            } else
            {
                return device + '\\';
            }
        } else
        if (tail.length > 0) {
            return device + tail;
        } else
        {
            return device;
        }
    },
    isAbsolute: function (path) {
        validateString(path, 'path');
        var len = path.length;
        if (len === 0) {
            return false;
        }
        var code = path.charCodeAt(0);
        if (isPathSeparator(code)) {
            return true;
        } else
        if (isWindowsDeviceRoot(code)) {
            // Possible device root
            if (len > 2 && path.charCodeAt(1) === CHAR_COLON) {
                if (isPathSeparator(path.charCodeAt(2))) {
                    return true;
                }
            }
        }
        return false;
    },
    join: function () {
        var paths = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            paths[_i] = arguments[_i];
        }
        if (paths.length === 0) {
            return '.';
        }
        var joined;
        var firstPart;
        for (var i = 0; i < paths.length; ++i) {
            var arg = paths[i];
            validateString(arg, 'path');
            if (arg.length > 0) {
                if (joined === undefined) {
                    joined = firstPart = arg;
                } else
                {
                    joined += '\\' + arg;
                }
            }
        }
        if (joined === undefined) {
            return '.';
        }
        // Make sure that the joined path doesn't start with two slashes, because
        // normalize() will mistake it for an UNC path then.
        //
        // This step is skipped when it is very clear that the user actually
        // intended to point at an UNC path. This is assumed when the first
        // non-empty string arguments starts with exactly two slashes followed by
        // at least one more non-slash character.
        //
        // Note that for normalize() to treat a path as an UNC path it needs to
        // have at least 2 components, so we don't filter for that here.
        // This means that the user can use join to construct UNC paths from
        // a server name and a share name; for example:
        //   path.join('//server', 'share') -> '\\\\server\\share\\')
        var needsReplace = true;
        var slashCount = 0;
        if (typeof firstPart === 'string' && isPathSeparator(firstPart.charCodeAt(0))) {
            ++slashCount;
            var firstLen = firstPart.length;
            if (firstLen > 1) {
                if (isPathSeparator(firstPart.charCodeAt(1))) {
                    ++slashCount;
                    if (firstLen > 2) {
                        if (isPathSeparator(firstPart.charCodeAt(2))) {
                            ++slashCount;
                        } else
                        {
                            // We matched a UNC path in the first part
                            needsReplace = false;
                        }
                    }
                }
            }
        }
        if (needsReplace) {
            // Find any more consecutive slashes we need to replace
            for (; slashCount < joined.length; ++slashCount) {
                if (!isPathSeparator(joined.charCodeAt(slashCount))) {
                    break;
                }
            }
            // Replace the slashes if needed
            if (slashCount >= 2) {
                joined = '\\' + joined.slice(slashCount);
            }
        }
        return win32.normalize(joined);
    },
    // It will solve the relative path from `from` to `to`, for instance:
    //  from = 'C:\\orandea\\test\\aaa'
    //  to = 'C:\\orandea\\impl\\bbb'
    // The output of the function should be: '..\\..\\impl\\bbb'
    relative: function (from, to) {
        validateString(from, 'from');
        validateString(to, 'to');
        if (from === to) {
            return '';
        }
        var fromOrig = win32.resolve(from);
        var toOrig = win32.resolve(to);
        if (fromOrig === toOrig) {
            return '';
        }
        from = fromOrig.toLowerCase();
        to = toOrig.toLowerCase();
        if (from === to) {
            return '';
        }
        // Trim any leading backslashes
        var fromStart = 0;
        for (; fromStart < from.length; ++fromStart) {
            if (from.charCodeAt(fromStart) !== CHAR_BACKWARD_SLASH) {
                break;
            }
        }
        // Trim trailing backslashes (applicable to UNC paths only)
        var fromEnd = from.length;
        for (; fromEnd - 1 > fromStart; --fromEnd) {
            if (from.charCodeAt(fromEnd - 1) !== CHAR_BACKWARD_SLASH) {
                break;
            }
        }
        var fromLen = fromEnd - fromStart;
        // Trim any leading backslashes
        var toStart = 0;
        for (; toStart < to.length; ++toStart) {
            if (to.charCodeAt(toStart) !== CHAR_BACKWARD_SLASH) {
                break;
            }
        }
        // Trim trailing backslashes (applicable to UNC paths only)
        var toEnd = to.length;
        for (; toEnd - 1 > toStart; --toEnd) {
            if (to.charCodeAt(toEnd - 1) !== CHAR_BACKWARD_SLASH) {
                break;
            }
        }
        var toLen = toEnd - toStart;
        // Compare paths to find the longest common path from root
        var length = fromLen < toLen ? fromLen : toLen;
        var lastCommonSep = -1;
        var i = 0;
        for (; i <= length; ++i) {
            if (i === length) {
                if (toLen > length) {
                    if (to.charCodeAt(toStart + i) === CHAR_BACKWARD_SLASH) {
                        // We get here if `from` is the exact base path for `to`.
                        // For example: from='C:\\foo\\bar'; to='C:\\foo\\bar\\baz'
                        return toOrig.slice(toStart + i + 1);
                    } else
                    if (i === 2) {
                        // We get here if `from` is the device root.
                        // For example: from='C:\\'; to='C:\\foo'
                        return toOrig.slice(toStart + i);
                    }
                }
                if (fromLen > length) {
                    if (from.charCodeAt(fromStart + i) === CHAR_BACKWARD_SLASH) {
                        // We get here if `to` is the exact base path for `from`.
                        // For example: from='C:\\foo\\bar'; to='C:\\foo'
                        lastCommonSep = i;
                    } else
                    if (i === 2) {
                        // We get here if `to` is the device root.
                        // For example: from='C:\\foo\\bar'; to='C:\\'
                        lastCommonSep = 3;
                    }
                }
                break;
            }
            var fromCode = from.charCodeAt(fromStart + i);
            var toCode = to.charCodeAt(toStart + i);
            if (fromCode !== toCode) {
                break;
            } else
            if (fromCode === CHAR_BACKWARD_SLASH) {
                lastCommonSep = i;
            }
        }
        // We found a mismatch before the first common path separator was seen, so
        // return the original `to`.
        if (i !== length && lastCommonSep === -1) {
            return toOrig;
        }
        var out = '';
        if (lastCommonSep === -1) {
            lastCommonSep = 0;
        }
        // Generate the relative path based on the path difference between `to` and
        // `from`
        for (i = fromStart + lastCommonSep + 1; i <= fromEnd; ++i) {
            if (i === fromEnd || from.charCodeAt(i) === CHAR_BACKWARD_SLASH) {
                if (out.length === 0) {
                    out += '..';
                } else
                {
                    out += '\\..';
                }
            }
        }
        // Lastly, append the rest of the destination (`to`) path that comes after
        // the common path parts
        if (out.length > 0) {
            return out + toOrig.slice(toStart + lastCommonSep, toEnd);
        } else
        {
            toStart += lastCommonSep;
            if (toOrig.charCodeAt(toStart) === CHAR_BACKWARD_SLASH) {
                ++toStart;
            }
            return toOrig.slice(toStart, toEnd);
        }
    },
    toNamespacedPath: function (path) {
        // Note: this will *probably* throw somewhere.
        if (typeof path !== 'string') {
            return path;
        }
        if (path.length === 0) {
            return '';
        }
        var resolvedPath = win32.resolve(path);
        if (resolvedPath.length >= 3) {
            if (resolvedPath.charCodeAt(0) === CHAR_BACKWARD_SLASH) {
                // Possible UNC root
                if (resolvedPath.charCodeAt(1) === CHAR_BACKWARD_SLASH) {
                    var code = resolvedPath.charCodeAt(2);
                    if (code !== CHAR_QUESTION_MARK && code !== CHAR_DOT) {
                        // Matched non-long UNC root, convert the path to a long UNC path
                        return '\\\\?\\UNC\\' + resolvedPath.slice(2);
                    }
                }
            } else
            if (isWindowsDeviceRoot(resolvedPath.charCodeAt(0))) {
                // Possible device root
                if (resolvedPath.charCodeAt(1) === CHAR_COLON &&
                resolvedPath.charCodeAt(2) === CHAR_BACKWARD_SLASH) {
                    // Matched device root, convert the path to a long UNC path
                    return '\\\\?\\' + resolvedPath;
                }
            }
        }
        return path;
    },
    dirname: function (path) {
        validateString(path, 'path');
        var len = path.length;
        if (len === 0) {
            return '.';
        }
        var rootEnd = -1;
        var end = -1;
        var matchedSlash = true;
        var offset = 0;
        var code = path.charCodeAt(0);
        // Try to match a root
        if (len > 1) {
            if (isPathSeparator(code)) {
                // Possible UNC root
                rootEnd = offset = 1;
                if (isPathSeparator(path.charCodeAt(1))) {
                    // Matched double path separator at beginning
                    var j = 2;
                    var last = j;
                    // Match 1 or more non-path separators
                    for (; j < len; ++j) {
                        if (isPathSeparator(path.charCodeAt(j))) {
                            break;
                        }
                    }
                    if (j < len && j !== last) {
                        // Matched!
                        last = j;
                        // Match 1 or more path separators
                        for (; j < len; ++j) {
                            if (!isPathSeparator(path.charCodeAt(j))) {
                                break;
                            }
                        }
                        if (j < len && j !== last) {
                            // Matched!
                            last = j;
                            // Match 1 or more non-path separators
                            for (; j < len; ++j) {
                                if (isPathSeparator(path.charCodeAt(j))) {
                                    break;
                                }
                            }
                            if (j === len) {
                                // We matched a UNC root only
                                return path;
                            }
                            if (j !== last) {
                                // We matched a UNC root with leftovers
                                // Offset by 1 to include the separator after the UNC root to
                                // treat it as a "normal root" on top of a (UNC) root
                                rootEnd = offset = j + 1;
                            }
                        }
                    }
                }
            } else
            if (isWindowsDeviceRoot(code)) {
                // Possible device root
                if (path.charCodeAt(1) === CHAR_COLON) {
                    rootEnd = offset = 2;
                    if (len > 2) {
                        if (isPathSeparator(path.charCodeAt(2))) {
                            rootEnd = offset = 3;
                        }
                    }
                }
            }
        } else
        if (isPathSeparator(code)) {
            // `path` contains just a path separator, exit early to avoid
            // unnecessary work
            return path;
        }
        for (var i = len - 1; i >= offset; --i) {
            if (isPathSeparator(path.charCodeAt(i))) {
                if (!matchedSlash) {
                    end = i;
                    break;
                }
            } else
            {
                // We saw the first non-path separator
                matchedSlash = false;
            }
        }
        if (end === -1) {
            if (rootEnd === -1) {
                return '.';
            } else
            {
                end = rootEnd;
            }
        }
        return path.slice(0, end);
    },
    basename: function (path, ext) {
        if (ext !== undefined) {
            validateString(ext, 'ext');
        }
        validateString(path, 'path');
        var start = 0;
        var end = -1;
        var matchedSlash = true;
        var i;
        // Check for a drive letter prefix so as not to mistake the following
        // path separator as an extra separator at the end of the path that can be
        // disregarded
        if (path.length >= 2) {
            var drive = path.charCodeAt(0);
            if (isWindowsDeviceRoot(drive)) {
                if (path.charCodeAt(1) === CHAR_COLON) {
                    start = 2;
                }
            }
        }
        if (ext !== undefined && ext.length > 0 && ext.length <= path.length) {
            if (ext.length === path.length && ext === path) {
                return '';
            }
            var extIdx = ext.length - 1;
            var firstNonSlashEnd = -1;
            for (i = path.length - 1; i >= start; --i) {
                var code = path.charCodeAt(i);
                if (isPathSeparator(code)) {
                    // If we reached a path separator that was not part of a set of path
                    // separators at the end of the string, stop now
                    if (!matchedSlash) {
                        start = i + 1;
                        break;
                    }
                } else
                {
                    if (firstNonSlashEnd === -1) {
                        // We saw the first non-path separator, remember this index in case
                        // we need it if the extension ends up not matching
                        matchedSlash = false;
                        firstNonSlashEnd = i + 1;
                    }
                    if (extIdx >= 0) {
                        // Try to match the explicit extension
                        if (code === ext.charCodeAt(extIdx)) {
                            if (--extIdx === -1) {
                                // We matched the extension, so mark this as the end of our path
                                // component
                                end = i;
                            }
                        } else
                        {
                            // Extension does not match, so our result is the entire path
                            // component
                            extIdx = -1;
                            end = firstNonSlashEnd;
                        }
                    }
                }
            }
            if (start === end) {
                end = firstNonSlashEnd;
            } else
            if (end === -1) {
                end = path.length;
            }
            return path.slice(start, end);
        } else
        {
            for (i = path.length - 1; i >= start; --i) {
                if (isPathSeparator(path.charCodeAt(i))) {
                    // If we reached a path separator that was not part of a set of path
                    // separators at the end of the string, stop now
                    if (!matchedSlash) {
                        start = i + 1;
                        break;
                    }
                } else
                if (end === -1) {
                    // We saw the first non-path separator, mark this as the end of our
                    // path component
                    matchedSlash = false;
                    end = i + 1;
                }
            }
            if (end === -1) {
                return '';
            }
            return path.slice(start, end);
        }
    },
    extname: function (path) {
        validateString(path, 'path');
        var start = 0;
        var startDot = -1;
        var startPart = 0;
        var end = -1;
        var matchedSlash = true;
        // Track the state of characters (if any) we see before our first dot and
        // after any path separator we find
        var preDotState = 0;
        // Check for a drive letter prefix so as not to mistake the following
        // path separator as an extra separator at the end of the path that can be
        // disregarded
        if (path.length >= 2 &&
        path.charCodeAt(1) === CHAR_COLON &&
        isWindowsDeviceRoot(path.charCodeAt(0))) {
            start = startPart = 2;
        }
        for (var i = path.length - 1; i >= start; --i) {
            var code = path.charCodeAt(i);
            if (isPathSeparator(code)) {
                // If we reached a path separator that was not part of a set of path
                // separators at the end of the string, stop now
                if (!matchedSlash) {
                    startPart = i + 1;
                    break;
                }
                continue;
            }
            if (end === -1) {
                // We saw the first non-path separator, mark this as the end of our
                // extension
                matchedSlash = false;
                end = i + 1;
            }
            if (code === CHAR_DOT) {
                // If this is our first dot, mark it as the start of our extension
                if (startDot === -1) {
                    startDot = i;
                } else
                if (preDotState !== 1) {
                    preDotState = 1;
                }
            } else
            if (startDot !== -1) {
                // We saw a non-dot and non-path separator before our dot, so we should
                // have a good chance at having a non-empty extension
                preDotState = -1;
            }
        }
        if (startDot === -1 ||
        end === -1 ||
        // We saw a non-dot character immediately before the dot
        preDotState === 0 ||
        // The (right-most) trimmed path component is exactly '..'
        preDotState === 1 &&
        startDot === end - 1 &&
        startDot === startPart + 1) {
            return '';
        }
        return path.slice(startDot, end);
    },
    format: function (pathObject) {
        if (pathObject === null || typeof pathObject !== 'object') {
            throw new ErrorInvalidArgType('pathObject', 'Object', pathObject);
        }
        return _format('\\', pathObject);
    },
    parse: function (path) {
        validateString(path, 'path');
        var ret = { root: '', dir: '', base: '', ext: '', name: '' };
        if (path.length === 0) {
            return ret;
        }
        var len = path.length;
        var rootEnd = 0;
        var code = path.charCodeAt(0);
        // Try to match a root
        if (len > 1) {
            if (isPathSeparator(code)) {
                // Possible UNC root
                rootEnd = 1;
                if (isPathSeparator(path.charCodeAt(1))) {
                    // Matched double path separator at beginning
                    var j = 2;
                    var last = j;
                    // Match 1 or more non-path separators
                    for (; j < len; ++j) {
                        if (isPathSeparator(path.charCodeAt(j))) {
                            break;
                        }
                    }
                    if (j < len && j !== last) {
                        // Matched!
                        last = j;
                        // Match 1 or more path separators
                        for (; j < len; ++j) {
                            if (!isPathSeparator(path.charCodeAt(j))) {
                                break;
                            }
                        }
                        if (j < len && j !== last) {
                            // Matched!
                            last = j;
                            // Match 1 or more non-path separators
                            for (; j < len; ++j) {
                                if (isPathSeparator(path.charCodeAt(j))) {
                                    break;
                                }
                            }
                            if (j === len) {
                                // We matched a UNC root only
                                rootEnd = j;
                            } else
                            if (j !== last) {
                                // We matched a UNC root with leftovers
                                rootEnd = j + 1;
                            }
                        }
                    }
                }
            } else
            if (isWindowsDeviceRoot(code)) {
                // Possible device root
                if (path.charCodeAt(1) === CHAR_COLON) {
                    rootEnd = 2;
                    if (len > 2) {
                        if (isPathSeparator(path.charCodeAt(2))) {
                            if (len === 3) {
                                // `path` contains just a drive root, exit early to avoid
                                // unnecessary work
                                ret.root = ret.dir = path;
                                return ret;
                            }
                            rootEnd = 3;
                        }
                    } else
                    {
                        // `path` contains just a drive root, exit early to avoid
                        // unnecessary work
                        ret.root = ret.dir = path;
                        return ret;
                    }
                }
            }
        } else
        if (isPathSeparator(code)) {
            // `path` contains just a path separator, exit early to avoid
            // unnecessary work
            ret.root = ret.dir = path;
            return ret;
        }
        if (rootEnd > 0) {
            ret.root = path.slice(0, rootEnd);
        }
        var startDot = -1;
        var startPart = rootEnd;
        var end = -1;
        var matchedSlash = true;
        var i = path.length - 1;
        // Track the state of characters (if any) we see before our first dot and
        // after any path separator we find
        var preDotState = 0;
        // Get non-dir info
        for (; i >= rootEnd; --i) {
            code = path.charCodeAt(i);
            if (isPathSeparator(code)) {
                // If we reached a path separator that was not part of a set of path
                // separators at the end of the string, stop now
                if (!matchedSlash) {
                    startPart = i + 1;
                    break;
                }
                continue;
            }
            if (end === -1) {
                // We saw the first non-path separator, mark this as the end of our
                // extension
                matchedSlash = false;
                end = i + 1;
            }
            if (code === CHAR_DOT) {
                // If this is our first dot, mark it as the start of our extension
                if (startDot === -1) {
                    startDot = i;
                } else
                if (preDotState !== 1) {
                    preDotState = 1;
                }
            } else
            if (startDot !== -1) {
                // We saw a non-dot and non-path separator before our dot, so we should
                // have a good chance at having a non-empty extension
                preDotState = -1;
            }
        }
        if (startDot === -1 ||
        end === -1 ||
        // We saw a non-dot character immediately before the dot
        preDotState === 0 ||
        // The (right-most) trimmed path component is exactly '..'
        preDotState === 1 &&
        startDot === end - 1 &&
        startDot === startPart + 1) {
            if (end !== -1) {
                ret.base = ret.name = path.slice(startPart, end);
            }
        } else
        {
            ret.name = path.slice(startPart, startDot);
            ret.base = path.slice(startPart, end);
            ret.ext = path.slice(startDot, end);
        }
        // If the directory is the root, use the entire root as the `dir` including
        // the trailing slash if any (`C:\abc` -> `C:\`). Otherwise, strip out the
        // trailing slash (`C:\abc\def` -> `C:\abc`).
        if (startPart > 0 && startPart !== rootEnd) {
            ret.dir = path.slice(0, startPart - 1);
        } else
        {
            ret.dir = ret.root;
        }
        return ret;
    },
    sep: '\\',
    delimiter: ';',
    win32: null,
    posix: null };

var posix = {
    // path.resolve([from ...], to)
    resolve: function () {
        var pathSegments = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            pathSegments[_i] = arguments[_i];
        }
        var resolvedPath = '';
        var resolvedAbsolute = false;
        for (var i = pathSegments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
            var path = void 0;
            if (i >= 0) {
                path = pathSegments[i];
            } else
            {
                path = _process_js__WEBPACK_IMPORTED_MODULE_0__["cwd"]();
            }
            validateString(path, 'path');
            // Skip empty entries
            if (path.length === 0) {
                continue;
            }
            resolvedPath = path + '/' + resolvedPath;
            resolvedAbsolute = path.charCodeAt(0) === CHAR_FORWARD_SLASH;
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        // Normalize the path
        resolvedPath = normalizeString(resolvedPath, !resolvedAbsolute, '/', isPosixPathSeparator);
        if (resolvedAbsolute) {
            if (resolvedPath.length > 0) {
                return '/' + resolvedPath;
            } else
            {
                return '/';
            }
        } else
        if (resolvedPath.length > 0) {
            return resolvedPath;
        } else
        {
            return '.';
        }
    },
    normalize: function (path) {
        validateString(path, 'path');
        if (path.length === 0) {
            return '.';
        }
        var isAbsolute = path.charCodeAt(0) === CHAR_FORWARD_SLASH;
        var trailingSeparator = path.charCodeAt(path.length - 1) === CHAR_FORWARD_SLASH;
        // Normalize the path
        path = normalizeString(path, !isAbsolute, '/', isPosixPathSeparator);
        if (path.length === 0 && !isAbsolute) {
            path = '.';
        }
        if (path.length > 0 && trailingSeparator) {
            path += '/';
        }
        if (isAbsolute) {
            return '/' + path;
        }
        return path;
    },
    isAbsolute: function (path) {
        validateString(path, 'path');
        return path.length > 0 && path.charCodeAt(0) === CHAR_FORWARD_SLASH;
    },
    join: function () {
        var paths = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            paths[_i] = arguments[_i];
        }
        if (paths.length === 0) {
            return '.';
        }
        var joined;
        for (var i = 0; i < paths.length; ++i) {
            var arg = arguments[i];
            validateString(arg, 'path');
            if (arg.length > 0) {
                if (joined === undefined) {
                    joined = arg;
                } else
                {
                    joined += '/' + arg;
                }
            }
        }
        if (joined === undefined) {
            return '.';
        }
        return posix.normalize(joined);
    },
    relative: function (from, to) {
        validateString(from, 'from');
        validateString(to, 'to');
        if (from === to) {
            return '';
        }
        from = posix.resolve(from);
        to = posix.resolve(to);
        if (from === to) {
            return '';
        }
        // Trim any leading backslashes
        var fromStart = 1;
        for (; fromStart < from.length; ++fromStart) {
            if (from.charCodeAt(fromStart) !== CHAR_FORWARD_SLASH) {
                break;
            }
        }
        var fromEnd = from.length;
        var fromLen = fromEnd - fromStart;
        // Trim any leading backslashes
        var toStart = 1;
        for (; toStart < to.length; ++toStart) {
            if (to.charCodeAt(toStart) !== CHAR_FORWARD_SLASH) {
                break;
            }
        }
        var toEnd = to.length;
        var toLen = toEnd - toStart;
        // Compare paths to find the longest common path from root
        var length = fromLen < toLen ? fromLen : toLen;
        var lastCommonSep = -1;
        var i = 0;
        for (; i <= length; ++i) {
            if (i === length) {
                if (toLen > length) {
                    if (to.charCodeAt(toStart + i) === CHAR_FORWARD_SLASH) {
                        // We get here if `from` is the exact base path for `to`.
                        // For example: from='/foo/bar'; to='/foo/bar/baz'
                        return to.slice(toStart + i + 1);
                    } else
                    if (i === 0) {
                        // We get here if `from` is the root
                        // For example: from='/'; to='/foo'
                        return to.slice(toStart + i);
                    }
                } else
                if (fromLen > length) {
                    if (from.charCodeAt(fromStart + i) === CHAR_FORWARD_SLASH) {
                        // We get here if `to` is the exact base path for `from`.
                        // For example: from='/foo/bar/baz'; to='/foo/bar'
                        lastCommonSep = i;
                    } else
                    if (i === 0) {
                        // We get here if `to` is the root.
                        // For example: from='/foo'; to='/'
                        lastCommonSep = 0;
                    }
                }
                break;
            }
            var fromCode = from.charCodeAt(fromStart + i);
            var toCode = to.charCodeAt(toStart + i);
            if (fromCode !== toCode) {
                break;
            } else
            if (fromCode === CHAR_FORWARD_SLASH) {
                lastCommonSep = i;
            }
        }
        var out = '';
        // Generate the relative path based on the path difference between `to`
        // and `from`
        for (i = fromStart + lastCommonSep + 1; i <= fromEnd; ++i) {
            if (i === fromEnd || from.charCodeAt(i) === CHAR_FORWARD_SLASH) {
                if (out.length === 0) {
                    out += '..';
                } else
                {
                    out += '/..';
                }
            }
        }
        // Lastly, append the rest of the destination (`to`) path that comes after
        // the common path parts
        if (out.length > 0) {
            return out + to.slice(toStart + lastCommonSep);
        } else
        {
            toStart += lastCommonSep;
            if (to.charCodeAt(toStart) === CHAR_FORWARD_SLASH) {
                ++toStart;
            }
            return to.slice(toStart);
        }
    },
    toNamespacedPath: function (path) {
        // Non-op on posix systems
        return path;
    },
    dirname: function (path) {
        validateString(path, 'path');
        if (path.length === 0) {
            return '.';
        }
        var hasRoot = path.charCodeAt(0) === CHAR_FORWARD_SLASH;
        var end = -1;
        var matchedSlash = true;
        for (var i = path.length - 1; i >= 1; --i) {
            if (path.charCodeAt(i) === CHAR_FORWARD_SLASH) {
                if (!matchedSlash) {
                    end = i;
                    break;
                }
            } else
            {
                // We saw the first non-path separator
                matchedSlash = false;
            }
        }
        if (end === -1) {
            return hasRoot ? '/' : '.';
        }
        if (hasRoot && end === 1) {
            return '//';
        }
        return path.slice(0, end);
    },
    basename: function (path, ext) {
        if (ext !== undefined) {
            validateString(ext, 'ext');
        }
        validateString(path, 'path');
        var start = 0;
        var end = -1;
        var matchedSlash = true;
        var i;
        if (ext !== undefined && ext.length > 0 && ext.length <= path.length) {
            if (ext.length === path.length && ext === path) {
                return '';
            }
            var extIdx = ext.length - 1;
            var firstNonSlashEnd = -1;
            for (i = path.length - 1; i >= 0; --i) {
                var code = path.charCodeAt(i);
                if (code === CHAR_FORWARD_SLASH) {
                    // If we reached a path separator that was not part of a set of path
                    // separators at the end of the string, stop now
                    if (!matchedSlash) {
                        start = i + 1;
                        break;
                    }
                } else
                {
                    if (firstNonSlashEnd === -1) {
                        // We saw the first non-path separator, remember this index in case
                        // we need it if the extension ends up not matching
                        matchedSlash = false;
                        firstNonSlashEnd = i + 1;
                    }
                    if (extIdx >= 0) {
                        // Try to match the explicit extension
                        if (code === ext.charCodeAt(extIdx)) {
                            if (--extIdx === -1) {
                                // We matched the extension, so mark this as the end of our path
                                // component
                                end = i;
                            }
                        } else
                        {
                            // Extension does not match, so our result is the entire path
                            // component
                            extIdx = -1;
                            end = firstNonSlashEnd;
                        }
                    }
                }
            }
            if (start === end) {
                end = firstNonSlashEnd;
            } else
            if (end === -1) {
                end = path.length;
            }
            return path.slice(start, end);
        } else
        {
            for (i = path.length - 1; i >= 0; --i) {
                if (path.charCodeAt(i) === CHAR_FORWARD_SLASH) {
                    // If we reached a path separator that was not part of a set of path
                    // separators at the end of the string, stop now
                    if (!matchedSlash) {
                        start = i + 1;
                        break;
                    }
                } else
                if (end === -1) {
                    // We saw the first non-path separator, mark this as the end of our
                    // path component
                    matchedSlash = false;
                    end = i + 1;
                }
            }
            if (end === -1) {
                return '';
            }
            return path.slice(start, end);
        }
    },
    extname: function (path) {
        validateString(path, 'path');
        var startDot = -1;
        var startPart = 0;
        var end = -1;
        var matchedSlash = true;
        // Track the state of characters (if any) we see before our first dot and
        // after any path separator we find
        var preDotState = 0;
        for (var i = path.length - 1; i >= 0; --i) {
            var code = path.charCodeAt(i);
            if (code === CHAR_FORWARD_SLASH) {
                // If we reached a path separator that was not part of a set of path
                // separators at the end of the string, stop now
                if (!matchedSlash) {
                    startPart = i + 1;
                    break;
                }
                continue;
            }
            if (end === -1) {
                // We saw the first non-path separator, mark this as the end of our
                // extension
                matchedSlash = false;
                end = i + 1;
            }
            if (code === CHAR_DOT) {
                // If this is our first dot, mark it as the start of our extension
                if (startDot === -1) {
                    startDot = i;
                } else
                if (preDotState !== 1) {
                    preDotState = 1;
                }
            } else
            if (startDot !== -1) {
                // We saw a non-dot and non-path separator before our dot, so we should
                // have a good chance at having a non-empty extension
                preDotState = -1;
            }
        }
        if (startDot === -1 ||
        end === -1 ||
        // We saw a non-dot character immediately before the dot
        preDotState === 0 ||
        // The (right-most) trimmed path component is exactly '..'
        preDotState === 1 &&
        startDot === end - 1 &&
        startDot === startPart + 1) {
            return '';
        }
        return path.slice(startDot, end);
    },
    format: function (pathObject) {
        if (pathObject === null || typeof pathObject !== 'object') {
            throw new ErrorInvalidArgType('pathObject', 'Object', pathObject);
        }
        return _format('/', pathObject);
    },
    parse: function (path) {
        validateString(path, 'path');
        var ret = { root: '', dir: '', base: '', ext: '', name: '' };
        if (path.length === 0) {
            return ret;
        }
        var isAbsolute = path.charCodeAt(0) === CHAR_FORWARD_SLASH;
        var start;
        if (isAbsolute) {
            ret.root = '/';
            start = 1;
        } else
        {
            start = 0;
        }
        var startDot = -1;
        var startPart = 0;
        var end = -1;
        var matchedSlash = true;
        var i = path.length - 1;
        // Track the state of characters (if any) we see before our first dot and
        // after any path separator we find
        var preDotState = 0;
        // Get non-dir info
        for (; i >= start; --i) {
            var code = path.charCodeAt(i);
            if (code === CHAR_FORWARD_SLASH) {
                // If we reached a path separator that was not part of a set of path
                // separators at the end of the string, stop now
                if (!matchedSlash) {
                    startPart = i + 1;
                    break;
                }
                continue;
            }
            if (end === -1) {
                // We saw the first non-path separator, mark this as the end of our
                // extension
                matchedSlash = false;
                end = i + 1;
            }
            if (code === CHAR_DOT) {
                // If this is our first dot, mark it as the start of our extension
                if (startDot === -1) {
                    startDot = i;
                } else
                if (preDotState !== 1) {
                    preDotState = 1;
                }
            } else
            if (startDot !== -1) {
                // We saw a non-dot and non-path separator before our dot, so we should
                // have a good chance at having a non-empty extension
                preDotState = -1;
            }
        }
        if (startDot === -1 ||
        end === -1 ||
        // We saw a non-dot character immediately before the dot
        preDotState === 0 ||
        // The (right-most) trimmed path component is exactly '..'
        preDotState === 1 &&
        startDot === end - 1 &&
        startDot === startPart + 1) {
            if (end !== -1) {
                if (startPart === 0 && isAbsolute) {
                    ret.base = ret.name = path.slice(1, end);
                } else
                {
                    ret.base = ret.name = path.slice(startPart, end);
                }
            }
        } else
        {
            if (startPart === 0 && isAbsolute) {
                ret.name = path.slice(1, startDot);
                ret.base = path.slice(1, end);
            } else
            {
                ret.name = path.slice(startPart, startDot);
                ret.base = path.slice(startPart, end);
            }
            ret.ext = path.slice(startDot, end);
        }
        if (startPart > 0) {
            ret.dir = path.slice(0, startPart - 1);
        } else
        if (isAbsolute) {
            ret.dir = '/';
        }
        return ret;
    },
    sep: '/',
    delimiter: ':',
    win32: null,
    posix: null };

posix.win32 = win32.win32 = win32;
posix.posix = win32.posix = posix;
var normalize = _process_js__WEBPACK_IMPORTED_MODULE_0__["platform"] === 'win32' ? win32.normalize : posix.normalize;
var join = _process_js__WEBPACK_IMPORTED_MODULE_0__["platform"] === 'win32' ? win32.join : posix.join;
var relative = _process_js__WEBPACK_IMPORTED_MODULE_0__["platform"] === 'win32' ? win32.relative : posix.relative;
var dirname = _process_js__WEBPACK_IMPORTED_MODULE_0__["platform"] === 'win32' ? win32.dirname : posix.dirname;
var basename = _process_js__WEBPACK_IMPORTED_MODULE_0__["platform"] === 'win32' ? win32.basename : posix.basename;
var extname = _process_js__WEBPACK_IMPORTED_MODULE_0__["platform"] === 'win32' ? win32.extname : posix.extname;
var sep = _process_js__WEBPACK_IMPORTED_MODULE_0__["platform"] === 'win32' ? win32.sep : posix.sep;

/***/ }),

/***/ 6270:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(process) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "cwd", function() { return cwd; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "env", function() { return env; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "platform", function() { return platform; });
/* harmony import */ var _platform_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6222);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/

var safeProcess = typeof process === 'undefined' ? {
    cwd: function () {return '/';},
    env: Object.create(null),
    get platform() {return _platform_js__WEBPACK_IMPORTED_MODULE_0__["isWindows"] ? 'win32' : _platform_js__WEBPACK_IMPORTED_MODULE_0__["isMacintosh"] ? 'darwin' : 'linux';},
    nextTick: function (callback) {return Object(_platform_js__WEBPACK_IMPORTED_MODULE_0__["setImmediate"])(callback);} } :
process;
var cwd = safeProcess.cwd;
var env = safeProcess.env;
var platform = safeProcess.platform;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(31)))

/***/ }),

/***/ 6271:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "TokenizationRegistryImpl", function() { return TokenizationRegistryImpl; });
/* harmony import */ var _base_common_event_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6213);
/* harmony import */ var _base_common_lifecycle_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6216);
/* harmony import */ var _base_common_types_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6232);
/* harmony import */ var _base_common_map_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6233);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/




var TokenizationRegistryImpl = /** @class */function () {
    function TokenizationRegistryImpl() {
        this._map = new Map();
        this._promises = new Map();
        this._onDidChange = new _base_common_event_js__WEBPACK_IMPORTED_MODULE_0__["Emitter"]();
        this.onDidChange = this._onDidChange.event;
        this._colorMap = null;
    }
    TokenizationRegistryImpl.prototype.fire = function (languages) {
        this._onDidChange.fire({
            changedLanguages: languages,
            changedColorMap: false });

    };
    TokenizationRegistryImpl.prototype.register = function (language, support) {
        var _this = this;
        this._map.set(language, support);
        this.fire([language]);
        return Object(_base_common_lifecycle_js__WEBPACK_IMPORTED_MODULE_1__["toDisposable"])(function () {
            if (_this._map.get(language) !== support) {
                return;
            }
            _this._map.delete(language);
            _this.fire([language]);
        });
    };
    TokenizationRegistryImpl.prototype.registerPromise = function (language, supportPromise) {
        var _this = this;
        var registration = null;
        var isDisposed = false;
        this._promises.set(language, supportPromise.then(function (support) {
            _this._promises.delete(language);
            if (isDisposed || !support) {
                return;
            }
            registration = _this.register(language, support);
        }));
        return Object(_base_common_lifecycle_js__WEBPACK_IMPORTED_MODULE_1__["toDisposable"])(function () {
            isDisposed = true;
            if (registration) {
                registration.dispose();
            }
        });
    };
    TokenizationRegistryImpl.prototype.getPromise = function (language) {
        var _this = this;
        var support = this.get(language);
        if (support) {
            return Promise.resolve(support);
        }
        var promise = this._promises.get(language);
        if (promise) {
            return promise.then(function (_) {return _this.get(language);});
        }
        return null;
    };
    TokenizationRegistryImpl.prototype.get = function (language) {
        return Object(_base_common_types_js__WEBPACK_IMPORTED_MODULE_2__["withUndefinedAsNull"])(this._map.get(language));
    };
    TokenizationRegistryImpl.prototype.setColorMap = function (colorMap) {
        this._colorMap = colorMap;
        this._onDidChange.fire({
            changedLanguages: Object(_base_common_map_js__WEBPACK_IMPORTED_MODULE_3__["keys"])(this._map),
            changedColorMap: true });

    };
    TokenizationRegistryImpl.prototype.getColorMap = function () {
        return this._colorMap;
    };
    TokenizationRegistryImpl.prototype.getDefaultBackground = function () {
        if (this._colorMap && this._colorMap.length > 2 /* DefaultBackground */) {
                return this._colorMap[2 /* DefaultBackground */];
            }
        return null;
    };
    return TokenizationRegistryImpl;
}();


/***/ }),

/***/ 6292:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "clearNode", function() { return clearNode; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "removeNode", function() { return removeNode; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isInDOM", function() { return isInDOM; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "hasClass", function() { return hasClass; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addClass", function() { return addClass; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addClasses", function() { return addClasses; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "removeClass", function() { return removeClass; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "removeClasses", function() { return removeClasses; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "toggleClass", function() { return toggleClass; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addDisposableListener", function() { return addDisposableListener; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addStandardDisposableListener", function() { return addStandardDisposableListener; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addStandardDisposableGenericMouseDownListner", function() { return addStandardDisposableGenericMouseDownListner; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addDisposableGenericMouseDownListner", function() { return addDisposableGenericMouseDownListner; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addDisposableGenericMouseUpListner", function() { return addDisposableGenericMouseUpListner; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addDisposableNonBubblingMouseOutListener", function() { return addDisposableNonBubblingMouseOutListener; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addDisposableNonBubblingPointerOutListener", function() { return addDisposableNonBubblingPointerOutListener; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "runAtThisOrScheduleAtNextAnimationFrame", function() { return runAtThisOrScheduleAtNextAnimationFrame; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "scheduleAtNextAnimationFrame", function() { return scheduleAtNextAnimationFrame; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addDisposableThrottledListener", function() { return addDisposableThrottledListener; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getComputedStyle", function() { return getComputedStyle; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getClientArea", function() { return getClientArea; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Dimension", function() { return Dimension; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getTopLeftOffset", function() { return getTopLeftOffset; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getDomNodePagePosition", function() { return getDomNodePagePosition; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "StandardWindow", function() { return StandardWindow; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getTotalWidth", function() { return getTotalWidth; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getContentWidth", function() { return getContentWidth; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getContentHeight", function() { return getContentHeight; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getTotalHeight", function() { return getTotalHeight; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isAncestor", function() { return isAncestor; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "findParentWithClass", function() { return findParentWithClass; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isShadowRoot", function() { return isShadowRoot; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isInShadowDOM", function() { return isInShadowDOM; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getShadowRoot", function() { return getShadowRoot; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "createStyleSheet", function() { return createStyleSheet; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "createCSSRule", function() { return createCSSRule; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "removeCSSRulesContainingSelector", function() { return removeCSSRulesContainingSelector; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isHTMLElement", function() { return isHTMLElement; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "EventType", function() { return EventType; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "EventHelper", function() { return EventHelper; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "saveParentsScrollTop", function() { return saveParentsScrollTop; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "restoreParentsScrollTop", function() { return restoreParentsScrollTop; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "trackFocus", function() { return trackFocus; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "append", function() { return append; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Namespace", function() { return Namespace; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "$", function() { return $; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "show", function() { return show; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "hide", function() { return hide; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "removeTabIndexAndUpdateFocus", function() { return removeTabIndexAndUpdateFocus; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getElementsByTagName", function() { return getElementsByTagName; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "computeScreenAwareSize", function() { return computeScreenAwareSize; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "windowOpenNoOpener", function() { return windowOpenNoOpener; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "animate", function() { return animate; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "asDomUri", function() { return asDomUri; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "asCSSUrl", function() { return asCSSUrl; });
/* harmony import */ var _browser_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6293);
/* harmony import */ var _event_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6294);
/* harmony import */ var _keyboardEvent_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6295);
/* harmony import */ var _mouseEvent_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6296);
/* harmony import */ var _common_async_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6211);
/* harmony import */ var _common_errors_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6214);
/* harmony import */ var _common_event_js__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(6213);
/* harmony import */ var _common_lifecycle_js__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(6216);
/* harmony import */ var _common_platform_js__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(6222);
/* harmony import */ var _common_arrays_js__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(6262);
/* harmony import */ var _common_network_js__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(6298);
/* harmony import */ var _canIUse_js__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(6299);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __extends = undefined && undefined.__extends || function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
        { __proto__: [] } instanceof Array && function (d, b) {d.__proto__ = b;} ||
        function (d, b) {for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];};
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {this.constructor = d;}
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();
var __assign = undefined && undefined.__assign || function () {
    __assign = Object.assign || function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = undefined && undefined.__spreadArrays || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
    for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
    r[k] = a[j];
    return r;
};












function clearNode(node) {
    while (node.firstChild) {
        node.removeChild(node.firstChild);
    }
}
function removeNode(node) {
    if (node.parentNode) {
        node.parentNode.removeChild(node);
    }
}
function isInDOM(node) {
    while (node) {
        if (node === document.body) {
            return true;
        }
        node = node.parentNode || node.host;
    }
    return false;
}
var _manualClassList = new ( /** @class */function () {
    function class_1() {
        this._lastStart = -1;
        this._lastEnd = -1;
    }
    class_1.prototype._findClassName = function (node, className) {
        var classes = node.className;
        if (!classes) {
            this._lastStart = -1;
            return;
        }
        className = className.trim();
        var classesLen = classes.length,classLen = className.length;
        if (classLen === 0) {
            this._lastStart = -1;
            return;
        }
        if (classesLen < classLen) {
            this._lastStart = -1;
            return;
        }
        if (classes === className) {
            this._lastStart = 0;
            this._lastEnd = classesLen;
            return;
        }
        var idx = -1,idxEnd;
        while ((idx = classes.indexOf(className, idx + 1)) >= 0) {
            idxEnd = idx + classLen;
            // a class that is followed by another class
            if ((idx === 0 || classes.charCodeAt(idx - 1) === 32 /* Space */) && classes.charCodeAt(idxEnd) === 32 /* Space */) {
                    this._lastStart = idx;
                    this._lastEnd = idxEnd + 1;
                    return;
                }
            // last class
            if (idx > 0 && classes.charCodeAt(idx - 1) === 32 /* Space */ && idxEnd === classesLen) {
                this._lastStart = idx - 1;
                this._lastEnd = idxEnd;
                return;
            }
            // equal - duplicate of cmp above
            if (idx === 0 && idxEnd === classesLen) {
                this._lastStart = 0;
                this._lastEnd = idxEnd;
                return;
            }
        }
        this._lastStart = -1;
    };
    class_1.prototype.hasClass = function (node, className) {
        this._findClassName(node, className);
        return this._lastStart !== -1;
    };
    class_1.prototype.addClasses = function (node) {
        var _this = this;
        var classNames = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            classNames[_i - 1] = arguments[_i];
        }
        classNames.forEach(function (nameValue) {return nameValue.split(' ').forEach(function (name) {return _this.addClass(node, name);});});
    };
    class_1.prototype.addClass = function (node, className) {
        if (!node.className) {// doesn't have it for sure
            node.className = className;
        } else
        {
            this._findClassName(node, className); // see if it's already there
            if (this._lastStart === -1) {
                node.className = node.className + ' ' + className;
            }
        }
    };
    class_1.prototype.removeClass = function (node, className) {
        this._findClassName(node, className);
        if (this._lastStart === -1) {
            return; // Prevent styles invalidation if not necessary
        } else
        {
            node.className = node.className.substring(0, this._lastStart) + node.className.substring(this._lastEnd);
        }
    };
    class_1.prototype.removeClasses = function (node) {
        var _this = this;
        var classNames = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            classNames[_i - 1] = arguments[_i];
        }
        classNames.forEach(function (nameValue) {return nameValue.split(' ').forEach(function (name) {return _this.removeClass(node, name);});});
    };
    class_1.prototype.toggleClass = function (node, className, shouldHaveIt) {
        this._findClassName(node, className);
        if (this._lastStart !== -1 && (shouldHaveIt === undefined || !shouldHaveIt)) {
            this.removeClass(node, className);
        }
        if (this._lastStart === -1 && (shouldHaveIt === undefined || shouldHaveIt)) {
            this.addClass(node, className);
        }
    };
    return class_1;
}())();
var _nativeClassList = new ( /** @class */function () {
    function class_2() {
    }
    class_2.prototype.hasClass = function (node, className) {
        return Boolean(className) && node.classList && node.classList.contains(className);
    };
    class_2.prototype.addClasses = function (node) {
        var _this = this;
        var classNames = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            classNames[_i - 1] = arguments[_i];
        }
        classNames.forEach(function (nameValue) {return nameValue.split(' ').forEach(function (name) {return _this.addClass(node, name);});});
    };
    class_2.prototype.addClass = function (node, className) {
        if (className && node.classList) {
            node.classList.add(className);
        }
    };
    class_2.prototype.removeClass = function (node, className) {
        if (className && node.classList) {
            node.classList.remove(className);
        }
    };
    class_2.prototype.removeClasses = function (node) {
        var _this = this;
        var classNames = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            classNames[_i - 1] = arguments[_i];
        }
        classNames.forEach(function (nameValue) {return nameValue.split(' ').forEach(function (name) {return _this.removeClass(node, name);});});
    };
    class_2.prototype.toggleClass = function (node, className, shouldHaveIt) {
        if (node.classList) {
            node.classList.toggle(className, shouldHaveIt);
        }
    };
    return class_2;
}())();
// In IE11 there is only partial support for `classList` which makes us keep our
// custom implementation. Otherwise use the native implementation, see: http://caniuse.com/#search=classlist
var _classList = _browser_js__WEBPACK_IMPORTED_MODULE_0__["isIE"] ? _manualClassList : _nativeClassList;
var hasClass = _classList.hasClass.bind(_classList);
var addClass = _classList.addClass.bind(_classList);
var addClasses = _classList.addClasses.bind(_classList);
var removeClass = _classList.removeClass.bind(_classList);
var removeClasses = _classList.removeClasses.bind(_classList);
var toggleClass = _classList.toggleClass.bind(_classList);
var DomListener = /** @class */function () {
    function DomListener(node, type, handler, options) {
        this._node = node;
        this._type = type;
        this._handler = handler;
        this._options = options || false;
        this._node.addEventListener(this._type, this._handler, this._options);
    }
    DomListener.prototype.dispose = function () {
        if (!this._handler) {
            // Already disposed
            return;
        }
        this._node.removeEventListener(this._type, this._handler, this._options);
        // Prevent leakers from holding on to the dom or handler func
        this._node = null;
        this._handler = null;
    };
    return DomListener;
}();
function addDisposableListener(node, type, handler, useCaptureOrOptions) {
    return new DomListener(node, type, handler, useCaptureOrOptions);
}
function _wrapAsStandardMouseEvent(handler) {
    return function (e) {
        return handler(new _mouseEvent_js__WEBPACK_IMPORTED_MODULE_3__["StandardMouseEvent"](e));
    };
}
function _wrapAsStandardKeyboardEvent(handler) {
    return function (e) {
        return handler(new _keyboardEvent_js__WEBPACK_IMPORTED_MODULE_2__["StandardKeyboardEvent"](e));
    };
}
var addStandardDisposableListener = function addStandardDisposableListener(node, type, handler, useCapture) {
    var wrapHandler = handler;
    if (type === 'click' || type === 'mousedown') {
        wrapHandler = _wrapAsStandardMouseEvent(handler);
    } else
    if (type === 'keydown' || type === 'keypress' || type === 'keyup') {
        wrapHandler = _wrapAsStandardKeyboardEvent(handler);
    }
    return addDisposableListener(node, type, wrapHandler, useCapture);
};
var addStandardDisposableGenericMouseDownListner = function addStandardDisposableListener(node, handler, useCapture) {
    var wrapHandler = _wrapAsStandardMouseEvent(handler);
    return addDisposableGenericMouseDownListner(node, wrapHandler, useCapture);
};
function addDisposableGenericMouseDownListner(node, handler, useCapture) {
    return addDisposableListener(node, _common_platform_js__WEBPACK_IMPORTED_MODULE_8__["isIOS"] && _canIUse_js__WEBPACK_IMPORTED_MODULE_11__["BrowserFeatures"].pointerEvents ? EventType.POINTER_DOWN : EventType.MOUSE_DOWN, handler, useCapture);
}
function addDisposableGenericMouseUpListner(node, handler, useCapture) {
    return addDisposableListener(node, _common_platform_js__WEBPACK_IMPORTED_MODULE_8__["isIOS"] && _canIUse_js__WEBPACK_IMPORTED_MODULE_11__["BrowserFeatures"].pointerEvents ? EventType.POINTER_UP : EventType.MOUSE_UP, handler, useCapture);
}
function addDisposableNonBubblingMouseOutListener(node, handler) {
    return addDisposableListener(node, 'mouseout', function (e) {
        // Mouse out bubbles, so this is an attempt to ignore faux mouse outs coming from children elements
        var toElement = e.relatedTarget;
        while (toElement && toElement !== node) {
            toElement = toElement.parentNode;
        }
        if (toElement === node) {
            return;
        }
        handler(e);
    });
}
function addDisposableNonBubblingPointerOutListener(node, handler) {
    return addDisposableListener(node, 'pointerout', function (e) {
        // Mouse out bubbles, so this is an attempt to ignore faux mouse outs coming from children elements
        var toElement = e.relatedTarget;
        while (toElement && toElement !== node) {
            toElement = toElement.parentNode;
        }
        if (toElement === node) {
            return;
        }
        handler(e);
    });
}
var _animationFrame = null;
function doRequestAnimationFrame(callback) {
    if (!_animationFrame) {
        var emulatedRequestAnimationFrame = function (callback) {
            return setTimeout(function () {return callback(new Date().getTime());}, 0);
        };
        _animationFrame = self.requestAnimationFrame ||
        self.msRequestAnimationFrame ||
        self.webkitRequestAnimationFrame ||
        self.mozRequestAnimationFrame ||
        self.oRequestAnimationFrame ||
        emulatedRequestAnimationFrame;
    }
    return _animationFrame.call(self, callback);
}
/**
   * Schedule a callback to be run at the next animation frame.
   * This allows multiple parties to register callbacks that should run at the next animation frame.
   * If currently in an animation frame, `runner` will be executed immediately.
   * @return token that can be used to cancel the scheduled runner (only if `runner` was not executed immediately).
   */
var runAtThisOrScheduleAtNextAnimationFrame;
/**
                                                     * Schedule a callback to be run at the next animation frame.
                                                     * This allows multiple parties to register callbacks that should run at the next animation frame.
                                                     * If currently in an animation frame, `runner` will be executed at the next animation frame.
                                                     * @return token that can be used to cancel the scheduled runner.
                                                     */
var scheduleAtNextAnimationFrame;
var AnimationFrameQueueItem = /** @class */function () {
    function AnimationFrameQueueItem(runner, priority) {
        if (priority === void 0) {priority = 0;}
        this._runner = runner;
        this.priority = priority;
        this._canceled = false;
    }
    AnimationFrameQueueItem.prototype.dispose = function () {
        this._canceled = true;
    };
    AnimationFrameQueueItem.prototype.execute = function () {
        if (this._canceled) {
            return;
        }
        try {
            this._runner();
        }
        catch (e) {
            Object(_common_errors_js__WEBPACK_IMPORTED_MODULE_5__["onUnexpectedError"])(e);
        }
    };
    // Sort by priority (largest to lowest)
    AnimationFrameQueueItem.sort = function (a, b) {
        return b.priority - a.priority;
    };
    return AnimationFrameQueueItem;
}();
(function () {
    /**
               * The runners scheduled at the next animation frame
               */
    var NEXT_QUEUE = [];
    /**
                          * The runners scheduled at the current animation frame
                          */
    var CURRENT_QUEUE = null;
    /**
                               * A flag to keep track if the native requestAnimationFrame was already called
                               */
    var animFrameRequested = false;
    /**
                                     * A flag to indicate if currently handling a native requestAnimationFrame callback
                                     */
    var inAnimationFrameRunner = false;
    var animationFrameRunner = function () {
        animFrameRequested = false;
        CURRENT_QUEUE = NEXT_QUEUE;
        NEXT_QUEUE = [];
        inAnimationFrameRunner = true;
        while (CURRENT_QUEUE.length > 0) {
            CURRENT_QUEUE.sort(AnimationFrameQueueItem.sort);
            var top_1 = CURRENT_QUEUE.shift();
            top_1.execute();
        }
        inAnimationFrameRunner = false;
    };
    scheduleAtNextAnimationFrame = function (runner, priority) {
        if (priority === void 0) {priority = 0;}
        var item = new AnimationFrameQueueItem(runner, priority);
        NEXT_QUEUE.push(item);
        if (!animFrameRequested) {
            animFrameRequested = true;
            doRequestAnimationFrame(animationFrameRunner);
        }
        return item;
    };
    runAtThisOrScheduleAtNextAnimationFrame = function (runner, priority) {
        if (inAnimationFrameRunner) {
            var item = new AnimationFrameQueueItem(runner, priority);
            CURRENT_QUEUE.push(item);
            return item;
        } else
        {
            return scheduleAtNextAnimationFrame(runner, priority);
        }
    };
})();
var MINIMUM_TIME_MS = 16;
var DEFAULT_EVENT_MERGER = function (lastEvent, currentEvent) {
    return currentEvent;
};
var TimeoutThrottledDomListener = /** @class */function (_super) {
    __extends(TimeoutThrottledDomListener, _super);
    function TimeoutThrottledDomListener(node, type, handler, eventMerger, minimumTimeMs) {
        if (eventMerger === void 0) {eventMerger = DEFAULT_EVENT_MERGER;}
        if (minimumTimeMs === void 0) {minimumTimeMs = MINIMUM_TIME_MS;}
        var _this = _super.call(this) || this;
        var lastEvent = null;
        var lastHandlerTime = 0;
        var timeout = _this._register(new _common_async_js__WEBPACK_IMPORTED_MODULE_4__["TimeoutTimer"]());
        var invokeHandler = function () {
            lastHandlerTime = new Date().getTime();
            handler(lastEvent);
            lastEvent = null;
        };
        _this._register(addDisposableListener(node, type, function (e) {
            lastEvent = eventMerger(lastEvent, e);
            var elapsedTime = new Date().getTime() - lastHandlerTime;
            if (elapsedTime >= minimumTimeMs) {
                timeout.cancel();
                invokeHandler();
            } else
            {
                timeout.setIfNotSet(invokeHandler, minimumTimeMs - elapsedTime);
            }
        }));
        return _this;
    }
    return TimeoutThrottledDomListener;
}(_common_lifecycle_js__WEBPACK_IMPORTED_MODULE_7__["Disposable"]);
function addDisposableThrottledListener(node, type, handler, eventMerger, minimumTimeMs) {
    return new TimeoutThrottledDomListener(node, type, handler, eventMerger, minimumTimeMs);
}
function getComputedStyle(el) {
    return document.defaultView.getComputedStyle(el, null);
}
function getClientArea(element) {
    // Try with DOM clientWidth / clientHeight
    if (element !== document.body) {
        return new Dimension(element.clientWidth, element.clientHeight);
    }
    // If visual view port exits and it's on mobile, it should be used instead of window innerWidth / innerHeight, or document.body.clientWidth / document.body.clientHeight
    if (_common_platform_js__WEBPACK_IMPORTED_MODULE_8__["isIOS"] && window.visualViewport) {
        var width = window.visualViewport.width;
        var height = window.visualViewport.height - (_browser_js__WEBPACK_IMPORTED_MODULE_0__["isStandalone"]
        // in PWA mode, the visual viewport always includes the safe-area-inset-bottom (which is for the home indicator)
        // even when you are using the onscreen monitor, the visual viewport will include the area between system statusbar and the onscreen keyboard
        // plus the area between onscreen keyboard and the bottom bezel, which is 20px on iOS.
        ? 20 + 4 : // + 4px for body margin
        0);
        return new Dimension(width, height);
    }
    // Try innerWidth / innerHeight
    if (window.innerWidth && window.innerHeight) {
        return new Dimension(window.innerWidth, window.innerHeight);
    }
    // Try with document.body.clientWidth / document.body.clientHeight
    if (document.body && document.body.clientWidth && document.body.clientHeight) {
        return new Dimension(document.body.clientWidth, document.body.clientHeight);
    }
    // Try with document.documentElement.clientWidth / document.documentElement.clientHeight
    if (document.documentElement && document.documentElement.clientWidth && document.documentElement.clientHeight) {
        return new Dimension(document.documentElement.clientWidth, document.documentElement.clientHeight);
    }
    throw new Error('Unable to figure out browser width and height');
}
var SizeUtils = /** @class */function () {
    function SizeUtils() {
    }
    // Adapted from WinJS
    // Converts a CSS positioning string for the specified element to pixels.
    SizeUtils.convertToPixels = function (element, value) {
        return parseFloat(value) || 0;
    };
    SizeUtils.getDimension = function (element, cssPropertyName, jsPropertyName) {
        var computedStyle = getComputedStyle(element);
        var value = '0';
        if (computedStyle) {
            if (computedStyle.getPropertyValue) {
                value = computedStyle.getPropertyValue(cssPropertyName);
            } else
            {
                // IE8
                value = computedStyle.getAttribute(jsPropertyName);
            }
        }
        return SizeUtils.convertToPixels(element, value);
    };
    SizeUtils.getBorderLeftWidth = function (element) {
        return SizeUtils.getDimension(element, 'border-left-width', 'borderLeftWidth');
    };
    SizeUtils.getBorderRightWidth = function (element) {
        return SizeUtils.getDimension(element, 'border-right-width', 'borderRightWidth');
    };
    SizeUtils.getBorderTopWidth = function (element) {
        return SizeUtils.getDimension(element, 'border-top-width', 'borderTopWidth');
    };
    SizeUtils.getBorderBottomWidth = function (element) {
        return SizeUtils.getDimension(element, 'border-bottom-width', 'borderBottomWidth');
    };
    SizeUtils.getPaddingLeft = function (element) {
        return SizeUtils.getDimension(element, 'padding-left', 'paddingLeft');
    };
    SizeUtils.getPaddingRight = function (element) {
        return SizeUtils.getDimension(element, 'padding-right', 'paddingRight');
    };
    SizeUtils.getPaddingTop = function (element) {
        return SizeUtils.getDimension(element, 'padding-top', 'paddingTop');
    };
    SizeUtils.getPaddingBottom = function (element) {
        return SizeUtils.getDimension(element, 'padding-bottom', 'paddingBottom');
    };
    SizeUtils.getMarginLeft = function (element) {
        return SizeUtils.getDimension(element, 'margin-left', 'marginLeft');
    };
    SizeUtils.getMarginTop = function (element) {
        return SizeUtils.getDimension(element, 'margin-top', 'marginTop');
    };
    SizeUtils.getMarginRight = function (element) {
        return SizeUtils.getDimension(element, 'margin-right', 'marginRight');
    };
    SizeUtils.getMarginBottom = function (element) {
        return SizeUtils.getDimension(element, 'margin-bottom', 'marginBottom');
    };
    return SizeUtils;
}();
// ----------------------------------------------------------------------------------------
// Position & Dimension
var Dimension = /** @class */function () {
    function Dimension(width, height) {
        this.width = width;
        this.height = height;
    }
    return Dimension;
}();

function getTopLeftOffset(element) {
    // Adapted from WinJS.Utilities.getPosition
    // and added borders to the mix
    var offsetParent = element.offsetParent;
    var top = element.offsetTop;
    var left = element.offsetLeft;
    while ((element = element.parentNode) !== null &&
    element !== document.body &&
    element !== document.documentElement) {
        top -= element.scrollTop;
        var c = isShadowRoot(element) ? null : getComputedStyle(element);
        if (c) {
            left -= c.direction !== 'rtl' ? element.scrollLeft : -element.scrollLeft;
        }
        if (element === offsetParent) {
            left += SizeUtils.getBorderLeftWidth(element);
            top += SizeUtils.getBorderTopWidth(element);
            top += element.offsetTop;
            left += element.offsetLeft;
            offsetParent = element.offsetParent;
        }
    }
    return {
        left: left,
        top: top };

}
/**
   * Returns the position of a dom node relative to the entire page.
   */
function getDomNodePagePosition(domNode) {
    var bb = domNode.getBoundingClientRect();
    return {
        left: bb.left + StandardWindow.scrollX,
        top: bb.top + StandardWindow.scrollY,
        width: bb.width,
        height: bb.height };

}
var StandardWindow = new ( /** @class */function () {
    function class_3() {
    }
    Object.defineProperty(class_3.prototype, "scrollX", {
        get: function () {
            if (typeof window.scrollX === 'number') {
                // modern browsers
                return window.scrollX;
            } else
            {
                return document.body.scrollLeft + document.documentElement.scrollLeft;
            }
        },
        enumerable: true,
        configurable: true });

    Object.defineProperty(class_3.prototype, "scrollY", {
        get: function () {
            if (typeof window.scrollY === 'number') {
                // modern browsers
                return window.scrollY;
            } else
            {
                return document.body.scrollTop + document.documentElement.scrollTop;
            }
        },
        enumerable: true,
        configurable: true });

    return class_3;
}())();
// Adapted from WinJS
// Gets the width of the element, including margins.
function getTotalWidth(element) {
    var margin = SizeUtils.getMarginLeft(element) + SizeUtils.getMarginRight(element);
    return element.offsetWidth + margin;
}
function getContentWidth(element) {
    var border = SizeUtils.getBorderLeftWidth(element) + SizeUtils.getBorderRightWidth(element);
    var padding = SizeUtils.getPaddingLeft(element) + SizeUtils.getPaddingRight(element);
    return element.offsetWidth - border - padding;
}
// Adapted from WinJS
// Gets the height of the content of the specified element. The content height does not include borders or padding.
function getContentHeight(element) {
    var border = SizeUtils.getBorderTopWidth(element) + SizeUtils.getBorderBottomWidth(element);
    var padding = SizeUtils.getPaddingTop(element) + SizeUtils.getPaddingBottom(element);
    return element.offsetHeight - border - padding;
}
// Adapted from WinJS
// Gets the height of the element, including its margins.
function getTotalHeight(element) {
    var margin = SizeUtils.getMarginTop(element) + SizeUtils.getMarginBottom(element);
    return element.offsetHeight + margin;
}
// ----------------------------------------------------------------------------------------
function isAncestor(testChild, testAncestor) {
    while (testChild) {
        if (testChild === testAncestor) {
            return true;
        }
        testChild = testChild.parentNode;
    }
    return false;
}
function findParentWithClass(node, clazz, stopAtClazzOrNode) {
    while (node && node.nodeType === node.ELEMENT_NODE) {
        if (hasClass(node, clazz)) {
            return node;
        }
        if (stopAtClazzOrNode) {
            if (typeof stopAtClazzOrNode === 'string') {
                if (hasClass(node, stopAtClazzOrNode)) {
                    return null;
                }
            } else
            {
                if (node === stopAtClazzOrNode) {
                    return null;
                }
            }
        }
        node = node.parentNode;
    }
    return null;
}
function isShadowRoot(node) {
    return node && !!node.host && !!node.mode;
}
function isInShadowDOM(domNode) {
    return !!getShadowRoot(domNode);
}
function getShadowRoot(domNode) {
    while (domNode.parentNode) {
        if (domNode === document.body) {
            // reached the body
            return null;
        }
        domNode = domNode.parentNode;
    }
    return isShadowRoot(domNode) ? domNode : null;
}
function createStyleSheet(container) {
    if (container === void 0) {container = document.getElementsByTagName('head')[0];}
    var style = document.createElement('style');
    style.type = 'text/css';
    style.media = 'screen';
    container.appendChild(style);
    return style;
}
var _sharedStyleSheet = null;
function getSharedStyleSheet() {
    if (!_sharedStyleSheet) {
        _sharedStyleSheet = createStyleSheet();
    }
    return _sharedStyleSheet;
}
function getDynamicStyleSheetRules(style) {
    if (style && style.sheet && style.sheet.rules) {
        // Chrome, IE
        return style.sheet.rules;
    }
    if (style && style.sheet && style.sheet.cssRules) {
        // FF
        return style.sheet.cssRules;
    }
    return [];
}
function createCSSRule(selector, cssText, style) {
    if (style === void 0) {style = getSharedStyleSheet();}
    if (!style || !cssText) {
        return;
    }
    style.sheet.insertRule(selector + '{' + cssText + '}', 0);
}
function removeCSSRulesContainingSelector(ruleName, style) {
    if (style === void 0) {style = getSharedStyleSheet();}
    if (!style) {
        return;
    }
    var rules = getDynamicStyleSheetRules(style);
    var toDelete = [];
    for (var i = 0; i < rules.length; i++) {
        var rule = rules[i];
        if (rule.selectorText.indexOf(ruleName) !== -1) {
            toDelete.push(i);
        }
    }
    for (var i = toDelete.length - 1; i >= 0; i--) {
        style.sheet.deleteRule(toDelete[i]);
    }
}
function isHTMLElement(o) {
    if (typeof HTMLElement === 'object') {
        return o instanceof HTMLElement;
    }
    return o && typeof o === 'object' && o.nodeType === 1 && typeof o.nodeName === 'string';
}
var EventType = {
    // Mouse
    CLICK: 'click',
    DBLCLICK: 'dblclick',
    MOUSE_UP: 'mouseup',
    MOUSE_DOWN: 'mousedown',
    MOUSE_OVER: 'mouseover',
    MOUSE_MOVE: 'mousemove',
    MOUSE_OUT: 'mouseout',
    MOUSE_ENTER: 'mouseenter',
    MOUSE_LEAVE: 'mouseleave',
    POINTER_UP: 'pointerup',
    POINTER_DOWN: 'pointerdown',
    POINTER_MOVE: 'pointermove',
    CONTEXT_MENU: 'contextmenu',
    WHEEL: 'wheel',
    // Keyboard
    KEY_DOWN: 'keydown',
    KEY_PRESS: 'keypress',
    KEY_UP: 'keyup',
    // HTML Document
    LOAD: 'load',
    BEFORE_UNLOAD: 'beforeunload',
    UNLOAD: 'unload',
    ABORT: 'abort',
    ERROR: 'error',
    RESIZE: 'resize',
    SCROLL: 'scroll',
    FULLSCREEN_CHANGE: 'fullscreenchange',
    WK_FULLSCREEN_CHANGE: 'webkitfullscreenchange',
    // Form
    SELECT: 'select',
    CHANGE: 'change',
    SUBMIT: 'submit',
    RESET: 'reset',
    FOCUS: 'focus',
    FOCUS_IN: 'focusin',
    FOCUS_OUT: 'focusout',
    BLUR: 'blur',
    INPUT: 'input',
    // Local Storage
    STORAGE: 'storage',
    // Drag
    DRAG_START: 'dragstart',
    DRAG: 'drag',
    DRAG_ENTER: 'dragenter',
    DRAG_LEAVE: 'dragleave',
    DRAG_OVER: 'dragover',
    DROP: 'drop',
    DRAG_END: 'dragend',
    // Animation
    ANIMATION_START: _browser_js__WEBPACK_IMPORTED_MODULE_0__["isWebKit"] ? 'webkitAnimationStart' : 'animationstart',
    ANIMATION_END: _browser_js__WEBPACK_IMPORTED_MODULE_0__["isWebKit"] ? 'webkitAnimationEnd' : 'animationend',
    ANIMATION_ITERATION: _browser_js__WEBPACK_IMPORTED_MODULE_0__["isWebKit"] ? 'webkitAnimationIteration' : 'animationiteration' };

var EventHelper = {
    stop: function (e, cancelBubble) {
        if (e.preventDefault) {
            e.preventDefault();
        } else
        {
            // IE8
            e.returnValue = false;
        }
        if (cancelBubble) {
            if (e.stopPropagation) {
                e.stopPropagation();
            } else
            {
                // IE8
                e.cancelBubble = true;
            }
        }
    } };

function saveParentsScrollTop(node) {
    var r = [];
    for (var i = 0; node && node.nodeType === node.ELEMENT_NODE; i++) {
        r[i] = node.scrollTop;
        node = node.parentNode;
    }
    return r;
}
function restoreParentsScrollTop(node, state) {
    for (var i = 0; node && node.nodeType === node.ELEMENT_NODE; i++) {
        if (node.scrollTop !== state[i]) {
            node.scrollTop = state[i];
        }
        node = node.parentNode;
    }
}
var FocusTracker = /** @class */function (_super) {
    __extends(FocusTracker, _super);
    function FocusTracker(element) {
        var _this = _super.call(this) || this;
        _this._onDidFocus = _this._register(new _common_event_js__WEBPACK_IMPORTED_MODULE_6__["Emitter"]());
        _this.onDidFocus = _this._onDidFocus.event;
        _this._onDidBlur = _this._register(new _common_event_js__WEBPACK_IMPORTED_MODULE_6__["Emitter"]());
        _this.onDidBlur = _this._onDidBlur.event;
        var hasFocus = isAncestor(document.activeElement, element);
        var loosingFocus = false;
        var onFocus = function () {
            loosingFocus = false;
            if (!hasFocus) {
                hasFocus = true;
                _this._onDidFocus.fire();
            }
        };
        var onBlur = function () {
            if (hasFocus) {
                loosingFocus = true;
                window.setTimeout(function () {
                    if (loosingFocus) {
                        loosingFocus = false;
                        hasFocus = false;
                        _this._onDidBlur.fire();
                    }
                }, 0);
            }
        };
        _this._refreshStateHandler = function () {
            var currentNodeHasFocus = isAncestor(document.activeElement, element);
            if (currentNodeHasFocus !== hasFocus) {
                if (hasFocus) {
                    onBlur();
                } else
                {
                    onFocus();
                }
            }
        };
        _this._register(Object(_event_js__WEBPACK_IMPORTED_MODULE_1__["domEvent"])(element, EventType.FOCUS, true)(onFocus));
        _this._register(Object(_event_js__WEBPACK_IMPORTED_MODULE_1__["domEvent"])(element, EventType.BLUR, true)(onBlur));
        return _this;
    }
    return FocusTracker;
}(_common_lifecycle_js__WEBPACK_IMPORTED_MODULE_7__["Disposable"]);
function trackFocus(element) {
    return new FocusTracker(element);
}
function append(parent) {
    var children = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        children[_i - 1] = arguments[_i];
    }
    children.forEach(function (child) {return parent.appendChild(child);});
    return children[children.length - 1];
}
var SELECTOR_REGEX = /([\w\-]+)?(#([\w\-]+))?((.([\w\-]+))*)/;
var Namespace;
(function (Namespace) {
    Namespace["HTML"] = "http://www.w3.org/1999/xhtml";
    Namespace["SVG"] = "http://www.w3.org/2000/svg";
})(Namespace || (Namespace = {}));
function _$(namespace, description, attrs) {
    var children = [];
    for (var _i = 3; _i < arguments.length; _i++) {
        children[_i - 3] = arguments[_i];
    }
    var match = SELECTOR_REGEX.exec(description);
    if (!match) {
        throw new Error('Bad use of emmet');
    }
    attrs = __assign({}, attrs || {});
    var tagName = match[1] || 'div';
    var result;
    if (namespace !== Namespace.HTML) {
        result = document.createElementNS(namespace, tagName);
    } else
    {
        result = document.createElement(tagName);
    }
    if (match[3]) {
        result.id = match[3];
    }
    if (match[4]) {
        result.className = match[4].replace(/\./g, ' ').trim();
    }
    Object.keys(attrs).forEach(function (name) {
        var value = attrs[name];
        if (typeof value === 'undefined') {
            return;
        }
        if (/^on\w+$/.test(name)) {
            result[name] = value;
        } else
        if (name === 'selected') {
            if (value) {
                result.setAttribute(name, 'true');
            }
        } else
        {
            result.setAttribute(name, value);
        }
    });
    Object(_common_arrays_js__WEBPACK_IMPORTED_MODULE_9__["coalesce"])(children).
    forEach(function (child) {
        if (child instanceof Node) {
            result.appendChild(child);
        } else
        {
            result.appendChild(document.createTextNode(child));
        }
    });
    return result;
}
function $(description, attrs) {
    var children = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        children[_i - 2] = arguments[_i];
    }
    return _$.apply(void 0, __spreadArrays([Namespace.HTML, description, attrs], children));
}
$.SVG = function (description, attrs) {
    var children = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        children[_i - 2] = arguments[_i];
    }
    return _$.apply(void 0, __spreadArrays([Namespace.SVG, description, attrs], children));
};
function show() {
    var elements = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        elements[_i] = arguments[_i];
    }
    for (var _a = 0, elements_1 = elements; _a < elements_1.length; _a++) {
        var element = elements_1[_a];
        element.style.display = '';
        element.removeAttribute('aria-hidden');
    }
}
function hide() {
    var elements = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        elements[_i] = arguments[_i];
    }
    for (var _a = 0, elements_2 = elements; _a < elements_2.length; _a++) {
        var element = elements_2[_a];
        element.style.display = 'none';
        element.setAttribute('aria-hidden', 'true');
    }
}
function findParentWithAttribute(node, attribute) {
    while (node && node.nodeType === node.ELEMENT_NODE) {
        if (node instanceof HTMLElement && node.hasAttribute(attribute)) {
            return node;
        }
        node = node.parentNode;
    }
    return null;
}
function removeTabIndexAndUpdateFocus(node) {
    if (!node || !node.hasAttribute('tabIndex')) {
        return;
    }
    // If we are the currently focused element and tabIndex is removed,
    // standard DOM behavior is to move focus to the <body> element. We
    // typically never want that, rather put focus to the closest element
    // in the hierarchy of the parent DOM nodes.
    if (document.activeElement === node) {
        var parentFocusable = findParentWithAttribute(node.parentElement, 'tabIndex');
        if (parentFocusable) {
            parentFocusable.focus();
        }
    }
    node.removeAttribute('tabindex');
}
function getElementsByTagName(tag) {
    return Array.prototype.slice.call(document.getElementsByTagName(tag), 0);
}
/**
   * Find a value usable for a dom node size such that the likelihood that it would be
   * displayed with constant screen pixels size is as high as possible.
   *
   * e.g. We would desire for the cursors to be 2px (CSS px) wide. Under a devicePixelRatio
   * of 1.25, the cursor will be 2.5 screen pixels wide. Depending on how the dom node aligns/"snaps"
   * with the screen pixels, it will sometimes be rendered with 2 screen pixels, and sometimes with 3 screen pixels.
   */
function computeScreenAwareSize(cssPx) {
    var screenPx = window.devicePixelRatio * cssPx;
    return Math.max(1, Math.floor(screenPx)) / window.devicePixelRatio;
}
/**
   * See https://github.com/Microsoft/monaco-editor/issues/601
   * To protect against malicious code in the linked site, particularly phishing attempts,
   * the window.opener should be set to null to prevent the linked site from having access
   * to change the location of the current page.
   * See https://mathiasbynens.github.io/rel-noopener/
   */
function windowOpenNoOpener(url) {
    if (_common_platform_js__WEBPACK_IMPORTED_MODULE_8__["isNative"] || _browser_js__WEBPACK_IMPORTED_MODULE_0__["isEdgeWebView"]) {
        // In VSCode, window.open() always returns null...
        // The same is true for a WebView (see https://github.com/Microsoft/monaco-editor/issues/628)
        window.open(url);
    } else
    {
        var newTab = window.open();
        if (newTab) {
            newTab.opener = null;
            newTab.location.href = url;
        }
    }
}
function animate(fn) {
    var step = function () {
        fn();
        stepDisposable = scheduleAtNextAnimationFrame(step);
    };
    var stepDisposable = scheduleAtNextAnimationFrame(step);
    return Object(_common_lifecycle_js__WEBPACK_IMPORTED_MODULE_7__["toDisposable"])(function () {return stepDisposable.dispose();});
}
_common_network_js__WEBPACK_IMPORTED_MODULE_10__["RemoteAuthorities"].setPreferredWebSchema(/^https:/.test(window.location.href) ? 'https' : 'http');
function asDomUri(uri) {
    if (!uri) {
        return uri;
    }
    if (_common_network_js__WEBPACK_IMPORTED_MODULE_10__["Schemas"].vscodeRemote === uri.scheme) {
        return _common_network_js__WEBPACK_IMPORTED_MODULE_10__["RemoteAuthorities"].rewrite(uri);
    }
    return uri;
}
/**
   * returns url('...')
   */
function asCSSUrl(uri) {
    if (!uri) {
        return "url('')";
    }
    return "url('" + asDomUri(uri).toString(true).replace(/'/g, '%27') + "')";
}

/***/ }),

/***/ 6293:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getZoomLevel", function() { return getZoomLevel; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getTimeSinceLastZoomLevelChanged", function() { return getTimeSinceLastZoomLevelChanged; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "onDidChangeZoomLevel", function() { return onDidChangeZoomLevel; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getPixelRatio", function() { return getPixelRatio; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isIE", function() { return isIE; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isEdge", function() { return isEdge; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isEdgeOrIE", function() { return isEdgeOrIE; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isFirefox", function() { return isFirefox; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isWebKit", function() { return isWebKit; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isChrome", function() { return isChrome; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isSafari", function() { return isSafari; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isWebkitWebView", function() { return isWebkitWebView; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isIPad", function() { return isIPad; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isEdgeWebView", function() { return isEdgeWebView; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isStandalone", function() { return isStandalone; });
/* harmony import */ var _common_event_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6213);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/

var WindowManager = /** @class */function () {
    function WindowManager() {
        // --- Zoom Level
        this._zoomLevel = 0;
        this._lastZoomLevelChangeTime = 0;
        this._onDidChangeZoomLevel = new _common_event_js__WEBPACK_IMPORTED_MODULE_0__["Emitter"]();
        this.onDidChangeZoomLevel = this._onDidChangeZoomLevel.event;
    }
    WindowManager.prototype.getZoomLevel = function () {
        return this._zoomLevel;
    };
    WindowManager.prototype.getTimeSinceLastZoomLevelChanged = function () {
        return Date.now() - this._lastZoomLevelChangeTime;
    };
    // --- Pixel Ratio
    WindowManager.prototype.getPixelRatio = function () {
        var ctx = document.createElement('canvas').getContext('2d');
        var dpr = window.devicePixelRatio || 1;
        var bsr = ctx.webkitBackingStorePixelRatio ||
        ctx.mozBackingStorePixelRatio ||
        ctx.msBackingStorePixelRatio ||
        ctx.oBackingStorePixelRatio ||
        ctx.backingStorePixelRatio || 1;
        return dpr / bsr;
    };
    WindowManager.INSTANCE = new WindowManager();
    return WindowManager;
}();
function getZoomLevel() {
    return WindowManager.INSTANCE.getZoomLevel();
}
/** Returns the time (in ms) since the zoom level was changed */
function getTimeSinceLastZoomLevelChanged() {
    return WindowManager.INSTANCE.getTimeSinceLastZoomLevelChanged();
}
function onDidChangeZoomLevel(callback) {
    return WindowManager.INSTANCE.onDidChangeZoomLevel(callback);
}
function getPixelRatio() {
    return WindowManager.INSTANCE.getPixelRatio();
}
var userAgent = navigator.userAgent;
var isIE = userAgent.indexOf('Trident') >= 0;
var isEdge = userAgent.indexOf('Edge/') >= 0;
var isEdgeOrIE = isIE || isEdge;
var isFirefox = userAgent.indexOf('Firefox') >= 0;
var isWebKit = userAgent.indexOf('AppleWebKit') >= 0;
var isChrome = userAgent.indexOf('Chrome') >= 0;
var isSafari = !isChrome && userAgent.indexOf('Safari') >= 0;
var isWebkitWebView = !isChrome && !isSafari && isWebKit;
var isIPad = userAgent.indexOf('iPad') >= 0 || isSafari && navigator.maxTouchPoints > 0;
var isEdgeWebView = isEdge && userAgent.indexOf('WebView/') >= 0;
var isStandalone = window.matchMedia && window.matchMedia('(display-mode: standalone)').matches;

/***/ }),

/***/ 6294:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "domEvent", function() { return domEvent; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "stop", function() { return stop; });
/* harmony import */ var _common_event_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6213);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/

var domEvent = function (element, type, useCapture) {
    var fn = function (e) {return emitter.fire(e);};
    var emitter = new _common_event_js__WEBPACK_IMPORTED_MODULE_0__["Emitter"]({
        onFirstListenerAdd: function () {
            element.addEventListener(type, fn, useCapture);
        },
        onLastListenerRemove: function () {
            element.removeEventListener(type, fn, useCapture);
        } });

    return emitter.event;
};
function stop(event) {
    return _common_event_js__WEBPACK_IMPORTED_MODULE_0__["Event"].map(event, function (e) {
        e.preventDefault();
        e.stopPropagation();
        return e;
    });
}

/***/ }),

/***/ 6295:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "StandardKeyboardEvent", function() { return StandardKeyboardEvent; });
/* harmony import */ var _browser_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6293);
/* harmony import */ var _common_keyCodes_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6235);
/* harmony import */ var _common_platform_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6222);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/



var KEY_CODE_MAP = new Array(230);
var INVERSE_KEY_CODE_MAP = new Array(112 /* MAX_VALUE */);
(function () {
    for (var i = 0; i < INVERSE_KEY_CODE_MAP.length; i++) {
        INVERSE_KEY_CODE_MAP[i] = -1;
    }
    function define(code, keyCode) {
        KEY_CODE_MAP[code] = keyCode;
        INVERSE_KEY_CODE_MAP[keyCode] = code;
    }
    define(3, 7 /* PauseBreak */); // VK_CANCEL 0x03 Control-break processing
    define(8, 1 /* Backspace */);
    define(9, 2 /* Tab */);
    define(13, 3 /* Enter */);
    define(16, 4 /* Shift */);
    define(17, 5 /* Ctrl */);
    define(18, 6 /* Alt */);
    define(19, 7 /* PauseBreak */);
    define(20, 8 /* CapsLock */);
    define(27, 9 /* Escape */);
    define(32, 10 /* Space */);
    define(33, 11 /* PageUp */);
    define(34, 12 /* PageDown */);
    define(35, 13 /* End */);
    define(36, 14 /* Home */);
    define(37, 15 /* LeftArrow */);
    define(38, 16 /* UpArrow */);
    define(39, 17 /* RightArrow */);
    define(40, 18 /* DownArrow */);
    define(45, 19 /* Insert */);
    define(46, 20 /* Delete */);
    define(48, 21 /* KEY_0 */);
    define(49, 22 /* KEY_1 */);
    define(50, 23 /* KEY_2 */);
    define(51, 24 /* KEY_3 */);
    define(52, 25 /* KEY_4 */);
    define(53, 26 /* KEY_5 */);
    define(54, 27 /* KEY_6 */);
    define(55, 28 /* KEY_7 */);
    define(56, 29 /* KEY_8 */);
    define(57, 30 /* KEY_9 */);
    define(65, 31 /* KEY_A */);
    define(66, 32 /* KEY_B */);
    define(67, 33 /* KEY_C */);
    define(68, 34 /* KEY_D */);
    define(69, 35 /* KEY_E */);
    define(70, 36 /* KEY_F */);
    define(71, 37 /* KEY_G */);
    define(72, 38 /* KEY_H */);
    define(73, 39 /* KEY_I */);
    define(74, 40 /* KEY_J */);
    define(75, 41 /* KEY_K */);
    define(76, 42 /* KEY_L */);
    define(77, 43 /* KEY_M */);
    define(78, 44 /* KEY_N */);
    define(79, 45 /* KEY_O */);
    define(80, 46 /* KEY_P */);
    define(81, 47 /* KEY_Q */);
    define(82, 48 /* KEY_R */);
    define(83, 49 /* KEY_S */);
    define(84, 50 /* KEY_T */);
    define(85, 51 /* KEY_U */);
    define(86, 52 /* KEY_V */);
    define(87, 53 /* KEY_W */);
    define(88, 54 /* KEY_X */);
    define(89, 55 /* KEY_Y */);
    define(90, 56 /* KEY_Z */);
    define(93, 58 /* ContextMenu */);
    define(96, 93 /* NUMPAD_0 */);
    define(97, 94 /* NUMPAD_1 */);
    define(98, 95 /* NUMPAD_2 */);
    define(99, 96 /* NUMPAD_3 */);
    define(100, 97 /* NUMPAD_4 */);
    define(101, 98 /* NUMPAD_5 */);
    define(102, 99 /* NUMPAD_6 */);
    define(103, 100 /* NUMPAD_7 */);
    define(104, 101 /* NUMPAD_8 */);
    define(105, 102 /* NUMPAD_9 */);
    define(106, 103 /* NUMPAD_MULTIPLY */);
    define(107, 104 /* NUMPAD_ADD */);
    define(108, 105 /* NUMPAD_SEPARATOR */);
    define(109, 106 /* NUMPAD_SUBTRACT */);
    define(110, 107 /* NUMPAD_DECIMAL */);
    define(111, 108 /* NUMPAD_DIVIDE */);
    define(112, 59 /* F1 */);
    define(113, 60 /* F2 */);
    define(114, 61 /* F3 */);
    define(115, 62 /* F4 */);
    define(116, 63 /* F5 */);
    define(117, 64 /* F6 */);
    define(118, 65 /* F7 */);
    define(119, 66 /* F8 */);
    define(120, 67 /* F9 */);
    define(121, 68 /* F10 */);
    define(122, 69 /* F11 */);
    define(123, 70 /* F12 */);
    define(124, 71 /* F13 */);
    define(125, 72 /* F14 */);
    define(126, 73 /* F15 */);
    define(127, 74 /* F16 */);
    define(128, 75 /* F17 */);
    define(129, 76 /* F18 */);
    define(130, 77 /* F19 */);
    define(144, 78 /* NumLock */);
    define(145, 79 /* ScrollLock */);
    define(186, 80 /* US_SEMICOLON */);
    define(187, 81 /* US_EQUAL */);
    define(188, 82 /* US_COMMA */);
    define(189, 83 /* US_MINUS */);
    define(190, 84 /* US_DOT */);
    define(191, 85 /* US_SLASH */);
    define(192, 86 /* US_BACKTICK */);
    define(193, 110 /* ABNT_C1 */);
    define(194, 111 /* ABNT_C2 */);
    define(219, 87 /* US_OPEN_SQUARE_BRACKET */);
    define(220, 88 /* US_BACKSLASH */);
    define(221, 89 /* US_CLOSE_SQUARE_BRACKET */);
    define(222, 90 /* US_QUOTE */);
    define(223, 91 /* OEM_8 */);
    define(226, 92 /* OEM_102 */);
    /**
                                    * https://lists.w3.org/Archives/Public/www-dom/2010JulSep/att-0182/keyCode-spec.html
                                    * If an Input Method Editor is processing key input and the event is keydown, return 229.
                                    */
    define(229, 109 /* KEY_IN_COMPOSITION */);
    if (_browser_js__WEBPACK_IMPORTED_MODULE_0__["isIE"]) {
        define(91, 57 /* Meta */);
    } else
    if (_browser_js__WEBPACK_IMPORTED_MODULE_0__["isFirefox"]) {
        define(59, 80 /* US_SEMICOLON */);
        define(107, 81 /* US_EQUAL */);
        define(109, 83 /* US_MINUS */);
        if (_common_platform_js__WEBPACK_IMPORTED_MODULE_2__["isMacintosh"]) {
            define(224, 57 /* Meta */);
        }
    } else
    if (_browser_js__WEBPACK_IMPORTED_MODULE_0__["isWebKit"]) {
        define(91, 57 /* Meta */);
        if (_common_platform_js__WEBPACK_IMPORTED_MODULE_2__["isMacintosh"]) {
            // the two meta keys in the Mac have different key codes (91 and 93)
            define(93, 57 /* Meta */);
        } else
        {
            define(92, 57 /* Meta */);
        }
    }
})();
function extractKeyCode(e) {
    if (e.charCode) {
        // "keypress" events mostly
        var char = String.fromCharCode(e.charCode).toUpperCase();
        return _common_keyCodes_js__WEBPACK_IMPORTED_MODULE_1__["KeyCodeUtils"].fromString(char);
    }
    return KEY_CODE_MAP[e.keyCode] || 0 /* Unknown */;
}
var ctrlKeyMod = _common_platform_js__WEBPACK_IMPORTED_MODULE_2__["isMacintosh"] ? 256 /* WinCtrl */ : 2048 /* CtrlCmd */;
var altKeyMod = 512 /* Alt */;
var shiftKeyMod = 1024 /* Shift */;
var metaKeyMod = _common_platform_js__WEBPACK_IMPORTED_MODULE_2__["isMacintosh"] ? 2048 /* CtrlCmd */ : 256 /* WinCtrl */;
var StandardKeyboardEvent = /** @class */function () {
    function StandardKeyboardEvent(source) {
        this._standardKeyboardEventBrand = true;
        var e = source;
        this.browserEvent = e;
        this.target = e.target;
        this.ctrlKey = e.ctrlKey;
        this.shiftKey = e.shiftKey;
        this.altKey = e.altKey;
        this.metaKey = e.metaKey;
        this.keyCode = extractKeyCode(e);
        this.code = e.code;
        // console.info(e.type + ": keyCode: " + e.keyCode + ", which: " + e.which + ", charCode: " + e.charCode + ", detail: " + e.detail + " ====> " + this.keyCode + ' -- ' + KeyCode[this.keyCode]);
        this.ctrlKey = this.ctrlKey || this.keyCode === 5 /* Ctrl */;
        this.altKey = this.altKey || this.keyCode === 6 /* Alt */;
        this.shiftKey = this.shiftKey || this.keyCode === 4 /* Shift */;
        this.metaKey = this.metaKey || this.keyCode === 57 /* Meta */;
        this._asKeybinding = this._computeKeybinding();
        this._asRuntimeKeybinding = this._computeRuntimeKeybinding();
        // console.log(`code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`);
    }
    StandardKeyboardEvent.prototype.preventDefault = function () {
        if (this.browserEvent && this.browserEvent.preventDefault) {
            this.browserEvent.preventDefault();
        }
    };
    StandardKeyboardEvent.prototype.stopPropagation = function () {
        if (this.browserEvent && this.browserEvent.stopPropagation) {
            this.browserEvent.stopPropagation();
        }
    };
    StandardKeyboardEvent.prototype.toKeybinding = function () {
        return this._asRuntimeKeybinding;
    };
    StandardKeyboardEvent.prototype.equals = function (other) {
        return this._asKeybinding === other;
    };
    StandardKeyboardEvent.prototype._computeKeybinding = function () {
        var key = 0 /* Unknown */;
        if (this.keyCode !== 5 /* Ctrl */ && this.keyCode !== 4 /* Shift */ && this.keyCode !== 6 /* Alt */ && this.keyCode !== 57 /* Meta */) {
                key = this.keyCode;
            }
        var result = 0;
        if (this.ctrlKey) {
            result |= ctrlKeyMod;
        }
        if (this.altKey) {
            result |= altKeyMod;
        }
        if (this.shiftKey) {
            result |= shiftKeyMod;
        }
        if (this.metaKey) {
            result |= metaKeyMod;
        }
        result |= key;
        return result;
    };
    StandardKeyboardEvent.prototype._computeRuntimeKeybinding = function () {
        var key = 0 /* Unknown */;
        if (this.keyCode !== 5 /* Ctrl */ && this.keyCode !== 4 /* Shift */ && this.keyCode !== 6 /* Alt */ && this.keyCode !== 57 /* Meta */) {
                key = this.keyCode;
            }
        return new _common_keyCodes_js__WEBPACK_IMPORTED_MODULE_1__["SimpleKeybinding"](this.ctrlKey, this.shiftKey, this.altKey, this.metaKey, key);
    };
    return StandardKeyboardEvent;
}();


/***/ }),

/***/ 6296:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "StandardMouseEvent", function() { return StandardMouseEvent; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DragMouseEvent", function() { return DragMouseEvent; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "StandardWheelEvent", function() { return StandardWheelEvent; });
/* harmony import */ var _browser_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6293);
/* harmony import */ var _iframe_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6297);
/* harmony import */ var _common_platform_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6222);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __extends = undefined && undefined.__extends || function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
        { __proto__: [] } instanceof Array && function (d, b) {d.__proto__ = b;} ||
        function (d, b) {for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];};
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {this.constructor = d;}
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();



var StandardMouseEvent = /** @class */function () {
    function StandardMouseEvent(e) {
        this.timestamp = Date.now();
        this.browserEvent = e;
        this.leftButton = e.button === 0;
        this.middleButton = e.button === 1;
        this.rightButton = e.button === 2;
        this.buttons = e.buttons;
        this.target = e.target;
        this.detail = e.detail || 1;
        if (e.type === 'dblclick') {
            this.detail = 2;
        }
        this.ctrlKey = e.ctrlKey;
        this.shiftKey = e.shiftKey;
        this.altKey = e.altKey;
        this.metaKey = e.metaKey;
        if (typeof e.pageX === 'number') {
            this.posx = e.pageX;
            this.posy = e.pageY;
        } else
        {
            // Probably hit by MSGestureEvent
            this.posx = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
            this.posy = e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
        }
        // Find the position of the iframe this code is executing in relative to the iframe where the event was captured.
        var iframeOffsets = _iframe_js__WEBPACK_IMPORTED_MODULE_1__["IframeUtils"].getPositionOfChildWindowRelativeToAncestorWindow(self, e.view);
        this.posx -= iframeOffsets.left;
        this.posy -= iframeOffsets.top;
    }
    StandardMouseEvent.prototype.preventDefault = function () {
        if (this.browserEvent.preventDefault) {
            this.browserEvent.preventDefault();
        }
    };
    StandardMouseEvent.prototype.stopPropagation = function () {
        if (this.browserEvent.stopPropagation) {
            this.browserEvent.stopPropagation();
        }
    };
    return StandardMouseEvent;
}();

var DragMouseEvent = /** @class */function (_super) {
    __extends(DragMouseEvent, _super);
    function DragMouseEvent(e) {
        var _this = _super.call(this, e) || this;
        _this.dataTransfer = e.dataTransfer;
        return _this;
    }
    return DragMouseEvent;
}(StandardMouseEvent);

var StandardWheelEvent = /** @class */function () {
    function StandardWheelEvent(e, deltaX, deltaY) {
        if (deltaX === void 0) {deltaX = 0;}
        if (deltaY === void 0) {deltaY = 0;}
        this.browserEvent = e || null;
        this.target = e ? e.target || e.targetNode || e.srcElement : null;
        this.deltaY = deltaY;
        this.deltaX = deltaX;
        if (e) {
            // Old (deprecated) wheel events
            var e1 = e;
            var e2 = e;
            // vertical delta scroll
            if (typeof e1.wheelDeltaY !== 'undefined') {
                this.deltaY = e1.wheelDeltaY / 120;
            } else
            if (typeof e2.VERTICAL_AXIS !== 'undefined' && e2.axis === e2.VERTICAL_AXIS) {
                this.deltaY = -e2.detail / 3;
            } else
            if (e.type === 'wheel') {
                // Modern wheel event
                // https://developer.mozilla.org/en-US/docs/Web/API/WheelEvent
                var ev = e;
                if (ev.deltaMode === ev.DOM_DELTA_LINE) {
                    // the deltas are expressed in lines
                    this.deltaY = -e.deltaY;
                } else
                {
                    this.deltaY = -e.deltaY / 40;
                }
            }
            // horizontal delta scroll
            if (typeof e1.wheelDeltaX !== 'undefined') {
                if (_browser_js__WEBPACK_IMPORTED_MODULE_0__["isSafari"] && _common_platform_js__WEBPACK_IMPORTED_MODULE_2__["isWindows"]) {
                    this.deltaX = -(e1.wheelDeltaX / 120);
                } else
                {
                    this.deltaX = e1.wheelDeltaX / 120;
                }
            } else
            if (typeof e2.HORIZONTAL_AXIS !== 'undefined' && e2.axis === e2.HORIZONTAL_AXIS) {
                this.deltaX = -e.detail / 3;
            } else
            if (e.type === 'wheel') {
                // Modern wheel event
                // https://developer.mozilla.org/en-US/docs/Web/API/WheelEvent
                var ev = e;
                if (ev.deltaMode === ev.DOM_DELTA_LINE) {
                    // the deltas are expressed in lines
                    this.deltaX = -e.deltaX;
                } else
                {
                    this.deltaX = -e.deltaX / 40;
                }
            }
            // Assume a vertical scroll if nothing else worked
            if (this.deltaY === 0 && this.deltaX === 0 && e.wheelDelta) {
                this.deltaY = e.wheelDelta / 120;
            }
        }
    }
    StandardWheelEvent.prototype.preventDefault = function () {
        if (this.browserEvent) {
            if (this.browserEvent.preventDefault) {
                this.browserEvent.preventDefault();
            }
        }
    };
    StandardWheelEvent.prototype.stopPropagation = function () {
        if (this.browserEvent) {
            if (this.browserEvent.stopPropagation) {
                this.browserEvent.stopPropagation();
            }
        }
    };
    return StandardWheelEvent;
}();


/***/ }),

/***/ 6297:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "IframeUtils", function() { return IframeUtils; });
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var hasDifferentOriginAncestorFlag = false;
var sameOriginWindowChainCache = null;
function getParentWindowIfSameOrigin(w) {
    if (!w.parent || w.parent === w) {
        return null;
    }
    // Cannot really tell if we have access to the parent window unless we try to access something in it
    try {
        var location_1 = w.location;
        var parentLocation = w.parent.location;
        if (location_1.protocol !== parentLocation.protocol || location_1.hostname !== parentLocation.hostname || location_1.port !== parentLocation.port) {
            hasDifferentOriginAncestorFlag = true;
            return null;
        }
    }
    catch (e) {
        hasDifferentOriginAncestorFlag = true;
        return null;
    }
    return w.parent;
}
function findIframeElementInParentWindow(parentWindow, childWindow) {
    var parentWindowIframes = parentWindow.document.getElementsByTagName('iframe');
    var iframe;
    for (var i = 0, len = parentWindowIframes.length; i < len; i++) {
        iframe = parentWindowIframes[i];
        if (iframe.contentWindow === childWindow) {
            return iframe;
        }
    }
    return null;
}
var IframeUtils = /** @class */function () {
    function IframeUtils() {
    }
    /**
       * Returns a chain of embedded windows with the same origin (which can be accessed programmatically).
       * Having a chain of length 1 might mean that the current execution environment is running outside of an iframe or inside an iframe embedded in a window with a different origin.
       * To distinguish if at one point the current execution environment is running inside a window with a different origin, see hasDifferentOriginAncestor()
       */
    IframeUtils.getSameOriginWindowChain = function () {
        if (!sameOriginWindowChainCache) {
            sameOriginWindowChainCache = [];
            var w = window;
            var parent_1;
            do {
                parent_1 = getParentWindowIfSameOrigin(w);
                if (parent_1) {
                    sameOriginWindowChainCache.push({
                        window: w,
                        iframeElement: findIframeElementInParentWindow(parent_1, w) });

                } else
                {
                    sameOriginWindowChainCache.push({
                        window: w,
                        iframeElement: null });

                }
                w = parent_1;
            } while (w);
        }
        return sameOriginWindowChainCache.slice(0);
    };
    /**
        * Returns true if the current execution environment is chained in a list of iframes which at one point ends in a window with a different origin.
        * Returns false if the current execution environment is not running inside an iframe or if the entire chain of iframes have the same origin.
        */
    IframeUtils.hasDifferentOriginAncestor = function () {
        if (!sameOriginWindowChainCache) {
            this.getSameOriginWindowChain();
        }
        return hasDifferentOriginAncestorFlag;
    };
    /**
        * Returns the position of `childWindow` relative to `ancestorWindow`
        */
    IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow = function (childWindow, ancestorWindow) {
        if (!ancestorWindow || childWindow === ancestorWindow) {
            return {
                top: 0,
                left: 0 };

        }
        var top = 0,left = 0;
        var windowChain = this.getSameOriginWindowChain();
        for (var _i = 0, windowChain_1 = windowChain; _i < windowChain_1.length; _i++) {
            var windowChainEl = windowChain_1[_i];
            if (windowChainEl.window === ancestorWindow) {
                break;
            }
            if (!windowChainEl.iframeElement) {
                break;
            }
            var boundingRect = windowChainEl.iframeElement.getBoundingClientRect();
            top += boundingRect.top;
            left += boundingRect.left;
        }
        return {
            top: top,
            left: left };

    };
    return IframeUtils;
}();


/***/ }),

/***/ 6298:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Schemas", function() { return Schemas; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "RemoteAuthorities", function() { return RemoteAuthorities; });
/* harmony import */ var _uri_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6221);
/* harmony import */ var _platform_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6222);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/


var Schemas;
(function (Schemas) {
    /**
                      * A schema that is used for models that exist in memory
                      * only and that have no correspondence on a server or such.
                      */
    Schemas.inMemory = 'inmemory';
    /**
                                    * A schema that is used for setting files
                                    */
    Schemas.vscode = 'vscode';
    /**
                                * A schema that is used for internal private files
                                */
    Schemas.internal = 'private';
    /**
                                   * A walk-through document.
                                   */
    Schemas.walkThrough = 'walkThrough';
    /**
                                          * An embedded code snippet.
                                          */
    Schemas.walkThroughSnippet = 'walkThroughSnippet';
    Schemas.http = 'http';
    Schemas.https = 'https';
    Schemas.file = 'file';
    Schemas.mailto = 'mailto';
    Schemas.untitled = 'untitled';
    Schemas.data = 'data';
    Schemas.command = 'command';
    Schemas.vscodeRemote = 'vscode-remote';
    Schemas.vscodeRemoteResource = 'vscode-remote-resource';
    Schemas.userData = 'vscode-userdata';
})(Schemas || (Schemas = {}));
var RemoteAuthoritiesImpl = /** @class */function () {
    function RemoteAuthoritiesImpl() {
        this._hosts = Object.create(null);
        this._ports = Object.create(null);
        this._connectionTokens = Object.create(null);
        this._preferredWebSchema = 'http';
        this._delegate = null;
    }
    RemoteAuthoritiesImpl.prototype.setPreferredWebSchema = function (schema) {
        this._preferredWebSchema = schema;
    };
    RemoteAuthoritiesImpl.prototype.rewrite = function (uri) {
        if (this._delegate) {
            return this._delegate(uri);
        }
        var authority = uri.authority;
        var host = this._hosts[authority];
        if (host && host.indexOf(':') !== -1) {
            host = "[" + host + "]";
        }
        var port = this._ports[authority];
        var connectionToken = this._connectionTokens[authority];
        var query = "path=" + encodeURIComponent(uri.path);
        if (typeof connectionToken === 'string') {
            query += "&tkn=" + encodeURIComponent(connectionToken);
        }
        return _uri_js__WEBPACK_IMPORTED_MODULE_0__["URI"].from({
            scheme: _platform_js__WEBPACK_IMPORTED_MODULE_1__["isWeb"] ? this._preferredWebSchema : Schemas.vscodeRemoteResource,
            authority: host + ":" + port,
            path: "/vscode-remote-resource",
            query: query });

    };
    return RemoteAuthoritiesImpl;
}();
var RemoteAuthorities = new RemoteAuthoritiesImpl();

/***/ }),

/***/ 6299:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "BrowserFeatures", function() { return BrowserFeatures; });
/* harmony import */ var _browser_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6293);
/* harmony import */ var _common_platform_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6222);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/


/**
                                                    * Browser feature we can support in current platform, browser and environment.
                                                    */
var BrowserFeatures = {
    clipboard: {
        writeText: _common_platform_js__WEBPACK_IMPORTED_MODULE_1__["isNative"] ||
        document.queryCommandSupported && document.queryCommandSupported('copy') ||
        !!(navigator && navigator.clipboard && navigator.clipboard.writeText),
        readText: _common_platform_js__WEBPACK_IMPORTED_MODULE_1__["isNative"] ||
        !!(navigator && navigator.clipboard && navigator.clipboard.readText),
        richText: function () {
            if (_browser_js__WEBPACK_IMPORTED_MODULE_0__["isIE"]) {
                return false;
            }
            if (_browser_js__WEBPACK_IMPORTED_MODULE_0__["isEdge"]) {
                var index = navigator.userAgent.indexOf('Edge/');
                var version = parseInt(navigator.userAgent.substring(index + 5, navigator.userAgent.indexOf('.', index)), 10);
                if (!version || version >= 12 && version <= 16) {
                    return false;
                }
            }
            return true;
        }() },

    keyboard: function () {
        if (_common_platform_js__WEBPACK_IMPORTED_MODULE_1__["isNative"] || _browser_js__WEBPACK_IMPORTED_MODULE_0__["isStandalone"]) {
            return 0 /* Always */;
        }
        if (navigator.keyboard || _browser_js__WEBPACK_IMPORTED_MODULE_0__["isSafari"]) {
            return 1 /* FullScreen */;
        }
        return 2 /* None */;
    }(),
    touch: 'ontouchstart' in window || navigator.maxTouchPoints > 0 || window.navigator.msMaxTouchPoints > 0,
    pointerEvents: window.PointerEvent && ('ontouchstart' in window || window.navigator.maxTouchPoints > 0 || navigator.maxTouchPoints > 0 || window.navigator.msMaxTouchPoints > 0) };

/***/ }),

/***/ 6312:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "setARIAContainer", function() { return setARIAContainer; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "alert", function() { return alert; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "status", function() { return status; });
/* harmony import */ var _aria_css__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6313);
/* harmony import */ var _aria_css__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_aria_css__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _nls_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6210);
/* harmony import */ var _common_platform_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6222);
/* harmony import */ var _dom_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6292);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/




var ariaContainer;
var alertContainer;
var statusContainer;
function setARIAContainer(parent) {
    ariaContainer = document.createElement('div');
    ariaContainer.className = 'monaco-aria-container';
    alertContainer = document.createElement('div');
    alertContainer.className = 'monaco-alert';
    alertContainer.setAttribute('role', 'alert');
    alertContainer.setAttribute('aria-atomic', 'true');
    ariaContainer.appendChild(alertContainer);
    statusContainer = document.createElement('div');
    statusContainer.className = 'monaco-status';
    statusContainer.setAttribute('role', 'status');
    statusContainer.setAttribute('aria-atomic', 'true');
    ariaContainer.appendChild(statusContainer);
    parent.appendChild(ariaContainer);
}
/**
   * Given the provided message, will make sure that it is read as alert to screen readers.
   */
function alert(msg, disableRepeat) {
    insertMessage(alertContainer, msg, disableRepeat);
}
/**
   * Given the provided message, will make sure that it is read as status to screen readers.
   */
function status(msg, disableRepeat) {
    if (_common_platform_js__WEBPACK_IMPORTED_MODULE_2__["isMacintosh"]) {
        alert(msg, disableRepeat); // VoiceOver does not seem to support status role
    } else
    {
        insertMessage(statusContainer, msg, disableRepeat);
    }
}
var repeatedTimes = 0;
var prevText = undefined;
function insertMessage(target, msg, disableRepeat) {
    if (!ariaContainer) {
        return;
    }
    // If the same message should be inserted that is already present, a screen reader would
    // not announce this message because it matches the previous one. As a workaround, we
    // alter the message with the number of occurences unless this is explicitly disabled
    // via the disableRepeat flag.
    if (!disableRepeat) {
        if (prevText === msg) {
            repeatedTimes++;
        } else
        {
            prevText = msg;
            repeatedTimes = 0;
        }
        switch (repeatedTimes) {
            case 0:break;
            case 1:
                msg = _nls_js__WEBPACK_IMPORTED_MODULE_1__["localize"]('repeated', "{0} (occurred again)", msg);
                break;
            default:
                msg = _nls_js__WEBPACK_IMPORTED_MODULE_1__["localize"]('repeatedNtimes', "{0} (occurred {1} times)", msg, repeatedTimes);
                break;}

    }
    _dom_js__WEBPACK_IMPORTED_MODULE_3__["clearNode"](target);
    target.textContent = msg;
    // See https://www.paciellogroup.com/blog/2012/06/html5-accessibility-chops-aria-rolealert-browser-support/
    target.style.visibility = 'hidden';
    target.style.visibility = 'visible';
}

/***/ }),

/***/ 6313:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(6314);
if(typeof content === 'string') content = [[module.i, content, '']];
// Prepare cssTransformation
var transform;

var options = {"hmr":true}
options.transform = transform
// add the styles to the DOM
var update = __webpack_require__(3628)(content, options);
if(content.locals) module.exports = content.locals;
// Hot Module Replacement
if(false) {}

/***/ }),

/***/ 6314:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(3627)(false);
// imports


// module
exports.push([module.i, "/*---------------------------------------------------------------------------------------------\r\n *  Copyright (c) Microsoft Corporation. All rights reserved.\r\n *  Licensed under the MIT License. See License.txt in the project root for license information.\r\n *--------------------------------------------------------------------------------------------*/\r\n\r\n.monaco-aria-container {\r\n\tposition: absolute; /* try to hide from window but not from screen readers */\r\n\tleft:-999em;\r\n}", ""]);

// exports


/***/ }),

/***/ 6361:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ID_EDITOR_WORKER_SERVICE", function() { return ID_EDITOR_WORKER_SERVICE; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "IEditorWorkerService", function() { return IEditorWorkerService; });
/* harmony import */ var _platform_instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6224);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/

var ID_EDITOR_WORKER_SERVICE = 'editorWorkerService';
var IEditorWorkerService = Object(_platform_instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_0__["createDecorator"])(ID_EDITOR_WORKER_SERVICE);

/***/ }),

/***/ 6362:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "alertFormattingEdits", function() { return alertFormattingEdits; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getRealAndSyntheticDocumentFormattersOrdered", function() { return getRealAndSyntheticDocumentFormattersOrdered; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FormattingConflicts", function() { return FormattingConflicts; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "formatDocumentRangeWithSelectedProvider", function() { return formatDocumentRangeWithSelectedProvider; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "formatDocumentRangeWithProvider", function() { return formatDocumentRangeWithProvider; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "formatDocumentWithSelectedProvider", function() { return formatDocumentWithSelectedProvider; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "formatDocumentWithProvider", function() { return formatDocumentWithProvider; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getDocumentRangeFormattingEditsUntilResult", function() { return getDocumentRangeFormattingEditsUntilResult; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getDocumentFormattingEditsUntilResult", function() { return getDocumentFormattingEditsUntilResult; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getOnTypeFormattingEdits", function() { return getOnTypeFormattingEdits; });
/* harmony import */ var _base_browser_ui_aria_aria_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6312);
/* harmony import */ var _base_common_arrays_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6262);
/* harmony import */ var _base_common_cancellation_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6212);
/* harmony import */ var _base_common_errors_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6214);
/* harmony import */ var _base_common_uri_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6221);
/* harmony import */ var _browser_core_editorState_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6363);
/* harmony import */ var _browser_editorBrowser_js__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(6367);
/* harmony import */ var _common_core_position_js__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(6225);
/* harmony import */ var _common_core_range_js__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(6243);
/* harmony import */ var _common_core_selection_js__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(6242);
/* harmony import */ var _common_modes_js__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(6264);
/* harmony import */ var _common_services_editorWorkerService_js__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(6361);
/* harmony import */ var _common_services_modelService_js__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(6226);
/* harmony import */ var _formattingEdit_js__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(6369);
/* harmony import */ var _nls_js__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(6210);
/* harmony import */ var _platform_extensions_common_extensions_js__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(6371);
/* harmony import */ var _platform_instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(6224);
/* harmony import */ var _base_common_linkedList_js__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(6217);
/* harmony import */ var _platform_commands_common_commands_js__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(6231);
/* harmony import */ var _base_common_types_js__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(6232);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
    function adopt(value) {return value instanceof P ? value : new P(function (resolve) {resolve(value);});}
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {try {step(generator.next(value));} catch (e) {reject(e);}}
        function rejected(value) {try {step(generator["throw"](value));} catch (e) {reject(e);}}
        function step(result) {result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);}
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = undefined && undefined.__generator || function (thisArg, body) {
    var _ = { label: 0, sent: function () {if (t[0] & 1) throw t[1];return t[1];}, trys: [], ops: [] },f,y,t,g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {return this;}), g;
    function verb(n) {return function (v) {return step([n, v]);};}
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0:case 1:t = op;break;
                case 4:_.label++;return { value: op[1], done: false };
                case 5:_.label++;y = op[1];op = [0];continue;
                case 7:op = _.ops.pop();_.trys.pop();continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {_ = 0;continue;}
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {_.label = op[1];break;}
                    if (op[0] === 6 && _.label < t[1]) {_.label = t[1];t = op;break;}
                    if (t && _.label < t[2]) {_.label = t[2];_.ops.push(op);break;}
                    if (t[2]) _.ops.pop();
                    _.trys.pop();continue;}

            op = body.call(thisArg, _);
        } catch (e) {op = [6, e];y = 0;} finally {f = t = 0;}
        if (op[0] & 5) throw op[1];return { value: op[0] ? op[1] : void 0, done: true };
    }
};




















function alertFormattingEdits(edits) {
    edits = edits.filter(function (edit) {return edit.range;});
    if (!edits.length) {
        return;
    }
    var range = edits[0].range;
    for (var i = 1; i < edits.length; i++) {
        range = _common_core_range_js__WEBPACK_IMPORTED_MODULE_8__["Range"].plusRange(range, edits[i].range);
    }
    var startLineNumber = range.startLineNumber,endLineNumber = range.endLineNumber;
    if (startLineNumber === endLineNumber) {
        if (edits.length === 1) {
            Object(_base_browser_ui_aria_aria_js__WEBPACK_IMPORTED_MODULE_0__["alert"])(_nls_js__WEBPACK_IMPORTED_MODULE_14__["localize"]('hint11', "Made 1 formatting edit on line {0}", startLineNumber));
        } else
        {
            Object(_base_browser_ui_aria_aria_js__WEBPACK_IMPORTED_MODULE_0__["alert"])(_nls_js__WEBPACK_IMPORTED_MODULE_14__["localize"]('hintn1', "Made {0} formatting edits on line {1}", edits.length, startLineNumber));
        }
    } else
    {
        if (edits.length === 1) {
            Object(_base_browser_ui_aria_aria_js__WEBPACK_IMPORTED_MODULE_0__["alert"])(_nls_js__WEBPACK_IMPORTED_MODULE_14__["localize"]('hint1n', "Made 1 formatting edit between lines {0} and {1}", startLineNumber, endLineNumber));
        } else
        {
            Object(_base_browser_ui_aria_aria_js__WEBPACK_IMPORTED_MODULE_0__["alert"])(_nls_js__WEBPACK_IMPORTED_MODULE_14__["localize"]('hintnn', "Made {0} formatting edits between lines {1} and {2}", edits.length, startLineNumber, endLineNumber));
        }
    }
}
function getRealAndSyntheticDocumentFormattersOrdered(model) {
    var result = [];
    var seen = new Set();
    // (1) add all document formatter
    var docFormatter = _common_modes_js__WEBPACK_IMPORTED_MODULE_10__["DocumentFormattingEditProviderRegistry"].ordered(model);
    for (var _i = 0, docFormatter_1 = docFormatter; _i < docFormatter_1.length; _i++) {
        var formatter = docFormatter_1[_i];
        result.push(formatter);
        if (formatter.extensionId) {
            seen.add(_platform_extensions_common_extensions_js__WEBPACK_IMPORTED_MODULE_15__["ExtensionIdentifier"].toKey(formatter.extensionId));
        }
    }
    // (2) add all range formatter as document formatter (unless the same extension already did that)
    var rangeFormatter = _common_modes_js__WEBPACK_IMPORTED_MODULE_10__["DocumentRangeFormattingEditProviderRegistry"].ordered(model);
    var _loop_1 = function (formatter) {
        if (formatter.extensionId) {
            if (seen.has(_platform_extensions_common_extensions_js__WEBPACK_IMPORTED_MODULE_15__["ExtensionIdentifier"].toKey(formatter.extensionId))) {
                return "continue";
            }
            seen.add(_platform_extensions_common_extensions_js__WEBPACK_IMPORTED_MODULE_15__["ExtensionIdentifier"].toKey(formatter.extensionId));
        }
        result.push({
            displayName: formatter.displayName,
            extensionId: formatter.extensionId,
            provideDocumentFormattingEdits: function (model, options, token) {
                return formatter.provideDocumentRangeFormattingEdits(model, model.getFullModelRange(), options, token);
            } });

    };
    for (var _a = 0, rangeFormatter_1 = rangeFormatter; _a < rangeFormatter_1.length; _a++) {
        var formatter = rangeFormatter_1[_a];
        _loop_1(formatter);
    }
    return result;
}
var FormattingConflicts = /** @class */function () {
    function FormattingConflicts() {
    }
    FormattingConflicts.select = function (formatter, document, mode) {
        return __awaiter(this, void 0, void 0, function () {
            var selector;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (formatter.length === 0) {
                            return [2 /*return*/, undefined];
                        }
                        selector = FormattingConflicts._selectors.iterator().next().value;
                        if (!selector) return [3 /*break*/, 2];
                        return [4 /*yield*/, selector(formatter, document, mode)];
                    case 1:return [2 /*return*/, _a.sent()];
                    case 2:return [2 /*return*/, formatter[0]];}

            });
        });
    };
    FormattingConflicts._selectors = new _base_common_linkedList_js__WEBPACK_IMPORTED_MODULE_17__["LinkedList"]();
    return FormattingConflicts;
}();

function formatDocumentRangeWithSelectedProvider(accessor, editorOrModel, range, mode, token) {
    return __awaiter(this, void 0, void 0, function () {
        var instaService, model, provider, selected;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    instaService = accessor.get(_platform_instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_16__["IInstantiationService"]);
                    model = Object(_browser_editorBrowser_js__WEBPACK_IMPORTED_MODULE_6__["isCodeEditor"])(editorOrModel) ? editorOrModel.getModel() : editorOrModel;
                    provider = _common_modes_js__WEBPACK_IMPORTED_MODULE_10__["DocumentRangeFormattingEditProviderRegistry"].ordered(model);
                    return [4 /*yield*/, FormattingConflicts.select(provider, model, mode)];
                case 1:
                    selected = _a.sent();
                    if (!selected) return [3 /*break*/, 3];
                    return [4 /*yield*/, instaService.invokeFunction(formatDocumentRangeWithProvider, selected, editorOrModel, range, token)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:return [2 /*return*/];}

        });
    });
}
function formatDocumentRangeWithProvider(accessor, provider, editorOrModel, range, token) {
    return __awaiter(this, void 0, void 0, function () {
        var workerService, model, cts, edits, rawEdits, range_1, initialSelection_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    workerService = accessor.get(_common_services_editorWorkerService_js__WEBPACK_IMPORTED_MODULE_11__["IEditorWorkerService"]);
                    if (Object(_browser_editorBrowser_js__WEBPACK_IMPORTED_MODULE_6__["isCodeEditor"])(editorOrModel)) {
                        model = editorOrModel.getModel();
                        cts = new _browser_core_editorState_js__WEBPACK_IMPORTED_MODULE_5__["EditorStateCancellationTokenSource"](editorOrModel, 1 /* Value */ | 4 /* Position */, token);
                    } else
                    {
                        model = editorOrModel;
                        cts = new _browser_core_editorState_js__WEBPACK_IMPORTED_MODULE_5__["TextModelCancellationTokenSource"](editorOrModel, token);
                    }
                    _a.label = 1;
                case 1:
                    _a.trys.push([1,, 4, 5]);
                    return [4 /*yield*/, provider.provideDocumentRangeFormattingEdits(model, range, model.getFormattingOptions(), cts.token)];
                case 2:
                    rawEdits = _a.sent();
                    return [4 /*yield*/, workerService.computeMoreMinimalEdits(model.uri, rawEdits)];
                case 3:
                    edits = _a.sent();
                    if (cts.token.isCancellationRequested) {
                        return [2 /*return*/, true];
                    }
                    return [3 /*break*/, 5];
                case 4:
                    cts.dispose();
                    return [7 /*endfinally*/];
                case 5:
                    if (!edits || edits.length === 0) {
                        return [2 /*return*/, false];
                    }
                    if (Object(_browser_editorBrowser_js__WEBPACK_IMPORTED_MODULE_6__["isCodeEditor"])(editorOrModel)) {
                        // use editor to apply edits
                        _formattingEdit_js__WEBPACK_IMPORTED_MODULE_13__["FormattingEdit"].execute(editorOrModel, edits);
                        alertFormattingEdits(edits);
                        editorOrModel.pushUndoStop();
                        editorOrModel.revealPositionInCenterIfOutsideViewport(editorOrModel.getPosition(), 1 /* Immediate */);
                    } else
                    {
                        range_1 = edits[0].range;
                        initialSelection_1 = new _common_core_selection_js__WEBPACK_IMPORTED_MODULE_9__["Selection"](range_1.startLineNumber, range_1.startColumn, range_1.endLineNumber, range_1.endColumn);
                        model.pushEditOperations([initialSelection_1], edits.map(function (edit) {
                            return {
                                text: edit.text,
                                range: _common_core_range_js__WEBPACK_IMPORTED_MODULE_8__["Range"].lift(edit.range),
                                forceMoveMarkers: true };

                        }), function (undoEdits) {
                            for (var _i = 0, undoEdits_1 = undoEdits; _i < undoEdits_1.length; _i++) {
                                var range_2 = undoEdits_1[_i].range;
                                if (_common_core_range_js__WEBPACK_IMPORTED_MODULE_8__["Range"].areIntersectingOrTouching(range_2, initialSelection_1)) {
                                    return [new _common_core_selection_js__WEBPACK_IMPORTED_MODULE_9__["Selection"](range_2.startLineNumber, range_2.startColumn, range_2.endLineNumber, range_2.endColumn)];
                                }
                            }
                            return null;
                        });
                    }
                    return [2 /*return*/, true];}

        });
    });
}
function formatDocumentWithSelectedProvider(accessor, editorOrModel, mode, token) {
    return __awaiter(this, void 0, void 0, function () {
        var instaService, model, provider, selected;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    instaService = accessor.get(_platform_instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_16__["IInstantiationService"]);
                    model = Object(_browser_editorBrowser_js__WEBPACK_IMPORTED_MODULE_6__["isCodeEditor"])(editorOrModel) ? editorOrModel.getModel() : editorOrModel;
                    provider = getRealAndSyntheticDocumentFormattersOrdered(model);
                    return [4 /*yield*/, FormattingConflicts.select(provider, model, mode)];
                case 1:
                    selected = _a.sent();
                    if (!selected) return [3 /*break*/, 3];
                    return [4 /*yield*/, instaService.invokeFunction(formatDocumentWithProvider, selected, editorOrModel, mode, token)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:return [2 /*return*/];}

        });
    });
}
function formatDocumentWithProvider(accessor, provider, editorOrModel, mode, token) {
    return __awaiter(this, void 0, void 0, function () {
        var workerService, model, cts, edits, rawEdits, range, initialSelection_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    workerService = accessor.get(_common_services_editorWorkerService_js__WEBPACK_IMPORTED_MODULE_11__["IEditorWorkerService"]);
                    if (Object(_browser_editorBrowser_js__WEBPACK_IMPORTED_MODULE_6__["isCodeEditor"])(editorOrModel)) {
                        model = editorOrModel.getModel();
                        cts = new _browser_core_editorState_js__WEBPACK_IMPORTED_MODULE_5__["EditorStateCancellationTokenSource"](editorOrModel, 1 /* Value */ | 4 /* Position */, token);
                    } else
                    {
                        model = editorOrModel;
                        cts = new _browser_core_editorState_js__WEBPACK_IMPORTED_MODULE_5__["TextModelCancellationTokenSource"](editorOrModel, token);
                    }
                    _a.label = 1;
                case 1:
                    _a.trys.push([1,, 4, 5]);
                    return [4 /*yield*/, provider.provideDocumentFormattingEdits(model, model.getFormattingOptions(), cts.token)];
                case 2:
                    rawEdits = _a.sent();
                    return [4 /*yield*/, workerService.computeMoreMinimalEdits(model.uri, rawEdits)];
                case 3:
                    edits = _a.sent();
                    if (cts.token.isCancellationRequested) {
                        return [2 /*return*/, true];
                    }
                    return [3 /*break*/, 5];
                case 4:
                    cts.dispose();
                    return [7 /*endfinally*/];
                case 5:
                    if (!edits || edits.length === 0) {
                        return [2 /*return*/, false];
                    }
                    if (Object(_browser_editorBrowser_js__WEBPACK_IMPORTED_MODULE_6__["isCodeEditor"])(editorOrModel)) {
                        // use editor to apply edits
                        _formattingEdit_js__WEBPACK_IMPORTED_MODULE_13__["FormattingEdit"].execute(editorOrModel, edits);
                        if (mode !== 2 /* Silent */) {
                                alertFormattingEdits(edits);
                                editorOrModel.pushUndoStop();
                                editorOrModel.revealPositionInCenterIfOutsideViewport(editorOrModel.getPosition(), 1 /* Immediate */);
                            }
                    } else
                    {
                        range = edits[0].range;
                        initialSelection_2 = new _common_core_selection_js__WEBPACK_IMPORTED_MODULE_9__["Selection"](range.startLineNumber, range.startColumn, range.endLineNumber, range.endColumn);
                        model.pushEditOperations([initialSelection_2], edits.map(function (edit) {
                            return {
                                text: edit.text,
                                range: _common_core_range_js__WEBPACK_IMPORTED_MODULE_8__["Range"].lift(edit.range),
                                forceMoveMarkers: true };

                        }), function (undoEdits) {
                            for (var _i = 0, undoEdits_2 = undoEdits; _i < undoEdits_2.length; _i++) {
                                var range_3 = undoEdits_2[_i].range;
                                if (_common_core_range_js__WEBPACK_IMPORTED_MODULE_8__["Range"].areIntersectingOrTouching(range_3, initialSelection_2)) {
                                    return [new _common_core_selection_js__WEBPACK_IMPORTED_MODULE_9__["Selection"](range_3.startLineNumber, range_3.startColumn, range_3.endLineNumber, range_3.endColumn)];
                                }
                            }
                            return null;
                        });
                    }
                    return [2 /*return*/, true];}

        });
    });
}
function getDocumentRangeFormattingEditsUntilResult(workerService, model, range, options, token) {
    return __awaiter(this, void 0, void 0, function () {
        var providers, _i, providers_1, provider, rawEdits;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    providers = _common_modes_js__WEBPACK_IMPORTED_MODULE_10__["DocumentRangeFormattingEditProviderRegistry"].ordered(model);
                    _i = 0, providers_1 = providers;
                    _a.label = 1;
                case 1:
                    if (!(_i < providers_1.length)) return [3 /*break*/, 5];
                    provider = providers_1[_i];
                    return [4 /*yield*/, Promise.resolve(provider.provideDocumentRangeFormattingEdits(model, range, options, token)).catch(_base_common_errors_js__WEBPACK_IMPORTED_MODULE_3__["onUnexpectedExternalError"])];
                case 2:
                    rawEdits = _a.sent();
                    if (!Object(_base_common_arrays_js__WEBPACK_IMPORTED_MODULE_1__["isNonEmptyArray"])(rawEdits)) return [3 /*break*/, 4];
                    return [4 /*yield*/, workerService.computeMoreMinimalEdits(model.uri, rawEdits)];
                case 3:return [2 /*return*/, _a.sent()];
                case 4:
                    _i++;
                    return [3 /*break*/, 1];
                case 5:return [2 /*return*/, undefined];}

        });
    });
}
function getDocumentFormattingEditsUntilResult(workerService, model, options, token) {
    return __awaiter(this, void 0, void 0, function () {
        var providers, _i, providers_2, provider, rawEdits;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    providers = getRealAndSyntheticDocumentFormattersOrdered(model);
                    _i = 0, providers_2 = providers;
                    _a.label = 1;
                case 1:
                    if (!(_i < providers_2.length)) return [3 /*break*/, 5];
                    provider = providers_2[_i];
                    return [4 /*yield*/, Promise.resolve(provider.provideDocumentFormattingEdits(model, options, token)).catch(_base_common_errors_js__WEBPACK_IMPORTED_MODULE_3__["onUnexpectedExternalError"])];
                case 2:
                    rawEdits = _a.sent();
                    if (!Object(_base_common_arrays_js__WEBPACK_IMPORTED_MODULE_1__["isNonEmptyArray"])(rawEdits)) return [3 /*break*/, 4];
                    return [4 /*yield*/, workerService.computeMoreMinimalEdits(model.uri, rawEdits)];
                case 3:return [2 /*return*/, _a.sent()];
                case 4:
                    _i++;
                    return [3 /*break*/, 1];
                case 5:return [2 /*return*/, undefined];}

        });
    });
}
function getOnTypeFormattingEdits(workerService, model, position, ch, options) {
    var providers = _common_modes_js__WEBPACK_IMPORTED_MODULE_10__["OnTypeFormattingEditProviderRegistry"].ordered(model);
    if (providers.length === 0) {
        return Promise.resolve(undefined);
    }
    if (providers[0].autoFormatTriggerCharacters.indexOf(ch) < 0) {
        return Promise.resolve(undefined);
    }
    return Promise.resolve(providers[0].provideOnTypeFormattingEdits(model, position, ch, options, _base_common_cancellation_js__WEBPACK_IMPORTED_MODULE_2__["CancellationToken"].None)).catch(_base_common_errors_js__WEBPACK_IMPORTED_MODULE_3__["onUnexpectedExternalError"]).then(function (edits) {
        return workerService.computeMoreMinimalEdits(model.uri, edits);
    });
}
_platform_commands_common_commands_js__WEBPACK_IMPORTED_MODULE_18__["CommandsRegistry"].registerCommand('_executeFormatRangeProvider', function (accessor) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    var resource = args[0],range = args[1],options = args[2];
    Object(_base_common_types_js__WEBPACK_IMPORTED_MODULE_19__["assertType"])(_base_common_uri_js__WEBPACK_IMPORTED_MODULE_4__["URI"].isUri(resource));
    Object(_base_common_types_js__WEBPACK_IMPORTED_MODULE_19__["assertType"])(_common_core_range_js__WEBPACK_IMPORTED_MODULE_8__["Range"].isIRange(range));
    var model = accessor.get(_common_services_modelService_js__WEBPACK_IMPORTED_MODULE_12__["IModelService"]).getModel(resource);
    if (!model) {
        throw Object(_base_common_errors_js__WEBPACK_IMPORTED_MODULE_3__["illegalArgument"])('resource');
    }
    return getDocumentRangeFormattingEditsUntilResult(accessor.get(_common_services_editorWorkerService_js__WEBPACK_IMPORTED_MODULE_11__["IEditorWorkerService"]), model, _common_core_range_js__WEBPACK_IMPORTED_MODULE_8__["Range"].lift(range), options, _base_common_cancellation_js__WEBPACK_IMPORTED_MODULE_2__["CancellationToken"].None);
});
_platform_commands_common_commands_js__WEBPACK_IMPORTED_MODULE_18__["CommandsRegistry"].registerCommand('_executeFormatDocumentProvider', function (accessor) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    var resource = args[0],options = args[1];
    Object(_base_common_types_js__WEBPACK_IMPORTED_MODULE_19__["assertType"])(_base_common_uri_js__WEBPACK_IMPORTED_MODULE_4__["URI"].isUri(resource));
    var model = accessor.get(_common_services_modelService_js__WEBPACK_IMPORTED_MODULE_12__["IModelService"]).getModel(resource);
    if (!model) {
        throw Object(_base_common_errors_js__WEBPACK_IMPORTED_MODULE_3__["illegalArgument"])('resource');
    }
    return getDocumentFormattingEditsUntilResult(accessor.get(_common_services_editorWorkerService_js__WEBPACK_IMPORTED_MODULE_11__["IEditorWorkerService"]), model, options, _base_common_cancellation_js__WEBPACK_IMPORTED_MODULE_2__["CancellationToken"].None);
});
_platform_commands_common_commands_js__WEBPACK_IMPORTED_MODULE_18__["CommandsRegistry"].registerCommand('_executeFormatOnTypeProvider', function (accessor) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    var resource = args[0],position = args[1],ch = args[2],options = args[3];
    Object(_base_common_types_js__WEBPACK_IMPORTED_MODULE_19__["assertType"])(_base_common_uri_js__WEBPACK_IMPORTED_MODULE_4__["URI"].isUri(resource));
    Object(_base_common_types_js__WEBPACK_IMPORTED_MODULE_19__["assertType"])(_common_core_position_js__WEBPACK_IMPORTED_MODULE_7__["Position"].isIPosition(position));
    Object(_base_common_types_js__WEBPACK_IMPORTED_MODULE_19__["assertType"])(typeof ch === 'string');
    var model = accessor.get(_common_services_modelService_js__WEBPACK_IMPORTED_MODULE_12__["IModelService"]).getModel(resource);
    if (!model) {
        throw Object(_base_common_errors_js__WEBPACK_IMPORTED_MODULE_3__["illegalArgument"])('resource');
    }
    return getOnTypeFormattingEdits(accessor.get(_common_services_editorWorkerService_js__WEBPACK_IMPORTED_MODULE_11__["IEditorWorkerService"]), model, _common_core_position_js__WEBPACK_IMPORTED_MODULE_7__["Position"].lift(position), ch, options);
});

/***/ }),

/***/ 6363:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "EditorState", function() { return EditorState; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "EditorStateCancellationTokenSource", function() { return EditorStateCancellationTokenSource; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "TextModelCancellationTokenSource", function() { return TextModelCancellationTokenSource; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "StableEditorScrollState", function() { return StableEditorScrollState; });
/* harmony import */ var _base_common_strings_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6219);
/* harmony import */ var _base_common_cancellation_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6212);
/* harmony import */ var _base_common_lifecycle_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6216);
/* harmony import */ var _keybindingCancellation_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6364);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __extends = undefined && undefined.__extends || function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
        { __proto__: [] } instanceof Array && function (d, b) {d.__proto__ = b;} ||
        function (d, b) {for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];};
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {this.constructor = d;}
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();




var EditorState = /** @class */function () {
    function EditorState(editor, flags) {
        this.flags = flags;
        if ((this.flags & 1 /* Value */) !== 0) {
            var model = editor.getModel();
            this.modelVersionId = model ? _base_common_strings_js__WEBPACK_IMPORTED_MODULE_0__["format"]('{0}#{1}', model.uri.toString(), model.getVersionId()) : null;
        } else
        {
            this.modelVersionId = null;
        }
        if ((this.flags & 4 /* Position */) !== 0) {
            this.position = editor.getPosition();
        } else
        {
            this.position = null;
        }
        if ((this.flags & 2 /* Selection */) !== 0) {
            this.selection = editor.getSelection();
        } else
        {
            this.selection = null;
        }
        if ((this.flags & 8 /* Scroll */) !== 0) {
            this.scrollLeft = editor.getScrollLeft();
            this.scrollTop = editor.getScrollTop();
        } else
        {
            this.scrollLeft = -1;
            this.scrollTop = -1;
        }
    }
    EditorState.prototype._equals = function (other) {
        if (!(other instanceof EditorState)) {
            return false;
        }
        var state = other;
        if (this.modelVersionId !== state.modelVersionId) {
            return false;
        }
        if (this.scrollLeft !== state.scrollLeft || this.scrollTop !== state.scrollTop) {
            return false;
        }
        if (!this.position && state.position || this.position && !state.position || this.position && state.position && !this.position.equals(state.position)) {
            return false;
        }
        if (!this.selection && state.selection || this.selection && !state.selection || this.selection && state.selection && !this.selection.equalsRange(state.selection)) {
            return false;
        }
        return true;
    };
    EditorState.prototype.validate = function (editor) {
        return this._equals(new EditorState(editor, this.flags));
    };
    return EditorState;
}();

/**
                         * A cancellation token source that cancels when the editor changes as expressed
                         * by the provided flags
                         */
var EditorStateCancellationTokenSource = /** @class */function (_super) {
    __extends(EditorStateCancellationTokenSource, _super);
    function EditorStateCancellationTokenSource(editor, flags, parent) {
        var _this = _super.call(this, editor, parent) || this;
        _this.editor = editor;
        _this._listener = new _base_common_lifecycle_js__WEBPACK_IMPORTED_MODULE_2__["DisposableStore"]();
        if (flags & 4 /* Position */) {
                _this._listener.add(editor.onDidChangeCursorPosition(function (_) {return _this.cancel();}));
            }
        if (flags & 2 /* Selection */) {
                _this._listener.add(editor.onDidChangeCursorSelection(function (_) {return _this.cancel();}));
            }
        if (flags & 8 /* Scroll */) {
                _this._listener.add(editor.onDidScrollChange(function (_) {return _this.cancel();}));
            }
        if (flags & 1 /* Value */) {
                _this._listener.add(editor.onDidChangeModel(function (_) {return _this.cancel();}));
                _this._listener.add(editor.onDidChangeModelContent(function (_) {return _this.cancel();}));
            }
        return _this;
    }
    EditorStateCancellationTokenSource.prototype.dispose = function () {
        this._listener.dispose();
        _super.prototype.dispose.call(this);
    };
    return EditorStateCancellationTokenSource;
}(_keybindingCancellation_js__WEBPACK_IMPORTED_MODULE_3__["EditorKeybindingCancellationTokenSource"]);

/**
                                                * A cancellation token source that cancels when the provided model changes
                                                */
var TextModelCancellationTokenSource = /** @class */function (_super) {
    __extends(TextModelCancellationTokenSource, _super);
    function TextModelCancellationTokenSource(model, parent) {
        var _this = _super.call(this, parent) || this;
        _this._listener = model.onDidChangeContent(function () {return _this.cancel();});
        return _this;
    }
    TextModelCancellationTokenSource.prototype.dispose = function () {
        this._listener.dispose();
        _super.prototype.dispose.call(this);
    };
    return TextModelCancellationTokenSource;
}(_base_common_cancellation_js__WEBPACK_IMPORTED_MODULE_1__["CancellationTokenSource"]);

var StableEditorScrollState = /** @class */function () {
    function StableEditorScrollState(_visiblePosition, _visiblePositionScrollDelta) {
        this._visiblePosition = _visiblePosition;
        this._visiblePositionScrollDelta = _visiblePositionScrollDelta;
    }
    StableEditorScrollState.capture = function (editor) {
        var visiblePosition = null;
        var visiblePositionScrollDelta = 0;
        if (editor.getScrollTop() !== 0) {
            var visibleRanges = editor.getVisibleRanges();
            if (visibleRanges.length > 0) {
                visiblePosition = visibleRanges[0].getStartPosition();
                var visiblePositionScrollTop = editor.getTopForPosition(visiblePosition.lineNumber, visiblePosition.column);
                visiblePositionScrollDelta = editor.getScrollTop() - visiblePositionScrollTop;
            }
        }
        return new StableEditorScrollState(visiblePosition, visiblePositionScrollDelta);
    };
    StableEditorScrollState.prototype.restore = function (editor) {
        if (this._visiblePosition) {
            var visiblePositionScrollTop = editor.getTopForPosition(this._visiblePosition.lineNumber, this._visiblePosition.column);
            editor.setScrollTop(visiblePositionScrollTop + this._visiblePositionScrollDelta);
        }
    };
    return StableEditorScrollState;
}();


/***/ }),

/***/ 6364:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "EditorKeybindingCancellationTokenSource", function() { return EditorKeybindingCancellationTokenSource; });
/* harmony import */ var _editorExtensions_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6220);
/* harmony import */ var _platform_contextkey_common_contextkey_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6230);
/* harmony import */ var _base_common_cancellation_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6212);
/* harmony import */ var _base_common_linkedList_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6217);
/* harmony import */ var _platform_instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6224);
/* harmony import */ var _platform_instantiation_common_extensions_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6365);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __extends = undefined && undefined.__extends || function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
        { __proto__: [] } instanceof Array && function (d, b) {d.__proto__ = b;} ||
        function (d, b) {for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];};
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {this.constructor = d;}
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();






var IEditorCancellationTokens = Object(_platform_instantiation_common_instantiation_js__WEBPACK_IMPORTED_MODULE_4__["createDecorator"])('IEditorCancelService');
var ctxCancellableOperation = new _platform_contextkey_common_contextkey_js__WEBPACK_IMPORTED_MODULE_1__["RawContextKey"]('cancellableOperation', false);
Object(_platform_instantiation_common_extensions_js__WEBPACK_IMPORTED_MODULE_5__["registerSingleton"])(IEditorCancellationTokens, /** @class */function () {
    function class_1() {
        this._tokens = new WeakMap();
    }
    class_1.prototype.add = function (editor, cts) {
        var data = this._tokens.get(editor);
        if (!data) {
            data = editor.invokeWithinContext(function (accessor) {
                var key = ctxCancellableOperation.bindTo(accessor.get(_platform_contextkey_common_contextkey_js__WEBPACK_IMPORTED_MODULE_1__["IContextKeyService"]));
                var tokens = new _base_common_linkedList_js__WEBPACK_IMPORTED_MODULE_3__["LinkedList"]();
                return { key: key, tokens: tokens };
            });
            this._tokens.set(editor, data);
        }
        var removeFn;
        data.key.set(true);
        removeFn = data.tokens.push(cts);
        return function () {
            // remove w/o cancellation
            if (removeFn) {
                removeFn();
                data.key.set(!data.tokens.isEmpty());
                removeFn = undefined;
            }
        };
    };
    class_1.prototype.cancel = function (editor) {
        var data = this._tokens.get(editor);
        if (!data) {
            return;
        }
        // remove with cancellation
        var cts = data.tokens.pop();
        if (cts) {
            cts.cancel();
            data.key.set(!data.tokens.isEmpty());
        }
    };
    return class_1;
}(), true);
var EditorKeybindingCancellationTokenSource = /** @class */function (_super) {
    __extends(EditorKeybindingCancellationTokenSource, _super);
    function EditorKeybindingCancellationTokenSource(editor, parent) {
        var _this = _super.call(this, parent) || this;
        _this.editor = editor;
        _this._unregister = editor.invokeWithinContext(function (accessor) {return accessor.get(IEditorCancellationTokens).add(editor, _this);});
        return _this;
    }
    EditorKeybindingCancellationTokenSource.prototype.dispose = function () {
        this._unregister();
        _super.prototype.dispose.call(this);
    };
    return EditorKeybindingCancellationTokenSource;
}(_base_common_cancellation_js__WEBPACK_IMPORTED_MODULE_2__["CancellationTokenSource"]);

Object(_editorExtensions_js__WEBPACK_IMPORTED_MODULE_0__["registerEditorCommand"])(new ( /** @class */function (_super) {
    __extends(class_2, _super);
    function class_2() {
        return _super.call(this, {
            id: 'editor.cancelOperation',
            kbOpts: {
                weight: 100 /* EditorContrib */,
                primary: 9 /* Escape */ },

            precondition: ctxCancellableOperation }) ||
        this;
    }
    class_2.prototype.runEditorCommand = function (accessor, editor) {
        accessor.get(IEditorCancellationTokens).cancel(editor);
    };
    return class_2;
}(_editorExtensions_js__WEBPACK_IMPORTED_MODULE_0__["EditorCommand"]))());

/***/ }),

/***/ 6365:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "registerSingleton", function() { return registerSingleton; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getSingletonServiceDescriptors", function() { return getSingletonServiceDescriptors; });
/* harmony import */ var _descriptors_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6366);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/

var _registry = [];
function registerSingleton(id, ctor, supportsDelayedInstantiation) {
    _registry.push([id, new _descriptors_js__WEBPACK_IMPORTED_MODULE_0__["SyncDescriptor"](ctor, [], supportsDelayedInstantiation)]);
}
function getSingletonServiceDescriptors() {
    return _registry;
}

/***/ }),

/***/ 6366:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SyncDescriptor", function() { return SyncDescriptor; });
var SyncDescriptor = /** @class */function () {
    function SyncDescriptor(ctor, staticArguments, supportsDelayedInstantiation) {
        if (staticArguments === void 0) {staticArguments = [];}
        if (supportsDelayedInstantiation === void 0) {supportsDelayedInstantiation = false;}
        this.ctor = ctor;
        this.staticArguments = staticArguments;
        this.supportsDelayedInstantiation = supportsDelayedInstantiation;
    }
    return SyncDescriptor;
}();


/***/ }),

/***/ 6367:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isCodeEditor", function() { return isCodeEditor; });
/* harmony import */ var _common_editorCommon_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6368);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/

/**
                                                            *@internal
                                                            */
function isCodeEditor(thing) {
    if (thing && typeof thing.getEditorType === 'function') {
        return thing.getEditorType() === _common_editorCommon_js__WEBPACK_IMPORTED_MODULE_0__["EditorType"].ICodeEditor;
    } else
    {
        return false;
    }
}

/***/ }),

/***/ 6368:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isThemeColor", function() { return isThemeColor; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "EditorType", function() { return EditorType; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Handler", function() { return Handler; });
/**
 * @internal
 */
function isThemeColor(o) {
    return o && typeof o.id === 'string';
}
/**
   * The type of the `IEditor`.
   */
var EditorType = {
    ICodeEditor: 'vs.editor.ICodeEditor',
    IDiffEditor: 'vs.editor.IDiffEditor' };

/**
                                             * Built-in commands.
                                             * @internal
                                             */
var Handler = {
    ExecuteCommand: 'executeCommand',
    ExecuteCommands: 'executeCommands',
    Type: 'type',
    ReplacePreviousChar: 'replacePreviousChar',
    CompositionStart: 'compositionStart',
    CompositionEnd: 'compositionEnd',
    Paste: 'paste',
    Cut: 'cut',
    Undo: 'undo',
    Redo: 'redo' };

/***/ }),

/***/ 6369:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FormattingEdit", function() { return FormattingEdit; });
/* harmony import */ var _common_core_editOperation_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6370);
/* harmony import */ var _common_core_range_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6243);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/


var FormattingEdit = /** @class */function () {
    function FormattingEdit() {
    }
    FormattingEdit._handleEolEdits = function (editor, edits) {
        var newEol = undefined;
        var singleEdits = [];
        for (var _i = 0, edits_1 = edits; _i < edits_1.length; _i++) {
            var edit = edits_1[_i];
            if (typeof edit.eol === 'number') {
                newEol = edit.eol;
            }
            if (edit.range && typeof edit.text === 'string') {
                singleEdits.push(edit);
            }
        }
        if (typeof newEol === 'number') {
            if (editor.hasModel()) {
                editor.getModel().pushEOL(newEol);
            }
        }
        return singleEdits;
    };
    FormattingEdit._isFullModelReplaceEdit = function (editor, edit) {
        if (!editor.hasModel()) {
            return false;
        }
        var model = editor.getModel();
        var editRange = model.validateRange(edit.range);
        var fullModelRange = model.getFullModelRange();
        return fullModelRange.equalsRange(editRange);
    };
    FormattingEdit.execute = function (editor, _edits) {
        editor.pushUndoStop();
        var edits = FormattingEdit._handleEolEdits(editor, _edits);
        if (edits.length === 1 && FormattingEdit._isFullModelReplaceEdit(editor, edits[0])) {
            // We use replace semantics and hope that markers stay put...
            editor.executeEdits('formatEditsCommand', edits.map(function (edit) {return _common_core_editOperation_js__WEBPACK_IMPORTED_MODULE_0__["EditOperation"].replace(_common_core_range_js__WEBPACK_IMPORTED_MODULE_1__["Range"].lift(edit.range), edit.text);}));
        } else
        {
            editor.executeEdits('formatEditsCommand', edits.map(function (edit) {return _common_core_editOperation_js__WEBPACK_IMPORTED_MODULE_0__["EditOperation"].replaceMove(_common_core_range_js__WEBPACK_IMPORTED_MODULE_1__["Range"].lift(edit.range), edit.text);}));
        }
        editor.pushUndoStop();
    };
    return FormattingEdit;
}();


/***/ }),

/***/ 6370:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "EditOperation", function() { return EditOperation; });
/* harmony import */ var _range_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6243);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/

var EditOperation = /** @class */function () {
    function EditOperation() {
    }
    EditOperation.insert = function (position, text) {
        return {
            range: new _range_js__WEBPACK_IMPORTED_MODULE_0__["Range"](position.lineNumber, position.column, position.lineNumber, position.column),
            text: text,
            forceMoveMarkers: true };

    };
    EditOperation.delete = function (range) {
        return {
            range: range,
            text: null };

    };
    EditOperation.replace = function (range, text) {
        return {
            range: range,
            text: text };

    };
    EditOperation.replaceMove = function (range, text) {
        return {
            range: range,
            text: text,
            forceMoveMarkers: true };

    };
    return EditOperation;
}();


/***/ }),

/***/ 6371:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ExtensionIdentifier", function() { return ExtensionIdentifier; });
/**
 * **!Do not construct directly!**
 *
 * **!Only static methods because it gets serialized!**
 *
 * This represents the "canonical" version for an extension identifier. Extension ids
 * have to be case-insensitive (due to the marketplace), but we must ensure case
 * preservation because the extension API is already public at this time.
 *
 * For example, given an extension with the publisher `"Hello"` and the name `"World"`,
 * its canonical extension identifier is `"Hello.World"`. This extension could be
 * referenced in some other extension's dependencies using the string `"hello.world"`.
 *
 * To make matters more complicated, an extension can optionally have an UUID. When two
 * extensions have the same UUID, they are considered equal even if their identifier is different.
 */
var ExtensionIdentifier = /** @class */function () {
    function ExtensionIdentifier(value) {
        this.value = value;
        this._lower = value.toLowerCase();
    }
    /**
       * Gives the value by which to index (for equality).
       */
    ExtensionIdentifier.toKey = function (id) {
        if (typeof id === 'string') {
            return id.toLowerCase();
        }
        return id._lower;
    };
    return ExtensionIdentifier;
}();


/***/ }),

/***/ 6381:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ClickLinkMouseEvent", function() { return ClickLinkMouseEvent; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ClickLinkKeyboardEvent", function() { return ClickLinkKeyboardEvent; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ClickLinkOptions", function() { return ClickLinkOptions; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ClickLinkGesture", function() { return ClickLinkGesture; });
/* harmony import */ var _base_browser_browser_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6293);
/* harmony import */ var _base_common_lifecycle_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6216);
/* harmony import */ var _base_common_event_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6213);
/* harmony import */ var _base_common_platform_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6222);
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __extends = undefined && undefined.__extends || function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
        { __proto__: [] } instanceof Array && function (d, b) {d.__proto__ = b;} ||
        function (d, b) {for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];};
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {this.constructor = d;}
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();




function hasModifier(e, modifier) {
    return !!e[modifier];
}
/**
   * An event that encapsulates the various trigger modifiers logic needed for go to definition.
   */
var ClickLinkMouseEvent = /** @class */function () {
    function ClickLinkMouseEvent(source, opts) {
        this.target = source.target;
        this.hasTriggerModifier = hasModifier(source.event, opts.triggerModifier);
        this.hasSideBySideModifier = hasModifier(source.event, opts.triggerSideBySideModifier);
        this.isNoneOrSingleMouseDown = _base_browser_browser_js__WEBPACK_IMPORTED_MODULE_0__["isIE"] || source.event.detail <= 1; // IE does not support event.detail properly
    }
    return ClickLinkMouseEvent;
}();

/**
                                 * An event that encapsulates the various trigger modifiers logic needed for go to definition.
                                 */
var ClickLinkKeyboardEvent = /** @class */function () {
    function ClickLinkKeyboardEvent(source, opts) {
        this.keyCodeIsTriggerKey = source.keyCode === opts.triggerKey;
        this.keyCodeIsSideBySideKey = source.keyCode === opts.triggerSideBySideKey;
        this.hasTriggerModifier = hasModifier(source, opts.triggerModifier);
    }
    return ClickLinkKeyboardEvent;
}();

var ClickLinkOptions = /** @class */function () {
    function ClickLinkOptions(triggerKey, triggerModifier, triggerSideBySideKey, triggerSideBySideModifier) {
        this.triggerKey = triggerKey;
        this.triggerModifier = triggerModifier;
        this.triggerSideBySideKey = triggerSideBySideKey;
        this.triggerSideBySideModifier = triggerSideBySideModifier;
    }
    ClickLinkOptions.prototype.equals = function (other) {
        return this.triggerKey === other.triggerKey &&
        this.triggerModifier === other.triggerModifier &&
        this.triggerSideBySideKey === other.triggerSideBySideKey &&
        this.triggerSideBySideModifier === other.triggerSideBySideModifier;
    };
    return ClickLinkOptions;
}();

function createOptions(multiCursorModifier) {
    if (multiCursorModifier === 'altKey') {
        if (_base_common_platform_js__WEBPACK_IMPORTED_MODULE_3__["isMacintosh"]) {
            return new ClickLinkOptions(57 /* Meta */, 'metaKey', 6 /* Alt */, 'altKey');
        }
        return new ClickLinkOptions(5 /* Ctrl */, 'ctrlKey', 6 /* Alt */, 'altKey');
    }
    if (_base_common_platform_js__WEBPACK_IMPORTED_MODULE_3__["isMacintosh"]) {
        return new ClickLinkOptions(6 /* Alt */, 'altKey', 57 /* Meta */, 'metaKey');
    }
    return new ClickLinkOptions(6 /* Alt */, 'altKey', 5 /* Ctrl */, 'ctrlKey');
}
var ClickLinkGesture = /** @class */function (_super) {
    __extends(ClickLinkGesture, _super);
    function ClickLinkGesture(editor) {
        var _this = _super.call(this) || this;
        _this._onMouseMoveOrRelevantKeyDown = _this._register(new _base_common_event_js__WEBPACK_IMPORTED_MODULE_2__["Emitter"]());
        _this.onMouseMoveOrRelevantKeyDown = _this._onMouseMoveOrRelevantKeyDown.event;
        _this._onExecute = _this._register(new _base_common_event_js__WEBPACK_IMPORTED_MODULE_2__["Emitter"]());
        _this.onExecute = _this._onExecute.event;
        _this._onCancel = _this._register(new _base_common_event_js__WEBPACK_IMPORTED_MODULE_2__["Emitter"]());
        _this.onCancel = _this._onCancel.event;
        _this._editor = editor;
        _this._opts = createOptions(_this._editor.getOption(59 /* multiCursorModifier */));
        _this.lastMouseMoveEvent = null;
        _this.hasTriggerKeyOnMouseDown = false;
        _this._register(_this._editor.onDidChangeConfiguration(function (e) {
            if (e.hasChanged(59 /* multiCursorModifier */)) {
                var newOpts = createOptions(_this._editor.getOption(59 /* multiCursorModifier */));
                if (_this._opts.equals(newOpts)) {
                    return;
                }
                _this._opts = newOpts;
                _this.lastMouseMoveEvent = null;
                _this.hasTriggerKeyOnMouseDown = false;
                _this._onCancel.fire();
            }
        }));
        _this._register(_this._editor.onMouseMove(function (e) {return _this.onEditorMouseMove(new ClickLinkMouseEvent(e, _this._opts));}));
        _this._register(_this._editor.onMouseDown(function (e) {return _this.onEditorMouseDown(new ClickLinkMouseEvent(e, _this._opts));}));
        _this._register(_this._editor.onMouseUp(function (e) {return _this.onEditorMouseUp(new ClickLinkMouseEvent(e, _this._opts));}));
        _this._register(_this._editor.onKeyDown(function (e) {return _this.onEditorKeyDown(new ClickLinkKeyboardEvent(e, _this._opts));}));
        _this._register(_this._editor.onKeyUp(function (e) {return _this.onEditorKeyUp(new ClickLinkKeyboardEvent(e, _this._opts));}));
        _this._register(_this._editor.onMouseDrag(function () {return _this.resetHandler();}));
        _this._register(_this._editor.onDidChangeCursorSelection(function (e) {return _this.onDidChangeCursorSelection(e);}));
        _this._register(_this._editor.onDidChangeModel(function (e) {return _this.resetHandler();}));
        _this._register(_this._editor.onDidChangeModelContent(function () {return _this.resetHandler();}));
        _this._register(_this._editor.onDidScrollChange(function (e) {
            if (e.scrollTopChanged || e.scrollLeftChanged) {
                _this.resetHandler();
            }
        }));
        return _this;
    }
    ClickLinkGesture.prototype.onDidChangeCursorSelection = function (e) {
        if (e.selection && e.selection.startColumn !== e.selection.endColumn) {
            this.resetHandler(); // immediately stop this feature if the user starts to select (https://github.com/Microsoft/vscode/issues/7827)
        }
    };
    ClickLinkGesture.prototype.onEditorMouseMove = function (mouseEvent) {
        this.lastMouseMoveEvent = mouseEvent;
        this._onMouseMoveOrRelevantKeyDown.fire([mouseEvent, null]);
    };
    ClickLinkGesture.prototype.onEditorMouseDown = function (mouseEvent) {
        // We need to record if we had the trigger key on mouse down because someone might select something in the editor
        // holding the mouse down and then while mouse is down start to press Ctrl/Cmd to start a copy operation and then
        // release the mouse button without wanting to do the navigation.
        // With this flag we prevent goto definition if the mouse was down before the trigger key was pressed.
        this.hasTriggerKeyOnMouseDown = mouseEvent.hasTriggerModifier;
    };
    ClickLinkGesture.prototype.onEditorMouseUp = function (mouseEvent) {
        if (this.hasTriggerKeyOnMouseDown) {
            this._onExecute.fire(mouseEvent);
        }
    };
    ClickLinkGesture.prototype.onEditorKeyDown = function (e) {
        if (this.lastMouseMoveEvent && (
        e.keyCodeIsTriggerKey // User just pressed Ctrl/Cmd (normal goto definition)
        || e.keyCodeIsSideBySideKey && e.hasTriggerModifier // User pressed Ctrl/Cmd+Alt (goto definition to the side)
        )) {
            this._onMouseMoveOrRelevantKeyDown.fire([this.lastMouseMoveEvent, e]);
        } else
        if (e.hasTriggerModifier) {
            this._onCancel.fire(); // remove decorations if user holds another key with ctrl/cmd to prevent accident goto declaration
        }
    };
    ClickLinkGesture.prototype.onEditorKeyUp = function (e) {
        if (e.keyCodeIsTriggerKey) {
            this._onCancel.fire();
        }
    };
    ClickLinkGesture.prototype.resetHandler = function () {
        this.lastMouseMoveEvent = null;
        this.hasTriggerKeyOnMouseDown = false;
        this._onCancel.fire();
    };
    return ClickLinkGesture;
}(_base_common_lifecycle_js__WEBPACK_IMPORTED_MODULE_1__["Disposable"]);


/***/ }),

/***/ 6789:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return VariableAlertWrapper; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _constants_AppUrlConstants__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3041);
/* harmony import */ var _constants_SettingsTypeConstants__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(4040);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(749);
/* harmony import */ var _components_messaging_Alert__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(3853);
var _class;






const OPEN_SETTINGS_ANCHOR = '#openSettings',
alertMessageWithAutoPersist = 'Use variables to reuse values in different places. ' +
'The current value is used while sending a request and is never synced to Postman\'s servers. ' +
`The initial value is auto-updated to reflect the current value. [Change this](${OPEN_SETTINGS_ANCHOR}) behaviour from Settings. ` +
`[Learn more about variable values](${_constants_AppUrlConstants__WEBPACK_IMPORTED_MODULE_2__["SESSION_VARIABLE_DOCS"]})`,
alertMessageWithoutAutoPersist = 'Use variables to reuse values in different places. Work with the current value of a variable' +
` to prevent sharing sensitive values with your team. [Learn more about variable values](${_constants_AppUrlConstants__WEBPACK_IMPORTED_MODULE_2__["SESSION_VARIABLE_DOCS"]})`;let


VariableAlertWrapper = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class VariableAlertWrapper extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);
    this.handleMessageLinkClick = this.handleMessageLinkClick.bind(this);
    this.handleDismissAlert = this.handleDismissAlert.bind(this);
    this.state = { showAlert: pm.settings.getSetting('showSessionVariablesAlert') };

    this.handleSettingUpdate = this.handleSettingUpdate.bind(this);
  }

  componentDidMount() {
    pm.settings.on('setSetting:showSessionVariablesAlert', this.handleSettingUpdate);
  }

  componentWillUnmount() {
    pm.settings.off('setSetting:showSessionVariablesAlert', this.handleSettingUpdate);
  }

  handleMessageLinkClick(target) {
    if (target === OPEN_SETTINGS_ANCHOR) {
      pm.mediator.trigger('openSettingsModal', _constants_SettingsTypeConstants__WEBPACK_IMPORTED_MODULE_3__["SETTINGS_GENERAL"]);
    }
    this.props.onMessageLinkClick && this.props.onMessageLinkClick(target);
  }

  handleDismissAlert() {
    pm.settings.setSetting('showSessionVariablesAlert', false);
  }

  handleSettingUpdate() {
    this.setState({ showAlert: pm.settings.getSetting('showSessionVariablesAlert') });
  }

  render() {
    let configMap = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_4__["getStore"])('ConfigurationStore').configs,

    // NOTE: Browser platform does not support autoPersistVariables setting.
    alertMessage = configMap.get('request.autoPersistVariables') && window.SDK_PLATFORM !== 'browser' ?
    alertMessageWithAutoPersist :
    alertMessageWithoutAutoPersist;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: this.props.className },

        this.state.showAlert &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_components_messaging_Alert__WEBPACK_IMPORTED_MODULE_5__["default"], {
          type: 'info',
          message: alertMessage,
          onMessageLinkClick: this.handleMessageLinkClick,
          onDismiss: this.handleDismissAlert })));




  }}) || _class;

/***/ }),

/***/ 6826:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ACTION_TYPE_DUPLICATE", function() { return ACTION_TYPE_DUPLICATE; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ACTION_TYPE_SHARE", function() { return ACTION_TYPE_SHARE; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ACTION_TYPE_DOWNLOAD", function() { return ACTION_TYPE_DOWNLOAD; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ACTION_TYPE_DELETE", function() { return ACTION_TYPE_DELETE; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ACTION_REMOVE_FROM_WORKSPACE", function() { return ACTION_REMOVE_FROM_WORKSPACE; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ACTION_MANAGE_ROLES", function() { return ACTION_MANAGE_ROLES; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ACTION_REQUEST_ACCESS", function() { return ACTION_REQUEST_ACCESS; });
const ACTION_TYPE_DUPLICATE = 'duplicate',
ACTION_TYPE_SHARE = 'share',
ACTION_TYPE_DOWNLOAD = 'download',
ACTION_TYPE_DELETE = 'delete',
ACTION_REMOVE_FROM_WORKSPACE = 'remove-from-workspace',
ACTION_MANAGE_ROLES = 'manage-roles',
ACTION_REQUEST_ACCESS = 'request-access';

/***/ }),

/***/ 6827:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var _js_modules_pipelines_user_action__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2435);
/* harmony import */ var _js_services_conversion_promisifiedConverter__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2832);
/* harmony import */ var _js_modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(748);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(749);
/* harmony import */ var _js_modules_services_ShareModalService__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5207);
/* harmony import */ var _js_modules_services_ManageRolesModalService__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(5208);
/* harmony import */ var _js_models_services_DashboardService__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(3243);
/* harmony import */ var _constants_EnvironmentActionsConstant__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(6826);









/* harmony default export */ __webpack_exports__["default"] = ((id, action, modifiers, options = {}, callback) => {
  const uid = _.get(Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('EnvironmentStore').find(id), 'uid');

  if (typeof options === 'function') {
    callback = options;
    options = {};
  }

  if (action === _constants_EnvironmentActionsConstant__WEBPACK_IMPORTED_MODULE_7__["ACTION_TYPE_DUPLICATE"]) {
    const duplicateEnvironmentEvent = {
      name: 'duplicate',
      namespace: 'environment',
      data: {
        model: 'environment',
        environment: { id } } };



    Object(_js_modules_pipelines_user_action__WEBPACK_IMPORTED_MODULE_0__["default"])(duplicateEnvironmentEvent);
    options.origin === 'browse' && _js_modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_2__["default"].addEvent('environment', 'duplicate', 'browse_view');
  } else if (action === _constants_EnvironmentActionsConstant__WEBPACK_IMPORTED_MODULE_7__["ACTION_TYPE_DOWNLOAD"]) {
    Object(_js_services_conversion_promisifiedConverter__WEBPACK_IMPORTED_MODULE_1__["default"])().then(converter => {
      converter.saveEntity({ id }, { type: 'environment' });
      options.origin === 'browse' && _js_modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_2__["default"].addEvent('environment', 'download', 'browse_view');
    });
  } else if (action === _constants_EnvironmentActionsConstant__WEBPACK_IMPORTED_MODULE_7__["ACTION_TYPE_DELETE"]) {
    pm.mediator.trigger('showEnvironmentDeleteModal', id, { origin: options.origin }, callback);
  } else if (action === _constants_EnvironmentActionsConstant__WEBPACK_IMPORTED_MODULE_7__["ACTION_TYPE_SHARE"]) {
    pm.mediator.trigger('hideManageEnvironmentModal');
    Object(_js_modules_services_ShareModalService__WEBPACK_IMPORTED_MODULE_4__["shareEnvironment"])(uid, { origin: options.origin });
  } else if (action === _constants_EnvironmentActionsConstant__WEBPACK_IMPORTED_MODULE_7__["ACTION_REMOVE_FROM_WORKSPACE"]) {
    const type = 'environment',
    { origin } = options;

    pm.mediator.trigger('showRemoveFromWorkspaceModal', id, { type, origin }, callback);
  } else if (action === _constants_EnvironmentActionsConstant__WEBPACK_IMPORTED_MODULE_7__["ACTION_MANAGE_ROLES"]) {
    pm.mediator.trigger('hideManageEnvironmentModal');
    Object(_js_modules_services_ManageRolesModalService__WEBPACK_IMPORTED_MODULE_5__["manageRolesOnEnvironment"])(uid, { origin: options.origin });
  } else if (action === _constants_EnvironmentActionsConstant__WEBPACK_IMPORTED_MODULE_7__["ACTION_REQUEST_ACCESS"]) {
    Object(_js_models_services_DashboardService__WEBPACK_IMPORTED_MODULE_6__["openRequestAccess"])('environment', uid, 'grant_role');
  }
});
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6914:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Header", function() { return Header; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Heading", function() { return Heading; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ProfilePic", function() { return ProfilePic; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Meta", function() { return Meta; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Body", function() { return Body; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "User", function() { return User; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Folder", function() { return Folder; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Request", function() { return Request; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Response", function() { return Response; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Collection", function() { return Collection; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Time", function() { return Time; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Details", function() { return Details; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Restore", function() { return Restore; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _postman_date_helper__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5224);
/* harmony import */ var _postman_date_helper__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_postman_date_helper__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var postman_collection__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(790);
/* harmony import */ var postman_collection__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(postman_collection__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _base_Avatar__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(3235);
/* harmony import */ var _constants_ActivityFeedDetailsMapConstant__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(5288);
/* harmony import */ var _WorkspaceActivityFeedDetailsComponents__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(6915);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(2929);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(749);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;








let

Header = class Header extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {

  constructor(props) {
    super(props);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-activity-item-header' },
        this.props.children));


  }};let


Heading = class Heading extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {

  constructor(props) {
    super(props);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-activity-item-heading' },
        this.props.children));


  }};let


ProfilePic = class ProfilePic extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {

  constructor(props) {
    super(props);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-activity-item-profile-pic-wrapper' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Avatar__WEBPACK_IMPORTED_MODULE_4__["default"], { type: 'user', userId: this.props.id })));


  }};let


Meta = class Meta extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {

  constructor(props) {
    super(props);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-activity-item-meta' },
        this.props.children));


  }};let


Body = class Body extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {

  constructor(props) {
    super(props);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-activity-item-body' },
        this.props.children));


  }};let


Folder = class Folder extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {

  constructor(props) {
    super(props);
    this.handleClick = this.handleClick.bind(this);
  }

  handleClick() {
    let payload = {
      type: 'folder',
      id: this.props.id };

    if (this.props.actionHandler) {
      this.props.actionHandler(payload);
    }
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'workspace-activity-item-folder',
          onClick: this.handleClick },
        this.props.name));

  }};let


Response = class Response extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {

  constructor(props) {
    super(props);
    this.handleClick = this.handleClick.bind(this);
  }

  handleClick() {
    let payload = {
      type: 'response',
      id: this.props.id };

    if (this.props.actionHandler) {
      this.props.actionHandler(payload);
    }
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'workspace-activity-item-response',
          onClick: this.handleClick },
        this.props.name));

  }};let


Request = class Request extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {

  constructor(props) {
    super(props);
    this.handleClick = this.handleClick.bind(this);
  }

  handleClick() {
    let payload = {
      type: '`request`',
      id: this.props.id };

    if (this.props.actionHandler) {
      this.props.actionHandler(payload);
    }
  }

  render() {
    let methodClasses = classnames__WEBPACK_IMPORTED_MODULE_1___default()(
    'activity-item-request-method',
    `method-${this.props.method}`);

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'workspace-activity-item-request-name', onClick: this.handleClick },
        this.props.name));


  }};let


Collection = class Collection extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {

  constructor(props) {
    super(props);
    this.handleClick = this.handleClick.bind(this);
  }

  handleClick() {
    let payload = {
      type: 'collection',
      id: this.props.id };

    if (this.props.actionHandler) {
      this.props.actionHandler(payload);
    }
  }

  render() {
    let methodClasses = classnames__WEBPACK_IMPORTED_MODULE_1___default()(
    'activity-item-collection-method',
    `method-${this.props.method}`),

    meta = this.props.meta;
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null,

        meta.model === 'collection' ?
        ' this ' :
        !_.isEmpty(this.props.name) ?
        ' the ' :
        ' a ',

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'collection '),

        meta.model === 'workspace' &&
        !_.isEmpty(this.props.name) &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'workspace-activity-item-collection-name', onClick: this.handleClick }, this.props.name)));



  }};let



User = Object(mobx_react__WEBPACK_IMPORTED_MODULE_7__["observer"])(_class = class User extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {

  constructor(props) {
    super(props);
  }

  render() {
    let currentUser = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_8__["getStore"])('CurrentUserStore');

    let displayName = currentUser.id === this.props.id ? 'You' : this.props.name || this.props.username;
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'workspace-activity-item-user' }, displayName, ','));

  }}) || _class;let


Time = class Time extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {

  constructor(props) {
    super(props);
  }

  render() {
    let formattedTime = _postman_date_helper__WEBPACK_IMPORTED_MODULE_2___default.a.getFormattedTime(this.props.timestamp);
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'workspace-activity-item-time' }, formattedTime));

  }};let


Details = class Details extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {

  constructor(props) {
    super(props);
  }

  filterEntity(entity, data) {
    if (_.includes(['test', 'prerequest'], entity)) {
      return this.processEvents(entity, data);
    }
    return data;
  }

  processEvents(processDataType, data) {
    let sdkEvents = new postman_collection__WEBPACK_IMPORTED_MODULE_3__["EventList"]({}, data),
    entityEvent = _.head(sdkEvents.listenersOwn(processDataType));

    return _.invoke(entityEvent, 'script.toSource');
  }

  render() {
    let {
      input = {},
      rollback = {},
      model,
      instance,
      detailsError = false } =
    this.props;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-activity-item-details-wrapper' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-activity-item-details' },

          _.map(_constants_ActivityFeedDetailsMapConstant__WEBPACK_IMPORTED_MODULE_5__["default"], (activity, index) => {
            let entity = activity.entity,
            previous = rollback[entity],
            current = input[entity],
            filterEntity = activity.filterEntity,
            isChangeSetAvailable = false;

            if (filterEntity) {
              previous = this.filterEntity(filterEntity, previous);
              current = this.filterEntity(filterEntity, current);
            }

            isChangeSetAvailable = previous || current;

            if (isChangeSetAvailable && entity === 'order') {
              previous = null;
              current = 'Changed';
            }
            if (isChangeSetAvailable) {
              return (
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_WorkspaceActivityFeedDetailsComponents__WEBPACK_IMPORTED_MODULE_6__["DetailsItem"], _extends({
                  key: activity.entity + index,
                  previous: previous || '',
                  current: current || '',
                  model: model,
                  name: instance.name || '' },
                activity)));


            }
            return false;
          }))));




  }};let


Restore = class Restore extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {

  constructor(props) {
    super(props);

    this.handleClick = this.handleClick.bind(this);
  }

  handleClick() {
    this.props.onRestore && this.props.onRestore(this.props.id);
  }

  getClasses() {
    return classnames__WEBPACK_IMPORTED_MODULE_1___default()({
      'workspace-activity-item-restore': true,
      'workspace-activity-item-restore--is-restoring': this.props.isRestoring });

  }

  render() {
    if (_.isNil(this.props.id) ||
    _.isNil(this.props.rollback_from) ||
    this.props.id < this.props.rollback_from) {
      return false;
    }

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: this.getClasses(), onClick: this.handleClick },
        this.props.isRestoring ? 'Restoring...' : 'Restore'));


  }};



/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6915:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DetailsItem", function() { return DetailsItem; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _base_diff_Diff__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3648);
/* harmony import */ var _utils_util__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(784);



let

NormalView = class NormalView extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {
  constructor(props) {
    super(props);
  }
  render() {
    let {
      previous,
      current } =
    this.props;
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-activity-item-details-content-right' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'workspace-activity-item-details-content-data' }, previous),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, previous ? ' to ' : ' '),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'workspace-activity-item-details-content-data' }, current)));


  }};let


DiffView = class DiffView extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {
  constructor(props) {
    super(props);
  }
  render() {
    let {
      type = 'chars',
      previous,
      current,
      modalHeader } =
    this.props;
    previous = type === 'lines' ? _utils_util__WEBPACK_IMPORTED_MODULE_3__["default"].beautifyJs(previous) : previous;
    current = type === 'lines' ? _utils_util__WEBPACK_IMPORTED_MODULE_3__["default"].beautifyJs(current) : current;
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-activity-item-details-content-right workspace-activity-item-details-diff-view' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_diff_Diff__WEBPACK_IMPORTED_MODULE_2__["default"], {
          modalHeader: modalHeader,
          previous: previous,
          current: current,
          type: type })));



  }};let


DetailsItem = class DetailsItem extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {

  constructor(props) {
    super(props);
  }

  getClasses() {
    return classnames__WEBPACK_IMPORTED_MODULE_1___default()({
      'workspace-activity-item-details-content': true,
      'normal-view': this.props.view === 'normal' });

  }

  render() {
    let {
      previous,
      current,
      label,
      model,
      name,
      diffType } =
    this.props,
    modalHeader = 'Change to ' + label + ' for ' + model + ' ' + name;
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: this.getClasses() },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-activity-item-details-content-left' },
          label),


        this.props.view === 'normal' &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(NormalView, {
          previous: previous,
          current: current }),



        this.props.view === 'diff' &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(DiffView, {
          modalHeader: modalHeader,
          previous: previous,
          current: current,
          type: diffType })));




  }};




/***/ }),

/***/ 6948:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ResponseIcon; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2813);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('svg', { width: '16px', height: '10px', viewBox: '0 0 16 10', version: '1.1' },
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('defs', null,
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { d: 'M0.842105263,3 L15.1578947,3 C15.6631579,3 16,3.33333333 16,3.83333333 L16,12.1666667 C16,12.6666667 15.6631579,13 15.1578947,13 L0.842105263,13 C0.336842105,13 0,12.6666667 0,12.1666667 L0,3.83333333 C0,3.33333333 0.336842105,3 0.842105263,3 Z M4.0709561,9.79474646 C4.38605088,9.79474646 4.65303559,9.77083499 4.87191822,9.72301133 C5.09080085,9.67518767 5.29645123,9.60222703 5.48887553,9.50412721 L5.48887553,8.63594818 C5.25315577,8.74876297 5.02706061,8.83092033 4.81058328,8.88242273 C4.59410595,8.93392514 4.3644029,8.95967595 4.12146723,8.95967595 C3.80877775,8.95967595 3.56584572,8.87016121 3.39266386,8.69112905 C3.219482,8.51209689 3.12687919,8.26317234 3.11485268,7.94434793 L5.71617559,7.94434793 L5.71617559,7.39989668 C5.71617559,6.81620277 5.55742793,6.35881924 5.23992784,6.02773236 C4.92242776,5.69664548 4.47865589,5.53110453 3.90859892,5.53110453 C3.31208361,5.53110453 2.84486038,5.71933072 2.50691521,6.09578877 C2.16897005,6.47224681 2,7.00504345 2,7.69419465 C2,8.3637259 2.18280034,8.88119467 2.54840649,9.24661648 C2.91401265,9.6120383 3.42152411,9.79474646 4.0709561,9.79474646 Z M6.45580277,9.19511434 C6.45580277,9.39376646 6.51112392,9.54765824 6.62176789,9.65679429 C6.73241186,9.76593033 6.88875425,9.82049754 7.09079976,9.82049754 C7.28803466,9.82049754 7.44197179,9.7647041 7.55261575,9.65311556 C7.66325972,9.54152702 7.71858088,9.38886147 7.71858088,9.19511434 C7.71858088,8.99400971 7.66386104,8.83950482 7.55441972,8.73159502 C7.44497841,8.62368522 7.29043996,8.56973113 7.09079976,8.56973113 C6.88394364,8.56973113 6.72639862,8.62245899 6.61815995,8.7279163 C6.50992129,8.8333736 6.45580277,8.98910472 6.45580277,9.19511434 Z M9.05458398,9.41104996 L9.05711946,9.4121606 C8.76367549,9.48328314 8.54119031,9.60222688 8.38965725,9.76899539 C8.23812311,9.93576508 8.16235719,10.1429978 8.16235719,10.3906999 C8.16235719,10.7512167 8.31088246,11.0314101 8.60793746,11.2312885 C8.90499247,11.4311668 9.33493405,11.5311045 9.89777511,11.5311045 C10.633798,11.5311045 11.1984346,11.3986718 11.5917017,11.1338023 C11.9849689,10.8689328 12.1815995,10.496159 12.1815995,10.0154699 C12.1815995,9.64023815 12.0655454,9.35575295 11.8334336,9.16200581 C11.6013217,8.96825868 11.263983,8.87138656 10.8214071,8.87138656 L10.135899,8.87138656 C9.73180796,8.87138656 9.52976548,8.79045543 9.52976548,8.62859073 C9.52976548,8.52068093 9.58628927,8.42258259 9.69933854,8.33429275 L9.86169573,8.35268638 L10.0601323,8.36372255 C10.596515,8.36372255 11.0156329,8.24048651 11.3174985,7.99401072 C11.6193641,7.74753493 11.7702946,7.40357761 11.7702946,6.96212844 C11.7702946,6.73404636 11.7125682,6.52803984 11.5971137,6.34410269 L12.2285027,6.17856007 L12.2285027,5.60835774 L10.8214071,5.60835774 C10.7781116,5.59854776 10.6788943,5.5832199 10.5237523,5.56237369 C10.3686102,5.54152747 10.2345165,5.53110453 10.1214672,5.53110453 C9.58989512,5.53110453 9.18099963,5.65372746 8.89476849,5.898977 C8.60853735,6.14422654 8.46542393,6.49124943 8.46542393,6.94005609 C8.46542393,7.21964056 8.52735957,7.46243397 8.65123271,7.66844358 C8.77510585,7.87445319 8.94287327,8.02405317 9.15453999,8.117248 C8.98616873,8.21780031 8.85748692,8.32019045 8.76849068,8.42442151 C8.67949444,8.52865256 8.63499699,8.65924598 8.63499699,8.81620569 C8.63499699,8.94128296 8.67708918,9.05961408 8.7612748,9.17120262 C8.84482891,9.28195408 8.94259767,9.36190241 9.05458398,9.41104996 Z M9.11485268,10.3024105 C9.11485268,10.1429983 9.18280149,10.0148573 9.31870114,9.91798374 C9.4546008,9.82111017 9.62357085,9.77267411 9.82561636,9.77267411 L10.3956705,9.77267411 C10.6722804,9.77267411 10.8767281,9.80210362 11.0090198,9.86096351 C11.1413115,9.9198234 11.2074564,10.0265053 11.2074564,10.1810126 C11.2074564,10.3723072 11.0956115,10.5231334 10.8719182,10.6334957 C10.648225,10.743858 10.3391481,10.7990383 9.94467829,10.7990383 C9.68250019,10.7990383 9.47865376,10.7548941 9.33313289,10.6666042 C9.18761202,10.5783144 9.11485268,10.4569177 9.11485268,10.3024105 Z M9.51533373,6.95477099 C9.51533373,6.45936692 9.71737621,6.2116686 10.1214672,6.2116686 C10.5207476,6.2116686 10.7203848,6.45936692 10.7203848,6.95477099 C10.7203848,7.17794807 10.6722795,7.35452509 10.5760673,7.48450735 C10.4798552,7.6144896 10.3283233,7.67947976 10.1214672,7.67947976 C9.91701642,7.67947976 9.76488324,7.6144896 9.66506314,7.48450735 C9.56524304,7.35452509 9.51533373,7.17794807 9.51533373,6.95477099 Z M12.7372219,9.19511434 C12.7372219,9.39376646 12.792543,9.54765824 12.903187,9.65679429 C13.013831,9.76593033 13.1701734,9.82049754 13.3722189,9.82049754 C13.5694538,9.82049754 13.7233909,9.7647041 13.8340349,9.65311556 C13.9446788,9.54152702 14,9.38886147 14,9.19511434 C14,8.99400971 13.9452802,8.83950482 13.8358388,8.73159502 C13.7263975,8.62368522 13.5718591,8.56973113 13.3722189,8.56973113 C13.1653628,8.56973113 13.0078177,8.62245899 12.8995791,8.7279163 C12.7913404,8.8333736 12.7372219,8.98910472 12.7372219,9.19511434 Z M3.91581479,6.32938779 C4.14912925,6.32938779 4.33433485,6.40480089 4.47143716,6.55562936 C4.60853947,6.70645782 4.67949486,6.92043484 4.68430547,7.19756682 L3.14010824,7.19756682 C3.15935067,6.92043484 3.2351166,6.70645782 3.3674083,6.55562936 C3.4997,6.40480089 3.68250034,6.32938779 3.91581479,6.32938779 Z', id: 'path-1' })),

    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('g', { id: 'Symbols', stroke: 'none', strokeWidth: '1', fill: 'none', fillRule: 'evenodd' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('g', { id: 'icon/example', transform: 'translate(0.000000, -3.000000)' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('mask', { id: 'mask-2', fill: 'white' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('use', { xlinkHref: '#path-1' })),

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('use', { id: 'Combined-Shape', fill: '#535353', fillRule: 'nonzero', xlinkHref: '#path-1' }))));





function ResponseIcon(props) {
    return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_Icon__WEBPACK_IMPORTED_MODULE_1__["default"], _extends({},
        props, {
            icon: icon })));


}

/***/ }),

/***/ 6990:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return NoResultFound; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
let

NoResultFound = class NoResultFound extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'no-result' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'no-result-image-wrapper' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'no-result-image' })),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'label' }, 'Nothing here, Houston!'),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'subtext' }, 'We couldn\'t find anything matching that. Check the spelling or try using a different query.')));


  }};

/***/ }),

/***/ 7000:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return CollectionsEmpty; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _base_Buttons__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2934);
/* harmony import */ var _constants_AppUrlConstants__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3041);
/* harmony import */ var _external_navigation_ExternalNavigationService__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2388);



let
CollectionsEmpty = class CollectionsEmpty extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.handleAddToWorkspace = this.handleAddToWorkspace.bind(this);
    this.handleCreateCollection = this.handleCreateCollection.bind(this);
    this.openLink = this.openLink.bind(this);
  }

  handleCreateCollection() {
    this.props.onClose && this.props.onClose();
    if (this.props.isMember) {
      pm.mediator.trigger('showNewCollectionModal', id => {
        pm.mediator.trigger('focusCollectionInSideBar', id);
      });
    } else
    {
      pm.mediator.trigger('joinWorkspace');
    }
  }

  openLink(url) {
    url && Object(_external_navigation_ExternalNavigationService__WEBPACK_IMPORTED_MODULE_3__["openExternalLink"])(url);
  }

  handleAddToWorkspace() {
    if (this.props.isMember) {
      pm.mediator.trigger('openBulkAddToWorkspaceModal', this.props.workspaceId);
    } else
    {
      pm.mediator.trigger('joinWorkspace');
    }
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'entity-empty' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'entity-empty__illustration-wrapper entity-empty__illustration-wrapper--collections' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'collections-empty__illustration' })),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'entity-empty__title' }, 'Looks like you don\u2019t have any collections'),



        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'entity-empty__subtitle' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'API requests in Postman are saved in '),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_1__["Button"], {
              type: 'text',
              className: 'learn-more-link',
              onClick: this.openLink.bind(this, _constants_AppUrlConstants__WEBPACK_IMPORTED_MODULE_2__["COLLECTION_DOCS"]) }, 'Collections'),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, '. Collections make it easier to organize, test, document and monitor requests. Save some requests in a collection to get started.')),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'entity-empty__action' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_1__["Button"], {
              type: 'primary',
              onClick: this.handleAddToWorkspace }, 'Add collections to this workspace')),




        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'entity-empty__action--text' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_1__["Button"], {
              type: 'text',
              onClick: this.handleCreateCollection }, 'or create a collection'))));






  }};

/***/ }),

/***/ 7073:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return SelectDropdown; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _base_Avatar__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(3235);
/* harmony import */ var _base_Inputs__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3048);
/* harmony import */ var _base_Dropdowns__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2959);
/* harmony import */ var _base_Buttons__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2934);
/* harmony import */ var _base_FuzzySearchInput__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(3658);
/* harmony import */ var _base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(2974);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_7___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_7__);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};







let

SelectDropdown = class SelectDropdown extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      searchQuery: '',
      searchResults: [] };


    this.handleFuzzySearch = this.handleFuzzySearch.bind(this);
    this.getClasses = this.getClasses.bind(this);
  }

  handleFuzzySearch(searchQuery, searchResults) {
    this.setState({ searchQuery, searchResults });
  }

  handleSelect(id, isSelected) {
    let updatedSelectedMembers = {};

    if (isSelected) {
      updatedSelectedMembers = _extends({},
      this.props.selectedItems, {
        [id]: _.find(this.props.items, { id }) });

    } else
    {
      updatedSelectedMembers = _.omitBy(this.props.selectedItems, { id });
    }

    _.isFunction(this.props.onSelect) && this.props.onSelect(updatedSelectedMembers);
  }

  getClasses() {
    return classnames__WEBPACK_IMPORTED_MODULE_7___default()({
      'select-dropdown-container': true,
      'applied': this.props.isFilterApplied,
      'selected': !this.props.isFilterApplied && this.props.isSelected });

  }

  render() {
    let items = this.state.searchQuery ?
    this.state.searchResults :
    this.props.items;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: classnames__WEBPACK_IMPORTED_MODULE_7___default()('select-dropdown-container', this.props.className) },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_3__["Dropdown"], { className: this.getClasses() },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_3__["DropdownButton"], null,
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_4__["Button"], { type: 'text', className: 'select-dropdown-btn' }, this.props.dropDownPlaceholder)),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_3__["DropdownMenu"], null,
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'select-dropdown' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_FuzzySearchInput__WEBPACK_IMPORTED_MODULE_5__["default"], {
                searchQuery: this.state.searchQuery,
                placeholder: this.props.searchPlaceholder,
                onChange: this.handleFuzzySearch,
                items: this.props.items,
                searchFields: this.props.searchFields }),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: classnames__WEBPACK_IMPORTED_MODULE_7___default()({ 'select-dropdown-list': true, 'isLoading': this.props.isLoading }) },

                this.props.isLoading ?
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_6__["default"], null) :

                items && items.length ?
                _.map(items, item => {
                  return (
                    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                        key: item.id,
                        className: 'select-dropdown-item',
                        onClick: this.handleSelect.bind(this, item.id, !this.props.selectedItems[item.id]) },


                      item.icon ||
                      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Avatar__WEBPACK_IMPORTED_MODULE_1__["default"], {
                        size: 'small',
                        userId: item.id }),


                      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', {
                          className: 'select-dropdown-item-text',
                          title: item.name },

                        item.name),

                      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Inputs__WEBPACK_IMPORTED_MODULE_2__["Checkbox"], {
                        onChange: this.handleSelect.bind(this, item.id),
                        className: 'select-dropdown-item-checkbox',
                        checked: this.props.selectedItems[item.id] })));



                }) :

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'select-dropdown-item' }, 'No results found')))))));










  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 7081:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunIcon; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2813);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('svg', { width: '8', height: '10', viewBox: '0 0 16 16' },
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('defs', null,
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { id: 'run', d: 'M11.852 7.726L4.43 3.044a.264.264 0 0 0-.29-.002.319.319 0 0 0-.141.275v9.366a.319.319 0 0 0 .142.275c.09.057.2.056.289-.002l7.42-4.682A.317.317 0 0 0 12 8a.317.317 0 0 0-.148-.274z' })),

  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('use', { fill: '#282828', fillRule: 'evenodd', xlinkHref: '#run' }));



function RunIcon(props) {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_Icon__WEBPACK_IMPORTED_MODULE_1__["default"], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 7156:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var _constants_ActivityFeedDetailsMapConstant__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5288);
let

ActivityFeedHelper = class ActivityFeedHelper {

  getWhiteListedActivitiesCount(activity) {
    let changesCount = 0;
    if (activity.rollback && activity.input) {
      _.forEach(_constants_ActivityFeedDetailsMapConstant__WEBPACK_IMPORTED_MODULE_0__["default"], supportedActivity => {
        let entity = supportedActivity.entity;
        if (activity.rollback[entity] || activity.input[entity]) {
          ++changesCount;
        }
      });
    }
    return changesCount;
  }};


/* harmony default export */ __webpack_exports__["default"] = (new ActivityFeedHelper());
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 7303:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "conf", function() { return conf; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "language", function() { return language; });
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/

// Allow for running under nodejs/requirejs in tests
var _monaco = typeof monaco === 'undefined' ? self.monaco : monaco;
var conf = {
    wordPattern: /(-?\d*\.\d\w*)|([^\`\~\!\@\#\%\^\&\*\(\)\-\=\+\[\{\]\}\\\|\;\:\'\"\,\.\<\>\/\?\s]+)/g,
    comments: {
        lineComment: '//',
        blockComment: ['/*', '*/'] },

    brackets: [
    ['{', '}'],
    ['[', ']'],
    ['(', ')']],

    onEnterRules: [
    {
        // e.g. /** | */
        beforeText: /^\s*\/\*\*(?!\/)([^\*]|\*(?!\/))*$/,
        afterText: /^\s*\*\/$/,
        action: { indentAction: _monaco.languages.IndentAction.IndentOutdent, appendText: ' * ' } },

    {
        // e.g. /** ...|
        beforeText: /^\s*\/\*\*(?!\/)([^\*]|\*(?!\/))*$/,
        action: { indentAction: _monaco.languages.IndentAction.None, appendText: ' * ' } },

    {
        // e.g.  * ...|
        beforeText: /^(\t|(\ \ ))*\ \*(\ ([^\*]|\*(?!\/))*)?$/,
        action: { indentAction: _monaco.languages.IndentAction.None, appendText: '* ' } },

    {
        // e.g.  */|
        beforeText: /^(\t|(\ \ ))*\ \*\/\s*$/,
        action: { indentAction: _monaco.languages.IndentAction.None, removeText: 1 } }],


    autoClosingPairs: [
    { open: '{', close: '}' },
    { open: '[', close: ']' },
    { open: '(', close: ')' },
    { open: '"', close: '"', notIn: ['string'] },
    { open: '\'', close: '\'', notIn: ['string', 'comment'] },
    { open: '`', close: '`', notIn: ['string', 'comment'] },
    { open: "/**", close: " */", notIn: ["string"] }],

    folding: {
        markers: {
            start: new RegExp("^\\s*//\\s*#?region\\b"),
            end: new RegExp("^\\s*//\\s*#?endregion\\b") } } };



var language = {
    // Set defaultToken to invalid to see what you do not tokenize yet
    defaultToken: 'invalid',
    tokenPostfix: '.ts',
    keywords: [
    'abstract', 'as', 'break', 'case', 'catch', 'class', 'continue', 'const',
    'constructor', 'debugger', 'declare', 'default', 'delete', 'do', 'else',
    'enum', 'export', 'extends', 'false', 'finally', 'for', 'from', 'function',
    'get', 'if', 'implements', 'import', 'in', 'infer', 'instanceof', 'interface',
    'is', 'keyof', 'let', 'module', 'namespace', 'never', 'new', 'null', 'package',
    'private', 'protected', 'public', 'readonly', 'require', 'global', 'return',
    'set', 'static', 'super', 'switch', 'symbol', 'this', 'throw', 'true', 'try',
    'type', 'typeof', 'unique', 'var', 'void', 'while', 'with', 'yield', 'async',
    'await', 'of'],

    typeKeywords: [
    'any', 'boolean', 'number', 'object', 'string', 'undefined'],

    operators: [
    '<=', '>=', '==', '!=', '===', '!==', '=>', '+', '-', '**',
    '*', '/', '%', '++', '--', '<<', '</', '>>', '>>>', '&',
    '|', '^', '!', '~', '&&', '||', '??', '?', ':', '=', '+=', '-=',
    '*=', '**=', '/=', '%=', '<<=', '>>=', '>>>=', '&=', '|=',
    '^=', '@'],

    // we include these common regular expressions
    symbols: /[=><!~?:&|+\-*\/\^%]+/,
    escapes: /\\(?:[abfnrtv\\"']|x[0-9A-Fa-f]{1,4}|u[0-9A-Fa-f]{4}|U[0-9A-Fa-f]{8})/,
    digits: /\d+(_+\d+)*/,
    octaldigits: /[0-7]+(_+[0-7]+)*/,
    binarydigits: /[0-1]+(_+[0-1]+)*/,
    hexdigits: /[[0-9a-fA-F]+(_+[0-9a-fA-F]+)*/,
    regexpctl: /[(){}\[\]\$\^|\-*+?\.]/,
    regexpesc: /\\(?:[bBdDfnrstvwWn0\\\/]|@regexpctl|c[A-Z]|x[0-9a-fA-F]{2}|u[0-9a-fA-F]{4})/,
    // The main tokenizer for our languages
    tokenizer: {
        root: [
        [/[{}]/, 'delimiter.bracket'],
        { include: 'common' }],

        common: [
        // identifiers and keywords
        [/[a-z_$][\w$]*/, {
            cases: {
                '@typeKeywords': 'keyword',
                '@keywords': 'keyword',
                '@default': 'identifier' } }],


        [/[A-Z][\w\$]*/, 'type.identifier'],
        // [/[A-Z][\w\$]*/, 'identifier'],
        // whitespace
        { include: '@whitespace' },
        // regular expression: ensure it is terminated before beginning (otherwise it is an opeator)
        [/\/(?=([^\\\/]|\\.)+\/([gimsuy]*)(\s*)(\.|;|,|\)|\]|\}|$))/, { token: 'regexp', bracket: '@open', next: '@regexp' }],
        // delimiters and operators
        [/[()\[\]]/, '@brackets'],
        [/[<>](?!@symbols)/, '@brackets'],
        [/!(?=([^=]|$))/, 'delimiter'],
        [/@symbols/, {
            cases: {
                '@operators': 'delimiter',
                '@default': '' } }],


        // numbers
        [/(@digits)[eE]([\-+]?(@digits))?/, 'number.float'],
        [/(@digits)\.(@digits)([eE][\-+]?(@digits))?/, 'number.float'],
        [/0[xX](@hexdigits)n?/, 'number.hex'],
        [/0[oO]?(@octaldigits)n?/, 'number.octal'],
        [/0[bB](@binarydigits)n?/, 'number.binary'],
        [/(@digits)n?/, 'number'],
        // delimiter: after number because of .\d floats
        [/[;,.]/, 'delimiter'],
        // strings
        [/"([^"\\]|\\.)*$/, 'string.invalid'],
        [/'([^'\\]|\\.)*$/, 'string.invalid'],
        [/"/, 'string', '@string_double'],
        [/'/, 'string', '@string_single'],
        [/`/, 'string', '@string_backtick']],

        whitespace: [
        [/[ \t\r\n]+/, ''],
        [/\/\*\*(?!\/)/, 'comment.doc', '@jsdoc'],
        [/\/\*/, 'comment', '@comment'],
        [/\/\/.*$/, 'comment']],

        comment: [
        [/[^\/*]+/, 'comment'],
        [/\*\//, 'comment', '@pop'],
        [/[\/*]/, 'comment']],

        jsdoc: [
        [/[^\/*]+/, 'comment.doc'],
        [/\*\//, 'comment.doc', '@pop'],
        [/[\/*]/, 'comment.doc']],

        // We match regular expression quite precisely
        regexp: [
        [/(\{)(\d+(?:,\d*)?)(\})/, ['regexp.escape.control', 'regexp.escape.control', 'regexp.escape.control']],
        [/(\[)(\^?)(?=(?:[^\]\\\/]|\\.)+)/, ['regexp.escape.control', { token: 'regexp.escape.control', next: '@regexrange' }]],
        [/(\()(\?:|\?=|\?!)/, ['regexp.escape.control', 'regexp.escape.control']],
        [/[()]/, 'regexp.escape.control'],
        [/@regexpctl/, 'regexp.escape.control'],
        [/[^\\\/]/, 'regexp'],
        [/@regexpesc/, 'regexp.escape'],
        [/\\\./, 'regexp.invalid'],
        [/(\/)([gimsuy]*)/, [{ token: 'regexp', bracket: '@close', next: '@pop' }, 'keyword.other']]],

        regexrange: [
        [/-/, 'regexp.escape.control'],
        [/\^/, 'regexp.invalid'],
        [/@regexpesc/, 'regexp.escape'],
        [/[^\]]/, 'regexp'],
        [/\]/, { token: 'regexp.escape.control', next: '@pop', bracket: '@close' }]],

        string_double: [
        [/[^\\"]+/, 'string'],
        [/@escapes/, 'string.escape'],
        [/\\./, 'string.escape.invalid'],
        [/"/, 'string', '@pop']],

        string_single: [
        [/[^\\']+/, 'string'],
        [/@escapes/, 'string.escape'],
        [/\\./, 'string.escape.invalid'],
        [/'/, 'string', '@pop']],

        string_backtick: [
        [/\$\{/, { token: 'delimiter.bracket', next: '@bracketCounting' }],
        [/[^\\`$]+/, 'string'],
        [/@escapes/, 'string.escape'],
        [/\\./, 'string.escape.invalid'],
        [/`/, 'string', '@pop']],

        bracketCounting: [
        [/\{/, 'delimiter.bracket', '@bracketCounting'],
        [/\}/, 'delimiter.bracket', '@pop'],
        { include: 'common' }] } };

/***/ })

}]);