/******/ (function(modules) { // webpackBootstrap
/******/ 	// install a JSONP callback for chunk loading
/******/ 	function webpackJsonpCallback(data) {
/******/ 		var chunkIds = data[0];
/******/ 		var moreModules = data[1];
/******/ 		var executeModules = data[2];
/******/
/******/ 		// add "moreModules" to the modules object,
/******/ 		// then flag all "chunkIds" as loaded and fire callback
/******/ 		var moduleId, chunkId, i = 0, resolves = [];
/******/ 		for(;i < chunkIds.length; i++) {
/******/ 			chunkId = chunkIds[i];
/******/ 			if(Object.prototype.hasOwnProperty.call(installedChunks, chunkId) && installedChunks[chunkId]) {
/******/ 				resolves.push(installedChunks[chunkId][0]);
/******/ 			}
/******/ 			installedChunks[chunkId] = 0;
/******/ 		}
/******/ 		for(moduleId in moreModules) {
/******/ 			if(Object.prototype.hasOwnProperty.call(moreModules, moduleId)) {
/******/ 				modules[moduleId] = moreModules[moduleId];
/******/ 			}
/******/ 		}
/******/ 		if(parentJsonpFunction) parentJsonpFunction(data);
/******/
/******/ 		while(resolves.length) {
/******/ 			resolves.shift()();
/******/ 		}
/******/
/******/ 		// add entry modules from loaded chunk to deferred list
/******/ 		deferredModules.push.apply(deferredModules, executeModules || []);
/******/
/******/ 		// run deferred modules when all chunks ready
/******/ 		return checkDeferredModules();
/******/ 	};
/******/ 	function checkDeferredModules() {
/******/ 		var result;
/******/ 		for(var i = 0; i < deferredModules.length; i++) {
/******/ 			var deferredModule = deferredModules[i];
/******/ 			var fulfilled = true;
/******/ 			for(var j = 1; j < deferredModule.length; j++) {
/******/ 				var depId = deferredModule[j];
/******/ 				if(installedChunks[depId] !== 0) fulfilled = false;
/******/ 			}
/******/ 			if(fulfilled) {
/******/ 				deferredModules.splice(i--, 1);
/******/ 				result = __webpack_require__(__webpack_require__.s = deferredModule[0]);
/******/ 			}
/******/ 		}
/******/
/******/ 		return result;
/******/ 	}
/******/
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// object to store loaded and loading chunks
/******/ 	// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 	// Promise = chunk loading, 0 = chunk loaded
/******/ 	var installedChunks = {
/******/ 		2: 0
/******/ 	};
/******/
/******/ 	var deferredModules = [];
/******/
/******/ 	// script path function
/******/ 	function jsonpScriptSrc(chunkId) {
/******/ 		return __webpack_require__.p + "" + ({"9":"CommonLazyChunk","11":"postman-converters","12":"monaco-editor","13":"postman-runtime","19":"jsonMode","20":"html","21":"htmlMode","22":"xml","23":"javascript","24":"tsMode","25":"markdown","26":"yaml","27":"graphql","28":"csharp","29":"cpp","30":"fsharp","31":"powershell","32":"go","33":"java","34":"objective-c","35":"php","36":"python","37":"ruby","38":"swift"}[chunkId]||chunkId) + ".js"
/******/ 	}
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/ 	// This file contains only the entry chunk.
/******/ 	// The chunk loading function for additional chunks
/******/ 	__webpack_require__.e = function requireEnsure(chunkId) {
/******/ 		var promises = [];
/******/
/******/
/******/ 		// JSONP chunk loading for javascript
/******/
/******/ 		var installedChunkData = installedChunks[chunkId];
/******/ 		if(installedChunkData !== 0) { // 0 means "already installed".
/******/
/******/ 			// a Promise means "currently loading".
/******/ 			if(installedChunkData) {
/******/ 				promises.push(installedChunkData[2]);
/******/ 			} else {
/******/ 				// setup Promise in chunk cache
/******/ 				var promise = new Promise(function(resolve, reject) {
/******/ 					installedChunkData = installedChunks[chunkId] = [resolve, reject];
/******/ 				});
/******/ 				promises.push(installedChunkData[2] = promise);
/******/
/******/ 				// start chunk loading
/******/ 				var script = document.createElement('script');
/******/ 				var onScriptComplete;
/******/
/******/ 				script.charset = 'utf-8';
/******/ 				script.timeout = 120;
/******/ 				if (__webpack_require__.nc) {
/******/ 					script.setAttribute("nonce", __webpack_require__.nc);
/******/ 				}
/******/ 				script.src = jsonpScriptSrc(chunkId);
/******/
/******/ 				// create error before stack unwound to get useful stacktrace later
/******/ 				var error = new Error();
/******/ 				onScriptComplete = function (event) {
/******/ 					// avoid mem leaks in IE.
/******/ 					script.onerror = script.onload = null;
/******/ 					clearTimeout(timeout);
/******/ 					var chunk = installedChunks[chunkId];
/******/ 					if(chunk !== 0) {
/******/ 						if(chunk) {
/******/ 							var errorType = event && (event.type === 'load' ? 'missing' : event.type);
/******/ 							var realSrc = event && event.target && event.target.src;
/******/ 							error.message = 'Loading chunk ' + chunkId + ' failed.\n(' + errorType + ': ' + realSrc + ')';
/******/ 							error.name = 'ChunkLoadError';
/******/ 							error.type = errorType;
/******/ 							error.request = realSrc;
/******/ 							chunk[1](error);
/******/ 						}
/******/ 						installedChunks[chunkId] = undefined;
/******/ 					}
/******/ 				};
/******/ 				var timeout = setTimeout(function(){
/******/ 					onScriptComplete({ type: 'timeout', target: script });
/******/ 				}, 120000);
/******/ 				script.onerror = script.onload = onScriptComplete;
/******/ 				document.head.appendChild(script);
/******/ 			}
/******/ 		}
/******/ 		return Promise.all(promises);
/******/ 	};
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "../js/";
/******/
/******/ 	// on error function for async loading
/******/ 	__webpack_require__.oe = function(err) { console.error(err); throw err; };
/******/
/******/ 	var jsonpArray = window["webpackJsonp"] = window["webpackJsonp"] || [];
/******/ 	var oldJsonpFunction = jsonpArray.push.bind(jsonpArray);
/******/ 	jsonpArray.push = webpackJsonpCallback;
/******/ 	jsonpArray = jsonpArray.slice();
/******/ 	for(var i = 0; i < jsonpArray.length; i++) webpackJsonpCallback(jsonpArray[i]);
/******/ 	var parentJsonpFunction = oldJsonpFunction;
/******/
/******/
/******/ 	// add entry module to deferred list
/******/ 	deferredModules.push([6008,5,8]);
/******/ 	// run deferred modules when ready
/******/ 	return checkDeferredModules();
/******/ })
/************************************************************************/
/******/ ({

/***/ 144:
/***/ (function(module, exports) {

module.exports = require("fs");

/***/ }),

/***/ 145:
/***/ (function(module, exports) {

module.exports = require("zlib");

/***/ }),

/***/ 4139:
/***/ (function(module, exports) {

module.exports = require("child_process");

/***/ }),

/***/ 5579:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var _models_sync_SyncManagerProxy__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5580);


/**
                                                                    *
                                                                    */
function bootSyncProxy(cb) {
  _.assign(window.pm, { syncManager: new _models_sync_SyncManagerProxy__WEBPACK_IMPORTED_MODULE_0__["default"]() });
  pm.logger.info('SyncProxy~boot - Success');
  cb && cb(null);
}

/* harmony default export */ __webpack_exports__["default"] = (bootSyncProxy);
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5580:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var backbone__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(205);
/* harmony import */ var backbone__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(backbone__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _modules_model_event__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(742);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(749);




/**
                                                    * Handles the socket, and is the interface for sending and receiving changesets
                                                    *
                                                    * @class SyncManager
                                                    */
var SyncManagerProxy = backbone__WEBPACK_IMPORTED_MODULE_0___default.a.Model.extend({
  defaults: function () {
    return {
      loggedIn: false,
      nextReconnectTime: null,
      timeTillReconnect: null };

  },

  sendEventToSyncShared: function (event) {
    this.syncInternalChannel.publish(event);
  },

  attachInternalChannelSubscription: function () {
    this.syncManagerInternalDispose = this.syncInternalChannel.subscribe(event => {
      let eventNamespace = Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_1__["getEventNamespace"])(event),
      eventName = Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_1__["getEventName"])(event),
      eventData = Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_1__["getEventData"])(event);

      if (eventNamespace === 'timeTillReconnect' && eventName === 'updated') {
        this.set('timeTillReconnect', eventData.timeTillReconnect);
        return;
      }

      if (eventNamespace === 'loggedIn' && eventName === 'updated') {
        this.set('loggedIn', eventData.loggedIn);
        return;
      }

      if (eventNamespace === 'conflicts' && eventName === 'show') {
        this.showConflicts(eventData.conflicts);
        return;
      }

      if (eventNamespace === 'issue' && eventName === 'show') {
        this.showSyncIssue(eventData.issue);
        return;
      }
    });
  },

  initialize: function () {
    this.syncInternalChannel = pm.eventBus.channel('sync-manager-internal');
    this.attachInternalChannelSubscription();
  },

  showConflicts: function (conflicts) {
    this.trigger('showConflicts', conflicts);
  },

  showSyncIssue: function (issue) {
    pm.mediator.trigger('showSyncIssue', issue);
  },

  syncIconClick: function () {
    this.sendEventToSyncShared(Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_1__["createEvent"])('syncIconClicked', 'command'));
  },

  restoreCollection: function (restoreTarget, cb) {
    let isSocketConnected = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_2__["getStore"])('SyncStatusStore').isSocketConnected;
    if (!isSocketConnected) {
      pm.toasts.error('You need to be connected to Postman Sync to restore a collection.');
      _.isFunction(cb) && cb(new Error('No sync connection to restore collection'));
      return;
    }
    this.sendEventToSyncShared(Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_1__["createEvent"])('restoreCollection', 'command', { restoreTarget: restoreTarget }));
    cb();
  },

  conflictsResolved: function (resolution) {
    this.sendEventToSyncShared(Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_1__["createEvent"])('conflictsResolved', 'command', { resolution: resolution }));
  },

  forceSync: function () {
    this.sendEventToSyncShared(Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_1__["createEvent"])('forceSync', 'command'));
  },

  forceSyncCollectionAndContinue: function (id) {
    this.sendEventToSyncShared(Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_1__["createEvent"])('forceSyncCollectionAndContinue', 'command', { collection: id }));
  },

  forceConnect: function () {
    this.sendEventToSyncShared(Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_1__["createEvent"])('forceConnect', 'command'));
  },

  fetchPendingConflicts: function () {
    this.sendEventToSyncShared(Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_1__["createEvent"])('fetchPendingConflicts', 'command'));
  } });


/* harmony default export */ __webpack_exports__["default"] = (SyncManagerProxy);
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5581:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var _runtime_api_ConsoleInterface__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5582);


/**
                                                                       * Boots up the console interface
                                                                       * @param {Function} cb - The callback with error
                                                                       */
function bootConsoleInterface(cb) {
  _.assign(window.pm, {
    console: new _runtime_api_ConsoleInterface__WEBPACK_IMPORTED_MODULE_0__["default"]() // @todo: Change to pm.console when we replace the current console
  });

  // Initialize the new console interface with current window information
  window.pm.console.initialize(pm && pm.window && pm.window.id).
  then(() => {
    pm.logger.info('NewConsole~boot - Success');

    // using `setTimeout` here to ensure that we take the errors in `cb` out
    // of the stack trace and do not call the `catch` block (which calls the
    // `cb` again!)
    return cb && setTimeout(cb, 0);
  }).
  catch(err => {
    pm.logger.error('NewConsole~boot - Failed');
    return cb && cb(err);
  });
}

/* harmony default export */ __webpack_exports__["default"] = (bootConsoleInterface);
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5582:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleInterface; });
/* harmony import */ var uuid__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(650);
/* harmony import */ var uuid__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(uuid__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _js_modules_model_event__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(742);
/* harmony import */ var _js_modules_pipelines_app_action__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2406);
/* harmony import */ var _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(731);
/* harmony import */ var _constants_ConsoleEventTypes__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2661);


// @note: remove the below imports when removing the `clear` method. The console
// service should be responsible for interacting with the pipeline.
// see the comment for `clear` method for details





let

ConsoleInterface = class ConsoleInterface {




































  /**
                                            * Constructor
                                            */ /**
                                                * The ID of the window that is associated for an instance
                                                * @type {String}
                                                * @private
                                                */ /**
                                                    * The types of events that we're handling.
                                                    * @default
                                                    * @type {Set<String>}
                                                    * @private
                                                    */constructor() {this.initialized = false;this._eventTypes = new Set([_constants_ConsoleEventTypes__WEBPACK_IMPORTED_MODULE_4__["CONSOLE_EVENT_LOG"], _constants_ConsoleEventTypes__WEBPACK_IMPORTED_MODULE_4__["CONSOLE_EVENT_NETWORK"], _constants_ConsoleEventTypes__WEBPACK_IMPORTED_MODULE_4__["CONSOLE_EVENT_EXCEPTION"]]);this._timelineId = null;this._windowId = null;this._sequence = 0; // Initialize the sugar helper methods over write
    this.log = this.write.bind(this, _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_3__["CONSOLE_LEVEL_LOG"]);this.info = this.write.bind(this, _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_3__["CONSOLE_LEVEL_INFO"]);this.warn = this.write.bind(this, _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_3__["CONSOLE_LEVEL_WARN"]);this.error = this.write.bind(this, _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_3__["CONSOLE_LEVEL_ERROR"]);} /**
                                                                                                                                                                                                                               * Connect to the timeline and register event types
                                                                                                                                                                                                                               *
                                                                                                                                                                                                                               * @param {String} windowId - The window id for attaching to the console stream
                                                                                                                                                                                                                               * @return {Promise} - A promise that resolves if connected to a timeline successfully
                                                                                                                                                                                                                               */ /**
                                                                                                                                                                                                                                   * A counter maintained to establish strict order of logs
                                                                                                                                                                                                                                   * @type {number}
                                                                                                                                                                                                                                   * @private
                                                                                                                                                                                                                                   */ /**
                                                                                                                                                                                                                                       * The ID of the console stream (timeline) that we're connected to.
                                                                                                                                                                                                                                       * @type {String}
                                                                                                                                                                                                                                       */ /**
                                                                                                                                                                                                                                           * The state of the console interface. It is true if the console is attached to a timeline.
                                                                                                                                                                                                                                           * @default
                                                                                                                                                                                                                                           * @type {Boolean}
                                                                                                                                                                                                                                           */initialize(windowId) {if (this.initialized) {return Promise.reject(new Error('Console has already been initialized'));}if (!windowId || typeof windowId !== 'string') {return Promise.reject(new TypeError('Invalid value for argument `windowId`'));}this._windowId = windowId;this._timelineId = uuid__WEBPACK_IMPORTED_MODULE_0___default.a.v4();this._sequence = 0;

    return Object(_js_modules_pipelines_app_action__WEBPACK_IMPORTED_MODULE_2__["default"])(Object(_js_modules_model_event__WEBPACK_IMPORTED_MODULE_1__["createEvent"])('createTimeline', 'console', {
      id: this._timelineId,
      window: this._windowId })).

    then(result => {
      if (!result || result.status !== 'OK') {
        return Promise.reject(new Error('Could not create a timeline for the window'));
      }

      this.initialized = true;

      return Promise.resolve();
    });
  }

  /**
     * Check if we're handling the event that was sent
     *
     * @param {String} eventType - the event type to check
     * @return {Boolean} - true if we're handling the event type
     */
  canHandleEvent(eventType) {
    if (typeof eventType !== 'string') {
      return false;
    }

    return this._eventTypes.has(eventType);
  }

  getTimelineId() {
    return this._timelineId;
  }

  /**
     * Writes a log to console
     *
     * @param {String} severity - One of several severity levels for the console message
     *  (defined in constants/ConsoleEventSeverity.js)
     * @param {String} eventType - One of the several available types for a console message.
     *  This must be one which was sent while instantiating the console
     * @param {Object} source - TBD
     * @param {Object} log - A detailed description for this log
     * @param {Number} [timestamp] - A timestamp to be used when logging this value
     */
  write(severity, eventType, source, log, timestamp = Date.now()) {
    if (!this.canHandleEvent(eventType)) {
      throw new Error(`ConsoleInterface~write: Could not handle event type: ${eventType}`);
    }

    if (!severity || typeof severity !== 'string') {
      return new Error('Invalid value for argument `severity`');
    }

    if (!source || typeof source !== 'object') {
      return new Error('Invalid value for argument `source`');
    }

    if (!log) {
      return new Error('Invalid value for argument `log`');
    }

    if (timestamp && (typeof timestamp !== 'number' || timestamp < 0)) {
      return new Error('Invalid value for argument `timestamp`');
    }

    if (!this.initialized) {
      pm.logger.warn('ConsoleInterface~write: Cannot write as interface has not been initialized');

      return;
    }

    return Object(_js_modules_pipelines_app_action__WEBPACK_IMPORTED_MODULE_2__["default"])(Object(_js_modules_model_event__WEBPACK_IMPORTED_MODULE_1__["createEvent"])('createEvent', 'console', {
      id: uuid__WEBPACK_IMPORTED_MODULE_0___default.a.v4(),
      timeline: this._timelineId,
      sequence: this._sequence++,
      timestamp,
      type: eventType,
      severity,
      source,
      details: log }));

  }

  /**
     * Clears console events from the persistence storage for all timelines.
     */
  clear() {
    if (!this.initialized) {
      pm.logger.warn('ConsoleInterface~clear: Cannot clear as interface has not been initialized');

      return;
    }

    // We're calling the dispatchAppAction directly to clear all console events
    // because:
    //   the clear event is supposed to be just like another event in a timeline
    //   to allow exporting timelines with info before the clear event was
    //   fired. Until the export capabilities are not added to the console, it's
    //   useless to keep the events in the storage which impacts performance.
    return Object(_js_modules_pipelines_app_action__WEBPACK_IMPORTED_MODULE_2__["default"])(Object(_js_modules_model_event__WEBPACK_IMPORTED_MODULE_1__["createEvent"])('deleteEvents', 'console', { timeline: this._timelineId }));
  }

  /**
     * Disconnect from the console stream. Once this method is called, the window
     * will not be able to send any logs to this stream.
     */
  destroy() {
    if (!this.initialized) {
      pm.logger.warn('ConsoleInterface~destroy: Cannot destroy as interface has not been initialized');

      return;
    }

    this.initialized = false;

    return Object(_js_modules_pipelines_app_action__WEBPACK_IMPORTED_MODULE_2__["default"])(Object(_js_modules_model_event__WEBPACK_IMPORTED_MODULE_1__["createEvent"])('deleteTimeline', 'console', { id: this._timelineId }));
  }};

/***/ }),

/***/ 5584:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ProxyListManager; });
const WHITELISTED_PROPS = ['disabled', 'httpProxy', 'httpsProxy', 'host', 'port',
'authenticate', 'username', 'password', 'bypass'];

/**
                                                    * Transform older proxy settings to newer version (globalProxies -> globalProxy).
                                                    *
                                                    * @param {Object[]} config
                                                    * @returns {Object}
                                                    */
function transformOlderSettings(config) {
  const defaultConfig = {
    disabled: true,
    httpProxy: true,
    httpsProxy: true,
    port: 8080 };


  if (!(Array.isArray(config) && config.length > 0)) {
    return defaultConfig;
  }

  config = config[0];

  if (!(config && config.host)) {
    return defaultConfig;
  }

  let pattern = String(_.get(config, 'match.pattern', '')),
  httpProxy = pattern.includes('http:') || pattern.includes('http+'),
  httpsProxy = pattern.includes('https');

  return {
    httpProxy: !httpProxy && !httpsProxy ? true : httpProxy, // unlikely but, set at-least HTTP proxy
    httpsProxy: httpsProxy,
    host: config.host,
    port: config.port,
    authenticate: config.authenticate,
    username: config.username,
    password: config.password,
    disabled: config.disabled };

}

/**
   * SDK compatible url mach for which the proxy has been associated with.
   *
   * @param {Boolean} httpProxy
   * @param {Boolean} httpsProxy
   * @returns {String}
   */
function getMatchPattern(httpProxy, httpsProxy) {
  const suffix = '://*:*/*';

  if (httpsProxy) {
    if (httpProxy) {
      return 'http+https' + suffix;
    }

    return 'https' + suffix;
  }

  return 'http' + suffix;
}

/**
   * Get bypass list for the proxy setting.
   *
   * @param {String} bypass
   * @returns {String[]}
   */
function getBypassList(bypass) {
  if (!(bypass && typeof bypass === 'string')) {return;}

  // split by ',' and '\n' and filter empty strings
  bypass = bypass.split(/,|\n/g).map(h => h.trim()).filter(Boolean);

  let host,
  i,
  ii = bypass.length,
  bypassList = new Array(ii);

  for (i = 0; i < ii; i++) {
    host = bypass[i];

    if (host.includes('://')) {// protocol is specified
      host = host.endsWith('/') ?
      host : // already a complete URL
      host + ':*/*'; // match all ports and paths
    } else
    {// just hostname
      host = `http+https://${host}:*/*`;
    }

    bypassList[i] = host;
  }

  return bypassList;
}let

ProxyListManager = class ProxyListManager {
  constructor() {
    this.globalProxy = this.getFromDB();
  }

  getFromDB() {
    let config = pm.settings.getSetting('ProxyListManager');

    !_.isObject(config) && (config = {});

    // migrate to newer global proxy configuration (< v7.9.0)
    // @note this migrate as well as set default config for newer versions
    if (!config.globalProxy) {
      config.globalProxy = transformOlderSettings(config.globalProxies);

      // update local storage to avoid this migration on every load
      this.saveToDB({ globalProxy: config.globalProxy });
    }

    return config.globalProxy;
  }

  saveToDB(config) {
    // bail out if not a valid config object (if present)
    if (config && !config.globalProxy) {
      return;
    }

    pm.settings.setSetting('ProxyListManager', config || { globalProxy: this.globalProxy });
  }

  update(config) {
    // bail out if not a valid config object
    if (!(config && config.globalProxy)) {
      return;
    }

    this.globalProxy = Object.assign(this.globalProxy, _.pick(config.globalProxy, WHITELISTED_PROPS));
  }

  /**
     * @returns {Object[]} - SDK compatible ProxyConfigList object
     */
  getGlobalProxyConfigList() {
    let globalProxy = this.globalProxy;

    return [{
      match: getMatchPattern(globalProxy.httpProxy, globalProxy.httpsProxy),
      host: globalProxy.host,
      port: globalProxy.port,
      authenticate: globalProxy.authenticate,
      username: globalProxy.username,
      password: globalProxy.password,
      disabled: globalProxy.disabled,
      bypass: getBypassList(globalProxy.bypass) }];

  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5588:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var backbone__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(205);
/* harmony import */ var backbone__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(backbone__WEBPACK_IMPORTED_MODULE_0__);

const Certificate = backbone__WEBPACK_IMPORTED_MODULE_0___default.a.Model.extend({
  defaults: function () {
    return {
      host: '',
      pemPath: '',
      keyPath: '',
      pfxPath: '',
      passphrase: null };

  },

  toJSON: function () {
    return {
      host: this.get('host'),
      pemPath: this.get('pemPath'),
      keyPath: this.get('keyPath'),
      pfxPath: this.get('pfxPath'),
      passphrase: this.get('passphrase') };

  } });



const CertificateManager = backbone__WEBPACK_IMPORTED_MODULE_0___default.a.Collection.extend({
  model: Certificate,

  initialize: function () {
    this.loadCertificates();
    pm.settings.on('setSetting:clientCertificates', this.loadCertificates, this);
  },

  loadCertificates: function () {
    let serialisedStore = pm.settings.getSetting('clientCertificates'),
    certificateStore = {};

    try {
      certificateStore = JSON.parse(serialisedStore);
      let certificates = _.get(certificateStore, 'certificates', []);
      let sanitizedCertificates = _.map(certificates, certificate => {
        let sanitizedHost = certificate.host.
        replace(/.*?:\/\//g, '') // strip protocol
        .replace(/\?.*/, '') // strip query
        .replace(/\/.*/, '') // strip path
        .replace(/^\./, ''); // strip leading period

        return _.assign({}, certificate, { host: sanitizedHost });
      });
      this.reset(sanitizedCertificates);
    }
    catch (e) {
      pm.logger.error('Error loading certificates', e);
    }
  },

  saveCertificates: function () {
    let certificateStore = { certificates: this.toJSON() };

    try {
      let serialisedStore = JSON.stringify(certificateStore);
      pm.settings.setSetting('clientCertificates', serialisedStore);
    }
    catch (e) {
      pm.logger.error('Error saving certificates', e);
    }
  },

  findCertificateByDomain: function (host) {
    return _.find(this.models, certificateModel => {
      return host === certificateModel.get('host');
    });
  },

  addCertificate(host, pemPath, keyPath, pfxPath, passphrase) {
    if (!host) {
      pm.logger.error('Error adding certificate', arguments);
      return;
    }

    let certificate = this.findCertificateByDomain(host);

    if (certificate) {
      this.updateCertificate(host, pemPath, keyPath, pfxPath, passphrase);
    } else
    {
      this.add({
        host: host,
        pemPath: pemPath,
        keyPath: keyPath,
        pfxPath: pfxPath,
        passphrase: passphrase });

    }

    this.saveCertificates();
    return true;
  },

  updateCertificate(host, pemPath, keyPath, pfxPath, passphrase) {
    let certificate = this.findCertificateByDomain(host);

    if (!certificate) {
      return false;
    }

    certificate.set({
      pemPath: pemPath,
      keyPath: keyPath,
      pfxPath: pfxPath,
      passphrase: passphrase });


    this.saveCertificates();

    return true;
  },

  removeCertificate(host) {
    let certificate = this.findCertificateByDomain(host);

    if (!certificate) {
      return false;
    }

    this.remove(certificate);

    this.saveCertificates();

    return true;
  } });


/* harmony default export */ __webpack_exports__["default"] = (CertificateManager);
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5592:
/***/ (function(module, exports) {

/*
 * base64-arraybuffer
 * https://github.com/niklasvh/base64-arraybuffer
 *
 * Copyright (c) 2012 Niklas von Hertzen
 * Licensed under the MIT license.
 */
(function(){
  "use strict";

  var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

  // Use a lookup table to find the index.
  var lookup = new Uint8Array(256);
  for (var i = 0; i < chars.length; i++) {
    lookup[chars.charCodeAt(i)] = i;
  }

  exports.encode = function(arraybuffer) {
    var bytes = new Uint8Array(arraybuffer),
    i, len = bytes.length, base64 = "";

    for (i = 0; i < len; i+=3) {
      base64 += chars[bytes[i] >> 2];
      base64 += chars[((bytes[i] & 3) << 4) | (bytes[i + 1] >> 4)];
      base64 += chars[((bytes[i + 1] & 15) << 2) | (bytes[i + 2] >> 6)];
      base64 += chars[bytes[i + 2] & 63];
    }

    if ((len % 3) === 2) {
      base64 = base64.substring(0, base64.length - 1) + "=";
    } else if (len % 3 === 1) {
      base64 = base64.substring(0, base64.length - 2) + "==";
    }

    return base64;
  };

  exports.decode =  function(base64) {
    var bufferLength = base64.length * 0.75,
    len = base64.length, i, p = 0,
    encoded1, encoded2, encoded3, encoded4;

    if (base64[base64.length - 1] === "=") {
      bufferLength--;
      if (base64[base64.length - 2] === "=") {
        bufferLength--;
      }
    }

    var arraybuffer = new ArrayBuffer(bufferLength),
    bytes = new Uint8Array(arraybuffer);

    for (i = 0; i < len; i+=4) {
      encoded1 = lookup[base64.charCodeAt(i)];
      encoded2 = lookup[base64.charCodeAt(i+1)];
      encoded3 = lookup[base64.charCodeAt(i+2)];
      encoded4 = lookup[base64.charCodeAt(i+3)];

      bytes[p++] = (encoded1 << 2) | (encoded2 >> 4);
      bytes[p++] = ((encoded2 & 15) << 4) | (encoded3 >> 2);
      bytes[p++] = ((encoded3 & 3) << 6) | (encoded4 & 63);
    }

    return arraybuffer;
  };
})();


/***/ }),

/***/ 5619:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "initializeConfigurations", function() { return initializeConfigurations; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "initializeServices", function() { return initializeServices; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "subscribeToModelEvents", function() { return subscribeToModelEvents; });
/* harmony import */ var _services_Configuration__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5620);
/* harmony import */ var _services_FeatureFlags__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5624);
/* harmony import */ var _modules_model_event__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(742);





let servicesMap = [
_services_Configuration__WEBPACK_IMPORTED_MODULE_0__["default"],
_services_FeatureFlags__WEBPACK_IMPORTED_MODULE_1__["default"]];


/**
                * Initializes the configuration service
                *
                * @param {Function} cb
                */
function initializeConfigurations(cb) {
  initializeServices().
  then(({ configService, featureFlagService }) => {
    pm.configs = configService;
    pm.features = featureFlagService;
    pm.logger.info('bootConfigurations~initialize - Success');
    cb && cb(null);
  }).
  catch(e => {
    pm.logger.error('bootConfigurations~initialize - Failed', e);
    cb & cb(e);
  });
}

/**
   * Initializes the configuration caches
   */
function initializeServices() {
  return Promise.all(_.map(servicesMap, s => {
    let service = new s();
    subscribeToModelEvents(service, service._getLayerNamespaces());
    return Promise.resolve(service);
  })).
  then(values => {
    return {
      configService: values[0],
      featureFlagService: values[1] };

  });
}

/**
   * Subscribes the caches to the model-events on the event bus
   *
   * @param {*} cache
   * @param {*} namespaces
   */
function subscribeToModelEvents(service, namespaces) {
  pm.eventBus.channel('model-events').subscribe(function (event) {
    Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_2__["processEvent"])(event, ['updated'], function (event, cb) {
      let eventNamespace = Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_2__["getEventNamespace"])(event),
      eventName = Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_2__["getEventName"])(event);

      if (!_.includes(namespaces, eventNamespace)) {
        return cb && cb();
      }

      // Bail out if any other action except updated
      if (eventName !== 'updated') {
        return cb && cb();
      }

      // Invalidate the cache if changes are made
      service.invalidateCache();
      cb && cb();
    });
  });
}
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5620:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _BaseConfigurationService__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5621);
/* harmony import */ var _modules_controllers_UserConfigurationController__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2398);
/* harmony import */ var _modules_controllers_DefaultConfigurationController__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5622);


let

Configuration = class Configuration extends _BaseConfigurationService__WEBPACK_IMPORTED_MODULE_0__["default"] {constructor(...args) {var _temp;return _temp = super(...args), this.
    layers = {
      user: {
        controller: _modules_controllers_UserConfigurationController__WEBPACK_IMPORTED_MODULE_1__["default"],
        namespace: 'userconfigs' },

      app: {
        controller: _modules_controllers_DefaultConfigurationController__WEBPACK_IMPORTED_MODULE_2__["default"],
        namespace: 'defaultconfigs' } }, this.




    resolutionOrder = ['app', 'user'], _temp;} // The order in which the layers will be resolved
};

/* harmony default export */ __webpack_exports__["default"] = (Configuration);

/***/ }),

/***/ 5621:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return BaseConfigurationService; });
/* harmony import */ var events__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(131);
/* harmony import */ var events__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(events__WEBPACK_IMPORTED_MODULE_0__);
let

BaseConfigurationService = class BaseConfigurationService extends events__WEBPACK_IMPORTED_MODULE_0___default.a {
  _getLayerNamespaces() {
    return _.map(this.layers, layer => layer.namespace);
  }

  _getResolved(key) {
    if (this.resolvedConfiguration[key] === undefined) {
      return Promise.reject(new Error('ConfigurationService: Could not get config. Key does not exist'));
    }
    return Promise.resolve(this.resolvedConfiguration[key]);
  }

  // Single level access support
  get(key) {
    // cache hit
    if (this.resolvedConfiguration) {
      return this._getResolved(key);
    }

    // cache miss
    return this.
    resolveConfigurationLayers().
    then(resolvedConfiguration => {
      this.resolvedConfiguration = resolvedConfiguration;
      return this._getResolved(key);
    });
  }

  // @todo Lazy loading implementation
  //
  // NOTE: PREVENT MISUSE OF THIS METHOD.
  // USE THE GET METHOD TO GET SPECIFIED KEYS.
  _getAll() {
    // cache hit
    if (this.resolvedConfiguration) {
      return Promise.resolve(this.resolvedConfiguration);
    }

    // cache miss
    return this.
    resolveConfigurationLayers().
    then(resolvedConfiguration => {
      this.resolvedConfiguration = resolvedConfiguration;
      return this.resolvedConfiguration;
    });
  }

  /**
     * Resolves single level JSON
     */
  resolveConfigurationLayers() {
    return Promise.all(_.map(this.resolutionOrder, i => this.layers[i].controller.getAll())).
    then(configurations => {
      let resolvedConfiguration = {};
      _.forEach(configurations, configuration => {
        Object.assign(resolvedConfiguration, configuration);
      });
      return resolvedConfiguration;
    });
  }

  invalidateCache() {
    this.resolvedConfiguration = null;
    this.emit('changed');
  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5622:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
let defaultConfiguration = __webpack_require__(5623);

/* harmony default export */ __webpack_exports__["default"] = ({
  getAll: function () {
    return Promise.resolve(defaultConfiguration);
  } });

/***/ }),

/***/ 5623:
/***/ (function(module) {

module.exports = JSON.parse("{\"editor.requestEditorLayoutName\":\"layout-1-column\",\"request.autoPersistVariables\":true,\"user.plansToAllowUpgrade\":[],\"workspace.visibilityAvailablePlans\":[],\"editor.openInNew\":false,\"editor.skipConfirmationBeforeClose\":false,\"editor.showIcons\":true}");

/***/ }),

/***/ 5624:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _BaseConfigurationService__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5621);
/* harmony import */ var _modules_controllers_UserFeatureFlagController__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2391);
/* harmony import */ var _modules_controllers_DefaultFeatureFlagController__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5625);


let

FeatureFlags = class FeatureFlags extends _BaseConfigurationService__WEBPACK_IMPORTED_MODULE_0__["default"] {constructor(...args) {var _temp;return _temp = super(...args), this.
    layers = {
      user: {
        controller: _modules_controllers_UserFeatureFlagController__WEBPACK_IMPORTED_MODULE_1__["default"],
        namespace: 'userfeatureflags' },

      app: {
        controller: _modules_controllers_DefaultFeatureFlagController__WEBPACK_IMPORTED_MODULE_2__["default"],
        namespace: 'defaultfeatureflags' } }, this.




    resolutionOrder = ['app', 'user'], _temp;} // The order in which the layers will be resolved.

  isEnabled(key) {
    return super.get(key);
  }

  get() {
    return new Error('Feature Flags: Use the isEnabled API to get a flag');
  }};


/* harmony default export */ __webpack_exports__["default"] = (FeatureFlags);

/***/ }),

/***/ 5625:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
let defaultFeatureFlags = __webpack_require__(5626);

/* harmony default export */ __webpack_exports__["default"] = ({
  getAll: function () {
    return Promise.resolve(defaultFeatureFlags);
  } });

/***/ }),

/***/ 5626:
/***/ (function(module) {

module.exports = JSON.parse("{\"inviteByNonAdmin\":false,\"collectionAndFolderConfigurations\":false,\"schemaChangelog\":true,\"requestValidation\":true,\"schemaSyncing\":false,\"schemaValidation\":true}");

/***/ }),

/***/ 5627:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_, global) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AgentInterface", function() { return AgentInterface; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "IPCAgent", function() { return IPCAgent; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "WebsocketAgent", function() { return WebsocketAgent; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "XHRAgent", function() { return XHRAgent; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AgentManager", function() { return AgentManager; });
/* harmony import */ var shortid__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5628);
/* harmony import */ var shortid__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(shortid__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var async__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(664);
/* harmony import */ var async__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(async__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var socket_io_client__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5638);
/* harmony import */ var socket_io_client__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(socket_io_client__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(64);
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(path__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var mobx__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(751);
/* harmony import */ var eventemitter3__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(5682);
/* harmony import */ var eventemitter3__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(eventemitter3__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _js_utils_FsHelper__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(2877);
/* harmony import */ var _js_common_utils_pathIsInside__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(5683);
/* harmony import */ var _js_common_utils_pathIsInside__WEBPACK_IMPORTED_MODULE_7___default = /*#__PURE__*/__webpack_require__.n(_js_common_utils_pathIsInside__WEBPACK_IMPORTED_MODULE_7__);
/* harmony import */ var _js_modules_model_event__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(742);
/* harmony import */ var _js_common_services_RuntimeExecutionService__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(5684);
/* harmony import */ var _js_common_services_RuntimeExecutionService__WEBPACK_IMPORTED_MODULE_9___default = /*#__PURE__*/__webpack_require__.n(_js_common_services_RuntimeExecutionService__WEBPACK_IMPORTED_MODULE_9__);
/* harmony import */ var _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(3269);
/* harmony import */ var _constants_VisualizerConstants__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(2906);
/* harmony import */ var _js_common_utils_postmanFs__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(5695);
/* harmony import */ var _js_common_utils_postmanFs__WEBPACK_IMPORTED_MODULE_12___default = /*#__PURE__*/__webpack_require__.n(_js_common_utils_postmanFs__WEBPACK_IMPORTED_MODULE_12__);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _desc, _value, _class, _descriptor, _descriptor2, _desc2, _value2, _class7, _descriptor3;function _initDefineProp(target, property, descriptor, context) {if (!descriptor) return;Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 });}function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {var desc = {};Object['ke' + 'ys'](descriptor).forEach(function (key) {desc[key] = descriptor[key];});desc.enumerable = !!desc.enumerable;desc.configurable = !!desc.configurable;if ('value' in desc || desc.initializer) {desc.writable = true;}desc = decorators.slice().reverse().reduce(function (desc, decorator) {return decorator(target, property, desc) || desc;}, desc);if (context && desc.initializer !== void 0) {desc.value = desc.initializer ? desc.initializer.call(context) : void 0;desc.initializer = undefined;}if (desc.initializer === void 0) {Object['define' + 'Property'](target, property, desc);desc = null;}return desc;}function _initializerWarningHelper(descriptor, context) {throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');} /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           * @file The agent manager forms a singleton to control which runtime agent
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           *       interface is used on which platform
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           */




// { REMOVE By shifting path related activity to the agent


// REMOVE }



// { REMOVE By shifting path related activity to the agent



// REMOVE }








// { REMOVE By shifting path related activity to the agent
const processFiles = files => _.map(files, file => {
  // If the file in not an instance of File then it already has been
  // processes, there is not much to do here (We should not hit this flow ideally)
  if (!(file instanceof File)) {
    return file;
  }

  const workingDir = Object(_js_utils_FsHelper__WEBPACK_IMPORTED_MODULE_6__["getWorkingDir"])();

  // Note: IPC Agent cannot be used in web hence we do not are much about
  // unavailability of file.path
  let filePath = file.path;

  if (_js_common_utils_pathIsInside__WEBPACK_IMPORTED_MODULE_7___default()(filePath, workingDir)) {
    // Set the relative path of the file from the workingDir as the selected file path
    filePath = path__WEBPACK_IMPORTED_MODULE_3___default.a.relative(workingDir, filePath);
  }

  // At this point we know that the file is an instance of file, i.e it has been newly added,
  // we transform the File object to a standard object that rest of the application will understand
  return {
    // The name of the file without the path
    name: file.name,

    // The mediatype of the file
    type: file.type,

    // The actual path will be used for white listing, null value will not add to whitelist
    // Note: actual path is always a absolute path
    actual: file.path,

    // Whatever the file path is sanitize it to posix (This has to be done right before saving)
    path: Object(_js_utils_FsHelper__WEBPACK_IMPORTED_MODULE_6__["sanitizePath"])(filePath) };

});

/**
     * Converts binary responseStream to base64 encoded string
     *
     * @param {Buffer|Uint8Array|ArrayBuffer|String} data
     */
function base64Encode(responseStream) {
  if (responseStream instanceof ArrayBuffer) {
    // ResponseStream will be ArrayBuffer in browser with Websocket agent. convert it to Uint8Array
    responseStream = new Uint8Array(responseStream);
  }

  if (responseStream instanceof Uint8Array) {
    // ResponseStream will be Uint8Array in browser. convert it to binary string
    const binstr = Array.prototype.map.call(responseStream, ch => String.fromCharCode(ch)).join('');

    return btoa(binstr);
  }

  // Checking if Buffer exist and responseStream is an instance of Buffer
  if (global.Buffer && responseStream instanceof global.Buffer) {
    // ResponseStream will be Buffer in electron app.
    return responseStream.toString('base64');
  }

  if (typeof responseStream === 'string') {
    return btoa(responseStream);
  }

  return null;
}

// REMOVE }

/**
 * Class to handle lifecycle of an agent
 */let
Lifecycle = (_class = class Lifecycle {constructor() {_initDefineProp(this, 'state', _descriptor, this);_initDefineProp(this, 'health', _descriptor2, this);this.


    selected = false;}


  setConnectionState(state) {
    this.state = state;
  }


  setHealth(health) {
    this.health = health;
  }

  /**
     * Interface to check health of the system
     */
  checkHealth() {}

  /**
                    * Hook triggered when agent gets selected
                    */
  select() {this.selected = true;}

  /**
                                    * Hook triggered when the agents gets deselected
                                    */
  deselect() {this.selected = false;}}, (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'state', [mobx__WEBPACK_IMPORTED_MODULE_4__["observable"]], { enumerable: true, initializer: function () {return _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["STATES"].DISCONNECTED;} }), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'health', [mobx__WEBPACK_IMPORTED_MODULE_4__["observable"]], { enumerable: true, initializer: function () {return false;} }), _applyDecoratedDescriptor(_class.prototype, 'setConnectionState', [mobx__WEBPACK_IMPORTED_MODULE_4__["action"]], Object.getOwnPropertyDescriptor(_class.prototype, 'setConnectionState'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setHealth', [mobx__WEBPACK_IMPORTED_MODULE_4__["action"]], Object.getOwnPropertyDescriptor(_class.prototype, 'setHealth'), _class.prototype)), _class);


/**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * A interface class implementing generic agent interfaces
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @interface
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */
let AgentInterface = class AgentInterface extends Lifecycle {constructor(...args) {var _temp;return _temp = super(...args), this.
    type = 'default', _temp;}

  /**
                               * Interface to trigger run a full collection
                               *
                               * @param {Object} info
                               * @param {String} info.id
                               * @param {Object} collection A collection in v2 postman collection schema
                               * @param {Object} options
                               *
                               */
  executeCollection() {}

  /**
                          * Terminates an ongoing execution
                          *
                          * @param {Object} criteria
                          * @param {String} criteria.id
                          *
                          */
  terminateExecution() {}

  /**
                           * Pauses an ongoing execution
                           *
                           * @param {Object} criteria
                           * @param {String} criteria.id
                           */
  pauseExecution() {}

  /**
                       * Resumes a paused ongoing execution
                       *
                       * @param {Object} criteria
                       * @param {String} criteria.id
                       */
  resumeExecution() {}

  /**
                        * @LivePreview: Used to preview request (headers, body/query params)
                        *
                        * @param {Object} request
                        * @param {Object} options
                        *  cookiePartitionId,
                        *  implicitCacheControl,
                        *  implicitTraceHeader,
                        *  protocolProfileBehavior
                        */
  previewRequest() {}

  /**
                       * Check if the given path is within the working directory
                       * @param {String} path
                       * @returns {Boolean}
                       */
  isInWorkingDir() {return false;}


  /**
                                    * Post process file selection for platform and agent compatibility
                                    *
                                    * @param {FileList} files A list of files returned from file selection
                                    * @param {processFileCallback} cb
                                    *
                                    * @callback processFileCallback Callback for
                                    * @param {Error} err
                                    * @param {Array} processedFiles
                                    */
  processFiles(_, cb) {return cb(null, _);}

  /**
                                             * Read contents of a file
                                             * @param {String|File} path
                                             * @param {readFileCallback} cb
                                             *
                                             * @callback readFileCallback Callback for
                                             * @param {Error} err
                                             * @param {String} content The content of the file after decoding as string
                                             */
  readFile(_, cb) {return cb(null, '');}

  /**
                                          * Check if the given file path is accessible
                                          * @param {String} path - Path to a directory or file (absolute or relative to working directory)
                                          * @param {Boolean} writeable - Should the access be writable
                                          * @param {pathAccessibleCallback} cb
                                          *
                                          * @callback pathAccessibleCallback
                                          * @param {Error} err - Error if file is not accessible
                                          */
  pathAccessible(_, __, cb) {return cb();}

  /**
                                            * Get the visualizer style content
                                            *
                                            * @param {getVisualizerStyleCallback} cb
                                            *
                                            * @callback getVisualizerStyleCallback
                                            * @param {Error} err
                                            * @param {String} content
                                            */
  getVisualizerStyle(cb) {return cb(null, '');}

  /**
                                                 * Get the preview source for visualizer/response preview
                                                 *
                                                 * @param {String} template
                                                 * @param {Object} options
                                                 * @param {String} options.fileExtension
                                                 * @param {String} options.mediaType
                                                 * @param {getPreviewFileCallback} cb
                                                 *
                                                 * @callback getPreviewFileCallback
                                                 * @param {Error} err
                                                 * @param {Object} template
                                                 * @param {('src'|'srcDoc')} template.type
                                                 * @param {String} template.value
                                                 */
  getPreviewFile(_, __, cb) {return cb(null, { type: 'src', value: '' });}

  /**
                                                                            * Used to query cookie manager
                                                                            *
                                                                            * @param {String} method - CookieManager method name
                                                                            * @param {String} partitionId - Electron session's partition id
                                                                            * @param {Object} options - Arguments
                                                                            * @param {Function} cb
                                                                            */
  cookieHandler(_, __, ___, cb) {return cb();}

  /**
                                                * Used to Save Response Buffer to a File
                                                *
                                                * @param {Object} contentInfo
                                                * @param {Buffer} stream
                                                * @param {Function} cb
                                                */
  saveResponseToFile(_, __, cb) {return cb();}};


/**
                                                  * Class representing Runtime behind IPC transport
                                                  * @class
                                                  * @implements {AgentInterface}
                                                  */
let IPCAgent = class IPCAgent extends AgentInterface {


  constructor(publish) {
    super();this.type = _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["TYPES"].IPC;

    this.ipc = __webpack_require__(62).ipcRenderer; // eslint-disable-line import/no-unresolved, global-require

    // Attach the general respond back channel
    this.ipc.on('runtime-ipc-event', (ev, message) => {publish(message);});

    Object(mobx__WEBPACK_IMPORTED_MODULE_4__["transaction"])(() => {
      this.setConnectionState(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["STATES"].CONNECTED);
      this.setHealth(true);
    });
  }

  $emit(event) {
    this.ipc.send('runtime-ipc-command', event);
  }

  $fn(event, fn, args, cb) {
    this.ipc.invoke('runtime-ipc-cb', event, fn, args).
    then(result => cb(...result)).
    catch(err => cb(err));
  }

  /**
     * @override
     */
  executeCollection(info, collection, variables, options) {
    this.$emit(Object(_js_modules_model_event__WEBPACK_IMPORTED_MODULE_8__["createEvent"])('execute', 'collection', {
      info,
      collection,
      variables,
      options }));

  }

  /**
     * @override
     */
  terminateExecution(criteria) {
    this.$emit(Object(_js_modules_model_event__WEBPACK_IMPORTED_MODULE_8__["createEvent"])('terminate', 'execution', {
      execution: criteria.id }));

  }

  /**
     * @override
     */
  pauseExecution(criteria) {
    this.$emit(Object(_js_modules_model_event__WEBPACK_IMPORTED_MODULE_8__["createEvent"])('pause', 'execution', {
      execution: criteria.id }));

  }

  /**
     * @override
     */
  resumeExecution(criteria) {
    this.$emit(Object(_js_modules_model_event__WEBPACK_IMPORTED_MODULE_8__["createEvent"])('resume', 'execution', {
      execution: criteria.id }));

  }

  /**
     * @override
     */
  previewRequest(request, options, cb) {
    this.$fn('runtime', 'previewRequest', [request, options], cb);
  }

  /**
     * @override
     */
  isInWorkingDir(path) {
    return this.ipc.sendSync(
    'postman-runtime-ipc-sync',
    'isInWorkingDir',
    [Object(_js_utils_FsHelper__WEBPACK_IMPORTED_MODULE_6__["getWorkingDir"])(), path]);

  }

  /**
     * @override
     */
  processFiles(files, cb = _.noop) {
    if (!files || _.isEmpty(files)) {
      return cb(null, files);
    }

    return cb(null, processFiles(files));
  }

  /**
     * @private
     *
     * Create a temporary file in the filesystem
     *
     * @param {String} name - Name of the file to be generated
     * @param {String} content - Content of the file
     * @param {createTemporaryFileCallback} cb - Callback function to be called on temp file creation
     *
     * @callback createTemporaryFileCallback Callback for
     * @param {Error} err
     * @param {String} tempFilepath - Path of the temporary file
     */
  $createTemporaryFile(name, content, cb) {
    this.$fn('files', 'create-temp', [name, content], cb);
  }

  /**
     * @override
     */
  readFile(path, cb) {
    // If path is an instance of file then extract the path from it
    if (path instanceof File) {
      path = path.path; // eslint-disable-line no-param-reassign
    }

    const postmanFs = new _js_common_utils_postmanFs__WEBPACK_IMPORTED_MODULE_12___default.a(Object(_js_utils_FsHelper__WEBPACK_IMPORTED_MODULE_6__["getWorkingDir"])()),

    // Convert relative path to absolute if required
    absolutePath = postmanFs._resolve(path, true);

    this.$fn('files', 'read', [absolutePath], cb);
  }

  /**
     * @override
     */
  pathAccessible(filePath, writeable, cb) {
    // If no path is given then there is nothing to check
    if (!filePath) {
      return cb();
    }

    const postmanFs = new _js_common_utils_postmanFs__WEBPACK_IMPORTED_MODULE_12___default.a(Object(_js_utils_FsHelper__WEBPACK_IMPORTED_MODULE_6__["getWorkingDir"])()),

    // Convert relative path to absolute
    absolutePath = postmanFs._resolve(filePath, true);

    this.$fn('files', 'access', [absolutePath, writeable], cb);
  }

  /**
     * @override
     */
  getVisualizerStyle(cb) {
    const stylesPath = path__WEBPACK_IMPORTED_MODULE_3___default.a.join(pm.app.get('visualizerLibrariesPath'), 'vendor.min.css');

    this.readFile(stylesPath, (err, result) => {
      const style = result && `<style type="text/css">${result}</style>`;

      cb(err, style);
    });
  }

  /**
     * @override
     */
  getPreviewFile(template, options = {}, cb) {
    const ext = options.fileExtension || 'html';

    this.$createTemporaryFile(`${shortid__WEBPACK_IMPORTED_MODULE_0___default.a.generate()}.${ext}`, template, (err, result) => {
      cb(err, result && {
        type: 'src',
        value: `file://${result}` });

    });
  }

  /**
     * @override
     */
  cookieHandler(method, partitionId, options, cb) {
    this.$fn('cookie', method, [partitionId, options], cb);
  }

  /**
     * @override
     */
  saveResponseToFile(contentInfo, stream, cb) {
    this.$fn('files', 'saveResponse', [contentInfo, stream], cb);
  }};


/**
       * Class representing Runtime behind Websocket transport
       * @class
       * @implements {AgentInterface}
       * @implements {Connection}
       */
let WebsocketAgent = class WebsocketAgent extends AgentInterface {


  constructor(publish) {
    super();

    // Note: extraEncryption will have no effect if remoteVerification is false
    this.type = _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["TYPES"].WS;this.opts = {
      handshakePath: `${window.postman_runtime_agent_service_url}/handshake/create`,
      remoteVerification: true,
      extraEncryption: false,
      port: window.postman_runtime_agent_port,
      autoConnect: true,
      healthCheckTimeout: 1000 };


    this.ioOptions = {
      reconnectionAttempts: 5,
      reconnectionDelayMax: 5000, // 10s
      timeout: 10000, // 10s
      transports: ['websocket'] };


    this.publish = publish;
    this.isWeb = window.SDK_PLATFORM === 'browser';

    this.socket = null;
    this.isReconnecting = false;
  }

  /**
     * Method of perform a health check to check of availability of the agent
     */
  async checkHealth() {
    // If the state is already connected then no need for a health check we can mark isHealthy to true
    if (this.state === _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["STATES"].CONNECTED) {
      // If health is not already set to true then set it to true
      !this.health && this.setHealth(true);

      return;
    }

    const aborter = new AbortController(),
    timeout = setTimeout(() => {aborter.abort();}, this.opts.healthCheckTimeout);

    return fetch(`http://localhost:${this.opts.port}/knockknock`, { signal: aborter.signal }).
    then(() => {
      clearTimeout(timeout);

      // If auto-connect is set to true and this agent is the selected one then fire connect
      // to automatically connect the agent
      if (this.health === false && this.selected && this.opts.autoConnect) {
        this.connect();
      }

      this.setHealth(true);
    }).
    catch(() => {
      clearTimeout(timeout);

      this.setHealth(false);
    });
  }

  /**
     * Connect to the websocket agent
     */
  connect() {
    // If the state is already in a connecting state then don't go forward
    if (this.state === _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["STATES"].CONNECTING) {
      return;
    }

    // If the socket is present and it is connected or isReconnecting then just bail out as-well
    if (this.socket && (this.socket.connected || this.isReconnecting)) {
      return;
    }

    // We are now attempting to connect/reconnect to the server
    this.setConnectionState(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["STATES"].CONNECTING);

    async__WEBPACK_IMPORTED_MODULE_1___default.a.waterfall([
    // Initiate remote verification if configured
    next => {
      if (!this.opts.remoteVerification) {
        return next(null, null);
      }

      // Remote Verification is turned-on hence we go the full way
      fetch(this.opts.handshakePath, { credentials: 'include' }).
      then(response => {
        if (response.status !== 200) {
          return Promise.reject(new Error(`Runtime agent verification failed to initiate. Got status code ${response.status}`));
        }

        return response.json();
      }).
      then(data => {
        this.encryption = {/* TODO: Set encryption key here */};

        return fetch(`http://localhost:${this.opts.port}/handshake`, {
          headers: {
            'x-access-token': data.token } });


      }).
      then(response => {
        if (response.status !== 200) {
          return Promise.reject(new Error(`Runtime agent verification failed to complete. Got status code ${response.status}`));
        }

        return response.json();
      }).
      then(({ id }) => {next(null, id);}).
      catch(err => {
        this.setConnectionState(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["STATES"].DISCONNECTED);

        pm.logger.error('AgentManager~connect: Agent handshake failed', err);

        return next(err);
      });
    },

    // Establish the websocket connection
    (id, next) => {
      this.socket = socket_io_client__WEBPACK_IMPORTED_MODULE_2___default()(`http://localhost:${this.opts.port}`, _extends({},
      this.ioOptions, {
        path: '/agent',
        query: {
          token: id } }));



      this.socket.on('runtime', this.publish || _.noop);

      this.socket.on('connect', () => {
        this.setConnectionState(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["STATES"].CONNECTED);
        this.isReconnecting = false; // It connected, reset the reconnecting state

        pm.logger.info('AgentManager~connect : Connected to websocket agent');
      });

      // Sad cases handling here
      this.socket.on('disconnect', reason => {
        pm.logger.warn('AgentManager~connect: Disconnected from websocket agent. reason=', reason);

        // There are primarily 3 reasons why disconnect happens
        // 1. transport close - the server crashed
        // 2. io server disconnect - the server explicitly closed the connection
        // 3. io client disconnect - the client explicitly closed the connection
        // The client will only attempt to reconnect in the case of transport close and no other case
        this.setConnectionState(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["STATES"].DISCONNECTED);

        // This.isReconnecting = false;
      });

      // Fired upon a connection error
      this.socket.on('connect_error', err => {
        // There can be a connection error if the server is not reachable or the handshake failed
        // We will try not to continue to attempt reconnection if its not network problem
        // FIXME: This flow might be hit in reconnection flow as well hence auto reconnection using
        // socket.io is not going to work more than 1 attempt for this case
        if (_.get(err, 'description.error.code') !== 'ECONNREFUSED') {
          this.socket.disconnect();
          this.setConnectionState(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["STATES"].DISCONNECTED);
          this.isReconnecting = false;
        }
      });

      // Fired upon an attempt to reconnect.
      this.socket.on('reconnecting', attempt => {
        this.setConnectionState(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["STATES"].CONNECTING);
        this.isReconnecting = true;
        pm.logger.info('AgentManager~connect: Reconnecting to websocket agent. attempt=', attempt);
      });

      // Fired when couldn’t reconnect within reconnectionAttempts.
      this.socket.on('reconnect_failed', () => {
        this.setConnectionState(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["STATES"].DISCONNECTED);
        this.isReconnecting = false;

        pm.logger.warn('AgentManager~connect: Reconnection failed from websocket agent. reason=', reason);
      });

      return next();
    }]);

  }

  /**
     * @override
     */
  select() {
    super.select();

    // Trigger a connect in case connection has not been established
    this.connect();
  }

  /**
     * @private
     *
     * Send an event to runtime over the network transport
     *
     * @param {String} event
     * @param {Object} message
     */
  $emit(event, message) {
    if (!this.socket || !this.socket.connected) {
      return false;
    }

    this.socket.emit(event, message);

    return true;
  }

  /**
     * @private
     *
     * Call an Remote function over the network
     *
     * @param {String} event - The channel of fn
     * @param {String} fn - Name of the remote function to call
     * @param {Array} args - Array of arguments for the remote function
     * @param {*} cb - The callback function to bind to the remote function
     */
  $fn(event, fn, args, cb) {
    if (!this.socket || !this.socket.connected) {
      // @todo: Handle what happens when connection is no available
      return cb(new Error('Connection Error'));
    }

    this.socket.emit(event, fn, args, cb);
  }

  /**
     * @private
     *
     * Upload contents of a file to the working directory
     *
     * @param {String} path - The path the file to upload in working directory
     * @param {File} data - The reference to the file object or content to write
     * @param {Function} cb - The callback to be called when done
     */
  $upload(path, data, cb) {
    if (!this.socket || !this.socket.connected) {
      // @todo: Handle what happens when connection is no available
      return cb(new Error('Connection Error'));
    }

    this.socket.binary(true).emit('uploads', Object(_js_utils_FsHelper__WEBPACK_IMPORTED_MODULE_6__["getWorkingDir"])(), path, data, cb);
  }

  /**
     * @override
     *
     * @note Executing a collection over the ws socket agent introduces a new state
     * where the connection is not yet established or disconnected, in such a condition
     * we are emitting a fake terminated event so that UI can respond accordingly and not
     * get stuck waiting for a finish. It also by-passes history creation
     */
  executeCollection(info, collection, variables, options) {
    this.$emit('runtime', Object(_js_modules_model_event__WEBPACK_IMPORTED_MODULE_8__["createEvent"])('execute', 'collection', {
      info,
      collection,
      variables,
      options }));

  }

  /**
     * @override
     */
  terminateExecution(criteria) {
    this.$emit('runtime', Object(_js_modules_model_event__WEBPACK_IMPORTED_MODULE_8__["createEvent"])('terminate', 'execution', {
      execution: criteria.id }));

  }

  /**
     * @override
     */
  pauseExecution(criteria) {
    this.$emit('runtime', Object(_js_modules_model_event__WEBPACK_IMPORTED_MODULE_8__["createEvent"])('pause', 'execution', {
      execution: criteria.id }));

  }

  /**
     * @override
     */
  resumeExecution(criteria) {
    this.$emit('runtime', Object(_js_modules_model_event__WEBPACK_IMPORTED_MODULE_8__["createEvent"])('resume', 'execution', {
      execution: criteria.id }));

  }

  /**
     * @override
     */
  previewRequest(request, options, cb) {
    this.$fn('runtime-fn', 'previewRequest', [request, options], cb);
  }

  /**
     * @override
     * @note IMPORTANT: Checking if the given path is in the working directory cannot be
     * done with the websocket agent at the moment because of the synchronous API.
     * Hence we always return true for any kind of path.
     * TODO: Convert working directory checks to be asynchronous with bulk API checks
     */
  isInWorkingDir() {
    return true;
  }

  /**
     * @override
     * Process or Upload file to working directory
     *
     * @param {Array} files
     * @param {Function} cb
     *
     * @note For running on web-platform we upload the contents of the file to the
     * working directory
     */
  processFiles(files, cb = _.noop) {
    if (!files || _.isEmpty(files)) {
      return cb(null, files);
    }

    // If its not the web platform them process files the traditional way
    if (!this.isWeb) {
      return cb(null, processFiles(files));
    }

    const iden = shortid__WEBPACK_IMPORTED_MODULE_0___default.a.generate();

    async__WEBPACK_IMPORTED_MODULE_1___default.a.map(files, (file, done) => {
      // If the file in not an instance of File then it already has been
      // processes, there is not much to do here
      if (!(file instanceof File)) {
        return done(null, file);
      }

      const path = [iden, file.name].join('/');

      // Upload the file to the working directory, we will not have an actual path here ever
      this.$upload(path, file, err => {
        if (err) {return done(err, {});}

        return done(null, {
          name: file.name,
          type: file.type,
          actual: null,
          path });

      });
    }, cb);
  }

  /**
     * @override
     */
  readFile(path, cb) {
    // If the path is not an instance of File then read through agent
    if (!(path instanceof File)) {
      return this.$fn('files', 'read', [path], cb);
    }

    const reader = new FileReader();

    reader.onload = () => {
      cb(null, reader.result);
    };

    reader.onerror = () => {
      cb(reader.error);
    };

    return reader.readAsText(path);
  }

  /**
     * @override
     */
  pathAccessible(path, writeable, cb) {
    // If no path is given then there is nothing to check
    if (!path) {
      return cb();
    }

    this.$fn('files', 'access', [path, writeable], cb);
  }

  /**
     * @override
     */
  getVisualizerStyle(cb) {
    // Here again we are bi-roads.
    // If app, fetch from file system
    if (!this.isWeb) {
      const stylesPath = path__WEBPACK_IMPORTED_MODULE_3___default.a.join(pm.app.get('visualizerLibrariesPath'), 'vendor.min.css');

      return this.readFile(stylesPath, (err, result) => {
        const style = result && `<style type="text/css">${result}</style>`;

        cb(err, style);
      });
    }

    // If web, fetch from CDN
    return cb(null, `<link rel="stylesheet" href="${_constants_VisualizerConstants__WEBPACK_IMPORTED_MODULE_11__["SKELETON_CSS_URL"]}"></link>`);
  }

  /**
     * @override
     */
  getPreviewFile(template, options = {}, cb) {
    const mediaType = options.mediaType || 'text/html';

    // Use data URI for media preview
    if (mediaType !== 'text/html') {
      const encodedTemplate = `data:${mediaType};base64,${base64Encode(template)}`;

      return cb(null, {
        type: 'src',
        value: encodedTemplate });

    }

    // Just return the preview as srcDoc
    cb(null, {
      type: 'srcDoc',
      value: template });

  }

  /**
     * @override
     */
  cookieHandler(method, partitionId, options, cb) {
    this.$fn('cookie', method, [partitionId, options], cb);
  }

  /**
     * @override
     */
  saveResponseToFile(contentInfo, stream, cb) {
    this.$fn('files', 'saveResponse', [contentInfo, stream], cb);
  }};


/**
       * Class representing Runtime with XHR
       * @class
       * @implements {AgentInterface}
       */
let XHRAgent = class XHRAgent extends AgentInterface {











  constructor(publish) {
    super();this.type = _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["TYPES"].XHR;this.initialized = false;this._fileReferences = new Map();

    this.$emit = publish;

    this.setHealth(true);
  }

  /**
     * @override
     * @returns {Promise}
     */ /**
         * Map to locally store path to File reference.
         *
         * @private
         */async select() {super.select();if (this.initialized) {return;}

    // Set the agent to have been initialized so as not to re-initialize on subsequent selects
    this.initialized = true;

    // Create the instance of runtime the very first time XHR agent is selected
    this.runtime = await Object(_js_common_services_RuntimeExecutionService__WEBPACK_IMPORTED_MODULE_9__["Browser"])();

    // Set the connection to connected. At this point we are ready for sending request
    this.setConnectionState(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["STATES"].CONNECTED);
  }

  /**
     * @override
     */
  executeCollection(info, collection, variables, options) {
    options.fileResolver = this.$fileResolver(); // Attach file resolver
    this.runtime.startRun(info, collection, variables, options, this.$emit);
  }

  /**
     * @override
     */
  terminateExecution(criteria) {
    this.runtime.stopRun(criteria.id, this.$emit);
  }

  /**
     * @override
     */
  pauseExecution(criteria) {
    this.runtime.pauseRun(criteria.id, this.$emit);
  }

  /**
     * @override
     */
  resumeExecution(criteria) {
    this.runtime.resumeRun(criteria.id, this.$emit);
  }

  /**
     * @override
     */
  previewRequest(request, _, cb) {
    this.runtime.previewRequest(request, {}, cb);
  }

  isInWorkingDir(path) {
    return this._fileReferences.has(path);
  }

  /**
     * @override
     */
  processFiles(files, cb) {
    if (!files || _.isEmpty(files)) {
      return cb(null, files);
    }

    const iden = shortid__WEBPACK_IMPORTED_MODULE_0___default.a.generate();

    async__WEBPACK_IMPORTED_MODULE_1___default.a.map(files, (file, done) => {
      // If the file in not an instance of File then it already has been
      // processes, there is not much to do here
      if (!(file instanceof File)) {
        return done(null, file);
      }

      const path = [iden, file.name].join('/');

      this._fileReferences.set(path, file);

      done(null, {
        name: file.name,
        type: file.type,
        actual: null,
        path });

    }, cb);
  }

  /**
     * @override
     */
  readFile(path, cb) {
    if (!(path instanceof File)) {
      // Check if we have the fileReference in the localmap
      if (!this._fileReferences.has(path)) {
        return cb();
      }

      // Replace the path with the fileReference
      path = this._fileReferences.get(path);
    }

    const reader = new FileReader();

    reader.onload = () => {
      cb(null, reader.result);
    };

    reader.onerror = () => {
      cb(reader.error);
    };

    return reader.readAsText(path);
  }

  /**
     * @override
     */
  pathAccessible(path, writeable, cb) {
    // TODO: Cannot check this we will assume that it is accessible by default or not
    cb(null);
  }

  /**
     * @override
     */
  getVisualizerStyle(cb) {
    // Fetch from CDN
    return cb(null, `<link rel="stylesheet" href="${_constants_VisualizerConstants__WEBPACK_IMPORTED_MODULE_11__["SKELETON_CSS_URL"]}"></link>`);
  }

  /**
     * @override
     */
  getPreviewFile(template, options = {}, cb) {
    const mediaType = options.mediaType || 'text/html';

    // Use data URI for media preview
    if (mediaType !== 'text/html') {
      const encodedTemplate = `data:${mediaType};base64,${base64Encode(template)}`;

      return cb(null, {
        type: 'src',
        value: encodedTemplate });

    }

    // Just return the preview as srcDoc
    cb(null, {
      type: 'srcDoc',
      value: template });

  }

  /**
     * `fs` like file resolver for XHR agent.
     *
     * @private
     */
  $fileResolver() {
    const fileReferences = this._fileReferences;

    return {
      stat(path, cb) {
        if (!fileReferences.has(path)) {
          const error = new Error(`ENOENT: no such file or directory, stat '${path}'`);

          error.code = 'ENOENT';
          error.path = path;

          return cb(error);
        }

        cb(null, {
          mode: 33060 // 444
        });
      },
      createReadStream(path) {
        return fileReferences.get(path);
      } };

  }

  /**
     * @override
     */
  saveResponseToFile(contentInfo, stream, cb) {
    this.runtime.saveStreamToFile(contentInfo, stream, cb);
  }};


// Create a name to constructor map
const AGENTS = new Map([
[_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["TYPES"].IPC, IPCAgent],
[_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["TYPES"].WS, WebsocketAgent],
[_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["TYPES"].XHR, XHRAgent]]);


let AgentManager = (_class7 = class AgentManager extends eventemitter3__WEBPACK_IMPORTED_MODULE_5___default.a {



  constructor() {
    super();

    // Create a storage for storing all initialized agents
    _initDefineProp(this, 'agent', _descriptor3, this);this._agents = new Map([]);
    this._healthCheck = {
      shortInterval: 5000, // 5 seconds
      longInterval: 30000 // 30 seconds
    };

    // If this is not the browser platform then we only use the IPC agent
    if (window.SDK_PLATFORM !== 'browser') {
      return this.switchAgent(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["TYPES"].IPC);
    }

    // Construct the xhr and websocket agents as the available agents
    this._agents.set(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["TYPES"].XHR, new (AGENTS.get(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["TYPES"].XHR))(this.publish.bind(this)));
    this._agents.set(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["TYPES"].WS, new (AGENTS.get(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["TYPES"].WS))(this.publish.bind(this)));

    // Otherwise the game beings, depending on the settings
    const type = _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["SETTING_TO_TYPE_MAP"][pm.settings.getSetting(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["SETTING_KEY"])];

    // Switch to the agent depending on the setting immediately
    this.switchAgent(type);

    // Finally we will listen to the setting changing
    pm.settings.on(`setSetting:${_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["SETTING_KEY"]}`, key => {
      this.switchAgent(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["SETTING_TO_TYPE_MAP"][key]);
    });

    // Start the websocket health checks
    this._checkWSHealth();
  }

  async _checkWSHealth() {
    // If agent does not have a ws agent then bail out
    if (!this._agents.has(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["TYPES"].WS)) {return;}

    // Perform health check on the websocket agent
    await this._agents.get(_constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["TYPES"].WS).checkHealth();

    setTimeout(
    () => {this._checkWSHealth();},

    // If the current agent type is WS and agent is not healthy then use a shorter interval
    this.agent.type === _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["TYPES"].WS && !this.agent.health ?
    this._healthCheck.shortInterval :
    this._healthCheck.longInterval);

  }


  switchAgent(type) {
    // If the agent friendly type does not include this type error out
    if (!AGENTS.has(type)) {
      pm.logger.error(`AgentManager~switchAgent - Cannot switch to unknown agent ${type}`);

      return;
    }

    if (window.SDK_PLATFORM === 'browser' && type === _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["TYPES"].IPC) {
      pm.logger.error(`AgentManager~switchAgent - Cannot switch to ${type} agent on browser platform`);

      return;
    }

    // Trigger the deselect hook on the existing agent
    this.agent.deselect();

    // Change or Create the next agent
    if (this._agents.has(type)) {
      // If the agent map already has the agent initialized then use that
      this.agent = this._agents.get(type);
    } else {
      // If we do not have the agent initialized yet, we initialize it
      this.agent = new (AGENTS.get(type))(this.publish.bind(this));

      // And the agent to list of initialized agents
      this._agents.set(type, this.agent);
    }

    // Trigger the agent select hook
    this.agent.select();

    this.emit('change', this.agent);
  }

  /**
     * Subscribe to events emitted by runtime agent
     * @param {Function} fn Listeners function for events emitted by the runtime agents
     */
  publish(message) {
    // We are going to emit this as standard event as well
    this.emit('events', message);

    // Note: This should be the only place in the entire app where messages
    // are published to `postman-runtime` channel.
    // Currently the `RuntimeVariableUpdatesListener` and `ModelEventToUIEventService`
    // are using this in the share process to update session variables and for lessons respectively
    // TODO: Remove these usages by establish a contract with lessons
    // pm.eventBus.channel('postman-runtime').publish(message);
  }


  get type() {
    return this.agent.type;
  }


  get isAvailable() {
    return this.agent.health;
  }


  get stat() {
    return {
      state: this.agent.state,
      type: this.agent.type,
      health: this.agent.health };

  }


  get isReady() {
    // The agent is ready when its healthy and state is connected
    return this.agent.health && this.agent.state === _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_10__["STATES"].CONNECTED;
  }}, (_descriptor3 = _applyDecoratedDescriptor(_class7.prototype, 'agent', [mobx__WEBPACK_IMPORTED_MODULE_4__["observable"]], { enumerable: true, initializer: function () {return new AgentInterface();} }), _applyDecoratedDescriptor(_class7.prototype, 'switchAgent', [mobx__WEBPACK_IMPORTED_MODULE_4__["action"]], Object.getOwnPropertyDescriptor(_class7.prototype, 'switchAgent'), _class7.prototype), _applyDecoratedDescriptor(_class7.prototype, 'type', [mobx__WEBPACK_IMPORTED_MODULE_4__["computed"]], Object.getOwnPropertyDescriptor(_class7.prototype, 'type'), _class7.prototype), _applyDecoratedDescriptor(_class7.prototype, 'isAvailable', [mobx__WEBPACK_IMPORTED_MODULE_4__["computed"]], Object.getOwnPropertyDescriptor(_class7.prototype, 'isAvailable'), _class7.prototype), _applyDecoratedDescriptor(_class7.prototype, 'stat', [mobx__WEBPACK_IMPORTED_MODULE_4__["computed"]], Object.getOwnPropertyDescriptor(_class7.prototype, 'stat'), _class7.prototype), _applyDecoratedDescriptor(_class7.prototype, 'isReady', [mobx__WEBPACK_IMPORTED_MODULE_4__["computed"]], Object.getOwnPropertyDescriptor(_class7.prototype, 'isReady'), _class7.prototype)), _class7);


/**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           * A booting interface for the Agent manager
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           * @param {Function} done
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           */
/* harmony default export */ __webpack_exports__["default"] = (function (done) {
  // Create a new manager and keep it within this scope
  const manager = new AgentManager();

  // Setup the pm.runtime with an agent property which is both
  // observable and event-emitter
  pm.runtime = new Proxy({}, {
    get(target, prop) {
      if (prop === 'agent') {
        return manager;
      }

      return manager.agent[prop];
    } });


  return done && done();
});
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61), __webpack_require__(19)))

/***/ }),

/***/ 5628:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

module.exports = __webpack_require__(5629);


/***/ }),

/***/ 5629:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var alphabet = __webpack_require__(5630);
var build = __webpack_require__(5632);
var isValid = __webpack_require__(5636);

// if you are using cluster or multiple servers use this to make each instance
// has a unique value for worker
// Note: I don't know if this is automatically set when using third
// party cluster solutions such as pm2.
var clusterWorkerId = __webpack_require__(5637) || 0;

/**
 * Set the seed.
 * Highly recommended if you don't want people to try to figure out your id schema.
 * exposed as shortid.seed(int)
 * @param seed Integer value to seed the random alphabet.  ALWAYS USE THE SAME SEED or you might get overlaps.
 */
function seed(seedValue) {
    alphabet.seed(seedValue);
    return module.exports;
}

/**
 * Set the cluster worker or machine id
 * exposed as shortid.worker(int)
 * @param workerId worker must be positive integer.  Number less than 16 is recommended.
 * returns shortid module so it can be chained.
 */
function worker(workerId) {
    clusterWorkerId = workerId;
    return module.exports;
}

/**
 *
 * sets new characters to use in the alphabet
 * returns the shuffled alphabet
 */
function characters(newCharacters) {
    if (newCharacters !== undefined) {
        alphabet.characters(newCharacters);
    }

    return alphabet.shuffled();
}

/**
 * Generate unique id
 * Returns string id
 */
function generate() {
  return build(clusterWorkerId);
}

// Export all other functions as properties of the generate function
module.exports = generate;
module.exports.generate = generate;
module.exports.seed = seed;
module.exports.worker = worker;
module.exports.characters = characters;
module.exports.isValid = isValid;


/***/ }),

/***/ 5630:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var randomFromSeed = __webpack_require__(5631);

var ORIGINAL = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_-';
var alphabet;
var previousSeed;

var shuffled;

function reset() {
    shuffled = false;
}

function setCharacters(_alphabet_) {
    if (!_alphabet_) {
        if (alphabet !== ORIGINAL) {
            alphabet = ORIGINAL;
            reset();
        }
        return;
    }

    if (_alphabet_ === alphabet) {
        return;
    }

    if (_alphabet_.length !== ORIGINAL.length) {
        throw new Error('Custom alphabet for shortid must be ' + ORIGINAL.length + ' unique characters. You submitted ' + _alphabet_.length + ' characters: ' + _alphabet_);
    }

    var unique = _alphabet_.split('').filter(function(item, ind, arr){
       return ind !== arr.lastIndexOf(item);
    });

    if (unique.length) {
        throw new Error('Custom alphabet for shortid must be ' + ORIGINAL.length + ' unique characters. These characters were not unique: ' + unique.join(', '));
    }

    alphabet = _alphabet_;
    reset();
}

function characters(_alphabet_) {
    setCharacters(_alphabet_);
    return alphabet;
}

function setSeed(seed) {
    randomFromSeed.seed(seed);
    if (previousSeed !== seed) {
        reset();
        previousSeed = seed;
    }
}

function shuffle() {
    if (!alphabet) {
        setCharacters(ORIGINAL);
    }

    var sourceArray = alphabet.split('');
    var targetArray = [];
    var r = randomFromSeed.nextValue();
    var characterIndex;

    while (sourceArray.length > 0) {
        r = randomFromSeed.nextValue();
        characterIndex = Math.floor(r * sourceArray.length);
        targetArray.push(sourceArray.splice(characterIndex, 1)[0]);
    }
    return targetArray.join('');
}

function getShuffled() {
    if (shuffled) {
        return shuffled;
    }
    shuffled = shuffle();
    return shuffled;
}

/**
 * lookup shuffled letter
 * @param index
 * @returns {string}
 */
function lookup(index) {
    var alphabetShuffled = getShuffled();
    return alphabetShuffled[index];
}

function get () {
  return alphabet || ORIGINAL;
}

module.exports = {
    get: get,
    characters: characters,
    seed: setSeed,
    lookup: lookup,
    shuffled: getShuffled
};


/***/ }),

/***/ 5631:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


// Found this seed-based random generator somewhere
// Based on The Central Randomizer 1.3 (C) 1997 by Paul Houle (houle@msc.cornell.edu)

var seed = 1;

/**
 * return a random number based on a seed
 * @param seed
 * @returns {number}
 */
function getNextValue() {
    seed = (seed * 9301 + 49297) % 233280;
    return seed/(233280.0);
}

function setSeed(_seed_) {
    seed = _seed_;
}

module.exports = {
    nextValue: getNextValue,
    seed: setSeed
};


/***/ }),

/***/ 5632:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var generate = __webpack_require__(5633);
var alphabet = __webpack_require__(5630);

// Ignore all milliseconds before a certain time to reduce the size of the date entropy without sacrificing uniqueness.
// This number should be updated every year or so to keep the generated id short.
// To regenerate `new Date() - 0` and bump the version. Always bump the version!
var REDUCE_TIME = 1567752802062;

// don't change unless we change the algos or REDUCE_TIME
// must be an integer and less than 16
var version = 7;

// Counter is used when shortid is called multiple times in one second.
var counter;

// Remember the last time shortid was called in case counter is needed.
var previousSeconds;

/**
 * Generate unique id
 * Returns string id
 */
function build(clusterWorkerId) {
    var str = '';

    var seconds = Math.floor((Date.now() - REDUCE_TIME) * 0.001);

    if (seconds === previousSeconds) {
        counter++;
    } else {
        counter = 0;
        previousSeconds = seconds;
    }

    str = str + generate(version);
    str = str + generate(clusterWorkerId);
    if (counter > 0) {
        str = str + generate(counter);
    }
    str = str + generate(seconds);
    return str;
}

module.exports = build;


/***/ }),

/***/ 5633:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var alphabet = __webpack_require__(5630);
var random = __webpack_require__(5634);
var format = __webpack_require__(5635);

function generate(number) {
    var loopCounter = 0;
    var done;

    var str = '';

    while (!done) {
        str = str + format(random, alphabet.get(), 1);
        done = number < (Math.pow(16, loopCounter + 1 ) );
        loopCounter++;
    }
    return str;
}

module.exports = generate;


/***/ }),

/***/ 5634:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var crypto = typeof window === 'object' && (window.crypto || window.msCrypto); // IE 11 uses window.msCrypto

var randomByte;

if (!crypto || !crypto.getRandomValues) {
    randomByte = function(size) {
        var bytes = [];
        for (var i = 0; i < size; i++) {
            bytes.push(Math.floor(Math.random() * 256));
        }
        return bytes;
    };
} else {
    randomByte = function(size) {
        return crypto.getRandomValues(new Uint8Array(size));
    };
}

module.exports = randomByte;


/***/ }),

/***/ 5635:
/***/ (function(module, exports) {

// This file replaces `format.js` in bundlers like webpack or Rollup,
// according to `browser` config in `package.json`.

module.exports = function (random, alphabet, size) {
  // We can’t use bytes bigger than the alphabet. To make bytes values closer
  // to the alphabet, we apply bitmask on them. We look for the closest
  // `2 ** x - 1` number, which will be bigger than alphabet size. If we have
  // 30 symbols in the alphabet, we will take 31 (00011111).
  // We do not use faster Math.clz32, because it is not available in browsers.
  var mask = (2 << Math.log(alphabet.length - 1) / Math.LN2) - 1
  // Bitmask is not a perfect solution (in our example it will pass 31 bytes,
  // which is bigger than the alphabet). As a result, we will need more bytes,
  // than ID size, because we will refuse bytes bigger than the alphabet.

  // Every hardware random generator call is costly,
  // because we need to wait for entropy collection. This is why often it will
  // be faster to ask for few extra bytes in advance, to avoid additional calls.

  // Here we calculate how many random bytes should we call in advance.
  // It depends on ID length, mask / alphabet size and magic number 1.6
  // (which was selected according benchmarks).

  // -~f => Math.ceil(f) if n is float number
  // -~i => i + 1 if n is integer number
  var step = -~(1.6 * mask * size / alphabet.length)
  var id = ''

  while (true) {
    var bytes = random(step)
    // Compact alternative for `for (var i = 0; i < step; i++)`
    var i = step
    while (i--) {
      // If random byte is bigger than alphabet even after bitmask,
      // we refuse it by `|| ''`.
      id += alphabet[bytes[i] & mask] || ''
      // More compact than `id.length + 1 === size`
      if (id.length === +size) return id
    }
  }
}


/***/ }),

/***/ 5636:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var alphabet = __webpack_require__(5630);

function isShortId(id) {
    if (!id || typeof id !== 'string' || id.length < 6 ) {
        return false;
    }

    var nonAlphabetic = new RegExp('[^' +
      alphabet.get().replace(/[|\\{}()[\]^$+*?.-]/g, '\\$&') +
    ']');
    return !nonAlphabetic.test(id);
}

module.exports = isShortId;


/***/ }),

/***/ 5637:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = 0;


/***/ }),

/***/ 5638:
/***/ (function(module, exports, __webpack_require__) {


/**
 * Module dependencies.
 */

var url = __webpack_require__(5639);
var parser = __webpack_require__(5643);
var Manager = __webpack_require__(5651);
var debug = __webpack_require__(5641)('socket.io-client');

/**
 * Module exports.
 */

module.exports = exports = lookup;

/**
 * Managers cache.
 */

var cache = exports.managers = {};

/**
 * Looks up an existing `Manager` for multiplexing.
 * If the user summons:
 *
 *   `io('http://localhost/a');`
 *   `io('http://localhost/b');`
 *
 * We reuse the existing instance based on same scheme/port/host,
 * and we initialize sockets for each namespace.
 *
 * @api public
 */

function lookup (uri, opts) {
  if (typeof uri === 'object') {
    opts = uri;
    uri = undefined;
  }

  opts = opts || {};

  var parsed = url(uri);
  var source = parsed.source;
  var id = parsed.id;
  var path = parsed.path;
  var sameNamespace = cache[id] && path in cache[id].nsps;
  var newConnection = opts.forceNew || opts['force new connection'] ||
                      false === opts.multiplex || sameNamespace;

  var io;

  if (newConnection) {
    debug('ignoring socket cache for %s', source);
    io = Manager(source, opts);
  } else {
    if (!cache[id]) {
      debug('new io instance for %s', source);
      cache[id] = Manager(source, opts);
    }
    io = cache[id];
  }
  if (parsed.query && !opts.query) {
    opts.query = parsed.query;
  }
  return io.socket(parsed.path, opts);
}

/**
 * Protocol version.
 *
 * @api public
 */

exports.protocol = parser.protocol;

/**
 * `connect`.
 *
 * @param {String} uri
 * @api public
 */

exports.connect = lookup;

/**
 * Expose constructors for standalone build.
 *
 * @api public
 */

exports.Manager = __webpack_require__(5651);
exports.Socket = __webpack_require__(5677);


/***/ }),

/***/ 5639:
/***/ (function(module, exports, __webpack_require__) {


/**
 * Module dependencies.
 */

var parseuri = __webpack_require__(5640);
var debug = __webpack_require__(5641)('socket.io-client:url');

/**
 * Module exports.
 */

module.exports = url;

/**
 * URL parser.
 *
 * @param {String} url
 * @param {Object} An object meant to mimic window.location.
 *                 Defaults to window.location.
 * @api public
 */

function url (uri, loc) {
  var obj = uri;

  // default to window.location
  loc = loc || (typeof location !== 'undefined' && location);
  if (null == uri) uri = loc.protocol + '//' + loc.host;

  // relative path support
  if ('string' === typeof uri) {
    if ('/' === uri.charAt(0)) {
      if ('/' === uri.charAt(1)) {
        uri = loc.protocol + uri;
      } else {
        uri = loc.host + uri;
      }
    }

    if (!/^(https?|wss?):\/\//.test(uri)) {
      debug('protocol-less url %s', uri);
      if ('undefined' !== typeof loc) {
        uri = loc.protocol + '//' + uri;
      } else {
        uri = 'https://' + uri;
      }
    }

    // parse
    debug('parse %s', uri);
    obj = parseuri(uri);
  }

  // make sure we treat `localhost:80` and `localhost` equally
  if (!obj.port) {
    if (/^(http|ws)$/.test(obj.protocol)) {
      obj.port = '80';
    } else if (/^(http|ws)s$/.test(obj.protocol)) {
      obj.port = '443';
    }
  }

  obj.path = obj.path || '/';

  var ipv6 = obj.host.indexOf(':') !== -1;
  var host = ipv6 ? '[' + obj.host + ']' : obj.host;

  // define unique id
  obj.id = obj.protocol + '://' + host + ':' + obj.port;
  // define href
  obj.href = obj.protocol + '://' + host + (loc && loc.port === obj.port ? '' : (':' + obj.port));

  return obj;
}


/***/ }),

/***/ 5640:
/***/ (function(module, exports) {

/**
 * Parses an URI
 *
 * @author Steven Levithan <stevenlevithan.com> (MIT license)
 * @api private
 */

var re = /^(?:(?![^:@]+:[^:@\/]*@)(http|https|ws|wss):\/\/)?((?:(([^:@]*)(?::([^:@]*))?)?@)?((?:[a-f0-9]{0,4}:){2,7}[a-f0-9]{0,4}|[^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/;

var parts = [
    'source', 'protocol', 'authority', 'userInfo', 'user', 'password', 'host', 'port', 'relative', 'path', 'directory', 'file', 'query', 'anchor'
];

module.exports = function parseuri(str) {
    var src = str,
        b = str.indexOf('['),
        e = str.indexOf(']');

    if (b != -1 && e != -1) {
        str = str.substring(0, b) + str.substring(b, e).replace(/:/g, ';') + str.substring(e, str.length);
    }

    var m = re.exec(str || ''),
        uri = {},
        i = 14;

    while (i--) {
        uri[parts[i]] = m[i] || '';
    }

    if (b != -1 && e != -1) {
        uri.source = src;
        uri.host = uri.host.substring(1, uri.host.length - 1).replace(/;/g, ':');
        uri.authority = uri.authority.replace('[', '').replace(']', '').replace(/;/g, ':');
        uri.ipv6uri = true;
    }

    return uri;
};


/***/ }),

/***/ 5641:
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(process) {/* eslint-env browser */

/**
 * This is the web browser implementation of `debug()`.
 */

exports.log = log;
exports.formatArgs = formatArgs;
exports.save = save;
exports.load = load;
exports.useColors = useColors;
exports.storage = localstorage();

/**
 * Colors.
 */

exports.colors = [
	'#0000CC',
	'#0000FF',
	'#0033CC',
	'#0033FF',
	'#0066CC',
	'#0066FF',
	'#0099CC',
	'#0099FF',
	'#00CC00',
	'#00CC33',
	'#00CC66',
	'#00CC99',
	'#00CCCC',
	'#00CCFF',
	'#3300CC',
	'#3300FF',
	'#3333CC',
	'#3333FF',
	'#3366CC',
	'#3366FF',
	'#3399CC',
	'#3399FF',
	'#33CC00',
	'#33CC33',
	'#33CC66',
	'#33CC99',
	'#33CCCC',
	'#33CCFF',
	'#6600CC',
	'#6600FF',
	'#6633CC',
	'#6633FF',
	'#66CC00',
	'#66CC33',
	'#9900CC',
	'#9900FF',
	'#9933CC',
	'#9933FF',
	'#99CC00',
	'#99CC33',
	'#CC0000',
	'#CC0033',
	'#CC0066',
	'#CC0099',
	'#CC00CC',
	'#CC00FF',
	'#CC3300',
	'#CC3333',
	'#CC3366',
	'#CC3399',
	'#CC33CC',
	'#CC33FF',
	'#CC6600',
	'#CC6633',
	'#CC9900',
	'#CC9933',
	'#CCCC00',
	'#CCCC33',
	'#FF0000',
	'#FF0033',
	'#FF0066',
	'#FF0099',
	'#FF00CC',
	'#FF00FF',
	'#FF3300',
	'#FF3333',
	'#FF3366',
	'#FF3399',
	'#FF33CC',
	'#FF33FF',
	'#FF6600',
	'#FF6633',
	'#FF9900',
	'#FF9933',
	'#FFCC00',
	'#FFCC33'
];

/**
 * Currently only WebKit-based Web Inspectors, Firefox >= v31,
 * and the Firebug extension (any Firefox version) are known
 * to support "%c" CSS customizations.
 *
 * TODO: add a `localStorage` variable to explicitly enable/disable colors
 */

// eslint-disable-next-line complexity
function useColors() {
	// NB: In an Electron preload script, document will be defined but not fully
	// initialized. Since we know we're in Chrome, we'll just detect this case
	// explicitly
	if (typeof window !== 'undefined' && window.process && (window.process.type === 'renderer' || window.process.__nwjs)) {
		return true;
	}

	// Internet Explorer and Edge do not support colors.
	if (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
		return false;
	}

	// Is webkit? http://stackoverflow.com/a/16459606/376773
	// document is undefined in react-native: https://github.com/facebook/react-native/pull/1632
	return (typeof document !== 'undefined' && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance) ||
		// Is firebug? http://stackoverflow.com/a/398120/376773
		(typeof window !== 'undefined' && window.console && (window.console.firebug || (window.console.exception && window.console.table))) ||
		// Is firefox >= v31?
		// https://developer.mozilla.org/en-US/docs/Tools/Web_Console#Styling_messages
		(typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31) ||
		// Double check webkit in userAgent just in case we are in a worker
		(typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/));
}

/**
 * Colorize log arguments if enabled.
 *
 * @api public
 */

function formatArgs(args) {
	args[0] = (this.useColors ? '%c' : '') +
		this.namespace +
		(this.useColors ? ' %c' : ' ') +
		args[0] +
		(this.useColors ? '%c ' : ' ') +
		'+' + module.exports.humanize(this.diff);

	if (!this.useColors) {
		return;
	}

	const c = 'color: ' + this.color;
	args.splice(1, 0, c, 'color: inherit');

	// The final "%c" is somewhat tricky, because there could be other
	// arguments passed either before or after the %c, so we need to
	// figure out the correct index to insert the CSS into
	let index = 0;
	let lastC = 0;
	args[0].replace(/%[a-zA-Z%]/g, match => {
		if (match === '%%') {
			return;
		}
		index++;
		if (match === '%c') {
			// We only are interested in the *last* %c
			// (the user may have provided their own)
			lastC = index;
		}
	});

	args.splice(lastC, 0, c);
}

/**
 * Invokes `console.log()` when available.
 * No-op when `console.log` is not a "function".
 *
 * @api public
 */
function log(...args) {
	// This hackery is required for IE8/9, where
	// the `console.log` function doesn't have 'apply'
	return typeof console === 'object' &&
		console.log &&
		console.log(...args);
}

/**
 * Save `namespaces`.
 *
 * @param {String} namespaces
 * @api private
 */
function save(namespaces) {
	try {
		if (namespaces) {
			exports.storage.setItem('debug', namespaces);
		} else {
			exports.storage.removeItem('debug');
		}
	} catch (error) {
		// Swallow
		// XXX (@Qix-) should we be logging these?
	}
}

/**
 * Load `namespaces`.
 *
 * @return {String} returns the previously persisted debug modes
 * @api private
 */
function load() {
	let r;
	try {
		r = exports.storage.getItem('debug');
	} catch (error) {
		// Swallow
		// XXX (@Qix-) should we be logging these?
	}

	// If debug isn't set in LS, and we're in Electron, try to load $DEBUG
	if (!r && typeof process !== 'undefined' && 'env' in process) {
		r = process.env.DEBUG;
	}

	return r;
}

/**
 * Localstorage attempts to return the localstorage.
 *
 * This is necessary because safari throws
 * when a user disables cookies/localstorage
 * and you attempt to access it.
 *
 * @return {LocalStorage}
 * @api private
 */

function localstorage() {
	try {
		// TVMLKit (Apple TV JS Runtime) does not have a window object, just localStorage in the global context
		// The Browser also has localStorage in the global context.
		return localStorage;
	} catch (error) {
		// Swallow
		// XXX (@Qix-) should we be logging these?
	}
}

module.exports = __webpack_require__(5642)(exports);

const {formatters} = module.exports;

/**
 * Map %j to `JSON.stringify()`, since no Web Inspectors do that by default.
 */

formatters.j = function (v) {
	try {
		return JSON.stringify(v);
	} catch (error) {
		return '[UnexpectedJSONParseError]: ' + error.message;
	}
};

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(31)))

/***/ }),

/***/ 5642:
/***/ (function(module, exports, __webpack_require__) {


/**
 * This is the common logic for both the Node.js and web browser
 * implementations of `debug()`.
 */

function setup(env) {
	createDebug.debug = createDebug;
	createDebug.default = createDebug;
	createDebug.coerce = coerce;
	createDebug.disable = disable;
	createDebug.enable = enable;
	createDebug.enabled = enabled;
	createDebug.humanize = __webpack_require__(3743);

	Object.keys(env).forEach(key => {
		createDebug[key] = env[key];
	});

	/**
	* Active `debug` instances.
	*/
	createDebug.instances = [];

	/**
	* The currently active debug mode names, and names to skip.
	*/

	createDebug.names = [];
	createDebug.skips = [];

	/**
	* Map of special "%n" handling functions, for the debug "format" argument.
	*
	* Valid key names are a single, lower or upper-case letter, i.e. "n" and "N".
	*/
	createDebug.formatters = {};

	/**
	* Selects a color for a debug namespace
	* @param {String} namespace The namespace string for the for the debug instance to be colored
	* @return {Number|String} An ANSI color code for the given namespace
	* @api private
	*/
	function selectColor(namespace) {
		let hash = 0;

		for (let i = 0; i < namespace.length; i++) {
			hash = ((hash << 5) - hash) + namespace.charCodeAt(i);
			hash |= 0; // Convert to 32bit integer
		}

		return createDebug.colors[Math.abs(hash) % createDebug.colors.length];
	}
	createDebug.selectColor = selectColor;

	/**
	* Create a debugger with the given `namespace`.
	*
	* @param {String} namespace
	* @return {Function}
	* @api public
	*/
	function createDebug(namespace) {
		let prevTime;

		function debug(...args) {
			// Disabled?
			if (!debug.enabled) {
				return;
			}

			const self = debug;

			// Set `diff` timestamp
			const curr = Number(new Date());
			const ms = curr - (prevTime || curr);
			self.diff = ms;
			self.prev = prevTime;
			self.curr = curr;
			prevTime = curr;

			args[0] = createDebug.coerce(args[0]);

			if (typeof args[0] !== 'string') {
				// Anything else let's inspect with %O
				args.unshift('%O');
			}

			// Apply any `formatters` transformations
			let index = 0;
			args[0] = args[0].replace(/%([a-zA-Z%])/g, (match, format) => {
				// If we encounter an escaped % then don't increase the array index
				if (match === '%%') {
					return match;
				}
				index++;
				const formatter = createDebug.formatters[format];
				if (typeof formatter === 'function') {
					const val = args[index];
					match = formatter.call(self, val);

					// Now we need to remove `args[index]` since it's inlined in the `format`
					args.splice(index, 1);
					index--;
				}
				return match;
			});

			// Apply env-specific formatting (colors, etc.)
			createDebug.formatArgs.call(self, args);

			const logFn = self.log || createDebug.log;
			logFn.apply(self, args);
		}

		debug.namespace = namespace;
		debug.enabled = createDebug.enabled(namespace);
		debug.useColors = createDebug.useColors();
		debug.color = selectColor(namespace);
		debug.destroy = destroy;
		debug.extend = extend;
		// Debug.formatArgs = formatArgs;
		// debug.rawLog = rawLog;

		// env-specific initialization logic for debug instances
		if (typeof createDebug.init === 'function') {
			createDebug.init(debug);
		}

		createDebug.instances.push(debug);

		return debug;
	}

	function destroy() {
		const index = createDebug.instances.indexOf(this);
		if (index !== -1) {
			createDebug.instances.splice(index, 1);
			return true;
		}
		return false;
	}

	function extend(namespace, delimiter) {
		const newDebug = createDebug(this.namespace + (typeof delimiter === 'undefined' ? ':' : delimiter) + namespace);
		newDebug.log = this.log;
		return newDebug;
	}

	/**
	* Enables a debug mode by namespaces. This can include modes
	* separated by a colon and wildcards.
	*
	* @param {String} namespaces
	* @api public
	*/
	function enable(namespaces) {
		createDebug.save(namespaces);

		createDebug.names = [];
		createDebug.skips = [];

		let i;
		const split = (typeof namespaces === 'string' ? namespaces : '').split(/[\s,]+/);
		const len = split.length;

		for (i = 0; i < len; i++) {
			if (!split[i]) {
				// ignore empty strings
				continue;
			}

			namespaces = split[i].replace(/\*/g, '.*?');

			if (namespaces[0] === '-') {
				createDebug.skips.push(new RegExp('^' + namespaces.substr(1) + '$'));
			} else {
				createDebug.names.push(new RegExp('^' + namespaces + '$'));
			}
		}

		for (i = 0; i < createDebug.instances.length; i++) {
			const instance = createDebug.instances[i];
			instance.enabled = createDebug.enabled(instance.namespace);
		}
	}

	/**
	* Disable debug output.
	*
	* @return {String} namespaces
	* @api public
	*/
	function disable() {
		const namespaces = [
			...createDebug.names.map(toNamespace),
			...createDebug.skips.map(toNamespace).map(namespace => '-' + namespace)
		].join(',');
		createDebug.enable('');
		return namespaces;
	}

	/**
	* Returns true if the given mode name is enabled, false otherwise.
	*
	* @param {String} name
	* @return {Boolean}
	* @api public
	*/
	function enabled(name) {
		if (name[name.length - 1] === '*') {
			return true;
		}

		let i;
		let len;

		for (i = 0, len = createDebug.skips.length; i < len; i++) {
			if (createDebug.skips[i].test(name)) {
				return false;
			}
		}

		for (i = 0, len = createDebug.names.length; i < len; i++) {
			if (createDebug.names[i].test(name)) {
				return true;
			}
		}

		return false;
	}

	/**
	* Convert regexp to namespace
	*
	* @param {RegExp} regxep
	* @return {String} namespace
	* @api private
	*/
	function toNamespace(regexp) {
		return regexp.toString()
			.substring(2, regexp.toString().length - 2)
			.replace(/\.\*\?$/, '*');
	}

	/**
	* Coerce `val`.
	*
	* @param {Mixed} val
	* @return {Mixed}
	* @api private
	*/
	function coerce(val) {
		if (val instanceof Error) {
			return val.stack || val.message;
		}
		return val;
	}

	createDebug.enable(createDebug.load());

	return createDebug;
}

module.exports = setup;


/***/ }),

/***/ 5643:
/***/ (function(module, exports, __webpack_require__) {


/**
 * Module dependencies.
 */

var debug = __webpack_require__(5644)('socket.io-parser');
var Emitter = __webpack_require__(5647);
var binary = __webpack_require__(5648);
var isArray = __webpack_require__(5649);
var isBuf = __webpack_require__(5650);

/**
 * Protocol version.
 *
 * @api public
 */

exports.protocol = 4;

/**
 * Packet types.
 *
 * @api public
 */

exports.types = [
  'CONNECT',
  'DISCONNECT',
  'EVENT',
  'ACK',
  'ERROR',
  'BINARY_EVENT',
  'BINARY_ACK'
];

/**
 * Packet type `connect`.
 *
 * @api public
 */

exports.CONNECT = 0;

/**
 * Packet type `disconnect`.
 *
 * @api public
 */

exports.DISCONNECT = 1;

/**
 * Packet type `event`.
 *
 * @api public
 */

exports.EVENT = 2;

/**
 * Packet type `ack`.
 *
 * @api public
 */

exports.ACK = 3;

/**
 * Packet type `error`.
 *
 * @api public
 */

exports.ERROR = 4;

/**
 * Packet type 'binary event'
 *
 * @api public
 */

exports.BINARY_EVENT = 5;

/**
 * Packet type `binary ack`. For acks with binary arguments.
 *
 * @api public
 */

exports.BINARY_ACK = 6;

/**
 * Encoder constructor.
 *
 * @api public
 */

exports.Encoder = Encoder;

/**
 * Decoder constructor.
 *
 * @api public
 */

exports.Decoder = Decoder;

/**
 * A socket.io Encoder instance
 *
 * @api public
 */

function Encoder() {}

var ERROR_PACKET = exports.ERROR + '"encode error"';

/**
 * Encode a packet as a single string if non-binary, or as a
 * buffer sequence, depending on packet type.
 *
 * @param {Object} obj - packet object
 * @param {Function} callback - function to handle encodings (likely engine.write)
 * @return Calls callback with Array of encodings
 * @api public
 */

Encoder.prototype.encode = function(obj, callback){
  debug('encoding packet %j', obj);

  if (exports.BINARY_EVENT === obj.type || exports.BINARY_ACK === obj.type) {
    encodeAsBinary(obj, callback);
  } else {
    var encoding = encodeAsString(obj);
    callback([encoding]);
  }
};

/**
 * Encode packet as string.
 *
 * @param {Object} packet
 * @return {String} encoded
 * @api private
 */

function encodeAsString(obj) {

  // first is type
  var str = '' + obj.type;

  // attachments if we have them
  if (exports.BINARY_EVENT === obj.type || exports.BINARY_ACK === obj.type) {
    str += obj.attachments + '-';
  }

  // if we have a namespace other than `/`
  // we append it followed by a comma `,`
  if (obj.nsp && '/' !== obj.nsp) {
    str += obj.nsp + ',';
  }

  // immediately followed by the id
  if (null != obj.id) {
    str += obj.id;
  }

  // json data
  if (null != obj.data) {
    var payload = tryStringify(obj.data);
    if (payload !== false) {
      str += payload;
    } else {
      return ERROR_PACKET;
    }
  }

  debug('encoded %j as %s', obj, str);
  return str;
}

function tryStringify(str) {
  try {
    return JSON.stringify(str);
  } catch(e){
    return false;
  }
}

/**
 * Encode packet as 'buffer sequence' by removing blobs, and
 * deconstructing packet into object with placeholders and
 * a list of buffers.
 *
 * @param {Object} packet
 * @return {Buffer} encoded
 * @api private
 */

function encodeAsBinary(obj, callback) {

  function writeEncoding(bloblessData) {
    var deconstruction = binary.deconstructPacket(bloblessData);
    var pack = encodeAsString(deconstruction.packet);
    var buffers = deconstruction.buffers;

    buffers.unshift(pack); // add packet info to beginning of data list
    callback(buffers); // write all the buffers
  }

  binary.removeBlobs(obj, writeEncoding);
}

/**
 * A socket.io Decoder instance
 *
 * @return {Object} decoder
 * @api public
 */

function Decoder() {
  this.reconstructor = null;
}

/**
 * Mix in `Emitter` with Decoder.
 */

Emitter(Decoder.prototype);

/**
 * Decodes an encoded packet string into packet JSON.
 *
 * @param {String} obj - encoded packet
 * @return {Object} packet
 * @api public
 */

Decoder.prototype.add = function(obj) {
  var packet;
  if (typeof obj === 'string') {
    packet = decodeString(obj);
    if (exports.BINARY_EVENT === packet.type || exports.BINARY_ACK === packet.type) { // binary packet's json
      this.reconstructor = new BinaryReconstructor(packet);

      // no attachments, labeled binary but no binary data to follow
      if (this.reconstructor.reconPack.attachments === 0) {
        this.emit('decoded', packet);
      }
    } else { // non-binary full packet
      this.emit('decoded', packet);
    }
  } else if (isBuf(obj) || obj.base64) { // raw binary data
    if (!this.reconstructor) {
      throw new Error('got binary data when not reconstructing a packet');
    } else {
      packet = this.reconstructor.takeBinaryData(obj);
      if (packet) { // received final buffer
        this.reconstructor = null;
        this.emit('decoded', packet);
      }
    }
  } else {
    throw new Error('Unknown type: ' + obj);
  }
};

/**
 * Decode a packet String (JSON data)
 *
 * @param {String} str
 * @return {Object} packet
 * @api private
 */

function decodeString(str) {
  var i = 0;
  // look up type
  var p = {
    type: Number(str.charAt(0))
  };

  if (null == exports.types[p.type]) {
    return error('unknown packet type ' + p.type);
  }

  // look up attachments if type binary
  if (exports.BINARY_EVENT === p.type || exports.BINARY_ACK === p.type) {
    var buf = '';
    while (str.charAt(++i) !== '-') {
      buf += str.charAt(i);
      if (i == str.length) break;
    }
    if (buf != Number(buf) || str.charAt(i) !== '-') {
      throw new Error('Illegal attachments');
    }
    p.attachments = Number(buf);
  }

  // look up namespace (if any)
  if ('/' === str.charAt(i + 1)) {
    p.nsp = '';
    while (++i) {
      var c = str.charAt(i);
      if (',' === c) break;
      p.nsp += c;
      if (i === str.length) break;
    }
  } else {
    p.nsp = '/';
  }

  // look up id
  var next = str.charAt(i + 1);
  if ('' !== next && Number(next) == next) {
    p.id = '';
    while (++i) {
      var c = str.charAt(i);
      if (null == c || Number(c) != c) {
        --i;
        break;
      }
      p.id += str.charAt(i);
      if (i === str.length) break;
    }
    p.id = Number(p.id);
  }

  // look up json data
  if (str.charAt(++i)) {
    var payload = tryParse(str.substr(i));
    var isPayloadValid = payload !== false && (p.type === exports.ERROR || isArray(payload));
    if (isPayloadValid) {
      p.data = payload;
    } else {
      return error('invalid payload');
    }
  }

  debug('decoded %s as %j', str, p);
  return p;
}

function tryParse(str) {
  try {
    return JSON.parse(str);
  } catch(e){
    return false;
  }
}

/**
 * Deallocates a parser's resources
 *
 * @api public
 */

Decoder.prototype.destroy = function() {
  if (this.reconstructor) {
    this.reconstructor.finishedReconstruction();
  }
};

/**
 * A manager of a binary event's 'buffer sequence'. Should
 * be constructed whenever a packet of type BINARY_EVENT is
 * decoded.
 *
 * @param {Object} packet
 * @return {BinaryReconstructor} initialized reconstructor
 * @api private
 */

function BinaryReconstructor(packet) {
  this.reconPack = packet;
  this.buffers = [];
}

/**
 * Method to be called when binary data received from connection
 * after a BINARY_EVENT packet.
 *
 * @param {Buffer | ArrayBuffer} binData - the raw binary data received
 * @return {null | Object} returns null if more binary data is expected or
 *   a reconstructed packet object if all buffers have been received.
 * @api private
 */

BinaryReconstructor.prototype.takeBinaryData = function(binData) {
  this.buffers.push(binData);
  if (this.buffers.length === this.reconPack.attachments) { // done with buffer list
    var packet = binary.reconstructPacket(this.reconPack, this.buffers);
    this.finishedReconstruction();
    return packet;
  }
  return null;
};

/**
 * Cleans up binary packet reconstruction variables.
 *
 * @api private
 */

BinaryReconstructor.prototype.finishedReconstruction = function() {
  this.reconPack = null;
  this.buffers = [];
};

function error(msg) {
  return {
    type: exports.ERROR,
    data: 'parser error: ' + msg
  };
}


/***/ }),

/***/ 5644:
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(process) {/**
 * This is the web browser implementation of `debug()`.
 *
 * Expose `debug()` as the module.
 */

exports = module.exports = __webpack_require__(5645);
exports.log = log;
exports.formatArgs = formatArgs;
exports.save = save;
exports.load = load;
exports.useColors = useColors;
exports.storage = 'undefined' != typeof chrome
               && 'undefined' != typeof chrome.storage
                  ? chrome.storage.local
                  : localstorage();

/**
 * Colors.
 */

exports.colors = [
  '#0000CC', '#0000FF', '#0033CC', '#0033FF', '#0066CC', '#0066FF', '#0099CC',
  '#0099FF', '#00CC00', '#00CC33', '#00CC66', '#00CC99', '#00CCCC', '#00CCFF',
  '#3300CC', '#3300FF', '#3333CC', '#3333FF', '#3366CC', '#3366FF', '#3399CC',
  '#3399FF', '#33CC00', '#33CC33', '#33CC66', '#33CC99', '#33CCCC', '#33CCFF',
  '#6600CC', '#6600FF', '#6633CC', '#6633FF', '#66CC00', '#66CC33', '#9900CC',
  '#9900FF', '#9933CC', '#9933FF', '#99CC00', '#99CC33', '#CC0000', '#CC0033',
  '#CC0066', '#CC0099', '#CC00CC', '#CC00FF', '#CC3300', '#CC3333', '#CC3366',
  '#CC3399', '#CC33CC', '#CC33FF', '#CC6600', '#CC6633', '#CC9900', '#CC9933',
  '#CCCC00', '#CCCC33', '#FF0000', '#FF0033', '#FF0066', '#FF0099', '#FF00CC',
  '#FF00FF', '#FF3300', '#FF3333', '#FF3366', '#FF3399', '#FF33CC', '#FF33FF',
  '#FF6600', '#FF6633', '#FF9900', '#FF9933', '#FFCC00', '#FFCC33'
];

/**
 * Currently only WebKit-based Web Inspectors, Firefox >= v31,
 * and the Firebug extension (any Firefox version) are known
 * to support "%c" CSS customizations.
 *
 * TODO: add a `localStorage` variable to explicitly enable/disable colors
 */

function useColors() {
  // NB: In an Electron preload script, document will be defined but not fully
  // initialized. Since we know we're in Chrome, we'll just detect this case
  // explicitly
  if (typeof window !== 'undefined' && window.process && window.process.type === 'renderer') {
    return true;
  }

  // Internet Explorer and Edge do not support colors.
  if (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
    return false;
  }

  // is webkit? http://stackoverflow.com/a/16459606/376773
  // document is undefined in react-native: https://github.com/facebook/react-native/pull/1632
  return (typeof document !== 'undefined' && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance) ||
    // is firebug? http://stackoverflow.com/a/398120/376773
    (typeof window !== 'undefined' && window.console && (window.console.firebug || (window.console.exception && window.console.table))) ||
    // is firefox >= v31?
    // https://developer.mozilla.org/en-US/docs/Tools/Web_Console#Styling_messages
    (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31) ||
    // double check webkit in userAgent just in case we are in a worker
    (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/));
}

/**
 * Map %j to `JSON.stringify()`, since no Web Inspectors do that by default.
 */

exports.formatters.j = function(v) {
  try {
    return JSON.stringify(v);
  } catch (err) {
    return '[UnexpectedJSONParseError]: ' + err.message;
  }
};


/**
 * Colorize log arguments if enabled.
 *
 * @api public
 */

function formatArgs(args) {
  var useColors = this.useColors;

  args[0] = (useColors ? '%c' : '')
    + this.namespace
    + (useColors ? ' %c' : ' ')
    + args[0]
    + (useColors ? '%c ' : ' ')
    + '+' + exports.humanize(this.diff);

  if (!useColors) return;

  var c = 'color: ' + this.color;
  args.splice(1, 0, c, 'color: inherit')

  // the final "%c" is somewhat tricky, because there could be other
  // arguments passed either before or after the %c, so we need to
  // figure out the correct index to insert the CSS into
  var index = 0;
  var lastC = 0;
  args[0].replace(/%[a-zA-Z%]/g, function(match) {
    if ('%%' === match) return;
    index++;
    if ('%c' === match) {
      // we only are interested in the *last* %c
      // (the user may have provided their own)
      lastC = index;
    }
  });

  args.splice(lastC, 0, c);
}

/**
 * Invokes `console.log()` when available.
 * No-op when `console.log` is not a "function".
 *
 * @api public
 */

function log() {
  // this hackery is required for IE8/9, where
  // the `console.log` function doesn't have 'apply'
  return 'object' === typeof console
    && console.log
    && Function.prototype.apply.call(console.log, console, arguments);
}

/**
 * Save `namespaces`.
 *
 * @param {String} namespaces
 * @api private
 */

function save(namespaces) {
  try {
    if (null == namespaces) {
      exports.storage.removeItem('debug');
    } else {
      exports.storage.debug = namespaces;
    }
  } catch(e) {}
}

/**
 * Load `namespaces`.
 *
 * @return {String} returns the previously persisted debug modes
 * @api private
 */

function load() {
  var r;
  try {
    r = exports.storage.debug;
  } catch(e) {}

  // If debug isn't set in LS, and we're in Electron, try to load $DEBUG
  if (!r && typeof process !== 'undefined' && 'env' in process) {
    r = process.env.DEBUG;
  }

  return r;
}

/**
 * Enable namespaces listed in `localStorage.debug` initially.
 */

exports.enable(load());

/**
 * Localstorage attempts to return the localstorage.
 *
 * This is necessary because safari throws
 * when a user disables cookies/localstorage
 * and you attempt to access it.
 *
 * @return {LocalStorage}
 * @api private
 */

function localstorage() {
  try {
    return window.localStorage;
  } catch (e) {}
}

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(31)))

/***/ }),

/***/ 5645:
/***/ (function(module, exports, __webpack_require__) {


/**
 * This is the common logic for both the Node.js and web browser
 * implementations of `debug()`.
 *
 * Expose `debug()` as the module.
 */

exports = module.exports = createDebug.debug = createDebug['default'] = createDebug;
exports.coerce = coerce;
exports.disable = disable;
exports.enable = enable;
exports.enabled = enabled;
exports.humanize = __webpack_require__(5646);

/**
 * Active `debug` instances.
 */
exports.instances = [];

/**
 * The currently active debug mode names, and names to skip.
 */

exports.names = [];
exports.skips = [];

/**
 * Map of special "%n" handling functions, for the debug "format" argument.
 *
 * Valid key names are a single, lower or upper-case letter, i.e. "n" and "N".
 */

exports.formatters = {};

/**
 * Select a color.
 * @param {String} namespace
 * @return {Number}
 * @api private
 */

function selectColor(namespace) {
  var hash = 0, i;

  for (i in namespace) {
    hash  = ((hash << 5) - hash) + namespace.charCodeAt(i);
    hash |= 0; // Convert to 32bit integer
  }

  return exports.colors[Math.abs(hash) % exports.colors.length];
}

/**
 * Create a debugger with the given `namespace`.
 *
 * @param {String} namespace
 * @return {Function}
 * @api public
 */

function createDebug(namespace) {

  var prevTime;

  function debug() {
    // disabled?
    if (!debug.enabled) return;

    var self = debug;

    // set `diff` timestamp
    var curr = +new Date();
    var ms = curr - (prevTime || curr);
    self.diff = ms;
    self.prev = prevTime;
    self.curr = curr;
    prevTime = curr;

    // turn the `arguments` into a proper Array
    var args = new Array(arguments.length);
    for (var i = 0; i < args.length; i++) {
      args[i] = arguments[i];
    }

    args[0] = exports.coerce(args[0]);

    if ('string' !== typeof args[0]) {
      // anything else let's inspect with %O
      args.unshift('%O');
    }

    // apply any `formatters` transformations
    var index = 0;
    args[0] = args[0].replace(/%([a-zA-Z%])/g, function(match, format) {
      // if we encounter an escaped % then don't increase the array index
      if (match === '%%') return match;
      index++;
      var formatter = exports.formatters[format];
      if ('function' === typeof formatter) {
        var val = args[index];
        match = formatter.call(self, val);

        // now we need to remove `args[index]` since it's inlined in the `format`
        args.splice(index, 1);
        index--;
      }
      return match;
    });

    // apply env-specific formatting (colors, etc.)
    exports.formatArgs.call(self, args);

    var logFn = debug.log || exports.log || console.log.bind(console);
    logFn.apply(self, args);
  }

  debug.namespace = namespace;
  debug.enabled = exports.enabled(namespace);
  debug.useColors = exports.useColors();
  debug.color = selectColor(namespace);
  debug.destroy = destroy;

  // env-specific initialization logic for debug instances
  if ('function' === typeof exports.init) {
    exports.init(debug);
  }

  exports.instances.push(debug);

  return debug;
}

function destroy () {
  var index = exports.instances.indexOf(this);
  if (index !== -1) {
    exports.instances.splice(index, 1);
    return true;
  } else {
    return false;
  }
}

/**
 * Enables a debug mode by namespaces. This can include modes
 * separated by a colon and wildcards.
 *
 * @param {String} namespaces
 * @api public
 */

function enable(namespaces) {
  exports.save(namespaces);

  exports.names = [];
  exports.skips = [];

  var i;
  var split = (typeof namespaces === 'string' ? namespaces : '').split(/[\s,]+/);
  var len = split.length;

  for (i = 0; i < len; i++) {
    if (!split[i]) continue; // ignore empty strings
    namespaces = split[i].replace(/\*/g, '.*?');
    if (namespaces[0] === '-') {
      exports.skips.push(new RegExp('^' + namespaces.substr(1) + '$'));
    } else {
      exports.names.push(new RegExp('^' + namespaces + '$'));
    }
  }

  for (i = 0; i < exports.instances.length; i++) {
    var instance = exports.instances[i];
    instance.enabled = exports.enabled(instance.namespace);
  }
}

/**
 * Disable debug output.
 *
 * @api public
 */

function disable() {
  exports.enable('');
}

/**
 * Returns true if the given mode name is enabled, false otherwise.
 *
 * @param {String} name
 * @return {Boolean}
 * @api public
 */

function enabled(name) {
  if (name[name.length - 1] === '*') {
    return true;
  }
  var i, len;
  for (i = 0, len = exports.skips.length; i < len; i++) {
    if (exports.skips[i].test(name)) {
      return false;
    }
  }
  for (i = 0, len = exports.names.length; i < len; i++) {
    if (exports.names[i].test(name)) {
      return true;
    }
  }
  return false;
}

/**
 * Coerce `val`.
 *
 * @param {Mixed} val
 * @return {Mixed}
 * @api private
 */

function coerce(val) {
  if (val instanceof Error) return val.stack || val.message;
  return val;
}


/***/ }),

/***/ 5646:
/***/ (function(module, exports) {

/**
 * Helpers.
 */

var s = 1000;
var m = s * 60;
var h = m * 60;
var d = h * 24;
var y = d * 365.25;

/**
 * Parse or format the given `val`.
 *
 * Options:
 *
 *  - `long` verbose formatting [false]
 *
 * @param {String|Number} val
 * @param {Object} [options]
 * @throws {Error} throw an error if val is not a non-empty string or a number
 * @return {String|Number}
 * @api public
 */

module.exports = function(val, options) {
  options = options || {};
  var type = typeof val;
  if (type === 'string' && val.length > 0) {
    return parse(val);
  } else if (type === 'number' && isNaN(val) === false) {
    return options.long ? fmtLong(val) : fmtShort(val);
  }
  throw new Error(
    'val is not a non-empty string or a valid number. val=' +
      JSON.stringify(val)
  );
};

/**
 * Parse the given `str` and return milliseconds.
 *
 * @param {String} str
 * @return {Number}
 * @api private
 */

function parse(str) {
  str = String(str);
  if (str.length > 100) {
    return;
  }
  var match = /^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(
    str
  );
  if (!match) {
    return;
  }
  var n = parseFloat(match[1]);
  var type = (match[2] || 'ms').toLowerCase();
  switch (type) {
    case 'years':
    case 'year':
    case 'yrs':
    case 'yr':
    case 'y':
      return n * y;
    case 'days':
    case 'day':
    case 'd':
      return n * d;
    case 'hours':
    case 'hour':
    case 'hrs':
    case 'hr':
    case 'h':
      return n * h;
    case 'minutes':
    case 'minute':
    case 'mins':
    case 'min':
    case 'm':
      return n * m;
    case 'seconds':
    case 'second':
    case 'secs':
    case 'sec':
    case 's':
      return n * s;
    case 'milliseconds':
    case 'millisecond':
    case 'msecs':
    case 'msec':
    case 'ms':
      return n;
    default:
      return undefined;
  }
}

/**
 * Short format for `ms`.
 *
 * @param {Number} ms
 * @return {String}
 * @api private
 */

function fmtShort(ms) {
  if (ms >= d) {
    return Math.round(ms / d) + 'd';
  }
  if (ms >= h) {
    return Math.round(ms / h) + 'h';
  }
  if (ms >= m) {
    return Math.round(ms / m) + 'm';
  }
  if (ms >= s) {
    return Math.round(ms / s) + 's';
  }
  return ms + 'ms';
}

/**
 * Long format for `ms`.
 *
 * @param {Number} ms
 * @return {String}
 * @api private
 */

function fmtLong(ms) {
  return plural(ms, d, 'day') ||
    plural(ms, h, 'hour') ||
    plural(ms, m, 'minute') ||
    plural(ms, s, 'second') ||
    ms + ' ms';
}

/**
 * Pluralization helper.
 */

function plural(ms, n, name) {
  if (ms < n) {
    return;
  }
  if (ms < n * 1.5) {
    return Math.floor(ms / n) + ' ' + name;
  }
  return Math.ceil(ms / n) + ' ' + name + 's';
}


/***/ }),

/***/ 5647:
/***/ (function(module, exports, __webpack_require__) {


/**
 * Expose `Emitter`.
 */

if (true) {
  module.exports = Emitter;
}

/**
 * Initialize a new `Emitter`.
 *
 * @api public
 */

function Emitter(obj) {
  if (obj) return mixin(obj);
};

/**
 * Mixin the emitter properties.
 *
 * @param {Object} obj
 * @return {Object}
 * @api private
 */

function mixin(obj) {
  for (var key in Emitter.prototype) {
    obj[key] = Emitter.prototype[key];
  }
  return obj;
}

/**
 * Listen on the given `event` with `fn`.
 *
 * @param {String} event
 * @param {Function} fn
 * @return {Emitter}
 * @api public
 */

Emitter.prototype.on =
Emitter.prototype.addEventListener = function(event, fn){
  this._callbacks = this._callbacks || {};
  (this._callbacks['$' + event] = this._callbacks['$' + event] || [])
    .push(fn);
  return this;
};

/**
 * Adds an `event` listener that will be invoked a single
 * time then automatically removed.
 *
 * @param {String} event
 * @param {Function} fn
 * @return {Emitter}
 * @api public
 */

Emitter.prototype.once = function(event, fn){
  function on() {
    this.off(event, on);
    fn.apply(this, arguments);
  }

  on.fn = fn;
  this.on(event, on);
  return this;
};

/**
 * Remove the given callback for `event` or all
 * registered callbacks.
 *
 * @param {String} event
 * @param {Function} fn
 * @return {Emitter}
 * @api public
 */

Emitter.prototype.off =
Emitter.prototype.removeListener =
Emitter.prototype.removeAllListeners =
Emitter.prototype.removeEventListener = function(event, fn){
  this._callbacks = this._callbacks || {};

  // all
  if (0 == arguments.length) {
    this._callbacks = {};
    return this;
  }

  // specific event
  var callbacks = this._callbacks['$' + event];
  if (!callbacks) return this;

  // remove all handlers
  if (1 == arguments.length) {
    delete this._callbacks['$' + event];
    return this;
  }

  // remove specific handler
  var cb;
  for (var i = 0; i < callbacks.length; i++) {
    cb = callbacks[i];
    if (cb === fn || cb.fn === fn) {
      callbacks.splice(i, 1);
      break;
    }
  }
  return this;
};

/**
 * Emit `event` with the given args.
 *
 * @param {String} event
 * @param {Mixed} ...
 * @return {Emitter}
 */

Emitter.prototype.emit = function(event){
  this._callbacks = this._callbacks || {};
  var args = [].slice.call(arguments, 1)
    , callbacks = this._callbacks['$' + event];

  if (callbacks) {
    callbacks = callbacks.slice(0);
    for (var i = 0, len = callbacks.length; i < len; ++i) {
      callbacks[i].apply(this, args);
    }
  }

  return this;
};

/**
 * Return array of callbacks for `event`.
 *
 * @param {String} event
 * @return {Array}
 * @api public
 */

Emitter.prototype.listeners = function(event){
  this._callbacks = this._callbacks || {};
  return this._callbacks['$' + event] || [];
};

/**
 * Check if this emitter has `event` handlers.
 *
 * @param {String} event
 * @return {Boolean}
 * @api public
 */

Emitter.prototype.hasListeners = function(event){
  return !! this.listeners(event).length;
};


/***/ }),

/***/ 5648:
/***/ (function(module, exports, __webpack_require__) {

/*global Blob,File*/

/**
 * Module requirements
 */

var isArray = __webpack_require__(5649);
var isBuf = __webpack_require__(5650);
var toString = Object.prototype.toString;
var withNativeBlob = typeof Blob === 'function' || (typeof Blob !== 'undefined' && toString.call(Blob) === '[object BlobConstructor]');
var withNativeFile = typeof File === 'function' || (typeof File !== 'undefined' && toString.call(File) === '[object FileConstructor]');

/**
 * Replaces every Buffer | ArrayBuffer in packet with a numbered placeholder.
 * Anything with blobs or files should be fed through removeBlobs before coming
 * here.
 *
 * @param {Object} packet - socket.io event packet
 * @return {Object} with deconstructed packet and list of buffers
 * @api public
 */

exports.deconstructPacket = function(packet) {
  var buffers = [];
  var packetData = packet.data;
  var pack = packet;
  pack.data = _deconstructPacket(packetData, buffers);
  pack.attachments = buffers.length; // number of binary 'attachments'
  return {packet: pack, buffers: buffers};
};

function _deconstructPacket(data, buffers) {
  if (!data) return data;

  if (isBuf(data)) {
    var placeholder = { _placeholder: true, num: buffers.length };
    buffers.push(data);
    return placeholder;
  } else if (isArray(data)) {
    var newData = new Array(data.length);
    for (var i = 0; i < data.length; i++) {
      newData[i] = _deconstructPacket(data[i], buffers);
    }
    return newData;
  } else if (typeof data === 'object' && !(data instanceof Date)) {
    var newData = {};
    for (var key in data) {
      newData[key] = _deconstructPacket(data[key], buffers);
    }
    return newData;
  }
  return data;
}

/**
 * Reconstructs a binary packet from its placeholder packet and buffers
 *
 * @param {Object} packet - event packet with placeholders
 * @param {Array} buffers - binary buffers to put in placeholder positions
 * @return {Object} reconstructed packet
 * @api public
 */

exports.reconstructPacket = function(packet, buffers) {
  packet.data = _reconstructPacket(packet.data, buffers);
  packet.attachments = undefined; // no longer useful
  return packet;
};

function _reconstructPacket(data, buffers) {
  if (!data) return data;

  if (data && data._placeholder) {
    return buffers[data.num]; // appropriate buffer (should be natural order anyway)
  } else if (isArray(data)) {
    for (var i = 0; i < data.length; i++) {
      data[i] = _reconstructPacket(data[i], buffers);
    }
  } else if (typeof data === 'object') {
    for (var key in data) {
      data[key] = _reconstructPacket(data[key], buffers);
    }
  }

  return data;
}

/**
 * Asynchronously removes Blobs or Files from data via
 * FileReader's readAsArrayBuffer method. Used before encoding
 * data as msgpack. Calls callback with the blobless data.
 *
 * @param {Object} data
 * @param {Function} callback
 * @api private
 */

exports.removeBlobs = function(data, callback) {
  function _removeBlobs(obj, curKey, containingObject) {
    if (!obj) return obj;

    // convert any blob
    if ((withNativeBlob && obj instanceof Blob) ||
        (withNativeFile && obj instanceof File)) {
      pendingBlobs++;

      // async filereader
      var fileReader = new FileReader();
      fileReader.onload = function() { // this.result == arraybuffer
        if (containingObject) {
          containingObject[curKey] = this.result;
        }
        else {
          bloblessData = this.result;
        }

        // if nothing pending its callback time
        if(! --pendingBlobs) {
          callback(bloblessData);
        }
      };

      fileReader.readAsArrayBuffer(obj); // blob -> arraybuffer
    } else if (isArray(obj)) { // handle array
      for (var i = 0; i < obj.length; i++) {
        _removeBlobs(obj[i], i, obj);
      }
    } else if (typeof obj === 'object' && !isBuf(obj)) { // and object
      for (var key in obj) {
        _removeBlobs(obj[key], key, obj);
      }
    }
  }

  var pendingBlobs = 0;
  var bloblessData = data;
  _removeBlobs(bloblessData);
  if (!pendingBlobs) {
    callback(bloblessData);
  }
};


/***/ }),

/***/ 5649:
/***/ (function(module, exports) {

var toString = {}.toString;

module.exports = Array.isArray || function (arr) {
  return toString.call(arr) == '[object Array]';
};


/***/ }),

/***/ 5650:
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(Buffer) {
module.exports = isBuf;

var withNativeBuffer = typeof Buffer === 'function' && typeof Buffer.isBuffer === 'function';
var withNativeArrayBuffer = typeof ArrayBuffer === 'function';

var isView = function (obj) {
  return typeof ArrayBuffer.isView === 'function' ? ArrayBuffer.isView(obj) : (obj.buffer instanceof ArrayBuffer);
};

/**
 * Returns true if obj is a buffer or an arraybuffer.
 *
 * @api private
 */

function isBuf(obj) {
  return (withNativeBuffer && Buffer.isBuffer(obj)) ||
          (withNativeArrayBuffer && (obj instanceof ArrayBuffer || isView(obj)));
}

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(104).Buffer))

/***/ }),

/***/ 5651:
/***/ (function(module, exports, __webpack_require__) {


/**
 * Module dependencies.
 */

var eio = __webpack_require__(5652);
var Socket = __webpack_require__(5677);
var Emitter = __webpack_require__(5647);
var parser = __webpack_require__(5643);
var on = __webpack_require__(5679);
var bind = __webpack_require__(5680);
var debug = __webpack_require__(5641)('socket.io-client:manager');
var indexOf = __webpack_require__(5676);
var Backoff = __webpack_require__(5681);

/**
 * IE6+ hasOwnProperty
 */

var has = Object.prototype.hasOwnProperty;

/**
 * Module exports
 */

module.exports = Manager;

/**
 * `Manager` constructor.
 *
 * @param {String} engine instance or engine uri/opts
 * @param {Object} options
 * @api public
 */

function Manager (uri, opts) {
  if (!(this instanceof Manager)) return new Manager(uri, opts);
  if (uri && ('object' === typeof uri)) {
    opts = uri;
    uri = undefined;
  }
  opts = opts || {};

  opts.path = opts.path || '/socket.io';
  this.nsps = {};
  this.subs = [];
  this.opts = opts;
  this.reconnection(opts.reconnection !== false);
  this.reconnectionAttempts(opts.reconnectionAttempts || Infinity);
  this.reconnectionDelay(opts.reconnectionDelay || 1000);
  this.reconnectionDelayMax(opts.reconnectionDelayMax || 5000);
  this.randomizationFactor(opts.randomizationFactor || 0.5);
  this.backoff = new Backoff({
    min: this.reconnectionDelay(),
    max: this.reconnectionDelayMax(),
    jitter: this.randomizationFactor()
  });
  this.timeout(null == opts.timeout ? 20000 : opts.timeout);
  this.readyState = 'closed';
  this.uri = uri;
  this.connecting = [];
  this.lastPing = null;
  this.encoding = false;
  this.packetBuffer = [];
  var _parser = opts.parser || parser;
  this.encoder = new _parser.Encoder();
  this.decoder = new _parser.Decoder();
  this.autoConnect = opts.autoConnect !== false;
  if (this.autoConnect) this.open();
}

/**
 * Propagate given event to sockets and emit on `this`
 *
 * @api private
 */

Manager.prototype.emitAll = function () {
  this.emit.apply(this, arguments);
  for (var nsp in this.nsps) {
    if (has.call(this.nsps, nsp)) {
      this.nsps[nsp].emit.apply(this.nsps[nsp], arguments);
    }
  }
};

/**
 * Update `socket.id` of all sockets
 *
 * @api private
 */

Manager.prototype.updateSocketIds = function () {
  for (var nsp in this.nsps) {
    if (has.call(this.nsps, nsp)) {
      this.nsps[nsp].id = this.generateId(nsp);
    }
  }
};

/**
 * generate `socket.id` for the given `nsp`
 *
 * @param {String} nsp
 * @return {String}
 * @api private
 */

Manager.prototype.generateId = function (nsp) {
  return (nsp === '/' ? '' : (nsp + '#')) + this.engine.id;
};

/**
 * Mix in `Emitter`.
 */

Emitter(Manager.prototype);

/**
 * Sets the `reconnection` config.
 *
 * @param {Boolean} true/false if it should automatically reconnect
 * @return {Manager} self or value
 * @api public
 */

Manager.prototype.reconnection = function (v) {
  if (!arguments.length) return this._reconnection;
  this._reconnection = !!v;
  return this;
};

/**
 * Sets the reconnection attempts config.
 *
 * @param {Number} max reconnection attempts before giving up
 * @return {Manager} self or value
 * @api public
 */

Manager.prototype.reconnectionAttempts = function (v) {
  if (!arguments.length) return this._reconnectionAttempts;
  this._reconnectionAttempts = v;
  return this;
};

/**
 * Sets the delay between reconnections.
 *
 * @param {Number} delay
 * @return {Manager} self or value
 * @api public
 */

Manager.prototype.reconnectionDelay = function (v) {
  if (!arguments.length) return this._reconnectionDelay;
  this._reconnectionDelay = v;
  this.backoff && this.backoff.setMin(v);
  return this;
};

Manager.prototype.randomizationFactor = function (v) {
  if (!arguments.length) return this._randomizationFactor;
  this._randomizationFactor = v;
  this.backoff && this.backoff.setJitter(v);
  return this;
};

/**
 * Sets the maximum delay between reconnections.
 *
 * @param {Number} delay
 * @return {Manager} self or value
 * @api public
 */

Manager.prototype.reconnectionDelayMax = function (v) {
  if (!arguments.length) return this._reconnectionDelayMax;
  this._reconnectionDelayMax = v;
  this.backoff && this.backoff.setMax(v);
  return this;
};

/**
 * Sets the connection timeout. `false` to disable
 *
 * @return {Manager} self or value
 * @api public
 */

Manager.prototype.timeout = function (v) {
  if (!arguments.length) return this._timeout;
  this._timeout = v;
  return this;
};

/**
 * Starts trying to reconnect if reconnection is enabled and we have not
 * started reconnecting yet
 *
 * @api private
 */

Manager.prototype.maybeReconnectOnOpen = function () {
  // Only try to reconnect if it's the first time we're connecting
  if (!this.reconnecting && this._reconnection && this.backoff.attempts === 0) {
    // keeps reconnection from firing twice for the same reconnection loop
    this.reconnect();
  }
};

/**
 * Sets the current transport `socket`.
 *
 * @param {Function} optional, callback
 * @return {Manager} self
 * @api public
 */

Manager.prototype.open =
Manager.prototype.connect = function (fn, opts) {
  debug('readyState %s', this.readyState);
  if (~this.readyState.indexOf('open')) return this;

  debug('opening %s', this.uri);
  this.engine = eio(this.uri, this.opts);
  var socket = this.engine;
  var self = this;
  this.readyState = 'opening';
  this.skipReconnect = false;

  // emit `open`
  var openSub = on(socket, 'open', function () {
    self.onopen();
    fn && fn();
  });

  // emit `connect_error`
  var errorSub = on(socket, 'error', function (data) {
    debug('connect_error');
    self.cleanup();
    self.readyState = 'closed';
    self.emitAll('connect_error', data);
    if (fn) {
      var err = new Error('Connection error');
      err.data = data;
      fn(err);
    } else {
      // Only do this if there is no fn to handle the error
      self.maybeReconnectOnOpen();
    }
  });

  // emit `connect_timeout`
  if (false !== this._timeout) {
    var timeout = this._timeout;
    debug('connect attempt will timeout after %d', timeout);

    // set timer
    var timer = setTimeout(function () {
      debug('connect attempt timed out after %d', timeout);
      openSub.destroy();
      socket.close();
      socket.emit('error', 'timeout');
      self.emitAll('connect_timeout', timeout);
    }, timeout);

    this.subs.push({
      destroy: function () {
        clearTimeout(timer);
      }
    });
  }

  this.subs.push(openSub);
  this.subs.push(errorSub);

  return this;
};

/**
 * Called upon transport open.
 *
 * @api private
 */

Manager.prototype.onopen = function () {
  debug('open');

  // clear old subs
  this.cleanup();

  // mark as open
  this.readyState = 'open';
  this.emit('open');

  // add new subs
  var socket = this.engine;
  this.subs.push(on(socket, 'data', bind(this, 'ondata')));
  this.subs.push(on(socket, 'ping', bind(this, 'onping')));
  this.subs.push(on(socket, 'pong', bind(this, 'onpong')));
  this.subs.push(on(socket, 'error', bind(this, 'onerror')));
  this.subs.push(on(socket, 'close', bind(this, 'onclose')));
  this.subs.push(on(this.decoder, 'decoded', bind(this, 'ondecoded')));
};

/**
 * Called upon a ping.
 *
 * @api private
 */

Manager.prototype.onping = function () {
  this.lastPing = new Date();
  this.emitAll('ping');
};

/**
 * Called upon a packet.
 *
 * @api private
 */

Manager.prototype.onpong = function () {
  this.emitAll('pong', new Date() - this.lastPing);
};

/**
 * Called with data.
 *
 * @api private
 */

Manager.prototype.ondata = function (data) {
  this.decoder.add(data);
};

/**
 * Called when parser fully decodes a packet.
 *
 * @api private
 */

Manager.prototype.ondecoded = function (packet) {
  this.emit('packet', packet);
};

/**
 * Called upon socket error.
 *
 * @api private
 */

Manager.prototype.onerror = function (err) {
  debug('error', err);
  this.emitAll('error', err);
};

/**
 * Creates a new socket for the given `nsp`.
 *
 * @return {Socket}
 * @api public
 */

Manager.prototype.socket = function (nsp, opts) {
  var socket = this.nsps[nsp];
  if (!socket) {
    socket = new Socket(this, nsp, opts);
    this.nsps[nsp] = socket;
    var self = this;
    socket.on('connecting', onConnecting);
    socket.on('connect', function () {
      socket.id = self.generateId(nsp);
    });

    if (this.autoConnect) {
      // manually call here since connecting event is fired before listening
      onConnecting();
    }
  }

  function onConnecting () {
    if (!~indexOf(self.connecting, socket)) {
      self.connecting.push(socket);
    }
  }

  return socket;
};

/**
 * Called upon a socket close.
 *
 * @param {Socket} socket
 */

Manager.prototype.destroy = function (socket) {
  var index = indexOf(this.connecting, socket);
  if (~index) this.connecting.splice(index, 1);
  if (this.connecting.length) return;

  this.close();
};

/**
 * Writes a packet.
 *
 * @param {Object} packet
 * @api private
 */

Manager.prototype.packet = function (packet) {
  debug('writing packet %j', packet);
  var self = this;
  if (packet.query && packet.type === 0) packet.nsp += '?' + packet.query;

  if (!self.encoding) {
    // encode, then write to engine with result
    self.encoding = true;
    this.encoder.encode(packet, function (encodedPackets) {
      for (var i = 0; i < encodedPackets.length; i++) {
        self.engine.write(encodedPackets[i], packet.options);
      }
      self.encoding = false;
      self.processPacketQueue();
    });
  } else { // add packet to the queue
    self.packetBuffer.push(packet);
  }
};

/**
 * If packet buffer is non-empty, begins encoding the
 * next packet in line.
 *
 * @api private
 */

Manager.prototype.processPacketQueue = function () {
  if (this.packetBuffer.length > 0 && !this.encoding) {
    var pack = this.packetBuffer.shift();
    this.packet(pack);
  }
};

/**
 * Clean up transport subscriptions and packet buffer.
 *
 * @api private
 */

Manager.prototype.cleanup = function () {
  debug('cleanup');

  var subsLength = this.subs.length;
  for (var i = 0; i < subsLength; i++) {
    var sub = this.subs.shift();
    sub.destroy();
  }

  this.packetBuffer = [];
  this.encoding = false;
  this.lastPing = null;

  this.decoder.destroy();
};

/**
 * Close the current socket.
 *
 * @api private
 */

Manager.prototype.close =
Manager.prototype.disconnect = function () {
  debug('disconnect');
  this.skipReconnect = true;
  this.reconnecting = false;
  if ('opening' === this.readyState) {
    // `onclose` will not fire because
    // an open event never happened
    this.cleanup();
  }
  this.backoff.reset();
  this.readyState = 'closed';
  if (this.engine) this.engine.close();
};

/**
 * Called upon engine close.
 *
 * @api private
 */

Manager.prototype.onclose = function (reason) {
  debug('onclose');

  this.cleanup();
  this.backoff.reset();
  this.readyState = 'closed';
  this.emit('close', reason);

  if (this._reconnection && !this.skipReconnect) {
    this.reconnect();
  }
};

/**
 * Attempt a reconnection.
 *
 * @api private
 */

Manager.prototype.reconnect = function () {
  if (this.reconnecting || this.skipReconnect) return this;

  var self = this;

  if (this.backoff.attempts >= this._reconnectionAttempts) {
    debug('reconnect failed');
    this.backoff.reset();
    this.emitAll('reconnect_failed');
    this.reconnecting = false;
  } else {
    var delay = this.backoff.duration();
    debug('will wait %dms before reconnect attempt', delay);

    this.reconnecting = true;
    var timer = setTimeout(function () {
      if (self.skipReconnect) return;

      debug('attempting reconnect');
      self.emitAll('reconnect_attempt', self.backoff.attempts);
      self.emitAll('reconnecting', self.backoff.attempts);

      // check again for the case socket closed in above events
      if (self.skipReconnect) return;

      self.open(function (err) {
        if (err) {
          debug('reconnect attempt error');
          self.reconnecting = false;
          self.reconnect();
          self.emitAll('reconnect_error', err.data);
        } else {
          debug('reconnect success');
          self.onreconnect();
        }
      });
    }, delay);

    this.subs.push({
      destroy: function () {
        clearTimeout(timer);
      }
    });
  }
};

/**
 * Called upon successful reconnect.
 *
 * @api private
 */

Manager.prototype.onreconnect = function () {
  var attempt = this.backoff.attempts;
  this.reconnecting = false;
  this.backoff.reset();
  this.updateSocketIds();
  this.emitAll('reconnect', attempt);
};


/***/ }),

/***/ 5652:
/***/ (function(module, exports, __webpack_require__) {


module.exports = __webpack_require__(5653);

/**
 * Exports parser
 *
 * @api public
 *
 */
module.exports.parser = __webpack_require__(5661);


/***/ }),

/***/ 5653:
/***/ (function(module, exports, __webpack_require__) {

/**
 * Module dependencies.
 */

var transports = __webpack_require__(5654);
var Emitter = __webpack_require__(5669);
var debug = __webpack_require__(5641)('engine.io-client:socket');
var index = __webpack_require__(5676);
var parser = __webpack_require__(5661);
var parseuri = __webpack_require__(5640);
var parseqs = __webpack_require__(5670);

/**
 * Module exports.
 */

module.exports = Socket;

/**
 * Socket constructor.
 *
 * @param {String|Object} uri or options
 * @param {Object} options
 * @api public
 */

function Socket (uri, opts) {
  if (!(this instanceof Socket)) return new Socket(uri, opts);

  opts = opts || {};

  if (uri && 'object' === typeof uri) {
    opts = uri;
    uri = null;
  }

  if (uri) {
    uri = parseuri(uri);
    opts.hostname = uri.host;
    opts.secure = uri.protocol === 'https' || uri.protocol === 'wss';
    opts.port = uri.port;
    if (uri.query) opts.query = uri.query;
  } else if (opts.host) {
    opts.hostname = parseuri(opts.host).host;
  }

  this.secure = null != opts.secure ? opts.secure
    : (typeof location !== 'undefined' && 'https:' === location.protocol);

  if (opts.hostname && !opts.port) {
    // if no port is specified manually, use the protocol default
    opts.port = this.secure ? '443' : '80';
  }

  this.agent = opts.agent || false;
  this.hostname = opts.hostname ||
    (typeof location !== 'undefined' ? location.hostname : 'localhost');
  this.port = opts.port || (typeof location !== 'undefined' && location.port
      ? location.port
      : (this.secure ? 443 : 80));
  this.query = opts.query || {};
  if ('string' === typeof this.query) this.query = parseqs.decode(this.query);
  this.upgrade = false !== opts.upgrade;
  this.path = (opts.path || '/engine.io').replace(/\/$/, '') + '/';
  this.forceJSONP = !!opts.forceJSONP;
  this.jsonp = false !== opts.jsonp;
  this.forceBase64 = !!opts.forceBase64;
  this.enablesXDR = !!opts.enablesXDR;
  this.withCredentials = false !== opts.withCredentials;
  this.timestampParam = opts.timestampParam || 't';
  this.timestampRequests = opts.timestampRequests;
  this.transports = opts.transports || ['polling', 'websocket'];
  this.transportOptions = opts.transportOptions || {};
  this.readyState = '';
  this.writeBuffer = [];
  this.prevBufferLen = 0;
  this.policyPort = opts.policyPort || 843;
  this.rememberUpgrade = opts.rememberUpgrade || false;
  this.binaryType = null;
  this.onlyBinaryUpgrades = opts.onlyBinaryUpgrades;
  this.perMessageDeflate = false !== opts.perMessageDeflate ? (opts.perMessageDeflate || {}) : false;

  if (true === this.perMessageDeflate) this.perMessageDeflate = {};
  if (this.perMessageDeflate && null == this.perMessageDeflate.threshold) {
    this.perMessageDeflate.threshold = 1024;
  }

  // SSL options for Node.js client
  this.pfx = opts.pfx || null;
  this.key = opts.key || null;
  this.passphrase = opts.passphrase || null;
  this.cert = opts.cert || null;
  this.ca = opts.ca || null;
  this.ciphers = opts.ciphers || null;
  this.rejectUnauthorized = opts.rejectUnauthorized === undefined ? true : opts.rejectUnauthorized;
  this.forceNode = !!opts.forceNode;

  // detect ReactNative environment
  this.isReactNative = (typeof navigator !== 'undefined' && typeof navigator.product === 'string' && navigator.product.toLowerCase() === 'reactnative');

  // other options for Node.js or ReactNative client
  if (typeof self === 'undefined' || this.isReactNative) {
    if (opts.extraHeaders && Object.keys(opts.extraHeaders).length > 0) {
      this.extraHeaders = opts.extraHeaders;
    }

    if (opts.localAddress) {
      this.localAddress = opts.localAddress;
    }
  }

  // set on handshake
  this.id = null;
  this.upgrades = null;
  this.pingInterval = null;
  this.pingTimeout = null;

  // set on heartbeat
  this.pingIntervalTimer = null;
  this.pingTimeoutTimer = null;

  this.open();
}

Socket.priorWebsocketSuccess = false;

/**
 * Mix in `Emitter`.
 */

Emitter(Socket.prototype);

/**
 * Protocol version.
 *
 * @api public
 */

Socket.protocol = parser.protocol; // this is an int

/**
 * Expose deps for legacy compatibility
 * and standalone browser access.
 */

Socket.Socket = Socket;
Socket.Transport = __webpack_require__(5660);
Socket.transports = __webpack_require__(5654);
Socket.parser = __webpack_require__(5661);

/**
 * Creates transport of the given type.
 *
 * @param {String} transport name
 * @return {Transport}
 * @api private
 */

Socket.prototype.createTransport = function (name) {
  debug('creating transport "%s"', name);
  var query = clone(this.query);

  // append engine.io protocol identifier
  query.EIO = parser.protocol;

  // transport name
  query.transport = name;

  // per-transport options
  var options = this.transportOptions[name] || {};

  // session id if we already have one
  if (this.id) query.sid = this.id;

  var transport = new transports[name]({
    query: query,
    socket: this,
    agent: options.agent || this.agent,
    hostname: options.hostname || this.hostname,
    port: options.port || this.port,
    secure: options.secure || this.secure,
    path: options.path || this.path,
    forceJSONP: options.forceJSONP || this.forceJSONP,
    jsonp: options.jsonp || this.jsonp,
    forceBase64: options.forceBase64 || this.forceBase64,
    enablesXDR: options.enablesXDR || this.enablesXDR,
    withCredentials: options.withCredentials || this.withCredentials,
    timestampRequests: options.timestampRequests || this.timestampRequests,
    timestampParam: options.timestampParam || this.timestampParam,
    policyPort: options.policyPort || this.policyPort,
    pfx: options.pfx || this.pfx,
    key: options.key || this.key,
    passphrase: options.passphrase || this.passphrase,
    cert: options.cert || this.cert,
    ca: options.ca || this.ca,
    ciphers: options.ciphers || this.ciphers,
    rejectUnauthorized: options.rejectUnauthorized || this.rejectUnauthorized,
    perMessageDeflate: options.perMessageDeflate || this.perMessageDeflate,
    extraHeaders: options.extraHeaders || this.extraHeaders,
    forceNode: options.forceNode || this.forceNode,
    localAddress: options.localAddress || this.localAddress,
    requestTimeout: options.requestTimeout || this.requestTimeout,
    protocols: options.protocols || void (0),
    isReactNative: this.isReactNative
  });

  return transport;
};

function clone (obj) {
  var o = {};
  for (var i in obj) {
    if (obj.hasOwnProperty(i)) {
      o[i] = obj[i];
    }
  }
  return o;
}

/**
 * Initializes transport to use and starts probe.
 *
 * @api private
 */
Socket.prototype.open = function () {
  var transport;
  if (this.rememberUpgrade && Socket.priorWebsocketSuccess && this.transports.indexOf('websocket') !== -1) {
    transport = 'websocket';
  } else if (0 === this.transports.length) {
    // Emit error on next tick so it can be listened to
    var self = this;
    setTimeout(function () {
      self.emit('error', 'No transports available');
    }, 0);
    return;
  } else {
    transport = this.transports[0];
  }
  this.readyState = 'opening';

  // Retry with the next transport if the transport is disabled (jsonp: false)
  try {
    transport = this.createTransport(transport);
  } catch (e) {
    this.transports.shift();
    this.open();
    return;
  }

  transport.open();
  this.setTransport(transport);
};

/**
 * Sets the current transport. Disables the existing one (if any).
 *
 * @api private
 */

Socket.prototype.setTransport = function (transport) {
  debug('setting transport %s', transport.name);
  var self = this;

  if (this.transport) {
    debug('clearing existing transport %s', this.transport.name);
    this.transport.removeAllListeners();
  }

  // set up transport
  this.transport = transport;

  // set up transport listeners
  transport
  .on('drain', function () {
    self.onDrain();
  })
  .on('packet', function (packet) {
    self.onPacket(packet);
  })
  .on('error', function (e) {
    self.onError(e);
  })
  .on('close', function () {
    self.onClose('transport close');
  });
};

/**
 * Probes a transport.
 *
 * @param {String} transport name
 * @api private
 */

Socket.prototype.probe = function (name) {
  debug('probing transport "%s"', name);
  var transport = this.createTransport(name, { probe: 1 });
  var failed = false;
  var self = this;

  Socket.priorWebsocketSuccess = false;

  function onTransportOpen () {
    if (self.onlyBinaryUpgrades) {
      var upgradeLosesBinary = !this.supportsBinary && self.transport.supportsBinary;
      failed = failed || upgradeLosesBinary;
    }
    if (failed) return;

    debug('probe transport "%s" opened', name);
    transport.send([{ type: 'ping', data: 'probe' }]);
    transport.once('packet', function (msg) {
      if (failed) return;
      if ('pong' === msg.type && 'probe' === msg.data) {
        debug('probe transport "%s" pong', name);
        self.upgrading = true;
        self.emit('upgrading', transport);
        if (!transport) return;
        Socket.priorWebsocketSuccess = 'websocket' === transport.name;

        debug('pausing current transport "%s"', self.transport.name);
        self.transport.pause(function () {
          if (failed) return;
          if ('closed' === self.readyState) return;
          debug('changing transport and sending upgrade packet');

          cleanup();

          self.setTransport(transport);
          transport.send([{ type: 'upgrade' }]);
          self.emit('upgrade', transport);
          transport = null;
          self.upgrading = false;
          self.flush();
        });
      } else {
        debug('probe transport "%s" failed', name);
        var err = new Error('probe error');
        err.transport = transport.name;
        self.emit('upgradeError', err);
      }
    });
  }

  function freezeTransport () {
    if (failed) return;

    // Any callback called by transport should be ignored since now
    failed = true;

    cleanup();

    transport.close();
    transport = null;
  }

  // Handle any error that happens while probing
  function onerror (err) {
    var error = new Error('probe error: ' + err);
    error.transport = transport.name;

    freezeTransport();

    debug('probe transport "%s" failed because of error: %s', name, err);

    self.emit('upgradeError', error);
  }

  function onTransportClose () {
    onerror('transport closed');
  }

  // When the socket is closed while we're probing
  function onclose () {
    onerror('socket closed');
  }

  // When the socket is upgraded while we're probing
  function onupgrade (to) {
    if (transport && to.name !== transport.name) {
      debug('"%s" works - aborting "%s"', to.name, transport.name);
      freezeTransport();
    }
  }

  // Remove all listeners on the transport and on self
  function cleanup () {
    transport.removeListener('open', onTransportOpen);
    transport.removeListener('error', onerror);
    transport.removeListener('close', onTransportClose);
    self.removeListener('close', onclose);
    self.removeListener('upgrading', onupgrade);
  }

  transport.once('open', onTransportOpen);
  transport.once('error', onerror);
  transport.once('close', onTransportClose);

  this.once('close', onclose);
  this.once('upgrading', onupgrade);

  transport.open();
};

/**
 * Called when connection is deemed open.
 *
 * @api public
 */

Socket.prototype.onOpen = function () {
  debug('socket open');
  this.readyState = 'open';
  Socket.priorWebsocketSuccess = 'websocket' === this.transport.name;
  this.emit('open');
  this.flush();

  // we check for `readyState` in case an `open`
  // listener already closed the socket
  if ('open' === this.readyState && this.upgrade && this.transport.pause) {
    debug('starting upgrade probes');
    for (var i = 0, l = this.upgrades.length; i < l; i++) {
      this.probe(this.upgrades[i]);
    }
  }
};

/**
 * Handles a packet.
 *
 * @api private
 */

Socket.prototype.onPacket = function (packet) {
  if ('opening' === this.readyState || 'open' === this.readyState ||
      'closing' === this.readyState) {
    debug('socket receive: type "%s", data "%s"', packet.type, packet.data);

    this.emit('packet', packet);

    // Socket is live - any packet counts
    this.emit('heartbeat');

    switch (packet.type) {
      case 'open':
        this.onHandshake(JSON.parse(packet.data));
        break;

      case 'pong':
        this.setPing();
        this.emit('pong');
        break;

      case 'error':
        var err = new Error('server error');
        err.code = packet.data;
        this.onError(err);
        break;

      case 'message':
        this.emit('data', packet.data);
        this.emit('message', packet.data);
        break;
    }
  } else {
    debug('packet received with socket readyState "%s"', this.readyState);
  }
};

/**
 * Called upon handshake completion.
 *
 * @param {Object} handshake obj
 * @api private
 */

Socket.prototype.onHandshake = function (data) {
  this.emit('handshake', data);
  this.id = data.sid;
  this.transport.query.sid = data.sid;
  this.upgrades = this.filterUpgrades(data.upgrades);
  this.pingInterval = data.pingInterval;
  this.pingTimeout = data.pingTimeout;
  this.onOpen();
  // In case open handler closes socket
  if ('closed' === this.readyState) return;
  this.setPing();

  // Prolong liveness of socket on heartbeat
  this.removeListener('heartbeat', this.onHeartbeat);
  this.on('heartbeat', this.onHeartbeat);
};

/**
 * Resets ping timeout.
 *
 * @api private
 */

Socket.prototype.onHeartbeat = function (timeout) {
  clearTimeout(this.pingTimeoutTimer);
  var self = this;
  self.pingTimeoutTimer = setTimeout(function () {
    if ('closed' === self.readyState) return;
    self.onClose('ping timeout');
  }, timeout || (self.pingInterval + self.pingTimeout));
};

/**
 * Pings server every `this.pingInterval` and expects response
 * within `this.pingTimeout` or closes connection.
 *
 * @api private
 */

Socket.prototype.setPing = function () {
  var self = this;
  clearTimeout(self.pingIntervalTimer);
  self.pingIntervalTimer = setTimeout(function () {
    debug('writing ping packet - expecting pong within %sms', self.pingTimeout);
    self.ping();
    self.onHeartbeat(self.pingTimeout);
  }, self.pingInterval);
};

/**
* Sends a ping packet.
*
* @api private
*/

Socket.prototype.ping = function () {
  var self = this;
  this.sendPacket('ping', function () {
    self.emit('ping');
  });
};

/**
 * Called on `drain` event
 *
 * @api private
 */

Socket.prototype.onDrain = function () {
  this.writeBuffer.splice(0, this.prevBufferLen);

  // setting prevBufferLen = 0 is very important
  // for example, when upgrading, upgrade packet is sent over,
  // and a nonzero prevBufferLen could cause problems on `drain`
  this.prevBufferLen = 0;

  if (0 === this.writeBuffer.length) {
    this.emit('drain');
  } else {
    this.flush();
  }
};

/**
 * Flush write buffers.
 *
 * @api private
 */

Socket.prototype.flush = function () {
  if ('closed' !== this.readyState && this.transport.writable &&
    !this.upgrading && this.writeBuffer.length) {
    debug('flushing %d packets in socket', this.writeBuffer.length);
    this.transport.send(this.writeBuffer);
    // keep track of current length of writeBuffer
    // splice writeBuffer and callbackBuffer on `drain`
    this.prevBufferLen = this.writeBuffer.length;
    this.emit('flush');
  }
};

/**
 * Sends a message.
 *
 * @param {String} message.
 * @param {Function} callback function.
 * @param {Object} options.
 * @return {Socket} for chaining.
 * @api public
 */

Socket.prototype.write =
Socket.prototype.send = function (msg, options, fn) {
  this.sendPacket('message', msg, options, fn);
  return this;
};

/**
 * Sends a packet.
 *
 * @param {String} packet type.
 * @param {String} data.
 * @param {Object} options.
 * @param {Function} callback function.
 * @api private
 */

Socket.prototype.sendPacket = function (type, data, options, fn) {
  if ('function' === typeof data) {
    fn = data;
    data = undefined;
  }

  if ('function' === typeof options) {
    fn = options;
    options = null;
  }

  if ('closing' === this.readyState || 'closed' === this.readyState) {
    return;
  }

  options = options || {};
  options.compress = false !== options.compress;

  var packet = {
    type: type,
    data: data,
    options: options
  };
  this.emit('packetCreate', packet);
  this.writeBuffer.push(packet);
  if (fn) this.once('flush', fn);
  this.flush();
};

/**
 * Closes the connection.
 *
 * @api private
 */

Socket.prototype.close = function () {
  if ('opening' === this.readyState || 'open' === this.readyState) {
    this.readyState = 'closing';

    var self = this;

    if (this.writeBuffer.length) {
      this.once('drain', function () {
        if (this.upgrading) {
          waitForUpgrade();
        } else {
          close();
        }
      });
    } else if (this.upgrading) {
      waitForUpgrade();
    } else {
      close();
    }
  }

  function close () {
    self.onClose('forced close');
    debug('socket closing - telling transport to close');
    self.transport.close();
  }

  function cleanupAndClose () {
    self.removeListener('upgrade', cleanupAndClose);
    self.removeListener('upgradeError', cleanupAndClose);
    close();
  }

  function waitForUpgrade () {
    // wait for upgrade to finish since we can't send packets while pausing a transport
    self.once('upgrade', cleanupAndClose);
    self.once('upgradeError', cleanupAndClose);
  }

  return this;
};

/**
 * Called upon transport error
 *
 * @api private
 */

Socket.prototype.onError = function (err) {
  debug('socket error %j', err);
  Socket.priorWebsocketSuccess = false;
  this.emit('error', err);
  this.onClose('transport error', err);
};

/**
 * Called upon transport close.
 *
 * @api private
 */

Socket.prototype.onClose = function (reason, desc) {
  if ('opening' === this.readyState || 'open' === this.readyState || 'closing' === this.readyState) {
    debug('socket close with reason: "%s"', reason);
    var self = this;

    // clear timers
    clearTimeout(this.pingIntervalTimer);
    clearTimeout(this.pingTimeoutTimer);

    // stop event from firing again for transport
    this.transport.removeAllListeners('close');

    // ensure transport won't stay open
    this.transport.close();

    // ignore further transport communication
    this.transport.removeAllListeners();

    // set ready state
    this.readyState = 'closed';

    // clear session id
    this.id = null;

    // emit close event
    this.emit('close', reason, desc);

    // clean buffers after, so users can still
    // grab the buffers on `close` event
    self.writeBuffer = [];
    self.prevBufferLen = 0;
  }
};

/**
 * Filters upgrades, returning only those matching client transports.
 *
 * @param {Array} server upgrades
 * @api private
 *
 */

Socket.prototype.filterUpgrades = function (upgrades) {
  var filteredUpgrades = [];
  for (var i = 0, j = upgrades.length; i < j; i++) {
    if (~index(this.transports, upgrades[i])) filteredUpgrades.push(upgrades[i]);
  }
  return filteredUpgrades;
};


/***/ }),

/***/ 5654:
/***/ (function(module, exports, __webpack_require__) {

/**
 * Module dependencies
 */

var XMLHttpRequest = __webpack_require__(5655);
var XHR = __webpack_require__(5658);
var JSONP = __webpack_require__(5673);
var websocket = __webpack_require__(5674);

/**
 * Export transports.
 */

exports.polling = polling;
exports.websocket = websocket;

/**
 * Polling transport polymorphic constructor.
 * Decides on xhr vs jsonp based on feature detection.
 *
 * @api private
 */

function polling (opts) {
  var xhr;
  var xd = false;
  var xs = false;
  var jsonp = false !== opts.jsonp;

  if (typeof location !== 'undefined') {
    var isSSL = 'https:' === location.protocol;
    var port = location.port;

    // some user agents have empty `location.port`
    if (!port) {
      port = isSSL ? 443 : 80;
    }

    xd = opts.hostname !== location.hostname || port !== opts.port;
    xs = opts.secure !== isSSL;
  }

  opts.xdomain = xd;
  opts.xscheme = xs;
  xhr = new XMLHttpRequest(opts);

  if ('open' in xhr && !opts.forceJSONP) {
    return new XHR(opts);
  } else {
    if (!jsonp) throw new Error('JSONP disabled');
    return new JSONP(opts);
  }
}


/***/ }),

/***/ 5655:
/***/ (function(module, exports, __webpack_require__) {

// browser shim for xmlhttprequest module

var hasCORS = __webpack_require__(5656);
var globalThis = __webpack_require__(5657);

module.exports = function (opts) {
  var xdomain = opts.xdomain;

  // scheme must be same when usign XDomainRequest
  // http://blogs.msdn.com/b/ieinternals/archive/2010/05/13/xdomainrequest-restrictions-limitations-and-workarounds.aspx
  var xscheme = opts.xscheme;

  // XDomainRequest has a flow of not sending cookie, therefore it should be disabled as a default.
  // https://github.com/Automattic/engine.io-client/pull/217
  var enablesXDR = opts.enablesXDR;

  // XMLHttpRequest can be disabled on IE
  try {
    if ('undefined' !== typeof XMLHttpRequest && (!xdomain || hasCORS)) {
      return new XMLHttpRequest();
    }
  } catch (e) { }

  // Use XDomainRequest for IE8 if enablesXDR is true
  // because loading bar keeps flashing when using jsonp-polling
  // https://github.com/yujiosaka/socke.io-ie8-loading-example
  try {
    if ('undefined' !== typeof XDomainRequest && !xscheme && enablesXDR) {
      return new XDomainRequest();
    }
  } catch (e) { }

  if (!xdomain) {
    try {
      return new globalThis[['Active'].concat('Object').join('X')]('Microsoft.XMLHTTP');
    } catch (e) { }
  }
};


/***/ }),

/***/ 5656:
/***/ (function(module, exports) {


/**
 * Module exports.
 *
 * Logic borrowed from Modernizr:
 *
 *   - https://github.com/Modernizr/Modernizr/blob/master/feature-detects/cors.js
 */

try {
  module.exports = typeof XMLHttpRequest !== 'undefined' &&
    'withCredentials' in new XMLHttpRequest();
} catch (err) {
  // if XMLHttp support is disabled in IE then it will throw
  // when trying to create
  module.exports = false;
}


/***/ }),

/***/ 5657:
/***/ (function(module, exports) {

module.exports = (function () {
  if (typeof self !== 'undefined') {
    return self;
  } else if (typeof window !== 'undefined') {
    return window;
  } else {
    return Function('return this')(); // eslint-disable-line no-new-func
  }
})();


/***/ }),

/***/ 5658:
/***/ (function(module, exports, __webpack_require__) {

/* global attachEvent */

/**
 * Module requirements.
 */

var XMLHttpRequest = __webpack_require__(5655);
var Polling = __webpack_require__(5659);
var Emitter = __webpack_require__(5669);
var inherit = __webpack_require__(5671);
var debug = __webpack_require__(5641)('engine.io-client:polling-xhr');
var globalThis = __webpack_require__(5657);

/**
 * Module exports.
 */

module.exports = XHR;
module.exports.Request = Request;

/**
 * Empty function
 */

function empty () {}

/**
 * XHR Polling constructor.
 *
 * @param {Object} opts
 * @api public
 */

function XHR (opts) {
  Polling.call(this, opts);
  this.requestTimeout = opts.requestTimeout;
  this.extraHeaders = opts.extraHeaders;

  if (typeof location !== 'undefined') {
    var isSSL = 'https:' === location.protocol;
    var port = location.port;

    // some user agents have empty `location.port`
    if (!port) {
      port = isSSL ? 443 : 80;
    }

    this.xd = (typeof location !== 'undefined' && opts.hostname !== location.hostname) ||
      port !== opts.port;
    this.xs = opts.secure !== isSSL;
  }
}

/**
 * Inherits from Polling.
 */

inherit(XHR, Polling);

/**
 * XHR supports binary
 */

XHR.prototype.supportsBinary = true;

/**
 * Creates a request.
 *
 * @param {String} method
 * @api private
 */

XHR.prototype.request = function (opts) {
  opts = opts || {};
  opts.uri = this.uri();
  opts.xd = this.xd;
  opts.xs = this.xs;
  opts.agent = this.agent || false;
  opts.supportsBinary = this.supportsBinary;
  opts.enablesXDR = this.enablesXDR;
  opts.withCredentials = this.withCredentials;

  // SSL options for Node.js client
  opts.pfx = this.pfx;
  opts.key = this.key;
  opts.passphrase = this.passphrase;
  opts.cert = this.cert;
  opts.ca = this.ca;
  opts.ciphers = this.ciphers;
  opts.rejectUnauthorized = this.rejectUnauthorized;
  opts.requestTimeout = this.requestTimeout;

  // other options for Node.js client
  opts.extraHeaders = this.extraHeaders;

  return new Request(opts);
};

/**
 * Sends data.
 *
 * @param {String} data to send.
 * @param {Function} called upon flush.
 * @api private
 */

XHR.prototype.doWrite = function (data, fn) {
  var isBinary = typeof data !== 'string' && data !== undefined;
  var req = this.request({ method: 'POST', data: data, isBinary: isBinary });
  var self = this;
  req.on('success', fn);
  req.on('error', function (err) {
    self.onError('xhr post error', err);
  });
  this.sendXhr = req;
};

/**
 * Starts a poll cycle.
 *
 * @api private
 */

XHR.prototype.doPoll = function () {
  debug('xhr poll');
  var req = this.request();
  var self = this;
  req.on('data', function (data) {
    self.onData(data);
  });
  req.on('error', function (err) {
    self.onError('xhr poll error', err);
  });
  this.pollXhr = req;
};

/**
 * Request constructor
 *
 * @param {Object} options
 * @api public
 */

function Request (opts) {
  this.method = opts.method || 'GET';
  this.uri = opts.uri;
  this.xd = !!opts.xd;
  this.xs = !!opts.xs;
  this.async = false !== opts.async;
  this.data = undefined !== opts.data ? opts.data : null;
  this.agent = opts.agent;
  this.isBinary = opts.isBinary;
  this.supportsBinary = opts.supportsBinary;
  this.enablesXDR = opts.enablesXDR;
  this.withCredentials = opts.withCredentials;
  this.requestTimeout = opts.requestTimeout;

  // SSL options for Node.js client
  this.pfx = opts.pfx;
  this.key = opts.key;
  this.passphrase = opts.passphrase;
  this.cert = opts.cert;
  this.ca = opts.ca;
  this.ciphers = opts.ciphers;
  this.rejectUnauthorized = opts.rejectUnauthorized;

  // other options for Node.js client
  this.extraHeaders = opts.extraHeaders;

  this.create();
}

/**
 * Mix in `Emitter`.
 */

Emitter(Request.prototype);

/**
 * Creates the XHR object and sends the request.
 *
 * @api private
 */

Request.prototype.create = function () {
  var opts = { agent: this.agent, xdomain: this.xd, xscheme: this.xs, enablesXDR: this.enablesXDR };

  // SSL options for Node.js client
  opts.pfx = this.pfx;
  opts.key = this.key;
  opts.passphrase = this.passphrase;
  opts.cert = this.cert;
  opts.ca = this.ca;
  opts.ciphers = this.ciphers;
  opts.rejectUnauthorized = this.rejectUnauthorized;

  var xhr = this.xhr = new XMLHttpRequest(opts);
  var self = this;

  try {
    debug('xhr open %s: %s', this.method, this.uri);
    xhr.open(this.method, this.uri, this.async);
    try {
      if (this.extraHeaders) {
        xhr.setDisableHeaderCheck && xhr.setDisableHeaderCheck(true);
        for (var i in this.extraHeaders) {
          if (this.extraHeaders.hasOwnProperty(i)) {
            xhr.setRequestHeader(i, this.extraHeaders[i]);
          }
        }
      }
    } catch (e) {}

    if ('POST' === this.method) {
      try {
        if (this.isBinary) {
          xhr.setRequestHeader('Content-type', 'application/octet-stream');
        } else {
          xhr.setRequestHeader('Content-type', 'text/plain;charset=UTF-8');
        }
      } catch (e) {}
    }

    try {
      xhr.setRequestHeader('Accept', '*/*');
    } catch (e) {}

    // ie6 check
    if ('withCredentials' in xhr) {
      xhr.withCredentials = this.withCredentials;
    }

    if (this.requestTimeout) {
      xhr.timeout = this.requestTimeout;
    }

    if (this.hasXDR()) {
      xhr.onload = function () {
        self.onLoad();
      };
      xhr.onerror = function () {
        self.onError(xhr.responseText);
      };
    } else {
      xhr.onreadystatechange = function () {
        if (xhr.readyState === 2) {
          try {
            var contentType = xhr.getResponseHeader('Content-Type');
            if (self.supportsBinary && contentType === 'application/octet-stream' || contentType === 'application/octet-stream; charset=UTF-8') {
              xhr.responseType = 'arraybuffer';
            }
          } catch (e) {}
        }
        if (4 !== xhr.readyState) return;
        if (200 === xhr.status || 1223 === xhr.status) {
          self.onLoad();
        } else {
          // make sure the `error` event handler that's user-set
          // does not throw in the same tick and gets caught here
          setTimeout(function () {
            self.onError(typeof xhr.status === 'number' ? xhr.status : 0);
          }, 0);
        }
      };
    }

    debug('xhr data %s', this.data);
    xhr.send(this.data);
  } catch (e) {
    // Need to defer since .create() is called directly fhrom the constructor
    // and thus the 'error' event can only be only bound *after* this exception
    // occurs.  Therefore, also, we cannot throw here at all.
    setTimeout(function () {
      self.onError(e);
    }, 0);
    return;
  }

  if (typeof document !== 'undefined') {
    this.index = Request.requestsCount++;
    Request.requests[this.index] = this;
  }
};

/**
 * Called upon successful response.
 *
 * @api private
 */

Request.prototype.onSuccess = function () {
  this.emit('success');
  this.cleanup();
};

/**
 * Called if we have data.
 *
 * @api private
 */

Request.prototype.onData = function (data) {
  this.emit('data', data);
  this.onSuccess();
};

/**
 * Called upon error.
 *
 * @api private
 */

Request.prototype.onError = function (err) {
  this.emit('error', err);
  this.cleanup(true);
};

/**
 * Cleans up house.
 *
 * @api private
 */

Request.prototype.cleanup = function (fromError) {
  if ('undefined' === typeof this.xhr || null === this.xhr) {
    return;
  }
  // xmlhttprequest
  if (this.hasXDR()) {
    this.xhr.onload = this.xhr.onerror = empty;
  } else {
    this.xhr.onreadystatechange = empty;
  }

  if (fromError) {
    try {
      this.xhr.abort();
    } catch (e) {}
  }

  if (typeof document !== 'undefined') {
    delete Request.requests[this.index];
  }

  this.xhr = null;
};

/**
 * Called upon load.
 *
 * @api private
 */

Request.prototype.onLoad = function () {
  var data;
  try {
    var contentType;
    try {
      contentType = this.xhr.getResponseHeader('Content-Type');
    } catch (e) {}
    if (contentType === 'application/octet-stream' || contentType === 'application/octet-stream; charset=UTF-8') {
      data = this.xhr.response || this.xhr.responseText;
    } else {
      data = this.xhr.responseText;
    }
  } catch (e) {
    this.onError(e);
  }
  if (null != data) {
    this.onData(data);
  }
};

/**
 * Check if it has XDomainRequest.
 *
 * @api private
 */

Request.prototype.hasXDR = function () {
  return typeof XDomainRequest !== 'undefined' && !this.xs && this.enablesXDR;
};

/**
 * Aborts the request.
 *
 * @api public
 */

Request.prototype.abort = function () {
  this.cleanup();
};

/**
 * Aborts pending requests when unloading the window. This is needed to prevent
 * memory leaks (e.g. when using IE) and to ensure that no spurious error is
 * emitted.
 */

Request.requestsCount = 0;
Request.requests = {};

if (typeof document !== 'undefined') {
  if (typeof attachEvent === 'function') {
    attachEvent('onunload', unloadHandler);
  } else if (typeof addEventListener === 'function') {
    var terminationEvent = 'onpagehide' in globalThis ? 'pagehide' : 'unload';
    addEventListener(terminationEvent, unloadHandler, false);
  }
}

function unloadHandler () {
  for (var i in Request.requests) {
    if (Request.requests.hasOwnProperty(i)) {
      Request.requests[i].abort();
    }
  }
}


/***/ }),

/***/ 5659:
/***/ (function(module, exports, __webpack_require__) {

/**
 * Module dependencies.
 */

var Transport = __webpack_require__(5660);
var parseqs = __webpack_require__(5670);
var parser = __webpack_require__(5661);
var inherit = __webpack_require__(5671);
var yeast = __webpack_require__(5672);
var debug = __webpack_require__(5641)('engine.io-client:polling');

/**
 * Module exports.
 */

module.exports = Polling;

/**
 * Is XHR2 supported?
 */

var hasXHR2 = (function () {
  var XMLHttpRequest = __webpack_require__(5655);
  var xhr = new XMLHttpRequest({ xdomain: false });
  return null != xhr.responseType;
})();

/**
 * Polling interface.
 *
 * @param {Object} opts
 * @api private
 */

function Polling (opts) {
  var forceBase64 = (opts && opts.forceBase64);
  if (!hasXHR2 || forceBase64) {
    this.supportsBinary = false;
  }
  Transport.call(this, opts);
}

/**
 * Inherits from Transport.
 */

inherit(Polling, Transport);

/**
 * Transport name.
 */

Polling.prototype.name = 'polling';

/**
 * Opens the socket (triggers polling). We write a PING message to determine
 * when the transport is open.
 *
 * @api private
 */

Polling.prototype.doOpen = function () {
  this.poll();
};

/**
 * Pauses polling.
 *
 * @param {Function} callback upon buffers are flushed and transport is paused
 * @api private
 */

Polling.prototype.pause = function (onPause) {
  var self = this;

  this.readyState = 'pausing';

  function pause () {
    debug('paused');
    self.readyState = 'paused';
    onPause();
  }

  if (this.polling || !this.writable) {
    var total = 0;

    if (this.polling) {
      debug('we are currently polling - waiting to pause');
      total++;
      this.once('pollComplete', function () {
        debug('pre-pause polling complete');
        --total || pause();
      });
    }

    if (!this.writable) {
      debug('we are currently writing - waiting to pause');
      total++;
      this.once('drain', function () {
        debug('pre-pause writing complete');
        --total || pause();
      });
    }
  } else {
    pause();
  }
};

/**
 * Starts polling cycle.
 *
 * @api public
 */

Polling.prototype.poll = function () {
  debug('polling');
  this.polling = true;
  this.doPoll();
  this.emit('poll');
};

/**
 * Overloads onData to detect payloads.
 *
 * @api private
 */

Polling.prototype.onData = function (data) {
  var self = this;
  debug('polling got data %s', data);
  var callback = function (packet, index, total) {
    // if its the first message we consider the transport open
    if ('opening' === self.readyState) {
      self.onOpen();
    }

    // if its a close packet, we close the ongoing requests
    if ('close' === packet.type) {
      self.onClose();
      return false;
    }

    // otherwise bypass onData and handle the message
    self.onPacket(packet);
  };

  // decode payload
  parser.decodePayload(data, this.socket.binaryType, callback);

  // if an event did not trigger closing
  if ('closed' !== this.readyState) {
    // if we got data we're not polling
    this.polling = false;
    this.emit('pollComplete');

    if ('open' === this.readyState) {
      this.poll();
    } else {
      debug('ignoring poll - transport state "%s"', this.readyState);
    }
  }
};

/**
 * For polling, send a close packet.
 *
 * @api private
 */

Polling.prototype.doClose = function () {
  var self = this;

  function close () {
    debug('writing close packet');
    self.write([{ type: 'close' }]);
  }

  if ('open' === this.readyState) {
    debug('transport open - closing');
    close();
  } else {
    // in case we're trying to close while
    // handshaking is in progress (GH-164)
    debug('transport not open - deferring close');
    this.once('open', close);
  }
};

/**
 * Writes a packets payload.
 *
 * @param {Array} data packets
 * @param {Function} drain callback
 * @api private
 */

Polling.prototype.write = function (packets) {
  var self = this;
  this.writable = false;
  var callbackfn = function () {
    self.writable = true;
    self.emit('drain');
  };

  parser.encodePayload(packets, this.supportsBinary, function (data) {
    self.doWrite(data, callbackfn);
  });
};

/**
 * Generates uri for connection.
 *
 * @api private
 */

Polling.prototype.uri = function () {
  var query = this.query || {};
  var schema = this.secure ? 'https' : 'http';
  var port = '';

  // cache busting is forced
  if (false !== this.timestampRequests) {
    query[this.timestampParam] = yeast();
  }

  if (!this.supportsBinary && !query.sid) {
    query.b64 = 1;
  }

  query = parseqs.encode(query);

  // avoid port if default for schema
  if (this.port && (('https' === schema && Number(this.port) !== 443) ||
     ('http' === schema && Number(this.port) !== 80))) {
    port = ':' + this.port;
  }

  // prepend ? to query
  if (query.length) {
    query = '?' + query;
  }

  var ipv6 = this.hostname.indexOf(':') !== -1;
  return schema + '://' + (ipv6 ? '[' + this.hostname + ']' : this.hostname) + port + this.path + query;
};


/***/ }),

/***/ 5660:
/***/ (function(module, exports, __webpack_require__) {

/**
 * Module dependencies.
 */

var parser = __webpack_require__(5661);
var Emitter = __webpack_require__(5669);

/**
 * Module exports.
 */

module.exports = Transport;

/**
 * Transport abstract constructor.
 *
 * @param {Object} options.
 * @api private
 */

function Transport (opts) {
  this.path = opts.path;
  this.hostname = opts.hostname;
  this.port = opts.port;
  this.secure = opts.secure;
  this.query = opts.query;
  this.timestampParam = opts.timestampParam;
  this.timestampRequests = opts.timestampRequests;
  this.readyState = '';
  this.agent = opts.agent || false;
  this.socket = opts.socket;
  this.enablesXDR = opts.enablesXDR;
  this.withCredentials = opts.withCredentials;

  // SSL options for Node.js client
  this.pfx = opts.pfx;
  this.key = opts.key;
  this.passphrase = opts.passphrase;
  this.cert = opts.cert;
  this.ca = opts.ca;
  this.ciphers = opts.ciphers;
  this.rejectUnauthorized = opts.rejectUnauthorized;
  this.forceNode = opts.forceNode;

  // results of ReactNative environment detection
  this.isReactNative = opts.isReactNative;

  // other options for Node.js client
  this.extraHeaders = opts.extraHeaders;
  this.localAddress = opts.localAddress;
}

/**
 * Mix in `Emitter`.
 */

Emitter(Transport.prototype);

/**
 * Emits an error.
 *
 * @param {String} str
 * @return {Transport} for chaining
 * @api public
 */

Transport.prototype.onError = function (msg, desc) {
  var err = new Error(msg);
  err.type = 'TransportError';
  err.description = desc;
  this.emit('error', err);
  return this;
};

/**
 * Opens the transport.
 *
 * @api public
 */

Transport.prototype.open = function () {
  if ('closed' === this.readyState || '' === this.readyState) {
    this.readyState = 'opening';
    this.doOpen();
  }

  return this;
};

/**
 * Closes the transport.
 *
 * @api private
 */

Transport.prototype.close = function () {
  if ('opening' === this.readyState || 'open' === this.readyState) {
    this.doClose();
    this.onClose();
  }

  return this;
};

/**
 * Sends multiple packets.
 *
 * @param {Array} packets
 * @api private
 */

Transport.prototype.send = function (packets) {
  if ('open' === this.readyState) {
    this.write(packets);
  } else {
    throw new Error('Transport not open');
  }
};

/**
 * Called upon open
 *
 * @api private
 */

Transport.prototype.onOpen = function () {
  this.readyState = 'open';
  this.writable = true;
  this.emit('open');
};

/**
 * Called with data.
 *
 * @param {String} data
 * @api private
 */

Transport.prototype.onData = function (data) {
  var packet = parser.decodePacket(data, this.socket.binaryType);
  this.onPacket(packet);
};

/**
 * Called with a decoded packet.
 */

Transport.prototype.onPacket = function (packet) {
  this.emit('packet', packet);
};

/**
 * Called upon close.
 *
 * @api private
 */

Transport.prototype.onClose = function () {
  this.readyState = 'closed';
  this.emit('close');
};


/***/ }),

/***/ 5661:
/***/ (function(module, exports, __webpack_require__) {

/**
 * Module dependencies.
 */

var keys = __webpack_require__(5662);
var hasBinary = __webpack_require__(5663);
var sliceBuffer = __webpack_require__(5665);
var after = __webpack_require__(5666);
var utf8 = __webpack_require__(5667);

var base64encoder;
if (typeof ArrayBuffer !== 'undefined') {
  base64encoder = __webpack_require__(5592);
}

/**
 * Check if we are running an android browser. That requires us to use
 * ArrayBuffer with polling transports...
 *
 * http://ghinda.net/jpeg-blob-ajax-android/
 */

var isAndroid = typeof navigator !== 'undefined' && /Android/i.test(navigator.userAgent);

/**
 * Check if we are running in PhantomJS.
 * Uploading a Blob with PhantomJS does not work correctly, as reported here:
 * https://github.com/ariya/phantomjs/issues/11395
 * @type boolean
 */
var isPhantomJS = typeof navigator !== 'undefined' && /PhantomJS/i.test(navigator.userAgent);

/**
 * When true, avoids using Blobs to encode payloads.
 * @type boolean
 */
var dontSendBlobs = isAndroid || isPhantomJS;

/**
 * Current protocol version.
 */

exports.protocol = 3;

/**
 * Packet types.
 */

var packets = exports.packets = {
    open:     0    // non-ws
  , close:    1    // non-ws
  , ping:     2
  , pong:     3
  , message:  4
  , upgrade:  5
  , noop:     6
};

var packetslist = keys(packets);

/**
 * Premade error packet.
 */

var err = { type: 'error', data: 'parser error' };

/**
 * Create a blob api even for blob builder when vendor prefixes exist
 */

var Blob = __webpack_require__(5668);

/**
 * Encodes a packet.
 *
 *     <packet type id> [ <data> ]
 *
 * Example:
 *
 *     5hello world
 *     3
 *     4
 *
 * Binary is encoded in an identical principle
 *
 * @api private
 */

exports.encodePacket = function (packet, supportsBinary, utf8encode, callback) {
  if (typeof supportsBinary === 'function') {
    callback = supportsBinary;
    supportsBinary = false;
  }

  if (typeof utf8encode === 'function') {
    callback = utf8encode;
    utf8encode = null;
  }

  var data = (packet.data === undefined)
    ? undefined
    : packet.data.buffer || packet.data;

  if (typeof ArrayBuffer !== 'undefined' && data instanceof ArrayBuffer) {
    return encodeArrayBuffer(packet, supportsBinary, callback);
  } else if (typeof Blob !== 'undefined' && data instanceof Blob) {
    return encodeBlob(packet, supportsBinary, callback);
  }

  // might be an object with { base64: true, data: dataAsBase64String }
  if (data && data.base64) {
    return encodeBase64Object(packet, callback);
  }

  // Sending data as a utf-8 string
  var encoded = packets[packet.type];

  // data fragment is optional
  if (undefined !== packet.data) {
    encoded += utf8encode ? utf8.encode(String(packet.data), { strict: false }) : String(packet.data);
  }

  return callback('' + encoded);

};

function encodeBase64Object(packet, callback) {
  // packet data is an object { base64: true, data: dataAsBase64String }
  var message = 'b' + exports.packets[packet.type] + packet.data.data;
  return callback(message);
}

/**
 * Encode packet helpers for binary types
 */

function encodeArrayBuffer(packet, supportsBinary, callback) {
  if (!supportsBinary) {
    return exports.encodeBase64Packet(packet, callback);
  }

  var data = packet.data;
  var contentArray = new Uint8Array(data);
  var resultBuffer = new Uint8Array(1 + data.byteLength);

  resultBuffer[0] = packets[packet.type];
  for (var i = 0; i < contentArray.length; i++) {
    resultBuffer[i+1] = contentArray[i];
  }

  return callback(resultBuffer.buffer);
}

function encodeBlobAsArrayBuffer(packet, supportsBinary, callback) {
  if (!supportsBinary) {
    return exports.encodeBase64Packet(packet, callback);
  }

  var fr = new FileReader();
  fr.onload = function() {
    exports.encodePacket({ type: packet.type, data: fr.result }, supportsBinary, true, callback);
  };
  return fr.readAsArrayBuffer(packet.data);
}

function encodeBlob(packet, supportsBinary, callback) {
  if (!supportsBinary) {
    return exports.encodeBase64Packet(packet, callback);
  }

  if (dontSendBlobs) {
    return encodeBlobAsArrayBuffer(packet, supportsBinary, callback);
  }

  var length = new Uint8Array(1);
  length[0] = packets[packet.type];
  var blob = new Blob([length.buffer, packet.data]);

  return callback(blob);
}

/**
 * Encodes a packet with binary data in a base64 string
 *
 * @param {Object} packet, has `type` and `data`
 * @return {String} base64 encoded message
 */

exports.encodeBase64Packet = function(packet, callback) {
  var message = 'b' + exports.packets[packet.type];
  if (typeof Blob !== 'undefined' && packet.data instanceof Blob) {
    var fr = new FileReader();
    fr.onload = function() {
      var b64 = fr.result.split(',')[1];
      callback(message + b64);
    };
    return fr.readAsDataURL(packet.data);
  }

  var b64data;
  try {
    b64data = String.fromCharCode.apply(null, new Uint8Array(packet.data));
  } catch (e) {
    // iPhone Safari doesn't let you apply with typed arrays
    var typed = new Uint8Array(packet.data);
    var basic = new Array(typed.length);
    for (var i = 0; i < typed.length; i++) {
      basic[i] = typed[i];
    }
    b64data = String.fromCharCode.apply(null, basic);
  }
  message += btoa(b64data);
  return callback(message);
};

/**
 * Decodes a packet. Changes format to Blob if requested.
 *
 * @return {Object} with `type` and `data` (if any)
 * @api private
 */

exports.decodePacket = function (data, binaryType, utf8decode) {
  if (data === undefined) {
    return err;
  }
  // String data
  if (typeof data === 'string') {
    if (data.charAt(0) === 'b') {
      return exports.decodeBase64Packet(data.substr(1), binaryType);
    }

    if (utf8decode) {
      data = tryDecode(data);
      if (data === false) {
        return err;
      }
    }
    var type = data.charAt(0);

    if (Number(type) != type || !packetslist[type]) {
      return err;
    }

    if (data.length > 1) {
      return { type: packetslist[type], data: data.substring(1) };
    } else {
      return { type: packetslist[type] };
    }
  }

  var asArray = new Uint8Array(data);
  var type = asArray[0];
  var rest = sliceBuffer(data, 1);
  if (Blob && binaryType === 'blob') {
    rest = new Blob([rest]);
  }
  return { type: packetslist[type], data: rest };
};

function tryDecode(data) {
  try {
    data = utf8.decode(data, { strict: false });
  } catch (e) {
    return false;
  }
  return data;
}

/**
 * Decodes a packet encoded in a base64 string
 *
 * @param {String} base64 encoded message
 * @return {Object} with `type` and `data` (if any)
 */

exports.decodeBase64Packet = function(msg, binaryType) {
  var type = packetslist[msg.charAt(0)];
  if (!base64encoder) {
    return { type: type, data: { base64: true, data: msg.substr(1) } };
  }

  var data = base64encoder.decode(msg.substr(1));

  if (binaryType === 'blob' && Blob) {
    data = new Blob([data]);
  }

  return { type: type, data: data };
};

/**
 * Encodes multiple messages (payload).
 *
 *     <length>:data
 *
 * Example:
 *
 *     11:hello world2:hi
 *
 * If any contents are binary, they will be encoded as base64 strings. Base64
 * encoded strings are marked with a b before the length specifier
 *
 * @param {Array} packets
 * @api private
 */

exports.encodePayload = function (packets, supportsBinary, callback) {
  if (typeof supportsBinary === 'function') {
    callback = supportsBinary;
    supportsBinary = null;
  }

  var isBinary = hasBinary(packets);

  if (supportsBinary && isBinary) {
    if (Blob && !dontSendBlobs) {
      return exports.encodePayloadAsBlob(packets, callback);
    }

    return exports.encodePayloadAsArrayBuffer(packets, callback);
  }

  if (!packets.length) {
    return callback('0:');
  }

  function setLengthHeader(message) {
    return message.length + ':' + message;
  }

  function encodeOne(packet, doneCallback) {
    exports.encodePacket(packet, !isBinary ? false : supportsBinary, false, function(message) {
      doneCallback(null, setLengthHeader(message));
    });
  }

  map(packets, encodeOne, function(err, results) {
    return callback(results.join(''));
  });
};

/**
 * Async array map using after
 */

function map(ary, each, done) {
  var result = new Array(ary.length);
  var next = after(ary.length, done);

  var eachWithIndex = function(i, el, cb) {
    each(el, function(error, msg) {
      result[i] = msg;
      cb(error, result);
    });
  };

  for (var i = 0; i < ary.length; i++) {
    eachWithIndex(i, ary[i], next);
  }
}

/*
 * Decodes data when a payload is maybe expected. Possible binary contents are
 * decoded from their base64 representation
 *
 * @param {String} data, callback method
 * @api public
 */

exports.decodePayload = function (data, binaryType, callback) {
  if (typeof data !== 'string') {
    return exports.decodePayloadAsBinary(data, binaryType, callback);
  }

  if (typeof binaryType === 'function') {
    callback = binaryType;
    binaryType = null;
  }

  var packet;
  if (data === '') {
    // parser error - ignoring payload
    return callback(err, 0, 1);
  }

  var length = '', n, msg;

  for (var i = 0, l = data.length; i < l; i++) {
    var chr = data.charAt(i);

    if (chr !== ':') {
      length += chr;
      continue;
    }

    if (length === '' || (length != (n = Number(length)))) {
      // parser error - ignoring payload
      return callback(err, 0, 1);
    }

    msg = data.substr(i + 1, n);

    if (length != msg.length) {
      // parser error - ignoring payload
      return callback(err, 0, 1);
    }

    if (msg.length) {
      packet = exports.decodePacket(msg, binaryType, false);

      if (err.type === packet.type && err.data === packet.data) {
        // parser error in individual packet - ignoring payload
        return callback(err, 0, 1);
      }

      var ret = callback(packet, i + n, l);
      if (false === ret) return;
    }

    // advance cursor
    i += n;
    length = '';
  }

  if (length !== '') {
    // parser error - ignoring payload
    return callback(err, 0, 1);
  }

};

/**
 * Encodes multiple messages (payload) as binary.
 *
 * <1 = binary, 0 = string><number from 0-9><number from 0-9>[...]<number
 * 255><data>
 *
 * Example:
 * 1 3 255 1 2 3, if the binary contents are interpreted as 8 bit integers
 *
 * @param {Array} packets
 * @return {ArrayBuffer} encoded payload
 * @api private
 */

exports.encodePayloadAsArrayBuffer = function(packets, callback) {
  if (!packets.length) {
    return callback(new ArrayBuffer(0));
  }

  function encodeOne(packet, doneCallback) {
    exports.encodePacket(packet, true, true, function(data) {
      return doneCallback(null, data);
    });
  }

  map(packets, encodeOne, function(err, encodedPackets) {
    var totalLength = encodedPackets.reduce(function(acc, p) {
      var len;
      if (typeof p === 'string'){
        len = p.length;
      } else {
        len = p.byteLength;
      }
      return acc + len.toString().length + len + 2; // string/binary identifier + separator = 2
    }, 0);

    var resultArray = new Uint8Array(totalLength);

    var bufferIndex = 0;
    encodedPackets.forEach(function(p) {
      var isString = typeof p === 'string';
      var ab = p;
      if (isString) {
        var view = new Uint8Array(p.length);
        for (var i = 0; i < p.length; i++) {
          view[i] = p.charCodeAt(i);
        }
        ab = view.buffer;
      }

      if (isString) { // not true binary
        resultArray[bufferIndex++] = 0;
      } else { // true binary
        resultArray[bufferIndex++] = 1;
      }

      var lenStr = ab.byteLength.toString();
      for (var i = 0; i < lenStr.length; i++) {
        resultArray[bufferIndex++] = parseInt(lenStr[i]);
      }
      resultArray[bufferIndex++] = 255;

      var view = new Uint8Array(ab);
      for (var i = 0; i < view.length; i++) {
        resultArray[bufferIndex++] = view[i];
      }
    });

    return callback(resultArray.buffer);
  });
};

/**
 * Encode as Blob
 */

exports.encodePayloadAsBlob = function(packets, callback) {
  function encodeOne(packet, doneCallback) {
    exports.encodePacket(packet, true, true, function(encoded) {
      var binaryIdentifier = new Uint8Array(1);
      binaryIdentifier[0] = 1;
      if (typeof encoded === 'string') {
        var view = new Uint8Array(encoded.length);
        for (var i = 0; i < encoded.length; i++) {
          view[i] = encoded.charCodeAt(i);
        }
        encoded = view.buffer;
        binaryIdentifier[0] = 0;
      }

      var len = (encoded instanceof ArrayBuffer)
        ? encoded.byteLength
        : encoded.size;

      var lenStr = len.toString();
      var lengthAry = new Uint8Array(lenStr.length + 1);
      for (var i = 0; i < lenStr.length; i++) {
        lengthAry[i] = parseInt(lenStr[i]);
      }
      lengthAry[lenStr.length] = 255;

      if (Blob) {
        var blob = new Blob([binaryIdentifier.buffer, lengthAry.buffer, encoded]);
        doneCallback(null, blob);
      }
    });
  }

  map(packets, encodeOne, function(err, results) {
    return callback(new Blob(results));
  });
};

/*
 * Decodes data when a payload is maybe expected. Strings are decoded by
 * interpreting each byte as a key code for entries marked to start with 0. See
 * description of encodePayloadAsBinary
 *
 * @param {ArrayBuffer} data, callback method
 * @api public
 */

exports.decodePayloadAsBinary = function (data, binaryType, callback) {
  if (typeof binaryType === 'function') {
    callback = binaryType;
    binaryType = null;
  }

  var bufferTail = data;
  var buffers = [];

  while (bufferTail.byteLength > 0) {
    var tailArray = new Uint8Array(bufferTail);
    var isString = tailArray[0] === 0;
    var msgLength = '';

    for (var i = 1; ; i++) {
      if (tailArray[i] === 255) break;

      // 310 = char length of Number.MAX_VALUE
      if (msgLength.length > 310) {
        return callback(err, 0, 1);
      }

      msgLength += tailArray[i];
    }

    bufferTail = sliceBuffer(bufferTail, 2 + msgLength.length);
    msgLength = parseInt(msgLength);

    var msg = sliceBuffer(bufferTail, 0, msgLength);
    if (isString) {
      try {
        msg = String.fromCharCode.apply(null, new Uint8Array(msg));
      } catch (e) {
        // iPhone Safari doesn't let you apply to typed arrays
        var typed = new Uint8Array(msg);
        msg = '';
        for (var i = 0; i < typed.length; i++) {
          msg += String.fromCharCode(typed[i]);
        }
      }
    }

    buffers.push(msg);
    bufferTail = sliceBuffer(bufferTail, msgLength);
  }

  var total = buffers.length;
  buffers.forEach(function(buffer, i) {
    callback(exports.decodePacket(buffer, binaryType, true), i, total);
  });
};


/***/ }),

/***/ 5662:
/***/ (function(module, exports) {


/**
 * Gets the keys for an object.
 *
 * @return {Array} keys
 * @api private
 */

module.exports = Object.keys || function keys (obj){
  var arr = [];
  var has = Object.prototype.hasOwnProperty;

  for (var i in obj) {
    if (has.call(obj, i)) {
      arr.push(i);
    }
  }
  return arr;
};


/***/ }),

/***/ 5663:
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(Buffer) {/* global Blob File */

/*
 * Module requirements.
 */

var isArray = __webpack_require__(5664);

var toString = Object.prototype.toString;
var withNativeBlob = typeof Blob === 'function' ||
                        typeof Blob !== 'undefined' && toString.call(Blob) === '[object BlobConstructor]';
var withNativeFile = typeof File === 'function' ||
                        typeof File !== 'undefined' && toString.call(File) === '[object FileConstructor]';

/**
 * Module exports.
 */

module.exports = hasBinary;

/**
 * Checks for binary data.
 *
 * Supports Buffer, ArrayBuffer, Blob and File.
 *
 * @param {Object} anything
 * @api public
 */

function hasBinary (obj) {
  if (!obj || typeof obj !== 'object') {
    return false;
  }

  if (isArray(obj)) {
    for (var i = 0, l = obj.length; i < l; i++) {
      if (hasBinary(obj[i])) {
        return true;
      }
    }
    return false;
  }

  if ((typeof Buffer === 'function' && Buffer.isBuffer && Buffer.isBuffer(obj)) ||
    (typeof ArrayBuffer === 'function' && obj instanceof ArrayBuffer) ||
    (withNativeBlob && obj instanceof Blob) ||
    (withNativeFile && obj instanceof File)
  ) {
    return true;
  }

  // see: https://github.com/Automattic/has-binary/pull/4
  if (obj.toJSON && typeof obj.toJSON === 'function' && arguments.length === 1) {
    return hasBinary(obj.toJSON(), true);
  }

  for (var key in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, key) && hasBinary(obj[key])) {
      return true;
    }
  }

  return false;
}

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(104).Buffer))

/***/ }),

/***/ 5664:
/***/ (function(module, exports) {

var toString = {}.toString;

module.exports = Array.isArray || function (arr) {
  return toString.call(arr) == '[object Array]';
};


/***/ }),

/***/ 5665:
/***/ (function(module, exports) {

/**
 * An abstraction for slicing an arraybuffer even when
 * ArrayBuffer.prototype.slice is not supported
 *
 * @api public
 */

module.exports = function(arraybuffer, start, end) {
  var bytes = arraybuffer.byteLength;
  start = start || 0;
  end = end || bytes;

  if (arraybuffer.slice) { return arraybuffer.slice(start, end); }

  if (start < 0) { start += bytes; }
  if (end < 0) { end += bytes; }
  if (end > bytes) { end = bytes; }

  if (start >= bytes || start >= end || bytes === 0) {
    return new ArrayBuffer(0);
  }

  var abv = new Uint8Array(arraybuffer);
  var result = new Uint8Array(end - start);
  for (var i = start, ii = 0; i < end; i++, ii++) {
    result[ii] = abv[i];
  }
  return result.buffer;
};


/***/ }),

/***/ 5666:
/***/ (function(module, exports) {

module.exports = after

function after(count, callback, err_cb) {
    var bail = false
    err_cb = err_cb || noop
    proxy.count = count

    return (count === 0) ? callback() : proxy

    function proxy(err, result) {
        if (proxy.count <= 0) {
            throw new Error('after called too many times')
        }
        --proxy.count

        // after first error, rest are passed to err_cb
        if (err) {
            bail = true
            callback(err)
            // future error callbacks will go to error handler
            callback = err_cb
        } else if (proxy.count === 0 && !bail) {
            callback(null, result)
        }
    }
}

function noop() {}


/***/ }),

/***/ 5667:
/***/ (function(module, exports) {

/*! https://mths.be/utf8js v2.1.2 by @mathias */

var stringFromCharCode = String.fromCharCode;

// Taken from https://mths.be/punycode
function ucs2decode(string) {
	var output = [];
	var counter = 0;
	var length = string.length;
	var value;
	var extra;
	while (counter < length) {
		value = string.charCodeAt(counter++);
		if (value >= 0xD800 && value <= 0xDBFF && counter < length) {
			// high surrogate, and there is a next character
			extra = string.charCodeAt(counter++);
			if ((extra & 0xFC00) == 0xDC00) { // low surrogate
				output.push(((value & 0x3FF) << 10) + (extra & 0x3FF) + 0x10000);
			} else {
				// unmatched surrogate; only append this code unit, in case the next
				// code unit is the high surrogate of a surrogate pair
				output.push(value);
				counter--;
			}
		} else {
			output.push(value);
		}
	}
	return output;
}

// Taken from https://mths.be/punycode
function ucs2encode(array) {
	var length = array.length;
	var index = -1;
	var value;
	var output = '';
	while (++index < length) {
		value = array[index];
		if (value > 0xFFFF) {
			value -= 0x10000;
			output += stringFromCharCode(value >>> 10 & 0x3FF | 0xD800);
			value = 0xDC00 | value & 0x3FF;
		}
		output += stringFromCharCode(value);
	}
	return output;
}

function checkScalarValue(codePoint, strict) {
	if (codePoint >= 0xD800 && codePoint <= 0xDFFF) {
		if (strict) {
			throw Error(
				'Lone surrogate U+' + codePoint.toString(16).toUpperCase() +
				' is not a scalar value'
			);
		}
		return false;
	}
	return true;
}
/*--------------------------------------------------------------------------*/

function createByte(codePoint, shift) {
	return stringFromCharCode(((codePoint >> shift) & 0x3F) | 0x80);
}

function encodeCodePoint(codePoint, strict) {
	if ((codePoint & 0xFFFFFF80) == 0) { // 1-byte sequence
		return stringFromCharCode(codePoint);
	}
	var symbol = '';
	if ((codePoint & 0xFFFFF800) == 0) { // 2-byte sequence
		symbol = stringFromCharCode(((codePoint >> 6) & 0x1F) | 0xC0);
	}
	else if ((codePoint & 0xFFFF0000) == 0) { // 3-byte sequence
		if (!checkScalarValue(codePoint, strict)) {
			codePoint = 0xFFFD;
		}
		symbol = stringFromCharCode(((codePoint >> 12) & 0x0F) | 0xE0);
		symbol += createByte(codePoint, 6);
	}
	else if ((codePoint & 0xFFE00000) == 0) { // 4-byte sequence
		symbol = stringFromCharCode(((codePoint >> 18) & 0x07) | 0xF0);
		symbol += createByte(codePoint, 12);
		symbol += createByte(codePoint, 6);
	}
	symbol += stringFromCharCode((codePoint & 0x3F) | 0x80);
	return symbol;
}

function utf8encode(string, opts) {
	opts = opts || {};
	var strict = false !== opts.strict;

	var codePoints = ucs2decode(string);
	var length = codePoints.length;
	var index = -1;
	var codePoint;
	var byteString = '';
	while (++index < length) {
		codePoint = codePoints[index];
		byteString += encodeCodePoint(codePoint, strict);
	}
	return byteString;
}

/*--------------------------------------------------------------------------*/

function readContinuationByte() {
	if (byteIndex >= byteCount) {
		throw Error('Invalid byte index');
	}

	var continuationByte = byteArray[byteIndex] & 0xFF;
	byteIndex++;

	if ((continuationByte & 0xC0) == 0x80) {
		return continuationByte & 0x3F;
	}

	// If we end up here, it’s not a continuation byte
	throw Error('Invalid continuation byte');
}

function decodeSymbol(strict) {
	var byte1;
	var byte2;
	var byte3;
	var byte4;
	var codePoint;

	if (byteIndex > byteCount) {
		throw Error('Invalid byte index');
	}

	if (byteIndex == byteCount) {
		return false;
	}

	// Read first byte
	byte1 = byteArray[byteIndex] & 0xFF;
	byteIndex++;

	// 1-byte sequence (no continuation bytes)
	if ((byte1 & 0x80) == 0) {
		return byte1;
	}

	// 2-byte sequence
	if ((byte1 & 0xE0) == 0xC0) {
		byte2 = readContinuationByte();
		codePoint = ((byte1 & 0x1F) << 6) | byte2;
		if (codePoint >= 0x80) {
			return codePoint;
		} else {
			throw Error('Invalid continuation byte');
		}
	}

	// 3-byte sequence (may include unpaired surrogates)
	if ((byte1 & 0xF0) == 0xE0) {
		byte2 = readContinuationByte();
		byte3 = readContinuationByte();
		codePoint = ((byte1 & 0x0F) << 12) | (byte2 << 6) | byte3;
		if (codePoint >= 0x0800) {
			return checkScalarValue(codePoint, strict) ? codePoint : 0xFFFD;
		} else {
			throw Error('Invalid continuation byte');
		}
	}

	// 4-byte sequence
	if ((byte1 & 0xF8) == 0xF0) {
		byte2 = readContinuationByte();
		byte3 = readContinuationByte();
		byte4 = readContinuationByte();
		codePoint = ((byte1 & 0x07) << 0x12) | (byte2 << 0x0C) |
			(byte3 << 0x06) | byte4;
		if (codePoint >= 0x010000 && codePoint <= 0x10FFFF) {
			return codePoint;
		}
	}

	throw Error('Invalid UTF-8 detected');
}

var byteArray;
var byteCount;
var byteIndex;
function utf8decode(byteString, opts) {
	opts = opts || {};
	var strict = false !== opts.strict;

	byteArray = ucs2decode(byteString);
	byteCount = byteArray.length;
	byteIndex = 0;
	var codePoints = [];
	var tmp;
	while ((tmp = decodeSymbol(strict)) !== false) {
		codePoints.push(tmp);
	}
	return ucs2encode(codePoints);
}

module.exports = {
	version: '2.1.2',
	encode: utf8encode,
	decode: utf8decode
};


/***/ }),

/***/ 5668:
/***/ (function(module, exports) {

/**
 * Create a blob builder even when vendor prefixes exist
 */

var BlobBuilder = typeof BlobBuilder !== 'undefined' ? BlobBuilder :
  typeof WebKitBlobBuilder !== 'undefined' ? WebKitBlobBuilder :
  typeof MSBlobBuilder !== 'undefined' ? MSBlobBuilder :
  typeof MozBlobBuilder !== 'undefined' ? MozBlobBuilder : 
  false;

/**
 * Check if Blob constructor is supported
 */

var blobSupported = (function() {
  try {
    var a = new Blob(['hi']);
    return a.size === 2;
  } catch(e) {
    return false;
  }
})();

/**
 * Check if Blob constructor supports ArrayBufferViews
 * Fails in Safari 6, so we need to map to ArrayBuffers there.
 */

var blobSupportsArrayBufferView = blobSupported && (function() {
  try {
    var b = new Blob([new Uint8Array([1,2])]);
    return b.size === 2;
  } catch(e) {
    return false;
  }
})();

/**
 * Check if BlobBuilder is supported
 */

var blobBuilderSupported = BlobBuilder
  && BlobBuilder.prototype.append
  && BlobBuilder.prototype.getBlob;

/**
 * Helper function that maps ArrayBufferViews to ArrayBuffers
 * Used by BlobBuilder constructor and old browsers that didn't
 * support it in the Blob constructor.
 */

function mapArrayBufferViews(ary) {
  return ary.map(function(chunk) {
    if (chunk.buffer instanceof ArrayBuffer) {
      var buf = chunk.buffer;

      // if this is a subarray, make a copy so we only
      // include the subarray region from the underlying buffer
      if (chunk.byteLength !== buf.byteLength) {
        var copy = new Uint8Array(chunk.byteLength);
        copy.set(new Uint8Array(buf, chunk.byteOffset, chunk.byteLength));
        buf = copy.buffer;
      }

      return buf;
    }

    return chunk;
  });
}

function BlobBuilderConstructor(ary, options) {
  options = options || {};

  var bb = new BlobBuilder();
  mapArrayBufferViews(ary).forEach(function(part) {
    bb.append(part);
  });

  return (options.type) ? bb.getBlob(options.type) : bb.getBlob();
};

function BlobConstructor(ary, options) {
  return new Blob(mapArrayBufferViews(ary), options || {});
};

if (typeof Blob !== 'undefined') {
  BlobBuilderConstructor.prototype = Blob.prototype;
  BlobConstructor.prototype = Blob.prototype;
}

module.exports = (function() {
  if (blobSupported) {
    return blobSupportsArrayBufferView ? Blob : BlobConstructor;
  } else if (blobBuilderSupported) {
    return BlobBuilderConstructor;
  } else {
    return undefined;
  }
})();


/***/ }),

/***/ 5669:
/***/ (function(module, exports, __webpack_require__) {


/**
 * Expose `Emitter`.
 */

if (true) {
  module.exports = Emitter;
}

/**
 * Initialize a new `Emitter`.
 *
 * @api public
 */

function Emitter(obj) {
  if (obj) return mixin(obj);
};

/**
 * Mixin the emitter properties.
 *
 * @param {Object} obj
 * @return {Object}
 * @api private
 */

function mixin(obj) {
  for (var key in Emitter.prototype) {
    obj[key] = Emitter.prototype[key];
  }
  return obj;
}

/**
 * Listen on the given `event` with `fn`.
 *
 * @param {String} event
 * @param {Function} fn
 * @return {Emitter}
 * @api public
 */

Emitter.prototype.on =
Emitter.prototype.addEventListener = function(event, fn){
  this._callbacks = this._callbacks || {};
  (this._callbacks['$' + event] = this._callbacks['$' + event] || [])
    .push(fn);
  return this;
};

/**
 * Adds an `event` listener that will be invoked a single
 * time then automatically removed.
 *
 * @param {String} event
 * @param {Function} fn
 * @return {Emitter}
 * @api public
 */

Emitter.prototype.once = function(event, fn){
  function on() {
    this.off(event, on);
    fn.apply(this, arguments);
  }

  on.fn = fn;
  this.on(event, on);
  return this;
};

/**
 * Remove the given callback for `event` or all
 * registered callbacks.
 *
 * @param {String} event
 * @param {Function} fn
 * @return {Emitter}
 * @api public
 */

Emitter.prototype.off =
Emitter.prototype.removeListener =
Emitter.prototype.removeAllListeners =
Emitter.prototype.removeEventListener = function(event, fn){
  this._callbacks = this._callbacks || {};

  // all
  if (0 == arguments.length) {
    this._callbacks = {};
    return this;
  }

  // specific event
  var callbacks = this._callbacks['$' + event];
  if (!callbacks) return this;

  // remove all handlers
  if (1 == arguments.length) {
    delete this._callbacks['$' + event];
    return this;
  }

  // remove specific handler
  var cb;
  for (var i = 0; i < callbacks.length; i++) {
    cb = callbacks[i];
    if (cb === fn || cb.fn === fn) {
      callbacks.splice(i, 1);
      break;
    }
  }

  // Remove event specific arrays for event types that no
  // one is subscribed for to avoid memory leak.
  if (callbacks.length === 0) {
    delete this._callbacks['$' + event];
  }

  return this;
};

/**
 * Emit `event` with the given args.
 *
 * @param {String} event
 * @param {Mixed} ...
 * @return {Emitter}
 */

Emitter.prototype.emit = function(event){
  this._callbacks = this._callbacks || {};

  var args = new Array(arguments.length - 1)
    , callbacks = this._callbacks['$' + event];

  for (var i = 1; i < arguments.length; i++) {
    args[i - 1] = arguments[i];
  }

  if (callbacks) {
    callbacks = callbacks.slice(0);
    for (var i = 0, len = callbacks.length; i < len; ++i) {
      callbacks[i].apply(this, args);
    }
  }

  return this;
};

/**
 * Return array of callbacks for `event`.
 *
 * @param {String} event
 * @return {Array}
 * @api public
 */

Emitter.prototype.listeners = function(event){
  this._callbacks = this._callbacks || {};
  return this._callbacks['$' + event] || [];
};

/**
 * Check if this emitter has `event` handlers.
 *
 * @param {String} event
 * @return {Boolean}
 * @api public
 */

Emitter.prototype.hasListeners = function(event){
  return !! this.listeners(event).length;
};


/***/ }),

/***/ 5670:
/***/ (function(module, exports) {

/**
 * Compiles a querystring
 * Returns string representation of the object
 *
 * @param {Object}
 * @api private
 */

exports.encode = function (obj) {
  var str = '';

  for (var i in obj) {
    if (obj.hasOwnProperty(i)) {
      if (str.length) str += '&';
      str += encodeURIComponent(i) + '=' + encodeURIComponent(obj[i]);
    }
  }

  return str;
};

/**
 * Parses a simple querystring into an object
 *
 * @param {String} qs
 * @api private
 */

exports.decode = function(qs){
  var qry = {};
  var pairs = qs.split('&');
  for (var i = 0, l = pairs.length; i < l; i++) {
    var pair = pairs[i].split('=');
    qry[decodeURIComponent(pair[0])] = decodeURIComponent(pair[1]);
  }
  return qry;
};


/***/ }),

/***/ 5671:
/***/ (function(module, exports) {


module.exports = function(a, b){
  var fn = function(){};
  fn.prototype = b.prototype;
  a.prototype = new fn;
  a.prototype.constructor = a;
};

/***/ }),

/***/ 5672:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var alphabet = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-_'.split('')
  , length = 64
  , map = {}
  , seed = 0
  , i = 0
  , prev;

/**
 * Return a string representing the specified number.
 *
 * @param {Number} num The number to convert.
 * @returns {String} The string representation of the number.
 * @api public
 */
function encode(num) {
  var encoded = '';

  do {
    encoded = alphabet[num % length] + encoded;
    num = Math.floor(num / length);
  } while (num > 0);

  return encoded;
}

/**
 * Return the integer value specified by the given string.
 *
 * @param {String} str The string to convert.
 * @returns {Number} The integer value represented by the string.
 * @api public
 */
function decode(str) {
  var decoded = 0;

  for (i = 0; i < str.length; i++) {
    decoded = decoded * length + map[str.charAt(i)];
  }

  return decoded;
}

/**
 * Yeast: A tiny growing id generator.
 *
 * @returns {String} A unique id.
 * @api public
 */
function yeast() {
  var now = encode(+new Date());

  if (now !== prev) return seed = 0, prev = now;
  return now +'.'+ encode(seed++);
}

//
// Map each character to its index.
//
for (; i < length; i++) map[alphabet[i]] = i;

//
// Expose the `yeast`, `encode` and `decode` functions.
//
yeast.encode = encode;
yeast.decode = decode;
module.exports = yeast;


/***/ }),

/***/ 5673:
/***/ (function(module, exports, __webpack_require__) {

/**
 * Module requirements.
 */

var Polling = __webpack_require__(5659);
var inherit = __webpack_require__(5671);
var globalThis = __webpack_require__(5657);

/**
 * Module exports.
 */

module.exports = JSONPPolling;

/**
 * Cached regular expressions.
 */

var rNewline = /\n/g;
var rEscapedNewline = /\\n/g;

/**
 * Global JSONP callbacks.
 */

var callbacks;

/**
 * Noop.
 */

function empty () { }

/**
 * JSONP Polling constructor.
 *
 * @param {Object} opts.
 * @api public
 */

function JSONPPolling (opts) {
  Polling.call(this, opts);

  this.query = this.query || {};

  // define global callbacks array if not present
  // we do this here (lazily) to avoid unneeded global pollution
  if (!callbacks) {
    // we need to consider multiple engines in the same page
    callbacks = globalThis.___eio = (globalThis.___eio || []);
  }

  // callback identifier
  this.index = callbacks.length;

  // add callback to jsonp global
  var self = this;
  callbacks.push(function (msg) {
    self.onData(msg);
  });

  // append to query string
  this.query.j = this.index;

  // prevent spurious errors from being emitted when the window is unloaded
  if (typeof addEventListener === 'function') {
    addEventListener('beforeunload', function () {
      if (self.script) self.script.onerror = empty;
    }, false);
  }
}

/**
 * Inherits from Polling.
 */

inherit(JSONPPolling, Polling);

/*
 * JSONP only supports binary as base64 encoded strings
 */

JSONPPolling.prototype.supportsBinary = false;

/**
 * Closes the socket.
 *
 * @api private
 */

JSONPPolling.prototype.doClose = function () {
  if (this.script) {
    this.script.parentNode.removeChild(this.script);
    this.script = null;
  }

  if (this.form) {
    this.form.parentNode.removeChild(this.form);
    this.form = null;
    this.iframe = null;
  }

  Polling.prototype.doClose.call(this);
};

/**
 * Starts a poll cycle.
 *
 * @api private
 */

JSONPPolling.prototype.doPoll = function () {
  var self = this;
  var script = document.createElement('script');

  if (this.script) {
    this.script.parentNode.removeChild(this.script);
    this.script = null;
  }

  script.async = true;
  script.src = this.uri();
  script.onerror = function (e) {
    self.onError('jsonp poll error', e);
  };

  var insertAt = document.getElementsByTagName('script')[0];
  if (insertAt) {
    insertAt.parentNode.insertBefore(script, insertAt);
  } else {
    (document.head || document.body).appendChild(script);
  }
  this.script = script;

  var isUAgecko = 'undefined' !== typeof navigator && /gecko/i.test(navigator.userAgent);

  if (isUAgecko) {
    setTimeout(function () {
      var iframe = document.createElement('iframe');
      document.body.appendChild(iframe);
      document.body.removeChild(iframe);
    }, 100);
  }
};

/**
 * Writes with a hidden iframe.
 *
 * @param {String} data to send
 * @param {Function} called upon flush.
 * @api private
 */

JSONPPolling.prototype.doWrite = function (data, fn) {
  var self = this;

  if (!this.form) {
    var form = document.createElement('form');
    var area = document.createElement('textarea');
    var id = this.iframeId = 'eio_iframe_' + this.index;
    var iframe;

    form.className = 'socketio';
    form.style.position = 'absolute';
    form.style.top = '-1000px';
    form.style.left = '-1000px';
    form.target = id;
    form.method = 'POST';
    form.setAttribute('accept-charset', 'utf-8');
    area.name = 'd';
    form.appendChild(area);
    document.body.appendChild(form);

    this.form = form;
    this.area = area;
  }

  this.form.action = this.uri();

  function complete () {
    initIframe();
    fn();
  }

  function initIframe () {
    if (self.iframe) {
      try {
        self.form.removeChild(self.iframe);
      } catch (e) {
        self.onError('jsonp polling iframe removal error', e);
      }
    }

    try {
      // ie6 dynamic iframes with target="" support (thanks Chris Lambacher)
      var html = '<iframe src="javascript:0" name="' + self.iframeId + '">';
      iframe = document.createElement(html);
    } catch (e) {
      iframe = document.createElement('iframe');
      iframe.name = self.iframeId;
      iframe.src = 'javascript:0';
    }

    iframe.id = self.iframeId;

    self.form.appendChild(iframe);
    self.iframe = iframe;
  }

  initIframe();

  // escape \n to prevent it from being converted into \r\n by some UAs
  // double escaping is required for escaped new lines because unescaping of new lines can be done safely on server-side
  data = data.replace(rEscapedNewline, '\\\n');
  this.area.value = data.replace(rNewline, '\\n');

  try {
    this.form.submit();
  } catch (e) {}

  if (this.iframe.attachEvent) {
    this.iframe.onreadystatechange = function () {
      if (self.iframe.readyState === 'complete') {
        complete();
      }
    };
  } else {
    this.iframe.onload = complete;
  }
};


/***/ }),

/***/ 5674:
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(Buffer) {/**
 * Module dependencies.
 */

var Transport = __webpack_require__(5660);
var parser = __webpack_require__(5661);
var parseqs = __webpack_require__(5670);
var inherit = __webpack_require__(5671);
var yeast = __webpack_require__(5672);
var debug = __webpack_require__(5641)('engine.io-client:websocket');

var BrowserWebSocket, NodeWebSocket;

if (typeof WebSocket !== 'undefined') {
  BrowserWebSocket = WebSocket;
} else if (typeof self !== 'undefined') {
  BrowserWebSocket = self.WebSocket || self.MozWebSocket;
}

if (typeof window === 'undefined') {
  try {
    NodeWebSocket = __webpack_require__(5675);
  } catch (e) { }
}

/**
 * Get either the `WebSocket` or `MozWebSocket` globals
 * in the browser or try to resolve WebSocket-compatible
 * interface exposed by `ws` for Node-like environment.
 */

var WebSocketImpl = BrowserWebSocket || NodeWebSocket;

/**
 * Module exports.
 */

module.exports = WS;

/**
 * WebSocket transport constructor.
 *
 * @api {Object} connection options
 * @api public
 */

function WS (opts) {
  var forceBase64 = (opts && opts.forceBase64);
  if (forceBase64) {
    this.supportsBinary = false;
  }
  this.perMessageDeflate = opts.perMessageDeflate;
  this.usingBrowserWebSocket = BrowserWebSocket && !opts.forceNode;
  this.protocols = opts.protocols;
  if (!this.usingBrowserWebSocket) {
    WebSocketImpl = NodeWebSocket;
  }
  Transport.call(this, opts);
}

/**
 * Inherits from Transport.
 */

inherit(WS, Transport);

/**
 * Transport name.
 *
 * @api public
 */

WS.prototype.name = 'websocket';

/*
 * WebSockets support binary
 */

WS.prototype.supportsBinary = true;

/**
 * Opens socket.
 *
 * @api private
 */

WS.prototype.doOpen = function () {
  if (!this.check()) {
    // let probe timeout
    return;
  }

  var uri = this.uri();
  var protocols = this.protocols;

  var opts = {};

  if (!this.isReactNative) {
    opts.agent = this.agent;
    opts.perMessageDeflate = this.perMessageDeflate;

    // SSL options for Node.js client
    opts.pfx = this.pfx;
    opts.key = this.key;
    opts.passphrase = this.passphrase;
    opts.cert = this.cert;
    opts.ca = this.ca;
    opts.ciphers = this.ciphers;
    opts.rejectUnauthorized = this.rejectUnauthorized;
  }

  if (this.extraHeaders) {
    opts.headers = this.extraHeaders;
  }
  if (this.localAddress) {
    opts.localAddress = this.localAddress;
  }

  try {
    this.ws =
      this.usingBrowserWebSocket && !this.isReactNative
        ? protocols
          ? new WebSocketImpl(uri, protocols)
          : new WebSocketImpl(uri)
        : new WebSocketImpl(uri, protocols, opts);
  } catch (err) {
    return this.emit('error', err);
  }

  if (this.ws.binaryType === undefined) {
    this.supportsBinary = false;
  }

  if (this.ws.supports && this.ws.supports.binary) {
    this.supportsBinary = true;
    this.ws.binaryType = 'nodebuffer';
  } else {
    this.ws.binaryType = 'arraybuffer';
  }

  this.addEventListeners();
};

/**
 * Adds event listeners to the socket
 *
 * @api private
 */

WS.prototype.addEventListeners = function () {
  var self = this;

  this.ws.onopen = function () {
    self.onOpen();
  };
  this.ws.onclose = function () {
    self.onClose();
  };
  this.ws.onmessage = function (ev) {
    self.onData(ev.data);
  };
  this.ws.onerror = function (e) {
    self.onError('websocket error', e);
  };
};

/**
 * Writes data to socket.
 *
 * @param {Array} array of packets.
 * @api private
 */

WS.prototype.write = function (packets) {
  var self = this;
  this.writable = false;

  // encodePacket efficient as it uses WS framing
  // no need for encodePayload
  var total = packets.length;
  for (var i = 0, l = total; i < l; i++) {
    (function (packet) {
      parser.encodePacket(packet, self.supportsBinary, function (data) {
        if (!self.usingBrowserWebSocket) {
          // always create a new object (GH-437)
          var opts = {};
          if (packet.options) {
            opts.compress = packet.options.compress;
          }

          if (self.perMessageDeflate) {
            var len = 'string' === typeof data ? Buffer.byteLength(data) : data.length;
            if (len < self.perMessageDeflate.threshold) {
              opts.compress = false;
            }
          }
        }

        // Sometimes the websocket has already been closed but the browser didn't
        // have a chance of informing us about it yet, in that case send will
        // throw an error
        try {
          if (self.usingBrowserWebSocket) {
            // TypeError is thrown when passing the second argument on Safari
            self.ws.send(data);
          } else {
            self.ws.send(data, opts);
          }
        } catch (e) {
          debug('websocket closed before onclose event');
        }

        --total || done();
      });
    })(packets[i]);
  }

  function done () {
    self.emit('flush');

    // fake drain
    // defer to next tick to allow Socket to clear writeBuffer
    setTimeout(function () {
      self.writable = true;
      self.emit('drain');
    }, 0);
  }
};

/**
 * Called upon close
 *
 * @api private
 */

WS.prototype.onClose = function () {
  Transport.prototype.onClose.call(this);
};

/**
 * Closes socket.
 *
 * @api private
 */

WS.prototype.doClose = function () {
  if (typeof this.ws !== 'undefined') {
    this.ws.close();
  }
};

/**
 * Generates uri for connection.
 *
 * @api private
 */

WS.prototype.uri = function () {
  var query = this.query || {};
  var schema = this.secure ? 'wss' : 'ws';
  var port = '';

  // avoid port if default for schema
  if (this.port && (('wss' === schema && Number(this.port) !== 443) ||
    ('ws' === schema && Number(this.port) !== 80))) {
    port = ':' + this.port;
  }

  // append timestamp to URI
  if (this.timestampRequests) {
    query[this.timestampParam] = yeast();
  }

  // communicate binary support capabilities
  if (!this.supportsBinary) {
    query.b64 = 1;
  }

  query = parseqs.encode(query);

  // prepend ? to query
  if (query.length) {
    query = '?' + query;
  }

  var ipv6 = this.hostname.indexOf(':') !== -1;
  return schema + '://' + (ipv6 ? '[' + this.hostname + ']' : this.hostname) + port + this.path + query;
};

/**
 * Feature detection for WebSocket.
 *
 * @return {Boolean} whether this transport is available.
 * @api public
 */

WS.prototype.check = function () {
  return !!WebSocketImpl && !('__initialize' in WebSocketImpl && this.name === WS.prototype.name);
};

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(104).Buffer))

/***/ }),

/***/ 5675:
/***/ (function(module, exports) {

/* (ignored) */

/***/ }),

/***/ 5676:
/***/ (function(module, exports) {


var indexOf = [].indexOf;

module.exports = function(arr, obj){
  if (indexOf) return arr.indexOf(obj);
  for (var i = 0; i < arr.length; ++i) {
    if (arr[i] === obj) return i;
  }
  return -1;
};

/***/ }),

/***/ 5677:
/***/ (function(module, exports, __webpack_require__) {


/**
 * Module dependencies.
 */

var parser = __webpack_require__(5643);
var Emitter = __webpack_require__(5647);
var toArray = __webpack_require__(5678);
var on = __webpack_require__(5679);
var bind = __webpack_require__(5680);
var debug = __webpack_require__(5641)('socket.io-client:socket');
var parseqs = __webpack_require__(5670);
var hasBin = __webpack_require__(5663);

/**
 * Module exports.
 */

module.exports = exports = Socket;

/**
 * Internal events (blacklisted).
 * These events can't be emitted by the user.
 *
 * @api private
 */

var events = {
  connect: 1,
  connect_error: 1,
  connect_timeout: 1,
  connecting: 1,
  disconnect: 1,
  error: 1,
  reconnect: 1,
  reconnect_attempt: 1,
  reconnect_failed: 1,
  reconnect_error: 1,
  reconnecting: 1,
  ping: 1,
  pong: 1
};

/**
 * Shortcut to `Emitter#emit`.
 */

var emit = Emitter.prototype.emit;

/**
 * `Socket` constructor.
 *
 * @api public
 */

function Socket (io, nsp, opts) {
  this.io = io;
  this.nsp = nsp;
  this.json = this; // compat
  this.ids = 0;
  this.acks = {};
  this.receiveBuffer = [];
  this.sendBuffer = [];
  this.connected = false;
  this.disconnected = true;
  this.flags = {};
  if (opts && opts.query) {
    this.query = opts.query;
  }
  if (this.io.autoConnect) this.open();
}

/**
 * Mix in `Emitter`.
 */

Emitter(Socket.prototype);

/**
 * Subscribe to open, close and packet events
 *
 * @api private
 */

Socket.prototype.subEvents = function () {
  if (this.subs) return;

  var io = this.io;
  this.subs = [
    on(io, 'open', bind(this, 'onopen')),
    on(io, 'packet', bind(this, 'onpacket')),
    on(io, 'close', bind(this, 'onclose'))
  ];
};

/**
 * "Opens" the socket.
 *
 * @api public
 */

Socket.prototype.open =
Socket.prototype.connect = function () {
  if (this.connected) return this;

  this.subEvents();
  this.io.open(); // ensure open
  if ('open' === this.io.readyState) this.onopen();
  this.emit('connecting');
  return this;
};

/**
 * Sends a `message` event.
 *
 * @return {Socket} self
 * @api public
 */

Socket.prototype.send = function () {
  var args = toArray(arguments);
  args.unshift('message');
  this.emit.apply(this, args);
  return this;
};

/**
 * Override `emit`.
 * If the event is in `events`, it's emitted normally.
 *
 * @param {String} event name
 * @return {Socket} self
 * @api public
 */

Socket.prototype.emit = function (ev) {
  if (events.hasOwnProperty(ev)) {
    emit.apply(this, arguments);
    return this;
  }

  var args = toArray(arguments);
  var packet = {
    type: (this.flags.binary !== undefined ? this.flags.binary : hasBin(args)) ? parser.BINARY_EVENT : parser.EVENT,
    data: args
  };

  packet.options = {};
  packet.options.compress = !this.flags || false !== this.flags.compress;

  // event ack callback
  if ('function' === typeof args[args.length - 1]) {
    debug('emitting packet with ack id %d', this.ids);
    this.acks[this.ids] = args.pop();
    packet.id = this.ids++;
  }

  if (this.connected) {
    this.packet(packet);
  } else {
    this.sendBuffer.push(packet);
  }

  this.flags = {};

  return this;
};

/**
 * Sends a packet.
 *
 * @param {Object} packet
 * @api private
 */

Socket.prototype.packet = function (packet) {
  packet.nsp = this.nsp;
  this.io.packet(packet);
};

/**
 * Called upon engine `open`.
 *
 * @api private
 */

Socket.prototype.onopen = function () {
  debug('transport is open - connecting');

  // write connect packet if necessary
  if ('/' !== this.nsp) {
    if (this.query) {
      var query = typeof this.query === 'object' ? parseqs.encode(this.query) : this.query;
      debug('sending connect packet with query %s', query);
      this.packet({type: parser.CONNECT, query: query});
    } else {
      this.packet({type: parser.CONNECT});
    }
  }
};

/**
 * Called upon engine `close`.
 *
 * @param {String} reason
 * @api private
 */

Socket.prototype.onclose = function (reason) {
  debug('close (%s)', reason);
  this.connected = false;
  this.disconnected = true;
  delete this.id;
  this.emit('disconnect', reason);
};

/**
 * Called with socket packet.
 *
 * @param {Object} packet
 * @api private
 */

Socket.prototype.onpacket = function (packet) {
  var sameNamespace = packet.nsp === this.nsp;
  var rootNamespaceError = packet.type === parser.ERROR && packet.nsp === '/';

  if (!sameNamespace && !rootNamespaceError) return;

  switch (packet.type) {
    case parser.CONNECT:
      this.onconnect();
      break;

    case parser.EVENT:
      this.onevent(packet);
      break;

    case parser.BINARY_EVENT:
      this.onevent(packet);
      break;

    case parser.ACK:
      this.onack(packet);
      break;

    case parser.BINARY_ACK:
      this.onack(packet);
      break;

    case parser.DISCONNECT:
      this.ondisconnect();
      break;

    case parser.ERROR:
      this.emit('error', packet.data);
      break;
  }
};

/**
 * Called upon a server event.
 *
 * @param {Object} packet
 * @api private
 */

Socket.prototype.onevent = function (packet) {
  var args = packet.data || [];
  debug('emitting event %j', args);

  if (null != packet.id) {
    debug('attaching ack callback to event');
    args.push(this.ack(packet.id));
  }

  if (this.connected) {
    emit.apply(this, args);
  } else {
    this.receiveBuffer.push(args);
  }
};

/**
 * Produces an ack callback to emit with an event.
 *
 * @api private
 */

Socket.prototype.ack = function (id) {
  var self = this;
  var sent = false;
  return function () {
    // prevent double callbacks
    if (sent) return;
    sent = true;
    var args = toArray(arguments);
    debug('sending ack %j', args);

    self.packet({
      type: hasBin(args) ? parser.BINARY_ACK : parser.ACK,
      id: id,
      data: args
    });
  };
};

/**
 * Called upon a server acknowlegement.
 *
 * @param {Object} packet
 * @api private
 */

Socket.prototype.onack = function (packet) {
  var ack = this.acks[packet.id];
  if ('function' === typeof ack) {
    debug('calling ack %s with %j', packet.id, packet.data);
    ack.apply(this, packet.data);
    delete this.acks[packet.id];
  } else {
    debug('bad ack %s', packet.id);
  }
};

/**
 * Called upon server connect.
 *
 * @api private
 */

Socket.prototype.onconnect = function () {
  this.connected = true;
  this.disconnected = false;
  this.emit('connect');
  this.emitBuffered();
};

/**
 * Emit buffered events (received and emitted).
 *
 * @api private
 */

Socket.prototype.emitBuffered = function () {
  var i;
  for (i = 0; i < this.receiveBuffer.length; i++) {
    emit.apply(this, this.receiveBuffer[i]);
  }
  this.receiveBuffer = [];

  for (i = 0; i < this.sendBuffer.length; i++) {
    this.packet(this.sendBuffer[i]);
  }
  this.sendBuffer = [];
};

/**
 * Called upon server disconnect.
 *
 * @api private
 */

Socket.prototype.ondisconnect = function () {
  debug('server disconnect (%s)', this.nsp);
  this.destroy();
  this.onclose('io server disconnect');
};

/**
 * Called upon forced client/server side disconnections,
 * this method ensures the manager stops tracking us and
 * that reconnections don't get triggered for this.
 *
 * @api private.
 */

Socket.prototype.destroy = function () {
  if (this.subs) {
    // clean subscriptions to avoid reconnections
    for (var i = 0; i < this.subs.length; i++) {
      this.subs[i].destroy();
    }
    this.subs = null;
  }

  this.io.destroy(this);
};

/**
 * Disconnects the socket manually.
 *
 * @return {Socket} self
 * @api public
 */

Socket.prototype.close =
Socket.prototype.disconnect = function () {
  if (this.connected) {
    debug('performing disconnect (%s)', this.nsp);
    this.packet({ type: parser.DISCONNECT });
  }

  // remove socket from pool
  this.destroy();

  if (this.connected) {
    // fire events
    this.onclose('io client disconnect');
  }
  return this;
};

/**
 * Sets the compress flag.
 *
 * @param {Boolean} if `true`, compresses the sending data
 * @return {Socket} self
 * @api public
 */

Socket.prototype.compress = function (compress) {
  this.flags.compress = compress;
  return this;
};

/**
 * Sets the binary flag
 *
 * @param {Boolean} whether the emitted data contains binary
 * @return {Socket} self
 * @api public
 */

Socket.prototype.binary = function (binary) {
  this.flags.binary = binary;
  return this;
};


/***/ }),

/***/ 5678:
/***/ (function(module, exports) {

module.exports = toArray

function toArray(list, index) {
    var array = []

    index = index || 0

    for (var i = index || 0; i < list.length; i++) {
        array[i - index] = list[i]
    }

    return array
}


/***/ }),

/***/ 5679:
/***/ (function(module, exports) {


/**
 * Module exports.
 */

module.exports = on;

/**
 * Helper for subscriptions.
 *
 * @param {Object|EventEmitter} obj with `Emitter` mixin or `EventEmitter`
 * @param {String} event name
 * @param {Function} callback
 * @api public
 */

function on (obj, ev, fn) {
  obj.on(ev, fn);
  return {
    destroy: function () {
      obj.removeListener(ev, fn);
    }
  };
}


/***/ }),

/***/ 5680:
/***/ (function(module, exports) {

/**
 * Slice reference.
 */

var slice = [].slice;

/**
 * Bind `obj` to `fn`.
 *
 * @param {Object} obj
 * @param {Function|String} fn or string
 * @return {Function}
 * @api public
 */

module.exports = function(obj, fn){
  if ('string' == typeof fn) fn = obj[fn];
  if ('function' != typeof fn) throw new Error('bind() requires a function');
  var args = slice.call(arguments, 2);
  return function(){
    return fn.apply(obj, args.concat(slice.call(arguments)));
  }
};


/***/ }),

/***/ 5681:
/***/ (function(module, exports) {


/**
 * Expose `Backoff`.
 */

module.exports = Backoff;

/**
 * Initialize backoff timer with `opts`.
 *
 * - `min` initial timeout in milliseconds [100]
 * - `max` max timeout [10000]
 * - `jitter` [0]
 * - `factor` [2]
 *
 * @param {Object} opts
 * @api public
 */

function Backoff(opts) {
  opts = opts || {};
  this.ms = opts.min || 100;
  this.max = opts.max || 10000;
  this.factor = opts.factor || 2;
  this.jitter = opts.jitter > 0 && opts.jitter <= 1 ? opts.jitter : 0;
  this.attempts = 0;
}

/**
 * Return the backoff duration.
 *
 * @return {Number}
 * @api public
 */

Backoff.prototype.duration = function(){
  var ms = this.ms * Math.pow(this.factor, this.attempts++);
  if (this.jitter) {
    var rand =  Math.random();
    var deviation = Math.floor(rand * this.jitter * ms);
    ms = (Math.floor(rand * 10) & 1) == 0  ? ms - deviation : ms + deviation;
  }
  return Math.min(ms, this.max) | 0;
};

/**
 * Reset the number of attempts.
 *
 * @api public
 */

Backoff.prototype.reset = function(){
  this.attempts = 0;
};

/**
 * Set the minimum duration
 *
 * @api public
 */

Backoff.prototype.setMin = function(min){
  this.ms = min;
};

/**
 * Set the maximum duration
 *
 * @api public
 */

Backoff.prototype.setMax = function(max){
  this.max = max;
};

/**
 * Set the jitter
 *
 * @api public
 */

Backoff.prototype.setJitter = function(jitter){
  this.jitter = jitter;
};



/***/ }),

/***/ 5682:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var has = Object.prototype.hasOwnProperty
  , prefix = '~';

/**
 * Constructor to create a storage for our `EE` objects.
 * An `Events` instance is a plain object whose properties are event names.
 *
 * @constructor
 * @private
 */
function Events() {}

//
// We try to not inherit from `Object.prototype`. In some engines creating an
// instance in this way is faster than calling `Object.create(null)` directly.
// If `Object.create(null)` is not supported we prefix the event names with a
// character to make sure that the built-in object properties are not
// overridden or used as an attack vector.
//
if (Object.create) {
  Events.prototype = Object.create(null);

  //
  // This hack is needed because the `__proto__` property is still inherited in
  // some old browsers like Android 4, iPhone 5.1, Opera 11 and Safari 5.
  //
  if (!new Events().__proto__) prefix = false;
}

/**
 * Representation of a single event listener.
 *
 * @param {Function} fn The listener function.
 * @param {*} context The context to invoke the listener with.
 * @param {Boolean} [once=false] Specify if the listener is a one-time listener.
 * @constructor
 * @private
 */
function EE(fn, context, once) {
  this.fn = fn;
  this.context = context;
  this.once = once || false;
}

/**
 * Add a listener for a given event.
 *
 * @param {EventEmitter} emitter Reference to the `EventEmitter` instance.
 * @param {(String|Symbol)} event The event name.
 * @param {Function} fn The listener function.
 * @param {*} context The context to invoke the listener with.
 * @param {Boolean} once Specify if the listener is a one-time listener.
 * @returns {EventEmitter}
 * @private
 */
function addListener(emitter, event, fn, context, once) {
  if (typeof fn !== 'function') {
    throw new TypeError('The listener must be a function');
  }

  var listener = new EE(fn, context || emitter, once)
    , evt = prefix ? prefix + event : event;

  if (!emitter._events[evt]) emitter._events[evt] = listener, emitter._eventsCount++;
  else if (!emitter._events[evt].fn) emitter._events[evt].push(listener);
  else emitter._events[evt] = [emitter._events[evt], listener];

  return emitter;
}

/**
 * Clear event by name.
 *
 * @param {EventEmitter} emitter Reference to the `EventEmitter` instance.
 * @param {(String|Symbol)} evt The Event name.
 * @private
 */
function clearEvent(emitter, evt) {
  if (--emitter._eventsCount === 0) emitter._events = new Events();
  else delete emitter._events[evt];
}

/**
 * Minimal `EventEmitter` interface that is molded against the Node.js
 * `EventEmitter` interface.
 *
 * @constructor
 * @public
 */
function EventEmitter() {
  this._events = new Events();
  this._eventsCount = 0;
}

/**
 * Return an array listing the events for which the emitter has registered
 * listeners.
 *
 * @returns {Array}
 * @public
 */
EventEmitter.prototype.eventNames = function eventNames() {
  var names = []
    , events
    , name;

  if (this._eventsCount === 0) return names;

  for (name in (events = this._events)) {
    if (has.call(events, name)) names.push(prefix ? name.slice(1) : name);
  }

  if (Object.getOwnPropertySymbols) {
    return names.concat(Object.getOwnPropertySymbols(events));
  }

  return names;
};

/**
 * Return the listeners registered for a given event.
 *
 * @param {(String|Symbol)} event The event name.
 * @returns {Array} The registered listeners.
 * @public
 */
EventEmitter.prototype.listeners = function listeners(event) {
  var evt = prefix ? prefix + event : event
    , handlers = this._events[evt];

  if (!handlers) return [];
  if (handlers.fn) return [handlers.fn];

  for (var i = 0, l = handlers.length, ee = new Array(l); i < l; i++) {
    ee[i] = handlers[i].fn;
  }

  return ee;
};

/**
 * Return the number of listeners listening to a given event.
 *
 * @param {(String|Symbol)} event The event name.
 * @returns {Number} The number of listeners.
 * @public
 */
EventEmitter.prototype.listenerCount = function listenerCount(event) {
  var evt = prefix ? prefix + event : event
    , listeners = this._events[evt];

  if (!listeners) return 0;
  if (listeners.fn) return 1;
  return listeners.length;
};

/**
 * Calls each of the listeners registered for a given event.
 *
 * @param {(String|Symbol)} event The event name.
 * @returns {Boolean} `true` if the event had listeners, else `false`.
 * @public
 */
EventEmitter.prototype.emit = function emit(event, a1, a2, a3, a4, a5) {
  var evt = prefix ? prefix + event : event;

  if (!this._events[evt]) return false;

  var listeners = this._events[evt]
    , len = arguments.length
    , args
    , i;

  if (listeners.fn) {
    if (listeners.once) this.removeListener(event, listeners.fn, undefined, true);

    switch (len) {
      case 1: return listeners.fn.call(listeners.context), true;
      case 2: return listeners.fn.call(listeners.context, a1), true;
      case 3: return listeners.fn.call(listeners.context, a1, a2), true;
      case 4: return listeners.fn.call(listeners.context, a1, a2, a3), true;
      case 5: return listeners.fn.call(listeners.context, a1, a2, a3, a4), true;
      case 6: return listeners.fn.call(listeners.context, a1, a2, a3, a4, a5), true;
    }

    for (i = 1, args = new Array(len -1); i < len; i++) {
      args[i - 1] = arguments[i];
    }

    listeners.fn.apply(listeners.context, args);
  } else {
    var length = listeners.length
      , j;

    for (i = 0; i < length; i++) {
      if (listeners[i].once) this.removeListener(event, listeners[i].fn, undefined, true);

      switch (len) {
        case 1: listeners[i].fn.call(listeners[i].context); break;
        case 2: listeners[i].fn.call(listeners[i].context, a1); break;
        case 3: listeners[i].fn.call(listeners[i].context, a1, a2); break;
        case 4: listeners[i].fn.call(listeners[i].context, a1, a2, a3); break;
        default:
          if (!args) for (j = 1, args = new Array(len -1); j < len; j++) {
            args[j - 1] = arguments[j];
          }

          listeners[i].fn.apply(listeners[i].context, args);
      }
    }
  }

  return true;
};

/**
 * Add a listener for a given event.
 *
 * @param {(String|Symbol)} event The event name.
 * @param {Function} fn The listener function.
 * @param {*} [context=this] The context to invoke the listener with.
 * @returns {EventEmitter} `this`.
 * @public
 */
EventEmitter.prototype.on = function on(event, fn, context) {
  return addListener(this, event, fn, context, false);
};

/**
 * Add a one-time listener for a given event.
 *
 * @param {(String|Symbol)} event The event name.
 * @param {Function} fn The listener function.
 * @param {*} [context=this] The context to invoke the listener with.
 * @returns {EventEmitter} `this`.
 * @public
 */
EventEmitter.prototype.once = function once(event, fn, context) {
  return addListener(this, event, fn, context, true);
};

/**
 * Remove the listeners of a given event.
 *
 * @param {(String|Symbol)} event The event name.
 * @param {Function} fn Only remove the listeners that match this function.
 * @param {*} context Only remove the listeners that have this context.
 * @param {Boolean} once Only remove one-time listeners.
 * @returns {EventEmitter} `this`.
 * @public
 */
EventEmitter.prototype.removeListener = function removeListener(event, fn, context, once) {
  var evt = prefix ? prefix + event : event;

  if (!this._events[evt]) return this;
  if (!fn) {
    clearEvent(this, evt);
    return this;
  }

  var listeners = this._events[evt];

  if (listeners.fn) {
    if (
      listeners.fn === fn &&
      (!once || listeners.once) &&
      (!context || listeners.context === context)
    ) {
      clearEvent(this, evt);
    }
  } else {
    for (var i = 0, events = [], length = listeners.length; i < length; i++) {
      if (
        listeners[i].fn !== fn ||
        (once && !listeners[i].once) ||
        (context && listeners[i].context !== context)
      ) {
        events.push(listeners[i]);
      }
    }

    //
    // Reset the array, or remove it completely if we have no more listeners.
    //
    if (events.length) this._events[evt] = events.length === 1 ? events[0] : events;
    else clearEvent(this, evt);
  }

  return this;
};

/**
 * Remove all listeners, or those of the specified event.
 *
 * @param {(String|Symbol)} [event] The event name.
 * @returns {EventEmitter} `this`.
 * @public
 */
EventEmitter.prototype.removeAllListeners = function removeAllListeners(event) {
  var evt;

  if (event) {
    evt = prefix ? prefix + event : event;
    if (this._events[evt]) clearEvent(this, evt);
  } else {
    this._events = new Events();
    this._eventsCount = 0;
  }

  return this;
};

//
// Alias methods names because people roll like that.
//
EventEmitter.prototype.off = EventEmitter.prototype.removeListener;
EventEmitter.prototype.addListener = EventEmitter.prototype.on;

//
// Expose the prefix.
//
EventEmitter.prefixed = prefix;

//
// Allow `EventEmitter` to be imported as module namespace.
//
EventEmitter.EventEmitter = EventEmitter;

//
// Expose the module.
//
if (true) {
  module.exports = EventEmitter;
}


/***/ }),

/***/ 5683:
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {const path = __webpack_require__(64),
stripTrailingSep = thePath => {
    if (thePath[thePath.length - 1] === path.sep) {
        return thePath.slice(0, -1);
    }
    return thePath;
};

module.exports = function (thePath, potentialParent) {
    // For inside-directory checking, we want to allow trailing slashes, so normalize.
    thePath = stripTrailingSep(thePath);
    potentialParent = stripTrailingSep(potentialParent);

    // Node treats only Windows as case-insensitive in its path module; we follow those conventions.
    if (global.process.platform === 'win32') {
        thePath = thePath.toLowerCase();
        potentialParent = potentialParent.toLowerCase();
    }

    return thePath.lastIndexOf(potentialParent, 0) === 0 && (

    thePath[potentialParent.length] === path.sep ||
    thePath[potentialParent.length] === undefined);

};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(19)))

/***/ }),

/***/ 5684:
/***/ (function(module, exports, __webpack_require__) {

// ###### WARNING: DO NOT REQUIRE NON-ISOMORPHIC LIBRARIES HERE
let _ = __webpack_require__(61),
async = __webpack_require__(664),

EventProcessor = __webpack_require__(5685),

// ###### WARNING: DO NOT REQUIRE NON-ISOMORPHIC LIBRARIES HERE

// Character detection to node encoding map
CHARDET_BUFF_MAP = {
  ASCII: 'ascii',
  'UTF-8': 'utf8',
  'UTF-16LE': 'utf16le',
  'ISO-8859-1': 'latin1' },


detectEncoding = buff => CHARDET_BUFF_MAP[chardet.detect(buff)],

isBrowser = false,


// TODO: Implement these using a dependency injection model like awilix
fs,
os,
app,
path,
dialog,
chardet,
session,
PostmanFs,
CookieJar,
dryRunRequest,
CookieManager,
getSystemProxy,
SerializedError,
collectionRunner,
sanitizeFilename,
postmanCollectionSdk,

defaultWorkingDir,

activeRuns = {};

/**
                  * Helper function to get the file extension given a mime-type
                  * @param {String} mimeType
                  */
function __getProbableExtension(mimeType) {
  var mimeExtensions = [
  {
    typeSubstring: 'text',
    extension: '.txt' },

  {
    typeSubstring: 'json',
    extension: '.json' },

  {
    typeSubstring: 'javascript',
    extension: '.js' },

  {
    typeSubstring: 'pdf',
    extension: '.pdf' },

  {
    typeSubstring: 'png',
    extension: '.png' },

  {
    typeSubstring: 'jpg',
    extension: '.jpg' },

  {
    typeSubstring: 'jpeg',
    extension: '.jpg' },

  {
    typeSubstring: 'gif',
    extension: '.gif' },

  {
    typeSubstring: 'excel',
    extension: '.xls' },

  {
    typeSubstring: 'zip',
    extension: '.zip' },

  {
    typeSubstring: 'compressed',
    extension: '.zip' },

  {
    typeSubstring: 'audio/wav',
    extension: '.wav' },

  {
    typeSubstring: 'tiff',
    extension: '.tiff' },

  {
    typeSubstring: 'shockwave',
    extension: '.swf' },

  {
    typeSubstring: 'powerpoint',
    extension: '.ppt' },

  {
    typeSubstring: 'mpeg',
    extension: '.mpg' },

  {
    typeSubstring: 'quicktime',
    extension: '.mov' },

  {
    typeSubstring: 'html',
    extension: '.html' },

  {
    typeSubstring: 'css',
    extension: '.css' }];



  for (var i = 0; i < mimeExtensions.length; i++) {
    if (mimeType.indexOf(mimeExtensions[i].typeSubstring) > -1) {
      return mimeExtensions[i].extension;
    }
  }

  return '';
}


// #region API Functions

/**
 * @private
 */
function trackRun(executionId, run, processor) {
  // Set the processor as the runs processor
  run.processor = processor;

  activeRuns[executionId] = run;
}

/**
   * @private
   */
function addAborter(executionId, aborter) {
  activeRuns[executionId] && (activeRuns[executionId].aborter = aborter);
}

/**
   * @private
   */
function removeAborter(executionId) {
  activeRuns[executionId] && delete activeRuns[executionId].aborter;
}

/**
   * @private
   * Sanitizes options to be sent to runtime. Mostly converting objects into SDK instances.
   *
   * @param {Object} rawOptions
   */
function sanitizeRunOptions(rawOptions) {
  if (!rawOptions) {
    return;
  }

  if (rawOptions.useSystemProxy && !!getSystemProxy) {
    rawOptions.systemProxy = getSystemProxy;
  }

  if (rawOptions.proxies) {
    rawOptions.proxies = new postmanCollectionSdk.ProxyConfigList({}, rawOptions.proxies);
  }

  rawOptions.certificates = new postmanCollectionSdk.CertificateList({}, rawOptions.certificates);
}

/**
   * @private
   * Save the given stream to a file the user chooses
   *
   * @param {Object} contentInfo
   * @param {Buffer} stream
   */
function saveStreamToFile(contentInfo, stream, cb) {
  let name;

  // sdkResponse override
  if (contentInfo && contentInfo.fileName) {
    name = contentInfo.fileName || '';
  }

  if (_.isEmpty(name)) {
    name = 'response';
    name = contentInfo && contentInfo.mimeType ? `${name}${__getProbableExtension(contentInfo.mimeType)}` : name;
  }

  // TODO: Implement browser specific logic here
  if (isBrowser) {
    return;
  }

  // WARNING: All usages below require native dependencies hence be careful in browser environment

  name = sanitizeFilename(name, { replacement: '-' });

  dialog.showSaveDialog({
    title: 'Select path to save file',
    defaultPath: name // Default filename to be used
  }).then(result => {
    if (result.canceled) {
      // If the request was cancelled then don't do anything, not even call the callback;
      return cb(null, false);
    }

    fs.writeFile(result.filePath, stream, err => {
      return cb(err, true);
    });
  }).
  catch(cb);
}

/**
   * Abort and cleanup an existing collection run
   *
   * @param {String} executionId - The execution id to terminate or dispose
   * @param {Function} emit - emitter to call to denote the execution has terminated/disposed
   */
function disposeRun(executionId, emit = _.noop) {
  if (!executionId || !activeRuns[executionId]) {
    return;
  }

  const run = activeRuns[executionId];

  run.host && run.host.dispose && run.host.dispose();

  // dispose the reference
  activeRuns[executionId] = null;

  emit({ id: executionId, event: '__dispose__' });
}

/**
   * @public
   * Stops and disposes an existing collection run
   *
   * @param {String} executionId - The execution id to terminate or dispose
   * @param {Function} emit - emitter to call to denote the execution has terminated/disposed
   */
function stopRun(executionId, emit) {
  if (!executionId || !activeRuns[executionId]) {
    return;
  }

  const run = activeRuns[executionId];

  run.aborter && run.aborter.abort();
  run.abort();

  // Force call the stop event as postman-runtime will no longer call any event
  run.processor.call('abort', [null]);

  disposeRun(executionId, emit);
}

/**
   * @public
   * Pause the current collection run
   *
   * @param {String} executionId
   */
function pauseRun(executionId) {
  if (!executionId || !activeRuns[executionId]) {
    return;
  }

  activeRuns[executionId].pause();
}

/**
   * @public
   * Resume the paused current collection run
   *
   * @param {String} executionId
   */
function resumeRun(executionId) {
  if (!executionId || !activeRuns[executionId]) {
    return;
  }

  activeRuns[executionId].resume();
}

/**
   * @public
   * Start a collection run with the given collection and variables
   *
   * @param {Object} info
   * @param {Object} collection
   * @param {Object} variables
   * @param {Object} options
   */
function startRun(info, collection, variables, options = {}, emit) {
  const sdkCollection = new postmanCollectionSdk.Collection(collection),
  cookiePartitionId = options && options.cookiePartitionId,

  // Create an event processor instance and handling runtime events
  eventProccessor = new EventProcessor(info.schema, (event, data, refs) => {
    emit({ id: info.id, event, data, refs });
  });

  let cookieJar;

  // We have the CookieJar
  if (CookieJar) {
    cookieJar = new CookieJar(cookiePartitionId, {
      programmaticAccess: options.cookieConfiguration,
      readFromDB: !_.get(info, 'cookie.runtimeWithEmptyJar', false),
      writeToDB: !_.get(info, 'cookie.disableRealtimeWrite', false),
      onCookieAccessDenied: domain => {
        let message = `Unable to access "${domain}" cookie store.` +
        ' Try whitelisting the domain in "Manage Cookies" screen.' +
        ' View more detailed instructions in the Learning Center: https://go.pstmn.io/docs-cookies';

        emit({
          name: 'log',
          namespace: 'console',
          data: {
            id: info.id,
            cursor: {},
            level: 'warn',
            messages: [message] } });


      } });


    _.set(options, ['requester', 'cookieJar'], cookieJar);
  }

  // fileResolver defined and we have PostmanFs
  if (options.fileResolver && !!PostmanFs) {
    let { workingDir, insecureFileRead, fileWhitelist } = options.fileResolver;

    _.set(options, 'fileResolver', new PostmanFs(workingDir || defaultWorkingDir, insecureFileRead, fileWhitelist));
  }

  // sanitize
  sanitizeRunOptions(options);

  // add variables
  variables.environment && (options.environment = new postmanCollectionSdk.VariableScope(variables.environment));
  variables.globals && (options.globals = new postmanCollectionSdk.VariableScope(variables.globals));

  collectionRunner.run(sdkCollection, options, function (err, run) {
    if (err) {
      pm.logger.error('RuntimeExecutionService~startRun - Error in starting the run', err);

      this.emit({ id: info.id, event: '__dispose__', error: true });
      return;
    }

    trackRun(info.id, run, eventProccessor);

    // Intercept beforeRequest and response and done events
    eventProccessor.intercept('beforeRequest', (_, __, ___, ____, aborter) => {
      addAborter(info.id, aborter);
    });

    eventProccessor.intercept('response', (err, _, response) => {
      removeAborter(info.id);

      // If the response is present, and download is set then
      if (!err && response && info.download) {
        saveStreamToFile(response.contentInfo(), response.stream, (err, success) => {
          // If there is an error success then emit the download event
          (err || success) && eventProccessor.call('download', [err]);
        });
      }
    });

    eventProccessor.intercept('done', () => {
      if (info.cookie && info.cookie.saveAfterRun && cookieJar && typeof cookieJar.updateStore === 'function') {
        // TODO - DECIDE on what to do with cookies when there was an error in done
        cookieJar.updateStore(() => {
          disposeRun(info.id, emit);
        });

        return;
      }
      disposeRun(info.id, emit);
    });

    // Note: .handlers should be called after all interceptors have been attached
    // else events not part of schema will be ignored
    run.start(eventProccessor.handlers());
  });
}

/**
   * @public
   * LivePreview: Calling runtime's `dryRunRequest` to get previewed request
   *
   * @param {Request} request
   * @param {Object} info
   * @param {Object} options
   * @param {Function} cb
   */
function previewRequest(request, options = {}, cb) {
  let requestToPreview = new postmanCollectionSdk.Request(request),
  dryRunOptions = _.pick(options, ['implicitCacheControl', 'implicitTraceHeader', 'protocolProfileBehavior']);

  options.cookiePartitionId && CookieJar && (
  dryRunOptions.cookieJar = new CookieJar(options.cookiePartitionId, { readFromDB: true, writeToDB: false }));

  try {
    dryRunRequest(requestToPreview, dryRunOptions, (err, previewedRequest) => {
      cb(err, previewedRequest && previewedRequest.toJSON());
    });
  }
  catch (e) {
    pm.logger.error('RuntimeExecutionService~previewRequest.dryRunRequest', e);
  }
}

/**
   * Checks if the given path is within the working directory
   */
function isInWorkingDir(workingDir, path) {
  return Boolean(new PostmanFs(workingDir)._resolve(path, []));
}

/**
   * Create Temporary File
   * @param name
   * @param content
   */
function createTemporaryFile(name, content, cb) {
  const basePath = app.getPath('temp'),
  tempFilePath = path.join(basePath, name);

  async.waterfall([
  // Attempt to clear the file if it already exists.
  // Note: We ignore the error here
  next => fs.unlink(tempFilePath, () => next()),

  // Write the contents of the temp directory
  next => fs.writeFile(tempFilePath, content, next)],
  err => {
    cb(err && new SerializedError(err), tempFilePath);
  });
}

/**
   * Read file from filesystem
   * @param {String} id
   * @param {String} path
   */
function readFile(path, cb) {
  fs.readFile(path, (err, content) => {
    if (!err) {
      try {
        // From here on we will try detect the encoding and convert the buffer accordingly
        content = content.toString(detectEncoding(content));
      } catch (e) {
        err = new Error('Failed to detect encoding of the file content');
      }
    }

    return cb(err && new SerializedError(err), content);
  });
}

/**
   * Check if the given path has the required file-system access
   * @param {String} id
   * @param {String} path
   * @param {Boolean} writable
   */
function accessFile(path, writeable, cb) {
  // If no path is given then there is nothing to check
  if (!path) {
    return cb();
  }

  const perm = writeable ? fs.constants.R_OK | fs.constants.W_OK : fs.constants.R_OK;

  fs.access(path, perm, err => {
    cb(err && new SerializedError(err));
  });
}

/**
   * Handle CookieManager queries
   *
   * @param {String} method
   * @param {String} partitionId
   * @param {Object} options
   * @param {Function} cb
   */
function cookieHandler(method, partitionId, options, cb) {
  if (!(typeof CookieManager.prototype[method] === 'function' && partitionId && options)) {
    return cb(new TypeError('Illegal invocation'));
  }

  CookieManager.prototype[method].call({
    cookieStore: CookieManager.getCookieStore(partitionId) },
  options, cb);
}

/**
   * Listen to `changed` event on cookies of a partition
   *
   * @param {String} partitionId
   * @param {Function} cb
   */
function attachCookiesChangeListener(partitionId, cb) {
  const partition = session.fromPartition(partitionId);

  partition && partition.cookies.on('changed', cb);
}

// #endregion

// We have two places that this is going to be used main process in electron and the we agent, hence we expose two API's here
module.exports = function () {
  // IMPORTANT: Do not remove this comment. Used by webpack to ignore this section
};


module.exports.Browser = async function () {
  const postmanRuntime = await __webpack_require__.e(/* import() | postman-runtime */ 13).then(__webpack_require__.t.bind(null, 6772, 7));

  chardet = __webpack_require__(5688);
  postmanCollectionSdk = __webpack_require__(790);
  SerializedError = __webpack_require__(5686);

  collectionRunner = new postmanRuntime.Runner();
  dryRunRequest = postmanRuntime.Requester && postmanRuntime.Requester.dryRun;

  isBrowser = true;


  return {
    startRun,
    stopRun,
    pauseRun,
    resumeRun,

    previewRequest,
    saveStreamToFile };

};

/***/ }),

/***/ 5685:
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(Buffer) {const async = __webpack_require__(664),
SerializedError = __webpack_require__(5686),
sid = __webpack_require__(5628),

noOp = () => {},
get = (obj, path, defaultValue = undefined) => {
  const travel = regexp =>
  String.prototype.split.
  call(path, regexp).
  filter(Boolean).
  reduce((res, key) => res !== null && res !== undefined ? res[key] : res, obj);
  const result = travel(/[,[\]]+?/) || travel(/[,[\].]+?/);
  return result === undefined || result === obj ? defaultValue : result;
},

DEFAULT_CHUNK_SIZE = 10 * 1024 * 1024;let

Node = class Node {
  constructor(schema, manager) {
    // Replacement key for the property
    this.key = schema.key;

    // The source data structure
    this.from = schema.from || false;

    // The target data structure
    this.to = schema.to || false;

    // Create the selectation object chain
    if (schema.select) {
      // Create the selecters
      this.select = Object.
      keys(schema.select).
      map(k => {
        // If the value is false or null then we need to skip this selection
        if (schema.select[k] === false || schema.select[k] === null) {
          return false;
        }

        let N = {};

        // If the selection is a type of object then create new node
        if (typeof schema.select[k] === 'object') {
          N = new Node(schema.select[k], manager);
        }

        N._key = k;

        return N;
      }).
      filter(Boolean);
    } else {
      this.select = false;
    }

    // Create the mutations
    this.replace = schema.replace || false;

    // Create stream
    this.stream = schema.stream || false;

    // Set the streamEmitter
    this.manager = manager;

    // Array to save the ref id
    this._ref = [];
  }

  refs() {
    if (!this.select) {
      return this._ref;
    }

    return this.select.reduce((A, N) => {
      if (!(N instanceof Node)) {
        return A;
      }

      return A.concat(...N.refs());

    }, this._ref);
  }

  saveRef(id, data, options) {
    this._ref.push(id);
    this.manager.saveRef(id, { data, options });
  }

  $replace(input) {
    if (this.replace === false) {
      return input;
    }

    if (this.replace.call && typeof input === 'function') {
      return input();
    } else if (this.replace.fn && typeof input[this.replace.fn] === 'function') {
      return input[this.replace.fn]();
    } else if (this.replace.set) {
      return get(input, this.replace.set);
    } else if (Array.isArray(input) && this.replace.slice) {
      input[this.replace.slice.to] = input.slice.apply(input, this.replace.slice.from);

      return input;
    } else if (Array.isArray(this.replace.error)) {
      this.replace.error.forEach(e => {
        input[e] = input[e] && new SerializedError(input[e]);
      });

      return input;
    } else if (this.replace.stream && typeof Buffer !== 'undefined') {// If Buffer is undefined we can't stream
      // Streaming will work only if the input is a string or buffer
      if (!(typeof input === 'string' || Buffer.isBuffer(input))) {
        return input;
      }

      const chunk = this.replace.chunk || DEFAULT_CHUNK_SIZE;

      // If length if the input is smaller than the chunk size then just directly send it back
      // Streaming is not required;
      if (input.length <= chunk) {
        return input;
      }

      const id = sid.generate();

      this.saveRef(id, input, { chunk });

      return { $ref: id };
    } else if (this.replace.limit) {
      // Check on the existance of the .length property
      if (!input.length || input.length <= this.replace.limit) {
        return input;
      }

      if (this.replace.drop) {
        return { ___dropped___: true };
      } else if (typeof Buffer !== 'undefined' && Buffer.isBuffer(input)) {
        return { ___truncated___: true, data: input.subarray(0, this.replace.limit) };
      } else if (typeof input === 'string') {
        return { ___truncated___: true, data: input.substring(0, this.replace.limit) };
      }

      return { ___truncated___: true };
    } else
    {
      return input || this.replace.default;
    }
  }

  $select(input) {
    if (this.select === false) {
      return input;
    }

    return this.select.reduce((A, T) => {
      let parsed = input[T._key];

      // if the parsed value is a function then bind the parent input
      if (typeof parsed === 'function') {
        parsed = parsed.bind(input);
      }

      // If T is not an instance of a node then its a leaf
      if (parsed !== undefined && parsed !== null && T instanceof Node) {
        parsed = T.parse(parsed);
      }

      if (T.error !== false && (
      T.key === 'error' ||
      T.key === 'err' ||
      T._key === 'error' ||
      T._key === 'err') && Boolean(parsed)) {
        parsed = new SerializedError(parsed);
      }

      A[T.key || T._key] = parsed;

      return A;
    }, Array.isArray(input) && this.to !== 'object' ? [] : {});
  }

  /**
     * The argument to parse with node
     * @param {Array|Object} arg
     */
  parse(arg) {
    return [
    this.$replace.bind(this),
    this.$select.bind(this)].
    reduce((acc, fn) => fn(acc), arg);
  }};let


EventProcessor = class EventProcessor {
  constructor(schema = {}, emitter = noOp) {
    // Save the emitter to output the final data
    this.emitter = emitter;

    // This is streamer interface which can be used to send chunked data
    this.emitQueue = async.queue(({ event, data, refs }, done) => {
      // Send the chunk of data with the given id to the process otherside
      emitter(event, data, refs);

      // Defer the next transmit to the next event loop cycle
      setTimeout(done, 0);
    });

    // Now lets crate the processor map
    this.events = new Map([]);

    // Iterate over all the events process then
    Object.keys(schema).forEach(event => {
      // Set the root node to the events
      this.events.set(event, new Set([new Node(schema[event], this)]));
    });

    this.streams = new Map([]);
  }

  saveRef(id, data) {
    // We can later chose to save the refs to a file and stream from there
    this.streams.set(id, data);
  }

  intercept(event, fn) {
    if (this.events.has(event)) {
      this.events.get(event).add(fn);
    } else {
      this.events.set(event, new Set([fn]));
    }
  }

  streamPending(refs) {
    refs.forEach(ref => {
      const { data, options } = this.streams.get(ref),
      chunk = options.chunk || 1 * 1024 * 1024; // Default to 1MB chunks

      // We start from the start index until the chunks runout
      for (var i = 0, ii = 0; i < data.length; i += chunk, ii++) {
        const subarray = data.subarray(i, Math.min(i + chunk, data.length));

        this.emitQueue.push({
          event: '__ref__',
          data: {
            id: ref,
            meta: { index: ii, offset: i, length: subarray.length },
            data: subarray } });


      }

      this.emitQueue.push({
        event: '__ref__',
        data: {
          id: ref,
          meta: { end: true } } });



      // Finally clear refs to get garbage collected
      this.streams.delete(ref);
    });
  }

  call(event, args) {
    // Check if the events still exists in the map, else return
    if (!this.events.has(event)) {return;}

    // Iterate through each of the handlers for this event and fire them one after another
    this.events.
    get(event).
    forEach(handler => {
      if (handler instanceof Node) {
        // Call the parser funciton with the incoming arguments
        // Note: .refs must always be called after .parse. Refs are not generated
        // Until data is parsed;
        const data = handler.parse(args),
        refs = handler.refs();

        // 1. Emit the event first (Order is important)
        this.emitQueue.push({ event, data, refs });

        // 2. Start streaming the pending refs
        this.streamPending(refs);
      } else if (typeof handler === 'function') {
        setTimeout(() => {handler(...args);}, 0);
      }
    });
  }

  handlers() {
    return [...this.events.keys()].reduce((acc, name) => {
      acc[name] = (...args) => {this.call(name, args);};

      return acc;
    }, {});
  }};


module.exports = EventProcessor;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(104).Buffer))

/***/ }),

/***/ 5686:
/***/ (function(module, exports, __webpack_require__) {

var stacktrace = __webpack_require__(5687),
    hash = __webpack_require__(3740),
    uuid = __webpack_require__(650),
    SerialisedError;

SerialisedError = function (err, decorate) {
    var now = new Date(); // to hold date here before any more time is lost

    // If the function is called without the `new` operator, then we do it on behalf of the callee
	if (!(this instanceof SerialisedError)) {
		return new SerialisedError(err, decorate);
	}

    // Iterate on user-defined properties of error and mix in the default non ennumerable properties
	(typeof err === 'object') && (err !== null) &&
        Object.keys(err).concat(['name', 'message', 'stack']).forEach(function (key) {
    		this[key] = err[key];
    	}, this);

    // add additional meta information
    if (decorate) {
        this.checksum = hash.MD5(this);
        this.id = uuid.v4();
        this.timestamp = now.getTime();
        this.stacktrace = stacktrace.parse(this);
    }
};

module.exports = SerialisedError;


/***/ }),

/***/ 5687:
/***/ (function(module, exports) {

exports.get = function(belowFn) {
  var oldLimit = Error.stackTraceLimit;
  Error.stackTraceLimit = Infinity;

  var dummyObject = {};

  var v8Handler = Error.prepareStackTrace;
  Error.prepareStackTrace = function(dummyObject, v8StackTrace) {
    return v8StackTrace;
  };
  Error.captureStackTrace(dummyObject, belowFn || exports.get);

  var v8StackTrace = dummyObject.stack;
  Error.prepareStackTrace = v8Handler;
  Error.stackTraceLimit = oldLimit;

  return v8StackTrace;
};

exports.parse = function(err) {
  if (!err.stack) {
    return [];
  }

  var self = this;
  var lines = err.stack.split('\n').slice(1);

  return lines
    .map(function(line) {
      if (line.match(/^\s*[-]{4,}$/)) {
        return self._createParsedCallSite({
          fileName: line,
          lineNumber: null,
          functionName: null,
          typeName: null,
          methodName: null,
          columnNumber: null,
          'native': null,
        });
      }

      var lineMatch = line.match(/at (?:(.+)\s+)?\(?(?:(.+?):(\d+):(\d+)|([^)]+))\)?/);
      if (!lineMatch) {
        return;
      }

      var object = null;
      var method = null;
      var functionName = null;
      var typeName = null;
      var methodName = null;
      var isNative = (lineMatch[5] === 'native');

      if (lineMatch[1]) {
        var methodMatch = lineMatch[1].match(/([^\.]+)(?:\.(.+))?/);
        object = methodMatch[1];
        method = methodMatch[2];
        functionName = lineMatch[1];
        typeName = 'Object';
      }

      if (method) {
        typeName = object;
        methodName = method;
      }

      if (method === '<anonymous>') {
        methodName = null;
        functionName = '';
      }

      var properties = {
        fileName: lineMatch[2] || null,
        lineNumber: parseInt(lineMatch[3], 10) || null,
        functionName: functionName,
        typeName: typeName,
        methodName: methodName,
        columnNumber: parseInt(lineMatch[4], 10) || null,
        'native': isNative,
      };

      return self._createParsedCallSite(properties);
    })
    .filter(function(callSite) {
      return !!callSite;
    });
};

exports._createParsedCallSite = function(properties) {
  var methods = {};
  for (var property in properties) {
    var prefix = 'get';
    if (property === 'native') {
      prefix = 'is';
    }
    var method = prefix + property.substr(0, 1).toUpperCase() + property.substr(1);

    (function(property) {
      methods[method] = function() {
        return properties[property];
      }
    })(property);
  }

  var callSite = Object.create(methods);
  for (var property in properties) {
    callSite[property] = properties[property];
  }

  return callSite;
};


/***/ }),

/***/ 5688:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(Buffer) {
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const utf8_1 = __importDefault(__webpack_require__(5689));
const unicode = __importStar(__webpack_require__(5691));
const mbcs = __importStar(__webpack_require__(5692));
const sbcs = __importStar(__webpack_require__(5693));
const iso2022 = __importStar(__webpack_require__(5694));
let fsModule;
const loadFs = () => {
    if ( true && typeof module.exports === 'object') {
        fsModule = fsModule ? fsModule : __webpack_require__(144);
        return fsModule;
    }
    throw new Error('File system is not available');
};
const recognisers = [
    new utf8_1.default(),
    new unicode.UTF_16BE(),
    new unicode.UTF_16LE(),
    new unicode.UTF_32BE(),
    new unicode.UTF_32LE(),
    new mbcs.sjis(),
    new mbcs.big5(),
    new mbcs.euc_jp(),
    new mbcs.euc_kr(),
    new mbcs.gb_18030(),
    new iso2022.ISO_2022_JP(),
    new iso2022.ISO_2022_KR(),
    new iso2022.ISO_2022_CN(),
    new sbcs.ISO_8859_1(),
    new sbcs.ISO_8859_2(),
    new sbcs.ISO_8859_5(),
    new sbcs.ISO_8859_6(),
    new sbcs.ISO_8859_7(),
    new sbcs.ISO_8859_8(),
    new sbcs.ISO_8859_9(),
    new sbcs.windows_1251(),
    new sbcs.windows_1256(),
    new sbcs.KOI8_R(),
];
exports.detect = (buffer) => {
    const matches = exports.analyse(buffer);
    return matches.length > 0 ? matches[0].name : null;
};
exports.analyse = (buffer) => {
    const fByteStats = [];
    for (let i = 0; i < 256; i++)
        fByteStats[i] = 0;
    for (let i = buffer.length - 1; i >= 0; i--)
        fByteStats[buffer[i] & 0x00ff]++;
    let fC1Bytes = false;
    for (let i = 0x80; i <= 0x9f; i += 1) {
        if (fByteStats[i] !== 0) {
            fC1Bytes = true;
            break;
        }
    }
    const context = {
        fByteStats,
        fC1Bytes,
        fRawInput: buffer,
        fRawLength: buffer.length,
        fInputBytes: buffer,
        fInputLen: buffer.length,
    };
    const matches = recognisers
        .map((rec) => {
        return rec.match(context);
    })
        .filter((match) => {
        return !!match;
    })
        .sort((a, b) => {
        return b.confidence - a.confidence;
    });
    return matches;
};
exports.detectFile = (filepath, opts = {}) => new Promise((resolve, reject) => {
    let fd;
    const fs = loadFs();
    const handler = (err, buffer) => {
        if (fd) {
            fs.closeSync(fd);
        }
        if (err) {
            reject(err);
        }
        else {
            resolve(exports.detect(buffer));
        }
    };
    if (opts && opts.sampleSize) {
        fd = fs.openSync(filepath, 'r');
        const sample = Buffer.allocUnsafe(opts.sampleSize);
        fs.read(fd, sample, 0, opts.sampleSize, null, (err) => {
            handler(err, sample);
        });
        return;
    }
    fs.readFile(filepath, handler);
});
exports.detectFileSync = (filepath, opts = {}) => {
    const fs = loadFs();
    if (opts && opts.sampleSize) {
        const fd = fs.openSync(filepath, 'r');
        const sample = Buffer.allocUnsafe(opts.sampleSize);
        fs.readSync(fd, sample, 0, opts.sampleSize);
        fs.closeSync(fd);
        return exports.detect(sample);
    }
    return exports.detect(fs.readFileSync(filepath));
};
exports.default = {
    analyse: exports.analyse,
    detect: exports.detect,
    detectFileSync: exports.detectFileSync,
    detectFile: exports.detectFile,
};
//# sourceMappingURL=index.js.map
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(104).Buffer))

/***/ }),

/***/ 5689:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var match = __webpack_require__(5690).default;
class Utf8 {
    name() {
        return 'UTF-8';
    }
    match(det) {
        var hasBOM = false, numValid = 0, numInvalid = 0, input = det.fRawInput, trailBytes = 0, confidence;
        if (det.fRawLength >= 3 &&
            (input[0] & 0xff) == 0xef &&
            (input[1] & 0xff) == 0xbb &&
            (input[2] & 0xff) == 0xbf) {
            hasBOM = true;
        }
        for (var i = 0; i < det.fRawLength; i++) {
            var b = input[i];
            if ((b & 0x80) == 0)
                continue;
            if ((b & 0x0e0) == 0x0c0) {
                trailBytes = 1;
            }
            else if ((b & 0x0f0) == 0x0e0) {
                trailBytes = 2;
            }
            else if ((b & 0x0f8) == 0xf0) {
                trailBytes = 3;
            }
            else {
                numInvalid++;
                if (numInvalid > 5)
                    break;
                trailBytes = 0;
            }
            for (;;) {
                i++;
                if (i >= det.fRawLength)
                    break;
                if ((input[i] & 0xc0) != 0x080) {
                    numInvalid++;
                    break;
                }
                if (--trailBytes == 0) {
                    numValid++;
                    break;
                }
            }
        }
        confidence = 0;
        if (hasBOM && numInvalid == 0)
            confidence = 100;
        else if (hasBOM && numValid > numInvalid * 10)
            confidence = 80;
        else if (numValid > 3 && numInvalid == 0)
            confidence = 100;
        else if (numValid > 0 && numInvalid == 0)
            confidence = 80;
        else if (numValid == 0 && numInvalid == 0)
            confidence = 10;
        else if (numValid > numInvalid * 10)
            confidence = 25;
        else
            return null;
        return match(det, this, confidence);
    }
}
exports.default = Utf8;
//# sourceMappingURL=utf8.js.map

/***/ }),

/***/ 5690:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.default = (det, rec, confidence, name, lang) => ({
    confidence,
    name: name || rec.name(det),
    lang,
});
//# sourceMappingURL=match.js.map

/***/ }),

/***/ 5691:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const match = __webpack_require__(5690).default;
class UTF_16BE {
    name() {
        return 'UTF-16BE';
    }
    match(det) {
        var input = det.fRawInput;
        if (input.length >= 2 &&
            (input[0] & 0xff) == 0xfe &&
            (input[1] & 0xff) == 0xff) {
            return match(det, this, 100);
        }
        return null;
    }
}
exports.UTF_16BE = UTF_16BE;
class UTF_16LE {
    name() {
        return 'UTF-16LE';
    }
    match(det) {
        var input = det.fRawInput;
        if (input.length >= 2 &&
            (input[0] & 0xff) == 0xff &&
            (input[1] & 0xff) == 0xfe) {
            if (input.length >= 4 && input[2] == 0x00 && input[3] == 0x00) {
                return null;
            }
            return match(det, this, 100);
        }
        return null;
    }
}
exports.UTF_16LE = UTF_16LE;
class UTF_32 {
    name() {
        return 'UTF-32';
    }
    getChar(input, index) {
        return -1;
    }
    match(det) {
        var input = det.fRawInput, limit = (det.fRawLength / 4) * 4, numValid = 0, numInvalid = 0, hasBOM = false, confidence = 0;
        if (limit == 0) {
            return null;
        }
        if (this.getChar(input, 0) == 0x0000feff) {
            hasBOM = true;
        }
        for (var i = 0; i < limit; i += 4) {
            var ch = this.getChar(input, i);
            if (ch < 0 || ch >= 0x10ffff || (ch >= 0xd800 && ch <= 0xdfff)) {
                numInvalid += 1;
            }
            else {
                numValid += 1;
            }
        }
        if (hasBOM && numInvalid == 0) {
            confidence = 100;
        }
        else if (hasBOM && numValid > numInvalid * 10) {
            confidence = 80;
        }
        else if (numValid > 3 && numInvalid == 0) {
            confidence = 100;
        }
        else if (numValid > 0 && numInvalid == 0) {
            confidence = 80;
        }
        else if (numValid > numInvalid * 10) {
            confidence = 25;
        }
        return confidence == 0 ? null : match(det, this, confidence);
    }
}
class UTF_32BE extends UTF_32 {
    name() {
        return 'UTF-32BE';
    }
    getChar(input, index) {
        return (((input[index + 0] & 0xff) << 24) |
            ((input[index + 1] & 0xff) << 16) |
            ((input[index + 2] & 0xff) << 8) |
            (input[index + 3] & 0xff));
    }
}
exports.UTF_32BE = UTF_32BE;
class UTF_32LE extends UTF_32 {
    name() {
        return 'UTF-32LE';
    }
    getChar(input, index) {
        return (((input[index + 3] & 0xff) << 24) |
            ((input[index + 2] & 0xff) << 16) |
            ((input[index + 1] & 0xff) << 8) |
            (input[index + 0] & 0xff));
    }
}
exports.UTF_32LE = UTF_32LE;
//# sourceMappingURL=unicode.js.map

/***/ }),

/***/ 5692:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var match = __webpack_require__(5690).default;
function binarySearch(arr, searchValue) {
    const find = (arr, searchValue, left, right) => {
        if (right < left)
            return -1;
        var mid = Math.floor((left + right) >>> 1);
        if (searchValue > arr[mid])
            return find(arr, searchValue, mid + 1, right);
        if (searchValue < arr[mid])
            return find(arr, searchValue, left, mid - 1);
        return mid;
    };
    return find(arr, searchValue, 0, arr.length - 1);
}
class IteratedChar {
    constructor() {
        this.charValue = 0;
        this.index = 0;
        this.nextIndex = 0;
        this.error = false;
        this.done = false;
    }
    reset() {
        this.charValue = 0;
        this.index = -1;
        this.nextIndex = 0;
        this.error = false;
        this.done = false;
    }
    nextByte(det) {
        if (this.nextIndex >= det.fRawLength) {
            this.done = true;
            return -1;
        }
        var byteValue = det.fRawInput[this.nextIndex++] & 0x00ff;
        return byteValue;
    }
}
class mbcs {
    constructor() {
        this.commonChars = [];
    }
    name() {
        return 'mbcs';
    }
    match(det) {
        var singleByteCharCount = 0, doubleByteCharCount = 0, commonCharCount = 0, badCharCount = 0, totalCharCount = 0, confidence = 0;
        var iter = new IteratedChar();
        detectBlock: {
            for (iter.reset(); this.nextChar(iter, det);) {
                totalCharCount++;
                if (iter.error) {
                    badCharCount++;
                }
                else {
                    var cv = iter.charValue & 0xffffffff;
                    if (cv <= 0xff) {
                        singleByteCharCount++;
                    }
                    else {
                        doubleByteCharCount++;
                        if (this.commonChars != null) {
                            if (binarySearch(this.commonChars, cv) >= 0) {
                                commonCharCount++;
                            }
                        }
                    }
                }
                if (badCharCount >= 2 && badCharCount * 5 >= doubleByteCharCount) {
                    break detectBlock;
                }
            }
            if (doubleByteCharCount <= 10 && badCharCount == 0) {
                if (doubleByteCharCount == 0 && totalCharCount < 10) {
                    confidence = 0;
                }
                else {
                    confidence = 10;
                }
                break detectBlock;
            }
            if (doubleByteCharCount < 20 * badCharCount) {
                confidence = 0;
                break detectBlock;
            }
            if (this.commonChars == null) {
                confidence = 30 + doubleByteCharCount - 20 * badCharCount;
                if (confidence > 100) {
                    confidence = 100;
                }
            }
            else {
                var maxVal = Math.log(parseFloat(doubleByteCharCount) / 4);
                var scaleFactor = 90.0 / maxVal;
                confidence = Math.floor(Math.log(commonCharCount + 1) * scaleFactor + 10);
                confidence = Math.min(confidence, 100);
            }
        }
        return confidence == 0 ? null : match(det, this, confidence);
    }
    nextChar(iter, det) {
        return true;
    }
}
class sjis extends mbcs {
    constructor() {
        super(...arguments);
        this.commonChars = [
            0x8140,
            0x8141,
            0x8142,
            0x8145,
            0x815b,
            0x8169,
            0x816a,
            0x8175,
            0x8176,
            0x82a0,
            0x82a2,
            0x82a4,
            0x82a9,
            0x82aa,
            0x82ab,
            0x82ad,
            0x82af,
            0x82b1,
            0x82b3,
            0x82b5,
            0x82b7,
            0x82bd,
            0x82be,
            0x82c1,
            0x82c4,
            0x82c5,
            0x82c6,
            0x82c8,
            0x82c9,
            0x82cc,
            0x82cd,
            0x82dc,
            0x82e0,
            0x82e7,
            0x82e8,
            0x82e9,
            0x82ea,
            0x82f0,
            0x82f1,
            0x8341,
            0x8343,
            0x834e,
            0x834f,
            0x8358,
            0x835e,
            0x8362,
            0x8367,
            0x8375,
            0x8376,
            0x8389,
            0x838a,
            0x838b,
            0x838d,
            0x8393,
            0x8e96,
            0x93fa,
            0x95aa,
        ];
    }
    name() {
        return 'Shift_JIS';
    }
    language() {
        return 'ja';
    }
    nextChar(iter, det) {
        iter.index = iter.nextIndex;
        iter.error = false;
        var firstByte;
        firstByte = iter.charValue = iter.nextByte(det);
        if (firstByte < 0)
            return false;
        if (firstByte <= 0x7f || (firstByte > 0xa0 && firstByte <= 0xdf))
            return true;
        var secondByte = iter.nextByte(det);
        if (secondByte < 0)
            return false;
        iter.charValue = (firstByte << 8) | secondByte;
        if (!((secondByte >= 0x40 && secondByte <= 0x7f) ||
            (secondByte >= 0x80 && secondByte <= 0xff))) {
            iter.error = true;
        }
        return true;
    }
}
exports.sjis = sjis;
class big5 extends mbcs {
    constructor() {
        super(...arguments);
        this.commonChars = [
            0xa140,
            0xa141,
            0xa142,
            0xa143,
            0xa147,
            0xa149,
            0xa175,
            0xa176,
            0xa440,
            0xa446,
            0xa447,
            0xa448,
            0xa451,
            0xa454,
            0xa457,
            0xa464,
            0xa46a,
            0xa46c,
            0xa477,
            0xa4a3,
            0xa4a4,
            0xa4a7,
            0xa4c1,
            0xa4ce,
            0xa4d1,
            0xa4df,
            0xa4e8,
            0xa4fd,
            0xa540,
            0xa548,
            0xa558,
            0xa569,
            0xa5cd,
            0xa5e7,
            0xa657,
            0xa661,
            0xa662,
            0xa668,
            0xa670,
            0xa6a8,
            0xa6b3,
            0xa6b9,
            0xa6d3,
            0xa6db,
            0xa6e6,
            0xa6f2,
            0xa740,
            0xa751,
            0xa759,
            0xa7da,
            0xa8a3,
            0xa8a5,
            0xa8ad,
            0xa8d1,
            0xa8d3,
            0xa8e4,
            0xa8fc,
            0xa9c0,
            0xa9d2,
            0xa9f3,
            0xaa6b,
            0xaaba,
            0xaabe,
            0xaacc,
            0xaafc,
            0xac47,
            0xac4f,
            0xacb0,
            0xacd2,
            0xad59,
            0xaec9,
            0xafe0,
            0xb0ea,
            0xb16f,
            0xb2b3,
            0xb2c4,
            0xb36f,
            0xb44c,
            0xb44e,
            0xb54c,
            0xb5a5,
            0xb5bd,
            0xb5d0,
            0xb5d8,
            0xb671,
            0xb7ed,
            0xb867,
            0xb944,
            0xbad8,
            0xbb44,
            0xbba1,
            0xbdd1,
            0xc2c4,
            0xc3b9,
            0xc440,
            0xc45f,
        ];
    }
    name() {
        return 'Big5';
    }
    language() {
        return 'zh';
    }
    nextChar(iter, det) {
        iter.index = iter.nextIndex;
        iter.error = false;
        var firstByte = (iter.charValue = iter.nextByte(det));
        if (firstByte < 0)
            return false;
        if (firstByte <= 0x7f || firstByte == 0xff)
            return true;
        var secondByte = iter.nextByte(det);
        if (secondByte < 0)
            return false;
        iter.charValue = (iter.charValue << 8) | secondByte;
        if (secondByte < 0x40 || secondByte == 0x7f || secondByte == 0xff)
            iter.error = true;
        return true;
    }
}
exports.big5 = big5;
function eucNextChar(iter, det) {
    iter.index = iter.nextIndex;
    iter.error = false;
    var firstByte = 0;
    var secondByte = 0;
    var thirdByte = 0;
    buildChar: {
        firstByte = iter.charValue = iter.nextByte(det);
        if (firstByte < 0) {
            iter.done = true;
            break buildChar;
        }
        if (firstByte <= 0x8d) {
            break buildChar;
        }
        secondByte = iter.nextByte(det);
        iter.charValue = (iter.charValue << 8) | secondByte;
        if (firstByte >= 0xa1 && firstByte <= 0xfe) {
            if (secondByte < 0xa1) {
                iter.error = true;
            }
            break buildChar;
        }
        if (firstByte == 0x8e) {
            if (secondByte < 0xa1) {
                iter.error = true;
            }
            break buildChar;
        }
        if (firstByte == 0x8f) {
            thirdByte = iter.nextByte(det);
            iter.charValue = (iter.charValue << 8) | thirdByte;
            if (thirdByte < 0xa1) {
                iter.error = true;
            }
        }
    }
    return iter.done == false;
}
class euc_jp extends mbcs {
    constructor() {
        super(...arguments);
        this.commonChars = [
            0xa1a1,
            0xa1a2,
            0xa1a3,
            0xa1a6,
            0xa1bc,
            0xa1ca,
            0xa1cb,
            0xa1d6,
            0xa1d7,
            0xa4a2,
            0xa4a4,
            0xa4a6,
            0xa4a8,
            0xa4aa,
            0xa4ab,
            0xa4ac,
            0xa4ad,
            0xa4af,
            0xa4b1,
            0xa4b3,
            0xa4b5,
            0xa4b7,
            0xa4b9,
            0xa4bb,
            0xa4bd,
            0xa4bf,
            0xa4c0,
            0xa4c1,
            0xa4c3,
            0xa4c4,
            0xa4c6,
            0xa4c7,
            0xa4c8,
            0xa4c9,
            0xa4ca,
            0xa4cb,
            0xa4ce,
            0xa4cf,
            0xa4d0,
            0xa4de,
            0xa4df,
            0xa4e1,
            0xa4e2,
            0xa4e4,
            0xa4e8,
            0xa4e9,
            0xa4ea,
            0xa4eb,
            0xa4ec,
            0xa4ef,
            0xa4f2,
            0xa4f3,
            0xa5a2,
            0xa5a3,
            0xa5a4,
            0xa5a6,
            0xa5a7,
            0xa5aa,
            0xa5ad,
            0xa5af,
            0xa5b0,
            0xa5b3,
            0xa5b5,
            0xa5b7,
            0xa5b8,
            0xa5b9,
            0xa5bf,
            0xa5c3,
            0xa5c6,
            0xa5c7,
            0xa5c8,
            0xa5c9,
            0xa5cb,
            0xa5d0,
            0xa5d5,
            0xa5d6,
            0xa5d7,
            0xa5de,
            0xa5e0,
            0xa5e1,
            0xa5e5,
            0xa5e9,
            0xa5ea,
            0xa5eb,
            0xa5ec,
            0xa5ed,
            0xa5f3,
            0xb8a9,
            0xb9d4,
            0xbaee,
            0xbbc8,
            0xbef0,
            0xbfb7,
            0xc4ea,
            0xc6fc,
            0xc7bd,
            0xcab8,
            0xcaf3,
            0xcbdc,
            0xcdd1,
        ];
        this.nextChar = eucNextChar;
    }
    name() {
        return 'EUC-JP';
    }
    language() {
        return 'ja';
    }
}
exports.euc_jp = euc_jp;
class euc_kr extends mbcs {
    constructor() {
        super(...arguments);
        this.commonChars = [
            0xb0a1,
            0xb0b3,
            0xb0c5,
            0xb0cd,
            0xb0d4,
            0xb0e6,
            0xb0ed,
            0xb0f8,
            0xb0fa,
            0xb0fc,
            0xb1b8,
            0xb1b9,
            0xb1c7,
            0xb1d7,
            0xb1e2,
            0xb3aa,
            0xb3bb,
            0xb4c2,
            0xb4cf,
            0xb4d9,
            0xb4eb,
            0xb5a5,
            0xb5b5,
            0xb5bf,
            0xb5c7,
            0xb5e9,
            0xb6f3,
            0xb7af,
            0xb7c2,
            0xb7ce,
            0xb8a6,
            0xb8ae,
            0xb8b6,
            0xb8b8,
            0xb8bb,
            0xb8e9,
            0xb9ab,
            0xb9ae,
            0xb9cc,
            0xb9ce,
            0xb9fd,
            0xbab8,
            0xbace,
            0xbad0,
            0xbaf1,
            0xbbe7,
            0xbbf3,
            0xbbfd,
            0xbcad,
            0xbcba,
            0xbcd2,
            0xbcf6,
            0xbdba,
            0xbdc0,
            0xbdc3,
            0xbdc5,
            0xbec6,
            0xbec8,
            0xbedf,
            0xbeee,
            0xbef8,
            0xbefa,
            0xbfa1,
            0xbfa9,
            0xbfc0,
            0xbfe4,
            0xbfeb,
            0xbfec,
            0xbff8,
            0xc0a7,
            0xc0af,
            0xc0b8,
            0xc0ba,
            0xc0bb,
            0xc0bd,
            0xc0c7,
            0xc0cc,
            0xc0ce,
            0xc0cf,
            0xc0d6,
            0xc0da,
            0xc0e5,
            0xc0fb,
            0xc0fc,
            0xc1a4,
            0xc1a6,
            0xc1b6,
            0xc1d6,
            0xc1df,
            0xc1f6,
            0xc1f8,
            0xc4a1,
            0xc5cd,
            0xc6ae,
            0xc7cf,
            0xc7d1,
            0xc7d2,
            0xc7d8,
            0xc7e5,
            0xc8ad,
        ];
        this.nextChar = eucNextChar;
    }
    name() {
        return 'EUC-KR';
    }
    language() {
        return 'ko';
    }
}
exports.euc_kr = euc_kr;
class gb_18030 extends mbcs {
    constructor() {
        super(...arguments);
        this.commonChars = [
            0xa1a1,
            0xa1a2,
            0xa1a3,
            0xa1a4,
            0xa1b0,
            0xa1b1,
            0xa1f1,
            0xa1f3,
            0xa3a1,
            0xa3ac,
            0xa3ba,
            0xb1a8,
            0xb1b8,
            0xb1be,
            0xb2bb,
            0xb3c9,
            0xb3f6,
            0xb4f3,
            0xb5bd,
            0xb5c4,
            0xb5e3,
            0xb6af,
            0xb6d4,
            0xb6e0,
            0xb7a2,
            0xb7a8,
            0xb7bd,
            0xb7d6,
            0xb7dd,
            0xb8b4,
            0xb8df,
            0xb8f6,
            0xb9ab,
            0xb9c9,
            0xb9d8,
            0xb9fa,
            0xb9fd,
            0xbacd,
            0xbba7,
            0xbbd6,
            0xbbe1,
            0xbbfa,
            0xbcbc,
            0xbcdb,
            0xbcfe,
            0xbdcc,
            0xbecd,
            0xbedd,
            0xbfb4,
            0xbfc6,
            0xbfc9,
            0xc0b4,
            0xc0ed,
            0xc1cb,
            0xc2db,
            0xc3c7,
            0xc4dc,
            0xc4ea,
            0xc5cc,
            0xc6f7,
            0xc7f8,
            0xc8ab,
            0xc8cb,
            0xc8d5,
            0xc8e7,
            0xc9cf,
            0xc9fa,
            0xcab1,
            0xcab5,
            0xcac7,
            0xcad0,
            0xcad6,
            0xcaf5,
            0xcafd,
            0xccec,
            0xcdf8,
            0xceaa,
            0xcec4,
            0xced2,
            0xcee5,
            0xcfb5,
            0xcfc2,
            0xcfd6,
            0xd0c2,
            0xd0c5,
            0xd0d0,
            0xd0d4,
            0xd1a7,
            0xd2aa,
            0xd2b2,
            0xd2b5,
            0xd2bb,
            0xd2d4,
            0xd3c3,
            0xd3d0,
            0xd3fd,
            0xd4c2,
            0xd4da,
            0xd5e2,
            0xd6d0,
        ];
    }
    name() {
        return 'GB18030';
    }
    language() {
        return 'zh';
    }
    nextChar(iter, det) {
        iter.index = iter.nextIndex;
        iter.error = false;
        var firstByte = 0;
        var secondByte = 0;
        var thirdByte = 0;
        var fourthByte = 0;
        buildChar: {
            firstByte = iter.charValue = iter.nextByte(det);
            if (firstByte < 0) {
                iter.done = true;
                break buildChar;
            }
            if (firstByte <= 0x80) {
                break buildChar;
            }
            secondByte = iter.nextByte(det);
            iter.charValue = (iter.charValue << 8) | secondByte;
            if (firstByte >= 0x81 && firstByte <= 0xfe) {
                if ((secondByte >= 0x40 && secondByte <= 0x7e) ||
                    (secondByte >= 80 && secondByte <= 0xfe)) {
                    break buildChar;
                }
                if (secondByte >= 0x30 && secondByte <= 0x39) {
                    thirdByte = iter.nextByte(det);
                    if (thirdByte >= 0x81 && thirdByte <= 0xfe) {
                        fourthByte = iter.nextByte(det);
                        if (fourthByte >= 0x30 && fourthByte <= 0x39) {
                            iter.charValue =
                                (iter.charValue << 16) | (thirdByte << 8) | fourthByte;
                            break buildChar;
                        }
                    }
                }
                iter.error = true;
                break buildChar;
            }
        }
        return iter.done == false;
    }
}
exports.gb_18030 = gb_18030;
//# sourceMappingURL=mbcs.js.map

/***/ }),

/***/ 5693:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var match = __webpack_require__(5690).default;
var N_GRAM_MASK = 0xffffff;
class NGramParser {
    constructor(theNgramList, theByteMap) {
        this.byteIndex = 0;
        this.ngram = 0;
        this.ngramCount = 0;
        this.hitCount = 0;
        this.spaceChar = 0x20;
        this.ngramList = theNgramList;
        this.byteMap = theByteMap;
    }
    search(table, value) {
        var index = 0;
        if (table[index + 32] <= value)
            index += 32;
        if (table[index + 16] <= value)
            index += 16;
        if (table[index + 8] <= value)
            index += 8;
        if (table[index + 4] <= value)
            index += 4;
        if (table[index + 2] <= value)
            index += 2;
        if (table[index + 1] <= value)
            index += 1;
        if (table[index] > value)
            index -= 1;
        if (index < 0 || table[index] != value)
            return -1;
        return index;
    }
    lookup(thisNgram) {
        this.ngramCount += 1;
        if (this.search(this.ngramList, thisNgram) >= 0) {
            this.hitCount += 1;
        }
    }
    addByte(b) {
        this.ngram = ((this.ngram << 8) + (b & 0xff)) & N_GRAM_MASK;
        this.lookup(this.ngram);
    }
    nextByte(det) {
        if (this.byteIndex >= det.fInputLen)
            return -1;
        return det.fInputBytes[this.byteIndex++] & 0xff;
    }
    parse(det, spaceCh) {
        var b, ignoreSpace = false;
        this.spaceChar = spaceCh;
        while ((b = this.nextByte(det)) >= 0) {
            var mb = this.byteMap[b];
            if (mb != 0) {
                if (!(mb == this.spaceChar && ignoreSpace)) {
                    this.addByte(mb);
                }
                ignoreSpace = mb == this.spaceChar;
            }
        }
        this.addByte(this.spaceChar);
        var rawPercent = this.hitCount / this.ngramCount;
        if (rawPercent > 0.33)
            return 98;
        return Math.floor(rawPercent * 300.0);
    }
}
class NGramsPlusLang {
    constructor(la, ng) {
        this.fLang = la;
        this.fNGrams = ng;
    }
}
const isFlatNgrams = (val) => Array.isArray(val) && isFinite(val[0]);
class sbcs {
    constructor() {
        this.spaceChar = 0x20;
    }
    ngrams() {
        return [];
    }
    byteMap() {
        return [];
    }
    name(input) {
        return 'sbcs';
    }
    match(det) {
        var ngrams = this.ngrams();
        if (isFlatNgrams(ngrams)) {
            var parser = new NGramParser(ngrams, this.byteMap());
            var confidence = parser.parse(det, this.spaceChar);
            return confidence <= 0 ? null : match(det, this, confidence);
        }
        var bestConfidenceSoFar = -1;
        var lang = null;
        for (var i = ngrams.length - 1; i >= 0; i--) {
            var ngl = ngrams[i];
            var parser = new NGramParser(ngl.fNGrams, this.byteMap());
            var confidence = parser.parse(det, this.spaceChar);
            if (confidence > bestConfidenceSoFar) {
                bestConfidenceSoFar = confidence;
                lang = ngl.fLang;
            }
        }
        var name = this.name(det);
        return bestConfidenceSoFar <= 0
            ? null
            : match(det, this, bestConfidenceSoFar, name, lang);
    }
}
class ISO_8859_1 extends sbcs {
    byteMap() {
        return [
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x00,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xaa,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xb5,
            0x20,
            0x20,
            0x20,
            0x20,
            0xba,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xe0,
            0xe1,
            0xe2,
            0xe3,
            0xe4,
            0xe5,
            0xe6,
            0xe7,
            0xe8,
            0xe9,
            0xea,
            0xeb,
            0xec,
            0xed,
            0xee,
            0xef,
            0xf0,
            0xf1,
            0xf2,
            0xf3,
            0xf4,
            0xf5,
            0xf6,
            0x20,
            0xf8,
            0xf9,
            0xfa,
            0xfb,
            0xfc,
            0xfd,
            0xfe,
            0xdf,
            0xe0,
            0xe1,
            0xe2,
            0xe3,
            0xe4,
            0xe5,
            0xe6,
            0xe7,
            0xe8,
            0xe9,
            0xea,
            0xeb,
            0xec,
            0xed,
            0xee,
            0xef,
            0xf0,
            0xf1,
            0xf2,
            0xf3,
            0xf4,
            0xf5,
            0xf6,
            0x20,
            0xf8,
            0xf9,
            0xfa,
            0xfb,
            0xfc,
            0xfd,
            0xfe,
            0xff,
        ];
    }
    ngrams() {
        return [
            new NGramsPlusLang('da', [
                0x206166,
                0x206174,
                0x206465,
                0x20656e,
                0x206572,
                0x20666f,
                0x206861,
                0x206920,
                0x206d65,
                0x206f67,
                0x2070e5,
                0x207369,
                0x207374,
                0x207469,
                0x207669,
                0x616620,
                0x616e20,
                0x616e64,
                0x617220,
                0x617420,
                0x646520,
                0x64656e,
                0x646572,
                0x646574,
                0x652073,
                0x656420,
                0x656465,
                0x656e20,
                0x656e64,
                0x657220,
                0x657265,
                0x657320,
                0x657420,
                0x666f72,
                0x676520,
                0x67656e,
                0x676572,
                0x696765,
                0x696c20,
                0x696e67,
                0x6b6520,
                0x6b6b65,
                0x6c6572,
                0x6c6967,
                0x6c6c65,
                0x6d6564,
                0x6e6465,
                0x6e6520,
                0x6e6720,
                0x6e6765,
                0x6f6720,
                0x6f6d20,
                0x6f7220,
                0x70e520,
                0x722064,
                0x722065,
                0x722073,
                0x726520,
                0x737465,
                0x742073,
                0x746520,
                0x746572,
                0x74696c,
                0x766572,
            ]),
            new NGramsPlusLang('de', [
                0x20616e,
                0x206175,
                0x206265,
                0x206461,
                0x206465,
                0x206469,
                0x206569,
                0x206765,
                0x206861,
                0x20696e,
                0x206d69,
                0x207363,
                0x207365,
                0x20756e,
                0x207665,
                0x20766f,
                0x207765,
                0x207a75,
                0x626572,
                0x636820,
                0x636865,
                0x636874,
                0x646173,
                0x64656e,
                0x646572,
                0x646965,
                0x652064,
                0x652073,
                0x65696e,
                0x656974,
                0x656e20,
                0x657220,
                0x657320,
                0x67656e,
                0x68656e,
                0x687420,
                0x696368,
                0x696520,
                0x696e20,
                0x696e65,
                0x697420,
                0x6c6963,
                0x6c6c65,
                0x6e2061,
                0x6e2064,
                0x6e2073,
                0x6e6420,
                0x6e6465,
                0x6e6520,
                0x6e6720,
                0x6e6765,
                0x6e7465,
                0x722064,
                0x726465,
                0x726569,
                0x736368,
                0x737465,
                0x742064,
                0x746520,
                0x74656e,
                0x746572,
                0x756e64,
                0x756e67,
                0x766572,
            ]),
            new NGramsPlusLang('en', [
                0x206120,
                0x20616e,
                0x206265,
                0x20636f,
                0x20666f,
                0x206861,
                0x206865,
                0x20696e,
                0x206d61,
                0x206f66,
                0x207072,
                0x207265,
                0x207361,
                0x207374,
                0x207468,
                0x20746f,
                0x207768,
                0x616964,
                0x616c20,
                0x616e20,
                0x616e64,
                0x617320,
                0x617420,
                0x617465,
                0x617469,
                0x642061,
                0x642074,
                0x652061,
                0x652073,
                0x652074,
                0x656420,
                0x656e74,
                0x657220,
                0x657320,
                0x666f72,
                0x686174,
                0x686520,
                0x686572,
                0x696420,
                0x696e20,
                0x696e67,
                0x696f6e,
                0x697320,
                0x6e2061,
                0x6e2074,
                0x6e6420,
                0x6e6720,
                0x6e7420,
                0x6f6620,
                0x6f6e20,
                0x6f7220,
                0x726520,
                0x727320,
                0x732061,
                0x732074,
                0x736169,
                0x737420,
                0x742074,
                0x746572,
                0x746861,
                0x746865,
                0x74696f,
                0x746f20,
                0x747320,
            ]),
            new NGramsPlusLang('es', [
                0x206120,
                0x206361,
                0x20636f,
                0x206465,
                0x20656c,
                0x20656e,
                0x206573,
                0x20696e,
                0x206c61,
                0x206c6f,
                0x207061,
                0x20706f,
                0x207072,
                0x207175,
                0x207265,
                0x207365,
                0x20756e,
                0x207920,
                0x612063,
                0x612064,
                0x612065,
                0x61206c,
                0x612070,
                0x616369,
                0x61646f,
                0x616c20,
                0x617220,
                0x617320,
                0x6369f3,
                0x636f6e,
                0x646520,
                0x64656c,
                0x646f20,
                0x652064,
                0x652065,
                0x65206c,
                0x656c20,
                0x656e20,
                0x656e74,
                0x657320,
                0x657374,
                0x69656e,
                0x69f36e,
                0x6c6120,
                0x6c6f73,
                0x6e2065,
                0x6e7465,
                0x6f2064,
                0x6f2065,
                0x6f6e20,
                0x6f7220,
                0x6f7320,
                0x706172,
                0x717565,
                0x726120,
                0x726573,
                0x732064,
                0x732065,
                0x732070,
                0x736520,
                0x746520,
                0x746f20,
                0x756520,
                0xf36e20,
            ]),
            new NGramsPlusLang('fr', [
                0x206175,
                0x20636f,
                0x206461,
                0x206465,
                0x206475,
                0x20656e,
                0x206574,
                0x206c61,
                0x206c65,
                0x207061,
                0x20706f,
                0x207072,
                0x207175,
                0x207365,
                0x20736f,
                0x20756e,
                0x20e020,
                0x616e74,
                0x617469,
                0x636520,
                0x636f6e,
                0x646520,
                0x646573,
                0x647520,
                0x652061,
                0x652063,
                0x652064,
                0x652065,
                0x65206c,
                0x652070,
                0x652073,
                0x656e20,
                0x656e74,
                0x657220,
                0x657320,
                0x657420,
                0x657572,
                0x696f6e,
                0x697320,
                0x697420,
                0x6c6120,
                0x6c6520,
                0x6c6573,
                0x6d656e,
                0x6e2064,
                0x6e6520,
                0x6e7320,
                0x6e7420,
                0x6f6e20,
                0x6f6e74,
                0x6f7572,
                0x717565,
                0x72206c,
                0x726520,
                0x732061,
                0x732064,
                0x732065,
                0x73206c,
                0x732070,
                0x742064,
                0x746520,
                0x74696f,
                0x756520,
                0x757220,
            ]),
            new NGramsPlusLang('it', [
                0x20616c,
                0x206368,
                0x20636f,
                0x206465,
                0x206469,
                0x206520,
                0x20696c,
                0x20696e,
                0x206c61,
                0x207065,
                0x207072,
                0x20756e,
                0x612063,
                0x612064,
                0x612070,
                0x612073,
                0x61746f,
                0x636865,
                0x636f6e,
                0x64656c,
                0x646920,
                0x652061,
                0x652063,
                0x652064,
                0x652069,
                0x65206c,
                0x652070,
                0x652073,
                0x656c20,
                0x656c6c,
                0x656e74,
                0x657220,
                0x686520,
                0x692061,
                0x692063,
                0x692064,
                0x692073,
                0x696120,
                0x696c20,
                0x696e20,
                0x696f6e,
                0x6c6120,
                0x6c6520,
                0x6c6920,
                0x6c6c61,
                0x6e6520,
                0x6e6920,
                0x6e6f20,
                0x6e7465,
                0x6f2061,
                0x6f2064,
                0x6f2069,
                0x6f2073,
                0x6f6e20,
                0x6f6e65,
                0x706572,
                0x726120,
                0x726520,
                0x736920,
                0x746120,
                0x746520,
                0x746920,
                0x746f20,
                0x7a696f,
            ]),
            new NGramsPlusLang('nl', [
                0x20616c,
                0x206265,
                0x206461,
                0x206465,
                0x206469,
                0x206565,
                0x20656e,
                0x206765,
                0x206865,
                0x20696e,
                0x206d61,
                0x206d65,
                0x206f70,
                0x207465,
                0x207661,
                0x207665,
                0x20766f,
                0x207765,
                0x207a69,
                0x61616e,
                0x616172,
                0x616e20,
                0x616e64,
                0x617220,
                0x617420,
                0x636874,
                0x646520,
                0x64656e,
                0x646572,
                0x652062,
                0x652076,
                0x65656e,
                0x656572,
                0x656e20,
                0x657220,
                0x657273,
                0x657420,
                0x67656e,
                0x686574,
                0x696520,
                0x696e20,
                0x696e67,
                0x697320,
                0x6e2062,
                0x6e2064,
                0x6e2065,
                0x6e2068,
                0x6e206f,
                0x6e2076,
                0x6e6465,
                0x6e6720,
                0x6f6e64,
                0x6f6f72,
                0x6f7020,
                0x6f7220,
                0x736368,
                0x737465,
                0x742064,
                0x746520,
                0x74656e,
                0x746572,
                0x76616e,
                0x766572,
                0x766f6f,
            ]),
            new NGramsPlusLang('no', [
                0x206174,
                0x206176,
                0x206465,
                0x20656e,
                0x206572,
                0x20666f,
                0x206861,
                0x206920,
                0x206d65,
                0x206f67,
                0x2070e5,
                0x207365,
                0x20736b,
                0x20736f,
                0x207374,
                0x207469,
                0x207669,
                0x20e520,
                0x616e64,
                0x617220,
                0x617420,
                0x646520,
                0x64656e,
                0x646574,
                0x652073,
                0x656420,
                0x656e20,
                0x656e65,
                0x657220,
                0x657265,
                0x657420,
                0x657474,
                0x666f72,
                0x67656e,
                0x696b6b,
                0x696c20,
                0x696e67,
                0x6b6520,
                0x6b6b65,
                0x6c6520,
                0x6c6c65,
                0x6d6564,
                0x6d656e,
                0x6e2073,
                0x6e6520,
                0x6e6720,
                0x6e6765,
                0x6e6e65,
                0x6f6720,
                0x6f6d20,
                0x6f7220,
                0x70e520,
                0x722073,
                0x726520,
                0x736f6d,
                0x737465,
                0x742073,
                0x746520,
                0x74656e,
                0x746572,
                0x74696c,
                0x747420,
                0x747465,
                0x766572,
            ]),
            new NGramsPlusLang('pt', [
                0x206120,
                0x20636f,
                0x206461,
                0x206465,
                0x20646f,
                0x206520,
                0x206573,
                0x206d61,
                0x206e6f,
                0x206f20,
                0x207061,
                0x20706f,
                0x207072,
                0x207175,
                0x207265,
                0x207365,
                0x20756d,
                0x612061,
                0x612063,
                0x612064,
                0x612070,
                0x616465,
                0x61646f,
                0x616c20,
                0x617220,
                0x617261,
                0x617320,
                0x636f6d,
                0x636f6e,
                0x646120,
                0x646520,
                0x646f20,
                0x646f73,
                0x652061,
                0x652064,
                0x656d20,
                0x656e74,
                0x657320,
                0x657374,
                0x696120,
                0x696361,
                0x6d656e,
                0x6e7465,
                0x6e746f,
                0x6f2061,
                0x6f2063,
                0x6f2064,
                0x6f2065,
                0x6f2070,
                0x6f7320,
                0x706172,
                0x717565,
                0x726120,
                0x726573,
                0x732061,
                0x732064,
                0x732065,
                0x732070,
                0x737461,
                0x746520,
                0x746f20,
                0x756520,
                0xe36f20,
                0xe7e36f,
            ]),
            new NGramsPlusLang('sv', [
                0x206174,
                0x206176,
                0x206465,
                0x20656e,
                0x2066f6,
                0x206861,
                0x206920,
                0x20696e,
                0x206b6f,
                0x206d65,
                0x206f63,
                0x2070e5,
                0x20736b,
                0x20736f,
                0x207374,
                0x207469,
                0x207661,
                0x207669,
                0x20e472,
                0x616465,
                0x616e20,
                0x616e64,
                0x617220,
                0x617474,
                0x636820,
                0x646520,
                0x64656e,
                0x646572,
                0x646574,
                0x656420,
                0x656e20,
                0x657220,
                0x657420,
                0x66f672,
                0x67656e,
                0x696c6c,
                0x696e67,
                0x6b6120,
                0x6c6c20,
                0x6d6564,
                0x6e2073,
                0x6e6120,
                0x6e6465,
                0x6e6720,
                0x6e6765,
                0x6e696e,
                0x6f6368,
                0x6f6d20,
                0x6f6e20,
                0x70e520,
                0x722061,
                0x722073,
                0x726120,
                0x736b61,
                0x736f6d,
                0x742073,
                0x746120,
                0x746520,
                0x746572,
                0x74696c,
                0x747420,
                0x766172,
                0xe47220,
                0xf67220,
            ]),
        ];
    }
    name(input) {
        return input && input.fC1Bytes ? 'windows-1252' : 'ISO-8859-1';
    }
}
exports.ISO_8859_1 = ISO_8859_1;
class ISO_8859_2 extends sbcs {
    byteMap() {
        return [
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x00,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xb1,
            0x20,
            0xb3,
            0x20,
            0xb5,
            0xb6,
            0x20,
            0x20,
            0xb9,
            0xba,
            0xbb,
            0xbc,
            0x20,
            0xbe,
            0xbf,
            0x20,
            0xb1,
            0x20,
            0xb3,
            0x20,
            0xb5,
            0xb6,
            0xb7,
            0x20,
            0xb9,
            0xba,
            0xbb,
            0xbc,
            0x20,
            0xbe,
            0xbf,
            0xe0,
            0xe1,
            0xe2,
            0xe3,
            0xe4,
            0xe5,
            0xe6,
            0xe7,
            0xe8,
            0xe9,
            0xea,
            0xeb,
            0xec,
            0xed,
            0xee,
            0xef,
            0xf0,
            0xf1,
            0xf2,
            0xf3,
            0xf4,
            0xf5,
            0xf6,
            0x20,
            0xf8,
            0xf9,
            0xfa,
            0xfb,
            0xfc,
            0xfd,
            0xfe,
            0xdf,
            0xe0,
            0xe1,
            0xe2,
            0xe3,
            0xe4,
            0xe5,
            0xe6,
            0xe7,
            0xe8,
            0xe9,
            0xea,
            0xeb,
            0xec,
            0xed,
            0xee,
            0xef,
            0xf0,
            0xf1,
            0xf2,
            0xf3,
            0xf4,
            0xf5,
            0xf6,
            0x20,
            0xf8,
            0xf9,
            0xfa,
            0xfb,
            0xfc,
            0xfd,
            0xfe,
            0x20,
        ];
    }
    ngrams() {
        return [
            new NGramsPlusLang('cs', [
                0x206120,
                0x206279,
                0x20646f,
                0x206a65,
                0x206e61,
                0x206e65,
                0x206f20,
                0x206f64,
                0x20706f,
                0x207072,
                0x2070f8,
                0x20726f,
                0x207365,
                0x20736f,
                0x207374,
                0x20746f,
                0x207620,
                0x207679,
                0x207a61,
                0x612070,
                0x636520,
                0x636820,
                0x652070,
                0x652073,
                0x652076,
                0x656d20,
                0x656eed,
                0x686f20,
                0x686f64,
                0x697374,
                0x6a6520,
                0x6b7465,
                0x6c6520,
                0x6c6920,
                0x6e6120,
                0x6ee920,
                0x6eec20,
                0x6eed20,
                0x6f2070,
                0x6f646e,
                0x6f6a69,
                0x6f7374,
                0x6f7520,
                0x6f7661,
                0x706f64,
                0x706f6a,
                0x70726f,
                0x70f865,
                0x736520,
                0x736f75,
                0x737461,
                0x737469,
                0x73746e,
                0x746572,
                0x746eed,
                0x746f20,
                0x752070,
                0xbe6520,
                0xe16eed,
                0xe9686f,
                0xed2070,
                0xed2073,
                0xed6d20,
                0xf86564,
            ]),
            new NGramsPlusLang('hu', [
                0x206120,
                0x20617a,
                0x206265,
                0x206567,
                0x20656c,
                0x206665,
                0x206861,
                0x20686f,
                0x206973,
                0x206b65,
                0x206b69,
                0x206bf6,
                0x206c65,
                0x206d61,
                0x206d65,
                0x206d69,
                0x206e65,
                0x20737a,
                0x207465,
                0x20e973,
                0x612061,
                0x61206b,
                0x61206d,
                0x612073,
                0x616b20,
                0x616e20,
                0x617a20,
                0x62616e,
                0x62656e,
                0x656779,
                0x656b20,
                0x656c20,
                0x656c65,
                0x656d20,
                0x656e20,
                0x657265,
                0x657420,
                0x657465,
                0x657474,
                0x677920,
                0x686f67,
                0x696e74,
                0x697320,
                0x6b2061,
                0x6bf67a,
                0x6d6567,
                0x6d696e,
                0x6e2061,
                0x6e616b,
                0x6e656b,
                0x6e656d,
                0x6e7420,
                0x6f6779,
                0x732061,
                0x737a65,
                0x737a74,
                0x737ae1,
                0x73e967,
                0x742061,
                0x747420,
                0x74e173,
                0x7a6572,
                0xe16e20,
                0xe97320,
            ]),
            new NGramsPlusLang('pl', [
                0x20637a,
                0x20646f,
                0x206920,
                0x206a65,
                0x206b6f,
                0x206d61,
                0x206d69,
                0x206e61,
                0x206e69,
                0x206f64,
                0x20706f,
                0x207072,
                0x207369,
                0x207720,
                0x207769,
                0x207779,
                0x207a20,
                0x207a61,
                0x612070,
                0x612077,
                0x616e69,
                0x636820,
                0x637a65,
                0x637a79,
                0x646f20,
                0x647a69,
                0x652070,
                0x652073,
                0x652077,
                0x65207a,
                0x65676f,
                0x656a20,
                0x656d20,
                0x656e69,
                0x676f20,
                0x696120,
                0x696520,
                0x69656a,
                0x6b6120,
                0x6b6920,
                0x6b6965,
                0x6d6965,
                0x6e6120,
                0x6e6961,
                0x6e6965,
                0x6f2070,
                0x6f7761,
                0x6f7769,
                0x706f6c,
                0x707261,
                0x70726f,
                0x70727a,
                0x727a65,
                0x727a79,
                0x7369ea,
                0x736b69,
                0x737461,
                0x776965,
                0x796368,
                0x796d20,
                0x7a6520,
                0x7a6965,
                0x7a7920,
                0xf37720,
            ]),
            new NGramsPlusLang('ro', [
                0x206120,
                0x206163,
                0x206361,
                0x206365,
                0x20636f,
                0x206375,
                0x206465,
                0x206469,
                0x206c61,
                0x206d61,
                0x207065,
                0x207072,
                0x207365,
                0x2073e3,
                0x20756e,
                0x20ba69,
                0x20ee6e,
                0x612063,
                0x612064,
                0x617265,
                0x617420,
                0x617465,
                0x617520,
                0x636172,
                0x636f6e,
                0x637520,
                0x63e320,
                0x646520,
                0x652061,
                0x652063,
                0x652064,
                0x652070,
                0x652073,
                0x656120,
                0x656920,
                0x656c65,
                0x656e74,
                0x657374,
                0x692061,
                0x692063,
                0x692064,
                0x692070,
                0x696520,
                0x696920,
                0x696e20,
                0x6c6120,
                0x6c6520,
                0x6c6f72,
                0x6c7569,
                0x6e6520,
                0x6e7472,
                0x6f7220,
                0x70656e,
                0x726520,
                0x726561,
                0x727520,
                0x73e320,
                0x746520,
                0x747275,
                0x74e320,
                0x756920,
                0x756c20,
                0xba6920,
                0xee6e20,
            ]),
        ];
    }
    name(det) {
        return det && det.fC1Bytes ? 'windows-1250' : 'ISO-8859-2';
    }
}
exports.ISO_8859_2 = ISO_8859_2;
class ISO_8859_5 extends sbcs {
    byteMap() {
        return [
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x00,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xf1,
            0xf2,
            0xf3,
            0xf4,
            0xf5,
            0xf6,
            0xf7,
            0xf8,
            0xf9,
            0xfa,
            0xfb,
            0xfc,
            0x20,
            0xfe,
            0xff,
            0xd0,
            0xd1,
            0xd2,
            0xd3,
            0xd4,
            0xd5,
            0xd6,
            0xd7,
            0xd8,
            0xd9,
            0xda,
            0xdb,
            0xdc,
            0xdd,
            0xde,
            0xdf,
            0xe0,
            0xe1,
            0xe2,
            0xe3,
            0xe4,
            0xe5,
            0xe6,
            0xe7,
            0xe8,
            0xe9,
            0xea,
            0xeb,
            0xec,
            0xed,
            0xee,
            0xef,
            0xd0,
            0xd1,
            0xd2,
            0xd3,
            0xd4,
            0xd5,
            0xd6,
            0xd7,
            0xd8,
            0xd9,
            0xda,
            0xdb,
            0xdc,
            0xdd,
            0xde,
            0xdf,
            0xe0,
            0xe1,
            0xe2,
            0xe3,
            0xe4,
            0xe5,
            0xe6,
            0xe7,
            0xe8,
            0xe9,
            0xea,
            0xeb,
            0xec,
            0xed,
            0xee,
            0xef,
            0x20,
            0xf1,
            0xf2,
            0xf3,
            0xf4,
            0xf5,
            0xf6,
            0xf7,
            0xf8,
            0xf9,
            0xfa,
            0xfb,
            0xfc,
            0x20,
            0xfe,
            0xff,
        ];
    }
    ngrams() {
        return [
            0x20d220,
            0x20d2de,
            0x20d4de,
            0x20d7d0,
            0x20d820,
            0x20dad0,
            0x20dade,
            0x20ddd0,
            0x20ddd5,
            0x20ded1,
            0x20dfde,
            0x20dfe0,
            0x20e0d0,
            0x20e1de,
            0x20e1e2,
            0x20e2de,
            0x20e7e2,
            0x20ede2,
            0xd0ddd8,
            0xd0e2ec,
            0xd3de20,
            0xd5dbec,
            0xd5ddd8,
            0xd5e1e2,
            0xd5e220,
            0xd820df,
            0xd8d520,
            0xd8d820,
            0xd8ef20,
            0xdbd5dd,
            0xdbd820,
            0xdbecdd,
            0xddd020,
            0xddd520,
            0xddd8d5,
            0xddd8ef,
            0xddde20,
            0xddded2,
            0xde20d2,
            0xde20df,
            0xde20e1,
            0xded220,
            0xded2d0,
            0xded3de,
            0xded920,
            0xdedbec,
            0xdedc20,
            0xdee1e2,
            0xdfdedb,
            0xdfe0d5,
            0xdfe0d8,
            0xdfe0de,
            0xe0d0d2,
            0xe0d5d4,
            0xe1e2d0,
            0xe1e2d2,
            0xe1e2d8,
            0xe1ef20,
            0xe2d5db,
            0xe2de20,
            0xe2dee0,
            0xe2ec20,
            0xe7e2de,
            0xebe520,
        ];
    }
    name() {
        return 'ISO-8859-5';
    }
    language() {
        return 'ru';
    }
}
exports.ISO_8859_5 = ISO_8859_5;
class ISO_8859_6 extends sbcs {
    byteMap() {
        return [
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x00,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xc1,
            0xc2,
            0xc3,
            0xc4,
            0xc5,
            0xc6,
            0xc7,
            0xc8,
            0xc9,
            0xca,
            0xcb,
            0xcc,
            0xcd,
            0xce,
            0xcf,
            0xd0,
            0xd1,
            0xd2,
            0xd3,
            0xd4,
            0xd5,
            0xd6,
            0xd7,
            0xd8,
            0xd9,
            0xda,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xe0,
            0xe1,
            0xe2,
            0xe3,
            0xe4,
            0xe5,
            0xe6,
            0xe7,
            0xe8,
            0xe9,
            0xea,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
        ];
    }
    ngrams() {
        return [
            0x20c7e4,
            0x20c7e6,
            0x20c8c7,
            0x20d9e4,
            0x20e1ea,
            0x20e4e4,
            0x20e5e6,
            0x20e8c7,
            0xc720c7,
            0xc7c120,
            0xc7ca20,
            0xc7d120,
            0xc7e420,
            0xc7e4c3,
            0xc7e4c7,
            0xc7e4c8,
            0xc7e4ca,
            0xc7e4cc,
            0xc7e4cd,
            0xc7e4cf,
            0xc7e4d3,
            0xc7e4d9,
            0xc7e4e2,
            0xc7e4e5,
            0xc7e4e8,
            0xc7e4ea,
            0xc7e520,
            0xc7e620,
            0xc7e6ca,
            0xc820c7,
            0xc920c7,
            0xc920e1,
            0xc920e4,
            0xc920e5,
            0xc920e8,
            0xca20c7,
            0xcf20c7,
            0xcfc920,
            0xd120c7,
            0xd1c920,
            0xd320c7,
            0xd920c7,
            0xd9e4e9,
            0xe1ea20,
            0xe420c7,
            0xe4c920,
            0xe4e920,
            0xe4ea20,
            0xe520c7,
            0xe5c720,
            0xe5c920,
            0xe5e620,
            0xe620c7,
            0xe720c7,
            0xe7c720,
            0xe8c7e4,
            0xe8e620,
            0xe920c7,
            0xea20c7,
            0xea20e5,
            0xea20e8,
            0xeac920,
            0xead120,
            0xeae620,
        ];
    }
    name() {
        return 'ISO-8859-6';
    }
    language() {
        return 'ar';
    }
}
exports.ISO_8859_6 = ISO_8859_6;
class ISO_8859_7 extends sbcs {
    byteMap() {
        return [
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x00,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xa1,
            0xa2,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xdc,
            0x20,
            0xdd,
            0xde,
            0xdf,
            0x20,
            0xfc,
            0x20,
            0xfd,
            0xfe,
            0xc0,
            0xe1,
            0xe2,
            0xe3,
            0xe4,
            0xe5,
            0xe6,
            0xe7,
            0xe8,
            0xe9,
            0xea,
            0xeb,
            0xec,
            0xed,
            0xee,
            0xef,
            0xf0,
            0xf1,
            0x20,
            0xf3,
            0xf4,
            0xf5,
            0xf6,
            0xf7,
            0xf8,
            0xf9,
            0xfa,
            0xfb,
            0xdc,
            0xdd,
            0xde,
            0xdf,
            0xe0,
            0xe1,
            0xe2,
            0xe3,
            0xe4,
            0xe5,
            0xe6,
            0xe7,
            0xe8,
            0xe9,
            0xea,
            0xeb,
            0xec,
            0xed,
            0xee,
            0xef,
            0xf0,
            0xf1,
            0xf2,
            0xf3,
            0xf4,
            0xf5,
            0xf6,
            0xf7,
            0xf8,
            0xf9,
            0xfa,
            0xfb,
            0xfc,
            0xfd,
            0xfe,
            0x20,
        ];
    }
    ngrams() {
        return [
            0x20e1ed,
            0x20e1f0,
            0x20e3e9,
            0x20e4e9,
            0x20e5f0,
            0x20e720,
            0x20eae1,
            0x20ece5,
            0x20ede1,
            0x20ef20,
            0x20f0e1,
            0x20f0ef,
            0x20f0f1,
            0x20f3f4,
            0x20f3f5,
            0x20f4e7,
            0x20f4ef,
            0xdfe120,
            0xe120e1,
            0xe120f4,
            0xe1e920,
            0xe1ed20,
            0xe1f0fc,
            0xe1f220,
            0xe3e9e1,
            0xe5e920,
            0xe5f220,
            0xe720f4,
            0xe7ed20,
            0xe7f220,
            0xe920f4,
            0xe9e120,
            0xe9eade,
            0xe9f220,
            0xeae1e9,
            0xeae1f4,
            0xece520,
            0xed20e1,
            0xed20e5,
            0xed20f0,
            0xede120,
            0xeff220,
            0xeff520,
            0xf0eff5,
            0xf0f1ef,
            0xf0fc20,
            0xf220e1,
            0xf220e5,
            0xf220ea,
            0xf220f0,
            0xf220f4,
            0xf3e520,
            0xf3e720,
            0xf3f4ef,
            0xf4e120,
            0xf4e1e9,
            0xf4e7ed,
            0xf4e7f2,
            0xf4e9ea,
            0xf4ef20,
            0xf4eff5,
            0xf4f9ed,
            0xf9ed20,
            0xfeed20,
        ];
    }
    name(det) {
        return det && det.fC1Bytes ? 'windows-1253' : 'ISO-8859-7';
    }
    language() {
        return 'el';
    }
}
exports.ISO_8859_7 = ISO_8859_7;
class ISO_8859_8 extends sbcs {
    byteMap() {
        return [
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x00,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xb5,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xe0,
            0xe1,
            0xe2,
            0xe3,
            0xe4,
            0xe5,
            0xe6,
            0xe7,
            0xe8,
            0xe9,
            0xea,
            0xeb,
            0xec,
            0xed,
            0xee,
            0xef,
            0xf0,
            0xf1,
            0xf2,
            0xf3,
            0xf4,
            0xf5,
            0xf6,
            0xf7,
            0xf8,
            0xf9,
            0xfa,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
        ];
    }
    ngrams() {
        return [
            new NGramsPlusLang('he', [
                0x20e0e5,
                0x20e0e7,
                0x20e0e9,
                0x20e0fa,
                0x20e1e9,
                0x20e1ee,
                0x20e4e0,
                0x20e4e5,
                0x20e4e9,
                0x20e4ee,
                0x20e4f2,
                0x20e4f9,
                0x20e4fa,
                0x20ece0,
                0x20ece4,
                0x20eee0,
                0x20f2ec,
                0x20f9ec,
                0xe0fa20,
                0xe420e0,
                0xe420e1,
                0xe420e4,
                0xe420ec,
                0xe420ee,
                0xe420f9,
                0xe4e5e0,
                0xe5e020,
                0xe5ed20,
                0xe5ef20,
                0xe5f820,
                0xe5fa20,
                0xe920e4,
                0xe9e420,
                0xe9e5fa,
                0xe9e9ed,
                0xe9ed20,
                0xe9ef20,
                0xe9f820,
                0xe9fa20,
                0xec20e0,
                0xec20e4,
                0xece020,
                0xece420,
                0xed20e0,
                0xed20e1,
                0xed20e4,
                0xed20ec,
                0xed20ee,
                0xed20f9,
                0xeee420,
                0xef20e4,
                0xf0e420,
                0xf0e920,
                0xf0e9ed,
                0xf2ec20,
                0xf820e4,
                0xf8e9ed,
                0xf9ec20,
                0xfa20e0,
                0xfa20e1,
                0xfa20e4,
                0xfa20ec,
                0xfa20ee,
                0xfa20f9,
            ]),
            new NGramsPlusLang('he', [
                0x20e0e5,
                0x20e0ec,
                0x20e4e9,
                0x20e4ec,
                0x20e4ee,
                0x20e4f0,
                0x20e9f0,
                0x20ecf2,
                0x20ecf9,
                0x20ede5,
                0x20ede9,
                0x20efe5,
                0x20efe9,
                0x20f8e5,
                0x20f8e9,
                0x20fae0,
                0x20fae5,
                0x20fae9,
                0xe020e4,
                0xe020ec,
                0xe020ed,
                0xe020fa,
                0xe0e420,
                0xe0e5e4,
                0xe0ec20,
                0xe0ee20,
                0xe120e4,
                0xe120ed,
                0xe120fa,
                0xe420e4,
                0xe420e9,
                0xe420ec,
                0xe420ed,
                0xe420ef,
                0xe420f8,
                0xe420fa,
                0xe4ec20,
                0xe5e020,
                0xe5e420,
                0xe7e020,
                0xe9e020,
                0xe9e120,
                0xe9e420,
                0xec20e4,
                0xec20ed,
                0xec20fa,
                0xecf220,
                0xecf920,
                0xede9e9,
                0xede9f0,
                0xede9f8,
                0xee20e4,
                0xee20ed,
                0xee20fa,
                0xeee120,
                0xeee420,
                0xf2e420,
                0xf920e4,
                0xf920ed,
                0xf920fa,
                0xf9e420,
                0xfae020,
                0xfae420,
                0xfae5e9,
            ]),
        ];
    }
    name(det) {
        return det && det.fC1Bytes ? 'windows-1255' : 'ISO-8859-8';
    }
    language() {
        return 'he';
    }
}
exports.ISO_8859_8 = ISO_8859_8;
class ISO_8859_9 extends sbcs {
    byteMap() {
        return [
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x00,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xaa,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xb5,
            0x20,
            0x20,
            0x20,
            0x20,
            0xba,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xe0,
            0xe1,
            0xe2,
            0xe3,
            0xe4,
            0xe5,
            0xe6,
            0xe7,
            0xe8,
            0xe9,
            0xea,
            0xeb,
            0xec,
            0xed,
            0xee,
            0xef,
            0xf0,
            0xf1,
            0xf2,
            0xf3,
            0xf4,
            0xf5,
            0xf6,
            0x20,
            0xf8,
            0xf9,
            0xfa,
            0xfb,
            0xfc,
            0x69,
            0xfe,
            0xdf,
            0xe0,
            0xe1,
            0xe2,
            0xe3,
            0xe4,
            0xe5,
            0xe6,
            0xe7,
            0xe8,
            0xe9,
            0xea,
            0xeb,
            0xec,
            0xed,
            0xee,
            0xef,
            0xf0,
            0xf1,
            0xf2,
            0xf3,
            0xf4,
            0xf5,
            0xf6,
            0x20,
            0xf8,
            0xf9,
            0xfa,
            0xfb,
            0xfc,
            0xfd,
            0xfe,
            0xff,
        ];
    }
    ngrams() {
        return [
            0x206261,
            0x206269,
            0x206275,
            0x206461,
            0x206465,
            0x206765,
            0x206861,
            0x20696c,
            0x206b61,
            0x206b6f,
            0x206d61,
            0x206f6c,
            0x207361,
            0x207461,
            0x207665,
            0x207961,
            0x612062,
            0x616b20,
            0x616c61,
            0x616d61,
            0x616e20,
            0x616efd,
            0x617220,
            0x617261,
            0x6172fd,
            0x6173fd,
            0x617961,
            0x626972,
            0x646120,
            0x646520,
            0x646920,
            0x652062,
            0x65206b,
            0x656469,
            0x656e20,
            0x657220,
            0x657269,
            0x657369,
            0x696c65,
            0x696e20,
            0x696e69,
            0x697220,
            0x6c616e,
            0x6c6172,
            0x6c6520,
            0x6c6572,
            0x6e2061,
            0x6e2062,
            0x6e206b,
            0x6e6461,
            0x6e6465,
            0x6e6520,
            0x6e6920,
            0x6e696e,
            0x6efd20,
            0x72696e,
            0x72fd6e,
            0x766520,
            0x796120,
            0x796f72,
            0xfd6e20,
            0xfd6e64,
            0xfd6efd,
            0xfdf0fd,
        ];
    }
    name(det) {
        return det && det.fC1Bytes ? 'windows-1254' : 'ISO-8859-9';
    }
    language() {
        return 'tr';
    }
}
exports.ISO_8859_9 = ISO_8859_9;
class windows_1251 extends sbcs {
    byteMap() {
        return [
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x00,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x90,
            0x83,
            0x20,
            0x83,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x9a,
            0x20,
            0x9c,
            0x9d,
            0x9e,
            0x9f,
            0x90,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x9a,
            0x20,
            0x9c,
            0x9d,
            0x9e,
            0x9f,
            0x20,
            0xa2,
            0xa2,
            0xbc,
            0x20,
            0xb4,
            0x20,
            0x20,
            0xb8,
            0x20,
            0xba,
            0x20,
            0x20,
            0x20,
            0x20,
            0xbf,
            0x20,
            0x20,
            0xb3,
            0xb3,
            0xb4,
            0xb5,
            0x20,
            0x20,
            0xb8,
            0x20,
            0xba,
            0x20,
            0xbc,
            0xbe,
            0xbe,
            0xbf,
            0xe0,
            0xe1,
            0xe2,
            0xe3,
            0xe4,
            0xe5,
            0xe6,
            0xe7,
            0xe8,
            0xe9,
            0xea,
            0xeb,
            0xec,
            0xed,
            0xee,
            0xef,
            0xf0,
            0xf1,
            0xf2,
            0xf3,
            0xf4,
            0xf5,
            0xf6,
            0xf7,
            0xf8,
            0xf9,
            0xfa,
            0xfb,
            0xfc,
            0xfd,
            0xfe,
            0xff,
            0xe0,
            0xe1,
            0xe2,
            0xe3,
            0xe4,
            0xe5,
            0xe6,
            0xe7,
            0xe8,
            0xe9,
            0xea,
            0xeb,
            0xec,
            0xed,
            0xee,
            0xef,
            0xf0,
            0xf1,
            0xf2,
            0xf3,
            0xf4,
            0xf5,
            0xf6,
            0xf7,
            0xf8,
            0xf9,
            0xfa,
            0xfb,
            0xfc,
            0xfd,
            0xfe,
            0xff,
        ];
    }
    ngrams() {
        return [
            0x20e220,
            0x20e2ee,
            0x20e4ee,
            0x20e7e0,
            0x20e820,
            0x20eae0,
            0x20eaee,
            0x20ede0,
            0x20ede5,
            0x20eee1,
            0x20efee,
            0x20eff0,
            0x20f0e0,
            0x20f1ee,
            0x20f1f2,
            0x20f2ee,
            0x20f7f2,
            0x20fdf2,
            0xe0ede8,
            0xe0f2fc,
            0xe3ee20,
            0xe5ebfc,
            0xe5ede8,
            0xe5f1f2,
            0xe5f220,
            0xe820ef,
            0xe8e520,
            0xe8e820,
            0xe8ff20,
            0xebe5ed,
            0xebe820,
            0xebfced,
            0xede020,
            0xede520,
            0xede8e5,
            0xede8ff,
            0xedee20,
            0xedeee2,
            0xee20e2,
            0xee20ef,
            0xee20f1,
            0xeee220,
            0xeee2e0,
            0xeee3ee,
            0xeee920,
            0xeeebfc,
            0xeeec20,
            0xeef1f2,
            0xefeeeb,
            0xeff0e5,
            0xeff0e8,
            0xeff0ee,
            0xf0e0e2,
            0xf0e5e4,
            0xf1f2e0,
            0xf1f2e2,
            0xf1f2e8,
            0xf1ff20,
            0xf2e5eb,
            0xf2ee20,
            0xf2eef0,
            0xf2fc20,
            0xf7f2ee,
            0xfbf520,
        ];
    }
    name() {
        return 'windows-1251';
    }
    language() {
        return 'ru';
    }
}
exports.windows_1251 = windows_1251;
class windows_1256 extends sbcs {
    byteMap() {
        return [
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x00,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x81,
            0x20,
            0x83,
            0x20,
            0x20,
            0x20,
            0x20,
            0x88,
            0x20,
            0x8a,
            0x20,
            0x9c,
            0x8d,
            0x8e,
            0x8f,
            0x90,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x98,
            0x20,
            0x9a,
            0x20,
            0x9c,
            0x20,
            0x20,
            0x9f,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xaa,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xb5,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xc0,
            0xc1,
            0xc2,
            0xc3,
            0xc4,
            0xc5,
            0xc6,
            0xc7,
            0xc8,
            0xc9,
            0xca,
            0xcb,
            0xcc,
            0xcd,
            0xce,
            0xcf,
            0xd0,
            0xd1,
            0xd2,
            0xd3,
            0xd4,
            0xd5,
            0xd6,
            0x20,
            0xd8,
            0xd9,
            0xda,
            0xdb,
            0xdc,
            0xdd,
            0xde,
            0xdf,
            0xe0,
            0xe1,
            0xe2,
            0xe3,
            0xe4,
            0xe5,
            0xe6,
            0xe7,
            0xe8,
            0xe9,
            0xea,
            0xeb,
            0xec,
            0xed,
            0xee,
            0xef,
            0x20,
            0x20,
            0x20,
            0x20,
            0xf4,
            0x20,
            0x20,
            0x20,
            0x20,
            0xf9,
            0x20,
            0xfb,
            0xfc,
            0x20,
            0x20,
            0xff,
        ];
    }
    ngrams() {
        return [
            0x20c7e1,
            0x20c7e4,
            0x20c8c7,
            0x20dae1,
            0x20dded,
            0x20e1e1,
            0x20e3e4,
            0x20e6c7,
            0xc720c7,
            0xc7c120,
            0xc7ca20,
            0xc7d120,
            0xc7e120,
            0xc7e1c3,
            0xc7e1c7,
            0xc7e1c8,
            0xc7e1ca,
            0xc7e1cc,
            0xc7e1cd,
            0xc7e1cf,
            0xc7e1d3,
            0xc7e1da,
            0xc7e1de,
            0xc7e1e3,
            0xc7e1e6,
            0xc7e1ed,
            0xc7e320,
            0xc7e420,
            0xc7e4ca,
            0xc820c7,
            0xc920c7,
            0xc920dd,
            0xc920e1,
            0xc920e3,
            0xc920e6,
            0xca20c7,
            0xcf20c7,
            0xcfc920,
            0xd120c7,
            0xd1c920,
            0xd320c7,
            0xda20c7,
            0xdae1ec,
            0xdded20,
            0xe120c7,
            0xe1c920,
            0xe1ec20,
            0xe1ed20,
            0xe320c7,
            0xe3c720,
            0xe3c920,
            0xe3e420,
            0xe420c7,
            0xe520c7,
            0xe5c720,
            0xe6c7e1,
            0xe6e420,
            0xec20c7,
            0xed20c7,
            0xed20e3,
            0xed20e6,
            0xedc920,
            0xedd120,
            0xede420,
        ];
    }
    name() {
        return 'windows-1256';
    }
    language() {
        return 'ar';
    }
}
exports.windows_1256 = windows_1256;
class KOI8_R extends sbcs {
    byteMap() {
        return [
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x00,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x61,
            0x62,
            0x63,
            0x64,
            0x65,
            0x66,
            0x67,
            0x68,
            0x69,
            0x6a,
            0x6b,
            0x6c,
            0x6d,
            0x6e,
            0x6f,
            0x70,
            0x71,
            0x72,
            0x73,
            0x74,
            0x75,
            0x76,
            0x77,
            0x78,
            0x79,
            0x7a,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xa3,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xa3,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0x20,
            0xc0,
            0xc1,
            0xc2,
            0xc3,
            0xc4,
            0xc5,
            0xc6,
            0xc7,
            0xc8,
            0xc9,
            0xca,
            0xcb,
            0xcc,
            0xcd,
            0xce,
            0xcf,
            0xd0,
            0xd1,
            0xd2,
            0xd3,
            0xd4,
            0xd5,
            0xd6,
            0xd7,
            0xd8,
            0xd9,
            0xda,
            0xdb,
            0xdc,
            0xdd,
            0xde,
            0xdf,
            0xc0,
            0xc1,
            0xc2,
            0xc3,
            0xc4,
            0xc5,
            0xc6,
            0xc7,
            0xc8,
            0xc9,
            0xca,
            0xcb,
            0xcc,
            0xcd,
            0xce,
            0xcf,
            0xd0,
            0xd1,
            0xd2,
            0xd3,
            0xd4,
            0xd5,
            0xd6,
            0xd7,
            0xd8,
            0xd9,
            0xda,
            0xdb,
            0xdc,
            0xdd,
            0xde,
            0xdf,
        ];
    }
    ngrams() {
        return [
            0x20c4cf,
            0x20c920,
            0x20cbc1,
            0x20cbcf,
            0x20cec1,
            0x20cec5,
            0x20cfc2,
            0x20d0cf,
            0x20d0d2,
            0x20d2c1,
            0x20d3cf,
            0x20d3d4,
            0x20d4cf,
            0x20d720,
            0x20d7cf,
            0x20dac1,
            0x20dcd4,
            0x20ded4,
            0xc1cec9,
            0xc1d4d8,
            0xc5ccd8,
            0xc5cec9,
            0xc5d3d4,
            0xc5d420,
            0xc7cf20,
            0xc920d0,
            0xc9c520,
            0xc9c920,
            0xc9d120,
            0xccc5ce,
            0xccc920,
            0xccd8ce,
            0xcec120,
            0xcec520,
            0xcec9c5,
            0xcec9d1,
            0xcecf20,
            0xcecfd7,
            0xcf20d0,
            0xcf20d3,
            0xcf20d7,
            0xcfc7cf,
            0xcfca20,
            0xcfccd8,
            0xcfcd20,
            0xcfd3d4,
            0xcfd720,
            0xcfd7c1,
            0xd0cfcc,
            0xd0d2c5,
            0xd0d2c9,
            0xd0d2cf,
            0xd2c1d7,
            0xd2c5c4,
            0xd3d120,
            0xd3d4c1,
            0xd3d4c9,
            0xd3d4d7,
            0xd4c5cc,
            0xd4cf20,
            0xd4cfd2,
            0xd4d820,
            0xd9c820,
            0xded4cf,
        ];
    }
    name() {
        return 'KOI8-R';
    }
    language() {
        return 'ru';
    }
}
exports.KOI8_R = KOI8_R;
//# sourceMappingURL=sbcs.js.map

/***/ }),

/***/ 5694:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var match = __webpack_require__(5690).default;
class ISO_2022 {
    constructor() {
        this.escapeSequences = [];
    }
    name() {
        return 'ISO_2022';
    }
    match(det) {
        var i, j;
        var escN;
        var hits = 0;
        var misses = 0;
        var shifts = 0;
        var quality;
        var text = det.fInputBytes;
        var textLen = det.fInputLen;
        scanInput: for (i = 0; i < textLen; i++) {
            if (text[i] == 0x1b) {
                checkEscapes: for (escN = 0; escN < this.escapeSequences.length; escN++) {
                    var seq = this.escapeSequences[escN];
                    if (textLen - i < seq.length)
                        continue checkEscapes;
                    for (j = 1; j < seq.length; j++)
                        if (seq[j] != text[i + j])
                            continue checkEscapes;
                    hits++;
                    i += seq.length - 1;
                    continue scanInput;
                }
                misses++;
            }
            if (text[i] == 0x0e || text[i] == 0x0f)
                shifts++;
        }
        if (hits == 0)
            return null;
        quality = (100 * hits - 100 * misses) / (hits + misses);
        if (hits + shifts < 5)
            quality -= (5 - (hits + shifts)) * 10;
        return quality <= 0 ? null : match(det, this, quality);
    }
}
class ISO_2022_JP extends ISO_2022 {
    constructor() {
        super(...arguments);
        this.escapeSequences = [
            [0x1b, 0x24, 0x28, 0x43],
            [0x1b, 0x24, 0x28, 0x44],
            [0x1b, 0x24, 0x40],
            [0x1b, 0x24, 0x41],
            [0x1b, 0x24, 0x42],
            [0x1b, 0x26, 0x40],
            [0x1b, 0x28, 0x42],
            [0x1b, 0x28, 0x48],
            [0x1b, 0x28, 0x49],
            [0x1b, 0x28, 0x4a],
            [0x1b, 0x2e, 0x41],
            [0x1b, 0x2e, 0x46],
        ];
    }
    name() {
        return 'ISO-2022-JP';
    }
}
exports.ISO_2022_JP = ISO_2022_JP;
class ISO_2022_KR extends ISO_2022 {
    constructor() {
        super(...arguments);
        this.escapeSequences = [[0x1b, 0x24, 0x29, 0x43]];
    }
    name() {
        return 'ISO-2022-KR';
    }
}
exports.ISO_2022_KR = ISO_2022_KR;
class ISO_2022_CN extends ISO_2022 {
    constructor() {
        super(...arguments);
        this.escapeSequences = [
            [0x1b, 0x24, 0x29, 0x41],
            [0x1b, 0x24, 0x29, 0x47],
            [0x1b, 0x24, 0x2a, 0x48],
            [0x1b, 0x24, 0x29, 0x45],
            [0x1b, 0x24, 0x2b, 0x49],
            [0x1b, 0x24, 0x2b, 0x4a],
            [0x1b, 0x24, 0x2b, 0x4b],
            [0x1b, 0x24, 0x2b, 0x4c],
            [0x1b, 0x24, 0x2b, 0x4d],
            [0x1b, 0x4e],
            [0x1b, 0x4f],
        ];
    }
    name() {
        return 'ISO-2022-CN';
    }
}
exports.ISO_2022_CN = ISO_2022_CN;
//# sourceMappingURL=iso2022.js.map

/***/ }),

/***/ 5695:
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {const fs = __webpack_require__(144),
path = __webpack_require__(64),
Readable = __webpack_require__(226).Readable,
util = __webpack_require__(81),

_ = __webpack_require__(61),

pathIsInside = __webpack_require__(5683),

PPERM_ERR = 'PPERM: insecure file access outside working directory',
FUNCTION = 'function',
DEPRECATED_SYNC_WRITE_STREAM = 'SyncWriteStream',
EXPERIMENTAL_PROMISE = 'promises',

// Use simple character check instead of regex to prevent regex attack
/**
 * Windows root directory can be of the following from
 *
 * | File System | Actual           | Modified          |
 * |-------------|------------------|-------------------|
 * | LFS (Local) | C:\Program       | /C:/Program       |
 * | UNC         | \\Server\Program | ///Server/Program |
 */
isWindowsRoot = function (path) {
  const drive = path.charAt(1);

  return path.charAt(0) === '/' && (
  drive >= 'A' && drive <= 'Z' || drive >= 'a' && drive <= 'z') &&
  path.charAt(2) === ':' ||
  path.slice(0, 3) === '///'; // Modified UNC path
};

/**
    * Postman file resolver wrapper over fs
    *
    * @param {String} workingDir
    * @param {Boolean=false} insecureFileRead
    * @param {String[]} fileWhitelist
    */
function PostmanFs(workingDir, insecureFileRead = false, fileWhitelist = []) {
  this._fs = fs;
  this._path = path;
  this.constants = this._fs.constants;

  this.workingDir = workingDir;
  this.insecureFileRead = insecureFileRead;
  this.fileWhitelist = fileWhitelist;

  this.isWindows = global.process.platform === 'win32';
}

/**
   * Private method to resole the path based based on working directory
   *
   * @param {String} relOrAbsPath - Relative or absolute path to resolve
   * @param {Boolean} insecureFileRead - Resolve path outside of working directory
   * @param {String[]} whiteList - A list of absolute path to whitelist
   *
   * @returns {String} The resolved path
   */
PostmanFs.prototype._resolve = function (relOrAbsPath, insecureFileRead, whiteList = []) {
  // Special handling for windows absolute paths to work cross platform
  this.isWindows && isWindowsRoot(relOrAbsPath) && (relOrAbsPath = relOrAbsPath.substring(1));

  // Resolve the path from the working directory. The file should always be resolved so that
  // cross os variations are mitigated
  let resolvedPath = this._path.resolve(this.workingDir, relOrAbsPath);

  // Check file is within working directory
  if (!insecureFileRead && // insecureFile read disabled
  !pathIsInside(resolvedPath, this.workingDir) && // File not inside working directory
  !_.includes(whiteList, resolvedPath)) {// File not in whitelist
    // Exit
    return;
  }

  return resolvedPath;
};

/**
    * Asynchronous path resolver function
    *
    * @param {String} relOrAbsPath - Relative or absolute path to resolve
    * @param {String|String[]} [whiteList] - A optional list of additional absolute path to whitelist
    * @param {Function} callback -
    */
PostmanFs.prototype.resolvePath = function (relOrAbsPath, whiteList, callback) {
  if (!callback && typeof whiteList === 'function') {
    callback = whiteList;
    whiteList = [];
  }

  let resolvedPath = this._resolve(relOrAbsPath, this.insecureFileRead, _.concat(this.fileWhitelist, whiteList));

  if (!resolvedPath) {
    return callback(new Error(PPERM_ERR));
  }

  return callback(null, resolvedPath);
};

/**
    * Synchronous path resolver function
    *
    * @param {String} relOrAbsPath - Relative or absolute path to resolve
    * @param {String|String[]} [whiteList] - A optional list of additional absolute path to whitelist
    *
    * @returns {String} The resolved path
    */
PostmanFs.prototype.resolvePathSync = function (relOrAbsPath, whiteList) {
  // Resolve the path from the working directory
  const resolvedPath = this._resolve(relOrAbsPath, this.insecureFileRead, _.concat(this.fileWhitelist, whiteList));

  if (!resolvedPath) {
    throw new Error(PPERM_ERR);
  }

  return resolvedPath;
};

// Attach all functions in fs to postman-fs
Object.getOwnPropertyNames(fs).map(prop => {
  // Bail-out early to prevent fs module from logging warning for deprecated and experimental methods
  if (prop === DEPRECATED_SYNC_WRITE_STREAM || prop === EXPERIMENTAL_PROMISE || typeof fs[prop] !== FUNCTION) {
    return;
  }

  PostmanFs.prototype[prop] = fs[prop];
});

// Override the required functions
PostmanFs.prototype.stat = function (path, callback) {
  this.resolvePath(path, (err, resolvedPath) => {
    if (err) {
      return callback(err);
    }

    return this._fs.stat(resolvedPath, callback);
  });
};

PostmanFs.prototype.createReadStream = function (path, options) {
  try {
    return this._fs.createReadStream(this.resolvePathSync(path), options);
  } catch (err) {
    // Create a fake read steam that emits and error and
    const ErrorReadStream = function () {
      // Replicating behavior of fs module of disabling emitClose on destroy
      Readable.call(this, { emitClose: false });

      // Emit the error event with insure file access error
      this.emit('error', new Error(PPERM_ERR));

      // Options exists and disables autoClose then don't destroy
      options && !options.autoClose || this.destroy();
    };

    util.inherits(ErrorReadStream, Readable);

    return new ErrorReadStream();
  }
};

// @note: This will always allow reading file outside of working directory. Because we
// only use this function to read certificate files in `postman-runtime` and working directory
// restrictions don't apply to certificates.
PostmanFs.prototype.readFile = function (path, ...args) {
  let resolvedPath = this._resolve(path, true);

  return this._fs.readFile(resolvedPath, ...args);
};

module.exports = PostmanFs;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(19)))

/***/ }),

/***/ 5836:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return GenericContextMenu; });
/* harmony import */ var _electron_ElectronService__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2389);
let

GenericContextMenu = class GenericContextMenu {
  constructor() {
    this.Remote = __webpack_require__(62).remote;
    this.Menu = this.Remote.Menu;
    this.MenuItem = this.Remote.MenuItem;
    this.currentSelection = '';

    /**
                                 * On right click in any input field, text gets automatically selected even if there was no explicit selection made before.
                                 * The text which gets automatically selected on right click, depends on the cursor position.
                                 */
    window.addEventListener('contextmenu', e => {
      e.preventDefault();
      this.currentSelection = window.getSelection().toString();
      let menu = this.buildMenu(e);

      // Empty menu fix for windows native app
      if (menu && _.size(menu.items)) {
        menu.popup(Object(_electron_ElectronService__WEBPACK_IMPORTED_MODULE_0__["getCurrentWindow"])());
      }
    }, false);
  }

  buildMenu(e) {
    let menu = new this.Menu(),
    isInput = _.get(e, 'target.nodeName') === 'INPUT' || _.get(e, 'target.nodeName') === 'TEXTAREA',
    selectedText = this.currentSelection;

    // Resetting values so that context menu is not triggered on right clicking anywhere on the screen
    this.currentSelection = '';

    if (!_.isEmpty(selectedText) || isInput) {
      this.buildGenericMenu(menu);
    }
    return menu;
  }

  buildGenericMenu(menu) {

    menu.append(new this.MenuItem({
      label: 'Undo',
      role: 'undo' }));

    menu.append(new this.MenuItem({
      label: 'Redo',
      role: 'redo' }));

    menu.append(new this.MenuItem({ type: 'separator' }));
    menu.append(new this.MenuItem({
      label: 'Cut',
      role: 'cut' }));

    menu.append(new this.MenuItem({
      label: 'Copy',
      role: 'copy' }));

    menu.append(new this.MenuItem({
      label: 'Paste',
      role: 'paste' }));

    menu.append(new this.MenuItem({
      label: 'Select All',
      role: 'selectall' }));

    menu.append(new this.MenuItem({ type: 'separator' }));
  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5837:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return Console; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var react_notification_system__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5838);
/* harmony import */ var react_notification_system__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react_notification_system__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(749);
/* harmony import */ var _ConsoleFooter_ConsoleFooter__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5847);
/* harmony import */ var _ConsoleHeader_ConsoleHeader__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(5849);
/* harmony import */ var _ConsoleList_ConsoleList__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(5851);
/* harmony import */ var _js_components_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(2974);
/* harmony import */ var _ConsoleBlobViewer_ConsoleBlobViewer__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(6006);
/* harmony import */ var _js_constants_AppNotificationStyles__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(6007);
var _class;










let


Console = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class Console extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isBlobViewerOpen: false };


    this.themeChangeHandler = this.themeChangeHandler.bind(this);
    this.handleBlobViewerOpen = this.handleBlobViewerOpen.bind(this);
    this.handleBlobViewerClose = this.handleBlobViewerClose.bind(this);
    this.handleViewLargeBody = this.handleViewLargeBody.bind(this);

    // Setup store references
    this.store = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('ConsoleStore');
    this.eventStore = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('ConsoleEventStore');
  }

  componentDidMount() {
    pm.mediator.on('themeChange', this.themeChangeHandler);
    pm.toasts.setNotificationComponent(this.refs.notificationSystem);
  }

  componentWillUnmount() {
    pm.mediator.off('themeChange', this.themeChangeHandler);
  }

  themeChangeHandler() {
    // Force re-render the child components
    this.forceUpdate();
  }

  handleBlobViewerOpen() {
    this.setState({ isBlobViewerOpen: true });
  }

  handleBlobViewerClose() {
    this.setState({ isBlobViewerOpen: false }, () => {
      this.eventStore.updateBlob({}); // Reset the blob to empty object
    });
  }

  handleViewLargeBody(eventId, bodyType) {
    this.eventStore.loadBlob(eventId, bodyType);
    this.handleBlobViewerOpen();
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-container' },
        this.props.withDropdownRoot &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { id: 'dropdown-root', style: { width: 0, height: 0 } }),
        this.props.showHeader &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleHeader_ConsoleHeader__WEBPACK_IMPORTED_MODULE_5__["default"], {
          store: this.store,
          eventStore: this.eventStore }),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleList_ConsoleList__WEBPACK_IMPORTED_MODULE_6__["default"], {
          store: this.store,
          viewLargeBody: this.handleViewLargeBody }),

        this.props.showFooter &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleFooter_ConsoleFooter__WEBPACK_IMPORTED_MODULE_4__["default"], {
          store: this.store,
          eventStore: this.eventStore }),


        this.store.isLoading &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_7__["default"], { className: 'console-list__loading' }),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleBlobViewer_ConsoleBlobViewer__WEBPACK_IMPORTED_MODULE_8__["default"], {
          isOpen: this.state.isBlobViewerOpen,
          onClose: this.handleBlobViewerClose,
          isLoading: this.eventStore.isBlobLoading,
          data: this.eventStore.blob && this.eventStore.blob.data,
          bodyType: this.eventStore.blob && this.eventStore.blob.bodyType,
          type: this.eventStore.blob && this.eventStore.blob.type,
          isTruncated: this.eventStore.blob && this.eventStore.blob.isTruncated

          // This will be removed when we remove console window
          , showInModal: this.props.showBlobInModal }),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react_notification_system__WEBPACK_IMPORTED_MODULE_2___default.a, {
          allowHTML: true,
          ref: 'notificationSystem',
          style: _js_constants_AppNotificationStyles__WEBPACK_IMPORTED_MODULE_9__["default"] })));



  }}) || _class;

/***/ }),

/***/ 5838:
/***/ (function(module, exports, __webpack_require__) {

var React = __webpack_require__(2);
var createReactClass = __webpack_require__(5839);
var PropTypes = __webpack_require__(2815);
var merge = __webpack_require__(4);
var NotificationContainer = __webpack_require__(5842);
var Constants = __webpack_require__(5844);
var Styles = __webpack_require__(5846);

var NotificationSystem = createReactClass({

  uid: 3400,

  _isMounted: false,

  _getStyles: {
    overrideStyle: {},

    overrideWidth: null,

    setOverrideStyle: function(style) {
      this.overrideStyle = style;
    },

    wrapper: function() {
      if (!this.overrideStyle) return {};
      return merge({}, Styles.Wrapper, this.overrideStyle.Wrapper);
    },

    container: function(position) {
      var override = this.overrideStyle.Containers || {};
      if (!this.overrideStyle) return {};

      this.overrideWidth = Styles.Containers.DefaultStyle.width;

      if (override.DefaultStyle && override.DefaultStyle.width) {
        this.overrideWidth = override.DefaultStyle.width;
      }

      if (override[position] && override[position].width) {
        this.overrideWidth = override[position].width;
      }

      return merge({}, Styles.Containers.DefaultStyle, Styles.Containers[position], override.DefaultStyle, override[position]);
    },

    elements: {
      notification: 'NotificationItem',
      title: 'Title',
      messageWrapper: 'MessageWrapper',
      dismiss: 'Dismiss',
      action: 'Action',
      actionWrapper: 'ActionWrapper'
    },

    byElement: function(element) {
      var self = this;
      return function(level) {
        var _element = self.elements[element];
        var override = self.overrideStyle[_element] || {};
        if (!self.overrideStyle) return {};
        return merge({}, Styles[_element].DefaultStyle, Styles[_element][level], override.DefaultStyle, override[level]);
      };
    }
  },

  _didNotificationRemoved: function(uid) {
    var notification;
    var notifications = this.state.notifications.filter(function(toCheck) {
      if (toCheck.uid === uid) {
        notification = toCheck;
        return false;
      }
      return true;
    });

    if (this._isMounted) {
      this.setState({ notifications: notifications });
    }

    if (notification && notification.onRemove) {
      notification.onRemove(notification);
    }
  },

  getInitialState: function() {
    return {
      notifications: []
    };
  },

  propTypes: {
    style: PropTypes.oneOfType([
      PropTypes.bool,
      PropTypes.object
    ]),
    noAnimation: PropTypes.bool,
    allowHTML: PropTypes.bool
  },

  getDefaultProps: function() {
    return {
      style: {},
      noAnimation: false,
      allowHTML: false
    };
  },

  addNotification: function(notification) {
    var _notification = merge({}, Constants.notification, notification);
    var notifications = this.state.notifications;
    var i;

    if (!_notification.level) {
      throw new Error('notification level is required.');
    }

    if (Object.keys(Constants.levels).indexOf(_notification.level) === -1) {
      throw new Error('\'' + _notification.level + '\' is not a valid level.');
    }

    // eslint-disable-next-line
    if (isNaN(_notification.autoDismiss)) {
      throw new Error('\'autoDismiss\' must be a number.');
    }

    if (Object.keys(Constants.positions).indexOf(_notification.position) === -1) {
      throw new Error('\'' + _notification.position + '\' is not a valid position.');
    }

    // Some preparations
    _notification.position = _notification.position.toLowerCase();
    _notification.level = _notification.level.toLowerCase();
    _notification.autoDismiss = parseInt(_notification.autoDismiss, 10);

    _notification.uid = _notification.uid || this.uid;
    _notification.ref = 'notification-' + _notification.uid;
    this.uid += 1;

    // do not add if the notification already exists based on supplied uid
    for (i = 0; i < notifications.length; i += 1) {
      if (notifications[i].uid === _notification.uid) {
        return false;
      }
    }

    notifications.push(_notification);

    if (typeof _notification.onAdd === 'function') {
      notification.onAdd(_notification);
    }

    this.setState({
      notifications: notifications
    });

    return _notification;
  },

  getNotificationRef: function(notification) {
    var self = this;
    var foundNotification = null;

    Object.keys(this.refs).forEach(function(container) {
      if (container.indexOf('container') > -1) {
        Object.keys(self.refs[container].refs).forEach(function(_notification) {
          var uid = notification.uid ? notification.uid : notification;
          if (_notification === 'notification-' + uid) {
            // NOTE: Stop iterating further and return the found notification.
            // Since UIDs are uniques and there won't be another notification found.
            foundNotification = self.refs[container].refs[_notification];
          }
        });
      }
    });

    return foundNotification;
  },

  removeNotification: function(notification) {
    var foundNotification = this.getNotificationRef(notification);
    return foundNotification && foundNotification._hideNotification();
  },

  editNotification: function(notification, newNotification) {
    var foundNotification = null;
    // NOTE: Find state notification to update by using
    // `setState` and forcing React to re-render the component.
    var uid = notification.uid ? notification.uid : notification;

    var newNotifications = this.state.notifications.filter(function(stateNotification) {
      if (uid === stateNotification.uid) {
        foundNotification = stateNotification;
        return false;
      }

      return true;
    });


    if (!foundNotification) {
      return;
    }

    newNotifications.push(merge(
      {},
      foundNotification,
      newNotification
    ));

    this.setState({
      notifications: newNotifications
    });
  },

  clearNotifications: function() {
    var self = this;
    Object.keys(this.refs).forEach(function(container) {
      if (container.indexOf('container') > -1) {
        Object.keys(self.refs[container].refs).forEach(function(_notification) {
          self.refs[container].refs[_notification]._hideNotification();
        });
      }
    });
  },

  componentDidMount: function() {
    this._getStyles.setOverrideStyle(this.props.style);
    this._isMounted = true;
  },

  componentWillUnmount: function() {
    this._isMounted = false;
  },

  render: function() {
    var self = this;
    var containers = null;
    var notifications = this.state.notifications;

    if (notifications.length) {
      containers = Object.keys(Constants.positions).map(function(position) {
        var _notifications = notifications.filter(function(notification) {
          return position === notification.position;
        });

        if (!_notifications.length) {
          return null;
        }

        return (
          React.createElement(NotificationContainer, {
            ref:  'container-' + position, 
            key:  position, 
            position:  position, 
            notifications:  _notifications, 
            getStyles:  self._getStyles, 
            onRemove:  self._didNotificationRemoved, 
            noAnimation:  self.props.noAnimation, 
            allowHTML:  self.props.allowHTML}
          )
        );
      });
    }


    return (
      React.createElement("div", {className: "notifications-wrapper", style:  this._getStyles.wrapper() }, 
         containers 
      )
    );
  }
});

module.exports = NotificationSystem;


/***/ }),

/***/ 5839:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */



var React = __webpack_require__(2);
var factory = __webpack_require__(5840);

if (typeof React === 'undefined') {
  throw Error(
    'create-react-class could not find the React object. If you are using script tags, ' +
      'make sure that React is being loaded before create-react-class.'
  );
}

// Hack to grab NoopUpdateQueue from isomorphic React
var ReactNoopUpdateQueue = new React.Component().updater;

module.exports = factory(
  React.Component,
  React.isValidElement,
  ReactNoopUpdateQueue
);


/***/ }),

/***/ 5840:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */



var _assign = __webpack_require__(4);

var emptyObject = __webpack_require__(5841);
var _invariant = __webpack_require__(2818);

if (false) { var warning; }

var MIXINS_KEY = 'mixins';

// Helper function to allow the creation of anonymous functions which do not
// have .name set to the name of the variable being assigned to.
function identity(fn) {
  return fn;
}

var ReactPropTypeLocationNames;
if (false) {} else {
  ReactPropTypeLocationNames = {};
}

function factory(ReactComponent, isValidElement, ReactNoopUpdateQueue) {
  /**
   * Policies that describe methods in `ReactClassInterface`.
   */

  var injectedMixins = [];

  /**
   * Composite components are higher-level components that compose other composite
   * or host components.
   *
   * To create a new type of `ReactClass`, pass a specification of
   * your new class to `React.createClass`. The only requirement of your class
   * specification is that you implement a `render` method.
   *
   *   var MyComponent = React.createClass({
   *     render: function() {
   *       return <div>Hello World</div>;
   *     }
   *   });
   *
   * The class specification supports a specific protocol of methods that have
   * special meaning (e.g. `render`). See `ReactClassInterface` for
   * more the comprehensive protocol. Any other properties and methods in the
   * class specification will be available on the prototype.
   *
   * @interface ReactClassInterface
   * @internal
   */
  var ReactClassInterface = {
    /**
     * An array of Mixin objects to include when defining your component.
     *
     * @type {array}
     * @optional
     */
    mixins: 'DEFINE_MANY',

    /**
     * An object containing properties and methods that should be defined on
     * the component's constructor instead of its prototype (static methods).
     *
     * @type {object}
     * @optional
     */
    statics: 'DEFINE_MANY',

    /**
     * Definition of prop types for this component.
     *
     * @type {object}
     * @optional
     */
    propTypes: 'DEFINE_MANY',

    /**
     * Definition of context types for this component.
     *
     * @type {object}
     * @optional
     */
    contextTypes: 'DEFINE_MANY',

    /**
     * Definition of context types this component sets for its children.
     *
     * @type {object}
     * @optional
     */
    childContextTypes: 'DEFINE_MANY',

    // ==== Definition methods ====

    /**
     * Invoked when the component is mounted. Values in the mapping will be set on
     * `this.props` if that prop is not specified (i.e. using an `in` check).
     *
     * This method is invoked before `getInitialState` and therefore cannot rely
     * on `this.state` or use `this.setState`.
     *
     * @return {object}
     * @optional
     */
    getDefaultProps: 'DEFINE_MANY_MERGED',

    /**
     * Invoked once before the component is mounted. The return value will be used
     * as the initial value of `this.state`.
     *
     *   getInitialState: function() {
     *     return {
     *       isOn: false,
     *       fooBaz: new BazFoo()
     *     }
     *   }
     *
     * @return {object}
     * @optional
     */
    getInitialState: 'DEFINE_MANY_MERGED',

    /**
     * @return {object}
     * @optional
     */
    getChildContext: 'DEFINE_MANY_MERGED',

    /**
     * Uses props from `this.props` and state from `this.state` to render the
     * structure of the component.
     *
     * No guarantees are made about when or how often this method is invoked, so
     * it must not have side effects.
     *
     *   render: function() {
     *     var name = this.props.name;
     *     return <div>Hello, {name}!</div>;
     *   }
     *
     * @return {ReactComponent}
     * @required
     */
    render: 'DEFINE_ONCE',

    // ==== Delegate methods ====

    /**
     * Invoked when the component is initially created and about to be mounted.
     * This may have side effects, but any external subscriptions or data created
     * by this method must be cleaned up in `componentWillUnmount`.
     *
     * @optional
     */
    componentWillMount: 'DEFINE_MANY',

    /**
     * Invoked when the component has been mounted and has a DOM representation.
     * However, there is no guarantee that the DOM node is in the document.
     *
     * Use this as an opportunity to operate on the DOM when the component has
     * been mounted (initialized and rendered) for the first time.
     *
     * @param {DOMElement} rootNode DOM element representing the component.
     * @optional
     */
    componentDidMount: 'DEFINE_MANY',

    /**
     * Invoked before the component receives new props.
     *
     * Use this as an opportunity to react to a prop transition by updating the
     * state using `this.setState`. Current props are accessed via `this.props`.
     *
     *   componentWillReceiveProps: function(nextProps, nextContext) {
     *     this.setState({
     *       likesIncreasing: nextProps.likeCount > this.props.likeCount
     *     });
     *   }
     *
     * NOTE: There is no equivalent `componentWillReceiveState`. An incoming prop
     * transition may cause a state change, but the opposite is not true. If you
     * need it, you are probably looking for `componentWillUpdate`.
     *
     * @param {object} nextProps
     * @optional
     */
    componentWillReceiveProps: 'DEFINE_MANY',

    /**
     * Invoked while deciding if the component should be updated as a result of
     * receiving new props, state and/or context.
     *
     * Use this as an opportunity to `return false` when you're certain that the
     * transition to the new props/state/context will not require a component
     * update.
     *
     *   shouldComponentUpdate: function(nextProps, nextState, nextContext) {
     *     return !equal(nextProps, this.props) ||
     *       !equal(nextState, this.state) ||
     *       !equal(nextContext, this.context);
     *   }
     *
     * @param {object} nextProps
     * @param {?object} nextState
     * @param {?object} nextContext
     * @return {boolean} True if the component should update.
     * @optional
     */
    shouldComponentUpdate: 'DEFINE_ONCE',

    /**
     * Invoked when the component is about to update due to a transition from
     * `this.props`, `this.state` and `this.context` to `nextProps`, `nextState`
     * and `nextContext`.
     *
     * Use this as an opportunity to perform preparation before an update occurs.
     *
     * NOTE: You **cannot** use `this.setState()` in this method.
     *
     * @param {object} nextProps
     * @param {?object} nextState
     * @param {?object} nextContext
     * @param {ReactReconcileTransaction} transaction
     * @optional
     */
    componentWillUpdate: 'DEFINE_MANY',

    /**
     * Invoked when the component's DOM representation has been updated.
     *
     * Use this as an opportunity to operate on the DOM when the component has
     * been updated.
     *
     * @param {object} prevProps
     * @param {?object} prevState
     * @param {?object} prevContext
     * @param {DOMElement} rootNode DOM element representing the component.
     * @optional
     */
    componentDidUpdate: 'DEFINE_MANY',

    /**
     * Invoked when the component is about to be removed from its parent and have
     * its DOM representation destroyed.
     *
     * Use this as an opportunity to deallocate any external resources.
     *
     * NOTE: There is no `componentDidUnmount` since your component will have been
     * destroyed by that point.
     *
     * @optional
     */
    componentWillUnmount: 'DEFINE_MANY',

    /**
     * Replacement for (deprecated) `componentWillMount`.
     *
     * @optional
     */
    UNSAFE_componentWillMount: 'DEFINE_MANY',

    /**
     * Replacement for (deprecated) `componentWillReceiveProps`.
     *
     * @optional
     */
    UNSAFE_componentWillReceiveProps: 'DEFINE_MANY',

    /**
     * Replacement for (deprecated) `componentWillUpdate`.
     *
     * @optional
     */
    UNSAFE_componentWillUpdate: 'DEFINE_MANY',

    // ==== Advanced methods ====

    /**
     * Updates the component's currently mounted DOM representation.
     *
     * By default, this implements React's rendering and reconciliation algorithm.
     * Sophisticated clients may wish to override this.
     *
     * @param {ReactReconcileTransaction} transaction
     * @internal
     * @overridable
     */
    updateComponent: 'OVERRIDE_BASE'
  };

  /**
   * Similar to ReactClassInterface but for static methods.
   */
  var ReactClassStaticInterface = {
    /**
     * This method is invoked after a component is instantiated and when it
     * receives new props. Return an object to update state in response to
     * prop changes. Return null to indicate no change to state.
     *
     * If an object is returned, its keys will be merged into the existing state.
     *
     * @return {object || null}
     * @optional
     */
    getDerivedStateFromProps: 'DEFINE_MANY_MERGED'
  };

  /**
   * Mapping from class specification keys to special processing functions.
   *
   * Although these are declared like instance properties in the specification
   * when defining classes using `React.createClass`, they are actually static
   * and are accessible on the constructor instead of the prototype. Despite
   * being static, they must be defined outside of the "statics" key under
   * which all other static methods are defined.
   */
  var RESERVED_SPEC_KEYS = {
    displayName: function(Constructor, displayName) {
      Constructor.displayName = displayName;
    },
    mixins: function(Constructor, mixins) {
      if (mixins) {
        for (var i = 0; i < mixins.length; i++) {
          mixSpecIntoComponent(Constructor, mixins[i]);
        }
      }
    },
    childContextTypes: function(Constructor, childContextTypes) {
      if (false) {}
      Constructor.childContextTypes = _assign(
        {},
        Constructor.childContextTypes,
        childContextTypes
      );
    },
    contextTypes: function(Constructor, contextTypes) {
      if (false) {}
      Constructor.contextTypes = _assign(
        {},
        Constructor.contextTypes,
        contextTypes
      );
    },
    /**
     * Special case getDefaultProps which should move into statics but requires
     * automatic merging.
     */
    getDefaultProps: function(Constructor, getDefaultProps) {
      if (Constructor.getDefaultProps) {
        Constructor.getDefaultProps = createMergedResultFunction(
          Constructor.getDefaultProps,
          getDefaultProps
        );
      } else {
        Constructor.getDefaultProps = getDefaultProps;
      }
    },
    propTypes: function(Constructor, propTypes) {
      if (false) {}
      Constructor.propTypes = _assign({}, Constructor.propTypes, propTypes);
    },
    statics: function(Constructor, statics) {
      mixStaticSpecIntoComponent(Constructor, statics);
    },
    autobind: function() {}
  };

  function validateTypeDef(Constructor, typeDef, location) {
    for (var propName in typeDef) {
      if (typeDef.hasOwnProperty(propName)) {
        // use a warning instead of an _invariant so components
        // don't show up in prod but only in __DEV__
        if (false) {}
      }
    }
  }

  function validateMethodOverride(isAlreadyDefined, name) {
    var specPolicy = ReactClassInterface.hasOwnProperty(name)
      ? ReactClassInterface[name]
      : null;

    // Disallow overriding of base class methods unless explicitly allowed.
    if (ReactClassMixin.hasOwnProperty(name)) {
      _invariant(
        specPolicy === 'OVERRIDE_BASE',
        'ReactClassInterface: You are attempting to override ' +
          '`%s` from your class specification. Ensure that your method names ' +
          'do not overlap with React methods.',
        name
      );
    }

    // Disallow defining methods more than once unless explicitly allowed.
    if (isAlreadyDefined) {
      _invariant(
        specPolicy === 'DEFINE_MANY' || specPolicy === 'DEFINE_MANY_MERGED',
        'ReactClassInterface: You are attempting to define ' +
          '`%s` on your component more than once. This conflict may be due ' +
          'to a mixin.',
        name
      );
    }
  }

  /**
   * Mixin helper which handles policy validation and reserved
   * specification keys when building React classes.
   */
  function mixSpecIntoComponent(Constructor, spec) {
    if (!spec) {
      if (false) { var isMixinValid, typeofSpec; }

      return;
    }

    _invariant(
      typeof spec !== 'function',
      "ReactClass: You're attempting to " +
        'use a component class or function as a mixin. Instead, just use a ' +
        'regular object.'
    );
    _invariant(
      !isValidElement(spec),
      "ReactClass: You're attempting to " +
        'use a component as a mixin. Instead, just use a regular object.'
    );

    var proto = Constructor.prototype;
    var autoBindPairs = proto.__reactAutoBindPairs;

    // By handling mixins before any other properties, we ensure the same
    // chaining order is applied to methods with DEFINE_MANY policy, whether
    // mixins are listed before or after these methods in the spec.
    if (spec.hasOwnProperty(MIXINS_KEY)) {
      RESERVED_SPEC_KEYS.mixins(Constructor, spec.mixins);
    }

    for (var name in spec) {
      if (!spec.hasOwnProperty(name)) {
        continue;
      }

      if (name === MIXINS_KEY) {
        // We have already handled mixins in a special case above.
        continue;
      }

      var property = spec[name];
      var isAlreadyDefined = proto.hasOwnProperty(name);
      validateMethodOverride(isAlreadyDefined, name);

      if (RESERVED_SPEC_KEYS.hasOwnProperty(name)) {
        RESERVED_SPEC_KEYS[name](Constructor, property);
      } else {
        // Setup methods on prototype:
        // The following member methods should not be automatically bound:
        // 1. Expected ReactClass methods (in the "interface").
        // 2. Overridden methods (that were mixed in).
        var isReactClassMethod = ReactClassInterface.hasOwnProperty(name);
        var isFunction = typeof property === 'function';
        var shouldAutoBind =
          isFunction &&
          !isReactClassMethod &&
          !isAlreadyDefined &&
          spec.autobind !== false;

        if (shouldAutoBind) {
          autoBindPairs.push(name, property);
          proto[name] = property;
        } else {
          if (isAlreadyDefined) {
            var specPolicy = ReactClassInterface[name];

            // These cases should already be caught by validateMethodOverride.
            _invariant(
              isReactClassMethod &&
                (specPolicy === 'DEFINE_MANY_MERGED' ||
                  specPolicy === 'DEFINE_MANY'),
              'ReactClass: Unexpected spec policy %s for key %s ' +
                'when mixing in component specs.',
              specPolicy,
              name
            );

            // For methods which are defined more than once, call the existing
            // methods before calling the new property, merging if appropriate.
            if (specPolicy === 'DEFINE_MANY_MERGED') {
              proto[name] = createMergedResultFunction(proto[name], property);
            } else if (specPolicy === 'DEFINE_MANY') {
              proto[name] = createChainedFunction(proto[name], property);
            }
          } else {
            proto[name] = property;
            if (false) {}
          }
        }
      }
    }
  }

  function mixStaticSpecIntoComponent(Constructor, statics) {
    if (!statics) {
      return;
    }

    for (var name in statics) {
      var property = statics[name];
      if (!statics.hasOwnProperty(name)) {
        continue;
      }

      var isReserved = name in RESERVED_SPEC_KEYS;
      _invariant(
        !isReserved,
        'ReactClass: You are attempting to define a reserved ' +
          'property, `%s`, that shouldn\'t be on the "statics" key. Define it ' +
          'as an instance property instead; it will still be accessible on the ' +
          'constructor.',
        name
      );

      var isAlreadyDefined = name in Constructor;
      if (isAlreadyDefined) {
        var specPolicy = ReactClassStaticInterface.hasOwnProperty(name)
          ? ReactClassStaticInterface[name]
          : null;

        _invariant(
          specPolicy === 'DEFINE_MANY_MERGED',
          'ReactClass: You are attempting to define ' +
            '`%s` on your component more than once. This conflict may be ' +
            'due to a mixin.',
          name
        );

        Constructor[name] = createMergedResultFunction(Constructor[name], property);

        return;
      }

      Constructor[name] = property;
    }
  }

  /**
   * Merge two objects, but throw if both contain the same key.
   *
   * @param {object} one The first object, which is mutated.
   * @param {object} two The second object
   * @return {object} one after it has been mutated to contain everything in two.
   */
  function mergeIntoWithNoDuplicateKeys(one, two) {
    _invariant(
      one && two && typeof one === 'object' && typeof two === 'object',
      'mergeIntoWithNoDuplicateKeys(): Cannot merge non-objects.'
    );

    for (var key in two) {
      if (two.hasOwnProperty(key)) {
        _invariant(
          one[key] === undefined,
          'mergeIntoWithNoDuplicateKeys(): ' +
            'Tried to merge two objects with the same key: `%s`. This conflict ' +
            'may be due to a mixin; in particular, this may be caused by two ' +
            'getInitialState() or getDefaultProps() methods returning objects ' +
            'with clashing keys.',
          key
        );
        one[key] = two[key];
      }
    }
    return one;
  }

  /**
   * Creates a function that invokes two functions and merges their return values.
   *
   * @param {function} one Function to invoke first.
   * @param {function} two Function to invoke second.
   * @return {function} Function that invokes the two argument functions.
   * @private
   */
  function createMergedResultFunction(one, two) {
    return function mergedResult() {
      var a = one.apply(this, arguments);
      var b = two.apply(this, arguments);
      if (a == null) {
        return b;
      } else if (b == null) {
        return a;
      }
      var c = {};
      mergeIntoWithNoDuplicateKeys(c, a);
      mergeIntoWithNoDuplicateKeys(c, b);
      return c;
    };
  }

  /**
   * Creates a function that invokes two functions and ignores their return vales.
   *
   * @param {function} one Function to invoke first.
   * @param {function} two Function to invoke second.
   * @return {function} Function that invokes the two argument functions.
   * @private
   */
  function createChainedFunction(one, two) {
    return function chainedFunction() {
      one.apply(this, arguments);
      two.apply(this, arguments);
    };
  }

  /**
   * Binds a method to the component.
   *
   * @param {object} component Component whose method is going to be bound.
   * @param {function} method Method to be bound.
   * @return {function} The bound method.
   */
  function bindAutoBindMethod(component, method) {
    var boundMethod = method.bind(component);
    if (false) { var _bind, componentName; }
    return boundMethod;
  }

  /**
   * Binds all auto-bound methods in a component.
   *
   * @param {object} component Component whose method is going to be bound.
   */
  function bindAutoBindMethods(component) {
    var pairs = component.__reactAutoBindPairs;
    for (var i = 0; i < pairs.length; i += 2) {
      var autoBindKey = pairs[i];
      var method = pairs[i + 1];
      component[autoBindKey] = bindAutoBindMethod(component, method);
    }
  }

  var IsMountedPreMixin = {
    componentDidMount: function() {
      this.__isMounted = true;
    }
  };

  var IsMountedPostMixin = {
    componentWillUnmount: function() {
      this.__isMounted = false;
    }
  };

  /**
   * Add more to the ReactClass base class. These are all legacy features and
   * therefore not already part of the modern ReactComponent.
   */
  var ReactClassMixin = {
    /**
     * TODO: This will be deprecated because state should always keep a consistent
     * type signature and the only use case for this, is to avoid that.
     */
    replaceState: function(newState, callback) {
      this.updater.enqueueReplaceState(this, newState, callback);
    },

    /**
     * Checks whether or not this composite component is mounted.
     * @return {boolean} True if mounted, false otherwise.
     * @protected
     * @final
     */
    isMounted: function() {
      if (false) {}
      return !!this.__isMounted;
    }
  };

  var ReactClassComponent = function() {};
  _assign(
    ReactClassComponent.prototype,
    ReactComponent.prototype,
    ReactClassMixin
  );

  /**
   * Creates a composite component class given a class specification.
   * See https://facebook.github.io/react/docs/top-level-api.html#react.createclass
   *
   * @param {object} spec Class specification (which must define `render`).
   * @return {function} Component constructor function.
   * @public
   */
  function createClass(spec) {
    // To keep our warnings more understandable, we'll use a little hack here to
    // ensure that Constructor.name !== 'Constructor'. This makes sure we don't
    // unnecessarily identify a class without displayName as 'Constructor'.
    var Constructor = identity(function(props, context, updater) {
      // This constructor gets overridden by mocks. The argument is used
      // by mocks to assert on what gets mounted.

      if (false) {}

      // Wire up auto-binding
      if (this.__reactAutoBindPairs.length) {
        bindAutoBindMethods(this);
      }

      this.props = props;
      this.context = context;
      this.refs = emptyObject;
      this.updater = updater || ReactNoopUpdateQueue;

      this.state = null;

      // ReactClasses doesn't have constructors. Instead, they use the
      // getInitialState and componentWillMount methods for initialization.

      var initialState = this.getInitialState ? this.getInitialState() : null;
      if (false) {}
      _invariant(
        typeof initialState === 'object' && !Array.isArray(initialState),
        '%s.getInitialState(): must return an object or null',
        Constructor.displayName || 'ReactCompositeComponent'
      );

      this.state = initialState;
    });
    Constructor.prototype = new ReactClassComponent();
    Constructor.prototype.constructor = Constructor;
    Constructor.prototype.__reactAutoBindPairs = [];

    injectedMixins.forEach(mixSpecIntoComponent.bind(null, Constructor));

    mixSpecIntoComponent(Constructor, IsMountedPreMixin);
    mixSpecIntoComponent(Constructor, spec);
    mixSpecIntoComponent(Constructor, IsMountedPostMixin);

    // Initialize the defaultProps property after all mixins have been merged.
    if (Constructor.getDefaultProps) {
      Constructor.defaultProps = Constructor.getDefaultProps();
    }

    if (false) {}

    _invariant(
      Constructor.prototype.render,
      'createClass(...): Class specification must implement a `render` method.'
    );

    if (false) {}

    // Reduce time spent doing lookups by setting these on the prototype.
    for (var methodName in ReactClassInterface) {
      if (!Constructor.prototype[methodName]) {
        Constructor.prototype[methodName] = null;
      }
    }

    return Constructor;
  }

  return createClass;
}

module.exports = factory;


/***/ }),

/***/ 5841:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */



var emptyObject = {};

if (false) {}

module.exports = emptyObject;

/***/ }),

/***/ 5842:
/***/ (function(module, exports, __webpack_require__) {

var React = __webpack_require__(2);
var createReactClass = __webpack_require__(5839);
var PropTypes = __webpack_require__(2815);
var NotificationItem = __webpack_require__(5843);
var Constants = __webpack_require__(5844);

var NotificationContainer = createReactClass({

  propTypes: {
    position: PropTypes.string.isRequired,
    notifications: PropTypes.array.isRequired,
    getStyles: PropTypes.object
  },

  _style: {},

  componentWillMount: function() {
    // Fix position if width is overrided
    this._style = this.props.getStyles.container(this.props.position);

    if (this.props.getStyles.overrideWidth && (this.props.position === Constants.positions.tc || this.props.position === Constants.positions.bc)) {
      this._style.marginLeft = -(this.props.getStyles.overrideWidth / 2);
    }
  },

  render: function() {
    var self = this;
    var notifications;

    if ([Constants.positions.bl, Constants.positions.br, Constants.positions.bc].indexOf(this.props.position) > -1) {
      this.props.notifications.reverse();
    }

    notifications = this.props.notifications.map(function(notification) {
      return (
        React.createElement(NotificationItem, {
          ref:  'notification-' + notification.uid, 
          key:  notification.uid, 
          notification:  notification, 
          getStyles:  self.props.getStyles, 
          onRemove:  self.props.onRemove, 
          noAnimation:  self.props.noAnimation, 
          allowHTML:  self.props.allowHTML, 
          children:  self.props.children}
        )
      );
    });

    return (
      React.createElement("div", {className:  'notifications-' + this.props.position, style:  this._style}, 
         notifications 
      )
    );
  }
});


module.exports = NotificationContainer;


/***/ }),

/***/ 5843:
/***/ (function(module, exports, __webpack_require__) {

var React = __webpack_require__(2);
var createReactClass = __webpack_require__(5839);
var PropTypes = __webpack_require__(2815);
var ReactDOM = __webpack_require__(5);
var Constants = __webpack_require__(5844);
var Helpers = __webpack_require__(5845);
var merge = __webpack_require__(4);

/* From Modernizr */
var whichTransitionEvent = function() {
  var el = document.createElement('fakeelement');
  var transition;
  var transitions = {
    transition: 'transitionend',
    OTransition: 'oTransitionEnd',
    MozTransition: 'transitionend',
    WebkitTransition: 'webkitTransitionEnd'
  };

  Object.keys(transitions).forEach(function(transitionKey) {
    if (el.style[transitionKey] !== undefined) {
      transition = transitions[transitionKey];
    }
  });

  return transition;
};

var NotificationItem = createReactClass({
  propTypes: {
    notification: PropTypes.object,
    getStyles: PropTypes.object,
    onRemove: PropTypes.func,
    allowHTML: PropTypes.bool,
    noAnimation: PropTypes.bool,
    children: PropTypes.oneOfType([
      PropTypes.string,
      PropTypes.element
    ])
  },

  getDefaultProps: function() {
    return {
      noAnimation: false,
      onRemove: function() {},
      allowHTML: false
    };
  },

  getInitialState: function() {
    return {
      visible: undefined,
      removed: false
    };
  },

  componentWillMount: function() {
    var getStyles = this.props.getStyles;
    var level = this.props.notification.level;
    var dismissible = this.props.notification.dismissible;

    this._noAnimation = this.props.noAnimation;

    this._styles = {
      notification: getStyles.byElement('notification')(level),
      title: getStyles.byElement('title')(level),
      dismiss: getStyles.byElement('dismiss')(level),
      messageWrapper: getStyles.byElement('messageWrapper')(level),
      actionWrapper: getStyles.byElement('actionWrapper')(level),
      action: getStyles.byElement('action')(level)
    };

    if (!dismissible || dismissible === 'none' || dismissible === 'button') {
      this._styles.notification.cursor = 'default';
    }
  },

  _styles: {},

  _notificationTimer: null,

  _height: 0,

  _noAnimation: null,

  _isMounted: false,

  _removeCount: 0,

  _getCssPropertyByPosition: function() {
    var position = this.props.notification.position;
    var css = {};

    switch (position) {
    case Constants.positions.tl:
    case Constants.positions.bl:
      css = {
        property: 'left',
        value: -200
      };
      break;

    case Constants.positions.tr:
    case Constants.positions.br:
      css = {
        property: 'right',
        value: -200
      };
      break;

    case Constants.positions.tc:
      css = {
        property: 'top',
        value: -100
      };
      break;

    case Constants.positions.bc:
      css = {
        property: 'bottom',
        value: -100
      };
      break;

    default:
    }

    return css;
  },

  _defaultAction: function(event) {
    var notification = this.props.notification;

    event.preventDefault();
    this._hideNotification();
    if (typeof notification.action.callback === 'function') {
      notification.action.callback();
    }
  },

  _hideNotification: function() {
    if (this._notificationTimer) {
      this._notificationTimer.clear();
    }

    if (this._isMounted) {
      this.setState({
        visible: false,
        removed: true
      });
    }

    if (this._noAnimation) {
      this._removeNotification();
    }
  },

  _removeNotification: function() {
    this.props.onRemove(this.props.notification.uid);
  },

  _dismiss: function() {
    if (!this.props.notification.dismissible) {
      return;
    }

    this._hideNotification();
  },

  _showNotification: function() {
    var self = this;
    setTimeout(function() {
      if (self._isMounted) {
        self.setState({
          visible: true
        });
      }
    }, 50);
  },

  _onTransitionEnd: function() {
    if (this._removeCount > 0) return;
    if (this.state.removed) {
      this._removeCount += 1;
      this._removeNotification();
    }
  },

  componentDidMount: function() {
    var self = this;
    var transitionEvent = whichTransitionEvent();
    var notification = this.props.notification;
    var element = ReactDOM.findDOMNode(this);

    this._height = element.offsetHeight;

    this._isMounted = true;

    // Watch for transition end
    if (!this._noAnimation) {
      if (transitionEvent) {
        element.addEventListener(transitionEvent, this._onTransitionEnd);
      } else {
        this._noAnimation = true;
      }
    }


    if (notification.autoDismiss) {
      this._notificationTimer = new Helpers.Timer(function() {
        self._hideNotification();
      }, notification.autoDismiss * 1000);
    }

    this._showNotification();
  },

  _handleMouseEnter: function() {
    var notification = this.props.notification;
    if (notification.autoDismiss) {
      this._notificationTimer.pause();
    }
  },

  _handleMouseLeave: function() {
    var notification = this.props.notification;
    if (notification.autoDismiss) {
      this._notificationTimer.resume();
    }
  },

  _handleNotificationClick: function() {
    var dismissible = this.props.notification.dismissible;
    if (dismissible === 'both' || dismissible === 'click' || dismissible === true) {
      this._dismiss();
    }
  },

  componentWillUnmount: function() {
    var element = ReactDOM.findDOMNode(this);
    var transitionEvent = whichTransitionEvent();
    element.removeEventListener(transitionEvent, this._onTransitionEnd);
    this._isMounted = false;
  },

  _allowHTML: function(string) {
    return { __html: string };
  },

  render: function() {
    var notification = this.props.notification;
    var className = 'notification notification-' + notification.level;
    var notificationStyle = merge({}, this._styles.notification);
    var cssByPos = this._getCssPropertyByPosition();
    var dismiss = null;
    var actionButton = null;
    var title = null;
    var message = null;

    if (this.state.visible) {
      className += ' notification-visible';
    } else if (this.state.visible === false) {
      className += ' notification-hidden';
    }

    if (notification.dismissible === 'none') {
      className += ' notification-not-dismissible';
    }

    if (this.props.getStyles.overrideStyle) {
      if (!this.state.visible && !this.state.removed) {
        notificationStyle[cssByPos.property] = cssByPos.value;
      }

      if (this.state.visible && !this.state.removed) {
        notificationStyle.height = this._height;
        notificationStyle[cssByPos.property] = 0;
      }

      if (this.state.removed) {
        notificationStyle.overlay = 'hidden';
        notificationStyle.height = 0;
        notificationStyle.marginTop = 0;
        notificationStyle.paddingTop = 0;
        notificationStyle.paddingBottom = 0;
      }
      notificationStyle.opacity = this.state.visible ? this._styles.notification.isVisible.opacity : this._styles.notification.isHidden.opacity;
    }

    if (notification.title) {
      title = React.createElement("h4", {className: "notification-title", style:  this._styles.title},  notification.title);
    }

    if (notification.message) {
      if (this.props.allowHTML) {
        message = (
          React.createElement("div", {className: "notification-message", style:  this._styles.messageWrapper, dangerouslySetInnerHTML:  this._allowHTML(notification.message) })
        );
      } else {
        message = (
          React.createElement("div", {className: "notification-message", style:  this._styles.messageWrapper},  notification.message)
        );
      }
    }
    if (notification.dismissible === 'both' || notification.dismissible === 'button' || notification.dismissible === true) {
      dismiss = React.createElement("span", {className: "notification-dismiss", onClick:  this._dismiss, style:  this._styles.dismiss}, "×");
    }

    if (notification.action) {
      actionButton = (
        React.createElement("div", {className: "notification-action-wrapper", style:  this._styles.actionWrapper}, 
          React.createElement("button", {className: "notification-action-button", 
            onClick:  this._defaultAction, 
            style:  this._styles.action}, 
             notification.action.label
          )
        )
      );
    }

    if (notification.children) {
      actionButton = notification.children;
    }

    return (
      React.createElement("div", {className:  className, onClick:  this._handleNotificationClick, onMouseEnter:  this._handleMouseEnter, onMouseLeave:  this._handleMouseLeave, style:  notificationStyle }, 
         title, 
         message, 
         dismiss, 
         actionButton 
      )
    );
  }

});

module.exports = NotificationItem;


/***/ }),

/***/ 5844:
/***/ (function(module, exports) {

var CONSTANTS = {

  // Positions
  positions: {
    tl: 'tl',
    tr: 'tr',
    tc: 'tc',
    bl: 'bl',
    br: 'br',
    bc: 'bc'
  },

  // Levels
  levels: {
    success: 'success',
    error: 'error',
    warning: 'warning',
    info: 'info'
  },

  // Notification defaults
  notification: {
    title: null,
    message: null,
    level: null,
    position: 'tr',
    autoDismiss: 5,
    dismissible: 'both',
    action: null
  }
};


module.exports = CONSTANTS;


/***/ }),

/***/ 5845:
/***/ (function(module, exports) {

var Helpers = {
  Timer: function(callback, delay) {
    var timerId;
    var start;
    var remaining = delay;

    this.pause = function() {
      clearTimeout(timerId);
      remaining -= new Date() - start;
    };

    this.resume = function() {
      start = new Date();
      clearTimeout(timerId);
      timerId = setTimeout(callback, remaining);
    };

    this.clear = function() {
      clearTimeout(timerId);
    };

    this.resume();
  }
};

module.exports = Helpers;


/***/ }),

/***/ 5846:
/***/ (function(module, exports) {

// Used for calculations
var defaultWidth = 320;
var defaultColors = {
  success: {
    rgb: '94, 164, 0',
    hex: '#5ea400'
  },
  error: {
    rgb: '236, 61, 61',
    hex: '#ec3d3d'
  },
  warning: {
    rgb: '235, 173, 23',
    hex: '#ebad1a'
  },
  info: {
    rgb: '54, 156, 199',
    hex: '#369cc7'
  }
};
var defaultShadowOpacity = '0.9';

var STYLES = {

  Wrapper: {},
  Containers: {
    DefaultStyle: {
      fontFamily: 'inherit',
      position: 'fixed',
      width: defaultWidth,
      padding: '0 10px 10px 10px',
      zIndex: 9998,
      WebkitBoxSizing: 'border-box',
      MozBoxSizing: 'border-box',
      boxSizing: 'border-box',
      height: 'auto'
    },

    tl: {
      top: '0px',
      bottom: 'auto',
      left: '0px',
      right: 'auto'
    },

    tr: {
      top: '0px',
      bottom: 'auto',
      left: 'auto',
      right: '0px'
    },

    tc: {
      top: '0px',
      bottom: 'auto',
      margin: '0 auto',
      left: '50%',
      marginLeft: -(defaultWidth / 2)
    },

    bl: {
      top: 'auto',
      bottom: '0px',
      left: '0px',
      right: 'auto'
    },

    br: {
      top: 'auto',
      bottom: '0px',
      left: 'auto',
      right: '0px'
    },

    bc: {
      top: 'auto',
      bottom: '0px',
      margin: '0 auto',
      left: '50%',
      marginLeft: -(defaultWidth / 2)
    }

  },

  NotificationItem: {
    DefaultStyle: {
      position: 'relative',
      width: '100%',
      cursor: 'pointer',
      borderRadius: '2px',
      fontSize: '13px',
      margin: '10px 0 0',
      padding: '10px',
      display: 'block',
      WebkitBoxSizing: 'border-box',
      MozBoxSizing: 'border-box',
      boxSizing: 'border-box',
      opacity: 0,
      transition: '0.3s ease-in-out',
      WebkitTransform: 'translate3d(0, 0, 0)',
      transform: 'translate3d(0, 0, 0)',
      willChange: 'transform, opacity',

      isHidden: {
        opacity: 0
      },

      isVisible: {
        opacity: 1
      }
    },

    success: {
      borderTop: '2px solid ' + defaultColors.success.hex,
      backgroundColor: '#f0f5ea',
      color: '#4b583a',
      WebkitBoxShadow: '0 0 1px rgba(' + defaultColors.success.rgb + ',' + defaultShadowOpacity + ')',
      MozBoxShadow: '0 0 1px rgba(' + defaultColors.success.rgb + ',' + defaultShadowOpacity + ')',
      boxShadow: '0 0 1px rgba(' + defaultColors.success.rgb + ',' + defaultShadowOpacity + ')'
    },

    error: {
      borderTop: '2px solid ' + defaultColors.error.hex,
      backgroundColor: '#f4e9e9',
      color: '#412f2f',
      WebkitBoxShadow: '0 0 1px rgba(' + defaultColors.error.rgb + ',' + defaultShadowOpacity + ')',
      MozBoxShadow: '0 0 1px rgba(' + defaultColors.error.rgb + ',' + defaultShadowOpacity + ')',
      boxShadow: '0 0 1px rgba(' + defaultColors.error.rgb + ',' + defaultShadowOpacity + ')'
    },

    warning: {
      borderTop: '2px solid ' + defaultColors.warning.hex,
      backgroundColor: '#f9f6f0',
      color: '#5a5343',
      WebkitBoxShadow: '0 0 1px rgba(' + defaultColors.warning.rgb + ',' + defaultShadowOpacity + ')',
      MozBoxShadow: '0 0 1px rgba(' + defaultColors.warning.rgb + ',' + defaultShadowOpacity + ')',
      boxShadow: '0 0 1px rgba(' + defaultColors.warning.rgb + ',' + defaultShadowOpacity + ')'
    },

    info: {
      borderTop: '2px solid ' + defaultColors.info.hex,
      backgroundColor: '#e8f0f4',
      color: '#41555d',
      WebkitBoxShadow: '0 0 1px rgba(' + defaultColors.info.rgb + ',' + defaultShadowOpacity + ')',
      MozBoxShadow: '0 0 1px rgba(' + defaultColors.info.rgb + ',' + defaultShadowOpacity + ')',
      boxShadow: '0 0 1px rgba(' + defaultColors.info.rgb + ',' + defaultShadowOpacity + ')'
    }
  },

  Title: {
    DefaultStyle: {
      fontSize: '14px',
      margin: '0 0 5px 0',
      padding: 0,
      fontWeight: 'bold'
    },

    success: {
      color: defaultColors.success.hex
    },

    error: {
      color: defaultColors.error.hex
    },

    warning: {
      color: defaultColors.warning.hex
    },

    info: {
      color: defaultColors.info.hex
    }

  },

  MessageWrapper: {
    DefaultStyle: {
      margin: 0,
      padding: 0
    }
  },

  Dismiss: {
    DefaultStyle: {
      cursor: 'pointer',
      fontFamily: 'Arial',
      fontSize: '17px',
      position: 'absolute',
      top: '4px',
      right: '5px',
      lineHeight: '15px',
      backgroundColor: '#dededf',
      color: '#ffffff',
      borderRadius: '50%',
      width: '14px',
      height: '14px',
      fontWeight: 'bold',
      textAlign: 'center'
    },

    success: {
      color: '#f0f5ea',
      backgroundColor: '#b0ca92'
    },

    error: {
      color: '#f4e9e9',
      backgroundColor: '#e4bebe'
    },

    warning: {
      color: '#f9f6f0',
      backgroundColor: '#e1cfac'
    },

    info: {
      color: '#e8f0f4',
      backgroundColor: '#a4becb'
    }
  },

  Action: {
    DefaultStyle: {
      background: '#ffffff',
      borderRadius: '2px',
      padding: '6px 20px',
      fontWeight: 'bold',
      margin: '10px 0 0 0',
      border: 0
    },

    success: {
      backgroundColor: defaultColors.success.hex,
      color: '#ffffff'
    },

    error: {
      backgroundColor: defaultColors.error.hex,
      color: '#ffffff'
    },

    warning: {
      backgroundColor: defaultColors.warning.hex,
      color: '#ffffff'
    },

    info: {
      backgroundColor: defaultColors.info.hex,
      color: '#ffffff'
    }
  },

  ActionWrapper: {
    DefaultStyle: {
      margin: 0,
      padding: 0
    }
  }
};

module.exports = STYLES;


/***/ }),

/***/ 5847:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleFooter; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _js_utils_PluralizeHelper__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3224);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(3048);
/* harmony import */ var _js_components_base_Icons_ErrorIcon__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(3232);
/* harmony import */ var _js_components_base_Icons_SettingsIcon__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(5848);
/* harmony import */ var _js_components_base_Icons_WarningIcon__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(3225);
var _class;










const NARROW_WIDTH_THRESHOLD = 550;let


ConsoleFooter = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class ConsoleFooter extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isExpanded: false,
      isNarrow: false };


    this.toggleSettings = this.toggleSettings.bind(this);
    this.handleResize = this.handleResize.bind(this);
    this.getSettingToggles = this.getSettingToggles.bind(this);
  }

  componentDidMount() {
    window.addEventListener('resize', this.handleResize);
    this.handleResize();
  }

  componentWillUnmount() {
    window.removeEventListener('resize', this.handleResize);
  }

  getSettingToggles() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-footer__settings' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: 'settings__item',
            onClick: () => this.props.store.toggleTimestamp() },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__["Checkbox"], {
            checked: this.props.store.showTimestamp,
            className: 'settings__checkbox' }),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'settings__label' }, 'Show timestamps')),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: 'settings__item',
            onClick: () => this.props.store.toggleNetworkLogs() },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__["Checkbox"], {
            className: 'settings__checkbox',
            checked: this.props.store.hideNetworkLogs }),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'settings__label' }, 'Hide network'))));



  }

  handleResize() {
    if (window.innerWidth < NARROW_WIDTH_THRESHOLD) {
      !this.state.isNarrow && this.setState({ isNarrow: true });
    } else {
      this.state.isNarrow && this.setState({ isNarrow: false });
    }
  }

  toggleSettings() {
    this.setState(prevState => ({ isExpanded: !prevState.isExpanded }));
  }

  render() {
    const errorCount = _.get(this, 'props.eventStore.errorCount', 0),
    warnCount = _.get(this, 'props.eventStore.warnCount', 0);

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-footer' },

        this.state.isExpanded && this.state.isNarrow && this.getSettingToggles(),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-footer__meta-settings' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'meta-settings__left' },

            !!errorCount &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'meta console-footer__error' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_ErrorIcon__WEBPACK_IMPORTED_MODULE_5__["default"], {
                size: 'xs',
                className: 'meta__error-icon' }),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'meta__label' },
                errorCount,

                _js_utils_PluralizeHelper__WEBPACK_IMPORTED_MODULE_2__["default"].pluralize({
                  count: errorCount,
                  singular: ' error',
                  plural: ' errors' }))),







            !!warnCount &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'meta console-footer__warning' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_WarningIcon__WEBPACK_IMPORTED_MODULE_7__["default"], {
                size: 'xs',
                className: 'meta__warning-icon' }),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'meta__label' },
                warnCount,

                _js_utils_PluralizeHelper__WEBPACK_IMPORTED_MODULE_2__["default"].pluralize({
                  count: warnCount,
                  singular: ' warning',
                  plural: ' warnings' })))),







          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'meta-settings__right' },

            this.state.isNarrow ?
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], {
                type: 'icon',
                className: 'settings-icon',
                onClick: this.toggleSettings,
                tooltip: 'Console settings' },

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_SettingsIcon__WEBPACK_IMPORTED_MODULE_6__["default"], {
                size: 'xs',
                className: this.state.isExpanded && 'settings-icon--active' })) :



            this.getSettingToggles()))));





  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5848:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return SettingsIcon; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2813);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('svg', { width: '16', height: '16', viewBox: '0 0 16 16' },
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('defs', null,
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { id: 'settings', d: 'M16 9.62c-.162.507-.316 1.009-.49 1.502a.292.292 0 0 1-.24.074 40.124 40.124 0 0 1-1.51-.217.35.35 0 0 0-.409.16c-.178.275-.371.54-.579.795a.389.389 0 0 0-.046.502c.275.488.518.981.776 1.506l-1.378 1c-.423-.405-.848-.798-1.257-1.206a.354.354 0 0 0-.425-.091c-.348.125-.707.225-1.054.354a.318.318 0 0 0-.176.205c-.11.584-.206 1.174-.313 1.796H7.304a.21.21 0 0 1-.133-.145c-.105-.53-.201-1.063-.29-1.597a.26.26 0 0 0-.211-.245c-.37-.106-.738-.225-1.106-.348a.266.266 0 0 0-.318.074c-.412.428-.831.855-1.263 1.283l-1.421-1c.252-.508.486-1.013.753-1.5a.403.403 0 0 0-.04-.53c-.224-.263-.424-.545-.623-.825a.236.236 0 0 0-.29-.116c-.524.09-1.054.162-1.58.248a.235.235 0 0 1-.2-.023.228.228 0 0 1-.107-.168A19.382 19.382 0 0 0 .08 9.93a.205.205 0 0 1-.019-.188.21.21 0 0 1 .144-.125c.471-.229.926-.485 1.395-.719a.285.285 0 0 0 .188-.314c-.013-.35-.013-.699 0-1.049a.333.333 0 0 0-.22-.365C1.045 6.925.536 6.654 0 6.38c.162-.507.316-1.009.49-1.499a.292.292 0 0 1 .24-.074c.506.063 1.01.131 1.51.214a.347.347 0 0 0 .406-.157c.182-.283.381-.554.596-.813a.37.37 0 0 0 .03-.484 43.456 43.456 0 0 1-.77-1.509l1.377-1c.426.407.848.798 1.26 1.206a.35.35 0 0 0 .425.091c.347-.125.706-.225 1.054-.354a.315.315 0 0 0 .176-.205C6.904 1.212 7 .622 7.107 0h1.595a.212.212 0 0 1 .133.145c.104.53.203 1.061.29 1.597a.26.26 0 0 0 .211.248c.37.106.738.225 1.106.348.11.05.24.02.315-.074.411-.428.831-.856 1.26-1.283l1.421 1c-.252.51-.492 1.013-.75 1.503a.39.39 0 0 0 .026.525c.235.285.58.407.657.855.058.064.142.1.23.097a50.556 50.556 0 0 0 1.603-.243.235.235 0 0 1 .206.008.228.228 0 0 1 .118.166c.116.405.255.804.4 1.198.035.05.043.113.022.17a.187.187 0 0 1-.13.115c-.474.237-.94.493-1.415.73a.285.285 0 0 0-.185.313c0 .351.014.702 0 1.05a.333.333 0 0 0 .22.365c.51.242 1.027.516 1.56.786zM10.708 8a2.665 2.665 0 0 0-1.667-2.467 2.737 2.737 0 0 0-2.951.574 2.636 2.636 0 0 0-.59 2.906 2.707 2.707 0 0 0 2.501 1.647c1.49-.008 2.696-1.193 2.707-2.66z' })),

  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('use', { fill: '#A9A9A9', fillRule: 'evenodd', xlinkHref: '#settings' }));



function SettingsIcon(props) {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_Icon__WEBPACK_IMPORTED_MODULE_1__["default"], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 5849:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleHeader; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(3048);
/* harmony import */ var _ConsoleFilter_ConsoleFilter__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(5850);
var _class;





let


ConsoleHeader = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class ConsoleHeader extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    // Set a local state for searchQuery to debounce the search selection
    this.state = {
      searchQuery: '' };


    this.handleSearchChange = this.handleSearchChange.bind(this);
    this.handleSearchCancel = this.handleSearchCancel.bind(this);
    this.handleClear = this.handleClear.bind(this);
  }

  handleSearchChange(query) {
    this.setState({ searchQuery: query });

    this.props.store.setIsSearching(true);
    this.props.store.setSearchQueryDebounced(query);
  }

  handleSearchCancel() {
    this.props.store.setSearchQuery('');
  }

  handleClear() {
    this.props.store.clearEvents();
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-header' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-header__left' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'search-input' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__["Input"], {
              inputStyle: 'search',
              type: 'text',
              placeholder: 'Search messages',
              onChange: this.handleSearchChange,
              onCancel: this.handleSearchCancel,
              query: this.state.searchQuery,
              className: classnames__WEBPACK_IMPORTED_MODULE_2___default()({ 'is-highlighted': this.state.searchQuery }) })),



          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleFilter_ConsoleFilter__WEBPACK_IMPORTED_MODULE_5__["default"], null)),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-header__right' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], {
              type: 'secondary',
              className: 'clear-btn',
              size: 'small',
              onClick: this.handleClear,
              disabled: !_.get(this.props, 'eventStore.hasLogs') }, 'Clear'))));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5850:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleFilter; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2959);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(3048);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(749);
var _class;





let


ConsoleFilter = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class ConsoleFilter extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {
  constructor(props) {
    super(props);

    this.store = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('ConsoleStore');
    this.eventStore = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('ConsoleEventStore');

    this.handleToggleFilterLevel = this.handleToggleFilterLevel.bind(this);
  }

  handleToggleFilterLevel(level, e) {
    e && e.stopPropagation();
    this.eventStore.toggleFilterLevel(level);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-filter' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["Dropdown"], { disableCloseOnPageScroll: true },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["DropdownButton"], null,
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], { type: 'text', className: 'filter-btn' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, this.store && this.store.allFilterLevelsSelected ? 'All Logs' : 'Custom'))),


          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["DropdownMenu"], null,
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
                key: 'log',
                refKey: 'log',
                className: 'filter__menu-item' },

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  onClick: this.handleToggleFilterLevel.bind(null, 'log'),
                  className: 'menu-item__wrapper' },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__["Checkbox"], {
                  checked: _.includes(this.eventStore.filterLevels, 'log'),
                  className: 'menu-item__checkbox' }),

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'menu-item__label' }, 'Log'))),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
                key: 'info',
                refKey: 'info',
                className: 'filter__menu-item' },

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  onClick: this.handleToggleFilterLevel.bind(null, 'info'),
                  className: 'menu-item__wrapper' },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__["Checkbox"], {
                  checked: _.includes(this.eventStore.filterLevels, 'info'),
                  className: 'menu-item__checkbox' }),

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'menu-item__label' }, 'Info'))),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
                key: 'warn',
                refKey: 'warn',
                className: 'filter__menu-item' },

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  onClick: this.handleToggleFilterLevel.bind(null, 'warn'),
                  className: 'menu-item__wrapper' },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__["Checkbox"], {
                  checked: _.includes(this.eventStore.filterLevels, 'warn'),
                  className: 'menu-item__checkbox' }),

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'menu-item__label' }, 'Warning'))),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
                key: 'error',
                refKey: 'error',
                className: 'filter__menu-item' },

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  onClick: this.handleToggleFilterLevel.bind(null, 'error'),
                  className: 'menu-item__wrapper' },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__["Checkbox"], {
                  checked: _.includes(this.eventStore.filterLevels, 'error'),
                  className: 'menu-item__checkbox' }),

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'menu-item__label' }, 'Error')))))));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5851:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleList; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_window__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3616);
/* harmony import */ var react_virtualized_auto_sizer__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5852);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2929);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var mobx__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(751);
/* harmony import */ var _ConsoleListItem_ConsoleListItem__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(5853);
/* harmony import */ var _js_components_base_Text__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(3285);
var _class;










const MIN_ROW_HEIGHT = 24;let


ConsoleList = Object(mobx_react__WEBPACK_IMPORTED_MODULE_4__["observer"])(_class = class ConsoleList extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.getListItem = this.getListItem.bind(this);
    this.getItemSize = this.getItemSize.bind(this);
    this.handleClearCachedHeight = this.handleClearCachedHeight.bind(this);
    this.autoScrollToBottom = this.autoScrollToBottom.bind(this);
    this.onItemsRendered = this.onItemsRendered.bind(this);
    this.callOnScroll = this.callOnScroll.bind(this);
    this.observeSizeChange = this.observeSizeChange.bind(this);
    this.unobserveSizeChange = this.unobserveSizeChange.bind(this);
    this.renderEmptyState = this.renderEmptyState.bind(this);

    this.listRefs = {};
    this.autoScroll = true;

    // Listen to changes in number of Console events
    //
    // fireImmediately is used for the first scroll to bottom when Console is opened.
    //
    // requestIdleCallback is used because mounting and rendering of new Console events is of
    // higher priority and must be done before scrolling.
    // Also, this helps in waiting for the initial loading and mounting, when Console is booted,
    // before the initial scroll to bottom.
    this.reactionDisposer = Object(mobx__WEBPACK_IMPORTED_MODULE_6__["reaction"])(() => this.props.store.visibleEvents, () => {
      requestIdleCallback(this.autoScrollToBottom.bind(this));
    },
    {
      fireImmediately: true });

  }

  componentDidMount() {
    this.resizeObserver = new ResizeObserver(entries => {
      for (const entry of entries) {// eslint-disable-line no-unused-vars
        if (entry.target.offsetHeight === 0) {
          return;
        }

        this.handleClearCachedHeight(_.get(entry, 'target.dataset.index'));
      }
    });
  }

  componentWillUnmount() {
    this.reactionDisposer && this.reactionDisposer();
  }

  // Listen to user scroll for enabling autoscroll in Console.
  onItemsRendered({ visibleStopIndex }) {
    // Visible stop index is the last list item visible in the virtualized list
    //
    // if the last list item is visible, then autoscroll gets enabled
    if (visibleStopIndex >= this.props.store.eventCount - 2) {
      this.autoScroll = true;
    }
  }

  getItemSize(index) {
    const currentEvent = _.get(this.props, ['store', 'visibleEvents', index]),
    currentEventId = currentEvent && currentEvent.id,
    currentNode = currentEventId && Object(react_dom__WEBPACK_IMPORTED_MODULE_1__["findDOMNode"])(this.listRefs[currentEventId]);

    return currentNode && currentNode.offsetHeight || MIN_ROW_HEIGHT;
  }

  getListItem(data) {
    const consoleEvent = _.get(this.props, ['store', 'visibleEvents', data.index]),
    expandSet = _.get(this.props, 'store.expandSet'),
    toggleExpanded = () => {
      this.props.store.toggleExpanded(consoleEvent.id);
    };

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: this.getClassnames(), style: data.style },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleListItem_ConsoleListItem__WEBPACK_IMPORTED_MODULE_7__["default"], {
          key: consoleEvent.id,
          index: data.index,
          event: consoleEvent,
          showTimestamp: this.props.store.showTimestamp,
          onHeightChange: this.handleClearCachedHeight,
          ref: ref => {this.listRefs[consoleEvent.id] = ref;},
          isExpanded: expandSet.has(consoleEvent.id),
          toggleExpanded: toggleExpanded,
          observeSizeChange: this.observeSizeChange,
          unobserveSizeChange: this.unobserveSizeChange,
          viewLargeBody: this.props.viewLargeBody })));



  }

  getClassnames() {
    let isOverflown = false;

    if (this.listRef) {
      const node = Object(react_dom__WEBPACK_IMPORTED_MODULE_1__["findDOMNode"])(this.listRef);

      isOverflown = node.clientHeight < node.scrollHeight;
    }

    return classnames__WEBPACK_IMPORTED_MODULE_5___default()(
    'console-list-item',
    {
      'is-overflown': isOverflown });


  }

  handleClearCachedHeight(index) {
    this.listRef.resetAfterIndex(index);
  }

  // Listen to backward user scroll for disabling autoscroll in Console.
  callOnScroll({ scrollDirection }) {
    // If the user scrolls in upward direction, which is 'backward' in react-window
    // then autoscroll should be disabled
    if (scrollDirection === 'backward') {
      this.autoScroll = false;
    }
  }

  autoScrollToBottom() {
    if (!this.autoScroll) {
      return;
    }

    !_.isEmpty(this.listRef) && this.listRef.scrollToItem(this.props.store.eventCount);
  }

  observeSizeChange(node) {
    this.resizeObserver && this.resizeObserver.observe(node);
  }

  unobserveSizeChange(node) {
    this.resizeObserver && this.resizeObserver.unobserve(node);
  }

  renderEmptyState() {
    const { store } = this.props;

    if (store.searchQuery) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-list__empty' },
          ` No results found for "${this.props.store.searchQuery}"`));


    }

    // @todo the empty state might be wrong if some logs are hidden by user
    // preference.
    // i.e. (!store.allFilterLevelsSelected || store.hideNetworkLogs)

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-list__empty__container' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-list__empty' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-list__empty--title' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Text__WEBPACK_IMPORTED_MODULE_8__["default"], { type: 'heading-h4', value: 'No logs yet' })),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-list__empty--description' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Text__WEBPACK_IMPORTED_MODULE_8__["default"], { type: 'body-medium', value: 'Send a request to view its details in the console.' })))));




  }

  render() {
    const lister = data =>
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(mobx_react__WEBPACK_IMPORTED_MODULE_4__["Observer"], null,
      this.getListItem.bind(this, data)),


    sizer = ({ height, width }) =>
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(mobx_react__WEBPACK_IMPORTED_MODULE_4__["Observer"], null,
      () =>
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react_window__WEBPACK_IMPORTED_MODULE_2__["VariableSizeList"], {
          height: height,
          itemCount: this.props.store.eventCount,
          itemSize: this.getItemSize,
          width: width,
          ref: ref => {this.listRef = ref;},
          onItemsRendered: this.onItemsRendered,
          onScroll: this.callOnScroll },

        lister));





    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: classnames__WEBPACK_IMPORTED_MODULE_5___default()('console-list', { 'is-disabled': this.props.store.isLoading }) },

        !this.props.store.hasLogs ?
        this.renderEmptyState() :
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react_virtualized_auto_sizer__WEBPACK_IMPORTED_MODULE_3__["default"], null, sizer)));



  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5852:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(global) {/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);


/**
 * Detect Element Resize.
 * https://github.com/sdecima/javascript-detect-element-resize
 * Sebastian Decima
 *
 * Forked from version 0.5.3; includes the following modifications:
 * 1) Guard against unsafe 'window' and 'document' references (to support SSR).
 * 2) Defer initialization code via a top-level function wrapper (to support SSR).
 * 3) Avoid unnecessary reflows by not measuring size for scroll events bubbling from children.
 * 4) Add nonce for style element.
 **/

function createDetectElementResize(nonce) {
  // Check `document` and `window` in case of server-side rendering
  var _window;
  if (typeof window !== 'undefined') {
    _window = window;
  } else if (typeof self !== 'undefined') {
    _window = self;
  } else {
    _window = global;
  }

  var attachEvent = typeof document !== 'undefined' && document.attachEvent;

  if (!attachEvent) {
    var requestFrame = function () {
      var raf = _window.requestAnimationFrame || _window.mozRequestAnimationFrame || _window.webkitRequestAnimationFrame || function (fn) {
        return _window.setTimeout(fn, 20);
      };
      return function (fn) {
        return raf(fn);
      };
    }();

    var cancelFrame = function () {
      var cancel = _window.cancelAnimationFrame || _window.mozCancelAnimationFrame || _window.webkitCancelAnimationFrame || _window.clearTimeout;
      return function (id) {
        return cancel(id);
      };
    }();

    var resetTriggers = function resetTriggers(element) {
      var triggers = element.__resizeTriggers__,
          expand = triggers.firstElementChild,
          contract = triggers.lastElementChild,
          expandChild = expand.firstElementChild;
      contract.scrollLeft = contract.scrollWidth;
      contract.scrollTop = contract.scrollHeight;
      expandChild.style.width = expand.offsetWidth + 1 + 'px';
      expandChild.style.height = expand.offsetHeight + 1 + 'px';
      expand.scrollLeft = expand.scrollWidth;
      expand.scrollTop = expand.scrollHeight;
    };

    var checkTriggers = function checkTriggers(element) {
      return element.offsetWidth != element.__resizeLast__.width || element.offsetHeight != element.__resizeLast__.height;
    };

    var scrollListener = function scrollListener(e) {
      // Don't measure (which forces) reflow for scrolls that happen inside of children!
      if (e.target.className.indexOf('contract-trigger') < 0 && e.target.className.indexOf('expand-trigger') < 0) {
        return;
      }

      var element = this;
      resetTriggers(this);
      if (this.__resizeRAF__) {
        cancelFrame(this.__resizeRAF__);
      }
      this.__resizeRAF__ = requestFrame(function () {
        if (checkTriggers(element)) {
          element.__resizeLast__.width = element.offsetWidth;
          element.__resizeLast__.height = element.offsetHeight;
          element.__resizeListeners__.forEach(function (fn) {
            fn.call(element, e);
          });
        }
      });
    };

    /* Detect CSS Animations support to detect element display/re-attach */
    var animation = false,
        keyframeprefix = '',
        animationstartevent = 'animationstart',
        domPrefixes = 'Webkit Moz O ms'.split(' '),
        startEvents = 'webkitAnimationStart animationstart oAnimationStart MSAnimationStart'.split(' '),
        pfx = '';
    {
      var elm = document.createElement('fakeelement');
      if (elm.style.animationName !== undefined) {
        animation = true;
      }

      if (animation === false) {
        for (var i = 0; i < domPrefixes.length; i++) {
          if (elm.style[domPrefixes[i] + 'AnimationName'] !== undefined) {
            pfx = domPrefixes[i];
            keyframeprefix = '-' + pfx.toLowerCase() + '-';
            animationstartevent = startEvents[i];
            animation = true;
            break;
          }
        }
      }
    }

    var animationName = 'resizeanim';
    var animationKeyframes = '@' + keyframeprefix + 'keyframes ' + animationName + ' { from { opacity: 0; } to { opacity: 0; } } ';
    var animationStyle = keyframeprefix + 'animation: 1ms ' + animationName + '; ';
  }

  var createStyles = function createStyles(doc) {
    if (!doc.getElementById('detectElementResize')) {
      //opacity:0 works around a chrome bug https://code.google.com/p/chromium/issues/detail?id=286360
      var css = (animationKeyframes ? animationKeyframes : '') + '.resize-triggers { ' + (animationStyle ? animationStyle : '') + 'visibility: hidden; opacity: 0; } ' + '.resize-triggers, .resize-triggers > div, .contract-trigger:before { content: " "; display: block; position: absolute; top: 0; left: 0; height: 100%; width: 100%; overflow: hidden; z-index: -1; } .resize-triggers > div { background: #eee; overflow: auto; } .contract-trigger:before { width: 200%; height: 200%; }',
          head = doc.head || doc.getElementsByTagName('head')[0],
          style = doc.createElement('style');

      style.id = 'detectElementResize';
      style.type = 'text/css';

      if (nonce != null) {
        style.setAttribute('nonce', nonce);
      }

      if (style.styleSheet) {
        style.styleSheet.cssText = css;
      } else {
        style.appendChild(doc.createTextNode(css));
      }

      head.appendChild(style);
    }
  };

  var addResizeListener = function addResizeListener(element, fn) {
    if (attachEvent) {
      element.attachEvent('onresize', fn);
    } else {
      if (!element.__resizeTriggers__) {
        var doc = element.ownerDocument;
        var elementStyle = _window.getComputedStyle(element);
        if (elementStyle && elementStyle.position == 'static') {
          element.style.position = 'relative';
        }
        createStyles(doc);
        element.__resizeLast__ = {};
        element.__resizeListeners__ = [];
        (element.__resizeTriggers__ = doc.createElement('div')).className = 'resize-triggers';
        element.__resizeTriggers__.innerHTML = '<div class="expand-trigger"><div></div></div>' + '<div class="contract-trigger"></div>';
        element.appendChild(element.__resizeTriggers__);
        resetTriggers(element);
        element.addEventListener('scroll', scrollListener, true);

        /* Listen for a css animation to detect element display/re-attach */
        if (animationstartevent) {
          element.__resizeTriggers__.__animationListener__ = function animationListener(e) {
            if (e.animationName == animationName) {
              resetTriggers(element);
            }
          };
          element.__resizeTriggers__.addEventListener(animationstartevent, element.__resizeTriggers__.__animationListener__);
        }
      }
      element.__resizeListeners__.push(fn);
    }
  };

  var removeResizeListener = function removeResizeListener(element, fn) {
    if (attachEvent) {
      element.detachEvent('onresize', fn);
    } else {
      element.__resizeListeners__.splice(element.__resizeListeners__.indexOf(fn), 1);
      if (!element.__resizeListeners__.length) {
        element.removeEventListener('scroll', scrollListener, true);
        if (element.__resizeTriggers__.__animationListener__) {
          element.__resizeTriggers__.removeEventListener(animationstartevent, element.__resizeTriggers__.__animationListener__);
          element.__resizeTriggers__.__animationListener__ = null;
        }
        try {
          element.__resizeTriggers__ = !element.removeChild(element.__resizeTriggers__);
        } catch (e) {
          // Preact compat; see developit/preact-compat/issues/228
        }
      }
    }
  };

  return {
    addResizeListener: addResizeListener,
    removeResizeListener: removeResizeListener
  };
}

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var AutoSizer = function (_React$PureComponent) {
  inherits(AutoSizer, _React$PureComponent);

  function AutoSizer() {
    var _ref;

    var _temp, _this, _ret;

    classCallCheck(this, AutoSizer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = AutoSizer.__proto__ || Object.getPrototypeOf(AutoSizer)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      height: _this.props.defaultHeight || 0,
      width: _this.props.defaultWidth || 0
    }, _this._onResize = function () {
      var _this$props = _this.props,
          disableHeight = _this$props.disableHeight,
          disableWidth = _this$props.disableWidth,
          onResize = _this$props.onResize;


      if (_this._parentNode) {
        // Guard against AutoSizer component being removed from the DOM immediately after being added.
        // This can result in invalid style values which can result in NaN values if we don't handle them.
        // See issue #150 for more context.

        var _height = _this._parentNode.offsetHeight || 0;
        var _width = _this._parentNode.offsetWidth || 0;

        var _style = window.getComputedStyle(_this._parentNode) || {};
        var paddingLeft = parseInt(_style.paddingLeft, 10) || 0;
        var paddingRight = parseInt(_style.paddingRight, 10) || 0;
        var paddingTop = parseInt(_style.paddingTop, 10) || 0;
        var paddingBottom = parseInt(_style.paddingBottom, 10) || 0;

        var newHeight = _height - paddingTop - paddingBottom;
        var newWidth = _width - paddingLeft - paddingRight;

        if (!disableHeight && _this.state.height !== newHeight || !disableWidth && _this.state.width !== newWidth) {
          _this.setState({
            height: _height - paddingTop - paddingBottom,
            width: _width - paddingLeft - paddingRight
          });

          onResize({ height: _height, width: _width });
        }
      }
    }, _this._setRef = function (autoSizer) {
      _this._autoSizer = autoSizer;
    }, _temp), possibleConstructorReturn(_this, _ret);
  }

  createClass(AutoSizer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var nonce = this.props.nonce;

      if (this._autoSizer && this._autoSizer.parentNode && this._autoSizer.parentNode.ownerDocument && this._autoSizer.parentNode.ownerDocument.defaultView && this._autoSizer.parentNode instanceof this._autoSizer.parentNode.ownerDocument.defaultView.HTMLElement) {
        // Delay access of parentNode until mount.
        // This handles edge-cases where the component has already been unmounted before its ref has been set,
        // As well as libraries like react-lite which have a slightly different lifecycle.
        this._parentNode = this._autoSizer.parentNode;

        // Defer requiring resize handler in order to support server-side rendering.
        // See issue #41
        this._detectElementResize = createDetectElementResize(nonce);
        this._detectElementResize.addResizeListener(this._parentNode, this._onResize);

        this._onResize();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this._detectElementResize && this._parentNode) {
        this._detectElementResize.removeResizeListener(this._parentNode, this._onResize);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          className = _props.className,
          disableHeight = _props.disableHeight,
          disableWidth = _props.disableWidth,
          style = _props.style;
      var _state = this.state,
          height = _state.height,
          width = _state.width;

      // Outer div should not force width/height since that may prevent containers from shrinking.
      // Inner component should overflow and use calculated width/height.
      // See issue #68 for more information.

      var outerStyle = { overflow: 'visible' };
      var childParams = {};

      // Avoid rendering children before the initial measurements have been collected.
      // At best this would just be wasting cycles.
      var bailoutOnChildren = false;

      if (!disableHeight) {
        if (height === 0) {
          bailoutOnChildren = true;
        }
        outerStyle.height = 0;
        childParams.height = height;
      }

      if (!disableWidth) {
        if (width === 0) {
          bailoutOnChildren = true;
        }
        outerStyle.width = 0;
        childParams.width = width;
      }

      return Object(react__WEBPACK_IMPORTED_MODULE_0__["createElement"])(
        'div',
        {
          className: className,
          ref: this._setRef,
          style: _extends({}, outerStyle, style) },
        !bailoutOnChildren && children(childParams)
      );
    }
  }]);
  return AutoSizer;
}(react__WEBPACK_IMPORTED_MODULE_0__["PureComponent"]);

AutoSizer.defaultProps = {
  onResize: function onResize() {},
  disableHeight: false,
  disableWidth: false,
  style: {}
};

/* harmony default export */ __webpack_exports__["default"] = (AutoSizer);

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(19)))

/***/ }),

/***/ 5853:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleListItem; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2929);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var moment__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2703);
/* harmony import */ var moment__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(moment__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _ConsoleMessageItem__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(5854);
/* harmony import */ var _ConsoleNetworkItem_ConsoleNetworkItem__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(5998);
/* harmony import */ var _js_components_base_Icons_LockedIcon__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(6003);
/* harmony import */ var _js_components_base_Icons_ErrorIcon__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(3232);
/* harmony import */ var _js_components_base_Icons_WarningIcon__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(3225);
/* harmony import */ var _js_components_base_Icons_InformationIcon__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(3231);
/* harmony import */ var _js_components_base_Icons_RedirectIcon__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(6004);
/* harmony import */ var _js_components_base_Icons_CodeIcon__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(6005);
/* harmony import */ var _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(731);
var _class;
















let



ConsoleListItem = Object(mobx_react__WEBPACK_IMPORTED_MODULE_2__["observer"])(_class = class ConsoleListItem extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  componentDidMount() {
    this.selfNode = Object(react_dom__WEBPACK_IMPORTED_MODULE_1__["findDOMNode"])(this);

    // Starts observing element
    this.props.observeSizeChange && this.props.observeSizeChange(this.selfNode);
  }

  shouldComponentUpdate(nextProps) {
    // If showTimestamp modifier has changed then update the component
    if (this.props.showTimestamp !== nextProps.showTimestamp) {
      return true;
    }

    // If expanded state has not changed do not update
    if (this.props.isExpanded !== nextProps.isExpanded) {
      return true;
    }

    return false;
  }

  componentWillUnmount() {
    this.props.observeSizeChange && this.props.unobserveSizeChange(this.selfNode);
  }

  getLeftIcon(severity) {
    if (severity === _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_13__["CONSOLE_LEVEL_ERROR"]) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_ErrorIcon__WEBPACK_IMPORTED_MODULE_8__["default"], {
          size: 'xs',
          title: 'Error',
          className: 'c-li__icon c-li__icon--error' }));


    }

    if (severity === _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_13__["CONSOLE_LEVEL_WARN"]) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_WarningIcon__WEBPACK_IMPORTED_MODULE_9__["default"], {
          size: 'xs',
          title: 'Warning',
          className: 'c-li__icon c-li__icon--warning' }));


    }

    if (severity === _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_13__["CONSOLE_LEVEL_INFO"]) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_InformationIcon__WEBPACK_IMPORTED_MODULE_10__["default"], {
          size: 'xs',
          title: 'Info',
          className: 'c-li__icon c-li__icon--info' }));


    }

    return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { title: 'Log', className: 'c-li__icon empty' }, '\xA0');
  }

  getRightIcon(details) {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,

        details.redirect &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_RedirectIcon__WEBPACK_IMPORTED_MODULE_11__["default"], {
          size: 'xs',
          title: 'This request was triggered on redirect',
          className: 'c-li__icon c-li__redirect-icon' }),




        details.indirect === 'request' &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_CodeIcon__WEBPACK_IMPORTED_MODULE_12__["default"], {
          size: 'xs',
          title: 'This request was triggered by a function in your script',
          className: 'c-li__icon c-li__code-icon' }),




        details.indirect === 'auth' &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_LockedIcon__WEBPACK_IMPORTED_MODULE_7__["default"], {
          size: 'xs',
          title: 'This request was triggered by an authorization helper',
          className: 'c-li__icon c-li__lock-icon' })));





  }

  getDetails(event) {
    if (event.type === 'log') {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__msg-wrap' },

          _.map(event.details, (message, index) =>
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleMessageItem__WEBPACK_IMPORTED_MODULE_5__["default"], {
            message: message,
            key: index }))));





    }

    if (event.type === 'network') {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleNetworkItem_ConsoleNetworkItem__WEBPACK_IMPORTED_MODULE_6__["default"], {
          data: event.details,
          severity: event.severity,
          isExpanded: this.props.isExpanded,
          toggleExpanded: this.props.toggleExpanded,
          viewLargeBody: this.props.viewLargeBody,
          id: event.id // So that the NetworkItem knows which Blob to load
        }));

    }

    if (event.type === 'exception') {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleMessageItem__WEBPACK_IMPORTED_MODULE_5__["default"], {
          message: `${_.get(event, 'details.name', 'Error')}: ${_.get(event, 'details.message', '')}` }));


    }
  }

  render() {
    const severity = _.get(this.props, 'event.severity'),
    listItemClass = classnames__WEBPACK_IMPORTED_MODULE_3___default()('c-flex', {
      'is-error': severity === _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_13__["CONSOLE_LEVEL_ERROR"],
      'is-warning': severity === _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_13__["CONSOLE_LEVEL_WARN"],
      'is-log': severity === _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_13__["CONSOLE_LEVEL_LOG"],
      'is-info': severity === _constants_ConsoleEventSeverity__WEBPACK_IMPORTED_MODULE_13__["CONSOLE_LEVEL_INFO"],
      'is-indirect': !!(_.get(this.props, 'event.details.redirect') || _.get(this.props, 'event.details.indirect')) });


    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: listItemClass, 'data-index': this.props.index },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'c-flex__left' },

          this.getLeftIcon(severity),


          this.props.showTimestamp &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'c-li__timestamp' },
            moment__WEBPACK_IMPORTED_MODULE_4___default()(this.props.event.timestamp).format('HH:mm:ss.SSS')),




          this.getDetails(this.props.event)),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'c-flex__right' },

          this.getRightIcon(_.get(this.props, 'event.details', {})))));




  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5854:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleMessageItem; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_inspector__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5855);
/* harmony import */ var react_inspector__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_inspector__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _provider_ObjectInspector_styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5991);
/* harmony import */ var _provider_ObjectInspector_object_ObjectRootLabel__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5992);
/* harmony import */ var _provider_ObjectInspector_ObjectLabel__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5997);
/* harmony import */ var _provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(5996);







let

ConsoleMessageItem = class ConsoleMessageItem extends react__WEBPACK_IMPORTED_MODULE_0__["PureComponent"] {
  getMessage(message) {
    if (message === '') {
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: 0, className: 'c-li__empty', title: 'Empty String' });
    }

    const isStr = typeof message === 'string',
    splitMessage = String(message).split('\n'),
    isOnlyNewlines = isStr && splitMessage.length > message.length,
    isSingularString = isStr && splitMessage.length === 1;

    splitMessage[0] =
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: 'spch-0', className: 'c-li__msg-str' },
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_5__["default"], {
        quoteStart: isStr,
        quoteEnd: isSingularString,
        key: 'wf-0',
        sentence: splitMessage[0] }));




    for (let i = 1; i < splitMessage.length; i++) {
      splitMessage[i] =
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, { key: i },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: `spfl-${i}`, className: 'c-li__r-fill' }),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: `spch-${i}`, className: 'c-li__msg-str' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_5__["default"], {
            key: `wf-${i}`,
            sentence: splitMessage[i],
            quoteEnd: isStr && i === splitMessage.length - 1 })));




    }

    if (isOnlyNewlines) {
      splitMessage[splitMessage.length - 1] =
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
        isStr && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_5__["default"], { quoteEnd: true }),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: 'spfl__last', className: 'c-li__r-fill' }));


    }

    return splitMessage;
  }

  getTheme() {
    return _.defaults({ TREENODE_PADDING_LEFT: 15 }, _provider_ObjectInspector_styles__WEBPACK_IMPORTED_MODULE_2__["baseStyles"]);
  }

  nodeRenderer({
    depth, name, data, isNonenumerable, shouldShowArrow })
  {
    let styles;

    if (shouldShowArrow) {
      styles = { cursor: 'pointer' };
    }

    if (depth === 0) {
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: styles }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_ObjectInspector_object_ObjectRootLabel__WEBPACK_IMPORTED_MODULE_3__["default"], { name: name, data: data }));
    }

    return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_ObjectInspector_ObjectLabel__WEBPACK_IMPORTED_MODULE_4__["default"], { name: name, data: data, isNonenumerable: isNonenumerable, styles: styles });
  }

  render() {
    if (_.isObject(this.props.message)) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'c-li__msg-obj' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react_inspector__WEBPACK_IMPORTED_MODULE_1___default.a, {
            data: this.props.message,
            theme: this.getTheme(),
            nodeRenderer: this.nodeRenderer,
            sortObjectKeys: false })));



    }

    return this.getMessage(this.props.message);
  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5855:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Inspector = exports.ObjectName = exports.ObjectValue = exports.ObjectRootLabel = exports.ObjectLabel = exports.DOMInspector = exports.TableInspector = exports.ObjectInspector = exports.chromeDark = exports.chromeLight = undefined;

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = __webpack_require__(5895);

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _themes = __webpack_require__(5896);

Object.defineProperty(exports, 'chromeLight', {
  enumerable: true,
  get: function get() {
    return _themes.chromeLight;
  }
});
Object.defineProperty(exports, 'chromeDark', {
  enumerable: true,
  get: function get() {
    return _themes.chromeDark;
  }
});

var _ObjectInspector2 = __webpack_require__(5899);

var _ObjectInspector3 = _interopRequireDefault(_ObjectInspector2);

var _TableInspector2 = __webpack_require__(5972);

var _TableInspector3 = _interopRequireDefault(_TableInspector2);

var _DOMInspector2 = __webpack_require__(5985);

var _DOMInspector3 = _interopRequireDefault(_DOMInspector2);

var _ObjectLabel2 = __webpack_require__(5970);

var _ObjectLabel3 = _interopRequireDefault(_ObjectLabel2);

var _ObjectRootLabel2 = __webpack_require__(5966);

var _ObjectRootLabel3 = _interopRequireDefault(_ObjectRootLabel2);

var _ObjectValue2 = __webpack_require__(5969);

var _ObjectValue3 = _interopRequireDefault(_ObjectValue2);

var _ObjectName2 = __webpack_require__(5967);

var _ObjectName3 = _interopRequireDefault(_ObjectName2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isDom = __webpack_require__(5988);

var _isDom2 = _interopRequireDefault(_isDom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.ObjectInspector = _ObjectInspector3.default;
exports.TableInspector = _TableInspector3.default;
exports.DOMInspector = _DOMInspector3.default;
exports.ObjectLabel = _ObjectLabel3.default;
exports.ObjectRootLabel = _ObjectRootLabel3.default;
exports.ObjectValue = _ObjectValue3.default;
exports.ObjectName = _ObjectName3.default;

// Wrapping the inspectors

var Inspector = function Inspector(_ref) {
  var _ref$table = _ref.table,
      table = _ref$table === undefined ? false : _ref$table,
      data = _ref.data,
      rest = (0, _objectWithoutProperties3.default)(_ref, ['table', 'data']);

  if (table) {
    return _react2.default.createElement(_TableInspector3.default, (0, _extends3.default)({ data: data }, rest));
  }

  if ((0, _isDom2.default)(data)) return _react2.default.createElement(_DOMInspector3.default, (0, _extends3.default)({ data: data }, rest));

  return _react2.default.createElement(_ObjectInspector3.default, (0, _extends3.default)({ data: data }, rest));
};

Inspector.propTypes = {
  data: _propTypes2.default.any,
  name: _propTypes2.default.string,
  table: _propTypes2.default.bool
};

exports.Inspector = Inspector;
exports.default = Inspector;

/***/ }),

/***/ 5856:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _assign = __webpack_require__(5857);

var _assign2 = _interopRequireDefault(_assign);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = _assign2.default || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

/***/ }),

/***/ 5857:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5858), __esModule: true };

/***/ }),

/***/ 5858:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5859);
module.exports = __webpack_require__(5862).Object.assign;


/***/ }),

/***/ 5859:
/***/ (function(module, exports, __webpack_require__) {

// 19.1.3.1 Object.assign(target, source)
var $export = __webpack_require__(5860);

$export($export.S + $export.F, 'Object', { assign: __webpack_require__(5876) });


/***/ }),

/***/ 5860:
/***/ (function(module, exports, __webpack_require__) {

var global = __webpack_require__(5861);
var core = __webpack_require__(5862);
var ctx = __webpack_require__(5863);
var hide = __webpack_require__(5865);
var has = __webpack_require__(5875);
var PROTOTYPE = 'prototype';

var $export = function (type, name, source) {
  var IS_FORCED = type & $export.F;
  var IS_GLOBAL = type & $export.G;
  var IS_STATIC = type & $export.S;
  var IS_PROTO = type & $export.P;
  var IS_BIND = type & $export.B;
  var IS_WRAP = type & $export.W;
  var exports = IS_GLOBAL ? core : core[name] || (core[name] = {});
  var expProto = exports[PROTOTYPE];
  var target = IS_GLOBAL ? global : IS_STATIC ? global[name] : (global[name] || {})[PROTOTYPE];
  var key, own, out;
  if (IS_GLOBAL) source = name;
  for (key in source) {
    // contains in native
    own = !IS_FORCED && target && target[key] !== undefined;
    if (own && has(exports, key)) continue;
    // export native or passed
    out = own ? target[key] : source[key];
    // prevent global pollution for namespaces
    exports[key] = IS_GLOBAL && typeof target[key] != 'function' ? source[key]
    // bind timers to global for call from export context
    : IS_BIND && own ? ctx(out, global)
    // wrap global constructors for prevent change them in library
    : IS_WRAP && target[key] == out ? (function (C) {
      var F = function (a, b, c) {
        if (this instanceof C) {
          switch (arguments.length) {
            case 0: return new C();
            case 1: return new C(a);
            case 2: return new C(a, b);
          } return new C(a, b, c);
        } return C.apply(this, arguments);
      };
      F[PROTOTYPE] = C[PROTOTYPE];
      return F;
    // make static versions for prototype methods
    })(out) : IS_PROTO && typeof out == 'function' ? ctx(Function.call, out) : out;
    // export proto methods to core.%CONSTRUCTOR%.methods.%NAME%
    if (IS_PROTO) {
      (exports.virtual || (exports.virtual = {}))[key] = out;
      // export proto methods to core.%CONSTRUCTOR%.prototype.%NAME%
      if (type & $export.R && expProto && !expProto[key]) hide(expProto, key, out);
    }
  }
};
// type bitmap
$export.F = 1;   // forced
$export.G = 2;   // global
$export.S = 4;   // static
$export.P = 8;   // proto
$export.B = 16;  // bind
$export.W = 32;  // wrap
$export.U = 64;  // safe
$export.R = 128; // real proto method for `library`
module.exports = $export;


/***/ }),

/***/ 5861:
/***/ (function(module, exports) {

// https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
var global = module.exports = typeof window != 'undefined' && window.Math == Math
  ? window : typeof self != 'undefined' && self.Math == Math ? self
  // eslint-disable-next-line no-new-func
  : Function('return this')();
if (typeof __g == 'number') __g = global; // eslint-disable-line no-undef


/***/ }),

/***/ 5862:
/***/ (function(module, exports) {

var core = module.exports = { version: '2.6.11' };
if (typeof __e == 'number') __e = core; // eslint-disable-line no-undef


/***/ }),

/***/ 5863:
/***/ (function(module, exports, __webpack_require__) {

// optional / simple context binding
var aFunction = __webpack_require__(5864);
module.exports = function (fn, that, length) {
  aFunction(fn);
  if (that === undefined) return fn;
  switch (length) {
    case 1: return function (a) {
      return fn.call(that, a);
    };
    case 2: return function (a, b) {
      return fn.call(that, a, b);
    };
    case 3: return function (a, b, c) {
      return fn.call(that, a, b, c);
    };
  }
  return function (/* ...args */) {
    return fn.apply(that, arguments);
  };
};


/***/ }),

/***/ 5864:
/***/ (function(module, exports) {

module.exports = function (it) {
  if (typeof it != 'function') throw TypeError(it + ' is not a function!');
  return it;
};


/***/ }),

/***/ 5865:
/***/ (function(module, exports, __webpack_require__) {

var dP = __webpack_require__(5866);
var createDesc = __webpack_require__(5874);
module.exports = __webpack_require__(5870) ? function (object, key, value) {
  return dP.f(object, key, createDesc(1, value));
} : function (object, key, value) {
  object[key] = value;
  return object;
};


/***/ }),

/***/ 5866:
/***/ (function(module, exports, __webpack_require__) {

var anObject = __webpack_require__(5867);
var IE8_DOM_DEFINE = __webpack_require__(5869);
var toPrimitive = __webpack_require__(5873);
var dP = Object.defineProperty;

exports.f = __webpack_require__(5870) ? Object.defineProperty : function defineProperty(O, P, Attributes) {
  anObject(O);
  P = toPrimitive(P, true);
  anObject(Attributes);
  if (IE8_DOM_DEFINE) try {
    return dP(O, P, Attributes);
  } catch (e) { /* empty */ }
  if ('get' in Attributes || 'set' in Attributes) throw TypeError('Accessors not supported!');
  if ('value' in Attributes) O[P] = Attributes.value;
  return O;
};


/***/ }),

/***/ 5867:
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(5868);
module.exports = function (it) {
  if (!isObject(it)) throw TypeError(it + ' is not an object!');
  return it;
};


/***/ }),

/***/ 5868:
/***/ (function(module, exports) {

module.exports = function (it) {
  return typeof it === 'object' ? it !== null : typeof it === 'function';
};


/***/ }),

/***/ 5869:
/***/ (function(module, exports, __webpack_require__) {

module.exports = !__webpack_require__(5870) && !__webpack_require__(5871)(function () {
  return Object.defineProperty(__webpack_require__(5872)('div'), 'a', { get: function () { return 7; } }).a != 7;
});


/***/ }),

/***/ 5870:
/***/ (function(module, exports, __webpack_require__) {

// Thank's IE8 for his funny defineProperty
module.exports = !__webpack_require__(5871)(function () {
  return Object.defineProperty({}, 'a', { get: function () { return 7; } }).a != 7;
});


/***/ }),

/***/ 5871:
/***/ (function(module, exports) {

module.exports = function (exec) {
  try {
    return !!exec();
  } catch (e) {
    return true;
  }
};


/***/ }),

/***/ 5872:
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(5868);
var document = __webpack_require__(5861).document;
// typeof document.createElement is 'object' in old IE
var is = isObject(document) && isObject(document.createElement);
module.exports = function (it) {
  return is ? document.createElement(it) : {};
};


/***/ }),

/***/ 5873:
/***/ (function(module, exports, __webpack_require__) {

// 7.1.1 ToPrimitive(input [, PreferredType])
var isObject = __webpack_require__(5868);
// instead of the ES6 spec version, we didn't implement @@toPrimitive case
// and the second argument - flag - preferred type is a string
module.exports = function (it, S) {
  if (!isObject(it)) return it;
  var fn, val;
  if (S && typeof (fn = it.toString) == 'function' && !isObject(val = fn.call(it))) return val;
  if (typeof (fn = it.valueOf) == 'function' && !isObject(val = fn.call(it))) return val;
  if (!S && typeof (fn = it.toString) == 'function' && !isObject(val = fn.call(it))) return val;
  throw TypeError("Can't convert object to primitive value");
};


/***/ }),

/***/ 5874:
/***/ (function(module, exports) {

module.exports = function (bitmap, value) {
  return {
    enumerable: !(bitmap & 1),
    configurable: !(bitmap & 2),
    writable: !(bitmap & 4),
    value: value
  };
};


/***/ }),

/***/ 5875:
/***/ (function(module, exports) {

var hasOwnProperty = {}.hasOwnProperty;
module.exports = function (it, key) {
  return hasOwnProperty.call(it, key);
};


/***/ }),

/***/ 5876:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

// 19.1.2.1 Object.assign(target, source, ...)
var DESCRIPTORS = __webpack_require__(5870);
var getKeys = __webpack_require__(5877);
var gOPS = __webpack_require__(5892);
var pIE = __webpack_require__(5893);
var toObject = __webpack_require__(5894);
var IObject = __webpack_require__(5880);
var $assign = Object.assign;

// should work with symbols and should have deterministic property order (V8 bug)
module.exports = !$assign || __webpack_require__(5871)(function () {
  var A = {};
  var B = {};
  // eslint-disable-next-line no-undef
  var S = Symbol();
  var K = 'abcdefghijklmnopqrst';
  A[S] = 7;
  K.split('').forEach(function (k) { B[k] = k; });
  return $assign({}, A)[S] != 7 || Object.keys($assign({}, B)).join('') != K;
}) ? function assign(target, source) { // eslint-disable-line no-unused-vars
  var T = toObject(target);
  var aLen = arguments.length;
  var index = 1;
  var getSymbols = gOPS.f;
  var isEnum = pIE.f;
  while (aLen > index) {
    var S = IObject(arguments[index++]);
    var keys = getSymbols ? getKeys(S).concat(getSymbols(S)) : getKeys(S);
    var length = keys.length;
    var j = 0;
    var key;
    while (length > j) {
      key = keys[j++];
      if (!DESCRIPTORS || isEnum.call(S, key)) T[key] = S[key];
    }
  } return T;
} : $assign;


/***/ }),

/***/ 5877:
/***/ (function(module, exports, __webpack_require__) {

// 19.1.2.14 / 15.2.3.14 Object.keys(O)
var $keys = __webpack_require__(5878);
var enumBugKeys = __webpack_require__(5891);

module.exports = Object.keys || function keys(O) {
  return $keys(O, enumBugKeys);
};


/***/ }),

/***/ 5878:
/***/ (function(module, exports, __webpack_require__) {

var has = __webpack_require__(5875);
var toIObject = __webpack_require__(5879);
var arrayIndexOf = __webpack_require__(5883)(false);
var IE_PROTO = __webpack_require__(5887)('IE_PROTO');

module.exports = function (object, names) {
  var O = toIObject(object);
  var i = 0;
  var result = [];
  var key;
  for (key in O) if (key != IE_PROTO) has(O, key) && result.push(key);
  // Don't enum bug & hidden keys
  while (names.length > i) if (has(O, key = names[i++])) {
    ~arrayIndexOf(result, key) || result.push(key);
  }
  return result;
};


/***/ }),

/***/ 5879:
/***/ (function(module, exports, __webpack_require__) {

// to indexed object, toObject with fallback for non-array-like ES3 strings
var IObject = __webpack_require__(5880);
var defined = __webpack_require__(5882);
module.exports = function (it) {
  return IObject(defined(it));
};


/***/ }),

/***/ 5880:
/***/ (function(module, exports, __webpack_require__) {

// fallback for non-array-like ES3 and non-enumerable old V8 strings
var cof = __webpack_require__(5881);
// eslint-disable-next-line no-prototype-builtins
module.exports = Object('z').propertyIsEnumerable(0) ? Object : function (it) {
  return cof(it) == 'String' ? it.split('') : Object(it);
};


/***/ }),

/***/ 5881:
/***/ (function(module, exports) {

var toString = {}.toString;

module.exports = function (it) {
  return toString.call(it).slice(8, -1);
};


/***/ }),

/***/ 5882:
/***/ (function(module, exports) {

// 7.2.1 RequireObjectCoercible(argument)
module.exports = function (it) {
  if (it == undefined) throw TypeError("Can't call method on  " + it);
  return it;
};


/***/ }),

/***/ 5883:
/***/ (function(module, exports, __webpack_require__) {

// false -> Array#indexOf
// true  -> Array#includes
var toIObject = __webpack_require__(5879);
var toLength = __webpack_require__(5884);
var toAbsoluteIndex = __webpack_require__(5886);
module.exports = function (IS_INCLUDES) {
  return function ($this, el, fromIndex) {
    var O = toIObject($this);
    var length = toLength(O.length);
    var index = toAbsoluteIndex(fromIndex, length);
    var value;
    // Array#includes uses SameValueZero equality algorithm
    // eslint-disable-next-line no-self-compare
    if (IS_INCLUDES && el != el) while (length > index) {
      value = O[index++];
      // eslint-disable-next-line no-self-compare
      if (value != value) return true;
    // Array#indexOf ignores holes, Array#includes - not
    } else for (;length > index; index++) if (IS_INCLUDES || index in O) {
      if (O[index] === el) return IS_INCLUDES || index || 0;
    } return !IS_INCLUDES && -1;
  };
};


/***/ }),

/***/ 5884:
/***/ (function(module, exports, __webpack_require__) {

// 7.1.15 ToLength
var toInteger = __webpack_require__(5885);
var min = Math.min;
module.exports = function (it) {
  return it > 0 ? min(toInteger(it), 0x1fffffffffffff) : 0; // pow(2, 53) - 1 == 9007199254740991
};


/***/ }),

/***/ 5885:
/***/ (function(module, exports) {

// 7.1.4 ToInteger
var ceil = Math.ceil;
var floor = Math.floor;
module.exports = function (it) {
  return isNaN(it = +it) ? 0 : (it > 0 ? floor : ceil)(it);
};


/***/ }),

/***/ 5886:
/***/ (function(module, exports, __webpack_require__) {

var toInteger = __webpack_require__(5885);
var max = Math.max;
var min = Math.min;
module.exports = function (index, length) {
  index = toInteger(index);
  return index < 0 ? max(index + length, 0) : min(index, length);
};


/***/ }),

/***/ 5887:
/***/ (function(module, exports, __webpack_require__) {

var shared = __webpack_require__(5888)('keys');
var uid = __webpack_require__(5890);
module.exports = function (key) {
  return shared[key] || (shared[key] = uid(key));
};


/***/ }),

/***/ 5888:
/***/ (function(module, exports, __webpack_require__) {

var core = __webpack_require__(5862);
var global = __webpack_require__(5861);
var SHARED = '__core-js_shared__';
var store = global[SHARED] || (global[SHARED] = {});

(module.exports = function (key, value) {
  return store[key] || (store[key] = value !== undefined ? value : {});
})('versions', []).push({
  version: core.version,
  mode: __webpack_require__(5889) ? 'pure' : 'global',
  copyright: '© 2019 Denis Pushkarev (zloirock.ru)'
});


/***/ }),

/***/ 5889:
/***/ (function(module, exports) {

module.exports = true;


/***/ }),

/***/ 5890:
/***/ (function(module, exports) {

var id = 0;
var px = Math.random();
module.exports = function (key) {
  return 'Symbol('.concat(key === undefined ? '' : key, ')_', (++id + px).toString(36));
};


/***/ }),

/***/ 5891:
/***/ (function(module, exports) {

// IE 8- don't enum bug keys
module.exports = (
  'constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf'
).split(',');


/***/ }),

/***/ 5892:
/***/ (function(module, exports) {

exports.f = Object.getOwnPropertySymbols;


/***/ }),

/***/ 5893:
/***/ (function(module, exports) {

exports.f = {}.propertyIsEnumerable;


/***/ }),

/***/ 5894:
/***/ (function(module, exports, __webpack_require__) {

// 7.1.13 ToObject(argument)
var defined = __webpack_require__(5882);
module.exports = function (it) {
  return Object(defined(it));
};


/***/ }),

/***/ 5895:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

exports.default = function (obj, keys) {
  var target = {};

  for (var i in obj) {
    if (keys.indexOf(i) >= 0) continue;
    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
    target[i] = obj[i];
  }

  return target;
};

/***/ }),

/***/ 5896:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.chromeLight = exports.chromeDark = undefined;

var _chromeDark2 = __webpack_require__(5897);

var _chromeDark3 = _interopRequireDefault(_chromeDark2);

var _chromeLight2 = __webpack_require__(5898);

var _chromeLight3 = _interopRequireDefault(_chromeLight2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.chromeDark = _chromeDark3.default;
exports.chromeLight = _chromeLight3.default;

/***/ }),

/***/ 5897:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var theme = {
  BASE_FONT_FAMILY: 'Menlo, monospace',
  BASE_FONT_SIZE: '11px',
  BASE_LINE_HEIGHT: '14px',

  BASE_BACKGROUND_COLOR: 'rgb(36, 36, 36)',
  BASE_COLOR: 'rgb(213, 213, 213)',

  OBJECT_NAME_COLOR: 'rgb(227, 110, 236)',
  OBJECT_VALUE_NULL_COLOR: 'rgb(127, 127, 127)',
  OBJECT_VALUE_UNDEFINED_COLOR: 'rgb(127, 127, 127)',
  OBJECT_VALUE_REGEXP_COLOR: 'rgb(233, 63, 59)',
  OBJECT_VALUE_STRING_COLOR: 'rgb(233, 63, 59)',
  OBJECT_VALUE_SYMBOL_COLOR: 'rgb(233, 63, 59)',
  OBJECT_VALUE_NUMBER_COLOR: 'hsl(252, 100%, 75%)',
  OBJECT_VALUE_BOOLEAN_COLOR: 'hsl(252, 100%, 75%)',
  OBJECT_VALUE_FUNCTION_KEYWORD_COLOR: 'rgb(242, 85, 217)',

  HTML_TAG_COLOR: 'rgb(93, 176, 215)',
  HTML_TAGNAME_COLOR: 'rgb(93, 176, 215)',
  HTML_TAGNAME_TEXT_TRANSFORM: 'lowercase',
  HTML_ATTRIBUTE_NAME_COLOR: 'rgb(155, 187, 220)',
  HTML_ATTRIBUTE_VALUE_COLOR: 'rgb(242, 151, 102)',
  HTML_COMMENT_COLOR: 'rgb(137, 137, 137)',
  HTML_DOCTYPE_COLOR: 'rgb(192, 192, 192)',

  ARROW_COLOR: 'rgb(145, 145, 145)',
  ARROW_MARGIN_RIGHT: 3,
  ARROW_FONT_SIZE: 12,

  TREENODE_FONT_FAMILY: 'Menlo, monospace',
  TREENODE_FONT_SIZE: '11px',
  TREENODE_LINE_HEIGHT: '14px',
  TREENODE_PADDING_LEFT: 12,

  TABLE_BORDER_COLOR: 'rgb(85, 85, 85)',
  TABLE_TH_BACKGROUND_COLOR: 'rgb(44, 44, 44)',
  TABLE_TH_HOVER_COLOR: 'rgb(48, 48, 48)',
  TABLE_SORT_ICON_COLOR: 'black', //'rgb(48, 57, 66)',
  TABLE_DATA_BACKGROUND_IMAGE: 'linear-gradient(rgba(255, 255, 255, 0), rgba(255, 255, 255, 0) 50%, rgba(51, 139, 255, 0.0980392) 50%, rgba(51, 139, 255, 0.0980392))',
  TABLE_DATA_BACKGROUND_SIZE: '128px 32px'
};

exports.default = theme;

/***/ }),

/***/ 5898:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var theme = {
  BASE_FONT_FAMILY: 'Menlo, monospace',
  BASE_FONT_SIZE: '11px',
  BASE_LINE_HEIGHT: '14px',

  BASE_BACKGROUND_COLOR: 'white',
  BASE_COLOR: 'black',

  OBJECT_NAME_COLOR: 'rgb(136, 19, 145)',
  OBJECT_VALUE_NULL_COLOR: 'rgb(128, 128, 128)',
  OBJECT_VALUE_UNDEFINED_COLOR: 'rgb(128, 128, 128)',
  OBJECT_VALUE_REGEXP_COLOR: 'rgb(196, 26, 22)',
  OBJECT_VALUE_STRING_COLOR: 'rgb(196, 26, 22)',
  OBJECT_VALUE_SYMBOL_COLOR: 'rgb(196, 26, 22)',
  OBJECT_VALUE_NUMBER_COLOR: 'rgb(28, 0, 207)',
  OBJECT_VALUE_BOOLEAN_COLOR: 'rgb(28, 0, 207)',
  OBJECT_VALUE_FUNCTION_KEYWORD_COLOR: 'rgb(170, 13, 145)',

  HTML_TAG_COLOR: 'rgb(168, 148, 166)',
  HTML_TAGNAME_COLOR: 'rgb(136, 18, 128)',
  HTML_TAGNAME_TEXT_TRANSFORM: 'lowercase',
  HTML_ATTRIBUTE_NAME_COLOR: 'rgb(153, 69, 0)',
  HTML_ATTRIBUTE_VALUE_COLOR: 'rgb(26, 26, 166)',
  HTML_COMMENT_COLOR: 'rgb(35, 110, 37)',
  HTML_DOCTYPE_COLOR: 'rgb(192, 192, 192)',

  ARROW_COLOR: '#6e6e6e',
  ARROW_MARGIN_RIGHT: 3,
  ARROW_FONT_SIZE: 12,

  TREENODE_FONT_FAMILY: 'Menlo, monospace',
  TREENODE_FONT_SIZE: '11px',
  TREENODE_LINE_HEIGHT: '14px',
  TREENODE_PADDING_LEFT: 12,

  TABLE_BORDER_COLOR: '#aaa',
  TABLE_TH_BACKGROUND_COLOR: '#eee',
  TABLE_TH_HOVER_COLOR: 'hsla(0, 0%, 90%, 1)',
  TABLE_SORT_ICON_COLOR: '#6e6e6e',
  TABLE_DATA_BACKGROUND_IMAGE: 'linear-gradient(to bottom, white, white 50%, rgb(234, 243, 255) 50%, rgb(234, 243, 255))',
  TABLE_DATA_BACKGROUND_SIZE: '128px 32px'
};

exports.default = theme;

/***/ }),

/***/ 5899:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = __webpack_require__(5895);

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = __webpack_require__(5900);

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = __webpack_require__(5901);

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = __webpack_require__(5905);

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = __webpack_require__(5939);

var _inherits3 = _interopRequireDefault(_inherits2);

var _regenerator = __webpack_require__(5947);

var _regenerator2 = _interopRequireDefault(_regenerator);

var _slicedToArray2 = __webpack_require__(5950);

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TreeView = __webpack_require__(5959);

var _TreeView2 = _interopRequireDefault(_TreeView);

var _ObjectRootLabel = __webpack_require__(5966);

var _ObjectRootLabel2 = _interopRequireDefault(_ObjectRootLabel);

var _ObjectLabel = __webpack_require__(5970);

var _ObjectLabel2 = _interopRequireDefault(_ObjectLabel);

var _ThemeProvider = __webpack_require__(5971);

var _ThemeProvider2 = _interopRequireDefault(_ThemeProvider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createIterator = function createIterator(showNonenumerable, sortObjectKeys) {
  var objectIterator = /*#__PURE__*/_regenerator2.default.mark(function objectIterator(data) {
    var shouldIterate, dataIsArray, i, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, entry, _entry, k, v, keys, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, propertyName, propertyValue, _propertyValue;

    return _regenerator2.default.wrap(function objectIterator$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            shouldIterate = (typeof data === 'undefined' ? 'undefined' : (0, _typeof3.default)(data)) === 'object' && data !== null || typeof data === 'function';

            if (shouldIterate) {
              _context.next = 3;
              break;
            }

            return _context.abrupt('return');

          case 3:
            dataIsArray = Array.isArray(data);

            // iterable objects (except arrays)

            if (!(!dataIsArray && data[Symbol.iterator])) {
              _context.next = 41;
              break;
            }

            i = 0;
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context.prev = 9;
            _iterator = data[Symbol.iterator]();

          case 11:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context.next = 25;
              break;
            }

            entry = _step.value;

            if (!(Array.isArray(entry) && entry.length === 2)) {
              _context.next = 19;
              break;
            }

            _entry = (0, _slicedToArray3.default)(entry, 2), k = _entry[0], v = _entry[1];
            _context.next = 17;
            return {
              name: k,
              data: v
            };

          case 17:
            _context.next = 21;
            break;

          case 19:
            _context.next = 21;
            return {
              name: i.toString(),
              data: entry
            };

          case 21:
            i++;

          case 22:
            _iteratorNormalCompletion = true;
            _context.next = 11;
            break;

          case 25:
            _context.next = 31;
            break;

          case 27:
            _context.prev = 27;
            _context.t0 = _context['catch'](9);
            _didIteratorError = true;
            _iteratorError = _context.t0;

          case 31:
            _context.prev = 31;
            _context.prev = 32;

            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }

          case 34:
            _context.prev = 34;

            if (!_didIteratorError) {
              _context.next = 37;
              break;
            }

            throw _iteratorError;

          case 37:
            return _context.finish(34);

          case 38:
            return _context.finish(31);

          case 39:
            _context.next = 82;
            break;

          case 41:
            keys = Object.getOwnPropertyNames(data);

            if (sortObjectKeys === true && !dataIsArray) {
              // Array keys should not be sorted in alphabetical order
              keys.sort();
            } else if (typeof sortObjectKeys === 'function') {
              keys.sort(sortObjectKeys);
            }

            _iteratorNormalCompletion2 = true;
            _didIteratorError2 = false;
            _iteratorError2 = undefined;
            _context.prev = 46;
            _iterator2 = keys[Symbol.iterator]();

          case 48:
            if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
              _context.next = 65;
              break;
            }

            propertyName = _step2.value;

            if (!data.propertyIsEnumerable(propertyName)) {
              _context.next = 56;
              break;
            }

            propertyValue = data[propertyName];
            _context.next = 54;
            return {
              name: propertyName || '""',
              data: propertyValue
            };

          case 54:
            _context.next = 62;
            break;

          case 56:
            if (!showNonenumerable) {
              _context.next = 62;
              break;
            }

            // To work around the error (happens some time when propertyName === 'caller' || propertyName === 'arguments')
            // 'caller' and 'arguments' are restricted function properties and cannot be accessed in this context
            // http://stackoverflow.com/questions/31921189/caller-and-arguments-are-restricted-function-properties-and-cannot-be-access
            _propertyValue = void 0;

            try {
              _propertyValue = data[propertyName];
            } catch (e) {
              // console.warn(e)
            }

            if (!(_propertyValue !== undefined)) {
              _context.next = 62;
              break;
            }

            _context.next = 62;
            return {
              name: propertyName,
              data: _propertyValue,
              isNonenumerable: true
            };

          case 62:
            _iteratorNormalCompletion2 = true;
            _context.next = 48;
            break;

          case 65:
            _context.next = 71;
            break;

          case 67:
            _context.prev = 67;
            _context.t1 = _context['catch'](46);
            _didIteratorError2 = true;
            _iteratorError2 = _context.t1;

          case 71:
            _context.prev = 71;
            _context.prev = 72;

            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }

          case 74:
            _context.prev = 74;

            if (!_didIteratorError2) {
              _context.next = 77;
              break;
            }

            throw _iteratorError2;

          case 77:
            return _context.finish(74);

          case 78:
            return _context.finish(71);

          case 79:
            if (!(showNonenumerable && data !== Object.prototype /* already added */)) {
              _context.next = 82;
              break;
            }

            _context.next = 82;
            return {
              name: '__proto__',
              data: Object.getPrototypeOf(data),
              isNonenumerable: true
            };

          case 82:
          case 'end':
            return _context.stop();
        }
      }
    }, objectIterator, this, [[9, 27, 31, 39], [32,, 34, 38], [46, 67, 71, 79], [72,, 74, 78]]);
  });

  return objectIterator;
};

var defaultNodeRenderer = function defaultNodeRenderer(_ref) {
  var depth = _ref.depth,
      name = _ref.name,
      data = _ref.data,
      isNonenumerable = _ref.isNonenumerable;
  return depth === 0 ? _react2.default.createElement(_ObjectRootLabel2.default, { name: name, data: data }) : _react2.default.createElement(_ObjectLabel2.default, { name: name, data: data, isNonenumerable: isNonenumerable });
};

/**
 * Tree-view for objects
 */

var ObjectInspector = function (_Component) {
  (0, _inherits3.default)(ObjectInspector, _Component);

  function ObjectInspector() {
    (0, _classCallCheck3.default)(this, ObjectInspector);
    return (0, _possibleConstructorReturn3.default)(this, (ObjectInspector.__proto__ || Object.getPrototypeOf(ObjectInspector)).apply(this, arguments));
  }

  (0, _createClass3.default)(ObjectInspector, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          showNonenumerable = _props.showNonenumerable,
          sortObjectKeys = _props.sortObjectKeys,
          nodeRenderer = _props.nodeRenderer,
          rest = (0, _objectWithoutProperties3.default)(_props, ['showNonenumerable', 'sortObjectKeys', 'nodeRenderer']);

      var dataIterator = createIterator(showNonenumerable, sortObjectKeys);

      var renderer = nodeRenderer ? nodeRenderer : defaultNodeRenderer;

      return _react2.default.createElement(
        _ThemeProvider2.default,
        { theme: this.props.theme },
        _react2.default.createElement(_TreeView2.default, (0, _extends3.default)({ nodeRenderer: renderer, dataIterator: dataIterator }, rest))
      );
    }
  }]);
  return ObjectInspector;
}(_react.Component);

ObjectInspector.defaultProps = {
  showNonenumerable: false,

  theme: 'chromeLight'
};
ObjectInspector.propTypes = {
  /** An integer specifying to which level the tree should be initially expanded. */
  expandLevel: _propTypes2.default.number,
  /** An array containing all the paths that should be expanded when the component is initialized, or a string of just one path */
  expandPaths: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.array]),

  name: _propTypes2.default.string,
  /** Not required prop because we also allow undefined value */
  data: _propTypes2.default.any,

  /** A known theme or theme object */
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]),

  /** Show non-enumerable properties */
  showNonenumerable: _propTypes2.default.bool,
  /** Sort object keys with optional compare function. */
  sortObjectKeys: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.func]),

  /** Provide a custom nodeRenderer */
  nodeRenderer: _propTypes2.default.func
};
exports.default = ObjectInspector;

/***/ }),

/***/ 5900:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

exports.default = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

/***/ }),

/***/ 5901:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _defineProperty = __webpack_require__(5902);

var _defineProperty2 = _interopRequireDefault(_defineProperty);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      (0, _defineProperty2.default)(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

/***/ }),

/***/ 5902:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5903), __esModule: true };

/***/ }),

/***/ 5903:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5904);
var $Object = __webpack_require__(5862).Object;
module.exports = function defineProperty(it, key, desc) {
  return $Object.defineProperty(it, key, desc);
};


/***/ }),

/***/ 5904:
/***/ (function(module, exports, __webpack_require__) {

var $export = __webpack_require__(5860);
// 19.1.2.4 / 15.2.3.6 Object.defineProperty(O, P, Attributes)
$export($export.S + $export.F * !__webpack_require__(5870), 'Object', { defineProperty: __webpack_require__(5866).f });


/***/ }),

/***/ 5905:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && ((typeof call === "undefined" ? "undefined" : (0, _typeof3.default)(call)) === "object" || typeof call === "function") ? call : self;
};

/***/ }),

/***/ 5906:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _iterator = __webpack_require__(5907);

var _iterator2 = _interopRequireDefault(_iterator);

var _symbol = __webpack_require__(5926);

var _symbol2 = _interopRequireDefault(_symbol);

var _typeof = typeof _symbol2.default === "function" && typeof _iterator2.default === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof _symbol2.default === "function" && obj.constructor === _symbol2.default && obj !== _symbol2.default.prototype ? "symbol" : typeof obj; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = typeof _symbol2.default === "function" && _typeof(_iterator2.default) === "symbol" ? function (obj) {
  return typeof obj === "undefined" ? "undefined" : _typeof(obj);
} : function (obj) {
  return obj && typeof _symbol2.default === "function" && obj.constructor === _symbol2.default && obj !== _symbol2.default.prototype ? "symbol" : typeof obj === "undefined" ? "undefined" : _typeof(obj);
};

/***/ }),

/***/ 5907:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5908), __esModule: true };

/***/ }),

/***/ 5908:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5909);
__webpack_require__(5921);
module.exports = __webpack_require__(5925).f('iterator');


/***/ }),

/***/ 5909:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var $at = __webpack_require__(5910)(true);

// 21.1.3.27 String.prototype[@@iterator]()
__webpack_require__(5911)(String, 'String', function (iterated) {
  this._t = String(iterated); // target
  this._i = 0;                // next index
// 21.1.5.2.1 %StringIteratorPrototype%.next()
}, function () {
  var O = this._t;
  var index = this._i;
  var point;
  if (index >= O.length) return { value: undefined, done: true };
  point = $at(O, index);
  this._i += point.length;
  return { value: point, done: false };
});


/***/ }),

/***/ 5910:
/***/ (function(module, exports, __webpack_require__) {

var toInteger = __webpack_require__(5885);
var defined = __webpack_require__(5882);
// true  -> String#at
// false -> String#codePointAt
module.exports = function (TO_STRING) {
  return function (that, pos) {
    var s = String(defined(that));
    var i = toInteger(pos);
    var l = s.length;
    var a, b;
    if (i < 0 || i >= l) return TO_STRING ? '' : undefined;
    a = s.charCodeAt(i);
    return a < 0xd800 || a > 0xdbff || i + 1 === l || (b = s.charCodeAt(i + 1)) < 0xdc00 || b > 0xdfff
      ? TO_STRING ? s.charAt(i) : a
      : TO_STRING ? s.slice(i, i + 2) : (a - 0xd800 << 10) + (b - 0xdc00) + 0x10000;
  };
};


/***/ }),

/***/ 5911:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var LIBRARY = __webpack_require__(5889);
var $export = __webpack_require__(5860);
var redefine = __webpack_require__(5912);
var hide = __webpack_require__(5865);
var Iterators = __webpack_require__(5913);
var $iterCreate = __webpack_require__(5914);
var setToStringTag = __webpack_require__(5918);
var getPrototypeOf = __webpack_require__(5920);
var ITERATOR = __webpack_require__(5919)('iterator');
var BUGGY = !([].keys && 'next' in [].keys()); // Safari has buggy iterators w/o `next`
var FF_ITERATOR = '@@iterator';
var KEYS = 'keys';
var VALUES = 'values';

var returnThis = function () { return this; };

module.exports = function (Base, NAME, Constructor, next, DEFAULT, IS_SET, FORCED) {
  $iterCreate(Constructor, NAME, next);
  var getMethod = function (kind) {
    if (!BUGGY && kind in proto) return proto[kind];
    switch (kind) {
      case KEYS: return function keys() { return new Constructor(this, kind); };
      case VALUES: return function values() { return new Constructor(this, kind); };
    } return function entries() { return new Constructor(this, kind); };
  };
  var TAG = NAME + ' Iterator';
  var DEF_VALUES = DEFAULT == VALUES;
  var VALUES_BUG = false;
  var proto = Base.prototype;
  var $native = proto[ITERATOR] || proto[FF_ITERATOR] || DEFAULT && proto[DEFAULT];
  var $default = $native || getMethod(DEFAULT);
  var $entries = DEFAULT ? !DEF_VALUES ? $default : getMethod('entries') : undefined;
  var $anyNative = NAME == 'Array' ? proto.entries || $native : $native;
  var methods, key, IteratorPrototype;
  // Fix native
  if ($anyNative) {
    IteratorPrototype = getPrototypeOf($anyNative.call(new Base()));
    if (IteratorPrototype !== Object.prototype && IteratorPrototype.next) {
      // Set @@toStringTag to native iterators
      setToStringTag(IteratorPrototype, TAG, true);
      // fix for some old engines
      if (!LIBRARY && typeof IteratorPrototype[ITERATOR] != 'function') hide(IteratorPrototype, ITERATOR, returnThis);
    }
  }
  // fix Array#{values, @@iterator}.name in V8 / FF
  if (DEF_VALUES && $native && $native.name !== VALUES) {
    VALUES_BUG = true;
    $default = function values() { return $native.call(this); };
  }
  // Define iterator
  if ((!LIBRARY || FORCED) && (BUGGY || VALUES_BUG || !proto[ITERATOR])) {
    hide(proto, ITERATOR, $default);
  }
  // Plug for library
  Iterators[NAME] = $default;
  Iterators[TAG] = returnThis;
  if (DEFAULT) {
    methods = {
      values: DEF_VALUES ? $default : getMethod(VALUES),
      keys: IS_SET ? $default : getMethod(KEYS),
      entries: $entries
    };
    if (FORCED) for (key in methods) {
      if (!(key in proto)) redefine(proto, key, methods[key]);
    } else $export($export.P + $export.F * (BUGGY || VALUES_BUG), NAME, methods);
  }
  return methods;
};


/***/ }),

/***/ 5912:
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(5865);


/***/ }),

/***/ 5913:
/***/ (function(module, exports) {

module.exports = {};


/***/ }),

/***/ 5914:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var create = __webpack_require__(5915);
var descriptor = __webpack_require__(5874);
var setToStringTag = __webpack_require__(5918);
var IteratorPrototype = {};

// 25.1.2.1.1 %IteratorPrototype%[@@iterator]()
__webpack_require__(5865)(IteratorPrototype, __webpack_require__(5919)('iterator'), function () { return this; });

module.exports = function (Constructor, NAME, next) {
  Constructor.prototype = create(IteratorPrototype, { next: descriptor(1, next) });
  setToStringTag(Constructor, NAME + ' Iterator');
};


/***/ }),

/***/ 5915:
/***/ (function(module, exports, __webpack_require__) {

// 19.1.2.2 / 15.2.3.5 Object.create(O [, Properties])
var anObject = __webpack_require__(5867);
var dPs = __webpack_require__(5916);
var enumBugKeys = __webpack_require__(5891);
var IE_PROTO = __webpack_require__(5887)('IE_PROTO');
var Empty = function () { /* empty */ };
var PROTOTYPE = 'prototype';

// Create object with fake `null` prototype: use iframe Object with cleared prototype
var createDict = function () {
  // Thrash, waste and sodomy: IE GC bug
  var iframe = __webpack_require__(5872)('iframe');
  var i = enumBugKeys.length;
  var lt = '<';
  var gt = '>';
  var iframeDocument;
  iframe.style.display = 'none';
  __webpack_require__(5917).appendChild(iframe);
  iframe.src = 'javascript:'; // eslint-disable-line no-script-url
  // createDict = iframe.contentWindow.Object;
  // html.removeChild(iframe);
  iframeDocument = iframe.contentWindow.document;
  iframeDocument.open();
  iframeDocument.write(lt + 'script' + gt + 'document.F=Object' + lt + '/script' + gt);
  iframeDocument.close();
  createDict = iframeDocument.F;
  while (i--) delete createDict[PROTOTYPE][enumBugKeys[i]];
  return createDict();
};

module.exports = Object.create || function create(O, Properties) {
  var result;
  if (O !== null) {
    Empty[PROTOTYPE] = anObject(O);
    result = new Empty();
    Empty[PROTOTYPE] = null;
    // add "__proto__" for Object.getPrototypeOf polyfill
    result[IE_PROTO] = O;
  } else result = createDict();
  return Properties === undefined ? result : dPs(result, Properties);
};


/***/ }),

/***/ 5916:
/***/ (function(module, exports, __webpack_require__) {

var dP = __webpack_require__(5866);
var anObject = __webpack_require__(5867);
var getKeys = __webpack_require__(5877);

module.exports = __webpack_require__(5870) ? Object.defineProperties : function defineProperties(O, Properties) {
  anObject(O);
  var keys = getKeys(Properties);
  var length = keys.length;
  var i = 0;
  var P;
  while (length > i) dP.f(O, P = keys[i++], Properties[P]);
  return O;
};


/***/ }),

/***/ 5917:
/***/ (function(module, exports, __webpack_require__) {

var document = __webpack_require__(5861).document;
module.exports = document && document.documentElement;


/***/ }),

/***/ 5918:
/***/ (function(module, exports, __webpack_require__) {

var def = __webpack_require__(5866).f;
var has = __webpack_require__(5875);
var TAG = __webpack_require__(5919)('toStringTag');

module.exports = function (it, tag, stat) {
  if (it && !has(it = stat ? it : it.prototype, TAG)) def(it, TAG, { configurable: true, value: tag });
};


/***/ }),

/***/ 5919:
/***/ (function(module, exports, __webpack_require__) {

var store = __webpack_require__(5888)('wks');
var uid = __webpack_require__(5890);
var Symbol = __webpack_require__(5861).Symbol;
var USE_SYMBOL = typeof Symbol == 'function';

var $exports = module.exports = function (name) {
  return store[name] || (store[name] =
    USE_SYMBOL && Symbol[name] || (USE_SYMBOL ? Symbol : uid)('Symbol.' + name));
};

$exports.store = store;


/***/ }),

/***/ 5920:
/***/ (function(module, exports, __webpack_require__) {

// 19.1.2.9 / 15.2.3.2 Object.getPrototypeOf(O)
var has = __webpack_require__(5875);
var toObject = __webpack_require__(5894);
var IE_PROTO = __webpack_require__(5887)('IE_PROTO');
var ObjectProto = Object.prototype;

module.exports = Object.getPrototypeOf || function (O) {
  O = toObject(O);
  if (has(O, IE_PROTO)) return O[IE_PROTO];
  if (typeof O.constructor == 'function' && O instanceof O.constructor) {
    return O.constructor.prototype;
  } return O instanceof Object ? ObjectProto : null;
};


/***/ }),

/***/ 5921:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5922);
var global = __webpack_require__(5861);
var hide = __webpack_require__(5865);
var Iterators = __webpack_require__(5913);
var TO_STRING_TAG = __webpack_require__(5919)('toStringTag');

var DOMIterables = ('CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,' +
  'DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,' +
  'MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,' +
  'SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,' +
  'TextTrackList,TouchList').split(',');

for (var i = 0; i < DOMIterables.length; i++) {
  var NAME = DOMIterables[i];
  var Collection = global[NAME];
  var proto = Collection && Collection.prototype;
  if (proto && !proto[TO_STRING_TAG]) hide(proto, TO_STRING_TAG, NAME);
  Iterators[NAME] = Iterators.Array;
}


/***/ }),

/***/ 5922:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var addToUnscopables = __webpack_require__(5923);
var step = __webpack_require__(5924);
var Iterators = __webpack_require__(5913);
var toIObject = __webpack_require__(5879);

// 22.1.3.4 Array.prototype.entries()
// 22.1.3.13 Array.prototype.keys()
// 22.1.3.29 Array.prototype.values()
// 22.1.3.30 Array.prototype[@@iterator]()
module.exports = __webpack_require__(5911)(Array, 'Array', function (iterated, kind) {
  this._t = toIObject(iterated); // target
  this._i = 0;                   // next index
  this._k = kind;                // kind
// 22.1.5.2.1 %ArrayIteratorPrototype%.next()
}, function () {
  var O = this._t;
  var kind = this._k;
  var index = this._i++;
  if (!O || index >= O.length) {
    this._t = undefined;
    return step(1);
  }
  if (kind == 'keys') return step(0, index);
  if (kind == 'values') return step(0, O[index]);
  return step(0, [index, O[index]]);
}, 'values');

// argumentsList[@@iterator] is %ArrayProto_values% (9.4.4.6, 9.4.4.7)
Iterators.Arguments = Iterators.Array;

addToUnscopables('keys');
addToUnscopables('values');
addToUnscopables('entries');


/***/ }),

/***/ 5923:
/***/ (function(module, exports) {

module.exports = function () { /* empty */ };


/***/ }),

/***/ 5924:
/***/ (function(module, exports) {

module.exports = function (done, value) {
  return { value: value, done: !!done };
};


/***/ }),

/***/ 5925:
/***/ (function(module, exports, __webpack_require__) {

exports.f = __webpack_require__(5919);


/***/ }),

/***/ 5926:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5927), __esModule: true };

/***/ }),

/***/ 5927:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5928);
__webpack_require__(5936);
__webpack_require__(5937);
__webpack_require__(5938);
module.exports = __webpack_require__(5862).Symbol;


/***/ }),

/***/ 5928:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

// ECMAScript 6 symbols shim
var global = __webpack_require__(5861);
var has = __webpack_require__(5875);
var DESCRIPTORS = __webpack_require__(5870);
var $export = __webpack_require__(5860);
var redefine = __webpack_require__(5912);
var META = __webpack_require__(5929).KEY;
var $fails = __webpack_require__(5871);
var shared = __webpack_require__(5888);
var setToStringTag = __webpack_require__(5918);
var uid = __webpack_require__(5890);
var wks = __webpack_require__(5919);
var wksExt = __webpack_require__(5925);
var wksDefine = __webpack_require__(5930);
var enumKeys = __webpack_require__(5931);
var isArray = __webpack_require__(5932);
var anObject = __webpack_require__(5867);
var isObject = __webpack_require__(5868);
var toObject = __webpack_require__(5894);
var toIObject = __webpack_require__(5879);
var toPrimitive = __webpack_require__(5873);
var createDesc = __webpack_require__(5874);
var _create = __webpack_require__(5915);
var gOPNExt = __webpack_require__(5933);
var $GOPD = __webpack_require__(5935);
var $GOPS = __webpack_require__(5892);
var $DP = __webpack_require__(5866);
var $keys = __webpack_require__(5877);
var gOPD = $GOPD.f;
var dP = $DP.f;
var gOPN = gOPNExt.f;
var $Symbol = global.Symbol;
var $JSON = global.JSON;
var _stringify = $JSON && $JSON.stringify;
var PROTOTYPE = 'prototype';
var HIDDEN = wks('_hidden');
var TO_PRIMITIVE = wks('toPrimitive');
var isEnum = {}.propertyIsEnumerable;
var SymbolRegistry = shared('symbol-registry');
var AllSymbols = shared('symbols');
var OPSymbols = shared('op-symbols');
var ObjectProto = Object[PROTOTYPE];
var USE_NATIVE = typeof $Symbol == 'function' && !!$GOPS.f;
var QObject = global.QObject;
// Don't use setters in Qt Script, https://github.com/zloirock/core-js/issues/173
var setter = !QObject || !QObject[PROTOTYPE] || !QObject[PROTOTYPE].findChild;

// fallback for old Android, https://code.google.com/p/v8/issues/detail?id=687
var setSymbolDesc = DESCRIPTORS && $fails(function () {
  return _create(dP({}, 'a', {
    get: function () { return dP(this, 'a', { value: 7 }).a; }
  })).a != 7;
}) ? function (it, key, D) {
  var protoDesc = gOPD(ObjectProto, key);
  if (protoDesc) delete ObjectProto[key];
  dP(it, key, D);
  if (protoDesc && it !== ObjectProto) dP(ObjectProto, key, protoDesc);
} : dP;

var wrap = function (tag) {
  var sym = AllSymbols[tag] = _create($Symbol[PROTOTYPE]);
  sym._k = tag;
  return sym;
};

var isSymbol = USE_NATIVE && typeof $Symbol.iterator == 'symbol' ? function (it) {
  return typeof it == 'symbol';
} : function (it) {
  return it instanceof $Symbol;
};

var $defineProperty = function defineProperty(it, key, D) {
  if (it === ObjectProto) $defineProperty(OPSymbols, key, D);
  anObject(it);
  key = toPrimitive(key, true);
  anObject(D);
  if (has(AllSymbols, key)) {
    if (!D.enumerable) {
      if (!has(it, HIDDEN)) dP(it, HIDDEN, createDesc(1, {}));
      it[HIDDEN][key] = true;
    } else {
      if (has(it, HIDDEN) && it[HIDDEN][key]) it[HIDDEN][key] = false;
      D = _create(D, { enumerable: createDesc(0, false) });
    } return setSymbolDesc(it, key, D);
  } return dP(it, key, D);
};
var $defineProperties = function defineProperties(it, P) {
  anObject(it);
  var keys = enumKeys(P = toIObject(P));
  var i = 0;
  var l = keys.length;
  var key;
  while (l > i) $defineProperty(it, key = keys[i++], P[key]);
  return it;
};
var $create = function create(it, P) {
  return P === undefined ? _create(it) : $defineProperties(_create(it), P);
};
var $propertyIsEnumerable = function propertyIsEnumerable(key) {
  var E = isEnum.call(this, key = toPrimitive(key, true));
  if (this === ObjectProto && has(AllSymbols, key) && !has(OPSymbols, key)) return false;
  return E || !has(this, key) || !has(AllSymbols, key) || has(this, HIDDEN) && this[HIDDEN][key] ? E : true;
};
var $getOwnPropertyDescriptor = function getOwnPropertyDescriptor(it, key) {
  it = toIObject(it);
  key = toPrimitive(key, true);
  if (it === ObjectProto && has(AllSymbols, key) && !has(OPSymbols, key)) return;
  var D = gOPD(it, key);
  if (D && has(AllSymbols, key) && !(has(it, HIDDEN) && it[HIDDEN][key])) D.enumerable = true;
  return D;
};
var $getOwnPropertyNames = function getOwnPropertyNames(it) {
  var names = gOPN(toIObject(it));
  var result = [];
  var i = 0;
  var key;
  while (names.length > i) {
    if (!has(AllSymbols, key = names[i++]) && key != HIDDEN && key != META) result.push(key);
  } return result;
};
var $getOwnPropertySymbols = function getOwnPropertySymbols(it) {
  var IS_OP = it === ObjectProto;
  var names = gOPN(IS_OP ? OPSymbols : toIObject(it));
  var result = [];
  var i = 0;
  var key;
  while (names.length > i) {
    if (has(AllSymbols, key = names[i++]) && (IS_OP ? has(ObjectProto, key) : true)) result.push(AllSymbols[key]);
  } return result;
};

// 19.4.1.1 Symbol([description])
if (!USE_NATIVE) {
  $Symbol = function Symbol() {
    if (this instanceof $Symbol) throw TypeError('Symbol is not a constructor!');
    var tag = uid(arguments.length > 0 ? arguments[0] : undefined);
    var $set = function (value) {
      if (this === ObjectProto) $set.call(OPSymbols, value);
      if (has(this, HIDDEN) && has(this[HIDDEN], tag)) this[HIDDEN][tag] = false;
      setSymbolDesc(this, tag, createDesc(1, value));
    };
    if (DESCRIPTORS && setter) setSymbolDesc(ObjectProto, tag, { configurable: true, set: $set });
    return wrap(tag);
  };
  redefine($Symbol[PROTOTYPE], 'toString', function toString() {
    return this._k;
  });

  $GOPD.f = $getOwnPropertyDescriptor;
  $DP.f = $defineProperty;
  __webpack_require__(5934).f = gOPNExt.f = $getOwnPropertyNames;
  __webpack_require__(5893).f = $propertyIsEnumerable;
  $GOPS.f = $getOwnPropertySymbols;

  if (DESCRIPTORS && !__webpack_require__(5889)) {
    redefine(ObjectProto, 'propertyIsEnumerable', $propertyIsEnumerable, true);
  }

  wksExt.f = function (name) {
    return wrap(wks(name));
  };
}

$export($export.G + $export.W + $export.F * !USE_NATIVE, { Symbol: $Symbol });

for (var es6Symbols = (
  // 19.4.2.2, 19.4.2.3, 19.4.2.4, 19.4.2.6, 19.4.2.8, 19.4.2.9, 19.4.2.10, 19.4.2.11, 19.4.2.12, 19.4.2.13, 19.4.2.14
  'hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables'
).split(','), j = 0; es6Symbols.length > j;)wks(es6Symbols[j++]);

for (var wellKnownSymbols = $keys(wks.store), k = 0; wellKnownSymbols.length > k;) wksDefine(wellKnownSymbols[k++]);

$export($export.S + $export.F * !USE_NATIVE, 'Symbol', {
  // 19.4.2.1 Symbol.for(key)
  'for': function (key) {
    return has(SymbolRegistry, key += '')
      ? SymbolRegistry[key]
      : SymbolRegistry[key] = $Symbol(key);
  },
  // 19.4.2.5 Symbol.keyFor(sym)
  keyFor: function keyFor(sym) {
    if (!isSymbol(sym)) throw TypeError(sym + ' is not a symbol!');
    for (var key in SymbolRegistry) if (SymbolRegistry[key] === sym) return key;
  },
  useSetter: function () { setter = true; },
  useSimple: function () { setter = false; }
});

$export($export.S + $export.F * !USE_NATIVE, 'Object', {
  // 19.1.2.2 Object.create(O [, Properties])
  create: $create,
  // 19.1.2.4 Object.defineProperty(O, P, Attributes)
  defineProperty: $defineProperty,
  // 19.1.2.3 Object.defineProperties(O, Properties)
  defineProperties: $defineProperties,
  // 19.1.2.6 Object.getOwnPropertyDescriptor(O, P)
  getOwnPropertyDescriptor: $getOwnPropertyDescriptor,
  // 19.1.2.7 Object.getOwnPropertyNames(O)
  getOwnPropertyNames: $getOwnPropertyNames,
  // 19.1.2.8 Object.getOwnPropertySymbols(O)
  getOwnPropertySymbols: $getOwnPropertySymbols
});

// Chrome 38 and 39 `Object.getOwnPropertySymbols` fails on primitives
// https://bugs.chromium.org/p/v8/issues/detail?id=3443
var FAILS_ON_PRIMITIVES = $fails(function () { $GOPS.f(1); });

$export($export.S + $export.F * FAILS_ON_PRIMITIVES, 'Object', {
  getOwnPropertySymbols: function getOwnPropertySymbols(it) {
    return $GOPS.f(toObject(it));
  }
});

// 24.3.2 JSON.stringify(value [, replacer [, space]])
$JSON && $export($export.S + $export.F * (!USE_NATIVE || $fails(function () {
  var S = $Symbol();
  // MS Edge converts symbol values to JSON as {}
  // WebKit converts symbol values to JSON as null
  // V8 throws on boxed symbols
  return _stringify([S]) != '[null]' || _stringify({ a: S }) != '{}' || _stringify(Object(S)) != '{}';
})), 'JSON', {
  stringify: function stringify(it) {
    var args = [it];
    var i = 1;
    var replacer, $replacer;
    while (arguments.length > i) args.push(arguments[i++]);
    $replacer = replacer = args[1];
    if (!isObject(replacer) && it === undefined || isSymbol(it)) return; // IE8 returns string on undefined
    if (!isArray(replacer)) replacer = function (key, value) {
      if (typeof $replacer == 'function') value = $replacer.call(this, key, value);
      if (!isSymbol(value)) return value;
    };
    args[1] = replacer;
    return _stringify.apply($JSON, args);
  }
});

// 19.4.3.4 Symbol.prototype[@@toPrimitive](hint)
$Symbol[PROTOTYPE][TO_PRIMITIVE] || __webpack_require__(5865)($Symbol[PROTOTYPE], TO_PRIMITIVE, $Symbol[PROTOTYPE].valueOf);
// 19.4.3.5 Symbol.prototype[@@toStringTag]
setToStringTag($Symbol, 'Symbol');
// 20.2.1.9 Math[@@toStringTag]
setToStringTag(Math, 'Math', true);
// 24.3.3 JSON[@@toStringTag]
setToStringTag(global.JSON, 'JSON', true);


/***/ }),

/***/ 5929:
/***/ (function(module, exports, __webpack_require__) {

var META = __webpack_require__(5890)('meta');
var isObject = __webpack_require__(5868);
var has = __webpack_require__(5875);
var setDesc = __webpack_require__(5866).f;
var id = 0;
var isExtensible = Object.isExtensible || function () {
  return true;
};
var FREEZE = !__webpack_require__(5871)(function () {
  return isExtensible(Object.preventExtensions({}));
});
var setMeta = function (it) {
  setDesc(it, META, { value: {
    i: 'O' + ++id, // object ID
    w: {}          // weak collections IDs
  } });
};
var fastKey = function (it, create) {
  // return primitive with prefix
  if (!isObject(it)) return typeof it == 'symbol' ? it : (typeof it == 'string' ? 'S' : 'P') + it;
  if (!has(it, META)) {
    // can't set metadata to uncaught frozen object
    if (!isExtensible(it)) return 'F';
    // not necessary to add metadata
    if (!create) return 'E';
    // add missing metadata
    setMeta(it);
  // return object ID
  } return it[META].i;
};
var getWeak = function (it, create) {
  if (!has(it, META)) {
    // can't set metadata to uncaught frozen object
    if (!isExtensible(it)) return true;
    // not necessary to add metadata
    if (!create) return false;
    // add missing metadata
    setMeta(it);
  // return hash weak collections IDs
  } return it[META].w;
};
// add metadata on freeze-family methods calling
var onFreeze = function (it) {
  if (FREEZE && meta.NEED && isExtensible(it) && !has(it, META)) setMeta(it);
  return it;
};
var meta = module.exports = {
  KEY: META,
  NEED: false,
  fastKey: fastKey,
  getWeak: getWeak,
  onFreeze: onFreeze
};


/***/ }),

/***/ 5930:
/***/ (function(module, exports, __webpack_require__) {

var global = __webpack_require__(5861);
var core = __webpack_require__(5862);
var LIBRARY = __webpack_require__(5889);
var wksExt = __webpack_require__(5925);
var defineProperty = __webpack_require__(5866).f;
module.exports = function (name) {
  var $Symbol = core.Symbol || (core.Symbol = LIBRARY ? {} : global.Symbol || {});
  if (name.charAt(0) != '_' && !(name in $Symbol)) defineProperty($Symbol, name, { value: wksExt.f(name) });
};


/***/ }),

/***/ 5931:
/***/ (function(module, exports, __webpack_require__) {

// all enumerable object keys, includes symbols
var getKeys = __webpack_require__(5877);
var gOPS = __webpack_require__(5892);
var pIE = __webpack_require__(5893);
module.exports = function (it) {
  var result = getKeys(it);
  var getSymbols = gOPS.f;
  if (getSymbols) {
    var symbols = getSymbols(it);
    var isEnum = pIE.f;
    var i = 0;
    var key;
    while (symbols.length > i) if (isEnum.call(it, key = symbols[i++])) result.push(key);
  } return result;
};


/***/ }),

/***/ 5932:
/***/ (function(module, exports, __webpack_require__) {

// 7.2.2 IsArray(argument)
var cof = __webpack_require__(5881);
module.exports = Array.isArray || function isArray(arg) {
  return cof(arg) == 'Array';
};


/***/ }),

/***/ 5933:
/***/ (function(module, exports, __webpack_require__) {

// fallback for IE11 buggy Object.getOwnPropertyNames with iframe and window
var toIObject = __webpack_require__(5879);
var gOPN = __webpack_require__(5934).f;
var toString = {}.toString;

var windowNames = typeof window == 'object' && window && Object.getOwnPropertyNames
  ? Object.getOwnPropertyNames(window) : [];

var getWindowNames = function (it) {
  try {
    return gOPN(it);
  } catch (e) {
    return windowNames.slice();
  }
};

module.exports.f = function getOwnPropertyNames(it) {
  return windowNames && toString.call(it) == '[object Window]' ? getWindowNames(it) : gOPN(toIObject(it));
};


/***/ }),

/***/ 5934:
/***/ (function(module, exports, __webpack_require__) {

// 19.1.2.7 / 15.2.3.4 Object.getOwnPropertyNames(O)
var $keys = __webpack_require__(5878);
var hiddenKeys = __webpack_require__(5891).concat('length', 'prototype');

exports.f = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
  return $keys(O, hiddenKeys);
};


/***/ }),

/***/ 5935:
/***/ (function(module, exports, __webpack_require__) {

var pIE = __webpack_require__(5893);
var createDesc = __webpack_require__(5874);
var toIObject = __webpack_require__(5879);
var toPrimitive = __webpack_require__(5873);
var has = __webpack_require__(5875);
var IE8_DOM_DEFINE = __webpack_require__(5869);
var gOPD = Object.getOwnPropertyDescriptor;

exports.f = __webpack_require__(5870) ? gOPD : function getOwnPropertyDescriptor(O, P) {
  O = toIObject(O);
  P = toPrimitive(P, true);
  if (IE8_DOM_DEFINE) try {
    return gOPD(O, P);
  } catch (e) { /* empty */ }
  if (has(O, P)) return createDesc(!pIE.f.call(O, P), O[P]);
};


/***/ }),

/***/ 5936:
/***/ (function(module, exports) {



/***/ }),

/***/ 5937:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5930)('asyncIterator');


/***/ }),

/***/ 5938:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5930)('observable');


/***/ }),

/***/ 5939:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _setPrototypeOf = __webpack_require__(5940);

var _setPrototypeOf2 = _interopRequireDefault(_setPrototypeOf);

var _create = __webpack_require__(5944);

var _create2 = _interopRequireDefault(_create);

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + (typeof superClass === "undefined" ? "undefined" : (0, _typeof3.default)(superClass)));
  }

  subClass.prototype = (0, _create2.default)(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf2.default ? (0, _setPrototypeOf2.default)(subClass, superClass) : subClass.__proto__ = superClass;
};

/***/ }),

/***/ 5940:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5941), __esModule: true };

/***/ }),

/***/ 5941:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5942);
module.exports = __webpack_require__(5862).Object.setPrototypeOf;


/***/ }),

/***/ 5942:
/***/ (function(module, exports, __webpack_require__) {

// 19.1.3.19 Object.setPrototypeOf(O, proto)
var $export = __webpack_require__(5860);
$export($export.S, 'Object', { setPrototypeOf: __webpack_require__(5943).set });


/***/ }),

/***/ 5943:
/***/ (function(module, exports, __webpack_require__) {

// Works with __proto__ only. Old v8 can't work with null proto objects.
/* eslint-disable no-proto */
var isObject = __webpack_require__(5868);
var anObject = __webpack_require__(5867);
var check = function (O, proto) {
  anObject(O);
  if (!isObject(proto) && proto !== null) throw TypeError(proto + ": can't set as prototype!");
};
module.exports = {
  set: Object.setPrototypeOf || ('__proto__' in {} ? // eslint-disable-line
    function (test, buggy, set) {
      try {
        set = __webpack_require__(5863)(Function.call, __webpack_require__(5935).f(Object.prototype, '__proto__').set, 2);
        set(test, []);
        buggy = !(test instanceof Array);
      } catch (e) { buggy = true; }
      return function setPrototypeOf(O, proto) {
        check(O, proto);
        if (buggy) O.__proto__ = proto;
        else set(O, proto);
        return O;
      };
    }({}, false) : undefined),
  check: check
};


/***/ }),

/***/ 5944:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5945), __esModule: true };

/***/ }),

/***/ 5945:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5946);
var $Object = __webpack_require__(5862).Object;
module.exports = function create(P, D) {
  return $Object.create(P, D);
};


/***/ }),

/***/ 5946:
/***/ (function(module, exports, __webpack_require__) {

var $export = __webpack_require__(5860);
// 19.1.2.2 / 15.2.3.5 Object.create(O [, Properties])
$export($export.S, 'Object', { create: __webpack_require__(5915) });


/***/ }),

/***/ 5947:
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(5948);


/***/ }),

/***/ 5948:
/***/ (function(module, exports, __webpack_require__) {

/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

// This method of obtaining a reference to the global object needs to be
// kept identical to the way it is obtained in runtime.js
var g = (function() { return this })() || Function("return this")();

// Use `getOwnPropertyNames` because not all browsers support calling
// `hasOwnProperty` on the global `self` object in a worker. See #183.
var hadRuntime = g.regeneratorRuntime &&
  Object.getOwnPropertyNames(g).indexOf("regeneratorRuntime") >= 0;

// Save the old regeneratorRuntime in case it needs to be restored later.
var oldRuntime = hadRuntime && g.regeneratorRuntime;

// Force reevalutation of runtime.js.
g.regeneratorRuntime = undefined;

module.exports = __webpack_require__(5949);

if (hadRuntime) {
  // Restore the original runtime.
  g.regeneratorRuntime = oldRuntime;
} else {
  // Remove the global property added by runtime.js.
  try {
    delete g.regeneratorRuntime;
  } catch(e) {
    g.regeneratorRuntime = undefined;
  }
}


/***/ }),

/***/ 5949:
/***/ (function(module, exports) {

/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

!(function(global) {
  "use strict";

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  var inModule = typeof module === "object";
  var runtime = global.regeneratorRuntime;
  if (runtime) {
    if (inModule) {
      // If regeneratorRuntime is defined globally and we're in a module,
      // make the exports object identical to regeneratorRuntime.
      module.exports = runtime;
    }
    // Don't bother evaluating the rest of this file if the runtime was
    // already defined globally.
    return;
  }

  // Define the runtime globally (as expected by generated code) as either
  // module.exports (if we're in a module) or a new, empty object.
  runtime = global.regeneratorRuntime = inModule ? module.exports : {};

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  runtime.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunctionPrototype[toStringTagSymbol] =
    GeneratorFunction.displayName = "GeneratorFunction";

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      prototype[method] = function(arg) {
        return this._invoke(method, arg);
      };
    });
  }

  runtime.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  runtime.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      if (!(toStringTagSymbol in genFun)) {
        genFun[toStringTagSymbol] = "GeneratorFunction";
      }
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  runtime.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return Promise.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return Promise.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration. If the Promise is rejected, however, the
          // result for this iteration will be rejected with the same
          // reason. Note that rejections of yielded Promises are not
          // thrown back into the generator function, as is the case
          // when an awaited Promise is rejected. This difference in
          // behavior between yield and await is important, because it
          // allows the consumer to decide what to do with the yielded
          // rejection (swallow it and continue, manually .throw it back
          // into the generator, abandon iteration, whatever). With
          // await, by contrast, there is no opportunity to examine the
          // rejection reason outside the generator function, so the
          // only option is to throw it from the await expression, and
          // let the generator function handle the exception.
          result.value = unwrapped;
          resolve(result);
        }, reject);
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new Promise(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };
  runtime.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  runtime.async = function(innerFn, outerFn, self, tryLocsList) {
    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList)
    );

    return runtime.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        if (delegate.iterator.return) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  Gp[toStringTagSymbol] = "Generator";

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  Gp[iteratorSymbol] = function() {
    return this;
  };

  Gp.toString = function() {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  runtime.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  runtime.values = values;

  function doneResult() {
    return { value: undefined, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined;
      }

      return ContinueSentinel;
    }
  };
})(
  // In sloppy mode, unbound `this` refers to the global object, fallback to
  // Function constructor if we're in global strict mode. That is sadly a form
  // of indirect eval which violates Content Security Policy.
  (function() { return this })() || Function("return this")()
);


/***/ }),

/***/ 5950:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _isIterable2 = __webpack_require__(5951);

var _isIterable3 = _interopRequireDefault(_isIterable2);

var _getIterator2 = __webpack_require__(5955);

var _getIterator3 = _interopRequireDefault(_getIterator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = (0, _getIterator3.default)(arr), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if ((0, _isIterable3.default)(Object(arr))) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

/***/ }),

/***/ 5951:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5952), __esModule: true };

/***/ }),

/***/ 5952:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5921);
__webpack_require__(5909);
module.exports = __webpack_require__(5953);


/***/ }),

/***/ 5953:
/***/ (function(module, exports, __webpack_require__) {

var classof = __webpack_require__(5954);
var ITERATOR = __webpack_require__(5919)('iterator');
var Iterators = __webpack_require__(5913);
module.exports = __webpack_require__(5862).isIterable = function (it) {
  var O = Object(it);
  return O[ITERATOR] !== undefined
    || '@@iterator' in O
    // eslint-disable-next-line no-prototype-builtins
    || Iterators.hasOwnProperty(classof(O));
};


/***/ }),

/***/ 5954:
/***/ (function(module, exports, __webpack_require__) {

// getting tag from 19.1.3.6 Object.prototype.toString()
var cof = __webpack_require__(5881);
var TAG = __webpack_require__(5919)('toStringTag');
// ES3 wrong here
var ARG = cof(function () { return arguments; }()) == 'Arguments';

// fallback for IE11 Script Access Denied error
var tryGet = function (it, key) {
  try {
    return it[key];
  } catch (e) { /* empty */ }
};

module.exports = function (it) {
  var O, T, B;
  return it === undefined ? 'Undefined' : it === null ? 'Null'
    // @@toStringTag case
    : typeof (T = tryGet(O = Object(it), TAG)) == 'string' ? T
    // builtinTag case
    : ARG ? cof(O)
    // ES3 arguments fallback
    : (B = cof(O)) == 'Object' && typeof O.callee == 'function' ? 'Arguments' : B;
};


/***/ }),

/***/ 5955:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5956), __esModule: true };

/***/ }),

/***/ 5956:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5921);
__webpack_require__(5909);
module.exports = __webpack_require__(5957);


/***/ }),

/***/ 5957:
/***/ (function(module, exports, __webpack_require__) {

var anObject = __webpack_require__(5867);
var get = __webpack_require__(5958);
module.exports = __webpack_require__(5862).getIterator = function (it) {
  var iterFn = get(it);
  if (typeof iterFn != 'function') throw TypeError(it + ' is not iterable!');
  return anObject(iterFn.call(it));
};


/***/ }),

/***/ 5958:
/***/ (function(module, exports, __webpack_require__) {

var classof = __webpack_require__(5954);
var ITERATOR = __webpack_require__(5919)('iterator');
var Iterators = __webpack_require__(5913);
module.exports = __webpack_require__(5862).getIteratorMethod = function (it) {
  if (it != undefined) return it[ITERATOR]
    || it['@@iterator']
    || Iterators[classof(it)];
};


/***/ }),

/***/ 5959:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = __webpack_require__(5895);

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = __webpack_require__(5900);

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = __webpack_require__(5901);

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = __webpack_require__(5905);

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = __webpack_require__(5939);

var _inherits3 = _interopRequireDefault(_inherits2);

var _defineProperty2 = __webpack_require__(5960);

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TreeNode = __webpack_require__(5961);

var _TreeNode2 = _interopRequireDefault(_TreeNode);

var _pathUtils = __webpack_require__(5965);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var reducer = function reducer(state, action) {
  switch (action.type) {
    case 'TOGGLE_EXPAND':
      {
        var path = action.path;
        var expandedPaths = state.expandedPaths;
        var expanded = !!expandedPaths[path];

        return Object.assign({}, state, {
          expandedPaths: Object.assign({}, state.expandedPaths, (0, _defineProperty3.default)({}, path, !expanded))
        });
      }
    default:
      return state;
  }
};

var ConnectedTreeNode = function (_Component) {
  (0, _inherits3.default)(ConnectedTreeNode, _Component);

  function ConnectedTreeNode(props, context) {
    (0, _classCallCheck3.default)(this, ConnectedTreeNode);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ConnectedTreeNode.__proto__ || Object.getPrototypeOf(ConnectedTreeNode)).call(this, props));

    _this.state = context.store.storeState;
    return _this;
  }

  (0, _createClass3.default)(ConnectedTreeNode, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !!nextState.expandedPaths[nextProps.path] !== !!this.state.expandedPaths[this.props.path] || nextProps.data !== this.props.data || nextProps.name !== this.props.name;
    }
  }, {
    key: 'handleClick',
    value: function handleClick(path) {
      this.context.store.storeState = reducer(this.context.store.storeState, {
        type: 'TOGGLE_EXPAND',
        path: path
      });
      this.setState(this.context.store.storeState);
    }
  }, {
    key: 'renderChildNodes',
    value: function renderChildNodes(parentData, parentPath) {
      var dataIterator = this.props.dataIterator;
      var depth = this.props.depth;
      var nodeRenderer = this.props.nodeRenderer;


      var childNodes = [];
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = dataIterator(parentData)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _ref2 = _step.value;
          var name = _ref2.name,
              data = _ref2.data,
              props = (0, _objectWithoutProperties3.default)(_ref2, ['name', 'data']);

          var key = name;
          var path = parentPath + '.' + key;
          childNodes.push(_react2.default.createElement(ConnectedTreeNode, (0, _extends3.default)({
            name: name,
            data: data,
            depth: depth + 1,
            path: path,
            key: key,
            dataIterator: dataIterator,
            nodeRenderer: nodeRenderer
          }, props)) // props for nodeRenderer
          );
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return childNodes;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          data = _props.data,
          dataIterator = _props.dataIterator,
          path = _props.path,
          depth = _props.depth;


      var nodeHasChildNodes = (0, _pathUtils.hasChildNodes)(data, dataIterator);
      var expandedPaths = this.state.expandedPaths;

      var expanded = !!expandedPaths[path];

      var nodeRenderer = this.props.nodeRenderer;


      return _react2.default.createElement(
        _TreeNode2.default,
        (0, _extends3.default)({
          expanded: expanded,
          onClick: nodeHasChildNodes ? this.handleClick.bind(this, path) : function () {}
          // show arrow anyway even if not expanded and not rendering children
          , shouldShowArrow: nodeHasChildNodes
          // show placeholder only for non root nodes
          , shouldShowPlaceholder: depth > 0
          // Render a node from name and data (or possibly other props like isNonenumerable)
          , nodeRenderer: nodeRenderer
        }, this.props),
        // only render if the node is expanded
        expanded ? this.renderChildNodes(data, path) : undefined
      );
    }
  }]);
  return ConnectedTreeNode;
}(_react.Component);

ConnectedTreeNode.propTypes = {
  name: _propTypes2.default.string,
  data: _propTypes2.default.any,
  dataIterator: _propTypes2.default.func,

  depth: _propTypes2.default.number,
  expanded: _propTypes2.default.bool,

  nodeRenderer: _propTypes2.default.func
};

ConnectedTreeNode.contextTypes = {
  store: _propTypes2.default.any
};

var TreeView = function (_Component2) {
  (0, _inherits3.default)(TreeView, _Component2);

  function TreeView(props) {
    (0, _classCallCheck3.default)(this, TreeView);

    var _this2 = (0, _possibleConstructorReturn3.default)(this, (TreeView.__proto__ || Object.getPrototypeOf(TreeView)).call(this, props));

    _this2.store = {
      storeState: {
        expandedPaths: (0, _pathUtils.getExpandedPaths)(props.data, props.dataIterator, props.expandPaths, props.expandLevel)
      }
    };
    return _this2;
  }

  (0, _createClass3.default)(TreeView, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.store = {
        storeState: {
          expandedPaths: (0, _pathUtils.getExpandedPaths)(nextProps.data, nextProps.dataIterator, nextProps.expandPaths, nextProps.expandLevel, this.store.storeState.expandedPaths)
        }
      };
    }
  }, {
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        store: this.store
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          name = _props2.name,
          data = _props2.data,
          dataIterator = _props2.dataIterator;
      var nodeRenderer = this.props.nodeRenderer;


      var rootPath = _pathUtils.DEFAULT_ROOT_PATH;

      return _react2.default.createElement(ConnectedTreeNode, {
        name: name,
        data: data,
        dataIterator: dataIterator,
        depth: 0,
        path: rootPath,
        nodeRenderer: nodeRenderer
      });
    }
  }]);
  return TreeView;
}(_react.Component);

TreeView.defaultProps = {
  expandLevel: 0,
  expandPaths: []
};
TreeView.childContextTypes = {
  store: _propTypes2.default.any
};


TreeView.propTypes = {
  name: _propTypes2.default.string,
  data: _propTypes2.default.any,
  dataIterator: _propTypes2.default.func,

  nodeRenderer: _propTypes2.default.func
};

TreeView.defaultProps = {
  name: undefined
};

exports.default = TreeView;

/***/ }),

/***/ 5960:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _defineProperty = __webpack_require__(5902);

var _defineProperty2 = _interopRequireDefault(_defineProperty);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (obj, key, value) {
  if (key in obj) {
    (0, _defineProperty2.default)(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

/***/ }),

/***/ 5961:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = __webpack_require__(5900);

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = __webpack_require__(5901);

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = __webpack_require__(5905);

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = __webpack_require__(5939);

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createStyles = __webpack_require__(5962);

var _createStyles2 = _interopRequireDefault(_createStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Arrow = function Arrow(_ref) {
  var expanded = _ref.expanded,
      styles = _ref.styles;
  return _react2.default.createElement(
    'span',
    { style: (0, _extends3.default)({}, styles.base, expanded ? styles.expanded : styles.collapsed) },
    '\u25B6'
  );
};

var TreeNode = function (_Component) {
  (0, _inherits3.default)(TreeNode, _Component);

  function TreeNode() {
    (0, _classCallCheck3.default)(this, TreeNode);
    return (0, _possibleConstructorReturn3.default)(this, (TreeNode.__proto__ || Object.getPrototypeOf(TreeNode)).apply(this, arguments));
  }

  (0, _createClass3.default)(TreeNode, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          expanded = _props.expanded,
          onClick = _props.onClick,
          children = _props.children,
          nodeRenderer = _props.nodeRenderer,
          title = _props.title,
          shouldShowArrow = _props.shouldShowArrow,
          shouldShowPlaceholder = _props.shouldShowPlaceholder;
      var theme = this.context.theme;

      var styles = (0, _createStyles2.default)('TreeNode', theme);

      var renderedNode = (0, _react.createElement)(nodeRenderer, this.props);
      var childNodes = expanded ? children : undefined;

      return _react2.default.createElement(
        'li',
        { 'aria-expanded': expanded, role: 'treeitem', style: styles.treeNodeBase, title: title },
        _react2.default.createElement(
          'div',
          { style: styles.treeNodePreviewContainer, onClick: onClick },
          shouldShowArrow || _react.Children.count(children) > 0 ? _react2.default.createElement(Arrow, { expanded: expanded, styles: styles.treeNodeArrow }) : shouldShowPlaceholder && _react2.default.createElement(
            'span',
            { style: styles.treeNodePlaceholder },
            '\xA0'
          ),
          renderedNode
        ),
        _react2.default.createElement(
          'ol',
          { role: 'group', style: styles.treeNodeChildNodesContainer },
          childNodes
        )
      );
    }
  }]);
  return TreeNode;
}(_react.Component);

TreeNode.propTypes = {
  name: _propTypes2.default.string,
  data: _propTypes2.default.any,

  expanded: _propTypes2.default.bool,
  shouldShowArrow: _propTypes2.default.bool,
  shouldShowPlaceholder: _propTypes2.default.bool,

  nodeRenderer: _propTypes2.default.func,

  onClick: _propTypes2.default.func
};

TreeNode.defaultProps = {
  name: undefined,
  data: undefined,
  expanded: true,

  nodeRenderer: function nodeRenderer(_ref2) {
    var name = _ref2.name;
    return _react2.default.createElement(
      'span',
      null,
      name
    );
  },

  onClick: function onClick() {},

  shouldShowArrow: false,
  shouldShowPlaceholder: true
};

TreeNode.contextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]).isRequired
};

exports.default = TreeNode;

/***/ }),

/***/ 5962:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

var _themes = __webpack_require__(5896);

var themes = _interopRequireWildcard(_themes);

var _base = __webpack_require__(5963);

var _base2 = _interopRequireDefault(_base);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = Object.keys(themes).reduce(function (styles, themeName) {
  styles[themeName] = (0, _base2.default)(themes[themeName]);
  return styles;
}, {});

var createStyles = function createStyles(key, theme) {
  // console.debug(styles, theme, styles[theme])
  if (typeof theme === 'string') {
    return styles[theme][key];
  } else if ((typeof theme === 'undefined' ? 'undefined' : (0, _typeof3.default)(theme)) === 'object') {
    return (0, _base2.default)(theme)[key];
  }
  // Default styles
  return styles['chromeLight'][key];
};

exports.default = createStyles;

/***/ }),

/***/ 5963:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _unselectable = __webpack_require__(5964);

var _unselectable2 = _interopRequireDefault(_unselectable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (theme) {
  return {
    DOMNodePreview: {
      htmlOpenTag: {
        base: {
          color: theme.HTML_TAG_COLOR
        },
        tagName: {
          color: theme.HTML_TAGNAME_COLOR,
          textTransform: theme.HTML_TAGNAME_TEXT_TRANSFORM
        },
        htmlAttributeName: {
          color: theme.HTML_ATTRIBUTE_NAME_COLOR
        },
        htmlAttributeValue: {
          color: theme.HTML_ATTRIBUTE_VALUE_COLOR
        }
      },
      htmlCloseTag: {
        base: {
          color: theme.HTML_TAG_COLOR
        },
        offsetLeft: {
          /* hack: offset placeholder */
          marginLeft: -theme.TREENODE_PADDING_LEFT
        },
        tagName: {
          color: theme.HTML_TAGNAME_COLOR,
          textTransform: theme.HTML_TAGNAME_TEXT_TRANSFORM
        }
      },
      htmlComment: {
        color: theme.HTML_COMMENT_COLOR
      },
      htmlDoctype: {
        color: theme.HTML_DOCTYPE_COLOR
      }
    },

    ObjectName: {
      base: {
        color: theme.OBJECT_NAME_COLOR
      },
      dimmed: {
        opacity: 0.6
      }
    },

    ObjectValue: {
      objectValueNull: {
        color: theme.OBJECT_VALUE_NULL_COLOR
      },
      objectValueUndefined: {
        color: theme.OBJECT_VALUE_UNDEFINED_COLOR
      },
      objectValueRegExp: {
        color: theme.OBJECT_VALUE_REGEXP_COLOR
      },
      objectValueString: {
        color: theme.OBJECT_VALUE_STRING_COLOR
      },
      objectValueSymbol: {
        color: theme.OBJECT_VALUE_SYMBOL_COLOR
      },
      objectValueNumber: {
        color: theme.OBJECT_VALUE_NUMBER_COLOR
      },
      objectValueBoolean: {
        color: theme.OBJECT_VALUE_BOOLEAN_COLOR
      },
      objectValueFunctionKeyword: {
        color: theme.OBJECT_VALUE_FUNCTION_KEYWORD_COLOR,
        fontStyle: 'italic'
      },
      objectValueFunctionName: {
        fontStyle: 'italic'
      }
    },

    TreeNode: {
      treeNodeBase: {
        color: theme.BASE_COLOR,
        backgroundColor: theme.BASE_BACKGROUND_COLOR,

        lineHeight: theme.TREENODE_LINE_HEIGHT,
        cursor: 'default',

        boxSizing: 'border-box',
        listStyle: 'none',

        fontFamily: theme.TREENODE_FONT_FAMILY,
        fontSize: theme.TREENODE_FONT_SIZE
      },
      treeNodePreviewContainer: {},
      treeNodePlaceholder: (0, _extends3.default)({
        whiteSpace: 'pre',

        fontSize: theme.ARROW_FONT_SIZE,
        marginRight: theme.ARROW_MARGIN_RIGHT
      }, _unselectable2.default),
      treeNodeArrow: {
        base: (0, _extends3.default)({
          color: theme.ARROW_COLOR,
          display: 'inline-block',
          // lineHeight: '14px',
          fontSize: theme.ARROW_FONT_SIZE,
          marginRight: theme.ARROW_MARGIN_RIGHT
        }, _unselectable2.default),
        expanded: {
          WebkitTransform: 'rotateZ(90deg)',
          MozTransform: 'rotateZ(90deg)',
          transform: 'rotateZ(90deg)'
        },
        collapsed: {
          WebkitTransform: 'rotateZ(0deg)',
          MozTransform: 'rotateZ(0deg)',
          transform: 'rotateZ(0deg)'
        }
      },
      treeNodeChildNodesContainer: {
        margin: 0, // reset user-agent style
        paddingLeft: theme.TREENODE_PADDING_LEFT
      }
    },

    TableInspector: {
      base: {
        color: theme.BASE_COLOR,

        position: 'relative',
        border: '1px solid ' + theme.TABLE_BORDER_COLOR,
        fontFamily: theme.BASE_FONT_FAMILY,
        fontSize: theme.BASE_FONT_SIZE,
        lineHeight: '120%',
        boxSizing: 'border-box',
        cursor: 'default'
      }
    },

    TableInspectorHeaderContainer: {
      base: {
        top: 0,
        height: '17px',
        left: 0,
        right: 0,
        overflowX: 'hidden'
      },
      table: {
        tableLayout: 'fixed',
        borderSpacing: 0,
        borderCollapse: 'separate',
        height: '100%',
        width: '100%',
        margin: 0
      }
    },

    TableInspectorDataContainer: {
      tr: {
        display: 'table-row'
      },
      td: {
        boxSizing: 'border-box',
        border: 'none', // prevent overrides
        height: '16px', // /* 0.5 * table.background-size height */
        verticalAlign: 'top',
        padding: '1px 4px',
        WebkitUserSelect: 'text',

        whiteSpace: 'nowrap',
        textOverflow: 'ellipsis',
        overflow: 'hidden',
        lineHeight: '14px'
      },
      div: {
        position: 'static',
        top: '17px',
        bottom: 0,
        overflowY: 'overlay',
        transform: 'translateZ(0)',

        left: 0,
        right: 0,
        overflowX: 'hidden'
      },
      table: {
        positon: 'static',
        left: 0,
        top: 0,
        right: 0,
        bottom: 0,
        borderTop: '0 none transparent',
        margin: 0, // prevent user agent stylesheet overrides

        backgroundImage: theme.TABLE_DATA_BACKGROUND_IMAGE,
        backgroundSize: theme.TABLE_DATA_BACKGROUND_SIZE,
        tableLayout: 'fixed',

        // table
        borderSpacing: 0,
        borderCollapse: 'separate',
        // height: '100%',
        width: '100%',

        fontSize: theme.BASE_FONT_SIZE,
        lineHeight: '120%'
      }
    },

    TableInspectorTH: {
      base: {
        position: 'relative', // anchor for sort icon container
        height: 'auto',
        textAlign: 'left',
        backgroundColor: theme.TABLE_TH_BACKGROUND_COLOR,
        borderBottom: '1px solid ' + theme.TABLE_BORDER_COLOR,
        fontWeight: 'normal',
        verticalAlign: 'middle',
        padding: '0 4px',

        whiteSpace: 'nowrap',
        textOverflow: 'ellipsis',
        overflow: 'hidden',
        lineHeight: '14px',

        ':hover': {
          backgroundColor: theme.TABLE_TH_HOVER_COLOR
        }
      },
      div: {
        whiteSpace: 'nowrap',
        textOverflow: 'ellipsis',
        overflow: 'hidden',

        // prevent user agent stylesheet overrides
        fontSize: theme.BASE_FONT_SIZE,
        lineHeight: '120%'
      }
    },

    TableInspectorLeftBorder: {
      none: {
        borderLeft: 'none'
      },
      solid: {
        borderLeft: '1px solid ' + theme.TABLE_BORDER_COLOR
      }
    },

    TableInspectorSortIcon: (0, _extends3.default)({
      display: 'block',
      marginRight: 3, // 4,
      width: 8,
      height: 7,

      marginTop: -7,
      color: theme.TABLE_SORT_ICON_COLOR,
      fontSize: 12
    }, _unselectable2.default)
  };
};

/***/ }),

/***/ 5964:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = {
  WebkitTouchCallout: 'none',
  WebkitUserSelect: 'none',
  KhtmlUserSelect: 'none',
  MozUserSelect: 'none',
  msUserSelect: 'none',
  OUserSelect: 'none',
  userSelect: 'none'
};

/***/ }),

/***/ 5965:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hasChildNodes = hasChildNodes;
var DEFAULT_ROOT_PATH = exports.DEFAULT_ROOT_PATH = '$';

var WILDCARD = '*';

function hasChildNodes(data, dataIterator) {
  return !dataIterator(data).next().done;
}

var wildcardPathsFromLevel = exports.wildcardPathsFromLevel = function wildcardPathsFromLevel(level) {
  // i is depth
  return Array.from({ length: level }, function (_, i) {
    return [DEFAULT_ROOT_PATH].concat(Array.from({ length: i }, function () {
      return '*';
    })).join('.');
  });
};

var getExpandedPaths = exports.getExpandedPaths = function getExpandedPaths(data, dataIterator, expandPaths, expandLevel) {
  var initialState = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};

  var wildcardPaths = [].concat(wildcardPathsFromLevel(expandLevel)).concat(expandPaths).filter(function (path) {
    return typeof path === 'string';
  }); // could be undefined

  var expandedPaths = [];
  wildcardPaths.forEach(function (wildcardPath) {
    var keyPaths = wildcardPath.split('.');
    var populatePaths = function populatePaths(curData, curPath, depth) {
      if (depth === keyPaths.length) {
        expandedPaths.push(curPath);
        return;
      }
      var key = keyPaths[depth];
      if (depth === 0) {
        if (hasChildNodes(curData, dataIterator) && (key === DEFAULT_ROOT_PATH || key === WILDCARD)) {
          populatePaths(curData, DEFAULT_ROOT_PATH, depth + 1);
        }
      } else {
        if (key === WILDCARD) {
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = dataIterator(curData)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var _ref2 = _step.value;
              var name = _ref2.name,
                  _data = _ref2.data;

              if (hasChildNodes(_data, dataIterator)) {
                populatePaths(_data, curPath + '.' + name, depth + 1);
              }
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }
        } else {
          var value = curData[key];
          if (hasChildNodes(value, dataIterator)) {
            populatePaths(value, curPath + '.' + key, depth + 1);
          }
        }
      }
    };

    populatePaths(data, '', 0);
  });

  return expandedPaths.reduce(function (obj, path) {
    obj[path] = true;
    return obj;
  }, initialState);
};

/***/ }),

/***/ 5966:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _ObjectName = __webpack_require__(5967);

var _ObjectName2 = _interopRequireDefault(_ObjectName);

var _ObjectPreview = __webpack_require__(5968);

var _ObjectPreview2 = _interopRequireDefault(_ObjectPreview);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ObjectRootLabel = function ObjectRootLabel(_ref) {
  var name = _ref.name,
      data = _ref.data;

  if (typeof name === 'string') {
    return _react2.default.createElement(
      'span',
      null,
      _react2.default.createElement(_ObjectName2.default, { name: name }),
      _react2.default.createElement(
        'span',
        null,
        ': '
      ),
      _react2.default.createElement(_ObjectPreview2.default, { data: data })
    );
  } else {
    return _react2.default.createElement(_ObjectPreview2.default, { data: data });
  }
};

exports.default = ObjectRootLabel;

/***/ }),

/***/ 5967:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createStyles = __webpack_require__(5962);

var _createStyles2 = _interopRequireDefault(_createStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A view for object property names.
 *
 * If the property name is enumerable (in Object.keys(object)),
 * the property name will be rendered normally.
 *
 * If the property name is not enumerable (`Object.prototype.propertyIsEnumerable()`),
 * the property name will be dimmed to show the difference.
 */
var ObjectName = function ObjectName(_ref, _ref2) {
  var name = _ref.name,
      dimmed = _ref.dimmed,
      styles = _ref.styles;
  var theme = _ref2.theme;

  var themeStyles = (0, _createStyles2.default)('ObjectName', theme);
  var appliedStyles = (0, _extends3.default)({}, themeStyles.base, dimmed ? themeStyles['dimmed'] : {}, styles);

  return _react2.default.createElement(
    'span',
    { style: appliedStyles },
    name
  );
};

ObjectName.propTypes = {
  /** Property name */
  name: _propTypes2.default.string,
  /** Should property name be dimmed */
  dimmed: _propTypes2.default.bool
};

ObjectName.defaultProps = {
  dimmed: false
};

ObjectName.contextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object])
};

exports.default = ObjectName;

/***/ }),

/***/ 5968:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ObjectValue = __webpack_require__(5969);

var _ObjectValue2 = _interopRequireDefault(_ObjectValue);

var _ObjectName = __webpack_require__(5967);

var _ObjectName2 = _interopRequireDefault(_ObjectName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* NOTE: Chrome console.log is italic */
var styles = {
  preview: {
    fontStyle: 'italic'
  }
};

/* intersperse arr with separator */
function intersperse(arr, sep) {
  if (arr.length === 0) {
    return [];
  }

  return arr.slice(1).reduce(function (xs, x) {
    return xs.concat([sep, x]);
  }, [arr[0]]);
}

/**
 * A preview of the object
 */
var ObjectPreview = function ObjectPreview(_ref) {
  var data = _ref.data,
      maxProperties = _ref.maxProperties;

  var object = data;

  if ((typeof object === 'undefined' ? 'undefined' : (0, _typeof3.default)(object)) !== 'object' || object === null || object instanceof Date || object instanceof RegExp) {
    return _react2.default.createElement(_ObjectValue2.default, { object: object });
  }

  if (Array.isArray(object)) {
    return _react2.default.createElement(
      'span',
      { style: styles.preview },
      '[',
      intersperse(object.map(function (element, index) {
        return _react2.default.createElement(_ObjectValue2.default, { key: index, object: element });
      }), ', '),
      ']'
    );
  } else {
    var propertyNodes = [];
    for (var propertyName in object) {
      var propertyValue = object[propertyName];
      if (object.hasOwnProperty(propertyName)) {
        var ellipsis = void 0;
        if (propertyNodes.length === maxProperties - 1 && Object.keys(object).length > maxProperties) {
          ellipsis = _react2.default.createElement(
            'span',
            { key: 'ellipsis' },
            '\u2026'
          );
        }
        propertyNodes.push(_react2.default.createElement(
          'span',
          { key: propertyName },
          _react2.default.createElement(_ObjectName2.default, { name: propertyName || '""' }),
          ':\xA0',
          _react2.default.createElement(_ObjectValue2.default, { object: propertyValue }),
          ellipsis
        ));
        if (ellipsis) break;
      }
    }

    return _react2.default.createElement(
      'span',
      { style: styles.preview },
      object.constructor.name + ' {',
      intersperse(propertyNodes, ', '),
      '}'
    );
  }
};

ObjectPreview.propTypes = {
  /**
   * max number of properties shown in the property view
   */
  maxProperties: _propTypes2.default.number
};
ObjectPreview.defaultProps = {
  maxProperties: 5
};

exports.default = ObjectPreview;

/***/ }),

/***/ 5969:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createStyles = __webpack_require__(5962);

var _createStyles2 = _interopRequireDefault(_createStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A short description of the object values.
 * Can be used to render tree node in ObjectInspector
 * or render objects in TableInspector.
 */
var ObjectValue = function ObjectValue(_ref, _ref2) {
  var object = _ref.object,
      styles = _ref.styles;
  var theme = _ref2.theme;

  var themeStyles = (0, _createStyles2.default)('ObjectValue', theme);

  var mkStyle = function mkStyle(key) {
    return (0, _extends3.default)({}, themeStyles[key], styles);
  };

  switch (typeof object === 'undefined' ? 'undefined' : (0, _typeof3.default)(object)) {
    case 'number':
      return _react2.default.createElement(
        'span',
        { style: mkStyle('objectValueNumber') },
        String(object)
      );
    case 'string':
      return _react2.default.createElement(
        'span',
        { style: mkStyle('objectValueString') },
        '"',
        object,
        '"'
      );
    case 'boolean':
      return _react2.default.createElement(
        'span',
        { style: mkStyle('objectValueBoolean') },
        String(object)
      );
    case 'undefined':
      return _react2.default.createElement(
        'span',
        { style: mkStyle('objectValueUndefined') },
        'undefined'
      );
    case 'object':
      if (object === null) {
        return _react2.default.createElement(
          'span',
          { style: mkStyle('objectValueNull') },
          'null'
        );
      }
      if (object instanceof Date) {
        return _react2.default.createElement(
          'span',
          null,
          object.toString()
        );
      }
      if (object instanceof RegExp) {
        return _react2.default.createElement(
          'span',
          { style: mkStyle('objectValueRegExp') },
          object.toString()
        );
      }
      if (Array.isArray(object)) {
        return _react2.default.createElement(
          'span',
          null,
          'Array[' + object.length + ']'
        );
      }
      if (!object.constructor) {
        return _react2.default.createElement(
          'span',
          null,
          'Object'
        );
      }
      if (typeof object.constructor.isBuffer === 'function' && object.constructor.isBuffer(object)) {
        return _react2.default.createElement(
          'span',
          null,
          'Buffer[' + object.length + ']'
        );
      }

      return _react2.default.createElement(
        'span',
        null,
        object.constructor.name
      );
    case 'function':
      return _react2.default.createElement(
        'span',
        null,
        _react2.default.createElement(
          'span',
          { style: mkStyle('objectValueFunctionKeyword') },
          'function'
        ),
        _react2.default.createElement(
          'span',
          { style: mkStyle('objectValueFunctionName') },
          '\xA0',
          object.name,
          '()'
        )
      );
    case 'symbol':
      return _react2.default.createElement(
        'span',
        { style: mkStyle('objectValueSymbol') },
        object.toString()
      );
    default:
      return _react2.default.createElement('span', null);
  }
};

ObjectValue.propTypes = {
  /** the object to describe */
  object: _propTypes2.default.any
};

ObjectValue.contextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object])
};

exports.default = ObjectValue;

/***/ }),

/***/ 5970:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ObjectName = __webpack_require__(5967);

var _ObjectName2 = _interopRequireDefault(_ObjectName);

var _ObjectValue = __webpack_require__(5969);

var _ObjectValue2 = _interopRequireDefault(_ObjectValue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * if isNonenumerable is specified, render the name dimmed
 */
var ObjectLabel = function ObjectLabel(_ref) {
  var name = _ref.name,
      data = _ref.data,
      isNonenumerable = _ref.isNonenumerable;

  var object = data;

  return _react2.default.createElement(
    'span',
    null,
    _react2.default.createElement(_ObjectName2.default, { name: name, dimmed: isNonenumerable }),
    _react2.default.createElement(
      'span',
      null,
      ': '
    ),
    _react2.default.createElement(_ObjectValue2.default, { object: object })
  );
};

ObjectLabel.propTypes = {
  /** Non enumerable object property will be dimmed */
  isNonenumerable: _propTypes2.default.bool
};

ObjectLabel.defaultProps = {
  isNonenumerable: false
};

exports.default = ObjectLabel;

/***/ }),

/***/ 5971:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = __webpack_require__(5900);

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = __webpack_require__(5901);

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = __webpack_require__(5905);

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = __webpack_require__(5939);

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = __webpack_require__(2);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ThemeProvider = function (_Component) {
  (0, _inherits3.default)(ThemeProvider, _Component);

  function ThemeProvider() {
    (0, _classCallCheck3.default)(this, ThemeProvider);
    return (0, _possibleConstructorReturn3.default)(this, (ThemeProvider.__proto__ || Object.getPrototypeOf(ThemeProvider)).apply(this, arguments));
  }

  (0, _createClass3.default)(ThemeProvider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      var theme = this.props.theme;

      return {
        // createStyles: createStyles
        theme: theme
      };
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children;
    }
  }]);
  return ThemeProvider;
}(_react.Component);

ThemeProvider.childContextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object])
};

exports.default = ThemeProvider;

/***/ }),

/***/ 5972:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

var _classCallCheck2 = __webpack_require__(5900);

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = __webpack_require__(5901);

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = __webpack_require__(5905);

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = __webpack_require__(5939);

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ThemeProvider = __webpack_require__(5971);

var _ThemeProvider2 = _interopRequireDefault(_ThemeProvider);

var _createStyles = __webpack_require__(5962);

var _createStyles2 = _interopRequireDefault(_createStyles);

var _getHeaders2 = __webpack_require__(5973);

var _getHeaders3 = _interopRequireDefault(_getHeaders2);

var _DataContainer = __webpack_require__(5982);

var _DataContainer2 = _interopRequireDefault(_DataContainer);

var _HeaderContainer = __webpack_require__(5983);

var _HeaderContainer2 = _interopRequireDefault(_HeaderContainer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TableInspector = function (_Component) {
  (0, _inherits3.default)(TableInspector, _Component);

  function TableInspector(props) {
    (0, _classCallCheck3.default)(this, TableInspector);

    var _this = (0, _possibleConstructorReturn3.default)(this, (TableInspector.__proto__ || Object.getPrototypeOf(TableInspector)).call(this, props));

    _this.state = {
      sorted: false, // has user ever clicked the <th> tag to sort?
      sortIndexColumn: false, // is index column sorted?
      sortColumn: undefined, // which column is sorted?
      sortAscending: false // is sorting ascending or descending?
    };
    return _this;
  }

  (0, _createClass3.default)(TableInspector, [{
    key: 'handleIndexTHClick',
    value: function handleIndexTHClick() {
      this.setState(function (_ref) {
        var sortIndexColumn = _ref.sortIndexColumn,
            sortAscending = _ref.sortAscending;
        return {
          sorted: true,
          sortIndexColumn: true,
          sortColumn: undefined,
          // when changed to a new column, default to asending
          sortAscending: sortIndexColumn ? !sortAscending : true
        };
      });
    }
  }, {
    key: 'handleTHClick',
    value: function handleTHClick(col) {
      this.setState(function (_ref2) {
        var sortColumn = _ref2.sortColumn,
            sortAscending = _ref2.sortAscending;
        return {
          sorted: true,
          sortIndexColumn: false,
          // update sort column
          sortColumn: col,
          // when changed to a new column, default to asending
          sortAscending: col === sortColumn ? !sortAscending : true
        };
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var data = this.props.data;
      var columns = this.props.columns;

      var theme = this.props.theme;

      var styles = (0, _createStyles2.default)('TableInspector', theme);

      if ((typeof data === 'undefined' ? 'undefined' : (0, _typeof3.default)(data)) !== 'object' || data === null) {
        return _react2.default.createElement('div', null);
      }

      var _getHeaders = (0, _getHeaders3.default)(data),
          rowHeaders = _getHeaders.rowHeaders,
          colHeaders = _getHeaders.colHeaders;

      // columns to be displayed are specified
      // NOTE: there's some space for optimization here


      if (columns !== undefined) {
        colHeaders = columns;
      }

      var rowsData = rowHeaders.map(function (rowHeader) {
        return data[rowHeader];
      });

      var sortIndexColumn = this.state.sortIndexColumn,
          sortColumn = this.state.sortColumn,
          sortAscending = this.state.sortAscending;

      var columnDataWithRowIndexes = void 0; /* row indexes are [0..nRows-1] */
      // TODO: refactor
      if (sortColumn !== undefined) {
        // the column to be sorted (rowsData, column) => [[columnData, rowIndex]]
        columnDataWithRowIndexes = rowsData.map(function (rowData, index) {
          // normalize rowData
          if ((typeof rowData === 'undefined' ? 'undefined' : (0, _typeof3.default)(rowData)) === 'object' && rowData !== null /*&& rowData.hasOwnProperty(sortColumn)*/
          ) {
              var columnData = rowData[sortColumn];
              return [columnData, index];
            }
          return [undefined, index];
        });
      } else {
        if (sortIndexColumn) {
          columnDataWithRowIndexes = rowHeaders.map(function (rowData, index) {
            var columnData = rowHeaders[index];
            return [columnData, index];
          });
        }
      }
      if (columnDataWithRowIndexes !== undefined) {
        // apply a mapper before sorting (because we need to access inside a container)
        var comparator = function comparator(mapper, ascending) {
          return function (a, b) {
            var v1 = mapper(a); // the datum
            var v2 = mapper(b);
            var type1 = typeof v1 === 'undefined' ? 'undefined' : (0, _typeof3.default)(v1);
            var type2 = typeof v2 === 'undefined' ? 'undefined' : (0, _typeof3.default)(v2);
            // use '<' operator to compare same type of values or compare type precedence order #
            var lt = function lt(v1, v2) {
              if (v1 < v2) {
                return -1;
              } else if (v1 > v2) {
                return 1;
              } else {
                return 0;
              }
            };
            var result = void 0;
            if (type1 === type2) {
              result = lt(v1, v2);
            } else {
              // order of different types
              var order = {
                string: 0,
                number: 1,
                object: 2,
                symbol: 3,
                boolean: 4,
                undefined: 5,
                function: 6
              };
              result = lt(order[type1], order[type2]);
            }
            // reverse result if descending
            if (!ascending) result = -result;
            return result;
          };
        };
        var sortedRowIndexes = columnDataWithRowIndexes.sort(comparator(function (item) {
          return item[0];
        }, sortAscending)).map(function (item) {
          return item[1];
        }); // sorted row indexes
        rowHeaders = sortedRowIndexes.map(function (i) {
          return rowHeaders[i];
        });
        rowsData = sortedRowIndexes.map(function (i) {
          return rowsData[i];
        });
      }

      return _react2.default.createElement(
        _ThemeProvider2.default,
        { theme: this.props.theme },
        _react2.default.createElement(
          'div',
          { style: styles.base },
          _react2.default.createElement(_HeaderContainer2.default, {
            columns: colHeaders
            /* for sorting */
            , sorted: this.state.sorted,
            sortIndexColumn: this.state.sortIndexColumn,
            sortColumn: this.state.sortColumn,
            sortAscending: this.state.sortAscending,
            onTHClick: this.handleTHClick.bind(this),
            onIndexTHClick: this.handleIndexTHClick.bind(this)
          }),
          _react2.default.createElement(_DataContainer2.default, { rows: rowHeaders, columns: colHeaders, rowsData: rowsData })
        )
      );
    }
  }]);
  return TableInspector;
}(_react.Component); /**
                      * Specs:
                      * https://developer.chrome.com/devtools/docs/commandline-api#tabledata-columns
                      * https://developer.mozilla.org/en-US/docs/Web/API/Console/table
                      */

exports.default = TableInspector;


TableInspector.propTypes = {
  /**
   * the Javascript object you would like to inspect, either an array or an object
   */
  data: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.object]),
  /**
   * An array of the names of the columns you'd like to display in the table
   */
  columns: _propTypes2.default.array
};

TableInspector.defaultProps = {
  data: undefined,
  columns: undefined,
  theme: 'chromeLight'
};

/***/ }),

/***/ 5973:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = __webpack_require__(5974);

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

exports.default = getHeaders;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Polyfill for running tests
 * `includes` is an ES2016 feature
 */
if (!Array.prototype.includes) {
  Array.prototype.includes = function (searchElement /*, fromIndex*/) {
    var O = Object(this);
    var len = parseInt(O.length) || 0;
    if (len === 0) {
      return false;
    }
    var n = parseInt(arguments[1]) || 0;
    var k;
    if (n >= 0) {
      k = n;
    } else {
      k = len + n;
      if (k < 0) {
        k = 0;
      }
    }
    var currentElement;
    while (k < len) {
      currentElement = O[k];
      if (searchElement === currentElement || searchElement !== searchElement && currentElement !== currentElement) {
        // NaN !== NaN
        return true;
      }
      k++;
    }
    return false;
  };
}

function getHeaders(data) {
  if ((typeof data === 'undefined' ? 'undefined' : (0, _typeof3.default)(data)) === 'object') {
    var rowHeaders = void 0;
    // is an array
    if (Array.isArray(data)) {
      var nRows = data.length;
      rowHeaders = [].concat((0, _toConsumableArray3.default)(Array(nRows).keys()));
    } else if (data !== null) {
      // is an object
      // keys are row indexes
      rowHeaders = Object.keys(data);
    }

    // Time: O(nRows * nCols)
    var colHeaders = rowHeaders.reduce(function (colHeaders, rowHeader) {
      var row = data[rowHeader];
      if ((typeof row === 'undefined' ? 'undefined' : (0, _typeof3.default)(row)) === 'object' && row !== null) {
        /* O(nCols) Could optimize `includes` here */
        var cols = Object.keys(row);
        cols.reduce(function (xs, x) {
          if (!xs.includes(x)) {
            /* xs is the colHeaders to be filled by searching the row's indexes */
            xs.push(x);
          }
          return xs;
        }, colHeaders);
      }
      return colHeaders;
    }, []);
    return {
      rowHeaders: rowHeaders,
      colHeaders: colHeaders
    };
  }
  return undefined;
}

/***/ }),

/***/ 5974:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _from = __webpack_require__(5975);

var _from2 = _interopRequireDefault(_from);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {
      arr2[i] = arr[i];
    }

    return arr2;
  } else {
    return (0, _from2.default)(arr);
  }
};

/***/ }),

/***/ 5975:
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(5976), __esModule: true };

/***/ }),

/***/ 5976:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(5909);
__webpack_require__(5977);
module.exports = __webpack_require__(5862).Array.from;


/***/ }),

/***/ 5977:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var ctx = __webpack_require__(5863);
var $export = __webpack_require__(5860);
var toObject = __webpack_require__(5894);
var call = __webpack_require__(5978);
var isArrayIter = __webpack_require__(5979);
var toLength = __webpack_require__(5884);
var createProperty = __webpack_require__(5980);
var getIterFn = __webpack_require__(5958);

$export($export.S + $export.F * !__webpack_require__(5981)(function (iter) { Array.from(iter); }), 'Array', {
  // 22.1.2.1 Array.from(arrayLike, mapfn = undefined, thisArg = undefined)
  from: function from(arrayLike /* , mapfn = undefined, thisArg = undefined */) {
    var O = toObject(arrayLike);
    var C = typeof this == 'function' ? this : Array;
    var aLen = arguments.length;
    var mapfn = aLen > 1 ? arguments[1] : undefined;
    var mapping = mapfn !== undefined;
    var index = 0;
    var iterFn = getIterFn(O);
    var length, result, step, iterator;
    if (mapping) mapfn = ctx(mapfn, aLen > 2 ? arguments[2] : undefined, 2);
    // if object isn't iterable or it's array with default iterator - use simple case
    if (iterFn != undefined && !(C == Array && isArrayIter(iterFn))) {
      for (iterator = iterFn.call(O), result = new C(); !(step = iterator.next()).done; index++) {
        createProperty(result, index, mapping ? call(iterator, mapfn, [step.value, index], true) : step.value);
      }
    } else {
      length = toLength(O.length);
      for (result = new C(length); length > index; index++) {
        createProperty(result, index, mapping ? mapfn(O[index], index) : O[index]);
      }
    }
    result.length = index;
    return result;
  }
});


/***/ }),

/***/ 5978:
/***/ (function(module, exports, __webpack_require__) {

// call something on iterator step with safe closing on error
var anObject = __webpack_require__(5867);
module.exports = function (iterator, fn, value, entries) {
  try {
    return entries ? fn(anObject(value)[0], value[1]) : fn(value);
  // 7.4.6 IteratorClose(iterator, completion)
  } catch (e) {
    var ret = iterator['return'];
    if (ret !== undefined) anObject(ret.call(iterator));
    throw e;
  }
};


/***/ }),

/***/ 5979:
/***/ (function(module, exports, __webpack_require__) {

// check on default Array iterator
var Iterators = __webpack_require__(5913);
var ITERATOR = __webpack_require__(5919)('iterator');
var ArrayProto = Array.prototype;

module.exports = function (it) {
  return it !== undefined && (Iterators.Array === it || ArrayProto[ITERATOR] === it);
};


/***/ }),

/***/ 5980:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var $defineProperty = __webpack_require__(5866);
var createDesc = __webpack_require__(5874);

module.exports = function (object, index, value) {
  if (index in object) $defineProperty.f(object, index, createDesc(0, value));
  else object[index] = value;
};


/***/ }),

/***/ 5981:
/***/ (function(module, exports, __webpack_require__) {

var ITERATOR = __webpack_require__(5919)('iterator');
var SAFE_CLOSING = false;

try {
  var riter = [7][ITERATOR]();
  riter['return'] = function () { SAFE_CLOSING = true; };
  // eslint-disable-next-line no-throw-literal
  Array.from(riter, function () { throw 2; });
} catch (e) { /* empty */ }

module.exports = function (exec, skipClosing) {
  if (!skipClosing && !SAFE_CLOSING) return false;
  var safe = false;
  try {
    var arr = [7];
    var iter = arr[ITERATOR]();
    iter.next = function () { return { done: safe = true }; };
    arr[ITERATOR] = function () { return iter; };
    exec(arr);
  } catch (e) { /* empty */ }
  return safe;
};


/***/ }),

/***/ 5982:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = __webpack_require__(5906);

var _typeof3 = _interopRequireDefault(_typeof2);

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createStyles = __webpack_require__(5962);

var _createStyles2 = _interopRequireDefault(_createStyles);

var _ObjectValue = __webpack_require__(5969);

var _ObjectValue2 = _interopRequireDefault(_ObjectValue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DataContainer = function DataContainer(_ref, _ref2) {
  var rows = _ref.rows,
      columns = _ref.columns,
      rowsData = _ref.rowsData;
  var theme = _ref2.theme;

  var styles = (0, _createStyles2.default)('TableInspectorDataContainer', theme);
  var borderStyles = (0, _createStyles2.default)('TableInspectorLeftBorder', theme);

  return _react2.default.createElement(
    'div',
    { style: styles.div },
    _react2.default.createElement(
      'table',
      { style: styles.table },
      _react2.default.createElement('colgroup', null),
      _react2.default.createElement(
        'tbody',
        null,
        rows.map(function (row, i) {
          return _react2.default.createElement(
            'tr',
            { key: row, style: styles.tr },
            _react2.default.createElement(
              'td',
              { style: (0, _extends3.default)({}, styles.td, borderStyles.none) },
              row
            ),
            columns.map(function (column) {
              var rowData = rowsData[i];
              // rowData could be
              //  object -> index by key
              //    array -> index by array index
              //    null -> pass
              //  boolean -> pass
              //  string -> pass (hasOwnProperty returns true for [0..len-1])
              //  number -> pass
              //  function -> pass
              //  symbol
              //  undefined -> pass
              if ((typeof rowData === 'undefined' ? 'undefined' : (0, _typeof3.default)(rowData)) === 'object' && rowData !== null && rowData.hasOwnProperty(column)) {
                return _react2.default.createElement(
                  'td',
                  { key: column, style: (0, _extends3.default)({}, styles.td, borderStyles.solid) },
                  _react2.default.createElement(_ObjectValue2.default, { object: rowData[column] })
                );
              } else {
                return _react2.default.createElement('td', { key: column, style: (0, _extends3.default)({}, styles.td, borderStyles.solid) });
              }
            })
          );
        })
      )
    )
  );
};

DataContainer.contextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]).isRequired
};

exports.default = DataContainer;

/***/ }),

/***/ 5983:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createStyles = __webpack_require__(5962);

var _createStyles2 = _interopRequireDefault(_createStyles);

var _TH = __webpack_require__(5984);

var _TH2 = _interopRequireDefault(_TH);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HeaderContainer = function HeaderContainer(_ref, _ref2) {
  var indexColumnText = _ref.indexColumnText,
      columns = _ref.columns,
      sorted = _ref.sorted,
      sortIndexColumn = _ref.sortIndexColumn,
      sortColumn = _ref.sortColumn,
      sortAscending = _ref.sortAscending,
      onTHClick = _ref.onTHClick,
      onIndexTHClick = _ref.onIndexTHClick;
  var theme = _ref2.theme;

  var styles = (0, _createStyles2.default)('TableInspectorHeaderContainer', theme);
  var borderStyles = (0, _createStyles2.default)('TableInspectorLeftBorder', theme);
  return _react2.default.createElement(
    'div',
    { style: styles.base },
    _react2.default.createElement(
      'table',
      { style: styles.table },
      _react2.default.createElement(
        'tbody',
        null,
        _react2.default.createElement(
          'tr',
          null,
          _react2.default.createElement(
            _TH2.default,
            {
              borderStyle: borderStyles.none,
              sorted: sorted && sortIndexColumn,
              sortAscending: sortAscending,
              onClick: onIndexTHClick
            },
            indexColumnText
          ),
          columns.map(function (column) {
            return _react2.default.createElement(
              _TH2.default,
              {
                borderStyle: borderStyles.solid,
                key: column,
                sorted: sorted && sortColumn === column,
                sortAscending: sortAscending,
                onClick: onTHClick.bind(undefined, column)
              },
              column
            );
          })
        )
      )
    )
  );
};

HeaderContainer.defaultProps = {
  indexColumnText: '(index)',
  columns: []
};

HeaderContainer.contextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]).isRequired
};

exports.default = HeaderContainer;

/***/ }),

/***/ 5984:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = __webpack_require__(5895);

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = __webpack_require__(5900);

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = __webpack_require__(5901);

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = __webpack_require__(5905);

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = __webpack_require__(5939);

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createStyles = __webpack_require__(5962);

var _createStyles2 = _interopRequireDefault(_createStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SortIconContainer = function SortIconContainer(props) {
  return _react2.default.createElement(
    'div',
    {
      style: {
        position: 'absolute',
        top: 1,
        right: 0,
        bottom: 1,
        display: 'flex',
        alignItems: 'center'
      }
    },
    props.children
  );
};

var SortIcon = function SortIcon(_ref, _ref2) {
  var sortAscending = _ref.sortAscending;
  var theme = _ref2.theme;

  var glyph = sortAscending ? '▲' : '▼';
  var styles = (0, _createStyles2.default)('TableInspectorSortIcon', theme);
  return _react2.default.createElement(
    'div',
    { style: styles },
    glyph
  );
};

SortIcon.contextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]).isRequired
};

var TH = function (_Component) {
  (0, _inherits3.default)(TH, _Component);

  function TH() {
    var _ref3;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, TH);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref3 = TH.__proto__ || Object.getPrototypeOf(TH)).call.apply(_ref3, [this].concat(args))), _this), _this.state = { hovered: false }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(TH, [{
    key: 'toggleHovered',
    value: function toggleHovered(hovered) {
      this.setState({ hovered: hovered });
    }
  }, {
    key: 'render',
    value: function render() {
      // either not sorted, sort ascending or sort descending
      var _props = this.props,
          borderStyle = _props.borderStyle,
          children = _props.children,
          onClick = _props.onClick,
          sortAscending = _props.sortAscending,
          sorted = _props.sorted,
          props = (0, _objectWithoutProperties3.default)(_props, ['borderStyle', 'children', 'onClick', 'sortAscending', 'sorted']);
      var theme = this.context.theme;

      var styles = (0, _createStyles2.default)('TableInspectorTH', theme);

      return _react2.default.createElement(
        'th',
        (0, _extends3.default)({}, props, {
          style: (0, _extends3.default)({}, styles.base, borderStyle, this.state.hovered ? styles.base[':hover'] : {}),
          onMouseEnter: this.toggleHovered.bind(this, true),
          onMouseLeave: this.toggleHovered.bind(this, false),
          onClick: onClick
        }),
        _react2.default.createElement(
          'div',
          { style: styles.div },
          children
        ),
        sorted && _react2.default.createElement(
          SortIconContainer,
          null,
          _react2.default.createElement(SortIcon, { sortAscending: sortAscending })
        )
      );
    }
  }]);
  return TH;
}(_react.Component);

TH.contextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]).isRequired
};

TH.defaultProps = {
  sortAscending: false,
  sorted: false,
  onClick: undefined
};

exports.default = TH;

/***/ }),

/***/ 5985:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(5856);

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = __webpack_require__(5900);

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = __webpack_require__(5901);

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = __webpack_require__(5905);

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = __webpack_require__(5939);

var _inherits3 = _interopRequireDefault(_inherits2);

var _regenerator = __webpack_require__(5947);

var _regenerator2 = _interopRequireDefault(_regenerator);

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DOMNodePreview = __webpack_require__(5986);

var _DOMNodePreview2 = _interopRequireDefault(_DOMNodePreview);

var _TreeView = __webpack_require__(5959);

var _TreeView2 = _interopRequireDefault(_TreeView);

var _shouldInline = __webpack_require__(5987);

var _shouldInline2 = _interopRequireDefault(_shouldInline);

var _ThemeProvider = __webpack_require__(5971);

var _ThemeProvider2 = _interopRequireDefault(_ThemeProvider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var domIterator = /*#__PURE__*/_regenerator2.default.mark(function domIterator(data) {
  var textInlined, i, node;
  return _regenerator2.default.wrap(function domIterator$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          if (!(data && data.childNodes)) {
            _context.next = 17;
            break;
          }

          textInlined = (0, _shouldInline2.default)(data);

          if (!textInlined) {
            _context.next = 4;
            break;
          }

          return _context.abrupt('return');

        case 4:
          i = 0;

        case 5:
          if (!(i < data.childNodes.length)) {
            _context.next = 14;
            break;
          }

          node = data.childNodes[i];

          if (!(node.nodeType === Node.TEXT_NODE && node.textContent.trim().length === 0)) {
            _context.next = 9;
            break;
          }

          return _context.abrupt('continue', 11);

        case 9:
          _context.next = 11;
          return {
            name: node.tagName + '[' + i + ']',
            data: node
          };

        case 11:
          i++;
          _context.next = 5;
          break;

        case 14:
          if (!data.tagName) {
            _context.next = 17;
            break;
          }

          _context.next = 17;
          return {
            name: 'CLOSE_TAG',
            data: {
              tagName: data.tagName
            },
            isCloseTag: true
          };

        case 17:
        case 'end':
          return _context.stop();
      }
    }
  }, domIterator, this);
});

var DOMInspector = function (_Component) {
  (0, _inherits3.default)(DOMInspector, _Component);

  function DOMInspector() {
    (0, _classCallCheck3.default)(this, DOMInspector);
    return (0, _possibleConstructorReturn3.default)(this, (DOMInspector.__proto__ || Object.getPrototypeOf(DOMInspector)).apply(this, arguments));
  }

  (0, _createClass3.default)(DOMInspector, [{
    key: 'render',
    value: function render() {
      var nodeRenderer = _DOMNodePreview2.default;

      return _react2.default.createElement(
        _ThemeProvider2.default,
        { theme: this.props.theme },
        _react2.default.createElement(_TreeView2.default, (0, _extends3.default)({ nodeRenderer: nodeRenderer, dataIterator: domIterator }, this.props))
      );
    }
  }]);
  return DOMInspector;
}(_react.Component);

DOMInspector.propTypes = {
  /** The DOM Node to inspect */
  data: _propTypes2.default.object.isRequired
};
DOMInspector.defaultProps = {
  theme: 'chromeLight'
};
exports.default = DOMInspector;

/***/ }),

/***/ 5986:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(2815);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createStyles = __webpack_require__(5962);

var _createStyles2 = _interopRequireDefault(_createStyles);

var _shouldInline = __webpack_require__(5987);

var _shouldInline2 = _interopRequireDefault(_shouldInline);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var OpenTag = function OpenTag(_ref) {
  var tagName = _ref.tagName,
      attributes = _ref.attributes,
      styles = _ref.styles;

  return _react2.default.createElement(
    'span',
    { style: styles.base },
    '<',
    _react2.default.createElement(
      'span',
      { style: styles.tagName },
      tagName
    ),
    function () {
      if (attributes) {
        var attributeNodes = [];
        for (var i = 0; i < attributes.length; i++) {
          var attribute = attributes[i];
          attributeNodes.push(_react2.default.createElement(
            'span',
            { key: i },
            ' ',
            _react2.default.createElement(
              'span',
              { style: styles.htmlAttributeName },
              attribute.name
            ),
            '="',
            _react2.default.createElement(
              'span',
              { style: styles.htmlAttributeValue },
              attribute.value
            ),
            '"'
          ));
        }
        return attributeNodes;
      }
    }(),
    '>'
  );
};

// isChildNode style={{ marginLeft: -12 /* hack: offset placeholder */ }}
var CloseTag = function CloseTag(_ref2) {
  var tagName = _ref2.tagName,
      _ref2$isChildNode = _ref2.isChildNode,
      isChildNode = _ref2$isChildNode === undefined ? false : _ref2$isChildNode,
      styles = _ref2.styles;
  return _react2.default.createElement(
    'span',
    { style: Object.assign({}, styles.base, isChildNode && styles.offsetLeft) },
    '</',
    _react2.default.createElement(
      'span',
      { style: styles.tagName },
      tagName
    ),
    '>'
  );
};

var nameByNodeType = {
  1: 'ELEMENT_NODE',
  3: 'TEXT_NODE',
  7: 'PROCESSING_INSTRUCTION_NODE',
  8: 'COMMENT_NODE',
  9: 'DOCUMENT_NODE',
  10: 'DOCUMENT_TYPE_NODE', // http://stackoverflow.com/questions/6088972/get-doctype-of-an-html-as-string-with-javascript
  11: 'DOCUMENT_FRAGMENT_NODE'
};

var DOMNodePreview = function DOMNodePreview(_ref3, _ref4) {
  var isCloseTag = _ref3.isCloseTag,
      data = _ref3.data,
      expanded = _ref3.expanded;
  var theme = _ref4.theme;

  var styles = (0, _createStyles2.default)('DOMNodePreview', theme);

  if (isCloseTag) {
    return _react2.default.createElement(CloseTag, { styles: styles.htmlCloseTag, isChildNode: true, tagName: data.tagName });
  }

  switch (data.nodeType) {
    case Node.ELEMENT_NODE:
      return _react2.default.createElement(
        'span',
        null,
        _react2.default.createElement(OpenTag, {
          tagName: data.tagName,
          attributes: data.attributes,
          styles: styles.htmlOpenTag
        }),
        (0, _shouldInline2.default)(data) ? data.textContent : !expanded && '…',
        !expanded && _react2.default.createElement(CloseTag, { tagName: data.tagName, styles: styles.htmlCloseTag })
      );
    case Node.TEXT_NODE:
      return _react2.default.createElement(
        'span',
        null,
        data.textContent
      );
    case Node.CDATA_SECTION_NODE:
      return _react2.default.createElement(
        'span',
        null,
        '<![CDATA[' + data.textContent + ']]>'
      );
    case Node.COMMENT_NODE:
      return _react2.default.createElement(
        'span',
        { style: styles.htmlComment },
        '<!--',
        data.textContent,
        '-->'
      );
    case Node.PROCESSING_INSTRUCTION_NODE:
      return _react2.default.createElement(
        'span',
        null,
        data.nodeName
      );
    case Node.DOCUMENT_TYPE_NODE:
      return _react2.default.createElement(
        'span',
        { style: styles.htmlDoctype },
        '<!DOCTYPE ',
        data.name,
        data.publicId ? ' PUBLIC "' + data.publicId + '"' : '',
        !data.publicId && data.systemId ? ' SYSTEM' : '',
        data.systemId ? ' "' + data.systemId + '"' : '',
        '>'
      );
    case Node.DOCUMENT_NODE:
      return _react2.default.createElement(
        'span',
        null,
        data.nodeName
      );
    case Node.DOCUMENT_FRAGMENT_NODE:
      return _react2.default.createElement(
        'span',
        null,
        data.nodeName
      );
    default:
      return _react2.default.createElement(
        'span',
        null,
        nameByNodeType[data.nodeType]
      );
  }
};

DOMNodePreview.propTypes = {
  /** If true, just render a close tag */
  isCloseTag: _propTypes2.default.bool,
  /**  */
  name: _propTypes2.default.string,
  /** The DOM Node */
  data: _propTypes2.default.object.isRequired,
  /** Whether the DOM node has been expanded. */
  expanded: _propTypes2.default.bool.isRequired
};

DOMNodePreview.contextTypes = {
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]).isRequired
};

exports.default = DOMNodePreview;

/***/ }),

/***/ 5987:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var TEXT_NODE_MAX_INLINE_CHARS = 80;

var shouldInline = function shouldInline(data) {
  return data.childNodes.length === 0 || data.childNodes.length === 1 && data.childNodes[0].nodeType === Node.TEXT_NODE && data.textContent.length < TEXT_NODE_MAX_INLINE_CHARS;
};

exports.default = shouldInline;

/***/ }),

/***/ 5988:
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(5989)
var isWindow = __webpack_require__(5990)

function isNode (val) {
  if (!isObject(val) || !isWindow(window) || typeof window.Node !== 'function') {
    return false
  }

  return typeof val.nodeType === 'number' &&
    typeof val.nodeName === 'string'
}

module.exports = isNode


/***/ }),

/***/ 5989:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = function isObject(x) {
	return typeof x === "object" && x !== null;
};


/***/ }),

/***/ 5990:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = function (obj) {

  if (obj == null) {
    return false;
  }

  var o = Object(obj);

  return o === o.window;
};


/***/ }),

/***/ 5991:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "useStyles", function() { return useStyles; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "baseStyles", function() { return baseStyles; });
const base = {
  ObjectPreview: {
    objectDescription: {
      fontStyle: 'italic' },

    preview: {
      fontStyle: 'italic' },

    arrayMaxProperties: 5,
    objectMaxProperties: 3 },


  ObjectName: {
    base: {},
    dimmed: {
      opacity: 0.6 } },



  ObjectValue: {
    objectValueNull: {
      color: 'var(--color-accent-success)' },

    objectValueUndefined: {
      color: 'var(--color-accent-success)' },

    objectValueRegExp: {
      color: 'var(--color-accent-success)' },

    objectValueString: {
      color: 'var(--color-accent-success)',
      wordBreak: 'break-all' },

    objectValueSymbol: {
      color: 'var(--color-accent-success)' },

    objectValueNumber: {
      color: 'var(--color-accent-success)' },

    objectValueBoolean: {
      color: 'var(--color-accent-success)' },

    objectValueFunctionPrefix: {
      color: 'var(--color-accent-success)',
      fontStyle: 'italic' },

    objectValueFunctionName: {
      fontStyle: 'italic' } } };




/**
                                  * Hook to get the component styles for the current theme.
                                  * @param {string} baseStylesKey - Name of the component to be styled
                                  */
const useStyles = baseStylesKey => base[baseStylesKey];

const baseStyles = {
  BASE_BACKGROUND_COLOR: 'transparent',
  ARROW_MARGIN_RIGHT: 4,
  ARROW_FONT_SIZE: 8,
  ARROW_COLOR: 'var(--content-tertiary)' };

/***/ }),

/***/ 5992:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ObjectName__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5993);
/* harmony import */ var _ObjectPreview__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5994);




const ObjectRootLabel = ({ name, data }) => {
  if (typeof name === 'string') {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null,
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ObjectName__WEBPACK_IMPORTED_MODULE_1__["default"], { name: name }),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, ': '),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ObjectPreview__WEBPACK_IMPORTED_MODULE_2__["default"], { data: data })));


  }

  return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ObjectPreview__WEBPACK_IMPORTED_MODULE_2__["default"], { data: data });
};

/* harmony default export */ __webpack_exports__["default"] = (ObjectRootLabel);

/***/ }),

/***/ 5993:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5991);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};



/**
                                        * A view for object property names.
                                        *
                                        * If the property name is enumerable (in Object.keys(object)),
                                        * the property name will be rendered normally.
                                        *
                                        * If the property name is not enumerable (`Object.prototype.propertyIsEnumerable()`),
                                        * the property name will be dimmed to show the difference.
                                        */
const ObjectName = ({ name, dimmed = false, styles = {} }) => {
  const themeStyles = Object(_styles__WEBPACK_IMPORTED_MODULE_2__["useStyles"])('ObjectName'),
  appliedStyles = _extends({},
  themeStyles.base,
  dimmed ? themeStyles.dimmed : {},
  styles);


  return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: appliedStyles }, name);
};

ObjectName.propTypes = {
  /** Property name */
  name: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.string,

  /** Should property name be dimmed */
  dimmed: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.bool };


ObjectName.defaultProps = {
  name: '',
  dimmed: false };


/* harmony default export */ __webpack_exports__["default"] = (ObjectName);

/***/ }),

/***/ 5994:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ObjectValue__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5995);
/* harmony import */ var _ObjectName__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5993);
/* harmony import */ var _styles__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5991);







/* Intersperse arr with separator */
// eslint-disable-next-line require-jsdoc
function intersperse(arr, sep) {
  if (arr.length === 0) {
    return [];
  }

  return arr.slice(1).reduce((xs, x) => xs.concat([sep, x]), [arr[0]]);
}

/**
   * A preview of the object
   */
const ObjectPreview = ({ data }) => {
  const styles = Object(_styles__WEBPACK_IMPORTED_MODULE_3__["useStyles"])('ObjectPreview'),
  object = data;

  if (
  typeof object !== 'object' ||
  object === null ||
  object instanceof Date ||
  object instanceof RegExp)
  {
    return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ObjectValue__WEBPACK_IMPORTED_MODULE_1__["default"], { object: object });
  }

  if (Array.isArray(object)) {
    const maxProperties = styles.arrayMaxProperties,
    previewArray = object.
    slice(0, maxProperties).
    map((element, index) => react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ObjectValue__WEBPACK_IMPORTED_MODULE_1__["default"], { key: index, object: element }));

    if (object.length > maxProperties) {
      previewArray.push(react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: 'ellipsis' }, '\u2026'));
    }

    const arrayLength = object.length;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: styles.objectDescription },
          arrayLength === 0 ? '' : `(${arrayLength})\xa0`),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: styles.preview }, '[',

          intersperse(previewArray, ', '), ']')));




  }

  const maxProperties = styles.objectMaxProperties,

  propertyNodes = [];

  // eslint-disable-next-line
  for (const propertyName in object) {
    const propertyValue = object[propertyName];

    if (Object.prototype.hasOwnProperty.call(object, propertyName)) {
      let ellipsis;

      if (
      propertyNodes.length === maxProperties - 1 &&
      Object.keys(object).length > maxProperties)
      {
        ellipsis = react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: 'ellipsis' }, '\u2026');
      }

      propertyNodes.push(
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: propertyName },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ObjectName__WEBPACK_IMPORTED_MODULE_2__["default"], { name: propertyName || '""' }), ':\xA0',

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ObjectValue__WEBPACK_IMPORTED_MODULE_1__["default"], { object: propertyValue }),
        ellipsis));


      if (ellipsis) break;
    }
  }

  const objectConstructorName = object.constructor ? object.constructor.name : 'Object';

  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: styles.objectDescription },
        objectConstructorName === 'Object' ? '' : `${objectConstructorName} `),

      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: styles.preview },
        '{',
        intersperse(propertyNodes, ', '),
        '}')));



};

/* harmony default export */ __webpack_exports__["default"] = (ObjectPreview);

/***/ }),

/***/ 5995:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5991);
/* harmony import */ var _WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5996);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};






/**
                                             * A short description of the object values.
                                             * Can be used to render tree node in ObjectInspector
                                             * or render objects in TableInspector.
                                             */
const ObjectValue = ({ object, styles }) => {
  const themeStyles = Object(_styles__WEBPACK_IMPORTED_MODULE_2__["useStyles"])('ObjectValue'),

  mkStyle = key => _extends({}, themeStyles[key], styles);

  switch (typeof object) {
    case 'number':
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueNumber') }, String(object));

    case 'string':
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueString') }, '"',

          !_.isEmpty(object) && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_3__["default"], { sentence: object }), '"'));




    case 'boolean':
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueBoolean') }, String(object)));


    case 'undefined':
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueUndefined') }, 'undefined');

    case 'object':
      if (object === null) {
        return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueNull') }, 'null');
      }

      if (object instanceof Date) {
        return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, object.toString());
      }

      if (object instanceof RegExp) {
        return (
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueRegExp') }, object.toString()));

      }

      if (Array.isArray(object)) {
        return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, `[${object.length}]`);
      }

      if (!object.constructor) {
        return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, String('{…}'));
      }

      if (typeof object.constructor.isBuffer === 'function' && object.constructor.isBuffer(object)) {
        return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, `Buffer[${object.length}]`);
      }

      if (object.constructor.name === 'Object') {
        const isEmpty = !Object.getOwnPropertyNames(object).length,
        style = { fontStyle: 'italic' };

        return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: style }, isEmpty ? String('{}') : String('{…}'));
      }

      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, object.constructor.name);

    case 'function':
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueFunctionPrefix') }, '\u0192\xA0'),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueFunctionName') },
            `${object.name}()`)));




    case 'symbol':
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: mkStyle('objectValueSymbol') }, object.toString()));


    default:
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null);}

};

ObjectValue.propTypes = {
  // The object to describe
  object: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.any // eslint-disable-line react/forbid-prop-types
};

ObjectValue.defaultProps = {
  object: undefined };


/* harmony default export */ __webpack_exports__["default"] = (ObjectValue);
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5996:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return WhitespaceFormatter; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);


const NULL = '\u20E0',
SPACE = '\u00B7',
TAB = '\u2192',
CARRIAGE_RETURN = '\u21B5',
CharMap = {
  0: NULL,
  9: TAB,
  10: CARRIAGE_RETURN,
  13: CARRIAGE_RETURN,
  32: SPACE };let


WhitespaceFormatter = class WhitespaceFormatter extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  getMessage(message) {
    if (message === null) {
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'wf__nl', title: 'New line' }, '\n');
    }

    return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'wf__tk' }, message);
  }

  getParsedMessage(sentence) {
    if (_.isEmpty(sentence)) {
      return [null, null, null];
    }

    // Figure out the start boundary characters
    let startBoundary = '',
    endBoundary = '',

    i = 0,
    isEmpty = false;

    // Find empty starting boundary character
    while (sentence.charCodeAt(i) in CharMap) {
      startBoundary += CharMap[sentence.charCodeAt(i)];

      // If we could reach the end then the complete string is empty
      if (++i === sentence.length) {
        isEmpty = true;
        break;
      }
    }

    if (isEmpty) {
      return [startBoundary];
    }

    i = sentence.length - 1;

    // Find empty starting boundary character
    while (sentence.charCodeAt(i) in CharMap) {
      endBoundary = CharMap[sentence.charCodeAt(i)] + endBoundary;

      // This should not happen, but just in case it happened
      if (--i === -1) {
        break;
      }
    }

    return [startBoundary, sentence.trim(), endBoundary];
  }

  getWhitespaces(whitespaces) {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,

        _.map(whitespaces, (whitespace, index) => {
          if (whitespace === SPACE) {
            return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: index, className: 'wf__sp', title: 'Single space' }, ' ');
          }

          if (whitespace === TAB) {
            return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: index, className: 'wf__tb', title: 'Tab' }, '\t');
          }

          return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { key: index, className: 'wf__ch' }, whitespace);
        })));



  }

  render() {
    const line = _.isNil(this.props.sentence) ? [null, '', null] : this.getParsedMessage(String(this.props.sentence));

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'wf__item' },
        this.props.quoteStart && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'wf__qt' }),
        line[0] !== null && this.getWhitespaces(line[0]),

        this.getMessage(line[1]),

        line[2] !== null && this.getWhitespaces(line[2]),

        this.props.quoteEnd && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'wf__qt' })));


  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5997:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _object_ObjectName__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5993);
/* harmony import */ var _object_ObjectValue__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5995);






/**
                                                 * If isNonenumerable is specified, render the name dimmed
                                                 */
const ObjectLabel = ({
  name, data, isNonenumerable = false, styles = {} }) =>

react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { style: styles },
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_object_ObjectName__WEBPACK_IMPORTED_MODULE_2__["default"], { name: name, dimmed: isNonenumerable }),
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, ': '),
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_object_ObjectValue__WEBPACK_IMPORTED_MODULE_3__["default"], { object: data }));



ObjectLabel.propTypes = {
  /** Non enumerable object property will be dimmed */
  isNonenumerable: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.bool };


ObjectLabel.defaultProps = {
  isNonenumerable: false };


/* harmony default export */ __webpack_exports__["default"] = (ObjectLabel);

/***/ }),

/***/ 5998:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleNetworkItem; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _postman_pretty_ms__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3286);
/* harmony import */ var _postman_pretty_ms__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_postman_pretty_ms__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _ConsoleListItemPretty_ConsoleListItemPretty__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5999);
/* harmony import */ var _ConsoleListItemRaw_ConsoleListItemRaw__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6002);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(2934);









/**
                                                                        * Data should be of the following format
                                                                        * data:
                                                                        *  request:
                                                                        *  response:
                                                                        *  session:
                                                                        *  timings:
                                                                        */let

ConsoleNetworkItem = class ConsoleNetworkItem extends react__WEBPACK_IMPORTED_MODULE_0__["PureComponent"] {
  constructor(props) {
    super(props);

    this.state = { activeTab: 'pretty' };

    this.toggleView = this.toggleView.bind(this);
    this.handleToggle = this.handleToggle.bind(this);
    this.getButtonText = this.getButtonText.bind(this);
    this.viewLargeBody = this.viewLargeBody.bind(this);
  }

  componentDidUpdate() {
    Object(react_dom__WEBPACK_IMPORTED_MODULE_1__["findDOMNode"])(this).scrollIntoViewIfNeeded();
  }

  getRequestHead(data) {
    // Use the href property and then fallback to url
    return `${data.request.method} ${data.request.href || data.request.url}`;
  }

  getNetworkErrorOrWarning(data) {
    if (data.error) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__network-error' },
          `Error: ${data.error.message || data.error}`));


    }

    if (data.warning) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__network-warning' },
          `Warning: ${data.warning.message || data.warning}`));


    }
  }

  getStatusCode(data) {
    if (data.redirect === true) {
      return _.get(this.props, 'data.response.statusCode');
    }

    return _.get(this.props, 'data.response.code');
  }

  getButtonText() {
    if (this.state.activeTab === 'pretty') {
      return 'Show raw log';
    }

    return 'Show pretty log';
  }

  toggleView() {
    if (this.state.activeTab === 'pretty') {
      return this.setState({ activeTab: 'raw' });
    }

    return this.setState({ activeTab: 'pretty' });
  }

  handleToggle() {
    this.props.toggleExpanded();
  }

  /**
    * A utility helper method that prettifies raw millisecond counts and returns it.
    *
    * @param {Number} ms - The raw millisecond count, usually from response times.
    * @returns {String} - The prettified time, scaled to units of time, depending on the input value.
    */
  formatTime(ms) {
    return ms < 1998 ? `${_.ceil(ms, 2)} ms` :
    _postman_pretty_ms__WEBPACK_IMPORTED_MODULE_3___default()(ms || 0, {
      secondsDecimalDigits: 2,
      keepDecimalsOnWholeSeconds: true,
      padUnits: true });

  }

  viewLargeBody(bodyType) {
    this.props.viewLargeBody(this.props.id, bodyType);
  }

  render() {
    const responseTime = _.get(this.props, 'data.response.responseTime');

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__network-wrap' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__network-msg', onClick: this.handleToggle },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: classnames__WEBPACK_IMPORTED_MODULE_2___default()('network-expand__caret', { down: this.props.isExpanded }) }, '\u25B6'),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'network__message' },

            this.getRequestHead(this.props.data)),


          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'network__response-meta' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'network__response-code' }, this.getStatusCode(this.props.data)),

            Boolean(responseTime) &&

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'separator' }),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'network__response-time' }, this.formatTime(responseTime))))),






        this.props.isExpanded &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__network-wrap--expanded' },
          this.getNetworkErrorOrWarning(this.props.data),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__network-expanded' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'network-expanded__left' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: classnames__WEBPACK_IMPORTED_MODULE_2___default()({ 'is-hidden': this.state.activeTab !== 'pretty' }) },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleListItemPretty_ConsoleListItemPretty__WEBPACK_IMPORTED_MODULE_4__["default"], {
                  data: this.props.data,
                  viewLargeBody: this.viewLargeBody })),


              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: classnames__WEBPACK_IMPORTED_MODULE_2___default()({ 'is-hidden': this.state.activeTab !== 'raw' }) },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleListItemRaw_ConsoleListItemRaw__WEBPACK_IMPORTED_MODULE_5__["default"], {
                  data: this.props.data,
                  viewLargeBody: this.viewLargeBody }))),




            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'network-expanded__right' },

              !(this.props.data.browserRequest || this.props.data.redirect || this.props.data.error) &&
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_6__["Button"], {
                  className: 'network__switch-view',
                  type: 'text',
                  onClick: this.toggleView },

                this.getButtonText()))))));










  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 5999:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleListItemPretty; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_inspector__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5855);
/* harmony import */ var react_inspector__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_inspector__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _provider_ObjectInspector_ObjectLabel__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5997);
/* harmony import */ var _provider_ObjectInspector_styles__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5991);
/* harmony import */ var _ConsoleNetworkFormatter__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6000);
/* harmony import */ var _js_constants_RequestDataModeConstants__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2662);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(3229);
/* harmony import */ var _ConsoleBodyViewer_ConsoleBodyViewer__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(6001);
/* harmony import */ var _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(3269);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};













const REQUEST_HEADER_WARNING = 'This request did not get sent completely and might not have all the required system headers.',
REQUEST_HEADER_XHR_AGENT_WARNING = 'Some headers may be missing. Send this request with the Postman Desktop Agent to view accurate request headers.',
RESPONSE_HEADER_XHR_AGENT_WARNING = 'Some headers may be missing. Send this request with the Postman Desktop Agent to view accurate response headers.';let

ConsoleListItemPretty = class ConsoleListItemPretty extends react__WEBPACK_IMPORTED_MODULE_0__["PureComponent"] {
  constructor(props) {
    super(props);

    this.getBodyView = this.getBodyView.bind(this);
  }

  getRequestBody(request) {
    // Check for an ignored body and bail
    if (_.get(request, 'body.___ignored___')) {
      return { ___ignored___: true };
    }


    const mode = _.get(request, 'body.mode', _js_constants_RequestDataModeConstants__WEBPACK_IMPORTED_MODULE_5__["REQUEST_DATA_MODE_RAW"]),
    body = _.get(request, ['body', mode]);

    // Return empty or raw body as it is
    if (!body || body === '""' || mode === _js_constants_RequestDataModeConstants__WEBPACK_IMPORTED_MODULE_5__["REQUEST_DATA_MODE_RAW"]) {
      return body;
    }

    // At this moment the datamode could be any of form-data, url-encoded or graphql
    if (Array.isArray(body)) {
      return body.reduce((acc, b) => {
        if (b.disabled) {
          return acc;
        }

        // Check if the key already exists then
        if (acc[b.key]) {
          if (Array.isArray(acc[b.key])) {
            acc[b.key].push(b.value);
          } else {
            acc[b.key] = [acc[b.key], b.value];
          }
        } else {
          acc[b.key] = b.value;
        }

        return acc;
      }, {});
    }

    return body;
  }

  getResponseBody(response) {
    // Check for unsupported body and bail
    if (_.get(response, 'body.___unsupported___')) {
      return { ___unsupported___: true };
    }

    // Check for an ignored body and bail
    if (_.get(response, 'body.___ignored___')) {
      return { ___ignored___: true };
    }

    // Return the response body
    return _.get(response, 'body');
  }

  getHeaders(data) {
    if (!(data && data.headers)) {
      return;
    }

    return _.filter(data.headers, header => !header.disabled);
  }

  getTheme() {
    return _extends({ TREENODE_PADDING_LEFT: 8 }, _provider_ObjectInspector_styles__WEBPACK_IMPORTED_MODULE_3__["baseStyles"]);
  }

  getView(name, data, isExpanded, info) {
    if (_.isArray(data) || !_.isObject(data)) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleNetworkFormatter__WEBPACK_IMPORTED_MODULE_4__["default"], {
          isExpanded: isExpanded,
          name: name,
          data: data,
          info: info }));


    }

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react_inspector__WEBPACK_IMPORTED_MODULE_1___default.a, {
        data: data,
        theme: this.getTheme(),
        name: name,
        nodeRenderer: this.nodeRenderer,
        expandLevel: isExpanded ? 1 : 0 }));


  }

  getBodyView(name, data, bodyType, canViewInEditor) {
    const canPreviewInline = !(_.get(data, '___ignored___') || _.get(data, '___unsupported___'));

    if (!(canPreviewInline && _.isObject(data))) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ConsoleBodyViewer_ConsoleBodyViewer__WEBPACK_IMPORTED_MODULE_8__["default"], {
          name: name,
          data: data,
          viewLargeBody: this.props.viewLargeBody,
          bodyType: bodyType,
          isExpanded: !canPreviewInline,
          canViewInEditor: canViewInEditor }));


    }

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react_inspector__WEBPACK_IMPORTED_MODULE_1___default.a, {
        data: data,
        theme: this.getTheme(),
        name: name,
        nodeRenderer: this.nodeRendererBody.bind(this, bodyType, canViewInEditor) }));


  }

  getRequestHeadersError(data, responseStarted) {
    if (!_.get(this.props, 'data.request.headers.length')) {
      return;
    }

    if (!responseStarted && this.props.data.error) {
      return REQUEST_HEADER_WARNING;
    }

    if (data && data.agentUsed === _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_9__["TYPES"].XHR) {
      return REQUEST_HEADER_XHR_AGENT_WARNING;
    }
  }

  viewLargeBody(bodyType, e) {
    e && e.stopPropagation();
    this.props.viewLargeBody(bodyType);
  }

  nodeRenderer({
    depth, name, data, isNonenumerable, shouldShowArrow })
  {
    if (depth === 0) {
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'node-renderer__root-node' }, name);
    }

    let styles;

    if (shouldShowArrow) {
      styles = { cursor: 'pointer' };
    }

    return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_ObjectInspector_ObjectLabel__WEBPACK_IMPORTED_MODULE_2__["default"], { name: name, data: data, isNonenumerable: isNonenumerable, styles: styles });
  }

  nodeRendererBody(bodyType, canViewInEditor, {
    depth, name, data, isNonenumerable, shouldShowArrow })
  {
    if (depth === 0) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'node-renderer__root-node' },
          name,

          canViewInEditor &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_6__["Button"], {
              type: 'icon',
              onClick: this.viewLargeBody.bind(this, bodyType),
              className: 'console__large-body__btn',
              tooltip: 'Open in Editor' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_7__["default"], { size: 'xs', className: 'console__body-viewer__open-icon' }))));





    }

    let styles;

    if (shouldShowArrow) {
      styles = { cursor: 'pointer' };
    }

    return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_ObjectInspector_ObjectLabel__WEBPACK_IMPORTED_MODULE_2__["default"], { name: name, data: data, isNonenumerable: isNonenumerable, styles: styles });
  }

  render() {
    const requestBody = this.getRequestBody(this.props.data.request),
    requestBodyMode = _.get(this.props, 'data.request.body.mode'),
    responseBody = this.getResponseBody(this.props.data.response),
    requestHeader = this.getHeaders(this.props.data.request),
    responseHeaders = this.getHeaders(this.props.data.response),
    certificate = _.get(this.props, 'data.request.certificate'),
    proxy = _.get(this.props, 'data.request.proxy'),
    session = _.get(this.props, 'data.session'),
    sessions = _.get(this.props, 'data.history.execution.sessions', {}),
    sessionKeys = _.keys(sessions),
    lastSessionKey = sessionKeys[sessionKeys.length - 1],
    responseStarted = !_.isEmpty(sessions[lastSessionKey]);

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-list__pretty' },

        !_.isEmpty(certificate) && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'pretty__certificate' }, this.getView('Client Certificate', certificate)),


        !_.isEmpty(proxy) &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'pretty__proxy' },

          this.getView('Proxy', proxy, true) // Expanded by default
        ),




        !_.isEmpty(session) && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'pretty__network' }, this.getView('Network', session)),


        !_.isEmpty(requestHeader) &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'pretty__request-headers' },

          this.getView('Request Headers', requestHeader, true, this.getRequestHeadersError(this.props.data, responseStarted)) // Expanded by default
        ),




        !_.isUndefined(requestBody) &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'pretty__request-body' }, this.getBodyView('Request Body', requestBody, 'request', requestBodyMode === 'raw')) // Can only open in editor if requestBodyMode is raw
        ,

        !_.isEmpty(responseHeaders) &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'pretty__response-headers' },

          this.getView('Response Headers', responseHeaders, true, _.get(this.props.data, 'agentUsed') === _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_9__["TYPES"].XHR && RESPONSE_HEADER_XHR_AGENT_WARNING) // Expanded by default
        ),




        !_.isUndefined(responseBody) && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'pretty__response-body' }, this.getBodyView('Response Body', responseBody, 'response', true))));



  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6000:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleNetworkFormatter; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5996);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Icons_InformationIconNew__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(3624);




let

ConsoleNetworkFormatter = class ConsoleNetworkFormatter extends react__WEBPACK_IMPORTED_MODULE_0__["PureComponent"] {
  constructor(props) {
    super(props);

    this.state = { isExpanded: props.isExpanded };

    this.handleToggle = this.handleToggle.bind(this);
  }

  getText(value) {
    if (typeof value === 'string') {
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_2__["default"], { quoteStart: true, sentence: value, quoteEnd: true });
    }

    return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_2__["default"], { sentence: value });
  }

  handleToggle() {
    this.setState(prevState => ({ isExpanded: !prevState.isExpanded }));
  }

  render() {
    const { data, name } = this.props;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__network-string' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: 'network-string__name',
            onClick: this.handleToggle },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: classnames__WEBPACK_IMPORTED_MODULE_1___default()('network-expand__caret', { down: this.state.isExpanded }) }, '\u25B6'),
          name,

          this.props.info &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], {
              type: 'icon',
              className: 'network-string__info',
              tooltip: this.props.info },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_InformationIconNew__WEBPACK_IMPORTED_MODULE_4__["default"], { size: 'xs', className: 'network-string__info-icon' }))),





        this.state.isExpanded && (
        _.isArray(data) ?
        _.map(data, (row, index) =>
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { key: index, className: 'network-formatter__item' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_2__["default"], { sentence: row.key })),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, ': '),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'network__value' }, this.getText(row.value)))) :


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'network-string__value' }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_2__["default"], { sentence: data })))));





  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6001:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleBodyViewer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3229);
/* harmony import */ var _provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5996);




let

ConsoleBodyViewer = class ConsoleBodyViewer extends react__WEBPACK_IMPORTED_MODULE_0__["PureComponent"] {
  constructor(props) {
    super(props);

    this.state = { isExpanded: props.isExpanded };

    this.handleToggle = this.handleToggle.bind(this);
    this.viewLargeBody = this.viewLargeBody.bind(this);
    this.getBody = this.getBody.bind(this);
    this.getIgnoredBodyText = this.getIgnoredBodyText.bind(this);
  }


  getText(value) {
    if (typeof value === 'string') {
      return `"${value}"`;
    }

    return value;
  }

  getIgnoredBodyText() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'console__ignored-body' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'The console only shows bodies smaller than 10 KB inline. To view the complete body, inspect it by clicking'),



        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'console__open__link', onClick: this.viewLargeBody },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_3__["default"], { size: 'xs', className: 'console__inline__open-icon' })),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, ' Open.'))));



  }

  getBody(data) {
    if (_.isNil(data)) {
      return String(data);
    }

    if (data.___unsupported___) {
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'console__unsupported-body' }, 'The console does not support viewing bodies with media files.');
    }

    if (data.___ignored___) {
      return this.getIgnoredBodyText();
    }

    if (data === '') {
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'c-li__empty' });
    }

    return (

      // Changing this from `span` to `div` as body is now a container with background color.
      // This wouldn't be possible with `span` as each line would get background color separately.
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'network-string__value body' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_provider_WhitespaceFormatter__WEBPACK_IMPORTED_MODULE_4__["default"], { sentence: data })));


  }

  handleToggle() {
    this.setState(prevState => ({ isExpanded: !prevState.isExpanded }));
  }


  viewLargeBody(e) {
    e && e.stopPropagation();
    this.props.viewLargeBody(this.props.bodyType);
  }

  render() {
    const { data, name, canViewInEditor } = this.props,
    isSupported = !_.get(data, '___unsupported___');

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'c-li__network-string' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: 'network-string__name',
            onClick: this.handleToggle },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: classnames__WEBPACK_IMPORTED_MODULE_1___default()('network-expand__caret', { down: this.state.isExpanded }) }, '\u25B6'),
          name,

          canViewInEditor && isSupported &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_2__["Button"], {
              type: 'icon',
              onClick: this.viewLargeBody,
              className: 'console__large-body__btn',
              tooltip: 'Open in Editor' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_3__["default"], { size: 'xs', className: 'console__body-viewer__open-icon' }))),





        this.state.isExpanded && this.getBody(data)));




  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6002:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleListItemRaw; });
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(64);
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(path__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3229);




const querystring = __webpack_require__(178),
{ Url } = __webpack_require__(790);let

ConsoleListItemRaw = class ConsoleListItemRaw extends react__WEBPACK_IMPORTED_MODULE_1__["PureComponent"] {
  getRawText() {
    const { data } = this.props,
    requestHeaders = this.getRequestHeaders(data.request),
    requestBody = this.getRequestBody(data.request),
    responseHeaders = this.getResponseHeaders(data.response),
    responseBody = this.getResponseBody(data.response);

    return {
      requestHeaders,
      requestBody,
      responseHeaders,
      responseBody };

  }

  getRequestHeaders(request) {
    const requestHeaders = _.
    chain(_.get(request, 'headers', [])).
    compact().
    reject('disabled').
    map(header => `${header.key || header.name}: ${header.value}`).
    value(),
    url = new Url(request.url),
    httpVersion = request.httpVersion ? request.httpVersion : '1.1';

    let queryString = url.getQueryString({ encode: true, ignoreDisabled: true });

    queryString = queryString ? `?${queryString}` : '';

    return _.concat(
    [`${request.method} ${url.getPath()}${queryString} HTTP/${httpVersion}`],
    requestHeaders);

  }

  getRequestBody(request) {
    let requestBody;

    const requestBodyMode = _.get(request, 'body.mode', '');

    if (requestBodyMode === 'formdata') {
      // Extract boundary from content-type header, which is of the form:
      //  Content-Type: multipart/form-data; boundary=--------------------------648758041545280124149783
      const contentType = _.find(request.headers, header => String(header.key).toLowerCase() === 'content-type');

      let boundary = contentType && contentType.value.
      split(';').
      map(x => x.trim()).
      find(x => x.startsWith('boundary='));

      boundary = boundary && boundary.substr(9);

      // Boundary might not be present in the header if user sends a custom header.
      // just add a custom boundary in that case
      if (!boundary) {
        boundary = '--------------------------postman';
      }

      boundary = `--${boundary}`;

      // Convert form data params into a fake of the request body that was actually sent:
      //
      // --------------------------648758041545280124149783
      // Content-Disposition: form-data; name="text1"
      //
      // value1
      // --------------------------648758041545280124149783
      // Content-Disposition: form-data; name="file1"; filename="some-file-name.txt"
      // Content-Type: application/octet-stream
      //
      // FILE CONTENT HERE
      // --------------------------648758041545280124149783--
      //
      const formData = _.
      chain(_.get(request, 'body.formdata', [])).
      filter(param => !param.disabled).
      map(param => {
        const NON_ASCII_REGEX = /[^\t\x20-\x7e\x80-\xff]/;

        let filename,
        formEntry = `Content-Disposition: form-data; name="${param.key}"`;

        // Try to get filename from "src" param
        if (typeof param.src === 'string') {
          filename = path__WEBPACK_IMPORTED_MODULE_0___default.a.basename(param.src);
        }

        // If param.type is "file", we should always show the "filename" param (it can be empty string)
        if (!filename && param.type === 'file') {
          filename = '';
        }

        // Filename can be empty string, make sure we handle it
        if (typeof filename === 'string') {
          formEntry += `; filename="${filename}"`;
        }

        // If filename is a UTF string, encode it as per RFC 6266
        if (NON_ASCII_REGEX.test(filename)) {
          formEntry += `; filename*="UTF-8''${

          // @note see RFC 8187
          // @todo use postman-urlencoder instead of encodeURIComponent for consistency
          encodeURIComponent(filename)

          // Note that although RFC3986 reserves "!", RFC8187 does not,
          // so we do not need to escape it
          .replace(/['()*]/g, c => `%${c.charCodeAt(0).toString(16)}`)

          // The following are not required for percent-encoding per RFC8187,
          // so we can allow for a little better readability over the wire: |`^
          .replace(/%(?:7C|60|5E)/g, unescape)
          }"`;
        }

        formEntry += '\r\n';

        // Only add content-type if it was user specified
        // @note this misses the content-type which was actually sent because
        // we have no way to knowing what it was
        if (param.contentType) {
          formEntry += `Content-Type: ${param.contentType}\r\n`;
        }

        formEntry += '\r\n';

        // If we have a filename, we print it; if not, we try to print the
        // value param
        if (param.type === 'file' && filename) {
          formEntry += `<${filename}>`;
        } else if (typeof param.value === 'string') {
          formEntry += param.value;
        }

        formEntry += '\r\n';

        return formEntry;
      }).
      join(`${boundary}\r\n`).
      value();

      if (formData) {
        requestBody = `${boundary}\r\n${formData}${boundary}--`;
      } else {
        requestBody = '';
      }
    } else if (requestBodyMode === 'urlencoded') {
      requestBody = _.
      chain(_.get(request.body, 'urlencoded', [])).
      reject('disabled').
      map(parameter => querystring.stringify({ [parameter.key]: parameter.value })).
      join('&').
      value();
    } else if (requestBodyMode === 'raw') {
      requestBody = _.get(request, 'body.raw');
    } else if (requestBodyMode === 'graphql') {
      const body = [],
      content = _.get(request, 'body.graphql');

      if (Object.hasOwnProperty.call(content, 'query') && typeof content.query === 'string') {
        body.push(`"query":${JSON.stringify(content.query)}`);
      }

      if (Object.hasOwnProperty.call(content, 'operationName') && typeof content.operationName === 'string') {
        body.push(`"operationName":${JSON.stringify(content.operationName)}`);
      }

      if (Object.hasOwnProperty.call(content, 'variables') && typeof content.variables === 'string' && content.variables !== '') {
        body.push(`"variables":${content.variables}`); // Already a stringified JSON
      }

      requestBody = `{${body.join(',')}}`;
    }

    return requestBody;
  }

  getResponseHeaders(response) {
    if (!response) {
      return [];
    }

    const responseHeaders = _.
    chain(_.get(response, 'headers', [])).
    map(header => `${header.key || header.name}: ${header.value}`).
    value(),
    httpVersion = response.httpVersion ? response.httpVersion : '1.1';

    return _.concat(
    [`HTTP/${httpVersion} ${response.code}${response.status ? ` ${response.status}` : ''}`],
    responseHeaders);

  }

  getResponseBody(response) {
    return response ? response.body : '';
  }

  getIgnoredBodyText(bodyType) {
    return (
      react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('span', { className: 'console__ignored-body' },
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('span', null, 'The console only shows',

          bodyType,
          ' bodies smaller than 10 KB inline. To view the complete body, inspect it by clicking '),

        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('span', { className: 'console__open__link', onClick: this.props.viewLargeBody.bind(null, bodyType) },
          react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('span', null, react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement(_js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_2__["default"], { size: 'xs', className: 'console__inline__open-icon' })),
          react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('span', null, ' Open.'))));



  }

  render() {
    const raw = this.getRawText(),
    isResponseBodyUnsupported = _.get(this.props, 'data.response.body.___unsupported___'),
    isRequestBodyLarge = _.get(this.props, 'data.request.body.___ignored___'),
    isResponseBodyLarge = _.get(this.props, 'data.response.body.___ignored___');

    return (
      react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { className: 'console-net-item' },
        react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { className: 'console-net-item__body console-net-item__body--raw console-list__raw' },

          !_.isEmpty(raw.requestHeaders) &&
          react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { className: 'console-net-item__body-left__request' },
            _.map(raw.requestHeaders, (line, index) => line && react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { key: `request-line-${index}` }, line))),




          isRequestBodyLarge ?
          this.getIgnoredBodyText('request') :

          !_.isEmpty(raw.requestBody) &&
          react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { className: 'console-net-item__body-left__request-body' },
            _.map(_.split(raw.requestBody, '\n'), (line, index) => line && react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { key: `request-body-line-${index}` }, line))),




          !_.isEmpty(raw.responseHeaders) &&
          react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { className: 'console-net-item__body-left__response' },
            _.map(raw.responseHeaders, (line, index) => line && react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { key: `response-line-${index}` }, line))),




          isResponseBodyUnsupported &&
          react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('span', { className: 'console__unsupported-body' }, 'The console does not support viewing response bodies with media files.') || (

          isResponseBodyLarge ?
          this.getIgnoredBodyText('response') :
          !_.isEmpty(raw.responseBody) &&
          react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { className: 'console-net-item__body-left__response-body' },
            _.map(_.split(raw.responseBody, '\n'), (line, index) => line && react__WEBPACK_IMPORTED_MODULE_1___default.a.createElement('div', { key: `response-body-line-${index}` }, line)))))));






  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6003:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return LockedIcon; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2813);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('svg', { width: '12', height: '14', viewBox: '0 0 16 16' },
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('defs', null,
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { id: 'locked', d: 'M8 1C5.79 1 4 2.79 4 5v2H2v8h12V7h-2V5c0-2.21-1.79-4-4-4zm0 2c1.19 0 2 .81 2 2v2H6V5c0-1.19.81-2 2-2z' })),

  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('use', { fill: '#282828', fillRule: 'evenodd', xlinkHref: '#locked' }));



function LockedIcon(props) {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_Icon__WEBPACK_IMPORTED_MODULE_1__["default"], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 6004:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RedirectIcon; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2813);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('svg', { width: '16', height: '16', viewBox: '0 0 16 16', fill: 'none', xmlns: 'http://www.w3.org/2000/svg' },
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { d: 'M11 2H16V7H15V3.70713L8.41424 10.2929C7.63319 11.0739 6.36686 11.0739 5.58581 10.2929L0.146469 4.85355L0.853577 4.14645L6.29292 9.58579C6.68344 9.97631 7.31661 9.97631 7.70713 9.58579L14.2929 3H11V2Z', fill: '#7E7E7E' }),
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { d: 'M0 13H16V14H0V13Z', fill: '#7E7E7E' }));



function RedirectIcon(props) {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_Icon__WEBPACK_IMPORTED_MODULE_1__["default"], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 6005:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return CodeIcon; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2813);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('svg', { width: '16', height: '14', viewBox: '0 0 16 14', fill: 'none', xmlns: 'http://www.w3.org/2000/svg' },
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { d: 'M6.47431 13.1581L10.4743 1.15812L9.52563 0.841888L5.52563 12.8419L6.47431 13.1581Z', fill: '#A9A9A9' }),
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { d: 'M4.6464 2.64645L0.292847 7L4.6464 11.3536L5.35351 10.6465L1.70706 7L5.35351 3.35356L4.6464 2.64645Z', fill: '#A9A9A9' }),
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { d: 'M11.3536 2.64645L15.7071 7L11.3536 11.3536L10.6465 10.6465L14.2929 7L10.6465 3.35356L11.3536 2.64645Z', fill: '#A9A9A9' }));



function CodeIcon(props) {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_Icon__WEBPACK_IMPORTED_MODULE_1__["default"], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 6006:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleBlobViewer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2929);
/* harmony import */ var _js_components_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2974);
/* harmony import */ var _js_components_base_Modals__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(3250);
/* harmony import */ var _appsdk_components_editors_texteditor_TextEditor__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2952);
/* harmony import */ var _js_components_base_Icons_InformationIcon__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(3231);
/* harmony import */ var _js_components_base_Tooltips__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(2935);
/* harmony import */ var _js_components_base_Icons_CloseIcon__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(3049);
var _class;









const TRUNCATED_TOOLTIP_COPY = 'The console truncates bodies larger than 5 MB',
responseLanguages = [
{ key: 'json', label: 'JSON' },
{ key: 'xml', label: 'XML' },
{ key: 'html', label: 'HTML' },
{ key: 'text', label: 'Text' },
{ key: 'auto', label: 'Auto' }];let



ConsoleBlobViewer = Object(mobx_react__WEBPACK_IMPORTED_MODULE_2__["observer"])(_class = class ConsoleBlobViewer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      activeLanguage: props.type,
      languageIntent: 'auto',
      wordWrap: true,
      isTooltipVisible: false };


    this.handleLanguageSelect = this.handleLanguageSelect.bind(this);
    this.handleLineWrapToggle = this.handleLineWrapToggle.bind(this);
    this.showTooltip = this.showTooltip.bind(this);
    this.handleTooltipClose = this.handleTooltipClose.bind(this);
    this.renderInModal = this.renderInModal.bind(this);
    this.renderInContainer = this.renderInContainer.bind(this);
  }

  getCustomStyles() {
    return {
      margin: 'auto' };

  }

  handleLanguageSelect(language) {
    let languageToBeUpdated = language,
    languageIntent = 'manual';

    if (languageToBeUpdated === 'auto') {
      languageToBeUpdated = this.props.type || 'text';
      languageIntent = 'auto';
    }

    this.setState({ activeLanguage: languageToBeUpdated, languageIntent });
  }

  handleLineWrapToggle() {
    this.setState(prevState => ({ wordWrap: !prevState.wordWrap }));
  }

  showTooltip() {
    this.setState({ isTooltipVisible: true });
  }

  handleTooltipClose() {
    this.state.isTooltipVisible && this.setState({ isTooltipVisible: false });
  }

  renderInModal(data, activeLanguage) {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Modals__WEBPACK_IMPORTED_MODULE_4__["Modal"], {
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onClose,
          customStyles: this.getCustomStyles(),
          fullscreen: true },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Modals__WEBPACK_IMPORTED_MODULE_4__["ModalHeader"], null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console__text-editor__header' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null,
              `${this.props.bodyType} Body`),



            this.props.isTruncated &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'console__text-editor__truncated-label' }, '(truncated)'),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  ref: 'tooltipTarget',
                  onClick: this.showTooltip,
                  className: 'truncated-info__button' },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_InformationIcon__WEBPACK_IMPORTED_MODULE_6__["default"], { className: 'truncated-info__icon', size: 'xs' })),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Tooltips__WEBPACK_IMPORTED_MODULE_7__["Tooltip"], {
                  show: this.state.isTooltipVisible,
                  target: this.refs.tooltipTarget,
                  onClose: this.handleTooltipClose,
                  closeOnClickOutside: true,
                  immediate: true },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Tooltips__WEBPACK_IMPORTED_MODULE_7__["TooltipBody"], null,
                  TRUNCATED_TOOLTIP_COPY))))),







        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Modals__WEBPACK_IMPORTED_MODULE_4__["ModalContent"], { className: 'console__text-editor__container' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console__text-editor' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_appsdk_components_editors_texteditor_TextEditor__WEBPACK_IMPORTED_MODULE_5__["default"], {
              showActionBar: true,
              autoFormat: true,
              readOnly: true,
              enableLinks: true,
              language: _.toLower(activeLanguage),
              languages: responseLanguages,
              onLanguageSelect: this.handleLanguageSelect,
              wordWrap: this.state.wordWrap,
              onWordWrapClick: this.handleLineWrapToggle,
              value: data }),


            this.props.isLoading && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_3__["default"], { className: 'console-list__loading' })))));





  }

  renderInContainer(data, activeLanguage) {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: classnames__WEBPACK_IMPORTED_MODULE_1___default()('console__blob-viewer', { 'is-hidden': !this.props.isOpen }) },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console__text-editor__header' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'header__section-left' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null,
              `${this.props.bodyType} Body`),



            this.props.isTruncated &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'console__text-editor__truncated-label' }, '(truncated)'),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  ref: 'tooltipTarget',
                  onClick: this.showTooltip,
                  className: 'truncated-info__button' },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_InformationIcon__WEBPACK_IMPORTED_MODULE_6__["default"], { className: 'truncated-info__icon', size: 'xs' })),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Tooltips__WEBPACK_IMPORTED_MODULE_7__["Tooltip"], {
                  show: this.state.isTooltipVisible,
                  target: this.refs.tooltipTarget,
                  onClose: this.handleTooltipClose,
                  closeOnClickOutside: true,
                  immediate: true },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Tooltips__WEBPACK_IMPORTED_MODULE_7__["TooltipBody"], null,
                  TRUNCATED_TOOLTIP_COPY)))),






          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'header__section-right' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_CloseIcon__WEBPACK_IMPORTED_MODULE_8__["default"], { className: 'header__section-right__close-icon', onClick: this.props.onClose }))),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console__text-editor__container' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_appsdk_components_editors_texteditor_TextEditor__WEBPACK_IMPORTED_MODULE_5__["default"], {
            showActionBar: true,
            readOnly: true,
            enableLinks: true,
            language: _.toLower(activeLanguage),
            languages: responseLanguages,
            onLanguageSelect: this.handleLanguageSelect,
            wordWrap: this.state.wordWrap,
            onWordWrapClick: this.handleLineWrapToggle,
            value: data }),


          this.props.isLoading && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_3__["default"], { className: 'console-list__loading' }))));




  }

  render() {
    const activeLanguage = (this.state.languageIntent === 'auto' ? this.props.type : this.state.activeLanguage) || '';

    let { data } = this.props;

    if (_.isEmpty(data)) {
      data = '';
    }

    return this.props.showInModal ?
    this.renderInModal(data, activeLanguage) :
    this.renderInContainer(data, activeLanguage);
  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6007:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
const AppNotificationStyles = {
  Containers: {
    DefaultStyle: {
      zIndex: 210,
      width: 360 },

    tr: { bottom: '30px', top: 'unset' } },

  MessageWrapper: {
    DefaultStyle: {
      display: 'inline-block',
      paddingRight: '10px' } },


  NotificationItem: {
    DefaultStyle: {
      textAlign: 'inherit',
      wordBreak: 'break-word',
      margin: '0',
      overflowY: 'hidden',
      transition: 'all 0.3s ease-in-out',
      cursor: 'default' },


    success: {
      borderTop: 'none',
      backgroundColor: 'none',
      boxShadow: 'none' },


    error: {
      borderTop: 'none',
      backgroundColor: 'none',
      boxShadow: 'none' },


    warning: {
      borderTop: 'none',
      backgroundColor: 'none',
      boxShadow: 'none' },


    info: {
      borderTop: 'none',
      backgroundColor: 'none',
      boxShadow: 'none' } },


  ActionWrapper: { DefaultStyle: { display: 'inline-block' } },
  Action: {
    DefaultStyle: {
      backgroundColor: 'transparent',
      borderRadius: '0',
      padding: '0',
      fontWeight: 'bold',
      margin: '0 0 0 5px',
      border: 0,
      textDecoration: 'underline' },


    success: {
      backgroundColor: 'transparent',
      color: '#468847' },


    error: {
      backgroundColor: 'transparent',
      color: '#B94A48' },


    warning: {
      backgroundColor: 'transparent',
      color: '#C09853' },


    info: {
      backgroundColor: 'transparent',
      color: '#3A87AD' } },


  Dismiss: { DefaultStyle: { display: 'none' } } };


/* harmony default export */ __webpack_exports__["default"] = (AppNotificationStyles);

/***/ }),

/***/ 6008:
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(6009);


/***/ }),

/***/ 6009:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _runtime_components_runner_Runner__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6010);
/* harmony import */ var _init__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6074);
/* harmony import */ var _styles_runner_scss__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6077);
/* harmony import */ var _styles_runner_scss__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_styles_runner_scss__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _utils_TelemetryHelpers__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(5699);
/* harmony import */ var _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(748);
/* harmony import */ var _components_empty_states_CrashHandler__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(3248);
/* harmony import */ var _shared_ThemeContext__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(5700);










if (false) {} else
{
  window.onbeforeunload = () => {
    return false;
  };
}

const rootEl = document.getElementsByClassName('app-root')[0];

_init__WEBPACK_IMPORTED_MODULE_3__["default"].init(err => {

  if (err) {
    Object(react_dom__WEBPACK_IMPORTED_MODULE_1__["render"])(react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_components_empty_states_CrashHandler__WEBPACK_IMPORTED_MODULE_7__["default"], { showError: true }), rootEl);
    return;
  }

  Object(react_dom__WEBPACK_IMPORTED_MODULE_1__["render"])(
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_components_empty_states_CrashHandler__WEBPACK_IMPORTED_MODULE_7__["default"], null,
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_shared_ThemeContext__WEBPACK_IMPORTED_MODULE_8__["Theme"], null,
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_runtime_components_runner_Runner__WEBPACK_IMPORTED_MODULE_2__["default"], null))),


  rootEl,
  () => {
    let loadTime = Object(_utils_TelemetryHelpers__WEBPACK_IMPORTED_MODULE_5__["getWindowLoadTime"])();
    _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_6__["default"].addEvent('app_performance_metric', 'runner_window_loaded', null, null, { load_time: loadTime });
  });

});

/***/ }),

/***/ 6010:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return Runner; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var react_notification_system__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5838);
/* harmony import */ var react_notification_system__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react_notification_system__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(749);
/* harmony import */ var _js_constants_AppNotificationStylesForRunner__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6011);
/* harmony import */ var _js_components_base_keymaps_KeyMaps__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2960);
/* harmony import */ var _js_components_base_Panes__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(3044);
/* harmony import */ var _js_components_base_XPaths_XPathProvider__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(6012);
/* harmony import */ var _RunnerHeader_RunnerHeader__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(6013);
/* harmony import */ var _RunnerRun_RunnerRun__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(6026);
/* harmony import */ var _RunnerResults_RunnerResults__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(6048);
/* harmony import */ var _RunnerSummary_RunnerSummary__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(6056);
/* harmony import */ var _RunnerBottomPane_RunnerBottomPaneHeader__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(6063);
/* harmony import */ var _RunnerBottomPane_RunnerBottomPaneContainer__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(6066);
/* harmony import */ var _js_containers_workspaces_MissingCurrentWorkspaceModalContainer__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(6067);
/* harmony import */ var _js_containers_user_UserInvalidSessionModalContainer__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(6069);
/* harmony import */ var _js_containers_user_UserSignOutModalContainer__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(6071);
/* harmony import */ var _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(5353);
/* harmony import */ var _js_constants_Panes__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(3046);
var _class;























const keyMap = {
  increaseUIZoom: 'mod+=',
  decreaseUIZoom: 'mod+-',
  resetUIZoom: 'mod+0' },

keyHandler = {
  increaseUIZoom: () => {pm.uiZoom.increase();},
  decreaseUIZoom: () => {pm.uiZoom.decrease();},
  resetUIZoom: () => {pm.uiZoom.reset();} };let



Runner = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class Runner extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.handleTabChange = this.handleTabChange.bind(this);
    this.handleSelect = this.handleSelect.bind(this);
    this.handleRunAction = this.handleRunAction.bind(this);

    // Setup store references to start with
    this.store = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('RunnerStore');
  }

  componentDidMount() {
    pm.toasts.setNotificationComponent(this.refs.notificationSystem);
  }

  getContent() {
    if (this.store.activeTab === _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_17__["RUNNER_TAB_RUN"]) {
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerRun_RunnerRun__WEBPACK_IMPORTED_MODULE_9__["default"], { onOpenRun: this.handleSelect });
    }

    if (this.store.activeTab === _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_17__["RUNNER_TAB_RESULTS"]) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerResults_RunnerResults__WEBPACK_IMPORTED_MODULE_10__["default"], {
          onOpenRun: this.handleSelect,
          onTabChange: this.handleTabChange,
          onRunAction: this.handleRunAction }));


    }

    if (this.store.activeTab === _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_17__["RUNNER_TAB_SUMMARY"]) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerSummary_RunnerSummary__WEBPACK_IMPORTED_MODULE_11__["default"], {
          onOpenRun: this.handleSelect,
          onTabChange: this.handleTabChange,
          onRunAction: this.handleRunAction }));


    }
  }

  handleRunAction(action) {
    switch (action) {
      case 'pause':
        this.store.pauseRun();
        break;

      case 'resume':
        this.store.resumeRun();
        break;

      case 'stop':
        this.store.stopRun();
        break;

      case 'retry':
        this.store.retryRun();
        break;

      default:break;}

  }


  handleTabChange(tab) {
    this.store.setActiveTab(tab);
  }

  handleSelect(runId) {
    this.store.setSelectedRun(runId);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_XPaths_XPathProvider__WEBPACK_IMPORTED_MODULE_7__["default"], { identifier: 'runner' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_keymaps_KeyMaps__WEBPACK_IMPORTED_MODULE_5__["default"], { handlers: keyHandler, keyMap: keyMap },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'app-runner' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { id: 'dropdown-root', style: { width: 0, height: 0 } }),
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Panes__WEBPACK_IMPORTED_MODULE_6__["PaneGroup"], { defaultLayout: _js_constants_Panes__WEBPACK_IMPORTED_MODULE_18__["PANE_LAYOUT_VERTICAL"], attachZoomHandler: true },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Panes__WEBPACK_IMPORTED_MODULE_6__["Pane"], { height: { resizableByDefault: false } },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Panes__WEBPACK_IMPORTED_MODULE_6__["PaneContent"], { height: { default: 50 } },
                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerHeader_RunnerHeader__WEBPACK_IMPORTED_MODULE_8__["default"], {
                    activeTab: this.store.activeTab,
                    onTabChange: this.handleTabChange }))),




              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Panes__WEBPACK_IMPORTED_MODULE_6__["Pane"], { height: { min: 200, collapsed: 0 } },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Panes__WEBPACK_IMPORTED_MODULE_6__["PaneContent"], null,
                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-contents' },
                    this.getContent()))),




              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Panes__WEBPACK_IMPORTED_MODULE_6__["Pane"], {
                  height: { collapsedByDefault: true, default: 300, min: 200 } },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Panes__WEBPACK_IMPORTED_MODULE_6__["PaneHeader"], {
                  height: 32,
                  defaultLayout: 'horizontal',
                  horizontalComponent: react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerBottomPane_RunnerBottomPaneHeader__WEBPACK_IMPORTED_MODULE_12__["default"], null) }),

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Panes__WEBPACK_IMPORTED_MODULE_6__["PaneContent"], { className: 'runner-bottom-pane__content' },
                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerBottomPane_RunnerBottomPaneContainer__WEBPACK_IMPORTED_MODULE_13__["default"], null)))),




            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react_notification_system__WEBPACK_IMPORTED_MODULE_2___default.a, {
              allowHTML: true,
              ref: 'notificationSystem',
              style: _js_constants_AppNotificationStylesForRunner__WEBPACK_IMPORTED_MODULE_4__["default"] }),

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_containers_workspaces_MissingCurrentWorkspaceModalContainer__WEBPACK_IMPORTED_MODULE_14__["default"], null),
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_containers_user_UserInvalidSessionModalContainer__WEBPACK_IMPORTED_MODULE_15__["default"], null),
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_containers_user_UserSignOutModalContainer__WEBPACK_IMPORTED_MODULE_16__["default"], null)))));




  }}) || _class;

/***/ }),

/***/ 6011:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _AppNotificationStyles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6007);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};

/* harmony default export */ __webpack_exports__["default"] = (_extends({},
_AppNotificationStyles__WEBPACK_IMPORTED_MODULE_0__["default"], {
  Containers: {
    DefaultStyle: {
      zIndex: 110,
      width: 360 },

    tr: { bottom: '0px', top: 'unset' } } }));

/***/ }),

/***/ 6012:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return XPathProvider; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _XPathManager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2920);
/* harmony import */ var mobx__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(751);






/**
                                    * XPathProvider is the root context provider for XPath Components.
                                    *
                                    * XPath component create new xPath by using xPath of its ancestor.
                                    * Also consumers can control when to make an xPath visible by passing boolean value
                                    * to isVisible.
                                    *
                                    * That is why it becomes important to make the xPath context as observable so that any change
                                    * (in xPath or visibility) in an xPath can cause all its descendents to re-register (unregister)
                                    * themselves.
                                    *
                                    *
                                    */let


XPathProvider = class XPathProvider extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);
    this.xPathManager = Object(mobx__WEBPACK_IMPORTED_MODULE_3__["observable"])({
      register: _XPathManager__WEBPACK_IMPORTED_MODULE_2__["default"].register,
      unregister: _XPathManager__WEBPACK_IMPORTED_MODULE_2__["default"].unregister,
      path: props.identifier,
      isVisible: this.props.isVisible });

  }

  getChildContext() {
    return { xPathManager: this.xPathManager };
  }

  render() {
    return this.props.children;
  }};


XPathProvider.childContextTypes = { xPathManager: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.object };

XPathProvider.propTypes = { identifier: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.string };

XPathProvider.defaultProps = {
  isVisible: true };

/***/ }),

/***/ 6013:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerHeader; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2934);
/* harmony import */ var _js_containers_workspaces_WorkspaceSwitcherContainer__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6014);
/* harmony import */ var _js_external_navigation_ExternalNavigationService__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2388);
/* harmony import */ var _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5353);
/* harmony import */ var _js_constants_AppUrlConstants__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(3041);









let

RunnerHeader = class RunnerHeader extends react__WEBPACK_IMPORTED_MODULE_0__["PureComponent"] {
  constructor(props) {
    super(props);

    this.handleNewmanLink = this.handleNewmanLink.bind(this);
    this.handleDocsLink = this.handleDocsLink.bind(this);
  }

  handleNewmanLink() {
    Object(_js_external_navigation_ExternalNavigationService__WEBPACK_IMPORTED_MODULE_3__["openExternalLink"])('https://www.npmjs.com/package/newman');
  }

  handleDocsLink() {
    Object(_js_external_navigation_ExternalNavigationService__WEBPACK_IMPORTED_MODULE_3__["openExternalLink"])(_js_constants_AppUrlConstants__WEBPACK_IMPORTED_MODULE_5__["RUNNER_DOCS"]);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-header' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-header__section-left' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-header__section-left__tab runner-header__section-left__tab--runner' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                className: 'runner-header__section-left__runner',
                onClick: this.props.onTabChange.bind(this, _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_4__["RUNNER_TAB_RUN"]) }, 'Collection Runner')),






          (this.props.activeTab === _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_4__["RUNNER_TAB_RESULTS"] || this.props.activeTab === _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_4__["RUNNER_TAB_SUMMARY"]) &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-header__section-left__tab runner-header__section-left__tab--results' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-header__section-left__arrow runner-header__section-left__results-pre-arrow' }),
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                className: 'runner-header__section-left__results',
                onClick: this.props.onTabChange.bind(this, _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_4__["RUNNER_TAB_RESULTS"]) }, 'Run Results'),



            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-header__section-left__arrow runner-header__section-left__results-post-arrow' })),





          this.props.activeTab === _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_4__["RUNNER_TAB_SUMMARY"] &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-header__section-left__tab runner-header__section-left__tab--summary' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-header__section-left__arrow runner-header__section-left__summary-pre-arrow' }),
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                className: 'runner-header__section-left__summary',
                onClick: this.props.onTabChange.bind(this, _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_4__["RUNNER_TAB_SUMMARY"]) }, 'Run Summary'),



            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-header__section-left__arrow runner-header__section-left__summary-post-arrow' }))),




        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-header__section-center' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_containers_workspaces_WorkspaceSwitcherContainer__WEBPACK_IMPORTED_MODULE_2__["default"], null)),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-header__section-right' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_1__["Button"], {
              className: 'runner-header__section-right__newman',
              size: 'small',
              type: 'header',
              onClick: this.handleNewmanLink }, 'Run In Command Line'),



          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_1__["Button"], {
              className: 'runner-header__section-right__docs',
              size: 'small',
              type: 'header',
              onClick: this.handleDocsLink }, 'Docs'))));






  }};

/***/ }),

/***/ 6014:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return WorkspaceSwitcherContainer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(751);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2929);
/* harmony import */ var _external_navigation_ExternalNavigationService__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2388);
/* harmony import */ var _components_workspaces_WorkspaceSwitcher__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6015);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(749);
/* harmony import */ var _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(748);
/* harmony import */ var _modules_services_AuthHandlerService__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(3854);
/* harmony import */ var _modules_controllers_SyncWorkspaceController__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(779);
/* harmony import */ var _modules_controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(756);
/* harmony import */ var _modules_model_event__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(742);
/* harmony import */ var _modules_pipelines_user_action__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(2435);
/* harmony import */ var _constants_RequesterTabConstants__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(774);
/* harmony import */ var _models_services_DashboardService__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(3243);
/* harmony import */ var _constants_AppUrlConstants_js__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(3041);
/* harmony import */ var _components_base_XPaths_XPath__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(2955);
/* harmony import */ var _services_WorkspaceSwitchService__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(2696);
/* harmony import */ var _collaboration_services_DashboardService__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(6023);
/* harmony import */ var _modules_services_PermissionsService__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(6024);
var _class;




















const REFETCH_WORKSPACE_WAIT_TIME = 1000, // 1 sec
WINDOW_TYPE = {
  RUNNER: 'runner',
  REQUESTER: 'requester' };let



WorkspaceSwitcherContainer = Object(mobx_react__WEBPACK_IMPORTED_MODULE_2__["observer"])(_class = class WorkspaceSwitcherContainer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      activeTab: 'personal',
      isLoading: false,
      dataFetchedFirstTime: false, // will be set to true the first time API returns the data
      canViewTeamWorkspaces: false,
      personalWorkspaces: [],
      teamWorkspaces: [], // team workspaces that the user belongs to
      joinableWorkspaces: [], // team workspaces that the user can join
      joiningWorkspaceId: '' };


    this.handleToggle = this.handleToggle.bind(this);
    this.handleTabChange = this.handleTabChange.bind(this);
    this.handleSwitchWorkspace = this.handleSwitchWorkspace.bind(this);
    this.handleWorkspaceAction = this.handleWorkspaceAction.bind(this);
    this.handleSignIn = this.handleSignIn.bind(this);
    this.handleLearnMore = this.handleLearnMore.bind(this);
    this.handleProUpgradeClick = this.handleProUpgradeClick.bind(this);
    this.showWorkspacesFromLocalData = this.showWorkspacesFromLocalData.bind(this);
    this.refetchWorkspaces = _.debounce(this.refetchWorkspaces.bind(this), REFETCH_WORKSPACE_WAIT_TIME, { leading: true, trailing: false });
    this.handleWorkspaceJoin = this.handleWorkspaceJoin.bind(this);
  }

  componentDidMount() {
    // InitialHydration, read from db and assign the personal and joined workspaces
    _modules_controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_9__["default"].getAll().
    then((workspaces = []) => {
      let {
        personal,
        joined,
        joinable } =
      this.segregateWorkspaces(workspaces);

      this.setState({
        personalWorkspaces: personal || [],
        teamWorkspaces: joined || [], // team workspaces that the user belongs to
        joinableWorkspaces: joinable || [] // team workspaces that the user can join
      });
    }).
    catch(err => {
      pm.logger.error('WorkspaceSwitcherContainer~componentDidMount: Could not get data from db', err);
    });

    // This autorun is responsible for fetching the permission 'viewVisibleWorkspaceTeam'
    // An autorun is used instead of a reaction here as there could be a race condition where the socket is connected by teamID has not been hydrated yet
    this.fetchPermissionsAutorun = Object(mobx__WEBPACK_IMPORTED_MODULE_1__["autorun"])(() => {
      const isSocketConnected = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('SyncStatusStore').isSocketConnected,
      teamId = _.get(Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('CurrentUserStore'), 'team.id');

      if (!teamId) {
        return this.setState({ canViewTeamWorkspaces: false });
      }

      if (isSocketConnected) {
        Object(_modules_services_PermissionsService__WEBPACK_IMPORTED_MODULE_18__["fetchPermissions"])(['viewVisibleWorkspaceTeam']).
        then(({ viewVisibleWorkspaceTeam }) => {
          this.setState({ canViewTeamWorkspaces: viewVisibleWorkspaceTeam });
        });
      }
    });
  }

  componentWillUnmount() {
    // Dispose Reaction
    this.fetchPermissionsAutorun && this.fetchPermissionsAutorun();
  }

  getActiveStore() {
    let viewMode = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('ActiveWorkspaceSessionStore').viewMode;

    if (viewMode === _constants_RequesterTabConstants__WEBPACK_IMPORTED_MODULE_12__["WORKSPACE_BUILDER_VIEW"]) {
      return Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('ActiveWorkspaceStore');
    } else
    if (viewMode === _constants_RequesterTabConstants__WEBPACK_IMPORTED_MODULE_12__["WORKSPACE_BROWSER_VIEW"]) {
      return Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('ActiveBrowseWorkspaceStore');
    }
  }

  handleToggle(isOpen) {
    // do nothing if requested to close an already closed switcher
    if (!this.state.isOpen && !isOpen) {
      return;
    }

    let activeTab = this.getActiveStore().type || 'personal';
    this.setState({
      isOpen,
      activeTab },
    () => {
      // switcher was closed, bail
      if (!isOpen) {
        return;
      }

      _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_6__["default"].addEvent('workspace', 'view_workspace_list', 'workspace_switcher', null, activeTab);

      // otherwise try to re-fetch it from sync
      this.refetchWorkspaces();
    });
  }

  /**
     * Returns a list of workspaces into 3 category: personal, joined, joinable
     * @param {Array<Object>} workspaces
     * @returns {Object} having keys 'personal', 'joined', 'joinable' and value as array of workspace list
     */
  segregateWorkspaces(workspaces = []) {
    let currentUserId = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('CurrentUserStore').id,
    wsMemberPropertyPath = `members.users.${currentUserId}`,
    personal = [],
    joined = [],
    joinable = [];

    _.forEach(workspaces, ws => {
      if (!ws) {
        return;
      }

      switch (ws.type) {
        case 'personal':
          personal.push(ws);
          break;

        case 'team':
          _.get(ws, wsMemberPropertyPath) ?
          joined.push(ws) : joinable.push(ws);
          break;}

    });

    return {
      personal: _.sortBy(personal, [w => _.toLower(w.name)]),
      joined: _.sortBy(joined, [w => _.toLower(w.name)]),
      joinable: _.sortBy(joinable, [w => _.toLower(w.name)]) };

  }

  async showWorkspacesFromLocalData() {
    let allWorkspaces = await _modules_controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_9__["default"].getAll(),
    wsMap = this.segregateWorkspaces(allWorkspaces);

    this.setState({
      isLoading: false,
      personalWorkspaces: wsMap.personal,
      teamWorkspaces: wsMap.joined,
      joinableWorkspaces: [] });

  }

  refetchWorkspaces() {
    if (!this.state.isOpen) {
      return;
    }

    this.setState({
      isLoading: true });


    _modules_controllers_SyncWorkspaceController__WEBPACK_IMPORTED_MODULE_8__["default"].getAll().
    then(workspaces => {
      let wsMap = this.segregateWorkspaces(workspaces);

      this.setState({
        isLoading: false,
        dataFetchedFirstTime: true,
        personalWorkspaces: wsMap.personal,
        teamWorkspaces: wsMap.joined,
        joinableWorkspaces: wsMap.joinable });


      _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_6__["default"].addEvent('sync', 'get_workspaces', { source: 'workspace_switcher' });
    })

    // Could not get the data from sync, fallback to showing only the joined workspaces from local data
    .catch(() => {
      this.showWorkspacesFromLocalData();
    });
  }

  handleTabChange(activeTab) {
    this.setState({ activeTab });
    _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_6__["default"].addEvent('workspace', 'view_workspace_list', 'workspace_switcher', null, activeTab);
  }

  handleSwitchWorkspace(id) {
    let toBeSwitchedToWorkspaceInstance = pm.stores.WorkspaceStore.find(id),

    // workspace will only be not there in the store when it is an unjoined workspace,
    // and unjoined workspace is also a case of a team workspace
    analyticsLabel = toBeSwitchedToWorkspaceInstance && toBeSwitchedToWorkspaceInstance.type === 'personal' ? 'workspace_switcher_personal' : 'workspace_switcher_team';

    // On artemis unjoined workspace needs to be opened in dashboard and on App it needs to be opened in Browse mode
    if (window.SDK_PLATFORM === 'browser' && _.find(this.state.joinableWorkspaces, { id: id })) {
      Object(_collaboration_services_DashboardService__WEBPACK_IMPORTED_MODULE_17__["openWorkspace"])(id);
    } else
    {
      _services_WorkspaceSwitchService__WEBPACK_IMPORTED_MODULE_16__["default"].switchWorkspace(id).
      catch(e => {
        console.log('Error in switching workspace', e);
      });
    }


    this.handleToggle(false);
    _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_6__["default"].addEvent('workspace', 'switch_workspace', analyticsLabel, 1);
  }

  handleWorkspaceAction(workspace, action) {
    this.handleToggle(false);
    switch (action) {
      case 'create':
        pm.mediator.trigger('openCreateNewWorkspaceModal');
        break;
      case 'manage-all':
        Object(_models_services_DashboardService__WEBPACK_IMPORTED_MODULE_13__["manageWorkspaces"])();
        break;}

  }

  handleSignIn() {
    this.handleToggle(false);
    _modules_services_AuthHandlerService__WEBPACK_IMPORTED_MODULE_7__["default"].login();
  }

  handleProUpgradeClick() {
    let currentUser = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('CurrentUserStore'),
    quantity;

    if (currentUser.team) {
      quantity = _.get(currentUser, 'organizations[0].team_users').length;
    }

    quantity = quantity || 1;

    Object(_models_services_DashboardService__WEBPACK_IMPORTED_MODULE_13__["upgradeToPro"])({ quantity });

    this.handleToggle(false);
  }

  handleLearnMore() {
    this.handleToggle(false);

    Object(_external_navigation_ExternalNavigationService__WEBPACK_IMPORTED_MODULE_3__["openExternalLink"])(_constants_AppUrlConstants_js__WEBPACK_IMPORTED_MODULE_14__["WORKSPACE_DOCS"]);
  }

  handleWorkspaceJoin(workspaceId) {
    if (!workspaceId) {
      return;
    }

    let joinWorkspaceEvent = Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_10__["createEvent"])('join', 'workspace', { model: 'workspace', workspace: { id: workspaceId } });

    this.setState({
      joiningWorkspaceId: workspaceId });


    Object(_modules_pipelines_user_action__WEBPACK_IMPORTED_MODULE_11__["default"])(joinWorkspaceEvent).
    then(() => {
      // This is done because after join it takes time for workspace to be hydrated in local DB
      this.workspaceStoreReaction = Object(mobx__WEBPACK_IMPORTED_MODULE_1__["reaction"])(() => {
        return Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('WorkspaceStore').find(workspaceId);
      }, workspace => {
        // If user has closed the switcher, do not switch the workspace and set joiningWorkspaceId as empty string
        if (_.isEmpty(workspace) || !this.state.isOpen) {
          this.setState({ joiningWorkspaceId: '' });
          return this.workspaceStoreReaction && this.workspaceStoreReaction();
        }

        // Close the tab and set joiningWorkspaceId as empty string once workspace is present in DB
        this.setState({
          isOpen: false,
          joiningWorkspaceId: '' },
        () => {
          _services_WorkspaceSwitchService__WEBPACK_IMPORTED_MODULE_16__["default"].switchWorkspace(workspace.id);
          return this.workspaceStoreReaction && this.workspaceStoreReaction();
        });
      });
    }).
    catch(e => {
      this.setState({
        joiningWorkspaceId: '' });

    });
  }

  render() {
    let activeWorkspaceStore = this.getActiveStore();
    if (!activeWorkspaceStore) {
      return false;
    }

    let initialWorkspaces = {
      personalWorkspaces: this.state.personalWorkspaces,
      teamWorkspaces: this.state.teamWorkspaces,
      joinableWorkspaces: this.state.joinableWorkspaces },

    isOffline = !Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('SyncStatusStore').isSocketConnected,
    activeWindow = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('ActiveWindowStore').type;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_components_base_XPaths_XPath__WEBPACK_IMPORTED_MODULE_15__["default"], { identifier: 'workspaceDropdown' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_components_workspaces_WorkspaceSwitcher__WEBPACK_IMPORTED_MODULE_4__["default"], {
          isLoading: this.state.isLoading && !this.state.dataFetchedFirstTime,
          activeTab: this.state.activeTab,
          activeWorkspace: activeWorkspaceStore,
          isLoggedIn: Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('CurrentUserStore').isLoggedIn,
          canViewTeamWorkspaces: this.state.canViewTeamWorkspaces,
          isOpen: this.state.isOpen,
          initialWorkspaces: initialWorkspaces,
          onToggle: this.handleToggle,
          onSignIn: this.handleSignIn,
          onLearnMore: this.handleLearnMore,
          onTabChange: this.handleTabChange,
          onSwitchWorkspace: this.handleSwitchWorkspace,
          onWorkspaceAction: this.handleWorkspaceAction,
          onProUpgradeClick: this.handleProUpgradeClick,
          isOffline: isOffline,
          teamSyncEnabled: Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('CurrentUserStore').teamSyncEnabled,
          disableActions: activeWindow === WINDOW_TYPE.RUNNER,
          disableJoinableWorkspaces: activeWindow === WINDOW_TYPE.RUNNER,
          onJoin: this.handleWorkspaceJoin,
          joiningWorkspaceId: this.state.joiningWorkspaceId })));



  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6015:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return WorkspaceSwitcher; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _postman_react_click_outside__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2936);
/* harmony import */ var _postman_react_click_outside__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_postman_react_click_outside__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _base_Tabs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2957);
/* harmony import */ var _base_Buttons__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2934);
/* harmony import */ var _base_FuzzySearchInput__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(3658);
/* harmony import */ var _WorkspaceSwitcherList__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(6016);
/* harmony import */ var _containers_sync_SyncOfflineStatusContainer__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(6019);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_9___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_9__);
/* harmony import */ var _base_XPaths_XPath__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(2955);
/* harmony import */ var _base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(2974);
/* harmony import */ var _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(748);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(749);
/* harmony import */ var _collaboration_utils_util__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(6021);
/* harmony import */ var _collaboration_containers_PermissionDenied__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(6022);
/* harmony import */ var _postman_design_system__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(3051);
/* harmony import */ var _postman_design_system__WEBPACK_IMPORTED_MODULE_16___default = /*#__PURE__*/__webpack_require__.n(_postman_design_system__WEBPACK_IMPORTED_MODULE_16__);
var _dec, _class;
















let



WorkspaceSwitcher = (_dec = _postman_react_click_outside__WEBPACK_IMPORTED_MODULE_2___default()({ eventCapturingPhase: false }), _dec(_class = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class WorkspaceSwitcher extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      searchQuery: '',
      focusedWorkspace: '',
      filteredPersonalWorkspaces: [],
      filteredTeamWorkspaces: [],
      filteredJoinableWorkspaces: [] };


    this.handleSwitchWorkspace = this.handleSwitchWorkspace.bind(this);
    this.setFocusedWorkspace = this.setFocusedWorkspace.bind(this);
    this.handleSignIn = this.handleSignIn.bind(this);
    this.handleTabChange = this.handleTabChange.bind(this);
    this.handleLearnMore = this.handleLearnMore.bind(this);
    this.handleProUpgrade = this.handleProUpgrade.bind(this);
    this.handleFuzzySearch = this.handleFuzzySearch.bind(this);
    this.handleSearchClick = this.handleSearchClick.bind(this);
    this.handleKeyDown = this.handleKeyDown.bind(this);
    this.getToggle = this.getToggle.bind(this);
  }

  handleProUpgrade() {
    this.props.onProUpgradeClick && this.props.onProUpgradeClick();
  }

  handleClickOutside(e) {
    this.props.onToggle && this.props.onToggle(false) || _.noop;
  }

  handleAction(action) {
    this.props.onWorkspaceAction && this.props.onWorkspaceAction(null, action);
  }

  handleSwitchWorkspace(id) {
    this.props.onSwitchWorkspace && this.props.onSwitchWorkspace(id);
  }

  handleTabChange(activeTab) {
    this.setState({
      focusedWorkspace: '' },
    () => {
      _.isFunction(this.props.onTabChange) && this.props.onTabChange(activeTab);
    });
  }

  handleSignIn() {
    this.props.onSignIn && this.props.onSignIn();
  }

  handleLearnMore() {
    this.props.onLearnMore && this.props.onLearnMore();
  }

  handleFuzzySearch(searchQuery, searchResults) {
    this.setState({
      focusedWorkspace: '',
      searchQuery: searchQuery,
      filteredPersonalWorkspaces: _.intersection(_.get(this.props.initialWorkspaces, 'personalWorkspaces', []), searchResults),
      filteredTeamWorkspaces: _.intersection(_.get(this.props.initialWorkspaces, 'teamWorkspaces', []), searchResults),
      filteredJoinableWorkspaces: _.intersection(_.get(this.props.initialWorkspaces, 'joinableWorkspaces', []), searchResults) });

  }

  isButtonDisabled() {
    if (this.props.isOffline) {
      return true;
    }
    return false;
  }

  getToggle() {
    if (this.props.disable) {
      return _.noop;
    }

    this.setState({
      searchQuery: '',
      focusedWorkspace: '' });


    this.props.onToggle(!this.props.isOpen);
  }

  getSwitcherClasses() {
    return classnames__WEBPACK_IMPORTED_MODULE_9___default()({
      'workspace-switcher__active': !this.props.disable,
      'workspace-switcher__disabled': this.props.disable });

  }

  handleSearchClick() {
    _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_12__["default"].addEvent('workspace', 'filter_workspace', 'workspace_switcher', 1);
  }

  setFocusedWorkspace(id) {
    this.setState({ focusedWorkspace: id });
  }

  handleKeyDown(event) {
    let nextIndex,
    currentIndex,
    workspaces = [],
    workspacesLength;

    if (_.isEmpty(this.props.initialWorkspaces)) {
      return;
    }

    if (this.props.activeTab === 'personal') {
      if (!_.isEmpty(this.props.initialWorkspaces.personalWorkspaces)) {
        workspaces = this.state.searchQuery ? this.state.filteredPersonalWorkspaces : this.props.initialWorkspaces.personalWorkspaces;
      }
    } else
    if (this.props.activeTab === 'team') {
      if (!_.isEmpty(this.props.initialWorkspaces.teamWorkspaces) || !_.isEmpty(this.props.initialWorkspaces.joinableWorkspaces)) {
        let joinableWorkspaces = [],
        teamWorkspaces = this.state.searchQuery ? this.state.filteredTeamWorkspaces : this.props.initialWorkspaces.teamWorkspaces;

        if (!this.props.disableJoinableWorkspaces) {
          joinableWorkspaces = this.state.searchQuery ? this.state.filteredJoinableWorkspaces : this.props.initialWorkspaces.joinableWorkspaces;
        }

        workspaces = [...teamWorkspaces, ...joinableWorkspaces];
      }
    }

    workspacesLength = workspaces.length;

    if (!workspacesLength) {
      return;
    }

    currentIndex = workspaces.findIndex(x => x.id === this.state.focusedWorkspace);

    if (_collaboration_utils_util__WEBPACK_IMPORTED_MODULE_14__["default"].isArrowUpEvent(event.key)) {
      nextIndex = currentIndex === 0 ? workspacesLength - 1 : (currentIndex - 1) % workspacesLength;
      this.setFocusedWorkspace(workspaces[nextIndex].id);
    } else
    if (_collaboration_utils_util__WEBPACK_IMPORTED_MODULE_14__["default"].isArrowDownEvent(event.key)) {
      nextIndex = (currentIndex + 1) % workspacesLength;
      this.setFocusedWorkspace(workspaces[nextIndex].id);
    } else
    if (_collaboration_utils_util__WEBPACK_IMPORTED_MODULE_14__["default"].isEnterEvent(event.key) && this.state.focusedWorkspace) {
      this.handleSwitchWorkspace(this.state.focusedWorkspace);
    }
  }

  render() {
    let isLoggedIn = this.props.isLoggedIn,
    canViewTeamWorkspaces = this.props.canViewTeamWorkspaces,
    searchQuery = this.state.searchQuery,
    initialWorkspaces = this.props.initialWorkspaces,
    filteredWorkspacesBySearch = {
      personalWorkspaces: this.state.filteredPersonalWorkspaces,
      teamWorkspaces: this.state.filteredTeamWorkspaces,
      joinableWorkspaces: this.state.filteredJoinableWorkspaces },

    isLoading = this.props.isLoading,
    items = _.concat(initialWorkspaces.personalWorkspaces, initialWorkspaces.teamWorkspaces, initialWorkspaces.joinableWorkspaces),
    disableButton = this.isButtonDisabled();

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: this.getSwitcherClasses(),
            onClick: this.getToggle },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_postman_design_system__WEBPACK_IMPORTED_MODULE_16__["Icon"], {
            name: 'icon-entity-workspaces-stroke',
            className: 'workspace-switcher__icon pm-icon pm-icon-primary',
            color: 'content-color-constant' }),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
              className: 'workspace-switcher__name',
              title: this.props.activeWorkspace.name },

            _.truncate(this.props.activeWorkspace.name, { length: 40 }) || 'Loading..'),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_postman_design_system__WEBPACK_IMPORTED_MODULE_16__["Icon"], { name: 'icon-direction-down', size: 'large', className: 'workspace-switcher__icon pm-icon pm-icon-primary' })),


        this.props.isOpen &&
        !isLoggedIn &&

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__selector' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state__title' }, 'Sign in to create workspaces'),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state__description' }, 'Workspaces help you organize your collections and environments.'),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state__learn-more' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], {
                  type: 'text',
                  onClick: this.handleLearnMore }, 'Learn more about workspaces')),




            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state__primary-btn' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], {
                  type: 'primary',
                  size: 'large',
                  onClick: this.handleSignIn }, 'Sign in to create workspaces')))),









        this.props.isOpen &&
        isLoggedIn &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            tabIndex: '0',
            className: 'workspace-switcher__selector',
            onKeyDown: this.handleKeyDown },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__header' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Tabs__WEBPACK_IMPORTED_MODULE_4__["Tabs"], {
                activeRef: this.props.activeTab,
                className: 'workspace-switcher__tabs',
                defaultActive: 'personal',
                type: 'primary',
                onChange: this.handleTabChange },

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_XPaths_XPath__WEBPACK_IMPORTED_MODULE_10__["default"], { identifier: 'personal' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Tabs__WEBPACK_IMPORTED_MODULE_4__["Tab"], { className: 'workspace-switcher__tab', refKey: 'personal' },
                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'workspace-switcher__tab__title' }, 'Personal'))),


              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_XPaths_XPath__WEBPACK_IMPORTED_MODULE_10__["default"], { identifier: 'team' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Tabs__WEBPACK_IMPORTED_MODULE_4__["Tab"], { className: 'workspace-switcher__tab', refKey: 'team' },
                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'workspace-switcher__tab__title' }, 'Team')))),




            !this.props.disableActions &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__actions' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_XPaths_XPath__WEBPACK_IMPORTED_MODULE_10__["default"], { identifier: 'createNew' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], {
                    className:
                    classnames__WEBPACK_IMPORTED_MODULE_9___default()({
                      'workspace-switcher__action workspace-switcher__action--create': true,
                      'disable-component': disableButton }),


                    type: 'text',
                    onClick: this.handleAction.bind(this, 'create') }, 'Create New')),




              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_XPaths_XPath__WEBPACK_IMPORTED_MODULE_10__["default"], { identifier: 'allWorkspaces' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], {
                    className:
                    classnames__WEBPACK_IMPORTED_MODULE_9___default()({
                      'workspace-switcher__action workspace-switcher__action--manage': true,
                      'disable-component': disableButton }),


                    type: 'text',
                    onClick: this.handleAction.bind(this, 'manage-all') }, 'All workspaces')))),








          !isLoading && !(this.props.activeTab === 'team' && !this.props.isOffline &&
          this.props.teamSyncEnabled && !canViewTeamWorkspaces) &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__search' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_FuzzySearchInput__WEBPACK_IMPORTED_MODULE_6__["default"], {
              ref: 'fuzzySearch',
              searchQuery: searchQuery,
              placeholder: 'Search for a workspace',
              onChange: this.handleFuzzySearch,
              onClick: this.handleSearchClick,
              onKeyDown: this.handleKeyDown,
              items: items,
              searchFields: ['name'] })),




          this.props.activeTab === 'personal' &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list' },

            isLoading &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_11__["default"], null),


            !_.isEmpty(initialWorkspaces.personalWorkspaces) &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list__group' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_WorkspaceSwitcherList__WEBPACK_IMPORTED_MODULE_7__["default"], {
                focusedWorkspace: this.state.focusedWorkspace,
                setFocusedWorkspace: this.setFocusedWorkspace,
                onSwitchWorkspace: this.handleSwitchWorkspace,
                workspaces: searchQuery ? filteredWorkspacesBySearch.personalWorkspaces : initialWorkspaces.personalWorkspaces,
                activeWorkspace: this.props.activeWorkspace,
                onToggle: this.props.onToggle,
                disableActions: this.props.disableActions }))),






          this.props.activeTab === 'team' && !this.props.isOffline &&
          this.props.teamSyncEnabled && !canViewTeamWorkspaces &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_collaboration_containers_PermissionDenied__WEBPACK_IMPORTED_MODULE_15__["default"], null),


          this.props.activeTab === 'team' && !this.props.teamSyncEnabled &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state workspace-switcher__upgrade_to_pro' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state__title' }, 'Start collaborating in team workspaces'),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state__description' }, 'Team workspaces allow you to share and work together on your API collections with your colleagues.'),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__state__primary-btn' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_XPaths_XPath__WEBPACK_IMPORTED_MODULE_10__["default"], { identifier: 'createNewTeam' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], {
                    type: 'primary',
                    size: 'large',
                    onClick: this.handleAction.bind(this, 'create') }, 'Create a team workspace')))),








          this.props.activeTab === 'team' && this.props.teamSyncEnabled &&
          canViewTeamWorkspaces &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_containers_sync_SyncOfflineStatusContainer__WEBPACK_IMPORTED_MODULE_8__["default"], { position: 'switcher' }),


            isLoading &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_11__["default"], null),


            !_.isEmpty(initialWorkspaces.teamWorkspaces) &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list__group' + (this.props.isOffline ? ' disable-component' : '') },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list__group__header' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'workspace-switcher__list__group__title' }, 'Workspaces you belong to')),



              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_WorkspaceSwitcherList__WEBPACK_IMPORTED_MODULE_7__["default"], {
                focusedWorkspace: this.state.focusedWorkspace,
                setFocusedWorkspace: this.setFocusedWorkspace,
                onSwitchWorkspace: this.handleSwitchWorkspace,
                workspaces: searchQuery ? filteredWorkspacesBySearch.teamWorkspaces : initialWorkspaces.teamWorkspaces,
                activeWorkspace: this.props.activeWorkspace,
                onToggle: this.props.onToggle,
                disableActions: this.props.disableActions })),




            !this.props.disableJoinableWorkspaces && !_.isEmpty(initialWorkspaces.joinableWorkspaces) &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list__group' + (this.props.isOffline ? ' disable-component' : '') },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list__group__header' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'workspace-switcher__list__group__title' }, 'Workspaces you can join')),



              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_WorkspaceSwitcherList__WEBPACK_IMPORTED_MODULE_7__["default"], {
                focusedWorkspace: this.state.focusedWorkspace,
                setFocusedWorkspace: this.setFocusedWorkspace,
                onSwitchWorkspace: this.handleSwitchWorkspace,
                workspaces: searchQuery ? filteredWorkspacesBySearch.joinableWorkspaces : initialWorkspaces.joinableWorkspaces,
                activeWorkspace: this.props.activeWorkspace,
                onToggle: this.props.onToggle,
                onJoin: this.props.onJoin,
                joiningWorkspaceId: this.props.joiningWorkspaceId,
                disableActions: this.props.disableActions }))))));









  }}) || _class) || _class);


WorkspaceSwitcher.propTypes = {
  onToggle: prop_types__WEBPACK_IMPORTED_MODULE_3___default.a.func.isRequired,
  initialWorkspaces: prop_types__WEBPACK_IMPORTED_MODULE_3___default.a.object.isRequired };
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6016:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return WorkspaceSwitcherList; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _WorkspaceSwitcherListItem__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6017);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2929);
var _class;


let


WorkspaceSwitcherList = Object(mobx_react__WEBPACK_IMPORTED_MODULE_2__["observer"])(_class = class WorkspaceSwitcherList extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.switcherRef;
    this.handleSwitchWorkspace = this.handleSwitchWorkspace.bind(this);
  }

  handleSwitchWorkspace(id) {
    this.props.onSwitchWorkspace && this.props.onSwitchWorkspace(id);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list__group__list' },

        _.isEmpty(this.props.workspaces) ?

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__no-result' }, 'No workspaces found') :





        _.map(this.props.workspaces, workspace => {
          return (
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_WorkspaceSwitcherListItem__WEBPACK_IMPORTED_MODULE_1__["default"], {
              isFocused: workspace.id === this.props.focusedWorkspace,
              setFocus: this.props.setFocusedWorkspace,
              onToggle: this.props.onToggle,
              onSelect: this.handleSwitchWorkspace,
              workspace: workspace,
              active: workspace.id === this.props.activeWorkspace.id,
              key: workspace.id,
              onJoin: this.props.onJoin,
              joiningWorkspaceId: this.props.joiningWorkspaceId,
              disableActions: this.props.disableActions }));


        })));




  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6017:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return WorkspaceSwitcherListItem; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _base_Buttons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2934);
/* harmony import */ var _WorkspaceActionDropdown__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6018);
/* harmony import */ var _base_Dropdowns__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2959);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(749);
/* harmony import */ var _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(748);
/* harmony import */ var _base_Icons_SuccessIcon__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(3220);
/* harmony import */ var _base_Tooltips__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(2935);
/* harmony import */ var _base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(2974);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;











let


WorkspaceSwitcherListItem = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class WorkspaceSwitcherListItem extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isActionsDropdownOpen: false,
      showTooltip: false };


    this.itemRef = null;
    this.userPreferenceForWorkspace = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_6__["getStore"])('UserPreferenceStore').find(`workspace:${this.props.workspace.id}:isHistoryAndRunsPulled`);
    this.isWorkspaceVisitedOnce = this.userPreferenceForWorkspace ? this.userPreferenceForWorkspace.value : true;
    this.syncStatusStore = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_6__["getStore"])('SyncStatusStore');

    this.handleSelect = this.handleSelect.bind(this);
    this.handleMouseEnter = this.handleMouseEnter.bind(this);
    this.handleDropdownToggle = this.handleDropdownToggle.bind(this);
    this.handleDropdownAction = this.handleDropdownAction.bind(this);
    this.toggleTooltip = this.toggleTooltip.bind(this);
    this.handleJoin = this.handleJoin.bind(this);
  }

  isSwitchingDisabled() {
    return !this.syncStatusStore.isSocketConnected && !this.isWorkspaceVisitedOnce;
  }

  handleJoin(e) {
    e && e.preventDefault();
    e && e.stopPropagation();

    !this.props.joiningWorkspaceId && this.props.onJoin && this.props.onJoin(_.get(this.props.workspace, 'id'));
  }

  getClasses() {
    return classnames__WEBPACK_IMPORTED_MODULE_2___default()({
      'workspace-switcher__list__group__list-item': true,
      'is-active': this.props.active,
      'is-hovered': this.state.isActionsDropdownOpen,
      'is-focused': this.props.isFocused,
      'is-disabled': this.isSwitchingDisabled() });

  }

  componentWillReceiveProps(newProps) {
    if (newProps.isFocused !== this.props.isFocused && newProps.isFocused) {
      this.scrollIntoView();
    }
  }

  handleSelect() {
    this.props.onSelect && !this.isSwitchingDisabled() && this.props.onSelect(this.props.workspace.id);
  }

  handleDropdownToggle(isOpen, e) {
    e && e.stopPropagation();
    e && e.preventDefault();

    this.setState({ isActionsDropdownOpen: isOpen });
  }

  handleDropdownAction() {
    this.props.onToggle && this.props.onToggle(false);
  }

  scrollIntoView() {
    this.itemRef &&
    _.isFunction(this.itemRef.scrollIntoView) &&
    this.itemRef.scrollIntoView({ block: 'nearest', inline: 'center' });
  }

  toggleTooltip() {
    this.setState(prevState => {
      return { showTooltip: !prevState.showTooltip };
    });
  }

  handleMouseEnter() {
    const id = _.get(this.props.workspace, 'id');

    _.isFunction(this.props.setFocus) && this.props.setFocus(id);
  }

  render() {
    const isSwitchingDisabled = this.isSwitchingDisabled();
    const tooltipProps = isSwitchingDisabled ? {
      ref: ref => this.workspaceItem = ref,
      onMouseEnter: this.toggleTooltip,
      onMouseLeave: this.toggleTooltip } :
    {},
    workspaceId = _.get(this.props.workspace, 'id');

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', _extends({
          ref: ref => this.itemRef = ref,
          className: this.getClasses(),
          onClick: this.handleSelect,
          onMouseEnter: this.handleMouseEnter },
        tooltipProps),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list__group__list-item__enabled' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Icons_SuccessIcon__WEBPACK_IMPORTED_MODULE_8__["default"], {
            className: 'workspace-switcher__list__group__list-item__enabled__icon',
            size: 'xs' })),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'workspace-switcher__list__group__list-item__name' },
          this.props.workspace.name),


        !this.props.disableActions && !isSwitchingDisabled && this.props.onJoin &&

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], {
            className: 'workspace-switcher__join',
            type: 'text',
            size: 'large',
            disabled: this.props.joiningWorkspaceId,
            onClick: this.handleJoin },

          this.props.joiningWorkspaceId === workspaceId ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_10__["default"], null) : 'Join'),




        !this.props.disableActions && !isSwitchingDisabled && !(this.props.joiningWorkspaceId === workspaceId) &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_WorkspaceActionDropdown__WEBPACK_IMPORTED_MODULE_4__["default"], {
          workspaceId: this.props.workspace.id,
          onAction: this.handleDropdownAction,
          onToggle: this.handleDropdownToggle }),


        isSwitchingDisabled &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Tooltips__WEBPACK_IMPORTED_MODULE_9__["Tooltip"], {
            show: this.state.showTooltip,
            target: this.workspaceItem,
            placement: 'right',
            immediate: true },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Tooltips__WEBPACK_IMPORTED_MODULE_9__["TooltipBody"], null, 'You need to be online to switch to this workspace.'))));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6018:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return WorkspaceActionDropdown; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _base_Buttons__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2934);
/* harmony import */ var _base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2959);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(749);
/* harmony import */ var _base_Icons_MoreIcon__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(3290);
/* harmony import */ var _utils_uuid_helper__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2401);
/* harmony import */ var _modules_controllers_SyncWorkspaceController__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(779);
/* harmony import */ var _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(748);
/* harmony import */ var _services_UIEventService__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(2921);
/* harmony import */ var _constants_UIEventConstants__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(2922);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(2929);
/* harmony import */ var _constants_MoreButtonTooltipConstant__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(3632);
var _class;











let


WorkspaceActionDropdown = Object(mobx_react__WEBPACK_IMPORTED_MODULE_10__["observer"])(_class = class WorkspaceActionDropdown extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = { isDefaultWorkspace: false };

    this.handleItemSelect = this.handleItemSelect.bind(this);
    this.handleShareWorkspace = this.handleShareWorkspace.bind(this);
  }

  UNSAFE_componentWillMount() {
    this.setDefaultWorkspace();
  }

  setDefaultWorkspace() {
    let currentUser = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('CurrentUserStore'),
    workspace = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('WorkspaceStore').find(this.props.workspaceId),
    defaultUserWorkspaceId = Object(_utils_uuid_helper__WEBPACK_IMPORTED_MODULE_5__["deterministicUUID"])(`user:${currentUser.id}`),
    defaultTeamWorkspaceId = null;

    if (workspace && workspace.id === defaultUserWorkspaceId) {
      this.setState({ isDefaultWorkspace: true });
      return;
    }

    let teamId = _.get(currentUser, 'team.id', null);
    if (teamId) {
      defaultTeamWorkspaceId = Object(_utils_uuid_helper__WEBPACK_IMPORTED_MODULE_5__["deterministicUUID"])(`team:${teamId}`);

      if (this.props.workspaceId === defaultTeamWorkspaceId) {
        this.setState({ isDefaultWorkspace: true });
      }
    }
  }

  handleShareWorkspace() {
    let workspaceId = this.props.workspaceId,
    workspace = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('WorkspaceStore').find(workspaceId),
    currentUser = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('CurrentUserStore');

    if (workspace.type === 'personal' && (this.state.isDefaultWorkspace || currentUser.isFreeUser)) {
      _services_UIEventService__WEBPACK_IMPORTED_MODULE_8__["default"].publish(_constants_UIEventConstants__WEBPACK_IMPORTED_MODULE_9__["OPEN_INVITE_MODAL"], { workspaceId, source: 'share_ws' });
      return;
    }

    pm.mediator.trigger('openShareWorkspaceModal', workspaceId);
  }

  handleItemSelect(item) {
    let { workspaceId } = this.props,
    workspace = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('WorkspaceStore').find(workspaceId);
    if (!workspace && item !== 'details') {
      pm.mediator.trigger('joinWorkspace', workspaceId);
      return;
    }
    switch (item) {
      case 'details':
        _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEvent('workspace', 'view_details');

        pm.mediator.trigger('openWorkspaceDetailsModal', workspaceId);
        break;

      case 'manageMembers':
      case 'share':
        this.handleShareWorkspace(item);
        break;

      case 'rename':
      case 'addMembers':
      case 'description':
        pm.mediator.trigger('openEditWorkspaceModal', workspaceId);
        break;

      case 'delete':
        pm.mediator.trigger('showWorkspaceDeleteModal', workspaceId);
        break;
      case 'leave':
        pm.mediator.trigger('showWorkspaceLeaveModal', workspaceId);
        break;
      default:
        break;}

    this.props.onAction && this.props.onAction(item);
  }

  getDisabledState() {
    let isOffline = !Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('SyncStatusStore').isSocketConnected;
    if (isOffline) {
      return {
        active: true,
        text: 'You need to be online to perform these actions on the workspace.' };

    }

    return { active: false };
  }

  getShareDisabledStatus() {
    let disabledState = this.getDisabledState();
    if (disabledState.active) {
      return {
        isShareDisabled: true,
        shareDisableText: disabledState.text };

    }

    return { isShareDisabled: false, shareDisableText: '' };
  }

  getDeleteDisabledStatus() {
    let disabledState = this.getDisabledState();

    if (disabledState.active) {
      return {
        isDeleteDisabled: true,
        deleteDisableText: disabledState.text };

    }

    // Bootstrapped workspace cannot be deleted
    if (this.state.isDefaultWorkspace) {
      return {
        isDeleteDisabled: true,
        deleteDisableText: 'You cannot delete this workspace.' };

    }

    return { isDeleteDisabled: false, deleteDisableText: '' };
  }

  render() {
    let isOffline = !Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('SyncStatusStore').isSocketConnected,
    disabledState = this.getDisabledState(isOffline),
    workspace = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('WorkspaceStore').find(this.props.workspaceId),
    { isShareDisabled, shareDisableText } = this.getShareDisabledStatus(),
    { isDeleteDisabled, deleteDisableText } = this.getDeleteDisabledStatus();

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["Dropdown"], {
          className: 'workspace-actions-dropdown',
          onSelect: this.handleItemSelect,
          onToggle: this.props.onToggle },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["DropdownButton"], {
            dropdownStyle: 'nocaret',
            type: 'custom' },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_1__["Button"], {
              type: 'icon',
              className: 'workspace-actions-dropdown-button',
              tooltip: _constants_MoreButtonTooltipConstant__WEBPACK_IMPORTED_MODULE_11__["ACTION_TYPE_VIEW_MORE_ACTIONS_TOOLTIP"] },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Icons_MoreIcon__WEBPACK_IMPORTED_MODULE_4__["default"], null))),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["DropdownMenu"], { 'align-right': true },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], { refKey: 'details' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'View Details')),


          workspace && workspace.type === 'personal' &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
              disabled: isShareDisabled,
              disabledText: shareDisableText,
              tooltipPlacement: this.props.tooltipPlacement,
              refKey: 'share' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'Invite to Workspace')),


          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
              disabled: disabledState.active,
              disabledText: disabledState.text,
              refKey: 'rename' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'Rename')),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
              disabled: disabledState.active,
              disabledText: disabledState.text,
              refKey: 'description' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'Edit Workspace')),


          workspace && workspace.type === 'team' &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
              disabled: disabledState.active,
              disabledText: disabledState.text,
              refKey: 'addMembers' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'Add Members')),



          workspace && workspace.type !== 'personal' &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
              disabled: disabledState.active,
              disabledText: disabledState.text,
              refKey: 'manageMembers' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'Invite to Workspace')),



          workspace && workspace.type !== 'personal' &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
              disabled: disabledState.active,
              disabledText: disabledState.text,
              refKey: 'leave' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'Leave')),


          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Dropdowns__WEBPACK_IMPORTED_MODULE_2__["MenuItem"], {
              disabled: isDeleteDisabled,
              disabledText: deleteDisableText,
              tooltipPlacement: this.props.tooltipPlacement,
              refKey: 'delete' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'Delete')))));




  }}) || _class;


WorkspaceActionDropdown.defaultProps = { tooltipPlacement: 'right' };
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6019:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return SyncOfflineStatusBarContainer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _components_sync_SyncOfflineStatusBar__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6020);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(749);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2929);
/* harmony import */ var _constants_RequesterTabConstants__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(774);
var _class;





const config = {
  switcher: {
    default: {
      offline: 'You need to have an active internet connection to be able to switch to or create a workspace.',
      connecting: 'Trying to reconnect to sync.' } },


  builder: {
    default: {
      offline: 'You seem to be offline. Any changes made while offline might not sync properly with other members of this workspace.',
      connecting: 'Trying to reconnect to sync... Any changes made while offline will sync once you are back online..' },

    personal: {
      offline: 'You seem to be offline. Data in this workspace might not be up to date.' } } };let





SyncOfflineStatusBarContainer = Object(mobx_react__WEBPACK_IMPORTED_MODULE_3__["observer"])(_class = class SyncOfflineStatusBarContainer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);
  }

  getMessage(position, status, workspaceType) {
    const data = config[position];
    const defaultMessages = data.default;

    return _.get(data, [workspaceType, status]) || defaultMessages[status];
  }

  render() {
    let currentSyncStatus = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_2__["getStore"])('SyncStatusStore').currentSyncStatus,
    notInSync = !Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_2__["getStore"])('SyncStatusStore').isSocketConnected,
    status;

    if (currentSyncStatus === 'connecting') {
      status = 'connecting';
    } else if (!_.includes('insync', 'syncing', 'idle'), currentSyncStatus) {
      status = 'offline';
    }

    let isOpen = notInSync &&
    !(Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_2__["getStore"])('ActiveWorkspaceSessionStore').viewMode === _constants_RequesterTabConstants__WEBPACK_IMPORTED_MODULE_4__["WORKSPACE_BROWSER_VIEW"] && status === 'offline' && this.props.position === 'builder');

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_components_sync_SyncOfflineStatusBar__WEBPACK_IMPORTED_MODULE_1__["default"], {
        isOpen: isOpen,
        status: status,
        message: this.getMessage(this.props.position, status, Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_2__["getStore"])('ActiveWorkspaceStore').type) }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6020:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _base_Infobar__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(3716);
/* harmony import */ var _constants_InfobarConstants__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2424);




const infoBarType = {
  'connecting': _constants_InfobarConstants__WEBPACK_IMPORTED_MODULE_2__["WARN"],
  'offline': _constants_InfobarConstants__WEBPACK_IMPORTED_MODULE_2__["ERROR"] };let


SyncOfflineStatusBar = class SyncOfflineStatusBar extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  render() {
    return (
      this.props.isOpen &&
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Infobar__WEBPACK_IMPORTED_MODULE_1__["default"], {
        type: infoBarType[this.props.status],
        message: this.props.message,
        isDismissable: false,
        className: 'sync-offline-status-bar' }));


  }};


/* harmony default export */ __webpack_exports__["default"] = (SyncOfflineStatusBar);

/***/ }),

/***/ 6021:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony default export */ __webpack_exports__["default"] = ({
  /**
                  * Check if the keyboard event key name
                  * is ArrowUp, or Up in older versions of IE/Edge
                  *
                  * @param {String} key - KeyboardEvent.key
                  * @returns {boolean} - true if key is ArrowUp/Up
                  */
  isArrowUpEvent(key) {
    return key === 'ArrowUp' || key === 'Up';
  },

  /**
      * Check if the keyboard event key name
      * is ArrowDown, or Down in older versions of IE/Edge
      *
      * @param {String} key - KeyboardEvent.key
      * @returns {boolean} - true if key is ArrowDown/Down
      */
  isArrowDownEvent(key) {
    return key === 'ArrowDown' || key === 'Down';
  },

  /**
      * Check if the keyboard event key name is Enter
      * also labelled as Return in few keyboards
      *
      * @param {String} key - KeyboardEvent.key
      * @returns {boolean} - true if key is Enter
      */
  isEnterEvent(key) {
    return key === 'Enter';
  } });

/***/ }),

/***/ 6022:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);


const PermissionDenied = ({ title, subtitle }) => {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'permission-denied' },
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'permission-denied--img' }),
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'permission-denied--title' },
        title || 'You don\'t have permissions to view this page'),

      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'permission-denied--subtitle' },
        subtitle || 'Only users with a developer role can view or join team workspaces. Contact your team admin to make sure you have the proper roles.')));



};

/* harmony default export */ __webpack_exports__["default"] = (PermissionDenied);

/***/ }),

/***/ 6023:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "openWorkspace", function() { return openWorkspace; });
/* harmony import */ var _js_modules_services_APIService__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2386);


/**
                                                                                * Open workspace
                                                                                *
                                                                                * @param {String} id - workspace ID
                                                                                */
function openWorkspace(id) {
  Object(_js_modules_services_APIService__WEBPACK_IMPORTED_MODULE_0__["openAuthenticatedRoute"])(`${pm.dashboardUrl}/workspaces/${id}`);
}



/***/ }),

/***/ 6024:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchPermissions", function() { return fetchPermissions; });
/* harmony import */ var _PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6025);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(749);
/* harmony import */ var _utils_util__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(784);
/* harmony import */ var _controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(756);





const PERMISSION_HANDLER_MAP = {

  /**
                                  * Checks if user has permission to add member to the workspace
                                  *
                                  * @param { String } workspaceId
                                  *
                                  * @returns { Boolean }
                                  */
  addMemberToWorkspace: async workspaceId => {
    let { type } = await _controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_3__["default"].get({ id: workspaceId });

    if (!Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore').team || type === 'personal') {
      return true;
    }

    try {
      return _.get((await Object(_PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__["fetchAddMemberToWorkspaces"])([workspaceId])), `${workspaceId}.allowed`, true);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to remove member to the workspace
      *
      * @param { String } workspaceId
      *
      * @returns { Boolean }
      */
  removeMemberFromWorkspace: async workspaceId => {
    let { type } = await _controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_3__["default"].get({ id: workspaceId });

    if (!Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore').team || type === 'personal') {
      return true;
    }

    try {
      return _.get((await Object(_PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__["fetchRemoveMemberFromWorkspaces"])([workspaceId])), `${workspaceId}.allowed`, true);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to update roles in the workspace
      *
      * @param { String } workspaceId
      *
      * @returns { Boolean }
      */
  updateWorkspaceRoles: async workspaceId => {
    let { type } = await _controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_3__["default"].get({ id: workspaceId });

    if (!Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore').team || type === 'personal') {
      return true;
    }

    try {
      return _.get((await Object(_PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__["fetchUpdateWorkspacesRoles"])([workspaceId])), `${workspaceId}.allowed`, true);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to update workspace meta
      *
      * @param { String } workspaceId
      *
      * @returns { Boolean }
      */
  updateWorkspaceMeta: async workspaceId => {
    let { type } = await _controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_3__["default"].get({ id: workspaceId });

    if (!Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore').team || type === 'personal') {
      return true;
    }

    try {
      return _.get((await Object(_PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__["fetchUpdateWorkspacesMeta"])([workspaceId])), `${workspaceId}.allowed`, true);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to send preapproved invites in a team
      *
      * @returns { Boolean }
      */
  manageTeamInvites: async () => {
    const user = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore'),
    teamId = _.get(user, 'team.id');

    // A free user or the one for which the trial has been activated
    // can invite users outside the team.
    if (_utils_util__WEBPACK_IMPORTED_MODULE_2__["default"].isFreeUser(user) || _utils_util__WEBPACK_IMPORTED_MODULE_2__["default"].isTrialActive(user)) {
      return true;
    }

    try {
      return _.get((await Object(_PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__["fetchManageTeamInvites"])(teamId)), `${teamId}.allowed`, true);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to send unapproved invites in a team
      *
      * @returns { Boolean }
      */
  sendUnapprovedInvites: async () => {
    const user = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore'),
    teamId = _.get(user, 'team.id');

    try {
      return _.get((await Object(_PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__["fetchSendUnapprovedInvites"])(teamId)), `${teamId}.allowed`, false);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to manage payments in a team
      *
      * @returns { Boolean }
      */
  managePayment: async () => {
    const user = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore'),
    teamId = _.get(user, 'team.id');

    if (!Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore').isUserDelinquent) {
      return true;
    }

    try {
      return _.get((await Object(_PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__["fetchManagePayment"])(teamId)), `${teamId}.allowed`, false);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to view team workspaces
      *
      * @returns { Boolean }
      */
  viewVisibleWorkspaceTeam: async () => {
    const user = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_1__["getStore"])('CurrentUserStore'),
    teamId = _.get(user, 'team.id');

    try {
      return _.get((await Object(_PermissionRemoteFetchService__WEBPACK_IMPORTED_MODULE_0__["fetchViewVisibleWorkspaceTeam"])(teamId)), `${teamId}.allowed`, false);
    }
    catch (e) {
      console.warn(e);

      return false;
    }
  } };


/**
        * Fetches permission status for an array of permissions
        * Check individual handlers for function definition
        *
        * @param { String[] } permissions
        * @param { String } entityId
        */
async function fetchPermissions(permissions = [], entityId) {
  let permissionStatus = {};

  permissionStatus = await Promise.all(
  _.map(permissions, async permission => {
    if (!PERMISSION_HANDLER_MAP[permission]) {
      console.warn(`${permission} permission does not exist`);

      return {
        name: permission,
        allowed: false };

    }

    return {
      name: permission,
      allowed: await PERMISSION_HANDLER_MAP[permission](entityId) };

  }));


  return _.reduce(permissionStatus, (acc, permission) => {
    acc[permission.name] = permission.allowed;

    return acc;
  }, {});
}
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6025:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchAddCollectionToWorkspaces", function() { return fetchAddCollectionToWorkspaces; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchAddMemberToWorkspaces", function() { return fetchAddMemberToWorkspaces; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchRemoveMemberFromWorkspaces", function() { return fetchRemoveMemberFromWorkspaces; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchUpdateWorkspacesMeta", function() { return fetchUpdateWorkspacesMeta; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchUpdateWorkspacesRoles", function() { return fetchUpdateWorkspacesRoles; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchCollectionManageRole", function() { return fetchCollectionManageRole; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchCollectionShare", function() { return fetchCollectionShare; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchAddEnvironmentToWorkspaces", function() { return fetchAddEnvironmentToWorkspaces; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchEnvironmentShare", function() { return fetchEnvironmentShare; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchEnvironmentManageRole", function() { return fetchEnvironmentManageRole; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchAddAPIToWorkspaces", function() { return fetchAddAPIToWorkspaces; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchAPIManageRole", function() { return fetchAPIManageRole; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchAPIShare", function() { return fetchAPIShare; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchSendUnapprovedInvites", function() { return fetchSendUnapprovedInvites; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchManageTeamInvites", function() { return fetchManageTeamInvites; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchManagePayment", function() { return fetchManagePayment; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchViewVisibleWorkspaceTeam", function() { return fetchViewVisibleWorkspaceTeam; });
/* harmony import */ var _constants_ACConstants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2443);
/* harmony import */ var _controllers_UserController__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2383);
/* harmony import */ var _SyncRemoteFetcherService__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(762);




const {
  ADD_COLLECTION_TO_WORKSPACE,
  ADD_ENVIRONMENT_TO_WORKSPACE,
  ADD_MEMBER_TO_WORKSPACE,
  REMOVE_MEMBER_FROM_WORKSPACE,
  UPDATE_WORKSPACE_META,
  UPDATE_WORKSPACE_ROLES,
  UPDATE_COLLECTION_ROLES,
  UPDATE_ENVIRONMENT_ROLES,
  SHARE_COLLECTION,
  SHARE_ENVIRONMENT } =
_constants_ACConstants__WEBPACK_IMPORTED_MODULE_0__["default"],

// @todo: Move these permissions as imports from ACConstants once the file is updated
// by @product-core
ADD_API_TO_WORKSPACE = 'ADD_API_TO_WORKSPACE',
SHARE_API = 'SHARE_API',
UPDATE_API_ROLES = 'UPDATE_API_ROLES',
WORKSPACE = 'workspace',
COLLECTION = 'collection',
ENVIRONMENT = 'environment',
API = 'api',
USER = 'user',
TEAM = 'team',
MANAGE_TEAM_INVITES = 'MANAGE_TEAM_INVITES',
SEND_UNAPPROVED_INVITES = 'SEND_UNAPPROVED_INVITES',
MANAGE_PAYMENTS = 'MANAGE_PAYMENTS',
VIEW_VISIBLE_WORKSPACE_TEAM = 'VIEW_VISIBLE_WORKSPACE_TEAM';

/**
                                                              * Fetches the permission for a list of models
                                                              *
                                                              * @private
                                                              * @param {String} permission
                                                              * @param {Object} options
                                                              * @param {Array<Object>} options.modelIds
                                                              * @param {String} options.modelType
                                                              * @returns Promise<{ permissions: object[] }>
                                                              */
async function _fetchPerObject(permission, options) {
  let { modelIds, modelType } = options,
  { id: userId } = await _controllers_UserController__WEBPACK_IMPORTED_MODULE_1__["default"].get(),
  criteria = _.transform(modelIds, (acc, modelId) => {
    acc[modelId] = {
      entityType: USER,
      entityId: userId,
      permission,
      objectType: modelType,
      objectId: modelId };

  }, {});

  return _SyncRemoteFetcherService__WEBPACK_IMPORTED_MODULE_2__["default"].
  remoteFetch('permission', 'fetchPerObject', criteria);
}

/**
   * Fetches the permission status for adding a collection to a workspaces
   * for a given list of workspaces
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchAddCollectionToWorkspaces(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchAddCollectionToWorkspace: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(ADD_COLLECTION_TO_WORKSPACE, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for adding a member to the workspace
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchAddMemberToWorkspaces(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchAddMemberToWorkspaces: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(ADD_MEMBER_TO_WORKSPACE, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for removing a member from the workspace
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchRemoveMemberFromWorkspaces(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchRemoveMemberFromWorkspaces: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(REMOVE_MEMBER_FROM_WORKSPACE, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for updating workspace meta
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchUpdateWorkspacesMeta(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchUpdateWorkspacesMeta: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(UPDATE_WORKSPACE_META, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for updating workspace roles
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchUpdateWorkspacesRoles(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchUpdateWorkspacesRoles: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(UPDATE_WORKSPACE_ROLES, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}


/**
   * Fetches the permission status for managing roles on a collection
   *
   * @param {String} collectionUID
   * @returns Promise<{ results: object[] }>
   */
function fetchCollectionManageRole(collectionUID) {
  if (!collectionUID) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchUpdateWorkspacesRoles: No collection UID provided'));
  }

  let options = { modelIds: [collectionUID], modelType: COLLECTION };

  return _fetchPerObject(UPDATE_COLLECTION_ROLES, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for sharing a collection
   *
   * @param {String} collectionUID
   * @returns Promise<{ results: object[] }>
   */
function fetchCollectionShare(collectionUID) {
  if (!collectionUID) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchUpdateWorkspacesRoles: No collection UID provided'));
  }

  let options = { modelIds: [collectionUID], modelType: COLLECTION };

  return _fetchPerObject(SHARE_COLLECTION, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for adding a environment to a workspaces
   * for a given list of workspaces
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchAddEnvironmentToWorkspaces(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchAddEnvironmentToWorkspaces: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(ADD_ENVIRONMENT_TO_WORKSPACE, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for sharing a environment
   *
   * @param {String} environmentUID
   * @returns Promise<{ results: object[] }>
   */
function fetchEnvironmentShare(environmentUID) {
  if (!environmentUID) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchEnvironmentShare: No environment UID provided'));
  }

  let options = { modelIds: [environmentUID], modelType: ENVIRONMENT };

  return _fetchPerObject(SHARE_ENVIRONMENT, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for managing roles on a environment
   *
   * @param {String} environmentUID
   * @returns Promise<{ results: object[] }>
   */
function fetchEnvironmentManageRole(environmentUID) {
  if (!environmentUID) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchEnvironmentManageRole: No environment UID provided'));
  }

  let options = { modelIds: [environmentUID], modelType: ENVIRONMENT };

  return _fetchPerObject(UPDATE_ENVIRONMENT_ROLES, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for adding an API to a workspaces
   * for a given list of workspaces
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchAddAPIToWorkspaces(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchAddAPIToWorkspaces: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(ADD_API_TO_WORKSPACE, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}


/**
   * Fetches the permission status for managing roles on an API
   *
   * @param {String} apiId
   * @returns Promise<{ results: object[] }>
   */
function fetchAPIManageRole(apiId) {
  if (!apiId) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchAPIManageRole: No API ID provided'));
  }

  let options = { modelIds: [apiId], modelType: API };

  return _fetchPerObject(UPDATE_API_ROLES, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for sharing an API
   *
   * @param {String} apiId
   * @returns Promise<{ results: object[] }>
   */
function fetchAPIShare(apiId) {
  if (!apiId) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchAPIShare: No API ID provided'));
  }

  let options = { modelIds: [apiId], modelType: API };

  return _fetchPerObject(SHARE_API, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
  * Fetches permission status for send unapproved invites
  * @param { String } teamId
  * @returns Promise<{ results: object[] }>
  */
function fetchSendUnapprovedInvites(teamId) {
  if (!teamId) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchSendUnapprovedInvites: No team id provided'));
  }

  let options = { modelIds: [teamId], modelType: TEAM };

  return _fetchPerObject(SEND_UNAPPROVED_INVITES, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
  * Fetches permission status for send preapproved invites
  * @param { String } teamId
  * @returns Promise<{ results: object[] }>
  */
function fetchManageTeamInvites(teamId) {
  if (!teamId) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchManageTeamInvites: No team id provided'));
  }

  let options = { modelIds: [teamId], modelType: TEAM };

  return _fetchPerObject(MANAGE_TEAM_INVITES, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
  * Fetches permission status for managing payment
  * @param { String } teamId
  * @returns Promise<{ results: object[] }>
  */
function fetchManagePayment(teamId) {
  if (!teamId) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchManagePayment: No team id provided'));
  }

  let options = { modelIds: [teamId], modelType: TEAM };

  return _fetchPerObject(MANAGE_PAYMENTS, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
  * Fetches permission status for viewing team workspaces
  * @param { String } teamId
  * @returns Promise<{ results: object[] }>
  */
function fetchViewVisibleWorkspaceTeam(teamId) {
  if (!teamId) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchViewVisibleWorkspaceTeam: No team id provided'));
  }

  let options = { modelIds: [teamId], modelType: TEAM };

  return _fetchPerObject(VIEW_VISIBLE_WORKSPACE_TEAM, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6026:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerRun; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _RunSelector_RunnerRunsSelector__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6027);
/* harmony import */ var _RecentRuns_RunnerRecentRuns__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6038);
/* harmony import */ var _RunCustomizer_RunnerRunsCustomizer__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6044);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(749);
var _class;





let



RunnerRun = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class RunnerRun extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    // Let get the reference to the store
    this.store = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('RunnerSelectionStore');
  }

  isCollectionSelected() {
    return !!_.get(this.store, 'selection.collection');
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunSelector_RunnerRunsSelector__WEBPACK_IMPORTED_MODULE_2__["default"], null),
        this.isCollectionSelected() ?

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunCustomizer_RunnerRunsCustomizer__WEBPACK_IMPORTED_MODULE_4__["default"], null) :


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RecentRuns_RunnerRecentRuns__WEBPACK_IMPORTED_MODULE_3__["default"], { onOpenRun: this.props.onOpenRun })));



  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6027:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerRunsSelector; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _js_components_explorer_RunnerCollectionExplorer__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6028);
/* harmony import */ var _js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2959);
/* harmony import */ var _js_components_base_Tooltips__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2935);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(3048);
/* harmony import */ var _base_molecule__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(3679);
/* harmony import */ var _js_components_base_SearchHighlighter__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(3671);
/* harmony import */ var _variables_environment_EnvironmentMetaIcons__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(6036);
/* harmony import */ var _js_components_base_Icons_CloseIcon__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(3049);
/* harmony import */ var _js_components_base_Icons_InformationIcon__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(3231);
/* harmony import */ var _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(5353);
/* harmony import */ var _RunnerSelectorFilePreview__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(6037);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(749);
/* harmony import */ var _base_atom__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(3633);
/* harmony import */ var _helpers_RunnerHelper__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(5395);
/* harmony import */ var _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(3269);
var _class;


















const keyMap = { start: 'meta+enter' },
defaultEnvironment = {
  id: null,
  name: 'No Environment' };let



RunnerRunsSelector = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class RunnerRunsSelector extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      dataArray: [],
      isPreviewModalOpen: false,
      isLogResTooltipVisible: false,
      isVariableTooltipVisible: false,
      isSaveCookiesTooltipVisible: false };


    this.handleFileSelect = this.handleFileSelect.bind(this);
    this.handleFilePreview = this.handleFilePreview.bind(this);
    this.handleCloseFilePreview = this.handleCloseFilePreview.bind(this);
    this.showTooltip = this.showTooltip.bind(this);
    this.hideTooltip = this.hideTooltip.bind(this);
    this.handleEnvSelect = this.handleEnvSelect.bind(this);
    this.handleStartRun = this.handleStartRun.bind(this);

    this.store = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_14__["getStore"])('RunnerSelectionStore');
  }

  getKeyMapHandlers() {
    return { start: this.handleStartRun };
  }

  getSelectedEnvironment() {
    const environments = this.getEnvironments(),
    environment = _.find(environments, ['id', this.store.selection.environment]),
    envName = environment ? environment.name : '';

    return envName;
  }

  getDataArray(callback) {
    if (!this.store.selection.dataFile) {
      return callback('No file selected');
    }

    const { fileType, dataFile } = this.store.selection;

    return Object(_helpers_RunnerHelper__WEBPACK_IMPORTED_MODULE_16__["readFile"])(dataFile, fileType, (err, data) => {
      if (err) {
        pm.toasts.error(err);

        return callback(err);
      }

      return callback(null, data);
    });
  }

  getCollections() {
    return this.store.collections;
  }

  getEnvironments() {
    const environments = _.sortBy(this.store.environments, environment => _.toLower(environment.name));

    return _.concat([defaultEnvironment], environments);
  }

  getTooltipText(isDisabled) {
    if (isDisabled) {
      return 'You do not have permissions to perform this action.';
    }
  }

  handleChange(key, value) {
    this.store.selection.change(key, value);
  }

  handleFileSelect(fileList) {
    if (_.isEmpty(fileList)) {
      this.refs.dataFile && this.refs.dataFile.clear();
    }

    // Process the file to handle websocket/xhr based flows
    pm.runtime.processFiles(fileList, (err, files) => {
      if (err) {
        const message = err.message === 'Connection Error' ? _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_17__["FILE_UPLOAD_CONNECTION_ERROR"] : _constants_AgentConstants__WEBPACK_IMPORTED_MODULE_17__["FILE_UPLOAD_PERM_ERROR"];

        pm.toasts.error(message, { noIcon: true, title: 'Couldn\'t upload file' });

        return;
      }

      this.handleChange('data', files);
    });
  }

  handleFilePreview() {
    this.getDataArray((err, dataArray) => {
      if (!err) {
        this.setState({
          dataArray,
          isPreviewModalOpen: true });

      }
    });
  }

  handleCloseFilePreview() {
    this.setState({ dataArray: [], isPreviewModalOpen: false });
  }

  handleStartRun() {
    this.store.startRun();
  }

  showTooltip(tooltipKey) {
    this.setState({ [tooltipKey]: true });
  }

  hideTooltip(tooltipKey) {
    this.setState({ [tooltipKey]: false });
  }

  filterEnvironments(environmentList, query, options = {}) {
    if (!query || options.firstRender) {
      return environmentList;
    }

    return _.filter(
    environmentList,
    environment => environment && environment.id && _.includes(_.toLower(environment.name), _.toLower(query)));

  }

  handleEnvSelect(environment) {
    this.handleChange('environment', environment.id);
  }

  renderEnvItem(item, search, option = {}) {
    const { name } = item,
    { id } = item,
    shouldHighlight = search && !option.firstRender;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'item-wrapper' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'item-label' },

          shouldHighlight ?

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_SearchHighlighter__WEBPACK_IMPORTED_MODULE_8__["default"], {
            source: name,
            query: search }) :


          name),




        // Adding this check to prevent showing meta icons for `No Environment` option
        id !== null && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_variables_environment_EnvironmentMetaIcons__WEBPACK_IMPORTED_MODULE_9__["default"], { environmentId: item.id })));



  }

  render() {
    const collections = this.getCollections(),
    environments = this.getEnvironments(),
    { selection } = this.store,
    selectedEnvironmentId = selection && selection.environment,
    selectedEnvironment = _.find(environments, env => env.id === selectedEnvironmentId) || defaultEnvironment;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_atom__WEBPACK_IMPORTED_MODULE_15__["KeyMaps"], {
          handlers: this.getKeyMapHandlers(),
          keyMap: keyMap },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__wrapper' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__item runner-runs-selector__item--target' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__meta runner-runs-selector__meta--target' }, 'Choose a collection or folder'),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_explorer_RunnerCollectionExplorer__WEBPACK_IMPORTED_MODULE_2__["default"], {
                selection: selection,
                collections: collections,
                loading: this.store.isHydrating || selection.loading })),



            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__item  runner-runs-selector__item--environment' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__meta runner-runs-selector__meta--environment' }, 'Environment'),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_molecule__WEBPACK_IMPORTED_MODULE_7__["InputSelectV2"], {
                className: 'runner-runs-selector__environment',
                selectedItem: selectedEnvironment,
                getInputValue: environmentObj => _.get(environmentObj, 'name') || '',
                optionRenderer: this.renderEnvItem,
                getFilteredList: this.filterEnvironments.bind(this, environments),
                ref: 'inputSelect',
                onSelect: this.handleEnvSelect,
                menuClassName: 'runner-runs__environment-selector-menu' })),



            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__item runner-runs-selector__item--iterations' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__meta runner-runs-selector__meta--iterations' }, 'Iterations'),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_6__["Input"], {
                className: 'runner-runs-selector__item__value runner-runs-selector__item__value--iterations',
                inputStyle: 'box',
                type: 'text',
                value: selection.iterations,
                onChange: this.handleChange.bind(this, 'iterations') })),



            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__item runner-runs-selector__item--delay' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__meta runner-runs-selector__meta--delay' }, 'Delay'),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_6__["Input"], {
                className: 'runner-runs-selector__item__value runner-runs-selector__item__value--delay',
                inputStyle: 'box',
                type: 'text',
                value: selection.delay,
                onChange: this.handleChange.bind(this, 'delay') }),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__postfix runner-runs-selector__postfix--delay' }, 'ms')),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__item runner-runs-selector__item--data-file' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__meta runner-runs-selector__meta--data-file' }, 'Data'),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], {
                  className: 'runner-runs-selector__item__value runner-runs-selector__item__value--data-file',
                  size: 'small',
                  type: 'secondary' }, 'Select File'),



              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_6__["Input"], {
                className: 'runner-runs-selector__item__value runner-runs-selector__item__value--data-file',
                type: 'file',
                ref: 'dataFile',
                onChange: this.handleFileSelect }),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__postfix runner-runs-selector__postfix--data-file' },
                _.get(selection, 'dataFile.name', '')),


              selection.dataFile &&

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], {
                  className: 'runner-runs-selector__postfix--data-file-remove',
                  type: 'icon',
                  onClick: this.handleFileSelect.bind(this, []),
                  tooltip: 'Remove selected file' },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_CloseIcon__WEBPACK_IMPORTED_MODULE_10__["default"], { className: 'runner-runs-selector__postfix--data-file-remove-icon' }))),






            selection.dataFile &&

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__item runner-runs-selector__item--data-file-type' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__meta runner-runs-selector__meta--data-file-type' }, 'Data File Type'),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_3__["Dropdown"], {
                  className: 'runner-runs-selector__item__value runner-runs-selector__item__value--data-file-type',
                  onSelect: this.handleChange.bind(this, 'dataType') },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_3__["DropdownButton"], {
                    size: 'small',
                    type: 'secondary' },

                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], { className: 'runner-runs-selector__item__value--data-file-type__selected' },
                    selection.fileType || _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_12__["RUNNER_DATA_FILE_TYPE_UNDETERMINED"])),


                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_3__["DropdownMenu"], null,
                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_3__["MenuItem"], { refKey: _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_12__["RUNNER_DATA_FILE_TYPE_JSON"], className: 'dropdown-menu-item--JSON' }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_12__["RUNNER_DATA_FILE_TYPE_JSON"])),
                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_3__["MenuItem"], { refKey: _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_12__["RUNNER_DATA_FILE_TYPE_CSV"], className: 'dropdown-menu-item--CSV' }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_12__["RUNNER_DATA_FILE_TYPE_CSV"])),
                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_3__["MenuItem"], { refKey: _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_12__["RUNNER_DATA_FILE_TYPE_UNDETERMINED"], className: 'dropdown-menu-item--Undetermined' }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_12__["RUNNER_DATA_FILE_TYPE_UNDETERMINED"])))),


              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], {
                  className: 'runner-runs-selector__item__value--data-file-preview',
                  size: 'small',
                  type: 'secondary',
                  onClick: this.handleFilePreview }, 'Preview')),







            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerSelectorFilePreview__WEBPACK_IMPORTED_MODULE_13__["default"], {
              dataArray: this.state.dataArray,
              isOpen: this.state.isPreviewModalOpen,
              handleClose: this.handleCloseFilePreview }),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__item runner-runs-selector__item--response' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__meta runner-runs-selector__meta--response' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_6__["Checkbox"], {
                  checked: selection.saveResponse,
                  onChange: this.handleChange.bind(this, 'saveResponse') })),


              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  className: 'runner-runs-selector__item__value runner-runs-selector__item__value--response',
                  onClick: this.handleChange.bind(this, 'persist', !selection.saveResponse) }, 'Save responses'),



              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__postfix runner-runs-selector__postfix--response' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                    className: 'runner-runs-selector__postfix-icon runner-runs-selector__postfix-icon--response',
                    ref: 'logResTooltipTarget',
                    onMouseEnter: this.showTooltip.bind(this, 'isLogResTooltipVisible'),
                    onMouseLeave: this.hideTooltip.bind(this, 'isLogResTooltipVisible') },

                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_InformationIcon__WEBPACK_IMPORTED_MODULE_11__["default"], {
                    className: 'runner-runs-selector__postfix-icon' })),


                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Tooltips__WEBPACK_IMPORTED_MODULE_4__["Tooltip"], {
                    show: this.state.isLogResTooltipVisible,
                    target: this.refs.logResTooltipTarget,
                    placement: 'right',
                    className: 'runner-runs-selector__postfix-tooltip',
                    immediate: true },

                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Tooltips__WEBPACK_IMPORTED_MODULE_4__["TooltipBody"], null, 'Logging responses allows you to view response headers and bodies for the request. This might impact performance on larger collection runs.')))),







            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__item  runner-runs-selector__item--persist' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__meta runner-runs-selector__meta--persist' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_6__["Checkbox"], {
                  checked: selection.persist,
                  onChange: this.handleChange.bind(this, 'persist') })),


              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  className: 'runner-runs-selector__item__value runner-runs-selector__item__value--persist',
                  onClick: this.handleChange.bind(this, 'persist', !selection.persist) }, 'Keep variable values'),



              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__postfix runner-runs-selector__postfix--persist' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                    className: 'runner-runs-selector__postfix-icon runner-runs-selector__postfix-icon--persist',
                    ref: 'variableTooltipTarget',
                    onMouseEnter: this.showTooltip.bind(this, 'isVariableTooltipVisible'),
                    onMouseLeave: this.hideTooltip.bind(this, 'isVariableTooltipVisible') },

                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_InformationIcon__WEBPACK_IMPORTED_MODULE_11__["default"], {
                    className: 'runner-runs-selector__postfix-icon' })),


                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Tooltips__WEBPACK_IMPORTED_MODULE_4__["Tooltip"], {
                    show: this.state.isVariableTooltipVisible,
                    target: this.refs.variableTooltipTarget,
                    placement: 'right',
                    className: 'runner-runs-selector__postfix-tooltip',
                    immediate: true },

                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Tooltips__WEBPACK_IMPORTED_MODULE_4__["TooltipBody"], null, 'Enabling this will write the value of the variables at the end of the run to its current value in the session.')))),







            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__item  runner-runs-selector__item--initial-cookies' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__meta runner-runs-selector__meta--initial-cookies' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_6__["Checkbox"], {
                  checked: selection.runWithEmptyCookieJar,
                  onChange: this.handleChange.bind(this, 'runWithEmptyCookieJar') })),


              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  className: 'runner-runs-selector__item__value runner-runs-selector__item__value--initial-cookies',
                  onClick: this.handleChange.bind(this, 'runWithEmptyCookieJar', !selection.runWithEmptyCookieJar) }, 'Run collection without using stored cookies')),





            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__item  runner-runs-selector__item--save-cookies' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__meta runner-runs-selector__meta--save-cookies' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_6__["Checkbox"], {
                  checked: selection.saveCookiesAfterRun,
                  onChange: this.handleChange.bind(this, 'saveCookiesAfterRun') })),


              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  className: 'runner-runs-selector__item__value runner-runs-selector__item__value--save-cookies',
                  onClick: this.handleChange.bind(this, 'saveCookiesAfterRun', !selection.saveCookiesAfterRun) }, 'Save cookies after collection run'),



              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-selector__postfix runner-runs-selector__postfix--save-cookies' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                    className: 'runner-runs-selector__postfix-icon runner-runs-selector__postfix-icon--save-cookies',
                    ref: 'saveCookiesTooltipTarget',
                    onMouseEnter: this.showTooltip.bind(this, 'isSaveCookiesTooltipVisible'),
                    onMouseLeave: this.hideTooltip.bind(this, 'isSaveCookiesTooltipVisible') },

                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_InformationIcon__WEBPACK_IMPORTED_MODULE_11__["default"], {
                    className: 'runner-runs-selector__postfix-icon' })),


                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Tooltips__WEBPACK_IMPORTED_MODULE_4__["Tooltip"], {
                    show: this.state.isSaveCookiesTooltipVisible,
                    target: this.refs.saveCookiesTooltipTarget,
                    placement: 'right',
                    className: 'runner-runs-selector__postfix-tooltip',
                    immediate: true },

                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Tooltips__WEBPACK_IMPORTED_MODULE_4__["TooltipBody"], null, 'Update the cookies stored in this session and save them to your cookie manager.')))),






            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], {
                className: 'runner-runs-selector__start-test',
                disabled: !selection.isRunnable,
                type: 'primary',
                onClick: this.handleStartRun,
                tooltip: this.getTooltipText(!selection.isPermitted) },

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, selection.collectionName ? `Run ${selection.collectionName}` : 'Start Run'))))));





  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6028:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerCollectionExplorer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _Explorer__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6029);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;




const flattenNode = function (flattened, node, depth, map) {
  if (!node) {
    return flattened;
  }

  flattened.push(node);

  _.each(node.folders_order, folderId => {
    let folder = map.folders.get(folderId);
    if (folder) {
      folder.type = 'folder';
      folder.depth = depth + 1;
      flattenNode(flattened, folder, depth + 1, map);
    }
  });

  _.each(node.order, requestId => {
    let request = map.requests.get(requestId);
    if (request) {
      request.type = 'request';
      request.depth = depth + 1;
      flattened.push(request);
    }
  });

  return flattened;
};

const flattenCollection = function (collection, folders, requests) {
  collection.type = 'collection';
  collection.depth = 0;
  return flattenNode([], collection, 0, { folders, requests });
};let


RunnerCollectionExplorer = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class RunnerCollectionExplorer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.handleSelect = this.handleSelect.bind(this);
  }

  UNSAFE_componentWillReceiveProps(nextProps) {
    // If the loading state is transitioning from loading to not-Loading then reset initial target

    // This covers case when user tries to run a folder or collection directly from the requester
    // window rather than from runner. It brings focus to the particular folder in collection
    // explorer.
    if (this.props.loading && !nextProps.loading) {
      this.resetTarget(nextProps.selection);
    }
  }

  componentDidMount() {
    this.resetTarget();
  }

  resetTarget(initialSelection = this.props.selection) {
    let item = { id: null, depth: -1 };

    if (_.get(initialSelection, 'collection')) {
      item = initialSelection.$collection;
      item.depth = 0;
    }

    if (_.get(initialSelection, 'folder')) {
      item = initialSelection.folders.get(initialSelection.folder);
    }

    item && setTimeout(() => {
      this.refs.explorer && this.refs.explorer.handleSelect(item);
    }, 0);
  }

  handleSelect(target) {
    this.props.selection.change('target', target);
  }

  getLeafIcon(node) {
    let method = node.method ? node.method.toUpperCase() : 'GET';
    let classes = `explorer-row__icon-leaf-icon request-method--${method}`;
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: classes },
        node.method));


  }

  render() {
    let collections = _.map(this.props.collections, collection => {
      // Let do a bit of hacky optimization here.
      // If collection is not present in the target selection then, lets just return
      if (collection.id !== this.props.selection.collection) {
        return [_extends({ type: 'collection', depth: 0 }, collection)];
      }

      return flattenCollection(_extends({}, collection), this.props.selection.folders, this.props.selection.requests);
    });

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'collection-explorer' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_Explorer__WEBPACK_IMPORTED_MODULE_3__["default"], {
          disableCreate: true,
          isLeaf: target => {return target.type === 'request';},
          leafIcon: this.getLeafIcon,
          ref: 'explorer',
          targets: _.flatten(collections),
          onBack: this.handleSelect,
          onSelect: this.handleSelect,
          loading: this.props.loading })));



  }}) || _class;


RunnerCollectionExplorer.defaultProps = {
  loadingCollections: false };


RunnerCollectionExplorer.propTypes = {
  disableCreate: prop_types__WEBPACK_IMPORTED_MODULE_2___default.a.bool,
  initialSelection: prop_types__WEBPACK_IMPORTED_MODULE_2___default.a.object,
  onCreate: prop_types__WEBPACK_IMPORTED_MODULE_2___default.a.func,
  onFilter: prop_types__WEBPACK_IMPORTED_MODULE_2___default.a.func,
  onSelect: prop_types__WEBPACK_IMPORTED_MODULE_2___default.a.func,
  loadingCollections: prop_types__WEBPACK_IMPORTED_MODULE_2___default.a.bool };
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6029:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return Explorer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ExplorerRow__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6030);
/* harmony import */ var _ExplorerSearch__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6032);
/* harmony import */ var _ExplorerResults__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6033);
/* harmony import */ var _ExplorerCreateRow__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6035);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2929);
/* harmony import */ var _base_Icons_LeftSolidIcon__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(2971);
/* harmony import */ var _collections_CollectionForkLabel__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(5239);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_8___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_8__);
/* harmony import */ var _base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(2974);
var _class;










let defaultSelection = {
  id: null,
  depth: -1 };let



Explorer = Object(mobx_react__WEBPACK_IMPORTED_MODULE_5__["observer"])(_class = class Explorer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      targets: [],
      selected: defaultSelection,
      filter: '',
      isCreating: false };


    this.setTargets = this.setTargets.bind(this);
    this.setTargetsDebounced = _.debounce(this.setTargets, 300);
    this.isLeaf = this.isLeaf.bind(this);
    this.getNextTargets = this.getNextTargets.bind(this);
    this.setNextTargets = this.setNextTargets.bind(this);
    this.handleSelect = this.handleSelect.bind(this);
    this.handleBack = this.handleBack.bind(this);
    this.handleSearch = this.handleSearch.bind(this);
    this.handleCreate = this.handleCreate.bind(this);
    this.handleStartCreate = this.handleStartCreate.bind(this);
    this.handleCancelCreate = this.handleCancelCreate.bind(this);
  }

  UNSAFE_componentWillMount() {
    this.setTargets();
  }

  UNSAFE_componentWillReceiveProps(nextProps) {
    if (_.isEqual(this.props.targets, nextProps.targets)) {
      return;
    }

    // hackk implementation for new collection/folder added
    if (nextProps.newTargetId && this.props.newTargetId === undefined) {
      let selected = _.find(nextProps.targets, target => {
        return _.isEqual(target.id, nextProps.newTargetId);
      });

      this.props.onSelect && this.props.onSelect(selected);
      this.setState({ selected: selected }, () => {
        this.setNextTargets(nextProps.targets, selected);
      });

      return;
    }

    this.setNextTargets(nextProps.targets, this.state.selected);
  }

  /**
     * find parent of the currently selected parent when going back
     */
  getSelectionParent() {
    let selected = this.state.selected,
    targets = this.props.targets,
    selectedIndex = _.findIndex(targets, ['id', selected.id]);

    if (selectedIndex === -1) {
      return this.state.selected;
    }

    let parentIndex = _.chain(targets).
    slice(0, selectedIndex).
    findLastIndex(['depth', selected.depth - 1]).
    value();

    if (parentIndex === -1) {
      return defaultSelection;
    }

    return this.props.targets[parentIndex];
  }

  setTargets(targets = this.props.targets) {
    this.setNextTargets(targets);
  }

  isLeaf(targets, node) {
    if (this.props.isLeaf) {
      return this.props.isLeaf(node);
    } else
    {
      let nextTargets = this.getNextTargets(targets, node);
      return !_.size(nextTargets);
    }
  }

  /**
     * get the next list of collections/folders as per the selected collection/folder
     * @param {Array} currentTargets - list of flattened collections and folders
     * @param {Object} selectedTarget - selected collection/folder
     */
  getNextTargets(currentTargets, selectedTarget) {
    // find index of the selected target from the array of currentTargets
    let selectedTargetIndex = _.findIndex(currentTargets, ['id', selectedTarget.id]);

    // handle in case there is no selected collection(when we initially open the modal to save request)
    if (selectedTargetIndex === -1) {
      this.setState({ selected: defaultSelection });
      return currentTargets;
    }

    // find index of the next collection/folder at same depth as the selectedTarget
    let endIndex = _.findIndex(currentTargets, n => {return n.depth <= currentTargets[selectedTargetIndex].depth;}, selectedTargetIndex + 1);

    // handle in case there is no next collection/folder having same depth in the currentTargets
    if (endIndex === -1) {
      endIndex = _.size(currentTargets);
    }

    // return the list of selected target tree
    return _.slice(currentTargets, selectedTargetIndex + 1, endIndex);
  }

  /**
     * set the next list of collections/folders as per the selected collection/folder
     * @param {Array} currentTargets - list of flattened collections and folders
     * @param {Object} selectedTarget - selected collection/folder
     */
  setNextTargets(currentTargets, selectedTarget = defaultSelection) {
    let nextTargets = this.getNextTargets(currentTargets, selectedTarget);

    this.setState({ targets: nextTargets });
  }

  /**
     * get the next targets on select of any collection/folder
     * @param {Object} target
     * @param {*} isLeaf
     */

  handleSelect(target, isLeaf = false) {
    if (this.props.disableLeaves && isLeaf) {
      return;
    }
    let nextTargets = this.getNextTargets(this.props.targets, target);

    this.setState({
      selected: target,
      filter: '',
      targets: nextTargets },
    () => {
      this.handleCancelCreate && this.handleCancelCreate();
      this.props.onSelect && this.props.onSelect(target);
    });
  }

  /**
     * go back one level up in the directory tree,fetch the parent of the selected target along with the next targets
     */
  handleBack() {
    let selected = this.getSelectionParent(),
    nextTargets = this.getNextTargets(this.props.targets, selected);

    this.setState({
      selected,
      targets: nextTargets },
    () => {
      this.handleCancelCreate && this.handleCancelCreate();

      _.invoke(this, 'props.onBack', selected);
    });
  }

  /**
     * search results based on the filter value
     * @param  {string} filter - collection/folder searched
     */
  handleSearch(filter) {
    this.setState({ filter }, () => {
      this.props.onFilter && this.props.onFilter(filter);
    });
  }

  /**
     * start creating collection/folder
     */
  handleStartCreate() {
    // create new collection/folder if the searched filter named collection/folder does not exist
    if (!_.isEmpty(this.state.filter)) {
      this.handleCreate(this.state.filter);
      return;
    }
    this.setState({ isCreating: true });
  }

  handleCancelCreate() {
    this.setState({ isCreating: false });
  }

  /**
     * to create new collection/folder
     * @param {string} name - name of collection or folder created
     */
  handleCreate(name) {
    if (!_.isEmpty(name)) {
      this.setState({ isCreating: false, filter: '' }, () => {
        _.invoke(this.props, 'onCreate', name, this.state.selected);
      });
    }
  }

  render() {
    const showLoadingIndicator = this.props.loading,
    showRows = !this.props.loading && _.isEmpty(this.state.filter);

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer__header-wrapper' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ExplorerSearch__WEBPACK_IMPORTED_MODULE_2__["default"], {
            disabled: this.props.loading,
            filter: this.state.filter,
            onSearch: this.handleSearch }),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer__header__create-wrapper' },

            _.isEqual(this.state.selected, defaultSelection) ?
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer__header-title' },
              _.isEmpty(this.state.filter) ? 'All Collections' : 'Search Results') :

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                className: 'explorer-pop-btn',
                onClick: this.handleBack },

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Icons_LeftSolidIcon__WEBPACK_IMPORTED_MODULE_6__["default"], { className: 'explorer-pop-btn__icon' }),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-pop-btn__text' },
                this.state.selected.name),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-pop-btn__meta' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_collections_CollectionForkLabel__WEBPACK_IMPORTED_MODULE_7__["default"], { forkInfo: _.get(this.state.selected, 'forkInfo') }))),




            !this.props.disableCreate &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                className: 'explorer__header-create-btn',
                onClick: this.handleStartCreate },

              this.props.createText && this.props.createText(this.state.selected)))),





        this.state.isCreating &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ExplorerCreateRow__WEBPACK_IMPORTED_MODULE_4__["default"], {
          placeholder: _.invoke(this.props, 'createPlaceholder', this.state.selected),
          onCancel: this.handleCancelCreate,
          onCreate: this.handleCreate }),



        showLoadingIndicator &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_9__["default"], null),


        showRows &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-rows' },

          _.map(this.state.targets, (target, index) => {
            let isLeaf = this.isLeaf(this.state.targets, target);

            return target.depth === this.state.selected.depth + 1 && (
            !this.props.hideLeaves || !isLeaf) &&
            !(this.props.hideNodes && this.props.hideNodes(target)) &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ExplorerRow__WEBPACK_IMPORTED_MODULE_1__["default"], {
              disableLeaves: this.props.disableLeaves,
              filter: this.state.filter,
              isLeaf: isLeaf,
              key: index,
              leafIcon: this.props.leafIcon,
              target: target,
              onSelect: this.handleSelect });


          })),




        !_.isEmpty(this.state.filter) &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ExplorerResults__WEBPACK_IMPORTED_MODULE_3__["default"], {
          filter: this.state.filter,
          allTargets: this.props.targets,
          isLeaf: this.props.isLeaf,
          onSelect: this.handleSelect })));




  }}) || _class;


Explorer.propTypes = {
  createPlaceholder: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func,
  createText: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func, // The callback function that will be called to render the first row in every view
  disableCreate: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.bool,
  disableLeaves: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.bool, // Indicates if leaves will be shown
  hideLeaves: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.bool,
  hideNodes: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func, // The callback function that will be called so you can hide specific nodes if needed
  isLeaf: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func, // The callback function that will be called to check if a node is a leaf
  leafIcon: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func, // The callback called to render the leaf icon
  onBack: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func,
  onCreate: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func,
  onFilter: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func,
  onSelect: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.func,
  targets: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.array,
  loading: prop_types__WEBPACK_IMPORTED_MODULE_8___default.a.bool };


Explorer.defaultProps = {
  disableLeaves: false,
  loading: false };
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6030:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ExplorerRow; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _base_Icons_CollectionIcon__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2812);
/* harmony import */ var _base_Icons_RightSolidIcon__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2970);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _collections_CollectionMetaIcons__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6031);
/* harmony import */ var _collections_CollectionForkLabel__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(5239);






let

ExplorerRow = class ExplorerRow extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.getClasses = this.getClasses.bind(this);
    this.handleSelect = this.handleSelect.bind(this);
  }

  getClasses(target) {
    return classnames__WEBPACK_IMPORTED_MODULE_1___default()({
      'explorer-row': true,
      'is-selected': target.id === _.get(this, 'props.selected.id'),
      'is-disabled': this.props.leafIcon && this.props.isLeaf },
    this.props.className);
  }

  /**
     * select a collection/folder
     * @param {Object} target
     */
  handleSelect(target, e) {
    e && e.stopPropagation();
    e && e.preventDefault();

    !this.props.isLeaf && _.invoke(this, 'props.onSelect', target, this.props.isLeaf);
  }

  render() {
    let { target } = this.props;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
          className: this.getClasses(target),
          onClick: this.handleSelect.bind(this, target) },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__icon' },

          this.props.isLeaf && _.isFunction(this.props.leafIcon) ?
          this.props.leafIcon(target) :
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Icons_CollectionIcon__WEBPACK_IMPORTED_MODULE_2__["default"], { className: 'explorer-row__icon-icon' })),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__name' },
          target.name),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__icons' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_collections_CollectionMetaIcons__WEBPACK_IMPORTED_MODULE_5__["default"], { collection: target })),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__meta' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_collections_CollectionForkLabel__WEBPACK_IMPORTED_MODULE_6__["default"], { forkInfo: _.get(target, 'forkInfo') })),


        !this.props.isLeaf &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Icons_RightSolidIcon__WEBPACK_IMPORTED_MODULE_3__["default"], { className: 'explorer-row__forward' })));



  }};


ExplorerRow.propTypes = {
  depth: prop_types__WEBPACK_IMPORTED_MODULE_4___default.a.number,
  filter: prop_types__WEBPACK_IMPORTED_MODULE_4___default.a.string,
  isLeaf: prop_types__WEBPACK_IMPORTED_MODULE_4___default.a.bool,
  onSelect: prop_types__WEBPACK_IMPORTED_MODULE_4___default.a.func,
  selected: prop_types__WEBPACK_IMPORTED_MODULE_4___default.a.object,
  target: prop_types__WEBPACK_IMPORTED_MODULE_4___default.a.object };
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6031:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _stores_CollectionStore__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(780);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(749);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2929);
/* harmony import */ var _postman_design_system__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(3051);
/* harmony import */ var _postman_design_system__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(_postman_design_system__WEBPACK_IMPORTED_MODULE_5__);
var _class;





let

CollectionMetaIcons = Object(mobx_react__WEBPACK_IMPORTED_MODULE_4__["observer"])(_class = class CollectionMetaIcons extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    const isCollectionEditable = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_3__["getStore"])('PermissionStore').can('edit', 'collection', this.props.collection.id);

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'collection-meta-icons' },
        this.props.collection.isShared && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_postman_design_system__WEBPACK_IMPORTED_MODULE_5__["Icon"], { name: 'icon-descriptive-team-stroke', className: 'collection-meta-icon pm-icon pm-icon-normal', size: 'small', title: 'Shared with team' }),
        !isCollectionEditable && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_postman_design_system__WEBPACK_IMPORTED_MODULE_5__["Icon"], { name: 'icon-state-locked-stroke', className: 'collection-meta-icon pm-icon pm-icon-normal', size: 'small', title: 'Read only' })));


  }}) || _class;


CollectionMetaIcons.propTypes = {
  collection: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.oneOfType([
  prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.instanceOf(_stores_CollectionStore__WEBPACK_IMPORTED_MODULE_2__["CollectionItemStore"]),
  prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.object]) };



/* harmony default export */ __webpack_exports__["default"] = (CollectionMetaIcons);

/***/ }),

/***/ 6032:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ExplorerSearch; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _base_Inputs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(3048);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_2__);


let

ExplorerSearch = class ExplorerSearch extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-search' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Inputs__WEBPACK_IMPORTED_MODULE_1__["Input"], {
          disabled: this.props.disabled,
          inputStyle: 'search',
          placeholder: 'Search for a collection or folder',
          query: this.props.filter,
          onChange: this.props.onSearch })));



  }};


ExplorerSearch.defaultProps = {
  disabled: false };


ExplorerSearch.propTypes = {
  filter: prop_types__WEBPACK_IMPORTED_MODULE_2___default.a.string.isRequired,
  onSearch: prop_types__WEBPACK_IMPORTED_MODULE_2___default.a.func.isRequired,
  disabled: prop_types__WEBPACK_IMPORTED_MODULE_2___default.a.bool };

/***/ }),

/***/ 6033:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ExplorerResults; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _base_SearchHighlighter__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3671);
/* harmony import */ var _utils_CollectionTreeUtil__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6034);




let

ExplorerResults = class ExplorerResults extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = { filteredItems: this.filterTargets(props.allTargets, props.filter) };

    this.filterTargets = this.filterTargets.bind(this);
    this.getPath = this.getPath.bind(this);
    this.handleSelect = this.handleSelect.bind(this);
    this.setFilteredItems = this.setFilteredItems.bind(this);
    this.setFilteredItemsDebounced = _.debounce(this.setFilteredItems, 300, {
      leading: false,
      trailing: true });

  }

  UNSAFE_componentWillReceiveProps(nextProps) {
    this.setFilteredItemsDebounced(nextProps);
  }

  getHighlightClasses(text) {
    return classnames__WEBPACK_IMPORTED_MODULE_2___default()({ 'highlight': text.isHighlight });
  }

  filterTargets(targets = this.props.allTargets, filter = this.props.filter) {
    return _.filter(targets, target => {
      if (_.isFunction(this.props.isLeaf)) {
        return !this.props.isLeaf(target) && _.includes(_.toLower(target.name), _.toLower(filter));
      }
      return _.includes(_.toLower(target.name), _.toLower(filter));
    });
  }

  setFilteredItems(nextProps) {
    this.setState({ filteredItems: this.filterTargets(nextProps.allTargets, nextProps.filter) });
  }

  getPath(target, itemToFind) {
    return Object(_utils_CollectionTreeUtil__WEBPACK_IMPORTED_MODULE_4__["getNodePath"])(target, itemToFind);
  }

  handleSelect(item) {
    _.invoke(this, 'props.onSelect', item);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-results' },

        _.map(this.state.filteredItems, (target, index) => {
          return (
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                className: 'explorer-row explorer-result',
                key: index,
                onClick: this.handleSelect.bind(this, target) },

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__icon' }),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__content' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__name' },
                  target.name),

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-result__path' },
                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_SearchHighlighter__WEBPACK_IMPORTED_MODULE_3__["default"], {
                    source: this.getPath(this.props.allTargets, target),
                    query: this.props.filter })))));





        })));



  }};



ExplorerResults.propTypes = {
  filter: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.string,
  onSelect: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.func,
  targets: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.array };
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6034:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "flattenCollection", function() { return flattenCollection; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "flattenCollections", function() { return flattenCollections; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "computeVisibility", function() { return computeVisibility; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getParents", function() { return getParents; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getNodePath", function() { return getNodePath; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getAllToggleableNodes", function() { return getAllToggleableNodes; });
/**
 * Denormalize folder children
 * @param  {string} folderId          folder id
 * @param  {Array} options.requests   all requests in collection
 * @param  {Array} options.folders    all folders in collection
 * @return {Object}                   denormalized folder object
 */

/**
     * Denormalize request children
     * @param  {string} requestId         request id
     * @param  {Array} options.requests   all requests in collection
     * @return {Object}                   denormalized folder object
     */

/**
         * Denormalize node children
         * @param  {string} folderId          folder id
         * @param  {Array} options.requests   all requests in collection
         * @param  {Array} options.folders    all folders in collection
         * @return {Object}                   denormalized folder object
         */

/**
             * Denormalize collection children
             * @param  {object} collection collection in v1 format
             * @return {object}            denormalized collection
             */

/** =========================================================================**/
/*
                                                                                   FLATTENING UTILS
                                                                                  */

/**
                                                                                      * Deep flatten a node in denormalized collection
                                                                                      * @param  {Object} node node in denormalized collection tree
                                                                                      * @param  {number} depth depth of node (default: 0)
                                                                                      * @return {Array}       deep flattened node
                                                                                      */
// function flattenNode (node, depth) {
function flattenNode(flattened, node, depth, map) {
  // let flattenedNode = _.omit(node, ['children']),
  //     nodeDepth = depth || 0,
  //     flattenedChildren = _.flatMap(node.children, (childNode) => {
  //       return flattenNode(childNode, nodeDepth + 1);
  //     });

  // flattenedNode.endOffset = _.size(flattenedChildren);
  // flattenedNode.depth = nodeDepth;

  // // TODO: add parent and child offsets

  // return _.concat(flattenedNode, flattenedChildren);

  // console.log('flattening', node)

  if (!node) {
    return flattened;
  }

  // node.endOffset = _.size(node.folders_order) + _.size(node.order)
  flattened.push(node);

  _.each(node.folders_order, folderId => {
    let folder = _.find(map.folders, ['id', folderId]);
    if (folder) {
      folder.type = 'folder';
      folder.depth = depth + 1;
      flattenNode(flattened, folder, depth + 1, map);
    }
  });

  _.each(node.order, requestId => {
    let request = _.find(map.requests, ['id', requestId]);
    if (request) {
      request.type = 'request';
      request.depth = depth + 1;
      flattened.push(request);
    }
  });

  return flattened;
}

/**
   * marks all children as (in)visible
   * @param  {Array}  visibilityMap visibilityMap
   * @param  {Array}  flatTree      flattened tree
   * @param  {Array}  openNodes     ids of open items
   * @param  {number}  nodeIdx      index of node in flattened tree
   * @param  {Boolean} isVisible    boolean for flagging (in)visible
   * @param  {Boolean} deep         deep
   * @return {undefined}            no return value. visibilityMap is mutated
   */
function _markChildrenVisibility(visibilityMap, flatTree, openNodes, nodeIdx, isVisible, deep) {
  let node = flatTree[nodeIdx],
  idx = nodeIdx + 1,
  endIdx = _.findIndex(flatTree, n => {return n.depth <= node.depth;}, idx + 1); // nodeIdx + node.endOffset + 1;

  if (endIdx === -1) {
    endIdx = _.size(flatTree);
  }

  // if deep, mark the whole subtree
  if (deep) {
    while (idx < endIdx) {
      let itemNode = flatTree[idx];

      visibilityMap[idx] = isVisible;

      // fast forward to next subtree
      if (_isNodeToggleable(itemNode) && !_isNodeOpen(itemNode, openNodes)) {
        let endOffset = _.findIndex(flatTree, n => {return n.depth <= itemNode.depth;}, idx + 1);
        if (endOffset === -1) {
          endOffset = _.size(flatTree) - idx;
        }
        idx += endOffset; // itemNode.endOffset;
      }

      ++idx;
    }

    return;
  }

  let nodeDepth = node.depth,
  immediateChildDepth = nodeDepth + 1;

  // loop from immediate child to start of next subtree
  while (idx < endIdx) {
    let itemNode = flatTree[idx],
    itemNodeDepth = itemNode.depth;

    if (itemNodeDepth <= nodeDepth) {
      break;
    }

    if (itemNodeDepth === immediateChildDepth) {
      visibilityMap[idx] = isVisible;
    }

    ++idx;
  }

  return;
}

/**
  * marks all parents as (in)visible
  * @param  {Array}  visibilityMap visibilityMap
  * @param  {Array}  flatTree      flattened tree
  * @param  {number}  nodeIdx      index of node in flattened tree
  * @param  {Boolean} isVisible    boolean for flagging (in)visible
  * @return {undefined}            no return value. visibilityMap is mutated
   */
function _markParentVisibility(visibilityMap, flatTree, nodeIdx, isVisible) {
  let node = flatTree[nodeIdx],
  nodeDepth = node.depth,
  idx = nodeIdx - 1,
  parentDepth = nodeDepth - 1;

  while (idx > -1) {
    let tmpNode = flatTree[idx],
    tmpNodeDepth = tmpNode.depth;
    if (tmpNodeDepth <= parentDepth) {
      visibilityMap[idx] = isVisible;
      --parentDepth;
    }
    --idx;
  }
}

/**
   * get parent items
   * @param  {Array} flatTree flattened tree
   * @param  {Object} nodeIdx index in flattened tree
   * @return {Array}          array of parent nodes
   */
function getParents(flatTree, nodeIdx) {
  let node = flatTree[nodeIdx],
  nodeDepth = node.depth,
  parents = [],
  idx = nodeIdx - 1,
  parentDepth = nodeDepth - 1;

  while (idx > -1) {
    let tmpNode = flatTree[idx],
    tmpNodeDepth = tmpNode.depth;
    if (tmpNodeDepth <= parentDepth) {
      parents.push(flatTree[idx]);
      --parentDepth;
    }
    --idx;
  }

  return parents;
}

/**
   * Get path for the item
   * @param  {Array} flatTree flattened tree
   * @param  {Object} node    node
   * @return {string}         path
   */
function getNodePath(flatTree, node) {

  let nodeIdx = _.findIndex(flatTree, ['id', node.id]);

  if (nodeIdx === -1) {
    return '';
  }

  let parents = getParents(flatTree, nodeIdx),
  pathItems = _.concat([node], parents);


  return _.chain(pathItems).
  reverse().
  map('name').
  join(' / ').
  value();
}

/**
   * check if the node is open
   * @param  {Object}  node      node in flattened tree
   * @param  {Array}  openNodes  ids of open nodes
   * @return {Boolean}           whether node is open
   */
function _isNodeOpen(node, openNodes) {
  return openNodes.get(node.id);

  // return _.includes(openNodes, node.id);
}

/**
   * check if node is toggled
   * @param  {Object}  node node in flattened tree
   * @return {Boolean}      whether node is toggleable
   */
function _isNodeToggleable(node) {
  return _.includes(['collection', 'folder'], node.type);
}

/**
   * returns id of all toggleable nodes
   * @param  {Array} flatTree flattened tree
   * @return {Array}          ids of toggleable nodes
   */
function getAllToggleableNodes(flatTree) {
  return _.chain(flatTree).
  filter(_isNodeToggleable).
  map('id').
  value();
}

/**
   * computes visibility map
   * @param  {Array} flatCollection flattened collection
   * @param  {Array} openNodes      array of open node ids
   * @param  {string} filterQuery    search filter
   * @return {Array}                visibility map
   */
function computeVisibility(flatCollection, openNodes, filterQuery) {
  let visibilityMap = new Array(_.size(flatCollection));
  _.fill(visibilityMap, false);
  visibilityMap[0] = true;

  _.each(flatCollection, (node, index) => {
    if (_isNodeToggleable(node) && _isNodeOpen(node, openNodes)) {
      // find the next sibling
      let endIndex = _.findIndex(flatCollection, n => n.depth <= node.depth, index + 1);
      if (endIndex === -1) {
        endIndex = _.size(flatCollection);
      }

      visibilityMap[index] = true;
      _.each(new Array(endIndex - index), (n, i) => {
        if (flatCollection[index + i].depth === node.depth + 1) {
          visibilityMap[index + i] = true;
        }
      });
    }
  });

  return visibilityMap;
}

/**
   * computes visibility map
   * @param  {Array} flatCollection flattened collection
   * @param  {Array} openNodes      array of open node ids
   * @param  {string} filterQuery    search filter
   * @return {Array}                visibility map
   */
function _computeVisibilityQuery(flatCollection, openNodes, filterQuery) {
  let lowerFilterQuery = _.toLower(filterQuery),
  matchingNodes = new Array(_.size(flatCollection)),
  visibilityMap = new Array(_.size(flatCollection));

  _.fill(matchingNodes, false);
  _.fill(visibilityMap, false);

  _.forEach(flatCollection, (flatNode, itemIdx) => {
    let lowerItemName = _.toLower(flatNode.name);

    // if not matching, flag as not visible
    if (!_.includes(lowerItemName, lowerFilterQuery)) {
      return;
    }

    matchingNodes[itemIdx] = true;
  });

  let matchIdx = 0,
  endMatchIdx = matchingNodes.length;

  while (matchIdx < endMatchIdx) {
    if (!matchingNodes[matchIdx]) {
      ++matchIdx;
      continue; // eslint-disable-line no-continue
    }

    let matchNode = flatCollection[matchIdx];

    // mark node as visible
    visibilityMap[matchIdx] = true;

    // if toggleable node, deep mark subtree and fast forward
    if (_isNodeToggleable(matchNode) && _isNodeOpen(matchNode, openNodes)) {
      _markChildrenVisibility(visibilityMap, flatCollection, openNodes, matchIdx, true, true);
      matchIdx += matchNode.endOffset;
    }

    // mark parent chain
    _markParentVisibility(visibilityMap, flatCollection, matchIdx, true);

    ++matchIdx;
  }

  let idx = 0,
  length = flatCollection.length;

  while (idx < length) {
    let node = flatCollection[idx];

    if (_isNodeToggleable(node)) {
      // if toggleable node, and is not open, deep mark subtree and fast forward
      if (visibilityMap[idx] && !_isNodeOpen(node, openNodes)) {
        _markChildrenVisibility(visibilityMap, flatCollection, openNodes, idx, false, true);
        let endIdx = _.findIndex(flatCollection, n => {return n.depth <= node.depth;}, idx + 1);
        if (endIdx === -1) {
          endIdx = _.size(flatCollection) - idx;
        }
        idx += endIdx;
      }
    }

    ++idx;
  }

  return visibilityMap;
}

/**
   * Deep flattens a collection
   * @param  {Object} collection collection in v1 format
   * @return {Array}             flattened collection
   */
function flattenCollection(collection, folders = [], requests = []) {
  // let denormalized = denormalizeCollection(collection);
  // return flattenNode(denormalized);
  collection.type = 'collection';
  collection.depth = 0;
  return flattenNode([], collection, 0, { folders, requests });
}

/**
   * Flattens list of collections
   * @param  {Array} collections              Array of v1 collections
   * @param  {Array} options.openCollections  Array of ids of open collections
   * @param  {Array} options.openFolders      Array of ids of open folders
   * @return {Array}                          Flattened collections
   */
function flattenCollections(collections) {
  return _.chain(collections).
  sortBy(collection => {
    return collection.get('name');
  }).
  map(collection => {
    return flattenCollection(collection.toJSON());
  }).
  value();
}


/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6035:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ExplorerCreateRow; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _base_Inputs__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3048);
/* harmony import */ var _base_Icons_SuccessIcon__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3220);



let

ExplorerCreateRow = class ExplorerCreateRow extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = { name: '' };

    this.handleCreate = this.handleCreate.bind(this);
    this.handleCancel = this.handleCancel.bind(this);
    this.handleChange = this.handleChange.bind(this);
  }

  componentDidMount() {
    this.refs.input && this.refs.input.focus();
  }

  handleCreate(e) {
    e && e.preventDefault();
    e && e.stopPropagation();
    this.props.onCreate(this.state.name);
  }

  handleCancel(e) {
    this.setState({ name: '' });
    this.props.onCancel && this.props.onCancel();
  }

  handleChange(value) {
    this.setState({ name: value });
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
          className: 'explorer-create-row' },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__icon' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'explorer-row__icon-icon' })),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Inputs__WEBPACK_IMPORTED_MODULE_2__["Input"], {
          className: 'explorer-row__create',
          inputStyle: 'search',
          hideSearchGlass: true,
          placeholder: this.props.placeholder,
          ref: 'input',
          query: this.state.name,
          onCancel: this.handleCancel,
          onChange: this.handleChange,
          onSubmit: this.handleCreate,
          onEnter: this.handleCreate }),

        !_.isEmpty(_.isString(this.state.name) && this.state.name.trim()) &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: 'explorer-row__save',
            onClick: this.handleCreate },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Icons_SuccessIcon__WEBPACK_IMPORTED_MODULE_3__["default"], {
            className: 'explorer-row__save-icon',
            style: 'primary' }))));





  }};


ExplorerCreateRow.propTypes = {
  onCancel: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.func,
  onCreate: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.func.isRequired,
  placeholder: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.string.isRequired };
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6036:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return EnvironmentMetaIcons; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2929);
/* harmony import */ var _js_components_base_Icons_LockedIcon__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6003);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(749);
var _class;



let


EnvironmentMetaIcons = Object(mobx_react__WEBPACK_IMPORTED_MODULE_2__["observer"])(_class = class EnvironmentMetaIcons extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  render() {
    const canEditEnvironment = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_4__["getStore"])('PermissionStore').can('edit', 'environment', this.props.environmentId);

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'environment-meta-icons' },
        !canEditEnvironment && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_LockedIcon__WEBPACK_IMPORTED_MODULE_3__["default"], { className: 'environment-meta-icon', size: this.props.iconSize, title: 'Read only' })));


  }}) || _class;


EnvironmentMetaIcons.propTypes = {
  environmentId: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.string.isRequired,
  iconSize: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.string };


EnvironmentMetaIcons.defaultProps = {
  iconSize: 'xs' };

/***/ }),

/***/ 6037:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerPreviewDataModalContainer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var pure_render_decorator__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2965);
/* harmony import */ var pure_render_decorator__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(pure_render_decorator__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _js_components_base_Modals__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3250);
var _class;

let


RunnerPreviewDataModalContainer = pure_render_decorator__WEBPACK_IMPORTED_MODULE_1___default()(_class = class RunnerPreviewDataModalContainer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.handleClose = this.handleClose.bind(this);
  }

  getCustomStyles() {
    return {
      marginTop: '10vh',
      height: '80vh',
      width: '700px' };

  }

  handleClose() {
    this.props.handleClose && this.props.handleClose();
  }

  computeKeysArray() {
    const { dataArray } = this.props,
    keys = ['Iteration'];

    if (_.isEmpty(dataArray)) {
      return keys;
    }

    Object.keys(dataArray[0]).forEach(key => {
      keys.push(key);
    });

    return keys;
  }

  stringifyParsedValue(value) {
    return JSON.stringify(value);
  }

  render() {
    const keys = this.computeKeysArray(),
    { dataArray } = this.props;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Modals__WEBPACK_IMPORTED_MODULE_2__["Modal"], {
          isOpen: this.props.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getCustomStyles(),
          className: 'runner-data-preview-modal' },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Modals__WEBPACK_IMPORTED_MODULE_2__["ModalHeader"], null, 'PREVIEW DATA'),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Modals__WEBPACK_IMPORTED_MODULE_2__["ModalContent"], null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'preview-data-modal-content-wrapper' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'preview-data-header-wrapper' },

              _.map(keys, (key, index) =>
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  className: 'preview-data-header',
                  key: String(key) + index },

                key))),





            dataArray && dataArray.length > 0 &&
            _.map(dataArray, (data, dataIndex) =>
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                className: 'preview-data-header-wrapper',
                key: `header${dataIndex}` },


              _.map(keys, (key, index) =>
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                  className: 'preview-data-value',
                  key: String(key) + index + dataIndex },


                index === 0 ?
                dataIndex + 1 :
                this.stringifyParsedValue(data[key])))))))));











  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6038:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerRecentRuns; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _postman_react_click_outside__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2936);
/* harmony import */ var _postman_react_click_outside__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_postman_react_click_outside__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _RunnerRecentRunsHeader__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6039);
/* harmony import */ var _RunnerRecentRunsList__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6041);
/* harmony import */ var _RunnerRunDeleteConfirmationModal__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6043);
/* harmony import */ var _js_components_base_keymaps_KeyMaps__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(2960);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(749);
/* harmony import */ var _helpers_RunnerHelper__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(5395);
/* harmony import */ var _onboarding_src_features_Recommendations_components_RecommendationViewer__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(3272);
var _class;








let



RunnerRecentRuns = _postman_react_click_outside__WEBPACK_IMPORTED_MODULE_2___default()(_class = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class RunnerRecentRuns extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      runFilter: '',
      isDeleteModalOpen: false,
      isFiltering: false,
      singleSelectionId: '' };


    this.handleDeleteModalOpen = this.handleDeleteModalOpen.bind(this);
    this.handleDeleteModalClose = this.handleDeleteModalClose.bind(this);
    this.handleDeleteMultipleRuns = this.handleDeleteMultipleRuns.bind(this);
    this.handleExport = this.handleExport.bind(this);
    this.handleImport = this.handleImport.bind(this);
    this.handleFilter = this.handleFilter.bind(this);

    this.deselectAllRuns = this.deselectAllRuns.bind(this);
    this.handleSelect = this.handleSelect.bind(this);
    this.handleDeselect = this.handleDeselect.bind(this);
    this.handleBulkExport = this.handleBulkExport.bind(this);
    this.handleFilteringFocus = this.handleFilteringFocus.bind(this);
    this.handleFilteringBlur = this.handleFilteringBlur.bind(this);
    this.handleSingleDeleteSelected = this.handleSingleDeleteSelected.bind(this);
    this.handleSingleDelete = this.handleSingleDelete.bind(this);
    this.handleDeleteRuns = this.handleDeleteRuns.bind(this);

    this.store = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_7__["getStore"])('RunnerRunStore');
  }

  getKeyMapHandlers() {
    return {
      quit: pm.shortcuts.handle('quit', this.deselectAllRuns),
      delete: pm.shortcuts.handle('delete', () => {
        if (!this.store.isMultiSelection || this.state.isFiltering) {
          return;
        }

        this.handleDeleteModalOpen();
      }) };

  }

  handleDeleteRuns() {
    if (this.state.singleSelectionId) {
      this.handleSingleDelete();
    } else {
      this.handleDeleteMultipleRuns();
    }
  }

  handleSingleDeleteSelected(id) {
    this.setState({ singleSelectionId: id });
    this.handleDeleteModalOpen();
  }

  handleSingleDelete() {
    this.store.deleteRun(this.state.singleSelectionId);
    this.setState({ singleSelectionId: '' });
    this.handleDeleteModalClose();
  }

  handleFilteringFocus() {
    this.setState({ isFiltering: true });
  }

  handleFilteringBlur() {
    this.setState({ isFiltering: false });
  }

  handleClickOutside() {
    if (!this.store.selectedRuns.size || this.state.isDeleteModalOpen) {
      return;
    }

    this.deselectAllRuns();
  }

  handleDeleteModalOpen() {
    this.setState({
      isDeleteModalOpen: true },
    () => {
      pm.mediator.trigger('showRunnerRunDeleteModal'); // Listening in Delete Modal to focus the element, which enable keyboard shortcuts
    });
  }

  handleDeleteModalClose() {
    this.setState({ isDeleteModalOpen: false, singleSelectionId: '' });
  }

  handleDeleteMultipleRuns() {
    let runsToDelete = [];

    if (this.store.isMultiSelection) {// If 2 or more runs are selected, delete selected runs
      runsToDelete = [...this.store.selectedRuns.keys()];
    } else {// Else delete all runs in the current workspace.
      runsToDelete = _.reduce(this.store.values, (runIds, run) => {
        runIds.push(run.id);

        return runIds;
      }, []);
    }

    this.store.deleteRun(runsToDelete);
    this.handleDeleteModalClose();
    this.deselectAllRuns();
  }

  handleSelect(runId) {
    this.store.addSelection(runId);
  }

  handleDeselect(runId) {
    this.store.deleteSelection(runId);
  }

  deselectAllRuns() {
    this.store.clearSelection();
  }

  handleBulkExport() {
    _.isFunction(_helpers_RunnerHelper__WEBPACK_IMPORTED_MODULE_8__["exportRuns"]) && Object(_helpers_RunnerHelper__WEBPACK_IMPORTED_MODULE_8__["exportRuns"])([...this.store.selectedRuns.keys()]);
    this.deselectAllRuns();
  }

  handleExport(id) {
    _.isFunction(_helpers_RunnerHelper__WEBPACK_IMPORTED_MODULE_8__["exportRun"]) && Object(_helpers_RunnerHelper__WEBPACK_IMPORTED_MODULE_8__["exportRun"])(id);
  }

  handleImport(runs) {
    _.isFunction(_helpers_RunnerHelper__WEBPACK_IMPORTED_MODULE_8__["importRun"]) && Object(_helpers_RunnerHelper__WEBPACK_IMPORTED_MODULE_8__["importRun"])(runs);
  }

  handleFilter(change) {
    this.setState({ runFilter: change });
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_keymaps_KeyMaps__WEBPACK_IMPORTED_MODULE_6__["default"], {
          keyMap: pm.shortcuts.getShortcuts(),
          handlers: this.getKeyMapHandlers() },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerRecentRunsHeader__WEBPACK_IMPORTED_MODULE_3__["default"], {
            runFilter: this.state.runFilter,
            onFilterChange: this.handleFilter,
            onImportRun: this.handleImport,
            isMultiSelected: this.store.isMultiSelection,
            selectedRunCount: _.get(this, 'store.selectedRuns.size', 0),
            openDeleteModal: this.handleDeleteModalOpen,
            onBulkExport: this.handleBulkExport,
            runs: this.store.values,
            onFocus: this.handleFilteringFocus,
            onBlur: this.handleFilteringBlur,
            loadingRuns: this.store.isHydrating }),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_onboarding_src_features_Recommendations_components_RecommendationViewer__WEBPACK_IMPORTED_MODULE_9__["default"], {
            target: 'tabs/runner/collection',
            className: 'runner-recent__onboarding-recommendation-viewer' }),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerRecentRunsList__WEBPACK_IMPORTED_MODULE_4__["default"], {
            runFilter: this.state.runFilter,
            runs: this.store.values,
            onDeleteRun: this.handleSingleDeleteSelected,
            onExportRun: this.handleExport,
            onOpenRun: this.props.onOpenRun,
            selectedRuns: this.store.selectedRuns,
            isMultiSelected: this.store.isMultiSelection,
            selectRun: this.handleSelect,
            deselectRun: this.handleDeselect,
            loadingRuns: this.store.isHydrating }),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerRunDeleteConfirmationModal__WEBPACK_IMPORTED_MODULE_5__["default"], {
            isOpen: this.state.isDeleteModalOpen,
            keymapRef: ref => {this.keymapRef = ref;},
            onConfirm: this.handleDeleteRuns,
            onRequestClose: this.handleDeleteModalClose,
            isMultiSelected: this.store.isMultiSelection,
            isSingleRun: !!this.state.singleSelectionId }))));




  }}) || _class) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6039:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerRecentRunsHeader; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(3048);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Icons_DeleteIcon__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3222);
/* harmony import */ var _js_components_base_Icons_DownloadIcon__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6040);




let

RunnerRecentRunsHeader = class RunnerRecentRunsHeader extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.handleImport = this.handleImport.bind(this);
    this.getRunnerHeader = this.getRunnerHeader.bind(this);
    this.getMultiSelectedRunnerHeader = this.getMultiSelectedRunnerHeader.bind(this);
  }

  getDisabledTooltip() {
    if (_.isEmpty(this.props.runs)) {
      return 'There are no collection runs to delete in this workspace.';
    }
  }

  getRunnerHeader() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__header' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__header__section-left' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__header__tabs' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__header__tab' }, 'Recent Runs'))),





        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__header__section-right' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_1__["Input"], {
            className: 'runner-recent-runs__header__search',
            inputStyle: 'search',
            placeholder: 'Type to Filter',
            disabled: this.props.loadingRuns,
            query: this.props.runFilter,
            onCancel: this.props.onFilterChange,
            onChange: this.props.onFilterChange,
            onFocus: this.props.onFocus,
            onBlur: this.props.onBlur }),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_2__["Button"], {
              className: 'runner-recent-runs__header__import',
              size: 'small',
              type: 'text',
              disabled: this.props.loadingRuns }, 'Import Runs'),



          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_1__["Input"], {
            className: 'runner-recent-runs__header__import-selector',
            ref: 'input',
            type: 'file',
            onChange: this.handleImport }),


          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'separator' }),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_2__["Button"], {
              className: 'runner-recent-runs__header__delete-all',
              size: 'small',
              type: 'text',
              onClick: this.props.openDeleteModal,
              disabled: _.isEmpty(this.props.runs),
              tooltip: this.getDisabledTooltip() }, 'Delete all'))));






  }

  getMultiSelectedRunnerHeader() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__header' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__header__section-left' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__header__tabs' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__header__tab' },
              this.props.selectedRunCount,
              ' ', 'runs selected'))),





        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__header__section-right' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_1__["Input"], {
            className: 'runner-recent-runs__header__search',
            inputStyle: 'search',
            placeholder: 'Type to Filter',
            query: this.props.runFilter,
            onCancel: this.props.onFilterChange,
            onChange: this.props.onFilterChange,
            onFocus: this.props.onFocus,
            onBlur: this.props.onBlur }),


          window.SDK_PLATFORM !== 'browser' &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_2__["Button"], {
              className: 'runner-recent-runs__header__bulk-action',
              onClick: this.props.onBulkExport,
              tooltip: 'Export selected runs',
              type: 'icon' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_DownloadIcon__WEBPACK_IMPORTED_MODULE_4__["default"], {
              className: 'runner-recent-runs__runs-list-item__action--export-icon',
              size: 'xs' })),




          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_2__["Button"], {
              className: 'runner-recent-runs__header__bulk-action',
              onClick: this.props.openDeleteModal,
              tooltip: 'Delete selected runs',
              type: 'icon' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_DeleteIcon__WEBPACK_IMPORTED_MODULE_3__["default"], {
              className: 'runner-recent-runs__runs-list-item__action--delete-icon',
              size: 'xs' })))));





  }

  handleImport(files) {
    this.props.onImportRun && this.props.onImportRun(files);
    this.refs.input && this.refs.input.clear();
  }

  render() {
    return (
      this.props.isMultiSelected ? this.getMultiSelectedRunnerHeader() : this.getRunnerHeader());

  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6040:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return DownloadIcon; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2813);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('svg', { width: '13', height: '16', viewBox: '0 0 16 16' },
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('defs', null,
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { id: 'download', d: 'M11 5V0H6v5H2l6.5 6.735L15 5h-4zm-9 9v2h13v-2H2z' })),

  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('use', { fill: '#282828', fillRule: 'evenodd', xlinkHref: '#download' }));



function DownloadIcon(props) {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_Icon__WEBPACK_IMPORTED_MODULE_1__["default"], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 6041:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerRecentRunsList; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _RunnerRecentRunsListItem__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6042);
/* harmony import */ var _js_components_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2974);
/* harmony import */ var _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5353);
/* harmony import */ var _services_RunnerExecutionService__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(5394);
var _class;




let


RunnerRecentRunsList = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class RunnerRecentRunsList extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  getOrderedRuns(runs) {
    return _.orderBy(_.filter(runs, run => run.status === _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_4__["RUN_STATUS"].FINISHED || _services_RunnerExecutionService__WEBPACK_IMPORTED_MODULE_5__["default"].isActive(run.id), run => run.createdAt, 'desc'));
  }

  getFilteredRuns(runs, filter) {
    return _.filter(runs, run => {
      try {
        return _.includes(run.name.toLowerCase(), filter.toLowerCase());
      } catch (e) {
        return false;
      }
    });
  }

  render() {
    const { runs } = this.props,
    orderedRuns = this.getOrderedRuns(runs),
    filteredRuns = this.getFilteredRuns(orderedRuns, this.props.runFilter),
    showLoadingIndicator = this.props.loadingRuns,
    noRunsCreated = !this.props.loadingRuns && _.isEmpty(orderedRuns),
    showRunsList = !this.props.loadingRuns && !_.isEmpty(orderedRuns),
    noSearchResults = showRunsList && _.isEmpty(filteredRuns);

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__runs-list' },

        showLoadingIndicator &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_3__["default"], null),


        noRunsCreated &&

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__runs-empty-list-item' }, 'You don\u2019t have any runs yet. Select a collection or folder to start a run.'),





        showRunsList &&
        _.map(filteredRuns, run => {
          const environment = _.get(run, 'meta.environmentName') || 'No Environment',
          selected = this.props.selectedRuns.has(run.id);

          return (
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerRecentRunsListItem__WEBPACK_IMPORTED_MODULE_2__["default"], {
              key: run.id,
              run: run,
              environment: environment,
              onDeleteRun: this.props.onDeleteRun,
              onExportRun: this.props.onExportRun,
              onOpenRun: this.props.onOpenRun,
              selectRun: this.props.selectRun,
              deselectRun: this.props.deselectRun,
              isMultiSelected: this.props.isMultiSelected,
              selected: selected }));


        }),


        noSearchResults &&

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__runs-empty-list-item' }, 'No runs with that name.')));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6042:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerRecentRunsListItem; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _postman_date_helper__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5224);
/* harmony import */ var _postman_date_helper__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_postman_date_helper__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2929);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Icons_DownloadIcon__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6040);
/* harmony import */ var _js_components_base_Icons_DeleteIcon__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(3222);
/* harmony import */ var _js_modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(748);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(749);
var _class;







let


RunnerRecentRunsListItem = Object(mobx_react__WEBPACK_IMPORTED_MODULE_3__["observer"])(_class = class RunnerRecentRunsListItem extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.handleSelect = this.handleSelect.bind(this);
    this.openRun = this.props.onOpenRun.bind(this);
  }

  getWrapperClasses() {
    return classnames__WEBPACK_IMPORTED_MODULE_1___default()({
      'runner-recent-runs__runs-list-item': true,
      'is-selected': this.props.selected });

  }

  getIndicatorClasses(run) {
    return classnames__WEBPACK_IMPORTED_MODULE_1___default()({
      'runner-recent-runs__runs-list-item__indicator': true,
      'is-running': run.status === 'started',
      'is-stopped': run.status === 'finished' && _.get(run, 'meta.state') === 'stopped',
      'is-failed': run.status === 'finished' && _.get(run, 'meta.state') === 'failed',
      'is-passed': run.status === 'finished' && _.get(run, 'meta.state') === 'passed' });

  }

  getStatusClasses(run) {
    return classnames__WEBPACK_IMPORTED_MODULE_1___default()({
      'runner-recent-runs__runs-list-item__status': true,
      'is-running': run.status === 'started',
      'is-stopped': run.status === 'finished' && _.get(run, 'meta.state') === 'stopped',
      'is-failed': run.status === 'finished' && _.get(run, 'meta.state') === 'failed',
      'is-passed': run.status === 'finished' && _.get(run, 'meta.state') === 'passed' });

  }

  getRunStatus() {
    const { run } = this.props;

    switch (run.status) {
      case 'paused':
        return 'PAUSED';

      case 'started':
        return 'RUNNING';

      case 'finished':{
          // Status can be finished in 3 cases (states) - stopped, passed or failed
          const state = _.get(run, 'meta.state', '').toUpperCase();

          return state === 'FAILED' ? `${_.get(run, 'meta.failedTestCount', '')} ${state}` : state;
        }

      default:
        return '';}

  }

  getTooltipText(isDisabled) {
    if (isDisabled) {
      return 'You do not have permissions to perform this action.';
    }

    return 'Delete run';
  }

  handleAction(action, e) {
    e.stopPropagation && e.stopPropagation();
    switch (action) {
      case 'export':
        _js_modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEvent('collectionrun', 'download', 'recent_runs');
        this.props.onExportRun && this.props.onExportRun(this.props.run.id);
        break;

      case 'delete':
        _js_modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEvent('collectionrun', 'delete');
        this.props.onDeleteRun && this.props.onDeleteRun(this.props.run.id);
        break;

      default:
        break;}

  }

  handleSelect(e) {
    if (e.ctrlKey || e.metaKey) {
      if (this.props.selected) {
        this.props.deselectRun(this.props.run && this.props.run.id);
      } else {
        this.props.selectRun(this.props.run && this.props.run.id);
      }
    } else {
      this.openRun(this.props.run && this.props.run.id);
    }
  }

  render() {
    const { run } = this.props,
    permissionStore = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_8__["getStore"])('PermissionStore'),
    canDeleteCollectionrun = permissionStore.can('delete', 'collectionrun', run.id);

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
          className: this.getWrapperClasses(),
          onClick: this.handleSelect },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__runs-list-item__indicator-wrapper' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: this.getIndicatorClasses(run) })),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__runs-list-item__section-left' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__runs-list-item__collection' },
            run.name),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__runs-list-item__environment' },
            this.props.environment)),



        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__runs-list-item__section-right' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: this.getStatusClasses(run) },
            this.getRunStatus()),


          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__runs-list-item__date' },
            _postman_date_helper__WEBPACK_IMPORTED_MODULE_2___default.a.getFormattedDateAndTime(run.createdAt))),




        !this.props.isMultiSelected && run.status === 'finished' &&

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-recent-runs__runs-list-item__actions' },

          window.SDK_PLATFORM !== 'browser' &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_4__["Button"], {
              className: 'runner-recent-runs__runs-list-item__action runner-recent-runs__runs-list-item__action--export',
              onClick: this.handleAction.bind(this, 'export'),
              tooltip: 'Export run' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_DownloadIcon__WEBPACK_IMPORTED_MODULE_5__["default"], {
              className: 'runner-recent-runs__runs-list-item__action--export-icon',
              size: 'xs' })),




          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_4__["Button"], {
              className: 'runner-recent-runs__runs-list-item__action runner-recent-runs__runs-list-item__action--delete',
              onClick: this.handleAction.bind(this, 'delete'),
              tooltip: this.getTooltipText(!canDeleteCollectionrun),
              disabled: !canDeleteCollectionrun },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_DeleteIcon__WEBPACK_IMPORTED_MODULE_6__["default"], {
              className: 'runner-recent-runs__runs-list-item__action--delete-icon',
              size: 'xs' })))));







  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6043:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerRunDeleteConfirmationModal; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Modals__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3250);
/* harmony import */ var _js_components_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2974);
/* harmony import */ var _js_components_base_keymaps_KeyMaps__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2960);





let

RunnerRunDeleteConfirmationModal = class RunnerRunDeleteConfirmationModal extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isDeleteFocused: true };

    this.handleSubmit = this.handleSubmit.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleFocusClick = this.handleFocusClick.bind(this);
    this.handleFocusSwitch = this.handleFocusSwitch.bind(this);
  }

  componentDidMount() {
    pm.mediator.on('showRunnerRunDeleteModal', () => {
      requestIdleCallback(() => {
        _.invoke(this, 'refs.keyMapsRef.focus');
      });
    });
  }

  componentWillUnmount() {
    pm.mediator.off('showRunnerRunDeleteModal');
  }

  getCustomStyles() {
    return { marginTop: '35vh' };
  }

  getClasses() {
    return classnames__WEBPACK_IMPORTED_MODULE_1___default()({ 'delete-confirmation-modal': true }, this.props.className);
  }

  getModalTitle() {
    if (this.props.isMultiSelected) {
      return 'DELETE COLLECTION RUNS';
    }

    if (this.props.isSingleRun) {
      return 'DELETE COLLECTION RUN';
    }

    return 'DELETE ALL COLLECTION RUNS';
  }

  getModalMessage() {
    if (this.props.isMultiSelected) {
      return 'Are you sure you want to delete all the selected collection runs from this workspace?';
    }

    if (this.props.isSingleRun) {
      return 'Are you sure you want to delete the selected collection run from this workspace?';
    }

    return 'Are you sure you want to delete all collection runs from this workspace?';
  }

  getKeyMapHandlers() {
    return {
      quit: pm.shortcuts.handle('quit', this.handleClose), // Discard and close
      select: pm.shortcuts.handle('select', this.handleFocusClick), // Save and close
      submit: pm.shortcuts.handle('submit', this.handleFocusClick), // Save and close
      space: pm.shortcuts.handle('space', this.handleFocusClick), // Submit based on what is in focus
      focusNext: pm.shortcuts.handle('focusNext', this.handleFocusSwitch) // Switch to next button
    };
  }

  handleClose() {
    this.props.onRequestClose && this.props.onRequestClose();
    this.setState({ isDeleteFocused: true });
  }

  handleSubmit() {
    this.props.onConfirm && this.props.onConfirm();
  }

  handleFocusSwitch() {
    this.setState(prev => ({ isDeleteFocused: !prev.isDeleteFocused }));
  }

  handleFocusClick() {
    this.state.isDeleteFocused ? this.handleSubmit() : this.handleClose();
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Modals__WEBPACK_IMPORTED_MODULE_3__["Modal"], {
          isOpen: this.props.isOpen,
          onRequestClose: this.handleClose,
          className: this.getClasses(),
          customStyles: this.getCustomStyles() },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Modals__WEBPACK_IMPORTED_MODULE_3__["ModalHeader"], null, this.getModalTitle()),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Modals__WEBPACK_IMPORTED_MODULE_3__["ModalContent"], null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_keymaps_KeyMaps__WEBPACK_IMPORTED_MODULE_5__["default"], {
              keyMap: pm.shortcuts.getShortcuts(),
              handlers: this.getKeyMapHandlers(),
              ref: 'keyMapsRef' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', null,
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'delete-confirmation-modal-message' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, this.getModalMessage())),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'delete-confirmation-modal-controls' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_2__["Button"], {
                    type: 'primary',
                    onClick: this.handleSubmit,
                    disabled: this.props.isDisabled || this.props.isDeleting,
                    className: 'delete-confirmation-modal-delete-button',
                    focused: this.state.isDeleteFocused },

                  this.props.isDeleting ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_4__["default"], { className: 'loading-indicator-size' }) : _.get(this.props, 'primaryAction', 'Delete')),

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_2__["Button"], {
                    className: 'delete-confirmation-modal-cancel-button',
                    type: 'secondary',
                    onClick: this.handleClose,
                    focused: !this.state.isDeleteFocused }, 'Cancel')))))));









  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6044:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerRunsCustomizer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var react_dnd__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3301);
/* harmony import */ var react_dnd__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react_dnd__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _postman_react_dnd_html5_backend__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3681);
/* harmony import */ var _postman_react_dnd_html5_backend__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_postman_react_dnd_html5_backend__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _RunnerRunsCustomizerList__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(6045);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Icons_CloseIcon__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(3049);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(749);
var _dec, _class;








let



RunnerRunsCustomizer = (_dec = Object(react_dnd__WEBPACK_IMPORTED_MODULE_2__["DragDropContext"])(_postman_react_dnd_html5_backend__WEBPACK_IMPORTED_MODULE_3___default.a), _dec(_class = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class RunnerRunsCustomizer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.handleDragDrop = this.handleDragDrop.bind(this);
    this.handleToggle = this.handleToggle.bind(this);
    this.handleReset = this.handleReset.bind(this);
    this.handleBack = this.handleBack.bind(this);

    this.store = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_9__["getStore"])('RunnerSelectionStore').selection;
  }

  setAllChecked(value) {
    this.store.setAllRequest(value);
  }

  getClasses() {
    return classnames__WEBPACK_IMPORTED_MODULE_5___default()({
      'runner-runs-customizer__container': true,
      'is-disabled': this.props.isInconsistent || this.props.isDeleted });

  }

  getDisableState() {
    if (this.store.isDeleted) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-customizer__disable-overlay' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'content' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'title' }, 'This collection has been deleted'),
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'description' }, 'Select another collection to continue.'),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_7__["Button"], {
                className: 'button',
                type: 'secondary',
                onClick: this.handleBack }, 'Close'))));






    }

    if (this.store.isInconsistent) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-customizer__disable-overlay' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'content' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'title' }, 'Reload to continue'),
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'description' }, 'Some of the requests you\'ve selected have been modified.',

              ' ',
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('br', null), 'Please reload the requests to continue.'),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_7__["Button"], {
                className: 'button',
                type: 'secondary',
                onClick: this.handleReset }, 'Reload'))));






    }
  }

  handleToggle(index) {
    this.store.toggleRequest(index);
  }

  handleDragDrop(from, to, position) {
    this.store.reorderRequests(from, to, position);
  }

  handleReset() {
    this.store.reset();
  }

  handleBack() {
    Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_9__["getStore"])('RunnerSelectionStore').reset();
  }

  render() {
    const noStructure = _.isEmpty(this.store.requestSelection);

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-customizer' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-customizer__header' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'runner-runs-customizer__header-title' }, 'RUN ORDER'),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-customizer__header-buttons' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_7__["Button"], {
                className: 'button',
                type: 'text',
                onClick: this.setAllChecked.bind(this, false),
                disabled: noStructure }, 'Deselect All'),



            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'separator' }),
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_7__["Button"], {
                className: 'button',
                type: 'text',
                onClick: this.setAllChecked.bind(this, true),
                disabled: noStructure }, 'Select All'),



            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'separator' }),
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_7__["Button"], {
                className: 'button',
                type: 'text',
                onClick: this.handleReset,
                disabled: noStructure }, 'Reset'),





            this.props.onClose &&

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_CloseIcon__WEBPACK_IMPORTED_MODULE_8__["default"], {
              className: 'close',
              size: 'xs',
              onClick: this.props.onClose }))),




        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: this.getClasses() },

          !noStructure &&

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerRunsCustomizerList__WEBPACK_IMPORTED_MODULE_6__["default"], {
            requests: this.store.requests,
            folders: this.store.folders,
            itemList: this.store.requestSelection,
            onItemToggle: this.handleToggle,
            onDragDrop: this.handleDragDrop,
            disabled: this.store.isInconsistent || this.store.isDeleted,
            onInconsistency: () => {/* NoOp */} })),





        this.getDisableState()));



  }}) || _class) || _class);



RunnerRunsCustomizer.defaultProps = {
  onClose: undefined };


RunnerRunsCustomizer.propTypes = {
  onClose: prop_types__WEBPACK_IMPORTED_MODULE_4___default.a.func };
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6045:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerRunsCustomizerList; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _RunnerRunsCustomizerListItem__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6046);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;

let


RunnerRunsCustomizerList = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class RunnerRunsCustomizerList extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  enrichItem(item) {
    // Enrich parents will their respective data
    item.parents = _.map(item.parents, parent => this.props.folders.get(parent) || {});

    // Enrich item itself. Adding item after so that keys conflict is not a problem
    const data = this.props.requests.get(item.id);

    return data ? _extends({}, data, item) : null;
  }

  render() {
    const itemList = this.props.itemList || [];

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-customizer__list' },

        _.map(itemList, (item, index) =>
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerRunsCustomizerListItem__WEBPACK_IMPORTED_MODULE_2__["default"], {
          key: index,
          index: index,
          item: this.enrichItem(_extends({}, item)),
          onItemToggle: this.props.onItemToggle,
          onDragDrop: this.props.onDragDrop,
          disabled: this.props.disabled,
          onInconsistency: this.props.onInconsistency }))));





  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6046:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerRunsCustomizerListItem; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_dnd__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(3301);
/* harmony import */ var react_dnd__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_dnd__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(3048);
/* harmony import */ var _js_utils_RequestMethodHelper__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6047);
/* harmony import */ var _js_components_base_Icons_MenuIcon__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(3630);
/* harmony import */ var _js_components_base_Icons_RightSolidIcon__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(2970);
/* harmony import */ var _js_components_base_FolderButton__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(3657);
var _dec, _dec2, _class;











const itemSource = {
  canDrag(props) {
    return !props.disabled;
  },

  beginDrag(props) {
    return {
      index: props.index,
      id: props.item.id,
      type: props.item.type };

  },

  endDrag(props, monitor) {
    const dragIndex = monitor.getItem().index,
    { dropIndex, position } = monitor.getDropResult() || {};

    if (dragIndex === dropIndex || _.isUndefined(dropIndex)) {
      return;
    }

    props.onDragDrop(dragIndex, dropIndex, position);
  } },


getMiddleY = component => {
  const elementRect = Object(react_dom__WEBPACK_IMPORTED_MODULE_2__["findDOMNode"])(component).getBoundingClientRect();

  return elementRect.top + elementRect.height / 2;
},

itemTarget = {
  hover(props, monitor, component) {
    const dragIndex = monitor.getItem().index,
    hoverIndex = props.index;

    if (dragIndex === hoverIndex) {
      return;
    }

    if (monitor.getClientOffset().y > getMiddleY(component)) {
      component.getDecoratedComponentInstance().scheduleHoverUpdate('bottom');
    } else {
      component.getDecoratedComponentInstance().scheduleHoverUpdate('top');
    }
  },

  drop(props, monitor, component) {
    return {
      dropIndex: props.index,
      position: monitor.getClientOffset().y > getMiddleY(component) ? 'after' : 'before' };

  } };let











RunnerRunsCustomizerListItem = (_dec = Object(react_dnd__WEBPACK_IMPORTED_MODULE_1__["DropTarget"])('runner-customizer-list-request', itemTarget, (connect, monitor) => ({ connectDropTarget: connect.dropTarget(), isDragOver: monitor.isOver({ shallow: true }) })), _dec2 = Object(react_dnd__WEBPACK_IMPORTED_MODULE_1__["DragSource"])('runner-customizer-list-request', itemSource, (connect, monitor) => ({ connectDragSource: connect.dragSource(), connectDragPreview: connect.dragPreview(), isDragging: monitor.isDragging() })), _dec(_class = _dec2(_class = class RunnerRunsCustomizerListItem extends react__WEBPACK_IMPORTED_MODULE_0__["PureComponent"] {
  constructor(props) {
    super(props);

    this.state = {
      dropHoverBottom: false,
      dropHoverTop: false };


    this.handleToggle = this.handleToggle.bind(this);
    this.setDropHoverTop = this.setDropHoverTop.bind(this);
    this.setDropHoverBottom = this.setDropHoverBottom.bind(this);
  }

  componentDidMount() {
    // If the cannot be resolved and disabled in false then emit inconsistency
    !this.props.item && !this.props.disabled && this.props.onInconsistency();
  }

  componentWillUnmount() {
    cancelAnimationFrame(this.requestedFrame);
  }

  setDropHoverTop() {
    !this.state.dropHoverTop &&
    this.setState({
      dropHoverBottom: false,
      dropHoverTop: true });

  }

  setDropHoverBottom() {
    !this.state.dropHoverBottom &&
    this.setState({
      dropHoverBottom: true,
      dropHoverTop: false });

  }

  getMethodIcon(method = 'GET') {
    method = method.toUpperCase();

    const classes = `customizer__row_request-icon request-method--${method}`;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: classes },
        _js_utils_RequestMethodHelper__WEBPACK_IMPORTED_MODULE_5__["default"].getMethodAbbreviation(method)));


  }

  getClasses() {
    return classnames__WEBPACK_IMPORTED_MODULE_3___default()({
      'runner-runs-customizer__list-item__row': true,
      'is-dragged': this.props.isDragging,
      'is-drop-hovered-top': this.state.dropHoverTop && this.props.isDragOver,
      'is-drop-hovered-bottom': this.state.dropHoverBottom && this.props.isDragOver });

  }

  scheduleHoverUpdate(type) {
    const func = type === 'bottom' ? this.setDropHoverBottom : this.setDropHoverTop;

    if (!this.requestedFrame) {
      this.requestedFrame = requestAnimationFrame(() => {
        try {
          func && func();
        } finally {
          this.requestedFrame = null;
        }
      });
    }
  }

  handleToggle() {
    this.props.onItemToggle(this.props.index);
  }

  render() {
    const {
      connectDragSource,
      connectDragPreview,
      connectDropTarget,
      item } =
    this.props;

    return item && connectDragPreview(connectDropTarget(
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-runs-customizer__list-item' },
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: this.getClasses() },
        connectDragSource(
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'customizer__sort-icon' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_MenuIcon__WEBPACK_IMPORTED_MODULE_6__["default"], { size: 'xs' }))),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_4__["Checkbox"], {
          className: 'customizer__row_check',
          checked: item.checked,
          onChange: this.handleToggle }),

        !_.isEmpty(item.parents) &&

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'customizer__row__parents' },

          _.map(item.parents, (folder, index) =>
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
              key: index,
              className: 'customizer__row_icons' },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_FolderButton__WEBPACK_IMPORTED_MODULE_8__["default"], {
              className: 'customizer__row_folder-icon',
              placement: 'bottom',
              tooltip: folder.name,
              disabled: this.props.disabled }),

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_RightSolidIcon__WEBPACK_IMPORTED_MODULE_7__["default"], null)))),





        this.getMethodIcon(item.method),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'customizer__row_name' },
          ' ',
          item.name)))));




  }}) || _class) || _class);
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6047:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
const MAX_METHOD_LENGTH = 5;let

RequestMethodHelper = class RequestMethodHelper {
  getMethodAbbreviation(method) {
    let abbrvHash = {
      'PROPFIND': 'PROP',
      'DELETE': 'DEL',
      'OPTIONS': 'OPT',
      'UNLINK': 'UNLNK',
      'UNLOCK': 'UNLCK' };


    if (method) {
      return abbrvHash[method.toUpperCase()] || method.toUpperCase().slice(0, MAX_METHOD_LENGTH);
    }
  }};


/* harmony default export */ __webpack_exports__["default"] = (new RequestMethodHelper());

/***/ }),

/***/ 6048:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerResults; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _js_components_base_keymaps_KeyMaps__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2960);
/* harmony import */ var _ResultsHeader_RunnerResultsHeader__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6049);
/* harmony import */ var _RunnerResultsContent__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6050);
/* harmony import */ var _js_components_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2974);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(2934);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(749);
/* harmony import */ var _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(5353);
/* harmony import */ var _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(653);
/* harmony import */ var _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_9___default = /*#__PURE__*/__webpack_require__.n(_constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_9__);
/* harmony import */ var _helpers_RunnerHelper__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(5395);
var _class;













const keyMap = {
  goBack: ['del', 'backspace'] };


/**
                                   * Renders a full screen loading indicator
                                   */
function RunnerEventsLoadingIndicator() {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-contents__loading_container' },
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_5__["default"], null)));


}

/**
   * Renders a full screen error message
   * @param {object} props
   * @param {string} props.title Title of this message
   * @param {string} props.body Body of this message
   * @param {string} props.onRetry Function that should handle a retry attempt
   */
function RunnerEventsLoadingError({ title, body, onRetry }) {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-contents__loading_container' },
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'entity-empty' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'entity-empty__illustration-wrapper entity-empty__illustration-wrapper--collection-run' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'collection-run-empty__illustration' })),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'entity-empty__title' },
          title),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'entity-empty__subtitle entity-empty__subtitle--collection-run' },
          body),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'entity-empty__action entity-empty__action--collection-run' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_6__["Button"], { type: 'secondary', onClick: onRetry }, 'Try again')))));






}let


RunnerResults = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class RunnerResults extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.handleExport = this.handleExport.bind(this);

    this.store = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_7__["getStore"])('RunnerEventStore');
    this.syncStatusStore = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_7__["getStore"])('SyncStatusStore');
  }

  getKeyMapHandlers() {
    return {
      goBack: this.props.onTabChange.bind(this, _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_8__["RUNNER_TAB_RUN"]) };

  }

  getContent() {
    const {
      isHydrating: isLoadingEvents,
      hasLoadingError,
      run } =
    this.store,
    { isSocketConnected } = this.syncStatusStore,
    isRunPartiallyInflated = _.get(run, 'meta.isPartial', false),
    showOfflineError = isRunPartiallyInflated && !isSocketConnected,
    showLoadingIndicator = !showOfflineError && isLoadingEvents,
    showLoadingError = !showLoadingIndicator && hasLoadingError,
    showResults = !(showOfflineError || showLoadingIndicator || showLoadingError);

    if (showOfflineError) {
      const { title, body } = _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_9__["RUNNER_RESULTS_ERROR_MESSAGE_MAP"][_constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_9__["SYNC_OFFLINE"]];

      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(RunnerEventsLoadingError, { title: title, body: body, onRetry: this.handleReloadRun });
    }

    if (showLoadingIndicator) {
      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(RunnerEventsLoadingIndicator, null);
    }

    if (showLoadingError) {
      const { title, body } = _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_9__["RUNNER_RESULTS_ERROR_MESSAGE_MAP"][_constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_9__["REMOTE_FETCH_ERROR"]];

      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(RunnerEventsLoadingError, { title: title, body: body, onRetry: this.handleReloadRun });
    }

    if (showResults) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0__["Fragment"], null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__section-top' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ResultsHeader_RunnerResultsHeader__WEBPACK_IMPORTED_MODULE_3__["default"], {
              store: this.store,
              onExport: this.handleExport,
              onRunAction: this.props.onRunAction,
              onNewRun: this.props.onTabChange.bind(this, _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_8__["RUNNER_TAB_RUN"]),
              onOpenSummary: this.props.onTabChange.bind(this, _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_8__["RUNNER_TAB_SUMMARY"]) })),



          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerResultsContent__WEBPACK_IMPORTED_MODULE_4__["default"], {
            ref: ref => {this.contentRef = ref;},
            store: this.store,
            jumpSelectedIteration: this.handleJumpIteration })));



    }
  }

  handleExport(id) {
    _.isFunction(_helpers_RunnerHelper__WEBPACK_IMPORTED_MODULE_10__["exportRun"]) && Object(_helpers_RunnerHelper__WEBPACK_IMPORTED_MODULE_10__["exportRun"])(id);
  }

  handleReloadRun() {
    const { run } = this.store;

    this.store.hydrate(run);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_keymaps_KeyMaps__WEBPACK_IMPORTED_MODULE_2__["default"], {
          handlers: this.getKeyMapHandlers(),
          keyMap: keyMap },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: 'runner-results',
            ref: results => results && results.focus() },

          this.getContent())));



  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6049:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerResultsHeader; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _postman_date_helper__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5224);
/* harmony import */ var _postman_date_helper__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_postman_date_helper__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2929);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Icons_RightSolidIcon__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2970);
/* harmony import */ var _js_components_base_RadialProgress__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(3670);
var _class;






const scale = (num, outMax) => num * outMax / 100;let


RunnerResultsHeader = Object(mobx_react__WEBPACK_IMPORTED_MODULE_2__["observer"])(_class = class RunnerResultsHeader extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.handleOpenSummary = this.handleOpenSummary.bind(this);
  }

  getProgress(run, done) {
    const requestCount = _.size(_.get(run, 'context.requestSelection'), []),
    iterationCount = _.get(run, 'context.iterations', 1),
    runFinished = _.get(run, 'status', 'finished') === 'finished';

    if (requestCount === 0) {
      return 0;
    }

    let total = requestCount * iterationCount;

    if (done > total) {
      total += done - total + 1;
    }

    return runFinished ? 100 : Math.floor(scale(Math.min(done / total * 100, 100), 99));
  }

  getProgressText(value) {
    if (value < 1000) {
      return value;
    }

    return `${(value / 1000).toPrecision(3)}K`;
  }

  handleOpenSummary() {
    this.props.onOpenSummary && this.props.onOpenSummary();
  }

  render() {
    const { run, itemCount } = this.props.store,
    totalIterations = _.get(run, 'context.iterations');

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__header' },

        _.includes(['initialized', 'started', 'paused'], run.status) &&

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_RadialProgress__WEBPACK_IMPORTED_MODULE_5__["default"], {
          borderWidth: 3,
          className: 'runner-results__header__progress',
          progress: this.getProgress(run, itemCount),
          radius: 30 }),





        run.status === 'finished' &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__header__passed-wrapper' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__header__passed' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__header__passed-count' },
                run.meta && this.getProgressText(run.meta.totalTestCount - run.meta.failedTestCount)), 'PASSED')),




          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__header__failed-wrapper' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__header__failed' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__header__failed-count' },
                this.getProgressText(run.meta.failedTestCount)), 'FAILED'))),








        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__meta' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__meta__name-iter' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__meta__name' },
              run.name),



            run.status === 'started' &&

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__meta__iterations' }, 'Running',

              ' ',

              totalIterations + (totalIterations === '1' ? ' iteration' : ' iterations'),

              ' ', '...'),





            run.status === 'paused' &&

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__meta__iterations' }, 'Paused'),






            run.status === 'finished' &&

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__meta__iterations' },
              _postman_date_helper__WEBPACK_IMPORTED_MODULE_1___default.a.getFormattedTime(run.createdAt))),





          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__meta__environment' }, _.get(run, 'meta.environmentName') || 'No Environment')),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__actions' },

          run.status === 'finished' &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,

            !this.props.hideSummary &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], {
                className: 'runner-results__summary-link',
                size: 'large',
                type: 'primary',
                onClick: this.handleOpenSummary }, 'Run Summary',


              ' ',
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_RightSolidIcon__WEBPACK_IMPORTED_MODULE_4__["default"], { className: 'runner-results__forward-icon', style: 'primary' })),




            window.SDK_PLATFORM !== 'browser' &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], {
                className: 'runner-results__action--export',
                type: 'secondary',
                onClick: this.props.onExport.bind(this, run.id) }, 'Export Results'),






            !this.props.hideSummary &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], {
                className: 'runner-results__action--retry',
                type: 'secondary',
                onClick: this.props.onRunAction.bind(this, 'retry') }, 'Retry')),










          run.status !== 'finished' &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], {
              className: 'runner-results__action--abort',
              type: 'secondary',
              onClick: this.props.onRunAction.bind(this, 'stop'),
              disabled: run.pendingStatus }, 'Stop Run'),







          run.status !== 'finished' && (
          run.status === 'paused' ?
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], {
              className: 'runner-results__action--resume',
              type: 'secondary',
              onClick: this.props.onRunAction.bind(this, 'resume') }, 'Resume') :




          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], {
              className: 'runner-results__action--pause',
              type: 'secondary',
              onClick: this.props.onRunAction.bind(this, 'pause'),
              disabled: run.pendingStatus }, 'Pause')),







          run.status === 'finished' &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], {
              className: 'runner-results__action--new',
              type: 'secondary',
              onClick: this.props.onNewRun.bind(this) }, 'New'))));








  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6050:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerResultsContent; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var mobx__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(751);
/* harmony import */ var react_window__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3616);
/* harmony import */ var react_virtualized_auto_sizer__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5852);
/* harmony import */ var _ResultsContent_RunnerResultsRequestListItem__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6051);
/* harmony import */ var _ResultsContent_RunnerResultsSidebar__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(6054);
/* harmony import */ var _ResultsIterationBar_RunnerResultsIterationBar__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(6055);







let

RunnerResultsContent = class RunnerResultsContent extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.getItemSize = this.getItemSize.bind(this);
    this.getListItem = this.getListItem.bind(this);
    this.autoScrollToBottom = this.autoScrollToBottom.bind(this);
    this.onItemsRendered = this.onItemsRendered.bind(this);
    this.callOnScroll = this.callOnScroll.bind(this);
    this.handleJumpIteration = this.handleJumpIteration.bind(this);

    this.autoScroll = true;

    // Listen to changes in number of Runner events
    //
    // requestIdleCallback is used because mounting and rendering of new Runner Results is of higher priority and must
    // be done before scrolling. Also, this helps in waiting for the mounting when Runner Results is opened, before the
    // initial scroll to bottom.
    this.reactionDisposer = Object(mobx__WEBPACK_IMPORTED_MODULE_2__["reaction"])(() => props.store.values, values => {
      requestIdleCallback(this.autoScrollToBottom.bind(this));


      // Clearing cached height whenever the list of items become empty. This is done specifically for
      // cases when new items come in `values` array but this component is not remounted and uses the
      // cached height of previous items.
      // Example for such a flow is when user clicks on `Retry` button after collapsing few items of previous run
      _.isEmpty(values) && !_.isEmpty(this.listRef) && this.listRef.resetAfterIndex(0);
    });

    this.reactionFilter = Object(mobx__WEBPACK_IMPORTED_MODULE_2__["reaction"])(() => props.store.filter, () => {
      !_.isEmpty(this.listRef) && this.listRef.resetAfterIndex(0);
      !_.isEmpty(this.listRef) && this.listRef.scrollToItem(0);
    });
  }

  componentWillUnmount() {
    this.reactionDisposer && this.reactionDisposer();
    this.reactionFilter && this.reactionFilter();
  }

  // Listen to user scroll for enabling autoscroll
  onItemsRendered({ visibleStartIndex, visibleStopIndex }) {
    const { isOngoing, itemCount, values } = this.props.store;

    this.props.store.changeIteration(_.get(values, [visibleStartIndex, 'iteration'], 0));

    // Visible stop index is the last list item visible in the virtualized list
    //
    // if the last list item is visible, then autoscroll gets enabled
    if (isOngoing && visibleStopIndex >= itemCount - 2) {
      this.autoScroll = true;
    }
  }

  getItemSize(index) {
    const { values, collapsedSet, iterationIndex } = this.props.store,
    event = values[index],
    isCollapsed = event && collapsedSet.has(event.id),
    testCount = event && event.tests && event.tests.length,

    additional = iterationIndex[event.iteration] === index ? 17 : 0;

    if (isCollapsed) {
      return 40 + additional; // Remove this extra +1 after removing extra border-bottom
    }

    if (testCount) {
      return testCount * 40 + 41 + additional; // Remove this extra +1 after removing extra border-bottom
    }

    return 81 + additional; // Remove this extra +1 after removing extra border-bottom
  }

  getListItem(data) {
    const { values, collapsedSet, iterationIndex } = this.props.store,
    event = values[data.index],
    toggleExpanded = () => {
      this.props.store.toggleExpanded(event.id);
      !_.isEmpty(this.listRef) && this.listRef.resetAfterIndex(data.index);
    },
    handleClearHeightCache = () => {
      !_.isEmpty(this.listRef) && this.listRef.resetAfterIndex(data.index);
    };

    if (!event) {
      return null;
    }

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { style: data.style },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ResultsContent_RunnerResultsRequestListItem__WEBPACK_IMPORTED_MODULE_5__["default"], {
          isOpen: !collapsedSet.has(event.id),
          toggleExpanded: toggleExpanded,
          key: data.index,
          filter: this.props.store.filter,
          event: event,
          store: this.props.store,
          showIter: iterationIndex[event.iteration] === data.index,
          resetHeight: handleClearHeightCache })));



  }

  autoScrollToBottom() {
    if (!this.autoScroll || !this.props.store.isOngoing) {
      return;
    }

    !_.isEmpty(this.listRef) && this.listRef.scrollToItem(this.props.store.values.length - 1);
  }

  // Listen to backward user scroll for disabling autoscroll
  callOnScroll({ scrollDirection }) {
    // If the user scrolls in upward direction, which is 'backward' in react-window
    // then autoscroll should be disabled
    if (scrollDirection === 'backward') {
      this.autoScroll = false;
    }
  }

  handleJumpIteration(iteration) {
    const index = this.props.store.iterationIndex[iteration];

    !_.isEmpty(this.listRef) && !_.isNil(index) && this.listRef.scrollToItem(index, 'start');
  }

  render() {
    const lister = data =>
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(mobx_react__WEBPACK_IMPORTED_MODULE_1__["Observer"], null,
      this.getListItem.bind(this, data)),


    sizer = ({ height, width }) =>
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(mobx_react__WEBPACK_IMPORTED_MODULE_1__["Observer"], null,
      () =>
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react_window__WEBPACK_IMPORTED_MODULE_3__["VariableSizeList"], {
          height: height,
          itemCount: this.props.store.valueLength,
          itemSize: this.getItemSize,
          width: width,
          onItemsRendered: this.onItemsRendered,
          onScroll: this.callOnScroll,
          ref: ref => {this.listRef = ref;} },

        lister));





    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__section-bottom' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ResultsContent_RunnerResultsSidebar__WEBPACK_IMPORTED_MODULE_6__["default"], { store: this.props.store }),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__body' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react_virtualized_auto_sizer__WEBPACK_IMPORTED_MODULE_4__["default"], null, sizer)),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ResultsIterationBar_RunnerResultsIterationBar__WEBPACK_IMPORTED_MODULE_7__["default"], {
          store: this.props.store,
          jumpIteration: this.handleJumpIteration })));



  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6051:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerResultsRequestListItem; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2929);
/* harmony import */ var _ResultTooltip__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6052);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Icons_DownSolidIcon__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(2969);
/* harmony import */ var _js_components_base_Icons_UpSolidIcon__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(2968);
/* harmony import */ var _RunnerResultsTestListItem__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(6053);
/* harmony import */ var _js_modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(748);
/* harmony import */ var _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(653);
/* harmony import */ var _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_10___default = /*#__PURE__*/__webpack_require__.n(_constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_10__);
var _class;









let


RunnerResultsRequestListItem = Object(mobx_react__WEBPACK_IMPORTED_MODULE_3__["observer"])(_class = class RunnerResultsRequestListItem extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      response: false };


    this.toggleResponse = this.toggleResponse.bind(this);

    this.testCount = 0;
  }

  componentDidUpdate() {
    if (this.testCount !== this.props.event.tests.length) {
      this.testCount = this.props.event.tests.length;
      this.props.resetHeight();
    }
  }

  getHeaderClasses() {
    return classnames__WEBPACK_IMPORTED_MODULE_2___default()({
      'runner-results__request__header': true,
      'is-failed': this.isFailed(this.props.event.tests) });

  }

  getStatusClasses() {
    const overallStatus = this.isFailed(this.props.event.tests);

    return classnames__WEBPACK_IMPORTED_MODULE_2___default()({
      'runner-results__request__status': true,
      'is-passed': !overallStatus,
      'is-failed': overallStatus });

  }

  getMethodClasses() {
    const method = _.get(this.props.event, 'item.request.method', 'get');

    return classnames__WEBPACK_IMPORTED_MODULE_2___default()({
      'runner-results__request__method': true,
      [`runner-results__request__method--${method.toUpperCase()}`]: true });

  }

  getToggleButtonClasses() {
    return classnames__WEBPACK_IMPORTED_MODULE_2___default()({
      'runner-results__request__expand': true,
      'is-open': this.props.isOpen });

  }

  getTooltipPosition() {
    const me = Object(react_dom__WEBPACK_IMPORTED_MODULE_1__["findDOMNode"])(this).getBoundingClientRect();

    return window.innerHeight > me.top + 230 ? 'bottom' : 'top';
  }

  getErrorMessage(error) {
    const consoleMessage = _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_10__["RUNNER_CONSOLE_MESSAGE_MAP"][error];

    // If the error message does not need a link to open Postman Console, use
    // the message from the constant string error messages.
    if (!(consoleMessage && Array.isArray(consoleMessage))) {
      return _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_10__["RUNNER_MESSAGE_MAP"][error] ?
      _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_10__["RUNNER_MESSAGE_MAP"][error] :
      _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_10__["RUNNER_MESSAGE_MAP"][_constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_10__["GENERIC_ERROR"]];
    }

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
        consoleMessage[0],
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('a', {
            className: 'test__name--link',
            onClick: () => {
              // @note we don't have a way to check if bottom pane is already
              // open. this event will be sent for every click on the error
              // message.
              _js_modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_9__["default"].addEventV2({
                category: 'console',
                action: 'open_pane',
                label: 'runner_error' });


              pm.mediator.trigger('openConsole');
            } },

          consoleMessage[1]),

        consoleMessage[2]));


  }

  isFailed(tests) {
    return _.some(tests, test => test.passed === false);
  }

  toggleResponse(e) {
    e && e.stopPropagation();
    this.setState(prev => ({ response: !prev.response }));
    !this.state.response && _js_modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_9__["default"].addEvent('collectionrun', 'view_response');
  }

  render() {
    const {
      item, response, error, tests, iteration } =
    this.props.event,
    method = _.get(item, 'request.method'),
    url = _.get(item, 'request.url'),
    path = _.get(item, 'request.path');

    // If the item does not exist then wait for it load
    if (!item) {
      return null;
    }

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__request' },
        this.props.showIter &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__request__iter' },
          `Iteration ${iteration + 1}`),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: this.getHeaderClasses() },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__request__details' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: this.getStatusClasses() }),
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: this.getMethodClasses() }, _.toUpper(method)),
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                className: 'runner-results__request__name',
                onClick: this.toggleResponse },

              item.name),

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__request__url' }, url),

            path &&
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { title: path, className: 'runner-results__request__path' }, path),


            this.state.response &&

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_ResultTooltip__WEBPACK_IMPORTED_MODULE_4__["default"], {
              store: this.props.store,
              event: this.props.event,
              position: this.getTooltipPosition.bind(this),
              onClose: this.toggleResponse })),






          !_.isEmpty(response) &&

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__response__details' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__response__details__detail' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__response__icon' }),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__response__code' },
                response.code,
                ' ',
                response.status)),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__response__details__detail' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__response__icon' }),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__response__time' },
                `${response.responseTime} ms`)),



            response.responseSize &&

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__response__details__detail' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__response__icon' }),
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__response__size' },

                response.responseSize.total < 1000 ?
                `${response.responseSize.total} B` :
                `${response.responseSize.total / 1000} KB`))),









          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], {
              className: 'runner-results__request__expand-button',
              onClick: this.props.toggleExpanded },


            this.props.isOpen ?
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_UpSolidIcon__WEBPACK_IMPORTED_MODULE_7__["default"], { className: 'runner-results__request__expand is-open' }) :
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_DownSolidIcon__WEBPACK_IMPORTED_MODULE_6__["default"], { className: 'runner-results__request__expand' }))),




        this.props.isOpen &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__request__body' },

          error &&

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__test is-failed' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__test__name' },
              this.getErrorMessage(error))),





          !error && _.isEmpty(tests) ?

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__test__empty' }, 'This request does not have any tests.') :



          _.map(tests, (test, index) =>
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerResultsTestListItem__WEBPACK_IMPORTED_MODULE_8__["default"], {
            key: index,
            test: test })))));







  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6052:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ResultTooltip; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _js_components_base_ExpandableTooltip__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3655);
/* harmony import */ var _js_utils_util__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(784);
/* harmony import */ var _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(653);
/* harmony import */ var _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__);
var _class;



let


ResultTooltip = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class ResultTooltip extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  componentDidMount() {
    const { id, request, response } = this.props.event;

    // Load request/response body from blob table if any of the either has not been ignored
    if (!(_.has(request, 'body.___ignored___') && _.has(response, 'body.___ignored___'))) {
      _.isFunction(this.props.store.loadBlob) && this.props.store.loadBlob(id);
    }
  }

  getTooltipData() {
    const { request, response } = this.props.event,
    blob = _.get(this.props, 'store.blob', {});

    let requestHeaders,
    responseHeaders;

    // Populate request headers
    if (_.has(request, 'headers.___ignored___')) {
      requestHeaders = _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__["RUNNER_MESSAGE_MAP"][_.get(request, 'headers.___ignored___')];
    } else if (!_.isEmpty(request.headers)) {
      requestHeaders = _.reduce(_.keys(request.headers), (headers, header) => {
        headers[header] = request.headers[header];

        return headers;
      }, {});
    } else {
      requestHeaders = _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__["RUNNER_MESSAGE_MAP"][_constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__["NO_REQUEST_HEADERS"]];
    }

    // Populate response headers
    if (_.has(response, 'headers.___ignored___')) {
      responseHeaders = _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__["RUNNER_MESSAGE_MAP"][_.get(response, 'headers.___ignored___')];
    } else if (!_.isEmpty(response)) {
      responseHeaders = _.reduce(response.headers, (headers, header) => {
        headers[header.key] = header.value;

        return headers;
      }, {});
    } else {
      responseHeaders = _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__["RUNNER_MESSAGE_MAP"][_constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__["NO_RESPONSE_HEADERS"]];
    }

    // Populate request and response body
    let requestBody = this.props.store.isBlobLoading ?
    _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__["RUNNER_MESSAGE_MAP"][_constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__["LOAD_BODY"]] :
    _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__["RUNNER_MESSAGE_MAP"][_.get(request, 'body.___ignored___')] || _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__["RUNNER_MESSAGE_MAP"][_constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__["NO_REQUEST_BODY"]],

    responseBody = this.props.store.isBlobLoading ?
    _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__["RUNNER_MESSAGE_MAP"][_constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__["LOAD_BODY"]] :
    _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__["RUNNER_MESSAGE_MAP"][_.get(response, 'body.___ignored___')] || _constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__["RUNNER_MESSAGE_MAP"][_constants_RunnerMessageConstants__WEBPACK_IMPORTED_MODULE_4__["NO_RESPONSE_BODY"]];


    // Do not update response/request body in cases where the body is ignored or the blob is empty
    // This update will only happen when the store is populated with blob data from the call made in
    // componentDidMount

    requestBody = !(_.isEmpty(blob.requestBody) || _.has(request, 'body.___ignored___')) ?

    // Parsing request body as it was stringified while storing in the db. See RunnerEventController
    _js_utils_util__WEBPACK_IMPORTED_MODULE_3__["default"].stringify(JSON.parse(blob.requestBody)) :
    requestBody;

    responseBody = !(_.isEmpty(blob.responseBody) || _.has(response, 'body.___ignored___')) ?
    _js_utils_util__WEBPACK_IMPORTED_MODULE_3__["default"].beautifyJs(blob.responseBody) :
    responseBody;

    return [{
      title: 'Request URL',
      body: request && request.url },
    {
      title: 'Request Headers',
      body: requestHeaders },
    {
      title: 'Request Body',
      body: requestBody },
    {
      title: 'Response Headers',
      body: responseHeaders },
    {
      title: 'Response Body',
      body: responseBody }];

  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_ExpandableTooltip__WEBPACK_IMPORTED_MODULE_2__["default"], {
        data: this.getTooltipData(),
        position: this.props.position,
        onClose: this.props.onClose }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6053:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerResultsTestListItem; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var pure_render_decorator__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2965);
/* harmony import */ var pure_render_decorator__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(pure_render_decorator__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_2__);
var _class;

let


RunnerResultsTestListItem = pure_render_decorator__WEBPACK_IMPORTED_MODULE_1___default()(_class = class RunnerResultsTestListItem extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  getClasses() {
    return classnames__WEBPACK_IMPORTED_MODULE_2___default()({
      'runner-results__test': true,
      'is-passed': this.props.test.passed === true && this.props.test.skipped !== true,
      'is-skipped': this.props.test.skipped === true,
      'is-failed': this.props.test.passed === false });

  }

  getStatusClasses() {
    return classnames__WEBPACK_IMPORTED_MODULE_2___default()({
      'runner-results__test__status': true,
      'is-passed': this.props.test.passed === true && this.props.test.skipped !== true,
      'is-skipped': this.props.test.skipped === true,
      'is-failed': this.props.test.passed === false });

  }

  getText(test) {
    if (test.skipped) {
      return 'SKIPPED';
    }

    return test.passed ? 'PASSED' : 'FAILED';
  }

  render() {
    const { test } = this.props;

    let testItemResult = test.name;

    if (!_.isEmpty(test.error)) {
      testItemResult += ` | ${_.get(test, 'error.name', '')}: ${_.get(test, 'error.message', '')}`;
    }

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: this.getClasses() },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: this.getStatusClasses() }),

        test.status &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__test__status__text' }, this.getText(test)),

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            title: test.name,
            className: 'runner-results__test__name' },

          testItemResult)));



  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6054:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerResultsSidebar; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_1__);

let

RunnerResultsSidebar = class RunnerResultsSidebar extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  onFilterChange(value) {
    this.props.store.changeFilter(value);
  }

  getTabClasses(tab, filter) {
    return classnames__WEBPACK_IMPORTED_MODULE_1___default()({
      'runner-results__sidebar__all': tab === 'all',
      'runner-results__sidebar__passed': tab === 'pass',
      'runner-results__sidebar__failed': tab === 'fail',
      'is-selected': filter === tab });

  }

  render() {
    const { status, filter } = this.props.store;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__sidebar' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: this.getTabClasses('all'),
            onClick: this.onFilterChange.bind(this, 'all') },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'passed' }),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'failed' })),



        status !== 'started' &&

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: this.getTabClasses('pass', filter),
            onClick: this.onFilterChange.bind(this, 'pass') },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'passed' })),




        status !== 'started' &&

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: this.getTabClasses('fail', filter),
            onClick: this.onFilterChange.bind(this, 'fail') },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'failed' }))));





  }};

/***/ }),

/***/ 6055:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerResultsIterationBar; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var mobx__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(751);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2929);
/* harmony import */ var react_window__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(3616);
/* harmony import */ var react_virtualized_auto_sizer__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(5852);







const ITEM_HEIGHT = 30;let

RunnerResultsIterationBar = class RunnerResultsIterationBar extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.scrollToItem = this.scrollToItem.bind(this);
  }

  componentDidMount() {
    this.reactionDisposer = Object(mobx__WEBPACK_IMPORTED_MODULE_2__["reaction"])(() => _.get(this.props, 'store.selectedIteration'), selectedIteration => this.scrollToItem(selectedIteration));
  }

  componentWillUnmount() {
    this.reactionDisposer && this.reactionDisposer();
  }

  getTabClasses(index) {
    const { run, selectedIteration, currentIteration } = this.props.store;

    return classnames__WEBPACK_IMPORTED_MODULE_1___default()({
      'runner-results__iterations__tab': true,
      'is-active': selectedIteration === index,
      'is-running': run.status !== 'finished' && currentIteration === index,
      'is-pending': index > currentIteration,
      'is-done': index <= currentIteration });

  }

  getListItem({ style, index }) {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { style: style },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: this.getTabClasses(index),
            key: index,
            onClick: this.handleIterationChange.bind(this, index) },

          index + 1)));



  }

  scrollToItem(index) {
    !_.isEmpty(this.listRef) && !_.isNil(index) && this.listRef.scrollToItem(index);
  }

  handleIterationChange(iteration) {
    if (iteration > this.props.currentIteration) {
      return;
    }

    this.props.store.changeIteration(iteration);
    this.props.jumpIteration(iteration);
  }

  render() {
    const iterationCount = _.get(this.props, 'store.run.context.iterations', 0),
    lister = data =>
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(mobx_react__WEBPACK_IMPORTED_MODULE_3__["Observer"], null,
      this.getListItem.bind(this, data));



    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-results__iterations__tabs' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react_virtualized_auto_sizer__WEBPACK_IMPORTED_MODULE_5__["default"], null,
          ({ height, width }) =>
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react_window__WEBPACK_IMPORTED_MODULE_4__["FixedSizeList"], {
              height: height,
              width: width,
              itemCount: iterationCount,
              itemSize: ITEM_HEIGHT,
              ref: ref => {this.listRef = ref;} },

            lister))));





  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6056:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerSummaryContainer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _js_components_base_keymaps_KeyMaps__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2960);
/* harmony import */ var _RunnerResults_ResultsHeader_RunnerResultsHeader__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6049);
/* harmony import */ var _RunnerResults_ResultsContent_RunnerResultsSidebar__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6054);
/* harmony import */ var _SummaryBody_RunnerSummaryBody__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6057);
/* harmony import */ var _SummaryHeaderIterations_RunnerSummaryHeaderIterations__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(6062);
/* harmony import */ var _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(5353);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(749);
/* harmony import */ var _helpers_RunnerHelper__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(5395);
var _class;












const keyMap = { goBack: ['del', 'backspace'] };let


RunnerSummaryContainer = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class RunnerSummaryContainer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      hoveredIteration: 0,
      scrollLeft: 0 };


    this.handleFilterChange = this.handleFilterChange.bind(this);
    this.handleIterationHover = this.handleIterationHover.bind(this);
    this.handleScroll = this.handleScroll.bind(this);
    this.handleExport = this.handleExport.bind(this);

    this.store = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_8__["getStore"])('RunnerEventStore');
  }

  getKeyMapHandlers() {
    return { goBack: this.props.onTabChange.bind(this, _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_7__["RUNNER_TAB_RESULTS"]) };
  }

  handleFilterChange(filter) {
    this.store.changeFilter(filter);
  }

  handleIterationHover(iterationId) {
    this.setState({ hoveredIteration: iterationId });
  }

  handleScroll(e) {
    e && this.setState({ scrollLeft: e.target.scrollLeft });
  }

  handleExport(id) {
    _.isFunction(_helpers_RunnerHelper__WEBPACK_IMPORTED_MODULE_9__["exportRun"]) && Object(_helpers_RunnerHelper__WEBPACK_IMPORTED_MODULE_9__["exportRun"])(id);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_keymaps_KeyMaps__WEBPACK_IMPORTED_MODULE_2__["default"], {
          handlers: this.getKeyMapHandlers(),
          keyMap: keyMap },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            className: 'runner-summary',
            ref: summary => summary && summary.focus() },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-summary__section-top' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerResults_ResultsHeader_RunnerResultsHeader__WEBPACK_IMPORTED_MODULE_3__["default"], {
              hideSummary: true,
              store: this.store,
              onExport: this.handleExport,
              onRunAction: this.props.onRunAction,
              onNewRun: this.props.onTabChange.bind(this, _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_7__["RUNNER_TAB_RUN"]) }),

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_SummaryHeaderIterations_RunnerSummaryHeaderIterations__WEBPACK_IMPORTED_MODULE_6__["default"], {
              hoveredIteration: this.state.hoveredIteration,
              run: this.store.run,
              scrollLeft: this.state.scrollLeft,
              onIterationHover: this.handleIterationHover,
              onOpenResults: this.props.onTabChange.bind(this, _constants_RunnerConstants__WEBPACK_IMPORTED_MODULE_7__["RUNNER_TAB_RESULTS"]),
              onScroll: this.handleScroll })),


          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-summary__section-bottom' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerResults_ResultsContent_RunnerResultsSidebar__WEBPACK_IMPORTED_MODULE_4__["default"], {
              store: this.store,
              onFilterChange: this.handleFilterChange }),

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_SummaryBody_RunnerSummaryBody__WEBPACK_IMPORTED_MODULE_5__["default"], {
              hoveredIteration: this.state.hoveredIteration,
              events: this.store.values,
              iterations: this.store.run.context.iterations,
              scrollLeft: this.state.scrollLeft,
              onIterationHover: this.handleIterationHover,
              onScroll: this.handleScroll })))));





  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6057:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerSummaryBody; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _RunnerSummaryRequestListItem__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6058);
var _class;

let


RunnerSummaryBody = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class RunnerSummaryBody extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  render() {
    const rows = _.orderBy(_.reduce(
    _.map(this.props.events, e => ({
      id: e.item.id,
      name: e.item.name,
      method: e.item.request && e.item.request.method || '',
      sequence: e.sequence,
      iteration: e.iteration,
      tests: e.tests })),
    (acc, val) => {
      // The data obtain here is {id, name, sequence, iteration, tests}
      // What we want to construct is tests:[iteration][testindex]
      // If we do not all ready have it then set it
      if (!acc[val.id]) {
        acc[val.id] = {
          id: val.id,
          name: val.name,
          method: val.method,
          sequence: val.sequence,
          tests: [],
          tmap: [],
          failed: false };

      }

      if (!acc[val.id].tmap[val.iteration]) {
        acc[val.id].tmap[val.iteration] = 0;
      }

      _.forEach(val.tests, test => {
        if (!acc[val.id].tests[test.index]) {
          acc[val.id].tests[test.index] = { name: test.name, iter: [] };
        }

        acc[val.id].tests[test.index].
        iter[val.iteration] = test.skipped ? 0 : test.passed ? 1 : 2; // eslint-disable-line no-nested-ternary

        test.passed === false && (acc[val.id].failed = true, acc[val.id].tmap[val.iteration] = 2);
      });

      if (val.tests.length && acc[val.id].tmap[val.iteration] === 0) {
        acc[val.id].tmap[val.iteration] = 1;
      }

      return acc;
    }, {}),
    'sequence');

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-summary__body' },

        _.map(rows, (row, id) =>
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerSummaryRequestListItem__WEBPACK_IMPORTED_MODULE_2__["default"], {
          hoveredIteration: this.props.hoveredIteration,
          iterations: this.props.iterations,
          row: row,
          key: id,
          scrollLeft: this.props.scrollLeft,
          onIterationHover: this.props.onIterationHover,
          onScroll: this.props.onScroll })),




        _.isEmpty(rows) &&

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-summary__body__empty' }, 'No tests found for the selected filter')));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6058:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerSummaryRequestListItem; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Icons_UpSolidIcon__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2968);
/* harmony import */ var _js_components_base_Icons_DownSolidIcon__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2969);
/* harmony import */ var _RunnerSummaryTestListItem__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(6059);
/* harmony import */ var _RunnerSummaryTimeline__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(6060);







let

RunnerSummaryRequestListItem = class RunnerSummaryRequestListItem extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = { isOpen: true };

    this.toggleRequest = this.toggleRequest.bind(this);
  }

  componentDidMount() {
    if (!this.props.row.failed) {
      this.toggleRequest();
    }
  }

  // eslint-disable-next-line camelcase
  UNSAFE_componentWillUpdate(nextProps) {
    const me = Object(react_dom__WEBPACK_IMPORTED_MODULE_1__["findDOMNode"])(this.refs.timeline);

    if (me) {
      me.scrollLeft = nextProps.scrollLeft;
    }
  }

  getStatusClasses(isFailed) {
    return classnames__WEBPACK_IMPORTED_MODULE_2___default()({
      'runner-summary__request-list-item__status': true,
      'is-failed': isFailed,
      'is-passed': !isFailed });

  }

  getMethodClasses(method = 'get') {
    return classnames__WEBPACK_IMPORTED_MODULE_2___default()(
    'runner-summary__request-list-item__method',
    `runner-summary__request-list-item__method--${method.toUpperCase()}`);

  }

  toggleRequest() {
    this.setState(prev => ({ isOpen: !prev.isOpen }));
  }

  render() {
    const { row } = this.props;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-summary__request-list-item' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-summary__request-list-item__header' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-summary__request-list-item__meta' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: this.getStatusClasses(row.failed) }),
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: this.getMethodClasses(row.method) },
              row.method.toUpperCase()),

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-summary__request-list-item__name' },
              row.name)),



          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-summary__request-list-item__timeline' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerSummaryTimeline__WEBPACK_IMPORTED_MODULE_7__["default"], {
              active: !this.state.isOpen,
              hoveredIteration: this.props.hoveredIteration,
              states: row.tmap,
              ref: 'timeline',
              scrollLeft: this.props.scrollLeft,
              type: 'request',
              onHover: this.props.onIterationHover,
              onScroll: this.props.onScroll })),



          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_3__["Button"], {
              className: 'runner-summary__request__expand-button',
              onClick: this.toggleRequest },


            this.state.isOpen ?
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_UpSolidIcon__WEBPACK_IMPORTED_MODULE_4__["default"], { className: 'runner-summary__request__expand is-open' }) :
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_DownSolidIcon__WEBPACK_IMPORTED_MODULE_5__["default"], { className: 'runner-summary__request__expand' }))),




        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-summary__request-list-item__body' },

          this.state.isOpen && _.map(row.tests, (test, index) =>
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerSummaryTestListItem__WEBPACK_IMPORTED_MODULE_6__["default"], {
            failed: row.failed,
            hoveredIteration: this.props.hoveredIteration,
            key: index,
            scrollLeft: this.props.scrollLeft,
            test: test,
            iteration: index,
            onIterationHover: this.props.onIterationHover,
            onScroll: this.props.onScroll })))));






  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6059:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerSummaryTestListItem; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _RunnerSummaryTimeline__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6060);



let

RunnerSummaryTestListItem = class RunnerSummaryTestListItem extends react__WEBPACK_IMPORTED_MODULE_0__["PureComponent"] {
  componentDidUpdate() {
    const me = Object(react_dom__WEBPACK_IMPORTED_MODULE_1__["findDOMNode"])(this.refs.timeline);

    if (me) {
      me.scrollLeft = this.props.scrollLeft;
    }
  }

  getClasses(failed) {
    return classnames__WEBPACK_IMPORTED_MODULE_2___default()({
      'runner-summary__test-list-item': true,
      'is-failed': failed });

  }

  getStatusClasses(failed) {
    return classnames__WEBPACK_IMPORTED_MODULE_2___default()({
      'runner-summary__test-list-item__status': true,
      'is-passed': !failed,
      'is-failed': failed });

  }

  render() {
    if (!this.props.test) {
      return null;
    }

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: this.getClasses(this.props.failed) },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-summary__test-list-item__meta' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: this.getStatusClasses(this.props.failed) }),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-summary__test-list-item__status__text' }, this.props.failed ? 'FAIL' : 'PASS'),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-summary__test-list-item__name' },
            this.props.test.name)),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            ref: 'timeline',
            className: 'runner-summary__test-list-item__timeline' },

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerSummaryTimeline__WEBPACK_IMPORTED_MODULE_3__["default"], {
            hoveredIteration: this.props.hoveredIteration,
            states: this.props.test.iter,
            scrollLeft: this.props.scrollLeft,
            iteration: this.props.iteration,
            type: 'test',
            onHover: this.props.onIterationHover,
            onScroll: this.props.onScroll }))));




  }};

/***/ }),

/***/ 6060:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerSummaryTimeline; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _RunnerSummaryTimelineKeyframe__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6061);

let


RunnerSummaryTimeline = class RunnerSummaryTimeline extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this._keyframe = this._keyframe.bind(this);
  }

  // eslint-disable-next-line camelcase
  UNSAFE_componentWillReceiveProps(nextProps) {
    if (this.props.scrollLeft !== nextProps.scrollLeft) {
      this.refs.timeline.scrollLeft = nextProps.scrollLeft;
    }
  }


  _keyframe(state, index) {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_RunnerSummaryTimelineKeyframe__WEBPACK_IMPORTED_MODULE_1__["default"], {
        active: this.props.active,
        key: index,
        type: this.props.type,
        hoveredIteration: this.props.hoveredIteration,
        state: state,
        iteration: index,
        onHover: this.props.onHover }));


  }

  render() {
    const { states } = this.props;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-summary__body__timeline' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'pm-row', ref: 'timeline', onScroll: this.props.onScroll },

          _.map(states, this._keyframe))));




  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6061:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerSummaryTimelineKeyframe; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _js_components_base_Icons_SuccessIcon__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3220);
/* harmony import */ var _js_components_base_Icons_CloseIcon__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3049);



let

RunnerSummaryTimelineKeyframe = class RunnerSummaryTimelineKeyframe extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  shouldComponentUpdate(nextProps) {
    if (this.props.active !== nextProps.active) {
      return true;
    }

    return nextProps.hoveredIteration === this.props.iteration ||
    this.props.hoveredIteration === this.props.iteration;
  }

  getTestKeyframes() {
    const { iteration, state } = this.props;

    return classnames__WEBPACK_IMPORTED_MODULE_1___default()({
      'runner-summary__body__timeline__keyframe': true,
      'is-grey': state === 0,
      'is-green': state === 1,
      'is-red': state === 2,
      'is-hovered': this.props.hoveredIteration === iteration });

  }

  getRequestKeyframes() {
    const { iteration, state } = this.props;

    return classnames__WEBPACK_IMPORTED_MODULE_1___default()({
      'runner-summary__body__timeline__keyframe': true,
      'is-grey': this.props.active && state === 0,
      'is-green': this.props.active && state === 1,
      'is-red': this.props.active && state === 2,
      'is-hovered': this.props.hoveredIteration === iteration });

  }

  render() {
    const className = this.props.type === 'test' ? this.getTestKeyframes() : this.getRequestKeyframes(),
    isPassing = _.includes(className, 'is-green'),
    isFailing = _.includes(className, 'is-red');

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
          className: 'runner-summary__body__timeline__keyframe-wrapper',
          onMouseOver: this.props.onHover.bind(this, this.props.iteration) },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: className },
          isPassing && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_SuccessIcon__WEBPACK_IMPORTED_MODULE_2__["default"], { size: 'xs', style: 'primary' }),
          isFailing && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_CloseIcon__WEBPACK_IMPORTED_MODULE_3__["default"], { size: 'xs', style: 'primary' }))));



  }};
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6062:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerSummaryHeaderIterations; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2814);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2929);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Icons_LeftSolidIcon__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2971);
var _class;




let


RunnerSummaryHeaderIterations = Object(mobx_react__WEBPACK_IMPORTED_MODULE_3__["observer"])(_class = class RunnerSummaryHeaderIterations extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  componentDidUpdate() {
    const me = Object(react_dom__WEBPACK_IMPORTED_MODULE_1__["findDOMNode"])(this.refs.tabs);

    if (me) {
      me.scrollLeft = this.props.scrollLeft;
    }
  }

  getIterationTabClasses(iterationId) {
    return classnames__WEBPACK_IMPORTED_MODULE_2___default()({
      'runner-summary__header-iteration__tab': true,
      'is-hovered': this.props.hoveredIteration === iterationId });

  }

  render() {
    const iterationCount = _.get(this.props.run, 'context.iterations');

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-summary__header-iterations' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-summary__header__actions' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_4__["Button"], {
              className: 'runner-summary__header__back',
              size: 'small',
              type: 'secondary',
              onClick: this.props.onOpenResults },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_LeftSolidIcon__WEBPACK_IMPORTED_MODULE_5__["default"], { className: 'runner-summary__back-icon' }), 'Back')),




        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
            ref: 'tabs',
            className: 'runner-summary__header-iteration__tabs',
            onScroll: this.props.onScroll },


          _.map(_.range(iterationCount), iteration =>
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
              className: this.getIterationTabClasses(iteration),
              key: iteration,
              onMouseEnter: this.props.onIterationHover.bind(this, iteration) },

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-summary__header-iteration__tab__count' },
              iteration + 1))))));







  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6063:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerBottomPaneHeader; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2815);
/* harmony import */ var prop_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(prop_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _console_ConsoleActions_ConsoleActions__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6064);
/* harmony import */ var _js_components_base_Icons_CloseIcon__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3049);
/* harmony import */ var _console_ConsoleHeader_ConsoleFilter_ConsoleFilter__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5850);
/* harmony import */ var _js_components_base_Icons_ConsoleIcon__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6065);
/* harmony import */ var _onboarding_src_common_dependencies__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(3274);







let

RunnerBottomPaneHeader = class RunnerBottomPaneHeader extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {
  constructor(props) {
    super(props);

    this.getActions = this.getActions.bind(this);
    this.handleConsoleToggle = this.handleConsoleToggle.bind(this);
  }

  componentDidMount() {
    pm.mediator.on('openConsole', this.handleConsoleToggle.bind(this, true));
  }

  componentDidUpdate(prevProps) {
    // Bail if there was no change in collapsed state
    if (prevProps.isCollapsed === this.props.isCollapsed) {
      return;
    }

    // If pane was uncollapsed, send analytics data
    if (!this.props.isCollapsed) {
      _onboarding_src_common_dependencies__WEBPACK_IMPORTED_MODULE_6__["AnalyticsService"].addEventV2({
        category: 'console',
        action: 'open_pane',
        label: 'runner_tab' });

    }
  }

  componentWillUnmount() {
    pm.mediator.off('openConsole', this.handleConsoleToggle.bind(this, true));
  }

  getActions() {
    const isUncollapsed = !this.props.isCollapsed;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-bottom-pane-header__actions' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_console_ConsoleActions_ConsoleActions__WEBPACK_IMPORTED_MODULE_2__["default"], { showOptions: isUncollapsed }),
        isUncollapsed &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_CloseIcon__WEBPACK_IMPORTED_MODULE_3__["default"], {
          className: 'actions__close-icon',
          style: 'header',
          onClick: this.props.onCollapseToggle })));




  }

  handleConsoleToggle(shouldOpen) {
    let shouldCollapse = !this.props.isCollapsed;

    if (typeof shouldOpen === 'boolean') {
      shouldCollapse = !shouldOpen;
    }

    this.props.onCollapseToggle(shouldCollapse);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'runner-bottom-pane-header' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'header__section-left' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'header__label', onClick: this.handleConsoleToggle },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_ConsoleIcon__WEBPACK_IMPORTED_MODULE_5__["default"], { style: 'header' }),
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'Console')),

          !this.props.isCollapsed &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'header__options' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_console_ConsoleHeader_ConsoleFilter_ConsoleFilter__WEBPACK_IMPORTED_MODULE_4__["default"], null))),



        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'header__section-right' },
          this.getActions())));



  }};


RunnerBottomPaneHeader.propTypes = {
  isCollapsed: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.bool,
  onCollapseToggle: prop_types__WEBPACK_IMPORTED_MODULE_1___default.a.func };


RunnerBottomPaneHeader.defaultProps = {
  isCollapsed: false,
  onCollapseToggle: undefined };

/***/ }),

/***/ 6064:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleActions; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx_react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2929);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(749);
/* harmony import */ var _js_utils_PluralizeHelper__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3224);
/* harmony import */ var _js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2959);
/* harmony import */ var _js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2934);
/* harmony import */ var _js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(3048);
/* harmony import */ var _js_components_base_Icons_MoreIcon__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(3290);
/* harmony import */ var _js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(3229);
/* harmony import */ var _js_modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(748);
var _class;










let


ConsoleActions = Object(mobx_react__WEBPACK_IMPORTED_MODULE_1__["observer"])(_class = class ConsoleActions extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {
  constructor(props) {
    super(props);

    this.consoleStore = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_2__["getStore"])('ConsoleStore');
    this.consoleEventStore = Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_2__["getStore"])('ConsoleEventStore');
  }

  handleClear() {
    this.consoleStore.clearEvents();
  }

  handleConsoleOptionsToggle(option, e) {
    e && e.stopPropagation();

    switch (option) {
      case 'timestamps':
        return this.consoleStore.toggleTimestamp();

      case 'network':
        return this.consoleStore.toggleNetworkLogs();

      default:}

  }

  handleConsoleWindowOpen() {
    _js_modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_9__["default"].addEventV2({
      category: 'console',
      action: 'open_window',
      label: 'expand' });


    pm.mediator.trigger('newConsoleWindow');
  }

  render() {
    const { errorCount, warnCount } = this.consoleEventStore,
    isBrowser = window.SDK_PLATFORM === 'browser';

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-actions' },
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-actions__meta' },
          !!errorCount &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'meta__item meta__error' },
            errorCount,

            _js_utils_PluralizeHelper__WEBPACK_IMPORTED_MODULE_3__["default"].pluralize({
              count: errorCount,
              singular: ' ERROR',
              plural: ' ERRORS' })),




          !!warnCount &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'meta__item meta__warning' },
            warnCount,

            _js_utils_PluralizeHelper__WEBPACK_IMPORTED_MODULE_3__["default"].pluralize({
              count: warnCount,
              singular: ' WARNING',
              plural: ' WARNINGS' }))),





        this.props.showOptions &&
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null,
          !!(errorCount || warnCount) &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-actions__separator' }),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-actions__clear-button' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], {
                type: 'secondary',
                className: 'clear-btn',
                size: 'small',
                onClick: this.handleClear.bind(this),
                disabled: !this.consoleEventStore.hasLogs }, 'Clear')),





          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_4__["Dropdown"], { className: 'console-actions__settings', disableCloseOnPageScroll: true },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_4__["DropdownButton"], { type: 'text', size: 'small', dropdownStyle: 'nocaret' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Buttons__WEBPACK_IMPORTED_MODULE_5__["Button"], { type: 'text' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_MoreIcon__WEBPACK_IMPORTED_MODULE_7__["default"], { style: 'header' }))),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_4__["DropdownMenu"], { 'align-right': true },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_4__["MenuItem"], {
                  className: 'filter__menu-item' },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                    onClick: this.handleConsoleOptionsToggle.bind(this, 'timestamps'),
                    className: 'menu-item__wrapper' },

                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_6__["Checkbox"], {
                    className: 'menu-item__checkbox',
                    checked: this.consoleStore.showTimestamp }),

                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'menu-item__label' }, 'Show timestamps'))),


              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Dropdowns__WEBPACK_IMPORTED_MODULE_4__["MenuItem"], {
                  className: 'filter__menu-item' },

                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', {
                    onClick: this.handleConsoleOptionsToggle.bind(this, 'network'),
                    className: 'menu-item__wrapper' },

                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Inputs__WEBPACK_IMPORTED_MODULE_6__["Checkbox"], {
                    className: 'menu-item__checkbox',
                    checked: this.consoleStore.hideNetworkLogs }),

                  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'menu-item__label' }, 'Hide Network'))))),





          !isBrowser &&
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'console-actions__open-window-button' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_js_components_base_Icons_OpenIcon2__WEBPACK_IMPORTED_MODULE_8__["default"], { style: 'header', onClick: this.handleConsoleWindowOpen })))));






  }}) || _class;

/***/ }),

/***/ 6065:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleIcon; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2813);
/* harmony import */ var _XPaths_XPath__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2955);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};



const icon =
react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('svg', { width: '16', height: '14', viewBox: '0 0 16 16' },
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('defs', null,
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { id: 'console', d: 'M1 5.208v8.178c0 .344.26.614.571.614H14.43c.311 0 .571-.27.571-.614V2.614C15 2.27 14.74 2 14.429 2H1.57C1.26 2 1 2.27 1 2.614v1.594h14v1H1zM14.429 15H1.57C.698 15 0 14.274 0 13.386V2.614C0 1.726.698 1 1.571 1H14.43C15.302 1 16 1.726 16 2.614v10.772c0 .888-.698 1.614-1.571 1.614zm-5.992-2.708h-2.5a.628.628 0 0 1-.625-.632c0-.35.28-.633.626-.633h2.5c.345 0 .624.283.624.633 0 .349-.28.632-.624.632zm-5-1.265a.619.619 0 0 1-.441-.185.635.635 0 0 1 0-.893l.808-.817-.808-.817a.637.637 0 0 1 0-.894.62.62 0 0 1 .884 0l1.249 1.264a.635.635 0 0 1 0 .894l-1.25 1.263a.621.621 0 0 1-.442.185z' })),

  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('use', { fill: 'gray', fillRule: 'evenodd', xlinkHref: '#console' }));



function ConsoleIcon(props) {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_XPaths_XPath__WEBPACK_IMPORTED_MODULE_2__["default"], { identifier: 'console' },
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_Icon__WEBPACK_IMPORTED_MODULE_1__["default"], _extends({},
      props, {
        icon: icon }))));



}

/***/ }),

/***/ 6066:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RunnerBottomPaneContainer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _console_Console__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5837);




/**
                                              * Functional component to render the contents of the bottom pane.
                                              */
function RunnerBottomPaneContainer() {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_console_Console__WEBPACK_IMPORTED_MODULE_1__["default"], null));

}

/***/ }),

/***/ 6067:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return MissingCurrentWorkspaceModalContainer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _components_workspaces_MissingCurrentWorkspaceModal__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6068);



const defaultState = { isOpen: false };let

MissingCurrentWorkspaceModalContainer = class MissingCurrentWorkspaceModalContainer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = defaultState;

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }

  UNSAFE_componentWillMount() {
    pm.mediator.on('missingCurrentWorkspace', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('missingCurrentWorkspace', this.handleOpen);
  }

  handleOpen(workspace) {
    this.setState({
      isOpen: true,
      workspaceName: workspace.name });

  }

  handleClose() {
    this.setState(defaultState);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_components_workspaces_MissingCurrentWorkspaceModal__WEBPACK_IMPORTED_MODULE_1__["default"], {
        isOpen: this.state.isOpen,
        workspaceName: this.state.workspaceName,
        onRequestClose: this.handleClose }));


  }};

/***/ }),

/***/ 6068:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _base_Modals__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(3250);
/* harmony import */ var _base_Buttons__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2934);


let

MissingCurrentWorkspaceModal = class MissingCurrentWorkspaceModal extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_1__["Modal"], {
          className: 'missing-current-workspace-modal',
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onRequestClose },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_1__["ModalContent"], null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'missing-current-workspace-modal__wrapper' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'modal-header-close-button', onClick: this.props.onRequestClose }),
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'missing-current-workspace-thumbnail__container' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'missing-current-workspace-thumbnail' })),

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'missing-current-workspace-modal__content' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'missing-current-workspace-modal__header' }, 'We can\'t seem to find the ',
                this.props.workspaceName, ' workspace'),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'missing-current-workspace-modal__subtext' }, 'The workspace might have been deleted by another user in your team. You have been switched to one of your personal workspaces.'),


              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'missing-current-workspace-modal__action' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_2__["Button"], {
                    type: 'primary',
                    onClick: this.props.onRequestClose }, 'Okay')))))));









  }};


/* harmony default export */ __webpack_exports__["default"] = (MissingCurrentWorkspaceModal);

/***/ }),

/***/ 6069:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return UserInvalidSessionModalContainer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _components_user_UserInvalidSessionModal__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6070);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(749);
/* harmony import */ var _modules_pipelines_app_action__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2406);
/* harmony import */ var _modules_model_event__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(742);
/* harmony import */ var pure_render_decorator__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2965);
/* harmony import */ var pure_render_decorator__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(pure_render_decorator__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _modules_services_AuthHandlerService__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(3854);
/* harmony import */ var _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(748);
/* harmony import */ var _utils_HttpService__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(2387);
var _class;









const COOLDOWN_MIN_MS = 15 * 1000, // Wait at least this much time before contacting Identity again
COOLDOWN_MAX_MS = 60 * 1000, // Wait at most this much time before contacting Identity again
COOLDOWN_WINDOW_MS = COOLDOWN_MAX_MS - COOLDOWN_MIN_MS;let


UserInvalidSessionModalContainer = pure_render_decorator__WEBPACK_IMPORTED_MODULE_5___default()(_class = class UserInvalidSessionModalContainer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,

      // Are we waiting on a response from Identity?
      validationInProgress: false,

      // Are we holding off from sending unnecessary calls to prevent loading the backend services? The
      // actual cooldown period is tracked separately from the throttle because while we know that we only
      // need to check once per MIN cooldown period, the actual period can vary and checks between MIN
      // and MAX will be short-circuited by other states which are being tracked.
      cooldown: false,

      // Have we already verified the invalidation once?
      invalidated: false };


    this.cooldown = this.cooldown.bind(this);
    this.validateSession = this.validateSession.bind(this);
    this.handleOpen = this.handleOpen.bind(this);
    this.handleOpenIntent = this.handleOpenIntent.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleSignIn = this.handleSignIn.bind(this);
    this.handleSignOut = this.handleSignOut.bind(this);

    /**
                                                         * every time whenever there is a successful log in, then close
                                                         * the session expired modal if its already open.
                                                         *
                                                         * There may be pending requests which have got executed later and
                                                         * might have triggered this modal when the requester window was hidden
                                                         */
    pm.eventBus.channel('auth-handler-events').subscribe(event => {
      if (event && event.name === 'authenticated' && event.namespace === 'authentication') {
        this.handleClose && this.handleClose();
      }
    });
  }

  UNSAFE_componentWillMount() {
    pm.logger.info('SessionValidation - Registering listener');
    pm.mediator.on('startReenterPassword', this.handleOpenIntent);

    // check if the current session is already locked
    // if the session is locked, the same event for showing this modal
    // (pm.mediator.trigger('startReenterPassword')) will be triggered
    pm.eventBus.channel('user-session-management').publish(Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_4__["createEvent"])('isSessionLocked', 'sessionManagement'));
  }

  componentWillUnmount() {
    pm.logger.info('SessionValidation - De-registering listener');
    pm.mediator.off('startReenterPassword', this.handleOpenIntent);
  }

  /**
     * Handle the intent to open this modal. Having this step in between, and treating this invocation as
     * an intent rather than an action allows us to take control of when this modal is displayed rather
     * than completely delegating that control to the caller.
     */
  handleOpenIntent() {
    pm.logger.info('SessionValidation - Intent received');
    _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
      category: 'identity',
      action: 'lock_session',
      label: 'intent' });


    if (this.state.isOpen) {
      // The modal is already open. There's nothing meaningful we can do here.
      pm.logger.info('SessionValidation - Modal already open');
      _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
        category: 'identity',
        action: 'lock_session',
        label: 'bail_modal_open' });


      return;
    }

    if (this.state.validationInProgress) {
      // We're already waiting on a response from Identity verifying the validity of this session,
      // there's no need to send another request.
      pm.logger.info('SessionValidation - Validation already in progress');
      _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
        category: 'identity',
        action: 'lock_session',
        label: 'bail_in_progress' });


      return;
    }

    if (this.state.cooldown) {
      // We're already offline because we've disconnected the socket already and are on cooldown. If this
      // intent is expressed at this point, it's because of a request coming in from a non-sync flow. Since
      // we're already in cooldown, we don't need to send out another request unnecessarily to check again.
      pm.logger.info('SessionValidation~cooldown - Application is already offline');
      _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
        category: 'identity',
        action: 'lock_session',
        label: 'bail_offline' });


      return;
    }

    if (this.state.invalidated) {
      // We've already verified that the session is invalid, we don't need to check again and the user should
      // definitely sign in again.
      pm.logger.info('SessionValidation - Session has already been verified as invalid');
      _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
        category: 'identity',
        action: 'lock_session',
        label: 'already_invalid' });


      return this.handleOpen();
    }

    // If we've reached this point, then we need to load the session validity from Identity.
    this.validateSession();
  }

  /**
     * To avoid cases where we show this modal as a false alarm, this component will take steps to verify
     * that the user session has indeed expired before actually displaying this blocking modal.
     */
  validateSession() {
    pm.logger.info(`SessionValidation - Validation starting (${pm.identityApiUrl})`);
    _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
      category: 'identity',
      action: 'lock_session',
      label: 'start_validation' });

    this.setState({ validationInProgress: true });

    // Send request to Identity directly using XHR, using the access token to fetch the current session
    // If the session was fetched and is valid, then we disconnect the socket for some time to avoid a
    // barrage of requests hitting Identity. The syncing logic at the time of writing drops a changeset if
    // the request to Sync fails (with some retry built in). If we don't disconnect the socket, we'll end
    // with a string of failed requests and a string of dropped changesets. To avoid this, we'll disconnect
    // the socket for some time and reconnect the socket when it's likely that load issues on Identity/Sync
    // have subsided. But we log it in case that helps with debugging later. If the session actually turns
    // out to be invalid, then we throw the modal.
    let headers = { 'x-access-token': _.get(Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_2__["getStore"])('CurrentUserStore'), 'auth.access_token') },
    options = { headers };

    _utils_HttpService__WEBPACK_IMPORTED_MODULE_8__["default"].request(`${pm.identityApiUrl}/api/sessions/current`, options).
    then(({ body, status }) => {
      pm.logger.info(`SessionValidation - Response received (${status})`);
    }).
    catch(error => {
      let status = _.get(error, 'status');

      pm.logger.info(`SessionValidation - Request error (${status})`);

      if (status === 401) {
        // This is the only case where we know for a fact that the session is invalid, so we can go ahead
        // and show the modal.
        pm.logger.info('SessionValidation - Session invalidity confirmed. Opening modal.');
        _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
          category: 'identity',
          action: 'lock_session',
          label: 'session_invalidated' });


        this.setState({ invalidated: true });

        return this.handleOpen();
      }
    }).
    finally(() => {
      this.setState({ validationInProgress: false });

      if (!this.state.isOpen) {
        // If the modal hasn't been opened by the time we reach here, something has gone wrong and we need to
        // disconnect the socket to prevent data loss. If we don't disconnect the socket, the current changeset
        // sync which triggered this change will get dropped and the next changeset will attempt to sync. That
        // will also fail for the same reason, causing that to be dropped as well. This will continue until all
        // changesets are dropped. To prevent this, we'll keep the socket disconnected for some time so that
        // the system can recover (hopefully?) by the next time the socket reconnects.
        let cooldown = this.cooldown(),
        cooldownSeconds = Math.floor(cooldown / 1000);

        pm.logger.error('SessionValidation - Session expiry hint validated as incorrect, ' +
        `disconnecting socket for ~${cooldownSeconds} seconds`);
        pm.mediator.trigger('appOffline');
        _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
          category: 'identity',
          action: 'lock_session',
          label: 'socket_disconnected' });

        this.setState({ cooldown: true });

        // Reconnect after some time to check again. The time we wait before reconnecting is spread out over
        // some period to avoid concurrent reconnects from all the apps in the wild.
        setTimeout(() => {
          pm.logger.info(`SessionValidation - Waited ~${cooldownSeconds} seconds. Reconnecting socket.`);
          pm.mediator.trigger('appOnline');
          _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_7__["default"].addEventV2({
            category: 'identity',
            action: 'lock_session',
            label: 'socket_reconnected' });

          this.setState({ cooldown: false });
        }, cooldown);
      }
    });
  }

  handleOpen() {
    this.setState({ isOpen: true });
  }

  handleClose() {
    this.setState({ isOpen: false });
  }

  handleSignIn() {
    _modules_services_AuthHandlerService__WEBPACK_IMPORTED_MODULE_6__["default"].reAuthenticate();
    this.handleClose();
  }

  handleSignOut() {
    pm.mediator.trigger('showUserSignoutModal', { isSessionExpired: true });
    this.handleClose();
  }

  /**
     * Rather than having a backoff logic, which would complicate this flow further and probably cause bugs,
     * we can spread out the removal of the cooldown in a pseudo-random manner using the configured cooldown
     * MIN & MAX times. We're okay with using Math.random here since our intent here is not to generate
     * a cooldown time that's cryptographically secure, rather simply spread out over the MIN & MAX times.
     *
     * @return {Number} The cooldown time in milliseconds
     */
  cooldown() {
    return Math.round(Math.random() * COOLDOWN_WINDOW_MS + COOLDOWN_MIN_MS);
  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_components_user_UserInvalidSessionModal__WEBPACK_IMPORTED_MODULE_1__["default"], {
        isOpen: this.state.isOpen,
        onSignIn: this.handleSignIn,
        onSignOut: this.handleSignOut }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6070:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return UserInvalidSessionModal; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _base_Buttons__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2934);
/* harmony import */ var _base_Modals__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3250);
/* harmony import */ var _base_keymaps_KeyMaps__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2960);



let

UserInvalidSessionModal = class UserInvalidSessionModal extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);
  }

  getKeymapHandlers() {
    return { 'submit': pm.shortcuts.handle('submit', this.props.onSignOut) };
  }

  getCustomStyles() {
    return { marginTop: '35vh' };
  }

  render() {
    // This modal should not be close-able

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_2__["Modal"], {
          customStyles: this.getCustomStyles(),
          isOpen: this.props.isOpen },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_2__["ModalHeader"], null, 'Session Expired'),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_2__["ModalContent"], null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_keymaps_KeyMaps__WEBPACK_IMPORTED_MODULE_3__["default"], { keyMap: pm.shortcuts.getShortcuts(), handlers: this.getKeymapHandlers() },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', null, 'Your session has expired. Please sign in again.'))),




        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_2__["ModalFooter"], null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_1__["Button"], {
              type: 'secondary',
              onClick: this.props.onSignOut }, 'Sign Out'),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_1__["Button"], {
              type: 'primary',
              onClick: this.props.onSignIn }, 'Sign In'))));




  }};

/***/ }),

/***/ 6071:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return UserSignOutModalContainer; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var pure_render_decorator__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2965);
/* harmony import */ var pure_render_decorator__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(pure_render_decorator__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _components_user_UserSignOutModal__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6072);
/* harmony import */ var _modules_model_event__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(742);
/* harmony import */ var _modules_pipelines_app_action__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2406);
/* harmony import */ var _stores_get_store__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(749);
/* harmony import */ var _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(748);
/* harmony import */ var _modules_controllers_WorkspaceController__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(756);
var _class;






let


UserSignOutModalContainer = pure_render_decorator__WEBPACK_IMPORTED_MODULE_1___default()(_class = class UserSignOutModalContainer extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      isSessionExpired: false,
      acceptForceSignout: false };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.toggleSignoutCheck = this.toggleSignoutCheck.bind(this);
    this.handleSocketConnectedCase = this.handleSocketConnectedCase.bind(this);
    this.handleSocketDisconnectedCase = this.handleSocketDisconnectedCase.bind(this);
  }

  UNSAFE_componentWillMount() {
    pm.mediator.on('showUserSignoutModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showUserSignoutModal', this.handleOpen);
  }

  handleSocketConnectedCase() {
    this.syncManagerInternalChannelDisposer = pm.eventBus.channel('sync-manager-internal').subscribe(event => {
      // bail out and return do not do anything
      if (!this.state.isOpen) {
        return;
      }

      // bail out if any other event other than verification of sync data integrity
      if (event.name === 'verified' && event.namespace === 'sync-data-integrity') {
        let data = Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_3__["getEventData"])(event),
        hasUnsyncedData = data && data.hasUnsyncedData,
        didFinishVerification = data && data.didFinishVerification;

        if (!didFinishVerification || hasUnsyncedData) {
          // if has unsynced data or we did not finish verification then show the warning
          this.setState({
            isLoading: false,
            showWarning: true,
            acceptForceSignout: false });

        } else {
          // this is the case where we have successfully verified that user data is in sync
          this.setState({
            isLoading: false,
            showWarning: false,
            acceptForceSignout: true });

        }
      }
    });

    pm.eventBus.channel('sync-manager-internal').publish(Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_3__["createEvent"])('verify', 'sync-data-integrity'));
  }

  handleSocketDisconnectedCase() {
    this.setState({
      isLoading: false,
      showWarning: true,
      acceptForceSignout: false });

  }

  handleOpen({ isSessionExpired } = {}) {
    // clean up if existing listeners are already there
    this.syncManagerInternalChannelDisposer && this.syncManagerInternalChannelDisposer();

    // if session expired dont show any warning or anything and show the state where user can directly log out
    if (isSessionExpired) {
      this.setState({
        isLoading: false,
        showWarning: false,
        acceptForceSignout: true,
        isOpen: true,
        isSessionExpired: isSessionExpired || false });


      return;
    }

    this.setState({
      isOpen: true,
      isLoading: true,
      acceptForceSignout: false,
      showWarning: false,
      isSessionExpired: isSessionExpired || false });


    _modules_services_AnalyticsService__WEBPACK_IMPORTED_MODULE_6__["default"].addEvent('account', 'initiate_sign_out');

    if (Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('SyncStatusStore').isSocketConnected) {
      this.handleSocketConnectedCase();
    } else {
      this.handleSocketDisconnectedCase();
    }
  }

  handleClose() {
    this.syncManagerInternalChannelDisposer && this.syncManagerInternalChannelDisposer();

    this.setState({
      isOpen: false,
      isSigningOut: false,
      acceptForceSignout: true });


    /**
                                    * If the user's auth session is expired, then go back to the `session expired modal`
                                    * https://github.com/postmanlabs/postman-app-support/issues/4859
                                    */
    if (this.state.isSessionExpired) {
      pm.mediator.trigger('startReenterPassword');
    }
  }

  handleConfirm() {
    let currentUser = Object(_stores_get_store__WEBPACK_IMPORTED_MODULE_5__["getStore"])('CurrentUserStore'),
    logoutEvent = Object(_modules_model_event__WEBPACK_IMPORTED_MODULE_3__["createEvent"])('logout', 'user', { id: currentUser.id });

    this.setState({ isSigningOut: true });

    Object(_modules_pipelines_app_action__WEBPACK_IMPORTED_MODULE_4__["default"])(logoutEvent).
    then(() => {
      this.handleClose();
    }).
    catch(e => {
      pm.logger.warn('UserSignOutModalContainer~Error in logging out user ', e);

      this.setState({
        signInLoading: false,
        signInError: e, // @todo copy from vineeth
        isSigningOut: false,
        disableSignout: false,
        acceptForceSignout: true });

      this.handleClose();
    });

  }

  toggleSignoutCheck() {
    this.setState({
      acceptForceSignout: !this.state.acceptForceSignout });

  }

  render() {
    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_components_user_UserSignOutModal__WEBPACK_IMPORTED_MODULE_2__["default"], {
        isSigningOut: this.state.isSigningOut,
        showWarning: this.state.showWarning,
        toggleSignoutCheck: this.toggleSignoutCheck,
        isLoading: this.state.isLoading,
        isOpen: this.state.isOpen,
        onClose: this.handleClose,
        onConfirm: this.handleConfirm,
        acceptForceSignout: this.state.acceptForceSignout }));


  }}) || _class;

/***/ }),

/***/ 6072:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return UserSignOutModal; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _base_Buttons__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2934);
/* harmony import */ var _base_Modals__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3250);
/* harmony import */ var _base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2974);
/* harmony import */ var _base_Inputs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(3048);
/* harmony import */ var _base_Icons_WarningIcon__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(3225);
/* harmony import */ var _base_Icons_SpannerIcon__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(6073);






let

UserSignOutModal = class UserSignOutModal extends react__WEBPACK_IMPORTED_MODULE_0__["Component"] {
  constructor(props) {
    super(props);

    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
    this.toggleSignoutCheck = this.toggleSignoutCheck.bind(this);
    this.renderModalContent = this.renderModalContent.bind(this);
  }

  handleClose() {
    this.props.onClose && this.props.onClose();
  }

  handleConfirm() {
    this.props.onConfirm && this.props.onConfirm();
  }

  toggleSignoutCheck() {
    this.props.toggleSignoutCheck && this.props.toggleSignoutCheck();
  }

  getCustomStyles() {
    return { marginTop: '35vh' };
  }

  renderModalContent() {
    let isLoading = this.props.isLoading,
    isSomethingWrong = !isLoading && this.props.showWarning;

    if (isLoading) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'sign-out-loading--container--text' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'sign-out-loading--text' }, 'Checking for unsaved changes...'),
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_3__["default"], { className: 'sign-out-loading-wrapper' })));


    } else

    if (isSomethingWrong) {
      return (
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'sign-out-warning-container-wrapper' },
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'sign-out-warning-container' },
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'sign-out-warning--header' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Icons_WarningIcon__WEBPACK_IMPORTED_MODULE_5__["default"], { className: 'sign-out-warning--warning-icon' }), 'You have unsaved changes'),


            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('br', null),
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'sign-out-warning--text' },
              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null, 'You will lose your unsaved changes if you sign out now. To save your changes, follow these steps:'),

              react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('ul', { className: 'sign-out-warning--list' },
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('li', null, 'Export your data from ', react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Icons_SpannerIcon__WEBPACK_IMPORTED_MODULE_6__["default"], { className: 'sign-out-settings-icon', size: 'xs' }), ' > Settings > Data to create a backup'),
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('li', null, 'Ensure you have a working internet connection'),
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('li', null, 'Quit the app (be sure to stay signed in)'),
                react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('li', null, 'Re-open the app again')),

              ' ')),


          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', null,
            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Inputs__WEBPACK_IMPORTED_MODULE_4__["Checkbox"], {
              className: 'sign-out-warning--checkbox',
              checked: this.props.acceptForceSignout,
              onChange: this.toggleSignoutCheck,
              disabled: this.props.isSigningOut }),

            react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('span', { className: 'sign-out-warning--checkbox-text' }, ' Sign out without saving my changes'))));



    }

    // nothing is wrong with data, allow signout
    else {
        return 'Signing out removes your synced history, collections and environments from local storage. You can access them again by signing back in anytime';
      }
  }

  render() {
    let disableSignout = this.props.isSigningOut || this.props.isLoading || this.props.showWarning && !this.props.acceptForceSignout;

    return (
      react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_2__["Modal"], {
          isOpen: this.props.isOpen,
          className: 'user-signout-modal',
          customStyles: this.getCustomStyles() },

        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_2__["ModalHeader"], null, 'SIGN OUT OF POSTMAN'),
        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_2__["ModalContent"], null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('div', { className: 'user-signout-modal-message' },
            this.renderModalContent())),


        react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Modals__WEBPACK_IMPORTED_MODULE_2__["ModalFooter"], null,
          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_1__["Button"], {
              type: 'secondary',
              onClick: this.handleClose,
              disabled: this.props.isSigningOut }, 'Cancel'),

          react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_Buttons__WEBPACK_IMPORTED_MODULE_1__["Button"], {
              type: 'primary',
              onClick: this.handleConfirm,
              disabled: disableSignout },

            this.props.isSigningOut ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_base_LoadingIndicator__WEBPACK_IMPORTED_MODULE_3__["default"], null) : 'Sign out and remove local data'))));




  }};


UserSignOutModal.defaultProps = { isLoading: false, isSigningOut: false };

/***/ }),

/***/ 6073:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return SortIcon; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2813);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('svg', { width: '16', height: '16', viewBox: '0 0 16 16' },
  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('defs', null,
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('path', { id: 'spanner', d: 'M8.9 13.304c-1.192-.385-2.018.096-3.486 1.444L4.129 16A10.665 10.665 0 0 1 0 11.956l1.468-1.444C2.844 9.356 3.12 8.779 2.844 7.238c-.367-1.733-.367-3.755 1.744-5.68l1.01-.771c3.21-1.926 6.973.289 6.973.289S9.634 3 9.267 3.29c-.458.29-1.743 1.733-.183 3.948 1.468 2.31 3.12 1.54 3.578 1.155.367-.192 3.304-2.118 3.304-2.118s.55 4.333-2.753 6.451c-1.56.963-3.212.963-4.313.578z' })),

  react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement('use', { fill: '#FFF', fillRule: 'nonzero', xlinkHref: '#spanner' }));




function SortIcon(props) {
  return (
    react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_Icon__WEBPACK_IMPORTED_MODULE_1__["default"], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 6074:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var async_series__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(10);
/* harmony import */ var async_series__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(async_series__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _boot_bootConfig__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(60);
/* harmony import */ var _boot_bootConfig__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_boot_bootConfig__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _boot_bootLogger__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(63);
/* harmony import */ var _boot_bootMessaging__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(204);
/* harmony import */ var _boot_bootWLModels__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(212);
/* harmony import */ var _boot_bootAppModels__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(743);
/* harmony import */ var _boot_bootSettings__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(5524);
/* harmony import */ var _boot_bootTelemetry__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(5527);
/* harmony import */ var _boot_bootSession__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(5574);
/* harmony import */ var _boot_bootRunner__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(6075);
/* harmony import */ var _boot_bootCrashReporter__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(5529);
/* harmony import */ var _boot_booted__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(5610);
/* harmony import */ var _boot_bootThemeManager__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(5611);
/* harmony import */ var _boot_bootConfigurations__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(5619);
/* harmony import */ var _runtime_api_AgentManager__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(5627);
/* harmony import */ var _utils_DisableProcessThrottling__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(5696);


















const windowConfig = {
  process: 'runner',
  ui: true };


window.pm = {};

pm.init = done => {
  async_series__WEBPACK_IMPORTED_MODULE_0___default()([
  _boot_bootConfig__WEBPACK_IMPORTED_MODULE_1___default.a.init(windowConfig),
  _boot_bootLogger__WEBPACK_IMPORTED_MODULE_2__["default"],
  _boot_bootMessaging__WEBPACK_IMPORTED_MODULE_3__["default"],
  _boot_bootCrashReporter__WEBPACK_IMPORTED_MODULE_10__["default"],
  _boot_bootTelemetry__WEBPACK_IMPORTED_MODULE_7__["default"],
  _boot_bootConfigurations__WEBPACK_IMPORTED_MODULE_13__["initializeConfigurations"],
  _boot_bootSettings__WEBPACK_IMPORTED_MODULE_6__["default"],
  _boot_bootWLModels__WEBPACK_IMPORTED_MODULE_4__["default"],
  _boot_bootAppModels__WEBPACK_IMPORTED_MODULE_5__["default"],
  _runtime_api_AgentManager__WEBPACK_IMPORTED_MODULE_14__["default"],
  _boot_bootSession__WEBPACK_IMPORTED_MODULE_8__["bootSession"],
  _boot_bootThemeManager__WEBPACK_IMPORTED_MODULE_12__["default"],
  _boot_bootRunner__WEBPACK_IMPORTED_MODULE_9__["default"]],
  err => {
    Object(_boot_booted__WEBPACK_IMPORTED_MODULE_11__["default"])(err);
    if (err) {
      pm.logger.error('Error in runner boot sequence', err);
    }

    // Disabling throttling for this process. This is to prevent electron from
    // throttling actions for this process even if it is running in the background
    Object(_utils_DisableProcessThrottling__WEBPACK_IMPORTED_MODULE_15__["default"])();

    done && done(err);
  });
};

/* harmony default export */ __webpack_exports__["default"] = (pm);

/***/ }),

/***/ 6075:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var async_series__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(10);
/* harmony import */ var async_series__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(async_series__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _bootStore__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5576);
/* harmony import */ var _bootConsoleInterface__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5581);
/* harmony import */ var _bootShortcuts__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5578);
/* harmony import */ var _bootSyncProxy__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5579);
/* harmony import */ var _controllers_GenericContextMenu__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(5836);
/* harmony import */ var _controllers_ProxyListManager__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(5584);
/* harmony import */ var _controllers_UIZoom__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(5583);
/* harmony import */ var _models_requests_CertificateManager__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(5588);
/* harmony import */ var _models_ToastManager__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(5568);
/* harmony import */ var _models_Toasts__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(5572);
/* harmony import */ var _runtime_services_SyncService__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(6076);
/* harmony import */ var _runtime_services_RunnerExecutionService__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(5394);


















/**
                                                                                        *
                                                                                        * @param {*} cb
                                                                                        */
function bootRunner(cb) {
  async_series__WEBPACK_IMPORTED_MODULE_0___default()([
  _bootStore__WEBPACK_IMPORTED_MODULE_1__["default"],
  _bootShortcuts__WEBPACK_IMPORTED_MODULE_3__["default"],
  _bootSyncProxy__WEBPACK_IMPORTED_MODULE_4__["default"],
  _bootConsoleInterface__WEBPACK_IMPORTED_MODULE_2__["default"]],
  err => {
    _.assign(window.pm, {
      toasts: _models_Toasts__WEBPACK_IMPORTED_MODULE_10__,
      toastManager: new _models_ToastManager__WEBPACK_IMPORTED_MODULE_9__["default"](),
      proxyListManager: new _controllers_ProxyListManager__WEBPACK_IMPORTED_MODULE_6__["default"](), // [settings]
      certificateManager: new _models_requests_CertificateManager__WEBPACK_IMPORTED_MODULE_8__["default"](), // [settings]
      uiZoom: new _controllers_UIZoom__WEBPACK_IMPORTED_MODULE_7__["default"](), // [settings]
      contextMenuManager: new _controllers_GenericContextMenu__WEBPACK_IMPORTED_MODULE_5__["default"]() });


    _runtime_services_RunnerExecutionService__WEBPACK_IMPORTED_MODULE_12__["default"].initialize();

    if (err) {
      pm.logger.error('Runner~boot - Failed', err);
    } else {
      // Begin fetching collection runs in the active workspace
      // We do not want to wait for this to get over
      // The UI is capable of handling updates to datastores
      // as and when they happen
      Object(_runtime_services_SyncService__WEBPACK_IMPORTED_MODULE_11__["fetchRunsOnWorkspaceChange"])();
      pm.logger.info('Runner~boot - Success');
    }

    return cb && cb(err);
  });
}

/* harmony default export */ __webpack_exports__["default"] = (bootRunner);
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(61)))

/***/ }),

/***/ 6076:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchMoreRunsInActiveWorkspace", function() { return fetchMoreRunsInActiveWorkspace; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetchRunsOnWorkspaceChange", function() { return fetchRunsOnWorkspaceChange; });
/* harmony import */ var async__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(664);
/* harmony import */ var async__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(async__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mobx__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(751);
/* harmony import */ var _js_common_controllers_WindowController__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(765);
/* harmony import */ var _js_common_controllers_WindowController__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_js_common_controllers_WindowController__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _js_modules_controllers_WorkspaceSessionController__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(770);
/* harmony import */ var _controllers_RunnerRunController__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2404);
/* harmony import */ var _js_modules_services_SyncRemoteFetcherService__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(762);
/* harmony import */ var _js_modules_sync_helpers_create_changeset__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(2402);
/* harmony import */ var _js_models_sync_services_SyncIncomingHandler__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(2724);
/* harmony import */ var _js_stores_get_store__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(749);










const MODEL_COLLECTION_RUN = 'collectionrun',
ACTION_IMPORT = 'import',
ACTION_FIND = 'find',
COLLECTION_RUN_FIRST_PULL_COUNT = 20,
DEFAULT_LAST_REVISION_ID = 0;

/**
                               * Gets the active workspace from workspace session
                               */
async function getActiveWorkspace() {
  return _js_common_controllers_WindowController__WEBPACK_IMPORTED_MODULE_2___default.a.getCurrentWindow().
  then(window => {
    if (!window) {
      pm.logger.error('Window not found in DB');

      return Promise.reject(Error('Runtime~getActiveWorkspace: Window not found in db'));
    }

    return _js_modules_controllers_WorkspaceSessionController__WEBPACK_IMPORTED_MODULE_3__["default"].get({ id: window.activeSession }).then(session => {
      if (!session) {
        pm.logger.error('WorkspaceSession not found in DB');

        return Promise.reject(Error('Runtime~getActiveWorkspace: WorkspaceSession not found in db'));
      }

      return session.workspace;
    });
  });
}

/**
   * Fetches collection runs from sync server for a specified workspace.
   * New runs are added to app datastore and not returned from this function.
   * Ensure that this is called only once sync socket is available
   *
   * See @fetchMoreRunsInWorkspace for an example
   *
   * @param {Object} options
   * @param {String} options.workspace  Id of the workspace from which collection runs are to be fetched
   * @param {Number} options.count  Maximum number of collection runs to be fetched
   * @param {Number} options.sinceLastRevisionId  Fetch only collection runs beyond this revision id
  */
function fetchMoreRemoteCollectionRuns({ workspace, count, sinceLastRevisionId }) {
  return new Promise((resolve, reject) => {
    async__WEBPACK_IMPORTED_MODULE_0___default.a.waterfall([
    // Fetch runs from remote source
    next => {
      _js_modules_services_SyncRemoteFetcherService__WEBPACK_IMPORTED_MODULE_5__["default"].remoteFetch(MODEL_COLLECTION_RUN, ACTION_FIND, {
        workspace,
        count,
        since_id: sinceLastRevisionId }).

      then(runs => next(null, runs)).
      catch(err => next(err));
    },

    // Filter out existing runs
    (runs, next) => {
      const runIds = runs.map(run => run.id),
      existingRuns = _controllers_RunnerRunController__WEBPACK_IMPORTED_MODULE_4__["default"].getAll({ id: runIds });

      existingRuns.
      then(results => {
        const existingRunIds = results.map(run => run.id),
        newIds = runIds.filter(id => existingRunIds.indexOf(id) === -1),
        newRuns = runs.filter(run => newIds.indexOf(run.id) !== -1);

        next(null, newRuns);
      }).
      catch(err => next(err));
    },

    // Process the runs as changesets
    // This ensures that partial runs are also handled appropriately
    (runs, next) => {
      const changesets = runs.map(run => Object(_js_modules_sync_helpers_create_changeset__WEBPACK_IMPORTED_MODULE_6__["default"])(
      MODEL_COLLECTION_RUN,
      ACTION_IMPORT,
      {
        instance: run,
        modelId: run.id,
        owner: run.owner },

      { partial: true }));


      next(null, changesets);
    },

    // Process the changesets individually
    // This will also take care of persisting runs to store
    (changesets, next) => {
      const promises = changesets.map(changeset => Object(_js_models_sync_services_SyncIncomingHandler__WEBPACK_IMPORTED_MODULE_7__["processIncomingChangeset"])(changeset).catch(
      e => {
        pm.logger.warn(
        'RunnerRunStore~fetchMoreCollectionRuns: Could not create collection run',
        e);

      }));


      return Promise.all(promises).
      then(() => next(null, changesets)).
      catch(err => next(err));
    }],
    err => {
      if (err) {
        reject(err);
      } else {
        resolve();
      }
    });
  });
}

/**
   * Fetches collection runs for active workspace
   *
   * @param {Number} count Maximum number of runs to fetch
   * @param {Number} sinceLastRevisionId  Fetch only collection runs beyond this revision id
   */
function fetchMoreRunsInActiveWorkspace(
count = COLLECTION_RUN_FIRST_PULL_COUNT,
sinceLastRevisionId = DEFAULT_LAST_REVISION_ID)
{
  return Promise.resolve(Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_8__["getStore"])('SyncStatusStore')).
  then(store => store.onSyncAvailable()).
  then(() => getActiveWorkspace()).
  then(workspace => fetchMoreRemoteCollectionRuns({ workspace, count, sinceLastRevisionId }));
}

/**
   * Sets up reaction to fetch collection runs for active workspace whenever
   * workspace is switched
   */
function fetchRunsOnWorkspaceChange() {
  Object(mobx__WEBPACK_IMPORTED_MODULE_1__["reaction"])(
  () => Object(_js_stores_get_store__WEBPACK_IMPORTED_MODULE_8__["getStore"])('ActiveWorkspaceSessionStore').workspace,
  fetchMoreRunsInActiveWorkspace,
  { fireImmediately: true });

}

/***/ }),

/***/ 6077:
/***/ (function(module, exports, __webpack_require__) {

// extracted by mini-css-extract-plugin

/***/ }),

/***/ 62:
/***/ (function(module, exports) {

module.exports = require("electron");

/***/ }),

/***/ 64:
/***/ (function(module, exports) {

module.exports = require("path");

/***/ }),

/***/ 86:
/***/ (function(module, exports) {

module.exports = require("os");

/***/ })

/******/ });